StyleTab

Tab themes for sawfish. This theme combines flexibility, appealing
look'n'feel and innovative ideas. As of Sawfish 1.8.0 it's the default theme.

It combines 4 themes (Reduce, Dark, Silver & Smoothly), bundled
with support for tabbed windowing. StyleTab provides various options like for
titlebar colors or button-order (separately for toplevel windows and transients),
aswell as support for having the titlebar on any of the four sides (can be
different for each window, using the "title-position" window-matcher, or
temporary by  clicking on the icon in the titlebar).

Ideas/code taken over from Crux/Anonymous/Mxflat/Reduce themes.

Created by fuchur

This is sawfish, a highly configurable window manager for X11.

It is released under the terms of the GNU GPL, 
	copyright (c) John Harper <jsh@users.sourceforge.net>

Maintainer until 2007 was: John Harper
Maintainer until Dec 2008 was: Janek Kozicki <cosurgi@gmail.com>
Maintainer since Dec 2008 is: Christopher Bratusek <nano@jpberlin.de>

For more details, see the sawfish wiki: http://sawfish.wikia.com/

Manifesto
*********

Sawfish is an extensible window manager using an Emacs Lisp-like
scripting language--all window decorations are configurable, the basic
idea is to have as much user-interface policy as possible controlled
through the Lisp language.

Despite this extensibility its policy is currently very minimal
compared to most window managers. Its aim is simply to manage windows
in the most flexible and attractive manner possible. As such it does
not implement desktop backgrounds, applications docks, or other things
that may be achieved through separate applications.

All high-level wm functions are implemented in Lisp for future
extensibility or redefinition. Currently this includes menus (using
GTK+), interactive window moving and resizing, virtual desktop,
iconification, focus/transient window policies, frame theme definitions
and much more.

Also, most received events are exported to the Lisp environment through
``key-bindings'' and hooks, similar to in Emacs. These events include
pointer behaviour and many internal X11 events (enter/leave,
focus-in/focus-out, map/unmap, etc..)

This directory contains high-level components, or "widgets" for
sawfish-config, *not* raw gtk widgets.

For example, 'boolean' is defined in widget.jl, among other widgets.
It implements checkbox for boolean defcustom options.

Translation howto
=================
This README is a manual for Sawfish translators.

Contents:
* Translation introduction
* General Workflow
* Sawfish specific issues

Translation introduction
========================
Like other open source, you can help us by translating Sawfish into
your language. (And if have noticed anything regarding translation,
please let us know.)

French translation, for example, is stored in 
<sawfish source dir>/po/fr.po. It's your language po file that you edit.

Translation is done by "gettext" software. You don't necessarily need
it to translate. Po file grammar is explained in gettext doc. For
technical details consult it.

Sawfish translation can be done by users, but is also done by GNOME
translation teams, which are independent of Sawfish.

General Workflow
================

1. (Optional) Update your language po file.
2. Edit your po file.
3. Send it to a GNOME translation team.

Each step is explained below.

Updating a po file
------------------
This step is desired, but optional. You need to have gettext
installed. Or, you can ask us to do it.

If you can, first update sawfish.pot, which is the base of all
po files:

    $ # download the latest sawfish, and extract it.
    $ cd <sawfish source>
    $ ./configure    # If it's git source, do instead ./autogen.sh
    $ make all
    $ cd po/
    $ ./make-pot     # This updates sawfish.pot

Update your language po file by:

    $ cd <sawfish source>/po/
    $ ./update.sh zh_CN.po # Or your language po file.

Editing
-------
Recommended tools are for example Gtranslator, KBabel or Lokalize.

Old tools "poedit" and emacs "po-mode" are less preferable, but also
available. The latter is included in the gettext package.

Submission
----------
You have to send it to the GNOME translation team of your language.
They'll review and commit it to the source. The precise procedure
may depend on languages. (Don't ask them Sawfish specific questions.)

Web:
First go to the GNOME translation home[1], and check your language
team. Register there, go to the Sawfish page[2], choose "Review
required", and paste your po file.

[1]: http://l10n.gnome.org/
[2]: http://l10n.gnome.org/module/sawfish/

Email:
At http://mail.gnome.org , check the mailing-list for your
language, like gnome-<lang>. If one does not exist, use gnome-i18n.

Thanks!

Sawfish specific issues
=======================
For several reasons, Sawifsh extracts strings to be translated in a
complicated manner.

String origin
-------------
Where do strings come from? You may want to know it, for example,
when you want to confirm the validity of a string marked "fuzzy".

Sawfish extracts strings from lisp sources which are under lisp/, 
themes/*/theme.jl, and scripts/. (It seems that the extraction script
uses C sources too, but the author of this README couldn't find
strings from C. C sources are under src/, for your information.)

In order to search the origin of a string, "ack" is a helpful
tool. (In Debian, it's call "ack-grep".) If you can use git, "git
grep" is your friend.

Command names are translated, too, but they are often brief and
difficult to get the meaning, without reading the documentation of
that command. Notice that command `foo-bar-baz' appears as "Foo bar
baz" in msgid.

c-format are probably not c
---------------------------
`c-format' flags are probably wrong, but we can't disable it. You may
have to change them to `no-c-format' to send a po file to the GNOME
web page or the GNOME git repository.

Not all are translated
----------------------
Please expand this list of untranslated strings. We don't know the
exact status.

* Event names like "Button1-Off". (This is difficult to support, so
  we won't fix it in near future.)

These scripts are intended to automatically take screenshots of sawfish themes.

To install/configure, do the following:

  - Install dependencies:

    # apt-get install cowsay xnest imagemagick xterm
    # apt-get install feh
    # apt-get install ... (more?)

  - Add a test user to your system.

    # adduser sawfish

  - Set up your sawfish directory.

    % su sawfish
    % cd
    % mkdir .sawfish
    % cd .sawfish
    % mkdir tarballs themes
    % cp /path/to/theme/tarballs/*.tar.gz ~/.sawfish/tarballs

  - Put these scripts in your path.

    % mkdir ~/bin
    % echo 'export PATH=$HOME/bin:$PATH' >> ~/.bashrc
    % cp /path/to/these/sawfish/scripts/* ~/bin

Then, you should be able to actually run the scripts.

  % mkdir ~/screenshots
  % cd ~/screenshots
  % make_screenshots.sh

Scott (ToyKeeper) Scriven

This theme is based on the QNX Photon microGUI (screenshots at
http://www.qnx.com/amiga/delivering.html).  Many image components were
taken from the minEguE enlightenment theme by Ben FrantzDale
(frantb@rpi.edu). The rest is by Ryan Lovett (ryan@ocf.berkeley.edu)
with modifications from John Harper.

StyleTab

Tab themes for sawfish. This theme combines flexibility, appealing
look'n'feel and innovative ideas. As of Sawfish 1.8.0 it's the default theme.

It combines 6 themes (Default, Reduce, Glass, Smoothly, Wixda and Flat), bundled
with support for tabbed windowing. StyleTab provides various options like for
titlebar colors or button-order (separately for toplevel windows and transients),
as well as support for having the titlebar on any of the four sides (can be
different for each window, using the "title-position" window-matcher, or
temporary by  clicking on the icon in the titlebar).

Ideas/code taken over from Crux/Anonymous/Mxflat/Reduce themes.

Created by fuchur

mxflat (v0.7.4) sawfish theme

The mxflat theme was made to match the gtk[1|2]-flat-engine.
It is probably the most customizable sawfish theme out there
but it also works very well if you do not adjust anything.

Remember: if there is something special to know about an option,
there is probably a tooltip helping you out.

Please send us your button icon sets if you've made any!

### upgrading  ###

(0.7.2 or later)
nothing

(0.7.1 or earlier)
you should really open ~/.sawfish/custom and delete the line
containing "mxflat:button-position-model". besides the
button position direction was changes, so you have to change
all negative position values to positive ones in sawfish-config or the 
custom file. furthermore some config variable names have changes,
so it might happen you have to readjust some options.

### Customization ###

Use the configurator. There're many options.

### copyright ###

mxflat was build with heavy use of other themes as reference
(e.g. the crux or gradient theme, just to name two of them)
and the help of the people in #sawfish at the freenode irc network.
besides we were inspired by the comments of people at our freshmeat page at

http://themes.freshmeat.net/projects/mxflat/
	
 thanks to all of them!

	
for comments, bug reports, suggestions, please mail us!

authors: mx (email) & ta (dev.null@gmx.net)
   
   Copyright (C) 2002 mx & ta

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Simple & Elegant (a Sawfish theme)
----------------

Version 0.05

To be used with a corresponding GTK+ theme
[http://gtk.themes.org/themes.phtml?themeid=951420422]
and a Uniread font from Linux Font Project
[http://dreamer.nitro.dk/linux/lfp].

My goal is to make THE ULTIMATE GOOD THEME (TM),
and this theme is my *current* visualization/interpretation
of that goal. This will be the only (Sawfish) theme by me.

I cannot deny you from forking this theme, but I beg you not
to. If you want to make the theme better, please submit your
ideas to me instead of trying to implement them in your
forked theme.

Copyright 2000 Sergej Malinovski <sergej@nospam.dk>. You
may hack, port, copy and distribute anything you might find
useful and not so useful under the terms of GPL.

;; groups.jl -- commands for manipulating window groups

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.groups

    (export iconify-group
	    uniconify-group
	    iconify-transient-group
	    uniconify-transient-group
	    make-group-sticky
	    make-group-unsticky
	    toggle-group-sticky
	    send-group-to-workspace
	    send-group-to-current-workspace
	    send-group-to-next-workspace
	    send-group-to-previous-workspace
	    move-group-to-current-viewport
	    move-group-viewport
	    move-group-left
	    move-group-right
	    move-group-up
	    move-group-down
	    raise-group
	    lower-group
	    raise-lower-group
	    raise-group-depth
	    lower-group-depth
	    set-group-frame-style)

    (open rep
	  sawfish.wm.util.groups
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.state.iconify
	  sawfish.wm.state.transient
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.stacking
	  sawfish.wm.frames)

  (define-structure-alias groups sawfish.wm.commands.groups)

  ;; iconification

  (define (call-with-iconify-mode mode fun w)
    (let ((iconify-group-mode mode)
	  (uniconify-group-mode mode))
      (fun w)))

  (define (iconify-group w)
    (call-with-iconify-mode 'group iconify-window w))
  (define (uniconify-group w)
    (call-with-iconify-mode 'group uniconify-window w))

  (define (iconify-transient-group w)
    (call-with-iconify-mode 'transients iconify-window w))
  (define (uniconify-transient-group w)
    (call-with-iconify-mode 'transients uniconify-window w))

  (define-command 'iconify-group
    iconify-group #:spec "%W")
  (define-command 'uniconify-group
    uniconify-group #:spec "%W")
  (define-command 'iconify-transient-group
    iconify-transient-group #:spec "%W")
  (define-command 'uniconify-transient-group
    uniconify-transient-group #:spec "%W")

  ;; sticky

  (define (make-group-sticky w)
    (map-window-group make-window-sticky w))
  (define (make-group-unsticky w)
    (map-window-group make-window-unsticky w))

  (defun toggle-group-sticky (w)
    (if (window-get w 'sticky)
	(make-group-unsticky w)
      (make-group-sticky w)))

  ;;###autoload
  (define-command 'make-group-sticky make-group-sticky #:spec "%W")
  (define-command 'make-group-unsticky make-group-unsticky #:spec "%W")
  (define-command 'toggle-group-sticky toggle-group-sticky #:spec "%W")

  ;; workspaces

  (define (send-group-to-workspace w send-group-dest-space)
    (map-window-group
     (lambda (x)
       (unless (window-get x 'sticky)
	 (move-window-to-workspace
	  x (nearest-workspace-with-window x current-workspace)
	  send-group-dest-space (eq x (input-focus))))) w))

  (define (send-group-to-current-workspace w)
    (send-group-to-workspace w current-workspace))

  (define (send-group-to-next-workspace send-group-window count)
    (ws-call-with-workspace (lambda (space)
			      (send-group-to-workspace send-group-window space)
			      (select-workspace space))
			    count workspace-send-boundary-mode))

  (define (send-group-to-previous-workspace w count)
    (send-group-to-next-workspace w (- count)))

  ;;###autoload
  (define-command 'send-group-to-current-workspace
    send-group-to-current-workspace #:spec "%W")
  (define-command 'send-group-to-next-workspace
    send-group-to-next-workspace #:spec "%W\np")
  (define-command 'send-group-to-previous-workspace
    send-group-to-previous-workspace #:spec "%W\np")

  ;; viewports

  (define (move-group-to-current-viewport w)
    (map-window-group move-window-to-current-viewport w))

  (define (move-group-viewport w col row)
    (map-window-group (lambda (x)
			(move-window-viewport x col row)) w)
    (move-viewport-to-window w))

  (define (move-group-left w) (move-group-viewport w -1 0))
  (define (move-group-right w) (move-group-viewport w 1 0))
  (define (move-group-up w) (move-group-viewport w 0 -1))
  (define (move-group-down w) (move-group-viewport w 0 1))

  ;;###autoload
  (define-command 'move-group-to-current-viewport
    move-group-to-current-viewport #:spec "%W")

  ;;###autoload
  (define-command 'move-group-left
    move-group-left #:spec "%W")
  (define-command 'move-group-right
    move-group-right #:spec "%W")
  (define-command 'move-group-up
    move-group-up #:spec "%W")
  (define-command 'move-group-down
    move-group-down #:spec "%W")

  ;; stacking

  (define (raise-group w) (raise-windows w (windows-in-group w t)))
  (define (lower-group w) (lower-windows w (windows-in-group w t)))
  (define (raise-lower-group w) (raise-lower-windows w (windows-in-group w t)))
  (define (raise-group-depth w) (map-window-group raise-window-depth w))
  (define (lower-group-depth w) (map-window-group lower-window-depth w))

  ;;###autoload
  (define-command 'raise-group raise-group
    #:spec "%W")
  (define-command 'lower-group lower-group
    #:spec "%W")
  (define-command 'raise-lower-group raise-lower-group
    #:spec "%W")
  (define-command 'raise-group-depth raise-group-depth #:spec "%W")
  (define-command 'lower-group-depth lower-group-depth #:spec "%W")

  ;; framing

  (define (set-group-frame-style w style)
    (map-window-group (lambda (x)
			(set-frame-style x style)) w))

  ;; deleting windows

  (define (delete-group w)
    "Delete all windows in the group that the current window is a member of."
    (map-window-group (lambda (x)
			;; Don't delete the desktop-window. It should
			;; probably be in a separate group, but isn't..
			(unless (desktop-window-p x)
			  (delete-window x))) w))

  ;;###autoload
  (define-command 'delete-group delete-group #:spec "%W"))

;; compat.jl -- support for obsolete functions and variables

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.compat

    (export custom-set-color
	    custom-set-font
	    custom-set-frame-style
	    get-window-by-class-re
	    get-window-by-name-re
	    maybe-raise-window
	    maybe-lower-window
	    popup-window-menu
	    rename-window-func
	    show-message
	    ws-copy-window
	    ws-insert-workspace
	    ws-move-window
	    ws-remove-workspace)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.menus
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.util.stacking)

;;; obsolete functions are collected here

  (define (show-message #!optional text font fg bg position)
    (let ((attrs nil))
      (when font
	(setq attrs (cons (cons 'font font) attrs)))
      (when fg
	(setq attrs (cons (cons 'fg fg) attrs)))
      (when bg
	(setq attrs (cons (cons 'bg bg) attrs)))
      (when position
	(setq attrs (cons (cons 'position position) attrs)))
      (display-message text attrs)))

  ;; Define alias for renamed functions.
  (define ws-copy-window copy-window-to-workspace)
  (define ws-move-window move-window-to-workspace)
  (define ws-insert-workspace insert-workspace)
  (define ws-remove-workspace remove-workspace)

  (define maybe-raise-window raise-window*)
  (define maybe-lower-window lower-window*)

  (define popup-window-menu popup-window-ops-menu)
  (define rename-window-func rename-window)

  (define (get-window-by-class-re class)
    (get-window-by-class class #:regex t))

  (define (get-window-by-name-re name)
    (get-window-by-name name #:regex t))

;;; obsolete commands

  (define (define-commands index)
    (let ((fn (lambda (base)
		(intern (format nil "%s:%d" base (1+ index))))))
      (define-command (fn "select-workspace")
	(lambda () (select-workspace-from-first index))
	#:class 'deprecated)
      (define-command (fn "send-to-workspace")
	(lambda (w) (send-window-to-workspace-from-first w index))
	#:spec "%W"
	#:class 'deprecated)
      (define-command (fn "copy-to-workspace")
	(lambda (w) (send-window-to-workspace-from-first w index t))
	#:spec "%W"
	#:class 'deprecated)))

  (do ((i 0 (1+ i)))
      ((= i 9))
    (define-commands i))

  (define-command 'insert-workspace (command-ref 'insert-workspace-after)
    #:doc "Obsolete. Renamed to insert-workspace-after."
    #:class 'deprecated)

  (define-command 'popup-window-menu (command-ref 'popup-window-ops-menu)
    #:doc "Obsolete. Renamed to popup-window-ops-menu."
    #:class 'deprecated
    #:spec "%W")

;;; obsolete options

  ;; 1. If these options are set in ~/.sawfish/custom, then they are
  ;;    ignored. This means the next time you save the file `custom',
  ;;    they are removed.
  ;; 2. You can't set value to them via custom related methods.
  (mapc (lambda (x)
	  (put x 'custom-obsolete t))
	'(viewport-columns viewport-rows preallocated-workspaces
          iconify-whole-group uniconify-whole-group
          always-update-frames edge-flip-warp-pointer
          frame-type-fallbacks warp-to-window-x-offset
          warp-to-window-y-offset uniquify-name-format
          transients-get-focus decorate-transients
          raise-windows-on-uniconify uniconify-to-current-workspace
          iconify-ignored focus-ignore-pointer-events
          focus-windows-on-uniconify transients-are-group-members
          raise-selected-windows warp-to-selected-windows
          menus-include-shortcuts configure-auto-gravity
          configure-ignore-stacking-requests
          beos-window-menu-simplifies customize-show-symbols
          move-snap-mode move-snap-ignored-windows
          move-resize-inhibit-configure move-snap-edges
          raise-windows-when-unshaded persistent-group-ids
          delete-workspaces-when-empty transients-on-parents-workspace
          audio-for-ignored-windows size-window-def-increment
          slide-window-increment default-bevel-percent sp-padding
          nokogiri-user-level nokogiri-buttons lock-first-workspace
          ignore-window-input-hint workspace-geometry
          pointer-motion-threshold ignore-program-positions
          infinite-desktop.stop-at-workspace-borders
	  edge-flip-enabled edge-flip-type edge-flip-only-when-moving
	  infinite-desktop-p infinite-desktop.move-distance
	  infinite-desktop.move-cursor-distance
	  tab-left-dec-width tab-right-dec-width
	  tab-left-margin tab-right-margin
	  tab-left-margin-transient tab-right-margin-transient
	  ))

;;; obsolete custom setters

  (define (custom-set-color var value #!optional req)
    (custom-set-typed-variable var value 'color req))
  (define (custom-set-font var value #!optional req)
    (custom-set-typed-variable var value 'font req))
  (define (custom-set-frame-style var value #!optional req)
    (custom-set-typed-variable var value 'frame-style req))

  (define-custom-setter 'custom-set-color custom-set-color)
  (define-custom-setter 'custom-set-font custom-set-font)
  (define-custom-setter 'custom-set-frame-style custom-set-frame-style))

;; edge/util.jl -- common utils for EdgeActions

;; Copyright (C) 2010 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.edge.util

    (export activate-flippers
	    get-active-corner
	    get-active-edge
	    move-window-to-corner
	    move-window-to-edge)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.edge.subrs)

  (define-structure-alias edge-util sawfish.wm.edge.util)

  (define (activate-flippers enable)
    (if enable
        (progn
	  (recreate-flippers)
	  (unless (in-hook-p 'after-restacking-hook raise-flippers)
	    (add-hook 'after-restacking-hook raise-flippers))
	  (unless (in-hook-p 'randr-change-notify-hook recreate-flippers)
	    (add-hook 'randr-change-notify-hook recreate-flippers)))
      (destroy-flippers)
      (remove-hook 'after-restacking-hook raise-flippers)
      (remove-hook 'randr-change-notify-hook recreate-flippers)))

  (define (get-active-corner)
    (let ((cursor-x (car (query-pointer)))
	  (cursor-y (cdr (query-pointer))))
      (cond ((or (and (< cursor-x hot-spots-corner-length)
		      (<= cursor-y 1))
		 (and (<= cursor-x 1)
		      (< cursor-y hot-spots-corner-length)))
	     'top-left)

	    ((or (and (> cursor-x (- (screen-width) hot-spots-corner-length))
		      (<= cursor-y 1))
		 (and (>= cursor-x (- (screen-width) 1))
		      (< cursor-y hot-spots-corner-length)))
	     'top-right)

	    ((or (and (> cursor-x (- (screen-width) hot-spots-corner-length))
		      (>= cursor-y (- (screen-height) 1)))
		 (and (>= cursor-x (- (screen-width) 1))
		      (> cursor-y (- (screen-height) hot-spots-corner-length))))
	     'bottom-right)

	    ((or (and (< cursor-x hot-spots-corner-length)
		      (>= cursor-y (- (screen-height) 1)))
		 (and (<= cursor-x 1)
		      (> cursor-y (- (screen-height) hot-spots-corner-length))))
	     'bottom-left))))

  (define (get-active-edge)
    (let ((cursor (query-pointer)))
      (cond ((zerop (car cursor))
	     'left)
	    ((= (car cursor) (1- (screen-width)))
	     'right)
	    ((zerop (cdr cursor))
	     'top)
	    ((= (cdr cursor) (1- (screen-height)))
	     'bottom))))

  (define (move-window-to-corner w corner)
    (let ((win-size (window-frame-dimensions w)))
      (case corner
	((top-left) (move-window-to w 0 0))
	((top-right) (move-window-to w (- (screen-width) (car win-size)) 0))
	((bottom-right) (move-window-to w (- (screen-width) (car win-size))
					  (- (screen-height) (cdr win-size))))
	((bottom-left) (move-window-to w 0 (- (screen-height) (cdr win-size)))))))

  (define (move-window-to-edge w edge)
    (let ((win-size (window-frame-dimensions w)))
      (case edge
	((left) (move-window-to w 0 (- (/ (screen-height) 2) (/ (cdr win-size) 2))))
	((top) (move-window-to w (- (/ (screen-width) 2) (/ (car win-size) 2)) 0))
	((right) (move-window-to w (screen-width) (- (/ (screen-height) 2) (/ (cdr win-size) 2))))
	((bottom) (move-window-to w (- (/ (screen-width) 2) (/ (car win-size) 2)) (screen-height)))))))

;; move-cursor.jl -- commands to move the mouse pointer
;; $Id: move-cursor.jl,v 1.4 2000/07/27 13:19:29 john Exp $

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.move-cursor

    (export move-cursor)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands)

  (defcustom move-cursor-increment 16
    "Number of pixels to move pointer in `move-cursor-' commands."
    :group misc
    :type (number 1))

  (define (move-cursor right down)
    (let ((coords (query-pointer)))
      (warp-cursor (+ (car coords) right) (+ (cdr coords) down))))

  (define (move-cursor-left)
    "Move the cursor `move-cursor-increment' pixels to the left."
    (move-cursor (- move-cursor-increment) 0))

  (define (move-cursor-right)
    "Move the cursor `move-cursor-increment' pixels to the right."
    (move-cursor move-cursor-increment 0))

  (define (move-cursor-up)
    "Move the cursor `move-cursor-increment' pixels upwards."
    (move-cursor 0 (- move-cursor-increment)))

  (define (move-cursor-down)
    "Move the cursor `move-cursor-increment' pixels downwards."
    (move-cursor 0 move-cursor-increment))

  (define (move-cursor-left-fine)
    "Move the cursor 1 pixel to the left."
    (move-cursor -1 0))

  (define (move-cursor-right-fine)
    "Move the cursor 1 pixel to the right."
    (move-cursor 1 0))

  (define (move-cursor-up-fine)
    "Move the cursor 1 pixel upwards."
    (move-cursor 0 -1))

  (define (move-cursor-down-fine)
    "Move the cursor 1 pixel downwards."
    (move-cursor 0 1))

  ;;###autoload
  (define-command 'move-cursor-right move-cursor-right)
  (define-command 'move-cursor-left move-cursor-left)
  (define-command 'move-cursor-up move-cursor-up)
  (define-command 'move-cursor-down move-cursor-down)
  (define-command 'move-cursor-right-fine move-cursor-right-fine)
  (define-command 'move-cursor-left-fine move-cursor-left-fine)
  (define-command 'move-cursor-up-fine move-cursor-up-fine)
  (define-command 'move-cursor-down-fine move-cursor-down-fine))

#!/bin/sh

# I tried: `REP_LOAD_PATH=... exec ...' but solaris /bin/sh won't play along

REP_LOAD_PATH="/usr/local/share/sawfish/lisp"
export REP_LOAD_PATH

exec rep "$0" "$@"

!#

;; main.jl -- entry point of Sawfish configurator
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA. 

(structure ()

    (open rep
	  rep.system
	  rep.io.files
	  rep.regexp)

  (when (getenv "SAWFISH_USER_LISP_DIR")
    (setq load-path
	  (append
	   (mapcar canonical-file-name
		   (string-split ":" (getenv "SAWFISH_USER_LISP_DIR")))
	   load-path)))

  ;; This is put here *after* SAWFISH_USER_LISP_DIR is parsed.
  (require 'sawfish.cfg.shell)

  (run-shell))

;; Emacs support
;; Local variables:
;; mode: sawfish
;; End:

#!/bin/sh

# I tried: `REP_LOAD_PATH=... exec ...' but solaris /bin/sh won't play along

REP_LOAD_PATH="/usr/pkg/share/sawfish/lisp"
export REP_LOAD_PATH

exec env LD_PRELOAD=/usr/lib/libpthread.so rep "$0" "$@"

!#

;; main.jl -- entry point of Sawfish configurator
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA. 

(structure ()

    (open rep
	  rep.system
	  rep.io.files
	  rep.regexp)

  (when (getenv "SAWFISH_USER_LISP_DIR")
    (setq load-path
	  (append
	   (mapcar canonical-file-name
		   (string-split ":" (getenv "SAWFISH_USER_LISP_DIR")))
	   load-path)))

  ;; This is put here *after* SAWFISH_USER_LISP_DIR is parsed.
  (require 'sawfish.cfg.shell)

  (run-shell))

;; Emacs support
;; Local variables:
;; mode: sawfish
;; End:

;; nokogiri-layout.jl -- arranging groups of slots
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.layout

    (export define-layout-type
	    layout-slots
	    document-slot
	    make-label)

    ((open rep
	   gui.gtk-2.gtk
	   rep.regexp
           rep.util.misc
	   sawfish.cfg.slot
	   sawfish.gtk.widget)
     (access rep.structures))

  (define widget-ptr nil)
  (define label-ptr nil)
  (define tempstring nil)

  (define (define-layout-type name fun) (put name 'nokogiri-layout fun))

  (define (layout-type name)
    (or (get name 'nokogiri-layout)
	;; try to dynamically load it
	(let ((module-name (intern (concat "sawfish.cfg.layouts."
					   (symbol-name name)))))
	  (condition-case nil
	      (progn
		(rep.structures#intern-structure module-name)
		(get name 'nokogiri-layout))
	    (error (layout-type 'vbox))))))

  (define (layout-slots name slots)
    ((layout-type (or (car name) name)) name slots))

;;; basic layout styles

  (define (layout-single style slots)
    (declare (unused style))
    (cond ((null slots)
	   (let ((placeholder (gtk-vbox-new nil 0)))
	     (gtk-widget-show placeholder)
	     placeholder))
	  ((= (length slots) 1)
	   (let ((w (document-slot (car slots))))
	     (set-slot-layout (car slots) w)
	     w))
	  (t (error "Too many slots for `single' layout"))))

  (define-layout-type 'single layout-single)

  (define (layout-box style slots)
    (let ((box ((if (eq style 'hbox)
		    gtk-hbox-new
		  gtk-vbox-new) nil box-spacing)))
      (mapc (lambda (s)
	      (let ((w (document-slot s)))
		(set-slot-layout s w)
		(if (memq 'expand-vertically (slot-flags s))
		    (gtk-box-pack-start box w t t)
		  (gtk-box-pack-start box w)))) slots)
      (gtk-widget-show box)
      box))

  (define-layout-type 'vbox layout-box)
  (define-layout-type 'hbox layout-box)

  (define (layout-frame style slots)
    (let ((frame (gtk-frame-new (cadr style)))
	  (vbox (layout-slots 'vbox slots)))
      (gtk-container-set-border-width frame box-border)
      (gtk-container-add frame vbox)
      (gtk-widget-show frame)
      frame))

  (define-layout-type 'frame layout-frame)

;;; including doc strings alongside slot widgets

  (define (document-slot slot)
    (let ((doc (slot-doc slot)))
      (if (or (null doc) (string= doc ""))
	  (slot-gtk-widget slot)
	(let ((split (tooltip-split doc)))
	  (define (add-tooltip widget)
	    (if (cdr split)
		;; tooltips need a window to receive events..
		(let ((ebox (gtk-event-box-new)))
		  (gtk-container-add ebox widget)
		  (tooltip-set ebox (cdr split))
		  ebox)
	      widget))

	  (setq doc (remove-newlines (car split)))
	  (if (memq 'framed (slot-flags slot))
	      (let ((hbox (gtk-hbox-new nil 0))
		    (vbox (gtk-vbox-new nil 0)))
		(gtk-box-pack-start hbox (gtk-label-new doc))
		(gtk-box-pack-start vbox hbox)
		(gtk-box-pack-start vbox (slot-gtk-widget slot) t t)
		(setq vbox (add-tooltip vbox))
		(gtk-widget-show-all vbox)
		vbox)

	    (if (string-match "\\\\top" doc)
		(let ((vbox (gtk-vbox-new nil box-spacing)))
		    (setq widget-ptr (slot-gtk-widget slot))
		    (setq label-ptr (make-label (substring doc 0 (match-start))))
		    (gtk-box-pack-start vbox label-ptr)
		    (gtk-box-pack-start vbox widget-ptr nil nil)
		    (gtk-widget-relate-label widget-ptr label-ptr)
		    (setq vbox (add-tooltip vbox))
		    (gtk-widget-show-all vbox)
		    vbox)

	      (if (string-match "\\\\bottom" doc)
		  (let ((vbox (gtk-vbox-new nil box-spacing)))
		      (setq widget-ptr (slot-gtk-widget slot))
		      (setq label-ptr (make-label (substring doc 0 (match-start))))
		      (gtk-box-pack-start vbox widget-ptr nil nil)
		      (gtk-box-pack-start vbox label-ptr)
		      (gtk-widget-relate-label widget-ptr label-ptr)
		      (setq vbox (add-tooltip vbox))
		      (gtk-widget-show-all vbox)
		      vbox)

		(if (or (string-match "\\\\left" doc)
                        (string-match "\\\\w" doc)) ;; backwards compat
		    (let ((hbox (gtk-hbox-new nil box-spacing)))
			(setq widget-ptr (slot-gtk-widget slot))
			(setq label-ptr (make-label (substring doc 0 (match-start))))
			(gtk-box-pack-start hbox label-ptr)
			(gtk-box-pack-start hbox widget-ptr nil nil)
			(gtk-widget-relate-label widget-ptr label-ptr)
			(setq hbox (add-tooltip hbox))
			(gtk-widget-show-all hbox)
			hbox)

		  (let ((hbox (gtk-hbox-new nil box-spacing)))
		      (setq widget-ptr (slot-gtk-widget slot))
		      (setq label-ptr (make-label doc))
		      (gtk-box-pack-start hbox widget-ptr nil nil)
		      (gtk-box-pack-start hbox label-ptr)
		      (gtk-widget-relate-label widget-ptr label-ptr)
		      (setq hbox (add-tooltip hbox))
		      (gtk-widget-show-all hbox)
		      hbox)))))))))

  (define (make-label text)
    (let ((label (gtk-label-new text)))
      (gtk-label-set-justify label 'left)
      ;; XXX GtkLabel line wrapping sucks, but it stops the
      ;; XXX text disappearing..
      (gtk-label-set-line-wrap label t)
      label)))

;; move-resize.jl -- interactive moving and resizing of windows
;; $Id: move-resize.jl,v 1.79 2000/10/20 23:24:13 john Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.move-resize

    (export move-window-interactively
	    resize-window-interactively
	    move-selected-window
	    resize-selected-window)

    (open rep
	  rep.system
	  rep.regexp
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.misc
	  sawfish.wm.state.maximize
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.util.stacking
	  sawfish.wm.util.edges)

  (define-structure-alias move-resize sawfish.wm.commands.move-resize)

  ;; we bind to disable-auto-raise
  (eval-when-compile (require 'sawfish.wm.ext.auto-raise))

  ;; todo:
  ;;  * obey the aspect ratio size hints

  (defcustom move-outline-mode 'opaque
    "How windows being moved are animated: \\w"
    :type symbol
    :options (opaque box)
    :user-level novice
    :group move)
  
  (defcustom resize-outline-mode 'opaque
    "How windows being resized are animated: \\w"
    :type symbol
    :options (opaque box)
    :user-level novice
    :group move)
  
  (defcustom move-resize-raise-window nil
    "Raise windows when they are moved or resized."
    :group move
    :type boolean)
  
  (defcustom move-show-position nil
    "Show current position of windows while moving."
    :group move
    :type boolean)
  
  (defcustom resize-show-dimensions t
    "Show current dimensions of windows while resizing."
    :group move
    :type boolean)
  
  (defcustom resize-edge-mode 'border
    "How to choose window edges when resizing: \\w"
    :type (choice region border grab border-grab)
    :user-level expert
    :group move)
  
  (defcustom move-snap-edges t
    "Snap window position to edges of other windows while moving."
    :group move
    :type boolean)
  
  (defcustom move-snap-epsilon 8
    "Proximity in pixels before snapping to a window edge."
    :group move
    :depends move-snap-edges
    :type (number 0 64)
    :user-level expert)
  
  (defcustom move-snap-mode 'resistance
    "How to snap together window edges: \\w"
    :group move
    :depends move-snap-edges
    :type (choice magnetism resistance attraction)
    :user-level expert)
  
  (defcustom move-snap-ignored-windows nil
    "Snap to otherwise-ignored windows."
    :group move
    :depends move-snap-edges
    :user-level expert
    :type boolean)
  
  (defcustom move-lock-when-maximized t
    "Lock position and size while windows are maximized."
    :type boolean
    :group (min-max maximize))
  
  (defcustom move-resize-inhibit-configure nil
    "Only update window contents after it has stopped moving."
    :type boolean
    :group move
    :user-level expert)

  (defvar move-resize-map (bind-keys (make-keymap)
			    "Any-Off" (lambda () (finished))
			    "Any-Move" (lambda () (motion))
			    "Any-ESC" (lambda () (cancel))
			    "Any-RET" (lambda () (finished))
			    "Up" 'move-cursor-up
			    "Down" 'move-cursor-down
			    "Left" 'move-cursor-left
			    "Right" 'move-cursor-right
			    "S-Up" 'move-cursor-up-fine
			    "S-Down" 'move-cursor-down-fine
			    "S-Left" 'move-cursor-left-fine
			    "S-Right" 'move-cursor-right-fine))

  (define fp-edges-alist '((top-border top)
			   (left-border left)
			   (right-border right)
			   (bottom-border bottom)
			   (top-left-corner top left)
			   (top-right-corner top right)
			   (bottom-left-corner bottom left)
			   (bottom-right-corner bottom right)))

  (defvar move-cursor-shape 'hand2)
  (defvar resize-cursor-shape 'hand2)

  ;; specials, should make these fluids (external users?)
  (defvar move-resize-window nil)
  (defvar move-resize-function nil)
  (defvar move-resize-x nil)
  (defvar move-resize-y nil)
  (defvar move-resize-width nil)
  (defvar move-resize-height nil)
  (defvar move-resize-old-x nil)
  (defvar move-resize-old-y nil)
  (defvar move-resize-old-width nil)
  (defvar move-resize-old-height nil)
  (defvar move-resize-old-ptr-x nil)
  (defvar move-resize-old-ptr-y nil)
  (defvar move-resize-last-ptr nil)
  (defvar move-resize-snap-state nil)
  (defvar move-resize-mode nil)
  (defvar move-resize-hints nil)
  (defvar move-resize-frame nil)
  (defvar move-resize-edges nil)
  (defvar move-resize-last-outline nil)
  (defvar move-resize-moving-edges nil)
  (defvar move-resize-directions nil)

  ;; called to initiate a move or resize on window W. FUNCTION is either
  ;; `move' or `resize'
  (define (do-move-resize w function)
    (if (eq function 'move)
	(call-window-hook 'before-move-hook w)
      (call-window-hook 'before-resize-hook w))
    (let* ((from-motion-event (and (current-event)
				   (string-match "-Move$" (event-name
							   (current-event)))))
	   (override-keymap move-resize-map)
	   ;; don't want any complications..
	   (unbound-key-hook nil)
	   (disable-auto-raise t)
	   (move-resize-window w)
	   (move-resize-function function)
	   (move-resize-old-x (car (window-position w)))
	   (move-resize-old-y (cdr (window-position w)))
	   (move-resize-old-width (car (window-dimensions w)))
	   (move-resize-old-height (cdr (window-dimensions w)))
	   (move-resize-x move-resize-old-x)
	   (move-resize-y move-resize-old-y)
	   (move-resize-width move-resize-old-width)
	   (move-resize-height move-resize-old-height)
	   (move-resize-last-ptr  (if from-motion-event
				      (query-button-press-pointer)
				    (query-pointer t)))
	   (move-resize-snap-state (cons))
	   (move-resize-old-ptr-x (car move-resize-last-ptr))
	   (move-resize-old-ptr-y (cdr move-resize-last-ptr))
	   (move-resize-hints (window-size-hints w))
	   (move-resize-frame (cons (- (car (window-frame-dimensions w))
				       move-resize-old-width)
				    (- (cdr (window-frame-dimensions w))
				       move-resize-old-height)))
	   (move-resize-mode (if (eq function 'move)
				 move-outline-mode
			       resize-outline-mode))
	   (move-resize-edges nil)
	   (move-resize-last-outline nil)
	   (move-resize-moving-edges move-resize-moving-edges)
	   (move-resize-directions move-resize-directions)
	   (old-frame-draw-mutex
	    (frame-draw-mutex (not (eq move-resize-mode 'opaque))))
	   (old-frame-state-mutex (frame-state-mutex 'clicked))
	   (old-synthetic-configure-mutex
	    (synthetic-configure-mutex move-resize-inhibit-configure))
	   server-grabbed)

      (when (and move-resize-raise-window (eq move-resize-mode 'opaque))
	;; only raise window initially if the display will get updated
	(raise-window* w))

      (update-edges)
      (unless (eq move-resize-mode 'opaque)
	(require 'sawfish.wm.util.window-outline)
	;; prevent any other programs drawing on the display
	(grab-server)
	(setq server-grabbed t))

      (add-hook 'enter-workspace-hook update-edges)
      (add-hook 'viewport-moved-hook update-edges)
      (unwind-protect
	  (progn
	    (allow-events 'async-pointer)
	    ;; ensure that we catch _all_ mouse events
	    (when (grab-pointer
		   nil (if (eq move-resize-function 'move)
			   move-cursor-shape resize-cursor-shape))
	      (unwind-protect
		  (progn
		    (grab-keyboard w)	;this may fail
		    (unless (eq move-resize-mode 'opaque)
		      (setq move-resize-last-outline
			    (list move-resize-mode
				  move-resize-x move-resize-y
				  (+ move-resize-width
				     (car move-resize-frame))
				  (+ move-resize-height
				     (cdr move-resize-frame))))
		      (apply draw-window-outline move-resize-last-outline))
		    (if (eq move-resize-function 'resize)
			(unless (eq resize-edge-mode 'grab)
			  (infer-anchor))
		      (infer-directions))
		    (catch 'move-resize-done
		      (when from-motion-event
			(motion))
		      (recursive-edit)))
		(ungrab-keyboard)
		(ungrab-pointer))))

	(when server-grabbed
	  (ungrab-server))
	(display-message nil)
	(frame-draw-mutex old-frame-draw-mutex)
	(frame-state-mutex old-frame-state-mutex)
	(synthetic-configure-mutex old-synthetic-configure-mutex)
	(remove-hook 'enter-workspace-hook update-edges)
	(remove-hook 'viewport-moved-hook update-edges))

      (when (and move-resize-raise-window (not (eq move-resize-mode 'opaque)))
	(raise-window* w))
      (if (eq function 'move)
	  (call-window-hook 'after-move-hook w (list move-resize-directions))
	(call-window-hook 'after-resize-hook w
			  (list move-resize-moving-edges)))))

  (define (update-edges)
    (setq move-resize-edges
	  (and move-snap-edges
	       (progn
		 (get-visible-window-edges
		  #:with-ignored-windows move-snap-ignored-windows
		  #:windows-to-ignore (list move-resize-window)
		  #:include-heads t)))))

  ;; called each pointer motion event during move/resize
  (define (motion)
    (let* ((this-ptr (query-pointer))
	   (ptr-x (car this-ptr))
	   (ptr-y (cdr this-ptr))
	   logical-width logical-height)
      (unless (eq move-resize-mode 'opaque)
	(apply erase-window-outline move-resize-last-outline))
      (cond ((eq move-resize-function 'move)
	     (when (memq 'horizontal move-resize-directions)
	       (setq move-resize-x (+ move-resize-old-x
				      (- ptr-x move-resize-old-ptr-x))))
	     (when (memq 'vertical move-resize-directions)
	       (setq move-resize-y (+ move-resize-old-y
				      (- ptr-y move-resize-old-ptr-y))))
	     (when move-snap-edges
	       (let
		   ((coords (snap-window-position-to-edges
			     move-resize-window (cons move-resize-x
						      move-resize-y)
			     (cons (- ptr-x (car move-resize-last-ptr))
				   (- ptr-y (cdr move-resize-last-ptr)))
			     move-resize-snap-state move-snap-epsilon
			     move-resize-edges move-snap-mode)))
		 (setq move-resize-x (car coords))
		 (setq move-resize-y (cdr coords)))))
	    ((eq move-resize-function 'resize)
	     (let
		 ((x-base (or (cdr (or (assq 'base-width move-resize-hints)
				       (assq 'min-width move-resize-hints))) 1))
		  (x-inc (or (cdr (assq 'width-inc move-resize-hints)) 1))
		  (y-base (or (cdr (or (assq 'base-height move-resize-hints)
				       (assq 'min-height move-resize-hints))) 1))
		  (y-inc (or (cdr (assq 'height-inc move-resize-hints)) 1)))
	       (when (memq resize-edge-mode '(grab border-grab))
		 (add-edges ptr-x ptr-y))
	       (cond
		((memq 'right move-resize-moving-edges)
		 (setq move-resize-width
		       (constrain-dimension-to-hints
			(+ move-resize-old-width
			   (- ptr-x move-resize-old-ptr-x))
			'x move-resize-hints)))
		((memq 'left move-resize-moving-edges)
		 (setq move-resize-width
		       (constrain-dimension-to-hints
			(+ move-resize-old-width
			   (- move-resize-old-ptr-x ptr-x))
			'x move-resize-hints))
		 (setq move-resize-x (- move-resize-old-x
					(- move-resize-width
					   move-resize-old-width)))))
	       (cond
		((memq 'bottom move-resize-moving-edges)
		 (setq move-resize-height
		       (constrain-dimension-to-hints
			(+ move-resize-old-height
			   (- ptr-y move-resize-old-ptr-y))
			'y move-resize-hints)))
		((memq 'top move-resize-moving-edges)
		 (setq move-resize-height
		       (constrain-dimension-to-hints
			(+ move-resize-old-height
			   (- move-resize-old-ptr-y ptr-y))
			'y move-resize-hints))
		 (setq move-resize-y (- move-resize-old-y
					(- move-resize-height
					   move-resize-old-height)))))
	       (setq logical-width (quotient (- move-resize-width
						x-base) x-inc))
	       (setq logical-height (quotient (- move-resize-height
						 y-base) y-inc)))))
      (call-window-hook (if (eq move-resize-function 'move)
			    'while-moving-hook
			  'while-resizing-hook) move-resize-window)
      (cond ((and (eq move-resize-function 'resize) resize-show-dimensions)
	     (display-message (format nil "%dx%d"
				      ;; XXX broken if while-resizing-hook
				      ;; XXX changes dimensions..
				      logical-width logical-height)))
	    ((and (eq move-resize-function 'move) move-show-position)
	     (display-message (format nil "%+d%+d"
				      move-resize-x move-resize-y))))
      (if (eq move-resize-mode 'opaque)
	  (apply-changes)
	(let ((m-dim-x (+ move-resize-width (car move-resize-frame)))
	      (m-dim-y (+ move-resize-height (cdr move-resize-frame))))
	  (setq move-resize-last-outline (list move-resize-mode
					       move-resize-x move-resize-y
					       m-dim-x m-dim-y))
	  (apply draw-window-outline move-resize-last-outline)))
      (setq move-resize-last-ptr this-ptr)))

  ;; called when the move/resize finished (i.e. button-release event)
  (define (finished)
    (unless (eq move-resize-mode 'opaque)
      (apply erase-window-outline move-resize-last-outline))
    (apply-changes)
    (throw 'move-resize-done t))

  (define (cancel)
    (if (eq move-resize-mode 'opaque)
	(move-resize-window-to move-resize-window
			       move-resize-old-x move-resize-old-y
			       move-resize-old-width move-resize-old-height)
      (apply erase-window-outline move-resize-last-outline))
    (throw 'move-resize-done nil))

  ;; commit the current state of the move or resize
  (define (apply-changes)
    (cond
     ((>= move-resize-x (screen-width))
      (setq move-resize-x (1- (screen-width))))
     ((<= move-resize-x (- (+ move-resize-width (car move-resize-frame))))
      (setq move-resize-x (1+ (- (+ move-resize-width
				    (car move-resize-frame)))))))
    (cond
     ((>= move-resize-y (screen-height))
      (setq move-resize-y (1- (screen-height))))
     ((<= move-resize-y (- (+ move-resize-height (cdr move-resize-frame))))
      (setq move-resize-y (1+ (- (+ move-resize-height
				    (cdr move-resize-frame)))))))
    (move-resize-window-to move-resize-window
			   move-resize-x move-resize-y
			   move-resize-width move-resize-height))

  ;; called when moving, tries to decide which edges to move, which to stick
  (define (infer-anchor)
    (unless move-resize-moving-edges
      (let (tem)
	(if (and (memq resize-edge-mode '(border border-grab))
		 (clicked-frame-part)
		 (setq tem (frame-part-get (clicked-frame-part) 'class))
		 (setq tem (cdr (assq tem fp-edges-alist))))
	    (setq move-resize-moving-edges (copy-sequence tem))
	  (cond ((<= (- move-resize-old-ptr-x move-resize-old-x)
		     (/ move-resize-old-width 3))
		 (setq move-resize-moving-edges
		       (cons 'left move-resize-moving-edges)))
		((>= (- move-resize-old-ptr-x move-resize-old-x)
		     (* (/ move-resize-old-width 3) 2))
		 (setq move-resize-moving-edges
		       (cons 'right move-resize-moving-edges))))
	  (cond ((<= (- move-resize-old-ptr-y move-resize-old-y)
		     (/ move-resize-old-height 3))
		 (setq move-resize-moving-edges
		       (cons 'top move-resize-moving-edges)))
		((>= (- move-resize-old-ptr-y move-resize-old-y)
		     (* (/ move-resize-old-height 3) 2))
		 (setq move-resize-moving-edges
		       (cons 'bottom move-resize-moving-edges)))))))
    (when (null move-resize-moving-edges)
      (setq move-resize-moving-edges '(bottom right)))
    (when move-lock-when-maximized
      (when (window-maximized-vertically-p move-resize-window)
	(setq move-resize-moving-edges
	      (delq 'top (delq 'bottom move-resize-moving-edges))))
      (when (window-maximized-horizontally-p move-resize-window)
	(setq move-resize-moving-edges
	      (delq 'left (delq 'right move-resize-moving-edges))))))

  (define (add-edges ptr-x ptr-y)
    (unless (or (and move-lock-when-maximized
		     (window-maximized-horizontally-p move-resize-window))
		(memq 'left move-resize-moving-edges)
		(memq 'right move-resize-moving-edges))
      (cond ((< ptr-x move-resize-x)
	     (setq move-resize-moving-edges
		   (cons 'left move-resize-moving-edges))
	     (setq move-resize-old-ptr-x move-resize-x))
	    ((> ptr-x (+ move-resize-x move-resize-width
			 (car move-resize-frame)))
	     (setq move-resize-moving-edges
		   (cons 'right move-resize-moving-edges))
	     (setq move-resize-old-ptr-x (+ move-resize-x move-resize-width
					    (car move-resize-frame))))))
    (unless (or (and move-lock-when-maximized
		     (window-maximized-vertically-p move-resize-window))
		(memq 'top move-resize-moving-edges)
		(memq 'bottom move-resize-moving-edges))
      (cond ((< ptr-y move-resize-y)
	     (setq move-resize-moving-edges
		   (cons 'top move-resize-moving-edges))
	     (setq move-resize-old-ptr-y move-resize-y))
	    ((> ptr-y (+ move-resize-y move-resize-height
			 (cdr move-resize-frame)))
	     (setq move-resize-moving-edges
		   (cons 'bottom move-resize-moving-edges))
	     (setq move-resize-old-ptr-y (+ move-resize-y move-resize-height
					    (cdr move-resize-frame)))))))

  (define (infer-directions)
    (unless move-resize-directions
      (setq move-resize-directions
	    (if (window-get move-resize-window 'fixed-position)
		'()
	      (list 'vertical 'horizontal))))
    (when move-lock-when-maximized
      (when (window-maximized-horizontally-p move-resize-window)
	(setq move-resize-directions
	      (delq 'horizontal move-resize-directions)))
      (when (window-maximized-vertically-p move-resize-window)
	(setq move-resize-directions
	      (delq 'vertical move-resize-directions)))))


;;; hook functions

  (define (lost-window w)
    (when (eq move-resize-window w)
      (finished)))

  (add-hook 'unmap-notify-hook lost-window t)
  (add-hook 'destroy-notify-hook lost-window t)


;;; Entry points

  (define (move-window-interactively w)
    "Move the window interactively using the mouse."
    (do-move-resize w 'move))

  (define (resize-window-interactively w)
    "Resize the window interactively using the mouse."
    (do-move-resize w 'resize))

  (define (move-selected-window)
    "Wait for the user to select a window, then interactively move that window."
    (let ((w (select-window)))
      (when w
	(move-window-interactively w))))

  (define (resize-selected-window)
    "Wait for the user to select a window, then interactively resize that window."
    (let ((w (select-window)))
      (when w
	(resize-window-interactively w))))

  ;;###autoload
  (define-command 'move-window-interactively
    move-window-interactively #:spec "%W")
  (define-command 'resize-window-interactively
    resize-window-interactively #:spec "%W")
  (define-command 'move-selected-window move-selected-window)
  (define-command 'resize-selected-window resize-selected-window))

(setq load-path (nconc load-path (list "/var/lib/sawfish")))
(let*
    ((dir "/etc/X11/sawfish/site-init.d")
     (files (and (file-directory-p dir) (directory-files dir))))
  (mapc
    (lambda (file)
      (condition-case data
          (load (expand-file-name file dir) t t t)
        (error (error-handler-function (car data) (cdr data)))))
    (sort files)))

;; sawmill-default.jl -- default user startup
;; $Id: defaults.jl,v 1.19 2000/11/15 21:51:02 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Commentary:

;; This file provides defaults for users without .sawmillrc files

(declare (in-module user))

;; magic comment to get an alias installed
;; (define-structure-alias sawmill-defaults sawfish.wm.defaults)

;; this is probably good for novice users?
(require 'sawfish.wm.ext.window-history)

;; save errors to aid debugging
(require 'sawfish.wm.ext.error-handler)

;; raise-commands.jl -- some commands for raising windows

;; Copyright (C) 1999-2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.raise-commands

    (export )

    (open rep
          sawfish.wm.windows
          sawfish.wm.events
          sawfish.wm.stacking
          sawfish.wm.util.stacking
          sawfish.wm.state.transient
          sawfish.wm.commands.groups
          sawfish.wm.commands
          sawfish.wm.focus)

  (define (replay-pointer w)
    ;; click-to-focus mode sets this to t when it calls a command
    ;; from within a button press event
    (unless (and (fluid focus-within-click-event)
		 (not (or focus-click-through
			  (window-get w 'focus-click-through)
			  (not (window-really-wants-input-p w)))))
      (allow-events 'replay-pointer)
      (unless (clicked-frame-part)
	(forget-button-press))))

  (define (and-pass-through-click w)
    "Raise the window that received the current event, then replay any pointer
events that invoked the command."
    (when (windowp w)
      (raise-window* w))
    (replay-pointer w))

  (define (and-pass-through-click-if-focused w)
    "Raise the window that received the current event (if it's focused), then
replay any pointer events that invoked the command."
    (when (and (windowp w) (eq w (input-focus)))
      (raise-window* w))
    (replay-pointer w))

  (define (or-pass-through-click w)
    (if (and (windowp w) (not (window-on-top-p w)))
	(raise-window* w)
      (replay-pointer w)))

  ;;###autoload
  (define-command 'raise-and-pass-through-click
    and-pass-through-click #:spec "%W")
  (define-command 'raise-and-pass-through-click-if-focused
    and-pass-through-click-if-focused #:spec "%w")
  (define-command 'raise-or-pass-through-click
    or-pass-through-click #:spec "%w")

;;; these should probably be considered obsolete

  (define (window-and-pass-through-click w)
    "Raise the window that received the current event, then replay any pointer
events that invoked the command."
    (when (windowp w)
      (raise-window w))
    (replay-pointer w))

  (define (group-and-pass-through-click w)
    "Raise the group of windows that received the current event, then replay
any pointer events that invoked the command."
    (when (windowp w)
      (raise-group w))
    (replay-pointer w))

  (define (transients-and-pass-through-click w)
    "Raise the window that received the current event and any transients it
has, then replay any pointer events that invoked the command."
    (when (windowp w)
      (raise-window-and-transients w))
    (replay-pointer w))

  ;;###autoload
  (define-command 'raise-window-and-pass-through-click
    window-and-pass-through-click #:spec "%w")
  (define-command 'raise-group-and-pass-through-click
    group-and-pass-through-click #:spec "%w")
  (define-command 'raise-transients-and-pass-through-click
    transients-and-pass-through-click #:spec "%w"))

;; place-window.jl -- decide where to initially place a window

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.placement

    (export define-placement-mode
	    autoload-placement-mode
	    placement-mode
	    acceptable-placement
	    place-window)

    (open rep
	  rep.system
	  rep.util.autoloader
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.util.groups
	  sawfish.wm.util.workarea
	  sawfish.wm.custom)

  (defcustom place-window-mode 'top-left
    "Method of placing windows: \\left"
    :type symbol
    :group (misc placement))

  (defcustom place-transient-mode 'centered-on-parent
    "Method of placing dialog windows: \\left"
    :type symbol
    :group (misc placement))

  (defcustom ignore-program-positions t
    "Ignore program-specified window placements."
    :type boolean
    :group (misc placement))

  (defvar placement-modes '()
    "List of names of all placement modes.")

;;; utility functions

  ;; autoload handling
  (define (getter symbol) (get symbol 'placement-mode))
  (define (setter symbol value)
    (unless (memq symbol placement-modes)
      (setq placement-modes (nconc placement-modes (list symbol))))
    (put symbol 'placement-mode value))
  (define autoloader (make-autoloader getter setter))
  (define placement-mode (autoloader-ref getter))

  (define (apply-keys name #!key for-normal for-dialogs)
    (define (add-to sym name)
      (let ((current (custom-get-property sym ':options)))
	(custom-set-property sym ':options
			     (nconc (delq name current) (list name)))))
    (when for-normal
      (add-to 'place-window-mode name))
    (when for-dialogs
      (add-to 'place-transient-mode name)))

  (define (define-placement-mode name fun . keys)
    "Define a new window placement mode called NAME (a symbol). The function
FUN will be called with a single argument when a window should be placed using
this mode. The single argument is the window to be placed."
    (setter name fun)
    (apply apply-keys name keys))

  (define (autoload-placement-mode name module . keys)
    (autoloader name module)
    (apply apply-keys name keys))

  (define (adjust-window-for-gravity w grav #!optional unadjust)
    (let ((coords (adjust-position-for-gravity
		   w grav (window-position w) unadjust)))
      (move-window-to w (car coords) (cdr coords))))

  ;; make sure the window doesn't overlap an avoided window
  (define (acceptable-placement w position)
    (require 'sawfish.wm.util.rects)
    (or (window-avoided-p w)
	(let* ((avoided-windows (filter-windows window-avoided-p))
	       (rects (rectangles-from-windows avoided-windows))
	       (dims (window-frame-dimensions w)))
	  (= 0 (rect-total-overlap dims position rects)))))

  ;; called from the place-window-hook
  (define (place-window w)
    (let ((hints (window-size-hints w)))
      ;; The only time this is ever called with (window-get w 'placed) non-nil
      ;; is when we're initializing the wm, and we want to adjust the window's
      ;; position for its gravity setting
      (if (or (window-get w 'placed)
	      (cdr (assq 'user-position hints))
	      (and (not (window-get w 'ignore-program-position))
		   (not ignore-program-positions)
		   (cdr (assq 'program-position hints))
		   (or (window-get w 'ignored)
		       (acceptable-placement w (window-position w))))
	      (window-get w 'fixed-position))
	  (adjust-window-for-gravity w (window-gravity w))
	(let ((mode (or (window-get w 'place-mode)
			(if (window-transient-p w)
			    place-transient-mode
			  place-window-mode))))
	  ((or (placement-mode mode) place-window-randomly) w)))
      t))

  (define (unplace-window w)
    (adjust-window-for-gravity w (window-gravity w) t))

  (add-hook 'place-window-hook place-window t)
  (add-hook 'remove-window-hook unplace-window)

;;; standard placement modes

  (define (place-window-randomly w)
    (let* ((dims (window-frame-dimensions w))
	   (max-rect (calculate-workarea #:window w #:head (current-head)))
	   (rect-dims (cons (- (nth 2 max-rect) (nth 0 max-rect))
			    (- (nth 3 max-rect) (nth 1 max-rect))))
	   (rect-pos (cons (nth 0 max-rect) (nth 1 max-rect)))
	   (x (+ (car rect-pos)
		 (if (< (car dims) (car rect-dims))
		     (random (- (car rect-dims) (car dims)))
		   0)))
	   (y (+ (cdr rect-pos)
		 (if (< (cdr dims) (cdr rect-dims))
		     (random (- (cdr rect-dims) (cdr dims)))
		   0))))
      (move-window-to w x y)))

  (define (place-window-interactively w)
    (require 'sawfish.wm.commands.move-resize)
    (let ((move-outline-mode 'box)
	  (move-from-interactive-placement t)
	  (ptr (query-pointer))
	  (dims (window-frame-dimensions w)))
      ;; XXX hacktastic! I don't know why the next thing is needed,
      ;; XXX but it is -- if the window was popped by a button click
      ;; XXX the ButtonRelease can get caught by move-window-int..
      ;; XXX (try double clicking on a gmc icon)
      ;; XXX 8 = ButtonReleaseMask
      (accept-x-input 8)
      (when (window-id w)
	(move-window-to w (- (car ptr) (quotient (car dims) 2))
			(- (cdr ptr) (quotient (cdr dims) 2)))
	(move-window-interactively w))))

  (define (place-window-centered w)
    (let ((dims (window-frame-dimensions w))
	  (h-dims (current-head-dimensions))
	  (h-off (current-head-offset))
	  (screen (calculate-workarea #:window w #:head (current-head))))
      (move-window-to w
		      (clamp* (+ (car h-off)
				 (quotient (- (car h-dims) (car dims)) 2))
			      (car dims) (nth 0 screen) (nth 2 screen))
		      (clamp* (+ (cdr h-off)
				 (quotient (- (cdr h-dims) (cdr dims)) 2))
			      (cdr dims) (nth 1 screen) (nth 3 screen)))))

  (define (place-window-centered-on-parent w)
    (let ((parent (let ((id (window-transient-p w)))
		    (and id (get-window-by-id id)))))
      ;; if no known parent, look if the focused window is in the
      ;; same group as W, if so use it
      (when (and (not parent) (not (eq (input-focus) w))
		 (memq (input-focus) (windows-in-group w)))
	(setq parent (input-focus)))
      (if (not parent)
	  (place-window-centered w)
	(let ((dims (window-frame-dimensions w))
	      (pdims (window-frame-dimensions parent))
	      (coords (window-position parent))
	      (screen (calculate-workarea #:window w
                                          #:head (current-head parent))))
	  (rplaca coords (clamp* (+ (car coords)
				    (quotient (- (car pdims) (car dims)) 2))
				 (car dims) (nth 0 screen) (nth 2 screen)))
	  (rplacd coords (clamp* (+ (cdr coords)
				    (quotient (- (cdr pdims) (cdr dims)) 2))
				 (cdr dims) (nth 1 screen) (nth 3 screen)))
	  (move-window-to w (car coords) (cdr coords))))))

  (define (place-window-under-pointer w)
    (let ((dims (window-frame-dimensions w))
	  (coords (query-pointer))
	  (screen (calculate-workarea #:window w #:head (pointer-head))))
      (rplaca coords (clamp* (- (car coords) (quotient (car dims) 2))
			     (car dims) (nth 0 screen) (nth 2 screen)))
      (rplacd coords (clamp* (- (cdr coords) (quotient (cdr dims) 2))
			     (cdr dims) (nth 1 screen) (nth 3 screen)))
      (move-window-to w (car coords) (cdr coords))))

  (define-placement-mode 'randomly place-window-randomly
    #:for-normal t #:for-dialogs t)
  (define-placement-mode 'interactively place-window-interactively
    #:for-normal t #:for-dialogs t)
  (define-placement-mode 'centered place-window-centered
    #:for-normal t #:for-dialogs t)
  (define-placement-mode 'centered-on-parent place-window-centered-on-parent
    #:for-normal t #:for-dialogs t)
  (define-placement-mode 'under-pointer place-window-under-pointer
    #:for-normal t #:for-dialogs t)
  (define-placement-mode 'none nop
    #:for-normal t #:for-dialogs t))

;; razor.jl -- Razor-Qt integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.razor

    (export detect-razor)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
	  sawfish.wm.windows
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias razor-int sawfish.wm.integration.razor)

  (define (init)
    (let (menu)
      (setq desktop-environment "razor")
      (setq want-poweroff-menu nil)

      ;; invoke the Razor-Qt terminal instead of xterm
      ;;
      ;; XXX Razor-Qt does not come with a default terminal-emulator
      ;; XXX candidate for int: konsole
      ;;
      ;; (unless (variable-customized-p 'xterm-program)
      ;; 	(setq xterm-program "razor-terminal"))

      ;; use the Razor-Qt help browser and url launcher
      ;;
      ;; XXX Razor-Qt does not come with a default browser
      ;; XXX candidate for int: QupZilla
      ;;
      ;; (unless (variable-customized-p 'browser-program)
      ;; 	(setq browser-program "razor-www-browser"))

      ;; use the Razor-Qt filemanager
      ;;
      ;; XXX Razor-Qt does not come with a default filemanager
      ;; XXX candidate: ??
      ;;
      ;; (unless (variable-customized-p 'filemanager-program)
      ;;   (setq filemanager-program "razor-fm"))

      ;; add some Razor-Qt menu-entries
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "Razor-Qt _Website") (browser "http://www.razor-qt.org"))
		      (,(_ "About Razor-Qt") (system "razor-about &")))))

      ;; add razor-logout and customize menu-entries
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_Customize Razor-Qt") (system "razor-config &"))
		      ;; XXX candidate: kmenuedit
		      ;; (,(_ "_Edit Razor-Qt menu") (system " &"))
		      ()
		      (,(_ "_Logout from Razor-Qt")
		       (system "razor-power logout &"))
		      (,(_ "_Reboot from Razor-Qt")
		       (system "razor-power reboot &"))
		      (,(_ "_Shutdown from Razor-Qt")
		       (system "razor-power shutdown &"))
		      (,(_ "S_uspend from Razor-Qt")
		       (system "razor-power suspend &"))
		      (,(_ "_Hibernate from Razor-Qt")
		       (system "razor-power hibernate &")))))))

  ;; Returns nil if razor is not found.
  ;; If detected, returns t, and do also razor support init.
  (define (detect-razor)
    (when (or (equal (getenv "XDG_CURRENT_DESKTKOP") "Razor")
	      (equal (getenv "DESKTOP_SESSION") "razor")
	      (get-window-by-class "Razor-desktop" #:regex t))
      (init)
      t)))

;; tooltips.jl -- display frame-part keymap descriptions

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.ext.tooltips

    (export display-tooltip
	    display-tooltip-after-delay
	    remove-tooltip)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.colors
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.events
	  sawfish.wm.util.keymap)

  (define-structure-alias tooltips sawfish.wm.ext.tooltips)

  (define tooltips-timer nil)

  ;;###autoload (defgroup tooltips "Tooltips" :group appearance :require sawfish.wm.ext.tooltips)

  (defgroup tooltips "Tooltips"
    :group appearance
    :require sawfish.wm.ext.tooltips)

  (defcustom tooltips-enabled nil
    "Display tooltips for window frames."
    :type boolean
    :group (appearance tooltips)
    :require sawfish.wm.ext.tooltips)

  (defcustom tooltips-show-doc-strings nil
    "Show full documentation in tooltips."
    :type boolean
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-delay 500
    "Number of milliseconds before displaying tooltips."
    :type number
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-timeout-delay 5000
    "Number of milliseconds before removing tooltips."
    :type number
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-font default-font
    "Font used to display tooltips, or nil for default."
    :type font
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-background-color "grey85"
    "Color used for the tooltips background"
    :type color
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-foreground-color "black"
    "Color used for the tooltips foreground"
    :type color
    :depends tooltips-enabled
    :group (appearance tooltips))

;;; displaying tooltips

  ;; the window it's displayed for (or t)
  (define tooltips-displayed nil)

  (define (display-tooltip text #!optional win)
    (let ((pos (query-pointer))
	  (pos-fn (lambda (in size inc)
		    (if (< in (/ size 2))
			(+ in inc)
		      (- (+ (- size in) inc))))))
      (rplaca pos (pos-fn (car pos) (screen-width) 0))
      (rplacd pos (pos-fn (cdr pos) (screen-height) 16))
      (display-message (if (functionp text) (text) text)
		       `((position . ,pos)
			 (background . ,tooltips-background-color)
			 (foreground . ,tooltips-foreground-color)
			 (x-justify . left)
			 (spacing . 2)
			 ,@(and tooltips-font
				(list (cons 'font tooltips-font)))))
      (setq tooltips-displayed (or win t))
      (setq tooltips-timer
	    (make-timer remove-tooltip
			(quotient tooltips-timeout-delay 1000)
			(mod tooltips-timeout-delay 1000)))
      (unless (in-hook-p 'pre-command-hook remove-tooltip)
	(add-hook 'pre-command-hook remove-tooltip))))

  (define (remove-tooltip)
    (remove-hook 'pre-command-hook remove-tooltip)
    (when tooltips-displayed
      (display-message nil)
      (setq tooltips-displayed nil))
    (when tooltips-timer
      (delete-timer tooltips-timer)
      (setq tooltips-timer nil)))

  (define (tooltips-unmapped win)
    (when (eq win tooltips-displayed)
      (remove-tooltip)))

  (add-hook 'unmap-notify-hook tooltips-unmapped)

  (define (call-after-delay thunk)
    (remove-tooltip)
    (when tooltips-enabled
      (setq tooltips-timer (make-timer (lambda ()
					 (setq tooltips-timer nil)
					 (thunk))
				       (quotient tooltips-delay 1000)
				       (mod tooltips-delay 1000)))
      (unless (in-hook-p 'pre-command-hook remove-tooltip)
	(add-hook 'pre-command-hook remove-tooltip))))

  (define (display-tooltip-after-delay . args)
    (call-after-delay (lambda ()
			(apply display-tooltip args))))

;;; frame-part tooltips

  ;; each item is (EVENT-DESC . DOC)
  (define (tooltips-format items)
    (let ((max-event-width 0)
	  (split (lambda (s)
		   (let (point parts)
		     (while (string-match "\n" s point)
		       (setq parts (cons (substring
					  s (or point 0) (match-start)) parts))
		       (setq point (match-end)))
		     (setq parts (cons (substring s (or point 0)) parts))
		     (nreverse parts))))
	  out)
      (mapc (lambda (cell)
	      (setq max-event-width (max max-event-width (length (car cell)))))
	    items)
      (setq max-event-width (1+ max-event-width))
      (mapc (lambda (cell)
	      (setq out (cons (car cell) out))
	      (setq out (cons (make-string (- max-event-width
					      (length (car cell))) ? ) out))
	      (let ((parts (split (cdr cell))))
		(when parts
		  (setq out (cons (car parts) out))
		  (setq out (cons ?\n out)))
		(mapc (lambda (string)
			(setq out (cons (make-string max-event-width ? ) out))
			(setq out (cons string out))
			(setq out (cons ?\n out))) (cdr parts)))) items)
      (apply concat (nreverse out))))

  (define (command-info command)
    (let (doc)
      (if (and tooltips-show-doc-strings command
	       (symbolp command)
	       (setq doc (command-documentation command)))
	  (_ doc)
	(format nil "%S" command))))

  (define (display-fp-tooltip fp)
    (let ((keymap (frame-part-get fp 'keymap))
	  items)
      (when (symbolp keymap)
	(setq keymap (symbol-value keymap)))
      (when (cdr keymap)
	(map-keymap (lambda (cell)
		      (setq items (cons (cons (event-name (cdr cell))
					      (command-info (car cell))) items)))
		    keymap)
	(display-tooltip (tooltips-format (nreverse items))))))

  (define (tooltips-fp-enter win fp)
    (declare (unused win))
    (when tooltips-enabled
      (call-after-delay (lambda ()
			  (unless (clicked-frame-part)
			    (display-fp-tooltip fp))))))

  (add-hook 'enter-frame-part-hook tooltips-fp-enter)
  (add-hook 'leave-frame-part-hook remove-tooltip))

;; Utilities for window placement and tiling

(define-structure sawfish.wm.tile.utils
    (export current-workspace
            window-workspace
            tileable-workspace-windows
            window-type
            window-x
            window-y
            window-width
            window-height
            scr-height
            scr-width
            push-window
            resize-frame-to
            input-focus
            focus-window
            align-workspace-windows
            notify
            take
            group-by
	    window-never-tile-p)
    (open rep
          rep.io.timers
          sawfish.wm.stacking
          sawfish.wm.state.ignored
	  sawfish.wm.state.iconify
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.placement
	  sawfish.wm.workspace
          sawfish.wm.util.window-order
          sawfish.wm.misc)

  (define (window-workspace w) (car (window-get w 'workspaces)))

  (define (window-never-tile-p w) (window-get w 'never-tile))

  (define (tileable-workspace-windows #!optional ignore)
    (remove-if (lambda (w)
		 (or (equal w ignore)
		     (dock-window-p w)
		     (window-iconified-p w)
		     ;; window-matcher
		     (window-never-tile-p w)
		     ;; for pager and stuff
		     (not (window-visible-p w))
		     ;; no dialogs
		     (not (eq (window-type w) 'default))
		     (window-ignored-p w)))
               (window-order current-workspace)))

  (define (window-x w) (car (window-position w)))
  (define (window-y w) (cdr (window-position w)))
  (define (window-width w) (car (window-frame-dimensions w)))
  (define (window-height w) (cdr (window-frame-dimensions w)))
  (define (scr-height #!optional (tm 0) (bm 0)) (- (screen-height) tm bm))
  (define (scr-width #!optional (l 0) (r 0) (g 0)) (- (screen-width) l r g))

  (define (resize-frame-to w width height)
    (let ((width-offset (- (car (window-frame-dimensions w))
                           (car (window-dimensions w))))
          (height-offset (- (cdr (window-frame-dimensions w))
                            (cdr (window-dimensions w)))))
      (resize-window-to w (- width width-offset) (- height height-offset))))

  (define (push-window w x y width height)
    (resize-frame-to w (inexact->exact width) (inexact->exact height))
    (move-window-to w (inexact->exact x) (inexact->exact y))
    (window-order-push w))

  (define (focus-window w) (window-order-push w))

  (define (align-workspace-windows)
    (interactive)
    (let* ((fw (input-focus))
           (windows (tileable-workspace-windows fw))
           (x (window-x fw))
           (y (window-y fw)))
      (mapc (lambda (w)
              (push-window w x y (window-width w) (window-height w)))
            windows)))

  (define %hide-timer (make-timer (lambda () (display-message nil))))

  (define (notify fmt #!rest args)
    (display-message (apply format (cons nil (cons fmt args))))
    (set-timer %hide-timer 1))

  (define (take n l)
    (cond ((null l) '())
          ((<= n 0) '())
          ((= 1 n) (list (car l)))
          (t (cons (car l) (take (- n 1) (cdr l))))))

  (define (group-by ws n)
    (cond ((null ws) ws)
          ((< n 1) (list ws))
          ((<= (length ws) n) (list ws))
          (t (cons (take n ws) (group-by (nthcdr n ws) n))))))

;; nokogiri-widgets/scheme-boolean.jl --
;;
;; Copyright (C) 2002 John Harper <jsh@unfactored.org>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widgets.scheme-boolean

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (make-item changed-callback)
    (let ((widget (gtk-toggle-button-new-with-label (_ "Yes"))))
      (define (update-label)
	(gtk-label-set-text (car (gtk-container-get-children widget))
			    (if (gtk-toggle-button-get-active widget)
				(_ "Yes") (_ "No"))))
      (gtk-label-set-justify (car (gtk-container-get-children widget)) 'left)
      (gtk-toggle-button-set-active widget t)
      (g-signal-connect
       widget "toggled"
       (lambda ()
	 (update-label)
	 (when changed-callback
	   (call-callback changed-callback))))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (let ((state (not (memq x '(() #f)))))
		     (gtk-toggle-button-set-active widget state))))
	  ((clear) (lambda ()
		     (gtk-toggle-button-set-active widget nil)))
	  ((ref) (lambda ()
		   (if (gtk-toggle-button-get-active widget) '#t '#f)))
	  ((gtk-widget) widget)
	  ((validp) (lambda () t))))))

  (define-widget-type 'scheme-boolean make-item)
  (widget-accepts-doc-string 'scheme-boolean))

#| sawfish.wm bootstrap

   $Id: wm.jl,v 1.9 2000/11/16 22:12:55 jsh Exp $

   Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawmill.

   sawmill is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawmill is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawmill; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(declare (in-module sawfish.wm))

(open-structures '(rep rep.system rep.io.files))

;;(setq debug-on-error '(bad-arg missing-arg void-value invalid-function))

;; so modularised rep knows where to inherit specials and load from
;; this will be changed to 'user later
(setq *user-structure* 'sawfish.wm)

;; load always-present session-manager stuff
(require 'sawfish.wm.session.init)

;; set $DISPLAY so that any subprocesses inherit it
(setenv "DISPLAY" display-name)

;; load i18n support when necessary
(unless batch-mode
  (let ((lang (or (getenv "LANGUAGE") (getenv "LC_ALL")
		  (getenv "LC_MESSAGES") (getenv "LANG")))
	(disable-nls (get-command-line-option "--disable-nls")))

    (when (and lang (not disable-nls) (not (string= lang "C")))
      (require 'rep.i18n.gettext)
      (bindtextdomain "sawfish" sawfish-locale-directory)
      (textdomain "sawfish"))))

;; add ~/.sawfish/lisp to load-path for user-code (canonicalize it
;; now to avoid calling tilde file-handler multiple times)
(setq load-path (cons (canonical-file-name "~/.sawfish/lisp") load-path))

;; import libraries that may be needed by autoload files
(require 'sawfish.wm.commands)
(require 'sawfish.wm.custom)
(require 'sawfish.wm.focus)
(require 'sawfish.wm.placement)
(require 'sawfish.wm.window-anim)

;; load standard libraries (but don't import them)
(mapc intern-structure '(sawfish.wm.keymaps
			 sawfish.wm.workspace
			 sawfish.wm.viewport
			 sawfish.wm.stacking
			 sawfish.wm.frames
			 sawfish.wm.swapper
			 sawfish.wm.state.configure
			 sawfish.wm.state.maximize
			 sawfish.wm.state.mwm
			 sawfish.wm.state.open-look
			 sawfish.wm.state.transient
			 sawfish.wm.state.shading
			 sawfish.wm.state.iconify
			 sawfish.wm.state.ignored
			 sawfish.wm.server))

;; create the exports from sawfish.wm
(open-structures '(sawfish.wm.colors
		   sawfish.wm.commands
		   sawfish.wm.cursors
		   sawfish.wm.custom
		   sawfish.wm.events
		   sawfish.wm.focus
		   sawfish.wm.fonts
		   sawfish.wm.frames
		   sawfish.wm.gaol
		   sawfish.wm.images
		   sawfish.wm.misc
		   sawfish.wm.placement
		   sawfish.wm.session.init
		   sawfish.wm.server
		   sawfish.wm.stacking
		   sawfish.wm.viewport
		   sawfish.wm.window-anim
		   sawfish.wm.windows
		   sawfish.wm.workspace
		   sawfish.wm.state.iconify
		   sawfish.wm.state.shading
		   sawfish.wm.state.transient
		   sawfish.wm.state.ignored))

(export-bindings (parse-interface
		  '(compound-interface
		    (structure-interface sawfish.wm.colors)
		    (structure-interface sawfish.wm.commands)
		    (structure-interface sawfish.wm.cursors)
		    (structure-interface sawfish.wm.custom)
		    (structure-interface sawfish.wm.events)
		    (structure-interface sawfish.wm.focus)
		    (structure-interface sawfish.wm.fonts)
		    (structure-interface sawfish.wm.frames)
		    (structure-interface sawfish.wm.gaol)
		    (structure-interface sawfish.wm.images)
		    (structure-interface sawfish.wm.misc)
		    (structure-interface sawfish.wm.placement)
		    (structure-interface sawfish.wm.session.init)
		    (structure-interface sawfish.wm.server)
		    (structure-interface sawfish.wm.stacking)
		    (structure-interface sawfish.wm.viewport)
		    (structure-interface sawfish.wm.window-anim)
		    (structure-interface sawfish.wm.windows)
		    (structure-interface sawfish.wm.workspace)
		    (structure-interface sawfish.wm.state.iconify)
		    (structure-interface sawfish.wm.state.shading)
		    (structure-interface sawfish.wm.state.transient)
		    (structure-interface sawfish.wm.state.ignored))))

(let ((sawfish-load-all (lambda (s)
			  ;; ensure files are loaded in the correct structure
			  (load-all s (lambda (f) (load f nil t))))))

  ;; all rep-based programs should do this
  (sawfish-load-all "sawfish/wm/autoload")
  (sawfish-load-all (concat "os-" (symbol-name operating-system))))

(let ((session-id (or (get-command-line-option "--sm-client-id" t)
		      ;; may be passed through from the default GNOME session
		      (get-command-line-option "-clientId" t))))

  ;; do user-level initialization
  (load "sawfish/wm/user")

  ;; now connect with the session manager; gsm requires that apps don't
  ;; connect until they're ready to handle the later priority levels
  (when (and (not batch-mode) (getenv "SESSION_MANAGER"))
    (sm-init session-id)))

;; nokogiri-group.jl -- group management
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.group

    (export group-real-name
	    group-slots
	    group-sub-groups
	    group-layout
	    root-group
	    top-group
	    set-top-group
	    get-group
	    fetch-group
	    update-group
	    get-sub-groups
	    refresh-groups-for-slots
	    make-group-tree
	    select-group
	    redisplay-group)

    (open rep
	  gui.gtk-2.gtk
	  rep.system
	  rep.data.records
	  rep.data.tables
	  sawfish.cfg.slot
	  sawfish.cfg.wm)

  (define-record-type :group
    (make-group name)
    ;; [no predicate]
    (name group-name)					;full name (a list)
    (real-name group-real-name group-real-name-set)	;human-readable name
    (loaded group-loaded-p group-loaded-set)		;t iff members read
    (slots group-slots group-slots-set)			;list of slots
    (sub-groups group-sub-groups group-sub-groups-set)	;((SYMBOL . REAL)..)
    (tree group-tree group-tree-set)			;GtkTree of sub groups
    (layout group-layout group-layout-set))

  (define-record-discloser :group
    (lambda (g) (format nil "#<:group %s>" (group-name g))))

  ;; hash table of all group objects
  (define group-table (make-table equal-hash equal))

  (define root-group '(root))		;XXX should be a constant

  (define top-group root-group)

  (define (set-top-group g) (setq top-group g))

  (define current-group nil)

  (defvar *nokogiri-group-selected-hook* '())
  (defvar *nokogiri-group-deselected-hook* '())

  (define (get-key lst key) (cadr (memq key lst)))

;;; group name manipulation

  ;; return the name of the parent of the group called GROUP, or
  ;; nil if this is the topmost group
  (define (group-name-above group)
    (if (null (cdr group))
	'()
      (let ((name (copy-sequence group)))
	(rplacd (nthcdr (- (length name) 2) name) '())
	name)))

  (define (group-name-local group) (last group))

  ;; return the name of the child called CHILD of the group called GROUP
  (define (group-name-add group child)
    (append group (list child)))

  (define group-name= equal)

;;; group creation and loading

  ;; return the group called NAME
  (define (get-group name)
    (let ((group (table-ref group-table name)))
      (unless group
	(setq group (make-group name))
	(table-set group-table name group))
      group))

  ;; ensure that all data for GROUP has been read
  (define (fetch-group group #!key force)
    (when (or force (not (group-loaded-p group)))
      (update-group group)))

  ;; forcibly reread data for GROUP
  (define (update-group group)
    (let ((data (wm-load-group (group-name group))))
      ;; DATA is (LAST-NAME-COMPONENT "REAL-NAME" (ITEMS...) OPTIONS...)
      ;; ITEMS are CUSTOM-NAME, or (SUB-GROUP-NAME REAL-NAME)
      (let ((real-name (cadr data))
	    (items (caddr data))
	    (layout (get-key (cdddr data) #:layout)))
	(group-real-name-set group real-name)
	(group-slots-set group (fetch-slots (filter atom items)))
	(group-sub-groups-set group (filter consp items))
	(group-layout-set group (or layout 'vbox))
	(group-loaded-set group t)
	(mapc update-dependences (group-slots group)))))

  ;; return a list containing the sub-groups of GROUP
  (define (get-sub-groups group)
    (mapcar (lambda (cell)
	      (get-group (group-name-add (group-name group) (car cell))))
	    (group-sub-groups group)))

  ;; return the parent group of GROUP, or nil
  (define (group-parent group)
    (let ((parent-name (group-name-above (group-name group))))
      (and parent-name (get-group parent-name))))

  ;; if the data for GROUP has been loaded, reload it and resync all state
  (define (refresh-group group)
    (when (group-loaded-p group)
      (let ((old-slots (length (group-slots group))))
	;; reload the group data from the wm
	(fetch-group group #:force t)
	(when (group-tree group)
	  ;; if necessary update the sub-trees of the group
	  (let ((old (gtk-container-get-children (group-tree group))))
	    (populate-branch group)
	    (mapc (lambda (x)
		    (gtk-tree-remove-item (group-tree group) x)) old)))
	;; if this is the currently displayed group, then
	;; make sure the display is consistent with the new state
	(when (and (eq group current-group)
		   (/= (length (group-slots group)) old-slots))
	  (select-group group #:force t)))))

  ;; Return the list of (unique) groups containing the list of SLOTS
  (define (locate-groups slots)
    (let ((out '()))
      (table-walk (lambda (name group)
		    (declare (unused name))
		    (when (unionq slots (group-slots group))
		      (setq out (cons group out))))
		  group-table)
      out))

  ;; Reload all groups containing the list of SLOTS
  (define (refresh-groups-for-slots slots)
    (mapc refresh-group (locate-groups slots)))

;;; group widgetry

  ;; creates the top-level tree node
  (define (make-group-tree group)
    (fetch-group group)
    (let ((tree (gtk-tree-new))
	  (item (make-tree-item (group-name-above (group-name group))
				(group-name-local (group-name group))
				(group-real-name group))))
      (gtk-tree-set-selection-mode tree 'browse)
      (gtk-tree-append tree item)
      (gtk-widget-show-all tree)
      tree))

  ;; creates the tree-item for a named group
  (define (make-tree-item parent-name name real-name)
    (let ((item (gtk-tree-item-new-with-label (_ real-name))))
      (g-signal-connect
       item "select" (group-selected parent-name name))
      (g-signal-connect
       item "deselect" (group-deselected parent-name name))
      item))

  ;; fills the contents of the tree associated with GROUP
  (define (populate-branch group)
    ;; check for sub groups
    (fetch-group group)
    (when (group-sub-groups group)
      (mapc (lambda (sub)
	      (let ((sgroup (get-group
			     (group-name-add (group-name group) (car sub))))
		    (item (make-tree-item (group-name group)
					  (car sub) (cadr sub))))
		(gtk-tree-append (group-tree group) item)
		(when (group-tree sgroup)
		  ;; rebuild the sub-tree of this item
		  (make-branch item sgroup))))
	    (group-sub-groups group))
      (gtk-widget-show-all (group-tree group))))

  ;; adds a sub-tree to ITEM representing GROUP
  (define (make-branch item group)
    (fetch-group group)
    (when (group-tree group)
      (group-tree-set group nil))
    (when (group-sub-groups group)
      (group-tree-set group (gtk-tree-new))
      (populate-branch group)
      (gtk-tree-item-set-subtree item (group-tree group))
      (gtk-tree-item-expand item)))

  (define (group-selected parent-name name)
    ;; called when a tree node is selected
    (lambda (item)
      (let ((group (get-group (group-name-add parent-name name))))
	(setq current-group group)

	;; fill the contents of the branch
	(unless (group-tree group)
	  (make-branch item group))

	;; display the slots for this group
	(call-hook '*nokogiri-group-selected-hook* (list group)))))

  (define (group-deselected parent-name name)
    (lambda (item)
      (declare (unused item))
      (let ((group (get-group (group-name-add parent-name name))))
	(call-hook '*nokogiri-group-deselected-hook* (list group))
	(setq current-group nil))))

  (define (select-group group #!key force)
    (when (or force (not (eq current-group group)))
      (when current-group
	(call-hook '*nokogiri-group-deselected-hook* (list current-group)))
      (setq current-group group)
      (call-hook '*nokogiri-group-selected-hook* (list current-group))))

  (define (redisplay-group)
    (when current-group
      (call-hook '*nokogiri-group-deselected-hook* (list current-group))
      (call-hook '*nokogiri-group-selected-hook* (list current-group))))

;;; util

  ;; return the union of lists X and Y, using `eq' for comparisons
  (define (unionq x y)
    (let loop
	((rest x)
	 (out '()))
      (cond ((null rest) (nreverse out))
	    ((memq (car rest) y) (loop (cdr rest) (cons (car rest) out)))
	    (t (loop (cdr rest) out))))))

;; hot-spots.jl -- Invoke lisp functions when hitting the screen-edge

;; Copyright (C) 2010 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.edge.hot-spots

    (export hot-spot-invoke)

    (open rep
	  rep.system
	  rep.io.timers
	  sawfish.wm.custom
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.workspace)

  (define-structure-alias hot-spots sawfish.wm.edge.hot-spots)

  (defvar left-edge-function nil
    "The function launched when hitting the left-edge.")

  (defvar top-left-corner-function nil
    "The function launched when hitting the top-left-corner.")

  (defvar top-edge-function nil
    "The function launched when hitting the top-edge.")

  (defvar top-right-corner-function nil
    "The function launched when hitting the top-right-corner.")

  (defvar right-edge-function nil
    "The function launched when hitting the right-edge.")

  (defvar bottom-right-corner-function nil
    "The function launched when hitting the bottom-right-corner.")

  (defvar bottom-edge-function nil
    "The function launched when hitting the bottom-edge.")

  (defvar bottom-left-corner-function nil
    "The function launched when hitting the bottom-left-corner.")

  (define hot-spot-timer nil)

  (define (hot-spot-invoke spot)
    (unless hot-spot-timer
      (let ((func (case spot
                    ((top-left)
                     top-left-corner-function)
                    ((top-right)
                     top-right-corner-function)
                    ((bottom-right)
                     bottom-right-corner-function)
                    ((bottom-left)
                     bottom-left-corner-function)
                    ((left)
                     left-edge-function)
                    ((top)
                     top-edge-function)
                    ((right)
                     right-edge-function)
                    ((bottom)
                     bottom-edge-function))))
        (if (functionp func)
            (setq hot-spot-timer
                  (make-timer (lambda ()
                                (setq hot-spot-timer nil)
                                (funcall func))
                              (quotient hot-spot-delay 1000)
                              (mod hot-spot-delay 1000)))
          (when func
            ;; non-nil, but not a function?
            (error "In hot-spot, your configuration of spot `%s' is wrong; it should be a function." spot))
	)))))

;; nokogiri-widgets/scheme-boolean.jl --
;;
;; Copyright (C) 2002 John Harper <jsh@unfactored.org>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widgets.scheme-boolean

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (make-item changed-callback)
    (let ((widget (gtk-check-button-new-with-label (_ "Enable"))))

      (gtk-label-set-justify (car (gtk-container-get-children widget)) 'left)
      (gtk-toggle-button-set-inconsistent widget t)

      (g-signal-connect widget "toggled" (lambda (widget)
					   (gtk-toggle-button-set-inconsistent widget nil)))

      (when changed-callback
	(g-signal-connect widget "toggled" (make-signal-callback changed-callback)))

      (gtk-widget-show widget)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (if (not (memq x '(() #f)))
		       (gtk-toggle-button-set-active widget t)
		     (gtk-toggle-button-set-inconsistent widget nil)
		     (gtk-toggle-button-set-active widget nil))))
	  ((clear) (lambda ()
		     (gtk-toggle-button-set-inconsistent widget t)))
	  ((ref) (lambda ()
		   (unless (gtk-toggle-button-get-inconsistent widget)
		     (if (gtk-toggle-button-get-active widget) '#t '#f))))
	  ((gtk-widget) widget)
	  ((validp) (lambda () t))))))

  (define-widget-type 'scheme-boolean make-item)
  (widget-accepts-doc-string 'scheme-boolean))

;; play-audio.jl -- functions for playing sound samples

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.play-audio

    (export play-sample)

    (open rep
	  rep.system
	  rep.io.files
	  rep.io.processes
	  sawfish.wm.custom
	  sawfish.wm.misc)

  (defvar audio-load-path
    (list "~/.sawfish/sounds"
	  (or (getenv "SAWFISHSOUNDSDIR")
	      (expand-file-name "../sounds" sawfish-lisp-lib-directory))
	  (or (getenv "SAWFISHSITESOUNDSDIR")
	      (expand-file-name "../../sounds" sawfish-lisp-lib-directory))
	  ".")
    "List of directories to search for sound samples.")

  (defcustom play-sample-program "/usr/bin/paplay"
    "The program used to play audio samples. Should be capable of
playing *.wav file.
  You can't set any arguments to pass from this variable. If you want
to give arguments or redirect output, write a wrapper program."
    :type file
    :group audio)

  ;; currently running audio process
  (define play-sample-process nil)

  (define (play-sample filename)
    "Play the audio sample stored in file FILENAME."
    (unless (file-exists-p filename)
      (setq filename (or (locate-file filename audio-load-path)
			 (error "No such sound sample: %s" filename))))
    (let
	((real-name (local-file-name filename))
	 (delete-it nil))
      (unless real-name
	(setq real-name (make-temp-name))
	(copy-file filename real-name)
	(setq delete-it t))
	;; start programs asynchronously in case they block..
	(let ((sentinel (lambda (proc)
	    (when (eq play-sample-process proc)
	      (setq play-sample-process nil))
	    (when delete-it
	      (delete-file real-name)))))
	  (when play-sample-process
	    (kill-process play-sample-process))
	  (setq play-sample-process (make-process standard-error sentinel))
	  (start-process play-sample-process play-sample-program real-name)))))

;; nokogiri-widgets/list.jl -- list widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widgets.list

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget
          sawfish.gtk.widgets.simple-dialog)

  ;; (list SPEC-OR-FUNCTION [TITLE])

  ;; if a functional spec is passed, these operations will be used:

  ;; - ((SPEC 'print) VALUE) => LIST-OF-STRINGS
  ;; - ((SPEC 'dialog) TITLE CALLBACK [#:for WIDGET] [#:value VALUE])
  ;; - ((SPEC 'validp) ARG) => BOOL

  ;; CALLBACK is a function that will be called with the new value
  ;; if it's accepted

  (defconst list-width 200)
  (defconst list-height -2)

  (define (make-list-item changed-callback spec #!optional title)

    (let ((clist (if title
		     (gtk-clist-new-with-titles (if (stringp title)
						    (vector title)
						  title))
		   (gtk-clist-new 1)))
	  (scroller (gtk-scrolled-window-new))
	  (add (gtk-button-new-from-stock "gtk-add"))
	  (delete (gtk-button-new-from-stock "gtk-delete"))
	  (edit (gtk-button-new-from-stock "gtk-edit"))
	  (outer-box (gtk-hbox-new nil box-spacing))
	  (button-box (gtk-vbox-new nil box-spacing))
	  (other-box (gtk-vbox-new nil box-spacing))
	  (value '())
	  (selection nil))

      (define (top-level) (gtk-widget-get-toplevel outer-box))

      (define (set-selection row)
	(setq selection row)
	(gtk-widget-set-sensitive delete selection)
	(gtk-widget-set-sensitive edit selection))

      (define (print-value x)
	(if (functionp spec)
	    ((spec 'print) x)
	  (list (format nil "%s" x))))

      (define (add-item)
	(let ((callback
               (lambda (new)
                 (with-clist-frozen clist
                                    (if (not selection)
                                        (progn
                                          (setq value (append value (list new)))
                                          (gtk-clist-append clist
                                                            (print-value new)))
                                      (setq value (copy-sequence value))
                                      (setq value (insert-after new value
                                                                selection))
                                      (gtk-clist-insert
                                       clist (1+ selection) (print-value new))
                                      (gtk-clist-select-row clist
                                                            (1+ selection) 0)))
                 (call-callback changed-callback))))
	  (if (functionp spec)
	      ((spec 'dialog) (_ "Add:") callback #:for (top-level))
	    (widget-dialog (_ "Add:") spec callback nil (top-level)))))

      (define (delete-item)
	(when selection
	  (let ((orig-sel selection))
	    (if (zerop selection)
		(setq value (cdr value))
	      (setq value (copy-sequence value))
	      (rplacd (nthcdr (1- selection) value)
		      (nthcdr (1+ selection) value)))
	    (with-clist-frozen clist
                               (gtk-clist-remove clist selection)
                               (if (> (gtk-clist-rows clist) orig-sel)
                                   (gtk-clist-select-row clist orig-sel 0)
                                 (set-selection nil)))
	    (call-callback changed-callback))))

      (define (edit-item)
	(when selection
	  (setq value (copy-sequence value))
	  (let* ((orig-sel selection)
		 (cell (nthcdr orig-sel value))
		 (callback
                  (lambda (new)
                    (rplaca cell new)
                    (with-clist-frozen clist
                                       (gtk-clist-remove clist orig-sel)
                                       (gtk-clist-insert
                                        clist orig-sel (print-value new))
                                       (gtk-clist-select-row clist orig-sel 0))
                    (call-callback changed-callback))))
	    (if (functionp spec)
		((spec 'dialog) (_ "Edit:") callback
		 #:value (car cell) #:for (top-level))
	      (widget-dialog (_ "Edit:") spec callback
			     (car cell) (top-level))))))

      (define (clear)
	(gtk-clist-clear clist)
	(setq value '()))

      (g-signal-connect add "clicked" add-item)
      (g-signal-connect delete "clicked" delete-item)
      (g-signal-connect edit "clicked" edit-item)
      (g-signal-connect clist "select_row"
                        (lambda (w row col)
                          (declare (unused w col))
                          (set-selection row)))
      (g-signal-connect clist "unselect_row"
                        (lambda (w row col)
                          (declare (unused w col))
                          (when (= row selection)
                            (set-selection nil))))
      (g-signal-connect clist "button_press_event"
                        (lambda (w ev)
                          (declare (unused w))
                          (when (eq (gdk-event-type ev) '2button-press)
                            (edit-item))
                          nil))
      (g-signal-connect clist "key_press_event"
                        (lambda (w ev)
                          (declare (unused w))
                          (when (string= (gdk-event-string ev) "\r")
                            (edit-item))
                          nil))

      (gtk-clist-set-shadow-type clist 'none)
      (gtk-clist-set-column-width clist 0 100)
      (gtk-clist-set-selection-mode clist 'browse)
      (gtk-scrolled-window-set-policy scroller 'automatic 'automatic)
      (gtk-scrolled-window-add-with-viewport scroller clist)
      ;; XXX fixme
      ;;(gtk-widget-set-usize scroller list-width list-height)
      (gtk-container-add outer-box scroller)
      (gtk-box-pack-end outer-box other-box)
      (gtk-box-pack-start other-box button-box)
      (gtk-box-pack-start button-box add)
      (gtk-box-pack-start button-box edit)
      (gtk-box-pack-start button-box delete)
      (gtk-widget-show-all outer-box)
      (set-selection nil)

      (lambda (op)
	(case op
	  ((gtk-widget) outer-box)
	  ((clear) (lambda ()
		     (clear)
		     (call-callback changed-callback)))
	  ((set) (lambda (x)
		   (clear)
		   (setq value x)
		   (mapc (lambda (cell)
			   (gtk-clist-append clist (print-value cell)))
			 value)
		   (call-callback changed-callback)))
	  ((ref) (lambda () value))
	  ((validp) (lambda (x)
		      (let ((validp (if (functionp spec)
					(spec 'validp)
				      ((make-widget spec) 'validp))))
			(catch 'out
			  (mapc (lambda (y)
				  (unless (validp y)
				    (throw 'out nil))) x))
			t)))))))

  (define-widget-type 'list make-list-item)

;;; utilities

  (define (insert-after x lst idx)
    (let ((cell (nthcdr idx lst)))
      (if cell
	  (rplacd cell (cons x (cdr cell)))
	(setq lst (nconc lst (list x))))
      lst))

  (defmacro with-clist-frozen (clist . body)
    `(progn
       (gtk-clist-freeze ,clist)
       (unwind-protect
	   (progn ,@body)
	 (gtk-clist-thaw ,clist)))))

;; prompt.jl -- read line from user
;; Time-stamp: <2000-02-25 22:02:54 tjp>
;;
;; Copyright (C) 2000 Topi Paavola <tjp@iki.fi>
;;   
;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; Commentary:

;; See the documentation for prompt.

(define-structure sawfish.wm.util.prompt

    (export prompt
	    prompt-for-symbol
	    prompt-for-function
	    prompt-for-variable
	    prompt-for-command

	    ;; autoloaded from prompt-extras
	    prompt-for-file
	    prompt-for-directory
	    prompt-from-list
	    prompt-for-string
	    prompt-for-number
	    pwd-prompt

	    ;; autoloaded from prompt-wm
	    prompt-for-window
	    prompt-for-workspace)

    (open rep
	  rep.system
	  rep.regexp
	  rep.data.ring
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands)

  (define-structure-alias prompt sawfish.wm.util.prompt)

  (defcustom prompt-keymap (make-keymap)
    "Keymap containing bindings active when reading a string from the user."
    :group bindings
    :type keymap)

  (defvar prompt-max-display 20
    "Maximum number of completions to display under the input string.")

  (defvar prompt-word-regexp "[0-9a-z_]"
    "Regexp that determines which characters are to be considered part
of a word when moving.")

  (defvar prompt-file-exclude '"\\.(o|jlc|x)$|~$|^#.*#$|^\\.\\.?$"
    "A regexp, if it matches the file being considered for completion, the file
is rejected.")

  (defvar prompt-list nil
    "List of possible entries for prompt-from-list.")

  (defvar prompt-list-fold-case nil
    "Whether prompt-from-list should ignore case.")

  (defvar prompt-history (make-ring 16)
    "Ring buffer containing strings most-recently entered through the `prompt'
function.")

  (defvar prompt-window-position
    (cons (- (quotient (screen-width) 2) 200) -200)
    "A cons cell defining the screen position at which the `prompt' window is
displayed. See the `display-message' function for more details.")

  (defvar prompt-result nil)
  (defvar prompt-prompt nil)
  (defvar prompt-completion-fun nil)
  (defvar prompt-validation-fun nil)
  (defvar prompt-abbrev-fun nil)
  (defvar prompt-display-fun nil)
  (defvar prompt-position 0)
  (defvar prompt-completion-position nil)
  (defvar prompt-completions nil)
  (defvar prompt-completions-outdated nil)
  (defvar prompt-history-pos nil)
  (defvar prompt-saved nil)

  (defun prompt-exit ()
    "Cancel string input."
    (throw 'prompt-exit nil))

  (defun prompt-accept ()
    "End input and accept current string."
    (let ((result (if (not prompt-validation-fun)
		      prompt-result
		    (prompt-validation-fun prompt-result))))
      (if result
	  (progn
	    (unless (or (null prompt-history)
			(equal (get-from-ring prompt-history 1) prompt-result))
	      (add-to-ring prompt-history prompt-result))
	    (throw 'prompt-exit result))
	(beep))))

  (defun prompt-next (count)
    (interactive "p")
    (when prompt-history
      (setq count (- prompt-history-pos count))
      (if (zerop count)
	  (progn
	    (setq prompt-result prompt-saved)
	    (setq prompt-history-pos count))
	(let
	    ((string (get-from-ring prompt-history count)))
	  (when string
	    (when (zerop prompt-history-pos)
	      (setq prompt-saved prompt-result))
	    (setq prompt-result string)
	    (setq prompt-history-pos count))))
      (prompt-changed)
      (prompt-end-of-line)
      (prompt-update-display)))

  (defun prompt-previous (count)
    (interactive "p")
    (prompt-next (- count)))

  (defun prompt-changed ()
    (setq prompt-completions-outdated t))

  (defun prompt-clear ()
    "Clear input buffer."
    (setq prompt-result "")
    (setq prompt-position 0)
    (prompt-changed)
    (prompt-update-display))

  (defun prompt-backspace ()
    "Remove previous character from buffer."
    (when (> prompt-position 0)
      (let ((cutoff (max (- prompt-position 1) 0)))
	(setq prompt-result
	      (concat (substring prompt-result 0 cutoff)
		      (substring prompt-result (1+ cutoff))))
	(setq prompt-position (max 0 (1- prompt-position)))
	(prompt-changed)
	(prompt-update-display))))

  (defun prompt-kill-line ()
    "Delete rest of line."
    (setq prompt-result (substring prompt-result 0 prompt-position))
    (prompt-changed)
    (prompt-update-display))

  (defun prompt-move (num)
    "Move NUM characters forward or backward."
    (let ((new-pos (+ prompt-position num)))
      (and (>= new-pos 0) (<= new-pos (length prompt-result))
	   (setq prompt-position new-pos)
	   (prompt-update-display))))
         
  (defun prompt-forward-word ()
    "Move to next non-word character."
    (setq prompt-position (1+ prompt-position))
    (while (and (< prompt-position (length prompt-result))
		(string-looking-at prompt-word-regexp
				   prompt-result prompt-position t))
      (setq prompt-position (1+ prompt-position)))
    (setq prompt-position (min prompt-position
			       (length prompt-result)))
    (prompt-update-display))

  (defun prompt-backward-word ()
    "Move to previous non-word character."
    (setq prompt-position (1- prompt-position))
    (while (and (> prompt-position 0)
		(string-looking-at prompt-word-regexp
				   prompt-result prompt-position t))
      (setq prompt-position (1- prompt-position)))
    (setq prompt-position (max prompt-position 0))
    (prompt-update-display))

  (defun prompt-forward-character ()
    "Move forward one character."
    (prompt-move 1))

  (defun prompt-backward-character ()
    "Move backward one character."
    (prompt-move -1))

  (defun prompt-beginning-of-line ()
    "Move to beginning of line."
    (setq prompt-position 0)
    (prompt-update-display))

  (defun prompt-end-of-line ()
    "Move to end of line."
    (setq prompt-position (length prompt-result))
    (prompt-update-display))

  (defun prompt-complete ()
    (if (and (not prompt-completions-outdated) prompt-completion-position)
	(let
	    ((new (min (max 0 (- (length prompt-completions)
				 prompt-max-display))
		       (+ prompt-completion-position prompt-max-display))))
	  (setq prompt-completion-position
		(if (= new prompt-completion-position)
		    0
		  new)))
      (when prompt-completion-fun
	(let
	    (compl)
	  (setq prompt-completions (prompt-completion-fun prompt-result))
	  (setq compl (complete-string prompt-result prompt-completions))
	  (when compl
	    (when (string= compl prompt-result)
	      (setq prompt-completions-outdated nil))
	    (setq prompt-result compl)
	    (setq prompt-completions
		  (sort (delete-if-not (lambda (x)
					 (string-head-eq x compl))
				       prompt-completions)))
	    (prompt-end-of-line)
	    (when (cdr prompt-completions)
	      (setq prompt-completion-position 0))))))
    (prompt-update-display))

  (defun prompt-format-completions ()
    (when (numberp prompt-completion-position)
      (let ((compl (nthcdr prompt-completion-position prompt-completions))
	    (continued nil))
	(when (nthcdr prompt-max-display compl)
	  (setq compl (reverse (nthcdr (- (length compl) prompt-max-display)
				       (reverse compl))))
	  (setq continued "[...]\n"))
	(concat (and (/= prompt-completion-position 0) "[...]\n")
		(apply concat (mapcar (lambda (x)
					(format nil "%s\n"
						(if prompt-abbrev-fun
						    (prompt-abbrev-fun x)
						  x)))
				      compl))
		continued))))

  (defun prompt-update-display ()
    (let ((result (if prompt-display-fun
		      (prompt-display-fun prompt-result)
		    prompt-result)))
      (display-message (concat (prompt-format-completions)
			       "\n\n"
			       prompt-prompt
			       (substring result 0 prompt-position)
			       ?| (substring result prompt-position))
		       `((position . ,prompt-window-position)))))

  ;; Insert all unbound keys to result.
  (defun prompt-unbound-callback ()
    (let ((key (current-event-string)))
      (setq prompt-result
	    (concat (substring prompt-result 0 prompt-position)
		    key
		    (substring prompt-result prompt-position)))
      (setq prompt-position (+ prompt-position (length key)))
      (prompt-changed)
      (prompt-update-display)
      t))

  (defun prompt (#!optional title start)
    "Prompt the user for a string."
    (unless (stringp title)
      (setq title "Enter string:"))
    (unless (string-match " $" title)
      (setq title (concat title ? )))
    (call-with-keyboard-grabbed
     (lambda ()
       (unwind-protect
	   (let* ((override-keymap prompt-keymap)
		  (prompt-result (or start ""))
		  (prompt-prompt title)
		  (prompt-position (length prompt-result))
		  (prompt-history-pos 0)
		  (prompt-saved nil)
		  (prompt-completion-position nil)
		  (prompt-completions nil)
		  (prompt-completions-outdated t)
		  (unbound-key-hook (list prompt-unbound-callback)))
	     (prompt-update-display)
	     (catch 'prompt-exit
	       (recursive-edit)))
	 (display-message nil)))))

  (defun prompt-for-symbol (#!optional title predicate validator)
    (let ((prompt-completion-fun 
	   (lambda (x)
	     (mapcar symbol-name
		     (apropos (concat ?^ (quote-regexp x)) predicate))))
	  (prompt-validation-fun
	   (lambda (x)
	     (let
		 ((symbol (intern x)))
	       (if validator
		   (and (validator symbol) symbol)
		 symbol)))))
      (prompt title)))

  (defun prompt-for-function (#!optional title)
    "Prompt for a function."
    (prompt-for-symbol (or title "Enter name of function:")
		       (lambda (x)
			 (and (boundp x)
			      (let ((value (symbol-value x)))
				(or (functionp value)
				    (macrop value)
				    (special-form-p value)))))))

  (defun prompt-for-variable (#!optional title)
    "Prompt for a variable."
    (prompt-for-symbol (or title "Enter name of variable:") boundp))

  (defun prompt-for-command (#!optional title)
    (prompt-for-symbol title commandp commandp))


;;; autoloads

  (autoload 'prompt-for-file "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-for-directory "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-from-list "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-for-string "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-for-number "sawfish/wm/util/prompt-extras")
  (autoload 'pwd-prompt "sawfish/wm/util/prompt-extras")

  (autoload 'prompt-for-window "sawfish/wm/util/prompt-wm")
  (autoload 'prompt-for-workspace "sawfish/wm/util/prompt-wm")


;;; init keymap

  (bind-keys prompt-keymap
             "ESC" prompt-exit
             "C-g" prompt-exit
             "C-u" prompt-clear
             "BS" prompt-backspace
             "C-k" prompt-kill-line
             "Left" prompt-backward-character
             "C-b" prompt-backward-character
             "Right" prompt-forward-character
             "C-f" prompt-forward-character
             "C-Left" prompt-backward-word
             "M-b" prompt-backward-word
             "A-b" prompt-backward-word
             "C-Right" prompt-forward-word
             "M-f" prompt-forward-word
             "A-f" prompt-forward-word
             "C-a" prompt-beginning-of-line
             "C-e" prompt-end-of-line
             "TAB" prompt-complete
             "RET" prompt-accept
	     "Up" prompt-previous
	     "Down" prompt-next
	     "M-n" prompt-next
	     "M-p" prompt-previous
	     "A-n" prompt-next
	     "A-p" prompt-previous))

;; nokogiri-widgets/event.jl
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.event

    (export )

    (open rep
          rep.regexp
          gui.gtk-2.gtk
          sawfish.gtk.widget
          sawfish.cfg.wm)

  (define (make-event-item changed)

    (let ((entry (gtk-entry-new))
	  (grab (gtk-button-new-with-label (_ "Grab...")))
	  (hbox (gtk-hbox-new nil box-spacing)))

      (gtk-container-add hbox entry)
      (gtk-box-pack-end hbox grab)
      (gtk-widget-show-all hbox)

      (g-signal-connect entry "changed" (make-signal-callback changed))
      (g-signal-connect grab "clicked"
                        (lambda ()
                          (gtk-entry-set-text entry (wm-grab-key))))

      (lambda (op)
	(case op
	  ((gtk-widget) hbox)
	  ((clear) (lambda ()
		     (gtk-entry-set-text entry "")))
	  ((set) (lambda (x)
		   (gtk-entry-set-text entry x)))
	  ((ref) (lambda ()
		   (strip-surrounding-whitespace (gtk-entry-get-text entry))))
	  ((validp) stringp)))))

  (define-widget-type 'event make-event-item)

  (define (strip-surrounding-whitespace string)
    (if (string-match "^\\s*(.*?)\\s*$" string)
	(expand-last-match "\\1")
      string)))

;; frames.jl -- handle window framing
;; $Id: frames.jl,v 1.81 2001/01/20 02:40:28 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.frames

    (compound-interface
     (structure-interface sawfish.wm.frames.subrs)
     (export custom-set-frame-style
	     after-setting-frame-option
	     define-frame-type-mapper
	     add-frame-style
	     reload-frame-style
	     reframe-window
	     reframe-all-windows
	     rebuild-frames-with-style
	     reframe-windows-with-style
	     set-frame-style
	     mark-frame-style-editable
	     frame-style-editable-p
	     window-type
	     set-window-type
	     window-type-remove-title
	     window-type-remove-border
	     window-type-add-title
	     window-type-add-border
	     find-all-frame-styles
	     frame-style-menu
	     frame-type-menu
	     remove-frame-class
	     add-frame-class
	     frame-class-removed-p
	     set-frame-part-value
	     def-frame-class
	     define-frame-class))
	    
    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.timers
	  sawfish.wm.frames.subrs
	  sawfish.wm.windows.subrs
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.events
	  sawfish.wm.gaol
	  sawfish.wm.session.init
	  sawfish.wm.workspace)

  ;; Commentary:

  ;; This sets the following window properties:

  ;;	frame-style		If set, the _user-chosen_ frame style
  ;;	current-frame-style	The current frame style
  ;;	type			The notional window type, defining
  ;;				 which parts of the frame are included

  ;; The different window types are:

  ;;	default			title bar and border
  ;;	transient		border only
  ;;	shaped			title-bar only
  ;;	shaped-transient	border-like title-bar only
  ;;	unframed		no frame at all
  ;;	icon
  ;;	dock

  ;; There is also a similar concept of frame types. The window type
  ;; never changes (unless the user explicitly does so). But the frame
  ;; type may depend on the current window state. For example, if it's
  ;; shaded, then it may have `shaded' or `shaded-transient' frame type.

  ;; These are the types that the frame styles see. Current types include
  ;; all the above window types plus:

  ;;	shaded			normal title bar only
  ;;	shaded-transient	transient title bar only

  ;; When framing windows the frame-type-fallback-alist variable will be
  ;; used to iterate frame types until a type that the theme implements
  ;; is found.

  ;; However, this separation of frame and window type shouldn't
  ;; discourage themes from detecting other window state. For example,
  ;; themes may want to display maximized windows differently from
  ;; non-maximized. (In fact the frame-type != window-type scheme is
  ;; largely just for compatibility)


;;; custom support

  (define (custom-make-frame-style-widget)
    `(frame-style ,(find-all-frame-styles t) ,theme-load-path))

  (put 'frame-style 'custom-widget custom-make-frame-style-widget)


;;; variables etc

  (defvar frame-part-classes
    '((title . ((cursor . hand2)
		(keymap . title-keymap)))
      (menu-button . ((keymap . menu-button-keymap)))
      (close-button . ((keymap . close-button-keymap)))
      (iconify-button . ((keymap . iconify-button-keymap)))
      (maximize-button . ((keymap . maximize-button-keymap)))
      (shade-button . ((keymap . shade-button-keymap)))
      (top-border . ((cursor . top_side)
		     (keymap . border-keymap)))
      (left-border . ((cursor . left_side)
		      (keymap . border-keymap)))
      (right-border . ((cursor . right_side)
		       (keymap . border-keymap)))
      (bottom-border . ((cursor . bottom_side)
			(keymap . border-keymap)))
      (top-left-corner . ((cursor . top_left_corner)
			  (keymap . border-keymap)))
      (top-right-corner . ((cursor . top_right_corner)
			   (keymap . border-keymap)))
      (bottom-left-corner . ((cursor . bottom_left_corner)
			     (keymap . border-keymap)))
      (bottom-right-corner . ((cursor . bottom_right_corner)
			      (keymap . border-keymap))))
    "Alist of (CLASS . ALIST) associating classes of frame parts with state
they inherit.")

  (defvar override-frame-part-classes nil
    "Alist of (CLASS . ALIST) associating classes of frame parts with state
that overrides settings set elsewhere.")

  (defvar nil-frame nil
    "Frame definition used for unframed windows.")

  (defcustom default-frame-style nil
    "Default frame style:"
    :type frame-style
    :widget-flags (expand-vertically)
    :user-level novice
    :group appearance
    :after-set (lambda () (after-setting-default-frame)))

  (defcustom reload-themes-when-changed t
    "Automatically reload themes when they are updated."
    :type boolean
    :user-level expert
    :group misc)

  (defcustom frame-type-fallback-alist
    '((transient . default)
      (shaped . default)
      (shaped-transient . shaped)
      (shaded . shaped)
      (shaded-transient . shaped-transient)
      (icon . shaped-transient)
      (dock . icon))
    "Frame type fallbacks:"
    :tooltip "Associate frame types with type to try if the theme doesn't \
implement the requested type."
    :type (alist ((symbol default shaped transient
			  shaped-transient icon doc) "From")
		 ((symbol default shaped transient
			  shaped-transient icon doc) "To"))
    :widget-flags (expand-vertically framed)
    :group appearance
    :user-level expert
    :after-set (lambda () (after-setting-frame-option)))

  (defvar theme-update-interval 60
    "Number of seconds between checking if theme files have been modified.")

  (defvar user-theme-directory "~/.sawfish/themes"
    "Directory containing user-local themes.")

  (defvar system-theme-directory (expand-file-name
				  "../themes" sawfish-lisp-lib-directory)
    "Directory containing themes from the current sawfish version.")

  (defvar site-theme-directory (expand-file-name
				"../../themes" sawfish-lisp-lib-directory)
    "Directory containing system-wide themes.")

  (defvar theme-load-path (list user-theme-directory
				site-theme-directory
				system-theme-directory)
    "List of directories from which themes may be loaded.")

  (define frame-styles nil
    "List of (NAME . FUNCTION) defining all loaded frame styles.")

  ;; List of (NAME FILENAME MODTIME) mapping loaded frame styles to the
  ;; files they were loaded from; used to check if the theme needs reloading
  (define frame-style-files nil)

  ;; List of styles that can be edited using sawfish-themer
  (define editable-frame-styles nil)

  (define frame-type-mappers '()
    "List of functions that map (WINDOW FRAME-TYPE) -> FRAME-TYPE. Used when
deciding which frame type to ask a theme to generate.")

  ;; list of (REGEXP DIR-EXPAND NAME-EXPAND)
  (defvar theme-suffix-regexps
    '(("^(.*)/(.*)\\.tar(\\.gz|\\.Z|\\.bz2|)$" "\\0#tar/\\2" "\\2")))

  (defvar theme-suffixes '("" ".tar" ".tar.gz" ".tar.Z" ".tar.bz2"))

  (defvar themes-are-gaolled t
    "When non-nil themes are assumed to be malicious.")

  (defvar sawfish-themer-program "sawfish-themer")


;;; defcustom's for some built-in variables

  (defcustom default-font nil
    "Default font: \\w"
    :group appearance
    :type font
    :widget-flags (expand-horizontally)
    :user-level novice
    :after-set (lambda () (after-setting-frame-option)))

  (defcustom default-bevel-percent nil
    "Bevel intensity: \\wpercent."
    :group appearance
    :type (number 0 100)
    :user-level expert
    :after-set (lambda () (after-setting-frame-option)))


;;; managing frame types

  (define (define-frame-type-mapper fun)
    (unless (memq fun frame-type-mappers)
      (setq frame-type-mappers (cons fun frame-type-mappers))))

  (define (find-frame-definition w style)
    ;; 1. map window type to actual frame type
    (let loop-1 ((rest frame-type-mappers)
		 (type (window-type w)))
      (if (null rest)
	  ;; found the final frame type, so,
	  ;; 2. find the closest type that the style implements to this
	  (let loop-2 ((type type)
		       (seen (list type)))
	    (cond ((eq type 'unframed) nil-frame)
		  ((style w type))
		  (t (let ((next (or (cdr (assq type frame-type-fallback-alist))
				     'unframed)))
		       (if (memq next seen)
			   ;; been here before..
			   nil-frame
			 (loop-2 next (cons next seen)))))))
	;; else, apply this transformation and keep looping
	(loop-1 (cdr rest) ((car rest) w type)))))


;;; managing frame styles

  (define (add-frame-style name function)
    (let ((cell (assq name frame-styles)))
      (if cell
	  (rplacd cell function)
	(setq frame-styles (cons (cons name function) frame-styles)))
      (when load-filename
	(let
	    ;; if we're loading from a tar-file, then check the
	    ;; tar file itself, not its contents (for efficiency)
	    ((file (if (string-match "#tar/" load-filename)
		       (substring load-filename 0 (match-start))
		     load-filename)))
	  (setq cell (assq name frame-style-files))
	  (if cell
	      (rplacd cell (list file (file-modtime file)))
	    (setq frame-style-files (cons (list name file (file-modtime file))
					  frame-style-files)))))
      (unless default-frame-style
	(setq default-frame-style name))))

  (define (check-frame-availability name)
    (unless (assq name frame-styles)
      (load-frame-style name)
      (or (assq name frame-styles) (error "No such frame style: %s" name))))

  (define (reload-frame-style name)
    (when (assq name frame-styles)
      (load-frame-style name)
      (reframe-windows-with-style name)))

  ;; called periodically from a timer
  (define (frames-on-idle timer)
    (set-timer timer theme-update-interval)
    (when reload-themes-when-changed
      (mapc (lambda (cell)
	      (let ((style (nth 0 cell))
		    (file (nth 1 cell))
		    (modtime (nth 2 cell)))
		(when (time-later-p (file-modtime file) modtime)
		  (reload-frame-style style))))
	    frame-style-files)))


;;; applying frame styles to windows

  (define (reframe-window w)
    (if (window-get w 'ignored)
	(progn
	  (window-put w 'current-frame-style nil)
	  (set-window-frame w nil-frame))
      (let ((style (or (window-get w 'frame-style)
		       default-frame-style)))
	(check-frame-availability style)
	(let ((style-fun (cdr (assq style frame-styles))))
	  (set-window-frame w (if style-fun
				  (find-frame-definition w style-fun)
				nil-frame))
	  (window-put w 'current-frame-style style)))))

  (define (reframe-all-windows) (map-windows reframe-window))

  (define after-setting-frame-option reframe-all-windows)

  (define (after-setting-default-frame)
    (check-frame-availability default-frame-style)
    (after-setting-frame-option))

  (define (rebuild-frames-with-style style)
    (map-windows (lambda (w)
		   (when (eq (window-get w 'current-frame-style) style)
		     (rebuild-frame w)))))

  (define (reframe-windows-with-style style)
    (map-windows (lambda (w)
		   (when (eq (window-get w 'current-frame-style) style)
		     (reframe-window w)))))

  (define (set-frame-style w style)
    (unless (eq (window-get w 'frame-style) style)
      (window-put w 'frame-style style)
      (call-window-hook 'window-state-change-hook w (list '(frame-style)))
      (reframe-window w)))


;;; editable frame styles

  (define (mark-frame-style-editable style)
    (unless (memq style editable-frame-styles)
      (setq editable-frame-styles (cons style editable-frame-styles))))

  (define (frame-style-editable-p style) (memq style editable-frame-styles))

  (define-command 'edit-frame-style
    (lambda (style)
      (if (not (memq style editable-frame-styles))
	  (error "Frame style isn't editable")
	(let ((dir (find-frame-style style)))
	  (when dir
	    (system (format nil "%s %s &" sawfish-themer-program dir))))))
    #:spec (lambda () (list default-frame-style)))


;;; kludge different window decors by modifying the assumed window type

  (define (window-type w)
    (or (window-get w 'type)
	(if (window-transient-p w)
	    (if (window-shaped-p w)
		'shaped-transient
	      'transient)
	  (if (window-shaped-p w)
	      'shaped
	    'default))))

  (define (set-window-type w type)
    (unless (eq (window-get w 'type) type)
      (window-put w 'type type)
      (call-window-hook 'window-state-change-hook w (list '(type)))
      (reframe-window w)))

  (define (window-type-remove-title type)
    (case type
      ((default) 'transient)
      ((shaped shaped-transient) 'unframed)
      (t type)))

  (define (window-type-remove-border type)
    (case type
      ((default) 'shaped)
      ((transient shaped-transient) 'unframed)
      (t type)))

  (define (window-type-add-title type)
    (case type
      ((transient) 'default)
      ((unframed) 'shaped)
      (t type)))

  (define (window-type-add-border type)
    (case type
      ((shaped) 'default)
      ((unframed) 'transient)
      (t type)))

  ;; create some commands for setting the window type
  (mapc (lambda (type)
	  (define-command (intern (concat "set-frame:" (symbol-name type)))
	    (lambda (w) (set-window-type w type)) #:spec "%W"))
	'(default transient shaped shaped-transient unframed))


;;; loading ``themes'' (currently just frame styles)

  (define (frame-style-directory dir #!optional get-name)
    (if (and (file-directory-p dir)
	     (or (file-exists-p (expand-file-name "theme.jl" dir))
		 (file-exists-p (expand-file-name "theme.jlc" dir))))
	(if get-name
	    (file-name-nondirectory dir)
	  dir)
      ;; try the list of suffixes
      (catch 'out
	(mapc (lambda (cell)
		(when (string-match (car cell) dir)
		  (let ((full (expand-last-match (nth 1 cell))))
		    (when (file-directory-p full)
		      (throw 'out (if get-name
				      (expand-last-match (nth 2 cell))
				    full))))))
	      theme-suffix-regexps)
	nil)))

  (define (find-frame-style name)
    (catch 'out
      (mapc (lambda (dir)
	      (mapc (lambda (suf)
		      (let* ((t-dir (expand-file-name
				     (concat (symbol-name name) suf) dir))
			     tem)
			(when (file-exists-p t-dir)
			  (setq tem (frame-style-directory t-dir))
			  (when tem
			    (throw 'out tem)))))
		    theme-suffixes))
	    theme-load-path)
      nil))

  (define (load-frame-style name)
    (let ((dir (find-frame-style name)))
      (when dir
	(let ((image-load-path (cons dir image-load-path)))
	  (if themes-are-gaolled
	      (let ((gaol (make-gaol)))
		(gaol-load (expand-file-name "theme.jl" dir) gaol)
		(define-gaol-structure (intern (concat "themes."
						       (symbol-name name)))
				       gaol))
	    (load (expand-file-name "theme" dir) nil t))))))

  (define (find-all-frame-styles #!optional sorted)
    (let (lst tem)
      (mapc (lambda (dir)
	      (when (file-directory-p dir)
		(mapc (lambda (t-dir)
			(when (setq tem (frame-style-directory
					 (expand-file-name t-dir dir) t))
			  (unless (member tem lst)
			    (setq lst (cons tem lst)))))
		      (directory-files dir))))
	    theme-load-path)
      (when sorted
	(setq lst (sort lst string-lessp)))
      (mapcar intern lst)))

  (define (frame-style-menu w)
    (let ((styles (find-all-frame-styles t)))
      (nconc (mapcar (lambda (s)
		       (list (quote-menu-item (symbol-name s))
			     (lambda ()
			       (set-frame-style (current-event-window) s))
			     (cons 'check (eq (window-get w 'frame-style) s))
			     '(group . menu-style)))
		     styles)
	     (list '())
	     (list (list (_ "Default")
			 (lambda ()
			   (set-frame-style (current-event-window) nil))
			 (cons 'check (not (window-get w 'frame-style)))
			 '(group . menu-style))))))

  (define (frame-type-menu w)
    `((,(_ "Normal") set-frame:default
       (check . ,(eq (window-type w) 'default))
       (group . menu-type))
      (,(_ "Title-only") set-frame:shaped
       (check . ,(eq (window-type w) 'shaped))
       (group . menu-type))
      (,(_ "Border-only") set-frame:transient
       (check . ,(eq (window-type w) 'transient))
       (group . menu-type))
      (,(_ "Top-border") set-frame:shaped-transient
       (check . ,(eq (window-type w) 'shaped-transient))
       (group . menu-type))
      (,(_ "None") set-frame:unframed
       (check . ,(eq (window-type w) 'unframed))
       (group . menu-type))))


;;; removing frame parts

  (define (remove-frame-class w class)
    (window-put w 'removed-classes
		(cons class (delq class (window-get w 'removed-classes))))
    (when (window-framed-p w)
      (rebuild-frame w)))

  (define (add-frame-class w class)
    (window-put w 'removed-classes
		(delq class (window-get w 'removed-classes)))
    (when (window-framed-p w)
      (rebuild-frame w)))

  (define (frame-class-removed-p w class)
    (memq class (window-get w 'removed-classes)))


;;; manipulating the frame part classes variables

  (define (set-frame-part-value class key value #!optional override)
    (let* ((var (if override 'override-frame-part-classes 'frame-part-classes))
	   (item (assq class (symbol-value var)))
	   tem)
      (if item
	  (if (setq tem (assq key (cdr item)))
	      (rplacd tem value)
	    (rplacd item (cons (cons key value) (cdr item))))
	(set var (cons (cons class (list (cons key value)))
		       (symbol-value var))))))

  ;; (def-frame-class shade-button '((cursor . foo) ...)
  ;;   (bind-keys shade-button-keymap
  ;;     "Button1-Off" 'toggle-window-shaded))
  ;; 
  ;; the idea being that it will only create the frame part if it doesn't
  ;; exist, it will add all properties from the second argument unless
  ;; they're already set, then create and initialise the keymap from the
  ;; third argument (unless a keymap is already defined)

  (defmacro def-frame-class (class alist #!rest keymap-forms)
    (if keymap-forms
	`(when (define-frame-class ',class ,alist t)
	   ,@keymap-forms)
      `(define-frame-class ',class ,alist)))

  (define (define-frame-class class alist #!optional with-keymap)
    (let ((cell (assq class frame-part-classes))
	  (ok-to-bind nil))
      (if (not cell)
	  (progn
	    (setq cell (cons class alist))
	    (setq frame-part-classes (cons cell frame-part-classes)))
	(mapc (lambda (attr)
		(let ((tem (assq (car attr) (cdr cell))))
		  (unless tem
		    (rplacd cell (cons attr (cdr cell))))))
	      alist))
      (when with-keymap
	(let ((map-name (intern (concat (symbol-name class) "-keymap"))))
	  (unless (boundp map-name)
	    (make-variable-special map-name)
	    (set map-name (make-keymap))
	    (setq ok-to-bind t)
	    ;; so the theme can bind to the keymap..
	    (gaol-define-special map-name))
	  (set-frame-part-value class 'keymap map-name)))
      ok-to-bind))


;;; initialisation

  (gaol-add add-frame-style reframe-window rebuild-frames-with-style
	    reframe-windows-with-style reframe-all-windows window-type
	    def-frame-class define-frame-class after-setting-frame-option
	    mark-frame-style-editable  frame-part-get frame-part-put
	    frame-part-window frame-part-x-window frame-part-position
	    frame-part-dimensions frame-part-state map-frame-parts
	    refresh-frame-part refresh-window rebuild-frame-part)

  (add-hook 'add-window-hook reframe-window t)
  (add-hook 'shape-notify-hook reframe-window t)

  (make-timer frames-on-idle theme-update-interval)

  (sm-add-saved-properties 'type 'ignored 'frame-style)
  (add-swapped-properties 'frame-active-color 'frame-inactive-color))

;; keymap.jl -- some keymap utilities, mostly copied from jade

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.keymap

    (export map-keymap
	    substitute-keymap-command
	    substitute-keymap-event
	    lazy-bind-keys
	    where-is
	    make-memoizing-where-is
	    describe-key
	    read-event
	    quote-event)

    (open rep
	  rep.system
	  rep.data.symbol-table
	  sawfish.wm.events
	  sawfish.wm.commands
	  sawfish.wm.misc
	  sawfish.wm.windows)

  (define-structure-alias keymap sawfish.wm.util.keymap)

;;; Map a function over all key bindings in a keymap

  (defvar map-keymap-recursively t
    "When nil, the map-keymap function will only map over the first level of
keymaps, i.e. all prefix keys are ignored.")

  (define (map-keymap function keymap)
    "Map FUNCTION over all key bindings under the keymap or list of
keymaps KEYMAP. FUNCTION is called as (FUNCTION KEY), where KEY is a
cons cell (COMMAND . EVENT)."
    (when (keymapp keymap)
      (setq keymap (list keymap)))
    (let ((keymap-list keymap)
          (done-list nil))
      (while keymap-list
	(let
	    ((keymap (car keymap-list)))
	  (setq keymap-list (cdr keymap-list))
	  (when (and (not (keymapp keymap)) (consp keymap))
	    (setq keymap (car keymap)))
	  (unless (memq keymap done-list)
	    (setq done-list (cons keymap done-list))
	    (when (symbolp keymap)
	      (setq keymap (symbol-value keymap)))
	    (when (keymapp keymap)
	      (mapc (lambda (k)
		      (funcall function k)) (cdr keymap))))))))

;;; Substitute one command for another in a keymap

  (define (substitute-keymap-command olddef newdef #!optional keymap)
    "Substitute all occurrences of the command OLDDEF for the command NEWDEF
in the keybindings under the keymap or list of keymaps KEYMAP."
    (map-keymap (lambda (k)
		  (when (eq (car k) olddef)
		    (rplaca k newdef))) keymap))

  (define (substitute-keymap-event old-ev new-ev #!optional keymap)
    "Substitute all occurrences of the event OLD-EV for the event NEW-EV
in the keybindings under the keymap or list of keymaps KEYMAP."
    (when (stringp old-ev)
      (setq old-ev (lookup-event old-ev)))
    (when (stringp new-ev)
      (setq new-ev (lookup-event new-ev)))
    (map-keymap (lambda (k)
		  (when (equal (cdr k) old-ev)
		    (rplacd k new-ev))) keymap))


;;; Adding bindings to a feature that may not yet be loaded

  (defmacro lazy-bind-keys (feature keymap #!rest bindings)
    "Install the list of BINDINGS in KEYMAP, assuming that KEYMAP is available
once FEATURE has been provided. If FEATURE has not yet been loaded, arrange
for the bindings to be installed if and when it is."
    `(if (featurep ',feature)
	 (bind-keys ,keymap ,@bindings)
       (eval-after-load ,(symbol-name feature)
         '(bind-keys ,keymap ,@bindings))))

;;; Search for a named command in the current keymap configuration

  (define (where-is command #!optional keymap)
    (require 'sawfish.wm.util.decode-events)
    (let ((where-is-results '()))
      (map-keymap (lambda (k)
		    (when (eq (car k) command)
		      (setq where-is-results
                            (cons (event-name (substitute-wm-modifier (cdr k)))
                                  where-is-results))))
		  (or keymap global-keymap))
      where-is-results))

  ;; XXX make this handle prefix keymaps
  (define (make-memoizing-where-is keymaps)
    "Return a function which when called with a command name as its single
argument, will return either false or a string naming the event to which
the command is found in the list of keymaps KEYMAPS."
    (require 'sawfish.wm.util.decode-events)
    (let ((cache (make-symbol-table)))
      (mapc (lambda (keymap)
	      (map-keymap (lambda (k)
			    (when (symbolp (car k))
			      (symbol-table-set cache (car k) (cdr k))))
			  keymap))
	    keymaps)
      (lambda (command)
	(let ((key (symbol-table-ref cache command)))
	  (and key (event-name (substitute-wm-modifier key)))))))

  (define (describe-key #!optional map)
    "Prompt for a key sequence, then print its binding."
    (require 'rep.lang.doc)
    (require 'sawfish.wm.commands.describe)
    (let (components)
      (letrec
	  ((loop
	    (lambda (keymap)
	      (let* ((key (read-event (concat "Describe key: " components)))
		     (binding (and key (search-keymap key keymap))))
		(when binding
		  (setq binding (car binding))
		  (setq components (concat components
					   (and components ? )
					   (event-name key)))
		  (cond ((keymapp binding)
			 (loop binding))
			((and (symbolp binding)
			      (keymapp (symbol-value binding t)))
			 (loop (symbol-value binding)))
			(t
			 (format standard-output
				 "`%s' is bound to `%s'\n\n"
				 components binding)
			 (describe-symbol binding))))))))
	(loop (or map global-keymap)))))

  ;;###autoload
  (define-command 'describe-key describe-key)
  (define-command-to-screen 'describe-key-to-screen describe-key)

;;; grab the next key event

  (define (read-event #!optional prompt)
    (call-with-pointer-grabbed
      (lambda ()
	(unwind-protect
	    (let ((override-keymap '(keymap))
		  (pointer-motion-threshold 20)
		  (unbound-key-hook
		    (list (lambda ()
		            (throw 'read-event (current-event))))))
	      (display-message (or prompt (_ "Press key...")))
	      (catch 'read-event
	        (recursive-edit)))
	  (display-message nil)))))

  (define (quote-event)
    "Sends the next key event directly to the focused client window, ignoring
any window manager bindings that it may have."
    (require 'sawfish.wm.util.decode-events)
    (let ((override-keymap '(keymap))
	  (unbound-key-hook (list (lambda ()
				    (let ((ev (decode-event (current-event))))
				      (if (eq 'key (car ev))
					  (progn
					    (allow-events 'replay-keyboard)
					    (throw 'quote-event))
					(allow-events 'sync-keyboard)))))))
      ;; grab on the client window, so that the events get replayed
      ;; to that window, not to our frame (thus avoiding any passive
      ;; grabs on the window)
      (when (grab-keyboard (window-id (input-focus)) nil t)
	(unwind-protect
	    (catch 'quote-event
	      (allow-events 'sync-keyboard)
	      (display-message (_ "[Quote]"))
	      (recursive-edit))
	  (display-message nil)
	  (ungrab-keyboard)))))

  ;;###autoload
  (define-command 'quote-event quote-event))

;; display-window.jl -- activating windows
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.display-window

    (export display-window-without-focusing
	    display-window)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.focus
	  sawfish.wm.workspace
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.viewport
	  sawfish.wm.util.stacking
	  sawfish.wm.state.shading
	  sawfish.wm.state.iconify
	  sawfish.wm.windows
	  sawfish.wm.util.window-order)

  (defcustom unshade-selected-windows nil
    "Unshade window when selected."
    :type boolean
    :group min-max)

;;; Activating windows

  ;; No Sawfish code except display-window calls this function.
  ;; But this is a command, too, so don't delete it.
  (define (display-window-without-focusing
	   w #!optional preferred-space #!key will-refocus)
    "Display the window, by choosing the workspace/viewport containing
the window W, and by showing it, i.e. the window is uniconified, or
unshaded if necessary."
    (when w
      (when (window-iconified-p w)
	(uniconify-window w))
      (when (or (not preferred-space)
		(not (window-in-workspace-p w preferred-space)))
	(setq preferred-space
	      (nearest-workspace-with-window w current-workspace)))
      (when preferred-space
	(select-workspace preferred-space will-refocus))
      (move-viewport-to-window w)
      (move-window-to-current-viewport w)
      (when (and unshade-selected-windows (window-get w 'shaded))
	(unshade-window w))))

  (define-command 'display-window-without-focusing
    display-window-without-focusing
    #:spec (lambda ()
	     (require 'sawfish.wm.util.prompt)
	     (list (prompt-for-window)))
    #:doc "Display the window, but don't focus. You're prompted to type in the name."
    )

  #|
    Currently, the optional argument `preferred-space' is not used
    anywhere in the Sawfish code, so I didn't describe it in the texi.
    Consider removing it, and instead implementing many other options
    with #!key.
  |#
  (define (display-window w #!optional preferred-space)
    "Do everything necessary to make window W ready for user,
i.e. display, focus, etc."
    (when w
      (display-window-without-focusing
       w preferred-space
       #:will-refocus (window-really-wants-input-p w))
      (activate-window w)))

  (define-command 'display-window display-window
    #:spec (lambda ()
	     (require 'sawfish.wm.util.prompt)
	     (list (prompt-for-window)))
    #:doc "Display the window. You're prompted to type in the name."))

#| nokogiri-no-gnome.jl -- workaround lack of GNOME widgets -*- lisp -*-

   $Id: stock.jl.gtk,v 1.8 2000/09/02 12:22:26 john Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure sawfish.gtk.stock

    (export stock-button
	    simple-dialog
	    about-dialog
	    make-url-widget)

    (open rep
	  gui.gtk
	  sawfish.gtk.widget)

  (define (stock-button type)
    (gtk-button-new-with-label
     (case type
       ((ok) (_ "OK"))
       ((cancel) (_ "Cancel"))
       ((revert) (_ "Revert"))
       ((apply) (_ "Apply"))
       ((yes) (_ "Yes"))
       ((no) (_ "No"))
       ((close) (_ "Close"))
       ((help) (_ "Help")))))

  (define (simple-dialog title widget #!optional ok-callback main-window)

    (let ((window (gtk-window-new 'dialog))
	  (vbox (gtk-vbox-new nil box-spacing))
	  (hbbox (gtk-hbutton-box-new))
	  (ok (stock-button 'ok))
	  (cancel (and ok-callback (stock-button 'cancel))))

      (define (on-cancel)
	(gtk-widget-destroy window))

      (define (on-ok)
	(ok-callback)
	(gtk-widget-destroy window))
	  
      (gtk-window-set-title window title)
      (gtk-window-set-wmclass window "ok_cancel_dialog" "Nokogiri")
      (gtk-container-border-width window box-border)
      (when main-window
	(gtk-window-set-transient-for window main-window))

      (gtk-button-box-set-layout hbbox 'end)
      (gtk-box-pack-start hbbox ok)
      (when cancel
	(gtk-box-pack-end hbbox cancel))
      (gtk-box-pack-end vbox hbbox)
      (gtk-container-add window vbox)
      (gtk-widget-show-all vbox)

      (gtk-container-add vbox widget)

      (when cancel
	(gtk-signal-connect cancel "clicked" on-cancel))
      (gtk-signal-connect ok "clicked" (if ok-callback on-ok on-cancel))
      (gtk-signal-connect window "delete_event" on-cancel)

      (gtk-widget-show window)
      (gtk-window-set-modal window t)
      (gtk-widget-grab-focus widget)

      window))

  (define (about-dialog title version copyright
			authors comments #!key logo extra)
    (let ((box (gtk-vbox-new nil 4))
	  (text (gtk-text-new)))
      (define (insert s)
	(gtk-text-insert text nil nil nil s (length s)))
      (insert (format nil "%s %s\n" title version))
      (insert (format nil "%s\n\n" copyright))
      (when authors
	(insert "Authors:\n")
	(mapc (lambda (x) (insert (format nil "    %s\n" x))) authors))
      (insert (format nil "\n%s\n" comments))
      (gtk-container-add box text)
      (when extra
	(gtk-box-pack-end box extra))
      (gtk-widget-show-all box)
      (simple-dialog "About" box)))

  (define (make-url-widget url label)
    (gtk-label-new (format nil "%s <%s>" label url))))

;; nokogiri.jl -- interface to sawfish-config
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.nokogiri

    (export nokogiri-report-slot
	    nokogiri-report-slots
	    nokogiri-report-group
	    nokogiri-apply-changes
	    nokogiri-report-commands
	    nokogiri-grab-key
	    nokogiri-grab-match-window-property)

    (open rep
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.customize
	  sawfish.wm.commands
	  sawfish.wm.util.keymap
	  sawfish.wm.ext.match-window)

  (defcustom customize-show-symbols nil
    "Show variable names of each customization option."
    :type boolean
    :group misc)

;;; interfaces

  (define (nokogiri-report-slot symbol)
    (require 'rep.lang.doc)
    (let* ((type (variable-type symbol))
	   (dep (get symbol 'custom-depends))
	   (doc (documentation symbol))
	   (value (if (get symbol 'custom-get)
		      ((get symbol 'custom-get) symbol)
		    (custom-serialize (symbol-value symbol) type)))
	   (widget-flags (get symbol 'custom-widget-flags)))
      (when (stringp doc)
	(setq doc (_ doc))
	(when customize-show-symbols
	  (setq doc (format nil "%s\n[%s]" doc (symbol-name symbol)))))

      (when (and (symbolp type) (get type 'custom-widget))
	(setq type ((get type 'custom-widget) type)))

      ;; backwards compatibility
      (case type
	((symbol)
	 (setq type `(choice ,@(custom-get-options symbol))))
	((number)
	 (when (get symbol 'custom-range)
	   (let ((range (get symbol 'custom-range)))
	     (setq type `(number ,(car range) ,(cdr range))))))
	((file-name)
	 (setq type 'file))
	((program-name)
	 (setq type 'program)))

      (nconc (list #:name symbol
		   #:type type
		   #:value value)
	     (and dep (list #:depends dep))
	     (and doc (list #:doc doc))
	     (and widget-flags (list #:widget-flags widget-flags)))))

  (define (nokogiri-report-slots names)
    (mapcar nokogiri-report-slot names))

  (define (nokogiri-report-group group)
    (let ((group (custom-find-group (cdr group)))
	  (layout (custom-get-group-property (cdr group) ':layout))
	  (requires (custom-get-group-property (cdr group) ':require)))
      (mapc require requires)
      (nconc (list (car group) (cadr group)
		   (mapcar (lambda (x)
			     (if (atom x)
				 x
			       (list (car x) (cadr x)))) (cddr group)))
	     (and layout (list #:layout layout)))))

  (define (nokogiri-apply-changes changes)
    (mapc (lambda (cell)
	    (customize-set (car cell)
			   (custom-deserialize (cdr cell)
					       (variable-type (car cell)))))
	  changes))

  (define (nokogiri-report-commands)
    (report-commands t))

  (define (nokogiri-grab-key) (event-name (read-event)))

  (define (nokogiri-grab-match-window-property name)
    (match-window-grab-x-property name))

;;; ignore these commands in customizer

  (mapc (lambda (x) (put x 'deprecated-command t))
	'(apropos-function apropos-variable beep call-command
                           copy-file delete-directory delete-file describe-key
                           describe-symbol focus-click garbage-collect load
                           make-directory nop rename-file set step system
                           trace untrace recursive-edit)))

;; nokogiri-apply.jl -- setting values in the wm
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.apply

    (export define-change-handler
	    apply-slot-changes
	    revert-slot-changes
	    changes-to-apply-p
	    changes-to-revert-p)

    (open rep
	  rep.system
	  rep.data.tables
	  gui.gtk-2.gtk
	  sawfish.gtk.widget
	  sawfish.gtk.widgets.simple-dialog
	  sawfish.cfg.slot
	  sawfish.cfg.group
	  sawfish.cfg.wm)

  ;; list of slots that have changed since last apply
  (define changed-slots '())

  ;; list of slots changed since they were created
  (define changed-slots-ever '())

  (define change-handler-table (make-table eq-hash eq))

  ;; arrange for HANDLER thunk to be called each time SLOT changes
  (define (define-change-handler slot handler)
    (table-set change-handler-table slot
	       (cons handler (table-ref change-handler-table slot))))

  (define (slot-change-handlers slot) (table-ref change-handler-table slot))

  (defvar *nokogiri-apply-immediately* t)

;;; applying changes

  (define (after-changed slot)
    (if (not *nokogiri-apply-immediately*)
	(unless (memq slot changed-slots)
	  (setq changed-slots (cons slot changed-slots)))
      (apply-slot-1 slot))
    (unless (memq slot changed-slots-ever)
      (setq changed-slots-ever (cons slot changed-slots-ever))))

  (add-hook '*nokogiri-slot-changed-hook* after-changed)

  (define in-apply-changes (make-fluid))

  (define (apply-changes-for slots getter)
    (define (do-apply)
      (wm-apply-changes (mapcar (lambda (slot)
				  (cons (slot-name slot) (getter slot)))
				slots))
      (refresh-groups-for-slots slots))

    (define (format-error ex)
      (when (eq (car ex) 'remote-sawfish)
	(condition-case nil
	    ;; this may fail if the string contains #<..>
	    (setq ex (read-from-string (cadr ex)))
	  (error nil)))
      (format nil "%s\n\n%s: %s"
	      (format nil (_ "While changing %s:")
		      (mapconcat (lambda (x)
				   (prin1-to-string (slot-name x)))
				 slots ", "))
	      (or (get (car ex) 'error-message) (car ex))
	      (mapconcat (lambda (x) (format nil "%s" x)) (cdr ex) ", ")))

    (when slots
      (if (fluid in-apply-changes)
	  ;; avoid infinite regress..
	  (do-apply)
	(let-fluids ((in-apply-changes t))
           (condition-case data
               (do-apply)
             (remote-sawfish
              ;; An error occurred while setting the values,
              ;; back them all out, then display the error message
              (revert-slots slots)
              (let ((label (gtk-label-new (format-error data))))
                (gtk-label-set-justify label 'left)
                (gtk-label-set-line-wrap label t)
                (gtk-widget-show label)
                (simple-dialog (_ "Sawfish Error") label nil
                               (gtk-widget-get-toplevel
                                (slot-gtk-widget (car slots)))))))))
      (mapc (lambda (slot)
	      (mapc (lambda (h) (h)) (slot-change-handlers slot))) slots)))

  (define (apply-slot-changes)
    (apply-changes-for changed-slots slot-value)
    (setq changed-slots '()))

  (define (apply-slot-1 slot)
    (apply-changes-for (list slot) slot-value))

  (define (revert-slots slots)
    (mapc (lambda (slot)
	    (widget-set (slot-widget slot) (slot-old-value slot))
	    (update-dependences slot)) slots)
    (apply-changes-for slots slot-old-value))

  (define (revert-slot-changes)
    (revert-slots changed-slots-ever)
    (setq changed-slots-ever '()))

  (define (changes-to-apply-p) changed-slots)

  (define (changes-to-revert-p)
    (> (length changed-slots-ever) 0)))

;; sawmill-default.jl -- default user startup
;; $Id: defaults.jl,v 1.19 2000/11/15 21:51:02 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Commentary:

;; This file provides defaults for users without .sawmillrc files

(declare (in-module user))

;; magic comment to get an alias installed
;; (define-structure-alias sawmill-defaults sawfish.wm.defaults)

;; if it looks like GNOME is the desktop environment, then load the
;; extra GNOME integration module
(unless batch-mode
  (catch 'out
    (mapc (lambda (prop)
	    (when (string-match "^GNOME_" (symbol-name prop))
	      (require 'sawfish.wm.gnome.integration)
	      (throw 'out t)))
	  (list-x-properties 'root))))

;; this is probably good for novice users?
(require 'sawfish.wm.ext.window-history)

;; save errors to aid debugging
(require 'sawfish.wm.ext.error-handler)

#| nokogiri-widgets/font.jl -- font selection widget

   $Id: font.jl,v 1.7 2003/01/12 20:30:45 jsh Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure sawfish.gtk.widgets.font ()

    (open rep
	  rep.system
	  gui.gtk-2.gtk
	  sawfish.gtk.widget
	  sawfish.wm.util.font)

  (defconst default-font "fixed")

  ;; FIXME: this is broken, in that only if Xrender is present
  ;; does gdk use Xft. But, it's the best I can do..
  (define use-xft (let ((x (getenv "GDK_USE_XFT")))
		    (and x (/= (string->number x) 0))))

  (define (make-font-item changed-callback)
    (let* ((box (gtk-hbox-new nil box-spacing))
	   (entry (gtk-entry-new))
	   (button (gtk-button-new-with-label (_ "Browse..."))))
      (gtk-editable-set-editable entry nil)
      (gtk-box-pack-start box entry t t)
      (gtk-box-pack-start box button)
      (when changed-callback
	(g-signal-connect
	 entry "changed" (make-signal-callback changed-callback)))
      (g-signal-connect
       button "clicked"
       (lambda ()
	 (let ((fontsel (gtk-font-selection-dialog-new (_ "Select font"))))
	   (gtk-font-selection-dialog-set-font-name
	    fontsel (gtk-entry-get-text entry))
	   (g-signal-connect
	    (gtk-font-selection-dialog-ok-button fontsel) "clicked"
	    (lambda ()
	      (gtk-entry-set-text
	       entry (gtk-font-selection-dialog-get-font-name fontsel))
	      (gtk-widget-destroy fontsel)))
	   (g-signal-connect
	    (gtk-font-selection-dialog-cancel-button fontsel) "clicked"
	    (lambda () (gtk-widget-destroy fontsel)))
	   (g-signal-connect fontsel "delete_event"
			       (lambda () (gtk-widget-destroy fontsel)))
	   (gtk-widget-show fontsel)
	   (gtk-grab-add fontsel))))
      (gtk-widget-show box)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (cond ((stringp x)
			  (gtk-entry-set-text entry x))
			 ((consp x)
			  (let ((face (cond
					((string-equal (car x) "Xft")
					 (xft-description->face (cdr x)))
					((string-equal (car x) "xlfd")
					 (xlfd-description->face (cdr x))))))
			    (when face
			      (gtk-entry-set-text
			       entry (face->pango-description face)))))
			 (t (gtk-entry-set-text entry default-font)))))
	  ((clear) (lambda ()
		     (gtk-entry-set-text entry default-font)))
	  ((ref) (lambda ()
		   (let* ((pango-name (gtk-entry-get-text entry))
			  (face (pango-description->face pango-name)))
		     (cond ((not face) nil)
			   (use-xft (cons "Xft" (face->xft-description face)))
			   (t (cons "xlfd" (face->xlfd-description face)))))))
	  ((gtk-widget) box)
	  ((validp) (lambda (x) (stringp x)))))))

  (define-widget-type 'font make-font-item))

;; Initiates lisp part of Sawfish.
;;
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA

(declare (in-module sawfish.wm))

(open-structures '(rep rep.system rep.io.files))

;;(setq debug-on-error '(bad-arg missing-arg void-value invalid-function))

;; so modularised rep knows where to inherit specials and load from
;; this will be changed to 'user later
(setq *user-structure* 'sawfish.wm)

;; Expand tilde for efficiency. Otherwise, tilde file-handler is called
;; everytime in path search.
(setq load-path (mapcar canonical-file-name load-path))

;; load always-present session-manager stuff
(require 'sawfish.wm.session.init)

;; set $DISPLAY so that any subprocesses inherit it
(setenv "DISPLAY" display-name)

;; load i18n support when necessary

(unless batch-mode
  (let ((lang (or (getenv "LANGUAGE") (getenv "LC_ALL")
		  (getenv "LC_MESSAGES") (getenv "LANG")))
	(disable-nls (get-command-line-option "--disable-nls")))

    (when (and lang (not disable-nls) (not (string= lang "C")))
      (require 'rep.i18n.gettext)
      (bindtextdomain "sawfish" sawfish-locale-directory)
      (when (boundp 'bindtextdomaincodeset)
	(bindtextdomaincodeset "sawfish" "UTF-8"))
      (textdomain "sawfish"))))

;; ignore file errors on stdio streams
(when (boundp 'set-file-ignore-errors)
  (set-file-ignore-errors (stdin-file) t)
  (set-file-ignore-errors (stdout-file) t)
  (set-file-ignore-errors (stderr-file) t))

;; used to mark variable declarations that need special attention
;; from the sawfish-xgettext script
(defmacro i18n-defvar args (cons 'defvar args))
(defmacro i18n-define args (cons 'define args))
(export-bindings '(i18n-defvar i18n-define))

;; import libraries needed by autoload
(require 'sawfish.wm.commands)
(require 'sawfish.wm.custom)
(require 'sawfish.wm.focus)
(require 'sawfish.wm.placement)
(require 'sawfish.wm.animation.setup)

;; load standard libraries (but don't import them)
(mapc intern-structure '(sawfish.wm.keymaps
			 sawfish.wm.workspace
			 sawfish.wm.viewport
			 sawfish.wm.stacking
			 sawfish.wm.frames
			 sawfish.wm.swapper
			 sawfish.wm.state.configure
			 sawfish.wm.state.maximize
			 sawfish.wm.state.mwm
			 sawfish.wm.state.open-look
			 sawfish.wm.state.transient
			 sawfish.wm.state.shading
			 sawfish.wm.state.iconify
			 sawfish.wm.state.ignored
			 sawfish.wm.server
			 sawfish.wm.state.wm-spec))

;; Create the exports from sawfish.wm; Bindings in these modules are
;; exported by sawfish.wm on behalf of them. User scripts have to
;; import only sawfish.wm for core functions.
(let ((mods '(sawfish.wm.colors
	      sawfish.wm.commands
	      sawfish.wm.cursors
	      sawfish.wm.custom
	      sawfish.wm.events
	      sawfish.wm.focus
	      sawfish.wm.fonts
	      sawfish.wm.frames
	      sawfish.wm.gaol
	      sawfish.wm.images
	      sawfish.wm.misc
	      sawfish.wm.placement
	      sawfish.wm.session.init
	      sawfish.wm.server
	      sawfish.wm.stacking
	      sawfish.wm.viewport
	      sawfish.wm.animation.setup
	      sawfish.wm.windows
	      sawfish.wm.workspace
	      sawfish.wm.state.iconify
	      sawfish.wm.state.shading
	      sawfish.wm.state.transient
	      sawfish.wm.state.ignored)))
  (open-structures mods)
  #| I.e.
  (export-bindings (parse-interface
		    '(compound-interface
		      (structure-interface sawfish.wm.colors)
		      (structure-interface sawfish.wm.commands)
		      ...)))
  |#
  (export-bindings (parse-interface
		    (cons 'compound-interface
			  (mapcar (lambda (i)
				    (list 'structure-interface i))
				  mods)))))

(let ((sawfish-load-all (lambda (s)
			  ;; ensure files are loaded in the correct structure
			  (load-all s (lambda (f) (load f nil t))))))

  ;; all rep-based programs should do this
  (sawfish-load-all "sawfish/wm/autoload")
  (sawfish-load-all (concat "os-" (symbol-name operating-system))))

(let ((session-id     (get-command-line-option "--sm-client-id" t))
      (session-prefix (get-command-line-option "--sm-prefix" t)))

  ;; Now connect with the session manager; gsm requires that apps don't
  ;; connect until they're ready to handle the later priority levels

  ;; NB: Even if you want to defer sm-init after sawfish.wm.user,
  ;; initialization of related command line arguments has to be done
  ;; here. Read also the comment below.
  (when (and (not batch-mode) (getenv "SESSION_MANAGER"))
    (sm-init session-id session-prefix)))

;; do user-level initialization
;; This swallows all command line arguments, including those starting
;; with "--".
(load "sawfish/wm/user")

;; hot-spots.jl -- Invoke lisp functions when hitting the screen-edge

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.hot-spots

    (export hot-spot-invoke
            hot-move-invoke)

    (open rep
	  rep.system
	  rep.io.timers
	  sawfish.wm.custom
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.workspace)

  (define-structure-alias hot-spots sawfish.wm.edge.hot-spots)

  (defvar left-edge-function nil
    "The function launched when hitting the left-edge.")

  (defvar top-left-corner-function nil
    "The function launched when hitting the top-left-corner.")

  (defvar top-edge-function nil
    "The function launched when hitting the top-edge.")

  (defvar top-right-corner-function nil
    "The function launched when hitting the top-right-corner.")

  (defvar right-edge-function nil
    "The function launched when hitting the right-edge.")

  (defvar bottom-right-corner-function nil
    "The function launched when hitting the bottom-right-corner.")

  (defvar bottom-edge-function nil
    "The function launched when hitting the bottom-edge.")

  (defvar bottom-left-corner-function nil
    "The function launched when hitting the bottom-left-corner.")

  (define hot-spot-timer nil)

  (define (hot-spot-invoke spot)
    (unless hot-spot-timer
      (let ((func (case spot
                    ((top-left)
                     top-left-corner-function)
                    ((top-right)
                     top-right-corner-function)
                    ((bottom-right)
                     bottom-right-corner-function)
                    ((bottom-left)
                     bottom-left-corner-function)
                    ((left)
                     left-edge-function)
                    ((top)
                     top-edge-function)
                    ((right)
                     right-edge-function)
                    ((bottom)
                     bottom-edge-function))))
        (if (functionp func)
            (progn
              (call-hook 'before-edge-action-hook (list 'hot-spot spot nil))
	      (setq hot-spot-timer
		    (make-timer (lambda ()
				  (setq hot-spot-timer nil)
				  (funcall func)
				  (call-hook 'after-edge-action-hook (list 'hot-spot spot nil)))
				(quotient hot-spot-delay 1000)
				(mod hot-spot-delay 1000))))
          (when func
            ;; non-nil, but not a function?
            (error "In hot-spot, your configuration of spot `%s' is wrong; it should be a function." spot))))))

  (defvar left-edge-move-function nil
    "The function launched when hitting the left-edge.")

  (defvar top-edge-move-function nil
    "The function launched when hitting the top-edge.")

  (defvar right-edge-move-function nil
    "The function launched when hitting the right-edge.")

  (defvar bottom-edge-move-function nil
    "The function launched when hitting the bottom-edge.")

  (define hot-move-timer nil)

  (define (hot-move-invoke spot)
    (unless hot-move-timer
      (let ((func (case spot
                    ((left)
                     left-edge-move-function)
                    ((top)
                     top-edge-move-function)
                    ((right)
                     right-edge-move-function)
                    ((bottom)
                     bottom-edge-move-function)))
            (win (input-focus)))
        (if (functionp func)
            (progn
	      (call-hook 'before-edge-action-hook (list 'hot-move spot t))
	      (setq hot-move-timer
		    (make-timer (lambda ()
				  (setq hot-move-timer nil)
				  (allow-events 'async-both)
				  (fake-release-window)
				  (funcall func win)
				  (call-hook 'after-edge-action-hook (list 'hot-move spot t)))
				(quotient hot-spot-delay 1000)
				(mod hot-spot-delay 1000))))
          (when func
            ;; non-nil, but not a function?
            (error "In hot-move, your configuration of spot `%s' is wrong; it should be a function." spot)))))))

;; focus.jl -- implement standard focus behaviour

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.focus

    (export define-focus-mode
	    autoload-focus-mode
	    focus-mode
	    set-focus-mode
	    focus-push-map
	    focus-pop-map
	    warp-pointer-if-necessary
	    focus-revert
	    focus-within-click-event)

    (open rep
	  rep.system
	  rep.util.autoloader
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.util.window-order
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.session.init)

  (defvar focus-modes nil
    "List containing all symbols naming focus modes.")

  (defcustom focus-mode 'click
    "When does the mouse pointer affect the input focus."
    :type symbol
    :group focus
    :before-set (lambda () (focus-mode-changed 'before))
    :after-set (lambda () (focus-mode-changed 'after)))

  (defcustom focus-click-through t
    "Click-to-focus mode passes the click through to the application."
    :type boolean
    :group focus)

  (defcustom focus-dont-push nil
    "Whether focusing a window doesn't change it's position in the stack."
    :type boolean
    :group focus)

  (defvar focus-xcycle-timestamp (cons (current-time) (current-utime))
    ;; current-utime can overflow librep's integer, which is 30-bit if minimal.
    ;; To be safe, current-time is used, too.
    "Used only to support x-cycle.jl.")

  (define (ignore-pointer-events)
    ;; Only necessary to support x-cycle.jl
    ;; Returns t if current-time is later than focus-xcycle-timestamp
    (prog1
	(and focus-xcycle-timestamp
	     (or (> (current-utime) (cdr focus-xcycle-timestamp))
		 (time-later-p (current-time) (car focus-xcycle-timestamp))
		 ))
      (setq focus-xcycle-timestamp nil)))

  (define focus-within-click-event (make-fluid nil)
          "When true, the current command is being called from within
a click-to-focus button press event.")

;;; general utilities

  (define (define-focus-mode name fun)
    "Define a new focus mode called NAME (a symbol). The function FUN will be
used to implement this focus mode, it will be called with arguments `(WINDOW
EVENT-NAME)', where EVENT-NAME may be one of the following symbols:
`pointer-in', `pointer-out', `focus-in', `focus-out', `add-window'
`before-mode-change', `after-mode-change', `warp-if-necessary' and
`focus-revert'."

    (unless (memq name focus-modes)
      (setq focus-modes (nconc focus-modes (list name))))
    (custom-set-property 'focus-mode ':options focus-modes)
    (put name 'focus-mode fun))

  ;; autoload handling
  (define (getter name) (get name 'focus-mode))
  (define autoload-focus-mode (make-autoloader getter define-focus-mode))
  (define focus-mode-ref (autoloader-ref getter))

  (define (window-focus-mode w)
    (or (and w (windowp w) (window-get w 'focus-mode)) focus-mode))

  (define (focus-invoke-mode w . args)
    (let* ((mode (window-focus-mode w))
	   (fun (focus-mode-ref mode)))
      (when fun
	(apply fun w args))))

  (define (set-focus-mode w mode)
    "Set the focus mode of window W to the mode named by symbol MODE."
    (unless (eq (window-get w 'focus-mode) mode)
      (focus-invoke-mode w 'before-mode-change)
      (window-put w 'focus-mode mode)
      (focus-invoke-mode w 'after-mode-change)))

  (define (focus-mode-changed time)
    (let ((arg (if (eq time 'before)
		   'before-mode-change
		 'after-mode-change)))
      (map-windows
       (lambda (w)
	 (unless (window-get w 'focus-mode)
	   (focus-invoke-mode w arg))))))

  (define (focus-push-map w map)
    (let ((current (window-get w 'keymap))
	  (saved (window-get w 'focus-saved-keymap)))
      (unless (or (eq current map) (null current))
	(unless saved
	  (window-put w 'focus-saved-keymap current))
	(window-put w 'keymap map))))

  (define (focus-pop-map w)
    (let ((saved (window-get w 'focus-saved-keymap)))
      (when saved
	(window-put w 'keymap saved)
	(window-put w 'focus-saved-keymap nil))))

  ;; W is the focused window. Warp to it if it conforms to
  ;; the focus mode.
  (define (warp-pointer-if-necessary #!optional (w (input-focus)))
    (focus-invoke-mode w 'warp-if-necessary))

  ;; Put focus in some window that hopefully feels natural.  This is
  ;; typically used when the window in focus has disappeared.  Thus
  ;; there is no reference window.
  (define (focus-revert)
    (let ((fun (focus-mode-ref focus-mode)))
      (when fun (fun nil 'focus-revert))))

;;; modes

  (define-focus-mode 'enter-exit
    ;; `pointer-out' should not be caught. `enter-root' handles it.
    ;; Furthermore, pointer-out used to make troubles: for example,
    ;; an appearance of a menu by alt-key which covers the pointer
    ;; made the focus lost.
    (lambda (w action)
      (case action
	((pointer-in)
	 (when (window-really-wants-input-p w)
	   (set-input-focus w)))
	((enter-root)
	 ;; ensure that any desktop window gets focused
	 (set-input-focus w))
	((warp-if-necessary)
	 (unless (eq (query-pointer-window) w)
	   (warp-cursor-to-window w)))
        ((focus-revert)
         (setq w (query-pointer-window))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define-focus-mode 'enter-only
    (lambda (w action)
      (case action
	((pointer-in)
	 (when (window-really-wants-input-p w)
	   (set-input-focus w)))
	((warp-if-necessary)
	 (let ((current (query-pointer-window)))
	   (unless (or (eq current w) (desktop-window-p current))
	     (warp-cursor-to-window w))))
        ((focus-revert)
         (setq w (query-pointer-window))
         (when (or (null w)
                   (desktop-window-p w))
           (setq w (window-order-most-recent)))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define (focus-click)
    (let ((w (current-event-window))
	  (event (current-event)))
      (when (window-really-wants-input-p w)
	(set-input-focus w))
      (focus-pop-map w)
      ;; do we need to do anything with the event?
      (when event
	;; allow-events called with replay-pointer ignores any passive
	;; grabs on the window, thus if the wm has a binding in the
	;; window's keymap, it would be ignored. So search manually..
	(let ((command (lookup-event-binding event)))
	  (if command
	      (let-fluids ((focus-within-click-event t))
		(call-command command))
	    (require 'sawfish.wm.util.decode-events)
	    (when (and (or focus-click-through
			   (window-get w 'focus-click-through)
			   (not (window-really-wants-input-p w)))
		       (not (should-grab-button-event-p
			     event (window-get w 'keymap))))
	      ;; pass the event through to the client window unless we
	      ;; need to keep the grab for the events that would follow
	      (allow-events 'replay-pointer)
	      (forget-button-press)))))
      (unless (eq (input-focus) w)
        (focus-push-map w click-to-focus-map))))

  (defvar click-to-focus-map
    (bind-keys (make-keymap)
               ;; apparently buttons 4 & 5 are usually bound to the
               ;; wheel on some mice
               "Any-Button1-Click1" focus-click
               "Any-Button2-Click1" focus-click
               "Any-Button3-Click1" focus-click))

  (define-focus-mode 'click
    (lambda (w action)
      (case action
	((focus-in)
	 (focus-pop-map w))
	((focus-out add-window)
	 (unless (or (not (window-really-wants-input-p w))
		     (eq w (input-focus)))
	   (focus-push-map w click-to-focus-map)))
	((before-mode-change)
	 (focus-pop-map w))
	((after-mode-change)
	 (unless (or (not (window-really-wants-input-p w))
		     (eq w (input-focus)))
	   (focus-push-map w click-to-focus-map)))
        ((focus-revert)
         (setq w (window-order-most-recent))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define-focus-mode 'enter-click
    (lambda (w action . args)
      (case action
        ((pointer-in warp-if-necessary focus-revert)
         (apply (focus-mode-ref 'enter-only) w action args))
        ((focus-in focus-out add-window before-mode-change after-mode-change)
         (apply (focus-mode-ref 'click) w action args)))))

;;; hooks

  (define (focus-enter-fun w mode)
    (unless (ignore-pointer-events)
      (cond ((desktop-window-p w)
	     (focus-invoke-mode w 'enter-root mode))
	    ((windowp w)
	     (focus-invoke-mode w 'pointer-in mode)))))

  (define (focus-leave-fun w mode)
    (unless (ignore-pointer-events)
      (cond ((desktop-window-p w)
	     (focus-invoke-mode w 'leave-root mode))
	    ((windowp w)
	     (focus-invoke-mode w 'pointer-out mode)))))

  (define (focus-in-fun w)
    (focus-invoke-mode w 'focus-in)
    (unless focus-dont-push
      (window-order-push w)))

  (define (focus-out-fun w) (focus-invoke-mode w 'focus-out))
  (define (focus-add-window w) (focus-invoke-mode w 'add-window))

  (add-hook 'enter-notify-hook focus-enter-fun t)
  (add-hook 'leave-notify-hook focus-leave-fun t)
  (add-hook 'focus-in-hook focus-in-fun t)
  (add-hook 'focus-out-hook focus-out-fun t)
  (add-hook 'map-notify-hook focus-add-window)

  (call-after-state-changed
   '(never-focus)
   (lambda (w)
     (if (window-get w 'never-focus)
	 (focus-pop-map w)
       (focus-add-window w))))

  (add-hook 'after-initialization-hook
	    (lambda () (map-windows focus-add-window)))

  (sm-add-saved-properties 'never-focus 'focus-mode)

;;; bug prevention

  ;; XXX Pavel reported this bug (windows becoming unfocusable in
  ;; XXX click-to-focus mode). I can't see why it happens, hence this
  ;; XXX kludge for now..

  (define (scan-windows-for-bugs)
    (map-windows (lambda (w)
		   (when (eq (window-focus-mode w) 'click)
		     ;; check that the correct keymaps are in place
		     (unless (or (eq (input-focus) w)
				 (not (window-mapped-p w))
				 (not (window-really-wants-input-p w))
				 (eq (window-get w 'keymap)
				     click-to-focus-map))
		       ;;(format standard-error
                       ;;        "Window lost focus keymap: %s, %s\n"
                       ;;        (window-name w) (window-get w 'keymap))
                       ;;(beep) (beep)
		       (focus-push-map w click-to-focus-map))))))

  (add-hook 'idle-hook scan-windows-for-bugs))

;; cycle.jl -- simple window cycling

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.cycle

    (export next-workspace-window
	    previous-workspace-window
	    next-window
	    previous-window)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.util.display-window)

  (define-structure-alias cycle sawfish.wm.commands.cycle)

  (define (next-workspace-window)
    "Select the next window of the current workspace."
    (let ((windows (delete-if-not window-in-cycle-p
				  (workspace-windows current-workspace))))
      (display-window (or (nth 1 (memq (input-focus) windows))
			  (car windows)))))

  (define (previous-workspace-window)
    "Focus on the previous window of the current workspace."
    (let ((windows (nreverse
		    (delete-if-not window-in-cycle-p
				   (workspace-windows current-workspace)))))
      (display-window (or (nth 1 (memq (input-focus) windows))
			  (car windows)))))

  (define (next-window)
    "Select the next window, cycling through all possible workspaces."
    (catch 'out
      (let* ((space current-workspace)
	     (limits (workspace-limits))
	     (windows (lambda ()
			(delete-if-not window-in-cycle-p
				       (workspace-windows space))))
	     (win (nth 1 (memq (input-focus) (windows)))))
	(while (not win)
	  (setq space (1+ space))
	  (when (> space (cdr limits))
	    (setq space (car limits)))
	  (when (= space current-workspace)
	    (throw 'out nil))
	  (setq win (car (windows))))
	(when win
	  (display-window win)))))

  (define (previous-window)
    "Select the previous window, cycling through all possible workspaces."
    (catch 'out
      (let* ((space current-workspace)
	     (limits (workspace-limits))
	     (windows (lambda ()
			(nreverse (delete-if-not window-in-cycle-p
						 (workspace-windows space)))))
	     (win (nth 1 (memq (input-focus) (windows)))))
	(while (not win)
	  (setq space (1- space))
	  (when (< space (car limits))
	    (setq space (cdr limits)))
	  (when (= space current-workspace)
	    (throw 'out nil))
	  (setq win (car (windows))))
	(when win
	  (display-window win)))))

  ;;###autoload
  (define-command 'next-workspace-window next-workspace-window)
  (define-command 'previous-workspace-window previous-workspace-window)
  (define-command 'next-window next-window)
  (define-command 'previous-window previous-window))

;; nokogiri-config.jl -- options that affect the configurator, not the wm
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.config

    (export define-config-item
	    initialize-configs)

    (open rep
	  rep.data.tables
	  sawfish.cfg.apply
	  sawfish.cfg.slot
	  sawfish.cfg.group)

  (define done-init nil)

  ;; list of (NAME . THUNK) -- configs to initialize at some point
  (define pending-configs '())

  (define (define-config-item name var thunk)
    (let ((callback (lambda ()
		      (set var (custom-symbol-value name))
		      (thunk))))
      (if done-init
	  (let ((slot (or (get-slot name)
			  (error "Unknown slot: %s" name))))
	    (define-change-handler slot callback)
	    (callback))
	(setq pending-configs (cons (cons name callback) pending-configs)))))

  (define (initialize-configs)
    (unless done-init
      ;; ensure that config group has been loaded
      (fetch-group (get-group root-group))
      (mapc (lambda (x)
	      (let ((slot (or (get-slot (car x))
			      (error "Unknown slot: %s" (car x)))))
		(define-change-handler slot (cdr x))
		((cdr x))))
	    pending-configs)
      (setq pending-configs '())
      (setq done-init t))))

;; lxde.jl -- LXDE integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@tuxfamily.org>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.integration.lxde

    (export detect-lxde)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
	  sawfish.wm.windows
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias lxde-int sawfish.wm.integration.lxde)

  (define (init)
    (let (menu)
      (setq desktop-environment "lxde")
      (setq want-poweroff-menu nil)

      ;; invoke the LXDE terminal instead of xterm
        (unless (variable-customized-p 'xterm-program)
		(setq xterm-program "lxterm"))

      ;; use the LXDE help browser and url launcher
      ;;
      ;; XXX LXDE does not come with a default browser
      ;; XXX candidate for int: ??
      ;;
      ;; (unless (variable-customized-p 'browser-program)
      ;; 	(setq browser-program "lxde-www-browser"))

      ;; use the LXDE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "pcmanfm"))

      ;; add some LXDE menu-entries
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "LXDE _Website") (browser "http://www.lxde.org")))))

      ;; add lxde-logout and customize menu-entries
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_LXSession Logout") (system "lxsession-logout &")))))))

  ;; Returns nil if lxde is not found.
  ;; If detected, returns t, and do also lxde support init.
  (define (detect-lxde)
    (when (or (equal (getenv "XDG_CURRENT_DESKTKOP") "LXDE")
	      (equal (getenv "DESKTOP_SESSION") "LXDE"))
      (init)
      t)))

;; preview-image-selector.jl
;; Based on file.jl
;; Author: Lucas Pandolfo
;; Modified by: Christopher Roy Bratusek <nano@jpberlin.de>

(define-structure sawfish.gtk.widgets.image

    (export )

    (open rep
	  rep.system
	  rep.io.files
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (make-image-item changed-callback)
    (let* ((box (gtk-table-new 1 2 nil))
	   (selector (gtk-file-chooser-button-new '() 'open))
	   (selector-preview (gtk-image-new))
	   (image-preview (gtk-image-new)))

      (gtk-container-set-border-width box 0)

      (gtk-table-attach box selector 0 1 0 1 'shrink 'shrink 0 0)
      (gtk-table-attach box image-preview 0 1 1 2  'shrink 'shrink 0 -12)

      (gtk-widget-set-size-request image-preview 150 150)
      (gtk-widget-set-size-request selector 150 -1)

      (when changed-callback
  	(g-signal-connect
	  selector "file-set" (make-signal-callback changed-callback)))

      (g-signal-connect selector "update-preview" 
			(lambda (w) 
			  (let* ((filename (gtk-file-chooser-get-preview-filename w))
				 (pixbuf (gdk-pixbuf-new-from-file-at-scale filename 150 -1 t)))
			    (if pixbuf
				(progn (gtk-image-set-from-pixbuf selector-preview pixbuf)
				       (gtk-file-chooser-set-preview-widget-active selector t))
				(gtk-file-chooser-set-preview-widget-active selector nil)))))

      (gtk-file-chooser-set-preview-widget selector selector-preview)

      (g-signal-connect selector "file-set" (lambda () 
					    (gtk-image-set-from-pixbuf image-preview (gdk-pixbuf-new-from-file-at-scale
										       (gtk-file-chooser-get-filename selector) 150 -1 t))))
      (gtk-widget-show box)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when (not (eq x ()))
		     (when (and (file-exists-p x) x)
		       (gtk-file-chooser-select-filename selector x))
		     (when (and (file-exists-p x) (stringp x) x)
		       (gtk-image-set-from-pixbuf image-preview
		         (gdk-pixbuf-new-from-file-at-scale x 150 -1 t))))))
	  ((clear) (lambda ()
		     (gtk-image-clear image-preview)
		     (gtk-file-chooser-select-filename selector "")))
	  ((ref) (lambda ()
		   (gtk-file-chooser-get-filename selector)))
	  ((gtk-widget) box)
	  ((validp) (lambda (x) (stringp x)))))))

  (define-widget-type 'image make-image-item))

;; nokogiri-widgets/keymap.jl
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.keymap

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
          rep.util.misc
          sawfish.gtk.widgets.simple-dialog
          sawfish.gtk.widget)

;;; widget for representing keymaps

  (define (command-name command)
    (or (car command) command))

  (define (make-keymap-item changed-callback)

    (define (print x)
      (let ((command (car x)))
	(list (cdr x)
	      (if (consp command)
		  (concat (beautify-symbol-name (command-name command))
			  ": "
			  (mapconcat (lambda (x) (format nil "%s" x))
				     (cdr command) ", "))
		(beautify-symbol-name command)))))

    (define (dialog title callback #!key for value)
      (declare (unused title))
      (let ((widget (make-widget `(keymap:binding))))
	(when value
	  (widget-set widget value))
	(simple-dialog (_ "Edit Binding") (widget-gtk-widget widget)
		       (lambda () (callback (widget-ref widget)))
		       for)))

    (define (validp x) (and (consp x) (symbolp (car x)) (stringp (cdr x))))

    (define (type op)
      (case op
	((print) print)
	((dialog) dialog)
	((validp) validp)))

    (let ((base (make-widget `(list ,type (,(_ "Key") ,(_ "Command")))
			     changed-callback)))
      ;; mold this to accept (keymap . LIST)
      (lambda (op)
	(case op
	  ((ref) (lambda ()
		   (cons 'keymap (widget-ref base))))
	  ((set) (lambda (x)
		   (widget-set base (cdr x))))
	  ((validp) (lambda (x)
		      (and (eq (car x) 'keymap)
			   (widget-valid-p base (cdr x)))))
	  (t (base op))))))

  (define-widget-type 'keymap make-keymap-item)

;;; widget for editing individual bindings

  (define (make-keymap:binding-item changed-callback)
    (make-widget `(pair command (labelled ,(_ "Key:") event)
			t t (start . middle))
		 changed-callback))

  (define-widget-type 'keymap:binding make-keymap:binding-item))

;; absolute-e/theme.jl
;; $Id: theme.jl,v 1.11 2000/05/15 16:37:52 john Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; The images and design of this theme are from Hallvar Helleseth's
;; Absolute E theme for Enlightenment

;; from the ABOUT file:

;;    Thanks for using Absolute E, the theme that thinks diffrently.
;;    This theme is created by Hallvar Helleseth using nothing but The
;;    Gimp.  Everything is originaly made by me - Propably the only
;;    Etheme that can say that ;) Though alot of people have helped me
;;    (too many to list here/can't remeber all of them either...) But I
;;    give them a BIG thank you!

;;    There is a GTK and WMaker version of this theme available at
;;    themes.org

;;    This theme is going to be following the cvs version of E and not
;;    the stable version (DR0.15.5)

;;    Reach me at hallvar@ii.uib.no (www.ii.uib.no/~hallvar)

;;    Date: July 19 1999.

(let*
    ((title-width (lambda (w)
		    (let
			((w-width (car (window-dimensions w))))
		      (- (min (max (/ w-width 2) 100) w-width) 16))))
     
     ;; 100x16
     (bar-images (mapcar (lambda (i)
			   (set-image-border i 4 4 4 4))
			 (list (make-image "bar_normal.png")
			       (make-image "bar_normal_active.png")
			       (make-image "bar_hilited_active.png")
			       (make-image "bar_clicked_active.png"))))

     (frame `(((background . ,bar-images)
	       (left-edge . 0)
	       (width . 16)
	       (top-edge . -16)
	       (height . 16)
	       (class . menu-button))
	      ((background . ,bar-images)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 16)
	       (width . ,title-width)
	       (top-edge . -16)
	       (class . title))
	      ((background . ,bar-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 16)))
	       (right-edge . 0)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-border))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ((background . ,bar-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-border))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-left-corner))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-right-corner))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-left-corner))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-right-corner))))

     (shaped-frame `(((background . ,bar-images)
		      (left-edge . 0)
		      (width . 16)
		      (top-edge . -16)
		      (height . 16)
		      (class . menu-button))
		     ((background . ,bar-images)
		      (foreground . "white")
		      (text . ,window-name)
		      (x-justify . center)
		      (y-justify . center)
		      (left-edge . 16)
		      (width . ,title-width)
		      (top-edge . -16)
		      (class . title))
		     ((background . ,bar-images)
		      (left-edge . ,(lambda (w) (+ (title-width w) 16)))
		      (right-edge . 0)
		      (top-edge . -4)
		      (height . 4)
		      (class . title))))

     (transient-frame `(((background . ,bar-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -4)
			 (height . 4)
			 (class . title))
			((background . ,bar-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-border))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . left-border))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . right-border))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (top-edge . -4)
			 (height . 4)
			 (class . top-right-corner))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (top-edge . -4)
			 (height . 4)
			 (class . top-left-corner))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-left-corner))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-right-corner))))

     (shaped-transient-frame `(((background . ,bar-images)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -4)
				(height . 4)
				(class . title)))))

  (add-frame-style 'absolute-e
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame)))))

;; shade-stack.jl -- maintain a stack of shaded windows as iconify substitute

;; Copyright (C) 1999 Luke Gorrie <luke@vegetable.org>
;; Modifications by: 	The Glyph <glyph@twistedmatrix.com>
;;			Christopher Roy Bratusek <nano@tuxfamily.org>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.ext.shade-stack

  (export toggle-window-shade-stacked
	  shade-stack-window
	  shade-unstack-window
	  window-shade-stacked-p)

  (open rep
	rep.system
	sawfish.wm.misc
	sawfish.wm.custom
	sawfish.wm.windows
	sawfish.wm.commands.move-resize
	sawfish.wm.state.shading
	sawfish.wm.stacking
	sawfish.wm.workspace
	sawfish.wm.frames)

  (define-structure-alias shade-stack sawfish.wm.ext.shade-stack)

  (defvar shade-stacks '())
  (defcustom shade-stack-columns 3
    "Number of columns for the shade stack."
    :group misc
    :type (range 1 4))
  ;; TODO: automatically calculate
  (defvar shade-stack-item-height 22)

  ;;; API commands

  (define (toggle-window-shade-stacked window)
    "Toggle shade-stacking of a window"
    (if (window-shade-stacked-p window (get-shade-stack))
	(shade-unstack-window window)
      (shade-stack-window window)))

  (define (shade-stack-window window)
    "Shade a window and stack it at the top of the screen"
    (if (window-shade-stacked-p window (get-shade-stack))
	t
      (let ((shaded-position (shade-stack-insert window)))
	(lower-window window)
	(shade-window window)
	(move-window-to window (car shaded-position) (cdr shaded-position))
	(resize-window-to window (- (quotient (screen-width) shade-stack-columns) 10)
			  (cdr (window-dimensions window))))))

  (define (shade-unstack-window window)
    "Unshade a window from the stack"
    (let* ((original-configuration (shade-stack-extract window))
	  (original-position (car original-configuration))
	  (original-dimensions (car (cdr original-configuration))))
      (if (window-get window 'shade-hover-unshaded)
	  (progn
	    (window-put window 'shaded nil)
	    (window-put window 'hide-client nil)
	    (window-put window 'shade-hover-unshaded nil)
	    (reframe-window window)
	    (call-window-hook 'unshade-window-hook window)
	    (call-window-hook 'window-state-change-hook
			      window (list '(shaded))))
	(unshade-window window))
      (raise-window window)
      (move-window-to window (car original-position) (cdr original-position))
      (resize-window-to window
			(car original-dimensions)
			(cdr original-dimensions))))

  ;;; Main stacking code

  (define (shade-stack-insert window)
    "Put a window into the shaded stack registry. Return its slot number."
      (let ((insert-result
	    (do-shade-stack-insert window
				    (remove-leading-empty (get-shade-stack)))))
	(set-shade-stack (cdr insert-result))
	(let ((idx (car insert-result)))
	  (cons (* (quotient (screen-width) shade-stack-columns)
		  (mod idx shade-stack-columns))
		(* shade-stack-item-height (quotient idx shade-stack-columns))))))

  (define (do-shade-stack-insert window stack)
    (let ((empty-slot (last-empty-slot-idx stack 0 nil)))
      (if (null empty-slot)
	  (cons (length stack)
		(cons (win-info window) stack))
	(cons (- (length stack) 1 empty-slot)
	      (set-elem stack empty-slot (win-info window))))))

  (define (shade-stack-extract window)
    "Take a window off the shaded stack registry. Return its original properties"
    (let ((extract-result (do-shade-stack-extract window (get-shade-stack) '())))
      (set-shade-stack (cdr extract-result))
      (car extract-result)))

  (define (do-shade-stack-extract window stack accu)
    (if (null stack)
	(error "window not on shade stack")
      (let ((elem (car stack)))
	(if (eq (car elem) window)
	    (cons (cdr elem)
		  (append (reverse (cons 'empty accu)) (cdr stack)))
	  (do-shade-stack-extract window
				  (cdr stack)
				  (cons (car stack) accu))))))

  (define (window-shade-stacked-p window stack)
    "Is window already on stack?"
    (if (null stack)
	nil
      (if (and (consp (car stack))
	      (eq (car (car stack)) window))
	  t
	(window-shade-stacked-p window (cdr stack)))))

  (define (get-shade-stack)
    "Get the shade stack for the current viewport / workspace"
    (let ((stack (assoc (make-key) shade-stacks)))
      (if stack
	  (cdr stack)
	nil)))

  (define (set-shade-stack stack)
    "Set the shade stack for the current viewport / workspace"
    (let ((key (make-key)))
      (setq shade-stacks (cons (cons key stack)
			      (filter (lambda (x) (not (equal (car x) key)))
				      shade-stacks)))))

  ;;; Utility functions

  (define (make-key)
    "Make a key to uniquely identify this viewport / workspace"
    (list current-workspace viewport-x-offset viewport-y-offset))

  (define (win-info window)
    "Capture pre-stacking window properties"
    (cons window (list (window-position window) (window-dimensions window))))

  (define (last-empty-slot-idx stack idx prev-idx)
    "Return the index of an empty slot, or nil if none exists"
    (if (null stack)
	prev-idx
      (let ((curr-idx (if (eq (car stack) 'empty)
			  idx
			prev-idx)))
	(last-empty-slot-idx (cdr stack) (+ idx 1) curr-idx))))

  (define (set-elem lst idx val)
    "Set element idx of lst to val"
    (if (= idx 0)
	(cons val (cdr lst))
      (cons (car lst) (set-elem (cdr lst) (- idx 1) val))))

  (define (remove-leading-empty lst)
    "Strip leading empty slots"
    (if (eq (car lst) 'empty)
	(remove-leading-empty (cdr lst))
      lst))

  (define (cleanup-after-window w)
    "If a shade-stacked window is destroyed, free up its slot"
    (setq shade-stacks
	  (mapcar (lambda (x) (cleanup-environment w x)) shade-stacks)))

  (define (cleanup-environment w stack-alist)
    (let ((key (car stack-alist))
	  (stack (cdr stack-alist)))
      (cons key
	    (mapcar (lambda (x)
		      (if (equal (car x) w)
			  'empty
			x))
		    stack))))

  (add-hook 'destroy-notify-hook cleanup-after-window))

;; stagger-placement.jl -- for jwz

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.placement.stagger

    (export )

    (open rep
          sawfish.wm.windows
          sawfish.wm.misc
          sawfish.wm.events
          sawfish.wm.placement
          sawfish.wm.custom
          sawfish.wm.util.workarea)

  (defcustom stagger-placement-step 32
    "Distance between successive placements in `stagger' placement mode."
    :type number
    :range (1)
    :group (misc placement))

  (define place-window-stagger
    (let ((last-x 0)
	  (last-y 0))
      (lambda (w)
	(let ((dims (window-frame-dimensions w))
	      (workarea (calculate-workarea #:window w)))
	  (setq last-x (+ last-x stagger-placement-step))
	  (setq last-y (+ last-y stagger-placement-step))
	  (when (>= (+ last-x (car dims)) (nth 2 workarea))
	    (setq last-x (nth 0 workarea)))
	  (when (>= (+ last-y (cdr dims)) (nth 3 workarea))
	    (setq last-y (nth 1 workarea)))
	  (move-window-to w last-x last-y)))))

  ;;###autoload
  (define-placement-mode 'stagger place-window-stagger #:for-normal t))

;; grow-pack.jl -- window resize and movement

;; Copyright (C) 2000, 01 Kai Grossjohann <Kai.Grossjohann@CS.Uni-Dortmund.DE>

;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;;; Commentary:

;; This package provides functions to `grow' or `pack' a window in four
;; directions.  `Growing' means to grow the window in the indicated
;; direction until it touches another window or by a given amount.
;; `Packing' means to move the window in the indicated direction until
;; it touches another window or by a given amount.

(define-structure sawfish.wm.commands.grow-pack

    (export grow-window-left
	    grow-window-right
	    grow-window-up
	    grow-window-down
	    pack-window-left
	    pack-window-right
	    pack-window-up
	    pack-window-down)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify
	  sawfish.wm.state.ignored
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.focus
	  sawfish.wm.workspace
	  sawfish.wm.stacking
	  sawfish.wm.util.stacking)

  (define-structure-alias grow-pack sawfish.wm.commands.grow-pack)

;;; Customization options.

  (defgroup gpsy "Grow, Pack, Shrink & Yank" :group move)

  (defcustom grow-is-maximize t
    "Whether growing is considered to be maximization."
    :type boolean
    :group (move gpsy))

  (defcustom pack-warp-pointer 'maybe
    "Whether and how to move the pointer when packing windows.
`maybe' means that the pointer is moved along with the window, if the
pointer was within the window area before packing. `always' warps the
pointer to the center of the window if it isn't already in the
window, then does like `maybe'.  `never' means not to warp the
pointer."
    :type (choice always maybe never)
    :group (move gpsy))

  (defcustom grow-pack-bump-obscured nil
    "Whether to bump into fully obscured windows."
    :type boolean
    :group (move gpsy))

  (defcustom grow-pack-bump-other-depth 'always
    "Whether to bump into windows on a different depth. When 'maybe,
Only `avoided' windows are bumped."
    :type (choice always maybe never)
    :group (move gpsy))

  (defcustom grow-pack-bump-ignored t
    "Whether to bump into ignored windows."
    :type boolean
    :group (move gpsy))

  (defcustom shrink-window-minimum-size 10
    "The minimum height or width to which a window may be shrunk."
    :type number
    :group (move gpsy))

  (defcustom yank-window-minimum-visible 10
    "The minimum amount of window left visible, if yanked over the edge."
    :type number
    :group (move gpsy))

;;; Code:

  ;; Entry points.

  (define (grow-window-left w #!optional arg)
    "Grows window to the left until it touches another window.
See `grow-window-up' for full doc."
    (grow-window w 'left arg))

  (define (grow-window-right w #!optional arg)
    "Grows window to the right until it touches another window.
See `grow-window-up' for full doc."
    (grow-window w 'right arg))

  (define (grow-window-up w #!optional arg)
    "Grows window upwards until it touches another window.
If the top edge was beyond the screen edge, it is brought back in.
With a universal prefix arg, maximize upwards instead.
With a numeric prefix arg, grow upwards by that many increments specified by
window or pixels instead."
    (grow-window w 'up arg))

  (define (grow-window-down w #!optional arg)
    "Grows window downwards until it touches another window.
See `grow-window-up' for full doc."
    (grow-window w 'down arg))

  (define (pack-window-left w #!optional arg)
    "Moves window to the left until it touches another window.
See `pack-window-up' for full doc."
    (pack-window w 'left arg))

  (define (pack-window-right w #!optional arg)
    "Moves window to the right until it touches another window.
See `pack-window-up' for full doc."
    (pack-window w 'right arg))

  (define (pack-window-up w #!optional arg)
    "Moves window upwards until it touches another window.
If the top edge was beyond the screen edge, it is moved back in.
With a universal prefix arg, move upwards maximally instead.
With a numeric prefix arg, move upwards by that many pixels instead."
    (pack-window w 'up arg))

  (define (pack-window-down w #!optional arg)
    "Moves window downwards until it touches another window.
See `pack-window-up' for full doc."
    (pack-window w 'down arg))

  ;; Command defs

  ;;###autoload
  (define-command 'grow-window-left grow-window-left #:spec "%W\nP")
  (define-command 'grow-window-right grow-window-right #:spec "%W\nP")
  (define-command 'grow-window-up grow-window-up #:spec "%W\nP")
  (define-command 'grow-window-down grow-window-down #:spec "%W\nP")
  (define-command 'pack-window-left pack-window-left #:spec "%W\nP")
  (define-command 'pack-window-right pack-window-right #:spec "%W\nP")
  (define-command 'pack-window-up pack-window-up #:spec "%W\nP")
  (define-command 'pack-window-down pack-window-down #:spec "%W\nP")

  ;; Implementation part.

  (define (bump-get-head w direction)
    (let* ((frame-dims (window-frame-dimensions w))
           (frame-pos (window-position w))
           (head1 (current-head w))
           (head2 (find-head
                   (case direction
                     ((left) (- (car frame-pos) 1))
                     ((right) (+ (car frame-pos) (car frame-dims)))
                     (t (car frame-pos)))
                   (case direction
                     ((up) (- (cdr frame-pos) 1))
                     ((down) (+ (cdr frame-pos) (cdr frame-dims)))
                     (t (cdr frame-pos))))))
      (if head2 head2 head1)))

  (define (bump-distance w direction maximize min-dist)
    (let* ((a (window-position w))
	   (z (window-frame-dimensions w))
	   (depth (window-get w 'depth))
	   (head (bump-get-head w direction))
	   (head-dims (head-dimensions head))
	   (head-offs (head-offset head))
	   bump cmp
	   xa xz
	   min-next border xborders)
      (let ((x (if (memq direction '(up down)) cdr car))
	    (y (if (memq direction '(up down)) car cdr)))
	(if (memq direction '(left up))
	    (setq border (x a)
		  min-next (- border min-dist)
		  xborders (lambda () `(,(+ (x xa) (x xz))
					,(y xa) . ,(+ (y xa) (y xz))))
		  a (y a)
		  z (+ a (y z))
	          bump (if (eq direction 'up)
	                   (cdr head-offs)
	                   (car head-offs))
		  cmp <=)
	  (setq border (+ (x a) (x z))
		min-next (+ border min-dist)
		xborders (lambda () `(,(x xa)
				      ,(y xa) . ,(+ (y xa) (y xz))))
		a (y a)
		z (+ a (y z))
	        bump (if (eq direction 'down)
	                 (+ (cdr head-offs) (cdr head-dims))
	                 (+ (car head-offs) (car head-dims)))
		cmp >=)))
      (if (cmp bump min-next)
	  (mapc
	   (lambda (x)
	     (and (not (window-iconified-p x))
		  (window-appears-in-workspace-p x current-workspace)
		  (if maximize
		      (if maximize-avoid-avoided (window-avoided-p x))
		    (or (eq depth (window-get x 'depth))
			(if (eq grow-pack-bump-other-depth 'maybe)
			    (window-avoided-p x)
			  (eq grow-pack-bump-other-depth 'always))))
		  (or grow-pack-bump-obscured
                      (not (eq (stacking-visibility x) 'fully-obscured)))
		  (or grow-pack-bump-ignored
		      (not (window-ignored-p x)))
		  (setq xa (window-position x)
			xz (window-frame-dimensions x))
		  (cmp bump (car (setq x (xborders))) min-next)
		  (< a (cddr x))
		  (< (cadr x) z)
		  (setq bump (car x))))
	   (managed-windows)))
      (- bump border)))

  (define (grow-window w direction #!optional arg)
    (if (eq arg '-) (setq arg -1))
    (let* ((horizontal (memq direction '(left right)))
	   (pos (window-position w))
	   (x (car pos))
	   (y (cdr pos))
	   (dim (window-dimensions w))
	   (maximize (when (consp arg) (setq arg ()) t))
	   (hints (window-size-hints w))
	   (inc (or (cdr (assq (if horizontal 'width-inc 'height-inc) hints))
		    1))
	   (distance (if arg
			 (* arg inc)
		       (abs (bump-distance w direction maximize inc))))
	   (new-dim (if horizontal
			(cons (+ (car dim) distance) (cdr dim))
		      (cons (car dim) (+ (cdr dim) distance)))))
      (when (or grow-is-maximize maximize)
	(unless (window-get w 'unmaximized-geometry)
	  (window-put w 'unmaximized-geometry (list x y (car dim) (cdr dim))))
	(window-put w
		    (if horizontal 'maximized-horizontally
                      'maximized-vertically)
		    t))
      (setq dim (cons (car new-dim) (cdr new-dim)))
      (maximize-truncate-dims w new-dim (if horizontal 'horizontal 'vertical)
			      hints)
      (when (memq direction '(left up))
	(setq distance (- distance (if horizontal
				       (- (car dim) (car new-dim))
				     (- (cdr dim) (cdr new-dim)))))
	(if (eq direction 'left)
	    (setq x (- x distance))
	  (setq y (- y distance))))
      (move-resize-window-to w x y (car new-dim) (cdr new-dim))
      (when maximize-raises (raise-window* w))
      (when (or grow-is-maximize maximize)
	(call-window-hook 'window-maximized-hook w
			  (list (if horizontal 'horizontal 'vertical)))
	(call-window-hook 'window-state-change-hook w (list '(maximized))))))

  (define (pack-window w direction #!optional arg)
    (if (eq arg '-) (setq arg -1))
    (let* ((horizontal (memq direction '(left right)))
	   (pos (window-position w))
	   (x (car pos))
	   (y (cdr pos))
	   (maximize (when (consp arg) (setq arg ()) t))
	   (distance (if arg
			 (if (memq direction '(left up)) (- arg) arg)
		       (bump-distance w direction maximize 1)))
	   (pointerw (query-pointer-window))
	   (xoffset (- (car (query-pointer)) x))
	   (yoffset (- (cdr (query-pointer)) y)))
      (if horizontal
	  (setq x (+ x distance))
	(setq y (+ y distance)))
      (move-window-to w x y)
      (case pack-warp-pointer
	((always)
	 (warp-cursor-to-window w))
	((maybe)
	 (when (equal pointerw w)
	   (warp-cursor (+ x xoffset) (+ y yoffset)))))
      (call-window-hook 'after-move-hook w
			`((,(if horizontal 'horizontal 'vertical)))))))

;; prompt.jl -- read line from user
;;
;; Copyright (C) 2008 Sergey I. Sharybin <sharybin@nm.ru>
;; Copyright (C) 2000 Topi Paavola <tjp@iki.fi>
;;
;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; Commentary:

;; See the documentation for prompt.

(define-structure sawfish.wm.util.prompt

    (export prompt
	    prompt-for-symbol
	    prompt-for-function
	    prompt-for-variable
	    prompt-for-command
            prompt-make-history

	    ;; motion / editing commands
	    prompt-backward-character
	    prompt-forward-character
	    prompt-backward-word
	    prompt-forward-word
	    prompt-beginning-of-line
	    prompt-end-of-line
	    prompt-previous
	    prompt-next
	    prompt-accept
	    prompt-complete
	    prompt-clear
	    prompt-backspace
	    prompt-kill-line
	    prompt-exit

	    ;; autoloaded from prompt-extras
	    prompt-for-file
	    prompt-for-directory
	    prompt-from-list
	    prompt-for-string
	    prompt-for-number
	    pwd-prompt

	    ;; autoloaded from prompt-wm
	    prompt-for-window
	    prompt-for-workspace)

    (open rep
	  rep.system
	  rep.regexp
	  rep.data.ring
	  sawfish.wm.misc
	  sawfish.wm.colors
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.fonts)

  (defgroup messages "Messages" :group misc)

  (defcustom prompt-font default-font
    "Font for prompt: \\left"
    :type font
    :group (misc messages))

  (defcustom prompt-color (cons (get-color "black") (get-color "white"))
    "Prompt message's colors."
    :type (pair (labelled "Foreground:" color) (labelled "Background:" color))
    :group (misc messages))

  (defcustom run-application:use-application-exclude t
    "Exclude applications from `run-application': "
    :type boolean
    :group (misc messages))

  (defcustom run-application:application-exclude "^\\."
    "a regular expression matching applications to exclude"
    :type string
    :group (misc messages)
    :depends run-application:use-application-exclude)

  (defcustom run-application:x-position nil
    "'run-application' x position: \\w"
    :type (choice (nil "Center")
		  (left "Left")
		  (right "Right"))
    :group (misc messages))

  (defcustom run-application:x-offset 0
    "'run-application' x offset: \\w"
    :type (number 0)
    :group (misc messages)
    :depends run-application:x-position)

  (defcustom run-application:y-position nil
    "'run-application' y position: \\w"
    :type (choice (nil "Center")
		  (top "Top")
		  (bottom "Bottom"))
    :group (misc messages))

  (defcustom run-application:y-offset 0
    "'run-application' y offset: \\w"
    :type (number 0)
    :group (misc messages)
    :depends run-application:y-position)
 
  (define-structure-alias prompt sawfish.wm.util.prompt)

  (defcustom prompt-keymap (make-keymap)
    "Keymap containing bindings active when reading a string from the user."
    :group bindings
    :type keymap)

  (defvar prompt-max-display 20
    "Maximum number of completions to display under the input string.")

  (defvar prompt-word-regexp "[0-9a-z_]"
    "Regexp that determines which characters are to be considered part
of a word when moving.")

  (defvar prompt-window-position
    (cons (- (quotient (screen-width) 2) 200) -200)
    "A cons cell defining the screen position at which the `prompt' window is
displayed. See the `display-message' function for more details.")

  (define (prompt-make-history)
    "Make a receptacle for prompt history."
    (make-fluid (make-ring 16)))

  ;; Internal variables:
  (define prompt-history-default (prompt-make-history))
  (define prompt-history nil)
  (define prompt-result nil)
  (define prompt-prompt nil)
  (define prompt-completion-fun nil)
  (define prompt-validation-fun nil)
  (define prompt-abbrev-fun nil)
  (define prompt-display-fun nil)
  (define prompt-position 0)
  (define prompt-completion-position nil)
  (define prompt-completions nil)
  (define prompt-completions-outdated nil)
  (define prompt-history-pos nil)
  (define prompt-saved nil)
  (define prompt-attr nil)


  ;; From merlin
  ;; But maybe better if we'd include this util?

  ;; string/font -> font
  (define (prompt-fontify font)
    (if (stringp font) (get-font font) font))

  ;; string/color -> color
  (define (prompt-colorify color)
    (if (stringp color) (get-color color) color))

  ;; assq with default
  (define (prompt-assqd key alist default)
    (if (assq key alist)
        (assq key alist)
      (cons key default)))

  (define (prompt-exit)
    "Cancel string input."
    (throw 'prompt-exit nil))

  (define (prompt-accept)
    "End input and accept current string."
    (let ((result (if (not prompt-validation-fun)
		      prompt-result
		    (prompt-validation-fun prompt-result))))
      (if result
	  (progn
	    (unless (or (null prompt-history)
			(equal (get-from-ring prompt-history 1) prompt-result))
	      (add-to-ring prompt-history prompt-result))
	    (throw 'prompt-exit result))
	(beep))))

  (define (prompt-next count)
    (interactive "p")
    (when prompt-history
      (setq count (- prompt-history-pos count))
      (if (zerop count)
	  (progn
	    (setq prompt-result prompt-saved)
	    (setq prompt-history-pos count))
	(let
	    ((string (get-from-ring prompt-history count)))
	  (when string
	    (when (zerop prompt-history-pos)
	      (setq prompt-saved prompt-result))
	    (setq prompt-result string)
	    (setq prompt-history-pos count))))
      (prompt-changed)
      (prompt-end-of-line)
      (prompt-update-display)))

  (define (prompt-previous count)
    (interactive "p")
    (prompt-next (- count)))

  (define (prompt-changed)
    (setq prompt-completions-outdated t))

  (define (prompt-clear)
    "Clear input buffer."
    (setq prompt-result "")
    (setq prompt-position 0)
    (prompt-changed)
    (prompt-update-display))

  (define (prompt-backspace)
    "Remove previous character from buffer."
    (when (> prompt-position 0)
      (let ((cutoff (max (- prompt-position 1) 0)))
	(setq prompt-result
	      (concat (substring prompt-result 0 cutoff)
		      (substring prompt-result (1+ cutoff))))
	(setq prompt-position (max 0 (1- prompt-position)))
	(prompt-changed)
	(prompt-update-display))))

  (define (prompt-kill-line)
    "Delete rest of line."
    (setq prompt-result (substring prompt-result 0 prompt-position))
    (prompt-changed)
    (prompt-update-display))

  (define (prompt-move num)
    "Move NUM characters forward or backward."
    (let ((new-pos (+ prompt-position num)))
      (and (>= new-pos 0) (<= new-pos (length prompt-result))
	   (setq prompt-position new-pos)
	   (prompt-update-display))))

  (define (prompt-forward-word)
    "Move to next non-word character."
    (setq prompt-position (1+ prompt-position))
    (while (and (< prompt-position (length prompt-result))
		(string-looking-at prompt-word-regexp
				   prompt-result prompt-position t))
      (setq prompt-position (1+ prompt-position)))
    (setq prompt-position (min prompt-position
			       (length prompt-result)))
    (prompt-update-display))

  (define (prompt-backward-word)
    "Move to previous non-word character."
    (setq prompt-position (1- prompt-position))
    (while (and (> prompt-position 0)
		(string-looking-at prompt-word-regexp
				   prompt-result prompt-position t))
      (setq prompt-position (1- prompt-position)))
    (setq prompt-position (max prompt-position 0))
    (prompt-update-display))

  (define (prompt-forward-character)
    "Move forward one character."
    (prompt-move 1))

  (define (prompt-backward-character)
    "Move backward one character."
    (prompt-move -1))

  (define (prompt-beginning-of-line)
    "Move to beginning of line."
    (setq prompt-position 0)
    (prompt-update-display))

  (define (prompt-end-of-line)
    "Move to end of line."
    (setq prompt-position (length prompt-result))
    (prompt-update-display))

  (define (prompt-complete)
    (if (and (not prompt-completions-outdated) prompt-completion-position)
	(let
	    ((new (min (max 0 (- (length prompt-completions)
				 prompt-max-display))
		       (+ prompt-completion-position prompt-max-display))))
	  (setq prompt-completion-position
		(if (= new prompt-completion-position)
		    0
		  new)))
      (when prompt-completion-fun
	(let
	    (compl)
	  (setq prompt-completions (prompt-completion-fun prompt-result))
	  (setq compl (complete-string prompt-result prompt-completions))
	  (when compl
	    (when (string= compl prompt-result)
	      (setq prompt-completions-outdated nil))
	    (setq prompt-result compl)
	    (setq prompt-completions
		  (sort (delete-if-not (lambda (x)
					 (string-head-eq x compl))
				       prompt-completions)))
	    (prompt-end-of-line)
	    (when (cdr prompt-completions)
	      (setq prompt-completion-position 0))))))
    (prompt-update-display))

  (define (prompt-format-completions)
    (when (numberp prompt-completion-position)
      (let ((compl (nthcdr prompt-completion-position prompt-completions))
	    (continued nil))
	(when (nthcdr prompt-max-display compl)
	  (setq compl (reverse (nthcdr (- (length compl) prompt-max-display)
				       (reverse compl))))
	  (setq continued "[...]\n"))
	(concat (and (/= prompt-completion-position 0) "[...]\n")
		(apply concat (mapcar (lambda (x)
					(format nil "%s\n"
						(if prompt-abbrev-fun
						    (prompt-abbrev-fun x)
						  x)))
				      compl))
		continued))))

  (define (prompt-update-display)
    (let ((result (if prompt-display-fun
		      (prompt-display-fun prompt-result)
                    prompt-result))
          (completions (prompt-format-completions)))
      (let
          ((fg (prompt-colorify
                (cdr (prompt-assqd 'foreground prompt-attr
                                   (car prompt-color)))))
           (bg (prompt-colorify
                (cdr (prompt-assqd 'background prompt-attr
                                   (cdr prompt-color)))))
           (font (prompt-fontify
                  (cdr (prompt-assqd 'font prompt-attr prompt-font)))))
        (display-message
         (concat completions
                 (when completions "\n\n")
                 prompt-prompt
                 (substring result 0 prompt-position)
                 ?| (substring result prompt-position))
         `((position . ,prompt-window-position)
           (foreground . ,fg)
           (background . ,bg)
           (font . , font)
           )))))

  ;; Insert all unbound keys to result.
  (define (prompt-unbound-callback)
    (let ((key (current-event-string)))
      (setq prompt-result
	    (concat (substring prompt-result 0 prompt-position)
		    key
		    (substring prompt-result prompt-position)))
      (setq prompt-position (+ prompt-position (length key)))
      (prompt-changed)
      (prompt-update-display)
      t))

  (define (prompt #!key title start attributes completion-fun
                  validation-fun abbrev-fun display-fun history)
    "Prompt the user for a string.  All of the keyword options are
optional and have reasonable defaults.

 - `title' is the message displayed to prompt the user.
 - `start' is an initial string automatically entered into the prompt.
 - `attributes' can be used to set text attributes.
 - `completion-fun' is a function used for tab completion.
 - `validation-fun' is a function that checks input for validity.
 - `abbrev-fun' is used to abbreviate possible completions for display.
 - `display-fun' can be used to change the way entered text is displayed.
 - `history' contains history.  Use `prompt-make-history' to generate
   an appropriate value."
    (unless (stringp title)
      (setq title "Enter string:"))
    (unless (string-match " $" title)
      (setq title (concat title ? )))
    (call-with-keyboard-grabbed
     (lambda ()
       (unwind-protect
           (let ((override-keymap prompt-keymap)
                 (unbound-key-hook (list prompt-unbound-callback)))
             (setq prompt-history (fluid (or history
                                             prompt-history-default))
                   prompt-completion-fun completion-fun
                   prompt-validation-fun validation-fun
                   prompt-abbrev-fun abbrev-fun
                   prompt-display-fun display-fun
                   prompt-result (or start "")
                   prompt-prompt title
                   prompt-position (length prompt-result)
                   prompt-history-pos 0
                   prompt-saved nil
                   prompt-attr attributes
                   prompt-completion-position nil
                   prompt-completions nil
                   prompt-completions-outdated t)
	     (prompt-update-display)
	     (catch 'prompt-exit
	       (recursive-edit)))
	 (display-message nil)))))

  (define symbol-history (prompt-make-history))
  (define (prompt-for-symbol #!key title predicate validator history)
    (prompt #:title title
            #:completion-fun (lambda (x)
                               (mapcar symbol-name
                                       (apropos (concat ?^ (quote-regexp x))
                                                predicate)))
            #:validation-fun (lambda (x)
                               (let
                                   ((symbol (intern x)))
                                 (if validator
                                     (and (validator symbol) symbol)
                                   symbol)))
            #:history (or history symbol-history)))

  (define function-history (prompt-make-history))
  (define (prompt-for-function #!optional title)
    "Prompt for a function."
    (prompt-for-symbol #:title (or title "Enter name of function:")
                       #:predicate (lambda (x)
                                     (and (boundp x)
                                          (let ((value (symbol-value x)))
                                            (or (functionp value)
                                                (macrop value)
                                                (special-form-p value)))))
                       #:history function-history))

  (define variable-history (prompt-make-history))
  (define (prompt-for-variable #!optional title)
    "Prompt for a variable."
    (prompt-for-symbol #:title (or title "Enter name of variable:")
                       #:predicate boundp
                       #:history variable-history))

  (define command-history (prompt-make-history))
  (define (prompt-for-command #!optional title)
    (prompt-for-symbol #:title title
                       #:predicate commandp
                       #:validator commandp
                       #:history command-history))


;;; autoloads

  (autoload 'prompt-for-file "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-for-directory "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-from-list "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-for-string "sawfish/wm/util/prompt-extras")
  (autoload 'prompt-for-number "sawfish/wm/util/prompt-extras")
  (autoload 'pwd-prompt "sawfish/wm/util/prompt-extras")

  (autoload 'prompt-for-window "sawfish/wm/util/prompt-wm")
  (autoload 'prompt-for-workspace "sawfish/wm/util/prompt-wm")


;;; init keymap

  (bind-keys prompt-keymap
             "ESC" prompt-exit
             "C-g" prompt-exit
             "C-u" prompt-clear
             "BS" prompt-backspace
             "C-k" prompt-kill-line
             "Left" prompt-backward-character
             "C-b" prompt-backward-character
             "Right" prompt-forward-character
             "C-f" prompt-forward-character
             "C-Left" prompt-backward-word
             "M-b" prompt-backward-word
             "A-b" prompt-backward-word
             "C-Right" prompt-forward-word
             "M-f" prompt-forward-word
             "A-f" prompt-forward-word
             "C-a" prompt-beginning-of-line
             "C-e" prompt-end-of-line
             "TAB" prompt-complete
             "RET" prompt-accept
	     "Up" prompt-previous
	     "Down" prompt-next
	     "M-n" prompt-next
	     "M-p" prompt-previous
	     "A-n" prompt-next
	     "A-p" prompt-previous))

;; audio-events.jl -- map wm actions to audio samples

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;;###autoload (defgroup audio "Sound" :require sawfish.wm.ext.audio-events)

(define-structure sawfish.wm.ext.audio-events

    (export audio-event-handler)

    (open rep
	  rep.system
	  sawfish.wm.custom
	  sawfish.wm.windows
	  sawfish.wm.state.maximize
	  sawfish.wm.util.play-audio)

  (define-structure-alias audio-events sawfish.wm.ext.audio-events)

  (defgroup audio "Sound" :require sawfish.wm.ext.audio-events)

  ;; XXX it would be cool to merge the customization with the GNOME sound prefs

  (defcustom audio-events-enabled nil
    "Play sound effects for window events."
    :type boolean
    :require sawfish.wm.ext.audio-events
    :group audio)

  (defvar audio-for-ignored-windows nil
    "Play sound effects for unmanaged windows.")

  ;; standard events are: iconified, uniconified, shaded, unshaded,
  ;; maximized, unmaximized, mapped, unmapped, mapped-transient,
  ;; unmapped-transient, switch-workspace, move-viewport, focused,
  ;; unfocused

  (defcustom audio-events-alist '((iconified . "iconify.wav")
				  (uniconified . "uniconify.wav")
				  (shaded . "shade.wav")
				  (unshaded . "unshade.wav")
				  (maximized . "maximize.wav")
				  (unmaximized . "unmaximize.wav")
				  (mapped . "map.wav")
				  (unmapped . "unmap.wav")
				  (mapped-transient . "map-transient.wav")
				  (unmapped-transient . "unmap-transient.wav")
                                  ;;(focused . "focused.wav")
                                  ;;(unfocused . "unfocused.wav")
				  (switch-workspace . "switch-workspace.wav")
				  (move-viewport . "move-viewport.wav"))
    nil
    :type* `(alist ((symbol iconified uniconified
			    shaded unshaded
			    maximized unmaximized
			    mapped unmapped
			    mapped-transient unmapped-transient
			    switch-workspace move-viewport
			    focused unfocused) ,(_ "Event"))
		   (file ,(_ "Audio file")))
    :widget-flags (expand-vertically)
    :depends audio-events-enabled
    :group audio)

  (defun audio-event-handler (event #!optional w)
    "Possibly play a sound sample for EVENT (a symbol) occurring on window W."
    (when (and audio-events-enabled
	       (or (null w)
		   (not (window-get w 'ignored))
		   audio-for-ignored-windows))
      (let
	  ((sample (cdr (assq event audio-events-alist))))
	(when sample
	  (require 'sawfish.wm.util.play-audio)
	  (play-sample sample)))))

;;; hooks

  (defun audio-state-change-fun (w states)
    (mapc (lambda (state)
	    (case state
	      ((iconified)
	       (audio-event-handler (if (window-get w 'iconified)
					'iconified 'uniconified) w))
	      ((shaded)
	       (audio-event-handler (if (window-get w 'shaded)
					'shaded 'unshaded) w))
	      ((maximized)
	       (audio-event-handler (if (window-maximized-p w)
					'maximized 'unmaximized) w)))) states))

  (call-after-state-changed '(iconified shaded maximized)
			    audio-state-change-fun)

  (defun audio-focus-in-fun (w)
    (audio-event-handler 'focused w))

  (add-hook 'focus-in-hook audio-focus-in-fun)

  (defun audio-focus-out-fun (w)
    (audio-event-handler 'unfocused w))

  (add-hook 'focus-out-hook audio-focus-out-fun)

  (defun audio-mapped-fun (w)
    (audio-event-handler (if (window-transient-p w)
			     'mapped-transient 'mapped) w))

  (add-hook 'map-notify-hook audio-mapped-fun)

  (defun audio-unmapped-fun (w)
    (audio-event-handler (if (window-transient-p w)
			     'unmapped-transient 'unmapped) w))

  (add-hook 'unmap-notify-hook audio-unmapped-fun)

  (defun audio-enter-ws-fun ()
    (audio-event-handler 'switch-workspace))

  (add-hook 'enter-workspace-hook audio-enter-ws-fun)

  (defun audio-move-vp-fun ()
    (audio-event-handler 'move-viewport))

  (add-hook 'viewport-moved-hook audio-move-vp-fun))

;; viewport-drag.jl -- Smooth viewport motion with mouse

;; Based on dtm-infinite-desktop.jl in public domain, written by
;; David T. McWherter <udmcwher@mcs.drexel.edu>
;; 
;; Copyright (C) 2010 Christopher Roy Bratusek <zanghar@freent.de>

;; This file is part of sawfish.

;; viewport-drag is public domain. It's free in any mean for anyone.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

(define-structure sawfish.wm.edge.viewport-drag

    (export viewport-drag-invoke)

    (open rep
          rep.system
          sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands.move-cursor
          sawfish.wm.viewport)

  (define-structure-alias viewport-drag sawfish.wm.edge.viewport-drag)

  (define (drag-right while-moving)
    "Shifts the viewport `viewport-drag-distance' pixels to the right."
    (let ((dist viewport-drag-distance)
          (cdist viewport-drag-cursor-distance)
          (maxx (* (screen-width) (1- (car viewport-dimensions)))))
      (if
          (and (viewport-honor-workspace-edges)
               (> (+ dist viewport-x-offset) maxx))
          (setq dist (- maxx viewport-x-offset)))
      (set-viewport (+ viewport-x-offset dist) viewport-y-offset)
      (move-cursor (- (min dist cdist)) 0)

      (call-hook 'after-edge-action-hook (list 'viewport-drag 'right while-moving))))

  (define (drag-left while-moving)
    "Shifts the viewport `viewport-drag-distance' pixels to the left."
    (let ((dist (- viewport-drag-distance))
          (cdist (- viewport-drag-cursor-distance))
          (minx 0))
      (if
          (and (viewport-honor-workspace-edges)
               (< (+ viewport-x-offset dist) minx))
          (setq dist (- minx viewport-x-offset)))
      (set-viewport (+ viewport-x-offset dist) viewport-y-offset)
      (move-cursor (- (max dist cdist)) 0)

      (call-hook 'after-edge-action-hook (list 'viewport-drag 'left while-moving))))

  (define (drag-up while-moving)
    "Shifts the viewport `viewport-drag-distance' pixels up."
    (let ((dist (- viewport-drag-distance))
          (cdist (- viewport-drag-cursor-distance))
          (miny 0))
      (if
          (and (viewport-honor-workspace-edges)
               (< (+ viewport-y-offset dist) miny))
          (setq dist (- miny viewport-y-offset)))
      (set-viewport viewport-x-offset (+ viewport-y-offset dist))
      (move-cursor 0 (- (max dist cdist)))

      (call-hook 'after-edge-action-hook (list 'viewport-drag 'up while-moving))))

  (define (drag-down while-moving)
    "Shifts the viewport `viewport-drag-distance' pixels down."
    (let ((dist viewport-drag-distance)
          (cdist viewport-drag-cursor-distance)
          (maxy (* (screen-height) (1- (cdr viewport-dimensions)))))
      (if
          (and (viewport-honor-workspace-edges)
               (> (+ dist viewport-y-offset) maxy))
          (setq dist (- maxy viewport-y-offset)))
      (set-viewport viewport-x-offset (+ viewport-y-offset dist))
      (move-cursor 0 (- (min dist cdist)))

      (call-hook 'after-edge-action-hook (list 'viewport-drag 'down while-moving))))

  (define (viewport-drag-invoke edge while-moving)
    (call-hook 'before-edge-action-hook (list 'viewport-drag edge while-moving))
    (case edge
      ((left) (drag-left while-moving))
      ((top) (drag-up while-moving))
      ((right) (drag-right while-moving))
      ((bottom) (drag-down while-moving)))))

;; absolute-e/theme.jl

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; The images and design of this theme are from Hallvar Helleseth's
;; Absolute E theme for Enlightenment

;; from the ABOUT file:

;;    Thanks for using Absolute E, the theme that thinks diffrently.
;;    This theme is created by Hallvar Helleseth using nothing but The
;;    Gimp.  Everything is originally made by me - Propably the only
;;    Etheme that can say that ;) Though alot of people have helped me
;;    (too many to list here/can't remember all of them either...) But I
;;    give them a BIG thank you!

;;    There is a GTK and WMaker version of this theme available at
;;    themes.org

;;    This theme is going to be following the cvs version of E and not
;;    the stable version (DR0.15.5)

;;    Reach me at hallvar@ii.uib.no (www.ii.uib.no/~hallvar)

;;    Date: July 19 1999.

(let*
    ((title-width (lambda (w)
		    (let
			((w-width (car (window-dimensions w))))
		      (- (min (max (/ w-width 2) 100) w-width) 16))))

     ;; 100x16
     (bar-images (mapcar (lambda (i)
			   (set-image-border i 4 4 4 4))
			 (list (make-image "bar_normal.png")
			       (make-image "bar_normal_active.png")
			       (make-image "bar_hilited_active.png")
			       (make-image "bar_clicked_active.png"))))

     (frame `(((background . ,bar-images)
	       (left-edge . 0)
	       (width . 16)
	       (top-edge . -16)
	       (height . 16)
	       (class . menu-button))
	      ((background . ,bar-images)
	       (foreground . "white")
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 16)
	       (width . ,title-width)
	       (top-edge . -16)
	       (class . title))
	      ((background . ,bar-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 16)))
	       (right-edge . 0)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-border))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ((background . ,bar-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-border))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-left-corner))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (top-edge . -4)
	       (height . 4)
	       (class . top-right-corner))
	      ((background . ,bar-images)
	       (left-edge . -4)
	       (width . 4)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-left-corner))
	      ((background . ,bar-images)
	       (right-edge . -4)
	       (width . 4)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-right-corner))))

     (shaped-frame `(((background . ,bar-images)
		      (left-edge . 0)
		      (width . 16)
		      (top-edge . -16)
		      (height . 16)
		      (class . menu-button))
		     ((background . ,bar-images)
		      (foreground . "white")
		      (text . ,window-name)
		      (x-justify . center)
		      (y-justify . center)
		      (left-edge . 16)
		      (width . ,title-width)
		      (top-edge . -16)
		      (class . title))
		     ((background . ,bar-images)
		      (left-edge . ,(lambda (w) (+ (title-width w) 16)))
		      (right-edge . 0)
		      (top-edge . -4)
		      (height . 4)
		      (class . title))))

     (transient-frame `(((background . ,bar-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -4)
			 (height . 4)
			 (class . title))
			((background . ,bar-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-border))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . left-border))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . right-border))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (top-edge . -4)
			 (height . 4)
			 (class . top-right-corner))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (top-edge . -4)
			 (height . 4)
			 (class . top-left-corner))
			((background . ,bar-images)
			 (left-edge . -4)
			 (width . 4)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-left-corner))
			((background . ,bar-images)
			 (right-edge . -4)
			 (width . 4)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-right-corner))))

     (shaped-transient-frame `(((background . ,bar-images)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -4)
				(height . 4)
				(class . title)))))

  (add-frame-style 'absolute-e
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame)))))

;; raise-commands.jl -- some commands for raising windows

;; Copyright (C) 1999-2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.raise-commands

    (export )

    (open rep
          sawfish.wm.windows
          sawfish.wm.events
          sawfish.wm.stacking
          sawfish.wm.util.stacking
          sawfish.wm.state.transient
          sawfish.wm.commands.groups
          sawfish.wm.commands
          sawfish.wm.focus)

  (define (replay-pointer w)
    ;; click-to-focus mode sets this to t when it calls a command
    ;; from within a button press event
    (unless (and (fluid focus-within-click-event)
		 (not (or focus-click-through
			  (window-get w 'focus-click-through)
			  (not (window-really-wants-input-p w)))))
      (allow-events 'replay-pointer)
      (unless (clicked-frame-part)
	(forget-button-press))))

  (define (and-pass-through-click w)
    "Raise the window that received the current event, then replay any pointer
events that invoked the command."
    (when (windowp w)
      (raise-window* w))
    (replay-pointer w))

  (define (and-pass-through-click-if-focused w)
    "Raise the window that received the current event (if it's focused), then
replay any pointer events that invoked the command."
    (when (and (windowp w) (eq w (input-focus)))
      (raise-window* w))
    (replay-pointer w))

  (define (or-pass-through-click w)
    "Raise the window if it is not on top, or if the window is on top, then replay
any pointer events that invoked the command."
    (if (and (windowp w) (not (window-on-top-p w)))
	(raise-window* w)
      (replay-pointer w)))

  ;;###autoload
  (define-command 'raise-and-pass-through-click
    and-pass-through-click #:spec "%W")
  (define-command 'raise-and-pass-through-click-if-focused
    and-pass-through-click-if-focused #:spec "%w")
  (define-command 'raise-or-pass-through-click
    or-pass-through-click #:spec "%w")

;;; these should probably be considered obsolete

  (define (window-and-pass-through-click w)
    "Raise the window that received the current event, then replay any pointer
events that invoked the command."
    (when (windowp w)
      (raise-window w))
    (replay-pointer w))

  (define (group-and-pass-through-click w)
    "Raise the group of windows that received the current event, then replay
any pointer events that invoked the command."
    (when (windowp w)
      (raise-group w))
    (replay-pointer w))

  (define (transients-and-pass-through-click w)
    "Raise the window that received the current event and any transients it
has, then replay any pointer events that invoked the command."
    (when (windowp w)
      (raise-window-and-transients w))
    (replay-pointer w))

  ;;###autoload
  (define-command 'raise-window-and-pass-through-click
    window-and-pass-through-click #:spec "%w")
  (define-command 'raise-group-and-pass-through-click
    group-and-pass-through-click #:spec "%w")
  (define-command 'raise-transients-and-pass-through-click
    transients-and-pass-through-click #:spec "%w"))

;; nokogiri-layouts/keymaps.jl -- shell for binding group
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA. 

(define-structure sawfish.cfg.layouts.keymaps

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
	  rep.util.misc
          sawfish.cfg.slot
          sawfish.cfg.wm
          sawfish.cfg.layout
          sawfish.gtk.widget)

  (define label-ptr nil)

  (define (keymap-slot-p slot)
    ;; XXX so fucking evil!
    (string-match "-keymap$" (symbol-name (slot-name slot))))

  (define (layout-keymaps style slots)
    (declare (unused style))

    (let* ((hbox (gtk-hbox-new nil box-spacing))
	   (vbox (gtk-vbox-new nil box-spacing))
	   (km-vbox (gtk-vbox-new nil box-spacing))
	   (keymap-slots (filter keymap-slot-p slots))
	   (other-slots (filter (lambda (x) (not (keymap-slot-p x))) slots))
	   (active (car keymap-slots))
           (combo (gtk-combo-box-text-new)))

      (when keymap-slots
	(setq label-ptr (gtk-label-new (_ "Context:")))
	(gtk-box-pack-start hbox label-ptr)
        (gtk-box-pack-start hbox combo)
	(gtk-box-pack-start vbox hbox)

	(let loop
	    ((rest keymap-slots))
	  (when rest
            (gtk-combo-box-text-append-text combo
              (or (_ (beautify-symbol-name (slot-name (car rest) #:cut "-keymap")))
                  (_ (cadar rest))))
	      (loop (cdr rest)))

        (gtk-combo-box-set-active combo 0)

        (g-signal-connect combo "changed"
            (lambda ()
              (let ((slot (nth (gtk-combo-box-get-active combo) keymap-slots)))
                (when active
                  (gtk-container-remove km-vbox (slot-gtk-widget active)))
                (setq active slot)
                (gtk-box-pack-start km-vbox (slot-gtk-widget active) t t)))))

	(when active
	  (gtk-box-pack-start km-vbox (slot-gtk-widget active) t t))

	(gtk-box-pack-start vbox km-vbox t t))

      (gtk-box-pack-start vbox (layout-slots 'vbox other-slots))

      (gtk-widget-show-all vbox)
      vbox))

  (define-layout-type 'keymaps layout-keymaps))

;; custom.jl -- Emacs-like ``customizing'' (but more simple)

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.custom

    (export custom-groups
	    custom-option-alist
	    custom-group-option-alist
	    defcustom
	    defgroup
	    custom-declare-variable
	    custom-declare-group
	    custom-quote-keys
	    define-custom-setter
	    custom-set-property
	    custom-get-property
	    custom-set-group-property
	    custom-get-group-property
	    custom-add-option
	    custom-get-options
	    custom-find-group
	    custom-set
	    custom-set-variable
	    custom-set-typed-variable
	    variable-customized-p
	    variable-type
	    variable-default-value
	    variable-declared-p
	    make-custom-form
	    custom-eval
	    custom-serialize
	    custom-deserialize
	    define-custom-serializer
	    define-custom-deserializer
	    custom-load-user-file)

    (open rep
	  rep.io.files
	  rep.data.tables
	  rep.structures
	  rep.system
	  #|
	     Don't add more sawfish.wm.* here unless you know what
	     you're doing. Instead, embed 'require' in
	     definition. It's because this file is read from
	     windows.jl. See windows.jl for more.
	  |#
	  sawfish.wm.commands
	  sawfish.wm.gaol
	  sawfish.wm.colors
	  sawfish.wm.fonts
	  sawfish.wm.misc)

  (define-structure-alias custom sawfish.wm.custom)

  ;; list associating groups with the list of variables in that group
  (define custom-groups (list 'root "Sawfish"))

  (defvar custom-user-file "~/.sawfish/custom"
    "File used to store user's configuration settings.")

  (defvar custom-default-file (expand-file-name "sawfish/wm/custom-defaults.jl"
						sawfish-lisp-lib-directory)
    "Lisp library storing default customization settings.")

  (define custom-quoted-keys
    '(:group :require :type :options :range :depends
             :layout :widget-flags)
    "defcustom keys whose values are quoted by the macro expansion.")

  (define custom-option-alist '((:group . custom-group)
				(:require . custom-require)
				(:type . custom-type)
				(:type* . custom-type)
				(:options . custom-options)
				(:depends . custom-depends)
				(:set . custom-set)
				(:get . custom-get)
				(:widget . custom-widget)
				(:after-set . custom-after-set)
				(:before-set . custom-before-set)
				(:range . custom-range)
				(:widget-flags . custom-widget-flags)))

  (define custom-group-option-alist '((:layout . custom-group-layout)
				      (:require . custom-group-require)))

  ;; hash group names (lists of symbols) to alist of options
  (define custom-group-table (make-table equal-hash equal))

;;; defining custom variables and groups

  (defmacro defcustom (symbol value doc #!rest keys)
    "Define a new customization variable SYMBOL which initially has value
VALUE (unless SYMBOL is already bound, in which case its value is not
altered), and documentations string DOC.

KEYS is a property-list containing any of the following:

	:group GROUP
	:require FEATURE
	:type TYPE
	:options OPTIONS
	:depends SYMBOL
	:range (MIN . MAX)		for `number' type
	:set FUNCTION
	:get FUNCTION
	:before-set FUNCTION
	:after-set FUNCTION
	:widget FUNCTION

TYPE may be `boolean', `number', `string', `symbol', `file-name',
`program-name', `font', `color'.

Note that the values of the `:group', `:require', `:type', `:options',
`:depends' and `:range' keys are not evaluated. All other key values are
evaluated.

Each defcustom'd symbol may have several special properties

	custom-set (FUNCTION SYMBOL VALUE)
	custom-get (FUNCTION SYMBOL)
	custom-widget (FUNCTION SYMBOL)

These functions are used while constructing and responding to the
customisation dialog. If not set in the symbol itself they may be
inherited from the plist of the type of the variable.

custom-set and custom-get may be used to translate data types to the
string representation required by some widget types. custom-widget may
construct the widget definition passed to the ui backend."

    (let* ((cell (memq ':tooltip keys))
	   (tooltip (cadr cell))
	   (tem (gensym)))
      (when cell
	(setq keys (delq (car cell) (delq (cadr cell) keys))))
      `(let ((,tem ,value))
	 (defvar ,symbol ,tem ,(if tooltip (concat doc "\n\n" tooltip) doc))
	 (custom-declare-variable ',symbol ,(custom-quote-keys keys) ,tem))))

  (defmacro defgroup (symbol doc #!rest keys)
    "Declare a new custom group called SYMBOL, with English name DOC. The
property list KEYS may contain the following key-value items:

	:group PARENT-GROUP
	:layout LAYOUT-TYPE

Note that the value of the `:group' key is not evaluated."

    `(custom-declare-group ',symbol ,doc ,(custom-quote-keys keys)))

  (define (custom-declare-variable symbol keys #!optional default-value)
    (let (type prop)
      (while keys
	(setq prop (cdr (assq (car keys) custom-option-alist)))
	(setq keys (cdr keys))
	(when prop
	  (put symbol prop (car keys)))
	(setq keys (cdr keys)))
      (custom-add-to-group symbol (get symbol 'custom-group))
      (setq type (get symbol 'custom-type))
      (when (eq (car type) 'set)
	;; backwards compatibility
	(put symbol 'custom-options (cdr type))
	(setq type 'symbol)
	(put symbol 'custom-type type))
      (when (and type (symbolp type))
	(when (and (not (get symbol 'custom-get)) (get type 'custom-get))
	  (put symbol 'custom-get (get type 'custom-get)))
	(when (and (not (get symbol 'custom-set)) (get type 'custom-set))
	  (put symbol 'custom-set (get type 'custom-set)))
	(when (and (not (get symbol 'custom-widget)) (get type 'custom-widget))
	  (put symbol 'custom-widget (get type 'custom-widget))))
      (put symbol 'custom-default-value default-value)
      symbol))

  (define (custom-declare-group group #!optional doc keys)
    (let (container)
      (while keys
	(case (car keys)
	  ((:group)
	   (setq container (nth 1 keys))
	   (unless (listp container)
	     (setq container (list container))))
	  ((:require)
	   (custom-group-requires (append container (list group)) (cadr keys)))
	  (t
	   (custom-set-group-property (append container (list group))
				      (car keys) (cadr keys))))
	(setq keys (cddr keys)))
      (custom-add-to-group (list group doc) container)
      (unless container
	;; declare a command to customize this group
	(define-command (intern (concat "customize:" (symbol-name group)))
          (lambda ()
            (require 'sawfish.wm.customize)
            (customize group))
	  #:doc (format nil
			"Invoke configurator to customize group \"%s\"."
			group
			)))))

  (define (custom-quote-keys keys)
    (let ((out '()))
      (while (and keys (cdr keys))
	(if (memq (car keys) custom-quoted-keys)
	    (setq out (cons (list 'quote (nth 1 keys))
			    (cons (list 'quote (car keys)) out)))
	  (setq out (cons (nth 1 keys) (cons (list 'quote (car keys)) out))))
	(setq keys (nthcdr 2 keys)))
      (cons 'list (nreverse out))))

;;; general management

  (define custom-setter-table (make-table symbol-hash eq))

  (define (define-custom-setter name def)
    (table-set custom-setter-table name def))

  (define (custom-setter name)
    (or (table-ref custom-setter-table name)
	(error "No such custom setter: %s" name)))

  (define (custom-set-property sym prop value)
    "Set the custom key PROP for defcustom'd symbol SYM to value."
    (let ((key (cdr (assq prop custom-option-alist))))
      (when key
	(put sym key value))))

  (define (custom-get-property sym prop)
    (let ((key (cdr (assq prop custom-option-alist))))
      (and key (get sym key))))

  (define (custom-set-group-property group prop value)
    "Set the custom key PROP for defgroup'd symbol SYM to value."
    (unless (listp group)
      (setq group (list group)))
    (let* ((alist (table-ref custom-group-table group))
	   (cell (and alist (assq prop alist))))
      (if cell
	  (rplacd cell value)
	(setq alist (cons (cons prop value) alist))
	(table-set custom-group-table group alist))))

  (define (custom-get-group-property group prop)
    (unless (listp group)
      (setq group (list group)))
    (let ((alist (table-ref custom-group-table group)))
      (cdr (assq prop alist))))

  (define (custom-group-requires group feature)
    (unless (listp group)
      (setq group (list group)))
    (custom-set-group-property
     group ':require
     (cons feature (delq feature
			 (custom-get-group-property ':require group)))))

  (defmacro custom-add-option (sym option)
    "Assuming that defcustom'd symbol SYM is of type `symbol', add the
symbol OPTION to the list of choices."
    `(put ,sym 'custom-options
	  (nconc (get ,sym 'custom-options) (list ,option))))

  (defmacro custom-get-options (sym)
    "Assuming that defcustom'd symbol SYM is of type `symbol', return the
of choices."
    `(get ,sym 'custom-options))

  (define (custom-find-group full-group)
    (when (and (symbolp full-group) (not (null full-group)))
      (setq full-group (list full-group)))
    (let loop ((group full-group)
	       (parent custom-groups))
      (if (null group)
	  parent
	(loop (cdr group)
	      (or (assq (car group) (cddr parent))
		  (error "No such group: %S" full-group))))))

  (define (custom-add-to-group cell full-group)
    (when (and (symbolp full-group) (not (null full-group)))
      (setq full-group (list full-group)))
    (let loop ((group full-group)
	       (parent custom-groups))
      (if (null group)
	  (unless (or (memq cell (cddr parent))
		      (assq (car cell) (cddr parent)))
	    ;; reached the bottom most group
	    (rplacd (cdr parent) (nconc (cddr parent) (list cell))))
	;; keep on recursing
	(loop (cdr group)
	      (or (assq (car group) (cddr parent))
		  (error
		   "Unknown customization group: %s.\nIf not typo, its defgroup is not called yet." full-group)))
	(unless (cdr group)
	  (rplacd (cdr custom-groups)
		  (nconc (sort (filter consp (cddr custom-groups))
			       (lambda (x y)
				 (string-lessp (cadr x) (cadr y))))
			 (filter atom (cddr custom-groups))))))))

;;; setting values

  (define (custom-set setter symbol)
    (when (get symbol 'custom-before-set)
      ((get symbol 'custom-before-set) symbol))
    (make-variable-special symbol)
    (setter)
    (put symbol 'custom-user-value t)
    (when (get symbol 'custom-after-set)
      ((get symbol 'custom-after-set) symbol)))

  (define (custom-set-symbol setter symbol)
    (unless (get symbol 'custom-obsolete)
      (let* ((was-bound (boundp symbol))
	     (old-value (and was-bound (symbol-value symbol))))
	(call-with-exception-handler
	 (lambda ()
	   (custom-set setter symbol))
	 (lambda (ex)
	   ;; error while setting SYMBOL; revert to its old state
	   (if was-bound
	       (set symbol old-value)
	     (makunbound symbol))
	   (raise-exception ex))))))

  (define (custom-set-variable symbol value #!optional req)
    ;; XXX kludge for old custom files..
    (when (eq value 'nil) (setq value nil))
    (when (and req value)
      ;; load in the user module in case it's a file of bare code
      (user-require req))
    (custom-set-symbol (lambda ()
			 (make-variable-special symbol)
			 (set symbol value)) symbol))

  (define (custom-set-typed-variable symbol value type #!optional req)
    ;; XXX kludge for old custom files..
    (when (eq value 'nil) (setq value nil))
    (when (and req value)
      (user-require req))
    (custom-set-symbol (lambda ()
			 (make-variable-special symbol)
			 (set symbol (custom-deserialize value type)))
		       symbol))

  (define (variable-customized-p symbol)
    "Returns `t' if the variable named SYMBOL has been customized by
the user."
    (get symbol 'custom-user-value))

  (define (variable-type symbol)
    "Returns the customizable type of the variable named SYMBOL."
    (get symbol 'custom-type))

  (define (variable-default-value symbol)
    "Returns the default value of SYMBOL."
    (get symbol 'custom-default-value))

  ;; if the custom variable has been declared, then it will always
  ;; have a default-value property
  (define (variable-declared-p symbol)
    (memq 'custom-default-value (symbol-plist symbol)))

  (define (make-custom-form symbol value)
    (let ((fun (or (get symbol 'custom-set) 'custom-set-typed-variable))
	  (custom-value (custom-serialize value (variable-type symbol))))
      `(,fun ',symbol ',custom-value
             ,@(and (eq fun 'custom-set-typed-variable)
                    (list (list 'quote (variable-type symbol))))
             ,@(and (get symbol 'custom-require)
                    (list (list 'quote (get symbol 'custom-require)))))))

  (define (custom-eval form)
    (apply (custom-setter (car form))
	   (mapcar (lambda (x)
		     (if (eq (car x) 'quote)
			 (cadr x)
		       ;; XXX alternatives to user-eval
		       (user-eval x))) (cdr form))))

;;; serializing unreadable types

  ;; property name (symbol) to find type converters on during
  ;; custom-convert
  (define custom-converter-property (make-fluid))

  ;; convert VALUE of TYPE to or from a printable object
  (define (custom-convert value type)
    (case (or (car type) type)
      ((optional)
       (custom-convert value (cadr type)))

      ((labelled)
       (custom-convert value (caddr type)))

      ((quoted)
       `(quote ,(custom-convert (cadr value) (cadr type))))

      ((pair)
       (cons (custom-convert (car value) (cadr type))
	     (custom-convert (cdr value) (caddr type))))

      ((list)
       (mapcar (lambda (x) (custom-convert x (cadr type))) value))

      ((alist)
       (let ((k-type (or (car (cadr type)) (cadr type)))
	     (v-type (or (car (caddr type)) (caddr type))))
	 (mapcar (lambda (x)
		   (cons (custom-convert (car x) k-type)
			 (custom-convert (cdr x) v-type))) value)))

      ((and v-and h-and)
       (do ((values value (cdr values))
	    (types (cdr type) (cdr types))
	    (out '() (cons (custom-convert (car values) (car types)) out)))
	   ((or (null types) (null values))
	    (nreverse out))))

      ;; XXX handle `or' (needs type predicates)

      (t (let ((converter (get (or (car type) type)
			       (fluid custom-converter-property))))
	   (if converter
	       (converter value type)
	     value)))))

  (define (custom-serialize value type)
    "Convert VALUE of TYPE to a printable value."
    (let-fluids ((custom-converter-property 'custom-serializer))
      (custom-convert value type)))

  (define (custom-deserialize value type)
    "Convert VALUE of TYPE back from a printable value."
    (let-fluids ((custom-converter-property 'custom-deserializer))
      (custom-convert value type)))

  (define (define-custom-serializer type fun)
    (put type 'custom-serializer fun))

  (define (define-custom-deserializer type fun)
    (put type 'custom-deserializer fun))

;;; support for font and color primitive types

  (define-custom-serializer 'font (lambda (value)
				    (if (fontp value)
					(cons (font-type value)
					      (font-name value))
				      value)))

  (define-custom-deserializer 'font (lambda (value)
				      (cond ((stringp value)
					     (get-font value))
					    ((consp value)
					     (get-font-typed
					      (car value) (cdr value)))
					    (t value))))

  (define-custom-serializer 'color (lambda (value)
				     (if (colorp value)
					 (color-name value)
				       value)))

  (define-custom-deserializer 'color (lambda (value)
				       (if (stringp value)
					   (get-color value)
					 value)))

;;; default groups

  ;; If you suffer from Sawfish init failure in defcustom / defgroup
  ;; which is the result of additional "open", then push the defcustom
  ;; of the parent group here.
  (defgroup appearance "Appearance")
  (defgroup bindings "Bindings")
  (defgroup focus "Focus")
  (defgroup min-max "Mini/Maximizing")
  (defgroup misc "Miscellaneous")
  (defgroup move "Move/Resize" :require sawfish.wm.commands.move-resize)
  (defgroup placement "Placement" :group misc)
  (defgroup stacking "Stacking" :group misc)
  (defgroup workspace "Workspaces")
  (defgroup edge-actions "Edge Actions")

;;; loading user's customisations

  (define (custom-load filename)
    (let ((file (open-file filename 'read)))
      (unwind-protect
	  (condition-case nil
	      (while t
		(let ((form (read file)))
		  (call-with-error-handler
		   (lambda () (custom-eval form)))))
	    (end-of-stream))
	(close-file file))))

  (define (custom-load-user-file)
    "Load the user's customization file, or the custom-default-file."
    (cond ((file-exists-p custom-user-file)
	   (custom-load custom-user-file))
	  (custom-default-file
	   (custom-load custom-default-file))))

;;; init

  (let ((tem (get-command-line-option "--custom-file" t)))
    (when tem
      (setq custom-user-file tem)))

  (define-custom-setter 'custom-set-variable custom-set-variable)
  (define-custom-setter 'custom-set-typed-variable custom-set-typed-variable)

  (gaol-add defcustom defgroup custom-declare-variable custom-declare-group
	    custom-quote-keys custom-set-property custom-set-group-property
	    custom-option-alist custom-group-option-alist))

;; main.jl -- animation definition interface

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.animation.main

    (export make-outline-animator)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.animation.setup
	  sawfish.wm.custom
	  sawfish.wm.animation.modes
	  sawfish.wm.gaol
	  rep.io.timers)

  ;; For backward compatibility.
  (define-structure-alias anim-outline sawfish.wm.animation.main)

  (defcustom anim-outline-icon-coords (cons (screen-width) (screen-height))
    "Animation Outline Coordinates"
    :type (pair (number 1) (number 1))
    :group (appearance animation))

  (defcustom anim-outline-steps 16
    "Animation Steps"
    :type (range (1 . 1000))
    :group (appearance animation))

  (defcustom anim-outline-delay 20
    "Animation Delay"
    :type (range (1 . 1000))
    :group (appearance animation))

  (define (anim-outline-run w mode initial-coords initial-dims
			    final-coords final-dims)
    (let ((step 0)
	  (x-step (quotient (- (car final-coords) (car initial-coords))
			    anim-outline-steps))
	  (y-step (quotient (- (cdr final-coords) (cdr initial-coords))
			    anim-outline-steps))
	  (w-step (quotient (- (car final-dims) (car initial-dims))
			    anim-outline-steps))
	  (h-step (quotient (- (cdr final-dims) (cdr initial-dims))
			    anim-outline-steps))
	  (coords (cons (car initial-coords) (cdr initial-coords)))
	  (dims (cons (car initial-dims) (cdr initial-dims)))
	  timer)

      (define (stop)
	(delete-timer timer)
	(record-window-animator w nil)
	(ungrab-server))

      (define (protect fun)
	(call-with-exception-handler fun (lambda (ex)
					   (stop)
					   (raise-exception ex))))

      (define (clear)
	(unless (zerop step)
	  (protect (lambda ()
		     (erase-window-outline mode (car coords) (cdr coords)
					   (car dims) (cdr dims))))))

      (define (frame)
	(protect (lambda ()
		   (clear)
		   (if (>= step anim-outline-steps)
		       (stop)
		     (rplaca coords (+ (car coords) x-step))
		     (rplacd coords (+ (cdr coords) y-step))
		     (rplaca dims (+ (car dims) w-step))
		     (rplacd dims (+ (cdr dims) h-step))
		     (draw-window-outline mode (car coords) (cdr coords)
					  (car dims) (cdr dims))
		     (setq step (1+ step))
		     (set-timer timer)))))

      (define (animator win op)
	(declare (unused win))
	(when (eq op 'stop)
	  (clear)
	  (stop)))

      ;; kludged.. there may be Expose events waiting
      (accept-x-input)

      (grab-server)
      (record-window-animator w animator)
      (setq timer (make-timer frame nil anim-outline-delay))))

  (define (anim-outline-entry mode w op #!optional action)
    (when (eq op 'start)
      (case action
	((iconified)
	 (if (window-get w 'iconified)
	     (anim-outline-run w mode (window-position w)
			       (window-frame-dimensions w)
			       (or (window-get w 'icon-position)
				   anim-outline-icon-coords)
			       '(1 . 1)))))))

  (define (make-outline-animator mode)
    (lambda (w op #!optional action)
      (anim-outline-entry mode w op action)))

  (define wireframe-animator (make-outline-animator 'box))
  (define solid-animator (make-outline-animator 'solid))
  (define cross-animator (make-outline-animator 'cross))
  (define elliptical-animator (make-outline-animator 'elliptical))
  (define draft-animator (make-outline-animator 'draft))

  ;;###autoload
  (define-window-animator 'wireframe wireframe-animator)
  (define-window-animator 'solid solid-animator)
  (define-window-animator 'cross cross-animator)
  (define-window-animator 'elliptical elliptical-animator)
  (define-window-animator 'draft draft-animator))

;; edge/conf.jl -- configuration for EdgeActions

;; Copyright (C) 2011 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.conf

    (export)

    (open rep
	  sawfish.wm.custom
	  sawfish.wm.edge.actions)

  (define-structure-alias edge-conf sawfish.wm.edge.conf)

  (defvar before-edge-action-hook nil)
  (defvar after-edge-action-hook nil)

  (defcustom edge-actions-enabled nil
    "Activate edges to perform various actions."
    :group edge-actions
    :type boolean
    :after-set (lambda () (activate-edges-after-set)))

  (defcustom left-edge-action 'none/hot-spot
    "Action for the left screen-edge."
    :group edge-actions
    :type (choice none/hot-spot viewport-drag flip-workspace
		  flip-viewport show-desktop))

  (defcustom left-edge-move-action 'none/hot-move
    "Action for the left screen-edge while moving a window."
    :group edge-actions
    :type  (choice none/hot-move viewport-drag flip-workspace
		   flip-viewport expand-window maximize-window kill-window
		   iconify-window move-window-viewport move-window-workspace))

  (defcustom top-edge-action 'none/hot-spot
    "Action for the top screen-edge."
    :group edge-actions
    :type (choice none/hot-spot viewport-drag flip-workspace
		  flip-viewport show-desktop))

  (defcustom top-edge-move-action 'none/hot-move
    "Action for the top screen-edge while moving a window."
    :group edge-actions
    :type  (choice none/hot-move viewport-drag flip-workspace
		   flip-viewport expand-window maximize-window kill-window
		   iconify-window move-window-viewport move-window-workspace))

  (defcustom right-edge-action 'none/hot-spot
    "Action for the right screen-edge."
    :group edge-actions
    :type (choice none/hot-spot viewport-drag flip-workspace
		  flip-viewport show-desktop))

  (defcustom right-edge-move-action 'none/hot-move
    "Action for the right screen-edge while moving a window."
    :group edge-actions
    :type  (choice none/hot-move viewport-drag flip-workspace
		   flip-viewport expand-window maximize-window kill-window
		   iconify-window move-window-viewport move-window-workspace))

  (defcustom bottom-edge-action 'none/hot-spot
    "Action for the bottom screen-edge."
    :group edge-actions
    :type (choice none/hot-spot viewport-drag flip-workspace
		  flip-viewport show-desktop))

  (defcustom bottom-edge-move-action 'none/hot-move
    "Action for the bottom screen-edge while moving a window."
    :group edge-actions
    :type  (choice none/hot-move viewport-drag flip-workspace
		   flip-viewport expand-window maximize-window kill-window
		   iconify-window move-window-viewport move-window-workspace))

  (defcustom edge-flip-delay 250
    "Delay (in milliseconds) of flipping of viewport / workspace."
    :group edge-actions
    :type number
    :range (0 . nil))

  (defcustom hot-spot-delay 250
    "Delay (in milliseconds) before activating a hot-spot."
    :group edge-actions
    :type number
    :range (0 . nil))

  (defcustom hot-spots-corner-length 50
    "The size portion of the screen-border recognized as \"corners\",
in pixels. Applies to both x and y direction."
    :type (range (5 . 500))
    :group edge-actions)

  (defcustom viewport-drag-distance 64
    "Amount to drag the viewport (in pixel) each time the pointer hits the
screen edge."
    :group edge-actions
    :type number
    :range (1 . nil))

  (defcustom viewport-drag-cursor-distance 32
    "Amount to pull back the cursor (in pixel) after dragging the viewport."
    :group edge-actions
    :type number
    :range (1 . nil)))

;; wm.jl -- interface to WM as a server
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.wm

    (export wm-load-slots
	    wm-load-group
	    wm-apply-changes
	    wm-locale-dir
	    wm-grab-x-property
	    wm-grab-key
	    wm-command-list
	    wm-documentation)

    (open rep
	  sawfish.client)

;;; wm communication (possibly replace by CORBA..?)

  (define (wm-eval form #!optional read-back)
    (sawfish-client-eval form (not read-back)))

  (define (wm-eval-async form)
    (sawfish-client-eval-async form))

  (define done-init nil)
  (define (init-server)
    (unless done-init
      (wm-eval '(require 'sawfish.wm.util.nokogiri))
      (setq done-init t)))

;;; stub functions

  ;; returns a list of keyworded items. Keywords include:
  ;; #:name, #:depends, #:value, #:type, #:doc
  (define (wm-load-slots names)
    (init-server)
    (wm-eval `(nokogiri-report-slots ',names) t))

  ;; return the data in GROUP
  (define (wm-load-group group)
    (init-server)
    (wm-eval `(nokogiri-report-group ',group) t))

  ;; CHANGES is list of (SLOT-NAME . NEW-VALUE)
  (define (wm-apply-changes changes)
    (init-server)
    (wm-eval `(nokogiri-apply-changes ',changes)))

  (define (wm-locale-dir)
    (wm-eval 'sawfish-locale-directory t))

  (define (wm-grab-x-property prop-name)
    (wm-eval `(nokogiri-grab-match-window-property ',prop-name) t))

  (define (wm-grab-key)
    (wm-eval '(nokogiri-grab-key) t))

  (define wm-command-list
    (let ((commands '*undefined*))
      (lambda ()
	(unless (listp commands)
	  (init-server)
	  (setq commands (wm-eval '(nokogiri-report-commands) t)))
	commands)))

  (define (wm-documentation symbol)
    (wm-eval
     `(let ((doc (command-documentation ',symbol)))
	(and doc (_ doc))) t)))

;; shade-hover.jl -- temporarily unshade windows while hovered over

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.shade-hover

    (export clean-up)

    (open rep
          rep.system
          rep.io.timers
          sawfish.wm.windows
          sawfish.wm.custom
          sawfish.wm.events
          sawfish.wm.state.shading)

  (define-structure-alias shade-hover sawfish.wm.ext.shade-hover)

  (defgroup shade-hover "Shade Hover"
    :group focus
    :require sawfish.wm.ext.shade-hover)

  (defcustom shade-hover-mode nil
    "Enable shade-hover mode."
    :tooltip "(Temporarily unshades windows while the mouse pointer is \
over them.)"
    :group (focus shade-hover)
    :type boolean
    :require sawfish.wm.ext.shade-hover)

  (defcustom shade-hover-delay 250
    "Delay in milliseconds before unshading windows."
    :group (focus shade-hover)
    :depends shade-hover-mode
    :type (number 0 5000))

  (defcustom shade-hover-raise nil
    "Raise windows when they are unshaded."
    :group (focus shade-hover)
    :depends shade-hover-mode
    :type boolean)

  (define shade-hover-timer nil)
  (define shade-hover-window nil)

  (define (clean-up)
    (when shade-hover-timer
      (delete-timer shade-hover-timer)
      (setq shade-hover-timer nil))
    (setq shade-hover-window nil)
    (remove-hook 'pre-command-hook shade-hover-before))

  (define (shade-hover-leave w)
    (when (eq shade-hover-window w)
      (clean-up)
      (when (window-get w 'shade-hover-unshaded)
	(window-put w 'shade-hover-unshaded nil)
	(shade-window w))))

  (define (shade-hover-before)
    (let ((w (current-event-window)))
      (when (and (windowp w) (window-get w 'shade-hover-unshaded))
	(case this-command
	  ((toggle-window-shaded unshade-window)
	   ;; don't want window to shade then unshade
	   (clean-up)
	   (window-put w 'shade-hover-unshaded nil)
	   (setq this-command nil))
	  ((shade-window)
	   (clean-up))))))

  (define (shade-hover-enter w)
    (when (and (windowp w)
	       (or shade-hover-mode (window-get w 'shade-hover)))
      (when (window-get w 'shaded)
	(let ((callback
	       (lambda ()
		 (window-put w 'shade-hover-unshaded t)
		 (let
		     ((raise-windows-when-unshaded shade-hover-raise))
		   (unshade-window w)))))
	  (when shade-hover-timer
	    (delete-timer shade-hover-timer))
	  (setq shade-hover-window w)
	  (if (zerop shade-hover-delay)
	      (callback)
	    (setq shade-hover-timer
		  (make-timer callback
			      (quotient shade-hover-delay 1000)
			      (mod shade-hover-delay 1000))))
	  (unless (in-hook-p 'pre-command-hook shade-hover-before)
	    (add-hook 'pre-command-hook shade-hover-before))))))

  (add-hook 'enter-notify-hook shade-hover-enter)
  (add-hook 'leave-notify-hook shade-hover-leave)
  (add-hook 'focus-out-hook shade-hover-leave))

;; viewport.jl -- virtual desktops

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.viewport

    (export set-viewport
	    screen-viewport
	    set-screen-viewport
	    select-workspace-and-viewport
	    move-viewport
	    move-viewport-to-window
	    window-outside-workspace-p
	    window-outside-viewport-p
	    move-window-to-current-viewport
	    set-window-viewport
	    move-window-viewport
            viewport-at
	    window-viewport
            viewport-offset-coord
	    window-absolute-position
	    set-number-of-viewports
            rect-within-viewport-p
            rect-within-head-p
            window-head-any-viewport
	    viewport-minimum-size-changed
            viewport-honor-workspace-edges
	    viewport-windows
	    window-on-current-head-viewport-p
	    move-window-left
	    move-window-right
	    move-window-up
	    move-window-down)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.custom
          sawfish.wm.util.rects
	  sawfish.wm.session.init)

  ;; Virtual workspaces are implemented by moving windows in and out of
  ;; the screen dimensions. E.g. moving to the left moves all windows one
  ;; screen-width to the right.

  (defgroup viewport "Viewport" :group workspace)

  (defcustom viewport-dimensions '(1 . 1)
    "The number of columns and rows of the virtual desktop: \\left"
    :group (workspace viewport)
    :type (pair (number 1) (number 1))
    :tooltip "This is meaningless if dynamic viewport is enabled."
    :after-set (lambda () (viewport-size-changed t)))

  (defcustom viewport-minimum-dimensions '(1 . 1)
    "Minimum number of columns and rows of virtual desktop (if boundary mode is dynamic): \\left"
    :group (workspace viewport)
    :type (pair (number 1) (number 1))
    :after-set (lambda () (viewport-minimum-size-changed)))

  (defcustom uniconify-to-current-viewport t
    "Windows uniconify to the current viewport."
    :type boolean
    :group (workspace viewport))

  (defcustom scroll-viewport-steps 1
    "When you go to another viewport, the bigger this value,
the more smoothly the screen is scrolled.
It is the number of steps for scrolling. The value 1 means no scroll, and
the change is instantaneous."
    :group (workspace viewport)
    :type (range (1 . 50)))

  (defcustom viewport-boundary-mode 'stop
    "Stop, wrap-around, or grow the virtual desktop when you go beyond virtual desktop edge."
    :group (workspace viewport)
    :type (choice wrap-around stop dynamic))

  (defvar workspace-viewport-data nil
    "Information about the viewport details of different workspaces.")

  (defvar viewport-moved-hook nil)
  (defvar viewport-resized-hook nil)
  
;;; raw viewport handling

  ;; The unit is pixel, NOT (col, row).
  ;; Position (0, 0) means the top-left of the workspace.
  (defvar viewport-x-offset 0)
  (defvar viewport-y-offset 0)

  (define (warp-viewport x y)
    "Move viewport to (x, y). The unit is pixel, not (col, row).
Position (0, 0) is the top-left of the workspace."
    (define (move-window w)
      (unless (window-get w 'sticky-viewport)
	(let ((pos (window-position w)))
	  (move-window-to w (- (+ (car pos) viewport-x-offset) x)
			  (- (+ (cdr pos) viewport-y-offset) y)))))

    (unless (and (= viewport-x-offset x) (= viewport-y-offset y))
      (let loop ((rest (stacking-order))
		 (inside '())
		 (outside '()))
	(cond ((null rest)
	       (with-server-grabbed
		;; First move all windows not on the old viewport, and
		;; move in top-to-bottom order..
		(mapc move-window (nreverse outside))
		;; ..then move away the windows on the old viewport,
		;; in bottom-to-top order
		(mapc move-window inside)))

              ;; No need to warp windows not in the current workspace.
              ;; See viewport-leave-workspace-handler and
              ;; viewport-enter-workspace handler below.
              ((not
                (window-appears-in-workspace-p (car rest) current-workspace))
               (loop (cdr rest) inside outside))
	      ((window-outside-viewport-p (car rest))
	       (loop (cdr rest) inside (cons (car rest) outside)))

	      (t (loop (cdr rest) (cons (car rest) inside) outside))))

      (setq viewport-x-offset x)
      (setq viewport-y-offset y)))

  (define (viewport-honor-workspace-edges)
    "Whether or not to prevent the display from moving past the
current viewport boundaries.  Returns true if `viewport-boundary-mode'
is not set to 'dynamic."
    (not (eq viewport-boundary-mode 'dynamic)))

  (define (set-viewport x y)
    "Move viewport to (x, y). The unit is pixel, not (col, row).
Position (0, 0) is the top-left of the workspace.

Scroll is done whose steps are `scroll-viewport-steps'."
    (unless (= scroll-viewport-steps 1) ; fast skip if scroll is unwanted
      (let* ((xstep (quotient (- x viewport-x-offset) scroll-viewport-steps))
             (ystep (quotient (- y viewport-y-offset) scroll-viewport-steps))
             (step-count (if (= xstep ystep 0) 0 scroll-viewport-steps)))
        (while (> step-count 1)
          (warp-viewport (+ viewport-x-offset xstep)
                         (+ viewport-y-offset ystep))
          (setq step-count (1- step-count)))))
    (warp-viewport x y)
    (call-hook 'viewport-moved-hook))

  (define (viewport-before-exiting)
    ;; Reset all workspaces to viewport 0,0.  This is so that on
    ;; restart (or if another wm takes over) windows aren't in strange
    ;; places.
    (if workspace-viewport-data
        (mapc (lambda (ws-data)
                (select-workspace (car ws-data))
                (set-screen-viewport 0 0))
              workspace-viewport-data)
      (set-screen-viewport 0 0)))

  (add-hook 'before-exit-hook viewport-before-exiting t)

  (define (viewport-dynamic-resize)
    "Reset the size of the viewport to include the current screen as
well as any windows in the current workspace."
    (when (eq viewport-boundary-mode 'dynamic)
      (let ((windows
	     (filter-windows
	      (lambda (w)
		(window-in-workspace-p w current-workspace)))))
	(if windows
	    (let* ((width (screen-width))
                   (height (screen-height))
                   (points
                    (nconc
                     (mapcar (lambda (w)
                               (let ((pos (window-position w))
                                     (dims (window-frame-dimensions w)))
                                 (list (car pos)
                                       (cdr pos)
                                       (+ (car pos) (car dims))
                                       (+ (cdr pos) (cdr dims)))))
                             windows)
                     ;; Include the current screen:
                     `((0 0 ,(1- width) ,(1- height)))))
                   ;; The min/max values calculated below are relative to
                   ;; the old logical 0,0 point of the virtual desktop:
                   (old-x-origin (- viewport-x-offset))
                   (old-y-origin (- viewport-y-offset))
                   (x-min (- (apply min (mapcar car points)) old-x-origin))
                   (y-min (- (apply min (mapcar (lambda (e) (nth 1 e)) points))
                             old-y-origin))
                   (x-max (- (apply max (mapcar (lambda (e) (nth 2 e)) points))
                             old-x-origin))
                   (y-max (- (apply max (mapcar (lambda (e) (nth 3 e)) points))
                             old-y-origin))
                   ;; high-* values are the number of rows/columns above
                   ;; the old origin, low-* values the number below the
                   ;; old origin.
                   (high-rows (+ (quotient y-max height)
                                 (if (> (mod y-max height) 0)
                                     1
                                   0)))
                   (low-rows (+ (- (quotient y-min height))
                                (if (and (< y-min 0)
                                         (> (mod y-min height) 0))
                                    1
                                  0)))
                   (rows (+ low-rows high-rows))
                   (high-cols (+ (quotient x-max width)
                                 (if (> (mod x-max width) 0)
                                     1
                                   0)))
                   (low-cols (+ (- (quotient x-min width))
                                (if (and (< x-min 0)
                                         (> (mod x-min width) 0))
                                    1
                                  0)))
                   (cols (+ low-cols high-cols)))
	      (setq
               viewport-y-offset (- (- old-y-origin (* low-rows height)))
               viewport-x-offset (- (- old-x-origin (* low-cols width)))
	       viewport-dimensions (cons
				    (max cols
					 (car viewport-minimum-dimensions))
				    (max rows
					 (cdr viewport-minimum-dimensions)))))
	  (setq viewport-y-offset 0
		viewport-x-offset 0
		viewport-dimensions viewport-minimum-dimensions))
	(call-hook 'viewport-resized-hook))))

  ;; Resize virtual workspace on workspace switch or viewport move:
  (add-hook 'viewport-moved-hook
	    viewport-dynamic-resize)

  (add-hook 'after-initialization-hook
            viewport-dynamic-resize)

  (define (viewport-leave-workspace-handler ws)
    "On leaving a workspace, store information about the viewport
configuration so that it can be restored properly later.
`WS' is the workspace to leave."
    (let ((vp-data (list viewport-x-offset
                         viewport-y-offset
                         viewport-dimensions))
          (old-ent (assoc ws workspace-viewport-data)))
      (if old-ent
          (rplacd old-ent vp-data)
        (setq workspace-viewport-data
              (cons (cons ws vp-data)
                    workspace-viewport-data)))))

  (add-hook 'leave-workspace-hook
            viewport-leave-workspace-handler)

  (define (viewport-enter-workspace-handler ws)
    "Restore any saved data about the viewport for the new workspace.
When `viewport-boundary-mode' is not `dynamic', make sure that the new
viewport is within `viewport-dimensions'."
    (let ((vp-data (cdr (assoc ws workspace-viewport-data))))
      (if vp-data
          (let ((maybe-x-offset (car vp-data))
                (maybe-y-offset (nth 1 vp-data)))
            (if (eq viewport-boundary-mode 'dynamic)
                (setq viewport-dimensions (nth 2 vp-data)
                      viewport-x-offset maybe-x-offset
                      viewport-y-offset maybe-y-offset)
              ;; Do maybe-y-offset and maybe-x-offset fit within
              ;; current viewport-dimensions?
              (if (and (<= maybe-x-offset
                           (* (1- (cdr viewport-dimensions)) (screen-width)))
                       (<= maybe-y-offset
                           (* (1- (car viewport-dimensions)) (screen-height))))
                  (setq viewport-x-offset maybe-x-offset
                        viewport-y-offset maybe-y-offset)
                (setq viewport-x-offset 0
                      viewport-y-offset 0))))
        (setq viewport-x-offset 0
              viewport-y-offset 0))
      (viewport-size-changed)))

  (add-hook 'enter-workspace-hook
            viewport-enter-workspace-handler)

  ;; screen sized viewport handling

  (define (screen-viewport)
    "Gives the row and column of the current viewport."
    (cons (quotient viewport-x-offset (screen-width))
	  (quotient viewport-y-offset (screen-height))))

  ;; returns t if it actually moved the viewport
  (define (set-screen-viewport col row)
    (when (eq viewport-boundary-mode 'wrap-around)
      (setq col (mod col (car viewport-dimensions))
            row (mod row (cdr viewport-dimensions))))
    (when (or (eq viewport-boundary-mode 'dynamic)
	      (and (>= col 0) (< col (car viewport-dimensions))
		   (>= row 0) (< row (cdr viewport-dimensions))))
      (set-viewport (* col (screen-width))
                    (* row (screen-height)))
      t))

  (define (select-workspace-and-viewport space col row)
    (select-workspace space)
    (set-screen-viewport col row))

  ;; returns t if it actually moved the viewport
  (define (move-viewport right down)
    (let ((port (screen-viewport)))
      (set-screen-viewport (+ (car port) right)
			   (+ (cdr port) down))))

  (define (move-viewport-to-window window)
    (when (window-outside-viewport-p window)
      (let ((pos (window-position window)))
	(rplaca pos (+ (car pos) viewport-x-offset))
	(rplacd pos (+ (cdr pos) viewport-y-offset))
	(set-screen-viewport (quotient (car pos) (screen-width))
			     (quotient (cdr pos) (screen-height))))))

  (define (window-outside-workspace-p window)
    "True if `window' is outside the workspace.  Note that this does
not check which workspace the windows is in; the window is outside the
workspace if it's position is not within any viewport."
    (let ((pos (window-position window))
	  (dims (window-frame-dimensions window))
	  (left (- viewport-x-offset))
	  (right (- (* (car viewport-dimensions) (screen-width))
		    viewport-x-offset))
	  (top (- viewport-y-offset))
	  (bottom (- (* (cdr viewport-dimensions) (screen-height))
		     viewport-y-offset)))
      (or (>= (car pos) right)
	  (>= (cdr pos) bottom)
	  (<= (+ (car pos) (car dims)) left)
	  (<= (+ (cdr pos) (cdr dims)) top))))

  (define (window-outside-viewport-p window #!optional viewport)
    "True if no part of `window' is inside the current viewport.  If
`viewport' is specified check against that viewport rather than the
current one."
    (let* ((cur-vp (screen-viewport))
           (width (screen-width))
           (height (screen-height))
           (x-min (if viewport
                      (* (- (car viewport) (car cur-vp))
                         width)
                    0))
           (x-max (+ x-min width))
           (y-min (if viewport
                      (* (- (cdr viewport) (cdr cur-vp))
                         height)
                    0))
           (y-max (+ y-min height))
           (pos (window-position window))
           (dims (window-frame-dimensions window)))
      (or (<= (+ (car pos) (car dims)) x-min)
          (<= (+ (cdr pos) (cdr dims)) y-min)
          (>= (car pos) x-max)
          (>= (cdr pos) y-max))))

  (define (move-window-to-current-viewport window)
    (when (and (window-outside-viewport-p window)
	       (not (window-get window 'sticky-viewport)))
      (let ((pos (window-position window)))
	(move-window-to window (mod (car pos) (screen-width))
			(mod (cdr pos) (screen-height))))))

  (define (set-window-viewport window col row)
    (unless (window-get window 'sticky-viewport)
      (let ((pos (window-position window)))
	(setq col (max 0 (min (1- (car viewport-dimensions)) col)))
	(setq row (max 0 (min (1- (cdr viewport-dimensions)) row)))
	(setq col (+ (* col (screen-width)) (mod (car pos) (screen-width))))
	(setq row (+ (* row (screen-height)) (mod (cdr pos) (screen-height))))
	(move-window-to
	 window (- col viewport-x-offset) (- row viewport-y-offset)))))

  (define (move-window-viewport window col row)
    (let ((pos (window-position window)))
      (set-window-viewport window
			   (+ (quotient (+ (car pos) viewport-x-offset)
					(screen-width)) col)
			   (+ (quotient (+ (cdr pos) viewport-y-offset)
					(screen-height)) row))))

  (define (viewport-at x y)
    "Returns a cons cell consisting of the column and row of the
viewport containing the specified coordinates."
    (let ((x (+ x viewport-x-offset))
          (y (+ y viewport-y-offset)))
      ;; If x or y is negative the viewport must be adjusted by one.
      (cons (- (quotient x (screen-width))
               (if (< x 0)
                   1
                 0))
	    (- (quotient y (screen-height))
               (if (< y 0)
                   1
                 0)))))

  (define (window-viewport w)
    "Returns a cons cell consisting of the column and row of the
viewport containing (or mostly containing) `w'."
    (let* ((pos (window-position w))
           (dims (window-dimensions w)))
      (viewport-at (+ (car pos) (quotient (car dims) 2))
                   (+ (cdr pos) (quotient (cdr dims) 2)))))

  ;; From sawfish.wm.util.rects:
  ;; A rectangle is (LEFT TOP RIGHT BOTTOM [WEIGHT])
  ;; The left and top edges are considered part of the rectangle,
  ;; the right and bottom edges are not.

  (define (rect-within-viewport-p rect #!optional viewport)
    "Return t if `rect' is entirely inside the screen boundaries for
some viewport, regardless of whether it is the current viewport, or
even if the viewport currently exists.  If `viewport' is specified
check only against that viewport."
    (let ((vp (viewport-at (car rect) (nth 1 rect))))
      (when (or (null viewport) (equal vp viewport))
        (let ((offset (viewport-offset-coord vp)))
          (rect-wholly-within-rect (list (car offset)
                                         (cdr offset)
                                         (+ (car offset) (screen-width))
                                         (+ (cdr offset) (screen-height)))
                                   rect)))))

  ;; The next two functions should perhaps go in a "heads" module if
  ;; there were one.  But what makes them interesting is that they
  ;; must account for viewports, which is why I put them here.

  (define (rect-within-head-p rect #!optional head)
    "Return t if `rect' is entirely within some head on some
viewport. If `head' is provided `rect' must be within that head on
some viewport."
    (let* ((offset (viewport-offset-coord (viewport-at (car rect)
                                                 (nth 1 rect))))
           (left (- (car rect) (car offset)))
           (top (- (nth 1 rect) (cdr offset)))
           (right (- (nth 2 rect) (car offset)))
           (bottom (- (nth 3 rect) (cdr offset)))
           (head (or head (find-head left top)))
           (head-pos (head-offset head))
           (head-dims (head-dimensions head)))
      (rect-wholly-within-rect (list (car head-pos)
                                     (cdr head-pos)
                                     (+ (car head-pos) (car head-dims))
                                     (+ (cdr head-pos) (cdr head-dims)))
                               (list left top right bottom))))

  (define (window-head-any-viewport w)
    "Return the id of the head that would contain `w', if the viewport
`w' occupies were visible."
    (let* ((coords (window-position w))
           (dims (window-dimensions w))
           (center (cons (+ (car coords) (quotient (car dims) 2))
                         (+ (cdr coords) (quotient (cdr dims) 2))))
           (vp-offset (viewport-offset-coord (viewport-at (car center)
                                                    (cdr center)))))
      (find-head (- (car center) (car vp-offset))
                 (- (cdr center) (cdr vp-offset)))))

  (define (viewport-offset-coord vp)
    "Returns the offset from the current viewport to viewport `VP'
which is specified as (column . row). The return value is the cons
cell (x . y). The values are in pixel, and are negative if it lies at
left or above the current viewport.

`VP' can be outside of the workspace. If `VP' is nil, it is
understood as the current viewport, i.e., (0 . 0) will be returned."
    (if (consp vp)
        (let* ((cur-vp (screen-viewport)))
          (cons
           (* (- (car vp) (car cur-vp)) (screen-width))
           (* (- (cdr vp) (cdr cur-vp)) (screen-height))))
      '(0 . 0)))

  (define (window-absolute-position w #!optional disambiguate)
    "Returns the coordinates of the window as if the window's viewport
is selected. The return value is the cons cell (x . y)."
    ;; So, ignoring the side effect, it's roughly equal to
    ;; (set-screen-viewport (window-viewport w))
    ;; (window-position w)
    ;; The correct name should be "window-position-in-viewport".

    ;; The temporary hack 'disambiguate' is introduced in Sawfish 1.6.
    ;; It will be removed.

    ;; Two methods differ if the window lies across several vp slots.
    (if disambiguate
	;; method 1: always returns the same value.
	;; This is introduced in 1.6, and necessary for maximization.
	(let ((offset (viewport-offset-coord (window-viewport w)))
	      (coords (window-position w)))
	  (cons
	   (- (car coords) (car offset))
	   (- (cdr coords) (cdr offset))))
      ;; method 2: If the window is visible from the current viewport,
      ;; then simply window-position is returned.
      ;; Else, the viewport where the window's top-left lies is used.
      ;; This has existed for long time.
      ;; Perhaps this can be deleted, and check of visibility can be
      ;; separated, done by the caller.
      (let ((position (window-position w)))
	(if (window-outside-viewport-p w)
	    (cons (mod (+ (car position) viewport-x-offset) (screen-width))
		  (mod (+ (cdr position) viewport-y-offset) (screen-height)))
	  position))))

  (define (viewport-size-changed #!optional force)
    ;; This is called when the user requests a change (e.g., from the
    ;; gui, or via `set-number-of-viewports') as well as when the
    ;; desktop is switched.  If `force' is set it's considered to be
    ;; user-requested, and therefore mandatory that the
    ;; `viewport-dimensions' variable be respected.
    (when (or (< (car viewport-dimensions) (car viewport-minimum-dimensions))
	      (< (cdr viewport-dimensions) (cdr viewport-minimum-dimensions)))
      (if force
          (setq viewport-minimum-dimensions
                (cons (min (car viewport-dimensions)
                           (car viewport-minimum-dimensions))
                      (min (cdr viewport-dimensions)
                           (cdr viewport-minimum-dimensions))))
        (setq viewport-dimensions
              (cons (max (car viewport-dimensions)
                         (car viewport-minimum-dimensions))
                    (max (cdr viewport-dimensions)
                         (cdr viewport-minimum-dimensions)))))
      (when (eq viewport-boundary-mode 'dynamic)
	(viewport-dynamic-resize)))
    (unless (eq viewport-boundary-mode 'dynamic)
      ;; Not using dynmic viewports, so ensure that windows are within
      ;; the current virtual-workspace boundaries:
      (let ((port (screen-viewport)))
	(set-screen-viewport (min (car port) (1- (car viewport-dimensions)))
			     (min (cdr port) (1- (cdr viewport-dimensions))))
	(map-windows (lambda (w)
                       (when (and (window-outside-workspace-p w)
                                  (window-appears-in-workspace-p
                                   w current-workspace))
			 (move-window-to-current-viewport w))))
	(call-hook 'viewport-resized-hook))))

  (define (viewport-minimum-size-changed)
    (if (eq viewport-boundary-mode 'dynamic)
	(viewport-dynamic-resize)
      (when (or (< (car viewport-dimensions)
                   (car viewport-minimum-dimensions))
		(< (cdr viewport-dimensions)
                   (cdr viewport-minimum-dimensions)))
	(setq viewport-dimensions
	      (cons (max (car viewport-dimensions)
			 (car viewport-minimum-dimensions))
		    (max (cdr viewport-dimensions)
			 (cdr viewport-minimum-dimensions))))
	(viewport-size-changed))))

  (define (set-number-of-viewports width height)
    (setq viewport-dimensions (cons width height))
    (setq viewport-minimum-dimensions (cons width height))
    (if (eq viewport-boundary-mode 'dynamic)
	(viewport-dynamic-resize)
      (viewport-size-changed t)))

  (define (viewport-windows #!optional vp-col vp-row workspace
                            exclude-sticky exclude-iconified)
    "Provide a list of windows that are mapped to the specified viewport."
    (let* ((cur-vp (screen-viewport))
           (col (or vp-col (car cur-vp)))
           (row (or vp-row (cdr cur-vp)))
           (ws (or workspace current-workspace))
           (width (screen-width))
           (height (screen-height))
           (left (+ (- viewport-x-offset) (* col width)))
           (right (+ left (1- width)))
           (top (+ (- viewport-y-offset) (* row height)))
           (bottom (+ top (1- height))))
      (filter-windows (lambda (w)
                        (let ((pos (window-position w))
                              (dims (window-frame-dimensions w)))
                          (and (window-mapped-p w)
                               (not (window-get w 'ignored))
                               (if exclude-sticky
                                   (window-in-workspace-p w ws)
                                 (window-appears-in-workspace-p w ws))
                               (not (and exclude-iconified
                                         (window-get w 'iconified)))
                               (not (or (<= (+ (car pos) (car dims)) left)
                                        (<= (+ (cdr pos) (cdr dims)) top)
                                        (>= (car pos) right)
                                        (>= (cdr pos) bottom)))))))))

  (define (window-on-current-head-viewport-p w)
    (eq (current-head w) (window-head-any-viewport w)))

;;; commands

  (define (activate-viewport x y)
    "Select the specified viewport."
    (set-screen-viewport (1- x) (1- y)))

  (define-command 'activate-viewport activate-viewport
    #:spec "NX:\nNY:"
    #:type `(and (labelled ,(_ "Column:") (number 1))
		 (labelled ,(_ "Row:") (number 1)))
   )

  (define (activate-viewport-column x)
    "Select the specified viewport column."
    (set-screen-viewport (1- x) (cdr (screen-viewport))))

  (define-command 'activate-viewport-column activate-viewport-column
    #:spec "NX:"
    #:type `(and (labelled ,(_ "Column:") (number 1)))
   )

  (define (activate-viewport-row y)
    "Select the specified viewport row."
    (set-screen-viewport (car (screen-viewport)) (1- y)))

  (define-command 'activate-viewport-row activate-viewport-row
    #:spec "NY:"
    #:type `(and (labelled ,(_ "Row:") (number 1)))
   )

  (define (move-window-to-viewport x y)
    "Move the current window to the specified viewport."
    (move-window-viewport (current-event-window) (1- x) (1- y)))

  (define-command 'move-window-to-viewport move-window-to-viewport
    #:spec "NX:\nNY:"
    #:type '(and (labelled "X:" (number 1)) (labelled "Y:" (number 1)))
   )

  (define (move-viewport-right)
    "Move the viewport one screen to the right."
    (move-viewport 1 0))

  (define (move-viewport-left)
    "Move the viewport one screen to the left."
    (move-viewport -1 0))

  (define (move-viewport-down)
    "Move the viewport one screen down."
    (move-viewport 0 1))

  (define (move-viewport-up)
    "Move the viewport one screen up."
    (move-viewport 0 -1))

  ;; Moves the window by the specified offsets and then flips to the
  ;; viewport that is relative those offsets to the current viewport.
  (define (move-window-to-viewport-and-move-viewport window col row)
    (require 'sawfish.wm.util.stacking)
    (let ((sticky-viewport (window-get window 'sticky-viewport)))
      (window-put window 'sticky-viewport t)
      (with-server-grabbed
       (raise-window* window)
       (move-viewport col row)
       (set-input-focus window))
      (unless sticky-viewport
	(window-put window 'sticky-viewport nil))))

  (define (move-window-left w)
    "Move the window to the viewport on the left, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w -1 0))

  (define (move-window-right w)
    "Move the window to the viewport on the right, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w 1 0))

  (define (move-window-down w)
    "Move the window to the viewport below, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w 0 1))

  (define (move-window-up w)
    "Move the window to the viewport above, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w 0 -1))

  (define-command 'move-viewport-right move-viewport-right
   )
  (define-command 'move-viewport-left move-viewport-left
   )
  (define-command 'move-viewport-up move-viewport-up
   )
  (define-command 'move-viewport-down move-viewport-down
   )
  (define-command 'move-window-right move-window-right #:spec "%W"
   )
  (define-command 'move-window-left move-window-left #:spec "%W"
   )
  (define-command 'move-window-up move-window-up #:spec "%W"
   )
  (define-command 'move-window-down move-window-down #:spec "%W"
   )

;;; session management, config

  (define (viewport-saved-state w)
    (let ((position (window-position w)))
      (when (window-get w 'sticky-viewport)
	(rplaca position (mod (car position) (screen-width)))
	(rplacd position (mod (cdr position) (screen-height))))
      `((position . ,(window-absolute-position w))
	(viewport . ,(window-viewport w)))))

  (define (viewport-load-state w alist)
    (let ((position (cdr (assq 'position alist)))
	  (viewport (cdr (assq 'viewport alist))))
      (when position
	(if (or (not viewport) (window-get w 'sticky-viewport))
	    (move-window-to w (car position) (cdr position))
	  (move-window-to w (+ (* (car viewport) (screen-width))
			       (car position)
			       (- viewport-x-offset))
			  (+ (* (cdr viewport) (screen-height))
			     (cdr position)
			     (- viewport-y-offset)))
	  (when (window-outside-workspace-p w)
	    (move-window-to-current-viewport w)))
	(window-put w 'placed t))))

  (sm-add-saved-properties 'sticky-viewport)
  (add-hook 'sm-window-save-functions viewport-saved-state)
  (add-hook 'sm-restore-window-hook viewport-load-state)

  (define (viewport-window-uniconified w)
    (when uniconify-to-current-viewport
      (move-window-to-current-viewport w)))

  (add-hook 'uniconify-window-hook viewport-window-uniconified))

;; compat.jl -- aliases for obsolete functions
;; $Id: compat.jl,v 1.18 2002/04/21 23:11:40 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.compat

    (export show-message
	    ws-copy-window
	    ws-move-window
	    ws-insert-workspace
	    ws-remove-workspace
	    sawmill-directory
	    sawmill-lisp-lib-directory
	    sawmill-site-lisp-directory
	    sawmill-exec-directory
	    sawmill-version
	    custom-set-color
	    custom-set-font
	    custom-set-frame-style)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.workspace)

;;; obsolete functions

  (define (show-message #!optional text font fg bg position)
    (let ((attrs nil))
      (when font
	(setq attrs (cons (cons 'font font) attrs)))
      (when fg
	(setq attrs (cons (cons 'fg fg) attrs)))
      (when bg
	(setq attrs (cons (cons 'bg bg) attrs)))
      (when position
	(setq attrs (cons (cons 'position position) attrs)))
      (display-message text attrs)))

  (define ws-copy-window copy-window-to-workspace)
  (define ws-move-window move-window-to-workspace)
  (define ws-insert-workspace insert-workspace)
  (define ws-remove-workspace remove-workspace)

;;; obsolete variables

  (define sawmill-directory sawfish-directory)
  (define sawmill-lisp-lib-directory sawfish-lisp-lib-directory)
  (define sawmill-site-lisp-directory sawfish-site-lisp-directory)
  (define sawmill-exec-directory sawfish-exec-directory)
  (define sawmill-version sawfish-version)

;;; obsolete commands

  (define (define-commands index)
    (let ((fn (lambda (base)
		(intern (format nil "%s:%d" base (1+ index))))))
      (define-command (fn "select-workspace")
	(lambda () (select-workspace-from-first index))
	#:class 'deprecated)
      (define-command (fn "send-to-workspace")
	(lambda (w) (send-window-to-workspace-from-first w index))
	#:spec "%W"
	#:class 'deprecated)
      (define-command (fn "copy-to-workspace")
	(lambda (w) (send-window-to-workspace-from-first w index t))
	#:spec "%W"
	#:class 'deprecated)))

  (do ((i 0 (1+ i)))
      ((= i 9))
    (define-commands i))

  (define-command 'insert-workspace (command-ref 'insert-workspace-after)
    #:class 'deprecated)

;;; obsolete options

  (mapc (lambda (x)
	  (put x 'custom-obsolete t))
	'(viewport-columns viewport-rows viewport-dimensions
	  preallocated-workspaces iconify-whole-group
	  uniconify-whole-group always-update-frames
	  cycle-disable-auto-raise cycle-show-window-icons
	  cycle-warp-pointer cycle-focus-windows cycle-raise-windows
	  edge-flip-warp-pointer frame-type-fallbacks
	  warp-to-window-x-offset warp-to-window-y-offset
	  uniquify-name-format transients-get-focus decorate-transients
	  raise-windows-on-uniconify uniconify-to-current-workspace
	  uniconify-to-current-viewport iconify-ignored
	  maximize-always-expands maximize-ignore-when-filling
	  maximize-avoid-avoided focus-windows-on-uniconify
	  transients-are-group-members raise-selected-windows
	  warp-to-selected-windows menus-include-shortcuts
	  configure-auto-gravity configure-ignore-stacking-requests
	  beos-window-menu-simplifies customize-show-symbols
	  tooltips-timeout-enabled tooltips-delay
	  tooltips-timeout-delay tooltips-font
	  tooltips-foreground-color tooltips-background-color
	  move-snap-mode move-snap-ignored-windows
	  move-resize-inhibit-configure move-snap-edges
	  raise-windows-when-unshaded persistent-group-ids
	  delete-workspaces-when-empty transients-on-parents-workspace
	  edge-flip-delay audio-for-ignored-windows
	  size-window-def-increment slide-window-increment
	  default-bevel-percent sp-padding nokogiri-user-level
	  nokogiri-buttons workspace-boundary-mode
	  workspace-send-boundary-mode lock-first-workspace
	  ignore-window-input-hint default-window-animator
	  resize-edge-mode move-outline-mode resize-outline-mode
	  move-resize-raise-window workspace-geometry
	  pointer-motion-threshold ignore-program-positions))

;;; obsolete custom setters

  (define (custom-set-color var value #!optional req)
    (custom-set-typed-variable var value 'color req))
  (define (custom-set-font var value #!optional req)
    (custom-set-typed-variable var value 'font req))
  (define (custom-set-frame-style var value #!optional req)
    (custom-set-typed-variable var value 'frame-style req))

  (define-custom-setter 'custom-set-color custom-set-color)
  (define-custom-setter 'custom-set-font custom-set-font)
  (define-custom-setter 'custom-set-frame-style custom-set-frame-style))

;; grow-pack.jl -- window resize and movement
;; $Id: grow-pack.jl,v 1.11 2000/12/22 18:53:12 jsh Exp $
;; Id: grow-pack.jl,v 1.9 2000/08/04 16:42:43 grossjoh Exp 

;; Copyright (C) 2000 Kai Grossjohann <Kai.Grossjohann@CS.Uni-Dortmund.DE>

;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Commentary:

;; This package provides functions to `grow' or `pack' a window in
;; four directions.  `Growing' means to grow the window in the
;; indicated direction until it `bumps into' another window.
;; `Packing' means to move the window in the indicated direction until
;; it `bumps into' another window.

;; Copy this file into a directory which is on your load-path, then
;; use it.  I installed this package by placing the following into my
;; ~/.sawmillrc:
;;
;; (require 'grow-pack)
;; (require 'menus)
;; (setq window-ops-menu
;;       (append window-ops-menu
;;               (list (cons "Grow/pack" grow-pack-menu))))

(define-structure sawfish.wm.commands.grow-pack ()

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.util.rects
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.util.stacking)

  (define-structure-alias grow-pack sawfish.wm.commands.grow-pack)

;;; Code:

  (defcustom grow-window-repeat t
    "Whether growing an already grown window grows it again."
    :type boolean
    :group (min-max maximize))

  (defcustom grow-is-maximize t
    "Whether growing is considered to be maximization.  When you turn
this on, you can use `unmaximize-window' or something similar to get
back to the original size."
    :type boolean
    :group (min-max maximize))

  (defcustom pack-warp-pointer 'maybe
    "Whether and how to move the pointer when packing windows.

`maybe' means that the pointer is moved along with the window, if the
pointer was within the window area before packing.

`always' warps the pointer to the center of the window if it isn't
already in the window, then does like `maybe'.

`never' means not to warp the pointer."
    :type (choice maybe always never)
    :group (move))

  ;; Entry points.

  (defun grow-window-left (w)
    "Grows window to the left until it `bumps into' another window."
    (grow-window w 'left))

  (defun grow-window-right (w)
    "Grows window to the right until it `bumps into' another window."
    (grow-window w 'right))

  (defun grow-window-up (w)
    "Grows window upwards until it `bumps into' another window."
    (grow-window w 'up))

  (defun grow-window-down (w)
    "Grows window downwards until it `bumps into' another window."
    (grow-window w 'down))

  (defun pack-window-left (w)
    "Moves window to the left until it `bumps into' another window."
    (pack-window w 'left))

  (defun pack-window-right (w)
    "Moves window to the right until it `bumps into' another window."
    (pack-window w 'right))

  (defun pack-window-up (w)
    "Moves window upwards until it `bumps into' another window."
    (pack-window w 'up))

  (defun pack-window-down (w)
    "Moves window downwards until it `bumps into' another window."
    (pack-window w 'down))

  ;; Command defs

  ;;###autoload
  (define-command 'grow-window-left grow-window-left #:spec "%W")
  (define-command 'grow-window-right grow-window-right #:spec "%W")
  (define-command 'grow-window-up grow-window-up #:spec "%W")
  (define-command 'grow-window-down grow-window-down #:spec "%W")
  (define-command 'pack-window-left pack-window-left #:spec "%W")
  (define-command 'pack-window-right pack-window-right #:spec "%W")
  (define-command 'pack-window-up pack-window-up #:spec "%W")
  (define-command 'pack-window-down pack-window-down #:spec "%W")

  ;; Convenience variable.

  (defvar grow-pack-menu
    '(("Grow left" grow-window-left)
      ("Grow right" grow-window-right)
      ("Grow up" grow-window-up)
      ("Grow down" grow-window-down)
      ("Pack left" pack-window-left)
      ("Pack right" pack-window-right)
      ("Pack up" pack-window-up)
      ("Pack down" pack-window-down))
    "Menu of grow and pack operations.")

  ;; Implementation part.

  (defun gp-avoid-windows (w direction)
    "Returns list of windows to avoid when growing/filling window W in DIRECTION."
    (let* ((wpos    (window-position w))
	   (wdim    (window-frame-dimensions w))
	   (wleft   (car wpos))
	   (wtop    (cdr wpos))
	   (wright  (+ wleft (car wdim)))
	   (wbottom (+ wtop (cdr wdim)))
	   (nleft   wleft)
	   (ntop    wtop)
	   (nright  wright)
	   (nbottom wbottom))
      (when (eq direction 'left)
	(setq nleft 0)
	(when grow-window-repeat
	  (setq wleft (max (- wleft 1) 0))))
      (when (eq direction 'right)
	(setq nright (screen-width))
	(when grow-window-repeat
	  (setq wright (min (+ wright 1) (screen-width)))))
      (when (eq direction 'up)
	(setq ntop 0)
	(when grow-window-repeat
	  (setq wtop (max (- wtop 1) 0))))
      (when (eq direction 'down)
	(setq nbottom (screen-height))
	(when grow-window-repeat
	  (setq wbottom (min (+ wbottom 1) (screen-height)))))
      (filter-windows
       (lambda (x)
	 (let* ((xpos (window-position x))
		(xdim (window-frame-dimensions x))
		(xleft (car xpos))
		(xtop (cdr xpos))
		(xright (+ xleft (car xdim)))
		(xbottom (+ xtop (cdr xdim))))
	   ;; If window does not overlap W but does overlap the
	   ;; larger W, then we need to avoid this window.
	   (and (window-mapped-p x)
		(not (window-iconified-p x))
		(window-appears-in-workspace-p x current-workspace)
		(<= (rect-2d-overlap* (list xleft xtop xright xbottom)
				      (list wleft wtop wright wbottom)) 0)
		(> (rect-2d-overlap* (list xleft xtop xright xbottom)
				     (list nleft ntop nright nbottom)) 0)))))))

  (defun gp-surrounding-rect (wlist)
    "Returns the rectangle surrounding all given windows."
    (if wlist
	(let* ((w (car wlist))
	       (wrest (cdr wlist))
	       (wpos (window-position w))
	       (wdim (window-frame-dimensions w))
	       (rleft (car wpos))
	       (rtop  (cdr wpos))
	       (rright (+ rleft (car wdim)))
	       (rbottom (+ rtop (cdr wdim))))
	  (mapcar
	   (lambda (x)
	     (let* ((xpos (window-position x))
		    (xdim (window-frame-dimensions x))
		    (xleft (car xpos))
		    (xtop  (cdr xpos))
		    (xright (+ xleft (car xdim)))
		    (xbottom (+ xtop (cdr xdim))))
	       (when (< xleft rleft) (setq rleft xleft))
	       (when (< xtop  rtop) (setq rtop xtop))
	       (when (> xright rright) (setq rright xright))
	       (when (> xbottom rbottom) (setq rbottom xbottom))))
	   wrest)
	  (list rleft rtop rright rbottom))
      (list (screen-width) (screen-height) 0 0)))

  (defun grow-window (w direction)
    "Grows window W in DIRECTION."
    (let* ((avoid-wins (gp-avoid-windows w direction))
	   (surround   (gp-surrounding-rect avoid-wins))
	   (wpos       (window-position w))
	   (wdim       (window-dimensions w))
	   (fdim       (window-frame-dimensions w))
	   (wleft      (car wpos))
	   (wtop       (cdr wpos))
	   (wwidth     (car wdim))
	   (wheight    (cdr wdim))
	   (nwidth     wwidth)
	   (nheight    wheight)
	   (sleft      (nth 0 surround))
	   (stop       (nth 1 surround))
	   (sright     (nth 2 surround))
	   (sbottom    (nth 3 surround)))
      (when (eq direction 'left)
	(setq nwidth (- (+ wleft wwidth) sright)))
      (when (eq direction 'up)
	(setq nheight (- (+ wtop wheight) sbottom)))
      (when (eq direction 'right)
	(setq nwidth (- sleft wleft (- (car fdim) wwidth))))
      (when (eq direction 'down)
	(setq nheight (- stop wtop (- (cdr fdim) wheight))))
      (let
	  ((tem (cons nwidth nheight)))
	(maximize-truncate-dims w tem)	;truncate to column/row increments
	(setq nwidth (car tem))
	(setq nheight (cdr tem)))
      (when (eq direction 'left)
	(setq wleft (- wleft (- nwidth wwidth))))
      (when (eq direction 'up)
	(setq wtop (- wtop (- nheight wheight))))
      (when grow-is-maximize
	(unless (window-get w 'unmaximized-geometry)
	  (window-put w 'unmaximized-geometry (list (car wpos) (cdr wpos)
						    (car wdim) (cdr wdim))))
	(if (memq direction '(left right))
	    (window-put w 'maximized-horizontally t)
	  (window-put w 'maximzed-vertically t)))
      (move-resize-window-to w wleft wtop nwidth nheight)
      (when maximize-raises (raise-window* w))
      (when grow-is-maximize
	(call-window-hook 'window-maximized-hook w
			  (list (if (member direction '(left right))
				    'horizontal 'vertical)))
	(call-window-hook 'window-state-change-hook w (list '(maximized))))))

  (defun pack-window (w direction)
    (let* ((avoid-wins (gp-avoid-windows w direction))
	   (surround   (gp-surrounding-rect avoid-wins))
	   (wpos       (window-position w))
	   (wdim       (window-frame-dimensions w))
	   (wleft      (car wpos))
	   (wtop       (cdr wpos))
	   (wwidth     (car wdim))
	   (wheight    (cdr wdim))
	   (sleft      (nth 0 surround))
	   (stop       (nth 1 surround))
	   (sright     (nth 2 surround))
	   (sbottom    (nth 3 surround))
	   (wpointer   (query-pointer-window))
	   (xpointer   (car (query-pointer)))
	   (ypointer   (cdr (query-pointer)))
	   (xoffset    (- xpointer wleft))
	   (yoffset    (- ypointer wtop)))
      (when (eq direction 'left) (setq wleft sright))
      (when (eq direction 'up) (setq wtop sbottom))
      (when (eq direction 'right) (setq wleft (- sleft wwidth)))
      (when (eq direction 'down) (setq wtop (- stop wheight)))
      (move-window-to w wleft wtop)
      (cond ((eq pack-warp-pointer 'always)
	     (warp-cursor-to-window w))
	    ((eq pack-warp-pointer 'maybe)
	     (when (equal wpointer w)
	       (warp-cursor (+ wleft xoffset) (+ wtop yoffset)))))
      (call-window-hook 'after-move-hook w
			(list (list (if (memq direction '(left right))
					'horizontal 'vertical)))))))

;; hide-dialogs.jl -- only show dialog windows for the focused group
;;
;; Copyright (C) 2001 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; Commentary:

;; Small module to implement the NeXTSTEP feature Robin mentioned.

;; The idea is to minimize dialog windows for all groups but the group
;; containing the currently focused windows.

(define-structure sawfish.wm.ext.hide-dialogs

    (define )

    (open rep
          rep.system
          rep.io.timers
          sawfish.wm.util.groups
          sawfish.wm.state.iconify
          sawfish.wm.state.transient
          sawfish.wm.windows)

  (define (dialogs-in-group w)
    (filter window-transient-p (windows-in-group w)))

  (define (hide-dialogs w)
    (let ((iconify-group-mode nil))
      (mapc iconify-window (dialogs-in-group w))))

  (define (show-dialogs w)
    (let ((focus-windows-on-uniconify nil)
	  (raise-windows-on-uniconify nil)
	  (uniconify-to-current-workspace nil)
	  (uniconify-group-mode nil))
      (mapc uniconify-window (dialogs-in-group w))))

  (define (focus-in-group w)
    (and (input-focus)
	 (memq (input-focus) (windows-in-group w))))

  (define (focus-in w mode)
    (when (eq mode 'normal)
      (show-dialogs w)))

  (define (focus-out w mode)
    (when (eq mode 'normal)
      (make-timer (lambda ()
		    (unless (focus-in-group w)
		      (hide-dialogs w)))
		  0 100)))

  (add-hook 'focus-in-hook focus-in)
  (add-hook 'focus-out-hook focus-out))

;; top-left.jl -- place windows on the diagonal from the top-left corner
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; Commentary:

;; The idea here is that there's a fixed number of possible placement
;; positions on a diagonal from the top-left corner, each successive
;; spot is slightly below and to the right of the previous spot.

;; The placement algorithm searches these spots for the first one that
;; doesn't have the top-left corner of a window in its immediate
;; vicinity. If placing the window on the first found spot would push
;; the window off the right or bottom of the screen, then resize the
;; window to avoid this happening.

;; If no spot can be found to accomodate the window's minimum allowed
;; size, then fallback to placing the window randomly.

;; (note, for `screen' above, I actually mean the work-area, i.e. the
;; area not reserved for special windows, e.g. the panel)

(define-structure sawfish.wm.placement.top-left

    (export )

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.placement
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.util.workarea
	  sawfish.wm.state.iconify)

  (define top-left '(8 . 8))
  (define fuzz '(8 . 16))
  (define step '(16 . 32))

  (define resize-windows nil)

  (define (round-up x mult) (* (quotient (+ x (1- mult)) mult) mult))

  (define (next-position point)
    (cons (+ (car point) (car step))
	  (+ (cdr point) (cdr step))))

  (define (windows-around point)
    (filter-windows
     (lambda (w)
       (and (window-get w 'placed)
	    (window-in-workspace-p w current-workspace)
	    (not (window-outside-viewport-p w))
	    (window-mapped-p w)
	    (not (window-iconified-p w))
	    (let ((w-point (window-position w)))
	      (and (< (abs (- (car w-point) (car point))) (car fuzz))
		   (< (abs (- (cdr w-point) (cdr point))) (cdr fuzz))))))))

  (define (next-free-position point boundary)
    (let loop ((point point))
      (cond ((or (>= (car point) (car boundary))
		 (>= (cdr point) (cdr boundary)))
	     nil)
	    ((null (windows-around point))
	     point)
	    (t (loop (next-position point))))))

  (define (place-window-top-left w)
    (let* ((workarea (calculate-workarea #:window w #:head (current-head)))
	   (dims (window-dimensions w))
	   (f-dims (window-frame-dimensions w))
	   (hints (window-size-hints w))

	   (min-dims (if resize-windows
			 (cons (or (cdr (or (assq 'min-width hints)
					    (assq 'base-width hints))) 1)
			       (or (cdr (or (assq 'min-height hints)
					    (assq 'base-height hints))) 1))
		       dims))

	   (first (cons (max (round-up (nth 0 workarea) (car step))
			     (car top-left))
			(max (round-up (nth 1 workarea) (cdr step))
			     (cdr top-left))))

	   (boundary (cons (- (nth 2 workarea) (car min-dims)
			      (- (car f-dims) (car dims)))
			   (- (nth 3 workarea) (cdr min-dims)
			      (- (cdr f-dims) (cdr dims))))))

      (let ((point (next-free-position first boundary)))
	(if point
	    (progn
	      (move-window-to w (car point) (cdr point))
	      (let ((changed nil))
		(when (>= (+ (car point) (car f-dims)) (nth 2 workarea))
		  (rplaca dims (- (nth 2 workarea) (car point)
				  (- (car f-dims) (car dims))))
		  (setq changed t))
		(when (>= (+ (cdr point) (cdr f-dims)) (nth 3 workarea))
		  (rplacd dims (- (nth 3 workarea) (cdr point)
				  (- (cdr f-dims) (cdr dims))))
		  (setq changed t))
		(when changed
		  (resize-window-with-hints* w (car dims) (cdr dims)))))
	  ;; fall back to random placement
	  ((placement-mode 'randomly) w)))))

  ;;###autoload
  (define-placement-mode 'top-left place-window-top-left #:for-normal t))

;; compton.jl -- compton integration

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.


(define-structure sawfish.wm.prg.compton

    (export window-opacity start-compton stop-compton)

    (open rep
          rep.system
          rep.io.processes
          rep.io.timers
          rep.util.misc
	  rep.regexp
          sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.windows
          sawfish.wm.state.maximize
          sawfish.wm.ext.match-window)

  (define-structure-alias compton sawfish.wm.prg.compton)

  (define %compton-proc nil)
  (define switch-opacity nil)
  (define update-opacity nil)
  (define stop-compton nil)
  (define timer-load-compton nil)

  (defgroup window-effects "Window Effects"
    :group appearance)

  (if (not (program-exists-p "compton"))
      (defcustom opacity-introduction nil
        "!!! Install compton and restart sawfish to use transparency in sawfish. !!!"
        :type (label " ")
        :group (appearance window-effects))

    (defcustom opacity-enable nil "Enable opacity."
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom shadows-enable t "Enabled client-side shadows on windows."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom shadows-main-win nil "Only draw shadows on normal windows and dialogs."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom shadows-disable-shaped t "Don't draw shadows on shaped windows."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom shadows-disable-dad nil "Don't draw shadows on drag-and-drop windows."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom shadows-disable-menu nil "Don't draw shadows on menus."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom force-tabbed t "Force shadows by tabbed windows."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom shadows-crop-maximized nil "Crop shadows by maximized Windows (xinerama support)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom top-offset -15 "The top offset for shadows (Default -15)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (25 20 15 10 5 0 -05 -10 -15 -20 -25 -30 -35 -40 -45 -50)
      :after-set (lambda () (switch-opacity)))

    (defcustom left-offset -15 "The left offset for shadows (Default -15)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (25 20 15 10 5 0 -05 -10 -15 -20 -25 -30 -35 -40 -45 -50)
      :after-set (lambda () (switch-opacity)))

    (defcustom translucency 60 "The translucency for shadows (Default 80)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (10 20 30 40 50 60 70 80 90 100)
      :after-set (lambda () (switch-opacity)))

    (defcustom blur-radius 12 "The blur radius for shadows (Default 12)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24)
      :after-set (lambda () (switch-opacity)))

    (defcustom shadow-red 0 "Red color value of shadow (Default 0)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (0 1 2 3 4 5 6 7 8 9 10)
      :after-set (lambda () (switch-opacity)))

    (defcustom shadow-green 0 "Green color value of shadow (Default 0)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (0 1 2 3 4 5 6 7 8 9 10)
      :after-set (lambda () (switch-opacity)))

    (defcustom shadow-blue 0 "Blue color value of shadow (Default 0)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (0 1 2 3 4 5 6 7 8 9 10)
      :after-set (lambda () (switch-opacity)))

    (defcustom avoid-shadows t "Avoid drawing shadows on dock/panel windows."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom fade-enable t "Fade windows in/out when opening/closing and when opacity changes."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom fade-in 28 "Opacity change between steps while fading in (Default 28)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (1 7 14 21 28 35 42 49 56)
      :after-set (lambda () (switch-opacity)))

    (defcustom fade-out 28 "Opacity change between steps while fading out (Default 28)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (1 7 14 21 28 35 42 49 56)
      :after-set (lambda () (switch-opacity)))

    (defcustom fade-time 10 "The time between steps in a fade in milliseconds (Default 10)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (0 2 4 6 8 10 12 14 16 18 20 25 30 35 40 45 50)
      :after-set (lambda () (switch-opacity)))

    (defcustom zero-mask t "Zero the part of the shadow's mask behind the window (experimental)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type boolean
      :after-set (lambda () (switch-opacity)))

    (defcustom menu-opacity 10 "The opacity for menus (Default 10)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type symbol
      :options (5 6 7 8 9 10)
      :after-set (lambda () (switch-opacity)))

    (defcustom opacity-by-move 75 "Opacity by move (Default 75)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 75 1))

    (defcustom opacity-by-resize 75 "Opacity by resize (Default 75)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 75 1))

    (defcustom opacity-normal-i 90 "Opacity normal windows inactive (Default 90)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 90 1)
      :after-set (lambda () (update-opacity 'normal)))

    (defcustom opacity-dialog-i 85 "Opacity dialog windows inactive (Default 85)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 85 1)
      :after-set (lambda () (update-opacity 'dialog)))

    (defcustom opacity-tabbed-i 95 "Opacity tabbed windows inactive (Default 95)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 95 1)
      :after-set (lambda () (update-opacity 'tabbed)))

    (defcustom opacity-desktop-i 75 "Opacity desktop windows inactive (Default 75)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 75 1)
      :after-set (lambda () (update-opacity 'desktop)))

    (defcustom opacity-dock-a 100 "Opacity dock windows active (Default 100)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 50 100 100 1)
      :after-set (lambda () (update-opacity 'dock)))

    (defcustom opacity-dock-i 80 "Opacity dock windows inactive (Default 80)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 80 1)
      :after-set (lambda () (update-opacity 'dock)))

    (defcustom opacity-notify-i 85 "Opacity notify (Default 85)."
      :depends opacity-enable
      :group (appearance window-effects)
      :type (number 0 100 85 1)
      :after-set (lambda () (update-opacity 'notify)))

    (defcustom compton-extra-args "" "Extra arguments to compton."
      :depends opacity-enable
      :group (appearance window-effects)
      :type string)

    ;; windows custom-settings entry
    (define-match-window-property 'opacity 'appearance '(number 0 100 100))
    (define-match-window-property 'no-shadows 'appearance 'boolean)

    ;; info: compton crash with empty values 
    (define (shadows) (if shadows-enable '-c '-e1))
    (define (fade) (if fade-enable '-f '-e1))
    (define (avoid) (if avoid-shadows '-C '-e1))
    (define (zero) (if zero-mask '-z '-e1))
    (define (dad) (if shadows-disable-dad '-G '-e1))
    (define (smenu) (if shadows-disable-menu (concat "window_type *= 'menu'") (concat "window_type *= 'nil'")))

    (define (trans) (/ (+ 0.00 translucency) 100))
    (define (fade-i) (/ (+ 0.00 fade-in) 1000))
    (define (fade-o) (/ (+ 0.00 fade-out) 1000))
    (define (menu-o) (/ (+ 0.00 menu-opacity) 10))
    (define (red) (/ (+ 0.00 shadow-red) 10))
    (define (green) (/ (+ 0.00 shadow-green) 10))
    (define (blue) (/ (+ 0.00 shadow-blue) 10))

    (define (start-compton #!key
                           (c-shadows (shadows))
                           (c-fade (fade))
                           (c-avoid (avoid))
                           (c-zero (zero))
                           (c-smenu (smenu))
                           (c-dad (dad))
                           (c-trans (trans))
                           (c-fade-i (fade-i))
                           (c-fade-o (fade-o))
                           (c-menu-o (menu-o))
                           (c-red (red))
                           (c-green (green))
                           (c-blue (blue)))
      "Start compton. If a compton process already exists, it's being killed."
      (when (program-exists-p "compton")
        (stop-compton)
        (setq %compton-proc (make-process))
        (apply start-process %compton-proc "compton" (format nil "%s" c-shadows) (format nil "%s" c-fade) (format nil "%s" c-avoid) (format nil "%s" c-zero)
                       "-r" (number->string blur-radius) "-o" (format nil "%s" c-trans) "-l" (number->string left-offset)
                       "-t" (number->string top-offset) "-I" (format nil "%s" c-fade-i) "-O" (format nil "%s" c-fade-o) "-D" (number->string fade-time)
                       "-m" (format nil "%s" c-menu-o) "--shadow-red" (format nil "%s" c-red) "--shadow-green" (format nil "%s" c-green)
                       "--shadow-blue" (format nil "%s" c-blue) (format nil "%s" c-dad) "--detect-rounded-corners" "--shadow-exclude" (concat c-smenu)
		       "--shadow-exclude" "_COMPTON_SHADOW:32c = 0"
		       (unless (= (length compton-extra-args) 0) (string-split "\\s+" compton-extra-args)))))

    (define (stop-compton)
      "Stop compton, if running."
      (when %compton-proc (kill-process %compton-proc)
            (setq %compton-proc nil)))

    ;;0xffffffff opacity 0%
    ;;4294967294.00 opacity 0%
    ;;0x00000000 opacity 100%
    (define (get-opacity w)
      (* (/ 4294967294.00 100) w))

    (define (get-type w)
      (if (get-x-property w '_NET_WM_WINDOW_TYPE)
          (aref (nth 2 (get-x-property w '_NET_WM_WINDOW_TYPE)) 0)))

    (define (window-shadow w)
      "Set _COMPTON_SHADOW to exclude shadow for window w"
      (if (or (and (window-get w 'tabbed)
                   (not force-tabbed))
              (and (window-get w 'shaded)
                   shadows-disable-shaped)
              (and (not shadows-enable))
              (window-get w 'no-shadows)
              (and shadows-crop-maximized
                   (window-maximized-vertically-p w)
                   (window-maximized-horizontally-p w))
              (and (if shadows-main-win
                       (and (not (eq (get-type w) '_NET_WM_WINDOW_TYPE_DIALOG))
                            (not (eq (get-type w) '_NET_WM_WINDOW_TYPE_NORMAL))))))
          (set-x-property (window-frame-id w) '_COMPTON_SHADOW (make-vector 1 0) 'CARDINAL 32)
        (delete-x-property (window-frame-id w) '_COMPTON_SHADOW))
      (sync-server))

    (define (dim-window w opacity)
      "Set _NET_WM_WINDOW_OPACITY to opacity for window w"
      (window-shadow w)
      (if (eq opacity '0)
          (delete-x-property (window-frame-id w) '_NET_WM_WINDOW_OPACITY)
        (set-x-property (window-frame-id w) '_NET_WM_WINDOW_OPACITY (make-vector 1 opacity) 'CARDINAL 32))
      (sync-server))

    (define (window-opacity w)
      (if (window-get w 'opacity)
          (if (eq (input-focus) w)
              (dim-window w (get-opacity '100))
            (dim-window w (get-opacity (window-get w 'opacity))))
        (if (window-get w 'tabbed)
            (if (eq (input-focus) w)
                (dim-window w (get-opacity '100))
              (dim-window w (get-opacity opacity-tabbed-i)))
          (let ((type-is (get-type w)))
            (if (or (eq type-is '_NET_WM_WINDOW_TYPE_DIALOG)
                    (eq type-is '_NET_WM_WINDOW_TYPE_NOTIFY)
                    (eq type-is '_NET_WM_WINDOW_TYPE_DOCK)
                    (eq type-is '_NET_WM_WINDOW_TYPE_DESKTOP))
                (progn
                  (if (eq type-is '_NET_WM_WINDOW_TYPE_DIALOG)
                      (if (eq (input-focus) w)
                          (dim-window w (get-opacity '100))
                        (dim-window w (get-opacity opacity-dialog-i))))
                  (if (eq type-is '_NET_WM_WINDOW_TYPE_NOTIFY)
                      (if (eq (input-focus) w)
                          (dim-window w (get-opacity opacity-notify-i))
                        (dim-window w (get-opacity opacity-notify-i))))
                  (if (eq type-is '_NET_WM_WINDOW_TYPE_DOCK)
                      (if (eq (input-focus) w)
                          (dim-window w (get-opacity opacity-dock-a))
                        (dim-window w (get-opacity opacity-dock-i))))
                  (if (eq type-is '_NET_WM_WINDOW_TYPE_DESKTOP)
                      (if (eq (input-focus) w)
                          (dim-window w (get-opacity '100))
                        (dim-window w (get-opacity opacity-desktop-i)))))
              (if (eq (input-focus) w)
                  (dim-window w (get-opacity '100))
                (dim-window w (get-opacity opacity-normal-i))))))))

    (define (update-opacity type)
      (map-windows (lambda (w)
                     (let ((type-is (get-type w)))
                       (if (or (and (window-get w 'tabbed)
                                    (eq type 'tabbed))
                               (and (eq type-is '_NET_WM_WINDOW_TYPE_DIALOG)
                                    (eq type 'dialog))
                               (and (eq type-is '_NET_WM_WINDOW_TYPE_NOTIFY)
                                    (eq type 'notify))
                               (and (eq type-is '_NET_WM_WINDOW_TYPE_DOCK)
                                    (eq type 'dock))
                               (and (eq type-is '_NET_WM_WINDOW_TYPE_DESKTOP)
                                    (eq type 'desktop))
                               (and (not (window-get w 'tabbed))
                                    (not (eq type-is '_NET_WM_WINDOW_TYPE_DIALOG))
                                    (not (eq type-is '_NET_WM_WINDOW_TYPE_NOTIFY))
                                    (not (eq type-is '_NET_WM_WINDOW_TYPE_DOCK))
                                    (not (eq type-is '_NET_WM_WINDOW_TYPE_DESKTOP))
                                    (eq type 'normal)))
                           (window-opacity w))))))

    (define (switch-opacity)
      (when (not timer-load-compton)
        (if opacity-enable
            (start-compton)
          (stop-compton))
        (map-windows (lambda (w)
                       (if opacity-enable
                           (window-opacity w)
                         (dim-window w (get-opacity '100)))))))

    (define (max-window w)
      (if shadows-crop-maximized
          (window-shadow w)))

    (define (before-move w)
      (dim-window w (get-opacity opacity-by-move)))

    (define (before-resize w)
      (dim-window w (get-opacity opacity-by-resize)))
    
    (define (tab-release w)
      (if (and (car w)
               (not (cdr w)))
          (if opacity-enable
              (window-opacity (car w))
            (dim-window (car w) (get-opacity '100)))))

    (define (timer-compton-load)
      (setq timer-load-compton
            (make-timer (lambda ()
                          (setq timer-load-compton nil)
                          (switch-opacity))
                        (quotient 3000 1000) (mod 3000 1000))))

    (unless batch-mode
      (timer-compton-load)

      (add-hook 'window-maximized-hook (lambda (w) (if opacity-enable (max-window w))))
      (add-hook 'window-unmaximized-hook (lambda (w) (if opacity-enable (max-window w))))
      (add-hook 'tab-group-windows-hook (lambda (w) (if opacity-enable (tab-release w))))
      (add-hook 'after-add-window-hook (lambda (w) (if opacity-enable (window-opacity w))))
      (add-hook 'shade-window-hook (lambda (w) (if opacity-enable (window-opacity w))))
      (add-hook 'focus-in-hook (lambda (w) (if opacity-enable (window-opacity w))))
      (add-hook 'focus-out-hook (lambda (w) (if opacity-enable (window-opacity w))))
      (add-hook 'before-move-hook (lambda (w) (if opacity-enable (before-move w))))
      (add-hook 'after-move-hook (lambda (w) (if opacity-enable (window-opacity w))))
      (add-hook 'before-resize-hook (lambda (w) (if opacity-enable (before-resize w))))
      (add-hook 'after-resize-hook (lambda (w) (if opacity-enable (window-opacity w))))
      (add-hook 'after-initialization-hook switch-opacity)
      (add-hook 'before-exit-hook stop-compton))))

;; StyleTab

(define theme-name 'StyleTab)

;;need hash tables for icon cache 
;;
(require 'rep.data.tables)

;; Defcustom and defgroup
(defgroup StyleTab:group "StyleTab"
  :group appearance)

(defgroup StyleTab:settings-group "Settings"
  :group (appearance StyleTab:group))

(defgroup StyleTab:buttons-group "buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:top-buttons-group "Top Titlebar Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group))

(defgroup StyleTab:bottom-buttons-group "Bottom Titlebar Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group))

(defgroup StyleTab:left-buttons-group "Left Titlebar Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group))

(defgroup StyleTab:right-buttons-group "Right Titlebar Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group))

(defgroup StyleTab:top-left-buttons-group "Top Titlebar Left Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:top-buttons-group))

(defgroup StyleTab:top-right-buttons-group "Top Titlebar Right Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:top-buttons-group))

(defgroup StyleTab:bottom-left-buttons-group "Bottom Titlebar Left Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:bottom-buttons-group))

(defgroup StyleTab:bottom-right-buttons-group "Bottom Titlebar Right Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:bottom-buttons-group))

(defgroup StyleTab:left-top-buttons-group "Left Titlebar Top Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:left-buttons-group))

(defgroup StyleTab:left-bottom-buttons-group "Left Titlebar Bottom Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:left-buttons-group))

(defgroup StyleTab:right-top-buttons-group "Right Titlebar Top Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:right-buttons-group))

(defgroup StyleTab:right-bottom-buttons-group "Right Titlebar Bottom Buttons"
  :group (appearance StyleTab:group StyleTab:buttons-group StyleTab:right-buttons-group))

(defcustom styletab:style 'Dark "Frame and button style."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :options (Reduce Dark DarkColor Silver SilverColor Smoothly)
  :type symbol)

(defcustom styletab:titlebar-place 'top "Titlebar default place."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :options (top bottom left right)
  :type symbol)

(defcustom styletab:title-dimension 24 "Height of title border. Default 24"
  :group (appearance StyleTab:group StyleTab:settings-group)
  :type number
  :range (16 . 32))

(defcustom styletab:borders-dimension 4 "Width of window border. Default 4"
  :group (appearance StyleTab:group StyleTab:settings-group)
  :type number
  :range (0 . 10))

(defcustom styletab:custom-button-width nil "Customize buttons width. (Don't use styles defaults.)"
  :group (appearance StyleTab:group StyleTab:settings-group)
  :type boolean)

(defcustom styletab:button-width 0 "Width of Buttons. Default 0"
  :group (appearance StyleTab:group StyleTab:settings-group)
  :type number
  :depends styletab:custom-button-width
  :range (-4 . 4))

(defcustom styletab:title-font default-font
  "Tabbar font."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :type font)

(defcustom styletab:custom-colors nil "Customize title text colors. (Don't use styles defaults.)"
  :group (appearance StyleTab:group StyleTab:settings-group)
  :type boolean)

(defcustom styletab:focused-color "#E5E5E5"
  "Focused title text color."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :depends styletab:custom-colors
  :type color)

(defcustom styletab:highlighted-color "#FDFDFD"
  "Highlighted title text color."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :depends styletab:custom-colors
  :type color)

(defcustom styletab:inactive-color "#B1B1B1"
  "Inactive title text color."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :depends styletab:custom-colors
  :type color)

(defcustom styletab:inactive-highlighted-color "#CBCBCB"
  "Inactive Highlighted title text color."
  :group (appearance StyleTab:group StyleTab:settings-group)
  :depends styletab:custom-colors
  :type color)

(mapc
 (lambda (arg)
   (let ((type-list ;; ":type" in defcustom
          (append '(v-and)
                  (make-list 10
			     ;; Here, `list' is necessary. If you
			     ;; replace it with a quote, the configurator
			     ;; crashes.
                             (list 'v-and '(choice \(none\) close menu maximize minimize shade sticky space send-to-prev 
                                                   send-to-next lock raise-lower move-resize rename frame-type)
                                   '(boolean "Also show in transients"))))))
     (eval
      (macroexpand
       `(defcustom ,(car arg) ;; name
          ,(cadr arg) ;; default value
          ,(caddr arg) ;; doc
          :group
         ,`(appearance StyleTab:group StyleTab:buttons-group
                       ,(cadddr arg) ,(car (cddddr arg)))
         :type ,type-list
         ))))) ;; end of lambda
 '( ;; list to pass to mapc
   (styletab:top-left-buttons
    '((menu t) (frame-type t) (sticky nil) (shade nil) (space nil)
      (raise-lower nil) (lock nil) (move-resize nil))
    "Top Titlebar Left Buttons (from left to right)"
    StyleTab:top-buttons-group StyleTab:top-left-buttons-group)
   (styletab:top-right-buttons
    '((close t) (maximize t) (minimize nil) (space nil)
      (send-to-next nil) (send-to-prev nil))
    "Top Titlebar Right Buttons (from right to left)"
    StyleTab:top-buttons-group StyleTab:top-right-buttons-group)
   (styletab:bottom-left-buttons
    '((menu t) (frame-type t) (sticky nil) (shade nil) (space nil)
      (raise-lower nil) (lock nil) (move-resize nil))
    "Bottom Titlebar Left Buttons (from left to right)"
    StyleTab:bottom-buttons-group StyleTab:bottom-left-buttons-group)
   (styletab:bottom-right-buttons
    '((close t) (maximize t) (minimize nil) (space nil)
      (send-to-next nil) (send-to-prev nil))
    "Bottom Titlebar Right Buttons (from right to left)"
    StyleTab:bottom-buttons-group StyleTab:bottom-right-buttons-group)
   (styletab:left-top-buttons
    '((close t) (maximize t) (minimize t) (sticky nil) (lock nil))
    "Left Titlebar Top Buttons (from top to bottom)"
    StyleTab:left-buttons-group StyleTab:left-top-buttons-group)
   (styletab:left-bottom-buttons
    '((menu t) (frame-type t))
    "Left Titlebar Bottom Buttons (from bottom to top)"
    StyleTab:left-buttons-group StyleTab:left-bottom-buttons-group)
   (styletab:right-top-buttons
    '((close t) (maximize t) (minimize t) (sticky nil) (lock nil))
    "Right Titlebar Top Buttons (from top to bottom)"
    StyleTab:right-buttons-group StyleTab:right-top-buttons-group)
   (styletab:right-bottom-buttons
    '((menu t) (frame-type t))
    "Right Titlebar Bottom Buttons (from bottom to top)"
    StyleTab:right-buttons-group StyleTab:right-bottom-buttons-group)
   ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; styles settings 

;;(define styletab-style styletab:style)

(define title-colors-images
  (lambda ()
    (if (eq styletab:custom-colors t)
        (title-colors-custom)
      (case styletab:style
            ((Reduce) (title-colors-reduce))
            ((Dark) (title-colors-dark))
            ((DarkColor) (title-colors-dark))
            ((Silver) (title-colors-silver))
            ((SilverColor) (title-colors-silver))
            ((Smoothly) (title-colors-smoothly))))))

(define title-colors-custom
  (lambda ()
    `((focused . ,styletab:focused-color) (highlighted . ,styletab:highlighted-color) (clicked . ,styletab:highlighted-color) 
      (inactive . ,styletab:inactive-color) (inactive-highlighted . ,styletab:inactive-highlighted-color) 
      (inactive-clicked . ,styletab:inactive-highlighted-color))))

(define title-colors-reduce
  (lambda ()
    `((focused . "#E5E5E5") (highlighted . "#FDFDFD") (clicked . "#FDFDFD") (inactive . "#B1B1B1") (inactive-highlighted . "#CBCBCB")
      (inactive-clicked . "#CBCBCB"))))

(define title-colors-dark
  (lambda ()
    `((focused . "#F2F2F2") (highlighted . "#FEFEFE") (clicked . "#FEFEFE") (inactive . "#CBCBCB") (inactive-highlighted . "#D8D8D8")
      (inactive-clicked . "#D8D8D8"))))

(define title-colors-smoothly
  (lambda ()
    `((focused . "#000000") (highlighted . "#333333") (clicked . "#333333") (inactive . "#666666") (inactive-highlighted . "#777777")
      (inactive-clicked . "#777777"))))

(define title-colors-silver
  (lambda ()
    `((focused . "#000000") (highlighted . "#333333") (clicked . "#333333") (inactive . "#4C4C4C") (inactive-highlighted . "#666666")
      (inactive-clicked . "#666666"))))


(define button-width-custom
  (lambda ()
    (if (eq styletab:custom-button-width t)
        (button-width-set)
      (case styletab:style
            ((Reduce) (button-width-reduce))
            ((Dark) (button-width-dark))
            ((DarkColor) (button-width-dark))
            ((Silver) (button-width-silver))
            ((SilverColor) (button-width-silver))
            ((Smoothly) (button-width-smoothly))))))

(define button-width-add
  (lambda ()
    (if (eq styletab:custom-button-width nil)
        (button-width-zero)
      (case styletab:style
            ((Reduce) (button-width-reduce))
            ((Dark) (button-width-dark))
            ((DarkColor) (button-width-dark))
            ((Silver) (button-width-silver))
            ((SilverColor) (button-width-silver))
            ((Smoothly) (button-width-smoothly))))))

(define button-width-set (lambda () (+ styletab:button-width (button-width-add))))
(define button-width-zero (lambda () 0))
(define button-width-reduce (lambda () 0))
(define button-width-dark (lambda () 8))
(define button-width-silver (lambda () -4))
(define button-width-smoothly (lambda () 0))

(define tabbar-right-edge-width
  (lambda ()
    (case styletab:style
          ((Reduce) 6)
          ((Dark) 3)
          ((DarkColor) 3)
          ((Silver) 3)
          ((SilverColor) 3)
          ((Smoothly) 3))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; frame-class, keys bindings

(define (rotate-tab src dest)
  (let ((w (current-event-window))
        (wins (tab-group-window-index (current-event-window)))
        pos-x pos-y fdim framew framehigh dim-x dim-y current-title type)
    (if (not (window-get w 'title-position))
        (case styletab:titlebar-place
              ((top) (setq current-title 'top))
              ((bottom) (setq current-title 'bottom))
              ((left) (setq current-title 'left))
              ((right) (setq current-title 'right)))
      (setq current-title (window-get w 'title-position)))
    (setq type (window-get w 'type))
    (setq pos-x (car (window-position w)))
    (setq pos-y (cdr (window-position w)))
    (setq dim-x (car (window-dimensions w)))
    (setq dim-y (cdr (window-dimensions w)))
    (setq fdim (window-frame-dimensions w))
    (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ dim-x dim-y styletab:title-dimension)) 3))

    (when (not (eq type 'unframed))
      (if (window-get w 'shaded) (unshade-window w))
      (if (eq src 'horiz)
          (if (eq dest 'opposite)
              (progn
                (if (eq current-title 'top)
                    (setq dest 'bottom)
                  (setq dest 'top))
                (when (>= (+ pos-y dim-y styletab:title-dimension framew) (screen-height))
                  (setq pos-y (- (screen-height) dim-y styletab:title-dimension framew)))
                (when (<= pos-y 0) (setq pos-y 0)))
            ;; To left or right
            (if (or (eq (window-get w 'type) 'default)
                    (eq (window-get w 'type) 'transient))
                (setq framehigh (+ (- styletab:title-dimension (* styletab:borders-dimension 2)) framew))
              (setq framehigh (+ styletab:title-dimension framew)))
            (setq dim-x (- dim-x framehigh))
            (setq dim-y (+ dim-y framehigh))
            (when (and (eq dest 'left) (<= pos-x 0))
              (setq pos-x 0))
            (when (and (eq dest 'right)
                       (>= (+ pos-x dim-x framehigh framew framew) (screen-width)))
              (setq pos-x (- (screen-width) dim-x styletab:title-dimension framew))))
        ;; vert
        (if (eq dest 'opposite)
            (progn
              (if (eq current-title 'left)
                  (progn
                    (setq dest 'right)
                    (when (>= (+ pos-x dim-x) (screen-width))
                      (setq pos-x (- (screen-width) dim-x styletab:title-dimension framew))))
                (setq dest 'left)
                (when (<= pos-x 0) (setq pos-x 0))))
          ;; To top or bottom
          (if (or (eq (window-get w 'type) 'default)
                  (eq (window-get w 'type) 'transient))
              (setq framehigh (- styletab:title-dimension (* styletab:borders-dimension 2)))
            (setq framehigh styletab:title-dimension))
          (setq dim-x (+ dim-x framehigh framew))
          (setq dim-y (- dim-y framehigh framew))
          (when (>= (+ pos-y dim-y styletab:title-dimension framew) (screen-height))
            (setq pos-y (- (screen-height) dim-y styletab:title-dimension framew)))
          (when (<= pos-y 0) (setq pos-y 0))))

      (mapcar (lambda (w)
                (window-put w 'title-position dest)) wins)
      (call-window-hook 'window-state-change-hook w (list '(title-position)))
      (mapcar (lambda (w)
                (reframe-window w)
                (move-window-to w pos-x pos-y)
                (resize-window-to w dim-x dim-y)) wins))))

(define (tabbartotop)
  "Move tab-bar to top."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'left)
            (eq (window-get w 'title-position) 'right))
        (rotate-tab 'vert 'top))
    (if (eq (window-get w 'title-position) 'bottom)
        (rotate-tab 'horiz 'opposite))))

(define (tabbartobottom)
  "Move tab-bar to bottom."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'left)
            (eq (window-get w 'title-position) 'right))
        (rotate-tab 'vert 'bottom))
    (if (eq (window-get w 'title-position) 'top)
        (rotate-tab 'horiz 'opposite))))

(define (tabbartoleft)
  "Move tab-bar to left."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'left))
    (if (eq (window-get w 'title-position) 'right)
        (rotate-tab 'vert 'opposite))))

(define (tabbartoright)
  "Move tab-bar to right."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'right))
    (if (eq (window-get w 'title-position) 'left)
        (rotate-tab 'vert 'opposite))))

(define (tabbartoggle)
  " Move tab-bar to the opposite side. (Swap top & bottom, or left & right)"
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'opposite)
      (rotate-tab 'vert 'opposite))))

(define-command-gaol 'tabbar-toggle tabbartoggle)
(define-command-gaol 'tabbar-to-top tabbartotop)
(define-command-gaol 'tabbar-to-bottom tabbartobottom)
(define-command-gaol 'tabbar-to-left tabbartoleft)
(define-command-gaol 'tabbar-to-right tabbartoright)

(def-frame-class tabbar-horizontal-left-edge ()
  (bind-keys tabbar-horizontal-left-edge-keymap
             "Button1-Off" 'tabbar-to-left
             "Button2-Off" 'tabbar-toggle
             "Button3-Off" 'tabbar-to-right))

(def-frame-class tabbar-vertical-top-edge ()
  (bind-keys tabbar-vertical-top-edge-keymap
             "Button1-Off" 'tabbar-to-top
             "Button2-Off" 'tabbar-toggle
             "Button3-Off" 'tabbar-to-bottom))


(define (f-type dest)
  (let ((w (current-event-window))
        (wins (tab-group-window-index (current-event-window)))
        pos-x pos-y dim-x dim-y cur new current-title)
    (if (not (window-get w 'title-position))
        (case styletab:titlebar-place
              ((top) (setq current-title 'top))
              ((bottom) (setq current-title 'bottom))
              ((left) (setq current-title 'left))
              ((right) (setq current-title 'right)))
      (setq current-title (window-get w 'title-position)))
    (setq pos-x (car (window-position w)))
    (setq pos-y (cdr (window-position w)))
    (setq dim-x (car (window-dimensions w)))
    (setq dim-y (cdr (window-dimensions w)))
    (setq cur (window-get w 'type))
    (if (window-get w 'shaded) (unshade-window w))

    (when (eq dest 'def-tra)
      (if (eq cur 'default)
          (setq new 'transient)
        (setq new 'default))
      (when (or (eq cur 'shaped)
                (eq cur 'utility))
        (setq new 'default)
        (setq dim-x (- dim-x (* styletab:borders-dimension 2)))
        (setq dim-y (- dim-y styletab:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (+ dim-x styletab:borders-dimension))
          (setq dim-y (- dim-y styletab:borders-dimension))))
      (when (eq cur 'shaped-transient)
        (setq new 'transient)
        (setq dim-x (- dim-x (* styletab:borders-dimension 2)))
        (setq dim-y (- dim-y styletab:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (+ dim-x styletab:borders-dimension))
          (setq dim-y (- dim-y styletab:borders-dimension))))
      (when (eq cur 'unframed)
        (setq new 'default)
        (when (or (eq current-title 'top)
                  (eq current-title 'bottom))
          (setq dim-x (- dim-x (* styletab:borders-dimension 2)))
          (setq dim-y (- dim-y styletab:borders-dimension styletab:title-dimension)))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-y (- dim-y (* styletab:borders-dimension 2)))
          (setq dim-x (- dim-x styletab:borders-dimension styletab:title-dimension)))))

    (when (eq dest 'sha-tra)
      (if (or (eq cur 'shaped)
              (eq cur 'utility))
          (setq new 'shaped-transient)
        (setq new 'shaped))
      (when (eq cur 'default)
        (setq new 'shaped)
        (setq dim-x (+ dim-x (* styletab:borders-dimension 2)))
        (setq dim-y (+ dim-y styletab:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (- dim-x styletab:borders-dimension))
          (setq dim-y (+ dim-y styletab:borders-dimension))))
      (when (eq cur 'transient)
        (setq new 'shaped-transient)
        (setq dim-x (+ dim-x (* styletab:borders-dimension 2)))
        (setq dim-y (+ dim-y styletab:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (- dim-x styletab:borders-dimension))
          (setq dim-y (+ dim-y styletab:borders-dimension))))
      (when (eq cur 'unframed)
        (setq new 'shaped)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (- dim-y styletab:title-dimension))
          (setq dim-x (- dim-x styletab:title-dimension)))))

    (when (eq dest 'unf-def)
      (when (or (eq cur 'default)
                (eq cur 'transient))
        (setq new 'unframed)
        (when (or (eq current-title 'top)
                  (eq current-title 'bottom))
          (setq dim-x (+ dim-x (* styletab:borders-dimension 2)))
          (setq dim-y (+ dim-y styletab:borders-dimension styletab:title-dimension)))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-y (+ dim-y (* styletab:borders-dimension 2)))
          (setq dim-x (+ dim-x styletab:borders-dimension styletab:title-dimension))))
      (when (or (eq cur 'shaped)
                (eq cur 'shaped-transient)
                (eq cur 'utility))
        (setq new 'unframed)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (+ dim-y styletab:title-dimension))
          (setq dim-x (+ dim-x styletab:title-dimension))))
      (when (eq cur 'unframed)
        (setq new 'shaped-transient)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (- dim-y styletab:title-dimension))
          (setq dim-x (- dim-x styletab:title-dimension)))))
    (when (not (eq cur new))
      (mapcar (lambda (w)
                (window-put w 'type new)
                (reframe-window w)
                (move-window-to w pos-x pos-y)
                (resize-window-to w dim-x dim-y)) wins))))


(define (set-frame-default-and-default/transient)
  "Set frametype to `default' and toggle transient-ness with resize."
  (f-type 'def-tra))

(define (set-frame-unframed-and-unframed/shaped-transient)
  "Set frametype to 'unframed' and toggle transient-ness with resize"
  (f-type 'unf-def))

(define (set-frame-shaped-and-shaped/shaped-transient)
  "Set frametype to shaped and toggle transient-ness with resize"
  (f-type 'sha-tra))

(define-command-gaol 'set-frame-default-and-default/transient-toggle set-frame-default-and-default/transient)
(define-command-gaol 'set-frame-unframed-and-unframed/shaped-transient-toggle set-frame-unframed-and-unframed/shaped-transient)
(define-command-gaol 'set-frame-shaped-and-shaped/shaped-transient-toggle set-frame-shaped-and-shaped/shaped-transient)

(def-frame-class frame-type-button ()
  (bind-keys frame-type-button-keymap
             "Button1-Off" 'set-frame-default-and-default/transient-toggle
             "Button2-Off" 'set-frame-unframed-and-unframed/shaped-transient-toggle
             "Button3-Off" 'set-frame-shaped-and-shaped/shaped-transient-toggle))

(defvar prev-button-keymap
  (bind-keys (make-keymap)
			 "Button3-Off" 'send-to-next-workspace
             "Button2-Click" 'popup-workspace-list
             "Button1-Off" 'send-to-previous-workspace))
(defvar next-button-keymap
  (bind-keys (make-keymap)
             "Button3-Off" 'send-to-previous-workspace
             "Button2-Click" 'popup-workspace-list
             "Button1-Off" 'send-to-next-workspace))
(define-frame-class 'prev-button '((keymap . prev-button-keymap)))
(define-frame-class 'next-button '((keymap . next-button-keymap)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; make images 

;; button/icon table
;;
(define styletab-icon-cache (make-weak-table eq-hash eq))

;; frames/title table
;;
(define styletab-frame-cache (make-weak-table eq-hash eq))

(define (window-icon w)
  (or (table-ref styletab-icon-cache w)
      (let ((icon (window-icon-image w)))
        (if icon
            (let ((scaled (scale-image icon (- styletab:title-dimension 7) (- styletab:title-dimension 7))))
              (table-set styletab-icon-cache w scaled)
              scaled)
          (scale-image top-frame-icon-title-images (- styletab:title-dimension 7) (- styletab:title-dimension 7))))))

(define top-frame-icon-title-images 
  (make-image (concat (symbol-name  styletab:style) "/" "top-frame-icon-title-images-f.png")))

(define (get-frame-image img)
  (or
   (table-ref styletab-frame-cache img)
   (let ((image
          (make-image img)))
     (table-set styletab-frame-cache img image)
     image)))

(define make-border-image
  (lambda (w)
    `((focused . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-f.png")))
      (inactive . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-i.png"))))))

(define top-border-images 
  (lambda (w) (make-border-image (concat w "-frame-top-border"))))
(define top-left-corner-images 
  (lambda (w) (make-border-image (concat w "-frame-top-left-corner"))))
(define top-left-corner-shaped-images 
  (lambda (w) (make-border-image (concat w "-frame-top-left-corner-shaped"))))
(define top-right-corner-images
  (lambda (w) (make-border-image (concat w "-frame-top-right-corner"))))
(define top-right-corner-shaped-images
  (lambda (w) (make-border-image (concat w "-frame-top-right-corner-shaped"))))
(define tab-left-icon-images 
  (lambda (w) (make-border-image (concat w "-frame-tab-left-icon"))))
(define tab-images 
  (lambda (w) (make-border-image (concat w "-frame-tab"))))
(define tab-right-images 
  (lambda (w) (make-border-image (concat w "-frame-tab-right"))))
(define tab-bottom-icon-images
  (lambda (w) (make-border-image (concat w "-frame-tab-bottom-icon"))))
(define tab-top-images
  (lambda (w) (make-border-image (concat w "-frame-tab-top"))))
(define title-images 
  (lambda (w) (make-border-image (concat w "-frame-title"))))
(define left-border-images
  (lambda (w) (make-border-image (concat w "-frame-left-border"))))
(define right-border-images
  (lambda (w) (make-border-image (concat w "-frame-right-border"))))
(define bottom-left-corner-images
  (lambda (w) (make-border-image (concat w "-frame-bottom-left-corner"))))
(define bottom-border-images
  (lambda (w) (make-border-image (concat w "-frame-bottom-border"))))
(define bottom-right-corner-images
  (lambda (w) (make-border-image (concat w "-frame-bottom-right-corner"))))
(define bottom-border-cursor-images
  (lambda (w) (make-border-image (concat w "-frame-bottom-border-cursor"))))
(define bottom-left-corner-shaped-images
  (lambda (w) (make-border-image (concat w "-frame-bottom-left-corner-shaped"))))
(define bottom-right-corner-shaped-images
  (lambda (w) (make-border-image (concat w "-frame-bottom-right-corner-shaped"))))

(define make-button-image
  (lambda (w)
    `((focused . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-f.png")))
      (highlighted . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-h.png")))
      (clicked . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-c.png")))
      (inactive . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-i.png")))
      (inactive-highlighted . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-ih.png")))
      (inactive-clicked . ,(get-frame-image (concat (symbol-name  styletab:style) "/" w "-ic.png"))))))

(define button-images
  (lambda (w x) (make-button-image (concat w "-frame-" x "-button"))))

(define top-frame-shade-button-images (make-button-image "top-frame-shade-button"))
(define bottom-frame-shade-button-images (make-button-image "bottom-frame-shade-button"))
(define left-frame-shade-button-images (make-button-image "left-frame-shade-button"))
(define right-frame-shade-button-images (make-button-image "right-frame-shade-button"))
(define top-frame-unshade-button-images (make-button-image "top-frame-unshade-button"))
(define bottom-frame-unshade-button-images (make-button-image "bottom-frame-unshade-button"))
(define left-frame-unshade-button-images (make-button-image "left-frame-unshade-button"))
(define right-frame-unshade-button-images (make-button-image "right-frame-unshade-button"))
(define top-frame-sticky-button-images (make-button-image "top-frame-sticky-button"))
(define bottom-frame-sticky-button-images (make-button-image "bottom-frame-sticky-button"))
(define left-frame-sticky-button-images (make-button-image "left-frame-sticky-button"))
(define right-frame-sticky-button-images (make-button-image "right-frame-sticky-button"))
(define top-frame-unsticky-button-images (make-button-image "top-frame-unsticky-button"))
(define bottom-frame-unsticky-button-images (make-button-image "bottom-frame-unsticky-button"))
(define left-frame-unsticky-button-images (make-button-image "left-frame-unsticky-button"))
(define right-frame-unsticky-button-images (make-button-image "right-frame-unsticky-button"))
(define top-frame-maximize-button-images (make-button-image "top-frame-maximize-button"))
(define bottom-frame-maximize-button-images (make-button-image "bottom-frame-maximize-button"))
(define left-frame-maximize-button-images (make-button-image "left-frame-maximize-button"))
(define right-frame-maximize-button-images (make-button-image "right-frame-maximize-button"))
(define top-frame-unmaximize-button-images (make-button-image "top-frame-unmaximize-button"))
(define bottom-frame-unmaximize-button-images (make-button-image "bottom-frame-unmaximize-button"))
(define left-frame-unmaximize-button-images (make-button-image "left-frame-unmaximize-button"))
(define right-frame-unmaximize-button-images (make-button-image "right-frame-unmaximize-button"))
(define top-frame-lock-button-images (make-button-image "top-frame-lock-button"))
(define bottom-frame-lock-button-images (make-button-image "bottom-frame-lock-button"))
(define left-frame-lock-button-images (make-button-image "left-frame-lock-button"))
(define right-frame-lock-button-images (make-button-image "right-frame-lock-button"))
(define top-frame-unlock-button-images (make-button-image "top-frame-unlock-button"))
(define bottom-frame-unlock-button-images (make-button-image "bottom-frame-unlock-button"))
(define left-frame-unlock-button-images (make-button-image "left-frame-unlock-button"))
(define right-frame-unlock-button-images (make-button-image "right-frame-unlock-button"))
(define top-frame-prev-button-images (make-button-image "top-frame-prev-button"))
(define bottom-frame-prev-button-images (make-button-image "bottom-frame-prev-button"))
(define left-frame-prev-button-images (make-button-image "left-frame-prev-button"))
(define right-frame-prev-button-images (make-button-image "right-frame-prev-button"))
(define top-frame-prev-last-button-images (make-button-image "top-frame-prev-last-button"))
(define bottom-frame-prev-last-button-images (make-button-image "bottom-frame-prev-last-button"))
(define left-frame-prev-last-button-images (make-button-image "left-frame-prev-last-button"))
(define right-frame-prev-last-button-images (make-button-image "right-frame-prev-last-button"))
(define top-frame-next-button-images (make-button-image "top-frame-next-button"))
(define bottom-frame-next-button-images (make-button-image "bottom-frame-next-button"))
(define left-frame-next-button-images (make-button-image "left-frame-next-button"))
(define right-frame-next-button-images (make-button-image "right-frame-next-button"))
(define top-frame-next-last-button-images (make-button-image "top-frame-next-last-button"))
(define bottom-frame-next-last-button-images (make-button-image "bottom-frame-next-last-button"))
(define left-frame-next-last-button-images (make-button-image "left-frame-next-last-button"))
(define right-frame-next-last-button-images (make-button-image "right-frame-next-last-button"))
(define top-frame-raise-lower-button-images (make-button-image "top-frame-raise-lower-button"))
(define bottom-frame-raise-lower-button-images (make-button-image "bottom-frame-raise-lower-button"))
(define left-frame-raise-lower-button-images (make-button-image "left-frame-raise-lower-button"))
(define right-frame-raise-lower-button-images (make-button-image "right-frame-raise-lower-button"))
(define top-frame-ontop-button-images (make-button-image "top-frame-ontop-button"))
(define bottom-frame-ontop-button-images (make-button-image "bottom-frame-ontop-button"))
(define left-frame-ontop-button-images (make-button-image "left-frame-ontop-button"))
(define right-frame-ontop-button-images (make-button-image "right-frame-ontop-button"))
(define top-frame-unontop-button-images (make-button-image "top-frame-unontop-button"))
(define bottom-frame-unontop-button-images (make-button-image "bottom-frame-unontop-button"))
(define left-frame-unontop-button-images (make-button-image "left-frame-unontop-button"))
(define right-frame-unontop-button-images (make-button-image "right-frame-unontop-button"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; buttons, colors settings 

(define top-frame-sticky-image-set
  (lambda (w)
    (if (window-get w 'sticky)
        top-frame-unsticky-button-images
      top-frame-sticky-button-images)))

(define bottom-frame-sticky-image-set
  (lambda (w)
    (if (window-get w 'sticky)
        bottom-frame-unsticky-button-images
      bottom-frame-sticky-button-images)))

(define left-frame-sticky-image-set
  (lambda (w)
    (if (window-get w 'sticky)
        left-frame-unsticky-button-images
      left-frame-sticky-button-images)))

(define right-frame-sticky-image-set
  (lambda (w)
    (if (window-get w 'sticky)
        right-frame-unsticky-button-images
      right-frame-sticky-button-images)))

(define top-frame-shade-image-set
  (lambda (w)
    (if (window-get w 'shaded)
        top-frame-unshade-button-images
      top-frame-shade-button-images)))

(define bottom-frame-shade-image-set
  (lambda (w)
    (if (window-get w 'shaded)
        bottom-frame-unshade-button-images
      bottom-frame-shade-button-images)))

(define left-frame-shade-image-set
  (lambda (w)
    (if (window-get w 'shaded)
        left-frame-unshade-button-images
      left-frame-shade-button-images)))

(define right-frame-shade-image-set
  (lambda (w)
    (if (window-get w 'shaded)
        right-frame-unshade-button-images
      right-frame-shade-button-images)))

(define top-frame-maximize-image-set
  (lambda (w)
    (if (window-get w 'unmaximized-geometry)
        top-frame-unmaximize-button-images
      top-frame-maximize-button-images)))

(define bottom-frame-maximize-image-set
  (lambda (w)
    (if (window-get w 'unmaximized-geometry)
        bottom-frame-unmaximize-button-images
      bottom-frame-maximize-button-images)))

(define left-frame-maximize-image-set
  (lambda (w)
    (if (window-get w 'unmaximized-geometry)
        left-frame-unmaximize-button-images
      left-frame-maximize-button-images)))

(define right-frame-maximize-image-set
  (lambda (w)
    (if (window-get w 'unmaximized-geometry)
        right-frame-unmaximize-button-images
      right-frame-maximize-button-images)))

(defmacro window-in-workspace-p (w space)
  `(memq ,space (window-get ,w 'workspaces)))

(define (get-first-workspace) 1)

(define top-frame-prev-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-first-workspace) 1))
            (window-get w 'sticky))
        top-frame-prev-last-button-images
      top-frame-prev-button-images)))

(define bottom-frame-prev-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-first-workspace) 1))
            (window-get w 'sticky))
        bottom-frame-prev-last-button-images
      bottom-frame-prev-button-images)))

(define left-frame-prev-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-first-workspace) 1))
            (window-get w 'sticky))
        left-frame-prev-last-button-images
      left-frame-prev-button-images)))

(define right-frame-prev-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-first-workspace) 1))
            (window-get w 'sticky))
        right-frame-prev-last-button-images
      right-frame-prev-button-images)))

(define (get-last-workspace)
  (aref
   (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS)) 0))

(define top-frame-next-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-last-workspace) 1))
            (window-get w 'sticky))
        top-frame-next-last-button-images
      top-frame-next-button-images)))

(define bottom-frame-next-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-last-workspace) 1))
            (window-get w 'sticky))
        bottom-frame-next-last-button-images
      bottom-frame-next-button-images)))

(define left-frame-next-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-last-workspace) 1))
            (window-get w 'sticky))
        left-frame-next-last-button-images
      left-frame-next-button-images)))

(define right-frame-next-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-last-workspace) 1))
            (window-get w 'sticky))
        right-frame-next-last-button-images
      right-frame-next-button-images)))

(define top-frame-lock-image-set
  (lambda (w)
    (if (window-get w 'fixed-position)
        top-frame-unlock-button-images
      top-frame-lock-button-images)))

(define bottom-frame-lock-image-set
  (lambda (w)
    (if (window-get w 'fixed-position)
        bottom-frame-unlock-button-images
      bottom-frame-lock-button-images)))

(define left-frame-lock-image-set
  (lambda (w)
    (if (window-get w 'fixed-position)
        left-frame-unlock-button-images
      left-frame-lock-button-images)))

(define right-frame-lock-image-set
  (lambda (w)
    (if (window-get w 'fixed-position)
        right-frame-unlock-button-images
      right-frame-lock-button-images)))

(define top-frame-raise-lower-image-set
  (lambda (w)
    (if (= (window-get w 'depth) 0)
        top-frame-raise-lower-button-images
      (if (> (window-get w 'depth) 0)
          top-frame-ontop-button-images
        top-frame-unontop-button-images))))

(define bottom-frame-raise-lower-image-set
  (lambda (w)
    (if (= (window-get w 'depth) 0)
        bottom-frame-raise-lower-button-images
      (if (> (window-get w 'depth) 0)
          bottom-frame-ontop-button-images
        bottom-frame-unontop-button-images))))

(define left-frame-raise-lower-image-set
  (lambda (w)
    (if (= (window-get w 'depth) 0)
        left-frame-raise-lower-button-images
      (if (> (window-get w 'depth) 0)
          left-frame-ontop-button-images
        left-frame-unontop-button-images))))

(define right-frame-raise-lower-image-set
  (lambda (w)
    (if (= (window-get w 'depth) 0)
        right-frame-raise-lower-button-images
      (if (> (window-get w 'depth) 0)
          right-frame-ontop-button-images
        right-frame-unontop-button-images))))

(define frame-width
  (lambda (w)
    (if (or (eq (window-type w) 'default)
			(eq (window-type w) 'transient))
        styletab:borders-dimension
      0)))

(define frame-edge
  (lambda (w)
    (if (or (eq (window-type w) 'default)
            (eq (window-type w) 'transient))
        (- styletab:borders-dimension)
      0)))

(define title-height (lambda (w) styletab:title-dimension)) 
(define title-height-s (lambda (w) (- styletab:title-dimension 2)))
(define title-edge (lambda (w) (- styletab:title-dimension)))
(define title-edge-s (lambda (w) (- (- styletab:title-dimension 2))))
(define top-frame-button-width (lambda (w) (+ styletab:title-dimension (button-width-custom))))
(define bottom-frame-button-width (lambda (w) (+ styletab:title-dimension (button-width-custom))))
(define left-frame-button-height (lambda (w) (+ styletab:title-dimension (button-width-custom))))
(define right-frame-button-height (lambda (w) (+ styletab:title-dimension (button-width-custom))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; frames 

(define top-frame-default-border-corner-group 
  `(((class . top-left-corner)
     (background . ,(top-left-corner-images "top"))
     (left-edge . ,frame-edge)
     (top-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
	((class . top-right-corner)
     (background . ,(top-right-corner-images "top"))
     (top-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . title)
     (background . ,(title-images "top"))
     (right-edge . 0)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . 2))))

(define bottom-frame-default-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(bottom-left-corner-images "bottom"))
     (left-edge . ,frame-edge)
     (bottom-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . bottom-right-corner)
     (background . ,(bottom-right-corner-images "bottom"))
     (bottom-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . title)
     (background . ,(title-images "bottom"))
     (right-edge . 0)
     (bottom-edge . ,title-edge)
     (height . ,title-height-s)
     (width . 2))))

(define left-frame-default-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(bottom-left-corner-images "left"))
     (bottom-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . top-left-corner)
     (background . ,(top-left-corner-images "left"))
     (top-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))))

(define right-frame-default-border-corner-group
  `(((class . bottom-right-corner)
     (background . ,(bottom-right-corner-images "right"))
     (bottom-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . top-right-corner)
     (background . ,(top-right-corner-images "right"))
     (top-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))))

(define top-frame-border-group
  `(((class . left-border)
     (background . ,(left-border-images "top"))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (top-edge . 0)
     (width . ,frame-width)
     (bottom-edge . 0))
	((class . bottom-left-corner)
     (background . ,(bottom-left-corner-images "top"))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-border)
     (background . ,(bottom-border-images "top"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-right-corner)
     (background . ,(bottom-right-corner-images "top"))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . right-border)
     (background . ,(right-border-images "top"))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))))

(define bottom-frame-border-group
  `(((class . left-border)
     (background . ,(left-border-images "bottom"))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (bottom-edge . 0)
     (width . ,frame-width)
     (top-edge . 0))
    ((class . top-left-corner)
     (background . ,(top-left-corner-images "bottom"))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . top-border)
     (background . ,(top-border-images "bottom"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . top-right-corner)
     (background . ,(top-right-corner-images "bottom"))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . right-border)
     (background . ,(right-border-images "bottom"))
     (cursor . sb_h_double_arrow)
     (bottom-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (top-edge . 0))))

(define left-frame-border-group
  `(((class . bottom-border)
     (background . ,(bottom-border-images "left"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . bottom-right-corner)
     (background . ,(bottom-right-corner-images "left"))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . right-border)
     (background . ,(right-border-images "left"))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))
    ((class . top-right-corner)
     (background . ,(top-right-corner-images "left"))
     (top-edge . ,frame-edge)
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width))
    ((class . top-border)
     (background . ,(top-border-images "left"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))))

(define right-frame-border-group
  `(((class . bottom-border)
     (background . ,(bottom-border-images "right"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . bottom-left-corner)
     (background . ,(bottom-left-corner-images "right"))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . left-border)
     (background . ,(left-border-images "right"))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (left-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))
    ((class . top-left-corner)
     (background . ,(top-left-corner-images "right"))
     (top-edge . ,frame-edge)
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width))
    ((class . top-border)
     (background . ,(top-border-images "right"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))))

(define top-frame-title-group
  `(((class . top-border)
     (background . ,(top-border-images "top"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (top-edge . ,title-edge)
     (right-edge . 0)
     (height . 2))
    ((class . tabbar-horizontal)
     (x-justify . ,(lambda (w) (- styletab:title-dimension 12)))
     (y-justify . center)
     (background . ,(tab-images "top"))
     (foreground . ,title-colors-images)
     (font . ,(lambda () (list styletab:title-font)))
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (text . ,window-name))
    ((class . tabbar-horizontal-left-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(tab-left-icon-images "top"))
     (cursor . hand2)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . 2)
     (x-justify . 5))
    ((class . tabbar-horizontal-right-edge)
     (background . ,(tab-right-images "top"))
     (width . ,tabbar-right-edge-width)
     (height . ,title-height-s)
     (top-edge . ,title-edge-s))))

(define bottom-frame-title-group
  `(((class . title)
     (background . ,(bottom-border-images "bottom"))
     (left-edge . 0)
     (bottom-edge . -2)
     (right-edge . 0)
     (height . 2))
    ((class . tabbar-horizontal)
     (x-justify . ,(lambda (w) (- styletab:title-dimension 12)))
     (y-justify . center)
     (background . ,(tab-images "bottom"))
     (foreground . ,title-colors-images)
     (font . ,(lambda () (list styletab:title-font)))
     (bottom-edge . ,title-edge)
     (height . ,title-height-s)
     (text . ,window-name))
    ((class . tabbar-horizontal-left-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(tab-left-icon-images "bottom"))
     (cursor . hand2)
     (bottom-edge . ,title-edge)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . 2)
     (x-justify . 5))
    ((class . tabbar-horizontal-right-edge)
     (background . ,(tab-right-images "bottom"))
     (width . ,tabbar-right-edge-width)
     (height . ,title-height-s)
     (bottom-edge . ,title-edge))))

(define left-frame-title-group
  `(((class . left-border)
     (background . ,(left-border-images "left"))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (left-edge . ,title-edge)
     (bottom-edge . 0)
     (width . 2))
    ((class . tabbar-vertical-top-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(tab-top-images "left"))
     (cursor . hand2)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (left-edge . ,title-edge-s)
     (y-justify . 4)
     (x-justify . 2))
    ((class . tabbar-vertical)
     (x-justify . 12)
     (y-justify . center)
     (background . ,(tab-images "left"))
     (left-edge . ,title-edge-s)
     (width . ,title-height-s))
    ((class . tabbar-vertical-bottom-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(tab-bottom-icon-images "left"))
     (left-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . 1)
     (x-justify . 2))))

(define right-frame-title-group
  `(((class . right-border)
     (background . ,(right-border-images "right"))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,title-edge)
     (bottom-edge . 0)
     (width . 2))
    ((class . tabbar-vertical-top-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(tab-top-images "right"))
     (cursor . hand2)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (right-edge . ,title-edge-s)
     (y-justify . 4)
     (x-justify . 4))
    ((class . tabbar-vertical)
     (x-justify . 12)
     (y-justify . center)
     (background . ,(tab-images "right"))
     (right-edge . ,title-edge-s)
     (width . ,title-height-s))
    ((class . tabbar-vertical-bottom-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(tab-bottom-icon-images "right"))
     (right-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . 1)
     (x-justify . 4))))

(define bottom-frame-title-cursor-images
  `(((class . bottom-border)
     (background . ,(bottom-border-cursor-images "bottom"))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (bottom-edge . ,title-edge)
     (right-edge . 0)
     (height . 2))))

(define top-frame-close-button
  `((class . close-button)
    (background . ,(button-images "top" "close"))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-close-button
  `((class . close-button)
    (background . ,(button-images "bottom" "close"))
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-close-button
  `((class . close-button)
    (background . ,(button-images "left" "close"))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-close-button
  `((class . close-button)
    (background . ,(button-images "right" "close"))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-menu-button
  `((class . menu-button)
    (background . ,(button-images "top" "menu"))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-menu-button
  `((class . menu-button)
    (background . ,(button-images "bottom" "menu"))
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-menu-button
  `((class . menu-button)
    (background . ,(button-images "left" "menu"))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-menu-button
  `((class . menu-button)
    (background . ,(button-images "right" "menu"))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-iconify-button
  `((class . iconify-button)
    (background . ,(button-images "top" "iconify"))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-iconify-button
  `((class . iconify-button)
    (background . ,(button-images "bottom" "iconify"))
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-iconify-button
  `((class . iconify-button)
    (background . ,(button-images "left" "iconify"))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-iconify-button
  `((class . iconify-button)
    (background . ,(button-images "right" "iconify"))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-maximize-button
  `((class . maximize-button)
    (background . ,top-frame-maximize-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-maximize-button
  `((class . maximize-button)
    (background . ,bottom-frame-maximize-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-maximize-button
  `((class . maximize-button)
    (background . ,left-frame-maximize-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-maximize-button
  `((class . maximize-button)
    (background . ,right-frame-maximize-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-shade-button
  `((class . shade-button)
    (background . ,top-frame-shade-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-shade-button
  `((class . shade-button)
    (background . ,bottom-frame-shade-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-shade-button
  `((class . shade-button)
    (background . ,left-frame-shade-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-shade-button
  `((class . shade-button)
    (background . ,right-frame-shade-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-sticky-button
  `((class . sticky-button)
    (background . ,top-frame-sticky-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-sticky-button
  `((class . sticky-button)
    (background . ,bottom-frame-sticky-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-sticky-button
  `((class . sticky-button)
    (background . ,left-frame-sticky-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-sticky-button
  `((class . sticky-button)
    (background . ,right-frame-sticky-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-space-button
  `((class . title)
    (background . ,(title-images "top"))
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-space-button
  `((class . title)
    (background . ,(title-images "bottom"))
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-space-button
  `((class . title)
    (background . ,(title-images "left"))
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-space-button
  `((class . title)
    (background . ,(title-images "right"))
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-prev-button
  `((class . prev-button)
    (background . ,top-frame-prev-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-prev-button
  `((class . prev-button)
    (background . ,bottom-frame-prev-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-prev-button
  `((class . prev-button)
    (background . ,left-frame-prev-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-prev-button
  `((class . prev-button)
    (background . ,right-frame-prev-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-next-button
  `((class . next-button)
    (background . ,top-frame-next-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-next-button
  `((class . next-button)
    (background . ,bottom-frame-next-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-next-button
  `((class . next-button)
    (background . ,left-frame-next-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-next-button
  `((class . next-button)
    (background . ,right-frame-next-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-lock-button
  `((class . lock-button)
    (background . ,top-frame-lock-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-lock-button
  `((class . lock-button)
    (background . ,bottom-frame-lock-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-lock-button
  `((class . lock-button)
    (background . ,left-frame-lock-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-lock-button
  `((class . lock-button)
    (background . ,right-frame-lock-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,top-frame-raise-lower-image-set)
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,bottom-frame-raise-lower-image-set)
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,left-frame-raise-lower-image-set)
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,right-frame-raise-lower-image-set)
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define  top-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(button-images "top" "move-resize"))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define  bottom-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(button-images "bottom" "move-resize"))
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define  left-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(button-images "left" "move-resize"))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define  right-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(button-images "right" "move-resize"))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-rename-button
  `((class . rename-button)
    (background . ,(button-images "top" "rename"))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-rename-button
  `((class . rename-button)
    (background . ,(button-images "bottom" "rename"))
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-rename-button
  `((class . rename-button)
    (background . ,(button-images "left" "rename"))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-rename-button
  `((class . rename-button)
    (background . ,(button-images "right" "rename"))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(button-images "top" "frame-type"))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(button-images "bottom" "frame-type"))
    (cursor . hand2)
    (bottom-edge . ,title-edge)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(button-images "left" "frame-type"))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(button-images "right" "frame-type"))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-shaped-border-corner-group
  `(((class . top-left-corner)
     (background . ,(top-left-corner-shaped-images "top"))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (top-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
	((class . top-right-corner)
     (background . ,(top-right-corner-shaped-images "top"))
     (cursor . sb_h_double_arrow)
     (top-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . title)
     (background . ,(title-images "top"))
     (right-edge . 0)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . 2))))

(define bottom-frame-shaped-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(bottom-left-corner-shaped-images "bottom"))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (bottom-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . bottom-right-corner)
     (background . ,(bottom-right-corner-shaped-images "bottom"))
     (cursor . sb_h_double_arrow)
     (bottom-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . title)
     (background . ,(title-images "bottom"))
     (right-edge . 0)
     (bottom-edge . ,title-edge)
     (height . ,title-height-s)
     (width . 2))))

(define left-frame-shaped-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(bottom-left-corner-shaped-images "left"))
     (bottom-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . top-left-corner)
     (background . ,(top-left-corner-shaped-images "left"))
     (top-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))))

(define right-frame-shaped-border-corner-group
  `(((class . bottom-right-corner)
     (background . ,(bottom-right-corner-shaped-images "right"))
     (bottom-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . top-right-corner)
     (background . ,(top-right-corner-shaped-images "right"))
     (top-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))))

(define top-button-alist
  `((close  . ,top-frame-close-button)
    (menu   . ,top-frame-menu-button)
    (minimize   . ,top-frame-iconify-button)
    (maximize   . ,top-frame-maximize-button)
    (shade  . ,top-frame-shade-button)
    (sticky . ,top-frame-sticky-button)
    (space . ,top-frame-space-button)
    (send-to-prev . ,top-frame-prev-button)
    (send-to-next . ,top-frame-next-button)
    (lock . ,top-frame-lock-button)
    (raise-lower . ,top-frame-raise-lower-button)
    (move-resize . ,top-frame-move-resize-button)
    (rename . ,top-frame-rename-button)
    (frame-type . ,top-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define bottom-button-alist
  `((close  . ,bottom-frame-close-button)
    (menu   . ,bottom-frame-menu-button)
    (minimize   . ,bottom-frame-iconify-button)
    (maximize   . ,bottom-frame-maximize-button)
    (shade  . ,bottom-frame-shade-button)
    (sticky . ,bottom-frame-sticky-button)
    (space . ,bottom-frame-space-button)
    (send-to-prev . ,bottom-frame-prev-button)
    (send-to-next . ,bottom-frame-next-button)
    (lock . ,bottom-frame-lock-button)
    (raise-lower . ,bottom-frame-raise-lower-button)
    (move-resize . ,bottom-frame-move-resize-button)
    (rename . ,bottom-frame-rename-button)
    (frame-type . ,bottom-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define left-button-alist
  `((close  . ,left-frame-close-button)
    (menu   . ,left-frame-menu-button)
    (minimize   . ,left-frame-iconify-button)
    (maximize   . ,left-frame-maximize-button)
    (shade  . ,left-frame-shade-button)
    (sticky . ,left-frame-sticky-button)
    (space . ,left-frame-space-button)
    (send-to-prev . ,left-frame-prev-button)
    (send-to-next . ,left-frame-next-button)
    (lock . ,left-frame-lock-button)
    (raise-lower . ,left-frame-raise-lower-button)
    (move-resize . ,left-frame-move-resize-button)
    (rename . ,left-frame-rename-button)
    (frame-type . ,left-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define right-button-alist
  `((close  . ,right-frame-close-button)
    (menu   . ,right-frame-menu-button)
    (minimize   . ,right-frame-iconify-button)
    (maximize   . ,right-frame-maximize-button)
    (shade  . ,right-frame-shade-button)
    (sticky . ,right-frame-sticky-button)
    (space . ,right-frame-space-button)
    (send-to-prev . ,right-frame-prev-button)
    (send-to-next . ,right-frame-next-button)
    (lock . ,right-frame-lock-button)
    (raise-lower . ,right-frame-raise-lower-button)
    (move-resize . ,right-frame-move-resize-button)
    (rename . ,right-frame-rename-button)
    (frame-type . ,right-frame-frame-type-button)
    (\(none\)   . ,nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; build themes

(define normal-frame nil)
(define shaped-frame nil)
(define transient-frame nil)
(define shaped-transient-frame nil)

;; first run use top title
;;
(define current-title 'top)

(define create-frames
  ;; ripped from Anonymous
  ;;
  (lambda ()
    (let* (
           (button-alist
            (case current-title
                  ((top) top-button-alist)
                  ((bottom) bottom-button-alist)
                  ((left) left-button-alist)
                  ((right) right-button-alist)))

           ;; turns one cons cell (btn-name . show-in-transients) into a button
           ;; definition, adding the button position
           ;;
           (make-button
            (lambda (is-trans btn edge pos)
              (let ((btn-def  (cdr (assq (car btn) button-alist)))
                    (btn-in-trans (last btn)))
                (if (or (null btn-def) (and is-trans (not btn-in-trans)))
                    nil
                  (cons (cons edge pos) btn-def)))))

           ;; turns the list of cons cells (btn-name . show-in-transients) into
           ;; a list of button definitions, adding the button positions
           ;;
           (make-button-list
            (lambda (is-trans btn-list edge pos-start pos-inc)
              (let loop ((rest btn-list) (pos pos-start) (result ()))
                (if (null rest)
                    result
                  (let ((new-btn (make-button is-trans (car rest) edge pos)))
                    (if (null new-btn)
                        (loop (cdr rest) pos result)
                      (loop (cdr rest) (+ pos pos-inc) (append (list new-btn) result))))))))

		   (top-frame-normal-buttons-left 
            (make-button-list nil styletab:top-left-buttons 'left-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (top-frame-normal-buttons-right
            (make-button-list nil styletab:top-right-buttons 'right-edge 0 (+ styletab:title-dimension (button-width-custom))))
           (top-frame-transient-buttons-left
            (make-button-list t styletab:top-left-buttons 'left-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (top-frame-transient-buttons-right
            (make-button-list t styletab:top-right-buttons 'right-edge 0 (+ styletab:title-dimension (button-width-custom))))

           (bottom-frame-normal-buttons-left 
            (make-button-list nil styletab:bottom-left-buttons 'left-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (bottom-frame-normal-buttons-right
            (make-button-list nil styletab:bottom-right-buttons 'right-edge 0 (+ styletab:title-dimension (button-width-custom))))
           (bottom-frame-transient-buttons-left
            (make-button-list t styletab:bottom-left-buttons 'left-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (bottom-frame-transient-buttons-right
            (make-button-list t styletab:bottom-right-buttons 'right-edge 0 (+ styletab:title-dimension (button-width-custom))))

           (left-frame-normal-buttons-left 
            (make-button-list nil styletab:left-bottom-buttons 'bottom-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (left-frame-normal-buttons-right
            (make-button-list nil styletab:left-top-buttons 'top-edge 0 (+ styletab:title-dimension (button-width-custom))))
           (left-frame-transient-buttons-left
            (make-button-list t styletab:left-bottom-buttons 'bottom-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (left-frame-transient-buttons-right
            (make-button-list t styletab:left-top-buttons 'top-edge 0 (+ styletab:title-dimension (button-width-custom))))

           (right-frame-normal-buttons-left 
            (make-button-list nil styletab:right-bottom-buttons 'bottom-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (right-frame-normal-buttons-right
            (make-button-list nil styletab:right-top-buttons 'top-edge 0 (+ styletab:title-dimension (button-width-custom))))
           (right-frame-transient-buttons-left
            (make-button-list t styletab:right-bottom-buttons 'bottom-edge  0 (+ styletab:title-dimension (button-width-custom))))
           (right-frame-transient-buttons-right
            (make-button-list t styletab:right-top-buttons 'top-edge 0 (+ styletab:title-dimension (button-width-custom)))))

      (require 'sawfish.wm.tabs.tab)
      (when (eq current-title 'top)
        (let ((top-left-d-w 11)
              (top-right-d-w (tabbar-right-edge-width))
              (top-left-m
               (if (numberp (cdr (car (car top-frame-normal-buttons-left))))
                   (+ (cdr (car (car top-frame-normal-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (top-right-m
               (if (numberp (cdr (car (car top-frame-normal-buttons-right))))
                   (+ (cdr (car (car top-frame-normal-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0))
              (top-left-m-t
               (if (numberp (cdr (car (car top-frame-transient-buttons-left))))
                   (+ (cdr (car (car top-frame-transient-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (top-right-m-t
               (if (numberp (cdr (car (car top-frame-transient-buttons-right))))
                   (+ (cdr (car (car top-frame-transient-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0)))
          (set-tab-adjustments #:theme-left-dec-width top-left-d-w #:theme-right-dec-width top-right-d-w #:theme-left-margin top-left-m
                               #:theme-right-margin top-right-m #:theme-left-margin-transient top-left-m-t
                               #:theme-right-margin-transient top-right-m-t))
        (setq normal-frame
              (append top-frame-default-border-corner-group top-frame-title-group top-frame-normal-buttons-left 
                      top-frame-border-group top-frame-normal-buttons-right))
        (setq shaped-frame
              (append top-frame-shaped-border-corner-group top-frame-title-group top-frame-normal-buttons-left 
                      top-frame-normal-buttons-right))
        (setq transient-frame
              (append top-frame-default-border-corner-group top-frame-title-group top-frame-transient-buttons-left 
                      top-frame-border-group top-frame-transient-buttons-right))
        (setq shaped-transient-frame
              (append top-frame-shaped-border-corner-group top-frame-title-group top-frame-transient-buttons-left
                      top-frame-transient-buttons-right)))

      (when (eq current-title 'bottom)
        (let ((bottom-left-d-w 11)
              (bottom-right-d-w (tabbar-right-edge-width))
              (bottom-left-m
               (if (numberp (cdr (car (car bottom-frame-normal-buttons-left))))
                   (+ (cdr (car (car bottom-frame-normal-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (bottom-right-m
               (if (numberp (cdr (car (car bottom-frame-normal-buttons-right))))
                   (+ (cdr (car (car bottom-frame-normal-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0))
              (bottom-left-m-t
               (if (numberp (cdr (car (car bottom-frame-transient-buttons-left))))
                   (+ (cdr (car (car bottom-frame-transient-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (bottom-right-m-t
               (if (numberp (cdr (car (car bottom-frame-transient-buttons-right))))
                   (+ (cdr (car (car bottom-frame-transient-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0)))
          (set-tab-adjustments #:theme-left-dec-width bottom-left-d-w #:theme-right-dec-width bottom-right-d-w #:theme-left-margin bottom-left-m
                               #:theme-right-margin bottom-right-m #:theme-left-margin-transient bottom-left-m-t
                               #:theme-right-margin-transient bottom-right-m-t))
        (setq normal-frame
              (append bottom-frame-default-border-corner-group bottom-frame-title-group bottom-frame-normal-buttons-left 
                      bottom-frame-border-group bottom-frame-normal-buttons-right bottom-frame-title-cursor-images))
        (setq shaped-frame
              (append bottom-frame-shaped-border-corner-group bottom-frame-title-group bottom-frame-normal-buttons-left 
                      bottom-frame-normal-buttons-right bottom-frame-title-cursor-images))
        (setq transient-frame
              (append bottom-frame-default-border-corner-group bottom-frame-title-group bottom-frame-transient-buttons-left
                      bottom-frame-border-group bottom-frame-transient-buttons-right bottom-frame-title-cursor-images))
        (setq shaped-transient-frame
              (append bottom-frame-shaped-border-corner-group bottom-frame-title-group bottom-frame-transient-buttons-left 
                      bottom-frame-transient-buttons-right bottom-frame-title-cursor-images)))
      
      (when (eq current-title 'left)
        (let ((left-left-d-w 11)
              (left-right-d-w (- styletab:title-dimension 2))
              (left-left-m
               (if (numberp (cdr (car (car left-frame-normal-buttons-left))))
                   (+ (cdr (car (car left-frame-normal-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (left-right-m
               (if (numberp (cdr (car (car left-frame-normal-buttons-right))))
                   (+ (cdr (car (car left-frame-normal-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0))
              (left-left-m-t
               (if (numberp (cdr (car (car left-frame-transient-buttons-left))))
                   (+ (cdr (car (car left-frame-transient-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (left-right-m-t
               (if (numberp (cdr (car (car left-frame-transient-buttons-right))))
                   (+ (cdr (car (car left-frame-transient-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0)))
          (set-tab-adjustments #:theme-left-dec-width left-left-d-w #:theme-right-dec-width left-right-d-w #:theme-left-margin left-left-m
                               #:theme-right-margin left-right-m #:theme-left-margin-transient left-left-m-t
                               #:theme-right-margin-transient left-right-m-t))
        (setq normal-frame
              (append left-frame-title-group left-frame-normal-buttons-left left-frame-default-border-corner-group 
                      left-frame-border-group left-frame-normal-buttons-right))
        (setq shaped-frame
              (append left-frame-title-group left-frame-normal-buttons-left left-frame-shaped-border-corner-group 
                      left-frame-normal-buttons-right))
        (setq transient-frame
              (append left-frame-title-group left-frame-transient-buttons-left left-frame-default-border-corner-group 
                      left-frame-border-group left-frame-transient-buttons-right))
        (setq shaped-transient-frame
              (append left-frame-title-group left-frame-transient-buttons-left left-frame-shaped-border-corner-group 
                      left-frame-transient-buttons-right)))
      
      (when (eq current-title 'right)
        (let ((right-left-d-w 11)
              (right-right-d-w (- styletab:title-dimension 2))
              (right-left-m
               (if (numberp (cdr (car (car right-frame-normal-buttons-left))))
                   (+ (cdr (car (car right-frame-normal-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (right-right-m
               (if (numberp (cdr (car (car right-frame-normal-buttons-right))))
                   (+ (cdr (car (car right-frame-normal-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0))
              (right-left-m-t
               (if (numberp (cdr (car (car right-frame-transient-buttons-left))))
                   (+ (cdr (car (car right-frame-transient-buttons-left))) (+ styletab:title-dimension (button-width-custom))) 0))
              (right-right-m-t
               (if (numberp (cdr (car (car right-frame-transient-buttons-right))))
                   (+ (cdr (car (car right-frame-transient-buttons-right))) (+ styletab:title-dimension (button-width-custom))) 0)))
          (set-tab-adjustments #:theme-left-dec-width right-left-d-w #:theme-right-dec-width right-right-d-w #:theme-left-margin right-left-m
                               #:theme-right-margin right-right-m #:theme-left-margin-transient right-left-m-t
                               #:theme-right-margin-transient right-right-m-t))
        (setq normal-frame
              (append right-frame-title-group right-frame-normal-buttons-left right-frame-default-border-corner-group 
                      right-frame-border-group right-frame-normal-buttons-right))
        (setq shaped-frame
              (append right-frame-title-group right-frame-normal-buttons-left right-frame-shaped-border-corner-group 
                      right-frame-normal-buttons-right))
        (setq transient-frame
              (append right-frame-title-group right-frame-transient-buttons-left right-frame-default-border-corner-group 
                      right-frame-border-group right-frame-transient-buttons-right))
        (setq shaped-transient-frame
              (append right-frame-title-group right-frame-transient-buttons-left right-frame-shaped-border-corner-group 
                      right-frame-transient-buttons-right))))))

(create-frames)

;; At last! We create the actual theme
;;
(add-frame-style theme-name
                 (lambda (w type)
                   (case type
                         ((default)             normal-frame)
                         ((shaped)              shaped-frame)
                         ((transient)           transient-frame)
                         ((shaped-transient)    shaped-transient-frame)
                         ((utility)             normal-frame)
                         ((shaded-utility)      normal-frame)
                         ((unframed)            nil-frame))))

(define (current-title-w w)
  (if (not (window-get w 'title-position))
      (case styletab:titlebar-place
            ((top) (setq current-title 'top))
            ((bottom) (setq current-title 'bottom))
            ((left) (setq current-title 'left))
            ((right) (setq current-title 'right)))
    (setq current-title (window-get w 'title-position)))
  (create-frames))

(define (create-frames-only w)
  (when (eq (window-get w 'current-frame-style) theme-name)
    (current-title-w w)))

(define (reframe-windows style)
  (map-windows
   (lambda (w)
     (when (eq (window-get w 'current-frame-style) style)
       (current-title-w w)
       (reframe-window w)))))

(define reframe-all
  (lambda ()
    (reframe-windows theme-name)))

(define (reframe-one w)
  (when (not (window-get w 'tabbed))
    (when (eq (window-get w 'current-frame-style) theme-name)
      (current-title-w w)
      (rebuild-frame w))))

;; also reset icon cache
;;
(define clear-cache-reframe
  (lambda ()
    (setq styletab-icon-cache (make-weak-table eq-hash eq))
    (reframe-all)))

;; also reset all cache 
;;
(define (clear-cache-reload-frame-style)
  (setq styletab-icon-cache (make-weak-table eq-hash eq))
  (setq styletab-frame-cache (make-weak-table eq-hash eq))
  (reload-frame-style theme-name))

(call-after-state-changed '(sticky fixed-position stacking) reframe-one)
(call-after-state-changed '(title-position) create-frames-only)
(add-hook 'remove-from-workspace-hook reframe-one)

(custom-set-property 'styletab:title-font ':after-set reframe-all)
(custom-set-property 'styletab:custom-colors ':after-set reframe-all)
(custom-set-property 'styletab:focused-color ':after-set reframe-all)
(custom-set-property 'styletab:highlighted-color ':after-set reframe-all)
(custom-set-property 'styletab:inactive-color ':after-set reframe-all)
(custom-set-property 'styletab:inactive-highlighted-color ':after-set reframe-all)
(custom-set-property 'styletab:style ':after-set clear-cache-reload-frame-style)
(custom-set-property 'styletab:title-dimension ':after-set clear-cache-reframe)
(custom-set-property 'styletab:custom-button-width ':after-set clear-cache-reframe)
(custom-set-property 'styletab:button-width ':after-set clear-cache-reframe)
(custom-set-property 'styletab:borders-dimension ':after-set reframe-all)
(custom-set-property 'styletab:titlebar-place ':after-set reframe-all)
(custom-set-property 'styletab:top-left-buttons ':after-set reframe-all)
(custom-set-property 'styletab:top-right-buttons ':after-set reframe-all)
(custom-set-property 'styletab:bottom-left-buttons ':after-set reframe-all)
(custom-set-property 'styletab:bottom-right-buttons ':after-set reframe-all)
(custom-set-property 'styletab:left-top-buttons ':after-set reframe-all)
(custom-set-property 'styletab:left-bottom-buttons ':after-set reframe-all)
(custom-set-property 'styletab:right-top-buttons ':after-set reframe-all)
(custom-set-property 'styletab:right-bottom-buttons ':after-set reframe-all)

;; xmodmap.jl -- Xmodmap integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.xmodmap

  (export load-xmodmap
	  save-keymap
	  restore-keymap)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
        rep.io.files
	rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias xmodmap sawfish.wm.prg.xmodmap)

  (defcustom init-xmodmap nil
    "Whether to start xmodmap with Sawfish."
    :type boolean
    :group (misc apps))

  (defcustom xmodmap-config (concat (getenv "HOME") "/.Xmodmap")
    "xmodmap configuration file to use."
    :type file
    :depends init-xmodmap
    :group (misc apps))

  (define (save-keymap #!key (file "~/.Xmodmap.orig"))
    "Save current keymap to ~/.Xmodmap.orig - or a path passed."
    (system (format nil "xmodmap -pke >  %s &" file)))

  (define (restore-keymap)
    "Restore keymap from ~/.Xmodmap.org."
    (if (file-exists-p "~/.Xmodmap.orig")
        (system "xmodmap ~/.Xmodmap.orig &")
      (display-message (format nil "~/.xmodmap.orig does not exist."))))

  (define (load-xmodmap #!key (config xmodmap-config))
    "Start xmodmap. configuration-file may be passed, else $HOME/.Xmodmap is used."
    (if (program-exists-p "xmodmap")
        (progn
	  (save-keymap)
	  (if (file-exists-p config)
	      (system (format nil "xmodmap %s &" config))
	    (display-message (format nil "given configuration file does not exist."))))
      (display-message (format nil "xmodmap executable not found in PATH.")))))

;;; shrink windows to fit or yank them free.
;; Copyright 2000, 2001, 2003, 2005 by Timo Korvola <tkorvola@iki.fi>

;;; Commentary:
;; This package provides functions to shrink or yank a window in the
;; four cardinal directions.  Shrinking resizes the window by moving one
;; of its edges and yanking moves the window to meet the following condition:
;; - if the window was partially (or in case of yanking even entirely) outside
;;   the screen it will be entirely on the screen,
;; - otherwise, if the window intersected with other windows it will intersect
;;   with one less window,
;; - otherwise the window will not be moved or resized.
;;
;; If the window reaches its minimum size before this condition can be
;; satisfied the window is resized to the minimum size instead.  There
;; is also a minimum size constraint `shrink-window-minimum', which
;; applies to all windows.  However, it is measured in pixels and
;; windows may actually become smaller than the specified value due to
;; size truncation.
;;
;; If the window would have to be yanked off the screen to satisfy the
;; condition `yank-window-minimum-visible' pixels will be left visible instead.

(define-structure sawfish.wm.commands.shrink-yank

    (export shrink-window-left
            shrink-window-right
            shrink-window-up
            shrink-window-down
            yank-window-left
            yank-window-right
            yank-window-up
            yank-window-down)

    (open   rep
            sawfish.wm.commands
            sawfish.wm.commands.grow-pack
            sawfish.wm.events
            sawfish.wm.misc
            sawfish.wm.state.maximize
            sawfish.wm.state.iconify
            sawfish.wm.util.rects
            sawfish.wm.windows
            sawfish.wm.workspace
            sawfish.wm.custom)

  (define-structure-alias shrink-yank sawfish.wm.commands.shrink-yank)

;;; Customization options are defined in grow-pack.jl

;;; Commands:

  (define (shrink-window-left window)
    "Shrinks WINDOW by moving the right edge to the left until it
overlaps with one less window than before."
    (shrink-window window 'left))

  (define (shrink-window-right window)
    "Shrinks WINDOW by moving the left edge to the right until it
overlaps with one less window than before."
    (shrink-window window 'right))

  (define (shrink-window-up window)
    "Shrinks WINDOW by moving the lower edge upwards until it
overlaps with one less window than before."
    (shrink-window window 'up))

  (define (shrink-window-down window)
    "Shrinks WINDOW by moving the upper edge downwards until it
overlaps with one less window than before."
    (shrink-window window 'down))

  (define (yank-window-left window)
    "Moves WINDOW to the left until it overlaps with one less window
than before."
    (yank-window window 'left))

  (define (yank-window-right window)
    "Moves WINDOW to the right until it overlaps with one less window
than before."
    (yank-window window 'right))

  (define (yank-window-up window)
    "Moves WINDOW upwards until it overlaps with one less window than
before."
    (yank-window window 'up))

  (define (yank-window-down window)
    "Moves WINDOW downwards until it overlaps with one less window than
before."
    (yank-window window 'down))

  ;;###autoload
  (define-command 'shrink-window-left shrink-window-left #:spec "%W")
  (define-command 'shrink-window-right shrink-window-right #:spec "%W")
  (define-command 'shrink-window-up shrink-window-up #:spec "%W")
  (define-command 'shrink-window-down shrink-window-down #:spec "%W")
  (define-command 'yank-window-left yank-window-left #:spec "%W")
  (define-command 'yank-window-right yank-window-right #:spec "%W")
  (define-command 'yank-window-up yank-window-up #:spec "%W")
  (define-command 'yank-window-down yank-window-down #:spec "%W")

;;; Implementation:

  (define (window-frame-rect window)
    "Returns the rectangle (left top right bottom) describing the frame
dimensions of WINDOW."
    (let* ((wpos (window-position window))
	   (wdim (window-frame-dimensions window))
	   (wleft (car wpos))
	   (wtop (cdr wpos)))
      (list wleft wtop (+ wleft (car wdim)) (+ wtop (cdr wdim)))))

  ;; I can never remember these!
  (define left car)
  (define top cadr)
  (define right caddr)
  (define bottom cadddr)

  (define (maybe-warp-pointer window old-rect direction maybe)
    (define (scale x x0 x1 x0new x1new)
      (round (/ (+ (* (- x x0) x1new)
		   (* (- x1 x) x0new))
		(- x1 x0))))
    (define (truncate-rect r)
      (list (max (left r) 0)
	    (max (top r) 0)
	    (min (right r) (screen-width))
	    (min (bottom r) (screen-height))))
    (case pack-warp-pointer
      ((always) (warp-cursor-to-window window))
      ((maybe)
       (when maybe
	 (let* ((owr (truncate-rect old-rect))
                (nwr (truncate-rect (window-frame-rect window)))
                (ppos (query-pointer))
                (xpos (car ppos))
                (ypos (cdr ppos)))
	   (case direction
	     ((left right)
	      (setq xpos (scale xpos (left owr) (right owr)
                                (left nwr) (right nwr))))
	     ((up down)
	      (setq ypos (scale ypos (top owr) (bottom owr)
                                (top nwr) (bottom nwr)))))
	   (warp-cursor xpos ypos))))))

  ;; Return the coordinate of the window or screen intersection to shink or yank
  ;; to.  This will do for both shrinking and yanking although the requirements
  ;; are slightly different: e.g., a window that completely surrounds the active
  ;; window is irrelevant for shrinking.
  (define (find-least-intersection window wr direction yank)
    (let ((scr-interesction (find-least-screen-intersection wr direction))
          (wnd-intersection (find-least-window-intersection
                             window wr direction yank)))
      (if (and scr-interesction wnd-intersection)
          ((if (memq direction '(left up)) max min)
           scr-interesction wnd-intersection)
        (or scr-interesction wnd-intersection))))

  ;; Return the coordinate of the screen intersection to shrink or yank to.
  ;; On multi-display setups all heads which display portion of the window are
  ;; taken into account.
  (define (find-least-screen-intersection wr direction)
    (let* (result
           (i (head-count))
           (horizontal (memq direction '(left right)))
           (getter (if horizontal car cdr))
           (wedges (if horizontal
                       (cons (left wr) (right wr))
                     (cons (top wr) (bottom wr))))
           (cmp (if horizontal < >))
           (check-candidate (lambda (edge)
                              (and (< (car wedges) edge (cdr wedges))
                                   (or (not result) (cmp edge result))
                                   (setq result edge)))))
      ;; Go through all the displays.
      (while (> i 0)
        (setq i (1- i))
        (let ((dimensions (head-dimensions i))
              (offset     (head-offset     i)))
          (when (positivep (rect-2d-overlap dimensions offset wr))
            (check-candidate (getter offset))
            (check-candidate (+ (getter offset) (getter dimensions))))))
      ;; Check screen edges as well.
      (check-candidate 0)
      (check-candidate (if horizontal (screen-width) (screen-height)))
      result))

  ;; Return the coordinate of the window intersection to shink or yank to.
  (define (find-least-window-intersection window wr direction yank)
    (let* ((isect-coord (if yank
			    (case direction
			      ((left up) 0)
			      ((right) (screen-width))
			      ((down) (screen-height)))
			  (case direction
			    ((left) (left wr))
			    ((up) (top wr))
			    ((right) (right wr))
			    ((down) (bottom wr)))))
	   (isect-check (case direction
			  ((left)
			   (lambda (xr)
			     (and (< isect-coord (left xr) (right wr))
				  (setq isect-coord (left xr)))))
			  ((up)
			   (lambda (xr)
			     (and (< isect-coord (top xr) (bottom wr))
				  (setq isect-coord (top xr)))))
			  ((right)
			   (lambda (xr)
			     (and (< (left wr) (right xr) isect-coord)
				  (setq isect-coord (right xr)))))
			  ((down)
			   (lambda (xr)
			     (and (< (top wr) (bottom xr) isect-coord)
				  (setq isect-coord (bottom xr))))))))
      (let ((win nil))
	(mapc (lambda (x)
		(and (not (eql x window))
		     (not (window-iconified-p x))
		     (window-appears-in-workspace-p x current-workspace)
		     (let ((xr (window-frame-rect x)))
		       (and (positivep (rect-2d-overlap* wr xr))
			    (isect-check xr)
			    (setq win x)))))
	      (managed-windows))
	(and win isect-coord))))

  (define (shrink-window window direction)
    "Shrinks WINDOW by moving the edge opposite to DIRECTION (left, right,
up or down) towards DIRECTION until it overlaps with one less window than
before."
    (let* ((wr (window-frame-rect window))
	   (isect-coord (find-least-intersection window wr direction nil))
	   (nleft (left wr))
	   (ntop (top wr))
	   (wdim (window-dimensions window))
	   (nwidth (car wdim))
	   (nheight (cdr wdim)))
      (when (and isect-coord
		 (let ((max-shrinkage (- (case direction
					   ((left right) nwidth)
					   ((up down) nheight))
					 shrink-window-minimum-size)))
		   (when (positivep max-shrinkage)
		     (case direction
		       ((left) (setq nwidth (- nwidth
					       (min max-shrinkage
						    (- (right wr)
						       isect-coord)))))
		       ((up) (setq nheight (- nheight
					      (min max-shrinkage
						   (- (bottom wr)
						      isect-coord)))))
		       ((right) (setq nwidth (- nwidth
						(min max-shrinkage
						     (- isect-coord
							(left wr))))))
		       ((down) (setq nheight (- nheight
						(min max-shrinkage
						     (- isect-coord
							(top wr))))))))))
	(let ((tem (cons nwidth nheight)))
	  (maximize-truncate-dims window tem)
	  (setq nwidth (car tem)
		nheight (cdr tem)))
	(case direction
	  ((right) (setq nleft (+ nleft (- (car wdim) nwidth))))
	  ((down) (setq ntop (+ ntop (- (cdr wdim) nheight)))))
	(let ((pointerw (query-pointer-window)))
	  (move-resize-window-to window nleft ntop nwidth nheight)
	  (maybe-warp-pointer window wr direction (eql window pointerw))))))

  (define (yank-window window direction)
    "Moves WINDOW towards DIRECTION (left, right, up or down) until
WINDOW overlaps with one less window than before."
    (let* ((wr (window-frame-rect window))
	   (isect-coord (find-least-intersection window wr direction t))
	   (nleft (left wr))
	   (ntop (top wr)))
      (and isect-coord
	   (case direction
	     ((left) (let ((max-move (- (right wr)
					yank-window-minimum-visible)))
		       (when (positivep max-move)
			 (setq nleft (- nleft
					(min max-move
					     (- (right wr) isect-coord)))))))
	     ((up) (let ((max-move (- (bottom wr)
				      yank-window-minimum-visible)))
		     (when (positivep max-move)
		       (setq ntop (- ntop
				     (min max-move
					  (- (bottom wr) isect-coord)))))))
	     ((right) (let ((max-pos (- (screen-width)
					yank-window-minimum-visible)))
			(when (< (left wr) max-pos)
			  (setq nleft (min max-pos isect-coord)))))
	     ((down) (let ((max-pos (- (screen-height)
				       yank-window-minimum-visible)))
		       (when (< (top wr) max-pos)
			 (setq ntop (min max-pos isect-coord))))))
	   (let ((pointerw (query-pointer-window)))
	     (move-window-to window nleft ntop)
	     (maybe-warp-pointer window wr
				 direction (eql window pointerw)))))))

;; Based on gradient and Step themes created by:
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;; Copyright (C) 1999 Michele Campeotto <micampe@f2s.com>

;; Copyright (C) 2009-2011 Sergey Kozhemyakin <serg.kozhemyakin@gmail.com>

(define theme-name 'gradient-tabbed)

(require 'gradient)

;; customize variables

(defgroup gradient-tabbed "Gradient Tabbed Theme"
  :group appearance)

(defcustom gradient-tabbed:gradient-type 'horizontal
  "Direction of gradient in frame style."
  :type symbol
  :options (horizontal vertical diagonal)
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:normal-from-color (get-color "#a8a8a8")
  "`From' color of inactive frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:normal-to-color (get-color "#a8a8a8")
  "`To' color of inactive frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:active-from-color (get-color "#64b4df")
  "`From' color of active frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:active-to-color (get-color "#000030")
  "`To' color of active frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:active-handle-color (get-color "#64b4df")
  "Color of handles for active frame."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:inactive-handle-color (get-color "#a8a8a8")
  "Color of handles for inactive frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:active-close-color (get-color "#64b4df")
  "Color of close button for active frame."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:inactive-close-color (get-color "#a8a8a8")
  "Color of close button for inactive frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:active-menu-color (get-color "#64b4df")
  "Color of menu button for active frame."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:inactive-menu-color (get-color "#a8a8a8")
  "Color of menu button for inactive frames."
  :type color
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

(defcustom gradient-tabbed:save-memory t
  "Use less memory when creating gradients, possibly affecting quality."
  :type boolean
  :group (appearance gradient-tabbed)
  :after-set after-setting-frame-option)

;; helpers definitions

(define text-colors (list "grey50" "white"))

(define render-bg
  (lambda (img state)
    (apply (cond ((eq gradient-tabbed:gradient-type 'diagonal)
                  draw-diagonal-gradient)
                 ((eq gradient-tabbed:gradient-type 'horizontal)
                  draw-horizontal-gradient)
                 ((eq gradient-tabbed:gradient-type 'vertical)
                  draw-vertical-gradient))
           img (if state
                   (list gradient-tabbed:active-from-color
                         gradient-tabbed:active-to-color)
                 (list gradient-tabbed:normal-from-color
                       gradient-tabbed:normal-to-color)))
    (when (> (cdr (image-dimensions img)) 4)
      (bevel-image img 1 (not (eq state 'clicked))))
    (set-image-border img 1 1 1 1)))

(define scale (lambda () (if gradient-tabbed:save-memory 2 1)))
(define border-color (get-color "black"))

(define render-menu-button
  (lambda (img state)
    (clear-image
     img
     (if state
         gradient-tabbed:active-menu-color
       gradient-tabbed:inactive-menu-color))
    (when (> (cdr (image-dimensions img)) 4)
      (bevel-image img 1 (not (eq state 'clicked))))
    (set-image-border img 1 1 1 1)))

(define render-close-button
  (lambda (img state)
    (clear-image
     img
     (if state
         gradient-tabbed:active-close-color
       gradient-tabbed:inactive-close-color))
    (when (> (cdr (image-dimensions img)) 4)
      (bevel-image img 1 (not (eq state 'clicked))))
    (set-image-border img 1 1 1 1)))

(define menu-button
  (list
   (make-image "minimize-button.png")
   (make-image "minimize-button.png")
   nil
   (make-image "minimize-pressed.png")))

(define close-button
  (list
   (make-image "close-button.png")
   (make-image "close-button.png")
   nil
   (make-image "close-pressed.png")))

(define render-resizebar
  (lambda (img state)
    (clear-image
     img
     (if state
         gradient-tabbed:active-from-color
       gradient-tabbed:normal-from-color))
    (when (> (cdr (image-dimensions img)) 4)
      (bevel-image img 1 (not (eq state 'clicked))))
    (set-image-border img 1 1 1 1)))

(define render-resizebar-handle
  (lambda (img state)
    (clear-image
     img
     (if state
         gradient-tabbed:active-handle-color
       gradient-tabbed:inactive-handle-color))
    (when (> (cdr (image-dimensions img)) 4)
      (bevel-image img 1 (not (eq state 'clicked))))
    (set-image-border img 1 1 1 1)))

(define menu
  `((renderer . ,render-menu-button)
    (foreground . ,menu-button)
    (left-edge . 0)
    (width . 21)
    (top-edge . -21)
    (height . 21)
    (class . menu-button)
    (removable . nil)))

(define close
  `((renderer . ,render-close-button)
    (foreground . ,close-button)
    (right-edge . 0)
    (width . 21)
    (top-edge . -21)
    (height . 21)
    (class . close-button)
    (removable . nil)))

(define tab
  `((renderer . ,render-bg)
    (foreground . ,text-colors)
    (top-edge . -21)
    (height . 21)
    (text . ,window-name)
    (x-justify . 10)
    (y-justify . center)
    (class . tabbar-horizontal)))

(define transient-titlebar
  `((renderer . ,render-bg)
    (foreground . ,text-colors)
    (x-justify . 10)
    (y-justify . center)
    (left-edge . 0)
    (right-edge . 0)
    (top-edge . -21)
    (height . 21)
    (text . ,window-name)
    (class . title)))

(define resizebar
  `((renderer . ,render-resizebar)
    (left-edge . 29)
    (right-edge . 29)
    (bottom-edge . -6)
    (height . 6)
    (class . bottom-border)))

(define full-resizebar-top
  `((renderer . ,render-resizebar)
    (left-edge . 0)
    (right-edge . 0)
    (top-edge . -6)
    (height . 6)
    (class . top-border)))

(define full-resizebar-bottom
  `((renderer . ,render-resizebar)
    (left-edge . 0)
    (right-edge . 0)
    (bottom-edge . -6)
    (height . 6)
    (class . bottom-border)))

(define resizebar-right
  `((renderer . ,render-resizebar-handle)
    (right-edge . 0)
    (width . 29)
    (bottom-edge . -6)
    (height . 6)
    (class . bottom-right-corner)))

(define resizebar-left
  `((renderer . ,render-resizebar-handle)
    (left-edge . 0)
    (width . 29)
    (bottom-edge . -6)
    (height . 6)
    (class . bottom-left-corner)))

(define left-border
  `((background . ,border-color)
    (left-edge . -1)
    (width . 1)
    (top-edge . -21)
    (bottom-edge . -6)
    (class . left-border)))

(define right-border
  `((background . ,border-color)
    (right-edge . -1)
    (width . 1)
    (top-edge . -21)
    (bottom-edge . -6)
    (class . right-border)))

(define left-transient-border
  `((background . ,border-color)
    (left-edge . -1)
    (width . 1)
    (top-edge . -21)
    (bottom-edge . -1)
    (class . left-border)))

(define right-transient-border
  `((background . ,border-color)
    (right-edge . -1)
    (width . 1)
    (top-edge . -21)
    (bottom-edge . -1)
    (class . right-border)))

(define bottom-border
  `((background . ,border-color)
    (left-edge . -1)
    (right-edge . -1)
    (bottom-edge . -1)
    (height . 1)
    (class . bottom-border)))

(define top-border
  `((background . ,border-color)
    (left-edge . -1)
    (right-edge . -1)
    (top-edge . -22)
    (height . 1)
    (class . top-border)))

;; frames definitions

(define frame
  `(,menu
    ,close
    ,tab
    ,resizebar
    ,resizebar-left
    ,resizebar-right
    ,left-border
    ,right-border
    ,top-border))

(define shaped-frame
  `(,menu
    ,close
    ,tab
    ,left-transient-border
    ,right-transient-border
    ,bottom-border
    ,top-border))

(define transient-frame
  `(,tab
    ,left-transient-border
    ,right-transient-border
    ,bottom-border
    ,top-border))

(define shaped-transient-frame
  `(,tab))

;; build frames

(define create-frames
  (lambda ()
    (let ((gradient-tabbed-left-d-w 0)
          (gradient-tabbed-right-d-w 0)
          (gradient-tabbed-left-m 21)
          (gradient-tabbed-rigth-m 21)
          (gradient-tabbed-left-m-t 0)
          (gradient-tabbed-right-m-t 0))
      (require 'sawfish.wm.tabs.tab)
      (set-tab-adjustments #:theme-left-dec-width gradient-tabbed-left-d-w
                           #:theme-right-dec-width gradient-tabbed-right-d-w
                           #:theme-left-margin gradient-tabbed-left-m
                           #:theme-right-margin gradient-tabbed-rigth-m
                           #:theme-left-margin-transient gradient-tabbed-left-m-t
                           #:theme-right-margin-transient gradient-tabbed-right-m-t))))

(define (frame-style-name w)
  (when (eq (window-get w 'current-frame-style) theme-name)
    (set-tab-theme-name #:frame-style-supported-tabs theme-name)))

(define (get-frame w type)
  (create-frames)
  (case type
        ((default) frame)
        ((transient) transient-frame)
        ((shaped) shaped-frame)
        ((shaped-transient) shaped-transient-frame)))

(create-frames)

(add-frame-style theme-name get-frame)
(call-after-state-changed '(tab-theme-name) frame-style-name)

#| theme.jl for Arlo's new theme design

   Copyright (C) 2001 Eazel, Inc.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   $Id: theme.jl,v 1.1 2001/01/20 02:40:30 jsh Exp $

   Authors: John Harper <jsh@eazel.com>
|#

(require 'rep.data.tables)		;need hash tables for icon cache
(require 'sawfish.wm.util.recolor-image)

(defgroup Crux "Crux Theme"
  :group appearance)

(defcustom Crux:normal-color nil
  "Accent color for focused windows (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Crux)
  :user-level novice
  :after-set (lambda () (color-changed)))

(defcustom Crux:show-window-icons nil
  "Display the window's icon in its menu button."
  :type boolean
  :group (appearance Crux)
  :after-set (lambda () (rebuild-all)))

(defcustom Crux:button-theme 'windows
  "Display title buttons to mimic: \\w"
  :type (choice (platinum "MacOS Platinum")
		(macos-x "MacOS X")
		(windows "MS Windows")
		(next "NeXTSTEP"))
  :group (appearance Crux)
  :after-set (lambda () (reframe-all)))

;; maps WINDOW -> BUTTON-LIST
(define button-table (make-weak-table eq-hash eq))


;; images

;; 16x3
(define top-left-border
  (list (make-image "inactive:top-left-border.png")
	(make-image "active:top-left-border.png")))

;; 18x3
(define top-right-border
  (list (make-image "inactive:top-right-border.png")
	(make-image "active:top-right-border.png")))

;; 16*x3
(define top-center-left-border
  (list (set-image-border
	 (make-image "inactive:top-center-left-border.png") 0 13 0 0)
	(set-image-border
	 (make-image "active:top-center-left-border.png") 0 13 0 0)))

;; 16*x3
(define top-center-right-border
  (list (make-image "inactive:top-center-right-border.png")
	(make-image "active:top-center-right-border.png")))

;; 48*x19
(define top-center-left
  (list (make-image "inactive:top-center-left.png")
	(make-image "active:top-center-left.png")))

;; 48*x19
(define top-center-mid
  (list (make-image "inactive:top-center-mid.png")
	(make-image "active:top-center-mid.png")))

;; 48*x19
(define top-center-right
  (list (make-image "inactive:top-center-right.png")
	(make-image "active:top-center-right.png")))

;; 4x18
(define left-top-border
  (list (make-image "inactive:left-top-border.png")
	(make-image "active:left-top-border.png")))
(define left-top-border-shaped
  (list (make-image "inactive:left-top-border-shaped.png")
	(make-image "active:left-top-border-shaped.png")))

;; 5x16*
(define left-border
  (list (make-image "inactive:left-border.png")
	(make-image "active:left-border.png")))

;; 5x18
(define right-top-border
  (list (make-image "inactive:right-top-border.png")
	(make-image "active:right-top-border.png")))
(define right-top-border-shaped
  (list (make-image "inactive:right-top-border-shaped.png")
	(make-image "active:right-top-border-shaped.png")))

;; 6x16*
(define right-border
  (list (make-image "inactive:right-border.png")
	(make-image "active:right-border.png")))

;; 5x6
(define bottom-left-corner
  (list (make-image "inactive:bottom-left-corner.png")
	(make-image "active:bottom-left-corner.png")))

;; 32*x6
(define bottom-left-border
  (list (set-image-border (make-image "inactive:bottom-left-border.png") 0 30 0 0)
	(set-image-border (make-image "active:bottom-left-border.png") 0 30 0 0)))

;; 16*x6
(define bottom-right-border
  (list (make-image "inactive:bottom-right-border.png")
	(make-image "active:bottom-right-border.png")))

;; 6x6
(define bottom-right-corner
  (list (make-image "inactive:bottom-right-corner.png")
	(make-image "active:bottom-right-corner.png")))

;; 16x16
(define menu-button
  `((inactive . ,(make-image "inactive:menu-button.png"))
    (focused . ,(make-image "active:menu-button.png"))
    (inactive-highlighted . ,(make-image "inactive:menu-button-hilight.png"))
    (highlighted . ,(make-image "active:menu-button-hilight.png"))
    (inactive-clicked . ,(make-image "inactive:menu-button-pressed.png"))
    (clicked . ,(make-image "active:menu-button-pressed.png"))))
(define button-background
  `((inactive . ,(make-image "inactive:button.png"))
    (focused . ,(make-image "active:button.png"))
    (inactive-highlighted . ,(make-image "inactive:button-hilight.png"))
    (highlighted . ,(make-image "active:button-hilight.png"))
    (inactive-clicked . ,(make-image "inactive:button-pressed.png"))
    (clicked . ,(make-image "active:button-pressed.png"))))

;; 12x12
(define minimize-fg
  `((inactive . ,(make-image "inactive:minimize-button.png"))
    (focused . ,(make-image "active:minimize-button.png"))))
(define maximize-fg
  `((inactive . ,(make-image "inactive:maximize-button.png"))
    (focused . ,(make-image "active:maximize-button.png"))))
(define close-fg
  `((inactive . ,(make-image "inactive:close-button.png"))
    (focused . ,(make-image "active:close-button.png"))))
(define shade-fg
  `((inactive . ,(make-image "inactive:shade-button.png"))
    (focused . ,(make-image "active:shade-button.png"))))


;; geometry computations

(define (title-left-width w)
  (let ((buttons (table-ref button-table w)))
    (max 0 (min (- (car (window-dimensions w))
		   (* (length (cdr buttons)) 18))
		(+ (text-width (window-name w)) 52
		   (* (length (car buttons)) 18))))))

(define (top-border-left-width w)
  (let ((buttons (table-ref button-table w)))
    (max 0 (min (- (car (window-dimensions w)) (* (length (cdr buttons)) 18))
		(+ (title-left-width w) -43)))))

(define (bottom-border-left-width w)
  (max 0 (min (car (window-dimensions w))
	      (+ (title-left-width w)
		 (quotient (cdr (window-dimensions w)) 2)))))

(define (vertical-justification)
  ;; `center' justification adjusted for the 3-pixel top-border
  (max 0 (- (/ (- 22 (font-height default-font)) 2) 3)))

(define (horizontal-justification w)
  (+ (* (length (car (table-ref button-table w))) 18) 2))


;; recolouring images

(define (foreground-color)
  (if (colorp Crux:normal-color)
      Crux:normal-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
	(nth 3 gtkrc-background)
      (get-color "steelblue"))))

;; Recolor all images that need recolouring. Precalculates the lookup
;; tables first.
(define (recolor-all)
  ;; Use the SELECTED state of the background colors as the
  ;; midpoint of the gradient for recolouring images. (This is
  ;; usually a bright, contrasting colour, and thus is the
  ;; best choice. It works particularly well with the Eazel-Foo
  ;; themes)
  (let ((recolorer (make-image-recolorer (foreground-color)
					 #:zero-channel blue-channel
					 #:index-channel green-channel)))
    (mapc (lambda (x) (mapc recolorer (cdr x)))
	  (list top-left-border
		top-center-left-border
		top-center-left
		top-center-mid
		left-top-border
		left-top-border-shaped
		left-border
		bottom-left-corner
		bottom-left-border))
    (mapc (lambda (x)
	    (recolorer (cdr x))) menu-button)))


;; window icons

(define icon-table (make-weak-table eq-hash eq))

(define (window-icon w)
  (when Crux:show-window-icons
    (or (table-ref icon-table w)
	(let ((icon (window-icon-image w)))
	  (when icon
	    (let ((scaled (scale-image icon 12 12)))
	      (table-set icon-table w scaled)
	      scaled))))))


;; frames

(define common-frame-parts
  `(((background . ,top-left-border)
     (left-edge . -5)
     (top-edge . -22)
     (class . top-left-corner))

    ((background . ,top-center-left-border)
     (left-edge . 11)
     (top-edge . -22)
     (width . ,top-border-left-width)
     (class . top-border))
    ((background . ,top-center-right-border)
     (left-edge . ,(lambda (w) (+ (top-border-left-width w) 11)))
     (right-edge . 10)
     (top-edge . -22)
     (class . top-border))

    ((background . ,top-center-left)
     (left-edge . -2)
     (width . ,(lambda (w) (+ (title-left-width w) 2 -48)))
     (top-edge . -19)
     (text . ,window-name)
     (foreground . ("grey95" "white"))
     (x-justify . ,horizontal-justification)
     (y-justify . ,vertical-justification)
     (class . title))
    ((background . ,top-center-mid)
     (left-edge . ,(lambda (w) (max 0 (- (title-left-width w) 48))))
     (top-edge . -19)
     (class . title))
    ((background . ,top-center-right)
     (left-edge . ,title-left-width)
     (right-edge . -1)
     (top-edge . -19)
     (class . title))

    ((background . ,top-right-border)
     (right-edge . -6)
     (top-edge . -22)
     (class . top-right-corner))))

(define normal-frame
  `(,@common-frame-parts

    ((background . ,left-top-border)
     (left-edge . -5)
     (top-edge . -19)
     (class . top-left-corner))
    ((background . ,right-top-border)
     (right-edge . -6)
     (top-edge . -19)
     (class . top-right-corner))

    ((background . ,left-border)
     (left-edge . -5)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . left-border))

    ((background . ,bottom-left-corner)
     (left-edge . -5)
     (bottom-edge . -6)
     (class . bottom-left-corner))

    ((background . ,right-border)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))

    ((background . ,bottom-right-corner)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))

    ((background . ,bottom-left-border)
     (left-edge . 0)
     (width . ,bottom-border-left-width)
     (bottom-edge . -6)
     (class . bottom-border))
    ((background . ,bottom-right-border)
     (left-edge . ,bottom-border-left-width)
     (right-edge . 0)
     (bottom-edge . -6)
     (class . bottom-border))))

(define shaped-frame
  `(,@common-frame-parts

    ((background . ,left-top-border-shaped)
     (left-edge . -5)
     (top-edge . -19)
     (class . top-left-corner))
    ((background . ,right-top-border-shaped)
     (right-edge . -6)
     (top-edge . -19)
     (class . top-right-corner))))


;; packing buttons

(define button-map
  `((iconify-button . ,minimize-fg)
    (maximize-button . ,maximize-fg)
    (close-button . ,close-fg)
    (menu-button . ,window-icon)
    (shade-button . ,shade-fg)))

(define (button-theme type)
  (case Crux:button-theme
    ((platinum)
     '((close-button) . (maximize-button shade-button)))
    ((macos-x)
     '((close-button maximize-button iconify-button) . ()))
    ((windows)
     (if (eq type 'transient)
	 '((menu-button) . (close-button))
       '((menu-button) . (iconify-button maximize-button close-button))))
    ((next)
     '((iconify-button) . (close-button)))))

(define (make-buttons spec background edge)

  (define (make-button class fg point)
    `((background . ,background)
      (foreground . ,fg)
      (x-justify . 2)
      (y-justify . 2)
      (,edge . ,point)
      (top-edge . -19)
      (class . ,class)))

  (do ((rest spec (cdr rest))
       (point -1 (+ point 18))
       (out '() (cons (make-button (car rest)
				   (cdr (assq (car rest) button-map))
				   point) out)))
      ((null rest) out)))


;; misc stuff

(define (rebuild-all)
  (rebuild-frames-with-style 'Crux))

(define (reframe-all)
  (reframe-windows-with-style 'Crux))

(define (color-changed)
  (recolor-all)
  (reframe-all))

(define (make-frame w frame buttons)
  (table-set button-table w buttons)
  (append frame
	  (make-buttons (car buttons) menu-button 'left-edge)
	  (make-buttons (reverse (cdr buttons)) button-background 'right-edge)))

(define (get-frame w type)
  (case type
    ((default)
     (make-frame w normal-frame (button-theme 'normal)))
    ((transient)
     (make-frame w normal-frame (button-theme 'transient)))
    ((shaped)
     (make-frame w shaped-frame (button-theme 'normal)))
    ((shaped-transient)
     (make-frame w shaped-frame (button-theme 'transient)))))


;; initialization

(define initialize-gtkrc
  (let ((done nil))
    (lambda ()
      (unless done
	(require 'gtkrc)
	;; recolour everything when the GTK theme changes
	(gtkrc-call-after-changed color-changed)
	(setq done t)))))

;; setup the initial colours
(recolor-all)

;; register the theme
(add-frame-style 'Crux get-frame)

;; recalibrate frames when the window-name changes
(call-after-property-changed 'WM_NAME rebuild-all)

;; StyleTab

(define theme-name 'StyleTab)

;;need hash tables for icon cache 
(require 'rep.data.tables)

;; recolor imanges
(require 'sawfish.wm.util.recolor-image)

;; Defcustom and defgroup
(defgroup StyleTab:group "StyleTab"
  :group appearance)

(defgroup StyleTab:top-buttons-group "Top Titlebar Buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:bottom-buttons-group "Bottom Titlebar Buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:left-buttons-group "Left Titlebar Buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:right-buttons-group "Right Titlebar Buttons"
  :group (appearance StyleTab:group))

(defcustom styletab-c:titlebar-place 'top "Titlebar default place."
  :group (appearance StyleTab:group)
  :type symbol
  :options (top bottom left right))

(defcustom styletab-c:title-dimension 24 "Height of title border."
  :group (appearance StyleTab:group)
  :type symbol
  :options (16 18 20 22 24 26 28 30 32))

(defcustom styletab-c:borders-dimension 4 "Width of window border."
  :group (appearance StyleTab:group)
  :type symbol
  :options (0 2 4 6 8))

(defcustom styletab-c:custom-button-width nil "Customize buttons width."
  :group (appearance StyleTab:group)
  :type boolean)

(defcustom styletab-c:button-width 0 "Width of Buttons."
  :group (appearance StyleTab:group)
  :type symbol
  :depends styletab-c:custom-button-width
  :options (1 2 3 4 0 -1 -2 -3 -4))

(defcustom styletab-c:styles 'Default "Frame and button style."
  :group (appearance StyleTab:group)
  :type symbol
  :options (Default Reduce Glass WixDa Smoothly))

(defcustom styletab-c:proposals 'Pink "Color proposals."
  :group (appearance StyleTab:group)
  :type symbol
  :options (Default Reduce Glass WixDa Smoothly Brown Darkblue Blue Pink Green)
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:hightlight-tabbar nil "Also hightlighted tabbars."
  :group (appearance StyleTab:group)
  :type boolean
  :after-set (lambda () (botton-color-changed recolor-tab)))

(defcustom styletab-c:custom-frame-colors nil "Customize frame color/brightness (Don't use color proposals)."
  :group (appearance StyleTab:group)
  :type boolean
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:focus-frame-color (get-color "#780000")
  "Focus frame color."
  :group (appearance StyleTab:group)
  :type color
  :depends styletab-c:custom-frame-colors
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:unfocus-frame-color (get-color "#780000")
  "Inactive frame color"
  :group (appearance StyleTab:group)
  :type color
  :depends styletab-c:custom-frame-colors
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:inactive-dimout 2 "Dimout inactive frame."
  :group (appearance StyleTab:group)
  :depends styletab-c:custom-frame-colors
  :type symbol
  :options (0 1 2 3 4 5)
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:active-hightlight-brighten 2 "Focus window brightness mouse over buttons."
  :group (appearance StyleTab:group)
  :depends styletab-c:custom-frame-colors
  :type symbol
  :options (1 2 3 4 5 0 -1 -2 -3 -4 -5)
  :after-set (lambda () (bright-changed)))

(defcustom styletab-c:inactive-hightlight-brighten 2 "Inactive windows brightness mouse over buttons."
  :group (appearance StyleTab:group)
  :type symbol
  :depends styletab-c:custom-frame-colors
  :options (1 2 3 4 5 0 -1 -2 -3 -4 -5)
  :after-set (lambda () (bright-changed)))

(defcustom styletab-c:hightlight-close nil
  "Hightlighted close button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-close-button)))

(defcustom styletab-c:hightlight-close-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-close
  :after-set (lambda () (botton-color-changed recolor-close-button)))

(defcustom styletab-c:hightlight-maximize nil
  "Hightlighted maximize button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-maximize-button)))

(defcustom styletab-c:hightlight-maximize-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-maximize
  :after-set (lambda () (botton-color-changed recolor-maximize-button)))

(defcustom styletab-c:hightlight-iconify nil
  "Hightlighted minimize button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-iconify-button)))

(defcustom styletab-c:hightlight-iconify-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-iconify
  :after-set (lambda () (botton-color-changed recolor-iconify-button)))

(defcustom styletab-c:hightlight-shade nil
  "Hightlighted shade button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-shade-button)))

(defcustom styletab-c:hightlight-shade-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-shade
  :after-set (lambda () (botton-color-changed recolor-shade-button)))

(defcustom styletab-c:hightlight-sticky nil
  "Hightlighted sticky button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-sticky-button)))

(defcustom styletab-c:hightlight-sticky-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-sticky
  :after-set (lambda () (botton-color-changed recolor-sticky-button)))

(defcustom styletab-c:hightlight-menu nil
  "Hightlighted menu button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-menu-button)))

(defcustom styletab-c:hightlight-menu-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-menu
  :after-set (lambda () (botton-color-changed recolor-menu-button)))

(defcustom styletab-c:hightlight-frame-type nil
  "Hightlighted frame type button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-frame-type-button)))

(defcustom styletab-c:hightlight-frame-type-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-frame-type
  :after-set (lambda () (botton-color-changed recolor-frame-type-button)))

(defcustom styletab-c:hightlight-lock nil
  "Hightlighted lock button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-lock-button)))

(defcustom styletab-c:hightlight-lock-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-lock
  :after-set (lambda () (botton-color-changed recolor-lock-button)))

(defcustom styletab-c:hightlight-move-resize nil
  "Hightlighted move/resize button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-move-resize-button)))

(defcustom styletab-c:hightlight-move-resize-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-move-resize
  :after-set (lambda () (botton-color-changed recolor-move-resize-button)))

(defcustom styletab-c:hightlight-raise-lower nil
  "Hightlighted raise/lower button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-raise-lower-button)))

(defcustom styletab-c:hightlight-raise-lower-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-raise-lower
  :after-set (lambda () (botton-color-changed recolor-raise-lower-button)))

(defcustom styletab-c:hightlight-next nil
  "Hightlighted next workspace button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-next-button)))

(defcustom styletab-c:hightlight-next-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-next
  :after-set (lambda () (botton-color-changed recolor-next-button)))

(defcustom styletab-c:hightlight-prev nil
  "Hightlighted previous workspace button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-prev-button)))

(defcustom styletab-c:hightlight-prev-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-prev
  :after-set (lambda () (botton-color-changed recolor-prev-button)))

(defcustom styletab-c:hightlight-rename nil
  "Hightlighted rename button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-rename-button)))

(defcustom styletab-c:hightlight-rename-all nil "Always use."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-rename
  :after-set (lambda () (botton-color-changed recolor-rename-button)))

(mapc
 (lambda (arg)
   (let ((type-list ;; ":type" in defcustom
          (append '(v-and)
                  (make-list 10
                             ;; Here, `list' is necessary. If you
                             ;; replace it with a quote, the configurator
                             ;; crashes.
                             (list 'h-and '(choice \(none\) close menu maximize minimize shade sticky space send-to-prev
                                                   send-to-next lock raise-lower move-resize rename frame-type)
                                   '(boolean "Also show in transients"))))))
     (eval
      (macroexpand
       `(defcustom ,(car arg) ;; name
          ,(cadr arg) ;; default value
          ,(caddr arg) ;; doc
          :group
          ,`(appearance StyleTab:group
                        ,(cadddr arg))
          :type ,type-list
          ))))) ;; end of lambda
 '( ;; list to pass to mapc
   (styletab-c:top-left-buttons
    '((menu t) (sticky nil) (shade nil))
    "Top Titlebar Left Buttons (from left to right) \\top"
    StyleTab:top-buttons-group)
   (styletab-c:top-right-buttons
    '((close t) (maximize t) (minimize nil))
    "Top Titlebar Right Buttons (from right to left) \\top"
    StyleTab:top-buttons-group)
   (styletab-c:bottom-left-buttons
    '((menu t) (sticky nil) (shade nil))
    "Bottom Titlebar Left Buttons (from left to right) \\top"
    StyleTab:bottom-buttons-group)
   (styletab-c:bottom-right-buttons
    '((close t) (maximize t) (minimize nil))
    "Bottom Titlebar Right Buttons (from right to left) \\top"
    StyleTab:bottom-buttons-group)
   (styletab-c:left-top-buttons
    '((close t) (maximize t) (minimize nil))
    "Left Titlebar Top Buttons (from top to bottom) \\top"
    StyleTab:left-buttons-group)
   (styletab-c:left-bottom-buttons
    '((menu t) (sticky nil) (shade nil))
    "Left Titlebar Bottom Buttons (from bottom to top) \\top"
    StyleTab:left-buttons-group)
   (styletab-c:right-top-buttons
    '((close t) (maximize t) (minimize nil))
    "Right Titlebar Top Buttons (from top to bottom) \\top"
    StyleTab:right-buttons-group)
   (styletab-c:right-bottom-buttons
    '((menu t) (sticky nil) (shade nil))
    "Right Titlebar Bottom Buttons (from bottom to top) \\top"
    StyleTab:right-buttons-group)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; styles settings 

(define proposals-colors
  (lambda ()
    (case styletab-c:proposals
          ;; format "color" "dimout inactive frame" "brighte mouse over button active" "brighte mouse over button inactive"
          ((Default) (list "#000033" '40 '100 '100))
          ((Reduce) (list "#000000" '0 '100 '100))
          ((Glass) (list "#5E5E70" '60 '40 '60))
          ((WixDa) (list "#6E6D8F" '20 '40 '60))
          ((Smoothly) (list "#75759E" '20 '40 '40))
          ((Darkblue) (list "#00006E" '30 '70 '70))
          ((Brown) (list "#780000" '40 '40 '50))
          ((Blue) (list "#0000B4" '30 '40 '50))
          ((Pink) (list "#7F0081" '50 '50 '50))
          ((Green) (list "#006400" '30 '60 '60)))))

(define title-colors-images
  (lambda ()
    (case styletab-c:styles
          ((Default) (title-colors-default))
          ((Reduce) (title-colors-reduce))
          ((Glass) (title-colors-glass))
          ((WixDa) (title-colors-wixda))
          ((Smoothly) (title-colors-smoothly)))))

(define title-colors-default
  (lambda ()
    `((focused . "#F2F2F2") (highlighted . "#FEFEFE") (clicked . "#FEFEFE") (inactive . "#CBCBCB") (inactive-highlighted . "#D8D8D8")
      (inactive-clicked . "#D8D8D8"))))

(define title-colors-reduce
  (lambda ()
    `((focused . "#E5E5E5") (highlighted . "#FDFDFD") (clicked . "#FDFDFD") (inactive . "#B1B1B1") (inactive-highlighted . "#CBCBCB")
      (inactive-clicked . "#CBCBCB"))))

(define title-colors-glass
  (lambda ()
    `((focused . "#F2F2F2") (highlighted . "#FFFFFF") (clicked . "#FFFFFF") (inactive . "#D9D9D9") (inactive-highlighted . "#E6E6E6")
      (inactive-clicked . "#E6E6E6"))))

(define title-colors-wixda
  (lambda ()
    `((focused . "#262626") (highlighted . "#000000") (clicked . "#000000") (inactive . "#404040") (inactive-highlighted . "#333333")
      (inactive-clicked . "#333333"))))

(define title-colors-smoothly
  (lambda ()
    `((focused . "#333333") (highlighted . "#000000") (clicked . "#000000") (inactive . "#666666") (inactive-highlighted . "#444444")
      (inactive-clicked . "#444444"))))

(define button-width-custom
  (lambda ()
    (if (eq styletab-c:custom-button-width t)
        (button-width-set)
      (case styletab-c:styles
            ((Default) (button-width-default))
            ((Reduce) (button-width-reduce))
            ((Glass) (button-width-glass))
            ((WixDa) (button-width-wixda))
            ((Smoothly) (button-width-smoothly))))))

(define button-width-add
  (lambda ()
    (if (eq styletab-c:custom-button-width nil)
        (button-width-zero)
      (case styletab-c:styles
            ((Default) (button-width-default))
            ((Reduce) (button-width-reduce))
            ((Glass) (button-width-glass))
            ((WixDa) (button-width-wixda))
            ((Smoothly) (button-width-smoothly))))))

(define button-width-set (lambda () (+ styletab-c:button-width (button-width-add))))
(define button-width-zero (lambda () 0))
(define button-width-default (lambda () 8))
(define button-width-reduce (lambda () 0))
(define button-width-glass (lambda () 0))
(define button-width-wixda (lambda () -4))
(define button-width-smoothly (lambda () 0))

;; end of tabtext
(define tabbar-right-edge-width
  (lambda ()
    (case styletab-c:styles
          ((Default) 3)
          ((Reduce) 6)
          ((Glass) 3)
          ((WixDa) 3)
          ((Smoothly) 3))))

;; edge of first buttons left/right
(define button-left-edge
  (lambda ()
    (case styletab-c:styles
          ((Default) 0)
          ((Reduce) 0)
          ((Glass) 0)
          ((WixDa) 0)
          ((Smoothly) 0))))

(define button-right-edge
  (lambda ()
    (case styletab-c:styles
          ((Default) 1)
          ((Reduce) 1)
          ((Glass) 0)
          ((WixDa) 0)
          ((Smoothly) 2))))

(define icon-edge
  (lambda ()
    (case styletab-c:styles
          ((Default) 2)
          ((Reduce) 2)
          ((Glass) 1)
          ((WixDa) 1)
          ((Smoothly) 2))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; frame-class, keys bindings

(define (rotate-tab src dest)
  (let ((w (current-event-window))
        (wins (tab-group-window-index (current-event-window)))
        pos-x pos-y fdim framew framehigh dim-x dim-y current-title type)
    (if (not (window-get w 'title-position))
        (case styletab-c:titlebar-place
              ((top) (setq current-title 'top))
              ((bottom) (setq current-title 'bottom))
              ((left) (setq current-title 'left))
              ((right) (setq current-title 'right)))
      (setq current-title (window-get w 'title-position)))
    (setq type (window-get w 'type))
    (setq pos-x (car (window-position w)))
    (setq pos-y (cdr (window-position w)))
    (setq dim-x (car (window-dimensions w)))
    (setq dim-y (cdr (window-dimensions w)))
    (setq fdim (window-frame-dimensions w))
    (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ dim-x dim-y styletab-c:title-dimension)) 3))

    (when (not (eq type 'unframed))
      (if (window-get w 'shaded) (unshade-window w))
      (if (eq src 'horiz)
          (if (eq dest 'opposite)
              (progn
                (if (eq current-title 'top)
                    (setq dest 'bottom)
                  (setq dest 'top))
                (when (>= (+ pos-y dim-y styletab-c:title-dimension framew) (screen-height))
                  (setq pos-y (- (screen-height) dim-y styletab-c:title-dimension framew)))
                (when (<= pos-y 0) (setq pos-y 0)))
            ;; To left or right
            (if (or (eq (window-get w 'type) 'default)
                    (eq (window-get w 'type) 'transient))
                (setq framehigh (+ (- styletab-c:title-dimension (* styletab-c:borders-dimension 2)) framew))
              (setq framehigh (+ styletab-c:title-dimension framew)))
            (setq dim-x (- dim-x framehigh))
            (setq dim-y (+ dim-y framehigh))
            (when (and (eq dest 'left) (<= pos-x 0))
              (setq pos-x 0))
            (when (and (eq dest 'right)
                       (>= (+ pos-x dim-x framehigh framew framew) (screen-width)))
              (setq pos-x (- (screen-width) dim-x styletab-c:title-dimension framew))))
        ;; vert
        (if (eq dest 'opposite)
            (progn
              (if (eq current-title 'left)
                  (progn
                    (setq dest 'right)
                    (when (>= (+ pos-x dim-x) (screen-width))
                      (setq pos-x (- (screen-width) dim-x styletab-c:title-dimension framew))))
                (setq dest 'left)
                (when (<= pos-x 0) (setq pos-x 0))))
          ;; To top or bottom
          (if (or (eq (window-get w 'type) 'default)
                  (eq (window-get w 'type) 'transient))
              (setq framehigh (- styletab-c:title-dimension (* styletab-c:borders-dimension 2)))
            (setq framehigh styletab-c:title-dimension))
          (setq dim-x (+ dim-x framehigh framew))
          (setq dim-y (- dim-y framehigh framew))
          (when (>= (+ pos-y dim-y styletab-c:title-dimension framew) (screen-height))
            (setq pos-y (- (screen-height) dim-y styletab-c:title-dimension framew)))
          (when (<= pos-y 0) (setq pos-y 0))))

      (mapcar (lambda (w)
                (window-put w 'title-position dest)) wins)
      (call-window-hook 'window-state-change-hook w (list '(title-position)))
      (mapcar (lambda (w)
                (reframe-window w)
                (move-window-to w pos-x pos-y)
                (resize-window-to w dim-x dim-y)) wins))))

(define (tabbartotop)
  "Move tab-bar to top."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'left)
            (eq (window-get w 'title-position) 'right))
        (rotate-tab 'vert 'top))
    (if (eq (window-get w 'title-position) 'bottom)
        (rotate-tab 'horiz 'opposite))))

(define (tabbartobottom)
  "Move tab-bar to bottom."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'left)
            (eq (window-get w 'title-position) 'right))
        (rotate-tab 'vert 'bottom))
    (if (eq (window-get w 'title-position) 'top)
        (rotate-tab 'horiz 'opposite))))

(define (tabbartoleft)
  "Move tab-bar to left."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'left))
    (if (eq (window-get w 'title-position) 'right)
        (rotate-tab 'vert 'opposite))))

(define (tabbartoright)
  "Move tab-bar to right."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'right))
    (if (eq (window-get w 'title-position) 'left)
        (rotate-tab 'vert 'opposite))))

(define (tabbartoggle)
  "Move tab-bar to the opposite side. (Swap top & bottom, or left & right)"
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'opposite)
      (rotate-tab 'vert 'opposite))))

(define-command-gaol 'tabbar-toggle tabbartoggle)
(define-command-gaol 'tabbar-to-top tabbartotop)
(define-command-gaol 'tabbar-to-bottom tabbartobottom)
(define-command-gaol 'tabbar-to-left tabbartoleft)
(define-command-gaol 'tabbar-to-right tabbartoright)

(def-frame-class tabbar-horizontal-left-edge ()
  (bind-keys tabbar-horizontal-left-edge-keymap
             "Button1-Off" 'tabbar-to-left
             "Button2-Off" 'tabbar-toggle
             "Button3-Off" 'tabbar-to-right))

(def-frame-class tabbar-vertical-top-edge ()
  (bind-keys tabbar-vertical-top-edge-keymap
             "Button1-Off" 'tabbar-to-top
             "Button2-Off" 'tabbar-toggle
             "Button3-Off" 'tabbar-to-bottom))

(define (f-type dest)
  (let ((w (current-event-window))
        (wins (tab-group-window-index (current-event-window)))
        pos-x pos-y dim-x dim-y cur new current-title)
    (if (not (window-get w 'title-position))
        (case styletab-c:titlebar-place
              ((top) (setq current-title 'top))
              ((bottom) (setq current-title 'bottom))
              ((left) (setq current-title 'left))
              ((right) (setq current-title 'right)))
      (setq current-title (window-get w 'title-position)))
    (setq pos-x (car (window-position w)))
    (setq pos-y (cdr (window-position w)))
    (setq dim-x (car (window-dimensions w)))
    (setq dim-y (cdr (window-dimensions w)))
    (setq cur (window-get w 'type))
    (if (window-get w 'shaded) (unshade-window w))

    (when (eq dest 'def-tra)
      (if (eq cur 'default)
          (setq new 'transient)
        (setq new 'default))
      (when (or (eq cur 'shaped)
                (eq cur 'utility))
        (setq new 'default)
        (setq dim-x (- dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (- dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (+ dim-x styletab-c:borders-dimension))
          (setq dim-y (- dim-y styletab-c:borders-dimension))))
      (when (eq cur 'shaped-transient)
        (setq new 'transient)
        (setq dim-x (- dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (- dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (+ dim-x styletab-c:borders-dimension))
          (setq dim-y (- dim-y styletab-c:borders-dimension))))
      (when (eq cur 'unframed)
        (setq new 'default)
        (when (or (eq current-title 'top)
                  (eq current-title 'bottom))
          (setq dim-x (- dim-x (* styletab-c:borders-dimension 2)))
          (setq dim-y (- dim-y styletab-c:borders-dimension styletab-c:title-dimension)))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-y (- dim-y (* styletab-c:borders-dimension 2)))
          (setq dim-x (- dim-x styletab-c:borders-dimension styletab-c:title-dimension)))))

    (when (eq dest 'sha-tra)
      (if (or (eq cur 'shaped)
              (eq cur 'utility))
          (setq new 'shaped-transient)
        (setq new 'shaped))
      (when (eq cur 'default)
        (setq new 'shaped)
        (setq dim-x (+ dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (+ dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (- dim-x styletab-c:borders-dimension))
          (setq dim-y (+ dim-y styletab-c:borders-dimension))))
      (when (eq cur 'transient)
        (setq new 'shaped-transient)
        (setq dim-x (+ dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (+ dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (- dim-x styletab-c:borders-dimension))
          (setq dim-y (+ dim-y styletab-c:borders-dimension))))
      (when (eq cur 'unframed)
        (setq new 'shaped)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (- dim-y styletab-c:title-dimension))
          (setq dim-x (- dim-x styletab-c:title-dimension)))))

    (when (eq dest 'unf-def)
      (when (or (eq cur 'default)
                (eq cur 'transient))
        (setq new 'unframed)
        (when (or (eq current-title 'top)
                  (eq current-title 'bottom))
          (setq dim-x (+ dim-x (* styletab-c:borders-dimension 2)))
          (setq dim-y (+ dim-y styletab-c:borders-dimension styletab-c:title-dimension)))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-y (+ dim-y (* styletab-c:borders-dimension 2)))
          (setq dim-x (+ dim-x styletab-c:borders-dimension styletab-c:title-dimension))))
      (when (or (eq cur 'shaped)
                (eq cur 'shaped-transient)
                (eq cur 'utility))
        (setq new 'unframed)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (+ dim-y styletab-c:title-dimension))
          (setq dim-x (+ dim-x styletab-c:title-dimension))))
      (when (eq cur 'unframed)
        (setq new 'shaped-transient)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (- dim-y styletab-c:title-dimension))
          (setq dim-x (- dim-x styletab-c:title-dimension)))))
    (when (not (eq cur new))
      (mapcar (lambda (w)
                (window-put w 'type new)
                (reframe-window w)
                (move-window-to w pos-x pos-y)
                (resize-window-to w dim-x dim-y)) wins))))

(define (set-frame-default-and-default/transient)
  "Set frametype to `default' and toggle transient-ness with resize."
  (f-type 'def-tra))

(define (set-frame-unframed-and-unframed/shaped-transient)
  "Set frametype to 'unframed' and toggle transient-ness with resize"
  (f-type 'unf-def))

(define (set-frame-shaped-and-shaped/shaped-transient)
  "Set frametype to shaped and toggle transient-ness with resize"
  (f-type 'sha-tra))

(define-command-gaol 'set-frame-default-and-default/transient-toggle set-frame-default-and-default/transient)
(define-command-gaol 'set-frame-unframed-and-unframed/shaped-transient-toggle set-frame-unframed-and-unframed/shaped-transient)
(define-command-gaol 'set-frame-shaped-and-shaped/shaped-transient-toggle set-frame-shaped-and-shaped/shaped-transient)

(def-frame-class frame-type-button ()
  (bind-keys frame-type-button-keymap
             "Button1-Off" 'set-frame-default-and-default/transient-toggle
             "Button2-Off" 'set-frame-unframed-and-unframed/shaped-transient-toggle
             "Button3-Off" 'set-frame-shaped-and-shaped/shaped-transient-toggle))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; make images/recolor 

;; button/icon table
(define styletab-c-icon-cache (make-weak-table eq-hash eq))

;; frames/title table
(define styletab-c-frame-cache (make-table equal-hash equal))

(define (window-icon w)
  (or (table-ref styletab-c-icon-cache w)
      (let ((icon (window-icon-image w)))
        (if icon
            (let ((scaled (scale-image icon (- styletab-c:title-dimension 7) (- styletab-c:title-dimension 7))))
              (table-set styletab-c-icon-cache w scaled)
              scaled)
          (scale-image top-frame-icon-title-images (- styletab-c:title-dimension 7) (- styletab-c:title-dimension 7))))))

(defun brighten-color (color percentage)
  (let* ((red (car (color-rgb color)))
         (green (cadr (color-rgb color)))
         (blue (car (cddr (color-rgb color))))
         (red-delta (quotient (* red percentage) 100))
         (green-delta (quotient (* green percentage) 100))
         (blue-delta (quotient (* blue percentage) 100)))
    (get-color-rgb (min (+ red-delta red) 65535)
                   (min (+ green-delta green) 65535)
                   (min (+ blue-delta blue) 65535))))

(defun darken-color (color percentage)
  (let* ((red (car (color-rgb color)))
         (green (cadr (color-rgb color)))
         (blue (car (cddr (color-rgb color))))
         (red-delta (quotient (* red percentage) 100))
         (green-delta (quotient (* green percentage) 100))
         (blue-delta (quotient (* blue percentage) 100)))
    (get-color-rgb (max (- red red-delta) 0)
                   (max (- green green-delta) 0)
                   (max (- blue blue-delta) 0))))

(define (get-recolor-dark dimout color)
  (darken-color color dimout))

(define (get-recolor-bright bright color)
  (brighten-color color bright))

(define (do-recolor img color)
  (let ((recolorer
         (make-image-recolorer color
                               #:zero-channel blue-channel
                               #:index-channel green-channel)))
    (recolorer img)
    img))

(define (do-make-get-image img)
  (or
   (table-ref styletab-c-frame-cache img)
   (let ((image
          (make-image img)))
     (table-set styletab-c-frame-cache img image)
     image)))


(define (base-tables-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
    (table-unset styletab-c-frame-cache w)
    (table-set styletab-c-frame-cache w `((focused . ,focus) (inactive . ,inact)))))

(define (tab-tables-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (highl (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-h.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-bright 
                                (if (eq styletab-c:hightlight-tabbar t) 
                                    (/ (* styletab-c:active-hightlight-brighten 20) 2) 0)
                                styletab-c:focus-frame-color) (get-recolor-bright 
                                                               (if (eq styletab-c:hightlight-tabbar t) 
                                                                   (/ (nth 2 (proposals-colors)) 2) 0)
                                                               (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors)))))))
        (in-hi (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-ih.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-bright 
                                (if (eq styletab-c:hightlight-tabbar t) 
                                    (- (/ (* styletab-c:inactive-hightlight-brighten 20) 2) (* styletab-c:inactive-dimout 20))
                                  (- (* styletab-c:inactive-dimout 20)))
                                styletab-c:unfocus-frame-color)
                             (get-recolor-bright (if (eq styletab-c:hightlight-tabbar t) 
                                                     (- (/ (nth 3 (proposals-colors)) 2) (nth 1 (proposals-colors)))
                                                   (- (nth 1 (proposals-colors))))
                                                 (get-color (nth 0 (proposals-colors))))))))
    (table-unset styletab-c-frame-cache w)
    (table-set styletab-c-frame-cache w `((focused . ,focus) (highlighted . ,highl) (inactive . ,inact) (inactive-highlighted . ,in-hi)))))

(define (base-button-tables-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (in-cl (do-recolor (do-make-get-image  (concat (symbol-name styletab-c:styles) "/" w "-c.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors)))))))
        (click (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-c.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
    (table-unset styletab-c-frame-cache w)
    (table-set styletab-c-frame-cache w  `((focused . ,focus) (clicked . ,click) (inactive . ,inact) (inactive-clicked . ,in-cl)))))

(define scale-w nil)
(define scale-h nil)
(define (button-tables-images w x color always)
  (if (or (equal w '"top")
          (equal w '"bottom"))
      (progn (setq scale-w (+ styletab-c:title-dimension (button-width-custom)))
             (setq scale-h (- styletab-c:title-dimension 4)))
    (progn (setq scale-w (- styletab-c:title-dimension 4))
           (setq scale-h (+ styletab-c:title-dimension (button-width-custom)))))
  (let ((focus (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-f.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-dark 0 (if (and always color) color styletab-c:focus-frame-color))
                                          (get-recolor-dark 0 (if (and always color) color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
        (highl (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-h.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-bright (* styletab-c:active-hightlight-brighten 20)
                                                                (if color color styletab-c:focus-frame-color))
                                          (get-recolor-bright (nth 2 (proposals-colors))
                                                              (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
        (click (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-c.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-bright (* styletab-c:active-hightlight-brighten 20)
                                                                (if color color styletab-c:focus-frame-color))
                                          (get-recolor-bright (nth 2 (proposals-colors))
                                                              (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
        (inact (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-i.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-dark (* styletab-c:inactive-dimout 20)
                                                              (if (and always color) color styletab-c:unfocus-frame-color))
                                          (get-recolor-dark (nth 1 (proposals-colors))
                                                            (if (and always color) color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
        (in-hi (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-ih.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-bright (- (* styletab-c:inactive-hightlight-brighten 20) (* styletab-c:inactive-dimout 20))
                                                                (if color color styletab-c:unfocus-frame-color))
                                          (get-recolor-bright (- (nth 3 (proposals-colors)) (nth 1 (proposals-colors)))
                                                              (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
        (in-cl (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-ic.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-bright (- (* styletab-c:inactive-hightlight-brighten 20) (* styletab-c:inactive-dimout 20))
                                                                (if color color styletab-c:unfocus-frame-color))
                                          (get-recolor-bright (- (nth 3 (proposals-colors)) (nth 1 (proposals-colors)))
                                                              (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h)))
    (table-unset styletab-c-frame-cache w)
    (table-set styletab-c-frame-cache (concat w "-frame-" x "-button") `((focused . ,focus) (highlighted . ,highl) (clicked . ,click) (inactive . ,inact)
                                                                         (inactive-highlighted . ,in-hi) (inactive-clicked . ,in-cl)))))

;; frames/tabbar
(define top-frame-icon-title-images
  (make-image (concat (symbol-name styletab-c:styles) "/" "top-frame-icon-title-images-f.png")))

(define (tabbar-horizontal-images)
  (mapcar (lambda (w) (mapcar (lambda (x)
                                (tab-tables-images (concat x "-" w))) (list "top" "bottom"))) (list "frame-tab-left-icon" "frame-tab" "frame-tab-right")))
(define (tabbar-vertical-images)
  (mapcar (lambda (w) (mapcar (lambda (x)
                                (tab-tables-images (concat x "-" w))) (list "left" "right"))) (list "frame-tab-top" "frame-tab" "frame-tab-bottom-icon")))
(define (title-cursor-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-title-cursor"))) (list "top" "bottom" "left" "right")))
(define (title-nocursor-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-title-nocursor"))) (list "top" "bottom" "left" "right")))
(define (top-border-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-top-border"))) (list "bottom" "left" "right")))
(define (top-left-corner-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-top-left-corner"))) (list "top" "bottom" "left" "right")))
(define (top-right-corner-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-top-right-corner"))) (list "top" "bottom" "left" "right")))
(define (top-left-corner-shaped-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-top-left-corner-shaped"))) (list "top" "left")))
(define (top-right-corner-shaped-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-top-right-corner-shaped"))) (list "top" "right")))
(define (title-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-title"))) (list "top" "bottom" "left" "right")))
(define (left-border-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-left-border"))) (list "top" "bottom" "right")))
(define (right-border-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-right-border"))) (list "top" "bottom" "left")))
(define (bottom-left-corner-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-bottom-left-corner"))) (list "top" "bottom" "left" "right")))
(define (bottom-border-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-bottom-border"))) (list "top" "left" "right")))
(define (bottom-right-corner-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-bottom-right-corner"))) (list "top" "bottom" "left" "right")))
(define (bottom-left-corner-shaped-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-bottom-left-corner-shaped"))) (list "bottom" "left")))
(define (bottom-right-corner-shaped-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-bottom-right-corner-shaped"))) (list "bottom" "right")))

;; buttons
(define (base-button-images)
  (mapcar (lambda (w) (base-button-tables-images (concat w "-frame-button"))) (list "top" "bottom" "left" "right")))
(define (space-button-images)
  (mapcar (lambda (w) (base-tables-images (concat w "-frame-title"))) (list "top" "bottom" "left" "right")))
(define (close-button-images)
  (mapcar (lambda (w) (button-tables-images w "close" styletab-c:hightlight-close
                                            (if (eq styletab-c:hightlight-close-all t) t))) (list "top" "bottom" "left" "right")))
(define (menu-button-images)
  (mapcar (lambda (w) (button-tables-images w "menu" styletab-c:hightlight-menu
                                            (if (eq styletab-c:hightlight-menu-all t) t))) (list "top" "bottom" "left" "right")))
(define (iconify-button-images)
  (mapcar (lambda (w) (button-tables-images w "iconify" styletab-c:hightlight-iconify
                                            (if (eq styletab-c:hightlight-iconify-all t) t))) (list "top" "bottom" "left" "right")))
(define (move-resize-button-images)
  (mapcar (lambda (w) (button-tables-images w "move-resize" styletab-c:hightlight-move-resize
                                            (if (eq styletab-c:hightlight-move-resize-all t) t))) (list "top" "bottom" "left" "right")))
(define (rename-button-images)
  (mapcar (lambda (w) (button-tables-images w "rename" styletab-c:hightlight-rename
                                            (if (eq styletab-c:hightlight-rename-all t) t))) (list "top" "bottom" "left" "right")))
(define (frame-type-button-images)
  (mapcar (lambda (w) (button-tables-images w "frame-type" styletab-c:hightlight-frame-type
                                            (if (eq styletab-c:hightlight-frame-type-all t) t))) (list "top" "bottom" "left" "right")))
(define (maximize-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-maximize
                                                                (if (eq styletab-c:hightlight-maximize-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "maximize" "unmaximize")))
(define (shade-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-shade
                                                                (if (eq styletab-c:hightlight-shade-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "shade" "unshade")))
(define (sticky-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-sticky
                                                                (if (eq styletab-c:hightlight-sticky-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "sticky" "unsticky")))
(define (lock-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-lock
                                                                (if (eq styletab-c:hightlight-lock-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "lock" "unlock")))
(define (prev-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-prev
                                                                (if (eq styletab-c:hightlight-prev-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "prev" "prev-last")))
(define (next-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-next
                                                                (if (eq styletab-c:hightlight-next-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "next" "next-last")))
(define (raise-lower-button-images)
  (mapcar (lambda (w) (mapcar (lambda (x) (button-tables-images x w styletab-c:hightlight-raise-lower
                                                                (if (eq styletab-c:hightlight-raise-lower-all t) t)))
                              (list "top" "bottom" "left" "right"))) (list "raise-lower" "ontop" "unontop")))
(define (recolor-base)
  (title-cursor-images) (title-nocursor-images) (top-border-images) (top-left-corner-images) (top-right-corner-images) (top-left-corner-shaped-images)
  (top-right-corner-shaped-images) (title-images) (left-border-images) (right-border-images) (bottom-left-corner-images) (bottom-border-images)
  (bottom-right-corner-images) (bottom-left-corner-shaped-images) (bottom-right-corner-shaped-images) (base-button-images) (space-button-images))

(define (recolor-tab)
  (tabbar-horizontal-images) (tabbar-vertical-images))

(define (recolor-close-button)
  (close-button-images))
(define (recolor-menu-button)
  (menu-button-images))
(define (recolor-iconify-button)
  (iconify-button-images))
(define (recolor-move-resize-button)
  (move-resize-button-images))
(define (recolor-rename-button)
  (rename-button-images))
(define (recolor-frame-type-button)
  (frame-type-button-images))
(define (recolor-maximize-button)
  (maximize-button-images))
(define (recolor-shade-button)
  (shade-button-images))
(define (recolor-sticky-button)
  (sticky-button-images))
(define (recolor-lock-button)
  (lock-button-images))
(define (recolor-prev-button)
  (prev-button-images))
(define (recolor-next-button)
  (next-button-images))
(define (recolor-raise-lower-button)
  (raise-lower-button-images))

(define (recolor-all-buttons)
  (recolor-close-button) (recolor-menu-button) (recolor-iconify-button) (recolor-move-resize-button) 
  (recolor-rename-button) (recolor-frame-type-button) (recolor-maximize-button) (recolor-shade-button) 
  (recolor-sticky-button) (recolor-lock-button) (recolor-prev-button) (recolor-next-button) (recolor-raise-lower-button))

(define (recolor-all)
  (recolor-base) (recolor-tab) (recolor-all-buttons))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; frames classes
(defmacro window-in-workspace-p (w space)
  `(memq ,space (window-get ,w 'workspaces)))

(define (get-first-workspace) 1)

(define (get-last-workspace)
  (aref
   (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS)) 0))

(define frame-width
  (lambda (w)
    (if (or (eq (window-type w) 'default)
			(eq (window-type w) 'transient))
        styletab-c:borders-dimension
      0)))

(define frame-edge
  (lambda (w)
    (if (or (eq (window-type w) 'default)
            (eq (window-type w) 'transient))
        (- styletab-c:borders-dimension)
      0)))

(define sharped-edge
  (lambda (w)
    (if (or (eq (window-get w 'type) 'shaped) 
            (eq (window-get w 'type) 'shaped-transient))
        styletab-c:borders-dimension
      0)))

(define title-height (lambda (w) styletab-c:title-dimension)) 
(define title-height-s (lambda (w) (- styletab-c:title-dimension 4)))
(define title-edge (lambda (w) (- styletab-c:title-dimension)))
(define title-edge-s (lambda (w) (- (- styletab-c:title-dimension 2))))
(define top-frame-button-width (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))
(define bottom-frame-button-width (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))
(define left-frame-button-height (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))
(define right-frame-button-height (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))

(define top-frame-default-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (left-edge . 0)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-top-left-corner")))
     (left-edge . ,frame-edge)
     (top-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-top-right-corner")))
     (top-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (right-edge . 0)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define bottom-frame-default-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (left-edge . 0)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-bottom-left-corner")))
     (left-edge . ,frame-edge)
     (bottom-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-bottom-right-corner")))
     (bottom-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (right-edge . 0)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define left-frame-default-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (top-edge . 0)
     (left-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-top-left-corner")))
     (top-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-bottom-left-corner")))
     (bottom-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (bottom-edge . 0)
     (left-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))))

(define right-frame-default-border-corner-group
  `(((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (top-edge . 0)
     (right-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-top-right-corner")))
     (top-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-bottom-right-corner")))
     (bottom-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (bottom-edge . 0)
     (right-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))))

(define top-frame-border-group
  `(((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-left-border")))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (top-edge . 0)
     (width . ,frame-width)
     (bottom-edge . 0))
	((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-bottom-left-corner")))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-bottom-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-bottom-right-corner")))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-right-border")))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))))

(define bottom-frame-border-group
  `(((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-left-border")))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (bottom-edge . 0)
     (width . ,frame-width)
     (top-edge . 0))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-top-left-corner")))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-top-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-top-right-corner")))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-right-border")))
     (cursor . sb_h_double_arrow)
     (bottom-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (top-edge . 0))))

(define left-frame-border-group
  `(((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-bottom-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-bottom-right-corner")))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-right-border")))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-top-right-corner")))
     (top-edge . ,frame-edge)
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width))
    ((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-top-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))))

(define right-frame-border-group
  `(((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-bottom-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-bottom-left-corner")))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-left-border")))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (left-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-top-left-corner")))
     (top-edge . ,frame-edge)
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width))
    ((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-top-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))))

(define top-frame-title-group
  `(((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title-cursor")))
     (cursor . sb_v_double_arrow)
     (left-edge . ,sharped-edge)
     (top-edge . ,title-edge)
     (right-edge . ,sharped-edge)
     (height . 2))
    ((class . tabbar-horizontal)
     (x-justify . ,(lambda (w) (- styletab-c:title-dimension 12)))
     (y-justify . ,(lambda (w) (+ (/ styletab-c:title-dimension 2) -7)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-tab")))
     (foreground . ,title-colors-images)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (text . ,window-name))
    ((class . tabbar-horizontal-left-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-tab-left-icon")))
     (cursor . hand2)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,(lambda (w) (+ 2 (title-height-s w))))
     (y-justify . 2)
     (x-justify . ,(lambda (w) (+ 3 (icon-edge w)))))
    ((class . tabbar-horizontal-right-edge)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-tab-right")))
     (width . ,tabbar-right-edge-width)
     (height . ,title-height-s)
     (top-edge . ,title-edge-s))
    ((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title-nocursor")))
     (left-edge . ,sharped-edge)
     (top-edge . -2)
     (right-edge . ,sharped-edge)
     (height . 2))))

(define bottom-frame-title-group
  `(((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title-nocursor")))
     (left-edge . ,sharped-edge)
     (bottom-edge . -2)
     (right-edge . ,sharped-edge)
     (height . 2))
    ((class . tabbar-horizontal)
     (x-justify . ,(lambda (w) (- styletab-c:title-dimension 12)))
     (y-justify . ,(lambda (w) (+ (/ styletab-c:title-dimension 2) -7)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-tab")))
     (foreground . ,title-colors-images)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (text . ,window-name))
    ((class . tabbar-horizontal-left-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-tab-left-icon")))
     (cursor . hand2)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,(lambda (w) (+ 2 (title-height-s w))))
     (y-justify . 2)
     (x-justify . ,(lambda (w) (+ 3 (icon-edge w)))))
    ((class . tabbar-horizontal-right-edge)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-tab-right")))
     (width . ,tabbar-right-edge-width)
     (height . ,title-height-s)
     (bottom-edge . ,title-edge-s))
    ((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title-cursor")))
     (cursor . sb_v_double_arrow)
     (left-edge . ,sharped-edge)
     (bottom-edge . ,title-edge)
     (right-edge . ,sharped-edge)
     (height . 2))))

(define left-frame-title-group
  `(((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title-cursor")))
     (cursor . sb_h_double_arrow)
     (top-edge . ,sharped-edge)
     (left-edge . ,title-edge)
     (bottom-edge . ,sharped-edge)
     (width . 2))
    ((class . tabbar-vertical-top-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-tab-top")))
     (cursor . hand2)
     (height . ,(lambda (w) (+ 2 (title-height-s w))))
     (width . ,title-height-s)
     (left-edge . ,title-edge-s)
     (y-justify . ,(lambda (w) (+ 2 (icon-edge w))))
     (x-justify . 2))
    ((class . tabbar-vertical)
     (x-justify . 12)
     (y-justify . center)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-tab")))
     (left-edge . ,title-edge-s)
     (width . ,title-height-s))
    ((class . tabbar-vertical-bottom-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-tab-bottom-icon")))
     (left-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . ,(lambda (w) (- (+ 0 (icon-edge w)))))
     (x-justify . 2))
    ((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title-nocursor")))
     (top-edge . ,sharped-edge)
     (left-edge . -2)
     (bottom-edge . ,sharped-edge)
     (width . 2))))

(define right-frame-title-group
  `(((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title-cursor")))
     (cursor . sb_h_double_arrow)
     (top-edge . ,sharped-edge)
     (right-edge . ,title-edge)
     (bottom-edge . ,sharped-edge)
     (width . 2))
    ((class . tabbar-vertical-top-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-tab-top")))
     (cursor . hand2)
     (height . ,(lambda (w) (+ 2 (title-height-s w))))
     (width . ,title-height-s)
     (right-edge . ,title-edge-s)
     (y-justify . ,(lambda (w) (+ 2 (icon-edge w))))
     (x-justify . 2))
    ((class . tabbar-vertical)
     (x-justify . 12)
     (y-justify . center)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-tab")))
     (right-edge . ,title-edge-s)
     (width . ,title-height-s))
    ((class . tabbar-vertical-bottom-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-tab-bottom-icon")))
     (right-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . ,(lambda (w) (- (+ 0 (icon-edge w)))))
     (x-justify . 2))
    ((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title-nocursor")))
     (top-edge . ,sharped-edge)
     (right-edge . -2)
     (bottom-edge . ,sharped-edge)
     (width . 2))))

(define top-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-close-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-close-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-close-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-close-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-menu-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-menu-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-menu-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-menu-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-iconify-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-iconify-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-iconify-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-iconify-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry) 
                                   (table-ref styletab-c-frame-cache '"top-frame-unmaximize-button") 
                                 (table-ref styletab-c-frame-cache '"top-frame-maximize-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry) 
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unmaximize-button") 
                                 (table-ref styletab-c-frame-cache '"bottom-frame-maximize-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry) 
                                   (table-ref styletab-c-frame-cache '"left-frame-unmaximize-button") 
                                 (table-ref styletab-c-frame-cache '"left-frame-maximize-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry) 
                                   (table-ref styletab-c-frame-cache '"right-frame-unmaximize-button") 
                                 (table-ref styletab-c-frame-cache '"right-frame-maximize-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded) 
                                   (table-ref styletab-c-frame-cache '"top-frame-unshade-button") 
                                 (table-ref styletab-c-frame-cache '"top-frame-shade-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded) 
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unshade-button") 
                                 (table-ref styletab-c-frame-cache '"bottom-frame-shade-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded) 
                                   (table-ref styletab-c-frame-cache '"left-frame-unshade-button") 
                                 (table-ref styletab-c-frame-cache '"left-frame-shade-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded) 
                                   (table-ref styletab-c-frame-cache '"right-frame-unshade-button") 
                                 (table-ref styletab-c-frame-cache '"right-frame-shade-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'sticky) 
                                   (table-ref styletab-c-frame-cache '"top-frame-unsticky-button") 
                                 (table-ref styletab-c-frame-cache '"top-frame-sticky-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'sticky) 
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unsticky-button") 
                                 (table-ref styletab-c-frame-cache '"bottom-frame-sticky-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'sticky) 
                                   (table-ref styletab-c-frame-cache '"left-frame-unsticky-button") 
                                 (table-ref styletab-c-frame-cache '"left-frame-sticky-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'sticky) 
                                   (table-ref styletab-c-frame-cache '"right-frame-unsticky-button") 
                                 (table-ref styletab-c-frame-cache '"right-frame-sticky-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"top-frame-prev-last-button")   
                                 (table-ref styletab-c-frame-cache '"top-frame-prev-button"))))    
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"bottom-frame-prev-last-button")   
                                 (table-ref styletab-c-frame-cache '"bottom-frame-prev-button"))))    
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"left-frame-prev-last-button")   
                                 (table-ref styletab-c-frame-cache '"left-frame-prev-button"))))    
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"right-frame-prev-last-button")   
                                 (table-ref styletab-c-frame-cache '"right-frame-prev-button"))))    
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"top-frame-next-last-button")   
                                 (table-ref styletab-c-frame-cache '"top-frame-next-button"))))    
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"bottom-frame-next-last-button")   
                                 (table-ref styletab-c-frame-cache '"bottom-frame-next-button"))))    
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"left-frame-next-last-button")   
                                 (table-ref styletab-c-frame-cache '"left-frame-next-button"))))    
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky))
                                   (table-ref styletab-c-frame-cache '"right-frame-next-last-button")   
                                 (table-ref styletab-c-frame-cache '"right-frame-next-button"))))    
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'fixed-position) 
                                   (table-ref styletab-c-frame-cache '"top-frame-unlock-button") 
                                 (table-ref styletab-c-frame-cache '"top-frame-lock-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'fixed-position) 
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unlock-button") 
                                 (table-ref styletab-c-frame-cache '"bottom-frame-lock-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'fixed-position) 
                                   (table-ref styletab-c-frame-cache '"left-frame-unlock-button") 
                                 (table-ref styletab-c-frame-cache '"left-frame-lock-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'fixed-position) 
                                   (table-ref styletab-c-frame-cache '"right-frame-unlock-button") 
                                 (table-ref styletab-c-frame-cache '"right-frame-lock-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"top-frame-raise-lower-button") 
                                 (if (> (window-get w 'depth) 0) 
                                     (table-ref styletab-c-frame-cache '"top-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"top-frame-unontop-button")))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"bottom-frame-raise-lower-button") 
                                 (if (> (window-get w 'depth) 0) 
                                     (table-ref styletab-c-frame-cache '"bottom-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unontop-button")))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"left-frame-raise-lower-button") 
                                 (if (> (window-get w 'depth) 0) 
                                     (table-ref styletab-c-frame-cache '"left-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"left-frame-unontop-button")))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"right-frame-raise-lower-button") 
                                 (if (> (window-get w 'depth) 0) 
                                     (table-ref styletab-c-frame-cache '"right-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"right-frame-unontop-button")))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define  top-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-move-resize-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define  bottom-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-move-resize-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define  left-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-move-resize-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define  right-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-move-resize-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-rename-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-rename-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-rename-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-rename-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-frame-type-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-frame-type-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-frame-type-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-frame-type-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-shaped-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (left-edge . ,sharped-edge)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . top-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"top-frame-top-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"top-frame-top-left-corner"))))
     (left-edge . ,frame-edge)
     (top-edge . ,title-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . top-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"top-frame-top-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"top-frame-top-right-corner"))))
     (top-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (right-edge . ,sharped-edge)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define bottom-frame-shaped-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (left-edge . ,sharped-edge)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"bottom-frame-bottom-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-bottom-left-corner"))))
     (left-edge . ,frame-edge)
     (bottom-edge . ,title-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"bottom-frame-bottom-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-bottom-right-corner"))))
     (bottom-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (right-edge . ,sharped-edge)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define left-frame-shaped-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (top-edge . ,sharped-edge)
     (left-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))
    ((class . top-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"left-frame-top-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"left-frame-top-left-corner"))))
     (top-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"left-frame-bottom-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"left-frame-bottom-left-corner"))))
     (bottom-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (bottom-edge . ,sharped-edge)
     (left-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))))

(define right-frame-shaped-border-corner-group
  `(((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (top-edge . ,sharped-edge)
     (right-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))
    ((class . top-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"right-frame-top-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"right-frame-top-right-corner"))))
     (top-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded) 
                                    (table-ref styletab-c-frame-cache '"right-frame-bottom-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"right-frame-bottom-right-corner"))))
     (bottom-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped) 
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (bottom-edge . ,sharped-edge)
     (right-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))))

(define top-button-alist
  `((close  . ,top-frame-close-button)
    (menu   . ,top-frame-menu-button)
    (minimize   . ,top-frame-iconify-button)
    (maximize   . ,top-frame-maximize-button)
    (shade  . ,top-frame-shade-button)
    (sticky . ,top-frame-sticky-button)
    (space . ,top-frame-space-button)
    (send-to-prev . ,top-frame-prev-button)
    (send-to-next . ,top-frame-next-button)
    (lock . ,top-frame-lock-button)
    (raise-lower . ,top-frame-raise-lower-button)
    (move-resize . ,top-frame-move-resize-button)
    (rename . ,top-frame-rename-button)
    (frame-type . ,top-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define bottom-button-alist
  `((close  . ,bottom-frame-close-button)
    (menu   . ,bottom-frame-menu-button)
    (minimize   . ,bottom-frame-iconify-button)
    (maximize   . ,bottom-frame-maximize-button)
    (shade  . ,bottom-frame-shade-button)
    (sticky . ,bottom-frame-sticky-button)
    (space . ,bottom-frame-space-button)
    (send-to-prev . ,bottom-frame-prev-button)
    (send-to-next . ,bottom-frame-next-button)
    (lock . ,bottom-frame-lock-button)
    (raise-lower . ,bottom-frame-raise-lower-button)
    (move-resize . ,bottom-frame-move-resize-button)
    (rename . ,bottom-frame-rename-button)
    (frame-type . ,bottom-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define left-button-alist
  `((close  . ,left-frame-close-button)
    (menu   . ,left-frame-menu-button)
    (minimize   . ,left-frame-iconify-button)
    (maximize   . ,left-frame-maximize-button)
    (shade  . ,left-frame-shade-button)
    (sticky . ,left-frame-sticky-button)
    (space . ,left-frame-space-button)
    (send-to-prev . ,left-frame-prev-button)
    (send-to-next . ,left-frame-next-button)
    (lock . ,left-frame-lock-button)
    (raise-lower . ,left-frame-raise-lower-button)
    (move-resize . ,left-frame-move-resize-button)
    (rename . ,left-frame-rename-button)
    (frame-type . ,left-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define right-button-alist
  `((close  . ,right-frame-close-button)
    (menu   . ,right-frame-menu-button)
    (minimize   . ,right-frame-iconify-button)
    (maximize   . ,right-frame-maximize-button)
    (shade  . ,right-frame-shade-button)
    (sticky . ,right-frame-sticky-button)
    (space . ,right-frame-space-button)
    (send-to-prev . ,right-frame-prev-button)
    (send-to-next . ,right-frame-next-button)
    (lock . ,right-frame-lock-button)
    (raise-lower . ,right-frame-raise-lower-button)
    (move-resize . ,right-frame-move-resize-button)
    (rename . ,right-frame-rename-button)
    (frame-type . ,right-frame-frame-type-button)
    (\(none\)   . ,nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;; build themes

(define frame nil)
(define button-alist nil)
(define current-title styletab-c:titlebar-place)
(define recolor-lock t)
(define current-type nil)

;; botton list table
(define styletab-c-botton-cache (make-table equal-hash equal))

(define (make-buttons)
  (setq styletab-c-botton-cache (make-weak-table equal-hash equal))
  ;; ripped from Anonymous
  (let* (;; turns one cons cell (btn-name . show-in-transients) into a button
         ;; definition, adding the button position
         (make-button
          (lambda (is-trans btn edge pos)
            (let ((btn-def  (cdr (assq (car btn) button-alist)))
                  (btn-in-trans (last btn)))
              (if (or (null btn-def) (and is-trans (not btn-in-trans)))
                  nil
                (cons (cons edge pos) btn-def)))))
         
         ;; turns the list of cons cells (btn-name . show-in-transients) into
         ;; a list of button definitions, adding the button positions
         (make-button-list
          (lambda (is-trans btn-list edge pos-start pos-inc)
            (let loop ((rest btn-list) (pos pos-start) (result ()))
              (if (null rest)
                  result
                (let ((new-btn (make-button is-trans (car rest) edge pos)))
                  (if (null new-btn)
                      (loop (cdr rest) pos result)
                    (loop (cdr rest) (+ pos pos-inc) (append (list new-btn) result))))))))

         (setalist (setq button-alist top-button-alist))
         (top-normal-buttons-left
          (make-button-list nil styletab-c:top-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-normal-buttons-left-s
          (make-button-list nil styletab-c:top-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (top-normal-buttons-right
          (make-button-list nil styletab-c:top-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-normal-buttons-right-s
          (make-button-list nil styletab-c:top-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-left
          (make-button-list t styletab-c:top-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-left-s
          (make-button-list t styletab-c:top-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-right
          (make-button-list t styletab-c:top-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-right-s
          (make-button-list t styletab-c:top-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))

         (setalist (setq button-alist bottom-button-alist))
         (bottom-normal-buttons-left
          (make-button-list nil styletab-c:bottom-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-normal-buttons-left-s
          (make-button-list nil styletab-c:bottom-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-normal-buttons-right
          (make-button-list nil styletab-c:bottom-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-normal-buttons-right-s
          (make-button-list nil styletab-c:bottom-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-left
          (make-button-list t styletab-c:bottom-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-left-s
          (make-button-list t styletab-c:bottom-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-right
          (make-button-list t styletab-c:bottom-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-right-s
          (make-button-list t styletab-c:bottom-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))

         (setalist (setq button-alist left-button-alist))
         (left-normal-buttons-top
          (make-button-list nil styletab-c:left-top-buttons 'top-edge (+ (button-right-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-normal-buttons-top-s
          (make-button-list nil styletab-c:left-top-buttons 'top-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (left-normal-buttons-bottom 
          (make-button-list nil styletab-c:left-bottom-buttons 'bottom-edge (+ (button-left-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-normal-buttons-bottom-s
          (make-button-list nil styletab-c:left-bottom-buttons 'bottom-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-top
          (make-button-list t styletab-c:left-top-buttons 'top-edge (+ (button-right-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-top-s
          (make-button-list t styletab-c:left-top-buttons 'top-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-bottom
          (make-button-list t styletab-c:left-bottom-buttons 'bottom-edge (+ (button-left-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-bottom-s
          (make-button-list t styletab-c:left-bottom-buttons 'bottom-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         
         (setalist (setq button-alist right-button-alist))
         (right-normal-buttons-top
          (make-button-list nil styletab-c:right-top-buttons 'top-edge (+ (button-left-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-normal-buttons-top-s
          (make-button-list nil styletab-c:right-top-buttons 'top-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (right-normal-buttons-bottom 
          (make-button-list nil styletab-c:right-bottom-buttons 'bottom-edge (+ (button-right-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-normal-buttons-bottom-s
          (make-button-list nil styletab-c:right-bottom-buttons 'bottom-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-top
          (make-button-list t styletab-c:right-top-buttons 'top-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-top-s
          (make-button-list t styletab-c:right-top-buttons 'top-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-bottom
          (make-button-list t styletab-c:right-bottom-buttons 'bottom-edge (+ (button-right-edge) styletab-c:borders-dimension) 
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-bottom-s
          (make-button-list t styletab-c:right-bottom-buttons 'bottom-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom)))))
    
    (table-set styletab-c-botton-cache "top-normal-buttons-left" top-normal-buttons-left)
    (table-set styletab-c-botton-cache "top-normal-buttons-left-s" top-normal-buttons-left-s)
    (table-set styletab-c-botton-cache "top-normal-buttons-right" top-normal-buttons-right)
    (table-set styletab-c-botton-cache "top-normal-buttons-right-s" top-normal-buttons-right-s)
    (table-set styletab-c-botton-cache "top-transient-buttons-left" top-transient-buttons-left)
    (table-set styletab-c-botton-cache "top-transient-buttons-left-s" top-transient-buttons-left-s)
    (table-set styletab-c-botton-cache "top-transient-buttons-right" top-transient-buttons-right)
    (table-set styletab-c-botton-cache "top-transient-buttons-right-s" top-transient-buttons-right-s)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-left" bottom-normal-buttons-left)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-left-s" bottom-normal-buttons-left-s)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-right" bottom-normal-buttons-right)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-right-s" bottom-normal-buttons-right-s)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-left" bottom-transient-buttons-left)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-left-s" bottom-transient-buttons-left-s)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-right" bottom-transient-buttons-right)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-right-s" bottom-transient-buttons-right-s)
    (table-set styletab-c-botton-cache "left-normal-buttons-top" left-normal-buttons-top)
    (table-set styletab-c-botton-cache "left-normal-buttons-top-s" left-normal-buttons-top-s)
    (table-set styletab-c-botton-cache "left-normal-buttons-bottom" left-normal-buttons-bottom)
    (table-set styletab-c-botton-cache "left-normal-buttons-bottom-s" left-normal-buttons-bottom-s)
    (table-set styletab-c-botton-cache "left-transient-buttons-top" left-transient-buttons-top)
    (table-set styletab-c-botton-cache "left-transient-buttons-top-s" left-transient-buttons-top-s)
    (table-set styletab-c-botton-cache "left-transient-buttons-bottom" left-transient-buttons-bottom)
    (table-set styletab-c-botton-cache "left-transient-buttons-bottom-s" left-transient-buttons-bottom-s)
    (table-set styletab-c-botton-cache "right-normal-buttons-top" right-normal-buttons-top)
    (table-set styletab-c-botton-cache "right-normal-buttons-top-s" right-normal-buttons-top-s)
    (table-set styletab-c-botton-cache "right-normal-buttons-bottom" right-normal-buttons-bottom)
    (table-set styletab-c-botton-cache "right-normal-buttons-bottom-s" right-normal-buttons-bottom-s)
    (table-set styletab-c-botton-cache "right-transient-buttons-top" right-transient-buttons-top)
    (table-set styletab-c-botton-cache "right-transient-buttons-top-s" right-transient-buttons-top-s)
    (table-set styletab-c-botton-cache "right-transient-buttons-bottom" right-transient-buttons-bottom)
    (table-set styletab-c-botton-cache "right-transient-buttons-bottom-s" right-transient-buttons-bottom-s)))

(define (adjustments-tabbar w)
  (let ((tab-adjustments (table-ref styletab-c-botton-cache w)))
    (if (numberp (cdr (car (car tab-adjustments))))
        (+ (cdr (car (car tab-adjustments))) (+ styletab-c:title-dimension (button-width-custom))) 0)))

(define (check-sharped w)
  (if (or (eq current-type 'shaped)
          (eq current-type 'shaped-transient))
      w (concat w "-s")))

(define (make-frame w type current-title)
  (setq current-type (window-get w 'type))
  (require 'sawfish.wm.tabs.tab)
  (when (eq current-title 'top)
    (update-title-x-offsets `(,(- styletab-c:title-dimension 12) . 0))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (tabbar-right-edge-width)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"top-normal-buttons-left"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"top-normal-buttons-right"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"top-transient-buttons-left"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"top-transient-buttons-right")))
    (when (eq type 'normal-frame)
      (setq frame (append top-frame-title-group top-frame-default-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-left"))
                          top-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-right")))))
    (when (eq type 'transient-frame)
      (setq frame (append top-frame-title-group top-frame-default-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-left"))
                          top-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-right")))))
    (when (eq type 'shaped-frame)
      (setq frame (append top-frame-title-group top-frame-shaped-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-right")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append top-frame-title-group top-frame-shaped-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-right"))))))
  
  (when (eq current-title 'bottom)
    (update-title-x-offsets `(,(- styletab-c:title-dimension 12) . 0))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (tabbar-right-edge-width)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"bottom-normal-buttons-left"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"bottom-normal-buttons-right"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"bottom-transient-buttons-left"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"bottom-transient-buttons-right")))
    (when (eq type 'normal-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-default-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-left"))
                          bottom-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-right")))))
    (when (eq type 'transient-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-default-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-left"))
                          bottom-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-right")))))
    (when (eq type 'shaped-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-shaped-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-right")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-shaped-border-corner-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-right"))))))
  
  (when (eq current-title 'left)
    (update-title-x-offsets '(11 . -11))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (- styletab-c:title-dimension 2)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"left-normal-buttons-bottom"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"left-normal-buttons-top"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"left-transient-buttons-bottom"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"left-transient-buttons-top")))
    (when (eq type 'normal-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-bottom"))
                          left-frame-default-border-corner-group left-frame-border-group 
                          (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-top")))))
    (when (eq type 'transient-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-bottom")) 
                          left-frame-default-border-corner-group 
                          left-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-top")))))
    (when (eq type 'shaped-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-bottom"))
                          left-frame-shaped-border-corner-group (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-top")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-bottom"))
                          left-frame-shaped-border-corner-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-top"))))))
  
  (when (eq current-title 'right)
    (update-title-x-offsets '(11 . -11))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (- styletab-c:title-dimension 2)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"right-normal-buttons-bottom"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"right-normal-buttons-top"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"right-transient-buttons-bottom"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"right-transient-buttons-top")))
    (when (eq type 'normal-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-bottom")) 
                          right-frame-default-border-corner-group
                          right-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-top")))))
    (when (eq type 'transient-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-bottom")) 
                          right-frame-default-border-corner-group
                          right-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-top")))))
    (when (eq type 'shaped-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-bottom"))
                          right-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-top")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-bottom")) 
                          right-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-top"))))))
  frame)

(define (make-buttons-reframe-with-style)
  (make-buttons) 
  (reframe-windows-with-style theme-name))

(define (reframe-with-style)
  (reframe-windows-with-style theme-name))

(define (reframe-one w)
  (when (not (window-get w 'tabbed))
    (when (eq (window-get w 'current-frame-style) theme-name)
      (reframe-window w))))

;; reframe-with-style, resize bottons
;; reset icon cache
(define (clear-icon-cache-reframe)
  (when recolor-lock
    (setq recolor-lock nil)
    (recolor-all-buttons)
    (setq styletab-c-icon-cache (make-weak-table eq-hash eq))
    (make-buttons) 
    (reframe-with-style)
    (setq recolor-lock t)))

(define (color-changed)
  (when recolor-lock
    (setq recolor-lock nil)
    (recolor-all)
    (reframe-with-style)
    (setq recolor-lock t)))

(define (bright-changed)
  (when recolor-lock
    (setq recolor-lock nil)
    (recolor-tab)
    (recolor-all-buttons)
    (reframe-with-style)
    (setq recolor-lock t)))

(define (botton-color-changed botton)
  (when recolor-lock
    (setq recolor-lock nil)
    (botton)
    (reframe-with-style)
    (setq recolor-lock t)))

(define (reload-frame-style-reframe)
  (reload-frame-style theme-name)
  (reframe-with-style))

(define (get-frame w type)
  (let ((current-title 
         (if (not (window-get w 'title-position))
             (case styletab-c:titlebar-place
                   ((top)    'top)
                   ((bottom) 'bottom)
                   ((left)   'left)
                   ((right)  'right))
           (window-get w 'title-position))))
    (case type
          ((default)
           (make-frame w 'normal-frame current-title))
          ((utility)
           (make-frame w 'normal-frame current-title))
          ((shaded-utility)
           (make-frame w 'normal-frame current-title))
          ((transient)
           (make-frame w 'transient-frame current-title))
          ((shaped)
           (make-frame w 'shaped-frame current-title))
          ((shaped-transient)
           (make-frame w 'shaped-transient-frame current-title)))))

;; initialize theme
(color-changed)
(make-buttons)

(add-frame-style theme-name get-frame)

(call-after-state-changed '(maximized sticky fixed-position stacking) reframe-one)
(add-hook 'remove-from-workspace-hook reframe-one)

(custom-set-property 'styletab-c:styles ':after-set reload-frame-style-reframe)
(custom-set-property 'styletab-c:title-dimension ':after-set clear-icon-cache-reframe)
(custom-set-property 'styletab-c:custom-button-width ':after-set clear-icon-cache-reframe)
(custom-set-property 'styletab-c:button-width ':after-set clear-icon-cache-reframe)
(custom-set-property 'styletab-c:borders-dimension ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:titlebar-place ':after-set reframe-with-style)
(custom-set-property 'styletab-c:top-left-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:top-right-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:bottom-left-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:bottom-right-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:left-top-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:left-bottom-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:right-top-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:right-bottom-buttons ':after-set make-buttons-reframe-with-style)

;; auto-raise.jl -- auto-raise on focus

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.auto-raise

    (export )

    (open rep
          rep.system
          rep.io.timers
          sawfish.wm.windows
          sawfish.wm.custom
          sawfish.wm.util.stacking)

  (define-structure-alias auto-raise sawfish.wm.ext.auto-raise)

  (defgroup auto-raise "Auto-Raise" :group focus)

  (defcustom raise-windows-on-focus t
    "Raise windows when they are focused."
    :type boolean
    :require sawfish.wm.ext.auto-raise
    :group (focus auto-raise))

  (defcustom raise-window-timeout 500
    "Delay in milliseconds until focused windows are raised."
    :type number
    :depends raise-windows-on-focus
    :group (focus auto-raise))

  ;; Used to suppress temporarily in some commands.
  (defvar disable-auto-raise nil)

  (define rw-timer nil)
  (define rw-window nil)

  (define (rw-disable-timer)
    (when rw-timer
      (setq rw-window nil)
      (delete-timer rw-timer)
      (setq rw-timer nil)))

  (define (rw-on-focus w mode)
    (declare (unused mode))
    (when (not disable-auto-raise)
      (if (or (window-get w 'raise-on-focus) raise-windows-on-focus)
	  (progn
	    (setq rw-window w)
	    (if rw-timer
		(set-timer rw-timer)
	      (let ((timer-callback (lambda (timer)
				      (if disable-auto-raise
					  (set-timer timer)
					(setq rw-timer nil)
					(raise-window* rw-window))))
		    (delay (max 1 raise-window-timeout)))
		(setq rw-timer (make-timer timer-callback
					   (quotient delay 1000)
					   (mod delay 1000))))))
	(rw-disable-timer))))

  (define (rw-out-focus w mode)
    (declare (unused mode))
    (when (and rw-timer (eq rw-window w))
      (rw-disable-timer)))

  (add-hook 'focus-in-hook rw-on-focus)
  (add-hook 'focus-out-hook rw-out-focus))

;; gnome.jl -- minimal GNOME compliance
;; $Id: gnome.jl,v 1.67 2000/12/20 01:31:08 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.state.gnome

    (export WIN_STATE_STICKY
	    WIN_STATE_MAXIMIZED_VERT
	    WIN_STATE_MAXIMIZED_HORIZ
	    WIN_STATE_HIDDEN
	    WIN_STATE_SHADED
	    WIN_STATE_FIXED_POSITION
	    WIN_LAYER_NORMAL
	    WIN_HINTS_SKIP_FOCUS
	    WIN_HINTS_SKIP_WINLIST
	    WIN_HINTS_SKIP_TASKLIST
	    WIN_HINTS_FOCUS_ON_CLICK
	    WIN_HINTS_DO_NOT_COVER)

    (open rep
	  rep.regexp
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.menus
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.stacking
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify
	  sawfish.wm.state.shading)

  (define-structure-alias gnome sawfish.wm.state.gnome)

  (defconst WIN_STATE_STICKY 1)
  (defconst WIN_STATE_MAXIMIZED_VERT 4)
  (defconst WIN_STATE_MAXIMIZED_HORIZ 8)
  (defconst WIN_STATE_HIDDEN 16)
  (defconst WIN_STATE_SHADED 32)
  (defconst WIN_STATE_FIXED_POSITION 256)

  (defconst WIN_LAYER_NORMAL 4)

  (defconst WIN_HINTS_SKIP_FOCUS 1)
  (defconst WIN_HINTS_SKIP_WINLIST 2)
  (defconst WIN_HINTS_SKIP_TASKLIST 4)
  (defconst WIN_HINTS_FOCUS_ON_CLICK 16)
  (defconst WIN_HINTS_DO_NOT_COVER 32)

  (defvar gnome-window-id nil)

  (defvar gnome-supported-protocols [_WIN_CLIENT_LIST _WIN_WORKSPACE
				     _WIN_WORKSPACE_COUNT _WIN_STATE
				     _WIN_LAYER])

  ;; this is needed since the gnome tasklist applet doesn't honour
  ;; the _WIN_HIDDEN property (?)
  (defvar gnome-ignored-windows-in-client-list t)

  (define (gnome-set-client-list)
    (let (clients vec)
      (map-windows (lambda (w)
		     (when (and (windowp w) (window-mapped-p w)
				(or gnome-ignored-windows-in-client-list
				    (not (window-get w 'ignored))))
		       (setq clients (cons (window-id w) clients)))))
      (setq vec (apply vector clients))
      (set-x-property 'root '_WIN_CLIENT_LIST vec 'CARDINAL 32)))

  (define current-workspace-index nil)
  (define current-workspace-count 0)
  (define current-workspace-names nil)
  (define current-area nil)
  (define current-area-count nil)

  (define (gnome-set-workspace)
    (let* ((limits (workspace-limits))
	   (port (screen-viewport))
	   (port-size viewport-dimensions)
	   (total-workspaces (1+ (- (cdr limits) (car limits)))))
      ;; apparently some pagers don't like it if we place windows
      ;; on (temporarily) non-existent workspaces
      (when (< current-workspace-count total-workspaces)
	(setq current-workspace-count total-workspaces)
	(set-x-property 'root '_WIN_WORKSPACE_COUNT
			(vector current-workspace-count) 'CARDINAL 32))
      (map-windows
       (lambda (w)
	 (let
	     ;; XXX the gnome-wm standard sucks..
	     ((space (and (not (window-get w 'sticky))
			  (window-get w 'swapped-in)))
	      (w-port (and (not (window-get w 'viewport-sticky))
			   (window-viewport w))))
	   (if space
	       (set-x-property w '_WIN_WORKSPACE
			       (vector (- space (car limits))) 'CARDINAL 32)
	     (delete-x-property w '_WIN_WORKSPACE))
	   (if w-port
	       (set-x-property w '_WIN_AREA
			       (vector (car w-port) (cdr w-port))
			       'CARDINAL 32)
	     (delete-x-property w '_WIN_AREA)))))
      (unless (equal current-workspace-index
		     (- current-workspace (car limits)))
	(setq current-workspace-index (- current-workspace (car limits)))
	(set-x-property 'root '_WIN_WORKSPACE
			(vector current-workspace-index) 'CARDINAL 32))
      (when (> current-workspace-count total-workspaces)
	(setq current-workspace-count total-workspaces)
	(set-x-property 'root '_WIN_WORKSPACE_COUNT
			(vector current-workspace-count) 'CARDINAL 32))
      (unless (equal current-workspace-names workspace-names)
	(setq current-workspace-names workspace-names)
	(set-x-text-property 'root '_WIN_WORKSPACE_NAMES
			     (apply vector workspace-names)))
      (unless (equal current-area port)
	(setq current-area port)
	(set-x-property 'root '_WIN_AREA (vector (car port) (cdr port))
			'CARDINAL 32))
      (unless (equal current-area-count port-size)
	(setq current-area-count port-size)
	(set-x-property 'root '_WIN_AREA_COUNT (vector (car port-size)
						       (cdr port-size))
			'CARDINAL 32))))

  (define (gnome-set-client-state w)
    (let ((state 0))
      (when (window-get w 'sticky)
	(setq state (logior state WIN_STATE_STICKY)))
      (when (window-get w 'shaded)
	(setq state (logior state WIN_STATE_SHADED)))
      (when (window-get w 'fixed-position)
	(setq state (logior state WIN_STATE_FIXED_POSITION)))
      (when (window-maximized-vertically-p w)
	(setq state (logior state WIN_STATE_MAXIMIZED_VERT)))
      (when (window-maximized-horizontally-p w)
	(setq state (logior state WIN_STATE_MAXIMIZED_HORIZ)))
      (when (window-get w 'ignored)
	(setq state (logior state WIN_STATE_HIDDEN)))
      (set-x-property w '_WIN_STATE (vector state) 'CARDINAL 32)
      (when (window-get w 'depth)
	(set-x-property w '_WIN_LAYER
			(vector (+ (window-get w 'depth) WIN_LAYER_NORMAL))
			'CARDINAL 32))))

  (define (gnome-set-client-hints w states)
    (let ((hints (let ((prop (get-x-property w '_WIN_HINTS)))
		   (if (eq (car prop) 'CARDINAL)
		       (aref (nth 2 prop) 0)
		     0))))
      (mapc (lambda (state)
	      (case state
		((window-list-skip)
		 (setq hints (logior (logand
				      hints (lognot WIN_HINTS_SKIP_WINLIST))
				     (if (window-get w 'window-list-skip)
					 WIN_HINTS_SKIP_WINLIST 0)
				     (if (window-get w 'avoid)
					 WIN_HINTS_DO_NOT_COVER 0))))))
	    states)
      (set-x-property w '_WIN_HINTS (vector hints) 'CARDINAL 32)))

  ;; XXX Ugly hacks to make the GNOME desktop function sanely
  (define (gnome-window-class-hacks w)
    (let ((class (get-x-text-property w 'WM_CLASS)))
      (when (and class (>= (length class) 2))
	(cond ((and (string= (aref class 1) "Panel")
		    (string= (aref class 0) "panel"))
	       ;; XXX I don't think the GNOME hints specify these things...
	       (window-put w 'focus-click-through t)
	       (window-put w 'no-history t)
	       (window-put w 'never-iconify t)
	       (window-put w 'never-maximize t)
	       ;; XXX the panel is broken, in that it doesn't check
	       ;; XXX that the wm gave it the position that it wanted.
	       ;; XXX (The wm is under no obligation; the panel should
	       ;; XXX move itself to the required position after
	       ;; XXX initially mapping the window, or perhaps it
	       ;; XXX should use the USPosition hints?). The following
	       ;; XXX line prevents panel windows being placed at all
	       (window-put w 'placed t))
	      ((string= (aref class 1) "gmc-desktop-icon")
	       (window-put w 'focus-click-through t)
	       (window-put w 'never-focus t)
	       (window-put w 'never-iconify t)
	       (window-put w 'never-maximize t)
	       ;; XXX same reason as above
	       (window-put w 'placed t))
	      ((and (string= (aref class 1) "Nautilus")
		    (string= (aref class 0) "desktop_window"))
	       (mark-window-as-desktop w))))))

  (define (gnome-honour-client-state w)
    (gnome-window-class-hacks w)
    (let ((state (get-x-property w '_WIN_STATE))
	  (hints (get-x-property w '_WIN_HINTS))
	  (layer (get-x-property w '_WIN_LAYER))
	  (space (get-x-property w '_WIN_WORKSPACE))
	  bits)
      (when (eq (car state) 'CARDINAL)
	(setq bits (aref (nth 2 state) 0))
	(unless (zerop (logand bits WIN_STATE_STICKY))
	  (window-put w 'sticky t)
	  (window-put w 'sticky-viewport t))
	(unless (zerop (logand bits WIN_STATE_SHADED))
	  (window-put w 'shaded t))
	(unless (zerop (logand bits WIN_STATE_FIXED_POSITION))
	  (window-put w 'fixed-position t))
	(unless (zerop (logand bits WIN_STATE_MAXIMIZED_VERT))
	  (unless (window-maximized-vertically-p w)
	    (window-put w 'queued-vertical-maximize t)))
	(unless (zerop (logand bits WIN_STATE_MAXIMIZED_HORIZ))
	  (unless (window-maximized-horizontally-p w)
	    (window-put w 'queued-horizontal-maximize t))))
      (when (eq (car hints) 'CARDINAL)
	(setq bits (aref (nth 2 hints) 0))
	(unless (zerop (logand bits WIN_HINTS_SKIP_FOCUS))
	  (window-put w 'cycle-skip t))
	(unless (zerop (logand bits WIN_HINTS_SKIP_WINLIST))
	  (window-put w 'window-list-skip t))
	(unless (zerop (logand bits WIN_HINTS_DO_NOT_COVER))
	  (window-put w 'avoid t)))
      (when layer
	(setq layer (aref (nth 2 layer) 0))
	(set-window-depth w (- layer WIN_LAYER_NORMAL)))
      (when (and space (not (window-workspaces w)))
	(set-window-workspaces w (list (aref (nth 2 space) 0))))))

  (define (gnome-client-message-handler w type data)
    (cond ((eq type '_WIN_WORKSPACE)
	   (let ((limits (workspace-limits)))
	     (select-workspace (+ (aref data 0) (car limits)))
	     t))
	  ((eq type '_WIN_AREA)
	   (set-screen-viewport (aref data 0) (aref data 1)))
	  ((and (eq type '_WIN_STATE) (windowp w))
	   (let ((mask (aref data 0))
		 (values (aref data 1))
		 tem)
	     (unless (zerop (logand mask WIN_STATE_STICKY))
	       (if (zerop (logand values WIN_STATE_STICKY))
		   (make-window-unsticky w)
		 (make-window-sticky w)))
	     (unless (zerop (logand mask WIN_STATE_SHADED))
	       (if (zerop (logand values WIN_STATE_SHADED))
		   (unshade-window w)
		 (shade-window w)))
	     (unless (zerop (logand mask WIN_STATE_FIXED_POSITION))
	       (window-put w 'fixed-position
			   (/= (logand values WIN_STATE_FIXED_POSITION) 0)))
	     (unless (zerop (logand mask WIN_STATE_MAXIMIZED_VERT))
	       (setq tem (window-maximized-vertically-p w))
	       (if (or (and (not tem) (not (zerop (logand values WIN_STATE_MAXIMIZED_VERT))))
		       (and tem (zerop (logand values WIN_STATE_MAXIMIZED_VERT))))
		   (maximize-window-vertically-toggle w)))
	     (unless (zerop (logand mask WIN_STATE_MAXIMIZED_HORIZ))
	       (setq tem (window-maximized-horizontally-p w))
	       (if (or (and (not tem) (not (zerop (logand values WIN_STATE_MAXIMIZED_HORIZ))))
		       (and tem (zerop (logand values WIN_STATE_MAXIMIZED_HORIZ))))
		   (maximize-window-horizontally-toggle w))))
	   t)
	  ((and (eq type '_WIN_HINTS) (windowp w))
	   (let ((mask (aref data 0))
		 (bits (aref data 1)))
	     (unless (zerop (logand mask WIN_HINTS_SKIP_FOCUS))
	       (window-put w 'cycle-skip
			   (not (zerop (logand bits WIN_HINTS_SKIP_FOCUS)))))
	     (unless (zerop (logand mask WIN_HINTS_SKIP_WINLIST))
	       (window-put w 'window-list-skip
			   (not (zerop (logand bits WIN_HINTS_SKIP_WINLIST)))))
	     (unless (zerop (logand mask WIN_HINTS_DO_NOT_COVER))
	       (window-put w 'avoid
			   (not (zerop (logand bits WIN_HINTS_DO_NOT_COVER)))))))
	  ((and (eq type '_WIN_LAYER) (windowp w))
	   (set-window-depth w (- (aref data 0) WIN_LAYER_NORMAL))
	   t)))

  (define (gnome-event-proxyer)
    (when (and (current-event) (eq (current-event-window) 'root))
      (let ((event (event-name (current-event))))
	;; only proxy Click1 or Off events, and only if we don't have
	;; a binding for an event that may follow in the same grab
	(cond ((and (string-match "^(.*)-Click1$" event)
		    (let ((mirror (lookup-event
				   (expand-last-match "\\1-Off"))))
		      (not (or (search-keymap mirror global-keymap)
			       (search-keymap mirror root-window-keymap)))))
	       ;; send with SubstructureNotifyMask
	       (proxy-current-event gnome-window-id (lsh 1 19))
	       t)
	      ((and (string-match "^(.*)-Off$" event)
		    (let ((mirrors
			   (mapcar (lambda (x)
				     (lookup-event
				      (concat (expand-last-match "\\1-") x)))
				   '("Click1" "Click2" "Click3" "Move"))))
		      (catch 'out
			(mapc (lambda (ev)
				(when (or (search-keymap ev global-keymap)
					  (search-keymap ev root-window-keymap))
				  (throw 'out nil)))
			      mirrors)
			t)))
	       ;; send with SubstructureNotifyMask
	       (proxy-current-event gnome-window-id (lsh 1 19))
	       t)))))


;;; initialisation

  (define (gnome-init)
    (setq gnome-window-id (create-window 'root -200 -200 5 5))

    (set-x-property 'root '_WIN_SUPPORTING_WM_CHECK
		    (vector gnome-window-id) 'CARDINAL 32)
    (set-x-property gnome-window-id '_WIN_SUPPORTING_WM_CHECK
		    (vector gnome-window-id) 'CARDINAL 32)

    (set-x-property 'root '_WIN_DESKTOP_BUTTON_PROXY
		    (vector gnome-window-id) 'CARDINAL 32)
    (set-x-property gnome-window-id '_WIN_DESKTOP_BUTTON_PROXY
		    (vector gnome-window-id) 'CARDINAL 32)

    (set-x-property 'root '_WIN_PROTOCOLS
		    gnome-supported-protocols 'ATOM 32)

    (let ((port (screen-viewport)))
      (set-x-property 'root '_WIN_AREA
		      (vector (car port) (cdr port)) 'CARDINAL 32)
      (set-x-property 'root '_WIN_AREA_COUNT
		      (vector (car viewport-dimensions)
			      (cdr viewport-dimensions)) 'CARDINAL 32)

      ;; XXX I'm using this property to tell desk-guide to move
      ;; XXX the current area on all desktops at once
      ;; XXX This is totally non-standard and may change..
      (set-x-property 'root '_WIN_UNIFIED_AREA (vector 1) 'CARDINAL 32))

    (delete-x-property 'root '_WIN_WORKSPACE_NAMES)

    (add-hook 'workspace-state-change-hook gnome-set-workspace)
    (add-hook 'viewport-resized-hook gnome-set-workspace)
    (add-hook 'viewport-moved-hook gnome-set-workspace)

    (add-hook 'add-window-hook gnome-set-client-list)
    (add-hook 'destroy-notify-hook gnome-set-client-list)
    (add-hook 'map-notify-hook gnome-set-client-list)
    (add-hook 'unmap-notify-hook gnome-set-client-list)
    (add-hook 'workspace-state-change-hook gnome-set-client-list)

    (add-hook 'before-add-window-hook gnome-honour-client-state)
    (add-hook 'add-window-hook gnome-set-client-state)
    (call-after-state-changed '(sticky shaded maximized ignored stacking)
			      gnome-set-client-state)
    (call-after-state-changed '(window-list-skip) gnome-set-client-hints)

    (add-hook 'client-message-hook gnome-client-message-handler)
    (add-hook 'unbound-key-hook gnome-event-proxyer)
    (add-hook 'before-exit-hook gnome-exit))

  (define (gnome-exit)
    (destroy-window gnome-window-id)
    (delete-x-property 'root '_WIN_SUPPORTING_WM_CHECK)
    (delete-x-property 'root '_WIN_PROTOCOLS)
    (delete-x-property 'root '_WIN_AREA)
    (delete-x-property 'root '_WIN_AREA_COUNT)
    (delete-x-property 'root '_WIN_UNIFIED_AREA))

  (unless (or gnome-window-id batch-mode)
    (gnome-init)
    (require 'sawfish.wm.gnome.match-window))

  (add-window-menu-toggle (_ "In GNOME _task list")
			  'gnome-toggle-skip-tasklist))

;; menus.jl -- popup menus

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.menus

    (export menu-start-process
	    menu-stop-process
	    popup-menu
	    popup-window-ops-menu
	    popup-window-list-menu
	    popup-root-menu
	    popup-apps-menu
	    add-window-menu-toggle
	    add-poweroff-menu
	    custom-menu)

    (open rep
	  rep.regexp
	  rep.io.files
	  rep.io.processes
	  rep.data.tables
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.frames
	  sawfish.wm.commands
	  sawfish.wm.util.groups
	  sawfish.wm.workspace
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify
	  sawfish.wm.commands.launcher
	  sawfish.wm.ext.error-handler)

  (define-structure-alias menus sawfish.wm.menus)

  ;; Suppress annoying compiler warnings
  (eval-when-compile (require 'rep.io.timers))

  (defcustom menus-include-shortcuts nil
    "Display key-binding information in menu items."
    :group misc
    :type boolean)

  (defvar menu-program (expand-file-name "sawfish-menu" sawfish-exec-directory)
    "Location of the program implementing sawfish's menu interface.")

  (defvar menu-program-stays-running t
    "When non-nil, the menu program is never stopped. If a number, then this
is taken as the number of seconds to let the process hang around unused
before killing it.")

  ;; the active user interface process
  (define menu-process nil)

  ;; output from the user-interface process that's received but not
  ;; yet processed
  (define menu-pending nil)

  ;; non-nil when we're waiting for a response from the ui process
  ;; if a window, then it's the window that received the event causing
  ;; the menu to be shown
  (define menu-active nil)

  ;; hash table mapping nicknames to result objects without read syntax
  (define nickname-table)
  (define nickname-index)

  ;; if menu-program-stays-running is a number, this may be a timer
  ;; waiting to kill the process
  (define menu-timer nil)

  (defvar window-ops-menu
    ;; Mysterious underscore "_" before a string offers (human
    ;; langugage) translation. The one inside of a string is
    ;; a shortcut key.
    `((,(_ "Mi_nimize") iconify-window
       (insensitive . ,(lambda (w)
                         (not (or (window-iconifiable-p w)
				  (not (window-get w 'never-iconify)))))))
      (,(lambda (w)
          (if (window-maximized-p w)
              (_ "Unma_ximize")
            (_ "Ma_ximize"))) maximize-window-toggle
            (insensitive . ,(lambda (w)
                              (not (or (window-maximized-p w)
                                       (window-maximizable-p w)
				       (not (window-get w 'never-maximize)))))))
      (,(_ "_Move") move-window-interactively
       (insensitive . ,(lambda (w)
			 (window-get w 'fixed-position))))
      (,(_ "_Resize") resize-window-interactively
       (insensitive . ,(lambda (w)
			 (window-get w 'fixed-size))))
      (,(_ "_Resize to") resize-window-prompt
       (insensitive . ,(lambda (w)
			 (window-get w 'fixed-size))))
      (,(_ "_Close") delete-window
       (insensitive . ,(lambda (w)
			 (window-get w 'never-delete))))
      ()
      (,(_ "_Toggle") . window-ops-toggle-menu)
      (,(_ "In _group") . window-group-menu)
      (,(_ "_Workspace")
       (,(_ "Move to _Previous workspace") send-to-previous-workspace)
       (,(_ "Move to _Next workspace") send-to-next-workspace)
       ()
       (,(_ "Copy to P_revious workspace") copy-to-previous-workspace)
       (,(_ "Copy to Ne_xt workspace") copy-to-next-workspace))
      (,(_ "_Grow & Pack")
       (,(_ "Grow left") grow-window-left)
       (,(_ "Grow right") grow-window-right)
       (,(_ "Grow up") grow-window-up)
       (,(_ "Grow down") grow-window-down)
       ()
       (,(_ "Pack left") pack-window-left)
       (,(_ "Pack right") pack-window-right)
       (,(_ "Pack up") pack-window-up)
       (,(_ "Pack down") pack-window-down))
      (,(_ "Shrink & _Yank")
       (,(_ "Shrink left") shrink-window-left)
       (,(_ "Shrink right") shrink-window-right)
       (,(_ "Shrink up") shrink-window-up)
       (,(_ "Shrink down") shrink-window-down)
       ()
       (,(_ "Yank left") yank-window-left)
       (,(_ "Yank right") yank-window-right)
       (,(_ "Yank up") yank-window-up)
       (,(_ "Yank down") yank-window-down))
      (,(_ "Stac_king")
       (,(_ "_Raise") raise-window)
       (,(_ "_Lower") lower-window)
       ()
       (,(_ "_Upper layer") raise-window-depth)
       (,(_ "Lo_wer layer") lower-window-depth))
      (,(_ "Frame ty_pe") . frame-type-menu)
      (,(_ "Frame sty_le") . frame-style-menu)))

  (defvar window-ops-toggle-menu '())

  ;; Window list menu
  (defvar window-menu nil)

  (defvar root-menu
    ;; Mysterious underscore "_" before a stringoffers (human
    ;; langugage) translation. The one inside of a string
    ;; specifies shortcut key.
    `((,(_ "Sawfish Rootmenu") nil (insensitive . t))
      ()
      (,(_ "_Windows") . window-menu)
      (,(_ "Work_spaces") . workspace-menu)
      ()
      (,(_ "_Programs") . apps-menu)
      (,(_ "_Customize") . custom-menu)
      ()
      (,(_ "Sessi_on")
       (,(_ "Display _Errors") display-errors)
       (,(_ "_Reload Appsmenu") update-apps-menu)
       ()
       (,(_ "Restart _Sawfish") restart)
       (,(_ "_Quit Sawfish") quit))
      ()
      (,(_ "_Help")
       (,(_ "Sawfish _FAQ") help:show-faq)
       (,(_ "Sawfish _News") help:show-news)
       (,(_ "Sawfish _Wiki") help:show-homepage)
       (,(_ "Sawfish _Manual") help:show-programmer-manual)
       ()
       (,(_ "_About Sawfish") help:about))))

  (defvar apps-menu)

  (define (add-poweroff-menu)
    "Add poweroff related menu items to Session sub-menu."
    (user-require 'sawfish.wm.commands.poweroff)
    (let ((menu (assoc (_ "Sessi_on") root-menu)))
      (when menu
	(nconc menu `(()
		      (,(_ "_Lockdown Display")
			(poweroff 'lockdown))
		      (,(_ "L_ogout from Session")
			(poweroff 'logout))
		      ()
		      (,(_ "_Reboot System")
		       (poweroff 'reboot))
		      (,(_ "_Shutdown System")
		       (poweroff 'halt))
		      (,(_ "S_uspend System")
		       (poweroff 'suspend))
		      (,(_ "_Hibernate System")
		       (poweroff 'hibernate)))))))

  (define (menu-start-process)
    (when menu-timer
      (delete-timer menu-timer)
      (setq menu-timer nil))
    (unless (and menu-process (process-in-use-p menu-process))
      (when menu-process
	(kill-process menu-process)
	(setq menu-process nil))
      (let ((menu-sentinel (lambda ()
			     (when (and menu-process
					(not (process-in-use-p menu-process)))
			       (setq menu-process nil))
			     (when menu-timer
			       (delete-timer menu-timer)
			       (setq menu-timer nil))))
	    (menu-filter (lambda (output)
			   (setq output (concat menu-pending output))
			   (setq menu-pending nil)
			   (condition-case nil
			       (let
				   ((result (read-from-string output)))
				 ;; GTK takes the focus for its menu,
				 ;; but later returns it to the original
				 ;; window. We want the focus to be
				 ;; restored by the time the menu-chosen
				 ;; command is invoked..
				 (accept-x-input)
				 (menu-dispatch result))
			     (end-of-stream
			      (setq menu-pending output))))))
	(setq menu-process (make-process menu-filter menu-sentinel)))
      (set-process-error-stream menu-process nil)
      (or (start-process menu-process menu-program)
	  (error "Can't start menu backend: %s" menu-program))))

  (define (menu-stop-process #!optional force)
    (when menu-process
      (cond ((and (not force) (numberp menu-program-stays-running))
	     ;; number of seconds to let it hang around for
	     (require 'rep.io.timers)
	     (setq menu-timer (make-timer (lambda ()
					    (when menu-process
					      (kill-process menu-process)
					      (setq menu-process nil))
					    (setq menu-timer nil))
					  menu-program-stays-running)))
	    ((or force (not menu-program-stays-running))
	     (kill-process menu-process)
	     (setq menu-process nil)))))

  (define (make-nickname obj)
    (let ((nick nickname-index))
      (setq nickname-index (1+ nickname-index))
      (table-set nickname-table nick obj)
      nick))

  (define (nicknamep arg) (fixnump arg))
  (define (nickname-ref nick) (table-ref nickname-table nick))

  ;; Currently only use is to pass the window object.
  (define menu-args (make-fluid '()))
  (define where-is-fun (make-fluid '()))

  (define (menu-preprocessor cell)
    (define (inner cell)
      (when cell
	(let ((label (car cell)))
	  (when (functionp label)
	    (setq label (apply label (fluid menu-args))))
	  (cond ((functionp (cdr cell))
		 (setq cell (apply (cdr cell) (fluid menu-args))))
		((and (symbolp (cdr cell)) (not (null (cdr cell))))
		 (setq cell (symbol-value (cdr cell)))
		 (when (functionp cell)
		   (setq cell (apply cell (fluid menu-args)))))
		(t (setq cell (cdr cell))))
	  (when cell
	    (if (and (consp (car cell)) (stringp (car (car cell))))
		;; recurse through sub-menu
		(setq cell (mapcar inner cell))
	      (let* ((action (car cell))
		     (options (cdr cell))
		     (shortcut (and (fluid where-is-fun)
				    (symbolp action)
				    ((fluid where-is-fun) action))))
		(when (not (symbolp action))
		  ;; a non-symbol result, replace by a nickname
		  (setq action (make-nickname (car cell))))
		;; scan the alist of options
		(setq options (mapcar
			       (lambda (cell)
				 (if (functionp (cdr cell))
				     (cons (car cell)
					   (apply (cdr cell)
						  (fluid menu-args)))
				   cell)) options))
		(when shortcut
		  (setq options (cons (cons 'shortcut shortcut) options)))
		(setq cell (cons action options)))))
	  (cons label cell))))
    (let-fluids ((where-is-fun (and menus-include-shortcuts
				    (require 'sawfish.wm.util.keymap)
				    (make-memoizing-where-is
				     (list global-keymap window-keymap)))))
      (inner cell)))

  (define (menu-dispatch result)
    (let ((orig-win menu-active))
      (menu-stop-process)
      (when (nicknamep result)
	(setq result (nickname-ref result)))
      (setq menu-active nil)
      (setq nickname-table nil)
      (frame-draw-mutex nil)
      (when result
	(when (windowp orig-win)
	  (current-event-window orig-win))
	(cond ((commandp result)
	       (call-command result))
	      ;; This supports (define (func) (interactive) ...)
	      ((functionp result)
	       (result))
	      ((consp result)
	       (user-eval result))
	      (t result)))))

  (define (popup-menu spec)
    (or spec (error "No menu given to popup-menu"))
    (if (and menu-active menu-process (process-in-use-p menu-process))
	(error "Menu already active")
      (let* ((part (clicked-frame-part))
	     (offset (and part (frame-part-position part)))
	     (dims (and part (frame-part-dimensions part))))
	(setq menu-active (or (current-event-window) (input-focus)))
	(condition-case error-data
	    (progn
	      (menu-start-process)
	      ;; prevent any depressed button being redrawn until the menu
	      ;; is popped down
	      ;; XXX expose events screw this up..
	      (when (clicked-frame-part)
		(frame-draw-mutex t))
	      ;; This function is probably called from a ButtonPress event,
	      ;; so cancel the implicit pointer grab (to allow the menu's grab
	      ;; to succeed)
	      (ungrab-pointer)
	      (ungrab-keyboard)
	      (sync-server t)
	      (when (functionp spec)
		(setq spec (spec)))
	      ;; XXX this is a hack, but I want menus to appear under buttons
	      (if (and part (setq part (frame-part-get part 'class))
		       (windowp menu-active)
		       (string-match "-button$" (symbol-name part)))
		  (progn
		    (rplaca offset
			    (max 0 (+ (car offset)
				      (car (window-position menu-active)))))
		    (rplacd offset
			    (max 0 (+ (cdr offset) (cdr dims)
				      (cdr (window-position menu-active))))))
		(setq offset nil))
	      (setq nickname-table (make-table eq-hash eq))
	      (setq nickname-index 0)
	      (format menu-process "(popup-menu %s %S %S)\n"
		      ;; write out the menu spec in one chunk to
		      ;; avoid large numbers of system calls :-[
		      (format nil "%S" (mapcar menu-preprocessor spec))
		      (x-server-timestamp) offset))
          (error
           ;; prevents spurious errors with subsequent menus
           (setq menu-active nil)
           (apply signal error-data))))))

  (define (popup-window-ops-menu w)
    "Display the menu listing all window operations."
    (let-fluids ((menu-args (list w)))
      (popup-menu window-ops-menu)))

  (define (popup-window-list-menu)
    "Display the window-list menu."
    (popup-menu window-menu))

  (define (popup-root-menu)
    "Display the main menu."
    (popup-menu root-menu))

  (define (popup-apps-menu)
    "Display the applications menu."
    (popup-menu apps-menu))

  ;;###autoload
  (define-command 'popup-window-ops-menu popup-window-ops-menu #:spec "%W")
  (define-command 'popup-root-menu popup-root-menu)
  (define-command 'popup-apps-menu popup-apps-menu)
  (define-command 'popup-window-list-menu popup-window-list-menu)

;;; menu modifiers

  (define (add-window-menu-toggle label command #!optional predicate)
    (let ((item (list* label command
		       (and predicate (list (cons 'check predicate))))))
      (let loop ((rest window-ops-toggle-menu))
	(cond
	 ((null rest)
	  (setq window-ops-toggle-menu (nconc window-ops-toggle-menu
					      (list item))))
	 ((eq (cadar rest) command)
	  (rplaca rest item))
	 (t (loop (cdr rest)))))))

;;; customize menu

  (defvar custom-menu-includes-all-settings t
    "When non-nil, the custom menu includes the `All settings' item.")

  (define (custom-menu)
    `(,@(and custom-menu-includes-all-settings
	     (list (list (_ "S_awfishConfig") 'customize) nil))
      ,@(mapcar (lambda (sub)
		  (list (_ (cadr sub))
			(intern (concat "customize:"
					(symbol-name (car sub))))))
		(filter consp (cddr custom-groups))))))

;; nokogiri-slot.jl -- managing individual config items
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.slot

    (export slot-name
	    slot-widget
	    slot-old-value
	    slot-gtk-widget
	    slot-doc slot-flags
	    slot-layout set-slot-layout
	    update-dependences
	    update-all-dependences
	    get-slot
	    slot-value
	    fetch-slots
	    custom-symbol-value)

    (open rep
	  gui.gtk-2.gtk
	  rep.system
	  rep.data.tables
	  rep.data.records
	  sawfish.gtk.widget
	  sawfish.cfg.wm)

  (define-record-type :slot
    (create-slot name old-value flags)
    ;; [no predicate]
    (name slot-name)			 ;name of config item
    (widget slot-widget slot-widget-set) ;associated lisp widget
    (layout slot-layout set-slot-layout) ;gtk widget if the slot is displayed
    (old-value slot-old-value)		 ;original value of slot's config
    (doc slot-doc slot-doc-set)		 ;doc string (unless shown in widget)
    (flags slot-flags))

  (define-record-discloser :slot
    (lambda (x) (format nil "#<slot %s>" (slot-name x))))

  ;; hash table mapping names to slots
  (define slot-table (make-table symbol-hash eq))

  ;; hash table mapping slot name to list of slots depending on them
  (define dependence-table (make-table symbol-hash eq))

  (defvar *nokogiri-slot-changed-hook* '())

;;; slot creation, data structure mgmt

  (define (slot-dependences slot)
    (table-ref dependence-table (slot-name slot)))

  (define (update-dependences slot)
    (when (slot-dependences slot)
      (let ((value (slot-value slot)))
	(mapc (lambda (dep)
		(when (slot-layout dep)
		  (if value
		      (gtk-widget-show (slot-layout dep))
		    (gtk-widget-hide (slot-layout dep)))))
	      (slot-dependences slot)))))

  (define (update-all-dependences)
    (table-walk (lambda (dep slots)
		  (declare (unused slots))
		  (update-dependences (get-slot dep))) dependence-table))

  ;; called when the value of SLOT changes
  (define (slot-changed slot)
    (call-hook '*nokogiri-slot-changed-hook* (list slot))
    (update-dependences slot))

  (define (slot-gtk-widget slot) (widget-gtk-widget (slot-widget slot)))

  (define (make-slot #!key name value type doc depends widget-flags)
    (let ((slot (create-slot name value widget-flags)))
      (table-set slot-table (slot-name slot) slot)

      ;; install dependendences
      (when depends
	(table-set dependence-table depends
		   (cons slot (table-ref dependence-table depends))))

      ;; create the widget
      (let* ((callback (lambda () (slot-changed slot)))
	     (doc (if (or (null doc) (string= doc ""))
		      doc
		    (_ doc))))
	(if (widget-accepts-doc-string-p (or (car type) type))
	    (slot-widget-set slot (make-widget type callback doc))
	  (slot-doc-set slot doc)
	  (slot-widget-set slot (make-widget type callback))))
      (widget-set (slot-widget slot) (slot-old-value slot))

      slot))

  (define (get-slot name) (table-ref slot-table name))
  (define (slot-value slot) (widget-ref (slot-widget slot)))

  ;; Return a list of slots for variables NAMES. Will load the data
  ;; from the WM if not already cached
  (define (fetch-slots names)
    ;; don't want to request one slot at a time from wm..

    ;; SLOTS is a list of slots matching NAMES, or nil if the slot
    ;; hadn't been loaded. EXTRA is a list of slots to splice into
    ;; the nil spaces.
    (define (merge slots extra)
      (let loop ((rest slots))
	(if (null rest)
	    slots
	  (when (null (car rest))
	    (rplaca rest (apply make-slot (car extra)))
	    (setq extra (cdr extra)))
	  (loop (cdr rest)))))

    ;; find which slots still need to be loaded
    (let ((slots (mapcar get-slot names)))
      (let loop
	  ((names-rest names)
	   (slots-rest slots)
	   (to-fetch '()))
	(if (null names-rest)
	    (if to-fetch
		;; load and merge the required slots
		(merge slots (wm-load-slots (nreverse to-fetch)))
	      slots)
	  (if (null (car slots-rest))
	      ;; slot not loaded yet
	      (loop (cdr names-rest)
		    (cdr slots-rest)
		    (cons (car names-rest) to-fetch))
	    (loop (cdr names-rest)
		  (cdr slots-rest)
		  to-fetch))))))

;;; misc

  (define (custom-symbol-value symbol)
    (let ((slot (or (get-slot symbol)
		    (error "Slot not loaded yet: %s" symbol))))
      (slot-value slot))))

;;; uptimes.jl --- Record sawfish session uptimes.
;; Copyright 1999,2000,2001 by Dave Pearson <davep@davep.org>
;; $Revision: 1.7 $

;; uptimes.jl is free software distributed under the terms of the GNU
;; General Public Licence, version 2. For details see the file COPYING.

;;; Commentary:
;;
;; The following code allows you to track the uptimes of your sawfish
;; sessions, this is essentially a port of uptimes.el to sawfish (see
;; <URL:http://www.davep.org/emacs/#uptimes.el> for the emacs version of
;; uptimes).
;;
;; To use this code simply drop it (or a compiled copy) into your load-path
;; and in your ~/.sawfishrc put:
;;
;; (require 'uptimes)
;;
;; You might want to place it as close to the top of the file as possible
;; because the "boottime" of your sawfish session is in reality measured
;; from the moment that uptimes.jl is loaded and evaluated.
;;
;; There are a number of commands that you might want to bind to keys. Two
;; are `uptimes-display-uptime' and `uptimes-display-uptimes'. The first
;; will display the uptime of your current sawfish session, the second will
;; display the last "n" and top "n" uptimes (where "n" is defined by the
;; value of `uptimes-count'). Both of these displays clear after
;; `uptimes-display-timeout' seconds.
;;
;; Two others are `uptimes-toggle-uptime' and `uptimes-toggle-uptimes'.
;; These commands display the same as the last two but instead of the
;; display clearing after a time they toggle the message on and off.

;;; Code:

;; Stuff we require.

(require 'timers)

;; Customise options.

(defgroup uptimes "Uptime Tracking")

(defcustom uptimes-display-timeout 5
  "Seconds to display the uptime before clearing the display."
  :group     uptimes
  :type      number
  :allow-nil nil)

(defcustom uptimes-database "~/.sawfish/uptimes"
  "File that holds the uptimes database."
  :group     uptimes
  :type      file-name
  :allow-nil nil)

(defcustom uptimes-count 10
  "Number of uptimes to keep on file."
  :group     uptimes
  :type      number
  :allow-nil nil)

(defcustom uptimes-autosave t
  "Should the uptime data be auto-saved?"
  :group     uptimes
  :type      boolean
  :after-set (lambda (var)
               (if (symbol-value var)
                   (uptimes-autosave-start)
                 (uptimes-autosave-stop))))

(defcustom uptimes-autosave-interval 300
  "How often, in seconds, should we autosave the data?"
  :group     uptimes
  :type      number
  :allow-nil nil
  :after-set (lambda ()
               (when uptimes-autosave
                 (uptimes-autosave-stop)
                 (uptimes-autosave-start))))

;; Non-customisable variables.

(defvar uptimes-boottime (current-time)
  "The time that uptimes.jl came into existence.")

(defvar uptimes-display-timer nil
  "Handle for the uptime display timer.")

(defvar uptimes-autosave-timer nil
  "Handle for the autosave timer.")

(defvar uptimes-last-n nil
  "Last `uptimes-count' uptimes.")

(defvar uptimes-top-n nil
  "Top `uptimes-count' uptimes.")

(defvar uptimes-uptime-visible nil
  "Is the uptime display visible?")

(defvar uptimes-uptimes-visible nil
  "Is the uptimes display visible?")

;; Main code.

(defun uptimes-key (#!optional boottime)
  "Return an `assoc' key for BOOTTIME.

If BOOTTIME is not supplied the value of `uptimes-boottime' is used."
  (let ((boot (or boottime uptimes-boottime)))
    (format nil "%d-%d" (car boot) (cdr boot))))

(defun uptimes-uptime (#!optional boottime endtime)
  "Return the difference between BOOTTIME and ENDTIME.

If BOOTTIME isn't supplied the value of `uptimes-boottime' is used.

If ENDTIME isn't supplied the return value of `current-time' is used."
  (let ((boot (or boottime uptimes-boottime))
        (end  (or endtime  (current-time))))
    (fix-time (cons (- (car end) (car boot))
                    (- (cdr end) (cdr boot))))))

(defun uptimes-uptime-list (#!optional boottime endtime)
  "Return the difference between BOOTTIME and ENDTIME as a list of values.

If BOOTTIME isn't supplied the value of `uptimes-boottime' is used.

If ENDTIME isn't supplied the return value of `current-time' is used.

The list contains (DAYS HOURS MINS SECS)."
  (let* ((uptime  (uptimes-uptime boottime endtime))
         (days    (car uptime))
         (hours   (truncate (/ (cdr uptime) 3600)))
         (mins    (truncate (/ (- (cdr uptime) (* hours 3600)) 60)))
         (secs    (- (cdr uptime) (* mins  60) (* hours 3600))))
    (list days hours mins secs)))

(defun uptimes-uptime-string (#!optional boottime endtime)
  "Return the difference between BOOTTIME and ENDTIME as a string.

If BOOTTIME isn't supplied the value of `uptimes-boottime' is used.

If ENDTIME isn't supplied the return value of `current-time' is used."
  (apply format (append '(() "%d.%02d:%02d:%02d") (uptimes-uptime-list boottime endtime))))

(defun uptimes-wordy-uptime (#!optional boottime endtime)
  "Return the difference between BOOTTIME and ENDTIME as text.

If BOOTTIME isn't supplied the value of `uptimes-boottime' is used.

If ENDTIME isn't supplied the return value of `current-time' is used."
  (let* ((uptime (uptimes-uptime-list boottime endtime))
         (days   (nth 0 uptime))
         (hours  (nth 1 uptime))
         (mins   (nth 2 uptime))
         (secs   (nth 3 uptime))
         (mul    (lambda (n word) (concat word (unless (= n 1) "s")))))
    (format nil   "%d %s, %d %s, %d %s and %d %s"
            days  (mul days  "day")
            hours (mul hours "hour")
            mins  (mul mins  "minute")
            secs  (mul secs  "second"))))

(defun uptimes-read-uptimes ()
  "Read the list of uptimes.

This function populates the variables `uptimes-last-n' and `uptimes-top-n'
with the historical uptimes. These values are read from the file pointed to
by `uptimes-database'."
  (when (file-exists-p uptimes-database)
    (let ((db (open-file uptimes-database 'read)))
      (unwind-protect
           (setq uptimes-last-n (read db)
                 uptimes-top-n  (read db))
        (close-file db)))))

(defun uptimes-save-uptimes ()
  "Save the list of uptimes.

This function writes the values of `uptimes-last-n' and `uptimes-top-n' to
the file pointed to by `uptimes-database'."
  (uptimes-update)
  (let ((db (open-file uptimes-database 'write)))
    (unwind-protect
         (progn
           (print uptimes-last-n db)
           (print uptimes-top-n db))
      (close-file db))))

(defun uptimes-truncate-list (uptimes)
  "Truncate UPTIMES to `uptimes-count' items in length."
  (let ((trunc-point (nthcdr (1- uptimes-count) uptimes)))
    (when (consp trunc-point)
      (setcdr trunc-point nil))
    uptimes))

(defun uptimes-update-list (uptimes now sort-pred)
  "Update the uptime record for NOW in UPTIMES and sort on SORT-PRED."
  (let* ((key  (uptimes-key))
         (this (cdr (assoc key uptimes))))
    (unless this
      (setq this    (cons uptimes-boottime nil)
            uptimes (append (list (cons key this)) uptimes)))
    (setcdr this now)
    (uptimes-truncate-list (sort uptimes sort-pred))))

(defun uptimes-update ()
  "Update the list of uptimes."
  (uptimes-read-uptimes)
  (let ((now (current-time)))
    (setq uptimes-last-n (uptimes-update-list
                          uptimes-last-n now
                          (lambda (x y) (> (cddr x) (cddr y))))
          uptimes-top-n  (uptimes-update-list
                          uptimes-top-n now
                          (lambda (x y)
                            (> (uptimes-uptime (cadr x) (cddr x))
                               (uptimes-uptime (cadr y) (cddr y))))))))

(defun uptimes-display-start ()
  "Start an uptime display."
  (when uptimes-display-timer
    (delete-timer uptimes-display-timer))
  (setq uptimes-display-timer
        (make-timer uptimes-display-clear uptimes-display-timeout 0)))

(defun uptimes-display-clear ()
  "Clear an uptime display."
  (interactive)
  (when uptimes-display-timer
    (display-message nil)
    (delete-timer uptimes-display-timer)
    (setq uptimes-display-timer nil)))

(defun uptimes-display-uptime (#!optional no-autoclear)
  "Display the sawfish session's uptime."
  (interactive)
  (display-message (format nil "sawfish has been up and running for\n%s"
                           (uptimes-wordy-uptime)))
  (unless no-autoclear
    (uptimes-display-start)))

(defun uptimes-toggle-uptime ()
  "Toggle the permanent display of the current uptime."
  (interactive)
  (if uptimes-uptime-visible
      (progn
        (display-message)
        (setq uptimes-uptime-visible nil))
    (uptimes-display-uptime t)
    (setq uptimes-uptime-visible  t
          uptimes-uptimes-visible nil)))

(defun uptimes-format-uptime (s uptime)
  "Format UPTIME onto stream S."
  (let ((format-time
         (lambda (time)
           (current-time-string time "%Y-%m-%d %T"))))
    (format s "%19s %19s %12s %s\n"
            (format-time (cadr uptime))
            (format-time (cddr uptime))
            (uptimes-uptime-string (cadr uptime) (cddr uptime))
            (if (string= (car uptime) (uptimes-key)) "<---" ""))))

(defun uptimes-display-uptimes (#!optional no-autoclear)
  "Display the sawfish uptime history."
  (interactive)
  (uptimes-update)
  (let* ((msg    (make-string-output-stream))
         (fmt    (lambda (uptime) (uptimes-format-uptime msg uptime)))
         (header (lambda (s)
                   (format s "Boot                Endtime             Uptime       This sawfish\n")
                   (format s "=================== =================== ============ ============\n"))))
    (format msg "Last %d sawfish uptimes\n\n" uptimes-count)    
    (header msg)
    (mapc fmt uptimes-last-n)
    (format msg "\nTop %d sawfish uptimes\n\n" uptimes-count)
    (header msg)
    (mapc fmt uptimes-top-n)
    (display-message (get-output-stream-string msg))
    (unless no-autoclear
      (uptimes-display-start))))

(defun uptimes-toggle-uptimes ()
  "Toggle the permanent display of the uptime history."
  (interactive)
  (if uptimes-uptimes-visible
      (progn
        (display-message)
        (setq uptimes-uptimes-visible nil))
    (uptimes-display-uptimes t)
    (setq uptimes-uptimes-visible t
          uptimes-uptime-visible nil)))

(defun uptimes-autosave-uptimes ()
  "Timer handler for the autosaving of uptimes."
  (uptimes-save-uptimes)
  (set-timer uptimes-autosave-timer))

(defun uptimes-autosave-start ()
  "Turn on autosaving of the uptimes."
  (unless uptimes-autosave-timer
    (setq uptimes-autosave-timer
          (make-timer uptimes-autosave-uptimes uptimes-autosave-interval 0))))

(defun uptimes-autosave-stop ()
  "Stop the autosave timer."
  (when uptimes-autosave-timer
    (delete-timer uptimes-autosave-timer)
    (setq uptimes-autosave-timer nil)))

;; Stuff to do when we're loaded.

(uptimes-save-uptimes)
(when uptimes-autosave
  (uptimes-autosave-start))
(unless (in-hook-p 'before-exit-hook uptimes-save-uptimes)
  (add-hook 'before-exit-hook uptimes-save-uptimes))

(provide 'uptimes)

;;; uptimes.jl ends here

;; match-window.jl -- match windows to properties

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This module provides a general mechanism for setting properties on
;; matched windows as they're created.

(define-structure sawfish.wm.ext.match-window

    (export match-window-grab-x-property
	    define-match-window-group
	    define-match-window-property
	    define-match-window-setter
	    define-match-window-formatter
	    add-window-matcher
	    remove-window-matcher
	    match-window)

    (open rep
	  rep.system
	  rep.regexp
	  sawfish.wm
	  sawfish.wm.windows
	  sawfish.wm.util.groups)

  (define-structure-alias match-window sawfish.wm.ext.match-window)

;;; configuration and customize stuff

  (i18n-defvar match-window-x-properties
               '((WM_NAME . "Name")
                 (WM_CLASS . "Class")
                 (WM_ICON_NAME . "Icon Name")
                 (WM_WINDOW_ROLE . "Role")
                 (WM_CLIENT_MACHINE . "Host")
                 (WM_COMMAND . "Command")
                 (WM_LOCALE_NAME . "Locale")))

  ;; Actions (for example, `ignore-program-position') are,
  ;; if declared by `define-match-window-setter' in this file,
  ;; handled by it. Otherwise registered with `window-put'.
  (i18n-defvar
   match-window-properties
   `((geometry ,(_ "Geometry")
	       (ignore-program-position boolean)
	       (place-mode ,(lambda () `(choice ,@placement-modes)))
	       ;; If for example x is -100, then the right border
	       ;; lies 100 pixels away from the right edge of the screen.
	       (position (or
			  (pair (number -65536 65536 0)
				(number -65536 65536 0))
			  (choice center east north north-east
				  north-west south south-east
				  south-west west)))
	       (workspace (number 1))
	       (new-workspace boolean)
	       (new-viewport boolean)
	       (viewport (pair (number 1) (number 1)))
	       (depth (range (-16 . 16) 0))
	       (placement-weight (number 0))
	       (fixed-position boolean)
	       (fixed-size boolean)
	       (sticky boolean)
	       (sticky-viewport boolean)
	       )
     (focus ,(_ "Focus")
            (raise-on-focus boolean)
            (focus-when-mapped (choice always never))
            (never-focus boolean)
            (focus-click-through boolean)
            (focus-mode ,(lambda () `(choice ,@focus-modes)))
	    (iconify-on-leave boolean))
     (appearance ,(_ "Appearance")
                 (frame-type ,(lambda ()
                                `(choice ,@(mapcar car match-window-types))))
                 (frame-style ,(lambda ()
                                 `(symbol ,@(find-all-frame-styles t))))
		 (window-type (choice normal dialog dock desktop menu toolbar utility splashscreen))
		 (title-position (choice top bottom right left))
		 (dimensions (pair (number 1) (number 1)))
		 (maximized (choice all vertical horizontal
				    fullscreen full-xinerama))
		 (iconified boolean)
		 (shaded boolean)
		 (shade-hover boolean)
		 (never-iconify boolean)
		 (never-maximize boolean)
		 (animator (choice none solid wireframe cross elliptical draft))
		 )
     (other ,(_ "Other")
            (avoid boolean)
            (ignored boolean)
            (group ,(lambda ()
                      `(symbol ,@(delete-if-not symbolp (window-group-ids)))))
            (tab-group string)
            (force-tab boolean)
            (ungrouped boolean)
            (cycle-skip boolean)
            (window-list-skip boolean)
            (task-list-skip boolean)
            (unique-name boolean)
            (window-name string)
            (transients-above (choice all parents none))
            (ignore-stacking-requests boolean)
	    (auto-gravity boolean)
	    (never-delete boolean)
	    (never-tile boolean)
	    )))

  ;; alist of (PROPERTY . FEATURE) mapping properties to the lisp
  ;; libraries implementing them
  (defvar match-window-features
    '((raise-on-focus . auto-raise)
      (shade-hover . shade-hover)))

  (defvar match-window-types
    '((normal . default)
      (title-only . shaped)
      (border-only . transient)
      (top-border . shaped-transient)
      (none . unframed)))

  (define (match-window-widget)
    (let ((props (mapcar
		  (lambda (sub)
		    (cons (cadr sub)
			  (mapcar (lambda (prop)
				    (if (functionp (cadr prop))
					(list* (car prop)
					       ((cadr prop))
					       (cddr prop))
				      prop))
				  (cddr sub)))) match-window-properties)))
      `(match-window ,props ,match-window-x-properties)))

  (put 'match-window 'custom-widget match-window-widget)

  ;;###autoload (defgroup match-window "Matched Windows" :layout single :require sawfish.wm.ext.match-window)
  (defgroup match-window "Window Rules"
    :layout single
    :require sawfish.wm.ext.match-window)

  ;; List of (MATCH-ELTS . ACTION-ELTS)
  ;; Each MATCH-ELT is (PROP . REGEXP or NUMBER or SYMBOL)
  ;; Each ACTION-ELT is (PROP . VALUE)
  (defcustom match-window-profile nil
    nil
    :type match-window
    :group match-window
    :require sawfish.wm.ext.match-window)

  ;; used by sawfish-config when grabbing property values
  (define (match-window-grab-x-property real-prop)
    (let ((window (select-window))
	  prop)
      (when window
	(setq prop (get-x-property window real-prop))
	(if (and prop (eq (car prop) 'STRING))
	    (setq prop (get-x-text-property window real-prop))
	  (setq prop (nth 2 prop)))
	(when prop
	  (cond ((get real-prop 'match-window-formatter)
		 (setq prop ((get real-prop 'match-window-formatter) prop)))
		((vectorp prop)
		 (setq prop (aref prop 0))))))
      (when (stringp prop)
	(setq prop (concat #\^ (quote-regexp prop) #\$)))
      prop))

  (define (define-match-window-group group name)
    (unless (assq group match-window-properties)
      (setq match-window-properties (nconc match-window-properties
					   (list (list group name))))))

  (define (define-match-window-property name group . def)
    (let* ((group-cell (or (assq group match-window-properties)
			   (error "Unknown match-window group: %s" group)))
	   (item-cell (assq name (cddr group-cell))))
      (if item-cell
	  (rplacd item-cell def)
	(rplacd (cdr group-cell) (nconc (cddr group-cell)
					(list (cons name def)))))))

  (define (define-match-window-setter name setter)
    (put name 'match-window-setter setter))

  (define (define-match-window-formatter name formatter)
    (put name 'match-window-formatter formatter))

  (define (alist-eq-p a b)
    "Whether alist a and b are equal. Used by add/remove-window-matcher"
    (let (ret-val tem)
      (when (eq (length a)
		(length b))
	(setq ret-val t)
	(while b
	  (setq tem (assoc (caar b) a))
	  (if (and tem
		   (equal (cdr tem) (cdar b)))
	      (setq b (cdr b))
	    (setq ret-val nil)
	    (setq b nil))))
      ret-val))

;;; main entry point

  (define (add-window-matcher rules #!rest actions)
    ;; #!rest is used to support the old usage.
    ;; The new grammar is (add-window-matcher rules actions),
    ;; where `actions' is an alist.
    ;;
    ;; The old grammar remains supported, but it is deprecated.
    ;; It was:
    ;;  (add-window-matcher 'WM_CLASS "Term"
    ;;       '(place-mode . interactive)
    ;;       '(maximize . all)
    ;;        ... )
    ;; The new style is introduced in 1.6. The old one can be deleted in
    ;; future.
    ;;
    ;; It used to have a bug in how the match was done.
    ;; Read the commit log.
    ;;
    ;; This wrapper function exists only to support the old use.
    (if (consp rules)
	(add-window-matcher-core rules (car actions))
      ;; old usage
      (add-window-matcher-core (list (cons rules (car actions)))
			       (cdr actions)))
    )

  (define (add-window-matcher-core rules actions)
    (catch 'out
      (let
	  ((add-to (lambda (slot)
		     (mapc (lambda (action)
			     (let
				 ((tem (assq (car action) (cdr slot))))
			       (if tem
				   (rplacd tem (cdr action))
				 (rplacd slot (cons action (cdr slot))))))
			   actions))))
	;; does the list already contain any actions for rules?
	;; then add, using add-to.
	(mapc (lambda (cell)
		(when (alist-eq-p rules (car cell))
		  (add-to cell)
		  (throw 'out t)))
	      match-window-profile)
	;; no. create new entry
	(setq match-window-profile (cons (list* rules actions)
					 match-window-profile))
	)))

  (define (remove-window-matcher rules #!rest props)
    ;; See add-window-matcher for why this wrapper is.
    (if (consp rules)
	(remove-window-matcher-core rules (car props))
      ;; old usage
      (remove-window-matcher-core (list (cons rules (car props)))
				  (cdr props)))
    )

  (define (remove-window-matcher-core rules props)
    (let
	((remove-from (lambda (slot)
			(mapc (lambda (p)
				(let
				    ((tem (assq p (cdr slot))))
				  (when tem
				    (rplacd slot (delq tem (cdr slot))))))
			      props))))
      (mapc (lambda (cell)
	      (when (alist-eq-p rules (car cell))
		(remove-from cell)))
	    match-window-profile)
      ;; remove any empty matchers
      (setq match-window-profile
	    (delete-if (lambda (cell)
			 (null (cdr cell))) match-window-profile))))

;;; matcher code

  (define (safe-string-match re . args)
    (condition-case data
	(apply string-match re args)
      (regexp-error
       (format standard-error
	       "regexp error in match-window: %s, %s" re (car data)))))

  (define (match-window w)
    (let ((prop-cache '()))

      ;; Get the X property P of window W, uses a cache, will
      ;; reformat properties with a match-window-formatter property
      (define (get-prop p)
	(let
	    ((tem (assq p prop-cache)))
	  (if tem
	      (cdr tem)
	    (setq tem (copy-sequence (get-x-property w p)))
	    (when (and tem (eq (car tem) 'STRING))
	      (rplaca (cddr tem) (get-x-text-property w p)))
	    (when (and tem (get p 'match-window-formatter))
	      (rplaca (cddr tem) ((get p 'match-window-formatter)
				  (nth 2 tem))))
	    (setq prop-cache (cons (cons p tem) prop-cache))
	    tem)))

      ;; Return t if X property PROP of window W matches INPUT (a
      ;; regexp, number, or symbol)
      (define (match-prop prop input)
	(catch 'out
	  (cond ((and (stringp input)
		      (or (stringp prop)
			  (and (vectorp prop)
			       (> (length prop) 0)
			       (stringp (aref prop 0)))))
		 ;; regexp match
		 (if (vectorp prop)
		     (do ((i 0 (1+ i)))
			 ((= i (length prop)) nil)
		       (when (safe-string-match input (aref prop i))
			 (throw 'out t)))
		   (safe-string-match input prop)))
		((and (numberp input) (numberp prop))
		 (= input prop))
		(t (equal input prop)))))

      ;; Execute the list of actions for window W
      (define (run-actions actions)
	(mapc (lambda (cell)
		(let ((feature (cdr (assq (car cell) match-window-features))))
		  (when feature
		    (require feature)))
		((or (get (car cell) 'match-window-setter) window-put)
		 w (car cell)
		 (if (eq (cdr cell) '#f) nil (cdr cell))))
	      actions)
	;; hack alert!
	(when (assq 'position actions)
	  (window-put w 'placed t)))

      ;; Return t if the window W satisfies a MATCH.  A MATCH can be one of:
      ;; * (cons PROP VALUE) where PROP is a symbol → checks whether property is
      ;;   defined on window and whether it matches VALUE.
      ;; * (cons FUNC ARGS) where FUNC is a function → calls function with
      ;;   window as first argument and ARGS as remaining arguments to determine
      ;;   whether window matches.
      (define (matches-p match)
        (and (consp match)
             (cond ((symbolp (car match))
                    (let ((prop (get-prop (car match))))
                      (and prop (match-prop (nth 2 prop) (cdr match)))))
                   ((functionp (car match))
                    (apply (car match) w (cdr match))))))

      (mapc (lambda (cell)
              (catch 'out
                (mapc (lambda (match)
                        (unless (matches-p match)
                          (throw 'out nil)))
                      (car cell))
		(run-actions (cdr cell))))
	    match-window-profile)))

  (add-hook 'before-add-window-hook match-window t)

;;; custom property formatters and setters

  (define-match-window-formatter 'WM_CLASS
    (lambda (vec)
      (format nil "%s/%s" (and (> (length vec) 1) (aref vec 1)) (aref vec 0))))

  (define-match-window-formatter 'WM_COMMAND
    (lambda (vec)
      (let ((i 0)
            parts)
        (while (< i (length vec))
          (when parts
            (setq parts (cons ?  parts)))
          (setq parts (cons (aref vec i) parts))
          (setq i (1+ i)))
        (apply concat (nreverse parts)))))

  (define-match-window-setter 'workspace
    (lambda (w prop value)
      (declare (unused prop))
      (unless (or (window-get w 'placed) (window-workspaces w))
        ;; translate from 1.. to 0..
        (set-window-workspaces w (list (1- value))))))

  (define-match-window-setter 'window-type
    (lambda (w prop value)
      (declare (unused prop))
      (cond ((eq value 'normal)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_NORMAL) 'ATOM 32)
         (set-window-type w 'default))
	    ((eq value 'dialog)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_DIALOG) 'ATOM 32)
         (mark-window-as-transient w))
        ((eq value 'dock)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_DOCK) 'ATOM 32)
         (mark-window-as-dock w))
        ((eq value 'desktop)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_DESKTOP) 'ATOM 32)
         (mark-window-as-desktop w))
        ((eq value 'menu)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_MENU) 'ATOM 32)
         (set-window-type w 'menu))
        ((eq value 'toolbar)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_TOOLBAR) 'ATOM 32)
         (set-window-type w 'toolbar))
        ((eq value 'utility)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_UTILITY) 'ATOM 32)
         (set-window-type w 'utility))
        ((eq value 'splashscreen)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_SPLASHSCREEN) 'ATOM 32)
         (set-window-type w 'splash)
         (window-put w 'place-mode 'centered)))))

  (define-match-window-setter 'position
    (lambda (w prop value)
      (declare (unused prop))
      (let* (xx
	     yy
	     (size (window-frame-dimensions w))
	     (vp-offset (viewport-offset-coord (window-viewport w)))
	     (x (if (symbolp value)
		    (cond ((memq value '(east south-east north-east))
			   (- (screen-width) (car size)))
			  ((memq value '(north center south))
			   (- (quotient (screen-width) 2)
			      (quotient (car size) 2)))
			  (t 0))
		  ;; numeric value
		  (setq xx (car value))
		  (if (< xx 0)
		      (setq xx (+ (- (screen-width) (car size)) xx))
		    xx)
		  ))
	     (y (if (symbolp value)
		    (cond ((memq value '(south south-east south-west))
			   (- (screen-height) (cdr size)))
			  ((memq value '(east center west))
			   (- (quotient (screen-height) 2)
			      (quotient (cdr size) 2)))
			  (t 0))
		  ;; numeric value
		  (setq yy (cdr value))
		  (if (< yy 0)
		      (setq yy (+ (- (screen-height) (cdr size)) yy))
		    yy)))
	     (gravity (cond ((symbolp value)
			     value)
			    ((and (< x 0) (< y 0))
			     'south-east)
			    ((< x 0)
			     'north-east)
			    ((< y 0)
			     'south-west)
			    (t nil))))
        (when gravity
          (window-put w 'gravity gravity))
        (move-window-to w
                        (+ (car vp-offset) x)
                        (+ (cdr vp-offset) y)))))

  (define-match-window-setter 'dimensions
    (lambda (w prop value)
      (declare (unused prop))
      (resize-window-with-hints* w (car value) (cdr value))))

  (define-match-window-setter 'viewport
    (lambda (w prop value)
      (declare (unused prop))
      (unless (window-get w 'placed)
        (set-screen-viewport (1- (car value)) (1- (cdr value)))
        (set-window-viewport w (1- (car value)) (1- (cdr value))))))

  (define-match-window-setter 'frame-type
    (lambda (w prop value)
      (declare (unused prop))
      (set-window-type w (or (cdr (assq value match-window-types)) value))))

  (define-match-window-setter 'ungrouped
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (add-window-to-new-group w))))

  (define-match-window-setter 'unique-name
    (lambda (w prop value)
      (declare (unused prop))
      (when value
	(uniquify-window-name w))))

  (define-match-window-setter 'focus-mode
    (lambda (w prop value)
      (declare (unused prop))
      (set-focus-mode w value)))

  (define-match-window-setter 'new-workspace
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (unless (window-get w 'placed)
          (let ((space (car (workspace-limits))))
            (while (not (workspace-empty-p space))
              (setq space (1+ space)))
            (set-window-workspaces w (list space)))))))

  (define-match-window-setter 'new-viewport
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (unless (window-get w 'placed)
          (let ((row 0)
                (col 0)
                (nomatch t))
            (while (and nomatch (< row (cdr viewport-dimensions)))
              (setq col 0)
              (while (and nomatch (< col (car viewport-dimensions)))
                (if (null (viewport-windows col row nil t))
                    (setq nomatch nil)
                  (setq col (1+ col))))
              (if nomatch
                  (setq row (1+ row))))
            (when nomatch
              (let ((cols (car viewport-dimensions))
                    (rows (cdr viewport-dimensions)))
                (if (<= cols rows)
                    (setq viewport-dimensions (cons (1+ cols) rows)
                          col cols
                          row 0)
                  (setq viewport-dimensions (cons cols (1+ rows))
                        col 0
                        row rows))))
            (set-screen-viewport col row)
            (set-window-viewport w col row))))))

  (define-match-window-setter 'tab-group
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (window-put w 'tab-group (intern value)))))

  (define-match-window-setter 'window-name
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (rename-window w value))))

  (define-match-window-setter 'maximized
    (lambda (w prop value)
      (declare (unused prop))
      (cond ((eq value 'vertical)
	     (window-put w 'queued-vertical-maximize t))
	    ((eq value 'horizontal)
	     (window-put w 'queued-horizontal-maximize t))
	    ((eq value 'all)
	     (window-put w 'queued-vertical-maximize t)
	     (window-put w 'queued-horizontal-maximize t))
	    ((eq value 'fullscreen)
	     (window-put w 'queued-fullscreen-maximize t))
	    ((eq value 'full-xinerama)
	     (window-put w 'queued-fullxinerama-maximize t))
	    )))

  (define-match-window-setter 'keymap-trans
    (lambda (w prop value)
      (declare (unused prop))
      (let ((keymap (or (window-get w 'keymap)
                        (window-put w 'keymap (copy-sequence window-keymap)))))
        (mapcar
         (lambda (pair)         ; pair of from and to keys
           (bind-keys keymap (car pair)
                      (lambda () (interactive)
                        (synthesize-event (lookup-event (cadr pair))
                                          (current-event-window))))) value))))

  )

;; prompt-wm.jl -- prompt variants for windows/workspaces

;; Contributed by Dave Pearson <davep@davep.org>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(declare (in-module sawfish.wm.util.prompt))

(require 'sawfish.wm.workspace)
(require 'sawfish.wm.windows)

(define (prompt-for-window #!optional title)
  "Prompt for a window title, return the window associated with that title."
  (letrec ((show-in-list-p
            (lambda (w)
              (and
               (not (window-get w 'ignored))
               (window-get w 'workspaces))))
           (window-names
            (lambda (windows)
              (when windows
                (if (show-in-list-p (car windows))
                    (cons (window-name (car windows))
			  (window-names (cdr windows)))
                  (window-names (cdr windows))))))
           (names-matching
            (lambda (re names)
              (when names
                (if (string-match re (car names))
                    (cons (car names) (names-matching re (cdr names)))
                  (names-matching re (cdr names))))))
           (complete-windows
            (lambda (text)
              (names-matching (format nil "^%s" text)
                              (sort (window-names (managed-windows)))))))
    (let ((window-title (prompt #:title (or title (_ "Window:"))
                                #:completion-fun complete-windows)))
      (unless (zerop (length window-title))
        (cdr (assoc window-title (mapcar (lambda (w)
					   (cons (window-name w) w))
					 (managed-windows))))))))

(define (prompt-for-workspace #!optional title)
  "Prompt for a workspace title, return the workspace number."
  (letrec ((make-workspace-list
            (lambda (ws)
              (unless (zerop ws)
                (cons (or (nth (1- ws) workspace-names)
                          (format nil (_ "Workspace %d") ws))
                      (make-workspace-list (1- ws))))))
           (workspaces
            (lambda ()
              (reverse (make-workspace-list (1+ (cdr (workspace-limits)))))))
           (names-matching
            (lambda (re names)
              (when names
                (if (string-match re (car names))
                    (cons (car names) (names-matching re (cdr names)))
                  (names-matching re (cdr names))))))
           (complete-workspaces
            (lambda (text)
              (names-matching (format nil "^%s" text) (workspaces)))))
    (let ((ws-title (prompt #:title (or title (_ "Workspace:"))
                            #:completion-fun complete-workspaces))
          (wsl (workspaces)))
      (unless (zerop (length ws-title))
        (let ((where (member ws-title wsl)))
          (when where
            (- (length wsl) (length where))))))))

;; nokogiri-widgets/command.jl
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.command

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
          rep.util.misc
          rep.util.misc
          sawfish.gtk.widget
          sawfish.cfg.wm)

  (define all-commands)

  (define (command-name command) (or (car command) command))

  (define (command-type command)
    (and (listp command) (cadr (memq #:type command))))

  (define (get-command name)
    (or (memq name all-commands) (assq name all-commands)))

  (define (filter-command-list) all-commands)

  (define (command-item x) (list (beautify-symbol-name (command-name x))))

  (define (make-command-item changed)

    (unless all-commands
      (setq all-commands (wm-command-list)))

    (let ((commands (filter-command-list))
	  (clist (gtk-clist-new-with-titles (list (_ "Command"))))
	  (text-view (gtk-text-view-new))
	  (vbox (gtk-vbox-new nil box-spacing))
	  (scroller (gtk-scrolled-window-new))
	  (scroller-2 (gtk-scrolled-window-new))
	  (params-hbox (gtk-hbox-new nil box-spacing))
	  (selection 0)
	  (params-spec nil)
	  (params-widget nil))

      (define (update-doc)
	(let ((doc (remove-newlines
		    (or (wm-documentation
			 (command-name (nth selection commands)))
			(_ "Undocumented"))))
	      (buffer (gtk-text-view-get-buffer text-view))
	      (iter (gtk-text-iter-new)))
	  (gtk-text-buffer-set-text buffer doc (length doc))
	  (gtk-text-buffer-get-start-iter buffer iter)
	  (gtk-text-buffer-place-cursor buffer iter)))

      (define (update-params)
	(let ((new-spec (command-type (nth selection commands))))
	  (unless (equal new-spec params-spec)
	    (when params-widget
	      (gtk-container-remove params-hbox (widget-gtk-widget
						 params-widget))
	      (setq params-widget nil))
	    (setq params-spec new-spec)
	    (if (null params-spec)
		(gtk-widget-hide params-hbox)
	      (setq params-widget (make-widget params-spec changed))
	      (gtk-container-add params-hbox (widget-gtk-widget params-widget))
	      (gtk-widget-show params-hbox)))))

      (mapc (lambda (c)
	      (gtk-clist-append clist (command-item c))) commands)

      (g-signal-connect clist "select_row"
                        (lambda (w row col)
                          (declare (unused w col))
                          (setq selection row)
                          (update-params)
                          (update-doc)
                          (call-callback changed)))

      ;; seems you have to `moveto' _after_ the widget is realized..
      (g-signal-connect clist "map"
                        (lambda ()
                          (gtk-clist-moveto clist selection 0)))

      (gtk-text-view-set-wrap-mode text-view 'word)
      (gtk-text-view-set-editable text-view nil)
      (gtk-widget-set-size-request text-view -1 50)
      (gtk-clist-set-selection-mode clist 'browse)
      (gtk-scrolled-window-set-policy scroller 'automatic 'automatic)
      (gtk-scrolled-window-set-policy scroller-2 'automatic 'automatic)
      (gtk-container-add scroller clist)
      (gtk-container-add scroller-2 text-view)
      (gtk-box-pack-end vbox scroller-2)
      (gtk-container-add vbox scroller)
      (gtk-box-pack-end vbox params-hbox)
      (gtk-widget-show-all vbox)
      (unless params-widget
	(gtk-widget-hide params-hbox))
      (gtk-widget-set-size-request vbox 350 350)
      (update-doc)

      (lambda (op)
	(case op
	  ((gtk-widget) vbox)
	  ((clear) (lambda ()
		     (when params-widget
		       (widget-clear params-widget))
		     (gtk-clist-select-row 0 0)
		     (gtk-clist-moveto clist 0 0)))
	  ((set) (lambda (x)
		   (let ((index (option-index commands (command-name x))))
		     (unless index
		       ;; scan in all-commands
		       (setq index (option-index
				    all-commands (command-name x)))
		       (if index
			   ;; yes, add it to the list
			   (let ((command (nth index all-commands)))
			     (setq commands (nconc commands (list command)))
			     (gtk-clist-append clist (command-item command))
			     (setq index (1- (length commands))))
			 (setq index 0)))
		     (setq selection index)
		     (gtk-clist-select-row clist index 0)
		     (gtk-clist-moveto clist index 0)
		     (when (cdr x)
		       (update-params)
		       (widget-set params-widget (cdr x))))))
	  ((ref) (lambda ()
		   (if params-widget
		       (cons (command-name (nth selection commands))
			     (widget-ref params-widget))
		     (command-name (nth selection commands)))))
	  ((validp) (lambda (x)
		      ;; XXX check params
		      (memq (command-name (car x)) commands)))))))

  (define-widget-type 'command make-command-item))

;; match-window.jl -- match windows to properties

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This module provides a general mechanism for setting properties on
;; matched windows as they're created.

(define-structure sawfish.wm.ext.match-window

    (export match-window-grab-x-property
	    define-match-window-group
	    define-match-window-property
	    define-match-window-setter
	    define-match-window-formatter
	    add-window-matcher
	    remove-window-matcher
	    match-window)

    (open rep
	  rep.system
	  rep.regexp
	  sawfish.wm
	  sawfish.wm.windows
	  sawfish.wm.util.groups)

  (define-structure-alias match-window sawfish.wm.ext.match-window)

;;; configuration and customize stuff

  (i18n-defvar match-window-x-properties
               '((WM_NAME . "Name")
                 (WM_CLASS . "Class")
                 (WM_ICON_NAME . "Icon Name")
                 (WM_WINDOW_ROLE . "Role")
                 (WM_CLIENT_MACHINE . "Host")
                 (WM_COMMAND . "Command")
                 (WM_LOCALE_NAME . "Locale")))

  ;; Actions (for example, `ignore-program-position') are,
  ;; if declared by `define-match-window-setter' in this file,
  ;; handled by it. Otherwise registered with `window-put'.
  (i18n-defvar
   match-window-properties
   `((geometry ,(_ "Geometry")
	       (ignore-program-position boolean)
	       (place-mode ,(lambda () `(choice ,@placement-modes)))
	       ;; If for example x is -100, then the right border
	       ;; lies 100 pixels away from the right edge of the screen.
	       (position (or
			  (pair (number -65536 65536 0)
				(number -65536 65536 0))
			  (choice center east north north-east
				  north-west south south-east
				  south-west west)))
	       (workspace (number 1))
	       (new-workspace boolean)
	       (new-viewport boolean)
	       (viewport (pair (number 1) (number 1)))
	       (depth (range (-16 . 16) 0))
	       (placement-weight (number 0))
	       (fixed-position boolean)
	       (fixed-size boolean)
	       (sticky boolean)
	       (sticky-viewport boolean)
	       )
     (focus ,(_ "Focus")
            (raise-on-focus boolean)
            (focus-when-mapped (choice always never))
            (never-focus boolean)
            (focus-click-through boolean)
            (focus-mode ,(lambda () `(choice ,@focus-modes)))
	    (iconify-on-leave boolean))
     (appearance ,(_ "Appearance")
                 (frame-type ,(lambda ()
                                `(choice ,@(mapcar car match-window-types))))
                 (frame-style ,(lambda ()
                                 `(symbol ,@(find-all-frame-styles t))))
		 (window-type (choice normal dialog dock desktop menu toolbar utility splashscreen))
		 (title-position (choice top bottom right left))
		 (dimensions (pair (number 1) (number 1)))
		 (maximized (choice all vertical horizontal
				    fullscreen full-xinerama))
		 (iconified boolean)
		 (shaded boolean)
		 (shade-hover boolean)
		 (never-iconify boolean)
		 (never-maximize boolean)
		 (animator (choice none solid wireframe cross elliptical draft))
		 )
     (other ,(_ "Other")
            (avoid boolean)
            (ignored boolean)
            (group ,(lambda ()
                      `(symbol ,@(delete-if-not symbolp (window-group-ids)))))
            (tab-group string)
            (force-tab boolean)
            (ungrouped boolean)
            (cycle-skip boolean)
            (window-list-skip boolean)
            (task-list-skip boolean)
            (unique-name boolean)
            (window-name string)
            (transients-above (choice all parents none))
            (ignore-stacking-requests boolean)
	    (auto-gravity boolean)
	    (never-delete boolean)
	    (never-tile boolean)
	    )))

  ;; alist of (PROPERTY . FEATURE) mapping properties to the lisp
  ;; libraries implementing them
  (defvar match-window-features
    '((raise-on-focus . auto-raise)
      (shade-hover . shade-hover)))

  (defvar match-window-types
    '((normal . default)
      (title-only . shaped)
      (border-only . transient)
      (top-border . shaped-transient)
      (none . unframed)))

  (define (match-window-widget)
    (let ((props (mapcar
		  (lambda (sub)
		    (cons (cadr sub)
			  (mapcar (lambda (prop)
				    (if (functionp (cadr prop))
					(list* (car prop)
					       ((cadr prop))
					       (cddr prop))
				      prop))
				  (cddr sub)))) match-window-properties)))
      `(match-window ,props ,match-window-x-properties)))

  (put 'match-window 'custom-widget match-window-widget)

  ;;###autoload (defgroup match-window "Matched Windows" :layout single :require sawfish.wm.ext.match-window)
  (defgroup match-window "Window Rules"
    :layout single
    :require sawfish.wm.ext.match-window)

  ;; List of (MATCH-ELTS . ACTION-ELTS)
  ;; Each MATCH-ELT is (PROP . REGEXP or NUMBER or SYMBOL)
  ;; Each ACTION-ELT is (PROP . VALUE)
  (defcustom match-window-profile nil
    nil
    :type match-window
    :group match-window
    :require sawfish.wm.ext.match-window)

  ;; used by sawfish-config when grabbing property values
  (define (match-window-grab-x-property real-prop)
    (let ((window (select-window))
	  prop)
      (when window
	(setq prop (get-x-property window real-prop))
	(if (and prop (eq (car prop) 'STRING))
	    (setq prop (get-x-text-property window real-prop))
	  (setq prop (nth 2 prop)))
	(when prop
	  (cond ((get real-prop 'match-window-formatter)
		 (setq prop ((get real-prop 'match-window-formatter) prop)))
		((vectorp prop)
		 (setq prop (aref prop 0))))))
      (when (stringp prop)
	(setq prop (concat #\^ (quote-regexp prop) #\$)))
      prop))

  (define (define-match-window-group group name)
    (unless (assq group match-window-properties)
      (setq match-window-properties (nconc match-window-properties
					   (list (list group name))))))

  (define (define-match-window-property name group . def)
    (let* ((group-cell (or (assq group match-window-properties)
			   (error "Unknown match-window group: %s" group)))
	   (item-cell (assq name (cddr group-cell))))
      (if item-cell
	  (rplacd item-cell def)
	(rplacd (cdr group-cell) (nconc (cddr group-cell)
					(list (cons name def)))))))

  (define (define-match-window-setter name setter)
    (put name 'match-window-setter setter))

  (define (define-match-window-formatter name formatter)
    (put name 'match-window-formatter formatter))

  (define (alist-eq-p a b)
    "Whether alist a and b are equal. Used by add/remove-window-matcher"
    (let (ret-val tem)
      (when (eq (length a)
		(length b))
	(setq ret-val t)
	(while b
	  (setq tem (assoc (caar b) a))
	  (if (and tem
		   (equal (cdr tem) (cdar b)))
	      (setq b (cdr b))
	    (setq ret-val nil)
	    (setq b nil))))
      ret-val))

;;; main entry point

  (define (add-window-matcher rules #!rest actions)
    ;; #!rest is used to support the old usage.
    ;; The new grammar is (add-window-matcher rules actions),
    ;; where `actions' is an alist.
    ;;
    ;; The old grammar remains supported, but it is deprecated.
    ;; It was:
    ;;  (add-window-matcher 'WM_CLASS "Term"
    ;;       '(place-mode . interactive)
    ;;       '(maximize . all)
    ;;        ... )
    ;; The new style is introduced in 1.6. The old one can be deleted in
    ;; future.
    ;;
    ;; It used to have a bug in how the match was done.
    ;; Read the commit log.
    ;;
    ;; This wrapper function exists only to support the old use.
    (if (consp rules)
	(add-window-matcher-core rules (car actions))
      ;; old usage
      (add-window-matcher-core (list (cons rules (car actions)))
			       (cdr actions)))
    )

  (define (add-window-matcher-core rules actions)
    (catch 'out
      (let
	  ((add-to (lambda (slot)
		     (mapc (lambda (action)
			     (let
				 ((tem (assq (car action) (cdr slot))))
			       (if tem
				   (rplacd tem (cdr action))
				 (rplacd slot (cons action (cdr slot))))))
			   actions))))
	;; does the list already contain any actions for rules?
	;; then add, using add-to.
	(mapc (lambda (cell)
		(when (alist-eq-p rules (car cell))
		  (add-to cell)
		  (throw 'out t)))
	      match-window-profile)
	;; no. create new entry
	(setq match-window-profile (cons (list* rules actions)
					 match-window-profile))
	)))

  (define (remove-window-matcher rules #!rest props)
    ;; See add-window-matcher for why this wrapper is.
    (if (consp rules)
	(remove-window-matcher-core rules (car props))
      ;; old usage
      (remove-window-matcher-core (list (cons rules (car props)))
				  (cdr props)))
    )

  (define (remove-window-matcher-core rules props)
    (let
	((remove-from (lambda (slot)
			(mapc (lambda (p)
				(let
				    ((tem (assq p (cdr slot))))
				  (when tem
				    (rplacd slot (delq tem (cdr slot))))))
			      props))))
      (mapc (lambda (cell)
	      (when (alist-eq-p rules (car cell))
		(remove-from cell)))
	    match-window-profile)
      ;; remove any empty matchers
      (setq match-window-profile
	    (delete-if (lambda (cell)
			 (null (cdr cell))) match-window-profile))))

;;; matcher code

  (define (safe-string-match re . args)
    (condition-case data
	(apply string-match re args)
      (regexp-error
       (format standard-error
	       "regexp error in match-window: %s, %s" re (car data)))))

  (define (match-window w)
    (let ((prop-cache '()))

      ;; Get the X property P of window W, uses a cache, will
      ;; reformat properties with a match-window-formatter property
      (define (get-prop p)
	(let
	    ((tem (assq p prop-cache)))
	  (if tem
	      (cdr tem)
	    (setq tem (copy-sequence (get-x-property w p)))
	    (when (and tem (eq (car tem) 'STRING))
	      (rplaca (cddr tem) (get-x-text-property w p)))
	    (when (and tem (get p 'match-window-formatter))
	      (rplaca (cddr tem) ((get p 'match-window-formatter)
				  (nth 2 tem))))
	    (setq prop-cache (cons (cons p tem) prop-cache))
	    tem)))

      ;; Return t if X property PROP of window W matches INPUT (a
      ;; regexp, number, or symbol)
      (define (match-prop prop input)
	(catch 'out
	  (cond ((and (stringp input)
		      (or (stringp prop)
			  (and (vectorp prop)
			       (> (length prop) 0)
			       (stringp (aref prop 0)))))
		 ;; regexp match
		 (if (vectorp prop)
		     (do ((i 0 (1+ i)))
			 ((= i (length prop)) nil)
		       (when (safe-string-match input (aref prop i))
			 (throw 'out t)))
		   (safe-string-match input prop)))
		((and (numberp input) (numberp prop))
		 (= input prop))
		(t (equal input prop)))))

      ;; Execute the list of actions for window W
      (define (run-actions actions)
	(mapc (lambda (cell)
		(let ((feature (cdr (assq (car cell) match-window-features))))
		  (when feature
		    (require feature)))
		((or (get (car cell) 'match-window-setter) window-put)
		 w (car cell)
		 (if (eq (cdr cell) '#f) nil (cdr cell))))
	      actions)
	;; hack alert!
	(when (assq 'position actions)
	  (window-put w 'placed t)))

      (mapc (lambda (cell)
	      (when (catch 'out
		      (mapc (lambda (match)
			      (let ((prop (and (symbolp (car match))
					       (get-prop (car match)))))
				(when (or (not prop)
					  (not (match-prop (nth 2 prop)
							   (cdr match))))
				  (throw 'out nil))))
			    (car cell))
		      t)
		(run-actions (cdr cell))))
	    match-window-profile)))

  (add-hook 'before-add-window-hook match-window t)

;;; custom property formatters and setters

  (define-match-window-formatter 'WM_CLASS
    (lambda (vec)
      (format nil "%s/%s" (and (> (length vec) 1) (aref vec 1)) (aref vec 0))))

  (define-match-window-formatter 'WM_COMMAND
    (lambda (vec)
      (let ((i 0)
            parts)
        (while (< i (length vec))
          (when parts
            (setq parts (cons ?  parts)))
          (setq parts (cons (aref vec i) parts))
          (setq i (1+ i)))
        (apply concat (nreverse parts)))))

  (define-match-window-setter 'workspace
    (lambda (w prop value)
      (declare (unused prop))
      (unless (or (window-get w 'placed) (window-workspaces w))
        ;; translate from 1.. to 0..
        (set-window-workspaces w (list (1- value))))))

  (define-match-window-setter 'window-type
    (lambda (w prop value)
      (declare (unused prop))
      (cond ((eq value 'normal)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_NORMAL) 'ATOM 32)
         (set-window-type w 'default))
	    ((eq value 'dialog)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_DIALOG) 'ATOM 32)
         (mark-window-as-transient w))
        ((eq value 'dock)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_DOCK) 'ATOM 32)
         (mark-window-as-dock w))
        ((eq value 'desktop)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_DESKTOP) 'ATOM 32)
         (mark-window-as-desktop w))
        ((eq value 'menu)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_MENU) 'ATOM 32)
         (set-window-type w 'menu))
        ((eq value 'toolbar)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_TOOLBAR) 'ATOM 32)
         (set-window-type w 'toolbar))
        ((eq value 'utility)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_UTILITY) 'ATOM 32)
         (set-window-type w 'utility))
        ((eq value 'splashscreen)
	     (set-x-property w '_NET_WM_WINDOW_TYPE (vector '_NET_WM_WINDOW_TYPE_SPLASHSCREEN) 'ATOM 32)
         (set-window-type w 'splash)
         (window-put w 'place-mode 'centered)))))

  (define-match-window-setter 'position
    (lambda (w prop value)
      (declare (unused prop))
      (let* (xx
	     yy
	     (size (window-frame-dimensions w))
	     (vp-offset (viewport-offset-coord (window-viewport w)))
	     (x (if (symbolp value)
		    (cond ((memq value '(east south-east north-east))
			   (- (screen-width) (car size)))
			  ((memq value '(north center south))
			   (- (quotient (screen-width) 2)
			      (quotient (car size) 2)))
			  (t 0))
		  ;; numeric value
		  (setq xx (car value))
		  (if (< xx 0)
		      (setq xx (+ (- (screen-width) (car size)) xx))
		    xx)
		  ))
	     (y (if (symbolp value)
		    (cond ((memq value '(south south-east south-west))
			   (- (screen-height) (cdr size)))
			  ((memq value '(east center west))
			   (- (quotient (screen-height) 2)
			      (quotient (cdr size) 2)))
			  (t 0))
		  ;; numeric value
		  (setq yy (cdr value))
		  (if (< yy 0)
		      (setq yy (+ (- (screen-height) (cdr size)) yy))
		    yy)))
	     (gravity (cond ((symbolp value)
			     value)
			    ((and (< x 0) (< y 0))
			     'south-east)
			    ((< x 0)
			     'north-east)
			    ((< y 0)
			     'south-west)
			    (t nil))))
        (when gravity
          (window-put w 'gravity gravity))
        (move-window-to w
                        (+ (car vp-offset) x)
                        (+ (cdr vp-offset) y)))))

  (define-match-window-setter 'dimensions
    (lambda (w prop value)
      (declare (unused prop))
      (resize-window-with-hints* w (car value) (cdr value))))

  (define-match-window-setter 'viewport
    (lambda (w prop value)
      (declare (unused prop))
      (unless (window-get w 'placed)
        (set-screen-viewport (1- (car value)) (1- (cdr value)))
        (set-window-viewport w (1- (car value)) (1- (cdr value))))))

  (define-match-window-setter 'frame-type
    (lambda (w prop value)
      (declare (unused prop))
      (set-window-type w (or (cdr (assq value match-window-types)) value))))

  (define-match-window-setter 'ungrouped
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (add-window-to-new-group w))))

  (define-match-window-setter 'unique-name
    (lambda (w prop value)
      (declare (unused prop))
      (when value
	(uniquify-window-name w))))

  (define-match-window-setter 'focus-mode
    (lambda (w prop value)
      (declare (unused prop))
      (set-focus-mode w value)))

  (define-match-window-setter 'new-workspace
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (unless (window-get w 'placed)
          (let ((space (car (workspace-limits))))
            (while (not (workspace-empty-p space))
              (setq space (1+ space)))
            (set-window-workspaces w (list space)))))))

  (define-match-window-setter 'new-viewport
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (unless (window-get w 'placed)
          (let ((row 0)
                (col 0)
                (nomatch t))
            (while (and nomatch (< row (cdr viewport-dimensions)))
              (setq col 0)
              (while (and nomatch (< col (car viewport-dimensions)))
                (if (null (viewport-windows col row nil t))
                    (setq nomatch nil)
                  (setq col (1+ col))))
              (if nomatch
                  (setq row (1+ row))))
            (when nomatch
              (let ((cols (car viewport-dimensions))
                    (rows (cdr viewport-dimensions)))
                (if (<= cols rows)
                    (setq viewport-dimensions (cons (1+ cols) rows)
                          col cols
                          row 0)
                  (setq viewport-dimensions (cons cols (1+ rows))
                        col 0
                        row rows))))
            (set-screen-viewport col row)
            (set-window-viewport w col row))))))

  (define-match-window-setter 'tab-group
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (window-put w 'tab-group (intern value)))))

  (define-match-window-setter 'window-name
    (lambda (w prop value)
      (declare (unused prop))
      (when value
        (rename-window w value))))

  (define-match-window-setter 'maximized
    (lambda (w prop value)
      (declare (unused prop))
      (cond ((eq value 'vertical)
	     (window-put w 'queued-vertical-maximize t))
	    ((eq value 'horizontal)
	     (window-put w 'queued-horizontal-maximize t))
	    ((eq value 'all)
	     (window-put w 'queued-vertical-maximize t)
	     (window-put w 'queued-horizontal-maximize t))
	    ((eq value 'fullscreen)
	     (window-put w 'queued-fullscreen-maximize t))
	    ((eq value 'full-xinerama)
	     (window-put w 'queued-fullxinerama-maximize t))
	    )))

  (define-match-window-setter 'keymap-trans
    (lambda (w prop value)
      (declare (unused prop))
      (let ((keymap (or (window-get w 'keymap)
                        (window-put w 'keymap (copy-sequence window-keymap)))))
        (mapcar
         (lambda (pair)         ; pair of from and to keys
           (bind-keys keymap (car pair)
                      (lambda () (interactive)
                        (synthesize-event (lookup-event (cadr pair))
                                          (current-event-window))))) value))))

  )

;; sawfish.wm.misc bootstrap
;;
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(declare (in-module sawfish.wm.misc))

(open-structures '(rep
		   rep.regexp
		   rep.module-system
		   rep.io.files
		   #|
		     Don't add more sawfish.wm.* here unless you know
		     what you're doing. Instead, embed 'require' in
		     definition. It's because this file is read
		     from windows.jl. See windows.jl for more.
		   |#
		   sawfish.wm.windows.subrs
		   sawfish.wm.events))

(defvar *user-module* nil)

(defmacro with-server-grabbed (#!rest forms)
  "Execute FORMS with the server grabbed."
  `(progn
     (grab-server)
     (unwind-protect
	 (progn ,@forms)
       (ungrab-server))))

(define (call-with-server-ungrabbed thunk)
  "Return the result of calling the zero-parameter function THUNK. If the
server is currently grabbed, ungrab it first, restoring the original grab
status after the call to THUNK returns."
  (let loop ((counter 0))
    (if (server-grabbed-p)
	(progn
	  (ungrab-server)
	  (loop (1+ counter)))
      (unwind-protect
	  (thunk)
	(do ((i 0 (1+ i)))
	    ((= i counter))
	  (grab-server))))))

(define grab-counter 0)

(define (call-with-keyboard-grabbed thunk)
  "Call the zero-parameter function THUNK with the keyboard grabbed. If unable
to grab the keyboard then THUNK won't be called."
  (when (grab-keyboard)
    (unwind-protect
	(progn
	  (setq grab-counter (1+ grab-counter))
	  (thunk))
      (when (zerop (setq grab-counter (1- grab-counter)))
	(ungrab-keyboard)))))

(define (call-with-pointer-grabbed thunk)
  (when (grab-pointer)
    (unwind-protect
        (progn
	  (setq grab-counter (1+ grab-counter))
	  (thunk))
      (when (zerop (setq grab-counter (1- grab-counter)))
	(ungrab-pointer)))))


(define (call-with-error-handler thunk)
  (condition-case data
      (thunk)
    (error
     (error-handler-function (car data) (cdr data)))))

(define (make-directory-recursively dir)
  "Try to create dir and all nonexistent parent dirs (like mkdir -p)."
  (while (not (file-exists-p dir))
    (let ((tem dir))
      (while (not (file-exists-p (expand-file-name ".." tem)))
	(setq tem (expand-file-name ".." tem)))
      (make-directory tem))))

(define (locate-file filename dirs)
  "Search for a file called FILENAME in any of the directories named by the
list of strings DIRS."
  (let loop ((rest dirs))
    (cond ((null rest) nil)
	  ((file-exists-p (expand-file-name filename (car rest)))
	   (expand-file-name filename (car rest)))
	  (t (loop (cdr rest))))))

(define (clamp x lower upper)
  (cond ((< x lower) lower)
	((> x upper) upper)
	(t x)))

(define (clamp* x w lower upper)
  (cond ((< x lower) lower)
	((> (+ x w) upper) (- upper w))
	(t x)))

(define (uniquify-list lst)
  "Remove all duplicates from list, tests using eq, order is lost."
  (let (out)
    (mapc (lambda (x)
	    (unless (memq x out)
	      (setq out (cons x out)))) lst)
    out))

(define (screen-dimensions)
  "Return the screen dimensions in pixels as a cons cell `(WIDTH . HEIGHT)'."
  (cons (screen-width) (screen-height)))

(define (pointer-head)
  "Return the id of a head currently containing the mouse pointer."
  (find-head (query-pointer)))

(define (current-head #!optional (w (input-focus)))
  "Return the id of the `current' head."
  (require 'sawfish.wm.windows)
  (if (not (desktop-window-p w))
      (or (and w (let ((point (window-position w))
                       (dims (window-dimensions w)))
                   (find-head (+ (car point) (quotient (car dims) 2))
                              (+ (cdr point) (quotient (cdr dims) 2)))))
          (pointer-head))
    (pointer-head)))

(define (current-head-dimensions #!optional (w (input-focus)))
  "Return a cons-cell defining the size in pixels of the current head (that
containing the window W, or containing the window with input focus if W is
false). Returns the screen dimensions if no such head can be identified."
  (or (and w (let ((head (current-head w)))
               (if head
                   (head-dimensions head)
                 (screen-dimensions))))
      (head-dimensions (pointer-head))))

(define (current-head-offset #!optional (w (input-focus)))
  "Return a cons-cell defining the origin of the current head (that
containing the window W, or containing the window with input focus if W is
false). Returns '(0 . 0) if no such head can be identified."
  (or (and w (let ((head (current-head w)))
               (if head
                   (head-offset head)
                 (cons 0 0))))
      (head-offset (pointer-head))))

(define (load-module name)
  "Ensure that the module called NAME has been loaded. Note that this does
_not_ import its bindings (or even make them accessible)."
  (intern-structure name))

(define (eval-in form struct-name)
  "Evaluate FORM in the module called STRUCT-NAME."
  (eval form (or (get-structure struct-name)
		 (error "Unknown module: %s" struct-name))))

(define (user-eval form)
  "Evaluate FORM in the `user' module."
  (eval form *user-module*))

(define (user-require feature)
  "Require FEATURE in the `user' module."
  (user-eval `(require ',feature)))

(define (quote-menu-item string)
  "Escape any `_' characters in STRING such that the result can be used as
the label of a menu item."
  (string-replace "_" "__" string))

(define (get-x-text-property w prop)
  "Fetches the X property named PROP from window W and returns a
vector of strings representing the contents of the property."
  (let ((value (get-x-property w prop)))
    (when (and value (stringp (caddr value)))
      (let ((string (caddr value)))
	;; regexp code chokes on NUL bytes, so do this the long way..
	(let loop ((start 0)
		   (point 0)
		   (out '()))
	  (cond ((= point (length string))
		 (apply vector (nreverse (cons (substring
						string start point) out))))
		((= (aref string point) 0)
		 (loop (1+ point) (1+ point)
		       (cons (substring string start point) out)))
		(t (loop start (1+ point) out))))))))

(define (set-x-text-property w prop seq #!optional (encoding 'STRING))
  "Set the X property named PROP on window W to the text property obtained
by concatenating the sequence of strings SEQ."
  (set-x-property w prop (mapconcat identity seq 0) encoding 8))

;; exports

(export-bindings
 '(with-server-grabbed call-with-server-ungrabbed call-with-pointer-grabbed
                       call-with-keyboard-grabbed call-with-error-handler
                       make-directory-recursively locate-file
                       clamp clamp* uniquify-list screen-dimensions
                       pointer-head current-head current-head-dimensions
                       current-head-offset load-module eval-in
                       user-eval user-require quote-menu-item
                       get-x-text-property set-x-text-property))

;; maximize.jl -- window maximization

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.state.maximize

    (export window-maximized-p
	    window-maximized-horizontally-p
	    window-maximized-vertically-p
	    window-maximized-fullscreen-p
	    window-unmaximized-position
	    window-unmaximized-dimensions
	    window-maximizable-p
	    frame-part-movable-p
	    maximize-truncate-dims
	    maximize-find-workarea
	    window-locked-vertically-p
	    window-locked-horizontally-p
	    maximize-window
	    unmaximize-window
	    maximize-window-vertically
	    maximize-window-horizontally
	    maximize-window-toggle
	    maximize-window-vertically-toggle
	    maximize-window-horizontally-toggle
	    maximize-fill-window
	    maximize-fill-window-vertically
	    maximize-fill-window-horizontally
	    maximize-fill-window-toggle
	    maximize-fill-window-vertically-toggle
	    maximize-fill-window-horizontally-toggle
	    maximize-window-fullscreen
	    maximize-window-fullscreen-toggle
	    maximize-window-fullxinerama
	    maximize-window-fullxinerama-toggle
	    maximize-discard)

    (open rep
	  rep.system
	  sawfish.wm.util.edges
	  sawfish.wm.util.rects
	  sawfish.wm.util.workarea
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.gaol
	  sawfish.wm.session.init
	  sawfish.wm.workspace
	  sawfish.wm.util.stacking
	  sawfish.wm.frames
	  sawfish.wm.misc
	  sawfish.wm.focus
          sawfish.wm.viewport
          sawfish.wm.state.shading)

  (define-structure-alias maximize sawfish.wm.state.maximize)

  (defvar maximize-always-expands nil
    "Maximizing a window in one dimension must increase the size of
that dimension.")

  (defvar maximize-raises t
    "Raise windows when they are maximized.")

  (defvar maximize-ignore-when-filling t
    "Let unmanaged windows be overlapped when filling windows.")

  (defvar maximize-avoid-avoided t
    "Don't cover `avoided' windows when maximizing.")

  (defcustom move-lock-when-maximized t
    "Lock position and size while windows are maximized."
    :type boolean
    :group min-max
    :tooltip "Remember that after you resize a maximized window, you can't unmaximize it any more.")

  ;; called when a window is maximized, args (W #!optional DIRECTION)
  (defvar window-maximized-hook nil)

  ;; called when a window is un-maximized, args (W #!optional DIRECTION)
  (defvar window-unmaximized-hook nil)

;;; handling maximized state

  (define (window-maximized-p w)
    (window-get w 'unmaximized-geometry))

  (define (window-maximized-fullscreen-p w)
    (window-get w 'maximized-fullscreen))

  (define (window-maximized-horizontally-p w)
    (window-get w 'maximized-horizontally))

  (define (window-maximized-vertically-p w)
    (window-get w 'maximized-vertically))

;;; States before maximization
  (define (window-unmaximized-position w)
    (let ((coords (window-position w))
	  (old-geom (unmaximized-geometry w)))
      (when (window-maximized-horizontally-p w)
	(rplaca coords (nth 0 old-geom)))
      (when (window-maximized-vertically-p w)
	(rplacd coords (nth 1 old-geom)))
      coords))

  (define (window-unmaximized-dimensions w)
    (let ((dims (window-dimensions w))
	  (old-geom (unmaximized-geometry w)))
      (when (window-maximized-horizontally-p w)
	(rplaca dims (nth 2 old-geom)))
      (when (window-maximized-vertically-p w)
	(rplacd dims (nth 3 old-geom)))
      dims))

  ;; This sets the window property `unmaximized-geometry' of each
  ;; currently maximize window to `(X Y W H)', the saved geometry.
  (define (save-unmaximized-geometry w)
    (unless (window-get w 'unmaximized-geometry)
      (let* ((coords (window-absolute-position w t))
             (dims (window-dimensions w)))
	(window-put w 'unmaximized-geometry (list (car coords) (cdr coords)
						  (car dims) (cdr dims))))))

  ;; Returns (x y width height)
  (define (unmaximized-geometry w)
    (window-get w 'unmaximized-geometry))

;;; Discard states before maximization
  (define (discard-unmaximized-geometry w)
    (window-put w 'unmaximized-geometry nil)
    (pop-window-type w 'sawfish.wm.state.maximize))

  (define (maximize-discard w #!optional direction)
    "Don't treat window as maximized any more, keeping the size and the
position. You'll be able to move and resize, but won't be able to unmaximize.
 If the optional argument `direction' is `vertical' or `horizontal', then
only that direction is unmaximized.
 If the window is not maximized, nothing happens."
    (unless (eq direction 'vertical)
      (window-put w 'maximized-horizontally nil))
    (unless (eq direction 'horizontal)
      (window-put w 'maximized-vertically nil))
    (let ((dims (window-dimensions w))
	  (coords (window-absolute-position w t))
	  (saved (unmaximized-geometry w)))
      (when saved
	(unless (window-maximized-horizontally-p w)
	  (rplaca saved (car coords))
	  (rplaca (nthcdr 2 saved) (car dims)))
	(unless (window-maximized-vertically-p w)
	  (rplaca (cdr saved) (cdr coords))
	  (rplaca (nthcdr 3 saved) (cdr dims))))
      (when (and (not (window-maximized-vertically-p w))
		 (not (window-maximized-horizontally-p w)))
	(discard-unmaximized-geometry w))))

  (define-command 'maximize-discard maximize-discard
    #:spec "%W"
    #:doc "Don't treat window as maximized any more, keeping the size and the position. You'll be able to move and resize, but won't be able to unmaximize."
    )

  #|
  (define (maximize-discard-move w directions #!key successful)
    (when successful
      (maximize-discard w (memq 'horizontal directions)
			(memq 'vertical directions))))

  ;; This is now disabled - it doesn't really make sense for moving..
  ;; (add-hook 'after-move-hook maximize-discard-move)
  |#

  (define (maximize-discard-resize w edges #!key successful)
    (when successful
      (let ((horiz (or (memq 'left edges) (memq 'right edges)))
	    (vert (or (memq 'top edges) (memq 'bottom edges))))
	(cond
	 ((and horiz (not vert))
	  (maximize-discard w 'horizontal))
	 ((and vert (not horiz))
	  (maximize-discard w 'vertical))
	 (t
	  (maximize-discard w))))))

  ;; After the window is resized, then the original size is meaningless.
  (add-hook 'after-resize-hook maximize-discard-resize)

;;; 1D packing

  (defmacro edges-touching (start end edge)
    `(> (- (min ,end (nth 2 ,edge)) (max ,start (nth 1 ,edge))) 0))

  (define (expand-edges start end minimum maximum perp-1 perp-2 edges)
    (if maximize-always-expands
	(progn
	  (mapc (lambda (edge)
		  ;; EDGE is (PERP START END OPEN-P)
		  (if (nth 3 edge)
		      (when (and (< (car edge) maximum)
				 (>= (car edge) perp-2)
				 (> (car edge) minimum)
				 (edges-touching start end edge))
			(setq maximum (car edge)))
		    (when (and (> (car edge) minimum)
			       (<= (car edge) perp-1)
			       (< (car edge) maximum)
			       (edges-touching start end edge))
		      (setq minimum (car edge)))))
		edges)
	  (cons minimum maximum))
      (let ((opening (sort (mapcar car (filter (lambda (e)
						 (and (nth 3 e)
						      (edges-touching
						       start end e)))
					       edges))))
	    (closing (sort (mapcar car (filter (lambda (e)
						 (and (not (nth 3 e))
						      (edges-touching
						       start end e)))
					       edges))))
	    max-perp
	    (max-size 0))
	;; find the maximum gap between a closing and an opening edge which
	;; doesn't include any other opening edges
	(while (and opening closing)
	  (while (and opening (<= (car opening) (car closing)))
	    (setq opening (cdr opening)))
	  (when (and (> (- (or (car opening) maximum) (car closing)) max-size)
		     (or (not (nth 1 closing))
			 (>= (nth 1 closing) (or (car opening) maximum))))
	    (setq max-perp (car closing))
	    (setq max-size (- (car opening) (car closing))))
	  (setq closing (cdr closing)))
	(if max-perp
	    (cons max-perp (+ max-perp max-size))
	  (cons perp-1 perp-2)))))

  (define (do-horizontal w edges coords dims fdims)
    (let* ((head (window-head-any-viewport w))
           (head-offset (head-offset head))
           (head-dims (head-dimensions head)))
      (let ((x-span (expand-edges (cdr coords) (+ (cdr coords) (cdr fdims))
				  (car head-offset)
				  (+ (car head-offset) (car head-dims))
				  (car coords) (+ (car coords) (car fdims))
				  (car edges))))
	(rplaca coords (car x-span))
	(rplaca dims (- (- (cdr x-span) (car x-span))
			(- (car fdims) (car dims))))
	w)))

  (define (do-vertical w edges coords dims fdims)
    (let* ((head (window-head-any-viewport w))
           (head-offset (head-offset head))
           (head-dims (head-dimensions head)))
      (let ((y-span (expand-edges (car coords) (+ (car coords) (car fdims))
				  (cdr head-offset)
				  (+ (cdr head-offset) (cdr head-dims))
				  (cdr coords) (+ (cdr coords) (cdr fdims))
				  (cdr edges))))
	(rplacd coords (car y-span))
	(rplacd dims (- (- (cdr y-span) (car y-span))
			(- (cdr fdims) (cdr dims))))
	w)))

;;; 2D packing

  (define (do-both window avoided edges coords dims fdims)
    (let ((max-rect (largest-rectangle-from-edges
		     edges
                     #:avoided avoided
                     #:head (window-head-any-viewport window))))
      (when max-rect
	(rplaca coords (nth 0 max-rect))
	(rplacd coords (nth 1 max-rect))
	(rplaca dims (- (- (nth 2 max-rect) (nth 0 max-rect))
			(- (car fdims) (car dims))))
	(rplacd dims (- (- (nth 3 max-rect) (nth 1 max-rect))
			(- (cdr fdims) (cdr dims))))
	window)))

;;; size hints stuff

  (define (window-maximizable-p w #!optional direction hints)
    (if (window-get w 'never-maximize)
	nil
      (unless hints
	(setq hints (window-size-hints w)))
      (let ((max-width (cdr (assq 'max-width hints)))
	    (max-height (cdr (assq 'max-height hints)))
	    (dims (window-dimensions w)))
	(catch 'out
	  (when (and (or (null direction) (eq direction 'horizontal))
		     max-width
		     (>= (car dims) max-width))
	    (throw 'out nil))
	  (when (and (or (null direction) (eq direction 'vertical))
		     max-height
		     (>= (cdr dims) max-height))
	    (throw 'out nil))
	  t))))

  (define (maximize-truncate-dims w dims #!optional direction hints)
    (unless hints
      (setq hints (window-size-hints w)))
    (let ((x-base (or (cdr (or (assq 'base-width hints)
			       (assq 'min-width hints))) 1))
	  (x-inc (or (cdr (assq 'width-inc hints)) 1))
	  (y-base (or (cdr (or (assq 'base-height hints)
			       (assq 'min-height hints))) 1))
	  (y-inc (or (cdr (assq 'height-inc hints)) 1))
	  (x-max (cdr (assq 'max-width hints)))
	  (y-max (cdr (assq 'max-height hints)))

	  (trunc (lambda (x inc base #!optional maximum)
		   (min (+ base (max 0 (- (- x base) (mod (- x base) inc))))
			(or maximum 65535)))))
      (when (or (null direction) (eq direction 'horizontal))
	(rplaca dims (trunc (car dims) x-inc x-base x-max)))
      (when (or (null direction) (eq direction 'vertical))
	(rplacd dims (trunc (cdr dims) y-inc y-base y-max)))
      dims))

;;; misc functions

  (define (maximize-find-workarea #!optional w #!key head head-fallback)
    "This function is deprecated. Use calculate-workarea instead."
    (declare (unused head-fallback))
    (calculate-workarea #:window w #:head head))

  (define (window-locked-vertically-p w)
    (and move-lock-when-maximized
	 (window-maximized-vertically-p w)))

  (define (window-locked-horizontally-p w)
    (and move-lock-when-maximized
	 (window-maximized-horizontally-p w)))

  (define (frame-part-movable-p w part)
    (if (not move-lock-when-maximized)
	t
      (let ((h-maximized (window-maximized-horizontally-p w))
	    (v-maximized (window-maximized-vertically-p w)))
	(case part
	  ((top-border bottom-border) (not v-maximized))
	  ((left-border right-border) (not h-maximized))
	  ((top-left-corner top-right-corner
                            bottom-left-corner bottom-right-corner title)
	   (not (and h-maximized v-maximized)))))))

;;; commands

  (define (maximize-window w #!optional direction only-1d)
    "Maximize the dimensions of the window."
    (when (window-get w 'shaded)
      (unshade-window w))
    (when (window-maximized-fullscreen-p w)
      (maximize-window-fullscreen w nil))
    (let* ((viewport (window-viewport w))
           (coords (window-position w))
           (head (window-head-any-viewport w))
           (dims (window-dimensions w))
           (fdims (window-frame-dimensions w))
           (hints (window-size-hints w))
           (avoided (and maximize-avoid-avoided (avoided-windows w)))
           (edges (get-visible-window-edges
                   #:with-ignored-windows t
                   #:windows avoided
                   #:include-heads (list head)
                   #:viewport viewport)))
      (when (window-maximizable-p w direction hints)
        (save-unmaximized-geometry w)
        (cond ((null direction)
               (if (not only-1d)
                   (do-both w avoided edges coords dims fdims)
                 (do-horizontal w edges coords dims fdims)
                 (do-vertical w edges coords dims fdims))
               (window-put w 'maximized-horizontally t)
               (window-put w 'maximized-vertically t))
              ((eq direction 'horizontal)
               (do-horizontal w edges coords dims fdims)
               (window-put w 'maximized-horizontally t))
              ((eq direction 'vertical)
               (do-vertical w edges coords dims fdims)
               (window-put w 'maximized-vertically t)))
        (maximize-truncate-dims w dims direction hints)
        (move-resize-window-to w (car coords) (cdr coords)
                               (car dims) (cdr dims))
        (when maximize-raises
          (raise-window* w))
        (call-window-hook 'window-maximized-hook w (list direction))
        (call-window-hook 'window-state-change-hook w
                          (list '(maximized))))))

  ;; does all unmaximizing except for changing the window properties and
  ;; calling the hooks
  (define (unmaximize-window-1 w #!optional direction before)
    (let ((vp-offset (viewport-offset-coord (window-viewport w)))
          (geom (unmaximized-geometry w))
	  (coords (window-position w))
	  (dims (window-dimensions w)))
      (when geom
	(when (memq direction '(() fullscreen horizontal))
	  (rplaca coords (+ (nth 0 geom) (car vp-offset)))
	  (rplaca dims (nth 2 geom)))
	(when (memq direction '(() fullscreen vertical))
	  (rplacd coords (+ (nth 1 geom) (cdr vp-offset)))
	  (rplacd dims (nth 3 geom)))
	(when before
	  (before))
	(move-resize-window-to w (car coords) (cdr coords)
			       (car dims) (cdr dims)))))

  (define (unmaximize-window w #!optional direction)
    "Restore the dimensions of the window to its original,
unmaximized, state."
    (unmaximize-window-1 w direction
                         (lambda ()
                           (when (memq direction '(() fullscreen horizontal))
                             (window-put w 'maximized-horizontally nil))
                           (when (memq direction '(() fullscreen vertical))
                             (window-put w 'maximized-vertically nil))
                           (window-put w 'maximized-fullscreen nil)
                           (when (and (not (window-maximized-vertically-p w))
                                      (not (window-maximized-horizontally-p w))
                                      (not (window-maximized-fullscreen-p w)))
                             (discard-unmaximized-geometry w))))
    (warp-pointer-if-necessary w)
    (call-window-hook 'window-unmaximized-hook w (list direction))
    (call-window-hook 'window-state-change-hook w (list '(maximized))))

  (define (maximize-window-vertically w)
    "Maximize the vertical dimension of the window."
    (maximize-window w 'vertical))

  (define (maximize-window-horizontally w)
    "Maximize the horizontal dimension of the window."
    (maximize-window w 'horizontal))

  (define (maximize-window-toggle w #!optional direction)
    "Toggle the state of the window between maximized and unmaximized."
    (if (window-maximized-p w)
	(unmaximize-window w direction)
      (maximize-window w direction)))

  (define (maximize-window-vertically-toggle w)
    "Toggle the state of the window between vertically maximized and
unmaximized."
    (if (window-maximized-vertically-p w)
	(unmaximize-window w 'vertical)
      (maximize-window w 'vertical)))

  (define (maximize-window-horizontally-toggle w)
    "Toggle the state of the window between horizontally maximized and
unmaximized."
    (if (window-maximized-horizontally-p w)
	(unmaximize-window w 'horizontal)
      (maximize-window w 'horizontal)))

  ;;###autoload
  (define-command 'maximize-window
    maximize-window #:spec "%W")
  (define-command 'unmaximize-window
    unmaximize-window #:spec "%W")
  (define-command 'maximize-window-vertically
    maximize-window-vertically #:spec "%W")
  (define-command 'maximize-window-horizontally
    maximize-window-horizontally #:spec "%W")
  (define-command 'maximize-window-toggle
    maximize-window-toggle #:spec "%W")
  (define-command 'maximize-window-horizontally-toggle
    maximize-window-horizontally-toggle #:spec "%W")
  (define-command 'maximize-window-vertically-toggle
    maximize-window-vertically-toggle #:spec "%W")

;;; fill commands

  (define (maximize-fill-window w #!optional direction)
    "Maximize the window without obscuring any other windows."
    (let ((avoid-by-default t)
	  (maximize-always-expands t)
	  (dont-avoid-ignored maximize-ignore-when-filling))
      (maximize-window w direction t)))

  (define (maximize-fill-window-vertically w)
    "Maximize the window vertically without obscuring any other windows."
    (maximize-fill-window w 'vertical))

  (define (maximize-fill-window-horizontally w)
    "Maximize the window horizontally without obscuring any other windows."
    (maximize-fill-window w 'horizontal))

  (define (maximize-fill-window-toggle w #!optional direction)
    "Toggle the state of the window between maximized-filled and unmaximized."
    (if (window-maximized-p w)
	(unmaximize-window w direction)
      (maximize-fill-window w direction)))

  (define (maximize-fill-window-vertically-toggle w)
    "Toggle the state of the window between vertically maximized-filled and
unmaximized."
    (if (window-maximized-vertically-p w)
	(unmaximize-window w 'vertical)
      (maximize-fill-window w 'vertical)))

  (define (maximize-fill-window-horizontally-toggle w)
    "Toggle the state of the window between horizontally maximized-filled and
unmaximized."
    (if (window-maximized-horizontally-p w)
	(unmaximize-window w 'horizontal)
      (maximize-fill-window w 'horizontal)))

  ;;###autoload
  (define-command 'maximize-fill-window
    maximize-fill-window #:spec "%W")
  (define-command 'maximize-fill-window-vertically
    maximize-fill-window-vertically #:spec "%W")
  (define-command 'maximize-fill-window-horizontally
    maximize-fill-window-horizontally #:spec "%W")
  (define-command 'maximize-fill-window-toggle
    maximize-fill-window-toggle #:spec "%W")
  (define-command 'maximize-fill-window-horizontally-toggle
    maximize-fill-window-horizontally-toggle #:spec "%W")
  (define-command 'maximize-fill-window-vertically-toggle
    maximize-fill-window-vertically-toggle #:spec "%W")

  ;; fullscreen commands

  (define (maximize-window-fullscreen w state)
    "Fullscreen maximize the window."
    (cond ((and state (not (window-maximized-fullscreen-p w)))
	   (when (window-maximizable-p w)
             (let* ((viewport (window-viewport w))
                    (vp-offset (viewport-offset-coord viewport))
                    (head (window-head-any-viewport w))
                    (head-offset (head-offset head))
                    (head-dims (head-dimensions head)))
	       (save-unmaximized-geometry w)
	       (window-put w 'unmaximized-type (window-type w))
	       (push-window-type w 'unframed 'sawfish.wm.state.maximize)
	       (move-resize-window-to w
                                      (+ (car head-offset) (car vp-offset))
                                      (+ (cdr head-offset) (cdr vp-offset))
                                      (car head-dims) (cdr head-dims))
	       (when maximize-raises
	         (raise-window* w))
	       (window-put w 'maximized-fullscreen t)
	       (window-put w 'maximized-vertically t)
	       (window-put w 'maximized-horizontally t)
	       (call-window-hook 'window-maximized-hook
				 w (list 'fullscreen))
	       (call-window-hook 'window-state-change-hook
				 w (list '(maximized))))))

	  ((and (not state) (window-maximized-fullscreen-p w))
	   (unmaximize-window w 'fullscreen))))

  (define (maximize-window-fullscreen-toggle w)
    "Toggle the state of the window between fullscreen maximized and
unmaximized."
    (maximize-window-fullscreen w (not (window-maximized-fullscreen-p w))))

  (define-command 'maximize-window-fullscreen
    maximize-window-fullscreen #:spec "%W
t")
  (define-command 'maximize-window-fullscreen-toggle
    maximize-window-fullscreen-toggle #:spec "%W")

  (define (maximize-window-fullxinerama w state)
    "Fullscreen maximize the window across all Xinerama screens."
    (cond ((and state (not (window-maximized-fullscreen-p w)))
	   (when (window-maximizable-p w)
	     (let ((screen-dims (screen-dimensions))
                   (vp-offset (viewport-offset-coord (window-viewport w))))
	       (save-unmaximized-geometry w)
	       (window-put w 'unmaximized-type (window-type w))
	       (push-window-type w 'unframed 'sawfish.wm.state.maximize)
	       (move-resize-window-to w
                                      (car vp-offset)
                                      (cdr vp-offset)
                                      (+ (car screen-dims) (car vp-offset))
                                      (+ (cdr screen-dims) (cdr vp-offset)))
	       (when maximize-raises
	         (raise-window* w))
	       (window-put w 'maximized-fullscreen t)
	       (window-put w 'maximized-vertically t)
	       (window-put w 'maximized-horizontally t)
	       (call-window-hook 'window-maximized-hook
				 w (list 'fullscreen))
	       (call-window-hook 'window-state-change-hook
				 w (list '(maximized))))))

	  ((and (not state) (window-maximized-fullscreen-p w))
	   (unmaximize-window w 'fullscreen))))

  (define (maximize-window-fullxinerama-toggle w)
    "Toggle the state of the window between fullscreen maximized
across all Xinerama and unmaximized."
    (maximize-window-fullxinerama w (not (window-maximized-fullscreen-p w))))

  (define-command 'maximize-window-fullxinerama
    maximize-window-fullxinerama #:spec "%W
t")
  
  (define-command 'maximize-window-fullxinerama-toggle
    maximize-window-fullxinerama-toggle #:spec "%W")

;;; initialisation

  (define (maximize-after-add-window w)
    (let ((vert (window-get w 'queued-vertical-maximize))
	  (horiz (window-get w 'queued-horizontal-maximize))
	  (full (window-get w 'queued-fullscreen-maximize))
          (fullxinerama (window-get w 'queued-fullxinerama-maximize)))
      (when (or vert horiz full fullxinerama)
	(when vert
	  (window-put w 'queued-vertical-maximize nil))
	(when horiz
	  (window-put w 'queued-horizontal-maximize nil))
	(when full
	  (window-put w 'queued-fullscreen-maximize nil))
        (when fullxinerama
          (window-put w 'queued-fullxinerama-maximize nil))
        (cond
         (full
          (maximize-window-fullscreen w t))
         (fullxinerama
          (maximize-window-fullxinerama w t))
         (t
          (maximize-window w (cond ((and vert horiz) nil)
                                   (vert 'vertical)
				   (horiz 'horizontal))))))))

  ;; before exiting, return all windows to their unmaximized
  ;; geometries. But _don't_ change any of the properties (either
  ;; wm-local or X) that mark the window as being maximized
  (add-hook 'before-exit-hook (lambda () (map-windows unmaximize-window-1)))

  (define (check-if-maximizable w)
    (let ((maximizable (window-maximizable-p w)))
      (when (and (not maximizable)
		 (not (frame-class-removed-p w 'maximize-button)))
	(remove-frame-class w 'maximize-button)
	(window-put w 'maximize-removed-maximize-button t))
      (when (and maximizable
		 (window-get w 'maximize-removed-maximize-button))
	(add-frame-class w 'maximize-button)
	(window-put w 'maximize-removed-maximize-button nil))))

  (define (property-notify w prop type)
    (declare (unused type))
    (when (eq prop 'WM_NORMAL_HINTS)
      (check-if-maximizable w)))

  (add-hook 'property-notify-hook property-notify)

  (add-hook 'after-initialization-hook
	    (lambda ()
	      (map-windows check-if-maximizable)
              (map-windows maximize-after-add-window)
	      ;; Don't install this hook until after all windows have
	      ;; initially been adopted, to avoid maximizing over
	      ;; avoided windows
	      (add-hook 'add-window-hook check-if-maximizable)
              (add-hook 'after-add-window-hook maximize-after-add-window)))

  (add-hook 'sm-window-save-functions
	    (lambda (w)
	      (if (window-maximized-fullscreen-p w)
		  (list '(maximized-fullscreen . t))
		(nconc (and (window-maximized-horizontally-p w)
			    (list '(maximized-horizontally . t)))
		       (and (window-maximized-vertically-p w)
			    (list '(maximized-vertically . t)))))))

  (add-hook 'sm-restore-window-hook
	    (lambda (w alist)
	      (mapc (lambda (cell)
		      (let ((v (cdr (assq (car cell) alist))))
			(when v
			  (window-put w (cdr cell) v))))
		    '((maximized-fullscreen . queued-fullscreen-maximize)
		      (maximized-vertically . queued-vertical-maximize)
		      (maximized-horizontally . queued-horizontal-maximize)))))

  (sm-add-saved-properties 'unmaximized-geometry)

  (add-swapped-properties
   'unmaximized-geometry 'maximized-vertically
   'maximized-horizontally 'maximized-fullscreen)

  (gaol-add window-maximized-p window-maximized-horizontally-p
	    window-maximized-vertically-p))

;; sawfish.wm.cursors bootstrap
;;
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(declare (in-module sawfish.wm.cursors))

(open-structures '(rep))

(put 'X_cursor 'cursor-shape 0)
(put 'arrow 'cursor-shape 2)
(put 'based_arrow_down 'cursor-shape 4)
(put 'based_arrow_up 'cursor-shape 6)
(put 'boat 'cursor-shape 8)
(put 'bogosity 'cursor-shape 10)
(put 'bottom_left_corner 'cursor-shape 12)
(put 'bottom_right_corner 'cursor-shape 14)
(put 'bottom_side 'cursor-shape 16)
(put 'bottom_tee 'cursor-shape 18)
(put 'box_spiral 'cursor-shape 20)
(put 'center_ptr 'cursor-shape 22)
(put 'circle 'cursor-shape 24)
(put 'clock 'cursor-shape 26)
(put 'coffee_mug 'cursor-shape 28)
(put 'cross 'cursor-shape 30)
(put 'cross_reverse 'cursor-shape 32)
(put 'crosshair 'cursor-shape 34)
(put 'diamond_cross 'cursor-shape 36)
(put 'dot 'cursor-shape 38)
(put 'dotbox 'cursor-shape 40)
(put 'double_arrow 'cursor-shape 42)
(put 'draft_large 'cursor-shape 44)
(put 'draft_small 'cursor-shape 46)
(put 'draped_box 'cursor-shape 48)
(put 'exchange 'cursor-shape 50)
(put 'fleur 'cursor-shape 52)
(put 'gobbler 'cursor-shape 54)
(put 'gumby 'cursor-shape 56)
(put 'hand1 'cursor-shape 58)
(put 'hand2 'cursor-shape 60)
(put 'heart 'cursor-shape 62)
(put 'icon 'cursor-shape 64)
(put 'iron_cross 'cursor-shape 66)
(put 'left_ptr 'cursor-shape 68)
(put 'left_side 'cursor-shape 70)
(put 'left_tee 'cursor-shape 72)
(put 'leftbutton 'cursor-shape 74)
(put 'll_angle 'cursor-shape 76)
(put 'lr_angle 'cursor-shape 78)
(put 'man 'cursor-shape 80)
(put 'middlebutton 'cursor-shape 82)
(put 'mouse 'cursor-shape 84)
(put 'pencil 'cursor-shape 86)
(put 'pirate 'cursor-shape 88)
(put 'plus 'cursor-shape 90)
(put 'question_arrow 'cursor-shape 92)
(put 'right_ptr 'cursor-shape 94)
(put 'right_side 'cursor-shape 96)
(put 'right_tee 'cursor-shape 98)
(put 'rightbutton 'cursor-shape 100)
(put 'rtl_logo 'cursor-shape 102)
(put 'sailboat 'cursor-shape 104)
(put 'sb_down_arrow 'cursor-shape 106)
(put 'sb_h_double_arrow 'cursor-shape 108)
(put 'sb_left_arrow 'cursor-shape 110)
(put 'sb_right_arrow 'cursor-shape 112)
(put 'sb_up_arrow 'cursor-shape 114)
(put 'sb_v_double_arrow 'cursor-shape 116)
(put 'shuttle 'cursor-shape 118)
(put 'sizing 'cursor-shape 120)
(put 'spider 'cursor-shape 122)
(put 'spraycan 'cursor-shape 124)
(put 'star 'cursor-shape 126)
(put 'target 'cursor-shape 128)
(put 'tcross 'cursor-shape 130)
(put 'top_left_arrow 'cursor-shape 132)
(put 'top_left_corner 'cursor-shape 134)
(put 'top_right_corner 'cursor-shape 136)
(put 'top_side 'cursor-shape 138)
(put 'top_tee 'cursor-shape 140)
(put 'trek 'cursor-shape 142)
(put 'ul_angle 'cursor-shape 144)
(put 'umbrella 'cursor-shape 146)
(put 'ur_angle 'cursor-shape 148)
(put 'watch 'cursor-shape 150)
(put 'xterm 'cursor-shape 152)

;; make-theme-preview.jl -- previewing for theme builder

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.theming.make-theme-preview

    (export make-theme-preview)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.theming.make-theme
	  sawfish.wm.frames)

  (define preview-window nil)
  (define preview-type 'default)
  (define preview-theme nil)

  (add-hook 'after-add-window-hook
	    (lambda (w)
	      (let
		  ((class (get-x-text-property w 'WM_CLASS)))
		(when (and (>= (length class) 2)
			   (string= (aref class 1) "SawfishThemer")
			   (string= (aref class 0) "preview"))
		  (setq preview-window w)
		  (when preview-theme
		    (set-window-frame w (preview-theme w preview-type)))))))

  (add-hook 'destroy-notify-hook
	    (lambda (w)
	      (when (eq w preview-window)
		(setq preview-window nil))))

  (defun make-theme-preview (patterns frames mappings #!optional type)
    (let ((theme (make-theme patterns frames mappings)))
      (setq preview-theme theme)
      (when type
	(setq preview-type type))
      (when preview-window
	(set-window-frame preview-window
			  (theme preview-window preview-type))))))

;; user.jl -- do user-local initialization
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; The idea is that the `user' module is where all user code gets to
;; play. By default it has a set of modules opened so that it looks
;; pretty much how the old non-modular wm looked.

;; This means that the `sawfish.wm' structures aren't modified by user
;; code, this is a good thing, since it means that modules importing
;; `sawfish.wm.foo' know what they are getting (no random user
;; bindings)

;; The downside is that it's harder for user extensions to redefine
;; existing code, IMHO this may also be a good thing..

(define-structure user

    (export )

    ((open rep
	   rep.regexp
	   rep.system
	   rep.io.files
	   rep.io.processes
	   sawfish.wm
	   sawfish.wm.util.groups
	   sawfish.wm.util.display-window
	   sawfish.wm.util.compat
	   sawfish.wm.ext.error-handler
	   sawfish.wm.ext.apps-menu
	   sawfish.wm.edge.conf
	   sawfish.wm.edge.actions
	   sawfish.wm.frames
	   sawfish.wm.menus
	   sawfish.wm.commands.launcher
	   sawfish.wm.ext.wallpaper
	   sawfish.wm.prg.compton
	   sawfish.wm.prg.conky
	   sawfish.wm.prg.trayer
	   sawfish.wm.prg.xgamma
	   sawfish.wm.prg.xmobar
	   sawfish.wm.prg.xmodmap
	   sawfish.wm.prg.xsettingsd)
     (access sawfish.wm.integration.kde
	     sawfish.wm.integration.gnome
	     sawfish.wm.integration.xfce
	     sawfish.wm.integration.mate
	     sawfish.wm.integration.lxde
	     sawfish.wm.integration.lumina)

     (set-binds))

  ;; "none" looks ugly, but if you are to change it to "", fix
  ;; apps-menu, too, or it will break.
  (defvar desktop-environment "none"
    "Running desktop environment, detected by Sawfish.
Possible values are \"kde\", \"gnome\", \"mate\", \"xfce\", \"lxde\", \"lumina\" or \"none\".")

  (defvar want-poweroff-menu t
    "Add poweroff menu if you don't use GNOME / KDE / XFCE / Razor-Qt / LXDE / Lumina.")

  (defvar want-extra-menu-entries t
    "Provide additional entries in root menu.")

  (setq *user-structure* 'user)

  ;; frame-style loaded if user hasn't set their own
  (define fallback-frame-style 'StyleTab)

  ;; give root-window 'WINDOW_MANAGER property with value sawfish
  (unless batch-mode
    (set-x-text-property 'root 'WINDOW_MANAGER (vector "sawfish")))

  (define rc-files '("~/.sawfishrc" "~/.sawfish/rc"))

  ;; initialize the special variable pointing at this structure
  (structure () (open rep rep.structures)
    (setq *user-module* (get-structure 'user)))

  (define (safe-load . args)
    (condition-case data
	(apply load args)
      (error
       (error-handler-function (car data) (cdr data)))))

  (define (rename-old-stuff)
    (when (and (file-directory-p "~/.sawmill")
	       (not (file-exists-p "~/.sawfish")))
      (rename-file "~/.sawmill" "~/.sawfish")
      (message "Renamed directory ~/.sawmill -> ~/.sawfish")
      (make-symlink "~/.sawmill" ".sawfish")
      (message "Created .sawmill symlink (delete if unwanted)"))

    (when (and (file-exists-p "~/.sawmillrc")
	       (not (file-exists-p "~/.sawfishrc")))
      (rename-file "~/.sawmillrc" "~/.sawfishrc")
      (message "Renamed file ~/.sawmillrc -> ~/.sawfishrc"))
    )

  ;; Detect desktop environment.
  ;; These functions have to non-nil if it detects a DE, otherwise nil.
  ;; It should also initialize, and set `desktop-environment',
  ;; and probably `want-poweroff-menu', too.
  (define (detect-desktop-environment)
    (or (sawfish.wm.integration.gnome#detect-gnome)
	(sawfish.wm.integration.mate#detect-mate)
	(sawfish.wm.integration.kde#detect-kde)
	(sawfish.wm.integration.xfce#detect-xfce)
	(sawfish.wm.integration.lxde#detect-lxde)
	(sawfish.wm.integration.lumina#detect-lumina))
    )

  ;; Don't signal an error even if user "require" them. These modules
  ;; existed in the past.
  (provide 'sawfish-defaults)
  (provide 'sawfish.wm.defaults)

;;; From here, executed at startup.

  ;; load ~/.sawfish/rc
  (setq error-destination 'init)
  (unless (get-command-line-option "--no-rc")
    (condition-case error-data
	(progn
	  ;; First the site-wide stuff
	  (load-all "site-init" (lambda (f) (safe-load f nil t)))

	  ;; then the users rep configuration, or site-wide defaults
	  (or (safe-load (concat (user-home-directory) ".reprc") t t t)
	      (safe-load "rep-defaults" t))

	  (unless batch-mode
	    (rename-old-stuff)
	    ;; detect DE before loading rc
            (detect-desktop-environment)

	    ;; then the customized options
	    (condition-case data
		(custom-load-user-file)
	      (error
	       (format (stderr-file) "error in custom file--> %S\n" data)))

	    ;; then the sawfish specific user configuration
	    (let loop ((rest rc-files))
	      (when rest
		(if (file-exists-p (car rest))
		    ;; Print stack trace on error during exeuction
		    ;; of ~/.sawfish/rc
		    (let ((%in-condition-case nil))
		      (safe-load (car rest) t t t))
		  (loop (cdr rest)))))))
      (error
       (format (stderr-file) "error in local config--> %S\n" error-data))))

  (when (equal desktop-environment "kde")
    (sawfish.wm.integration.kde#kde-late-init))

  (when (equal desktop-environment "lumina")
    (sawfish.wm.integration.lumina#lumina-window-matchers))

  (unless batch-mode
    (when want-extra-menu-entries
      (let ((menu root-menu))
        (user-require 'sawfish.wm.ext.run-application)
        (nconc menu `(()))
	(unless (equal xterm-program "")
	  (nconc menu `((,(_ "Open _Terminal") (xterm)))))
        (unless (equal filemanager-program "")
          (nconc menu `((,(_ "_Open Home") (filemanager "~")))))
	(unless (equal browser-program "")
	  (nconc menu `((,(_ "Open _Browser") (browser)))))
	(nconc menu `((,(_ "_Run Application") (run-application))))
        (nconc menu `((,(_ "_Kill Window") (system "xkill &")))))))

  ;; generate apps-menu from *.desktop files
  (unless batch-mode
    (init-apps-menu))

  ;; initialize edges, unless disabled
  (when (and (not batch-mode)
	   edge-actions-enabled)
      (activate-edges t))

  ;; apply customized frame-fonts
  (when use-custom-font
    (update-frame-font))

  ;; apply customized font-colors
  (when use-custom-font-color
    (update-frame-font-color))

  ;; apply customized cursor-shapes
  (when use-custom-button-cursor-shape
    (update-button-cursor-shape))

  ;; apply customized border-width/color
  (when use-custom-border
    (update-border-color-width))

  ;; apply customized text-position
  (when use-custom-text-position
    (update-text-position))

  (when want-poweroff-menu
    (add-poweroff-menu))

  ;; use a default theme if none given
  (unless (or batch-mode default-frame-style)
    (setq default-frame-style fallback-frame-style))

  (unless (and (boundp 'window-menu) window-menu)
    (require 'sawfish.wm.ext.beos-window-menu))

  ;; Use all arguments which are left.
  (let ((do-load (lambda (name)
		   (cond ((file-exists-p name)
			  (load name nil t t))
			 ((string-match "\\.jlc?$" name)
			  (load name))
			 (t (require (intern name))))))
	arg)
    (while (setq arg (car command-line-args))
      (setq command-line-args (cdr command-line-args))
      (cond
       ((member arg '("-f" "--call"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	((symbol-value (read-from-string arg))))
       ((member arg '("-l" "--load"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	(do-load arg))
       ((member arg '("-q" "--quit"))
	(throw 'quit 0))
       (t (do-load arg)))))

  (unless batch-mode
    (add-hook 'before-restart-hook
      (lambda () (let ((sc (get-window-by-class
			     "Sawfish-Configurator" #:regex t)))
		   (when sc
		     (delete-window-safely sc)
		     (system "touch ~/.restart_sc &")))))

    (add-hook 'before-exit-hook
      (lambda () (let ((sc (get-window-by-class
			     "Sawfish-Configurator" #:regex t)))
		   (when sc
		     (delete-window-safely sc)))))

    (when (file-exists-p "~/.restart_sc")
      (system "sawfish-config &")
      (delete-file "~/.restart_sc")))

  ;; auto-start handling
  (unless batch-mode
    (when init-xgamma
      (add-hook 'after-initialization-hook (lambda () (xgamma-set-from-cfg t t t)) t))
    (when init-wallpaper
      (add-hook 'after-initialization-hook set-wallpaper t))
    (when init-trayer
      (add-hook 'after-initialization-hook start-trayer t))
    (when init-xmobar
      (add-hook 'after-initialization-hook start-xmobar t))
    (when init-xmodmap
      (add-hook 'after-initialization-hook load-xmodmap t)
      (add-hook 'before-restart-hook restore-keymap t))
    (when init-xsettingsd
      (add-hook 'after-initialization-hook start-xsettingsd t))
    (when init-conky
      (add-hook 'after-initialization-hook start-conky t)))

  (when (eq error-destination 'init)
    (setq error-destination 'standard-error)))

;; prevent this file being loaded as a module
nil

(define-structure sawfish.wm.tile.col
    (export col-tiling
            increase-max-cols
            decrease-max-cols)
    (open rep
          rep.system
          sawfish.wm
          sawfish.wm.tile.tiler
          sawfish.wm.tile.utils)

  (define (col-tiling ws #!key
                      (top 0) (bottom 0) (cols 3) (gap 1) (auto t) (resize t))
    (register-workspace-tiler ws
                              col-tiler
                              (list cols top bottom gap resize)
			      auto
			      'col-tiler))

  (define (cols) (setting 0))
  (define (top-m) (setting 1))
  (define (bottom-m) (setting 2))
  (define (gap) (setting 3))
  (define (resize) (setting 4))

  (define (col-tiler focused deleted)
    (let ((windows (tileable-windows deleted)))
      (when (> (length windows) 0)
        (let* ((master (or focused (input-focus) (car windows)))
               (windows (cons master (delete master windows)))
               (groups (group-by windows (cols))))
          (mapc make-column groups)))))

  (define (make-column windows)
    (let* ((min-y (top-m))
           (max-y (max (scr-height (window-height (last windows)) (bottom-m))
                       min-y))
           (max-h (scr-height (top-m) (bottom-m)))
           (dy (floor (/ (- max-y min-y) (max (1- (cols)) 1))))
           (dx (floor (/ (scr-width (* (1+ (cols)) (gap))) (cols)))))
      (push-column windows (gap) min-y dx dy (gap) max-h)))

  (define (push-column ws x y dx dy g max-h)
    (when (not (null ws))
      (let* ((w (car ws))
             (wdx (if (resize) dx (window-width w)))
             (wdy (if (resize)
                      (min (window-height (car ws)) max-h)
                    (window-height w)))
             (sh (screen-width))
             (wx (if (> (+ x wdx) sh) (- sh wdx g) x)))
        (push-window (car ws) wx y wdx wdy)
        (push-column (cdr ws) (+ x dx g) (+ y dy) dx dy g max-h))))

  (define (ws-col-max ws delta)
    (let ((old (setting 0 #f ws)))
      (when old
        (let ((no (+ old delta)))
          (when (> no 1)
            (set-setting 0 no ws)
            no)))))

  (define (change-cols delta)
    (let ((n (ws-col-max current-workspace delta)))
      (when n
        (col-tiler nil nil)
        (notify "Maximum columns set to %s" n))))

  (define (increase-max-cols)
    (interactive)
    (change-cols 1))

  (define (decrease-max-cols)
    (interactive)
    (change-cols -1)))

;; edges.jl -- Identify all window edges

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.edges

    (export get-visible-window-edges
	    grid-from-edges
	    edges-within-epsilon
	    snap-window-position-to-edges)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.viewport)

  (define-structure-alias edges sawfish.wm.util.edges)

  (define (get-visible-window-edges #!key with-ignored-windows
				    windows-to-ignore (windows t)
				    include-screen include-heads
                                    viewport)
    "Returns (X-EDGES . Y-EDGES), X-EDGES is a list of (X Y1 Y2 OPEN-P),
and Y-EDGES is a list of (Y X1 X2 OPEN-P). OPEN-P is t if the edge is
the left or top edge of a window. For the root window, the meaning of
OPEN-P is reversed.

#:include-heads may be a list of head ids, or a true non-list, in which
case all heads are included.

#:viewport may be a cons cell specifying (col . row); if specified
edges are given for that viewport rather than the current one.

The returned lists may contain duplicates, and are unsorted."

    (let* ((width (screen-width))
           (height (screen-height))
           (vp-offset (viewport-offset-coord viewport))
           (cur-vp (and viewport (screen-viewport)))
           (x-offset (and viewport (* (screen-width)
                                      (- (car viewport)
                                         (car cur-vp)))))
           (y-offset (and viewport (* (screen-height)
                                      (- (cdr viewport)
                                         (cdr cur-vp)))))
           x-edges y-edges)
      (map-windows
       (lambda (w)
	 (when (and (window-mapped-p w)
		    (window-visible-p w)
                    (or (window-get w 'sticky-viewport)
                        (not (window-outside-viewport-p w viewport)))
		    (or with-ignored-windows
			(not (window-get w 'ignored)))
		    (not (memq w windows-to-ignore))
		    (or (not (listp windows)) (memq w windows)))
           (let ((dims (window-frame-dimensions w))
                 (coords (if (and viewport
                                  (window-get w 'sticky-viewport)
                                  (not (and (equal (car viewport)
                                                   (car cur-vp))
                                            (equal (cdr viewport)
                                                   (cdr cur-vp)))))
                             ;; Simulate the presence of w in
                             ;; the specified viewport:
                             (let ((pos (window-position w)))
                               (cons (+ (car pos) x-offset)
                                     (+ (cdr pos) y-offset)))
                           (window-position w))))
             (setq x-edges (cons (list (car coords) (cdr coords)
                                       (+ (cdr coords) (cdr dims)) t)
                                 (cons (list (+ (car coords) (car dims))
                                             (cdr coords)
                                             (+ (cdr coords) (cdr dims))
                                             nil)
                                       x-edges)))
             (setq y-edges (cons (list (cdr coords) (car coords)
                                       (+ (car coords) (car dims)) t)
                                 (cons (list (+ (cdr coords) (cdr dims))
                                             (car coords)
                                             (+ (car coords) (car dims))
                                             nil)
                                       y-edges)))))))

      (when include-screen
        (let* ((x-min (car vp-offset))
               (y-min (cdr vp-offset))
               (x-max (+ x-min width))
               (y-max (+ y-min height)))
          (setq x-edges (list* (list x-min y-min y-max nil)
                               (list x-max y-min y-max t)
                               x-edges))
          (setq y-edges (list* (list y-min x-min x-max nil)
                               (list y-max x-min x-max t)
                               y-edges))))

      (when (and include-heads (not (listp include-heads)))
	(setq include-heads (do ((i 0 (1+ i))
				 (lst '() (cons i lst)))
				((= i (head-count)) lst))))
      (when include-heads
	(mapc (lambda (h)
		(let* ((dims (head-dimensions h))
                       (offset (head-offset h))
                       (x-min (+ (car offset) (car vp-offset)))
                       (y-min (+ (cdr offset) (cdr vp-offset)))
                       (x-max (+ x-min (car dims)))
                       (y-max (+ y-min (cdr dims))))
		  (setq x-edges (list* (list x-min y-min y-max nil)
				       (list x-max y-min y-max t)
				       x-edges))
		  (setq y-edges (list* (list y-min x-min x-max nil)
				       (list y-max x-min x-max t)
				       y-edges))))
	      include-heads))

      (cons x-edges y-edges)))

  (define (grid-from-edges x-edges y-edges)
    "Given lists of edges X-EDGES and Y-EDGES, return a cons cell
`(X-POINTS . Y-POINTS)' describing the grid they represent."
    (cons (uniquify-list (mapcar car x-edges))
	  (uniquify-list (mapcar car y-edges))))

  ;; returns (EDGE-1 EDGE-2) where they're within EPSILON of each other. MODE
  ;; is one of the symbols `magnetism', `resistance', or `attraction'. DELTA
  ;; is the (signed) number of pixels moved since the last call
  (define (edges-within-epsilon list-1 list-2 epsilon delta
				old-edge #!optional mode)
    (let ((compare
	   (cond ((or (null mode) (eq mode 'magnetism))
		  (lambda (e1 e2)
		    (and (< (nth 1 e1) (nth 2 e2))
			 (> (nth 2 e1) (nth 1 e2))
			 (<= (- (max (car e1) (car e2))
				(min (car e1) (car e2)))
			     epsilon))))

		 ((eq mode 'attraction)
		  (lambda (e1 e2)
		    (and (< (nth 1 e1) (nth 2 e2))
			 (> (nth 2 e1) (nth 1 e2))
			 (or
			  (and (nth 3 e1) (not (nth 3 e2)) (<= delta 0)
			       (<= (- epsilon) (- (car e2) (car e1)) 0)
			       (or (< delta 0) (equal old-edge e2)))
			  (and (not (nth 3 e1)) (nth 3 e2) (>= delta 0)
			       (<= 0 (- (car e2) (car e1)) epsilon)
			       (or (> delta 0) (equal old-edge e2)))))))

		 ((eq mode 'resistance)
		  (lambda (e1 e2)
		    (and (< (nth 1 e1) (nth 2 e2))
			 (> (nth 2 e1) (nth 1 e2))
			 (or
			  (and (nth 3 e1) (not (nth 3 e2))
			       (<= (car e1) (car e2) (- (car e1) delta)))
			  (and (nth 3 e1) (not (nth 3 e2))
			       (equal old-edge e2)
			       (<= (- epsilon) (- (car e1) (car e2)) 0))
			  (and (not (nth 3 e1)) (nth 3 e2)
			       (>= (car e1) (car e2) (- (car e1) delta)))
			  (and (not (nth 3 e1)) (nth 3 e2)
			       (equal old-edge e2)
			       (<= 0 (- (car e1) (car e2)) epsilon)))))))))
      (catch 'out
	(mapc (lambda (edge-1)
		(mapc (lambda (edge-2)
			(when (compare edge-1 edge-2)
			  (throw 'out (cons edge-1 edge-2))))
		      list-2))
	      list-1)
	nil)))

  ;; returns the new (X . Y) of WINDOW. STATE is a cons cell that will be
  ;; used to record state across successive calls
  (define (snap-window-position-to-edges window coords deltas state
					 #!optional epsilon edges mode)
    (let* ((dims (window-frame-dimensions window))
	   (w-x-edges (list (list (car coords) (cdr coords)
				  (+ (cdr coords) (cdr dims)) t)
			    (list (+ (car coords) (car dims))
				  (cdr coords)
				  (+ (cdr coords) (cdr dims)) nil)))
	   (w-y-edges (list (list (cdr coords) (car coords)
				  (+ (car coords) (car dims)) t)
			    (list (+ (cdr coords) (cdr dims))
				  (car coords)
				  (+ (car coords) (car dims)) nil)))
	   tem)
      (setq coords (cons (car coords) (cdr coords)))
      (unless edges
	(setq edges (get-visible-window-edges)))
      (unless epsilon
	(setq epsilon 8))
      (unless mode
	(setq mode 'magnetism))

      ;; snap in X direction
      (if (setq tem (edges-within-epsilon
		     w-x-edges (car edges) epsilon
		     (car deltas) (car state) mode))
	  (progn
	    (rplaca state (cdr tem))
	    (setq tem (+ (car coords) (- (car (cdr tem)) (car (car tem)))))
	    (when (and (> tem (- (car dims))) (< tem (screen-width)))
	      (rplaca coords tem)))
	(rplaca state nil))

      ;; snap in Y direction
      (if (setq tem (edges-within-epsilon
		     w-y-edges (cdr edges) epsilon
		     (cdr deltas) (cdr state) mode))
	  (progn
	    (rplacd state (cdr tem))
	    (setq tem (+ (cdr coords) (- (car (cdr tem)) (car (car tem)))))
	    (when (and (> tem (- (cdr dims))) (< tem (screen-height)))
	      (rplacd coords tem)))
	(rplacd state nil))
      coords)))

;; describe.jl --

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.describe

    (export describe-symbol
	    apropos-function
	    apropos-variable)

    (open rep
	  rep.lang.doc
	  sawfish.wm.commands)

  (define-structure-alias describe sawfish.wm.commands.describe)

  (define (describe-symbol fun)
    "Print the documentation of a specified symbol to the standard output ."
    (describe-value (symbol-value fun t) fun)
    (format standard-output "\n%s\n"
	    (or (documentation fun nil (symbol-value fun t)) "Undocumented.")))

  ;;###autoload
  (define-command 'describe-symbol describe-symbol
    #:spec "SSymbol:")
  (define-command-to-screen 'describe-symbol-to-screen describe-symbol
    #:spec "SSymbol:"
    #:doc "Enter a name of var/func, and prints its doc.")

  (define (apropos-output symbols)
    (let ((separator (make-string 72 ?-)))
      (mapc (lambda (sym)
	      (write standard-output separator)
	      (write standard-output #\newline)
	      (describe-symbol sym)) symbols)))

  (define (apropos-function regexp #!optional all-functions)
    (format standard-output "Apropos %s `%s':\n\n"
	    (if all-functions "function" "command") regexp)
    (apropos-output (apropos regexp (if all-functions
					(lambda (s)
					  (and (boundp s)
					       (functionp (symbol-value s))))
				      commandp))))

  ;;###autoload
  (define-command 'apropos-function apropos-function
    #:spec "sApropos functions:\nP")
  (define-command-to-screen 'apropos-function-to-screen apropos-function
    #:spec "sApropos functions:\nP")

  (define (apropos-variable regexp)
    (format standard-output "Apropos variable `%s':\n" regexp)
    (apropos-output (apropos regexp boundp)))

  ;;###autoload
  (define-command 'apropos-variable apropos-variable
    #:spec "sApropos variables:")
  (define-command-to-screen 'apropos-variable-to-screen apropos-variable
    #:spec "sApropos variables:"))

;; mate.jl -- MATE integration

;; Copyright (C) 2011 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.mate

    (export detect-mate)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias mate-int sawfish.wm.integration.mate)

  (define (init)
    (let (menu)
      (setq desktop-environment "mate")
      (setq want-poweroff-menu nil)

      ;; invoke the MATE terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "mate-terminal"))

      ;; use the MATE help browser and url launcher
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "mate-www-browser"))

      ;; use the MATE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "caja"))

      ;; add some MATE menu-entries
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_MATE Help") (system "yelp &"))
		      (,(_ "MATE _Website") (browser "http://www.matsusoft.com.ar/projects/mate/"))
		      (,(_ "_About MATE") (system "mate-about &")))))

      ;; add mate-logout and customize menu-entries
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_Customize MATE") (system "mate-control-center &"))
		      (,(_ "_Edit MATE menu") (system "menulibre &"))
		      ()
		      (,(_ "L_ock screen from MATE")
			(system "mate-screensaver-command -l &"))
		      (,(_ "_Logout from MATE")
		       (system "mate-session-save --logout-dialog &"))
		      (,(_ "_Shutdown from MATE")
		       (system "mate-session-save --shutdown-dialog &")))))))

  ;; Returns nil if mate is not found.
  ;; If detected, returns t, and do also mate support init.
  (define (detect-mate)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "MATE")
              (equal (getenv "DESKTOP_SESSION") "sawfish-mate")
              (getenv "MATE_DESKTOP_SESSION_ID"))
      (init)
      t)))

;; user.jl -- do user-local initialization
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; The idea is that the `user' module is where all user code gets to
;; play. By default it has a set of modules opened so that it looks
;; pretty much how the old non-modular wm looked.

;; This means that the `sawfish.wm' structures aren't modified by user
;; code, this is a good thing, since it means that modules importing
;; `sawfish.wm.foo' know what they are getting (no random user
;; bindings)

;; The downside is that it's harder for user extensions to redefine
;; existing code, IMHO this may also be a good thing..

(define-structure user

    (export )

    ((open rep
	   rep.regexp
	   rep.system
	   rep.io.files
	   rep.io.processes
	   sawfish.wm
	   sawfish.wm.util.groups
	   sawfish.wm.util.display-window
	   sawfish.wm.util.compat
	   sawfish.wm.ext.error-handler
	   sawfish.wm.ext.apps-menu
	   sawfish.wm.edge.conf
	   sawfish.wm.edge.actions
	   sawfish.wm.frames
	   sawfish.wm.menus
	   sawfish.wm.commands.launcher
	   sawfish.wm.ext.wallpaper
	   sawfish.wm.prg.compton
	   sawfish.wm.prg.conky
	   sawfish.wm.prg.trayer
	   sawfish.wm.prg.xgamma
	   sawfish.wm.prg.xmobar
	   sawfish.wm.prg.xmodmap
	   sawfish.wm.prg.xsettingsd)
     (access sawfish.wm.integration.kde
	     sawfish.wm.integration.gnome
	     sawfish.wm.integration.xfce
	     sawfish.wm.integration.mate
	     sawfish.wm.integration.razor
	     sawfish.wm.integration.lxde
	     sawfish.wm.integration.lumina)

     (set-binds))

  ;; "none" looks ugly, but if you are to change it to "", fix
  ;; apps-menu, too, or it will break.
  (defvar desktop-environment "none"
    "Running desktop environment, detected by Sawfish.
Possible values are \"kde\", \"gnome\", \"mate\", \"xfce\", \"razor\", \"lxde\", \"lumina\" or \"none\".")

  (defvar want-poweroff-menu t
    "Add poweroff menu if you don't use GNOME / KDE / XFCE / Razor-Qt / LXDE / Lumina.")

  (defvar want-extra-menu-entries t
    "Provide additional entries in root menu.")

  (setq *user-structure* 'user)

  ;; frame-style loaded if user hasn't set their own
  (define fallback-frame-style 'StyleTab)

  ;; give root-window 'WINDOW_MANAGER property with value sawfish
  (unless batch-mode
    (set-x-text-property 'root 'WINDOW_MANAGER (vector "sawfish")))

  (define rc-files '("~/.sawfishrc" "~/.sawfish/rc"))

  ;; initialize the special variable pointing at this structure
  (structure () (open rep rep.structures)
    (setq *user-module* (get-structure 'user)))

  (define (safe-load . args)
    (condition-case data
	(apply load args)
      (error
       (error-handler-function (car data) (cdr data)))))

  (define (rename-old-stuff)
    (when (and (file-directory-p "~/.sawmill")
	       (not (file-exists-p "~/.sawfish")))
      (rename-file "~/.sawmill" "~/.sawfish")
      (message "Renamed directory ~/.sawmill -> ~/.sawfish")
      (make-symlink "~/.sawmill" ".sawfish")
      (message "Created .sawmill symlink (delete if unwanted)"))

    (when (and (file-exists-p "~/.sawmillrc")
	       (not (file-exists-p "~/.sawfishrc")))
      (rename-file "~/.sawmillrc" "~/.sawfishrc")
      (message "Renamed file ~/.sawmillrc -> ~/.sawfishrc"))
    )

  ;; Detect desktop environment.
  ;; These functions have to non-nil if it detects a DE, otherwise nil.
  ;; It should also initialize, and set `desktop-environment',
  ;; and probably `want-poweroff-menu', too.
  (define (detect-desktop-environment)
    (or (sawfish.wm.integration.gnome#detect-gnome)
	(sawfish.wm.integration.mate#detect-mate)
	(sawfish.wm.integration.kde#detect-kde)
	(sawfish.wm.integration.xfce#detect-xfce)
	(sawfish.wm.integration.razor#detect-razor)
	(sawfish.wm.integration.lxde#detect-lxde)
	(sawfish.wm.integration.lumina#detect-lumina))
    )

  ;; Don't signal an error even if user "require" them. These modules
  ;; existed in the past.
  (provide 'sawfish-defaults)
  (provide 'sawfish.wm.defaults)

;;; From here, executed at startup.

  ;; load ~/.sawfish/rc
  (setq error-destination 'init)
  (unless (get-command-line-option "--no-rc")
    (condition-case error-data
	(progn
	  ;; First the site-wide stuff
	  (load-all "site-init" (lambda (f) (safe-load f nil t)))

	  ;; then the users rep configuration, or site-wide defaults
	  (or (safe-load (concat (user-home-directory) ".reprc") t t t)
	      (safe-load "rep-defaults" t))

	  (unless batch-mode
	    (rename-old-stuff)
	    ;; detect DE before loading rc
            (detect-desktop-environment)

	    ;; then the customized options
	    (condition-case data
		(custom-load-user-file)
	      (error
	       (format (stderr-file) "error in custom file--> %S\n" data)))

	    ;; then the sawfish specific user configuration
	    (let loop ((rest rc-files))
	      (when rest
		(if (file-exists-p (car rest))
		    ;; Print stack trace on error during exeuction
		    ;; of ~/.sawfish/rc
		    (let ((%in-condition-case nil))
		      (safe-load (car rest) t t t))
		  (loop (cdr rest)))))))
      (error
       (format (stderr-file) "error in local config--> %S\n" error-data))))

  (when (equal desktop-environment "kde")
    (sawfish.wm.integration.kde#kde-late-init))

  (when (equal desktop-environment "lumina")
    (sawfish.wm.integration.lumina#lumina-window-matchers))

  (unless batch-mode
    (when want-extra-menu-entries
      (let ((menu root-menu))
        (user-require 'sawfish.wm.ext.run-application)
        (nconc menu `(()))
	(unless (equal xterm-program "")
	  (nconc menu `((,(_ "Open _Terminal") (xterm)))))
        (unless (equal filemanager-program "")
          (nconc menu `((,(_ "_Open Home") (filemanager "~")))))
	(unless (equal browser-program "")
	  (nconc menu `((,(_ "Open _Browser") (browser)))))
	(nconc menu `((,(_ "_Run Application") (run-application))))
        (nconc menu `((,(_ "_Kill Window") (system "xkill &")))))))

  ;; generate apps-menu from *.desktop files
  (unless batch-mode
    (init-apps-menu))

  ;; initialize edges, unless disabled
  (when (and (not batch-mode)
	   edge-actions-enabled)
      (activate-edges t))

  ;; apply customized frame-fonts
  (when use-custom-font
    (update-frame-font))

  ;; apply customized font-colors
  (when use-custom-font-color
    (update-frame-font-color))

  ;; apply customized cursor-shapes
  (when use-custom-button-cursor-shape
    (update-button-cursor-shape))

  ;; apply customized border-width/color
  (when use-custom-border
    (update-border-color-width))

  ;; apply customized text-position
  (when use-custom-text-position
    (update-text-position))

  (when want-poweroff-menu
    (add-poweroff-menu))

  ;; use a default theme if none given
  (unless (or batch-mode default-frame-style)
    (setq default-frame-style fallback-frame-style))

  (unless (and (boundp 'window-menu) window-menu)
    (require 'sawfish.wm.ext.beos-window-menu))

  ;; Use all arguments which are left.
  (let ((do-load (lambda (name)
		   (cond ((file-exists-p name)
			  (load name nil t t))
			 ((string-match "\\.jlc?$" name)
			  (load name))
			 (t (require (intern name))))))
	arg)
    (while (setq arg (car command-line-args))
      (setq command-line-args (cdr command-line-args))
      (cond
       ((member arg '("-f" "--call"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	((symbol-value (read-from-string arg))))
       ((member arg '("-l" "--load"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	(do-load arg))
       ((member arg '("-q" "--quit"))
	(throw 'quit 0))
       (t (do-load arg)))))

  (unless batch-mode
    (add-hook 'before-restart-hook
      (lambda () (let ((sc (get-window-by-class
			     "Sawfish-Configurator" #:regex t)))
		   (when sc
		     (delete-window-safely sc)
		     (system "touch ~/.restart_sc &")))))

    (add-hook 'before-exit-hook
      (lambda () (let ((sc (get-window-by-class
			     "Sawfish-Configurator" #:regex t)))
		   (when sc
		     (delete-window-safely sc)))))

    (when (file-exists-p "~/.restart_sc")
      (system "sawfish-config &")
      (delete-file "~/.restart_sc")))

  ;; auto-start handling
  (unless batch-mode
    (when init-xgamma
      (add-hook 'after-initialization-hook (lambda () (xgamma-set-from-cfg t t t)) t))
    (when init-wallpaper
      (add-hook 'after-initialization-hook set-wallpaper t))
    (when init-trayer
      (add-hook 'after-initialization-hook start-trayer t))
    (when init-xmobar
      (add-hook 'after-initialization-hook start-xmobar t))
    (when init-xmodmap
      (add-hook 'after-initialization-hook load-xmodmap t)
      (add-hook 'before-restart-hook restore-keymap t))
    (when init-xsettingsd
      (add-hook 'after-initialization-hook start-xsettingsd t))
    (when init-conky
      (add-hook 'after-initialization-hook start-conky t)))

  (when (eq error-destination 'init)
    (setq error-destination 'standard-error)))

;; prevent this file being loaded as a module
nil

;; smart-placement.jl -- ``intelligent'' window placement

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This implements two different algorithms: first-fit and best-fit.

;; Both use the same inner core -- they scan for the position to place
;; the window where it overlaps the smallest area with other windows

;; The two algorithms differ where more than one position has this
;; smallest overlap area. The first-fit algorithm takes the first such
;; position found, while the best-fit algorithm tries to choose the
;; best such position.

;; The cost function used for the best-fit currently tries to combine
;; two factors: the future ``usefulness'' of the chosen space, and the
;; number (and size) of the window edges the window will abut when
;; placed in the position

(define-structure sawfish.wm.placement.smart

    (export sp-do-placement
	    sp-first-fit
	    sp-best-fit
	    sp-fit-or-nil
	    sp-cost:grid-lines
	    sp-cost:aligned-edges
	    sp-cost:pointer-locality
	    sp-cost:focus-locality
	    sp-cost:center-locality
	    sp-cost:overlap)

    (open rep
	  sawfish.wm.util.rects
	  sawfish.wm.util.groups
	  sawfish.wm.util.workarea
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.placement
	  sawfish.wm.custom
	  sawfish.wm.workspace)

;;; options/variables

  (defvar sp-avoided-windows-weight 100)
  (defvar sp-normal-windows-weight 1)

  (defvar sp-padding 0
    "Try to leave at least this many pixels between window edges in
first/best-fit.")

  ;; the maximum number of points to keep in each grid dimension
  (defvar sp-max-points 10)

  ;; only when there's fewer X events than this pending do we try
  ;; to do smart placement
  (defvar sp-max-queued-events 256)

;;; utility functions

  ;; RECTS is a list of (LEFT TOP RIGHT BOTTOM); returns sorted, uniquified
  ;; (X-EDGES . Y-EDGES)
  (define (sp-make-grid rects #!optional with-root)
    (let ((grid (grid-from-rectangles rects)))
      ;; XXX fix for multiple heads
      (when with-root
	(unless (memql 0 (car grid))
	  (rplaca grid (cons 0 (car grid))))
	(unless (memql (screen-width) (car grid))
	  (rplaca grid (cons (screen-width) (car grid))))
	(unless (memql 0 (cdr grid))
	  (rplacd grid (cons 0 (cdr grid))))
	(unless (memql (screen-height) (cdr grid))
	  (rplacd grid (cons (screen-height) (cdr grid)))))
      (rplaca grid (sort (sp-prune-points (car grid) sp-max-points
					  (cons 0 (screen-width)))))
      (rplacd grid (sort (sp-prune-points (cdr grid) sp-max-points
					  (cons 0 (screen-height)))))
      grid))

  (define (sp-prune-points points maximum range)
    (setq points (delete-if-not (lambda (p)
				  (and (>= p (car range)) (<= p (cdr range))))
				points))
    (let ((total (length points)))
      (cond ((> total maximum)
	     ;; remove points
	     (let ((cutoff (* (max 0 (- total maximum)) 100)))
	       (setq total (* total 100))
	       (delete-if (lambda (unused)
			    (declare (unused unused))
			    (< (random total) cutoff)) points)))
	    ((< total maximum)
	     ;; add points
	     (while (< total maximum)
	       (setq points (cons (+ (car range)
				     (random (- (cdr range) (car range))))
				  points))
	       (setq total (1+ total)))))
      points))

  ;; returns the list of windows to compare with when overlapping, by
  ;; default windows with their `ignored' property set are dropped
  (define (sp-get-windows w #!optional pred)
    (filter-windows
     (lambda (x)
       (not (or (eq x w)
		(not (window-mapped-p x))
		(and (or (and pred (not (pred x))) (window-get x 'ignored))
		     (not (window-avoided-p x)))
		(window-get x 'iconified)
		(not (windows-share-workspace-p x w)))))))

;;; calculating overlaps

  ;; returns (POINT . OVERLAP), find the alignment of the rectangle
  ;; of dimensions DIMS at POINT with the least overlap compared to
  ;; RECTS
  (define (sp-least-overlap dims point rects)
    (let (min-overlap min-point)
      (mapc (lambda (delta)
	      (let ((point-foo (cons (+ (car point)
					(* (car delta) (car dims)))
				     (+ (cdr point)
					(* (cdr delta) (cdr dims)))))
		    tem)
		(when (and (>= (car point-foo) 0)
			   (>= (cdr point-foo) 0)
			   (<= (+ (car point-foo) (car dims)) (screen-width))
			   (<= (+ (cdr point-foo) (cdr dims)) (screen-height))
			   (= (rectangle-heads
			       (rectangle-from-coords point-foo dims)) 1))
		  (setq tem (rect-total-overlap dims point-foo rects))
		  (when (or (not min-point) (< tem min-overlap))
		    (setq min-overlap tem)
		    (setq min-point point-foo)))))
	    ;; try aligning all four corners to this point
	    '((0 . 0) (0 . -1) (-1 . 0) (-1 . -1)))
      (and min-point (cons min-point min-overlap))))

;;; first-fit search

  (define (sp-first-fit dims grid rects)
    (let ((point (cons 0 0))
	  min-point min-overlap tem)
      (catch 'done
	(mapc (lambda (y)
		(rplacd point y)
		(mapc (lambda (x)
			(rplaca point x)
			(setq tem (sp-least-overlap dims point rects))
			(when tem
			  (when (zerop (cdr tem))
			    (throw 'done (car tem)))
			  (when (or (not min-overlap)
				    (< (cdr tem) min-overlap))
			    (setq min-overlap (cdr tem))
			    (setq min-point (car tem)))))
		      (car grid)))
	      (cdr grid))
	;; no zero overlap point, use the point with least overlap
	min-point)))

  (define (sp-fit-or-nil dims grid rects)
    (let ((point (cons 0 0))
	  tem)
      (catch 'done
	(mapc (lambda (y)
		(rplacd point y)
		(mapc (lambda (x)
			(rplaca point x)
			(setq tem (sp-least-overlap dims point rects))
			(when (and tem (zerop (cdr tem)))
			  (throw 'done (car tem))))
		      (car grid)))
	      (cdr grid))
	nil)))

;;; best-fit search

  (defmacro sp-edges-adjacent (align-1 start-1 end-1 align-2 start-2 end-2)
    `(if (= ,align-1 ,align-2)
	 (rect-1d-overlap ,start-1 ,end-1 ,start-2 ,end-2)
       0))

  (define (sp-cost:grid-lines point dims grid rects)
    "Smart placement cost function. Cost is proportional to the number of grid
lines that the proposed placement crosses."
    (declare (unused rects))
    (let ((win-left (car point))
	  (win-top (cdr point))
	  (win-right (+ (car point) (car dims)))
	  (win-bottom (+ (cdr point) (cdr dims)))
	  (x-cross 0)
	  (y-cross 0)
	  (x-total 0)
	  (y-total 0))
      ;; count the number of grid lines this position crosses
      ;; the idea is to maximize this, since it's likely that it
      ;; will use up the annoying small parts of the screen
      (mapc (lambda (x)
	      (when (and (>= x win-left) (<= x win-right))
		(setq x-cross (1+ x-cross)))
	      (setq x-total (1+ x-total)))
	    (car grid))
      (mapc (lambda (y)
	      (when (and (>= y win-top) (<= y win-bottom))
		(setq y-cross (1+ y-cross)))
	      (setq y-total (1+ y-total)))
	    (cdr grid))
      (/ (* x-cross y-cross) (* x-total y-total))))

  (define (sp-cost:aligned-edges point dims grid rects)
    "Smart placement cost function. Cost is proportional to the length of the
edges that the proposed placement abuts."
    (declare (unused grid))
    (let ((win-left (car point))
	  (win-top (cdr point))
	  (win-right (+ (car point) (car dims)))
	  (win-bottom (+ (cdr point) (cdr dims)))
	  (edges (make-vector 4 0)))
      ;; how many window edges does this position abut?
      ;; it can save space to cluster windows as much as possible
      (mapc (lambda (r)
	      (aset edges 0 (max (sp-edges-adjacent
				  win-right win-top win-bottom
				  (car r) (nth 1 r) (nth 3 r))
				 (aref edges 0)))
	      (aset edges 1 (max (sp-edges-adjacent
				  win-left win-top win-bottom
				  (nth 2 r) (nth 1 r) (nth 3 r))
				 (aref edges 1)))
	      (aset edges 2 (max (sp-edges-adjacent
				  win-bottom win-left win-right
				  (nth 1 r) (car r) (nth 2 r))
				 (aref edges 2)))
	      (aset edges 3 (max (sp-edges-adjacent
				  win-top win-left win-right
				  (nth 3 r) (car r) (nth 2 r))
				 (aref edges 3))))
	    rects)
      (/ (+ (aref edges 0) (aref edges 1)
	    (aref edges 2) (aref edges 3))
	 (+ (* 2 (car dims)) (* 2 (cdr dims))))))

  ;; calculate the cost associated with the distance between POINT-1 and
  ;; POINT-2. As they get nearer the cost tends to zero, as they get
  ;; further apart the cost tends to one (hopefully)
  (define (sp-cost-from-distance point-1 point-2)
    (/ (sqrt (+ (expt (- (screen-width)
			 (abs (- (car point-2) (car point-1)))) 2)
		(expt (- (screen-height)
			 (abs (- (cdr point-2) (cdr point-1)))) 2)))
       (sqrt (+ (expt (screen-width) 2) (expt (screen-height) 2)))))

  (define (sp-cost:pointer-locality point dims grid rects)
    "Smart placement cost function. Cost is proportional to the distance
from the proposed placement to the current pointer position."
    (declare (unused grid rects))
    (sp-cost-from-distance (rectangle-center* point dims) (query-pointer)))

  (define (sp-cost:focus-locality point dims grid rects)
    "Smart placement cost function. Cost is proportional to the distance from
the proposed placement to the position of the currently focused window."
    (declare (unused grid rects))
    (let ((focus (input-focus)))
      (if focus
	  (sp-cost-from-distance (rectangle-center* point dims)
				 (rectangle-center* (window-position focus)
						    (window-dimensions focus)))
	1)))

  (define (sp-cost:center-locality point dims grid rects)
    "Smart placement cost function. Cost is proportional to the distance from
the proposed placement to the center of the screen."
    (declare (unused grid rects))
    (sp-cost-from-distance (rectangle-center* point dims)
			   (cons (/ (screen-width) 2) (/ (screen-height) 2))))

  (define (sp-cost:overlap point dims grid rects overlap)
    (declare (unused point dims grid rects))
    (exp (- (/ overlap (* (screen-width) (screen-height))))))

  (defvar sp-cost-components (list (cons sp-cost:overlap 7/8)
				   (cons sp-cost:center-locality 1/8))
    "Alist defining smart placement cost functions and their
associated weights (multipliers).")

  ;; This is the crux of the problem -- this function must assign a value
  ;; to placing a window of DIMS at POINT. GRID defines the grid from which
  ;; POINT was chosen, RECTS defines all other windows on the screen.
  ;; The returned value must be non-negative, with higher values reflecting
  ;; better placements
  (define (sp-cost point dims grid rects overlap)
    (let ((total 0))
      (mapc (lambda (cell)
	      (setq total
		    (+ total (* ((car cell) point dims grid rects overlap)
				(cdr cell)))))
	    sp-cost-components)
      total))

  (define (sp-best-fit dims grid rects)
    (let ((point (cons 0 0))
	  points tem)

      ;; 1. find the list of possible placements (POINT . OVERLAP)
      (mapc (lambda (y)
	      (rplacd point y)
	      (mapc (lambda (x)
		      (rplaca point x)
		      (setq tem (sp-least-overlap dims point rects))
		      (when tem
			(setq points (cons tem points))))
		    (car grid)))
	    (cdr grid))

      ;; 2. choose the best of these points
      (cond ((null points)
	     ;; no choice
	     nil)
	    ((null (cdr points))
	     ;; one choice
	     (caar points))
	    (t
	     ;; n choices
	     (let ((max-cost 0)
		   (max-point nil))
	       (mapc (lambda (p)
		       (let ((cost (sp-cost (car p) dims grid rects (cdr p))))
			 (when (> cost max-cost)
			   (setq max-cost cost)
			   (setq max-point (car p)))))
		     points)
	       max-point)))))

;;; entry-points

  (define (sp-do-placement w fit-fun #!optional fall-back-fun
                           #!key window-filter)
    (if (and sp-max-queued-events (> (x-events-queued) sp-max-queued-events))
	;; fitted placement can cause event tailbacks when there's
	;; lots of windows being opened with lots of windows already
	;; open
	((placement-mode 'randomly) w)
      (let* ((windows (sp-get-windows w window-filter))
	     (rects (rectangles-from-windows
		     windows
		     (lambda (x)
		       (cond ((window-avoided-p x)
			      sp-avoided-windows-weight)
			     ((window-get x 'placement-weight))
			     (t sp-normal-windows-weight)))))
	     (grid (sp-make-grid rects t))
	     (dims (window-frame-dimensions w))
	     (workarea (calculate-workarea #:window w))
	     (workarea-width (- (nth 2 workarea) (nth 0 workarea)))
	     (workarea-height (- (nth 3 workarea) (nth 1 workarea)))
	     point)

	;; first try with padding
	(when (and (> sp-padding 0)
		   (<= (+ (car dims) (* sp-padding 2)) workarea-width)
		   (<= (+ (cdr dims) (* sp-padding 2)) workarea-height))
	  (let ((padded-dims (cons (+ (car dims) (* sp-padding 2))
				   (+ (cdr dims) (* sp-padding 2)))))
	    (setq point (fit-fun padded-dims grid rects)))
	  (when point
	    (rplaca point (+ (car point) sp-padding))
	    (rplacd point (+ (cdr point) sp-padding))))

	;; then try without padding
	(when (null point)
	  (let ((smallest-dims (cons (min (car dims) workarea-width)
				     (min (cdr dims) workarea-height))))
	    (setq point (fit-fun smallest-dims grid rects))))

	(if point
	    (move-window-to w (car point) (cdr point))
	  ((or fall-back-fun (placement-mode 'randomly)) w)))))

  (define (place-window-first-fit w)
    (sp-do-placement w sp-first-fit))

  (define (place-window-best-fit w)
    (sp-do-placement w sp-best-fit))

  (define (place-window-best-fit-group w)
    (let ((group (windows-in-group w)))
      (sp-do-placement w sp-best-fit nil
		       #:window-filter (lambda (x) (memq x group)))))

  (define (place-window-first-fit-or-interactive w)
    (sp-do-placement w sp-fit-or-nil (placement-mode 'interactively)))


;;; init

  ;;###autoload
  (define-placement-mode 'first-fit place-window-first-fit #:for-normal t)
  (define-placement-mode 'best-fit place-window-best-fit #:for-normal t)
  (define-placement-mode 'best-fit-group
    place-window-best-fit-group #:for-normal t)
  (define-placement-mode 'first-fit-or-interactive
    place-window-first-fit-or-interactive #:for-normal t))

;; menus.jl -- popup menus
;; $Id: menus.jl,v 1.75 2002/11/03 08:25:19 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.menus

    (export menu-start-process
	    menu-stop-process
	    popup-menu
	    popup-window-menu
	    popup-root-menu
	    popup-apps-menu
	    add-window-menu-toggle
	    custom-menu)

    (open rep
	  rep.regexp
	  rep.io.files
	  rep.io.processes
	  rep.data.tables
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.frames
	  sawfish.wm.commands
	  sawfish.wm.util.groups
	  sawfish.wm.workspace
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify)

  (define-structure-alias menus sawfish.wm.menus)

  ;; Suppress annoying compiler warnings
  (eval-when-compile (require 'rep.io.timers))

  (defvar menus-include-shortcuts nil
    "Display key-binding information in menu items.")

  (defvar menu-program (expand-file-name "sawfish-menu" sawfish-exec-directory)
    "Location of the program implementing sawfish's menu interface.")

  (defvar menu-program-stays-running t
    "When non-nil, the menu program is never stopped. If a number, then this
is taken as the number of seconds to let the process hang around unused
before killing it.")

  ;; the active user interface process
  (define menu-process nil)

  ;; output from the user-interface process that's received but not
  ;; yet processed
  (define menu-pending nil)

  ;; non-nil when we're waiting for a response from the ui process
  ;; if a window, then it's the window that received the event causing
  ;; the menu to be shown
  (define menu-active nil)

  ;; hash table mapping nicknames to result objects without read syntax
  (define nickname-table)
  (define nickname-index)

  ;; if menu-program-stays-running is a number, this may be a timer
  ;; waiting to kill the process
  (define menu-timer nil)

  (defvar window-ops-menu
    `((,(_ "Minimize") iconify-window
       (insensitive . ,(lambda (w)
			 (not (window-iconifiable-p w)))))
      (,(lambda (w)
	  (if (window-maximized-p w)
	      (_ "Unmaximize")
	    (_ "Maximize"))) maximize-window-toggle
       (insensitive . ,(lambda (w)
			 (not (or (window-maximized-p w)
				  (window-maximizable-p w))))))
      (,(_ "_Close") delete-window)
      ()
      (,(_ "_Toggle") . window-ops-toggle-menu)
      (,(_ "In _group") . window-group-menu)
      (,(_ "_Send window to")
       (,(_ "_Previous workspace") send-to-previous-workspace)
       (,(_ "_Next workspace") send-to-next-workspace)
       (,(_ "Copy to previous") copy-to-previous-workspace)
       (,(_ "Copy to next") copy-to-next-workspace))
      (,(_ "Stacking")
       (,(_ "Raise") raise-window)
       (,(_ "Lower") lower-window)
       (,(_ "Upper layer") raise-window-depth)
       (,(_ "Lower layer") lower-window-depth))
      (,(_ "Frame type") . frame-type-menu)
      (,(_ "Frame style") . frame-style-menu)))

  (defvar window-ops-toggle-menu '())

  (defvar window-menu nil)

  (defvar root-menu
    `((,(_ "_Windows") . window-menu)
      (,(_ "Work_spaces") . workspace-menu)
      (,(_ "_Programs") . apps-menu)
      (,(_ "_Customize") . custom-menu)
      (,(_ "_Help")
       (,(_ "_FAQ...") help:show-faq)
       (,(_ "_News...") help:show-news)
       (,(_ "_WWW page...") help:show-homepage)
       (,(_ "_Manual...") help:show-programmer-manual)
       (,(_ "_About Sawfish...") help:about))
      ()
      (,(_ "_Restart") restart)
      (,(_ "_Quit") quit)))

  (defvar apps-menu
    `(("xterm" (system "xterm &"))
      ("Emacs" (system "emacs &"))
      ("Netscape" (system "netscape &"))
      ("The GIMP" (system "gimp &"))
      ("XFIG" (system "xfig &"))
      ("GV" (system "gv &"))
      ("xcalc" (system "xcalc &"))))

  (define (menu-start-process)
    (when menu-timer
      (delete-timer menu-timer)
      (setq menu-timer nil))
    (unless (and menu-process (process-in-use-p menu-process))
      (when menu-process
	(kill-process menu-process)
	(setq menu-process nil))
      (let ((menu-sentinel (lambda ()
			     (when (and menu-process
					(not (process-in-use-p menu-process)))
			       (setq menu-process nil))
			     (when menu-timer
			       (delete-timer menu-timer)
			       (setq menu-timer nil))))
	    (menu-filter (lambda (output)
			   (setq output (concat menu-pending output))
			   (setq menu-pending nil)
			   (condition-case nil
			       (let
				   ((result (read-from-string output)))
				 ;; GTK takes the focus for its menu,
				 ;; but later returns it to the original
				 ;; window. We want the focus to be
				 ;; restored by the time the menu-chosen
				 ;; command is invoked..
				 (accept-x-input)
				 (menu-dispatch result))
			     (end-of-stream
			      (setq menu-pending output))))))
	(setq menu-process (make-process menu-filter menu-sentinel)))
      (set-process-error-stream menu-process nil)
      (or (start-process menu-process menu-program)
	  (error "Can't start menu backend: %s" menu-program))))

  (define (menu-stop-process #!optional force)
    (when menu-process
      (cond ((and (not force) (numberp menu-program-stays-running))
	     ;; number of seconds to let it hang around for
	     (require 'rep.io.timers)
	     (setq menu-timer (make-timer (lambda ()
					    (when menu-process
					      (kill-process menu-process)
					      (setq menu-process nil))
					    (setq menu-timer nil))
					  menu-program-stays-running)))
	    ((or force (not menu-program-stays-running))
	     (kill-process menu-process)
	     (setq menu-process nil)))))

  (define (make-nickname obj)
    (let ((nick nickname-index))
      (setq nickname-index (1+ nickname-index))
      (table-set nickname-table nick obj)
      nick))

  (define (nicknamep arg) (fixnump arg))
  (define (nickname-ref nick) (table-ref nickname-table nick))

  (define menu-args (make-fluid '()))
  (define where-is-fun (make-fluid '()))

  (define (menu-preprocessor cell)
    (define (inner cell)
      (when cell
	(let ((label (car cell)))
	  (when (functionp label)
	    (setq label (apply label (fluid menu-args))))
	  (cond ((functionp (cdr cell))
		 (setq cell (apply (cdr cell) (fluid menu-args))))
		((and (symbolp (cdr cell)) (not (null (cdr cell))))
		 (setq cell (symbol-value (cdr cell)))
		 (when (functionp cell)
		   (setq cell (apply cell (fluid menu-args)))))
		(t (setq cell (cdr cell))))
	  (when cell
	    (if (and (consp (car cell)) (stringp (car (car cell))))
		;; recurse through sub-menu
		(setq cell (mapcar inner cell))
	      (let* ((action (car cell))
		     (options (cdr cell))
		     (shortcut (and (fluid where-is-fun)
				    (symbolp action)
				    ((fluid where-is-fun) action))))
		(when (not (symbolp action))
		  ;; a non-symbol result, replace by a nickname
		  (setq action (make-nickname (car cell))))
		;; scan the alist of options
		(setq options (mapcar
			       (lambda (cell)
				 (if (functionp (cdr cell))
				     (cons (car cell)
					   (apply (cdr cell)
						  (fluid menu-args)))
				   cell)) options))
		(when shortcut
		  (setq options (cons (cons 'shortcut shortcut) options)))
		(setq cell (cons action options)))))
	  (cons label cell))))
    (let-fluids ((where-is-fun (and menus-include-shortcuts
				    (require 'sawfish.wm.util.keymap)
				    (make-memoizing-where-is
				     (list global-keymap window-keymap)))))
      (inner cell)))

  (define (menu-dispatch result)
    (let ((orig-win menu-active))
      (menu-stop-process)
      (when (nicknamep result)
	(setq result (nickname-ref result)))
      (setq menu-active nil)
      (setq nickname-table nil)
      (frame-draw-mutex nil)
      (when result
	(when (windowp orig-win)
	  (current-event-window orig-win))
	(cond ((commandp result)
	       (call-command result))
	      ((functionp result)
	       (result))
	      ((consp result)
	       (user-eval result))
	      (t result)))))

  (define (popup-menu spec)
    (or spec (error "No menu given to popup-menu"))
    (if (and menu-active menu-process (process-in-use-p menu-process))
	(error "Menu already active")
      (let* ((part (clicked-frame-part))
	     (offset (and part (frame-part-position part)))
	     (dims (and part (frame-part-dimensions part))))
	(setq menu-active (or (current-event-window) (input-focus)))
	(condition-case error-data
	    (progn
	      (menu-start-process)
	      ;; prevent any depressed button being redrawn until the menu
	      ;; is popped down
	      ;; XXX expose events screw this up..
	      (when (clicked-frame-part)
		(frame-draw-mutex t))
	      ;; This function is probably called from a ButtonPress event,
	      ;; so cancel the implicit pointer grab (to allow the menu's grab
	      ;; to succeed)
	      (ungrab-pointer)
	      (ungrab-keyboard)
	      (sync-server)
	      (when (functionp spec)
		(setq spec (spec)))
	      ;; XXX this is a hack, but I want menus to appear under buttons
	      (if (and part (setq part (frame-part-get part 'class))
		       (windowp menu-active)
		       (string-match "-button$" (symbol-name part)))
		  (progn
		    (rplaca offset
			    (max 0 (+ (car offset)
				      (car (window-position menu-active)))))
		    (rplacd offset
			    (max 0 (+ (cdr offset) (cdr dims)
				      (cdr (window-position menu-active))))))
		(setq offset nil))
	      (setq nickname-table (make-table eq-hash eq))
	      (setq nickname-index 0)
	      (format menu-process "(popup-menu %s %S %S)\n"
		      ;; write out the menu spec in one chunk to
		      ;; avoid large numbers of system calls :-[
		      (format nil "%S" (mapcar menu-preprocessor spec))
		      (x-server-timestamp) offset))
	      (error
	       ;; prevents spurious errors with subsequent menus
	       (setq menu-active nil)
	       (apply signal error-data))))))

  (define (popup-window-menu w)
    "Display the menu listing all window operations."
    (let-fluids ((menu-args (list w)))
      (popup-menu window-ops-menu)))

  (define (popup-root-menu)
    "Display the main menu."
    (popup-menu root-menu))

  (define (popup-apps-menu)
    "Display the applications menu."
    (popup-menu apps-menu))

  ;;###autoload
  (define-command 'popup-window-menu popup-window-menu #:spec "%W")
  (define-command 'popup-root-menu popup-root-menu)
  (define-command 'popup-apps-menu popup-apps-menu)

;;; menu modifiers

  (define (add-window-menu-toggle label command #!optional predicate)
    (let ((item (list* label command
		       (and predicate (list (cons 'check predicate))))))
    (let loop ((rest window-ops-toggle-menu))
      (cond
       ((null rest)
	(setq window-ops-toggle-menu (nconc window-ops-toggle-menu
					    (list item))))
       ((eq (cadar rest) command)
	(rplaca rest item))
       (t (loop (cdr rest)))))))

;;; customize menu

  (defvar custom-menu-includes-all-settings t
    "When non-nil, the custom menu includes the `All settings' item.")

  (define (custom-menu)
    `(,@(and custom-menu-includes-all-settings
	     (list (list (_ "_All settings") 'customize) nil))
      ,@(mapcar (lambda (sub)
		  (list (_ (cadr sub))
			(intern (concat "customize:"
					(symbol-name (car sub))))))
		(filter consp (cddr custom-groups)))
      ,@(and (frame-style-editable-p default-frame-style)
	     (list nil `(,(_"Edit theme...") edit-frame-style))))))

;; gaol.jl -- protected environment for themes
;;
;; Copyright (C) 1999, 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.gaol

    (export make-gaol
	    gaol-load
	    gaol-eval
	    gaol-add
	    gaol-define
	    gaol-define-special
	    define-gaol-structure)

    (open rep
	  rep.io.files
	  sawfish.wm.colors
	  sawfish.wm.cursors
	  sawfish.wm.events
	  sawfish.wm.fonts
	  sawfish.wm.images
	  sawfish.wm.misc
	  rep.util.gaol)

  ;; safe functions in the core module
  (define safe-functions
    '(get-color-rgb get-color color-name color-rgb colorp
      get-cursor cursorp get-font get-font-typed
      font-type-exists-p font-name fontp font-type text-width
      font-height font-ascent font-descent screen-width
      screen-height get-x-property get-x-text-property
      list-x-properties x-atom x-atom-name make-image
      make-image-from-x-drawable copy-image
      flip-image-horizontally flip-image-vertically
      flip-image-diagonally image-get image-put imagep
      image-dimensions image-border set-image-border
      image-shape-color set-image-shape-color image-modifier
      set-image-modifier make-sized-image bevel-image clear-image
      tile-image scale-image composite-images crop-image
      make-keymap bind-keys unbind-keys keymapp eventp image-ref
      image-set image-map image-fill color-rgb-8 uniquify-list))

  (define safe-specials
    '(default-foreground display-name canonical-display-name
      default-font default-frame nil-frame frame-part-classes
      decorate-transients batch-mode default-directory frame-font
      ;; This should be in librep, but I added it here, too.
      ;; Without this, wrong theme codes make Sawfish crash.
      ;; It's ok for librep to fix it, too.
      %in-condition-case))

  (define safe-features '(sawfish.wm.util.gtkrc
			  sawfish.wm.util.x
			  ;; compatibility
			  gtkrc x))
  (define fully-safe-features '(rep.io.timers rep.data.tables
				rep.data.records rep.data.ring
				rep.data.queues rep.data.symbol-table
				sawfish.wm.util.gradient
				sawfish.wm.util.recolor-image
				sawfish.wm.theming.make-theme
				sawfish.wm.tabs.tab
				;; compatibility
				timers gradient make-theme))

;;; functions

  (defmacro gaol-add vars
    `(mapc (lambda (x) (gaol-define x (symbol-value x))) ',vars))

  (defun gaol:require (feature)
    (cond ((memq feature fully-safe-features) (gaol-open feature))
	  ((memq feature safe-features) (load-module feature))
	  (t (error "Gaolled code trying to require %s" feature))))

;;; initialize the gaol envrironment

  ;; for backwards compatibility, / is integer division in themes, use
  ;; `divide' for real division
  (gaol-define 'divide /)
  (gaol-define '/ quotient)

  ;; use safe version of require
  (gaol-define 'require gaol:require)

  ;; add standard bindings
  (mapc (lambda (x)
	  (if (boundp x)
	      (gaol-define x (symbol-value x))
	    (format standard-error "warning: %s unbound\n" x))) safe-functions)
  (mapc gaol-define-special safe-specials)

  ;; a plugin, so easier to do this here..
  (call-after-load "sawfish.wm.util.x"
                   (lambda ()
                     (require 'sawfish.wm.util.x)
                     (mapc (lambda (x) (gaol-define x (symbol-value x)))
                           '(x-create-gc x-change-gc x-destroy-gc x-gc-p
                             x-create-pixmap x-create-bitmap
                             x-change-window-attributes x-window-p
                             x-destroy-drawable x-drawable-p
                             x-pixmap-p x-bitmap-p x-drawable-id
                             x-drawable-width x-drawable-height
                             x-window-id x-window-back-buffer
                             x-window-swap-buffers x-clear-window
                             x-draw-string x-draw-line
                             x-draw-rectangle x-fill-rectangle
                             x-draw-arc x-fill-arc x-fill-polygon
                             x-copy-area x-draw-image
                             x-grab-image-from-drawable
                             x-gc-set-dashes)))))

;; kde-int.jl -- KDE integration

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.kde

    (export detect-kde
	    kde-late-init
	    kde-window-matchers)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher
	  sawfish.wm.ext.apps-menu
          sawfish.wm.ext.match-window)

  (define-structure-alias kde-int sawfish.wm.integration.kde)

  (defvar kde-desktop-directories
    '("/usr/share/applications/kde4/")
    "KDE specific directories where *.desktop files are stored.")

  (define (kde-window-matchers)
    ;; window matchers so we properly interact with plasma stuff
    (add-window-matcher '((WM_CLASS . "^krunner/krunner$"))
     '((focus-mode . click)
       (never-tile . t)))
    (add-window-matcher '((WM_CLASS . "^Plasma-desktop/plasma-desktop$"))
     '((focus-mode . click)
       (never-tile . t)))
    (add-window-matcher '((WM_CLASS . "^Plasma/Plasma$"))
     '((focus-mode . click)
       (never-tile . t)))
    (add-window-matcher '((WM_CLASS . "^plasmashell/plasmashell$"))
     '((focus-mode . click)
       (never-tile . t))))

  (define (init)
    (let (menu
	  kde-logout-cmd)
      (setq desktop-environment "kde")
      (setq want-poweroff-menu nil)

      ;; invoke the KDE terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "konsole"))

      ;; use the KDE Browser
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "konqueror"))

      ;; use the KDE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "dolphin"))

      ;; add some KDE help menus
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_KDE Help") (system "khelpcenter &"))
		      (,(_ "KDE _Website") (browser "http://www.kde.org")))))

      ;; add kde-logout menu item
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(setq kde-logout-cmd "qdbus org.kde.ksmserver /KSMServer org.kde.KSMServerInterface.logout")
	(nconc menu `(()
		      (,(_ "_Customize KDE") (system "systemsettings &"))
		      (,(_ "_Edit KDE menu") (system "kmenuedit &"))
		      ()
		      (,(_ "L_ock screen from KDE")
			(system "qdbus org.kde.krunner /ScreenSaver Lock &"))
		      (,(_ "S_witch User from KDE")
			(system "qdbus org.kde.krunner /App switchUser &"))
		      ()
		      (,(_ "_Logout from KDE")
		       (system ,(concat kde-logout-cmd " 1 0 -1 &")))
		      (,(_ "_Reboot from KDE")
		       (system ,(concat kde-logout-cmd " 1 1 -1 &")))
		      (,(_ "_Shutdown from KDE")
		       (system ,(concat kde-logout-cmd " 1 2 -1 &")))
		      (,(_ "S_uspend from KDE")
			(system "qdbus org.kde.kded /org/freedesktop/PowerManagement Suspend &"))
		      (,(_ "_Hibernate from KDE")
			(system "qdbus org.kde.kded /org/freedesktop/PowerManagement Hibernate &")))))))

  ;; Returns nil if kde is not found.
  ;; If detected, returns t, and do also kde support init.
  (define (detect-kde)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "KDE")
              (equal (getenv "DESKTOP_SESSION") "sawfish-kde4")
              (equal (getenv "DESKTOP_SESSION") "sawfish-kde5")
              (getenv "KDE_FULL_SESSION"))
      (init)
      t))

  ;; Should be called after user customization is read.
  (define (kde-late-init)
    (setq desktop-directory
	  (append desktop-directory kde-desktop-directories))
    (kde-window-matchers)))

;; edge/expand.jl -- window-expansion for EdgeActions

;; Copyright (C) 2011 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.expand

    (export expand-window-half-screen-horizontal
            expand-window-half-screen-vertical
            expand-action)

    (open rep
	  rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.commands.move-resize
	  sawfish.wm.state.maximize
	  sawfish.wm.edge.util)

  (define-structure-alias edge-expand sawfish.wm.edge.expand)

  (define (expand-window-half-screen-vertical side #!optional w)
    (unless w
      (setq w (input-focus)))
    (if (eq side 'left)
        (move-window-to-corner w 'top-left)
      (move-window-to-corner w 'top-right))
    (resize-window-frame-to w (/ (screen-width) 2) (window-height w))
    (maximize-fill-window-vertically w))

  (define (expand-window-half-screen-horizontal side #!optional w)
    (unless w
      (setq w (input-focus)))
    (if (eq side 'top)
        (move-window-to-corner w 'top-left)
      (move-window-to-corner w 'bottom-left))
    (resize-window-frame-to w (window-width w) (/ (screen-height) 2))
    (maximize-fill-window-horizontally w))

  (define (expand-action edge)
    (let ((w (input-focus))
          (func (case edge
                   ((left) expand-window-half-screen-vertical)
                   ((right) expand-window-half-screen-vertical)
                   ((top) expand-window-half-screen-horizontal)
                   ((bottom) expand-window-half-screen-horizontal))))
      (allow-events 'async-both)
      (fake-release-window)
      (funcall func edge w))))

;; customize.jl -- invocation of configurator GUI & customization file IO

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.customize

    (export customize
	    customize-read-user-file
	    customize-write-user-file
	    customize-set)

    (open rep
	  rep.system
	  rep.io.files
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.misc)

  (define-structure-alias customize sawfish.wm.customize)

  (defvar customize-program "sawfish-config"
    "Command name of the configurator GUI.")

  (defvar customize-group-opt "--group")

  (defvar customize-redirect ">/dev/null 2>&1 </dev/null"
    "Redirect the configurator's input & output.")

  ;; Stores the content of ~/.sawfish/custom, both for
  ;; parsing and writing.
  (define customize-user-forms nil)

  (define customize-user-file-read nil)
  (define customize-user-file-dirty nil)

;;; ui

  (define (customize #!optional group)
    "Invoke the configurator GUI."
    (system (format nil "%s %s '%S' %s &"
		    customize-program
		    (if group customize-group-opt "")
		    (or group "")
		    customize-redirect)))

  ;;###autoload
  (define-command 'customize customize)

;;; setting variables

  ;; Currently only called from `customize-set' below.
  (define (customize-read-user-file)
    "Read the file which saves user customization. A configurator
instance can read it only once."
    (unless customize-user-file-read
      (let ((filename
	     (cond ((file-exists-p custom-user-file) custom-user-file)
		   ((file-exists-p custom-default-file) custom-default-file)
		   (t (error "Can't find custom-default-file: %s"
			     custom-default-file)))))
	(setq customize-user-forms nil)
	(when (file-exists-p filename)
	  (let ((file (open-file filename 'read)))
	    (unwind-protect
		(condition-case nil
		    (while t
		      (setq customize-user-forms (cons (read file)
						       customize-user-forms)))
		  (end-of-stream))
	      (close-file file))
	    (setq customize-user-forms
		  ;; remove obsolete variables
		  (delete-if (lambda (form)
			       (get (cadadr form) 'custom-obsolete))
			     (nreverse customize-user-forms)))))
	(setq customize-user-file-read t)
	(setq customize-user-file-dirty nil))))

  (define (customize-write-user-file)
    (when customize-user-file-dirty
      (make-directory-recursively (file-name-directory custom-user-file))
      (let ((file (open-file custom-user-file 'write)))
	(when file
	  (unwind-protect
	      (progn
		(format file "\
;; Sawfish user customization -- do not edit by hand!
;; Use the configurator instead.
;; sawfish version %s, written %s\n\n"
                        sawfish-version (current-time-string))
		(mapc (lambda (f)
			(format file "%S\n" f)) customize-user-forms))
	    (close-file file))
	  (setq customize-user-file-dirty nil)))))

  (define (customize-set symbol value)
    (customize-read-user-file)
    (let ((form (make-custom-form symbol value)))
      (catch 'done
	(mapc (lambda (f)
		(when (eq (nth 1 (nth 1 f)) symbol)
		  (setq customize-user-forms
			(cons form (delq f customize-user-forms)))
		  (throw 'done t)))
	      customize-user-forms)
	(setq customize-user-forms (cons form customize-user-forms)))
      (setq customize-user-file-dirty t)
      (custom-eval form)))

  (unless batch-mode
    (add-hook 'idle-hook customize-write-user-file)
    (add-hook 'before-exit-hook customize-write-user-file)))

;; nokogiri-widgets/font.jl -- font selection widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.font

    (export )

    (open rep
          rep.system
          gui.gtk-2.gtk
          sawfish.gtk.widget
          sawfish.wm.util.font)

  ;; FIXME: this is broken, in that only if Xrender is present
  ;; does gdk use Xft. But, it's the best I can do..
  (define use-xft (let ((x (getenv "GDK_USE_XFT")))
		    (or (not x) (/= (string->number x) 0))))

  ;; defined by configure
  (define have-pango-xft (eq 'yes 'yes))

  (define default-font (if use-xft "Sans" "fixed"))

  (define (make-font-item changed-callback)
    (let* ((button (gtk-font-button-new)))

      (gtk-font-button-set-use-font button t)
      (gtk-widget-set-size-request button 150 -1)

      (when changed-callback
	(g-signal-connect
	 button "font-set" (make-signal-callback changed-callback)))

      (gtk-widget-show button)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (cond ((stringp x)
			  (gtk-font-button-set-font-name button x))
			 ((consp x)
			  (let ((face (cond
                                       ((string-equal (car x) "Xft")
                                        (xft-description->face (cdr x)))
                                       ((string-equal (car x) "xlfd")
                                        (xlfd-description->face (cdr x)))
                                       ((string-equal (car x) "pango")
                                        (pango-description->face (cdr x))))))
			    (when face
			      (gtk-font-button-set-font-name
			       button (face->pango-description face)))))
			 (t (gtk-font-button-set-font-name button default-font)))))
	  ((clear) (lambda ()
		     (gtk-font-button-set-font-name button default-font)))
	  ((ref) (lambda ()
		   (let* ((pango-name (gtk-font-button-get-font-name button))
			  (face (pango-description->face pango-name)))
		     (cond ((not face) nil)
			   (use-xft
			    (if have-pango-xft
				(cons "Pango" (face->pango-description face))
			      (cons "Xft" (face->xft-description face))))
			   (t (cons "xlfd" (face->xlfd-description face)))))))
	  ((gtk-widget) button)
	  ((validp) (lambda (x) (stringp x)))))))

  (define-widget-type 'font make-font-item))

;; maximize.jl -- window maximization
;; $Id: maximize.jl,v 1.54 2000/12/06 19:43:03 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.state.maximize

    (export window-maximized-p
	    window-maximized-horizontally-p
	    window-maximized-vertically-p
	    window-unmaximized-position
	    window-unmaximized-dimensions
	    window-maximizable-p
	    maximize-truncate-dims
	    maximize-find-workarea
	    maximize-window
	    unmaximize-window
	    maximize-window-vertically
	    maximize-window-horizontally
	    maximize-window-toggle
	    maximize-window-vertically-toggle
	    maximize-window-horizontally-toggle
	    maximize-fill-window
	    maximize-fill-window-vertically
	    maximize-fill-window-horizontally
	    maximize-fill-window-toggle
	    maximize-fill-window-vertically-toggle
	    maximize-fill-window-horizontally-toggle)

    (open rep
	  rep.system
	  sawfish.wm.util.edges
	  sawfish.wm.util.rects
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.gaol
	  sawfish.wm.session.init
	  sawfish.wm.workspace
	  sawfish.wm.util.display-window
	  sawfish.wm.util.stacking
	  sawfish.wm.frames
	  sawfish.wm.misc)

  (define-structure-alias maximize sawfish.wm.state.maximize)

  ;; This sets the window property `unmaximized-geometry' of each
  ;; currently maximize window to `(X Y W H)', the saved geometry.

  (defcustom maximize-always-expands nil
    "Maximizing a window in one dimension must increase the size of that dimension."
    :group (min-max maximize)
    :user-level expert
    :type boolean)

  (defcustom maximize-raises t
    "Raise windows when they are maximized."
    :group (min-max maximize)
    :type boolean)

  (defcustom maximize-ignore-when-filling t
    "Let unmanaged windows be overlapped when filling windows."
    :group (min-max maximize)
    :user-level expert
    :type boolean)

  (defcustom maximize-avoid-avoided t
    "Don't cover `avoided' windows when maximizing."
    :group (min-max maximize)
    :user-level expert
    :type boolean)

  ;; called when a window is maximized, args (W #!optional DIRECTION)
  (defvar window-maximized-hook nil)

  ;; called when a window is un-maximized, args (W #!optional DIRECTION)
  (defvar window-unmaximized-hook nil)


;;; handling maximized state

  (define (window-maximized-p w)
    (window-get w 'unmaximized-geometry))

  (define (window-maximized-horizontally-p w)
    (window-get w 'maximized-horizontally))

  (define (window-maximized-vertically-p w)
    (window-get w 'maximized-vertically))

  (define (window-unmaximized-position w)
    (let ((coords (window-position w))
	  (old-geom (window-get w 'unmaximized-geometry)))
      (when (window-maximized-horizontally-p w)
	(rplaca coords (nth 0 old-geom)))
      (when (window-maximized-vertically-p w)
	(rplaca coords (nth 1 old-geom)))
      coords))

  (define (window-unmaximized-dimensions w)
    (let ((dims (window-dimensions w))
	  (old-geom (window-get w 'unmaximized-geometry)))
      (when (window-maximized-horizontally-p w)
	(rplaca dims (nth 2 old-geom)))
      (when (window-maximized-vertically-p w)
	(rplacd dims (nth 3 old-geom)))
      dims))

  (define (maximize-discard w #!optional horizontally vertically)
    (when horizontally
      (window-put w 'maximized-horizontally nil))
    (when vertically
      (window-put w 'maximized-vertically nil))
    (let ((dims (window-dimensions w))
	  (coords (window-position w))
	  (saved (window-get w 'unmaximized-geometry)))
      (when saved
	(unless (window-maximized-horizontally-p w)
	  (rplaca saved (car coords))
	  (rplaca (nthcdr 2 saved) (car dims)))
	(unless (window-maximized-vertically-p w)
	  (rplaca (cdr saved) (cdr coords))
	  (rplaca (nthcdr 3 saved) (cdr dims))))
      (when (and (not (window-maximized-vertically-p w))
		 (not (window-maximized-horizontally-p w)))
	(window-put w 'unmaximized-geometry nil))))

  (define (maximize-discard-move w directions)
    (maximize-discard w (memq 'horizontal directions)
		      (memq 'vertical directions)))

  (define (maximize-discard-resize w edges)
    (maximize-discard w (or (memq 'left edges) (memq 'right edges))
		      (or (memq 'top edges) (memq 'bottom edges))))


;;; 1D packing

  (defmacro edges-touching (start end edge)
    `(> (- (min ,end (nth 2 ,edge)) (max ,start (nth 1 ,edge))) 0))

  (define (expand-edges start end minimum maximum perp-1 perp-2 edges)
    (if maximize-always-expands
	(progn
	  (mapc (lambda (edge)
		  ;; EDGE is (PERP START END OPEN-P)
		  (if (nth 3 edge)
		      (when (and (< (car edge) maximum)
				 (>= (car edge) perp-2)
				 (> (car edge) minimum)
				 (edges-touching start end edge))
			(setq maximum (car edge)))
		    (when (and (> (car edge) minimum)
			       (<= (car edge) perp-1)
			       (< (car edge) maximum)
			       (edges-touching start end edge))
		      (setq minimum (car edge)))))
		edges)
	  (cons minimum maximum))
      (let ((opening (sort (mapcar car (filter (lambda (e)
						 (and (nth 3 e)
						      (edges-touching
						       start end e)))
					       edges))))
	    (closing (sort (mapcar car (filter (lambda (e)
						 (and (not (nth 3 e))
						      (edges-touching
						       start end e)))
					       edges))))
	    max-perp
	    (max-size 0))
	;; find the maximum gap between a closing and an opening edge which
	;; doesn't include any other opening edges
	(while (and opening closing)
	  (while (and opening (<= (car opening) (car closing)))
	    (setq opening (cdr opening)))
	  (when (and (> (- (or (car opening) maximum) (car closing)) max-size)
		     (or (not (nth 1 closing))
			 (>= (nth 1 closing) (or (car opening) maximum))))
	    (setq max-perp (car closing))
	    (setq max-size (- (car opening) (car closing))))
	  (setq closing (cdr closing)))
	(if max-perp
	    (cons max-perp (+ max-perp max-size))
	  (cons perp-1 perp-2)))))

  (define (do-horizontal w edges coords dims fdims)
    (let ((head-offset (current-head-offset w))
	  (head-dims (current-head-dimensions w)))
      (let ((x-span (expand-edges (cdr coords) (+ (cdr coords) (cdr fdims))
				  (car head-offset)
				  (+ (car head-offset) (car head-dims))
				  (car coords) (+ (car coords) (car fdims))
				  (car edges))))
	(rplaca coords (car x-span))
	(rplaca dims (- (- (cdr x-span) (car x-span))
			(- (car fdims) (car dims))))
	w)))

  (define (do-vertical w edges coords dims fdims)
    (let ((head-offset (current-head-offset w))
	  (head-dims (current-head-dimensions w)))
      (let ((y-span (expand-edges (car coords) (+ (car coords) (car fdims))
				  (cdr head-offset)
				  (+ (cdr head-offset) (cdr head-dims))
				  (cdr coords) (+ (cdr coords) (cdr fdims))
				  (cdr edges))))
	(rplacd coords (car y-span))
	(rplacd dims (- (- (cdr y-span) (car y-span))
			(- (cdr fdims) (cdr dims))))
	w)))


;;; 2D packing

  (define (find-max-rectangle avoided edges #!optional head)
    (let* ((grid (grid-from-edges (car edges) (cdr edges)))
	   rects)
      (setq rects (rectangles-from-grid
		   (sort (car grid)) (sort (cdr grid))
		   (lambda (rect)
		     ;; the rectangle mustn't overlap any avoided windows
		     ;; or span multiple heads, or be on a different head
		     ;; to that requested
		     (catch 'foo
		       (mapc (lambda (w)
			       (when (or (> (rect-2d-overlap
					     (window-frame-dimensions w)
					     (window-position w)
					     rect) 0)
					 (/= (rectangle-heads rect) 1)
					 (and head (/= head (find-head (car rect) (cadr rect)))))
				 (throw 'foo nil)))
			     avoided)
		       t))))

      ;; find the largest rectangle
      (let ((max-area 0)
	    (max-rect nil))
	(mapc (lambda (rect)
		(when (and (rect-wholly-visible-p rect)
			   (> (rectangle-area rect) max-area))
		  (setq max-area (rectangle-area rect))
		  (setq max-rect rect))) rects)
	max-rect)))

  (define (do-both window avoided edges coords dims fdims)
    (let ((max-rect (find-max-rectangle avoided edges (current-head window))))
      (when max-rect
	(rplaca coords (nth 0 max-rect))
	(rplacd coords (nth 1 max-rect))
	(rplaca dims (- (- (nth 2 max-rect) (nth 0 max-rect))
			(- (car fdims) (car dims))))
	(rplacd dims (- (- (nth 3 max-rect) (nth 1 max-rect))
			(- (cdr fdims) (cdr dims))))
	window)))


;;; size hints stuff

  (define (window-maximizable-p w #!optional direction hints)
    (if (window-get w 'never-maximize)
	nil
      (unless hints
	(setq hints (window-size-hints w)))
      (let ((max-width (cdr (assq 'max-width hints)))
	    (max-height (cdr (assq 'max-height hints)))
	    (dims (window-dimensions w)))
	(catch 'out
	  (when (and (or (null direction) (eq direction 'horizontal))
		     max-width
		     (>= (car dims) max-width))
	    (throw 'out nil))
	  (when (and (or (null direction) (eq direction 'vertical))
		     max-height
		     (>= (cdr dims) max-height))
	    (throw 'out nil))
	  t))))

  (define (maximize-truncate-dims w dims #!optional direction hints)
    (unless hints
      (setq hints (window-size-hints w)))
    (let ((x-base (or (cdr (or (assq 'base-width hints)
			       (assq 'min-width hints))) 1))
	  (x-inc (or (cdr (assq 'width-inc hints)) 1))
	  (y-base (or (cdr (or (assq 'base-height hints)
			       (assq 'min-height hints))) 1))
	  (y-inc (or (cdr (assq 'height-inc hints)) 1))
	  (x-max (cdr (assq 'max-width hints)))
	  (y-max (cdr (assq 'max-height hints)))
	  
	  (trunc (lambda (x inc base #!optional maximum)
		   (min (+ base (max 0 (- (- x base) (mod (- x base) inc))))
			(or maximum 65535)))))
      (when (or (null direction) (eq direction 'horizontal))
	(rplaca dims (trunc (car dims) x-inc x-base x-max)))
      (when (or (null direction) (eq direction 'vertical))
	(rplacd dims (trunc (cdr dims) y-inc y-base y-max)))
      dims))


;;; misc functions

  (define (maximize-find-workarea #!optional w #!key head)
    "Return the rectangle representing the largest rectangle on the screen that
doesn't overlap any avoided windows, or nil."
    (let* ((avoided (avoided-windows w))
	   (edges (get-visible-window-edges
		   #:with-ignored-windows t
		   #:windows avoided
		   #:include-heads (list (or head (current-head))))))
      (find-max-rectangle avoided edges (current-head w))))


;;; commands

  (define (maximize-window w #!optional direction only-1d)
    "Maximize the dimensions of the window."
    (let ((unshade-selected-windows t))
      (display-window-without-focusing w))
    (let* ((coords (window-position w))
	   (dims (window-dimensions w))
	   (fdims (window-frame-dimensions w))
	   (hints (window-size-hints w))
	   (avoided (and maximize-avoid-avoided (avoided-windows w)))
	   (edges (get-visible-window-edges
		   #:with-ignored-windows t
		   #:windows avoided
		   #:include-heads (list (current-head)))))
      (when (window-maximizable-p w direction hints)
	(unless (window-get w 'unmaximized-geometry)
	  (window-put w 'unmaximized-geometry (list (car coords) (cdr coords)
						    (car dims) (cdr dims))))
	(cond ((null direction)
	       (if (not only-1d)
		   (do-both w avoided edges coords dims fdims)
		 (do-horizontal w edges coords dims fdims)
		 (do-vertical w edges coords dims fdims))
	       (window-put w 'maximized-horizontally t)
	       (window-put w 'maximized-vertically t))
	      ((eq direction 'horizontal)
	       (do-horizontal w edges coords dims fdims)
	       (window-put w 'maximized-horizontally t))
	      ((eq direction 'vertical)
	       (do-vertical w edges coords dims fdims)
	       (window-put w 'maximized-vertically t)))
	(maximize-truncate-dims w dims direction hints)
	(move-resize-window-to w (car coords) (cdr coords)
			       (car dims) (cdr dims))
	(when maximize-raises
	  (raise-window* w))
	(call-window-hook 'window-maximized-hook w (list direction))
	(call-window-hook 'window-state-change-hook w (list '(maximized))))))

  ;; does all unmaximizing except for changing the window properties and
  ;; calling the hooks
  (define (unmaximize-window-1 w #!optional direction before)
    (let ((geom (window-get w 'unmaximized-geometry))
	  (coords (window-position w))
	  (dims (window-dimensions w)))
      (when geom
	(when (or (null direction) (eq direction 'horizontal))
	  (rplaca coords (nth 0 geom))
	  (rplaca dims (nth 2 geom)))
	(when (or (null direction) (eq direction 'vertical))
	  (rplacd coords (nth 1 geom))
	  (rplacd dims (nth 3 geom)))
	(when before
	  (before))
	(move-resize-window-to w (car coords) (cdr coords)
			       (car dims) (cdr dims)))))

  (define (unmaximize-window w #!optional direction)
    "Restore the dimensions of the window to its original, unmaximized, state."
    (unmaximize-window-1 w direction
     (lambda ()
       (when (or (null direction) (eq direction 'horizontal))
	 (window-put w 'maximized-horizontally nil))
       (when (or (null direction) (eq direction 'vertical))
	 (window-put w 'maximized-vertically nil))
       (when (and (not (window-maximized-vertically-p w))
		  (not (window-maximized-horizontally-p w)))
	 (window-put w 'unmaximized-geometry nil))))
    (call-window-hook 'window-unmaximized-hook w (list direction))
    (call-window-hook 'window-state-change-hook w (list '(maximized))))

  (define (maximize-window-vertically w)
    "Maximize the vertical dimension of the window."
    (maximize-window w 'vertical))

  (define (maximize-window-horizontally w)
    "Maximize the horizontal dimension of the window."
    (maximize-window w 'horizontal))

  (define (maximize-window-toggle w #!optional direction)
    "Toggle the state of the window between maximized and unmaximized."
    (if (window-maximized-p w)
	(unmaximize-window w direction)
      (maximize-window w direction)))

  (define (maximize-window-vertically-toggle w)
    "Toggle the state of the window between vertically maximized and
unmaximized."
    (if (window-maximized-vertically-p w)
	(unmaximize-window w 'vertical)
      (maximize-window w 'vertical)))

  (define (maximize-window-horizontally-toggle w)
    "Toggle the state of the window between horizontally maximized and
unmaximized."
    (if (window-maximized-horizontally-p w)
	(unmaximize-window w 'horizontal)
      (maximize-window w 'horizontal)))

  ;;###autoload
  (define-command 'maximize-window maximize-window #:spec "%W")
  (define-command 'unmaximize-window unmaximize-window #:spec "%W")
  (define-command 'maximize-window-vertically maximize-window-vertically #:spec "%W")
  (define-command 'maximize-window-horizontally maximize-window-horizontally #:spec "%W")
  (define-command 'maximize-window-toggle maximize-window-toggle #:spec "%W")
  (define-command 'maximize-window-horizontally-toggle maximize-window-horizontally-toggle #:spec "%W")
  (define-command 'maximize-window-vertically-toggle maximize-window-vertically-toggle #:spec "%W")


;;; fill commands

  (define (maximize-fill-window w #!optional direction)
    "Maximize the window without obscuring any other windows."
    (let ((avoid-by-default t)
	  (maximize-always-expands t)
	  (dont-avoid-ignored maximize-ignore-when-filling))
      (maximize-window w direction t)))

  (define (maximize-fill-window-vertically w)
    "Maximize the window vertically without obscuring any other windows."
    (maximize-fill-window w 'vertical))

  (define (maximize-fill-window-horizontally w)
    "Maximize the window horizontally without obscuring any other windows."
    (maximize-fill-window w 'horizontal))

  (define (maximize-fill-window-toggle w #!optional direction)
    "Toggle the state of the window between maximized-filled and unmaximized."
    (if (window-maximized-p w)
	(unmaximize-window w direction)
      (maximize-fill-window w direction)))

  (define (maximize-fill-window-vertically-toggle w)
    "Toggle the state of the window between vertically maximized-filled and
unmaximized."
    (if (window-maximized-vertically-p w)
	(unmaximize-window w 'vertical)
      (maximize-fill-window w 'vertical)))

  (define (maximize-fill-window-horizontally-toggle w)
    "Toggle the state of the window between horizontally maximized-filled and
unmaximized."
    (if (window-maximized-horizontally-p w)
	(unmaximize-window w 'horizontal)
      (maximize-fill-window w 'horizontal)))

  ;;###autoload
  (define-command 'maximize-fill-window maximize-fill-window #:spec "%W")
  (define-command 'maximize-fill-window-vertically maximize-fill-window-vertically #:spec "%W")
  (define-command 'maximize-fill-window-horizontally maximize-fill-window-horizontally #:spec "%W")
  (define-command 'maximize-fill-window-toggle maximize-fill-window-toggle #:spec "%W")
  (define-command 'maximize-fill-window-horizontally-toggle maximize-fill-window-horizontally-toggle #:spec "%W")
  (define-command 'maximize-fill-window-vertically-toggle maximize-fill-window-vertically-toggle #:spec "%W")


;;; initialisation

  (define (after-add-window w)
    (let ((vert (window-get w 'queued-vertical-maximize))
	  (horiz (window-get w 'queued-horizontal-maximize)))
      (when (or vert horiz)
	(window-put w 'queued-vertical-maximize nil)
	(window-put w 'queued-horizontal-maximize nil)
	(maximize-window w (cond ((and vert horiz) nil)
				 (vert 'vertical)
				 (horiz 'horizontal))))))

  (add-hook 'after-add-window-hook after-add-window)

  ;; before exiting, return all windows to their unmaximized
  ;; geometries. But _don't_ change any of the properties (either
  ;; wm-local or X) that mark the window as being maximized
  (add-hook 'before-exit-hook (lambda () (map-windows unmaximize-window-1)))

  (define (check-if-maximizable w)
    (let ((maximizable (window-maximizable-p w)))
      (when (and (not maximizable)
		 (not (frame-class-removed-p w 'maximize-button)))
	(remove-frame-class w 'maximize-button)
	(window-put w 'maximize-removed-maximize-button t))
      (when (and maximizable
		 (window-get w 'maximize-removed-maximize-button))
	(add-frame-class w 'maximize-button)
	(window-put w 'maximize-removed-maximize-button nil))))

  (define (property-notify w prop type)
    (declare (unused type))
    (when (eq prop 'WM_NORMAL_HINTS)
      (check-if-maximizable w)))

  (add-hook 'property-notify-hook property-notify)
  (add-hook 'add-window-hook check-if-maximizable)

  (sm-add-saved-properties
   'unmaximized-geometry 'maximized-vertically 'maximized-horizontally)
  (add-swapped-properties
   'unmaximized-geometry 'maximized-vertically 'maximized-horizontally)

  (add-hook 'after-move-hook maximize-discard-move)
  (add-hook 'after-resize-hook maximize-discard-resize)

  (gaol-add window-maximized-p window-maximized-horizontally-p
	    window-maximized-vertically-p))

;; Utilities for window placement and tiling

(define-structure sawfish.wm.tile.utils
    (export current-workspace
            window-workspace
            tileable-workspace-windows
            window-type
            window-x
            window-y
            window-width
            window-height
            scr-height
            scr-width
            push-window
            resize-frame-to
            input-focus
            focus-window
            align-workspace-windows
            notify
            take
            group-by
            tab-background-p
	    window-never-tile-p)
    (open rep
          rep.io.timers
          sawfish.wm.stacking
          sawfish.wm.state.ignored
	  sawfish.wm.state.iconify
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.placement
	  sawfish.wm.workspace
          sawfish.wm.util.window-order
	  sawfish.wm.util.workarea
          sawfish.wm.misc)

  (define (window-workspace w) (car (window-get w 'workspaces)))

  (define (window-never-tile-p w) (window-get w 'never-tile))

  (define (tab-background-p w)
    "Returns t if a tabbed window is a background tab"
    (require 'sawfish.wm.tabs.tabgroup)
    (if tab-move-resize-lock 't
      (if (window-tabbed-p w)
          (if (member w (nthcdr 1 (tab-group-windows-stacking-order w))) 't))))

  (define (tileable-workspace-windows #!optional ignore)
    (remove-if (lambda (w)
                 (or (equal w ignore)
                     (dock-window-p w)
                     (window-iconified-p w)
                     ;; window-matcher
                     (window-never-tile-p w)
                     ;; for pager and stuff
                     (not (window-visible-p w))
                     ;; no dialogs
                     (eq (window-type w) 'transient)
                     (tab-background-p w)
                     (window-ignored-p w)))
               (window-order current-workspace)))

  (define (window-x w) (car (window-position w)))
  (define (window-y w) (cdr (window-position w)))
  (define (window-width w) (car (window-frame-dimensions w)))
  (define (window-height w) (cdr (window-frame-dimensions w)))
  (define (scr-height #!optional (tm 0) (bm 0)) (- (cadddr (calculate-workarea #:head (current-head))) tm bm))
  (define (scr-width #!optional (l 0) (r 0) (g 0)) (- (caddr (calculate-workarea #:head (current-head))) l r g))

  (define (resize-frame-to w width height)
    (let ((width-offset (- (car (window-frame-dimensions w))
                           (car (window-dimensions w))))
          (height-offset (- (cdr (window-frame-dimensions w))
                            (cdr (window-dimensions w)))))
      (resize-window-to w (- width width-offset) (- height height-offset))))

  (define (push-window w x y width height)
    (let ((height-offset (cadr (calculate-workarea #:window w #:head (current-head))))
          (width-offset (car (calculate-workarea #:window w #:head (current-head)))))
          (when (not (eq 0 height-offset))
	             (when (< y height-offset)
		         (setq y (+ y height-offset))
			 (setq height (- height height-offset))))
          (when (not (eq 0 width-offset))
		     (if (< x width-offset)
                         (progn
			   (setq x (+ x width-offset))
		           (setq width (- width (- width-offset x))))
		       (setq x (+ x width-offset))
		       (setq width (- width width-offset))))
    (resize-frame-to w (inexact->exact width) (inexact->exact height))
    (move-window-to w (inexact->exact x) (inexact->exact y))
    (require 'sawfish.wm.tabs.tabgroup)
    (when (window-tabbed-p w)
      (tab-refresh-group (nth 0 (tab-group-windows-stacking-order w)) 'move))
    (window-order-push w)))

  (define (focus-window w) (window-order-push w))

  (define (align-workspace-windows)
    (interactive)
    (let* ((fw (input-focus))
           (windows (tileable-workspace-windows fw))
           (x (window-x fw))
           (y (window-y fw)))
      (mapc (lambda (w)
              (push-window w x y (window-width w) (window-height w)))
            windows)))

  (define %hide-timer (make-timer (lambda () (display-message nil))))

  (define (notify fmt #!rest args)
    (display-message (apply format (cons nil (cons fmt args))))
    (set-timer %hide-timer 1))

  (define (take n l)
    (cond ((null l) '())
          ((<= n 0) '())
          ((= 1 n) (list (car l)))
          (t (cons (car l) (take (- n 1) (cdr l))))))

  (define (group-by ws n)
    (cond ((null ws) ws)
          ((< n 1) (list ws))
          ((<= (length ws) n) (list ws))
          (t (cons (take n ws) (group-by (nthcdr n ws) n))))))

;; off-center.jl -- place windows around the centre of the screen
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; Commentary:

;; This placement mode tries to put windows in the center of the
;; screen, but in such a way that the newly placed window doesn't fully
;; obscure an existing window.

;; This is to handle the case where two windows of the same size are
;; created one after the other, so that the user is sure to see (at
;; least part of) both windows

(define-structure sawfish.wm.placement.off-center

    (export )

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.placement
	  sawfish.wm.windows
	  sawfish.wm.viewport
	  sawfish.wm.workspace
	  sawfish.wm.util.rects
	  sawfish.wm.util.workarea
	  sawfish.wm.state.iconify)

  (define multipliers '[(0 . 0)		;centered

			(-1/8 . -1/8)	;diagonals
			(-1/8 . -1/8)
			(1/8 . -1/8)
			(1/8 . 1/8)
			(-1/8 . 1/8)
			(0 . -1/6)	;perpendicular
			(1/6 . 0)
			(0 . 1/6)
			(-1/6 . 0)

			(-1/4 . -1/4)	;diagonals
			(-1/4 . -1/4)
			(1/4 . -1/4)
			(1/4 . 1/4)
			(-1/4 . 1/4)
			(0 . -1/3)	;perpendicular
			(1/3 . 0)
			(0 . 1/3)
			(-1/3 . 0)

			(-1/2 . -1/2)	;diagonals
			(-1/2 . -1/2)
			(1/2 . -1/2)
			(1/2 . 1/2)
			(-1/2 . 1/2)
			(0 . -1/2)	;perpendicular
			(1/2 . 0)
			(0 . 1/2)
			(-1/2 . 0)])

  (define (make-point center dims index)
    (if (>= index (length multipliers))
	nil
      (let ((mult (aref multipliers index)))
	;; need to coerce to exact representation in case rep
	;; was compiled --without-gmp (and thus division may lose
	;; exactness)
	(cons (inexact->exact (round (- (+ (car center)
					   (* (car dims) (car mult)))
					(/ (car dims) 2))))
	      (inexact->exact (round (- (+ (cdr center)
					   (* (cdr dims) (cdr mult)))
					(/ (cdr dims) 2))))))))

  (define (obscured-windows w point dims)
    (filter-windows
     (lambda (x)
       (and (not (eq x w))
	    (window-mapped-p x)
	    (not (window-iconified-p x))
	    (window-in-workspace-p x current-workspace)
	    (let ((x-rect (car (rectangles-from-windows (list x)))))
	      (>= (rect-2d-overlap dims point x-rect)
		  (rectangle-area x-rect)))))))

  (define (within-rectangle point dims rect)
    (= (rect-2d-overlap dims point rect) (* (car dims) (cdr dims))))

  (define (place-window-off-center w)
    (let* ((workarea (calculate-workarea #:window w))
	   (fdims (window-frame-dimensions w))
	   (center (rectangle-center workarea)))

      (let loop ((index 0))
	(let ((point (make-point center fdims index)))
	  (if (null point)
	      ;; fall back to random placement
	      ((placement-mode 'randomly) w)

	    (if (and (within-rectangle point fdims workarea)
		     (null (obscured-windows w point fdims)))
		(move-window-to w (car point) (cdr point))

	      (loop (1+ index))))))))

  ;;###autoload
  (define-placement-mode 'off-center place-window-off-center #:for-normal t))

;; groups.jl -- commands for manipulating window groups

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.groups

    (export iconify-group
	    uniconify-group
	    iconify-transient-group
	    uniconify-transient-group
	    make-group-sticky
	    make-group-unsticky
	    toggle-group-sticky
	    send-group-to-workspace
	    send-group-to-current-workspace
	    send-group-to-next-workspace
	    send-group-to-previous-workspace
	    move-group-to-current-viewport
	    move-group-viewport
	    move-group-left
	    move-group-right
	    move-group-up
	    move-group-down
	    raise-group
	    lower-group
	    raise-lower-group
	    raise-group-depth
	    lower-group-depth
	    set-group-frame-style)

    (open rep
	  sawfish.wm.util.groups
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.state.iconify
	  sawfish.wm.state.transient
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.stacking
	  sawfish.wm.frames)

  (define-structure-alias groups sawfish.wm.commands.groups)

  ;; iconification

  (define (call-with-iconify-mode mode fun w)
    (let ((iconify-group-mode mode)
	  (uniconify-group-mode mode))
      (fun w)))

  (define (iconify-group w)
    "Minimize the window and all windows from the same group."
    (call-with-iconify-mode 'group iconify-window w))
  (define (uniconify-group w)
    "Restore the window and all windows from the same group from its minimized state."
    (call-with-iconify-mode 'group uniconify-window w))

  (define (iconify-transient-group w)
    "Minimize the transient window and all transient windows from the same group."
    (call-with-iconify-mode 'transients iconify-window w))
  (define (uniconify-transient-group w)
    "Restore the transient window and all transient windows from the same group from its minimized state."
    (call-with-iconify-mode 'transients uniconify-window w))

  (define-command 'iconify-group
    iconify-group #:spec "%W")
  (define-command 'uniconify-group
    uniconify-group #:spec "%W")
  (define-command 'iconify-transient-group
    iconify-transient-group #:spec "%W")
  (define-command 'uniconify-transient-group
    uniconify-transient-group #:spec "%W")

  ;; sticky

  (define (make-group-sticky w)
    "Make the window and all windows from the same group appears in all workspaces and viewports."
    (map-window-group make-window-sticky w))
  (define (make-group-unsticky w)
    "Make the window and all windows from the same group appears only in the
current workspaces or viewports."
    (map-window-group make-window-unsticky w))
  
  (defun toggle-group-sticky (w)
    "Toggle the `stickiness' from the window and all windows from the same group,
i.e. make it appear in all workspaces and viewports."
    (if (window-get w 'sticky)
        (make-group-unsticky w)
      (make-group-sticky w)))

  ;;###autoload
  (define-command 'make-group-sticky make-group-sticky #:spec "%W")
  (define-command 'make-group-unsticky make-group-unsticky #:spec "%W")
  (define-command 'toggle-group-sticky toggle-group-sticky #:spec "%W")

  ;; workspaces

  (define (send-group-to-workspace w send-group-dest-space)
    (map-window-group
     (lambda (x)
       (unless (window-get x 'sticky)
	 (move-window-to-workspace
	  x (nearest-workspace-with-window x current-workspace)
	  send-group-dest-space (eq x (input-focus))))) w))

  (define (send-group-to-current-workspace w)
    "Send the window and all windows from the same group to the current workspace."
    (send-group-to-workspace w current-workspace))

  (define (send-group-to-next-workspace send-group-window count)
    "Send the window and all windows from the same group to the next workspace."
    (ws-call-with-workspace (lambda (space)
			      (send-group-to-workspace send-group-window space)
			      (select-workspace space))
			    count workspace-send-boundary-mode))

  (define (send-group-to-previous-workspace w count)
    "Send the window and all windows from the same group to the previous workspace."
    (send-group-to-next-workspace w (- count)))

  ;;###autoload
  (define-command 'send-group-to-current-workspace
    send-group-to-current-workspace #:spec "%W")
  (define-command 'send-group-to-next-workspace
    send-group-to-next-workspace #:spec "%W\np")
  (define-command 'send-group-to-previous-workspace
    send-group-to-previous-workspace #:spec "%W\np")

  ;; viewports

  (define (move-group-to-current-viewport w)
    "Move the window and all windows from the same group
to the current viewport."
    (map-window-group move-window-to-current-viewport w))

  (define (move-group-viewport w col row)
    (map-window-group (lambda (x)
			(move-window-viewport x col row)) w)
    (move-viewport-to-window w))

  (define (move-group-left w) 
    "Move the window and all windows from the same group
to the viewport on the left, and switch to that viewport."
    (move-group-viewport w -1 0))

  (define (move-group-right w) 
    "Move the window and all windows from the same group
to the viewport on the right, and switch to that viewport."
    (move-group-viewport w 1 0))

  (define (move-group-up w) 
    "Move the window and all windows from the same group
to the viewport above, and switch to that viewport."
    (move-group-viewport w 0 -1))

  (define (move-group-down w) 
    "Move the window and all windows from the same group
to the viewport below, and switch to that viewport."
    (move-group-viewport w 0 1))

  ;;###autoload
  (define-command 'move-group-to-current-viewport
    move-group-to-current-viewport #:spec "%W")

  ;;###autoload
  (define-command 'move-group-left
    move-group-left #:spec "%W")
  (define-command 'move-group-right
    move-group-right #:spec "%W")
  (define-command 'move-group-up
    move-group-up #:spec "%W")
  (define-command 'move-group-down
    move-group-down #:spec "%W")

  ;; stacking

  (define (raise-group w) 
    "Raise the window and all windows from the same group to its highest
allowed position in the stacking order."
    (raise-windows w (windows-in-group w t)))

  (define (lower-group w) 
    "Lower the window and all windows from the same group to its lowest
allowed position in the stacking order."
    (lower-windows w (windows-in-group w t)))

  (define (raise-lower-group w) 
    "If the window is at its highest possible position, then lower the window and all
windows from the same group to its lowest possible position. Otherwise raise the window
and all windows from the group as far as allowed."
    (raise-lower-windows w (windows-in-group w t)))

  (define (raise-group-depth w) 
    "Put the window and all windows from the same group in the stacking level above its current level."
    (map-window-group raise-window-depth w))

  (define (lower-group-depth w) 
    "Put the window and all windows from the same group in the stacking level beneath its current level."
    (map-window-group lower-window-depth w))

  ;;###autoload
  (define-command 'raise-group raise-group
    #:spec "%W")
  (define-command 'lower-group lower-group
    #:spec "%W")
  (define-command 'raise-lower-group raise-lower-group
    #:spec "%W")
  (define-command 'raise-group-depth raise-group-depth #:spec "%W")
  (define-command 'lower-group-depth lower-group-depth #:spec "%W")

  ;; framing

  (define (set-group-frame-style w style)
    (map-window-group (lambda (x)
			(set-frame-style x style)) w))

  ;; deleting windows

  (define (delete-group w)
    "Delete all windows in the group that the current window is a member of."
    (map-window-group (lambda (x)
			;; Don't delete the desktop-window. It should
			;; probably be in a separate group, but isn't..
			(unless (desktop-window-p x)
			  (delete-window x))) w))

  ;;###autoload
  (define-command 'delete-group delete-group #:spec "%W"))

;; kde-int.jl -- KDE integration

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@tuxfamily.org>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.integration.kde

    (export detect-kde
	    kde-late-init)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher
	  sawfish.wm.ext.apps-menu)

  (define-structure-alias kde-int sawfish.wm.integration.kde)

  (defvar kde-desktop-directories
    '("/usr/share/applications/kde4/")
    "KDE specific directories where *.desktop files are stored.")

  (define (init)
    (let (menu
	  kde-logout-cmd)
      (setq desktop-environment "kde")
      (setq want-poweroff-menu nil)

      ;; invoke the KDE terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "konsole"))

      ;; use the KDE Browser
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "konqueror"))

      ;; use the KDE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "dolphin"))

      ;; add some KDE help menus
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_KDE Help") (system "khelpcenter &"))
		      (,(_ "KDE _Website") (browser "http://www.kde.org")))))

      ;; add kde-logout menu item
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(setq kde-logout-cmd "qdbus org.kde.ksmserver /KSMServer org.kde.KSMServerInterface.logout")
	(nconc menu `(()
		      (,(_ "_Customize KDE") (system "systemsettings &"))
		      (,(_ "_Edit KDE menu") (system "kmenuedit &"))
		      ()
		      (,(_ "L_ock screen from KDE")
			(system "qdbus org.kde.krunner /ScreenSaver Lock &"))
		      (,(_ "S_witch User from KDE")
			(system "qdbus org.kde.krunner /App switchUser &"))
		      ()
		      (,(_ "_Logout from KDE")
		       (system ,(concat kde-logout-cmd " 1 0 -1 &")))
		      (,(_ "_Reboot from KDE")
		       (system ,(concat kde-logout-cmd " 1 1 -1 &")))
		      (,(_ "_Shutdown from KDE")
		       (system ,(concat kde-logout-cmd " 1 2 -1 &")))
		      (,(_ "S_uspend from KDE")
			(system "qdbus org.kde.kded /org/freedesktop/PowerManagement Suspend &"))
		      (,(_ "_Hibernate from KDE")
			(system "qdbus org.kde.kded /org/freedesktop/PowerManagement Hibernate &")))))))

  ;; Returns nil if kde is not found.
  ;; If detected, returns t, and do also kde support init.
  (define (detect-kde)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "KDE")
              (getenv "KDE_FULL_SESSION"))
      (init)
      t))

  ;; Should be called after user customization is read.
  (define (kde-late-init)
    (setq desktop-directory
	  (append desktop-directory kde-desktop-directories))))

;; tabgroup.jl - tab main
;;
;; Copyright (C) Yann Hodique <Yann.Hodique@lifl.fr>
;;
;; This file is an official accepted contribution into sawfish.
;;
;; This script is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 22, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.tabs.tabgroup

    (export window-tabbed-p
            adjust-title
            tab-refresh-group
            tab-release-window
            tab-raise-left-window
            tab-raise-right-window
            tab-find-window
            tab-rank
            tab-group-window-list
            tab-group-window-index
            tab-group-window)

    (open rep
          rep.system
          rep.data.records
          sawfish.wm.gaol
          sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.windows
          sawfish.wm.frames
          sawfish.wm.state.iconify
          sawfish.wm.state.shading
          sawfish.wm.commands.move-resize
          sawfish.wm.stacking
          sawfish.wm.util.groups
          sawfish.wm.commands.groups
          sawfish.wm.workspace)
  
  (define-structure-alias tabgroup sawfish.wm.tabs.tabgroup)
  
  (define current-win nil)
  (define all-wins nil)
  (define oldgroup nil)
  (define tab-groups nil)
  (define tab-refresh-lock t)

  (define (window-tabbed-p w)
    (window-get w 'tabbed))

  (define-record-type :tab-group
    (tab-build-group p d wl)
    tab-group?
    (p tab-group-position)
    (d tab-group-dimensions)
    (wl tab-group-window-list))

  (define (adjust-title w)
    (call-window-hook 'window-state-change-hook w (list '(title-position))))

  (define (tab-move-resize-frame-window-to win x y w h)
    "Move and resize according to *frame* dimensions."
    (let* ((dim1 (window-dimensions win))
           (dim2 (window-frame-dimensions win))
           (dw (- (car dim2) (car dim1)))
           (dh (- (cdr dim2) (cdr dim1))))
      (move-resize-window-to win x y (- w dw) (- h dh))))

  (define (tab-make-new-group win)
    "Return a new group containing only WIN."
    (let* ((pos (window-position win))
           (dim (window-frame-dimensions win))
           (group (tab-build-group pos dim (list win))))
      (setq tab-groups (append tab-groups (cons group nil)))
      group))

  (define (tab-find-window win)
    "Return the group containing win."
    (let loop ((gr tab-groups))
      (cond
       ((null gr)
        (tab-make-new-group win)
        )
       ((member win (tab-group-window-list (car gr)))
        (car gr))
       (t
        (loop (cdr gr))))))

  (define (tab-window-group-index win)
    "Return the index of the group containing win."
    (let loop ((index 0))
      (cond
       ((eq index (length tab-groups))
        (tab-make-new-group win)
        index)
       ((member win (tab-group-window-list (nth index tab-groups)))
        index)
       (t
        (loop (+ index 1))))))

  (define (tab-group-window-index win)
    "Return the windows of the group containing win."
    (let* ((index (tab-window-group-index win))
           (wins (tab-group-window-list (nth index tab-groups))))
      wins))

  (define (tab-rank elem list)
    (if (eq elem (car list))
        0
      (+ 1 (tab-rank elem (cdr list)))))
  
  (define (tab-delete-window-from-group win index)
    "Remove WIN from the group at given index."
    (let* ((old (nth index tab-groups))
           (l (remove win (tab-group-window-list old))))
      (if (null l)
          (setq tab-groups (delete old tab-groups))
        (rplaca (nthcdr index tab-groups)
                (tab-build-group (tab-group-position old) (tab-group-dimensions old) l))
        (window-put win 'tabbed nil)
        (if (not (cdr l))
            (window-put (car l) 'tabbed nil))
        (setq oldgroup (car l)))))

  (define (tab-delete-window-from-tab-groups w)
    "Find window's group and remove it."
    (when (window-tabbed-p w)
      (tab-delete-window-from-group w (tab-window-group-index w))
      (window-put w 'fixed-position nil)
      (tab-refresh-group oldgroup 'frame)
      (rebuild-frame w 'frame)))

  (define (tab-put-window-in-group win index)
    "Put window in group at given index."
    (let* ((group (nth index tab-groups)))
      (rplaca (nthcdr index tab-groups)
              (tab-build-group (tab-group-position group)
                               (tab-group-dimensions group)
                               (append (tab-group-window-list group) (list win))))))

  (define (tab-refresh-group win prop)
    "Refresh the entire group containing WIN according to PROP.
PROP can be one of the symbols: raise, frame, reframe, reframe-all, style, move,
resize, title-position, type, depth, shade, unshade, iconify, uniconify, maximized,
sticky, unsticky, fixed-position."
    (when tab-refresh-lock
      (setq tab-refresh-lock nil)
      (unwind-protect
          (let* ((index (tab-window-group-index win))
                 (wins (tab-group-window-list (nth index tab-groups)))
                 (focus (tab-group-offset win 0))
                 (unfocus (remove focus wins)))
            (adjust-title win)
            (cond
             ((eq prop 'raise)
              (raise-windows focus wins))
             ((eq prop 'title-position)
              (let ((group-title-position (window-get win 'title-position)))
                (mapcar (lambda (w)
                          (window-put w 'title-position group-title-position)) unfocus)
               (window-put focus 'title-position group-title-position)))
             ((eq prop 'frame)
              (mapcar (lambda (w)
                        (rebuild-frame w)) unfocus)
              (rebuild-frame focus))
             ((eq prop 'reframe)
              (mapcar (lambda (w)
                        (reframe-window w)) unfocus))
             ((eq prop 'reframe-all)
              (mapcar (lambda (w)
                        (reframe-window w)) unfocus)
              (reframe-window focus))
             ((or (eq prop 'move) (eq prop 'resize))
              (let ((dim (window-frame-dimensions win))
                    (pos (window-position win)))
                (mapcar (lambda (w)
                          (tab-move-resize-frame-window-to w (car pos) (cdr pos) (car dim) (cdr dim))) unfocus)))
             ((eq prop 'style)
              (let ((group-frame-style (window-get win 'frame-style))
                    (dim (window-frame-dimensions win))
                    (pos (window-position win)))
                (mapcar (lambda (w)
                          (set-frame-style w group-frame-style)
                          (tab-move-resize-frame-window-to w (car pos) (cdr pos) (car dim) (cdr dim))) unfocus)))
             ((eq prop 'fixed-position)
              (let ((group-frame-fixed-position (window-get win 'fixed-position)))
                (mapcar (lambda (w)
                          (window-put w 'fixed-position group-frame-fixed-position)) unfocus)))
             ((eq prop 'type)
              (let ((group-frame-type (window-get win 'type)))
                (mapcar (lambda (w)
                          (window-put w 'type group-frame-type)) unfocus)))
             ((eq prop 'depth)
              (let ((group-frame-depth (window-get win 'depth)))
                (mapcar (lambda (w)
                          (window-put w 'depth group-frame-depth)) unfocus)
                (raise-window win)
                (set-input-focus win)))
             ((eq prop 'iconify)
              (mapcar (lambda (w)
                        (iconify-window w)) unfocus))
             ((eq prop 'uniconify)
              (mapcar (lambda (w)
                        (uniconify-window w)) unfocus))
             ((eq prop 'maximized)
              (let ((dim (window-frame-dimensions win))
                    (pos (window-position win))
                    (group-frame-maximized-vertically (window-get win 'maximized-vertically))
                    (group-frame-maximized-horizontally (window-get win 'maximized-horizontally))
                    (group-frame-maximized-fullscreen (window-get win 'maximized-fullscreen))
                    (group-frame-unmaximized-type (window-get win 'unmaximized-type))
                    (group-frame-unmaximized-geometry (window-get win 'unmaximized-geometry)))
                (mapcar (lambda (w)
                          (window-put w 'maximized-vertically group-frame-maximized-vertically)
                          (window-put w 'maximized-horizontally group-frame-maximized-horizontally)
                          (window-put w 'maximized-fullscreen group-frame-maximized-fullscreen)
                          (window-put w 'unmaximized-type group-frame-unmaximized-type)
                          (window-put w 'unmaximized-geometry group-frame-unmaximized-geometry)
                          (tab-move-resize-frame-window-to w (car pos) (cdr pos) (car dim) (cdr dim))) unfocus)))
             ((eq prop 'sticky)
              (mapcar (lambda (w)
                        (make-window-sticky w)) unfocus))
             ((eq prop 'unsticky)
              (mapcar (lambda (w)
                        (make-window-unsticky w)) unfocus))
             ((eq prop 'shade)
              (mapcar (lambda (w)
                        (shade-window w)) unfocus)) 
             ((eq prop 'unshade)
              (mapcar (lambda (w)
                        (unshade-window w)) unfocus))))
        (setq tab-refresh-lock t))))

  ;; Entry points
  (define (tab-group-window w win)
    "Add window W to tabgroup containing WIN."
    ;; don't add a window as tab, if it already
    ;; exists on another workspace
    (when (not (cdr (window-get win 'workspaces)))
      (let* ((index (tab-window-group-index win))
             (index2 (tab-window-group-index w))
             (pos (window-position win))
             (dim (window-dimensions win))
             ;; adopt window settings for the new tab
             (group-frame-style (window-get win 'frame-style))
             (group-frame-type (window-get win 'type))
             (group-frame-focus-mode (window-get win 'focus-mode))
             (group-frame-gravity (window-get win 'gravity))
             (group-frame-sticky (window-get win 'sticky))
             (group-frame-sticky-viewport (window-get win 'sticky-viewport))
             (group-frame-never-iconify (window-get win 'never-iconify))
             (group-frame-fixed-position (window-get win 'fixed-position))
             (group-frame-title-position (window-get win 'title-position))
             (group-frame-depth (window-get win 'depth))
             (group-frame-never-maximize (window-get win 'never-maximize))
             (group-frame-maximized-vertically (window-get win 'maximized-vertically))
             (group-frame-maximized-horizontally (window-get win 'maximized-horizontally))
             (group-frame-maximized-fullscreen (window-get win 'maximized-fullscreen))
             (group-frame-unmaximized-type (window-get win 'unmaximized-type))
             (group-frame-unmaximized-geometry (window-get win 'unmaximized-geometry)))
        (when (not (eq index index2))
          ;; tabgroup to tabgroup
          (when (window-tabbed-p w)
            (tab-delete-window-from-tab-groups w))
          (setq tab-refresh-lock nil)
          (if (window-get w 'shaded) (unshade-window w))
          (if (window-get win 'shaded) (unshade-window win))
          (window-put w 'frame-style group-frame-style)
          (window-put w 'type group-frame-type)
          (window-put w 'focus-mode group-frame-focus-mode)
          (window-put w 'gravity group-frame-gravity)
          (window-put w 'title-position group-frame-title-position)
          (window-put w 'sticky group-frame-sticky)
          (window-put w 'sticky-viewport group-frame-sticky-viewport)
          (window-put w 'never-iconify group-frame-never-iconify)
          (window-put w 'depth group-frame-depth)
          (window-put w 'fixed-position group-frame-fixed-position)
          (window-put w 'never-maximize group-frame-never-maximize)
          (window-put w 'maximized-vertically group-frame-maximized-vertically)
          (window-put w 'maximized-horizontally group-frame-maximized-horizontally)
          (window-put w 'maximized-fullscreen group-frame-maximized-fullscreen)
          (window-put w 'unmaximized-type group-frame-unmaximized-type)
          (window-put w 'unmaximized-geometry group-frame-unmaximized-geometry)
          ;; reframe w here, tab-refresh-group expectet
          ;; the same frame for w and win
          (reframe-window w)
          (tab-put-window-in-group w index)
          (tab-delete-window-from-group w index2)
          (resize-window-to w (car dim) (cdr dim))
          (move-window-to w (car pos) (cdr pos))
          (setq tab-refresh-lock t)
          (tab-refresh-group w 'frame)
          (set-input-focus w)
          (if (not (window-tabbed-p win)) (window-put win 'tabbed t))
          (window-put w 'tabbed t)))))
  
  (define (tab-release-window w)
    "Release the window from its group."
    (tab-delete-window-from-tab-groups w)
    (tab-make-new-group w))
  
  (define-command 'tab-release-window tab-release-window #:spec "%f")
  
  (define (tab-group-offset win n)
    "Return the window at position (pos+n) in window's group."
    (let* ((gr (tab-group-window-list (tab-find-window win)))
           (size (length gr))
           (r (tab-rank win gr)))
      (nth (modulo (+ r n) size) gr)))
  
  (define (tab-same-group-p w1 w2)
    "Predicate : true <=> w1 and w2 are grouped together."
    (member w1 (tab-group-window-list (tab-find-window w2))))

  (define (tab-raise-left-window)
    "Raise left window in current tab group."
    (let ((win (tab-group-offset (input-focus) -1)))
      (raise-window win)
      (set-input-focus win)))

  (define-command 'tab-raise-left-window tab-raise-left-window)

  (define (tab-raise-right-window)
    "Raise right window in current tab group."
    (let ((win (tab-group-offset (input-focus) 1)))
      (raise-window win)
      (set-input-focus win)))

  (define-command 'tab-raise-right-window tab-raise-right-window)

  (define (map-other-grouped-windows win func)
    ""
    (mapcar func
            (delete-if
             (lambda (w) (eq w win))
             (tab-group-window-list (tab-find-window win)))) )

  (define (tab-group-raise win)
    (if (window-tabbed-p win)
        (tab-refresh-group win 'raise)))

  (define (tab-group-sticky win)
    (if (window-get win 'sticky)
        (tab-refresh-group win 'sticky)
      (tab-refresh-group win 'unsticky)))

  (define (before-move-resize win)
    "Releas win from the tabgroup and iconify the rest from the group."
    (when (not (window-get win 'fixed-position))
      (when (eq all-wins nil)
        (let* ((index (tab-window-group-index win))
               (wins (tab-group-window-list (nth index tab-groups)))
               (tabs (remove win (tab-group-window-list (nth index tab-groups))))
               (default-window-animator 'none))
          (tab-delete-window-from-group win index)
          (rebuild-frame win)
          (setq tab-refresh-lock nil)
          (mapcar (lambda (w)
                    (when (window-get w 'never-iconify)
                      (window-put w 'never-iconify nil)
                      (window-put w 'never-iconify-opaque t))
                    (iconify-window w)) tabs)
          (setq all-wins wins)
          (setq current-win win))
        (setq tab-refresh-lock t))))

  (define (after-move-resize win)
    "Add all tabs to the tabgroup from win. (Releas and iconify by before-move-resize)"
    (setq tab-refresh-lock nil)
    (let* ((wins all-wins)
	   (default-window-animator 'none)
           (pos (window-position win))
           (dim (window-dimensions win))
           index index-old)
      (when (and (cdr wins)
                 (eq win current-win))
        (setq index (tab-window-group-index (car wins)))
        (mapcar (lambda (w)
                  (when (not (eq index (tab-window-group-index w)))
                    (setq index-old (tab-window-group-index w))
                    (tab-put-window-in-group w index)
                    (tab-delete-window-from-group w index-old))
                  (move-window-to w (car pos) (cdr pos))
                  (resize-window-to w (car dim) (cdr dim))
                  (uniconify-window w)
                  (when (window-get w 'never-iconify-opaque)
                    (window-put w 'never-iconify-opaque nil)
                    (window-put w 'never-iconify t))
                  (window-put w 'tabbed t)) wins)
        (raise-window win)
        (setq all-wins nil)
        (setq current-win nil))
      (setq tab-refresh-lock t)
      (when (window-tabbed-p win) 
        (tab-refresh-group win 'move)
        (tab-refresh-group win 'frame))))

  (unless batch-mode
    (add-hook 'window-state-change-hook
              (lambda (win args)
                (when (window-tabbed-p win)
                  (setq args (car args))
                  (cond ((eq 'sticky args)
                         (tab-group-sticky win)
                         (tab-refresh-group win 'frame))
                        ((eq 'fixed-position args)
                         (tab-refresh-group win 'fixed-position)
                         (tab-refresh-group win 'frame))
                        ((eq 'frame-style args)
                         (tab-refresh-group win 'style)
                         (tab-refresh-group win 'reframe-all)
                         (tab-refresh-group win 'move))
                        ((eq 'type args)
                         (tab-refresh-group win 'type)
                         (tab-refresh-group win 'reframe))
                        ((eq 'stacking args)
                         (tab-refresh-group win 'depth)
                         (tab-refresh-group win 'frame))))))
    
    (add-hook 'focus-in-hook (lambda (win) (tab-group-raise win)))
    (when (eq move-outline-mode 'opaque)
      (add-hook 'before-move-hook (lambda (win) (if (window-tabbed-p win) (before-move-resize win)))))
    (add-hook 'after-move-hook  (lambda (win) (after-move-resize win)))
    (when (eq resize-outline-mode 'opaque)
      (add-hook 'before-resize-hook (lambda (win) (if (window-tabbed-p win) (before-move-resize win)))))
    (add-hook 'after-resize-hook  (lambda (win) (after-move-resize win)))
    (add-hook 'shade-window-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'shade))))
    (add-hook 'unshade-window-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'unshade))))
    (add-hook 'iconify-window-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'iconify))))
    (add-hook 'uniconify-window-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'uniconify))))
    (add-hook 'window-maximized-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'maximized))))
    (add-hook 'window-unmaximized-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'maximized))))
    (add-hook 'add-to-workspace-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'frame))))
    (add-hook 'destroy-notify-hook tab-delete-window-from-tab-groups))

  (gaol-add tab-refresh-group tab-group-window-index)
  )

;; viewport-extras.jl -- extra viewport commands
;;
;; Contributed by: Dams Nadé <anvil@amin.unice.fr>

(define-structure sawfish.wm.commands.viewport-extras

    (export move-viewport-next
	    move-viewport-previous)

    (open rep
          sawfish.wm.viewport
          sawfish.wm.commands)

  ;; Returns (cons next-x next-y) from current screen-viewport
  (define (next-coords)
    (let* ((port (screen-viewport))
	   (x (car port))
	   (y (cdr port))
	   (xmax (- (car viewport-dimensions) 1))
	   (ymax (- (cdr viewport-dimensions) 1)))
      (cond ((not (= x xmax)) (cons (+ 1 x) y))
	    ((= y ymax) (cons 0 0))
	    (t (cons 0 (+ y 1))))))

  ;; Returns (cons prev-x prev-y) from current screen-viewport
  (define (previous-coords)
    (let* ((port (screen-viewport))
	   (x (car port))
	   (y (cdr port))
	   (xmax (- (car viewport-dimensions) 1))
	   (ymax (- (cdr viewport-dimensions) 1)))
      (cond ((not (= 0 x)) (cons (- x 1) y))
	    ((= y 0) (cons xmax ymax))
	    (t (cons xmax (- y 1))))))

  ;; Move window & screen-viewport
  (define (set-window-and-viewport w x y)
    (set-window-viewport w x y)
    (set-screen-viewport x y))

  (define (move-viewport-next)
    "Move to the next viewport."
    (let ((nextcoords (next-coords)))
      (set-screen-viewport (car nextcoords) (cdr nextcoords))))

  (define (move-viewport-previous)
    "Move to the previous viewport."
    (let ((prevcoords (previous-coords)))
      (set-screen-viewport (car prevcoords) (cdr prevcoords))))

  (define (move-window-next w)
    "Move the window to the next viewport."
    (let ((nexts (next-coords)))
      (set-window-and-viewport w (car nexts) (cdr nexts))))

  (define (move-window-previous w)
    "Move the window to the previous viewport."
    (let ((prevs (previous-coords)))
      (set-window-and-viewport w (car prevs) (cdr prevs))))

  ;;###autoload
  (define-command 'move-viewport-next
    move-viewport-next)
  (define-command 'move-viewport-previous
    move-viewport-previous)
  (define-command 'move-window-previous
    move-window-previous #:spec "%W")
  (define-command 'move-window-next
    move-window-next #:spec "%W"))

;; hot-spots.jl -- Invoke lisp functions when hitting the screen-edge

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.hot-spots

    (export hot-spot-invoke
            hot-move-invoke)

    (open rep
	  rep.system
	  sawfish.wm.custom
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.workspace)

  (define-structure-alias hot-spots sawfish.wm.edge.hot-spots)

  (defvar left-edge-function nil
    "The function launched when hitting the left-edge.")

  (defvar top-left-corner-function nil
    "The function launched when hitting the top-left-corner.")

  (defvar top-edge-function nil
    "The function launched when hitting the top-edge.")

  (defvar top-right-corner-function nil
    "The function launched when hitting the top-right-corner.")

  (defvar right-edge-function nil
    "The function launched when hitting the right-edge.")

  (defvar bottom-right-corner-function nil
    "The function launched when hitting the bottom-right-corner.")

  (defvar bottom-edge-function nil
    "The function launched when hitting the bottom-edge.")

  (defvar bottom-left-corner-function nil
    "The function launched when hitting the bottom-left-corner.")

  (define (hot-spot-invoke spot)
      (let ((func (case spot
                    ((top-left)
                     top-left-corner-function)
                    ((top-right)
                     top-right-corner-function)
                    ((bottom-right)
                     bottom-right-corner-function)
                    ((bottom-left)
                     bottom-left-corner-function)
                    ((left)
                     left-edge-function)
                    ((top)
                     top-edge-function)
                    ((right)
                     right-edge-function)
                    ((bottom)
                     bottom-edge-function))))
        (if (functionp func)
            (progn
              (call-hook 'before-edge-action-hook (list 'hot-spot spot nil))
              (funcall func)
              (call-hook 'after-edge-action-hook (list 'hot-spot spot nil)))
          (when func
            ;; non-nil, but not a function?
            (error "In hot-spot, your configuration of spot `%s' is wrong; it should be a function." spot)))))

  (defvar left-edge-move-function nil
    "The function launched when hitting the left-edge.")

  (defvar top-edge-move-function nil
    "The function launched when hitting the top-edge.")

  (defvar right-edge-move-function nil
    "The function launched when hitting the right-edge.")

  (defvar bottom-edge-move-function nil
    "The function launched when hitting the bottom-edge.")

  (define (hot-move-invoke spot)
      (let ((func (case spot
                    ((left)
                     left-edge-move-function)
                    ((top)
                     top-edge-move-function)
                    ((right)
                     right-edge-move-function)
                    ((bottom)
                     bottom-edge-move-function)))
            (win (input-focus)))
        (if (functionp func)
            (progn
	      (call-hook 'before-edge-action-hook (list 'hot-move spot t))
	      (allow-events 'async-both)
	      (fake-release-window)
	      (funcall func win)
	      (call-hook 'after-edge-action-hook (list 'hot-move spot t)))
          (when func
            ;; non-nil, but not a function?
            (error "In hot-move, your configuration of spot `%s' is wrong; it should be a function." spot))))))

;; x-cycle.jl -- stack-based window cycling

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Commentary:

;; Cycles through windows in MRU order. Whichever key is used to invoke
;; `cycle-windows' will continue to the next window on the stack when
;; pressed again. Releasing the initial modifier ends the cycling and
;; selects the current window

;; Thanks to Kuba Winnicki <blackwine@optimus.wroc.pl> for the idea:

;; [ assumes command invoked by MOD-KEY, i.e. M-TAB by default ]

;; MOD held;

;; * window 1            window 1            window 1          * window 3
;;   window 2    ==>   * window 2    ==>     window 2    ==>     window 1
;;   window 3    KEY     window 3    KEY   * window 3  release   window 2
;;   window 4            window 4            window 4    MOD     window 4

;; If cycle-raise-windows is enabled, focused window is brought to
;; front, but gets back to original placement in order when it's
;; defocused.

;; Also it'd be nice to be able to cycle through hidden windows as
;; well, like here:

;; MOD held;

;; * window 1            window 1            window 1          * window 3
;;  [window 2]   ==>   * window 2    ==>    [window 2]   ==>     window 1
;;  [window 3]   KEY    [window 3]   KEY   * window 3  release  [window 2]
;;   window 4            window 4            window 4    MOD     window 4

;; Each window may have an x-cycle-order property, an integer id
;; defining its position in the window stack, higher numbers equal
;; more recently selected. The ids may not be contiguous

;; Obviously there would be a problem when we overflow rep's integers, but
;; every now and then we compress the stack to make the ids contiguous

;; It might seem as though it should be possible to use the actual
;; window stacking to define MRU order. But since there are multiple
;; layers of windows this wouldn't work (selected windows may not reach
;; the top of the stack)

(define-structure sawfish.wm.commands.x-cycle

    (export define-cycle-command
	    define-cycle-command-pair)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.util.window-order
	  sawfish.wm.util.keymap
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.focus
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.util.stacking
	  sawfish.wm.events
	  sawfish.wm.util.decode-events
	  sawfish.wm.util.groups
	  sawfish.wm.util.rects
	  sawfish.wm.util.display-window)

  (define-structure-alias x-cycle sawfish.wm.commands.x-cycle)

  ;; we bind to disable-auto-raise and tooltips-enabled
  (eval-when-compile (require 'sawfish.wm.ext.auto-raise))
  (eval-when-compile (require 'sawfish.wm.ext.tooltips))

;;; customization options

  ;;###autoload (defgroup cycle "Window Cycling" :group focus :require sawfish.wm.commands.x-cycle)
  (defgroup cycle "Window Cycling"
    :group focus
    :require sawfish.wm.commands.x-cycle)

  (defcustom cycle-show-window-names t
    "Display window names and icons while cycling through windows."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-include-iconified t
    "Include iconified windows when cycling."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-all-workspaces nil
    "Include windows on all workspaces when cycling."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-all-viewports nil
    "Include windows on all viewports when cycling."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-raise-windows t
    "Raise windows while they're temporarily selected during cycling."
    :type boolean
    :group (focus cycle))

  (defcustom cycle-keymap (make-keymap)
    "Keymap containing bindings active only during window cycling operations."
    :group bindings
    :type keymap)

  (defvar after-cycle-step-hook '()
    "Window hook called after each step of window cycling.")

  ;; variables

  ;; the current window
  (define x-cycle-current (make-fluid))

  ;; the original stacking order
  (define x-cycle-stacking (make-fluid))

  ;; the list of windows being cycled through
  (define x-cycle-windows (make-fluid))

  ;; is this call during a cycle operation
  (define x-cycle-active (make-fluid))

  ;; list of all cycle command names
  (define cycle-commands '())

;;; code

  (define (forwards lst elt count)
    (let ((total (length lst))
	  (current (let loop ((rest lst) (i 0))
                        (cond ((null rest) 0)
                              ((eq (car rest) elt) i)
                              (t (loop (cdr rest) (1+ i)))))))
      (nth (mod (+ current count) total) lst)))

  (define (cycle-display-message)
    (require 'sawfish.wm.util.display-wininfo)
    (display-wininfo (fluid x-cycle-current)))

  (define (remove-message)
    (require 'sawfish.wm.util.display-wininfo)
    (display-wininfo nil))

  (define (cycle-next windows count)
    (fluid-set x-cycle-windows windows)
    (let ((win (window-order (if cycle-all-workspaces
                                 nil
                               current-workspace)
                             cycle-include-iconified cycle-all-viewports)))
      (setq win (delete-if (lambda (w)
                             (not (memq w windows))) win))
      (unless win
        (throw 'x-cycle-exit t))
      (if (fluid x-cycle-current)
          (when (or (window-get (fluid x-cycle-current) 'iconified)
                    (not (window-appears-in-workspace-p
                          (fluid x-cycle-current) current-workspace)))
            (hide-window (fluid x-cycle-current)))
        ;; first call, push the currently focused window onto
        ;; the top of the stack
        (when (input-focus)
          (fluid-set x-cycle-current (input-focus))
          (window-order-push (fluid x-cycle-current))
          (setq win (cons (fluid x-cycle-current)
                          (delq (fluid x-cycle-current) win)))))
      (when (fluid x-cycle-stacking)
        (restack-windows (fluid x-cycle-stacking))
        (fluid-set x-cycle-stacking nil))
      (if (fluid x-cycle-current)
          (setq win (forwards win (fluid x-cycle-current) count))
        (setq win (car win)))
      (fluid-set x-cycle-current win)
      (when (not (window-get win 'sticky))
        (select-workspace (nearest-workspace-with-window
                           win current-workspace)))
      (move-viewport-to-window win)
      (when (window-get win 'iconified)
        (show-window win))
      (when cycle-raise-windows
        (fluid-set x-cycle-stacking (stacking-order))
        (raise-window* win)
	(warp-pointer-if-necessary win))
      (when cycle-show-window-names
        (cycle-display-message))
      (when (window-really-wants-input-p win)
        (set-input-focus win))
      (allow-events 'sync-keyboard)
      (call-window-hook 'after-cycle-step-hook win)))

  (define (cycle-begin windows step)
    "Cycle through all windows in order of recent selections."
    (let ((tail-command nil)
	  (grab-win (input-focus)))
      (let-fluids ((x-cycle-current nil)
		   (x-cycle-stacking nil)
		   (x-cycle-windows windows)
		   (x-cycle-active t))

        (define (unmap-fun w)
          (when (eq w grab-win)
            (setq grab-win nil)
            (or (grab-keyboard nil nil t)
                (throw 'x-cycle-exit nil))
            (allow-events 'sync-keyboard)))

        (define (enter-fun space)
          (declare (unused space))
          (when grab-win
            (setq grab-win nil)
            (or (grab-keyboard nil nil t)
                (throw 'x-cycle-exit nil))
            (allow-events 'sync-keyboard)))

        (define (unbound-fun)
          (let* ((event (current-event))
                 (ev (decode-event event)))
            (cond
             ((memq 'release (nth 1 ev)) ; key released
              (when (and (modifier-keysym-p (nth 2 ev)) ; modifier released
                         (eq 2 (length (nth 1 ev))))    ; 'release + 1 modifier
                (throw 'x-cycle-exit t)))
             ((not (modifier-keysym-p (nth 2 ev)))
              ;; real key pressed
              (let* ((override-keymap cycle-keymap)
                     (command (lookup-event-binding event)))
                (unless command
                  ;; search cycle-keymap then the usual ones
                  (setq override-keymap nil)
                  (setq command (lookup-event-binding event)))
                (if (memq command cycle-commands)
                    ;; call without aborting cycle operation
                    (progn
                      (current-event-window (fluid x-cycle-current))
                      (call-command command))
                  (unless (setq tail-command command)
                    ;; no wm binding, so forward the event to
                    ;; the focused window (this is why we have
                    ;; to grab the keyboard synchronously)
                    (allow-events 'replay-keyboard))
                  (throw 'x-cycle-exit nil)))))))

        (let* ((decoded (decode-event (current-event)))
               (eval-modifier-events t)
               (eval-key-release-events t)
               (override-keymap (make-keymap))
               (focus-dont-push t)
               (disable-auto-raise t)
               (tooltips-enabled nil)
               (unmap-notify-hook (cons unmap-fun unmap-notify-hook))
               (enter-workspace-hook (cons enter-fun enter-workspace-hook))
               (unbound-key-hook (list unbound-fun)))

          (unless (and (eq 'key (car decoded)) (nth 1 decoded))
            (error "%s must be bound to a key event with modifiers."
                   this-command))

          ;; grab synchronously, so that event replaying works
          (when (grab-keyboard grab-win nil t)
            (unwind-protect
                (progn
                  (catch 'x-cycle-exit
                    ;; do the first step
                    (cycle-next windows step)
                    (setq focus-ignore-pointer-events t)
                    (recursive-edit))
                  (when (fluid x-cycle-current)
                    (display-window (fluid x-cycle-current))))
              (remove-message)
              (ungrab-keyboard)
              (make-timer (lambda ()
                            (setq focus-ignore-pointer-events nil))
                          0 100)))))

      (when tail-command
	;; make sure that the command operates on the newly-focused
	;; window, not the window that was focused when the original
	;; event was received
	(current-event-window (input-focus))
	(call-command tail-command))))

  (define (define-cycle-command name body . rest)
    "Create a command that will not cause the current cycle operation
to abort before execution.

All arguments are passed to define-command."
    (unless (memq name cycle-commands)
      (setq cycle-commands (cons name cycle-commands)))
    (apply define-command name body rest))

  (define (define-cycle-command-pair forward-name reverse-name selector . rest)
    "Create a pair of commands for cycling through windows. The command named
FORWARD-NAME cycles forwards, while the command named REVERSE-NAME cycles
backwards.

SELECTOR is called when initializing the cycle environment, it should
return the list of windows to cycle through, or the symbol `t' to
denote all cyclable windows.

Any extra arguments are passed to each call to define-command."
    (define (command-body step)
      (lambda args
	(let ((windows (apply selector args)))
	  (when windows
	    (if (fluid x-cycle-active)
		(cycle-next windows step)
	      (cycle-begin windows step))))))
    (when forward-name
      (apply define-cycle-command forward-name (command-body +1) rest))
    (when reverse-name
      (apply define-cycle-command reverse-name (command-body -1) rest)))

;;; commands

  (define-cycle-command-pair
    'cycle-windows 'cycle-windows-backwards
    (lambda () (filter-windows window-in-cycle-p)))

  (define-cycle-command-pair
    'cycle-group 'cycle-group-backwards
    (lambda (w)
      (delete-if-not window-in-cycle-p (windows-in-group w)))
    #:spec "%W")

  (define-cycle-command-pair
    'cycle-among-groups 'cycle-among-groups-backwards
    (lambda ()
      "Only cycle the top members of each group."
      (let loop
	  ((wl (window-order
		(if cycle-all-workspaces
		    nil
		  current-workspace)
		cycle-include-iconified cycle-all-viewports))
	   grps
	   retval)
	(when (and (window-in-cycle-p (car wl))
		   (not (memq (window-group-id (car wl)) grps)))
	  (when (window-group-id (car wl))
	    ;; Some windows don't have group.
	    (setq grps (cons (window-group-id (car wl)) grps)))
	  (setq retval (cons (car wl) retval)))
	(if (cdr wl)
	    (loop (cdr wl) grps retval)
	  (nreverse retval)
	  ))))

  (define-cycle-command-pair
    'cycle-prefix 'cycle-prefix-backwards
    (lambda (w)
      (when (string-match "^([^:]+)\\s*:" (window-name w))
        (let* ((prefix (expand-last-match "\\1"))
               (re (concat ?^ (quote-regexp prefix) "\\s*:")))
          (delete-if-not window-in-cycle-p
                         (filter-windows
                          (lambda (x)
                            (string-match re (window-name x))))))))
    #:spec "%W")

  (define-cycle-command-pair
    'cycle-class 'cycle-class-backwards
    (lambda (w)
      (let ((class (window-class w)))
        (delete-if-not window-in-cycle-p
                       (filter-windows
                        (lambda (x) (equal (window-class x) class))
                        (window-order)))))
    #:spec "%W")

  (define-cycle-command-pair
    'cycle-step 'cycle-step-backwards
    (lambda ()
      (if (fluid x-cycle-active)
          (fluid x-cycle-windows)
        (error "%s must be bound to a key event in the cycle keymap."
               this-command))))

  (define-cycle-command-pair
    'cycle-dock 'cycle-dock-backwards
    (lambda ()
      (delete-if-not (lambda (x) (window-in-cycle-p x #:ignore-cycle-skip t))
                     (filter-windows dock-window-p)))))

#| autoload cookies:

###autoload (autoload-command 'cycle-windows 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-windows-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-group 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-group-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-among-groups 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-among-groups-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-prefix 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-prefix-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-class 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-class-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-dock 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-dock-backwards 'sawfish.wm.commands.x-cycle)

|#

#| doc strings for the cycle commands:

::doc:sawfish.wm.commands.x-cycle#cycle-windows::
Cycle through all windows in order of recent selections.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-windows-backwards::
Cycle through all windows in reverse order of recent selections.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-group::
Cycle through all windows in the same group as the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-group-backwards::
Reverse cycle through all windows in the same group as the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-among-groups::
Cycle through different groups (only the top window of each group).
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-among-groups-backwards::
Reverse cycle through different groups (only the top window of each group).
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-prefix::
Cycle through all windows whose names match the leading colon-delimited
prefix of the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-prefix-backwards::
Reverse cycle through all windows whose names match the leading
colon-delimited prefix of the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-class::
Cycle through all windows with the same class as the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-class-backwards::
Reverse cycle through all windows with the same class as the current
window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-step::
Step one window forwards through the current window cycle list.
This command should only be used in the cycle keymap.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-step-backwards::
Step one window backwards through the current window cycle list.
This command should only be used in the cycle keymap.
::end::

|#

;; modes.jl -- Define animators.

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.animation.modes

    (export draw-window-outline
	    erase-window-outline
	    define-window-outliner
	    autoload-window-outliner)

    (open rep
	  rep.util.autoloader
	  sawfish.wm.misc)

  ;; For backward compatibility.
  (define-structure-alias window-outline sawfish.wm.animation.modes)

;;; mechanics

  (define (getter symbol) (get symbol 'window-outline))
  (define (setter symbol value) (put symbol 'window-outline value))

  (define define-window-outliner setter)
  (define autoload-window-outliner (make-autoloader getter setter))
  (define window-outliner (autoloader-ref getter))

;;; entry points

  (define (draw-window-outline mode x y width height)
    "Draw an outline of a window of dimensions (WIDTH, HEIGHT) at
position (X, Y) relative to the root window.

MODE is a symbol defining the type of outline drawn, currently it may
only be `box' for a 3x3 grid.

Use the `erase-window-outline' to erase the grid. Also note that since
these functions draw directly on the root window the server should be
grabbed until the outline is erased."

    (let ((fun (window-outliner mode)))
      (when fun
	(fun x y width height))))

  (defun erase-window-outline (mode x y width height)
    "Erase a previously drawn outline of a window of dimensions (WIDTH,
HEIGHT) at position (X, Y) relative to the root window. See
`draw-window-outline'. MODE is a symbol defining the type of outline
drawn, currently it may only be `box' for a 3x3 grid."

    (draw-window-outline mode x y width height))

;;; default outline types

  (define (draw-box-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let ((gc (x-create-root-xor-gc))
	  (x-step (/ width 3))
	  (y-step (/ height 3)))
      (do ((i 0 (1+ i)))
	  ((= i 4))
	(x-draw-line 'root gc
		     (cons x (inexact->exact (round (+ y (* y-step i)))))
		     (cons (+ x width) (inexact->exact
					(round (+ y (* y-step i))))))
	(x-draw-line 'root gc
		     (cons (inexact->exact (round (+ x (* x-step i)))) y)
		     (cons (inexact->exact
			    (round (+ x (* x-step i)))) (+ y height))))
      (x-destroy-gc gc)))

  (define-window-outliner 'box draw-box-outline)

  ;; this is quite flickery.. double buffering doesn't work either..
  (define (draw-solid-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let ((gc (x-create-root-xor-gc)))
      (x-fill-rectangle 'root gc (cons x y) (cons width height))
      (x-destroy-gc gc)))

  (define-window-outliner 'solid draw-solid-outline)

  (define (draw-cross-outline x y width height)
    (require 'sawfish.wm.util.x)
      (let
        ((gc (x-create-root-xor-gc))
         (ul (cons x y))                      ; upper left
         (ur (cons (+ x width) y))            ; upper right
         (ll (cons x (+ y height)))           ; lower left
         (lr (cons (+ x width) (+ y height))) ; lower right
        )
      ; perimeter outline
      (x-draw-line 'root gc ul ur)
      (x-draw-line 'root gc ll lr)
      (x-draw-line 'root gc ul ll)
      (x-draw-line 'root gc ur lr)
      ; cross
      (x-draw-line 'root gc ul lr)
      (x-draw-line 'root gc ur ll)
      (x-destroy-gc gc)))

  (define-window-outliner 'cross draw-cross-outline)

  (define (draw-elliptical-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let
      ((gc (x-create-root-xor-gc))
       (height-prime (inexact->exact (floor (* height 1.4142))))
       (width-prime  (inexact->exact (floor (* width 1.4142))))
      )
    ; draw the circumscribed ellipse (the outside one)
    (x-draw-arc 'root gc (cons (inexact->exact (- x (floor (/ width 4.8))))
			       (inexact->exact (- y (floor (/ height 4.8)))))
		(cons width-prime height-prime)
		(cons 0 (* 360 64)))
    ; draw the inscribed ellipse (the inside one)
    (x-draw-arc 'root gc (cons x y)
		(cons width height)
		(cons 0 (* 360 64)))
    (x-destroy-gc gc)))

  (define-window-outliner 'elliptical draw-elliptical-outline)

  (define (draw-draft-line rw gc pta ptb dim-p arrow-p)
    (require 'sawfish.wm.util.x)
    (let ((pta-x (car pta)) ; recover the components
	(pta-y (cdr pta))
	(ptb-x (car ptb))
	(ptb-y (cdr ptb))
	(delta-x (- (car ptb) (car pta))) ; figure out the difference
	(delta-y (- (cdr ptb) (cdr pta)))
	(xah 4)  ; cope with different window scales
	(yah 3)  ; to ensure arrow heads look the same
	(x-dim-offset 5) ; how far to offset the dimension from the
	(y-dim-offset 5) ; draft line
	)
    ; first off, we know we are going to draw the line, always
    (x-draw-line rw gc pta ptb)
    ; now figure out if we drawing vertically or horizontally
    (if (= pta-x ptb-x)
	(progn ; vertical
	 (if dim-p
	     (x-draw-text rw gc (cons (+ pta-x x-dim-offset)
					(+ pta-y (quotient delta-y 2))
					)
			    (format nil "%d" delta-y)))
	 (if arrow-p
	     (progn
	       (x-draw-line rw gc pta (cons (+ pta-x xah) (+ pta-y yah)))
	       (x-draw-line rw gc pta (cons (- pta-x xah) (+ pta-y yah)))
	       (x-draw-line rw gc ptb (cons (+ ptb-x xah) (- ptb-y yah)))
	       (x-draw-line rw gc ptb (cons (- ptb-x xah) (- ptb-y yah)))
	      ))
	 )
	(progn ; horizontal
         (if dim-p
	   (x-draw-text rw gc (cons (+ pta-x (quotient delta-x 2))
				      (- pta-y y-dim-offset)
				      )
			    (format nil "%d" delta-x)))
         (if arrow-p
	     (progn
	       (x-draw-line rw gc pta (cons (+ pta-x xah) (+ pta-y yah)))
	       (x-draw-line rw gc pta (cons (+ pta-x xah) (- pta-y yah)))
	       (x-draw-line rw gc ptb (cons (- ptb-x xah) (+ ptb-y yah)))
	       (x-draw-line rw gc ptb (cons (- ptb-x xah) (- ptb-y yah)))
	       ))
        ))))

  (define (draw-draft-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let
      ((gc (x-create-root-xor-gc))
       ; window Upper (Left Middle Right)
       (ul (cons x y))
       (um (cons (+ x (quotient width 2)) y))
       (ur (cons (+ x width) y))

       ; window Middle (Left Right)
       (ml (cons x           (+ y (quotient height 2))))
       (mr (cons (+ x width) (+ y (quotient height 2))))

       ; window Lower (Left Middle Right)
       (ll (cons x (+ y height)))
       (lm (cons (+ x (quotient width 2)) (+ y height)))
       (lr (cons (+ x width) (+ y height)))

       ; window Screen (Left Right Top Bottom)
       (sl (cons 0              (+ y (quotient height 2))))
       (sr (cons (screen-width) (+ y (quotient height 2))))
       (st (cons (+ x (quotient width 2)) 0))
       (sb (cons (+ x (quotient width 2)) (screen-height)))

       (offset 3) ; how much to offset the guidelines from the window
       )
    ; perimeter outline of window + frame
    ; is there an x-draw-retangle ?
    (x-draw-line 'root gc ul ur)
    (x-draw-line 'root gc ll lr)
    (x-draw-line 'root gc ul ll)
    (x-draw-line 'root gc ur lr)
    ; from screen left to left border
    (x-draw-line 'root gc (cons 0 y)            (cons (- x offset) y))
    (x-draw-line 'root gc (cons 0 (+ y height))
		 (cons (- x offset) (+ y height)))
    (draw-draft-line 'root gc sl ml t t)
    ; from screen top to top border
    (x-draw-line 'root gc (cons x 0) (cons x (- y offset)))
    (x-draw-line 'root gc (cons (+ x width) 0) (cons (+ x width) (- y offset)))
    (draw-draft-line 'root gc st um t t)
    ; from screen right to right border
    (x-draw-line 'root gc (cons (screen-width) y)
		 (cons (+ x width offset) y))
    (x-draw-line 'root gc (cons (screen-width) (+ y height))
		 (cons (+ x width offset) (+ y height)))
    (draw-draft-line 'root gc mr sr t t)
    ; from screen bottom to bottom border
    (x-draw-line 'root gc (cons x (screen-height))
		 (cons x (+ y height offset)))
    (x-draw-line 'root gc (cons (+ x width) (screen-height))
		 (cons (+ x width) (+ y height offset)))
    (draw-draft-line 'root gc lm sb 't 't)
    (x-destroy-gc gc)))

  (define-window-outliner 'draft draw-draft-outline))

;; kde-int.jl -- KDE integration

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.kde

    (export detect-kde
	    kde-late-init
	    kde-window-matchers)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher
	  sawfish.wm.ext.apps-menu
          sawfish.wm.ext.match-window)

  (define-structure-alias kde-int sawfish.wm.integration.kde)

  (defvar kde-desktop-directories
    '("/usr/share/applications/kde4/")
    "KDE specific directories where *.desktop files are stored.")

  (define (kde-window-matchers)
    ;; window matchers so we properly interact with plasma stuff
    (add-window-matcher '((WM_CLASS . "^krunner/krunner$"))
     '((focus-mode . click)
       (never-tile . t)))
    (add-window-matcher '((WM_CLASS . "^Plasma-desktop/plasma-desktop$"))
     '((focus-mode . click)
       (never-tile . t)))
    (add-window-matcher '((WM_CLASS . "^Plasma/Plasma$"))
     '((focus-mode . click)
       (never-tile . t)))
    (add-window-matcher '((WM_CLASS . "^plasmashell/plasmashell$"))
     '((focus-mode . click)
       (never-tile . t))))

  (define (init)
    (let (menu
	  kde-logout-cmd)
      (setq desktop-environment "kde")
      (setq want-poweroff-menu nil)

      ;; invoke the KDE terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "konsole"))

      ;; use the KDE Browser
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "konqueror"))

      ;; use the KDE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "dolphin"))

      ;; add some KDE help menus
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_KDE Help") (system "khelpcenter &"))
		      (,(_ "KDE _Website") (browser "http://www.kde.org")))))

      ;; add kde-logout menu item
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(setq kde-logout-cmd "qdbus org.kde.ksmserver /KSMServer org.kde.KSMServerInterface.logout")
	(nconc menu `(()
		      (,(_ "_Customize KDE") (system "systemsettings &"))
		      (,(_ "_Edit KDE menu") (system "kmenuedit &"))
		      ()
		      (,(_ "L_ock screen from KDE")
			(system "qdbus org.kde.krunner /ScreenSaver Lock &"))
		      (,(_ "S_witch User from KDE")
			(system "qdbus org.kde.krunner /App switchUser &"))
		      ()
		      (,(_ "_Logout from KDE")
		       (system ,(concat kde-logout-cmd " 1 0 -1 &")))
		      (,(_ "_Reboot from KDE")
		       (system ,(concat kde-logout-cmd " 1 1 -1 &")))
		      (,(_ "_Shutdown from KDE")
		       (system ,(concat kde-logout-cmd " 1 2 -1 &")))
		      (,(_ "S_uspend from KDE")
			(system "qdbus org.kde.kded /org/freedesktop/PowerManagement Suspend &"))
		      (,(_ "_Hibernate from KDE")
			(system "qdbus org.kde.kded /org/freedesktop/PowerManagement Hibernate &")))))))

  ;; Returns nil if kde is not found.
  ;; If detected, returns t, and do also kde support init.
  (define (detect-kde)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "KDE")
	      (equal (getenv "XDG_SESSION_DESKTOP") "plasma")
              (equal (getenv "DESKTOP_SESSION") "sawfish-kde4")
              (equal (getenv "DESKTOP_SESSION") "sawfish-kde5")
	      (equal (getenv "KDE_FULL_SESSION") "true"))
      (init)
      t))

  ;; Should be called after user customization is read.
  (define (kde-late-init)
    (setq desktop-directory
	  (append desktop-directory kde-desktop-directories))
    (kde-window-matchers)))

;; make-theme.jl -- support for theme builder

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.theming.make-theme

    (export make-theme)

    (open rep
	  rep.regexp
	  sawfish.wm.images
	  sawfish.wm.colors
	  sawfish.wm.fonts
	  sawfish.wm.gaol)

  (define-structure-alias make-theme sawfish.wm.theming.make-theme)

  (define (make-frames patterns-alist frame-alist)
    (let ((image-cache '()))

      (define (make-image-possibly-from-cache file)
	(or (cdr (assoc file image-cache))
	    (let ((img (gaol-eval `(make-image ',file))))
	      (setq image-cache (cons (cons file img) image-cache))
	      img)))

      (define (make-pattern def)
	(mapcar (lambda (elt)
		  (let ((state (car elt))
			(value (cdr elt)))
		    (cond ((stringp value)
			   (setq value (get-color value)))
			  ((and (consp value) (stringp (car value)))
			   (let
			       ((img (make-image-possibly-from-cache
                                      (car value))))
			     (when img
			       (mapc (lambda (attr)
				       (cond
					((eq (car attr) 'tiled)
					 (image-put img 'tiled (cdr attr)))
					((eq (car attr) 'border)
					 (apply set-image-border
						img (cdr attr)))))
				     (cdr value)))
			     (setq value img))))
		    (cons state value))) def))

      (let ((loaded-patterns (mapcar (lambda (cell)
				       (cons (car cell)
					     (make-pattern (cdr cell))))
				     patterns-alist)))

	(define (make-frame-part def)
	  (mapcar (lambda (cell)
		    (cons (car cell)
			  (cond ((and (eq (car cell) 'text)
				      (symbolp (cdr cell)))
				 (gaol-eval (cdr cell)))
				((and (memq (car cell)
					    '(foreground background))
				      (stringp (cdr cell)))
				 (if (string-match "^#" (cdr cell))
				     ;; color
				     (get-color (cdr cell))
				   (cdr (assoc (cdr cell) loaded-patterns))))
				((and (eq (car cell) 'font)
				      (stringp (cdr cell)))
				 (get-font (cdr cell)))
				(t
				 (cdr cell))))) def))

	(mapcar (lambda (cell)
		  (cons (car cell) (mapcar make-frame-part (cdr cell))))
		frame-alist))))

  (define (make-theme patterns-alist frame-alist mapping-alist)
    (let ((real-frames (make-frames patterns-alist frame-alist)))
      (lambda (w type)
	(declare (unused w))
	(let ((frame-name (or (cdr (assq type mapping-alist)))))
	  (and frame-name (cdr (assoc frame-name real-frames)))))))

  (gaol-define 'make-theme make-theme))

;; edge/util.jl -- common utils for EdgeActions

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.util

    (export activate-flippers
	    get-active-corner
	    get-active-edge
	    move-window-to-corner
	    move-window-to-edge)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.edge.subrs)

  (define-structure-alias edge-util sawfish.wm.edge.util)

  (define (activate-flippers enable)
    (if enable
        (progn
	  (recreate-flippers)
	  (unless (in-hook-p 'after-restacking-hook raise-flippers)
	    (add-hook 'after-restacking-hook raise-flippers))
	  (unless (in-hook-p 'randr-change-notify-hook recreate-flippers)
	    (add-hook 'randr-change-notify-hook recreate-flippers)))
      (destroy-flippers)
      (remove-hook 'after-restacking-hook raise-flippers)
      (remove-hook 'randr-change-notify-hook recreate-flippers)))

  (define (get-active-corner)
    (let ((cursor-x (car (query-pointer)))
	  (cursor-y (cdr (query-pointer))))
      (cond ((or (and (< cursor-x hot-spots-corner-length)
		      (<= cursor-y 1))
		 (and (<= cursor-x 1)
		      (< cursor-y hot-spots-corner-length)))
	     'top-left)

	    ((or (and (> cursor-x (- (screen-width) hot-spots-corner-length))
		      (<= cursor-y 1))
		 (and (>= cursor-x (- (screen-width) 1))
		      (< cursor-y hot-spots-corner-length)))
	     'top-right)

	    ((or (and (> cursor-x (- (screen-width) hot-spots-corner-length))
		      (>= cursor-y (- (screen-height) 1)))
		 (and (>= cursor-x (- (screen-width) 1))
		      (> cursor-y (- (screen-height) hot-spots-corner-length))))
	     'bottom-right)

	    ((or (and (< cursor-x hot-spots-corner-length)
		      (>= cursor-y (- (screen-height) 1)))
		 (and (<= cursor-x 1)
		      (> cursor-y (- (screen-height) hot-spots-corner-length))))
	     'bottom-left))))

  (define (get-active-edge)
    (let ((cursor (query-pointer)))
      (cond ((zerop (car cursor))
	     'left)
	    ((= (car cursor) (1- (screen-width)))
	     'right)
	    ((zerop (cdr cursor))
	     'top)
	    ((= (cdr cursor) (1- (screen-height)))
	     'bottom))))

  (define (move-window-to-corner w corner)
    (let ((win-size (window-frame-dimensions w)))
      (case corner
	((top-left) (move-window-to w 0 0))
	((top-right) (move-window-to w (- (screen-width) (car win-size)) 0))
	((bottom-right) (move-window-to w (- (screen-width) (car win-size))
					  (- (screen-height) (cdr win-size))))
	((bottom-left) (move-window-to w 0 (- (screen-height) (cdr win-size)))))))

  (define (move-window-to-edge w edge)
    (let ((win-size (window-frame-dimensions w)))
      (case edge
	((left) (move-window-to w 0 (- (/ (screen-height) 2) (/ (cdr win-size) 2))))
	((top) (move-window-to w (- (/ (screen-width) 2) (/ (car win-size) 2)) 0))
	((right) (move-window-to w (screen-width) (- (/ (screen-height) 2) (/ (cdr win-size) 2))))
	((bottom) (move-window-to w (- (/ (screen-width) 2) (/ (car win-size) 2)) (screen-height)))))))

;; nokogiri-widgets/alist.jl -- alist widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.alist

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget
          sawfish.gtk.widgets.simple-dialog)

  ;; (alist (KEY-SPEC "KEY-TITLE") (VALUE-SPEC "VALUE-TITLE"))

  (define (make-alist-item changed-callback key value)

    (let* ((spec `(pair ,(or (car key) key)
			,(or (car value) value)))
	   (title `(,(or (cadr key) (_ "Key"))
		    ,(or (cadr value) (_ "Value")))))

      (define (type op)
	(case op
	  ((print) (lambda (x) (list (format nil "%s" (car x))
				     (format nil "%s" (cdr x)))))
	  ((dialog) (lambda (title callback #!key value for)
		      (widget-dialog title spec callback value for)))
	  ((validp) ((make-widget spec) 'validp))))

      (make-widget `(list ,type ,title) changed-callback)))

  (define-widget-type 'alist make-alist-item))

;; nokogiri-widgets/pair.jl -- cons-cell widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.pair

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  ;; (pair CAR-SPEC CDR-SPEC)

  (define (box-packer arg)
    (case arg
      ((start) gtk-box-pack-start)
      ((end) gtk-box-pack-end)
      (t gtk-container-add)))

  (define (make-pair-item changed-callback left right
			  #!optional use-vbox reversed packing)
    (let ((hbox ((if use-vbox gtk-vbox-new gtk-hbox-new) nil box-spacing))
	  (left-widget (make-widget left changed-callback))
	  (right-widget (make-widget right changed-callback)))

      (let ((w1 (if (not reversed) left-widget right-widget))
	    (w2 (if (not reversed) right-widget left-widget)))

	((box-packer (car packing)) hbox (widget-gtk-widget w1))
	((box-packer (cdr packing)) hbox (widget-gtk-widget w2)))

      (gtk-widget-show hbox)

      (lambda (op)
	(case op
	  ((gtk-widget) hbox)
	  ((set) (lambda (x)
		   (widget-set left-widget (car x))
		   (widget-set right-widget (cdr x))))
	  ((clear) (lambda ()
		     (widget-clear left-widget)
		     (widget-clear right-widget)))
	  ((ref) (lambda ()
		   (cons (widget-ref left-widget)
			 (widget-ref right-widget))))
	  ((validp) (lambda (x)
		      (and (widget-valid-p left-widget (car x))
			   (widget-valid-p right-widget (cdr x)))))))))

  (define-widget-type 'pair make-pair-item))

#| nokogiri-widgets/workspace-geometry.jl

   $Id: workspace-geometry.jl,v 1.1 2000/09/01 20:03:29 john Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

;; GNOME-less version of this widget

(define-structure sawfish.ui.widgets.workspace-geometry ()

    (open rep
	  sawfish.gtk.widget)

  (define-widget-type 'workspace-geometry
    (lambda (changed)
      (make-widget `(pair (labelled ,(_ "Workspaces:") (number 1))
			  (pair (labelled ,(_ "Columns:") (number 1))
				(labelled ,(_ "Rows:") (number 1))) t)
		   changed))))

;; cabinet.jl 1.1 -- A tool for window display,search and manipulation 
;; Time-stamp: <2012-01-16 12:51:02 hqwrong>


;; Copyright (C) 2011, 2012 hqwrong <hq.wrong@gmail.com>


     ;; This program is free software: you can redistribute it and/or modify
     ;; it under the terms of the GNU General Public License as published by
     ;; the Free Software Foundation, either version 3 of the License, or (at
     ;; your option) any later version.

     ;; This program is distributed in the hope that it will be useful, but
     ;; WITHOUT ANY WARRANTY; without even the implied warranty of
     ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     ;; General Public License for more details.

     ;; You should have received a copy of the GNU General Public License
     ;; along with this program.  If not, see `http://www.gnu.org/licenses/'.

;;
;;; Commentary:

;; Note:
;;  The words "window" and "application" mean same
;;  thing,they are used interchangeablly. The word "item"
;;  means the item displayed on Cabinet, which corresponding
;;  to an application. The words "selected item" means the
;;  first item on Cabinet. The words "selected window" means
;;  the window corresponding to the selected item.

;; ** Start up
;;   Cabinet required `hqw-util.jl', it should have been published along
;; with Cabinet. To separate them apart, because hqw-util.jl's
;; independence, you may find it useful at other occasions.

;;   Put `hqw-util.jl' and `cabinet.jl' into your load directory,and 

;;   (require 'cabinet)

;;   Use command `cabinet-switch' to start Cabinet.
;; To bind it to "W-s",copy the following line to your rc file.

;; (bind-keys global-keymap "W-s" 'cabinet-switch)

;; ** Cabinet Features.
;;   Cabinet has a similar interface with iswitch,it also adds
;; some own features, like:

;; 1) Support window icons to be shown
;;    Actually,this is my main motive to write Cabinet. For
;; People are apt to distinguish from images instead of
;; text.

;; 2) Support cycling among workspaces
;;   Most times the reason you create another workspace is
;; to make a bunch of applications distinguished from
;; others. It's a bad idear to mix them together to choose
;; from. The better one is only let you have applications of
;; current workspace,and enable you to cycle among
;; workspaces.
;;   Though, Cabinet afford you a choice: To toggle between
;; workspace-mode -- to just show windows of current workspace --
;; and all-mode -- to show all the windows. When in
;; workspace mode, the tag on split line is something like
;; 2/3, which means the largest workspace id is 3, and now
;; you are in workspace of id 2. When in all mode, the tag
;; should be "ALL".
;; Notice to make you cycle through workspaces,you should
;; set workspace boundary to 'wrap-around,put this in your
;; rc file:

;; (setq workspace-boundary-mode 'wrap-around)

;; 3) Distinguish windows for display from windows for
;; manipulation.
;;   Some applications, most time you are not inclined to
;; select them via Cabinet, for you already have a hot key
;; for them or other reasons, but somehow you just want to
;; see them there: being displayed on Cabinet. You may see a
;; split line on Cabinet, the items below it are windows
;; that you just want to display. This feature makes Cabinet
;; could somehow functions like a panel.

;; 4) Use forground color instead of tag to indicate window
;; status.
;;   Because the same reason for enabling icons. Because it
;; saves a charater's space.

;; 5) Enable users to manipulate a bunch of windows.
;; Use "Super-Spc" to mark the selected window, and use
;; procedure `with-marked-wl', you can manipulate
;; them. The marks will be cleared out after you quit
;; from Cabinet. Cabinet affords a procedure to tile marked
;; windows horizontally .

;; 6) Item format
;;   Item format is  like this :
;;       icon + window name + <window class> + viewport id + workspace id
;;   Variable `cabinet-item-text' controls what to append to icon.
;;   You are welcomed to reset it.

;; ** Cabinet Keymap
;;   I made the default keymap(cabinet-keymap) according to my
;; favour, So it's recommended to create yours. The easiest
;; way to get started will be to copy the default keymap
;; binding from the cabinet.jl, and modify it.
;; Most key bindings are obvious, while some need extra explanation.
;; Here is a list:
;;           "Super-v"    toggle workspace-mode and all-mode
;;           "Super-s"    cycle windows
;;           "Super-r"    reversely cycle windows
;;           "Super-S"     cycle workspaces.(Notice 'S' is capital)
;;           "Super-R"     reversely cycle workspaces.
;;           "Super-z"     toggle iconify property of selected window.
;;           "Super-SPC"   mark selected window
;;           "Super-x"     exchange windows-for-display and windows-for-manipulation
;;           "Super-g"    Same with "RET",but will restore stack order.
;;           "Super-t"   tile horizontally marked windows
;;           "Super-T"   tile vertically marked windows

;; ** For ones who want to extend cabinet keymap
;; You may notice, in keymap definition, there are a bunch of
;; procedures like `with-draw', `with-new-wlist' and so on. Yes,
;; it's comfusing and ugly, but it's flexible, it enables
;; you to extend cabinet-keymap at will. Anyway,I've tried
;; to make doc string clear to alleviate you aversion.:-)

;; ** Version list
;; Cabinet 1.0 2011.11
;; Cabinet 1.1 2011.12.16  fixed a bug

;; Enjoy!!

(define-structure sawfish.wm.ext.cabinet 
  
      (export cabinet-switch
              ;; 
              cabinet-keymap
              cabinet-item-text
              ;; you'll need following procedures only when
              ;; you want to extend cabinet-keymap
              with-update-on-workspace
              with-selected
              with-marked-wl
              with-exit-and-clear-mark
              with-update-on-input
              with-new-wlist
              with-draw)

      (open rep
            rep.data
            rep.system
            rep.regexp
            rep.lang.math
            sawfish.wm.state.shading
            sawfish.wm.state.iconify
            sawfish.wm.stacking
            sawfish.wm.viewport
            sawfish.wm.state.maximize
            sawfish.wm.util.display-window
            sawfish.wm.custom
            sawfish.wm.commands
            sawfish.wm.colors
            sawfish.wm.events
            sawfish.wm.fonts
            sawfish.wm.images
            sawfish.wm.misc
            sawfish.wm.util.x
            sawfish.wm.windows
            sawfish.wm.workspace
	    sawfish.wm.util.events
	    sawfish.wm.ext.expose)

   ;; (mapc require '( rep
   ;;       rep.system
   ;;       rep.regexp
   ;;       sawfish.wm.state.iconify
   ;;       sawfish.wm.stacking
   ;;       sawfish.wm.viewport
   ;;       sawfish.wm.state.maximize
   ;;       sawfish.wm.custom
   ;;       sawfish.wm.commands
   ;;       sawfish.wm.colors
   ;;       sawfish.wm.events
   ;;       sawfish.wm.fonts
   ;;       sawfish.wm.images
   ;;       sawfish.wm.misc
   ;;       sawfish.wm.util.x
   ;;       sawfish.wm.windows
   ;;       sawfish.wm.workspace))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; variables welcome to change ;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   (defgroup cabinet "Cabinet"
      :group focus
      :require cabinet)

   (defcustom cabinet-x-margin 10
      "The horizontal margin of cabinet"
      :type number
      :group (focus cabinet))
   (defcustom cabinet-y-margin 10
      "The vertically margin of cabinet"
      :group (focus cabinet)
      :type number)
   (defcustom cabinet-item-margin 6
      " The margin between item and item."
      :group (focus cabinet)
      :type number)
   (defcustom cycle-as-start
      t
      "whether cycle overhead,when start cabinet-switch.
Just like x-cycle"
      :group (focus cabinet)
      :type boolean)

   (defcustom workspace-mode-on-initial
      t
      "whether to show windows in current workspace.
nil, means to show windows of all workspaces."
      :group (focus cabinet)
      :type boolean)
   
   (defcustom cabinet-input-line-margin
      25
      "The margin between input line and the first item"
      :group (focus cabinet)
      :type number)

   (defvar cabinet-icon-size '(32 . 32)
      "Each icon size of window shown on cabinet"
      )
   (defvar cabinet-input-forground (get-color "yellow")
      "Forground color of your input" )

   (defvar cabinet-split-line-forground (get-color "firebrick"))

   (defvar iconified-item-forground (get-color "gray"))

   (defvar default-item-forground (get-color "white"))

   (defvar maximized-item-forground (get-color "orange"))

   (defvar shaded-item-forground (get-color "blue"))

   (defvar cabinet-background (get-color "black"))

   

   (defvar cabinet-filter-out-for-manipulation-list
      '(
        "^Conky$"
        )
      "The matching windows are only for display.
You can see their items below split line.")

   (defvar cabinet-filter-out-for-display-list
      '(
        "^\.gnome-desktop$"
        "Gnome-panel"
        "^gmc$"
        "^panel$")
   
      "The matching windows are filtered out,they
will not be shown on cabinet.")

   (defvar manipulation-on-selected
      raise-window
      "what to do on selected window, each time draw/refresh
   Cabinet. 
It must be set to a procedure with one argument. ")
   
   (define (cabinet-item-text w)
      "The text part shown on cabinet item"
      (concat (when (window-get w 'cabinet-marked)
                 " **")
              "  "
              (window-name w)
              " <"
              (window-class-name w 1)
              ">"
              (format nil
                      " %s"
                      (window-viewport w)
                      )
              (format nil
                      " %s"
                      (window-get w 'workspaces))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End @ usr variables ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

   (define input-line-height (font-height default-font))
   (define cabinet-font-height input-line-height)

   (define wlist-for-manipulation          
      nil)

   (define wlist-for-display
      nil)

   (define wlist-for-cabinet
      nil)

   (define cabinet-window nil)

   (define cabinet-orin-wlist)
   (define cabinet-orin-focus)
   (define cabinet-input "")
   (define cabinet-orin-workspace)
   (define workspace-mode)
   (define cabinet-filter-for-display-func)
   (define cabinet-filter-for-manipulation-func)

   ;; item-format package
   (define (cabinet-item-format w)
      (define (cabinet-item-text-format w)
         (cons (cabinet-item-text w)
               (cond
                ((window-iconified-p w) iconified-item-forground)
                ((window-maximized-p w) maximized-item-forground)
                ((window-shaded-p w) shaded-item-forground )
                (t  default-item-forground)))
         )

      (let (
            (item (cons (window-icon-image w)
                        (cabinet-item-text-format w))))
                     
         (lambda (tag)
            (cond
             ((eq tag 'icon) (car item))
             ((eq tag 'text) (cadr item))
             ((eq tag 'forground) (cdr (cdr item)))))))

   (define (make-item icon text forground)
      (lambda (tag)
         (cond
          ((eq tag 'icon) icon)
          ((eq tag 'text) text)
          ((eq tag 'forground) forground))))
   (define (get-item-icon item) (item 'icon))
   (define (get-item-text item) (item 'text))
   (define (get-item-forground item) (item 'forground))
   ;; end @ item format package 

   (define (cabinet-filter filter-list)
      (lambda (window)
         (let loop ((fow-nrl filter-list))
              (cond
               ((null fow-nrl) t)
               ((or (string-match (car fow-nrl) 
                                  (window-name window)
                                  0 nil)
                    (string-match (car fow-nrl) 
                                  (window-class-name window 1)
                                  0 nil))
                nil)
               (t (loop (cdr fow-nrl)))))))

   (define (cabinet-split-line)
      (make-item nil
                 (format nil 
                         "===================%s========================="
                         (if workspace-mode
                               (format nil
                                       " %s/%s "
                                       current-workspace
                                       (cdr (workspace-limits)))
                            "ALL"))
                 cabinet-split-line-forground))

   (define (draw-items wl input-line)
      (when (x-window-p cabinet-window)
         (x-destroy-window cabinet-window)
         (setq cabinet-window nil))

      (let* (
             (wl-size (length wl))

             (cabinet-items wl)

             (item-height (max (cdr cabinet-icon-size)
                               cabinet-font-height))
             (wx (+ (* 2 cabinet-x-margin)
                    (car cabinet-icon-size)
                    (apply max
                           (mapcar text-width
                                   (cons input-line
                                         (mapcar get-item-text
                                                 cabinet-items))))))

             (wy (+ (* 2 cabinet-y-margin)
                    (* wl-size item-height)
                    (* (- wl-size 1) cabinet-item-margin)
                    cabinet-input-line-margin
                    input-line-height))
             (win-size (cons wx wy)))
         (define (event-handler type xw)
            (define (cabinet-draw-text str pos foreground)
               (let ((gc (x-create-gc xw
                                      `((foreground . ,foreground)))))
                  (x-draw-string xw gc pos str)
                  ;; (x-destroy-gc gc)
                  ))
            (x-clear-window wx)
            ;; draw input line
            (cabinet-draw-text input-line
                               (cons cabinet-x-margin (+ cabinet-y-margin
                                                         cabinet-font-height))
                               cabinet-input-forground)
         
            ;; draw item text
            (let ((item-count 0)
                  (item-height-with-margin (+ item-height
                                              cabinet-item-margin))
                  (input-height-with-margin (+ input-line-height
                                               cabinet-input-line-margin)))
               (mapc (lambda (item)
                     
                        (let* (
                               (icon (get-item-icon item))
                               (text (get-item-text item))
                               (item-forground (get-item-forground item))
                               (icon-x (+ cabinet-x-margin))
                               (icon-y (+ cabinet-y-margin
                                          input-height-with-margin
                                          (* item-count
                                             item-height-with-margin)))
                               (text-x (+ icon-x
                                          (car cabinet-icon-size)))
                               (text-y (+ icon-y
                                          (quotient cabinet-font-height 2)
                                          (quotient (cdr cabinet-icon-size)
                                                    3))))
                           (when icon
                              (x-draw-image icon xw
                                            (cons icon-x icon-y)
                                            cabinet-icon-size))
                           (cabinet-draw-text text
                                              (cons text-x text-y)
                                              item-forground
                                              ))
                        (setq item-count (+ 1 item-count)))
                     cabinet-items))) ;; end of event-handler

         (setq cabinet-window
               (x-create-window `(,(- (quotient (screen-width) 2)
                                      (quotient wx 2))
                                  .
                                  ,(- (quotient (screen-height) 2)
                                      (quotient wy 2)))
                                win-size
                                1
                                `(
                                  (background . ,cabinet-background)
                                  )
                                event-handler
                                ))
         (x-map-window cabinet-window)
         cabinet-window))

   ;; keymap package
   (define (cabinet-switch-to-next)
      (when (not (null wlist-for-manipulation))
         (setq wlist-for-manipulation
               (append (cdr wlist-for-manipulation)
                       (list (car wlist-for-manipulation))))))

   (define (cabinet-switch-to-previous)
      (when (not (null wlist-for-manipulation))
         (setq wlist-for-manipulation
               (let ((rl (reverse wlist-for-manipulation)))
                  (list* (car rl) (reverse (cdr rl)))))))

   (define (toggle-iconify)
      (let ((w (car wlist-for-manipulation)))
         (if (window-get w 'iconified)
               (uniconify-window w)
            (iconify-window w))))

   (define (erase-input)
      (setq cabinet-input ""))

   (define (with-draw cmd)  
      "If your cmd will change Cabinet's
apperances,then add it."
      (lambda ()
         (cmd)
         (draw-cabinet)))

   (define (with-new-wlist cmd)
      " If your cmd makes the number of items 
grow, then add it"
      (lambda ()
         (cmd)
         (setq wlist-for-manipulation
               (filter cabinet-filter-for-manipulation-func
                       (filter cabinet-filter-for-display-func
                               (stacking-order))))
         (setq wlist-for-display
               (filter (lambda (win)
                          (not (cabinet-filter-for-manipulation-func win)))
                       (filter cabinet-filter-for-display-func
                               (stacking-order))))))

   (define (with-update-on-input cmd)
      " It will filter items  on input after
execution of cmd, add it when you feel proper."
      (lambda ()  
         (cmd)
         (cabinet-update-on-input)))

   (define (cabinet-update-on-input)
      "Same with `with-update-on-input',except that it's
a procedure with no argument."
      (setq wlist-for-manipulation
            (if (not (null wlist-for-manipulation))
                  (filter (lambda (w)
                             (string-match cabinet-input
                                           (concat
                                            (window-name w)
                                            (window-class-name w ))
                                           0 t))
                          wlist-for-manipulation))))

   (define (with-exit-and-clear-mark cmd)
      " Use it, when you decide to quit Cabinet after
your cmd's execution."
      (lambda ()
         (cmd)
         (mapc (lambda (w)
                  (window-remprop w 'cabinet-marked))
               cabinet-orin-wlist)
         (event-exit-wait)))

   (define (with-marked-wl cmd)
      "The marked window will be passed to cmd as a list."
      (lambda ()
         (cmd (filter-windows (lambda (w)
                                 (window-get w
                                             'cabinet-marked))))))
   (define (with-selected cmd)
      "The selected window will be passed to cmd as an argument."
      (lambda ()
         (cmd (car wlist-for-manipulation))))

   (define (cycle-workspace count)
      (with-draw
       (lambda ()
          ((with-update-on-input (with-new-wlist (lambda () t))))
          (if workspace-mode
                (next-workspace count)
             (setq workspace-mode t))
          (update-on-workspace))))

   (define (with-update-on-workspace cmd)
      "It filters items for
current workspace windows.
add it, when your command changed workspace"
      (lambda ()
         (cmd)
         (update-on-workspace)))

   (define (update-on-workspace)
      " Same with `with-update-on-workspace',except that
this is a procedure with no argument."
      (when (eq workspace-mode t)
         (setq wlist-for-manipulation
               (filter (lambda (w)
                          (let (
                                (ww (window-get w 'workspaces)))
                             (or (memq current-workspace ww)
                                 (eq ww nil)))) 
                       wlist-for-manipulation))))

   (define cabinet-keymap
      (bind-keys (make-keymap)
                 "C-u" (with-draw
                        (with-update-on-input
                         (with-update-on-workspace
                          (with-new-wlist erase-input))))

                 "SPC" (with-draw
                        (with-update-on-input
                         (lambda ()
                            (setq cabinet-input
                                  (concat cabinet-input " ")))))
                 "BS" (with-draw
                       (with-update-on-input
                        (with-update-on-workspace
                         (with-new-wlist
                          (lambda ()
                             (when (> (length cabinet-input) 0)
                                (setq cabinet-input
                                      (substring cabinet-input
                                                 0
                                                 (1- (length cabinet-input))))
                                ))))))
              
                 "Super-s" (with-draw cabinet-switch-to-next)
                 "C-s" (with-draw cabinet-switch-to-next)
                 "Super-r" (with-draw cabinet-switch-to-previous)
                 "C-r" (with-draw cabinet-switch-to-previous)
                 "Super-w" (with-selected
                            (lambda (w)
                               (delete-window w)
                               (setq wlist-for-manipulation (cdr wlist-for-manipulation))
                               (draw-cabinet)))
                 "Super-z" (with-draw toggle-iconify)
                 "Super-C-z" (with-draw (lambda ()
                                           (toggle-iconify)
                                           (cabinet-switch-to-next)))
                 "RET" (with-exit-and-clear-mark
                        (with-selected
                         (lambda (w)
                           (display-window w))))
                 "Super-g" (with-exit-and-clear-mark (lambda ()
                                                        (select-workspace cabinet-orin-workspace)
                                                        (restack-windows cabinet-orin-wlist)
                                                        (set-input-focus cabinet-orin-focus)))
                 "Super-x" (with-draw
                            (with-update-on-input
                             (lambda ()
                                (let (
                                      (tmp wlist-for-manipulation))
                                   (setq wlist-for-manipulation wlist-for-display
                                         wlist-for-display tmp)))))
                 "Super-SPC" (with-draw
                              (with-selected
                               (lambda (w)
                                  (window-put w
                                              'cabinet-marked
                                              (not
						(window-get w 'cabinet-marked))))))
                 "Super-t" (with-marked-wl
                            (lambda (wl)
                               (expose-windows wl)))
                 "Super-T" (with-marked-wl
                            (lambda (wl)
                               (expose-windows wl t)))

                 "Super-S" (cycle-workspace 1)
                 "Super-R" (cycle-workspace -1)
                 "Super-v" (with-draw
                            (lambda ()
                               ((with-update-on-input
                                 (with-new-wlist
                                  (lambda () t))))
                               (setq workspace-mode (not workspace-mode))))
                ;; "Right" (with-draw
                 ;;          (with-selected
                 ;;           (lambda (w)
                 ;;              (send-to-next-workspace w 1))))
                 ;; "Left" (with-draw
                 ;;         (with-selected
                 ;;          (lambda (w)
                 ;;             (send-to-next-workspace w -1))))
                 ))

   ;; end @ keymap package

   (define (draw-cabinet)
      (let (
            (selected-w (car wlist-for-manipulation)))
         (when (not (null wlist-for-manipulation))
            (manipulation-on-selected selected-w))

         (draw-items (append (mapcar cabinet-item-format wlist-for-manipulation)
                             (list (cabinet-split-line))
                             (mapcar cabinet-item-format wlist-for-display))
                     (concat cabinet-input "_"))
         ))
         
   (defvar cabinet-handler
      `(
        (,(lambda (key) (= 1 (length key)))
         .
         ,(lambda (key)
             (setq cabinet-input (concat cabinet-input key))
             (cabinet-update-on-input)
             (draw-cabinet)))))

   (define (cabinet-switch)
      "The Main function."

      (setq cabinet-orin-wlist (stacking-order)
            cabinet-orin-focus (input-focus)

            cabinet-input ""
            cabinet-orin-workspace current-workspace
            workspace-mode workspace-mode-on-initial
            cabinet-filter-for-display-func
            (cabinet-filter cabinet-filter-out-for-display-list)
            cabinet-filter-for-manipulation-func
            (cabinet-filter cabinet-filter-out-for-manipulation-list)
            wlist-for-cabinet (filter cabinet-filter-for-display-func
                                      (stacking-order))

            wlist-for-manipulation (filter cabinet-filter-for-manipulation-func
                                           wlist-for-cabinet)
            wlist-for-display (filter (lambda (win)
                                         (not (cabinet-filter-for-manipulation-func win)))
                                      wlist-for-cabinet)
            )
    
  
      (when workspace-mode
         (update-on-workspace))
   
      (when cycle-as-start
         (cabinet-switch-to-next))
  
      (draw-cabinet)

      (event-wait-for #:keymap cabinet-keymap
                    #:handler cabinet-handler
                    #:loop-on-unbound t)
      (x-destroy-window cabinet-window))
   (define-command 'cabinet-switch cabinet-switch)
   )

;; tabgroup.jl - tab main
;;
;; Copyright (C) Yann Hodique <Yann.Hodique@lifl.fr>
;;
;; This file is an official accepted contribution into sawfish.
;;
;; This script is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 22, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.tabs.tabgroup

    (export window-tabbed-p
            frame-style-tabs-support-p
            net-wm-window-type-normal-p
            tab-refresh-group
            tab-release-window
            tab-raise-left-window
            tab-raise-right-window
            tab-move-to-beginning
            tab-move-to-end
            tab-move-to-right
            tab-move-to-left
            tab-window-group-index
            tab-find-window
            tab-rank
            tab-group-window-list
            tab-group-windows
            tab-group-windows-stacking-order
            tab-group-window
            tab-move-resize-lock)

    (open rep
          rep.system
          rep.io.timers
          rep.data.records
          sawfish.wm.gaol
          sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.windows
          sawfish.wm.frames
          sawfish.wm.tabs.tab
          sawfish.wm.events
          sawfish.wm.state.iconify
          sawfish.wm.state.shading
          sawfish.wm.commands.move-resize
          sawfish.wm.stacking
          sawfish.wm.util.groups
          sawfish.wm.util.window-order
          sawfish.wm.commands.groups
          sawfish.wm.ext.auto-raise
          sawfish.wm.ext.shade-hover
          sawfish.wm.workspace)

  (define-structure-alias tabgroup sawfish.wm.tabs.tabgroup)

  (define all-wins nil)
  (define windows-stacking-order nil)
  (define oldgroup nil)
  (define tab-groups nil)
  (define tab-refresh-lock t)
  (define tab-move-resize-lock nil)
  (define destroy nil)
  (define release-window t)
  (define last-unmap-id nil)
  (define in-tab-group-name nil)
  (define tab-theme-name)
  (define tab-theme-tabbars)
  (define timer-raise nil)

  (defvar tab-group-windows-hook '()
    "Tab-group-windows-hook called when changing or creating a tabgroup.
Returning all windows in the current tabgroup")

  (define (set-tab-theme-name #!key frame-style-supported-tabs)
    (setq tab-theme-name frame-style-supported-tabs))

  (define (frame-style-tabs-support-p w)
    "Returns t if the framestyle from W supports tabs.
Also need the currect settings in the theme.jl from the theme."
    (setq tab-theme-name nil)
    (call-window-hook 'window-state-change-hook w (list '(tab-theme-name)))
    (eq (window-get w 'current-frame-style) tab-theme-name))

  (define (set-tab-theme-tabbars #!key frame-style-supported-tabbars)
    (setq tab-theme-tabbars frame-style-supported-tabbars))

  (define (frame-style-tabbars-support w)
    "Returns a list with theme name and tabbars position if the framestyle from W 
has multiple tabbars. Also need the currect settings in the theme.jl from the theme."
    (setq tab-theme-tabbars nil)
    (call-window-hook 'window-state-change-hook w (list '(tab-theme-tabbars)))
    tab-theme-tabbars)
  
  (define (net-wm-window-type-normal-p w)
    "Returns t if _NET_WM_WINDOW_TYPE by W is true or W has window-property 'force-tab"
    (or (window-get w 'force-tab)
        (if (get-x-property w '_NET_WM_WINDOW_TYPE)
            (equal (aref (nth 2 (get-x-property w '_NET_WM_WINDOW_TYPE)) 0) '_NET_WM_WINDOW_TYPE_NORMAL))))

  (define (window-tabbed-p w)
        (window-get w 'tabbed))

  (define-record-type :tab-group
    (tab-build-group p d wl)
    tab-group?
    (p tab-group-position)
    (d tab-group-dimensions)
    (wl tab-group-window-list))

  (define (tab-move-resize-frame-window-to win x y w h)
    "Move and resize according to *frame* dimensions."
    (let* ((dim1 (window-dimensions win))
           (dim2 (window-frame-dimensions win))
           (dw (- (car dim2) (car dim1)))
           (dh (- (cdr dim2) (cdr dim1))))
      (move-resize-window-to win x y (- w dw) (- h dh))))

  (define (tab-make-new-group win)
    "Return a new group containing only WIN."
    (let* ((pos (window-position win))
           (dim (window-frame-dimensions win))
           (group (tab-build-group pos dim (list win))))
      (setq tab-groups (append tab-groups (cons group nil)))
      group))

  (define (tab-find-window win)
    "Return the group containing WIN."
    (let loop ((gr tab-groups))
      (cond
       ((null gr)
        (tab-make-new-group win)
        )
       ((member win (tab-group-window-list (car gr)))
        (car gr))
       (t
        (loop (cdr gr))))))

  (define (tab-window-group-index win)
    "Return the index of the group containing WIN."
    (let loop ((index 0))
      (cond
       ((eq index (length tab-groups))
        (tab-make-new-group win)
        index)
       ((member win (tab-group-window-list (nth index tab-groups)))
        index)
       (t
        (loop (+ index 1))))))

  (define (tab-group-windows win)
    "Return the windows of the group containing WIN."
    (let* ((index (tab-window-group-index win))
           (wins (tab-group-window-list (nth index tab-groups))))
      wins))

  (define (tab-group-windows-stacking-order win)
    "Return the windows of the group containing WIN sort by stacking order."
    (let* ((tabs (tab-group-windows win))
           (all-wins (stacking-order))
           order)
      (mapcar (lambda (w)
                (if (member w tabs)
                    (setq order (append order (list w))))) all-wins)
      order))

  (define (tab-rank elem list)
    "Returns the nth position from elem (tab) in a list (tabbar)"
    (if (eq elem (car list))
        0
      (+ 1 (tab-rank elem (cdr list)))))

  (define (destroy-hook w)
    (setq destroy 't)
    (tab-delete-window-from-tab-groups w))

  (define (tab-delete-window-from-group win index)
    "Remove WIN from the group at given index."
    (let* ((old (nth index tab-groups))
           (l (remove win (tab-group-window-list old))))
      (if (null l)
          (setq tab-groups (delete old tab-groups))
        (rplaca (nthcdr index tab-groups)
                (tab-build-group (tab-group-position old) (tab-group-dimensions old) l))
        (window-put win 'tabbed nil)
        (if (not (cdr l))
            (window-put (car l) 'tabbed nil))
        (setq oldgroup (car l)))))

  (define (tab-delete-window-from-tab-groups w)
    "Find window's group and remove it."
    (if release-window
        (remove-from-tab-group w))
    (setq release-window t)
    (when (window-tabbed-p w)
      (let ((wins (list (remove w (tab-group-windows w)))))
        (tab-delete-window-from-group w (tab-window-group-index w))
        (window-put w 'fixed-position nil)
        (tab-refresh-group oldgroup 'frame)
        (unshade-window (nth 0 (tab-group-windows-stacking-order oldgroup)))
        (window-order-push (nth 0 (tab-group-windows-stacking-order oldgroup)))
        (when (eq destroy 't)
          (set-input-focus (nth 0 (tab-group-windows-stacking-order oldgroup)))
          (setq destroy nil))
        (call-hook 'tab-group-windows-hook wins)
        (reframe-window w))))

  (define (tab-put-window-in-group win index)
    "Put window in group at given index."
    (let* ((group (nth index tab-groups)))
      (rplaca (nthcdr index tab-groups)
              (tab-build-group (tab-group-position group)
                               (tab-group-dimensions group)
                               (append (tab-group-window-list group) (list win))))
      (window-order-push win)))

  (define (tab-refresh-group win prop)
    "Refresh the entire group containing WIN according to PROP.
PROP can be one of the symbols: raise, frame, reframe, reframe-all, style, move,
resize, title-position, type, depth, shade, unshade, iconify, uniconify, maximized,
sticky, unsticky, fixed-position fixed-size."
    (when tab-refresh-lock
      (setq tab-refresh-lock nil)
      (unwind-protect
          (let* ((index (tab-window-group-index win))
                 (wins (tab-group-window-list (nth index tab-groups)))
                 (focus (tab-group-offset win 0))
                 (unfocus (remove focus wins))
                 not-shaded)
            (mapcar (lambda (w)
                      (if (not (window-get w 'shaded)) (setq not-shaded 't))) wins)
            (if not-shaded
                (mapcar (lambda (w)
                          (unshade-window w)) wins))
            (cond
             ((eq prop 'raise)
              (raise-windows win (remove win (tab-group-windows-stacking-order win))))
             ((eq prop 'title-position)
              (let ((group-title-position (window-get win 'title-position)))
                (mapcar (lambda (w)
                          (window-put w 'title-position group-title-position)) unfocus)
               (window-put focus 'title-position group-title-position)))
             ((eq prop 'frame)
              (mapcar (lambda (w)
                        (reframe-window w)) unfocus)
              (reframe-window focus))
             ((eq prop 'reframe)
              (mapcar (lambda (w)
                        (reframe-window w)) unfocus))
             ((eq prop 'reframe-all)
              (mapcar (lambda (w)
                        (reframe-window w)) unfocus)
              (reframe-window focus))
             ((or (eq prop 'move) (eq prop 'resize))
              (let ((dim (window-frame-dimensions win))
                    (pos (window-position win)))
                (mapcar (lambda (w)
                          (tab-move-resize-frame-window-to w (car pos) (cdr pos) (car dim) (cdr dim))) unfocus)))
             ((eq prop 'style)
              (let ((group-frame-style (window-get win 'frame-style))
                    (dim (window-frame-dimensions win))
                    (pos (window-position win)))
                (mapcar (lambda (w)
                          (set-frame-style w group-frame-style)
                          (tab-move-resize-frame-window-to w (car pos) (cdr pos) (car dim) (cdr dim))) unfocus)))
             ((eq prop 'fixed-position)
              (let ((group-frame-fixed-position (window-get win 'fixed-position)))
                (mapcar (lambda (w)
                          (window-put w 'fixed-position group-frame-fixed-position)) unfocus)))
             ((eq prop 'fixed-size)
              (let ((group-frame-fixed-size (window-get win 'fixed-size)))
                (mapcar (lambda (w)
                          (window-put w 'fixed-size group-frame-fixed-size)) unfocus)))
             ((eq prop 'type)
              (let ((group-frame-type (window-get win 'type)))
                (mapcar (lambda (w)
                          (window-put w 'type group-frame-type)) unfocus)))
             ((eq prop 'depth)
              (let ((group-frame-depth (window-get win 'depth)))
                (mapcar (lambda (w)
                          (window-put w 'depth group-frame-depth)) unfocus)
                (raise-window win)
                (set-input-focus win)))
             ((eq prop 'iconify)
              (mapcar (lambda (w)
                        (iconify-window w)) unfocus))
             ((eq prop 'uniconify)
              (mapcar (lambda (w)
                        (uniconify-window w)) unfocus))
             ((eq prop 'maximized)
              (let ((dim (window-frame-dimensions win))
                    (pos (window-position win))
                    (group-frame-maximized-vertically (window-get win 'maximized-vertically))
                    (group-frame-maximized-horizontally (window-get win 'maximized-horizontally))
                    (group-frame-maximized-fullscreen (window-get win 'maximized-fullscreen))
                    (group-frame-unmaximized-type (window-get win 'unmaximized-type))
                    (group-frame-unmaximized-geometry (window-get win 'unmaximized-geometry)))
                (mapcar (lambda (w)
                          (window-put w 'maximized-vertically group-frame-maximized-vertically)
                          (window-put w 'maximized-horizontally group-frame-maximized-horizontally)
                          (window-put w 'maximized-fullscreen group-frame-maximized-fullscreen)
                          (window-put w 'unmaximized-type group-frame-unmaximized-type)
                          (window-put w 'unmaximized-geometry group-frame-unmaximized-geometry)
                          (tab-move-resize-frame-window-to w (car pos) (cdr pos) (car dim) (cdr dim))) unfocus)))
             ((eq prop 'sticky)
              (let ((workspace-sticky (window-sticky-p/workspace win))
                    (viewport-sticky (window-sticky-p/viewport win))
                    tab-workspace-sticky tab-viewport-sticky)
                (mapcar (lambda (w)
                          (setq tab-workspace-sticky (window-sticky-p/workspace w))
                          (setq tab-viewport-sticky (window-sticky-p/viewport w))
                          (if (not (eq workspace-sticky tab-workspace-sticky))
                              (if workspace-sticky
                                  (make-window-sticky/workspace w)
                                (make-window-unsticky/workspace w)))
                          (if (not (eq viewport-sticky tab-viewport-sticky))
                              (if viewport-sticky
                                  (make-window-sticky/viewport w)
                                (make-window-unsticky/viewport w)))) unfocus))))
            (when (cdr (tab-group-windows win))
              (if not-shaded (unshade-window win))
              (mapcar (lambda (w)
                        (shade-window w)) (remove win (tab-group-windows win)))))
        (setq tab-refresh-lock t))))

  ;; Entry points
  (define (tab-group-window w win)
    "Add window W to tabgroup containing WIN."
    ;; don't add a window as tab, if it already
    ;; exists on another workspace or window type
    ;; is not a "normal" window (e.g. dock panel ...)
    ;; and framestyle supported tabs
    (when (and (not (cdr (window-get win 'workspaces)))
               (net-wm-window-type-normal-p w)
               (net-wm-window-type-normal-p win)
               (frame-style-tabs-support-p win))
      (let* ((index (tab-window-group-index win))
             (index2 (tab-window-group-index w))
             (pos (window-position win))
             (dim (window-dimensions win))
             ;; adopt window settings for the new tab
             (group-frame-style (window-get win 'frame-style))
             (group-frame-type (window-get win 'type))
             (group-frame-shade-hover (window-get win 'shade-hover))
             (group-frame-focus-mode (window-get win 'focus-mode))
             (group-frame-gravity (window-get win 'gravity))
             (group-frame-never-iconify (window-get win 'never-iconify))
             (group-frame-fixed-position (window-get win 'fixed-position))
             (group-frame-fixed-size (window-get win 'fixed-size))
             (group-frame-title-position (window-get win 'title-position))
             (group-frame-depth (window-get win 'depth))
             (group-frame-never-maximize (window-get win 'never-maximize))
             (group-frame-maximized-vertically (window-get win 'maximized-vertically))
             (group-frame-maximized-horizontally (window-get win 'maximized-horizontally))
             (group-frame-maximized-fullscreen (window-get win 'maximized-fullscreen))
             (group-frame-unmaximized-type (window-get win 'unmaximized-type))
             (group-frame-unmaximized-geometry (window-get win 'unmaximized-geometry))
             group-frame-to-workspaces group-frame-from-workspaces is-sticky-w is-sticky-v)
        (when (not (eq index index2))
          ;; tabgroup to tabgroup
          (when (window-tabbed-p w)
            (setq release-window nil)
            (tab-delete-window-from-tab-groups w)
            (setq index2 (tab-window-group-index w)))
          (if (window-get win 'iconified) (uniconify-window win))
          (if (window-get win 'shaded) (unshade-window win))
          (setq tab-refresh-lock nil)
          (if (window-sticky-p/workspace win) (setq is-sticky-w 't))
          (if (window-sticky-p/viewport win) (setq is-sticky-v 't))
          (if (window-sticky-p win) (make-window-unsticky win))
          (setq group-frame-to-workspaces (car (window-workspaces win)))
          (if (window-sticky-p w) (make-window-unsticky w))
          (setq group-frame-from-workspaces (car (window-workspaces w)))
          (if (window-get w 'iconified) (uniconify-window w))
          (if (window-get w 'shaded) (unshade-window w))
          (window-put w 'frame-style group-frame-style)
          (window-put w 'type group-frame-type)
          (window-put w 'shade-hover group-frame-shade-hover)
          (window-put w 'focus-mode group-frame-focus-mode)
          (window-put w 'gravity group-frame-gravity)
          (window-put w 'title-position group-frame-title-position)
          (window-put w 'never-iconify group-frame-never-iconify)
          (window-put w 'depth group-frame-depth)
          (window-put w 'fixed-position group-frame-fixed-position)
          (window-put w 'fixed-size group-frame-fixed-size)
          (window-put w 'never-maximize group-frame-never-maximize)
          (window-put w 'maximized-vertically group-frame-maximized-vertically)
          (window-put w 'maximized-horizontally group-frame-maximized-horizontally)
          (window-put w 'maximized-fullscreen group-frame-maximized-fullscreen)
          (window-put w 'unmaximized-type group-frame-unmaximized-type)
          (window-put w 'unmaximized-geometry group-frame-unmaximized-geometry)
          ;; reframe w here, tab-refresh-group expectet
          ;; the same frame for w and win
          (reframe-window w)
          (tab-put-window-in-group w index)
          (tab-delete-window-from-group w index2)
          (resize-window-to w (car dim) (cdr dim))
          (move-window-to w (car pos) (cdr pos))
          (when (and group-frame-to-workspaces group-frame-from-workspaces
                     (not (eq group-frame-to-workspaces group-frame-from-workspaces)))
            (move-window-to-workspace w group-frame-from-workspaces group-frame-to-workspaces))
          (if (and is-sticky-w is-sticky-v)
              (progn 
                (make-window-sticky win)
                (make-window-sticky w))
            (when is-sticky-w 
              (make-window-sticky/workspace win)
              (make-window-sticky/workspace w))
            (when is-sticky-v 
              (make-window-sticky/viewport win)
              (make-window-sticky/viewport w)))
          (setq tab-refresh-lock t)
          (tab-refresh-group w 'frame)
          (set-input-focus w)
          (call-hook 'tab-group-windows-hook (list (tab-group-windows w)))
          (if (not (window-tabbed-p win)) (window-put win 'tabbed t))
          (window-put w 'tabbed t)
          (raise-windows w (remove w (tab-group-windows-stacking-order w)))))))
  
  (define (tab-release-window w)
    "Release the window from its group."
    (setq release-window nil)
    (tab-delete-window-from-tab-groups w)
    (tab-make-new-group w))

  (define-command 'tab-release-window tab-release-window #:spec "%f")

  (define (tab-group-offset win n)
    "Return the window at position (pos+n) in window's group."
    (let* ((gr (tab-group-window-list (tab-find-window win)))
           (size (length gr))
           (r (tab-rank win gr)))
      (nth (modulo (+ r n) size) gr)))

  (define (tab-same-group-p w1 w2)
    "Predicate : true <=> w1 and w2 are grouped together."
    (member w1 (tab-group-window-list (tab-find-window w2))))

  (define (tab-raise-left-window)
    "Raise left window in current tab group."
    (let ((win (tab-group-offset (input-focus) -1)))
      (raise-window win)
      (set-input-focus win)))

  (define-command 'tab-raise-left-window tab-raise-left-window)

  (define (tab-raise-right-window)
    "Raise right window in current tab group."
    (let ((win (tab-group-offset (input-focus) 1)))
      (raise-window win)
      (set-input-focus win)))

  (define-command 'tab-raise-right-window tab-raise-right-window)

  (define (move-tab w pos)
    "Move tab W to pos"
    (when (window-tabbed-p w)
      (let* ((wins (tab-group-windows w))
            (rank (tab-rank w wins))
            (list-end (nthcdr rank wins))
            (list-start wins)
            right left current new-list)
        (mapcar (lambda (w)
                  (setq list-start (remove w list-start))) list-end)
        (when (eq pos 'next)
          (if (not (nth (+ rank 1) wins))
              (tab-move-to-beginning w)
            (setq list-end (remove w list-end))
            (setq right (nth (+ rank 1) wins))
            (setq list-end (remove (nth (+ rank 1) wins) list-end))         
            (setq current (list w))
            (if (consp list-start)
                (setq new-list (append new-list list-start)))
            (if right
                (setq new-list (append new-list (list right))))
            (if (consp current)
                (setq new-list (append new-list current)))
            (if (consp list-end)
                (setq new-list (append new-list list-end)))
            (setq all-wins (nthcdr 0 new-list))
            (after-move-resize w)))
        (when (eq pos 'prev)
          (setq left (last list-start))  
          (if (not left)
              (tab-move-to-end w)
          (setq list-start (remove left list-start))
            (setq list-end (nthcdr (+ rank 1) wins))
            (setq current (list w))
            (if (consp list-start)
                (setq new-list (append new-list list-start)))
            (if (consp current)
                (setq new-list (append new-list current)))
            (if left
                (setq new-list (append new-list (list left))))
            (if (consp list-end)
                (setq new-list (append new-list list-end)))
            (setq all-wins (nthcdr 0 new-list))
            (after-move-resize w))))))

  (define clicked-frame nil)
  (define (tab-move-to-right w)
    "Move tab to right in the tabbar."
    (setq clicked-frame (clicked-frame-part))
    (move-tab w 'next))

  (define-command 'tab-move-to-right tab-move-to-right #:spec "%f")

  (define (tab-move-to-left w)
    "Move tab to left in the tabbar."
    (setq clicked-frame (clicked-frame-part))
    (move-tab w 'prev))
  
  (define-command 'tab-move-to-left tab-move-to-left #:spec "%f")

  (define (move-tab-edge w pos)
    "Move tab W to pos"
    (when (window-tabbed-p w)
      (let ((tabs (remove w (tab-group-windows w))))
        (if (eq pos 'end)
            (setq all-wins (append tabs (cons w nil))))
        (if (eq pos 'beg)
            (setq all-wins (append (cons w nil) tabs)))
        (after-move-resize w))))

  (define (tab-move-to-end w)
    "Move tab to the end in the tabbar."
    (setq clicked-frame (clicked-frame-part))
    (move-tab-edge w 'end))

  (define-command 'tab-move-to-end tab-move-to-end #:spec "%f")

  (define (tab-move-to-beginning w)
    "Move tab to the beginning in the tabbar."
    (setq clicked-frame (clicked-frame-part))
    (move-tab-edge w 'beg))

  (define-command 'tab-move-to-beginning tab-move-to-beginning #:spec "%f")

  (define (map-other-grouped-windows win func)
    ""
    (mapcar func
            (delete-if
             (lambda (w) (eq w win))
             (tab-group-window-list (tab-find-window win)))) )

  (define (before-move win)
    (when (not (window-get win 'fixed-position))
      (before-move-resize win)))

  (define (before-move-resize win)
    "Releas WIN from the tabgroup and iconify the rest from the group."
    (let* ((default-window-animator 'none)
           (index (tab-window-group-index win))
           (wins (tab-group-windows win))
           (order (tab-group-windows-stacking-order win))
           (tabs (remove win (tab-group-windows win))))
      (setq tab-move-resize-lock 't)
      (tab-delete-window-from-group win index)
      (reframe-window win)
      (setq tab-refresh-lock nil)
      (mapcar (lambda (w)
                (when (window-get w 'never-iconify)
                  (window-put w 'never-iconify nil)
                  (window-put w 'never-iconify-opaque t))
                (iconify-window w)) tabs)
      (setq windows-stacking-order order)
      (setq all-wins wins))
    (setq tab-refresh-lock t))

  (define (after-move-resize win)
    "Add all tabs to the tabgroup from WIN. (Releas and iconify by before-move-resize)"
    (setq tab-refresh-lock nil)
    (let* ((default-window-animator 'none)
           (wins all-wins)
           (pos (window-position win))
           (dim (window-dimensions win))
           index index-old)
      (when (cdr wins)
        (setq index (tab-window-group-index (car wins)))
        (mapcar (lambda (w)
                  (setq index-old (tab-window-group-index w))
                  (tab-put-window-in-group w index)
                  (tab-delete-window-from-group w index-old)
                  (setq index (tab-window-group-index w))
                  (move-window-to w (car pos) (cdr pos))
                  (resize-window-to w (car dim) (cdr dim))
                  (uniconify-window w)
                  (when (window-get w 'never-iconify-opaque)
                    (window-put w 'never-iconify-opaque nil)
                    (window-put w 'never-iconify t))
                  (window-put w 'tabbed t)) wins)
        (call-hook 'tab-group-windows-hook (list (tab-group-windows win)))
        (raise-windows win (remove win windows-stacking-order))
        (tab-refresh-group win 'raise)
        (setq all-wins nil))
      (setq tab-refresh-lock t)
      (when (window-tabbed-p win)
        (tab-refresh-group win 'move)
        (tab-refresh-group win 'frame)
        (set-input-focus (nth 0 (tab-group-windows-stacking-order win)))
        (when clicked-frame
          (move-cursor-in-tabbar (input-focus))
          (setq clicked-frame nil)))
      (setq tab-move-resize-lock nil)))

  (define (move-cursor-in-tabbar win)
    (let* ((group (tab-find-window win))
           (tabnum (tab-rank win (tab-group-window-list group)))
           (tab-pos-list (tab-pos group tabnum win))
           (start-right
            (if (or (eq (window-get win 'type) 'transient)
                    (eq (window-get win 'type) 'shaped-transient))
                tabbar-left-margin-transient
              tabbar-left-margin)))
      (if (not (eq (window-get win 'current-frame-style) (nth 0 (frame-style-tabbars-support win))))
          (warp-cursor (+ (car (window-position win)) start-right (nth 4 tab-pos-list) (quotient (nth 6 tab-pos-list) 2))
                       (+ (quotient (- (cdr (window-frame-dimensions win)) (cdr (window-dimensions win)) 4) 2) (cdr (window-position win))))
        (let ((current-pos 
               (if (window-get win 'title-position)
                   (window-get win 'title-position)
                 (nth 1 (frame-style-tabbars-support win)))))
          (case current-pos
                ((top) (warp-cursor (+ (car (window-position win)) start-right (nth 4 tab-pos-list) (quotient (nth 6 tab-pos-list) 2))
                                    (+ (quotient (- (cdr (window-frame-dimensions win)) (cdr (window-dimensions win)) 4) 2) (cdr (window-position win)))))
                ((bottom) (warp-cursor (+ (car (window-position win)) start-right (nth 4 tab-pos-list) (quotient (nth 6 tab-pos-list) 2))
                                       (+ (quotient (- (cdr (window-frame-dimensions win)) (cdr (window-dimensions win))) 2) 
                                          (cdr (window-position win)) (cdr (window-dimensions win)))))
                ((left) (warp-cursor (+ (quotient (- (car (window-frame-dimensions win)) (car (window-dimensions win)) 4) 2) (car (window-position win)))
                                     (- (+ (cdr (window-position win)) (cdr (window-dimensions win))) start-right (nth 7 tab-pos-list) 
                                        (quotient (nth 9 tab-pos-list) 2))))
                ((right) (warp-cursor (+ (quotient (- (car (window-frame-dimensions win)) (car (window-dimensions win))) 2) 
                                         (car (window-position win)) (car (window-dimensions win)) 2) 
                                      (- (+ (cdr (window-position win)) (cdr (window-dimensions win))) start-right (nth 7 tab-pos-list) 
                                         (quotient (nth 9 tab-pos-list) 2)))))))))

  (define (unmap-id win)
    (setq last-unmap-id (window-id win)))

  (define (in-tab-group win)
    "Add a new window WIN as tab if have one (the first created if more as one)
of the windows the same 'tab-group property"
     (when (window-get win 'tab-group)
       (setq in-tab-group-name (append in-tab-group-name (cons (cons (window-id win) (window-get win 'tab-group)))))
       (let ((open-win-tabgroup (get-window-by-id (car (rassoc (window-get win 'tab-group) in-tab-group-name)))))
        ;; unmap-notify-hook gets not always a window-id for all
        ;; windows e.g. gimp (it will close more as one window and
        ;; also not all call the unmap-notify-hook and/or we get the window-id).
        ;; This next "if" will clean the list and remove the "ghosts".
        (if (not (eq open-win-tabgroup nil))
            (if (not (eq win open-win-tabgroup))
                (tab-group-window win open-win-tabgroup))
          (setq in-tab-group-name (remove (rassoc (window-get win 'tab-group) in-tab-group-name) in-tab-group-name))
          (in-tab-group win)))))

  (define (remove-from-tab-group win)
    "Remove WIN from in-tab-group-name alist if it have a 'tab-group property"
    (when (window-get win 'tab-group)
      (setq in-tab-group-name (remove (assoc last-unmap-id in-tab-group-name) in-tab-group-name))))

  (define (focus-in-tab win)
    (let ((timer-wait (if raise-windows-on-focus raise-window-timeout '1)))
      (if (or (eq focus-mode 'click)
              (eq (window-get win 'focus-mode) 'click))
          (setq timer-wait '1))
      (setq timer-raise
            (make-timer (lambda ()
                          (if (or shade-hover-mode (window-get win 'shade-hover))
                              (raise-windows win (remove win (tab-group-windows-stacking-order win)))
                            (tab-refresh-group win 'raise)))
                        (quotient timer-wait 1000) (mod timer-wait 1000)))))

  (define (focus-out-tab)
    (when timer-raise
      (delete-timer timer-raise)
      (setq timer-raise nil)))

  (define (unshade-tab win)
    (let ((unshade-nil))
      (when (window-get win 'shade-hover-unshaded)
        (mapcar (lambda (w)
                  (if (not (window-get w 'shaded)) (setq unshade-nil 't))) (remove win (tab-group-windows win)))
        (when unshade-nil
          (window-put win 'shade-hover-unshaded nil)
          (clean-up)
          (setq unshade-nil nil)
          (mapcar (lambda (w)
                    (shade-window w)) (remove win (tab-group-windows win))))
        (set-input-focus win))))

  (unless batch-mode
    (add-hook 'after-add-window-hook in-tab-group)
    (add-hook 'unmap-notify-hook unmap-id)
    (add-hook 'window-state-change-hook
              (lambda (win args)
                (when (window-tabbed-p win)
                  (setq args (car args))
                  (cond ((eq 'sticky args)
                         (tab-refresh-group win 'sticky)
                         (tab-refresh-group win 'frame))
                        ((eq 'fixed-position args)
                         (tab-refresh-group win 'fixed-position)
                         (tab-refresh-group win 'frame))
                        ((eq 'fixed-size args)
                         (tab-refresh-group win 'fixed-size)
                         (tab-refresh-group win 'frame))
                        ((eq 'frame-style args)
                         (tab-refresh-group win 'style)
                         (tab-refresh-group win 'reframe-all)
                         (tab-refresh-group win 'move))
                        ((eq 'type args)
                         (tab-refresh-group win 'type)
                         (tab-refresh-group win 'reframe))
                        ((eq 'stacking args)
                         (tab-refresh-group win 'depth)
                         (tab-refresh-group win 'frame))))))

    (when (eq move-outline-mode 'opaque)
      (add-hook 'before-move-hook (lambda (win) (if (window-tabbed-p win) (before-move win)))))
    (add-hook 'after-move-hook  (lambda (win) (after-move-resize win)))
    (when (eq resize-outline-mode 'opaque)
      (add-hook 'before-resize-hook (lambda (win) (if (window-tabbed-p win) (before-move-resize win)))))
    (add-hook 'after-resize-hook  (lambda (win) (after-move-resize win)))
    (add-hook 'focus-in-hook (lambda (win) (if (window-tabbed-p win) (focus-in-tab win))))
    (add-hook 'focus-out-hook (lambda (win) (if (window-tabbed-p win) (focus-out-tab))))
    (add-hook 'unshade-window-hook (lambda (win) (if (window-tabbed-p win) (unshade-tab win))))
    (add-hook 'iconify-window-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'iconify))))
    (add-hook 'uniconify-window-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'uniconify))))
    (add-hook 'window-maximized-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'maximized))))
    (add-hook 'window-unmaximized-hook (lambda (win) (if (window-tabbed-p win) (tab-refresh-group win 'maximized))))
    (add-hook 'destroy-notify-hook destroy-hook))

  (gaol-add set-tab-theme-name set-tab-theme-tabbars tab-refresh-group tab-group-windows))

;; theme file, written Tue Aug  1 13:08:21 2000
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("bottom-border"
         (inactive
          "bottom-border.png")
         (focused
          "bottom-border.png"))
        ("left-border"
         (inactive
          "left-border.png")
         (focused
          "left-border.png"))
        ("right-border"
         (inactive
          "right-border.png")
         (focused
          "right-border.png"))
        ("bottom-left-corner"
         (inactive
          "bottom-left-corner-inactive.png")
         (focused
          "bottom-left-corner.png")
         (clicked
          "bottom-left-corner-pressed.png"))
        ("bottom-right-corner"
         (inactive
          "bottom-right-corner-inactive.png")
         (focused
          "bottom-right-corner.png")
         (clicked
          "bottom-right-corner-pressed.png"))
        ("top-left-corner"
         (inactive
          "top-left-corner.png")
         (focused
          "top-left-corner.png"))
        ("top-right-corner"
         (inactive
          "top-right-corner.png")
         (focused
          "top-right-corner.png"))
        ("title-background"
         (inactive
          "title-background.png")
         (focused
          "title-background.png"))
        ("title-foreground"
         (inactive
          "title-foreground-inactive.png")
         (focused
          "title-foreground.png"))
        ("title-foreground-left"
         (inactive
          "title-foreground-left.png")
         (focused
          "title-foreground-left.png"))
        ("title-foreground-right"
         (inactive
          "title-foreground-right.png")
         (focused
          "title-foreground-right.png"))
        ("title-text-colors"
         (inactive . "#000000")
         (focused . "#ffffff"))
        ("close-button"
         (inactive
          "close-button-inactive.png")
         (focused
          "close-button.png")
         (clicked
          "close-button-pressed.png"))
        ("iconify-button"
         (inactive
          "iconify-button-inactive.png")
         (focused
          "iconify-button.png")
         (clicked
          "iconify-button-pressed.png"))
        ("maximize-button"
         (inactive
          "maximize-button-inactive.png")
         (focused
          "maximize-button.png")
         (clicked
          "maximize-button-pressed.png"))
        ("bottom-border-transient"
         (inactive
          "bottom-border-transient.png")
         (focused
          "bottom-border-transient.png"))
        ("left-border-transient"
         (inactive
          "left-border-transient.png")
         (focused
          "left-border-transient.png"))
        ("right-border-transient"
         (inactive
          "right-border-transient.png")
         (focused
          "right-border-transient.png"))
        ("top-left-corner-transient"
         (inactive
          "top-left-corner-transient-inactive.png")
         (focused
          "top-left-corner-transient.png")
         (clicked
          "top-left-corner-transient-pressed.png"))
        ("top-right-border-transient"
         (inactive
          "top-right-corner-transient-inactive.png")
         (focused
          "top-right-corner-transient.png")
         (clicked
          "top-right-corner-transient-pressed.png"))
        ("bottom-left-corner-transient"
         (inactive
          "bottom-left-corner-transient-inactive.png")
         (focused
          "bottom-left-corner-transient.png")
         (clicked
          "bottom-left-corner-transient-pressed.png"))
        ("bottom-right-corner-transient"
         (inactive
          "bottom-right-corner-transient-inactive.png")
         (focused
          "bottom-right-corner-transient.png")
         (clicked
          "bottom-right-corner-transient-pressed.png"))
        ("title-transient"
         (inactive
          "title-transient.png")
         (focused
          "title-transient.png"))
        ("title-transient-shaped"
         (inactive
          "title-transient-shaped.png")
         (focused
          "title-transient-shaped.png"))
        ("title-transient-shaped-left"
         (inactive
          "title-transient-shaped-left-inactive.png")
         (focused
          "title-transient-shaped-left.png"))
        ("title-transient-shaped-right"
         (inactive
          "title-transient-shaped-right-inactive.png")
         (focused
          "title-transient-shaped-right.png"))
        ("title-shaped"
         (inactive
          "title-shaped-inactive.png")
         (focused
          "title-shaped.png"))
        ("title-shaped-left"
         (inactive
          "title-shaped-left.png")
         (focused
          "title-shaped-left.png"))
        ("title-shpaed-right"
         (inactive
          "title-shaped-right.png")
         (focused
          "title-shaped-right.png"))))

     (frames-alist
      '(("default"
         ((cursor . left_ptr)
          (bottom-edge . -7)
          (right-edge . 23)
          (left-edge . 23)
          (background . "bottom-border")
          (class . bottom-border))
         ((cursor . left_ptr)
          (left-edge . -2)
          (bottom-edge . 0)
          (top-edge . 0)
          (background . "left-border")
          (class . left-border))
         ((cursor . left_ptr)
          (right-edge . -2)
          (bottom-edge . 0)
          (top-edge . 0)
          (background . "right-border")
          (class . right-border))
         ((cursor . left_ptr)
          (bottom-edge . -7)
          (left-edge . -2)
          (background . "bottom-left-corner")
          (class . bottom-left-corner))
         ((cursor . left_ptr)
          (right-edge . -2)
          (bottom-edge . -7)
          (background . "bottom-right-corner")
          (class . bottom-right-corner))
         ((cursor . left_ptr)
          (top-edge . -24)
          (left-edge . -2)
          (background . "top-left-corner")
          (class . top-left-corner))
         ((cursor . left_ptr)
          (right-edge . -2)
          (top-edge . -24)
          (background . "top-right-corner")
          (class . top-right-corner))
         ((cursor . left_ptr)
          (left-edge . 0)
          (right-edge . 0)
          (top-edge . -24)
          (background . "title-background")
          (class . title))
         ((top-edge . -22)
          (right-edge . 35)
          (left-edge . 21)
          (text . window-name)
          (y-justify . center)
          (x-justify . center)
          (background . "title-foreground")
          (foreground . "title-text-colors")
          (class . title))
         ((left-edge . 19)
          (background . "title-foreground-left")
          (top-edge . -22)
          (class . title))
         ((right-edge . 33)
          (top-edge . -22)
          (background . "title-foreground-right")
          (class . title))
         ((top-edge . -18)
          (left-edge . 4)
          (background . "close-button")
          (class . close-button))
         ((right-edge . 18)
          (top-edge . -18)
          (background . "iconify-button")
          (class . iconify-button))
         ((right-edge . 4)
          (top-edge . -18)
          (background . "maximize-button")
          (class . maximize-button)))
        ("shaped"
         ((cursor . left_ptr)
          (left-edge . 21)
          (right-edge . 35)
          (top-edge . -24)
          (text . window-name)
          (y-justify . center)
          (x-justify . center)
          (background . "title-shaped")
          (foreground . "title-text-colors")
          (class . title))
         ((left-edge . -2)
          (top-edge . -24)
          (background . "title-shaped-left")
          (class . title))
         ((right-edge . -2)
          (cursor . left_ptr)
          (top-edge . -24)
          (background . "title-shpaed-right")
          (class . title))
         ((top-edge . -18)
          (left-edge . 4)
          (background . "close-button")
          (class . close-button))
         ((right-edge . 18)
          (top-edge . -18)
          (background . "iconify-button")
          (class . iconify-button))
         ((right-edge . 4)
          (top-edge . -18)
          (background . "maximize-button")
          (class . maximize-button)))
        ("transient"
         ((cursor . left_ptr)
          (left-edge . 11)
          (right-edge . 11)
          (bottom-edge . -4)
          (background . "bottom-border-transient")
          (class . bottom-border))
         ((cursor . left_ptr)
          (top-edge . 0)
          (bottom-edge . 0)
          (left-edge . -4)
          (background . "left-border-transient")
          (class . left-border))
         ((cursor . left_ptr)
          (right-edge . -4)
          (background . "right-border-transient")
          (bottom-edge . 0)
          (top-edge . 0)
          (class . right-border))
         ((cursor . left_ptr)
          (bottom-edge . -4)
          (left-edge . -4)
          (background . "bottom-left-corner-transient")
          (class . bottom-left-corner))
         ((cursor . left_ptr)
          (bottom-edge . -4)
          (right-edge . -4)
          (background . "bottom-right-corner-transient")
          (class . bottom-right-corner))
         ((cursor . left_ptr)
          (top-edge . -4)
          (left-edge . -4)
          (background . "top-left-corner-transient")
          (class . top-left-corner))
         ((cursor . left_ptr)
          (top-edge . -4)
          (right-edge . -4)
          (background . "top-right-border-transient")
          (class . top-right-corner))
         ((right-edge . 11)
          (left-edge . 11)
          (top-edge . -4)
          (background . "title-transient")
          (class . title)))
        ("shaped-transient"
         ((right-edge . 11)
          (left-edge . 11)
          (top-edge . -4)
          (foreground . "#000000000000")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (background . "title-transient-shaped")
          (class . title))
         ((left-edge . -4)
          (background . "title-transient-shaped-left")
          (top-edge . -4)
          (class . title))
         ((top-edge . -4)
          (right-edge . -4)
          (background . "title-transient-shaped-right")
          (class . title)))))

     (mapping-alist
      '((default . "default")
        (shaped . "shaped")
        (transient . "transient")
        (shaped-transient . "shaped-transient")
        (unframed . "nil")))

     (theme-name 'Zami-like))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

;; nokogiri-widgets/color.jl -- color selector widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widgets.color

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
          sawfish.gtk.widget)

  (defconst default-color "#000000")

  (define (make-color-item changed-callback)
    (let* ((value default-color)
	   (button (gtk-color-button-new-with-color
                    (gdk-color-parse-interp value))))
      (g-signal-connect button "color-set"
                        (lambda ()
                          (let ((color (gtk-color-button-get-color-interp
                                        button)))
                            (setq value color)
                            (call-callback changed-callback))))
      (gtk-widget-show button)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (setq value x)
		   (gtk-color-button-set-color button (gdk-color-parse-interp
                                                       value))))
	  ((clear) (lambda ()
		     (setq value default-color)
		     (gtk-color-button-set-color button (gdk-color-parse-interp
                                                         value))))
	  ((ref) (lambda () value))
	  ((gtk-widget) button)
	  ((validp) (lambda (x)
		      (and (stringp x) (string-match "^#" x))))))))

  (define-widget-type 'color make-color-item))

;; wm-spec.jl -- implement the new (GNOME/KDE) wm hints spec

;; $Id: wm-spec.jl,v 1.20 2000/12/08 23:14:32 jsh Exp $

;; Copyright (C) 1999, 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.state.wm-spec

    (export define-wm-spec-window-type
	    define-wm-spec-window-state)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.state.maximize)

  ;; todo:

  ;; - _NET_WORKAREA
  ;; - _NET_WM_NAME		-- needs to be in C code?
  ;; - _NET_WM_STRUT
  ;; - _NET_WM_ICON

  ;; maybe add some state extensions for things the spec doesn't
  ;; cover but existed in the old GNOME spec; e.g. _GNOME_WM_STATE_FOO
  ;; for FOO being DO_NOT_COVER, SKIP_FOCUS, ..?


;;; constants

  (defconst _NET_WM_MOVERESIZE_SIZE_TOPLEFT 0)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOP 1)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOPRIGHT 2)
  (defconst _NET_WM_MOVERESIZE_SIZE_RIGHT 3)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT 4)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOM 5)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT 6)
  (defconst _NET_WM_MOVERESIZE_SIZE_LEFT 7)
  (defconst _NET_WM_MOVERESIZE_MOVE 8)

  (defconst _NET_WM_STATE_REMOVE 0)
  (defconst _NET_WM_STATE_ADD 1)
  (defconst _NET_WM_STATE_TOGGLE 2)

  (define wm-spec-window-id nil)

  (define supported-protocols
    [_NET_CLIENT_LIST _NET_CLIENT_LIST_STACKING _NET_NUMBER_OF_DESKTOPS
     _NET_DESKTOP_GEOMETRY _NET_DESKTOP_VIEWPORT _NET_CURRENT_DESKTOP
     _NET_DESKTOP_NAMES _NET_ACTIVE_WINDOW _NET_CLOSE_WINDOW
     _NET_WM_MOVERESIZE _NET_WM_DESKTOP _NET_WM_WINDOW_TYPE _NET_WM_STATE])
  
  (defconst desktop-layer -1)
  (defconst dock-layer +1)

  (define supported-states '())


;;; setting the client list hints

  (define (update-client-list-hints)
    (define (set-prop lst prop)
      (let loop ((rest lst)
		 (collected '()))
	(cond ((null rest)
	       (set-x-property 'root prop
			       (apply vector (nreverse collected))
			       'WINDOW 32))
	      ((window-mapped-p (car rest))
	       (loop (cdr rest) (cons (window-id (car rest)) collected)))
	      (t (loop (cdr rest) collected)))))
    (set-prop (managed-windows) '_NET_CLIENT_LIST)
    (set-prop (stacking-order) '_NET_CLIENT_LIST_STACKING))


;; setting the desktop / viewport hints

  (define last-workspace nil)
  (define last-workspace-count 0)
  (define last-workspace-names nil)
  (define last-area nil)
  (define last-area-count nil)

  (define (update-workspace-hints)
    (let* ((limits (workspace-limits))
	   (port (screen-viewport))
	   (port-size viewport-dimensions)
	   (total-workspaces (1+ (- (cdr limits) (car limits)))))

      (define (set-ws-hints)
	;; _NET_NUMBER_OF_DESKTOPS
	(unless (equal last-workspace-count total-workspaces)
	  (setq last-workspace-count total-workspaces)
	  (set-x-property 'root '_NET_NUMBER_OF_DESKTOPS
			  (vector total-workspaces) 'CARDINAL 32))

	;; _NET_DESKTOP_NAMES
	(unless (equal last-workspace-names workspace-names)
	  (setq last-workspace-names workspace-names)
	  (set-x-text-property 'root '_NET_DESKTOP_NAMES
			       (apply vector workspace-names)))

	;; _NET_CURRENT_DESKTOP
	(unless (equal last-workspace
		       (- current-workspace (car limits)))
	  (setq last-workspace (- current-workspace (car limits)))
	  (set-x-property 'root '_NET_CURRENT_DESKTOP
			  (vector last-workspace) 'CARDINAL 32))

	;; _NET_DESKTOP_GEOMETRY
	(unless (equal last-area-count port-size)
	  (setq last-area-count port-size)
	  (set-x-property 'root '_NET_DESKTOP_GEOMETRY
			  (vector (* (car port-size) (screen-width))
				  (* (cdr port-size) (screen-height)))
			  'CARDINAL 32))

	;; _NET_DESKTOP_VIEWPORT
	(unless (equal last-area port)
	  (let ((view (make-vector (* total-workspaces 2))))
	    (let loop ((i 0))
	      (if (= i total-workspaces)
		  (set-x-property 'root '_NET_DESKTOP_VIEWPORT
				  view 'CARDINAL 32)
		(aset view (* i 2) (* (car port) (screen-width)))
		(aset view (1+ (* i 2)) (* (cdr port) (screen-width)))
		(loop (1+ i)))))))

      (define (set-window-hints w)
	(let
	    ;; XXX the gnome-wm standard sucks..!
	    ((space (and (not (window-get w 'sticky))
			 (window-get w 'swapped-in))))
	  (if space
	      (set-x-property w '_NET_WM_DESKTOP
			      (vector (- space (car limits))) 'CARDINAL 32)
	    (set-x-property w '_NET_WM_DESKTOP
			    (vector #xffffffff) 'CARDINAL 32))))
		 
      ;; apparently some pagers don't like it if we place windows
      ;; on (temporarily) non-existent workspaces
      (when (< last-workspace-count total-workspaces)
	(set-ws-hints))

      (map-windows set-window-hints)

      (when (>= last-workspace-count total-workspaces)
	(set-ws-hints))))


;;; setting the focus hints

  (define last-focus nil)

  (define (update-focus-state)
    (let ((focus (input-focus)))
      (unless (eq last-focus focus)
	(setq last-focus focus)
	(set-x-property 'root '_NET_ACTIVE_WINDOW
			(vector (if focus (window-id focus) 0)) 'WINDOW 32))))


;;; setting the window state hints

  (define (update-client-state w)
    (let ((state (filter (lambda (x) (not (supported-state-p x)))
			 (window-get w 'wm-spec-last-states))))
      (mapc (lambda (x)
	      (when (and (not (pseudo-state-p x))
			 (call-state-fun w x 'get))
		(setq state (cons x state))))
	    supported-states)
      (set-x-property w '_NET_WM_STATE (apply vector state) 'ATOM 32)
      (window-put w 'wm-spec-last-states state)))


;;; honouring the initially set window state hints

  (define (update-icon-geometry w geom)
    (when (>= (length geom) 2)
      (window-put w 'icon-position (cons (aref geom 0) (aref geom 1)))))

  (define (wm-class-hacks w)
    (let ((class (get-x-text-property w 'WM_CLASS)))
      (when (and class (>= (length class) 2))
	(cond ((or (and (string= (aref class 1) "Panel")
			(string= (aref class 0) "panel"))
		   (and (string= (aref class 1) "kicker")
			(string= (aref class 0) "Panel")))
	       (window-put w 'focus-click-through t)
	       (window-put w 'avoid t)
	       (window-put w 'no-history t)
	       (window-put w 'never-iconify t)
	       (window-put w 'never-maximize t)
	       (window-put w 'sticky t)
	       (window-put w 'sticky-viewport t)
	       ;; XXX see gnome.jl for why this is needed..
	       (window-put w 'placed t))
	      ((string= (aref class 1) "gmc-desktop-icon")
	       (window-put w 'never-focus t)
	       (window-put w 'never-iconify t)
	       (window-put w 'never-maximize t))))))

  (define (honour-client-state w)
    ;; things the wm-hints doesn't supply
    (wm-class-hacks w)

    (let ((space (get-x-property w '_NET_WM_DESKTOP)))
      (when space
	(setq space (aref (nth 2 space) 0))
	(cond ((equal space #xffffffff)
	       (window-put w 'sticky t))
	      ((and (integerp space) (null (window-workspaces w)))
	       (set-window-workspaces w (list space))))))

    (let ((type (get-x-property w '_NET_WM_WINDOW_TYPE)))
      (when type
	(setq type (nth 2 type))
	;; _NET_WM_WINDOW_TYPE is a vector of atoms, the first atom
	;; about which we know something is the type we'll use
	(let loop ((i 0))
	  (cond ((= i (length type)))
		((get (aref type i) 'wm-spec-type)
		 ((get (aref type i) 'wm-spec-type) w))
		(t (loop (1+ i)))))))

    (let ((state (get-x-property w '_NET_WM_STATE)))
      (when state
	(setq state (nth 2 state))
	(do ((i 0 (1+ i)))
	    ((= i (length state)))
	  (call-state-fun w (aref state i) 'init))
	(window-put w 'wm-spec-last-states (vector->list state))))

    (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
      (when geom
	(update-icon-geometry w (nth 2 geom)))))


;;; helper functions

  (define (define-wm-spec-window-type x fun) (put x 'wm-spec-type fun))

  (define (define-wm-spec-window-state x fun #!key pseudo)
    (put x 'wm-spec-state fun)
    (unless (memq x supported-states)
      (setq supported-states (cons x supported-states)))
    (when pseudo
      (put x 'wm-spec-pseudo-state t)))

  (define (supported-state-p x) (get x 'wm-spec-state))
  (define (pseudo-state-p x) (get x 'wm-spec-pseudo-state))

  (define (call-state-fun w state mode)
    (let ((fun (get state 'wm-spec-state)))
      (when fun
	(fun w mode))))

  (define-wm-spec-window-type
   '_NET_WM_WINDOW_TYPE_DESKTOP
   (lambda (w)
     (require 'sawfish.wm.stacking)
     (mark-window-as-desktop w)
     (window-put w 'fixed-position t)
     ;; I thought these would be set by the application, but KDE doesn't..
     (window-put w 'type 'unframed)
     (window-put w 'sticky t)
     (window-put w 'sticky-viewport t)
     (set-window-depth w desktop-layer)))

  (define-wm-spec-window-type
   '_NET_WM_WINDOW_TYPE_DOCK
   (lambda (w)
     (require 'sawfish.wm.stacking)
     (set-window-depth w dock-layer)
     (window-put w 'window-list-skip t)
     (window-put w 'cycle-skip t)))

  (define-wm-spec-window-type
   '_NET_WM_WINDOW_TYPE_DIALOG
   (lambda (w)
     (require 'sawfish.wm.frames)
     (set-window-type w 'transient)))

  (define-wm-spec-window-state
   '_NET_WM_STATE_STICKY
   (lambda (w mode)
     (require 'sawfish.wm.state.iconify)
     (case mode
       ((init)   (window-put w 'sticky-viewport t))
       ((remove) (window-put w 'sticky-viewport nil))
       ((add)    (window-put w 'sticky-viewport t))
       ((toggle) (window-put w 'sticky-viewport
			     (not (window-get w 'sticky-viewport))))
       ((get)    (window-get w 'sticky-viewport)))
     (unless (memq mode '(init get))
       (call-window-hook 'window-state-change-hook w (list '(sticky))))))

  (define (wm-spec-maximize-handler direction)
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
	((init)
	 (window-put w (if (eq direction 'vertical)
			   'queued-vertical-maximize
			 'queued-horizontal-maximize) t))
	((remove) (unmaximize-window w direction))
	((add)    (maximize-window w direction))
	((toggle) (maximize-window-toggle w direction))
	((get)    (case direction
		    ((vertical) (window-maximized-vertically-p w))
		    ((horizontal) (window-maximized-horizontally-p w))
		    (t (window-maximized-p w)))))))

  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_VERT
			       (wm-spec-maximize-handler 'vertical))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_HORIZ
			       (wm-spec-maximize-handler 'horizontal))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED
			       (wm-spec-maximize-handler nil)
			       #:pseudo t)

  (define-wm-spec-window-state
   '_NET_WM_STATE_SHADED
   (lambda (w mode)
     (require 'sawfish.wm.state.shading)
     (case mode
       ((init)   (window-put w 'shaded t))
       ((add)    (shade-window w))
       ((remove) (unshade-window w))
       ((toggle) (toggle-window-shaded w))
       ((get)    (window-get w 'shaded)))))

  (define-wm-spec-window-state
   '_NET_WM_STATE_SKIP_PAGER
   (lambda (w mode)
     (case mode
       ((init add) (window-put w 'window-list-skip t))
       ((remove)   (window-put w 'window-list-skip nil))
       ((toggle)   (window-put w 'window-list-skip
			       (not (window-get w 'window-list-skip))))
       ((get)      (window-get w 'window-list-skip)))))


;;; client messages

  (define (client-message-handler w type data)
    (let ((handled t))
      (case type
	((_NET_CLOSE_WINDOW)
	 (when (windowp w)
	   (delete-window w)))

	((_NET_WM_MOVERESIZE)
	 (when (and (windowp w) (window-mapped-p w))
	   (require 'sawfish.wm.commands.move-resize)
	   (let ((mode (aref data 2)))
	     (if (eq mode _NET_WM_MOVERESIZE_MOVE)
		 (move-window-interactively w)
	       (let ((move-resize-moving-edges
		      (cond ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPLEFT) '(top left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOP) '(top))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPRIGHT) '(top right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT) '(bottom left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOM) '(bottom))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT) '(bottom right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_LEFT) '(left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_RIGHT) '(right)))))
		 (resize-window-interactively w))))))

	((_NET_NUMBER_OF_DESKTOPS _NET_DESKTOP_GEOMETRY)
	 ;; XXX these conflict with user preferences
	 )

	((_NET_DESKTOP_VIEWPORT)
	 (set-viewport (aref data 0) (aref data 1)))

	((_NET_CURRENT_DESKTOP)
	 (select-workspace (workspace-id-from-logical (aref data 0))))

	((_NET_DESKTOP_NAMES)
	 (setq data (aref data 0))
	 (let loop ((i 0)
		    (out '()))
	   (if (= i (length data))
	       (setq workspace-names (nreverse out))
	     (loop (1+ i) (cons (aref data i) out)))))

	((_NET_ACTIVE_WINDOW)
	 (when (and (windowp w) (window-mapped-p w))
	   ;; XXX select workspace / viewport automatically?
	   (set-input-focus w)))

	((_NET_WM_STATE)
	 (when (windowp w)
	   (let ((mode (cond ((eql (aref data 0) _NET_WM_STATE_REMOVE) 'remove)
			     ((eql (aref data 0) _NET_WM_STATE_ADD) 'add)
			     ((eql (aref data 0) _NET_WM_STATE_TOGGLE) 'toggle)))
		 (atom1 (x-atom-name (aref data 1)))
		 (atom2 (x-atom-name (aref data 2))))
	     (when (or (and (eq atom1 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom2 '_NET_WM_STATE_MAXIMIZED_HORIZ))
		       (and (eq atom2 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom1 '_NET_WM_STATE_MAXIMIZED_HORIZ)))
	       (setq atom1 '_NET_WM_STATE_MAXIMIZED)
	       (setq atom2 nil))
	     (when atom1
	       (call-state-fun w atom1 mode))
	     (when atom2
	       (call-state-fun w atom2 mode)))))

	(t (setq handled nil)))
      handled))


;;; property changes

  (define (property-change-handler w prop kind)
    (declare (unused kind))
    (case prop
      ((_NET_WM_ICON_GEOMETRY)
       (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
	 (when geom
	   (update-icon-geometry w (nth 2 geom)))))))


;;; utilities

  (define (vector->list vec)
    (do ((i 0 (1+ i))
	 (out '() (cons (aref vec i) out)))
	((= i (length vec)) (nreverse out))))


;;; initialisation

  (define (init)
    (setq wm-spec-window-id (create-window 'root -200 -200 5 5))

    (set-x-property 'root '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_WM_NAME "Sawfish" 'STRING 8)

    (set-x-property 'root '_NET_SUPPORTED supported-protocols 'ATOM 32)

    (update-client-list-hints)
    (update-workspace-hints)

    (add-hook 'workspace-state-change-hook update-workspace-hints)
    (add-hook 'viewport-resized-hook update-workspace-hints)
    (add-hook 'viewport-moved-hook update-workspace-hints)

    (add-hook 'add-window-hook update-client-list-hints)
    (add-hook 'destroy-notify-hook update-client-list-hints)
    (add-hook 'map-notify-hook update-client-list-hints)
    (add-hook 'unmap-notify-hook update-client-list-hints)
    (add-hook 'workspace-state-change-hook update-client-list-hints)

    (add-hook 'before-add-window-hook honour-client-state)
    (add-hook 'add-window-hook update-client-state)
    (call-after-state-changed '(sticky shaded maximized stacking)
			      update-client-state)

    (add-hook 'focus-in-hook update-focus-state)
    (add-hook 'focus-out-hook update-focus-state)

    (add-hook 'client-message-hook client-message-handler)
    (add-hook 'property-notify-hook property-change-handler)

    (add-hook 'before-exit-hook exit)

    (map-windows update-client-state))

  (define (exit)
    (destroy-window wm-spec-window-id)
    (delete-x-property 'root '_NET_SUPPORTING_WM_CHECK)
    (delete-x-property 'root '_NET_PROTOCOLS)
    (delete-x-property 'root '_NET_DESKTOP_GEOMETRY)
    (delete-x-property 'root '_NET_DESKTOP_VIEWPORT))

  (unless (or wm-spec-window-id batch-mode)
    (init)))

;; old-window-menu.jl

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; This is the "old" window menu. By default, beos-window-menu is used
;; instead. But **DON'T** remove. There sure exist those who use it,
;; according to a questionnaire.

;; Usage: add (require 'sawfish.wm.ext.old-window-menu) in your rc file.

(define-structure sawfish.wm.ext.old-window-menu

    (export old-window-menu)

    (open rep
	  rep.util.utf8
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.misc
	  sawfish.wm.menus
	  sawfish.wm.util.display-window)

  (define-structure-alias old-window-menu sawfish.wm.ext.old-window-menu)

  (define (make-label w)
    (let ((name (window-name w)))
      (quote-menu-item (concat (and (window-get w 'iconified) ?\[)
			       (if (> (utf8-string-length name) 20)
				   (concat (utf8-substring name 0 20) "...")
				 name)
			       (and (window-get w 'iconified)  ?\])))))

  (define (old-window-menu)
    (let* ((limits (workspace-limits))
	   (windows (managed-windows))
	   menu)
      (do ((i (car limits) (1+ i)))
	  ((> i (cdr limits)))
	(mapc (lambda (w)
		(when (and (window-in-workspace-p w i)
			   (window-mapped-p w)
			   (not (window-get w 'window-list-skip))
			   (or (not (window-get w 'ignored))
			       (window-get w 'iconified)))
		  (setq menu (cons (list (make-label w)
					 (lambda ()
					   (when (windowp w)
					     (display-window w)))
					 (cons 'check (eq (input-focus) w))
					 '(group . old-window-menu))
				   menu))))
	      windows)
	(unless (or (= i (cdr limits)) (null (car menu)))
	  (setq menu (cons nil menu))))
      ;; search for any iconified windows that aren't anywhere else in the menu
      (let (extra)
	(mapc (lambda (w)
		(when (and (not (window-get w 'window-list-skip))
			   (window-get w 'iconified)
			   (window-get w 'sticky))
		  (setq extra (cons (list (make-label w)
					  `(display-window
					    (get-window-by-id ,(window-id w))))
				    extra))))
	      windows)
	(when extra
	  (setq menu (if menu (nconc extra (list nil) menu) extra))))
      (nreverse menu)))

  (setq window-menu old-window-menu))

;; cycle.jl -- simple window cycling

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.cycle

    (export next-workspace-window
	    previous-workspace-window
	    next-window
	    previous-window)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.util.display-window)

  (define-structure-alias cycle sawfish.wm.commands.cycle)

  (define (next-workspace-window)
    "Select the next window of the current workspace."
    (let ((windows (delete-if-not window-in-cycle-p
				  (workspace-windows current-workspace))))
      (display-window (or (nth 1 (memq (input-focus) windows))
			  (car windows)))))

  (define (previous-workspace-window)
    "Focus on the previous window of the current workspace."
    (let ((windows (nreverse
		    (delete-if-not window-in-cycle-p
				   (workspace-windows current-workspace)))))
      (display-window (or (nth 1 (memq (input-focus) windows))
			  (car windows)))))

  (define (next-window)
    "Select the next window, cycling through all possible workspaces."
    (catch 'out
      (let* ((space current-workspace)
	     (limits (workspace-limits))
	     (windows (lambda ()
			(delete-if-not window-in-cycle-p
				       (workspace-windows space))))
	     (win (nth 1 (memq (input-focus) (windows)))))
	(while (not win)
	  (setq space (1+ space))
	  (when (> space (cdr limits))
	    (setq space (car limits)))
	  (when (= space current-workspace)
	    (throw 'out nil))
	  (setq win (car (windows))))
	(when win
	  (display-window win)))))

  (define (previous-window)
    "Select the previous window, cycling through all possible workspaces."
    (catch 'out
      (let* ((space current-workspace)
	     (limits (workspace-limits))
	     (windows (lambda ()
			(nreverse (delete-if-not window-in-cycle-p
						 (workspace-windows space)))))
	     (win (nth 1 (memq (input-focus) (windows)))))
	(while (not win)
	  (setq space (1- space))
	  (when (< space (car limits))
	    (setq space (cdr limits)))
	  (when (= space current-workspace)
	    (throw 'out nil))
	  (setq win (car (windows))))
	(when win
	  (display-window win)))))

  ;;###autoload
  (define-command 'next-workspace-window next-workspace-window)
  (define-command 'previous-workspace-window previous-workspace-window)
  (define-command 'next-window next-window)
  (define-command 'previous-window previous-window))

;; sm-load.jl -- session manager code to reload a saved session

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This currently assumes that load-session is called before any
;; windows are adopted. If this isn't the case apply-to-window
;; will need extra code to act on the restored state (which would
;; otherwise be done by functions in the add-window-hook)

(define-structure sawfish.wm.session.load

    (export load-session)

    (open rep
	  rep.system
	  rep.io.files
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.session.init
	  sawfish.wm.session.util)

  (define restored-session nil)

  (define (load-session filename)
    (setq restored-session nil)
    (when (file-exists-p filename)
      (let ((file (open-file filename 'read)))
	(when file
	  (unwind-protect
	      (condition-case nil
		  (while t
		    (setq restored-session (cons (read file)
						 restored-session)))
		(end-of-stream
		 (setq restored-session (nreverse restored-session))))
	    (close-file file))
	  (map-windows match-window)))))

  ;; Scan restored-session for window W
  (define (match-window w)
    (let ((item (catch 'found
		  (mapc (lambda (x)
			  (when (match-window-to-alist w x)
			    (throw 'found x)))
			restored-session))))
      (when item
	(setq restored-session (delq item restored-session))
	(apply-to-window w item))))

  ;; Match window W to ALIST
  (define (match-window-to-alist w alist)
    (let ((client-id (sm-get-window-prop w 'SM_CLIENT_ID))
	  (role (nth 2 (get-x-property w 'WM_WINDOW_ROLE)))
	  (class (sm-get-window-prop w 'WM_CLASS))
	  (name (sm-get-window-prop w 'WM_NAME))
	  (command (sm-get-window-prop w 'WM_COMMAND)))
      (catch 'out
	(when (and (not sm-sloppy-id-matching)
		   (not (eq (not (cdr (assq 'client-id alist)))
			    (not client-id))))
	  ;; one has a client-id, the other doesn't -- no match
	  (throw 'out nil))

	(cond (client-id
	       (unless (string= client-id (cdr (assq 'client-id alist)))
		 ;; id's don't match
		 (throw 'out nil)))
	      ;; no SM_CLIENT_ID, so try matching WM_COMMAND
	      ((and command (cdr (assq 'command alist)))
	       (unless (string= command (cdr (assq 'command alist)))
		 (throw 'out nil)))
	      ;; no WM_COMMAND so no match
	      (t
	       (throw 'out nil)))

	(if (and role (cdr (assq 'role alist)))
	    (unless (string= role (cdr (assq 'role alist)))
	      (throw 'out nil))
	  ;; no WM_WINDOW_ROLE, so try matching WM_CLASS
	  (when (and class (cdr (assq 'class alist))
		     (not (string= class (cdr (assq 'class alist)))))
            (throw 'out nil))
	  ;; no WM_CLASS, so try matching WM_NAME
	  (when (and name (cdr (assq 'name alist))
		     (not (string= name (cdr (assq 'name alist)))))
	    (throw 'out nil)))

	;; XXX match on WM_NAME and WM_CLIENT_MACHINE..?

	;; if we got here it must be a match
	t)))

  ;; Apply saved state in ALIST to W. This assumes that the add window
  ;; hook hasn't been called yet
  (define (apply-to-window w alist)
    (let (tem)
      (when (setq tem (cdr (assq 'dimensions alist)))
	(resize-window-to w (car tem) (cdr tem)))
      (mapc (lambda (lst)
	      (mapc (lambda (sym)
		      (when (setq tem (cdr (assq sym alist)))
			(window-put w sym tem))) lst))
	    (list sm-saved-window-properties sm-restored-window-properties))
      (call-window-hook 'sm-restore-window-hook w (list alist))))

  (add-hook 'before-add-window-hook match-window))

; microGUI/theme.jl

;; Copyright (C) 1999 Ryan Lovett <ryan@ocf.berkeley.edu>

;; This theme was based on the QNX Photon microGUI found at www.qnx.com
;; (screenshots at http://www.qnx.com/amiga/delivering.html). Many image
;; components were taken from the minEguE enlightenment theme by Ben
;; FrantzDale (frantzdb@admin.arhs.net). The theme and the rest of the images
;; were put together by Ryan (ryan@ocf.berkeley.edu).

;; hacked for lexical scope by John Harper

(let*
    ;; Update window title pixel length
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))
     
     ;; 2x6
     (bottom-images (make-image "bottom.png"))

     ;; 6x27
     (top-left-images (list (make-image "top_left_inactive.png")
			    (make-image "top_left.png")))
     (top-left-shaped-images (list (make-image "top_left_inactive_s.png")
				   (make-image "top_left_s.png")))

     ;; 19x19
     (top-blue-images (list (make-image "top_blue_inactive.png")
			    (make-image "top_blue.png")))

     ;; 12x19
     (top-curves-images (list (make-image "top_curves_inactive.png")
			      (make-image "top_curves.png")))

     ;; 19x19
     (top-grey-images (make-image "top_grey.png"))

     ;; 7x19
     (top-right-images (make-image "top_right.png"))
     (top-right-shaped-images (make-image "top_right_s.png"))

     ;; 6x6
     (bottom-left-images (make-image "bl.png"))

     ;; 6x6
     (bottom-right-images (make-image "br.png"))

     ;; 17x16
     (close-images (list (make-image "close_normal.png")
			 (make-image "close_active.png") nil
			 (make-image "close_clicked.png")))

     ;; 17x16
     (maximize-images (list (make-image "maximize_normal.png")
			    (make-image "maximize_active.png") nil
			    (make-image "maximize_clicked.png")))

     ;; 17x16
     (iconify-images (list (make-image "minimize_normal.png")
			   (make-image "minimize_active.png") nil
			   (make-image "minimize_clicked.png")))

     ;; 17x16
     (menu-images (list (make-image "menu_normal.png")
			(make-image "menu_active.png") nil
			(make-image "menu_clicked.png")))

     ;; 6x19
     (left-images (make-image "left.png"))

     ;; 6x19
     (right-images (make-image "right.png"))

     (top-images (flip-image-diagonally (copy-image left-images)))

     ;; 18x17
     (t-close-images (list (make-image "t_close_normal.png")
			   (make-image "t_close_active.png") nil
			   (make-image "t_close_clicked.png")))
     ;; 5x19
     (t-left-images (make-image "t_left.png"))

     ;; 18x10
     (t-right-images (make-image "t_right.png"))

     ;; 19x5
     (t-top-images (make-image "t_top.png"))

     ;; 19x5
     (t-bottom-images (make-image "t_bottom.png"))

     ;; 4x4
     (t-top-left-images (make-image "t_top_left.png"))

     ;; 4x4
     (t-bottom-left-images (make-image "t_bottom_left.png"))

     ;; 17x4
     (t-top-right-images (make-image "t_top_right.png"))

     ;; 17x4
     (t-bottom-right-images (make-image "t_bottom_right.png"))

     (text-colors '("grey85" "white"))

     ;; frame layout

     (frame `(((background . ,top-left-images)
	       (left-edge . -6)
	       (top-edge . -19)
	       (class . top-left-corner))

	      ;; top blue
	      ((background . ,top-blue-images)
	       (foreground . ,text-colors)
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -19)
	       (left-edge . 19)
	       (width . ,(lambda (w) (+ (title-width w) 13)))
	       (class . title))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -19)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; top curves
	      ((background . ,top-curves-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 32)))
	       (top-edge . -19)
	       (class . title))

	      ;; top grey
	      ((background . ,top-grey-images)
	       (top-edge . -19)
	       (left-edge . ,(lambda (w) (+ (title-width w) 44)))
	       (right-edge . 52)
	       (class . title))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -6)
	       (top-edge . 8)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; top-right corner
	      ((background . ,top-right-images)
	       (right-edge . -6)
	       (top-edge . -19)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -6)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 35)
	       (top-edge . -19)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 18)
	       (top-edge . -19)
	       (class . maximize-button))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . 1)
	       (top-edge . -19)
	       (class . close-button))))

       (shaped-frame `(((background . ,top-left-shaped-images)
			(left-edge . -6)
			(top-edge . -19)
			(height . 19)
			(class . top-left-corner))

		       ;; top blue
		       ((background . ,top-blue-images)
			(foreground . ,text-colors)
			(text . ,window-name)
			(x-justify . 4)
			(y-justify . center)
			(top-edge . -19)
			(left-edge . 19)
			(width . ,(lambda (w) (+ (title-width w) 13)))
			(class . title))

		       ;; menu button
		       ((background . ,menu-images)
			(top-edge . -19)
			(left-edge . 0)
			(class . menu-button))

		       ;; top curves
		       ((background . ,top-curves-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 32)))
			(top-edge . -19)
			(class . title))

		       ;; top grey
		       ((background . ,top-grey-images)
			(top-edge . -19)
			(left-edge . ,(lambda (w) (+ (title-width w) 44)))
			(right-edge . 52)
			(class . title))

		       ;; top-right corner
		       ((background . ,top-right-shaped-images)
			(right-edge . -6)
			(top-edge . -19)
			(height . 19)
			(class . top-right-corner))

		       ;; iconify button
		       ((background . ,iconify-images)
			(right-edge . 35)
			(top-edge . -19)
			(class . iconify-button))

		       ;; maximize button
		       ((background . ,maximize-images)
			(right-edge . 18)
			(top-edge . -19)
			(class . maximize-button))

		       ;; delete button
		       ((background . ,close-images)
			(right-edge . 1)
			(top-edge . -19)
			(class . close-button))))

       (transient-frame `(((background . ,t-top-left-images)
			   (left-edge . -5)
			   (top-edge . -5)
			   (class . top-left-corner))

			  ;;top-right corner
			  ((background . ,t-top-right-images)
			   (right-edge . -18)
			   (top-edge . -5)
			   (class . top-right-corner))

			  ;;title border
			  ((background . ,t-top-images)
			   (left-edge . -1)
			   (right-edge . -1)
			   (top-edge . -5)
			   (class . top-border))

			  ;; left border
			  ((background . ,t-left-images)
			   (left-edge . -5)
			   (top-edge . -1)
			   (bottom-edge . -1)
			   (class . left-border))

			  ;; right border
			  ((background . ,t-right-images)
			   (right-edge . -18)
			   (top-edge . -1)
			   (bottom-edge . -1)
			   (class . title))

			  ;; bottom border
			  ((background . ,t-bottom-images)
			   (left-edge . -1)
			   (right-edge . -1)
			   (bottom-edge . -5)
			   (class . bottom-border))

			  ;; bottom-left corner
			  ((background . ,t-bottom-left-images)
			   (left-edge . -5)
			   (bottom-edge . -5)
			   (class . bottom-left-corner))

			  ;; bottom-right corner
			  ((background . ,t-bottom-right-images)
			   (right-edge . -18)
			   (bottom-edge . -5)
			   (class . bottom-right-corner))

			  ;; delete button
			  ((background . ,t-close-images)
			   (right-edge . -18)
			   (top-edge . 1)
			   (class . close-button))))

       (shaped-transient-frame `(((background . ,t-top-right-images)
				  (right-edge . -18)
				  (top-edge . -5)
				  (class . top-right-corner))

				 ;; right border
				 ((background . ,t-right-images)
				  (right-edge . -18)
				  (top-edge . -1)
				  (bottom-edge . -1)
				  (class . title))

				 ;; bottom-right corner
				 ((background . ,t-bottom-right-images)
				  (right-edge . -18)
				  (bottom-edge . -5)
				  (class . bottom-right-corner))

				 ;; delete button
				 ((background . ,t-close-images)
				  (right-edge . -18)
				  (top-edge . 1)
				  (class . close-button)))))
  
  (add-frame-style 'microGUI
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'microGUI))))

;; configure.jl -- default configure-request handler

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.state.configure

    (export windows-intersect-p
	    window-occludes-p
	    configure-request-handler
	    configure-choose-gravity)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.workspace
	  sawfish.wm.stacking
	  sawfish.wm.state.maximize
	  sawfish.wm.util.stacking
	  sawfish.wm.viewport)

  (defvar configure-auto-gravity t
    "Automatically select window gravity from position on screen.")

  (defvar configure-ignore-stacking-requests nil
    "Ignore requests from applications to change window stacking.")

  ;; Returns true if window window1 and window2 intersect, false otherwise.
  (defun windows-intersect-p (window1 window2)
    (let ((w1pos (window-position window1))
	  (w2pos (window-position window2))
	  (w1dim (window-dimensions window1))
	  (w2dim (window-dimensions window2)))
      (not (or (not (windows-share-workspace-p window1 window2))
	       (> (car w1pos) (+ (car w2pos) (car w2dim)))
	       (> (car w2pos) (+ (car w1pos) (car w1dim)))
	       (> (cdr w1pos) (+ (cdr w2pos) (cdr w2dim)))
	       (> (cdr w2pos) (+ (cdr w1pos) (cdr w1dim)))))))

  ;; Returns true if window w occludes any window in the window
  ;; list wlist, false otherwise.  Windows do not occlude
  ;; themself.  If inverse is set and true, this function
  ;; returns whether w is occluded _by_ any window in wlist.
  (defun window-occludes-p (w wlist #!optional inverse)
    (letrec ((xid< (lambda (a b) (< (window-id a) (window-id b))))
	     (order (if inverse (reverse (stacking-order)) (stacking-order)))
	     (below-w (sort (cdr (member w order)) xid<))
	     (sorted-wlist (sort (copy-sequence wlist) xid<))
	     (iter (lambda (below wins)
		     (cond ((or (not below) (not wins)) nil)
			   ((xid< (car below) (car wins))
			    (iter (cdr below) wins))
			   ((xid< (car wins) (car below))
			    (iter below (cdr wins)))
			   ((windows-intersect-p w (car wins)) t)
			   (t (iter (cdr below) (cdr wins)))))))
      (iter below-w sorted-wlist)))

  (defun configure-request-handler (w alist)
    (let ((coords (window-position w))
	  (dims (window-dimensions w))
	  (hints (window-size-hints w))
	  tem)

      (when (and (setq tem (cdr (assq 'stack alist)))
		 (not configure-ignore-stacking-requests)
		 (not (window-get w 'ignore-stacking-requests)))
	(let ((relation (car tem))
	      (sibling (car (cdr tem))))
	  (case relation
	    ((above)
	     (if sibling (stack-window-above w sibling) (raise-window* w)))
	    ((below)
	     (if sibling (stack-window-below w sibling) (lower-window* w)))
	    ((top-if)
	     (if (window-occludes-p w (if sibling (list sibling)
					(stacking-order)) t)
		 (raise-window* w)))
	    ((bottom-if)
	     (if (window-occludes-p w (if sibling (list sibling)
					(stacking-order)))
		 (lower-window* w)))
	    ((opposite)
	     (cond ((window-occludes-p w (if sibling (list sibling)
					   (stacking-order)) t)
		    (raise-window* w))
		   ((window-occludes-p w (if sibling (list sibling)
					   (stacking-order)))
		    (lower-window* w))))
	    (t (error "Bad stacking relation: %s" relation)))))

      (when (setq tem (cdr (assq 'dimensions alist)))
	(when (not (assq 'position alist))
	  (let ((gravity (or (window-get w 'gravity)
			     (and (window-get w 'auto-gravity)
				  (configure-choose-gravity w))
			     (cdr (assq 'window-gravity hints))
			     (and configure-auto-gravity
				  (not (window-get w 'client-set-position))
				  (configure-choose-gravity w)))))

	    (unless (window-locked-horizontally-p w)
	      ;; anchor the window to the point specified by the gravity
	      (when (memq gravity '(east south-east north-east))
		;; [x] placed relative to the right of the frame
		(rplaca coords (- (car coords) (- (car tem) (car dims)))))
	      (when (memq gravity '(north center south))
		;; [x] placed relative to the center
		(rplaca coords (- (car coords) (quotient (- (car tem)
							    (car dims)) 2)))))
	    (unless (window-locked-vertically-p w)
	      (when (memq gravity '(south south-east south-west))
		;; [y] placed relative to the bottom of the frame
		(rplacd coords (- (cdr coords) (- (cdr tem) (cdr dims)))))
	      (when (memq gravity '(east center west))
		;; [y] placed relative to the center
		(rplacd coords (- (cdr coords) (quotient (- (cdr tem)
							    (cdr dims)) 2)))))))
	(unless (window-locked-horizontally-p w)
	  (rplaca dims (car tem)))
	(unless (window-locked-vertically-p w)
	  (rplacd dims (cdr tem))))

      (when (setq tem (cdr (assq 'position alist)))
	(let ((grav (window-gravity w hints)))
	  (when (and (car tem) (not (window-locked-horizontally-p w)))
	    (rplaca coords (adjust-position-for-gravity/x w grav (car tem))))
	  (when (and (cdr tem) (not (window-locked-vertically-p w)))
	    (rplacd coords (adjust-position-for-gravity/y w grav (cdr tem)))))
	;; if the program is setting its position, best not to interfere..
	(window-put w 'client-set-position t))

      (move-resize-window-to w (car coords) (cdr coords) (car dims) (cdr dims))

      ;; force the window to be somewhere in the virtual workspace..
      (when (and (not (window-get w 'client-set-position))
		 (window-outside-workspace-p w))
	(move-window-to-current-viewport w))))

  ;; decide which gravity to use to resize window W
  (defun configure-choose-gravity (w)
    (let* ((delta (lambda (x-1 y-1 x-2 y-2)
		    (+ (* (- x-2 x-1) (- x-2 x-1))
		       (* (- y-2 y-1) (- y-2 y-1)))))
	   (width (screen-width))
	   (height (screen-height))
	   (dims (window-frame-dimensions w))
	   (coords (window-absolute-position w))
	   (min-delta 1000000)
	   (min-i 1)
	   (min-j 1))

      (do ((i 0 (1+ i)))
	  ((= i 3))
	(do ((j 0 (1+ j)))
	    ((= j 3))
	  ;; divide the window into quarters; for each vertex find the
	  ;; distance to the same vertex of the screen. The minimum
	  ;; distance found gives the vertex to anchor the window to
	  (let
	      ((d (delta (+ (* i (/ (car dims) 2)) (car coords))
			 (+ (* j (/ (cdr dims) 2)) (cdr coords))
			 (* i (/ width 2))
			 (* j (/ height 2)))))
	    (when (< d min-delta)
	      (setq min-delta d)
	      (setq min-i i)
	      (setq min-j j)))))
      (aref (aref [[north-west north north-east]
		   [west center east]
		   [south-west south south-east]] min-j) min-i)))

  (add-hook 'configure-request-hook configure-request-handler))

;; decode-events.jl -- symbolic event manipulation

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.decode-events

    (export decode-modifier
	    encode-modifier
	    substitute-wm-modifier
	    decode-event
	    encode-event
	    string->keysym
	    modifier->keysyms
	    modifier-keysym-p
	    should-grab-button-event-p)

    (open rep
	  sawfish.wm.events)

  (define-structure-alias decode-events sawfish.wm.util.decode-events)

  (define (decode-modifier mods)
    (let ((out '()))
      (do ((i 0 (1+ i)))
	  ((= i 13))
	(when (not (zerop (logand mods (lsh 1 i))))
	  (setq out (cons (aref [shift lock control mod-1 mod-2
				       mod-3 mod-4 mod-5 button-1
				       button-2 button-3 button-4
				       button-5] i) out))))
      (when (not (zerop (logand mods (lsh 1 20))))
	(setq out (cons 'meta out)))
      (when (not (zerop (logand mods (lsh 1 21))))
	(setq out (cons 'alt out)))
      (when (not (zerop (logand mods (lsh 1 24))))
	(setq out (cons 'hyper out)))
      (when (not (zerop (logand mods (lsh 1 25))))
	(setq out (cons 'super out)))
      (when (not (zerop (logand mods (lsh 1 26))))
	(setq out (cons 'wm out)))
      (when (not (zerop (logand mods (lsh 1 22))))
	(setq out (cons 'any out)))
      (when (not (zerop (logand mods (lsh 1 23))))
	(setq out (cons 'release out)))
      out))

  (define (encode-modifier in)
    (let ((encode-mod-map '((shift . 1) (lock . 2)
			    (control . 4) (mod-1 . 8)
			    (mod-2 . 16) (mod-3 . 32) (mod-4 . 64)
			    (mod-5 . 128) (button-1 . 256)
			    (button-2 . 512) (button-3 . 1024)
			    (button-4 . 2048) (button-5 . 4096)
			    (meta . #x100000) (alt . #x200000)
			    (hyper . #x1000000) (super . #x2000000)
			    (wm . #x4000000) (any . #x400000)
			    (release . #x800000))))

      (apply + (mapcar (lambda (m)
			 (cdr (assq m encode-mod-map))) in))))

  (define (substitute-wm-modifier event)
    (if (/= (logand (cdr event) #x04000000) 0)
	(cons (car event) (logior (wm-modifier) (logand (cdr event)
							(lognot #x04000000))))
      event))

  (define (decode-event event)
    "Return a symbol description of the low-level event structure
EVENT (a cons cell). The symbolic description has the form `(TYPE
MODIFIER-LIST ACTION)'."
    (let* ((code (car event))
	   (mods (cdr event)))

      (cond ((not (zerop (logand mods (lsh 1 16))))
	     ;; keyboard event
	     (list 'key (decode-modifier mods) (x-keysym-name code)))
	    ((not (zerop (logand mods (lsh 1 17))))
	     ;; mouse event
	     (list 'mouse (decode-modifier mods)
		   (aref [click-1 click-2 move off-1 click-3 off-2 off-3]
			 (1- code))))
	    (t (error "Unknown event type")))))

  (define (encode-event event)
    "Return the low-level event structure (cons cell) representing the
symbolic event description EVENT, a list `(TYPE MODIFIER-LIST
ACTION)'."
    (let* ((code 0)
	   (mods (encode-modifier (cadr event))))

      (cond ((eq (car event) 'key)
	     (setq mods (logior mods (lsh 1 16)))
	     (setq code (x-lookup-keysym (caddr event))))
	    ((eq (car event) 'mouse)
	     (setq mods (logior mods (lsh 1 17)))
	     (setq code (cdr (assq (caddr event) '((click . 1)
						   (click-1 . 1)
						   (click-2 . 2)
						   (move . 3)
						   (off . 4)
						   (off-1 . 4)
						   (click-3 . 5)
						   (off-2 . 6)
						   (off-3 . 7))))))
	    (t (error "Unknown event type: %s" (car event))))
      (cons code mods)))

  (define (string->keysym string)
    "Convert a string naming a key into a symbol naming an X11 keysym."
    (x-keysym-name (car (lookup-event string))))

  (define (modifier->keysyms modifier)
    "Convert a symbol naming an event modifier into a list of symbols
representing the X11 keysyms that may generate the modifier."
    (cond ((eq modifier 'alt)
	   (mapcar string->keysym alt-keysyms))
	  ((eq modifier 'meta)
	   (mapcar string->keysym meta-keysyms))
	  ((eq modifier 'hyper)
	   (mapcar string->keysym hyper-keysyms))
	  ((eq modifier 'super)
	   (mapcar string->keysym super-keysyms))
	  ((eq modifier 'shift)
	   '(Shift_L Shift_R))
	  ((eq modifier 'control)
	   '(Control_L Control_R))
	  (t (error "Unknown modifier: %s" modifier))))

  (define (modifier-keysym-p keysym)
    "Returns true if KEYSYM is a modifier keysym."
    (or (memq keysym '(Shift_L Shift_R Control_L Control_R))
	(member (symbol-name keysym) alt-keysyms)
	(member (symbol-name keysym) meta-keysyms)
	(member (symbol-name keysym) hyper-keysyms)
	(member (symbol-name keysym) super-keysyms)))

  (define (member-event ev lst)
    (let loop ((rest lst))
         (cond ((null rest) nil)
               ((event-match ev (car rest)) rest)
               (t (loop (cdr rest))))))

  (define (should-grab-button-event-p event keymap)
    (let* ((decoded (decode-event event))
	   (variants (mapcar (lambda (action)
			       (encode-event
				(list (car decoded) (cadr decoded) action)))
			     '(click-2 click-3 move off-1 off-2 off-3))))
      (let loop ((rest (cdr keymap)))
           (cond ((null rest) nil)
                 ((member-event (cdar rest) variants) t)
                 (t (loop (cdr rest))))))))

;; iconify.jl -- iconification & (bah) stickiness

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;;; By historical reason, stickiness is here, too.

(define-structure sawfish.wm.state.iconify

    (export window-iconified-p
	    window-iconifiable-p
	    iconify-window
	    uniconify-window
	    toggle-window-iconified
	    iconify-workspace-windows
	    window-sticky-p/workspace
	    make-window-sticky/workspace
	    make-window-unsticky/workspace
	    window-sticky-p/viewport
	    make-window-sticky/viewport
	    make-window-unsticky/viewport
	    toggle-window-sticky/viewport
	    window-sticky-p
	    make-window-sticky
	    make-window-unsticky
	    toggle-window-sticky)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.workspace
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.stacking
	  sawfish.wm.viewport
	  sawfish.wm.util.groups
	  sawfish.wm.commands.groups
	  sawfish.wm.state.transient
	  sawfish.wm.menus)

  ;; Commentary:

  ;; Iconification (but without icons)

  ;; If iconified, a window has its `iconified' property set to t

  (defvar focus-windows-on-uniconify nil
    "Windows are focused after being minimized.")

  (defvar raise-windows-on-uniconify t
    "Windows are raised after being unminimized.")

  (defvar uniconify-to-current-workspace t
    "Move windows to the current workspace when they are unminimized.")

  (defvar iconify-ignored nil
    "Unmanaged windows may be iconified.")

  (defcustom iconify-group-mode 'transients
    "Minimizing a window also removes its: \\left"
    :type (choice none transients group)
    :group min-max)

  (defcustom uniconify-group-mode 'transients
    "Unminimizing a window also restores its: \\left"
    :type (choice none transients group)
    :group min-max)

  (defvar iconify-window-hook nil)
  (defvar uniconify-window-hook nil)

  (define (window-iconified-p w) (window-get w 'iconified))

  (define (window-iconifiable-p w)
    (and (not (window-get w 'never-iconify))
	 (not (window-get w 'iconified))
	 (not (desktop-window-p w))
	 (or iconify-ignored (not (window-get w 'ignored)))))

  (define (iconify-window-1 w)
    (when (window-iconifiable-p w)
      (window-put w 'iconified t)
      (when (window-visible-p w)
	(hide-window w))
      (call-window-hook 'iconify-window-hook w)
      (call-window-hook 'window-state-change-hook w (list '(iconified)))))

  (define (uniconify-window-1 w)
    (when (window-get w 'iconified)
      (window-put w 'iconified nil)
      (cond ((window-get w 'sticky)
	     (show-window w))
	    ((window-in-workspace-p w current-workspace)
	     (show-window w))
	    (uniconify-to-current-workspace
	     (ws-remove-window w t)
	     (ws-add-window-to-space w current-workspace)))
      (when raise-windows-on-uniconify
	(raise-window w))
      (when (and focus-windows-on-uniconify (window-really-wants-input-p w))
	(activate-window w))
      (call-window-hook 'uniconify-window-hook w)
      (call-window-hook 'window-state-change-hook w (list '(iconified)))))

  (define (windows-to-change w type)
    (case type
      ((transients)
       (filter (lambda (x)
		 (or (eq x w)
		     ;; Only include transients which would have
		     ;; no parents
		     (let ((parents
			    (delete-if window-iconified-p
				       (delq w (transient-parents x)))))
		       (null parents))))
	       (transient-group w)))
      ((group) (windows-in-group w))
      (t (list w))))

  (define (iconify-window w)
    "Minimize the window."
    (mapc iconify-window-1 (windows-to-change w iconify-group-mode)))

  (define (uniconify-window w)
    "Restore the window from its minimized state."
    (mapc uniconify-window-1 (windows-to-change w uniconify-group-mode)))

  (define (toggle-window-iconified w)
    "Toggle the iconification of window W."
    (if (window-get w 'iconified)
	(uniconify-window w)
      (iconify-window w)))

  (define-command 'iconify-window iconify-window #:spec "%W")
  (define-command 'uniconify-window uniconify-window #:spec "%W")
  (define-command 'toggle-window-iconified toggle-window-iconified #:spec "%W")

  (define (iconify-workspace-windows)
    "Minimize all windows on the current workspace."
    (map-windows (lambda (w)
		   (when (and (not (window-get w 'ignored))
			      (window-in-workspace-p w current-workspace))
		     (iconify-window w)))))

  (define-command 'iconify-workspace-windows iconify-workspace-windows)

;;; sticky-ness, could be in a separate file..

  ;; workspace sticky code

  (define (window-sticky-p/workspace w) (window-get w 'sticky))

  (define (emit-sticky-hook w)
    (call-window-hook 'window-state-change-hook w (list '(sticky))))

  (define (make-window-sticky/workspace w #!key no-hooks)
    (unless (window-sticky-p/workspace w)
      (ws-remove-window w t)
      (window-put w 'sticky t)
      (unless no-hooks
	(emit-sticky-hook w))))

  (define (make-window-unsticky/workspace w #!key no-hooks)
    (when (window-sticky-p/workspace w)
      (window-put w 'sticky nil)
      (ws-add-window-to-space w current-workspace)
      (unless no-hooks
	(emit-sticky-hook w))))

  ;; viewport sticky code

  (define (window-sticky-p/viewport w) (window-get w 'sticky-viewport))

  (define (make-window-sticky/viewport w #!key no-hooks)
    (unless (window-sticky-p/viewport w)
      (when (window-outside-viewport-p w)
	(move-window-to-current-viewport w))
      (window-put w 'sticky-viewport t)
      (unless no-hooks
	(emit-sticky-hook w))))

  (define (make-window-unsticky/viewport w #!key no-hooks)
    (when (window-sticky-p/viewport w)
      (window-put w 'sticky-viewport nil)
      (unless no-hooks
	(emit-sticky-hook w))))

   (define (toggle-window-sticky/viewport w)
     "Toggle the stickiness of the window, i.e. make it appear in
all viewports."
     (if (window-get w 'sticky-viewport)
	 (window-put w 'sticky-viewport nil)
       (window-put w 'sticky-viewport t)))

  ;; combined code

  (define (window-sticky-p w)
    (or (window-sticky-p/workspace w) (window-sticky-p/viewport w)))

  (define (make-window-sticky w)
    "Make the window appear in all workspaces and viewports."
    (unless (window-sticky-p w)
      (make-window-sticky/workspace w #:no-hooks t)
      (make-window-sticky/viewport w #:no-hooks t)
      (emit-sticky-hook w)))

  (define (make-window-unsticky w)
    "Make the window only appear on the current workspaces or viewports."
    (when (window-sticky-p w)
      (make-window-unsticky/workspace w #:no-hooks t)
      (make-window-unsticky/viewport w #:no-hooks t)
      (emit-sticky-hook w)))

  (define (toggle-window-sticky w)
    "Toggle the `stickiness' of the window, i.e. make it appear in
all workspaces and viewports."
    (if (window-sticky-p w)
	(make-window-unsticky w)
      (make-window-sticky w)))

  (define-command 'make-window-sticky make-window-sticky #:spec "%W")
  (define-command 'make-window-unsticky make-window-unsticky #:spec "%W")
  (define-command 'toggle-window-sticky toggle-window-sticky #:spec "%W")
  (define-command 'toggle-window-sticky-viewport
    toggle-window-sticky/viewport #:spec "%W")
    
  
;;; hooks

  (define (ws-client-msg-handler w prop data)
    (cond ((and (windowp w)
		(eq prop 'WM_CHANGE_STATE)
		(= (aref data 0) IconicState))
	   (iconify-window w)
	   t)))

  (define (ws-honour-client-state w)
    (let ((state (get-x-property w 'WM_STATE)))
      (when state
	(setq state (aref (nth 2 state) 0))
	(when (eq state IconicState)
	  (window-put w 'iconified t)))))

  (define (ws-set-client-state w)
    (set-x-property w 'WM_STATE
		    (vector (if (window-get w 'iconified)
				IconicState
			      NormalState) 0)
		    'WM_STATE 32))

  (add-hook 'client-message-hook ws-client-msg-handler)
  (add-hook 'before-add-window-hook ws-honour-client-state)
  (add-hook 'map-notify-hook ws-set-client-state t)
  (call-after-state-changed '(iconified) ws-set-client-state)

  (add-window-menu-toggle (_ "_Sticky") 'toggle-window-sticky window-sticky-p)

  (define (iconify-on-leave-fun w mode)
    (when (and (eq mode 'normal)
	       (windowp w)
	       (window-get w 'iconify-on-leave))
      (iconify-window w)))

  (add-hook 'leave-notify-hook iconify-on-leave-fun))

;; move-cursor.jl -- commands to move the mouse pointer

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.move-cursor

    (export move-cursor
            move-cursor-left-fine
            move-cursor-right-fine
            move-cursor-up-fine
            move-cursor-down-fine
            move-cursor-left
            move-cursor-right
            move-cursor-up
            move-cursor-down
	    move-cursor-northwest
	    move-cursor-northeast
	    move-cursor-southwest
	    move-cursor-southeast
            move-cursor-northwest-fine
	    move-cursor-northeast-fine
	    move-cursor-southwest-fine
	    move-cursor-southeast-fine
            move-cursor-center)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands
          sawfish.wm.gaol)

  (defcustom move-cursor-increment 16
    "Number of pixels to move pointer in."
    :group misc
    :type (number 1))

  (define (move-cursor right down)
    (let ((coords (query-pointer)))
      (warp-cursor (+ (car coords) right) (+ (cdr coords) down))))

  (define (move-cursor-left)
    "Move the cursor `move-cursor-increment' pixels to the left."
    (move-cursor (- move-cursor-increment) 0))

  (define (move-cursor-right)
    "Move the cursor `move-cursor-increment' pixels to the right."
    (move-cursor move-cursor-increment 0))

  (define (move-cursor-up)
    "Move the cursor `move-cursor-increment' pixels upwards."
    (move-cursor 0 (- move-cursor-increment)))

  (define (move-cursor-down)
    "Move the cursor `move-cursor-increment' pixels downwards."
    (move-cursor 0 move-cursor-increment))

  (define (move-cursor-northwest)
    "Move the cursor `move-cursor-increment' pixels northwest"
    (move-cursor (- move-cursor-increment) (- move-cursor-increment)))

  (define (move-cursor-northeast)
    "Move the cursor `move-cursor-increment' pixels northeast"
    (move-cursor move-cursor-increment (- move-cursor-increment)))

  (define (move-cursor-southwest)
    "Move the cursor `move-cursor-increment' pixels southwest"
    (move-cursor (- move-cursor-increment) move-cursor-increment))

  (define (move-cursor-southeast)
    "Move the cursor `move-cursor-increment' pixels southeast"
    (move-cursor move-cursor-increment move-cursor-increment))

  (define (move-cursor-left-fine)
    "Move the cursor 1 pixel to the left."
    (move-cursor -1 0))

  (define (move-cursor-right-fine)
    "Move the cursor 1 pixel to the right."
    (move-cursor 1 0))

  (define (move-cursor-up-fine)
    "Move the cursor 1 pixel upwards."
    (move-cursor 0 -1))

  (define (move-cursor-down-fine)
    "Move the cursor 1 pixel downwards."
    (move-cursor 0 1))

  (define (move-cursor-northwest-fine)
    "Move the cursor `move-cursor-increment' pixels northwest"
    (move-cursor -1 -1))

  (define (move-cursor-northeast-fine)
    "Move the cursor `move-cursor-increment' pixels northeast"
    (move-cursor 1 -1))

  (define (move-cursor-southwest-fine)
    "Move the cursor `move-cursor-increment' pixels southwest"
    (move-cursor -1 1))

  (define (move-cursor-southeast-fine)
    "Move the cursor `move-cursor-increment' pixels southeast"
    (move-cursor 1 1))

  (define (move-cursor-center)
    "Move the cursor to the center of the screen"
    (warp-cursor (/ (screen-width) 2) (/ (screen-height) 2)))

  ;;###autoload
  (define-command 'move-cursor-right move-cursor-right)
  (define-command 'move-cursor-left move-cursor-left)
  (define-command 'move-cursor-up move-cursor-up)
  (define-command 'move-cursor-down move-cursor-down)
  (define-command 'move-cursor-right-fine move-cursor-right-fine)
  (define-command 'move-cursor-left-fine move-cursor-left-fine)
  (define-command 'move-cursor-up-fine move-cursor-up-fine)
  (define-command 'move-cursor-down-fine move-cursor-down-fine)
  (define-command 'move-cursor-northwest move-cursor-northwest)
  (define-command 'move-cursor-northeast move-cursor-northeast)
  (define-command 'move-cursor-southwest move-cursor-southwest)
  (define-command 'move-cursor-southeast move-cursor-southeast)
  (define-command 'move-cursor-down-fine move-cursor-down-fine)
  (define-command 'move-cursor-northwest-fine move-cursor-northwest-fine)
  (define-command 'move-cursor-northeast-fine move-cursor-northeast-fine)
  (define-command 'move-cursor-southwest-fine move-cursor-southwest-fine)
  (define-command 'move-cursor-southeast-fine move-cursor-southeast-fine)
  (define-command 'move-cursor-center move-cursor-center))

;; Description: Handles tiling of all windows on a given workspace to
;; maintain them aligned with a main pane in the left and the others
;; stacked on the right.
;;
;; Author: Jose A. Ortega Ruiz <jao@gnu.org>
;; Inspiraton: smart-tile by Mark Triggs <mst@dishevelled.net>
;;
;; Usage:
;;   (require 'sawfish.wm.tile.tall)
;;   (tall-tiling 3 #:width 2 #:top 0 #:bottom 1 #:gap 1 #:max 3 #:right #t)
;;   (tall-tiling 1 #:width 3 #:top 20 #:bottom 3 #:gap 1 #:auto #f)
;;   (bind-keys global-keymap "M-=" 'increase-max-windows)
;;   (bind-keys global-keymap "M--" 'decrease-max-windows)
;;

(define-structure sawfish.wm.tile.tall
    (export tall-tiling
            tall-rotate-left
            tall-rotate-right
            increase-max-windows
            decrease-max-windows)
    (open rep
	  rep.system
          sawfish.wm.tile.tiler
          sawfish.wm.tile.utils
	  sawfish.wm.windows)

  (define (tall-tiling n #!key
                       (width 2) (top 0) (bottom 0) (gap 0)
                       (max 2) (auto t) (right #f) (master #f))
    (register-workspace-tiler n
                              tall-tiler
                              (list width top bottom gap max right)
                              auto
                              'tall-tiler
                              master))

  (define (tall-tiler master ignore)
    (let ((windows (tileable-windows ignore)))
      (when (> (length windows) 0)
        (let* ((master (or master (input-focus) (car windows)))
               (master (if (eq master ignore) (car windows) master))
               (children (remove master windows)))
          (do-tile master children)))))

  (define (do-tile master children)
    (let* ((lc (length children))
           (cno (if (> (setting 4) 1) (min (1- (setting 4)) lc) lc))
           (groups (reverse (group-by children cno)))
           (tm (setting 1))
           (bm (setting 2))
           (gap (setting 3))
           (rs (setting 5))
           (m-width (master-width (setting 0)))
           (c-height (child-height cno tm bm))
           (c-width (scr-width m-width (* 3 gap) 1))
           (h-offset (+ (if rs c-width m-width) (* 2 gap))))
      (mapc (lambda (g)
              (push-children (reverse g)
                             (if rs gap h-offset)
                             (scr-height c-height bm)
                             (if (= (length g) cno) tm -1)
                             c-width
                             c-height))
            groups)
      (push-window master (if rs h-offset gap) tm m-width (scr-height tm bm))))

  (define (master-width f) (floor (1- (/ (scr-width) f))))

  (define (child-height total tm bm)
    (floor (/ (scr-height tm bm) (if (> total 0) total 1))))

  (define (push-children children x y min-y w dy)
    (define (top-y)
      (if (and (null (cdr children)) (>= min-y 0)) min-y y))
    (when (not (null children))
      (push-window (car children) x (top-y) w dy)
      (push-children (cdr children) x (- y dy) min-y w dy)))

  (define (ws-inc-max ws delta)
    (let ((old (setting 4 #f ws)))
      (when old
        (let ((no (+ old delta)))
          (when (> no 1)
            (set-setting 4 no ws)
            no)))))

  (define (change-max-windows delta)
    (let ((n (ws-inc-max current-workspace delta)))
      (when n
        (tall-tiler nil nil)
        (notify "Maximum windows set to %s" n))))

  (define (increase-max-windows)
    (interactive)
    (change-max-windows 1))

  (define (decrease-max-windows)
    (interactive)
    (change-max-windows -1))

  (define (tall-rotate-left)
    (interactive)
    (when (eq 'tall-tiler (current-tiler-name))
      (let* ((windows (tileable-windows))
             (first (car windows))
             (rest (cdr windows))
             (master (car rest))
             (children (append (cdr rest) (list first))))
        (when rest
	  (do-tile master children)
	  (focus-window master)))))

  (define (tall-rotate-right)
    (interactive)
    (when (eq 'tall-tiler (current-tiler-name))
      (let* ((windows (tileable-windows))
             (first (car windows))
             (rest (cdr windows))
             (master (last rest))
             (children (cons first (remove master rest))))
	(when rest
          (do-tile master children)
	  (focus-window master))))))

#| nokogiri-widgets/file.jl -- file name widget

   $Id: file.jl,v 1.2 2000/09/01 20:00:04 john Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure sawfish.gtk.widgets.file ()

    (open rep
	  gui.gtk
	  sawfish.gtk.widget)

  (define (make-file-item changed-callback)
    (let* ((box (gtk-hbox-new nil box-spacing))
	   (entry (gtk-entry-new))
	   (button (gtk-button-new-with-label (_ "Browse..."))))
      (gtk-container-border-width box box-border)
      (gtk-box-pack-start box entry)
      (gtk-box-pack-start box button)
      (when changed-callback
	(gtk-signal-connect
	 entry "changed" (make-signal-callback changed-callback)))
      (gtk-signal-connect
       button "clicked"
       (lambda ()
	 (let ((filesel (gtk-file-selection-new (_ "Select file"))))
	   (gtk-file-selection-set-filename filesel (gtk-entry-get-text entry))
	   (gtk-signal-connect
	    (gtk-file-selection-ok-button filesel) "clicked"
	    (lambda ()
	      (gtk-entry-set-text
	       entry (gtk-file-selection-get-filename filesel))
	      (gtk-widget-destroy filesel)))
	   (gtk-signal-connect
	    (gtk-file-selection-cancel-button filesel) "clicked"
	    (lambda () (gtk-widget-destroy filesel)))
	   (gtk-signal-connect filesel "delete_event"
			       (lambda () (gtk-widget-destroy filesel)))
	   (gtk-widget-show filesel)
	   (gtk-grab-add filesel))))
      (gtk-widget-show box)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-entry-set-text entry (and (stringp x) x))))
	  ((clear) (lambda ()
		     (gtk-entry-set-text entry "")))
	  ((ref) (lambda () (gtk-entry-get-text entry)))
	  ((gtk-widget) box)
	  ((validp) (lambda (x) (stringp x)))))))

  (define-widget-type 'file make-file-item))

;; viewport.jl -- virtual desktops

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.viewport

    (export set-viewport
	    screen-viewport
	    set-screen-viewport
	    select-workspace-and-viewport
	    move-viewport
	    move-viewport-to-window
	    window-outside-workspace-p
	    window-outside-viewport-p
	    move-window-to-current-viewport
	    set-window-viewport
	    move-window-viewport
            viewport-at
	    window-viewport
            viewport-offset-coord
	    window-absolute-position
	    set-number-of-viewports
            rect-within-viewport-p
            rect-within-head-p
            window-head-any-viewport
	    viewport-minimum-size-changed
            viewport-honor-workspace-edges
	    viewport-windows
	    window-on-current-head-viewport-p)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.custom
          sawfish.wm.util.rects
	  sawfish.wm.session.init)

  ;; Virtual workspaces are implemented by moving windows in and out of
  ;; the screen dimensions. E.g. moving to the left moves all windows one
  ;; screen-width to the right.

  (defgroup viewport "Viewport" :group workspace)

  (defcustom viewport-dimensions '(1 . 1)
    "The number of columns and rows of the virtual desktop: \\left"
    :group (workspace viewport)
    :type (pair (number 1) (number 1))
    :tooltip "This is meaningless if dynamic viewport is enabled."
    :after-set (lambda () (viewport-size-changed t)))

  (defcustom viewport-minimum-dimensions '(1 . 1)
    "Minimum number of columns and rows of virtual desktop (if boundary mode is dynamic): \\left"
    :group (workspace viewport)
    :type (pair (number 1) (number 1))
    :after-set (lambda () (viewport-minimum-size-changed)))

  (defcustom uniconify-to-current-viewport t
    "Windows uniconify to the current viewport."
    :type boolean
    :group (workspace viewport))

  (defcustom scroll-viewport-steps 1
    "When you go to another viewport, the bigger this value,
the more smoothly the screen is scrolled.
It is the number of steps for scrolling. The value 1 means no scroll, and
the change is instantaneous."
    :group (workspace viewport)
    :type (range (1 . 50)))

  (defcustom viewport-boundary-mode 'stop
    "Stop, wrap-around, or grow the virtual desktop when you go beyond virtual desktop edge."
    :group (workspace viewport)
    :type (choice wrap-around stop dynamic))

  (defvar workspace-viewport-data nil
    "Information about the viewport details of different workspaces.")

  (defvar viewport-moved-hook nil)
  (defvar viewport-resized-hook nil)
  
;;; raw viewport handling

  ;; The unit is pixel, NOT (col, row).
  ;; Position (0, 0) means the top-left of the workspace.
  (defvar viewport-x-offset 0)
  (defvar viewport-y-offset 0)

  (define (warp-viewport x y)
    "Move viewport to (x, y). The unit is pixel, not (col, row).
Position (0, 0) is the top-left of the workspace."
    (define (move-window w)
      (unless (window-get w 'sticky-viewport)
	(let ((pos (window-position w)))
	  (move-window-to w (- (+ (car pos) viewport-x-offset) x)
			  (- (+ (cdr pos) viewport-y-offset) y)))))

    (unless (and (= viewport-x-offset x) (= viewport-y-offset y))
      (let loop ((rest (stacking-order))
		 (inside '())
		 (outside '()))
	(cond ((null rest)
	       (with-server-grabbed
		;; First move all windows not on the old viewport, and
		;; move in top-to-bottom order..
		(mapc move-window (nreverse outside))
		;; ..then move away the windows on the old viewport,
		;; in bottom-to-top order
		(mapc move-window inside)))

              ;; No need to warp windows not in the current workspace.
              ;; See viewport-leave-workspace-handler and
              ;; viewport-enter-workspace handler below.
              ((not
                (window-appears-in-workspace-p (car rest) current-workspace))
               (loop (cdr rest) inside outside))
	      ((window-outside-viewport-p (car rest))
	       (loop (cdr rest) inside (cons (car rest) outside)))

	      (t (loop (cdr rest) (cons (car rest) inside) outside))))

      (setq viewport-x-offset x)
      (setq viewport-y-offset y)))

  (define (viewport-honor-workspace-edges)
    "Whether or not to prevent the display from moving past the
current viewport boundaries.  Returns true if `viewport-boundary-mode'
is not set to 'dynamic."
    (not (eq viewport-boundary-mode 'dynamic)))

  (define (set-viewport x y)
    "Move viewport to (x, y). The unit is pixel, not (col, row).
Position (0, 0) is the top-left of the workspace.

Scroll is done whose steps are `scroll-viewport-steps'."
    (unless (= scroll-viewport-steps 1) ; fast skip if scroll is unwanted
      (let* ((xstep (quotient (- x viewport-x-offset) scroll-viewport-steps))
             (ystep (quotient (- y viewport-y-offset) scroll-viewport-steps))
             (step-count (if (= xstep ystep 0) 0 scroll-viewport-steps)))
        (while (> step-count 1)
          (warp-viewport (+ viewport-x-offset xstep)
                         (+ viewport-y-offset ystep))
          (setq step-count (1- step-count)))))
    (warp-viewport x y)
    (call-hook 'viewport-moved-hook))

  (define (viewport-before-exiting)
    ;; Reset all workspaces to viewport 0,0.  This is so that on
    ;; restart (or if another wm takes over) windows aren't in strange
    ;; places.
    (if workspace-viewport-data
        (mapc (lambda (ws-data)
                (select-workspace (car ws-data))
                (set-screen-viewport 0 0))
              workspace-viewport-data)
      (set-screen-viewport 0 0)))

  (add-hook 'before-exit-hook viewport-before-exiting t)

  (define (viewport-dynamic-resize)
    "Reset the size of the viewport to include the current screen as
well as any windows in the current workspace."
    (when (eq viewport-boundary-mode 'dynamic)
      (let ((windows
	     (filter-windows
	      (lambda (w)
		(window-in-workspace-p w current-workspace)))))
	(if windows
	    (let* ((width (screen-width))
                   (height (screen-height))
                   (points
                    (nconc
                     (mapcar (lambda (w)
                               (let ((pos (window-position w))
                                     (dims (window-frame-dimensions w)))
                                 (list (car pos)
                                       (cdr pos)
                                       (+ (car pos) (car dims))
                                       (+ (cdr pos) (cdr dims)))))
                             windows)
                     ;; Include the current screen:
                     `((0 0 ,(1- width) ,(1- height)))))
                   ;; The min/max values calculated below are relative to
                   ;; the old logical 0,0 point of the virtual desktop:
                   (old-x-origin (- viewport-x-offset))
                   (old-y-origin (- viewport-y-offset))
                   (x-min (- (apply min (mapcar car points)) old-x-origin))
                   (y-min (- (apply min (mapcar (lambda (e) (nth 1 e)) points))
                             old-y-origin))
                   (x-max (- (apply max (mapcar (lambda (e) (nth 2 e)) points))
                             old-x-origin))
                   (y-max (- (apply max (mapcar (lambda (e) (nth 3 e)) points))
                             old-y-origin))
                   ;; high-* values are the number of rows/columns above
                   ;; the old origin, low-* values the number below the
                   ;; old origin.
                   (high-rows (+ (quotient y-max height)
                                 (if (> (mod y-max height) 0)
                                     1
                                   0)))
                   (low-rows (+ (- (quotient y-min height))
                                (if (and (< y-min 0)
                                         (> (mod y-min height) 0))
                                    1
                                  0)))
                   (rows (+ low-rows high-rows))
                   (high-cols (+ (quotient x-max width)
                                 (if (> (mod x-max width) 0)
                                     1
                                   0)))
                   (low-cols (+ (- (quotient x-min width))
                                (if (and (< x-min 0)
                                         (> (mod x-min width) 0))
                                    1
                                  0)))
                   (cols (+ low-cols high-cols)))
	      (setq
               viewport-y-offset (- (- old-y-origin (* low-rows height)))
               viewport-x-offset (- (- old-x-origin (* low-cols width)))
	       viewport-dimensions (cons
				    (max cols
					 (car viewport-minimum-dimensions))
				    (max rows
					 (cdr viewport-minimum-dimensions)))))
	  (setq viewport-y-offset 0
		viewport-x-offset 0
		viewport-dimensions viewport-minimum-dimensions))
	(call-hook 'viewport-resized-hook))))

  ;; Resize virtual workspace on workspace switch or viewport move:
  (add-hook 'viewport-moved-hook
	    viewport-dynamic-resize)

  (add-hook 'after-initialization-hook
            viewport-dynamic-resize)

  (define (viewport-leave-workspace-handler ws)
    "On leaving a workspace, store information about the viewport
configuration so that it can be restored properly later.
`WS' is the workspace to leave."
    (let ((vp-data (list viewport-x-offset
                         viewport-y-offset
                         viewport-dimensions))
          (old-ent (assoc ws workspace-viewport-data)))
      (if old-ent
          (rplacd old-ent vp-data)
        (setq workspace-viewport-data
              (cons (cons ws vp-data)
                    workspace-viewport-data)))))

  (add-hook 'leave-workspace-hook
            viewport-leave-workspace-handler)

  (define (viewport-enter-workspace-handler ws)
    "Restore any saved data about the viewport for the new workspace.
When `viewport-boundary-mode' is not `dynamic', make sure that the new
viewport is within `viewport-dimensions'."
    (let ((vp-data (cdr (assoc ws workspace-viewport-data))))
      (if vp-data
          (let ((maybe-x-offset (car vp-data))
                (maybe-y-offset (nth 1 vp-data)))
            (if (eq viewport-boundary-mode 'dynamic)
                (setq viewport-dimensions (nth 2 vp-data)
                      viewport-x-offset maybe-x-offset
                      viewport-y-offset maybe-y-offset)
              ;; Do maybe-y-offset and maybe-x-offset fit within
              ;; current viewport-dimensions?
              (if (and (<= maybe-x-offset
                           (* (1- (cdr viewport-dimensions)) (screen-width)))
                       (<= maybe-y-offset
                           (* (1- (car viewport-dimensions)) (screen-height))))
                  (setq viewport-x-offset maybe-x-offset
                        viewport-y-offset maybe-y-offset)
                (setq viewport-x-offset 0
                      viewport-y-offset 0))))
        (setq viewport-x-offset 0
              viewport-y-offset 0))
      (viewport-size-changed)))

  (add-hook 'enter-workspace-hook
            viewport-enter-workspace-handler)

  ;; screen sized viewport handling

  (define (screen-viewport)
    "Gives the row and column of the current viewport."
    (cons (quotient viewport-x-offset (screen-width))
	  (quotient viewport-y-offset (screen-height))))

  ;; returns t if it actually moved the viewport
  (define (set-screen-viewport col row)
    (when (eq viewport-boundary-mode 'wrap-around)
      (setq col (mod col (car viewport-dimensions))
            row (mod row (cdr viewport-dimensions))))
    (when (or (eq viewport-boundary-mode 'dynamic)
	      (and (>= col 0) (< col (car viewport-dimensions))
		   (>= row 0) (< row (cdr viewport-dimensions))))
      (set-viewport (* col (screen-width))
                    (* row (screen-height)))
      t))

  (define (select-workspace-and-viewport space col row)
    (select-workspace space)
    (set-screen-viewport col row))

  ;; returns t if it actually moved the viewport
  (define (move-viewport right down)
    (let ((port (screen-viewport)))
      (set-screen-viewport (+ (car port) right)
			   (+ (cdr port) down))))

  (define (move-viewport-to-window window)
    (when (window-outside-viewport-p window)
      (let ((pos (window-position window)))
	(rplaca pos (+ (car pos) viewport-x-offset))
	(rplacd pos (+ (cdr pos) viewport-y-offset))
	(set-screen-viewport (quotient (car pos) (screen-width))
			     (quotient (cdr pos) (screen-height))))))

  (define (window-outside-workspace-p window)
    "True if `window' is outside the workspace.  Note that this does
not check which workspace the windows is in; the window is outside the
workspace if it's position is not within any viewport."
    (let ((pos (window-position window))
	  (dims (window-frame-dimensions window))
	  (left (- viewport-x-offset))
	  (right (- (* (car viewport-dimensions) (screen-width))
		    viewport-x-offset))
	  (top (- viewport-y-offset))
	  (bottom (- (* (cdr viewport-dimensions) (screen-height))
		     viewport-y-offset)))
      (or (>= (car pos) right)
	  (>= (cdr pos) bottom)
	  (<= (+ (car pos) (car dims)) left)
	  (<= (+ (cdr pos) (cdr dims)) top))))

  (define (window-outside-viewport-p window #!optional viewport)
    "True if no part of `window' is inside the current viewport.  If
`viewport' is specified check against that viewport rather than the
current one."
    (let* ((cur-vp (screen-viewport))
           (width (screen-width))
           (height (screen-height))
           (x-min (if viewport
                      (* (- (car viewport) (car cur-vp))
                         width)
                    0))
           (x-max (+ x-min width))
           (y-min (if viewport
                      (* (- (cdr viewport) (cdr cur-vp))
                         height)
                    0))
           (y-max (+ y-min height))
           (pos (window-position window))
           (dims (window-frame-dimensions window)))
      (or (<= (+ (car pos) (car dims)) x-min)
          (<= (+ (cdr pos) (cdr dims)) y-min)
          (>= (car pos) x-max)
          (>= (cdr pos) y-max))))

  (define (move-window-to-current-viewport window)
    (when (and (window-outside-viewport-p window)
	       (not (window-get window 'sticky-viewport)))
      (let ((pos (window-position window)))
	(move-window-to window (mod (car pos) (screen-width))
			(mod (cdr pos) (screen-height))))))

  (define (set-window-viewport window col row)
    (unless (window-get window 'sticky-viewport)
      (let ((pos (window-position window)))
	(setq col (max 0 (min (1- (car viewport-dimensions)) col)))
	(setq row (max 0 (min (1- (cdr viewport-dimensions)) row)))
	(setq col (+ (* col (screen-width)) (mod (car pos) (screen-width))))
	(setq row (+ (* row (screen-height)) (mod (cdr pos) (screen-height))))
	(move-window-to
	 window (- col viewport-x-offset) (- row viewport-y-offset)))))

  (define (move-window-viewport window col row)
    (let ((pos (window-position window)))
      (set-window-viewport window
			   (+ (quotient (+ (car pos) viewport-x-offset)
					(screen-width)) col)
			   (+ (quotient (+ (cdr pos) viewport-y-offset)
					(screen-height)) row))))

  (define (viewport-at x y)
    "Returns a cons cell consisting of the column and row of the
viewport containing the specified coordinates."
    (let ((x (+ x viewport-x-offset))
          (y (+ y viewport-y-offset)))
      ;; If x or y is negative the viewport must be adjusted by one.
      (cons (- (quotient x (screen-width))
               (if (< x 0)
                   1
                 0))
	    (- (quotient y (screen-height))
               (if (< y 0)
                   1
                 0)))))

  (define (window-viewport w)
    "Returns a cons cell consisting of the column and row of the
viewport containing (or mostly containing) `w'."
    (let* ((pos (window-position w))
           (dims (window-dimensions w)))
      (viewport-at (+ (car pos) (quotient (car dims) 2))
                   (+ (cdr pos) (quotient (cdr dims) 2)))))

  ;; From sawfish.wm.util.rects:
  ;; A rectangle is (LEFT TOP RIGHT BOTTOM [WEIGHT])
  ;; The left and top edges are considered part of the rectangle,
  ;; the right and bottom edges are not.

  (define (rect-within-viewport-p rect #!optional viewport)
    "Return t if `rect' is entirely inside the screen boundaries for
some viewport, regardless of whether it is the current viewport, or
even if the viewport currently exists.  If `viewport' is specified
check only against that viewport."
    (let ((vp (viewport-at (car rect) (nth 1 rect))))
      (when (or (null viewport) (equal vp viewport))
        (let ((offset (viewport-offset-coord vp)))
          (rect-wholly-within-rect (list (car offset)
                                         (cdr offset)
                                         (+ (car offset) (screen-width))
                                         (+ (cdr offset) (screen-height)))
                                   rect)))))

  ;; The next two functions should perhaps go in a "heads" module if
  ;; there were one.  But what makes them interesting is that they
  ;; must account for viewports, which is why I put them here.

  (define (rect-within-head-p rect #!optional head)
    "Return t if `rect' is entirely within some head on some
viewport. If `head' is provided `rect' must be within that head on
some viewport."
    (let* ((offset (viewport-offset-coord (viewport-at (car rect)
                                                 (nth 1 rect))))
           (left (- (car rect) (car offset)))
           (top (- (nth 1 rect) (cdr offset)))
           (right (- (nth 2 rect) (car offset)))
           (bottom (- (nth 3 rect) (cdr offset)))
           (head (or head (find-head left top)))
           (head-pos (head-offset head))
           (head-dims (head-dimensions head)))
      (rect-wholly-within-rect (list (car head-pos)
                                     (cdr head-pos)
                                     (+ (car head-pos) (car head-dims))
                                     (+ (cdr head-pos) (cdr head-dims)))
                               (list left top right bottom))))

  (define (window-head-any-viewport w)
    "Return the id of the head that would contain `w', if the viewport
`w' occupies were visible."
    (let* ((coords (window-position w))
           (dims (window-dimensions w))
           (center (cons (+ (car coords) (quotient (car dims) 2))
                         (+ (cdr coords) (quotient (cdr dims) 2))))
           (vp-offset (viewport-offset-coord (viewport-at (car center)
                                                    (cdr center)))))
      (find-head (- (car center) (car vp-offset))
                 (- (cdr center) (cdr vp-offset)))))

  (define (viewport-offset-coord vp)
    "Returns the offset from the current viewport to viewport `VP'
which is specified as (column . row). The return value is the cons
cell (x . y). The values are in pixel, and are negative if it lies at
left or above the current viewport.

`VP' can be outside of the workspace. If `VP' is nil, it is
understood as the current viewport, i.e., (0 . 0) will be returned."
    (if (consp vp)
        (let* ((cur-vp (screen-viewport)))
          (cons
           (* (- (car vp) (car cur-vp)) (screen-width))
           (* (- (cdr vp) (cdr cur-vp)) (screen-height))))
      '(0 . 0)))

  (define (window-absolute-position w #!optional disambiguate)
    "Returns the coordinates of the window as if the window's viewport
is selected. The return value is the cons cell (x . y)."
    ;; So, ignoring the side effect, it's roughly equal to
    ;; (set-screen-viewport (window-viewport w))
    ;; (window-position w)
    ;; The correct name should be "window-position-in-viewport".

    ;; The temporary hack 'disambiguate' is introduced in Sawfish 1.6.
    ;; It will be removed.

    ;; Two methods differ if the window lies across several vp slots.
    (if disambiguate
	;; method 1: always returns the same value.
	;; This is introduced in 1.6, and necessary for maximization.
	(let ((offset (viewport-offset-coord (window-viewport w)))
	      (coords (window-position w)))
	  (cons
	   (- (car coords) (car offset))
	   (- (cdr coords) (cdr offset))))
      ;; method 2: If the window is visible from the current viewport,
      ;; then simply window-position is returned.
      ;; Else, the viewport where the window's top-left lies is used.
      ;; This has existed for long time.
      ;; Perhaps this can be deleted, and check of visibility can be
      ;; separated, done by the caller.
      (let ((position (window-position w)))
	(if (window-outside-viewport-p w)
	    (cons (mod (+ (car position) viewport-x-offset) (screen-width))
		  (mod (+ (cdr position) viewport-y-offset) (screen-height)))
	  position))))

  (define (viewport-size-changed #!optional force)
    ;; This is called when the user requests a change (e.g., from the
    ;; gui, or via `set-number-of-viewports') as well as when the
    ;; desktop is switched.  If `force' is set it's considered to be
    ;; user-requested, and therefore mandatory that the
    ;; `viewport-dimensions' variable be respected.
    (when (or (< (car viewport-dimensions) (car viewport-minimum-dimensions))
	      (< (cdr viewport-dimensions) (cdr viewport-minimum-dimensions)))
      (if force
          (setq viewport-minimum-dimensions
                (cons (min (car viewport-dimensions)
                           (car viewport-minimum-dimensions))
                      (min (cdr viewport-dimensions)
                           (cdr viewport-minimum-dimensions))))
        (setq viewport-dimensions
              (cons (max (car viewport-dimensions)
                         (car viewport-minimum-dimensions))
                    (max (cdr viewport-dimensions)
                         (cdr viewport-minimum-dimensions)))))
      (when (eq viewport-boundary-mode 'dynamic)
	(viewport-dynamic-resize)))
    (unless (eq viewport-boundary-mode 'dynamic)
      ;; Not using dynmic viewports, so ensure that windows are within
      ;; the current virtual-workspace boundaries:
      (let ((port (screen-viewport)))
	(set-screen-viewport (min (car port) (1- (car viewport-dimensions)))
			     (min (cdr port) (1- (cdr viewport-dimensions))))
	(map-windows (lambda (w)
                       (when (and (window-outside-workspace-p w)
                                  (window-appears-in-workspace-p
                                   w current-workspace))
			 (move-window-to-current-viewport w))))
	(call-hook 'viewport-resized-hook))))

  (define (viewport-minimum-size-changed)
    (if (eq viewport-boundary-mode 'dynamic)
	(viewport-dynamic-resize)
      (when (or (< (car viewport-dimensions)
                   (car viewport-minimum-dimensions))
		(< (cdr viewport-dimensions)
                   (cdr viewport-minimum-dimensions)))
	(setq viewport-dimensions
	      (cons (max (car viewport-dimensions)
			 (car viewport-minimum-dimensions))
		    (max (cdr viewport-dimensions)
			 (cdr viewport-minimum-dimensions))))
	(viewport-size-changed))))

  (define (set-number-of-viewports width height)
    (setq viewport-dimensions (cons width height))
    (setq viewport-minimum-dimensions (cons width height))
    (if (eq viewport-boundary-mode 'dynamic)
	(viewport-dynamic-resize)
      (viewport-size-changed t)))

  (define (viewport-windows #!optional vp-col vp-row workspace
                            exclude-sticky exclude-iconified)
    "Provide a list of windows that are mapped to the specified viewport."
    (let* ((cur-vp (screen-viewport))
           (col (or vp-col (car cur-vp)))
           (row (or vp-row (cdr cur-vp)))
           (ws (or workspace current-workspace))
           (width (screen-width))
           (height (screen-height))
           (left (+ (- viewport-x-offset) (* col width)))
           (right (+ left (1- width)))
           (top (+ (- viewport-y-offset) (* row height)))
           (bottom (+ top (1- height))))
      (filter-windows (lambda (w)
                        (let ((pos (window-position w))
                              (dims (window-frame-dimensions w)))
                          (and (window-mapped-p w)
                               (not (window-get w 'ignored))
                               (if exclude-sticky
                                   (window-in-workspace-p w ws)
                                 (window-appears-in-workspace-p w ws))
                               (not (and exclude-iconified
                                         (window-get w 'iconified)))
                               (not (or (<= (+ (car pos) (car dims)) left)
                                        (<= (+ (cdr pos) (cdr dims)) top)
                                        (>= (car pos) right)
                                        (>= (cdr pos) bottom)))))))))

  (define (window-on-current-head-viewport-p w)
    (eq (current-head w) (window-head-any-viewport w)))

;;; commands

  (define (activate-viewport x y)
    "Select the specified viewport."
    (set-screen-viewport (1- x) (1- y)))

  (define-command 'activate-viewport activate-viewport
    #:spec "NX:\nNY:"
    #:type `(and (labelled ,(_ "Column:") (number 1))
		 (labelled ,(_ "Row:") (number 1)))
   )

  (define (activate-viewport-column x)
    "Select the specified viewport column."
    (set-screen-viewport (1- x) (cdr (screen-viewport))))

  (define-command 'activate-viewport-column activate-viewport-column
    #:spec "NX:"
    #:type `(and (labelled ,(_ "Column:") (number 1)))
   )

  (define (activate-viewport-row y)
    "Select the specified viewport row."
    (set-screen-viewport (car (screen-viewport)) (1- y)))

  (define-command 'activate-viewport-row activate-viewport-row
    #:spec "NY:"
    #:type `(and (labelled ,(_ "Row:") (number 1)))
   )

  (define (move-window-to-viewport x y)
    "Move the current window to the specified viewport."
    (move-window-viewport (current-event-window) (1- x) (1- y)))

  (define-command 'move-window-to-viewport move-window-to-viewport
    #:spec "NX:\nNY:"
    #:type '(and (labelled "X:" (number 1)) (labelled "Y:" (number 1)))
   )

  (define (move-viewport-right)
    "Move the viewport one screen to the right."
    (move-viewport 1 0))

  (define (move-viewport-left)
    "Move the viewport one screen to the left."
    (move-viewport -1 0))

  (define (move-viewport-down)
    "Move the viewport one screen down."
    (move-viewport 0 1))

  (define (move-viewport-up)
    "Move the viewport one screen up."
    (move-viewport 0 -1))

  ;; Moves the window by the specified offsets and then flips to the
  ;; viewport that is relative those offsets to the current viewport.
  (define (move-window-to-viewport-and-move-viewport window col row)
    (require 'sawfish.wm.util.stacking)
    (let ((sticky-viewport (window-get window 'sticky-viewport)))
      (window-put window 'sticky-viewport t)
      (with-server-grabbed
       (raise-window* window)
       (move-viewport col row)
       (set-input-focus window))
      (unless sticky-viewport
	(window-put window 'sticky-viewport nil))))

  (define (move-window-left w)
    "Move the window to the viewport on the left, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w -1 0))

  (define (move-window-right w)
    "Move the window to the viewport on the right, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w 1 0))

  (define (move-window-down w)
    "Move the window to the viewport below, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w 0 1))

  (define (move-window-up w)
    "Move the window to the viewport above, and switch to that
viewport."
    (move-window-to-viewport-and-move-viewport w 0 -1))

  (define-command 'move-viewport-right move-viewport-right
   )
  (define-command 'move-viewport-left move-viewport-left
   )
  (define-command 'move-viewport-up move-viewport-up
   )
  (define-command 'move-viewport-down move-viewport-down
   )
  (define-command 'move-window-right move-window-right #:spec "%W"
   )
  (define-command 'move-window-left move-window-left #:spec "%W"
   )
  (define-command 'move-window-up move-window-up #:spec "%W"
   )
  (define-command 'move-window-down move-window-down #:spec "%W"
   )

;;; session management, config

  (define (viewport-saved-state w)
    (let ((position (window-position w)))
      (when (window-get w 'sticky-viewport)
	(rplaca position (mod (car position) (screen-width)))
	(rplacd position (mod (cdr position) (screen-height))))
      `((position . ,(window-absolute-position w))
	(viewport . ,(window-viewport w)))))

  (define (viewport-load-state w alist)
    (let ((position (cdr (assq 'position alist)))
	  (viewport (cdr (assq 'viewport alist))))
      (when position
	(if (or (not viewport) (window-get w 'sticky-viewport))
	    (move-window-to w (car position) (cdr position))
	  (move-window-to w (+ (* (car viewport) (screen-width))
			       (car position)
			       (- viewport-x-offset))
			  (+ (* (cdr viewport) (screen-height))
			     (cdr position)
			     (- viewport-y-offset)))
	  (when (window-outside-workspace-p w)
	    (move-window-to-current-viewport w)))
	(window-put w 'placed t))))

  (sm-add-saved-properties 'sticky-viewport)
  (add-hook 'sm-window-save-functions viewport-saved-state)
  (add-hook 'sm-restore-window-hook viewport-load-state)

  (define (viewport-window-uniconified w)
    (when uniconify-to-current-viewport
      (move-window-to-current-viewport w)))

  (add-hook 'uniconify-window-hook viewport-window-uniconified))

;; make-theme.jl -- support for theme builder

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.theming.make-theme

    (export make-theme)

    (open rep
	  rep.regexp
	  sawfish.wm.images
	  sawfish.wm.colors
	  sawfish.wm.fonts
	  sawfish.wm.gaol)

  (define-structure-alias make-theme sawfish.wm.theming.make-theme)

  (define (make-frames patterns-alist frame-alist)
    (let ((image-cache '()))

      (define (make-image-possibly-from-cache file)
	(or (cdr (assoc file image-cache))
	    (let ((img (gaol-eval `(make-image ',file))))
	      (setq image-cache (cons (cons file img) image-cache))
	      img)))

      (define (make-pattern def)
	(mapcar (lambda (elt)
		  (let ((state (car elt))
			(value (cdr elt)))
		    (cond ((stringp value)
			   (setq value (get-color value)))
			  ((and (consp value) (stringp (car value)))
			   (let
			       ((img (make-image-possibly-from-cache
                                      (car value))))
			     (when img
			       (mapc (lambda (attr)
				       (cond
					((eq (car attr) 'tiled)
					 (image-put img 'tiled (cdr attr)))
					((eq (car attr) 'border)
					 (apply set-image-border
						img (cdr attr)))))
				     (cdr value)))
			     (setq value img))))
		    (cons state value))) def))

      (let ((loaded-patterns (mapcar (lambda (cell)
				       (cons (car cell)
					     (make-pattern (cdr cell))))
				     patterns-alist)))

	(define (make-frame-part def)
	  (mapcar (lambda (cell)
		    (cons (car cell)
			  (cond ((and (eq (car cell) 'text)
				      (symbolp (cdr cell)))
				 (gaol-eval (cdr cell)))
				((and (memq (car cell)
					    '(foreground background))
				      (stringp (cdr cell)))
				 (if (string-match "^#" (cdr cell))
				     ;; color
				     (get-color (cdr cell))
				   (cdr (assoc (cdr cell) loaded-patterns))))
				((and (eq (car cell) 'font)
				      (stringp (cdr cell)))
				 (get-font (cdr cell)))
				(t
				 (cdr cell))))) def))

	(mapcar (lambda (cell)
		  (cons (car cell) (mapcar make-frame-part (cdr cell))))
		frame-alist))))

  (define (make-theme patterns-alist frame-alist mapping-alist)
    (let ((real-frames (make-frames patterns-alist frame-alist)))
      (lambda (w type)
	(declare (unused w))
	(let ((frame-name (or (cdr (assq type mapping-alist)))))
	  (and frame-name (cdr (assoc frame-name real-frames)))))))

  (gaol-define 'make-theme make-theme))

;; nokogiri-shell.jl -- shell displaying custom groups
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.cfg.shell

    (export run-shell)

    (open rep
	  gui.gtk-2.gtk
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.streams
	  rep.io.timers
	  sawfish.gtk.widget
	  sawfish.cfg.i18n
	  sawfish.cfg.group
	  sawfish.cfg.slot
	  sawfish.cfg.apply
	  sawfish.cfg.layout
	  sawfish.cfg.config
	  sawfish.cfg.wm)

  (defvar *nokogiri-flatten-groups* nil)

  (define main-window)
  (define group-tree-widget)
  (define slot-box-widget)

  (define active-slots '())

  (define ok-widget)
  (define revert-widget)
  (define wiki-button)
  (define doc-button)
  (define about-button)
  (define edit-button)
  (define install-theme-label)
  (define install-theme-button)

  (define (initialize-shell)
    (let ((vbox (gtk-vbox-new nil box-spacing))
	  (hbox-a (gtk-hbutton-box-new))
	  (hbox-b (gtk-hbutton-box-new))
	  (s-scroller (gtk-scrolled-window-new))
	  root-container)

      (setq main-window (gtk-window-new 'toplevel))

      (gtk-box-set-homogeneous hbox-a t)
      (gtk-box-set-homogeneous hbox-b t)
      (gtk-window-set-resizable main-window t)
      (gtk-window-set-icon-name main-window "sawfish-config")
      (gtk-window-set-default-size main-window 550 400)
      (setq root-container (gtk-frame-new))
      (gtk-frame-set-shadow-type root-container 'etched-in)
      (gtk-container-add main-window root-container)

      (setq slot-box-widget (gtk-vbox-new nil box-spacing))

      (gtk-container-set-border-width vbox box-border)
      (gtk-container-set-border-width slot-box-widget box-border)
      (when s-scroller
	(gtk-scrolled-window-set-policy s-scroller 'automatic 'automatic)
	(gtk-scrolled-window-add-with-viewport s-scroller slot-box-widget))

      (let ((group (get-group top-group)))
	(fetch-group group)
	(if (and (not *nokogiri-flatten-groups*)
		 (group-sub-groups group))
	    (let ((paned (gtk-hpaned-new))
		  (g-scroller (gtk-scrolled-window-new)))
	      (setq group-tree-widget (make-group-tree (get-group top-group)))
	      (gtk-container-set-border-width group-tree-widget box-border)
	      (gtk-scrolled-window-set-policy g-scroller 'automatic 'automatic)
	      (gtk-container-add vbox paned)
	      (gtk-paned-add1 paned g-scroller)
	      (gtk-paned-add2 paned (or s-scroller slot-box-widget))
	      (gtk-paned-set-position paned 250)
	      (gtk-scrolled-window-add-with-viewport g-scroller
						     group-tree-widget))
	  (gtk-container-add vbox (or s-scroller slot-box-widget))))


	(setq ok-widget (gtk-button-new-from-stock "gtk-close"))
	(gtk-button-set-relief ok-widget 'none)
	(setq revert-widget (gtk-button-new-from-stock "gtk-undo"))
	(gtk-button-set-relief revert-widget 'none)
	
	(setq wiki-button (gtk-link-button-new-with-label "http://sawfish.wikia.com/" "Browse Wiki"))
	(gtk-button-set-relief wiki-button 'none)
	
	(setq edit-button (gtk-button-new-from-stock "gtk-edit"))
	(gtk-button-set-label edit-button "Edit RC")
	(gtk-button-set-relief edit-button 'none)
	
	(setq about-button (gtk-button-new-from-stock "gtk-about"))
	(gtk-button-set-relief about-button 'none)
	(setq doc-button (gtk-button-new-from-stock "gtk-help"))
	(gtk-button-set-relief doc-button 'none)
	
	(setq install-theme-label (gtk-label-new "Install theme:"))
	(setq install-theme-button (gtk-file-chooser-button-new '() 'open))
	(gtk-file-chooser-set-filename install-theme-button "~")

	(gtk-window-set-title main-window (_ "Sawfish Configurator"))
	(gtk-widget-set-name main-window (_ "Sawfish Configurator"))
	(gtk-window-set-wmclass main-window "sawfish-configurator"
                                "Sawfish-Configurator")

      (g-signal-connect main-window "delete_event" on-quit)

	(gtk-box-set-spacing hbox-a button-box-spacing)
	(gtk-button-box-set-layout hbox-a 'spread)

	(gtk-box-set-spacing hbox-b button-box-spacing)
	(gtk-button-box-set-layout hbox-b 'spread)
	
	(gtk-box-pack-end vbox hbox-b)
	(gtk-box-pack-end vbox hbox-a)

	(g-signal-connect ok-widget "clicked" on-ok)
	(g-signal-connect revert-widget "clicked" on-revert)
	
	(g-signal-connect edit-button "clicked"
	  (lambda () (if (file-exists-p "~/.sawfishrc")
		         (system "xdg-open ~/.sawfishrc &")
		       (if (file-exists-p "~/.sawfish/rc")
			   (system "xdg-open ~/.sawfish/rc &")
			 (system "echo \";;; Sawfish Resource File\" > ~/.sawfishrc &")
			 (system "xdg-open ~/.sawfishrc &")))))
	
	(g-signal-connect about-button "clicked"
	  (lambda () (system "sawfish-about >/dev/null 2>&1 </dev/null &")))
	
	(g-signal-connect doc-button "clicked"
	  (lambda () (system "x-terminal-emulator -e \"info sawfish Top\" &")))
	
	(g-signal-connect install-theme-button "file-set"
	  (lambda () (let ((file (gtk-file-chooser-get-filename install-theme-button))
			   (filex))
		       (unless (file-exists-p "~/.sawfish/themes/")
			 (unless (file-exists-p "~/.sawfish/")
			   (make-directory "~/.sawfish/"))
			 (make-directory "~/.sawfish/themes/"))
		       (setq filex (last (string-split "/" file)))
		       (gtk-file-chooser-set-filename install-theme-button "~")
		       (if (string-match "\\.tar" filex)
			   (copy-file file (concat "~/.sawfish/themes/" filex))
			 (sawfish-config-display-info "Only tar-archives can be installed at the moment." nil)))))

	(gtk-container-add hbox-a wiki-button)
	(gtk-container-add hbox-b install-theme-label)
	(gtk-container-add hbox-b install-theme-button)
	(gtk-container-add hbox-b doc-button)
	(gtk-container-add hbox-b edit-button)
	(gtk-container-add hbox-a about-button)
	(gtk-container-add hbox-a revert-widget)
	(gtk-container-add hbox-a ok-widget)

      (gtk-container-add root-container vbox)
      (gtk-widget-show-all main-window)
      (set-button-states)

      (if group-tree-widget
	  (progn
	    (gtk-tree-select-item group-tree-widget 0)
	    (mapc gtk-tree-item-expand
		  (gtk-container-get-children group-tree-widget)))
	(select-group (get-group top-group)))))

  (define (destroy-shell)
    (when main-window
      (gtk-widget-destroy main-window)
      (setq main-window nil)
      (setq group-tree-widget nil)
      (setq slot-box-widget nil)
      (setq ok-widget nil)
      (setq revert-widget nil)))

  (define (on-quit)
    (destroy-shell)
    (throw 'nokogiri-exit t))

  (define (on-ok)
    (apply-slot-changes)
    (on-quit))

  (define (on-apply)
    (apply-slot-changes)
    (set-button-states))

  (define (on-cancel)
    (revert-slot-changes)
    (on-quit))

  (define (on-revert)
    (revert-slot-changes)
    (set-button-states))

  (define (set-button-states)
    (when revert-widget
      (gtk-widget-set-sensitive revert-widget (changes-to-revert-p)))
    (when ok-widget
      (gtk-widget-set-sensitive ok-widget t)))

;;; displaying custom groups

  (define (get-slots group)
    (fetch-group group)
    (group-slots group))

  (define (add-active-slots slots)
    (setq active-slots (nconc active-slots
			      (filter (lambda (x)
					(not (memq x active-slots))) slots))))

  (define (display-book-tree group)

    (define (iter group slots)
      (let ((group-page (and slots (layout-slots (group-layout group) slots))))
	(add-active-slots slots)
	(when (and group-page (gtk-container-p group-page))
	  (gtk-container-set-border-width group-page box-border))
	(if (group-sub-groups group)
	    (let ((book (gtk-notebook-new)))
	      (gtk-notebook-set-scrollable book t)
	      (gtk-notebook-popup-enable book t)
	      (when group-page
		(gtk-notebook-append-page
		 book group-page (gtk-label-new (_ (group-real-name group)))))
	      (mapc (lambda (sub)
		      (fetch-group sub)
		      (let ((slots (get-slots sub)))
			(when (or slots (group-sub-groups sub))
			  (let ((page (iter sub slots)))
			    (when page
			      (gtk-notebook-append-page
			       book page (gtk-label-new
					  (_ (group-real-name sub)))))))))
		    (get-sub-groups group))
	      (gtk-widget-show book)
	      book)
	  group-page)))

    (let ((page (iter group (get-slots group))))
      (when page
	(gtk-container-add slot-box-widget page))))

  (define (display-flattened group)

    (define (iter book group slots)
      (when slots
	(let ((layout (layout-slots (group-layout group) slots)))
	  (add-active-slots slots)
          (gtk-box-pack-start book layout)
	  (when (gtk-container-p layout)
	    (gtk-container-set-border-width layout box-border))))
      (mapc (lambda (sub)
	      (fetch-group sub)
	      (let ((slots (get-slots sub)))
		(when (or slots (group-sub-groups group))
		  (iter book sub slots))))
	    (get-sub-groups group)))

    (let ((notebook (gtk-vbox-new nil 0)))
      (iter notebook group (get-slots group))
      (gtk-widget-show notebook)
      (gtk-container-add slot-box-widget notebook)))

  (define (display-unflattened group)
    (let* ((slots (get-slots group)))
      (gtk-container-add
       slot-box-widget (layout-slots (group-layout group) slots))
      (add-active-slots slots)))

  (define (add-group-widgets group)
    (if (and *nokogiri-flatten-groups* (group-sub-groups group))
	(display-book-tree group)
      (display-unflattened group))
    (update-all-dependences))

  (define (remove-group-widgets group)
    (declare (unused group))
    (mapc (lambda (s)
	    (let ((w (slot-gtk-widget s)))
	      (when (gtk-widget-parent w)
		(gtk-container-remove (gtk-widget-parent w) w))
	      (set-slot-layout s nil))) active-slots)
    (setq active-slots '())
    (mapc (lambda (w)
	    (gtk-container-remove slot-box-widget w))
	  (gtk-container-get-children slot-box-widget)))

  (define (sawfish-config-display-info text kill)
    (let ((window (gtk-window-new 'toplevel))
	  (vbox (gtk-vbox-new nil box-spacing))
	  (label (gtk-label-new text))
	  (button (gtk-button-new-from-stock "gtk-ok")))

      (gtk-window-set-title window "SawfishConfig Info")
      (gtk-window-set-icon-name window "gtk-info")

      (gtk-container-set-border-width window 10)
      
      (gtk-label-set-line-wrap label t)
      
      (gtk-widget-set-size-request label 225 45)
      
      (if kill
	  (progn
	    (g-signal-connect window "delete_event" (lambda () throw 'quit 1))
	    (g-signal-connect button "clicked" (lambda () (throw 'quit 1))))
	(g-signal-connect window "delete_event"
			  (lambda () (gtk-widget-destroy window)))
	(g-signal-connect button "clicked"
			  (lambda () (gtk-widget-destroy window))))
	    
      (gtk-container-add window vbox)
      (gtk-container-add vbox label)
      (gtk-container-add vbox button)

      (gtk-widget-show-all window)

      (setq interrupt-mode 'exit)
      (recursive-edit)
      (throw 'quit 1)))

  (define (run-shell)
    (condition-case nil
	(wm-locale-dir)
      (error (sawfish-config-display-info "Sawfish's configurator needs a running Sawfish. Aborting." t)))
    (when (get-command-line-option "--help")
      (write standard-output "\
usage: sawfish-config [OPTIONS...]\n
where OPTIONS are any of:\n
  --group=GROUP-NAME
  --flatten\n")
      (throw 'quit 0))

    (let ((group (get-command-line-option "--group" t)))
      (when group
	(setq group (read-from-string group))
	(set-top-group (if (listp group) group `(root ,group)))))

    (when (get-command-line-option "--flatten")
      (setq *nokogiri-flatten-groups* t))

    (setq interrupt-mode 'exit)
    (i18n-init)

    (initialize-configs)
    (initialize-shell)

    (catch 'nokogiri-exit
      (recursive-edit))
    (throw 'quit 0))

  (add-hook '*nokogiri-slot-changed-hook* set-button-states t)
  (add-hook '*nokogiri-group-selected-hook* add-group-widgets)
  (add-hook '*nokogiri-group-deselected-hook* remove-group-widgets))

;; wm-spec.jl -- ewmh support

;; Copyright (C) 1999, 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.state.wm-spec

    (export define-wm-spec-window-type
	    define-wm-spec-window-state)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.state.iconify
	  sawfish.wm.util.workarea)

  ;; todo:

  ;; - _NET_WM_ICON

  ;; 1.1 additions:
  ;;  - _NET_WM_ALLOWED_ACTIONS
  ;;  - _STATE_HIDDEN?
  ;;  - _NET_WM_MOVERESIZE changes
  ;;  - _NET_SHOWING_DESKTOP?
  ;;  - _NET_MOVERESIZE_WINDOW

;;; constants

  (defconst _NET_WM_MOVERESIZE_SIZE_TOPLEFT 0)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOP 1)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOPRIGHT 2)
  (defconst _NET_WM_MOVERESIZE_SIZE_RIGHT 3)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT 4)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOM 5)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT 6)
  (defconst _NET_WM_MOVERESIZE_SIZE_LEFT 7)
  (defconst _NET_WM_MOVERESIZE_MOVE 8)
  (defconst _NET_WM_MOVERESIZE_SIZE_KEYBOARD 9)
  (defconst _NET_WM_MOVERESIZE_MOVE_KEYBOARD 10)

  (defconst _NET_WM_STATE_REMOVE 0)
  (defconst _NET_WM_STATE_ADD 1)
  (defconst _NET_WM_STATE_TOGGLE 2)

  (define wm-spec-window-id nil)

  (define supported-atoms
    [_NET_ACTIVE_WINDOW
     _NET_CLIENT_LIST
     _NET_CLIENT_LIST_STACKING
     _NET_CLOSE_WINDOW
     _NET_CURRENT_DESKTOP
     _NET_DESKTOP_GEOMETRY
     _NET_DESKTOP_NAMES
     _NET_DESKTOP_VIEWPORT
     _NET_NUMBER_OF_DESKTOPS
     _NET_PROTOCOLS
     _NET_SHOWING_DESKTOP
     _NET_SUPPORTED
     _NET_SUPPORTING_WM_CHECK
     _NET_WORKAREA
     _NET_WM_DESKTOP
     _NET_WM_ICON_GEOMETRY
     _NET_WM_MOVERESIZE
     _NET_WM_MOVERESIZE_MOVE
     _NET_WM_MOVERESIZE_SIZE_BOTTOM
     _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT
     _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT
     _NET_WM_MOVERESIZE_SIZE_LEFT
     _NET_WM_MOVERESIZE_SIZE_RIGHT
     _NET_WM_MOVERESIZE_SIZE_TOP
     _NET_WM_MOVERESIZE_SIZE_TOPLEFT
     _NET_WM_MOVERESIZE_SIZE_TOPRIGHT
     _NET_WM_MOVERESIZE_SIZE_KEYBOARD
     _NET_WM_MOVERESIZE_MOVE_KEYBOARD
     _NET_WM_PING
     _NET_WM_STATE
     _NET_WM_STATE_ABOVE
     _NET_WM_STATE_ADD
     _NET_WM_STATE_BELOW
     _NET_WM_STATE_FULLSCREEN
     _NET_WM_STATE_MAXIMIZED
     _NET_WM_STATE_MAXIMIZED_HORZ
     _NET_WM_STATE_MAXIMIZED_VERT
     _NET_WM_STATE_REMOVE
     _NET_WM_STATE_SHADED
     _NET_WM_STATE_SKIP_PAGER
     _NET_WM_STATE_SKIP_TASKBAR
     _NET_WM_STATE_STICKY
     _NET_WM_STATE_TOGGLE
     _NET_WM_STRUT
     _NET_WM_WINDOW_TYPE
     _NET_WM_WINDOW_TYPE_DESKTOP
     _NET_WM_WINDOW_TYPE_DIALOG
     _NET_WM_WINDOW_TYPE_DOCK
     _NET_WM_WINDOW_TYPE_TOOLBAR
     _NET_WM_WINDOW_TYPE_MENU
     _NET_WM_WINDOW_TYPE_UTILITY
     _NET_WM_WINDOW_TYPE_SPLASH
     _NET_WM_USER_TIME])

  (defvar wm-spec-below-depth -2)
  (defvar wm-spec-above-depth +2)

  (define supported-states '())

;;; setting the client list hints

  (define (update-client-list-hints #!key only-stacking-list)
    (define (set-prop lst prop)
      (let loop ((rest lst)
		 (collected '()))
	(cond ((null rest)
	       (set-x-property 'root prop
			       (apply vector (nreverse collected))
			       'WINDOW 32))
	      ((window-mapped-p (car rest))
	       (loop (cdr rest) (cons (window-id (car rest)) collected)))
	      (t (loop (cdr rest) collected)))))
    (unless only-stacking-list
      (set-prop (managed-windows) '_NET_CLIENT_LIST))
    (set-prop (nreverse (stacking-order)) '_NET_CLIENT_LIST_STACKING))

  ;; setting the desktop / viewport hints

  (define last-workspace nil)
  (define last-workspace-count 0)
  (define last-workspace-names nil)
  (define last-area nil)
  (define last-area-count nil)
  (define last-workarea nil)
  (define last-showing-desktop nil)

  (define (update-window-workspace-hints w #!key (limits (workspace-limits)))
    (let ((vec (if (window-sticky-p/workspace w)
		   (vector #xffffffff)
		 (let ((space (or (window-get w 'swapped-in)
				  (car (window-workspaces w)))))
		   (and space (vector (- space (car limits))))))))
      (unless (equal vec (window-get w 'wm-spec/last-workspace))
	(if vec
	    (set-x-property w '_NET_WM_DESKTOP vec 'CARDINAL 32)
	  (delete-x-property w '_NET_WM_DESTOP))
	(window-put w 'wm-spec/last-workspace vec))))

  (define (update-workspace-hints)
    (let* ((limits (workspace-limits))
	   (port (screen-viewport))
           ;; Since vp size can vary from workspace to workspace, use
           ;; the maximum dimensions accross all workspaces.
	   (port-size (let ((dims (cons viewport-dimensions
                                        (mapcar (lambda (e)
                                                  (unless (eq (car e)
                                                              current-workspace)
                                                    (nth 3 e)))
                                                workspace-viewport-data))))
                        (cons (apply max (mapcar car dims))
                              (apply max (mapcar cdr dims)))))
	   (total-workspaces (1+ (- (cdr limits) (car limits))))
	   (workarea (make-vector (* 4 total-workspaces)))
	   (showing-desktop (showing-desktop-p)))

      (define (set-ws-hints)
	;; _NET_NUMBER_OF_DESKTOPS
	(unless (equal last-workspace-count total-workspaces)
	  (setq last-workspace-count total-workspaces)
	  (set-x-property 'root '_NET_NUMBER_OF_DESKTOPS
			  (vector total-workspaces) 'CARDINAL 32))

	;; _NET_DESKTOP_NAMES
	(unless (equal last-workspace-names workspace-names)
	  (setq last-workspace-names workspace-names)
	  (set-x-text-property 'root '_NET_DESKTOP_NAMES
			       (apply vector workspace-names)
			       'UTF8_STRING))

	;; _NET_CURRENT_DESKTOP
	(unless (equal last-workspace
		       (- current-workspace (car limits)))
	  (setq last-workspace (- current-workspace (car limits)))
	  (set-x-property 'root '_NET_CURRENT_DESKTOP
			  (vector last-workspace) 'CARDINAL 32))

	;; _NET_DESKTOP_GEOMETRY
	(unless (equal last-area-count port-size)
	  (setq last-area-count port-size)
	  (set-x-property 'root '_NET_DESKTOP_GEOMETRY
			  (vector (* (car port-size) (screen-width))
				  (* (cdr port-size) (screen-height)))
			  'CARDINAL 32))

	;; _NET_DESKTOP_VIEWPORT
	(unless (equal last-area port)
	  (let ((view (make-vector (* total-workspaces 2))))
	    (let loop ((i 0))
	      (if (= i total-workspaces)
		  (set-x-property 'root '_NET_DESKTOP_VIEWPORT
				  view 'CARDINAL 32)
		(if (eq i current-workspace)
		    (progn
		      (aset view (* i 2) (* (car port) (screen-width)))
		      (aset view (1+ (* i 2)) (* (cdr port)
						 (screen-height))))
		  (let ((vp-data (cdr (assoc i workspace-viewport-data))))
		    (aset view (* i 2) (car vp-data))
		    (aset view (1+ (* i 2)) (nth 1 vp-data))))
		(loop (1+ i))))))

	;; _NET_WORKAREA
	(unless (equal last-workarea workarea)
	  (set-x-property 'root '_NET_WORKAREA workarea 'CARDINAL 32)
	  (setq last-workarea workarea))

	;; _NET_SHOWING_DESKTOP
	(unless (equal showing-desktop last-showing-desktop)
	  (set-x-property 'root '_NET_SHOWING_DESKTOP
			  (vector (if showing-desktop 1 0)) 'CARDINAL 32)
	  (setq last-showing-desktop showing-desktop)))

      (define (set-window-hints w)
	(update-window-workspace-hints w #:limits limits))

      ;; calculate workareas
      (do ((i 0 (1+ i)))
	  ((= i total-workspaces))
	(let ((area (calculate-workarea-from-struts
		     #:workspace (+ i (car limits)))))
	  (aset workarea (+ (* i 4) 0) (nth 0 area))
	  (aset workarea (+ (* i 4) 1) (nth 1 area))
	  (aset workarea (+ (* i 4) 2) (- (nth 2 area) (nth 0 area)))
	  (aset workarea (+ (* i 4) 3) (- (nth 3 area) (nth 1 area)))))

      ;; apparently some pagers don't like it if we place windows
      ;; on (temporarily) non-existent workspaces
      (when (< last-workspace-count total-workspaces)
	(set-ws-hints))

      (map-windows set-window-hints)

      (when (>= last-workspace-count total-workspaces)
	(set-ws-hints))))

;;; setting the focus hints

  (define last-focus nil)

  (define (update-focus-state w mode)
    (declare (unused w))
    (let ((focus (input-focus)))
      (unless (or (eq mode 'grab) (eq mode 'ungrab) (eq last-focus focus))
	(setq last-focus focus)
	(set-x-property 'root '_NET_ACTIVE_WINDOW
			(vector (if focus (window-id focus) 0)) 'WINDOW 32))))

;;; setting the window state hints

  (define (update-client-state w)
    (let ((state '()))
      (mapc (lambda (x)
	      (when (and (not (pseudo-state-p x))
			 (call-state-fun w x 'get))
		(setq state (cons x state))))
	    supported-states)
      (set-x-property w '_NET_WM_STATE (apply vector state) 'ATOM 32)))

;;; honouring the initially set window state hints

  (define (update-icon-geometry w geom)
    (when (>= (length geom) 2)
      (window-put w 'icon-position (cons (aref geom 0) (aref geom 1)))))

  (define (update-strut w)
    (let ((strut (get-x-property w '_NET_WM_STRUT)))
      (when (and strut (eq (nth 0 strut) 'CARDINAL))
	(let ((data (nth 2 strut)))
	  (define-window-strut w (aref data 0) (aref data 2)
            (aref data 1) (aref data 3))))))

  (define (honour-client-state w)
    (let ((space (get-x-property w '_NET_WM_DESKTOP)))
      (when space
	(setq space (aref (nth 2 space) 0))
	(cond ((equal space #xffffffff)
	       (window-put w 'sticky t))
	      ((and (integerp space) (null (window-workspaces w)))
	       (set-window-workspaces w (list space))))))

    (let ((type (get-x-property w '_NET_WM_WINDOW_TYPE)))
      (when type
	(setq type (nth 2 type))
	;; _NET_WM_WINDOW_TYPE is a vector of atoms, the first atom
	;; about which we know something is the type we'll use
	(let loop ((i 0))
	  (cond ((= i (length type)))
		((get (aref type i) 'wm-spec-type)
		 ((get (aref type i) 'wm-spec-type) w))
		(t (loop (1+ i)))))))

    (let ((state (get-x-property w '_NET_WM_STATE)))
      (when state
	(setq state (nth 2 state))
	(do ((i 0 (1+ i)))
	    ((= i (length state)))
	  (call-state-fun w (aref state i) 'init))))

    (update-strut w)

    (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
      (when geom
	(update-icon-geometry w (nth 2 geom))))
    (when (equal (get-x-property w '_NET_WM_USER_TIME)
                 '(CARDINAL 32 #(0)))
      (window-put w 'inhibit-focus-when-mapped t)))

;;; helper functions

  (define (define-wm-spec-window-type x fun)
    (if (listp x)
	(mapc (lambda (y) (define-wm-spec-window-type y fun)) x)
      (put x 'wm-spec-type fun)))

  (define (define-wm-spec-window-state x fun #!key pseudo)
    (put x 'wm-spec-state fun)
    (unless (memq x supported-states)
      (setq supported-states (cons x supported-states)))
    (when pseudo
      (put x 'wm-spec-pseudo-state t)))

  (define (supported-state-p x) (and (symbolp x) (get x 'wm-spec-state)))
  (define (pseudo-state-p x) (and (symbolp x) (get x 'wm-spec-pseudo-state)))

  (define (call-state-fun w state mode)
    (let ((fun (and (symbolp state) (get state 'wm-spec-state))))
      (when fun
	(fun w mode))))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DESKTOP
    (lambda (w)
      (mark-window-as-desktop w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DOCK
    (lambda (w)
      (mark-window-as-dock w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DIALOG
    (lambda (w)
      (mark-window-as-transient w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_UTILITY
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'utility)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_TOOLBAR
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'toolbar)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_MENU
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'menu)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_SPLASH
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'splash)
      (window-put w 'place-mode 'centered)))

  (define-wm-spec-window-state '_NET_WM_STATE_STICKY
    (lambda (w mode)
      (case mode
        ((init)   (window-put w 'sticky-viewport t))
        ((remove) (make-window-unsticky/viewport w))
        ((add)    (make-window-sticky/viewport w))
        ((toggle) (if (window-sticky-p/viewport w)
                      (make-window-unsticky/viewport w)
                    (make-window-sticky/viewport w)))
        ((get)    (window-sticky-p/viewport w)))))

  (define (wm-spec-maximize-handler direction)
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
	((init)
	 (window-put w (if (eq direction 'vertical)
			   'queued-vertical-maximize
			 'queued-horizontal-maximize) t))
	((remove) (unmaximize-window w direction))
	((add)    (maximize-window w direction))
	((toggle) (maximize-window-toggle w direction))
	((get)    (if (window-maximized-fullscreen-p w)
		      nil
		    (case direction
		      ((vertical) (window-maximized-vertically-p w))
		      ((horizontal) (window-maximized-horizontally-p w))
		      (t (window-maximized-p w))))))))

  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_VERT
    (wm-spec-maximize-handler 'vertical))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_HORZ
    (wm-spec-maximize-handler 'horizontal))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED
    (wm-spec-maximize-handler nil)
    #:pseudo t)

  (define-wm-spec-window-state '_NET_WM_STATE_SHADED
    (lambda (w mode)
      (require 'sawfish.wm.state.shading)
      (case mode
        ((init)   (window-put w 'shaded t))
        ((add)    (shade-window w))
        ((remove) (unshade-window w))
        ((toggle) (toggle-window-shaded w))
        ((get)    (window-get w 'shaded)))))

  (define-wm-spec-window-state '_NET_WM_STATE_SKIP_PAGER
    (lambda (w mode)
      (case mode
        ((init add) (window-put w 'window-list-skip t))
        ((remove)   (window-put w 'window-list-skip nil))
        ((toggle)   (window-put w 'window-list-skip
                                (not (window-get w 'window-list-skip))))
        ((get)      (window-get w 'window-list-skip)))))

  (define-wm-spec-window-state '_NET_WM_STATE_SKIP_TASKBAR
    (lambda (w mode)
      (case mode
        ((init add) (window-put w 'task-list-skip t))
        ((remove)   (window-put w 'task-list-skip nil))
        ((toggle)   (window-put w 'task-list-skip
                                (not (window-get w 'task-list-skip))))
        ((get)      (window-get w 'task-list-skip)))))

  (define-wm-spec-window-state '_NET_WM_STATE_FULLSCREEN
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
        ((init) (window-put w 'queued-fullscreen-maximize t))
        ((add remove) (maximize-window-fullscreen w (eq mode 'add)))
        ((toggle) (maximize-window-fullscreen-toggle w))
        ((get) (window-maximized-fullscreen-p w)))))

  (define (above-below-handler depth w mode)
    (require 'sawfish.wm.stacking)
    (case mode
      ((init)
       (window-put w 'depth depth))
      ((add remove)
       (set-window-depth w (if (eq mode 'add) depth 0)))
      ((toggle)
       (set-window-depth w (if (= (window-depth w) depth) 0 depth)))
      ((get)
       (= (window-depth w) depth))))

  (define-wm-spec-window-state '_NET_WM_STATE_BELOW
    (lambda (w mode)
      (above-below-handler wm-spec-below-depth w mode)))

  (define-wm-spec-window-state '_NET_WM_STATE_ABOVE
    (lambda (w mode)
      (above-below-handler wm-spec-above-depth w mode)))

;;; client messages

  (define (client-message-handler w type data)
    (let ((handled t))
      (case type
	((_NET_CLOSE_WINDOW)
	 (when (windowp w)
	   (delete-window w)))

	((_NET_SHOWING_DESKTOP)
	 (if (= (aref data 0) 1)
	     (show-desktop)
	   (hide-desktop)))

	((_NET_WM_MOVERESIZE)
	 (when (and (windowp w) (window-mapped-p w))
	   (require 'sawfish.wm.commands.move-resize)
	   (let ((mode (aref data 2)))
	     ;; don't want grabs failing, sigh
	     (x-server-timestamp t t)
	     (if (or (eq mode _NET_WM_MOVERESIZE_MOVE)
		     (eq mode _NET_WM_MOVERESIZE_MOVE_KEYBOARD))
		 (move-window-interactively w)
	       (let ((move-resize-moving-edges
		      (cond ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPLEFT)
			     '(top left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOP)
			     '(top))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPRIGHT)
			     '(top right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT)
			     '(bottom left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOM)
			     '(bottom))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT)
			     '(bottom right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_LEFT)
			     '(left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_RIGHT)
			     '(right)))))
		 (resize-window-interactively w))))))

	((_NET_NUMBER_OF_DESKTOPS)
	 (set-number-of-workspaces (aref data 0)))

	((_NET_DESKTOP_GEOMETRY)
	 (set-number-of-viewports (aref data 0) (aref data 1)))

	((_NET_DESKTOP_VIEWPORT)
	 (set-viewport (aref data 0) (aref data 1)))

	((_NET_CURRENT_DESKTOP)
         ;; KDE spews _NET_CURRENT_DESKTOP( -1) messages so often that it
         ;; is best to just ignore out of bounds errors silently.
         (let ((ws (workspace-id-from-logical (aref data 0)))
               (limits (workspace-limits)))
           (if (<= (car limits) ws (cdr limits))
               (select-workspace ws))))

	((_NET_DESKTOP_NAMES)
	 ;; XXX this is kind of broken now we use workspace-names to
	 ;; XXX define the minimum number of workspaces to display?
	 (setq data (aref data 0))
	 (let loop ((i 0)
		    (out '()))
	   (if (= i (length data))
	       (setq workspace-names (nreverse out))
	     (loop (1+ i) (cons (aref data i) out)))))

	((_NET_ACTIVE_WINDOW)
	 (require 'sawfish.wm.util.display-window)
	 (when (and (windowp w) (window-mapped-p w))
	   (display-window w)))

	((_NET_WM_STATE)
	 (when (windowp w)
	   (let ((mode (cond ((eql (aref data 0) _NET_WM_STATE_REMOVE)
                              'remove)
			     ((eql (aref data 0) _NET_WM_STATE_ADD)
                              'add)
			     ((eql (aref data 0) _NET_WM_STATE_TOGGLE)
                              'toggle)))
		 (atom1 (x-atom-name (aref data 1)))
		 (atom2 (x-atom-name (aref data 2))))
	     (when (or (and (eq atom1 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom2 '_NET_WM_STATE_MAXIMIZED_HORZ))
		       (and (eq atom2 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom1 '_NET_WM_STATE_MAXIMIZED_HORZ)))
	       (setq atom1 '_NET_WM_STATE_MAXIMIZED)
	       (setq atom2 nil))
	     (when atom1
	       (call-state-fun w atom1 mode))
	     (when atom2
	       (call-state-fun w atom2 mode)))))

	((_NET_WM_DESKTOP)
	 (when (windowp w)
	   (let ((desktop (aref data 0)))
	     (if (eql desktop #xffffffff)
		 ;; making window sticky
		 (make-window-sticky/workspace w)
	       ;; changing the desktop
	       (make-window-unsticky/workspace w)
	       (send-window-to-workspace-from-first w desktop nil)))))

	(t (setq handled nil)))
      handled))

;;; property changes

  (define (property-change-handler w prop kind)
    (declare (unused kind))
    (case prop
      ((_NET_WM_ICON_GEOMETRY)
       (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
	 (when geom
	   (update-icon-geometry w (nth 2 geom)))))
      ((_NET_WM_STRUT)
       (update-strut w))))

;;; utilities

  (define (vector->list vec)
    (do ((i 0 (1+ i))
	 (out '() (cons (aref vec i) out)))
	((= i (length vec)) (nreverse out))))

  (define (update-on-configure-notify w)
    (when (eq w 'root)
      (update-workspace-hints)))

;;; initialisation

  (define (init)
    (setq wm-spec-window-id (create-window 'root -200 -200 5 5))

    (set-x-property 'root '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_WM_NAME "Sawfish" 'UTF8_STRING 8)

    (set-x-property 'root '_NET_SUPPORTED supported-atoms 'ATOM 32)

    (let ((current-desktop (get-x-property 'root '_NET_CURRENT_DESKTOP)))
      (when (and current-desktop
		 (eq (car current-desktop) 'CARDINAL)
		 (>= (length (caddr current-desktop)) 1))
	(add-hook 'after-initialization-hook
		  ;; Don't do this yet, it can screw things up
		  (lambda ()
		    (select-workspace-from-first
		     (aref (caddr current-desktop) 0))))))

    (update-client-list-hints)
    (update-workspace-hints)

    (add-hook 'workspace-state-change-hook update-workspace-hints)
    (add-hook 'viewport-resized-hook update-workspace-hints)
    (add-hook 'viewport-moved-hook update-workspace-hints)
    (add-hook 'workarea-changed-hook update-workspace-hints)
    (add-hook 'configure-notify-hook update-on-configure-notify)

    ;; Better not expose work in progress.  map-notify-hook gets
    ;; called after this anyway.
    ;;(add-hook 'add-window-hook update-client-list-hints)
    (add-hook 'destroy-notify-hook update-client-list-hints)
    (add-hook 'map-notify-hook update-client-list-hints)
    (add-hook 'unmap-notify-hook update-client-list-hints)
    (add-hook 'after-restacking-hook update-client-list-hints)

    (add-hook 'before-add-window-hook honour-client-state)
    (add-hook 'add-window-hook update-client-state)
    (call-after-state-changed '(sticky shaded maximized stacking
                                       window-list-skip task-list-skip)
			      update-client-state)
    (call-after-state-changed 'sticky update-window-workspace-hints)

    (add-hook 'focus-in-hook update-focus-state)
    (add-hook 'focus-out-hook update-focus-state)

    (add-hook 'client-message-hook client-message-handler)
    (add-hook 'property-notify-hook property-change-handler)

    (add-hook 'before-exit-hook exit)

    (map-windows update-client-state))

  (define (exit)
    (destroy-window wm-spec-window-id)
    (delete-x-property 'root '_NET_SUPPORTING_WM_CHECK)
    (delete-x-property 'root '_NET_PROTOCOLS)
    (delete-x-property 'root '_NET_DESKTOP_GEOMETRY)
    (delete-x-property 'root '_NET_DESKTOP_VIEWPORT))

  (unless (or wm-spec-window-id batch-mode)
    (init)))

;; wm-spec.jl -- ewmh support

;; Copyright (C) 1999, 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.state.wm-spec

    (export define-wm-spec-window-type
	    define-wm-spec-window-state)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.state.iconify
	  sawfish.wm.util.workarea)

  ;; todo:

  ;; - _NET_WM_ICON

  ;; 1.1 additions:
  ;;  - _NET_WM_ALLOWED_ACTIONS
  ;;  - _STATE_HIDDEN?
  ;;  - _NET_WM_MOVERESIZE changes
  ;;  - _NET_SHOWING_DESKTOP?
  ;;  - _NET_MOVERESIZE_WINDOW

;;; constants

  (defconst _NET_WM_MOVERESIZE_SIZE_TOPLEFT 0)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOP 1)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOPRIGHT 2)
  (defconst _NET_WM_MOVERESIZE_SIZE_RIGHT 3)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT 4)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOM 5)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT 6)
  (defconst _NET_WM_MOVERESIZE_SIZE_LEFT 7)
  (defconst _NET_WM_MOVERESIZE_MOVE 8)
  (defconst _NET_WM_MOVERESIZE_SIZE_KEYBOARD 9)
  (defconst _NET_WM_MOVERESIZE_MOVE_KEYBOARD 10)

  (defconst _NET_WM_STATE_REMOVE 0)
  (defconst _NET_WM_STATE_ADD 1)
  (defconst _NET_WM_STATE_TOGGLE 2)

  (define wm-spec-window-id nil)

  (define supported-atoms
    [_NET_ACTIVE_WINDOW
     _NET_CLIENT_LIST
     _NET_CLIENT_LIST_STACKING
     _NET_CLOSE_WINDOW
     _NET_CURRENT_DESKTOP
     _NET_DESKTOP_GEOMETRY
     _NET_DESKTOP_NAMES
     _NET_DESKTOP_VIEWPORT
     _NET_NUMBER_OF_DESKTOPS
     _NET_PROTOCOLS
     _NET_SHOWING_DESKTOP
     _NET_SUPPORTED
     _NET_SUPPORTING_WM_CHECK
     _NET_WORKAREA
     _NET_WM_DESKTOP
     _NET_WM_ICON_GEOMETRY
     _NET_WM_MOVERESIZE
     _NET_WM_MOVERESIZE_MOVE
     _NET_WM_MOVERESIZE_SIZE_BOTTOM
     _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT
     _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT
     _NET_WM_MOVERESIZE_SIZE_LEFT
     _NET_WM_MOVERESIZE_SIZE_RIGHT
     _NET_WM_MOVERESIZE_SIZE_TOP
     _NET_WM_MOVERESIZE_SIZE_TOPLEFT
     _NET_WM_MOVERESIZE_SIZE_TOPRIGHT
     _NET_WM_MOVERESIZE_SIZE_KEYBOARD
     _NET_WM_MOVERESIZE_MOVE_KEYBOARD
     _NET_WM_PING
     _NET_WM_STATE
     _NET_WM_STATE_ABOVE
     _NET_WM_STATE_ADD
     _NET_WM_STATE_BELOW
     _NET_WM_STATE_FULLSCREEN
     _NET_WM_STATE_MAXIMIZED
     _NET_WM_STATE_MAXIMIZED_HORZ
     _NET_WM_STATE_MAXIMIZED_VERT
     _NET_WM_STATE_REMOVE
     _NET_WM_STATE_SHADED
     _NET_WM_STATE_SKIP_PAGER
     _NET_WM_STATE_SKIP_TASKBAR
     _NET_WM_STATE_STICKY
     _NET_WM_STATE_TOGGLE
     _NET_WM_STRUT
     _NET_WM_WINDOW_TYPE
     _NET_WM_WINDOW_TYPE_DESKTOP
     _NET_WM_WINDOW_TYPE_DIALOG
     _NET_WM_WINDOW_TYPE_DOCK
     _NET_WM_WINDOW_TYPE_TOOLBAR
     _NET_WM_WINDOW_TYPE_MENU
     _NET_WM_WINDOW_TYPE_UTILITY
     _NET_WM_WINDOW_TYPE_SPLASH
     _NET_WM_USER_TIME])

  (defvar wm-spec-below-depth -2)
  (defvar wm-spec-above-depth +2)

  (define supported-states '())

;;; setting the client list hints

  (define (update-client-list-hints #!key only-stacking-list)
    (define (set-prop lst prop)
      (let loop ((rest lst)
		 (collected '()))
	(cond ((null rest)
	       (set-x-property 'root prop
			       (apply vector (nreverse collected))
			       'WINDOW 32))
	      ((window-mapped-p (car rest))
	       (loop (cdr rest) (cons (window-id (car rest)) collected)))
	      (t (loop (cdr rest) collected)))))
    (unless only-stacking-list
      (set-prop (managed-windows) '_NET_CLIENT_LIST))
    (set-prop (nreverse (stacking-order)) '_NET_CLIENT_LIST_STACKING))

  ;; setting the desktop / viewport hints

  (define last-workspace nil)
  (define last-workspace-count 0)
  (define last-workspace-names nil)
  (define last-area nil)
  (define last-area-count nil)
  (define last-workarea nil)
  (define last-showing-desktop nil)

  (define (update-window-workspace-hints w #!key (limits (workspace-limits)))
    (let ((vec (if (window-sticky-p/workspace w)
		   (vector #xffffffff)
		 (let ((space (or (window-get w 'swapped-in)
				  (car (window-workspaces w)))))
		   (and space (vector (- space (car limits))))))))
      (unless (equal vec (window-get w 'wm-spec/last-workspace))
	(if vec
	    (set-x-property w '_NET_WM_DESKTOP vec 'CARDINAL 32)
	  (delete-x-property w '_NET_WM_DESTOP))
	(window-put w 'wm-spec/last-workspace vec))))

  (define (update-workspace-hints)
    (let* ((limits (workspace-limits))
	   (port (screen-viewport))
           ;; Since vp size can vary from workspace to workspace, use
           ;; the maximum dimensions across all workspaces.
	   (port-size (let ((dims (cons viewport-dimensions
                                        (mapcar (lambda (e)
                                                  (unless (eq (car e)
                                                              current-workspace)
                                                    (nth 3 e)))
                                                workspace-viewport-data))))
                        (cons (apply max (mapcar car dims))
                              (apply max (mapcar cdr dims)))))
	   (total-workspaces (1+ (- (cdr limits) (car limits))))
	   (workarea (make-vector (* 4 total-workspaces)))
	   (showing-desktop (showing-desktop-p)))

      (define (set-ws-hints)
	;; _NET_NUMBER_OF_DESKTOPS
	(unless (equal last-workspace-count total-workspaces)
	  (setq last-workspace-count total-workspaces)
	  (set-x-property 'root '_NET_NUMBER_OF_DESKTOPS
			  (vector total-workspaces) 'CARDINAL 32))

	;; _NET_DESKTOP_NAMES
	(unless (equal last-workspace-names workspace-names)
	  (setq last-workspace-names workspace-names)
	  (set-x-text-property 'root '_NET_DESKTOP_NAMES
			       (apply vector workspace-names)
			       'UTF8_STRING))

	;; _NET_CURRENT_DESKTOP
	(unless (equal last-workspace
		       (- current-workspace (car limits)))
	  (setq last-workspace (- current-workspace (car limits)))
	  (set-x-property 'root '_NET_CURRENT_DESKTOP
			  (vector last-workspace) 'CARDINAL 32))

	;; _NET_DESKTOP_GEOMETRY
	(unless (equal last-area-count port-size)
	  (setq last-area-count port-size)
	  (set-x-property 'root '_NET_DESKTOP_GEOMETRY
			  (vector (* (car port-size) (screen-width))
				  (* (cdr port-size) (screen-height)))
			  'CARDINAL 32))

	;; _NET_DESKTOP_VIEWPORT
	(unless (equal last-area port)
	  (let ((view (make-vector (* total-workspaces 2))))
	    (let loop ((i 0))
	      (if (= i total-workspaces)
		  (set-x-property 'root '_NET_DESKTOP_VIEWPORT
				  view 'CARDINAL 32)
		(if (eq i current-workspace)
		    (progn
		      (aset view (* i 2) (* (car port) (screen-width)))
		      (aset view (1+ (* i 2)) (* (cdr port)
						 (screen-height))))
		  (let ((vp-data (cdr (assoc i workspace-viewport-data))))
		    (aset view (* i 2) (car vp-data))
		    (aset view (1+ (* i 2)) (nth 1 vp-data))))
		(loop (1+ i))))))

	;; _NET_WORKAREA
	(unless (equal last-workarea workarea)
	  (set-x-property 'root '_NET_WORKAREA workarea 'CARDINAL 32)
	  (setq last-workarea workarea))

	;; _NET_SHOWING_DESKTOP
	(unless (equal showing-desktop last-showing-desktop)
	  (set-x-property 'root '_NET_SHOWING_DESKTOP
			  (vector (if showing-desktop 1 0)) 'CARDINAL 32)
	  (setq last-showing-desktop showing-desktop)))

      (define (set-window-hints w)
	(update-window-workspace-hints w #:limits limits))

      ;; calculate workareas
      (do ((i 0 (1+ i)))
	  ((= i total-workspaces))
	(let ((area (calculate-workarea-from-struts
		     #:workspace (+ i (car limits)))))
	  (aset workarea (+ (* i 4) 0) (nth 0 area))
	  (aset workarea (+ (* i 4) 1) (nth 1 area))
	  (aset workarea (+ (* i 4) 2) (- (nth 2 area) (nth 0 area)))
	  (aset workarea (+ (* i 4) 3) (- (nth 3 area) (nth 1 area)))))

      ;; apparently some pagers don't like it if we place windows
      ;; on (temporarily) non-existent workspaces
      (when (< last-workspace-count total-workspaces)
	(set-ws-hints))

      (map-windows set-window-hints)

      (when (>= last-workspace-count total-workspaces)
	(set-ws-hints))))

;;; setting the focus hints

  (define last-focus nil)

  (define (update-focus-state w mode)
    (declare (unused w))
    (let ((focus (input-focus)))
      (unless (or (eq mode 'grab) (eq mode 'ungrab) (eq last-focus focus))
	(setq last-focus focus)
	(set-x-property 'root '_NET_ACTIVE_WINDOW
			(vector (if focus (window-id focus) 0)) 'WINDOW 32))))

;;; setting the window state hints

  (define (update-client-state w)
    (let ((state '()))
      (mapc (lambda (x)
	      (when (and (not (pseudo-state-p x))
			 (call-state-fun w x 'get))
		(setq state (cons x state))))
	    supported-states)
      (set-x-property w '_NET_WM_STATE (apply vector state) 'ATOM 32)))

;;; honouring the initially set window state hints

  (define (update-icon-geometry w geom)
    (when (>= (length geom) 2)
      (window-put w 'icon-position (cons (aref geom 0) (aref geom 1)))))

  (define (update-strut w)
    (let ((strut (get-x-property w '_NET_WM_STRUT)))
      (when (and strut (eq (nth 0 strut) 'CARDINAL))
	(let ((data (nth 2 strut)))
	  (define-window-strut w (aref data 0) (aref data 2)
            (aref data 1) (aref data 3))))))

  (define (honour-client-state w)
    (let ((space (get-x-property w '_NET_WM_DESKTOP)))
      (when space
	(setq space (aref (nth 2 space) 0))
	(cond ((equal space #xffffffff)
	       (window-put w 'sticky t))
	      ((and (integerp space) (null (window-workspaces w)))
	       (set-window-workspaces w (list space))))))

    (let ((type (get-x-property w '_NET_WM_WINDOW_TYPE)))
      (when type
	(setq type (nth 2 type))
	;; _NET_WM_WINDOW_TYPE is a vector of atoms, the first atom
	;; about which we know something is the type we'll use
	(let loop ((i 0))
	  (cond ((= i (length type)))
		((get (aref type i) 'wm-spec-type)
		 ((get (aref type i) 'wm-spec-type) w))
		(t (loop (1+ i)))))))

    (let ((state (get-x-property w '_NET_WM_STATE)))
      (when state
	(setq state (nth 2 state))
	(do ((i 0 (1+ i)))
	    ((= i (length state)))
	  (call-state-fun w (aref state i) 'init))))

    (update-strut w)

    (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
      (when geom
	(update-icon-geometry w (nth 2 geom))))
    (when (equal (get-x-property w '_NET_WM_USER_TIME)
                 '(CARDINAL 32 #(0)))
      (window-put w 'inhibit-focus-when-mapped t)))

;;; helper functions

  (define (define-wm-spec-window-type x fun)
    (if (listp x)
	(mapc (lambda (y) (define-wm-spec-window-type y fun)) x)
      (put x 'wm-spec-type fun)))

  (define (define-wm-spec-window-state x fun #!key pseudo)
    (put x 'wm-spec-state fun)
    (unless (memq x supported-states)
      (setq supported-states (cons x supported-states)))
    (when pseudo
      (put x 'wm-spec-pseudo-state t)))

  (define (supported-state-p x) (and (symbolp x) (get x 'wm-spec-state)))
  (define (pseudo-state-p x) (and (symbolp x) (get x 'wm-spec-pseudo-state)))

  (define (call-state-fun w state mode)
    (let ((fun (and (symbolp state) (get state 'wm-spec-state))))
      (when fun
	(fun w mode))))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DESKTOP
    (lambda (w)
      (mark-window-as-desktop w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DOCK
    (lambda (w)
      (mark-window-as-dock w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DIALOG
    (lambda (w)
      (mark-window-as-transient w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_UTILITY
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'utility)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_TOOLBAR
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'toolbar)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_MENU
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'menu)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_SPLASH
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'splash)
      (window-put w 'place-mode 'centered)))

  (define-wm-spec-window-state '_NET_WM_STATE_STICKY
    (lambda (w mode)
      (case mode
        ((init)   (window-put w 'sticky-viewport t))
        ((remove) (make-window-unsticky/viewport w))
        ((add)    (make-window-sticky/viewport w))
        ((toggle) (if (window-sticky-p/viewport w)
                      (make-window-unsticky/viewport w)
                    (make-window-sticky/viewport w)))
        ((get)    (window-sticky-p/viewport w)))))

  (define (wm-spec-maximize-handler direction)
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
	((init)
	 (window-put w (if (eq direction 'vertical)
			   'queued-vertical-maximize
			 'queued-horizontal-maximize) t))
	((remove) (unmaximize-window w direction))
	((add)    (maximize-window w direction))
	((toggle) (maximize-window-toggle w direction))
	((get)    (if (window-maximized-fullscreen-p w)
		      nil
		    (case direction
		      ((vertical) (window-maximized-vertically-p w))
		      ((horizontal) (window-maximized-horizontally-p w))
		      (t (window-maximized-p w))))))))

  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_VERT
    (wm-spec-maximize-handler 'vertical))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_HORZ
    (wm-spec-maximize-handler 'horizontal))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED
    (wm-spec-maximize-handler nil)
    #:pseudo t)

  (define-wm-spec-window-state '_NET_WM_STATE_SHADED
    (lambda (w mode)
      (require 'sawfish.wm.state.shading)
      (case mode
        ((init)   (window-put w 'shaded t))
        ((add)    (shade-window w))
        ((remove) (unshade-window w))
        ((toggle) (toggle-window-shaded w))
        ((get)    (window-get w 'shaded)))))

  (define-wm-spec-window-state '_NET_WM_STATE_SKIP_PAGER
    (lambda (w mode)
      (case mode
        ((init add) (window-put w 'window-list-skip t))
        ((remove)   (window-put w 'window-list-skip nil))
        ((toggle)   (window-put w 'window-list-skip
                                (not (window-get w 'window-list-skip))))
        ((get)      (window-get w 'window-list-skip)))))

  (define-wm-spec-window-state '_NET_WM_STATE_SKIP_TASKBAR
    (lambda (w mode)
      (case mode
        ((init add) (window-put w 'task-list-skip t))
        ((remove)   (window-put w 'task-list-skip nil))
        ((toggle)   (window-put w 'task-list-skip
                                (not (window-get w 'task-list-skip))))
        ((get)      (window-get w 'task-list-skip)))))

  (define-wm-spec-window-state '_NET_WM_STATE_FULLSCREEN
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
        ((init) (window-put w 'queued-fullscreen-maximize t))
        ((add remove) (maximize-window-fullscreen w (eq mode 'add)))
        ((toggle) (maximize-window-fullscreen-toggle w))
        ((get) (window-maximized-fullscreen-p w)))))

  (define (above-below-handler depth w mode)
    (require 'sawfish.wm.stacking)
    (case mode
      ((init)
       (window-put w 'depth depth))
      ((add remove)
       (set-window-depth w (if (eq mode 'add) depth 0)))
      ((toggle)
       (set-window-depth w (if (= (window-depth w) depth) 0 depth)))
      ((get)
       (= (window-depth w) depth))))

  (define-wm-spec-window-state '_NET_WM_STATE_BELOW
    (lambda (w mode)
      (above-below-handler wm-spec-below-depth w mode)))

  (define-wm-spec-window-state '_NET_WM_STATE_ABOVE
    (lambda (w mode)
      (above-below-handler wm-spec-above-depth w mode)))

;;; client messages

  (define (client-message-handler w type data)
    (let ((handled t))
      (case type
	((_NET_CLOSE_WINDOW)
	 (when (windowp w)
	   (delete-window w)))

	((_NET_SHOWING_DESKTOP)
	 (if (= (aref data 0) 1)
	     (show-desktop)
	   (hide-desktop)))

	((_NET_WM_MOVERESIZE)
	 (when (and (windowp w) (window-mapped-p w))
	   (require 'sawfish.wm.commands.move-resize)
	   (let ((mode (aref data 2)))
	     ;; don't want grabs failing, sigh
	     (x-server-timestamp t t)
	     (if (or (eq mode _NET_WM_MOVERESIZE_MOVE)
		     (eq mode _NET_WM_MOVERESIZE_MOVE_KEYBOARD))
		 (move-window-interactively w)
	       (let ((move-resize-moving-edges
		      (cond ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPLEFT)
			     '(top left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOP)
			     '(top))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPRIGHT)
			     '(top right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT)
			     '(bottom left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOM)
			     '(bottom))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT)
			     '(bottom right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_LEFT)
			     '(left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_RIGHT)
			     '(right)))))
		 (resize-window-interactively w))))))

	((_NET_NUMBER_OF_DESKTOPS)
	 (set-number-of-workspaces (aref data 0)))

	((_NET_DESKTOP_GEOMETRY)
	 (set-number-of-viewports (aref data 0) (aref data 1)))

	((_NET_DESKTOP_VIEWPORT)
	 (set-viewport (aref data 0) (aref data 1)))

	((_NET_CURRENT_DESKTOP)
         ;; KDE spews _NET_CURRENT_DESKTOP( -1) messages so often that it
         ;; is best to just ignore out of bounds errors silently.
         (let ((ws (workspace-id-from-logical (aref data 0)))
               (limits (workspace-limits)))
           (if (<= (car limits) ws (cdr limits))
               (select-workspace ws))))

	((_NET_DESKTOP_NAMES)
	 ;; XXX this is kind of broken now we use workspace-names to
	 ;; XXX define the minimum number of workspaces to display?
	 (setq data (aref data 0))
	 (let loop ((i 0)
		    (out '()))
	   (if (= i (length data))
	       (setq workspace-names (nreverse out))
	     (loop (1+ i) (cons (aref data i) out)))))

	((_NET_ACTIVE_WINDOW)
	 (require 'sawfish.wm.util.display-window)
	 (when (and (windowp w) (window-mapped-p w))
	   (display-window w)))

	((_NET_WM_STATE)
	 (when (windowp w)
	   (let ((mode (cond ((eql (aref data 0) _NET_WM_STATE_REMOVE)
                              'remove)
			     ((eql (aref data 0) _NET_WM_STATE_ADD)
                              'add)
			     ((eql (aref data 0) _NET_WM_STATE_TOGGLE)
                              'toggle)))
		 (atom1 (x-atom-name (aref data 1)))
		 (atom2 (x-atom-name (aref data 2))))
	     (when (or (and (eq atom1 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom2 '_NET_WM_STATE_MAXIMIZED_HORZ))
		       (and (eq atom2 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom1 '_NET_WM_STATE_MAXIMIZED_HORZ)))
	       (setq atom1 '_NET_WM_STATE_MAXIMIZED)
	       (setq atom2 nil))
	     (when atom1
	       (call-state-fun w atom1 mode))
	     (when atom2
	       (call-state-fun w atom2 mode)))))

	((_NET_WM_DESKTOP)
	 (when (windowp w)
	   (let ((desktop (aref data 0)))
	     (if (eql desktop #xffffffff)
		 ;; making window sticky
		 (make-window-sticky/workspace w)
	       ;; changing the desktop
	       (make-window-unsticky/workspace w)
	       (send-window-to-workspace-from-first w desktop nil)))))

	(t (setq handled nil)))
      handled))

;;; property changes

  (define (property-change-handler w prop kind)
    (declare (unused kind))
    (case prop
      ((_NET_WM_ICON_GEOMETRY)
       (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
	 (when geom
	   (update-icon-geometry w (nth 2 geom)))))
      ((_NET_WM_STRUT)
       (update-strut w))))

;;; utilities

  (define (vector->list vec)
    (do ((i 0 (1+ i))
	 (out '() (cons (aref vec i) out)))
	((= i (length vec)) (nreverse out))))

  (define (update-on-configure-notify w)
    (when (eq w 'root)
      (update-workspace-hints)))

;;; initialisation

  (define (init)
    (setq wm-spec-window-id (create-window 'root -200 -200 5 5))

    (set-x-property 'root '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_WM_NAME "Sawfish" 'UTF8_STRING 8)

    (set-x-property 'root '_NET_SUPPORTED supported-atoms 'ATOM 32)

    (let ((current-desktop (get-x-property 'root '_NET_CURRENT_DESKTOP)))
      (when (and current-desktop
		 (eq (car current-desktop) 'CARDINAL)
		 (>= (length (caddr current-desktop)) 1))
	(add-hook 'after-initialization-hook
		  ;; Don't do this yet, it can screw things up
		  (lambda ()
		    (select-workspace-from-first
		     (aref (caddr current-desktop) 0))))))

    (update-client-list-hints)
    (update-workspace-hints)

    (add-hook 'workspace-state-change-hook update-workspace-hints)
    (add-hook 'viewport-resized-hook update-workspace-hints)
    (add-hook 'viewport-moved-hook update-workspace-hints)
    (add-hook 'workarea-changed-hook update-workspace-hints)
    (add-hook 'configure-notify-hook update-on-configure-notify)

    ;; Better not expose work in progress.  map-notify-hook gets
    ;; called after this anyway.
    ;;(add-hook 'add-window-hook update-client-list-hints)
    (add-hook 'destroy-notify-hook update-client-list-hints)
    (add-hook 'map-notify-hook update-client-list-hints)
    (add-hook 'unmap-notify-hook update-client-list-hints)
    (add-hook 'after-restacking-hook update-client-list-hints)

    (add-hook 'before-add-window-hook honour-client-state)
    (add-hook 'add-window-hook update-client-state)
    (call-after-state-changed '(sticky shaded maximized stacking
                                       window-list-skip task-list-skip)
			      update-client-state)
    (call-after-state-changed 'sticky update-window-workspace-hints)

    (add-hook 'focus-in-hook update-focus-state)
    (add-hook 'focus-out-hook update-focus-state)

    (add-hook 'client-message-hook client-message-handler)
    (add-hook 'property-notify-hook property-change-handler)

    (add-hook 'before-exit-hook exit)

    (map-windows update-client-state))

  (define (exit)
    (destroy-window wm-spec-window-id)
    (delete-x-property 'root '_NET_SUPPORTING_WM_CHECK)
    (delete-x-property 'root '_NET_PROTOCOLS)
    (delete-x-property 'root '_NET_DESKTOP_GEOMETRY)
    (delete-x-property 'root '_NET_DESKTOP_VIEWPORT))

  (unless (or wm-spec-window-id batch-mode)
    (init)))

;; nokogiri-i18n -- support for internationalization
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.i18n

    (export i18n-lang
	    i18n-filename
	    i18n-init)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.i18n.gettext
	  sawfish.cfg.wm)

  (define i18n-lang (or (getenv "LC_ALL")
			(getenv "LC_MESSAGES")
			(getenv "LANG")))

  (define i18n-lang-base (and i18n-lang
			      (if (string-match "^([^_.]+)_.*" i18n-lang)
				  (expand-last-match "\\1")
				i18n-lang)))

  ;; for a file called FILE, look for one with a .LC extension LC is
  ;; the language code for the current language
  (define (i18n-filename file)
    (cond ((and i18n-lang
		(file-exists-p (concat file #\. i18n-lang)))
	   (concat file #\. i18n-lang))
	  ((and i18n-lang-base
		(file-exists-p (concat file #\. i18n-lang-base)))
	   (concat file #\. i18n-lang-base))
	  (t file)))

  (define (i18n-init)
    (unless (get-command-line-option "--disable-nls")
      (let ((locale-dir (wm-locale-dir)))
	(when locale-dir
	  (bindtextdomain "sawfish" locale-dir)
	  (when (boundp 'bindtextdomaincodeset)
	    (bindtextdomaincodeset "sawfish" "UTF-8"))
	  (textdomain "sawfish"))))))

;; edge/misc.jl -- misc actions for EdgeActions

;; Copyright (C) 2011 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.edge.misc

    (export maximize-action
   	    expose-windows-action)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.events
	  sawfish.wm.state.maximize
	  sawfish.wm.ext.expose)

  (define-structure-alias edge-misc sawfish.wm.edge.misc)

  (define (maximize-action)
    (let ((w (input-focus)))
      (allow-events 'async-both)
      (fake-release-window)
      (maximize-window w)))

  (define (expose-windows-action edge while-moving)
    (call-hook 'before-edge-action-hook (list 'expose-windows edge while-moving))
    (when while-moving
        (fake-release-window))
      (expose-windows-horizontally)
      (call-hook 'after-edge-action-hook (list 'expose-windows edge while-moving))))

;; font.jl -- some font-related functions
;;
;; Author: John Harper <jsh@unfactored.org>
;;
;; Copyright (C) 2002 John Harper
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.font

    (export make-face
	    face?
	    face-families
	    face-size
	    face-styles
	    xft-description->face
	    face->xft-description
	    pango-description->face
	    face->pango-description
	    xlfd-description->face
	    face->xlfd-description)

    (open rep
	  rep.system
	  rep.regexp
	  rep.data.records)

  ;; Xft font descriptions are <family-list>-<size>:<name>=<value>...

  ;; Pango font descriptions are [family-list] [style-options] [size]

  ;; XLFD font descriptions are -<foundry>-<family>-<weight>-<slant>-
  ;; <setwidth>-<add-style>-<pixel-size>-<point-size>-<res-x>-<res-y>-
  ;; <spacing>-<avg-width>-<charset-registry>-<charset-encoding>

  ;; We'll use a neutral "face" structure to describe fonts in a
  ;; general way. (it actually uses the Xft style names, but whatever)

  (define-record-type :face
    (make-face families size styles)
    face?
    (families face-families)
    (size face-size)
    (styles face-styles))

  (define-record-discloser :face
    (lambda (x)
      `(face ,(face-families x) ,(face-size x) ,(face-styles x))))

  (define (assoc-case x map)
    (let loop ((rest map))
      (cond ((null rest) nil)
	    ((string-equal x (caar rest)) (car rest))
	    (t (loop (cdr rest))))))

  (define (face-style face style)
    (cdr (assoc-case style (face-styles face))))

  ;; Xft naming scheme

  (define xft-abbrev-map
    '(("light" "weight" . "light")
      ("medium" "weight" . "medium")
      ("demibold" "weight" . "demibold")
      ("bold" "weight" . "bold")
      ("black" "weight" . "black")
      ("roman" "slant" . "roman")
      ("italic" "slant" . "italic")
      ("proportional" "spacing" . "proportional")
      ("mono" "spacing" . "mono")
      ("charcell" "spacing" . "charcell")
      ("rgb" "rgba" . "rgb")
      ("bgr" "rgba" . "bgr")
      ("vrgb" "rgba" . "vrgb")
      ("vbgr" "rgba" . "vbgr")))

  (define (xft-description->face name)
    (let* ((fields (string-split "\\s*:\\s*" name))
	   (fam-siz (car fields))
	   (family "Sans")
	   (size nil))

      ;; extract family and size
      (when fam-siz
	(cond ((string-match "[^\\](\\s*-\\s*)" fam-siz)
	       (setq family (substring fam-siz 0 (match-start 1)))
	       (setq size (string->number (substring fam-siz (match-end 1)))))
	      ((string-looking-at "\\d+" fam-siz)
	       (setq size (string->number fam-siz)))
	      (t (setq family fam-siz)))
	(setq family (string-replace "\\\\-" "-" family)))

      ;; extract styles
      (let loop ((rest (cdr fields))
		 (styles '()))
	(if (null rest)
	    (make-face family size (nreverse styles))
	  (cond ((string-match "\\s*=\\s*" (car rest))
		 (loop (cdr rest)
		       (cons (cons (substring (car rest) 0 (match-start))
				   (substring (car rest) (match-end)))
			     styles)))
		((assoc-case (car rest) xft-abbrev-map)
		 (loop (cdr rest)
		       (cons (cdr (assoc-case (car rest)
					      xft-abbrev-map)) styles)))
		;; drop unknown single words..
		(t (loop (cdr rest) styles)))))))

  (define (face->xft-description face)
    (let ((families (string-replace "-" "\\-" (face-families face)))
	  (size (face-size face))
	  (styles (face-styles face)))
      (mapconcat identity
		 (cons (if size
			   (format nil "%s-%s" families size)
			 families)
		       (mapcar (lambda (x)
				 (cond ((rassoc x xft-abbrev-map)
					(car (rassoc x xft-abbrev-map)))
				       ((cdr x)
					(format nil "%s=%s" (car x) (cdr x)))
				       (t (car x)))) styles)) #\:)))

  ;; Pango naming scheme

  (define pango-style-map
    '(("Oblique" "slant" . "oblique")
      ("Italic" "slant" . "italic")
      ("Small-Caps" "style" . "smallcaps")	;FIXME?
      #|
      ("Ultra-Condensed" . ?)			;FIXME
      ("Extra-Condensed" . ?)
      ("Condensed" . ?)
      ("Semi-Condensed" . ?)
      ("Semi-Expanded" . ?)
      ("Expanded" . ?)
      ("Extra-Expanded" . ?)
      ("Ultra-Expanded" . ?)
      |#
      ("Ultra-Light" "weight" . "ultralight")	;FIXME?
      ("Light" "weight" . "light")
      ("Medium" "weight" . "medium")
      ("Semi-Bold" "weight" . "demibold")
      ("Bold" "weight" . "bold")
      ("Ultra-Bold" "weight" . "ultrabold")	;FIXME?
      ("Heavy" "weight" . "black")))		;FIXME?

  (define (pango-description->face name)
    (let ((fields (string-split "\\s*,\\s*" name))
	  (family "Sans")
	  (force-family nil)
	  (size nil)
	  (styles '()))

      ;; if comma found in name, it separates family name and styles
      (when (> (length fields) 1)
	(setq force-family (car fields))
	(setq fields (list (mapconcat identity fields #\space))))

      ;; have to parse backwards, since family names may contain spaces..
      (setq fields (nreverse (string-split "\\s+" (car fields))))

      ;; look for a size at the end of the string
      (when (string-match "\\s*(\\d+)\\s*$" (car fields))
	(setq size (string->number (expand-last-match "\\1")))
	(setq fields (cdr fields)))

      ;; pop off style keywords
      (while (and fields (assoc-case (car fields) pango-style-map))
	(setq styles (cons (cdr (assoc-case
				 (car fields) pango-style-map)) styles))
	(setq fields (cdr fields)))

      ;; whatever's left is the family name, except of that comma
      ;; found in name
      (if force-family
	  (setq family force-family)
	(setq family (mapconcat identity (nreverse fields) #\space)))

      (make-face family size styles)))

  (define (assoc-grep regexp alist #!optional case-fold)
    (catch 'found
      (mapc (lambda (x) (if (string-match regexp (car x) 0 case-fold)
			    (throw 'found x)))
            alist)))

  (define (face->pango-description face)
    (let loop ((rest (face-styles face))
	       (out '()))
      (if (null rest)
	  (let* ((family (face-families face))
		 (regexp (concat "^" (last (string-split "\\s+" family)))))
	    (when (and (not (string-equal family ""))
		       (assoc-grep regexp pango-style-map t))
	      (setq family (concat family ",")))
	    (mapconcat identity
		       (nconc (list family)
			      (nreverse out)
			      (and (face-size face)
				   (list
				    (format nil "%d" (face-size face)))))
		       #\space))
	(let ((tem (rassoc (car rest) pango-style-map)))
	  (if tem
	      (loop (cdr rest) (cons (car tem) out))
	    (loop (cdr rest) out))))))

  ;; XLFD naming scheme

  (define xlfd-style-names
    '((5 . "width")
      (6 . "add-style")
      (8 . "point-size")
      (9 . "resolution-x")
      (10 . "resolution-y")
      (12 . "average-width")
      (13 . "charset-registry")
      (14 . "charset-encoding")))

  (define xlfd-slant-map
    '(("i" . "italic")
      ("o" . "oblique")
      ("r" . "roman")))

  (define xlfd-spacing-map
    '(("c" . "charcell")
      ("p" . "proportional")
      ("m" . "mono")))

  (define (xlfd-description->face name)
    (let* ((fields (string-split "-" name))
	   (nfields (length fields))
	   (family "Sans")
	   (size nil)
	   (styles '()))

      (if (= nfields 1)

	  ;; font alias, e.g. "fixed", kludge this
	  (make-face name nil nil)

	;; normal XLFD string

	(unless (or (<= nfields 2) (string= (nth 2 fields) "*"))
	  (setq family (nth 2 fields)))

	(unless (or (<= nfields 7) (string= (nth 7 fields) "*"))
	  (setq size (string->number (nth 7 fields))))

	(when (> nfields 3)
	  (let ((weight (nth 3 fields)))
	    (when (not (string= weight "medium"))
	      (setq styles (cons (cons "weight" weight) styles)))))

	(when (> nfields 4)
	  (let ((slant (nth 4 fields)))
	    (when (and (not (string= slant "r")) (assoc slant xlfd-slant-map))
	      (setq styles (cons (cons "slant"
				       (cdr (assoc slant xlfd-slant-map)))
				 styles)))))

	(when (> nfields 11)
	  (let ((spacing (nth 11 fields)))
	    (when (assoc spacing xlfd-spacing-map)
	      (setq styles (cons (cons "spacing"
				       (cdr (assoc spacing xlfd-spacing-map)))
				 styles)))))

	(do ((i 1 (1+ i)))
	    ((>= i (min 14 nfields)))
	  (let ((field (nth i fields))
		(name (assq i xlfd-style-names)))
	    (when (and name field (not (string= field "*")))
	      (setq styles (cons (cons (cdr (assq i xlfd-style-names))
				       (nth i fields)) styles)))))

	(make-face family size styles))))

  (define (face->xlfd-description face)
    (let ((out '()))

      (do ((i 14 (1- i)))
	  ((= i 0))

	(cond ((= i 2)
	       (setq out (cons (face-families face) out)))

	      ((= i 3)
	       (setq out (cons (or (face-style face "weight") "medium") out)))

	      ((= i 4)
	       (let ((slant (car (rassoc (face-style face "slant")
					 xlfd-slant-map))))
		 (setq out (cons (or slant "r") out))))

	      ((= i 7)
	       (setq out (cons (if (face-size face)
				   (number->string (face-size face))
				 "*") out)))

	      ((= i 11)
	       (let ((spacing (car (rassoc (face-style face "spacing")
					   xlfd-spacing-map))))
		 (setq out (cons (or spacing "*") out))))

	      (t (let ((style (assq i xlfd-style-names))
		       (name (cdr (assq i xlfd-style-names))))
		   (if (or (not style) (not name))
		       (setq out (cons "*" out))
		     (setq out (cons (or (face-style face name) "*") out)))))))

      (mapconcat identity (cons "" out) "-"))))

;; beos-window-menu.jl -- hack to change window-menu to approximate BeOS

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.beos-window-menu

    (export beos-window-menu)

    (open rep
	  rep.util.utf8
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.util.groups
	  sawfish.wm.util.display-window
	  sawfish.wm.menus)

  (define-structure-alias beos-window-menu sawfish.wm.ext.beos-window-menu)

  (define (abbreviate name #!optional len)
    (unless len (setq len 20))
    (if (> (utf8-string-length name) len)
	(concat (utf8-substring name 0 len) "...")
      name))

  (define (make-label w)
    (let ((name (window-name w))
	  (would-switch (or (not (window-appears-in-workspace-p
				  w current-workspace))
			    (window-outside-viewport-p w))))
      (quote-menu-item (concat (cond ((window-get w 'iconified) ?\[)
				     (would-switch ?\())
			       (abbreviate name)
			       (cond ((window-get w 'iconified)  ?\])
				     (would-switch ?\)))))))

  (define windows-left (make-fluid))

  (define (make-item w)
    (fluid-set windows-left (delq w (fluid windows-left)))
    (list (make-label w)
	  (lambda ()
	    (when (windowp w)
	      (display-window w)))
	  (cons 'check (and (eq (input-focus) w)))
	  '(group . beos-window-menu)))

  (define (group-name id)
    (cond ((symbolp id) (symbol-name id))
	  ((integerp id)
	   (let ((name (or (and (> id 0) (window-class id))
			   (and (> id 0) (nth 2 (get-x-property id 'WM_NAME)))
			   (window-class (car (windows-by-group id)))
			   "Unnamed")))
	     (abbreviate name)))))

  (define (window-suitable-p w)
    (and (memq w (fluid windows-left))
	 (window-mapped-p w)
	 (or (window-get w 'iconified)
	     (and (not (window-get w 'window-list-skip))
		  (not (window-get w 'ignored))
		  (not (desktop-window-p w))))))

  (define (make-group-item id)
    (let loop ((menu '())
	       (windows (windows-by-group id)))
         (if (null windows)
             (cons (group-name id) (nreverse menu))
           (if (window-suitable-p (car windows))
               (loop (cons (make-item (car windows)) menu) (cdr windows))
             (loop menu (cdr windows))))))

  (define (cleanup-menu menu)
    ;; sort the group names..
    (setq menu (sort menu (lambda (x y)
			    (not (string-lessp (car x) (car y))))))
    ;; ..then merge any identically named sub-menus
    (let loop ((rest menu))
         (when (cdr rest)
           (if (string= (caar rest) (caadr rest))
               (progn
                 (rplacd (car rest) (nconc (cdar rest) (cdadr rest)))
                 (rplacd rest (cddr rest))
                 (loop rest))
             (loop (cdr rest)))))
    menu)

  (define (make-menu)
    (let-fluids ((windows-left (managed-windows)))
                (let loop-1 ((menu '())
                             (groups (window-group-ids)))
                     (if (null groups)
                         (progn
                           (setq menu (cleanup-menu menu))
                           (let ((left (delete-if-not window-suitable-p
                                                      (fluid windows-left))))
                             (if left
                                 (let loop-2 ((menu (cons '() menu))
                                              (rest left))
                                      (if (null rest)
                                          menu
                                        (loop-2 (cons (make-item (car rest))
                                                      menu)
                                                (cdr rest))))
                               menu)))
                       (loop-1 (let ((item (make-group-item (car groups))))
                                 (if (cdr item)
                                     (cons item menu)
                                   menu))
                               (cdr groups))))))

  (define (simplify menu)
    (let loop ((rest menu)
	       (out '()))
         (if (null rest)
             out
           (let ((next (cdr rest)))
             ;; reverse the pointers
             (rplacd rest out)
             (when (= (length (cdar rest)) 1)
               (rplaca rest (cadar rest)))
             (loop next rest)))))

  (define (beos-window-menu) (simplify (make-menu)))

  (setq window-menu beos-window-menu))

;; fehlstart.jl -- fehlstart integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@tuxfamily.org>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.fehlstart

  (export start-fehlstart
          stop-fehlstart)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
	rep.io.files
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias fehlstart sawfish.wm.prg.fehlstart)

  (define %fehlstart-proc nil)

  (defcustom init-fehlstart nil
    "Whether to start fehlstart with Sawfish."
    :type boolean
    :group (misc apps))

  (define (start-fehlstart )
    "Start fehlstart. If a fehlstart process already exists, it's beeing killed."
    (if (program-exists-p "fehlstart")
        (progn
	  (when %fehlstart-proc (kill-process %fehlstart-proc))
          (setq %fehlstart-proc (make-process))
          (start-process %fehlstart-proc "fehlstart"))
      (display-message (format nil "fehlstart executable not found in PATH."))))

  (define (stop-fehlstart)
    "Stop fehlstart, if running."
    (when %fehlstart-proc (kill-process %fehlstart-proc))))

;; xgamma.jl -- xgamma integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.xgamma

  (export xgamma-set
	  ;; for user.jl/sawfish-config
	  xgamma-set-from-cfg
          xgamma-get)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias xgamma sawfish.wm.prg.xgamma)

  (defcustom init-xgamma nil
    "Set gamma values when Sawfish starts."
    :type boolean
    :group (misc apps))

  (defcustom xgamma-red 100
    "Gamma value for red channel in per cent."
    :type (range (0 . 200))
    :depends init-xgamma
    :group (misc apps)
    :after-set (lambda () (xgamma-set-from-cfg t nil nil)))

  (defcustom xgamma-green 100
    "Gamma value for green channel in per cent."
    :type (range (0 . 200))
    :depends init-xgamma
    :group (misc apps)
    :after-set (lambda () (xgamma-set-from-cfg nil t nil)))

  (defcustom xgamma-blue 100
    "Gamma value for blue channel in per cent."
    :type (range (0 . 200))
    :depends init-xgamma
    :group (misc apps)
    :after-set (lambda () (xgamma-set-from-cfg nil nil t)))

  (define (xgamma-get)
    (if (program-exists-p "xgamma")
        (system "xgamma &")
      (message (format nil "xgamma executable not found in PATH."))))

  (define (xgamma-set all #!key
                          (gamma 1.0)
                          (red 1.0)
                          (green 1.0)
                          (blue 1.0))
    (if (program-exists-p "xgamma")
        (if all
	    (system (format nil "xgamma -gamma %s &" gamma))
          (system (format nil "xgamma -rgamma %s -ggamma %s -bgamma %s &" red green blue)))
      (display-message (format nil "xgamma executable not found in PATH."))))

  (define (xgamma-set-from-cfg red green blue)
    (if (program-exists-p "xgamma")
        (progn
          (when red
            (system (format nil "xgamma -rgamma %s &" (/ xgamma-red 100.))))
          (when green
            (system (format nil "xgamma -ggamma %s &" (/ xgamma-green 100.))))
          (when blue
            (system (format nil "xgamma -bgamma %s &" (/ xgamma-blue 100.)))))
      (display-message (format nil "xgamma executable not found in PATH.")))))

;; focus.jl -- implement standard focus behaviour

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.focus

    (export define-focus-mode
	    autoload-focus-mode
	    focus-mode
	    set-focus-mode
	    focus-push-map
	    focus-pop-map
	    warp-pointer-if-necessary
	    focus-revert
	    focus-within-click-event)

    (open rep
	  rep.system
	  rep.util.autoloader
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.util.window-order
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.session.init)

  (defvar focus-modes nil
    "List containing all symbols naming focus modes.")

  (defcustom focus-mode 'click
    "When does the mouse pointer affect the input focus."
    :type symbol
    :group focus
    :before-set (lambda () (focus-mode-changed 'before))
    :after-set (lambda () (focus-mode-changed 'after)))

  (defcustom focus-click-through t
    "Click-to-focus mode passes the click through to the application."
    :type boolean
    :group focus)

  (defcustom focus-dont-push nil
    "Whether focusing a window doesn't change it's position in the stack."
    :type boolean
    :group focus)


  ;; Only used by x-cycle.jl
  (defvar focus-ignore-pointer-events nil
    "When true, pointer in/out events don't cause focus changes.")

  (define focus-within-click-event (make-fluid nil)
          "When true, the current command is being called from within
a click-to-focus button press event.")

;;; general utilities

  (define (define-focus-mode name fun)
    "Define a new focus mode called NAME (a symbol). The function FUN will be
used to implement this focus mode, it will be called with arguments `(WINDOW
EVENT-NAME)', where EVENT-NAME may be one of the following symbols:
`pointer-in', `pointer-out', `focus-in', `focus-out', `add-window'
`before-mode-change', `after-mode-change', `warp-if-necessary' and
`focus-revert'."

    (unless (memq name focus-modes)
      (setq focus-modes (nconc focus-modes (list name))))
    (custom-set-property 'focus-mode ':options focus-modes)
    (put name 'focus-mode fun))

  ;; autoload handling
  (define (getter name) (get name 'focus-mode))
  (define autoload-focus-mode (make-autoloader getter define-focus-mode))
  (define focus-mode-ref (autoloader-ref getter))

  (define (window-focus-mode w)
    (or (and w (windowp w) (window-get w 'focus-mode)) focus-mode))

  (define (focus-invoke-mode w . args)
    (let* ((mode (window-focus-mode w))
	   (fun (focus-mode-ref mode)))
      (when fun
	(apply fun w args))))

  (define (set-focus-mode w mode)
    "Set the focus mode of window W to the mode named by symbol MODE."
    (unless (eq (window-get w 'focus-mode) mode)
      (focus-invoke-mode w 'before-mode-change)
      (window-put w 'focus-mode mode)
      (focus-invoke-mode w 'after-mode-change)))

  (define (focus-mode-changed time)
    (let ((arg (if (eq time 'before)
		   'before-mode-change
		 'after-mode-change)))
      (map-windows
       (lambda (w)
	 (unless (window-get w 'focus-mode)
	   (focus-invoke-mode w arg))))))

  (define (focus-push-map w map)
    (let ((current (window-get w 'keymap))
	  (saved (window-get w 'focus-saved-keymap)))
      (unless (or (eq current map) (null current))
	(unless saved
	  (window-put w 'focus-saved-keymap current))
	(window-put w 'keymap map))))

  (define (focus-pop-map w)
    (let ((saved (window-get w 'focus-saved-keymap)))
      (when saved
	(window-put w 'keymap saved)
	(window-put w 'focus-saved-keymap nil))))

  ;; W is the focused window. Warp to it if it conforms to
  ;; the focus mode.
  (define (warp-pointer-if-necessary #!optional (w (input-focus)))
    (focus-invoke-mode w 'warp-if-necessary))

  ;; Put focus in some window that hopefully feels natural.  This is
  ;; typically used when the window in focus has disappeared.  Thus
  ;; there is no reference window.
  (define (focus-revert)
    (let ((fun (focus-mode-ref focus-mode)))
      (when fun (fun nil 'focus-revert))))

;;; modes

  #|
  From sawfish-1.5.0, enter-notify events invoked by grab are
  ignored in enter-exit and enter-only. This has a down side, too,
  but first let us see what's the intention.

  The problem that this solves is when you press Alt F2 in KDE, the
  Run Command popup appears and gets focused (if focus-when-mapped is
  non-nil), you start typing, the completion list pops up and takes
  focus, then you type a bit further and the completion list
  disappears.  Focus used to revert to the window the pointer was in,
  which usually was not the Run Command popup.  transient-unmap-window
  tries hard to get it right, then the grab-induced enter-notify
  brought focus to the wrong window anyway.

  The problem that this causes is when you open the KDE main menu by
  clicking the K icon in the panel, move the mouse into some
  application window and click to dismiss the open menu, focus reverts
  to the panel. You have to move the pointer out of the application
  window and back in to get it focused.
  |#
  (define-focus-mode 'enter-exit
    (lambda (w action . args)
      (case action
	((pointer-in)
	 (when (and (window-really-wants-input-p w)
		    ;; ignore grab/ungrab enter events
		    ;; See the above long comment
		    (eq (car args) 'normal))
	   (set-input-focus w)))
	((pointer-out)
	 ;; ignore grab/ungrab leave events
	 (when (eq (car args) 'normal)
	   (set-input-focus nil)))
	((enter-root)
	 ;; ensure that any desktop window gets focused
	 (set-input-focus w))
	((warp-if-necessary)
	 (unless (eq (query-pointer-window) w)
	   (warp-cursor-to-window w)))
        ((focus-revert)
         (setq w (query-pointer-window))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define-focus-mode 'enter-only
    (lambda (w action . args)
      (case action
	((pointer-in)
	 (when (and (window-really-wants-input-p w)
		    ;; ignore grab/ungrab enter events
		    ;; See the comment above enter-exit
		    (eq (car args) 'normal))
	   (set-input-focus w)))
	((warp-if-necessary)
	 (let ((current (query-pointer-window)))
	   (unless (or (eq current w) (desktop-window-p current))
	     (warp-cursor-to-window w))))
        ((focus-revert)
         (setq w (query-pointer-window))
         (when (or (null w)
                   (desktop-window-p w))
           (setq w (window-order-most-recent)))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define (focus-click)
    (let ((w (current-event-window))
	  (event (current-event)))
      (when (window-really-wants-input-p w)
	(set-input-focus w))
      (focus-pop-map w)
      ;; do we need to do anything with the event?
      (when event
	;; allow-events called with replay-pointer ignores any passive
	;; grabs on the window, thus if the wm has a binding in the
	;; window's keymap, it would be ignored. So search manually..
	(let ((command (lookup-event-binding event)))
	  (if command
	      (let-fluids ((focus-within-click-event t))
		(call-command command))
	    (require 'sawfish.wm.util.decode-events)
	    (when (and (or focus-click-through
			   (window-get w 'focus-click-through)
			   (not (window-really-wants-input-p w)))
		       (not (should-grab-button-event-p
			     event (window-get w 'keymap))))
	      ;; pass the event through to the client window unless we
	      ;; need to keep the grab for the events that would follow
	      (allow-events 'replay-pointer)
	      (forget-button-press)))))
      (unless (eq (input-focus) w)
        (focus-push-map w click-to-focus-map))))

  (defvar click-to-focus-map
    (bind-keys (make-keymap)
               ;; apparently buttons 4 & 5 are usually bound to the
               ;; wheel on some mice
               "Any-Button1-Click1" focus-click
               "Any-Button2-Click1" focus-click
               "Any-Button3-Click1" focus-click))

  (define-focus-mode 'click
    (lambda (w action)
      (case action
	((focus-in)
	 (focus-pop-map w))
	((focus-out add-window)
	 (unless (or (not (window-really-wants-input-p w))
		     (eq w (input-focus)))
	   (focus-push-map w click-to-focus-map)))
	((before-mode-change)
	 (focus-pop-map w))
	((after-mode-change)
	 (unless (or (not (window-really-wants-input-p w))
		     (eq w (input-focus)))
	   (focus-push-map w click-to-focus-map)))
        ((focus-revert)
         (setq w (window-order-most-recent))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define-focus-mode 'enter-click
    (lambda (w action . args)
      (case action
        ((pointer-in warp-if-necessary focus-revert)
         (apply (focus-mode-ref 'enter-only) w action args))
        ((focus-in focus-out add-window before-mode-change after-mode-change)
         (apply (focus-mode-ref 'click) w action args)))))

;;; hooks

  (define (focus-enter-fun w mode)
    (unless focus-ignore-pointer-events
      (cond ((desktop-window-p w)
	     (focus-invoke-mode w 'enter-root mode))
	    ((windowp w)
	     (focus-invoke-mode w 'pointer-in mode)))))

  (define (focus-leave-fun w mode)
    (unless focus-ignore-pointer-events
      (cond ((desktop-window-p w)
	     (focus-invoke-mode w 'leave-root mode))
	    ((windowp w)
	     (focus-invoke-mode w 'pointer-out mode)))))

  (define (focus-in-fun w)
    (focus-invoke-mode w 'focus-in)
    (unless focus-dont-push
      (window-order-push w)))

  (define (focus-out-fun w) (focus-invoke-mode w 'focus-out))
  (define (focus-add-window w) (focus-invoke-mode w 'add-window))

  (add-hook 'enter-notify-hook focus-enter-fun t)
  (add-hook 'leave-notify-hook focus-leave-fun t)
  (add-hook 'focus-in-hook focus-in-fun t)
  (add-hook 'focus-out-hook focus-out-fun t)
  (add-hook 'map-notify-hook focus-add-window)

  (call-after-state-changed
   '(never-focus)
   (lambda (w)
     (if (window-get w 'never-focus)
	 (focus-pop-map w)
       (focus-add-window w))))

  (add-hook 'after-initialization-hook
	    (lambda () (map-windows focus-add-window)))

  (sm-add-saved-properties 'never-focus 'focus-mode)

;;; bug prevention

  ;; XXX Pavel reported this bug (windows becoming unfocusable in
  ;; XXX click-to-focus mode). I can't see why it happens, hence this
  ;; XXX kludge for now..

  (define (scan-windows-for-bugs)
    (map-windows (lambda (w)
		   (when (eq (window-focus-mode w) 'click)
		     ;; check that the correct keymaps are in place
		     (unless (or (eq (input-focus) w)
				 (not (window-mapped-p w))
				 (not (window-really-wants-input-p w))
				 (eq (window-get w 'keymap)
				     click-to-focus-map))
		       ;;(format standard-error
                       ;;        "Window lost focus keymap: %s, %s\n"
                       ;;        (window-name w) (window-get w 'keymap))
                       ;;(beep) (beep)
		       (focus-push-map w click-to-focus-map))))))

  (add-hook 'idle-hook scan-windows-for-bugs))

;; edge/misc.jl -- misc actions for EdgeActions

;; Copyright (C) 2011 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.misc

    (export maximize-action
   	    expose-windows-action)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.events
	  sawfish.wm.state.maximize
	  sawfish.wm.ext.expose)

  (define-structure-alias edge-misc sawfish.wm.edge.misc)

  (define (maximize-action)
    (let ((w (input-focus)))
      (allow-events 'async-both)
      (fake-release-window)
      (maximize-window w)))

  (define (expose-windows-action edge while-moving)
    (call-hook 'before-edge-action-hook (list 'expose-windows edge while-moving))
    (when while-moving
        (fake-release-window))
      (expose-windows-horizontally)
      (call-hook 'after-edge-action-hook (list 'expose-windows edge while-moving))))

;; with-output.jl -- call a command/function redirecting stdout

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.with-output

    (export call-with-output-to-screen
	    with-output-to-screen)

    (open rep
	  rep.regexp
	  #|
	    Don't add more sawfish.wm.* here unless you know what
	    you're doing. Instead, embed 'require' in definition. It's
	    because this file is read from windows.jl -> custom.jl.
	    See windows.jl for more.
	  |#
	  sawfish.wm.misc)

  (define-structure-alias with-output sawfish.wm.util.with-output)

  (define (call-with-output-to-screen thunk)
    "Call the zero-parameter function THUNK with the `standard-output'
stream bound so that output is collected. After THUNK returns, the
emitted text will be display on the screen."

    (let ((standard-output (make-string-output-stream)))
      (unwind-protect
	  (thunk)
	(let ((out (get-output-stream-string standard-output)))
	  (unless (string= out "")
	    ;; display-message doesn't grok TAB characters,
	    ;; this is grossly inefficient; wtf..
	    (while (string-match "\t" out)
	      (setq out (concat (substring out 0 (match-start))
				#\space (substring out (match-end)))))
	    (display-message out))))))

  (defmacro with-output-to-screen (#!rest forms)
    "Evaluate FORMS. Any data they print to standard-output will be
displayed on the screen after they return."
    `(call-with-output-to-screen (lambda () ,@forms))))

;; ping.jl -- implement the _NET_WM_PING protocol
;;
;; Author: John Harper <jsh@eazel.com>
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.ping

    (export window-supports-ping-p
	    ping-window)

    (open rep
	  rep.io.timers
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows)

  (define make-ping-record cons)
  (define ping-callback car)
  (define ping-id cdr)

  ;; list of ping records sent but not completed
  (define pings-in-transit '())

  ;; The wm-spec talks about "timestamps", and how they can be used as
  ;; unique ids, but doesn't say whether they're X server timestamps.
  ;; Obviously, X server timestamps can't be used as unique ids, so we
  ;; just use sequence numbers..

  (define unique-id
    (let ((counter 0))
      (lambda ()
	(prog1
	    counter
	  (setq counter (1+ counter))))))

;;; public functions

  (define (window-supports-ping-p w)
    "Returns true if window W supports the _NET_WM_PING protocol."
    (window-supports-wm-protocol-p w '_NET_WM_PING))

  (define (ping-window w callback #!optional (timeout-msecs 1000))
    "Assuming that window W supports the _NET_WM_PING protocol (i.e. the
function `window-supports-ping-p' returns true), initiate a ping sequence.

The function CALLBACK will subsequently be called with a single
argument, true if the window responded to the ping within TIMEOUT-MSECS
milliseconds (defaults to 1 second), false otherwise."

    (let ((ping (make-ping-record callback (unique-id))))
      (send-client-message w 'WM_PROTOCOLS
			   (vector (x-atom '_NET_WM_PING)
				   (ping-id ping)) 32)
      (setq pings-in-transit (cons ping pings-in-transit))
      (make-timer (lambda ()
		    ;; Ensure that this ping hasn't already come back
		    (when (memq ping pings-in-transit)
		      (setq pings-in-transit (delq ping pings-in-transit))
		      (callback nil)))
		  (quotient timeout-msecs 1000) (mod timeout-msecs 1000))))

;;; event handler

  (define (client-message-handler w type data)
    (declare (unused w))
    (when (and (eq type 'WM_PROTOCOLS)
	       (eq (x-atom-name (aref data 0)) '_NET_WM_PING))
      ;; a returning ping (pong?)
      (let ((id (aref data 1)))
	(let loop ((rest pings-in-transit))
	  (cond ((null loop)
		 (format
		  standard-error "Received stray _NET_WM_PING: %s\n" data))

		((eql (ping-id (car rest)) id)
		 ;; found our ping
		 (let ((this (car rest)))
		   (setq pings-in-transit (delq this pings-in-transit))
		   ((ping-callback this) t)))

		(t (loop (cdr rest))))))
      t))

  (add-hook 'client-message-hook client-message-handler))

;; keymap.jl -- some keymap utilities, mostly copied from jade

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.keymap

    (export map-keymap
	    substitute-keymap-command
	    substitute-keymap-event
	    lazy-bind-keys
	    where-is
	    make-memoizing-where-is
	    describe-key
	    read-event
	    quote-event)

    (open rep
	  rep.system
	  rep.data.symbol-table
	  sawfish.wm.events
	  sawfish.wm.commands
	  sawfish.wm.misc
	  sawfish.wm.windows)

  (define-structure-alias keymap sawfish.wm.util.keymap)

;;; Map a function over all key bindings in a keymap

  (defvar map-keymap-recursively t
    "When nil, the map-keymap function will only map over the first level of
keymaps, i.e. all prefix keys are ignored.")

  (define (map-keymap function keymap)
    "Map FUNCTION over all key bindings under the keymap or list of
keymaps KEYMAP. FUNCTION is called as (FUNCTION KEY), where KEY is a
cons cell (COMMAND . EVENT)."
    (when (keymapp keymap)
      (setq keymap (list keymap)))
    (let ((keymap-list keymap)
          (done-list nil))
      (while keymap-list
	(let
	    ((keymap (car keymap-list)))
	  (setq keymap-list (cdr keymap-list))
	  (when (and (not (keymapp keymap)) (consp keymap))
	    (setq keymap (car keymap)))
	  (unless (memq keymap done-list)
	    (setq done-list (cons keymap done-list))
	    (when (symbolp keymap)
	      (setq keymap (symbol-value keymap)))
	    (when (keymapp keymap)
	      (mapc (lambda (k)
		      (funcall function k)) (cdr keymap))))))))

;;; Substitute one command for another in a keymap

  (define (substitute-keymap-command olddef newdef #!optional keymap)
    "Substitute all occurrences of the command OLDDEF for the command NEWDEF
in the keybindings under the keymap or list of keymaps KEYMAP."
    (map-keymap (lambda (k)
		  (when (eq (car k) olddef)
		    (rplaca k newdef))) keymap))

  (define (substitute-keymap-event old-ev new-ev #!optional keymap)
    "Substitute all occurrences of the event OLD-EV for the event NEW-EV
in the keybindings under the keymap or list of keymaps KEYMAP."
    (when (stringp old-ev)
      (setq old-ev (lookup-event old-ev)))
    (when (stringp new-ev)
      (setq new-ev (lookup-event new-ev)))
    (map-keymap (lambda (k)
		  (when (equal (cdr k) old-ev)
		    (rplacd k new-ev))) keymap))


;;; Adding bindings to a feature that may not yet be loaded

  (defmacro lazy-bind-keys (feature keymap #!rest bindings)
    "Install the list of BINDINGS in KEYMAP, assuming that KEYMAP is available
once FEATURE has been provided. If FEATURE has not yet been loaded, arrange
for the bindings to be installed if and when it is."
    `(if (featurep ',feature)
	 (bind-keys ,keymap ,@bindings)
       (eval-after-load ,(symbol-name feature)
         '(bind-keys ,keymap ,@bindings))))

;;; Search for a named command in the current keymap configuration

  (define (where-is command #!optional keymap)
    (require 'sawfish.wm.util.decode-events)
    (let ((where-is-results '()))
      (map-keymap (lambda (k)
		    (when (eq (car k) command)
		      (setq where-is-results
                            (cons (event-name (substitute-wm-modifier (cdr k)))
                                  where-is-results))))
		  (or keymap global-keymap))
      where-is-results))

  ;; XXX make this handle prefix keymaps
  (define (make-memoizing-where-is keymaps)
    "Return a function which when called with a command name as its single
argument, will return either false or a string naming the event to which
the command is found in the list of keymaps KEYMAPS."
    (require 'sawfish.wm.util.decode-events)
    (let ((cache (make-symbol-table)))
      (mapc (lambda (keymap)
	      (map-keymap (lambda (k)
			    (when (symbolp (car k))
			      (symbol-table-set cache (car k) (cdr k))))
			  keymap))
	    keymaps)
      (lambda (command)
	(let ((key (symbol-table-ref cache command)))
	  (and key (event-name (substitute-wm-modifier key)))))))

  (define (describe-key #!optional map)
    "Prompt for a key sequence, then print its binding."
    (require 'rep.lang.doc)
    (require 'sawfish.wm.commands.describe)
    (let (components)
      (letrec
	  ((loop
	    (lambda (keymap)
	      (let* ((key (read-event (concat "Describe key: " components)))
		     (binding (and key (search-keymap key keymap))))
		(when binding
		  (setq binding (car binding))
		  (setq components (concat components
					   (and components ? )
					   (event-name key)))
		  (cond ((keymapp binding)
			 (loop binding))
			((and (symbolp binding)
			      (keymapp (symbol-value binding t)))
			 (loop (symbol-value binding)))
			(t
			 (format standard-output
				 "`%s' is bound to `%s'\n\n"
				 components binding)
			 (describe-symbol binding))))))))
	(loop (or map global-keymap)))))

  ;;###autoload
  (define-command 'describe-key describe-key)
  (define-command-to-screen 'describe-key-to-screen describe-key)

;;; grab the next key event

  (define (read-event #!optional prompt)
    (call-with-keyboard-grabbed
     (lambda ()
       (unwind-protect
	   (let
	       ((override-keymap '(keymap))
		(unbound-key-hook
		 (list (lambda ()
			 (throw 'read-event (current-event))))))
	     (display-message (or prompt (_ "Press key...")))
	     (catch 'read-event
	       (recursive-edit)))
	 (display-message nil)))))

  (define (quote-event)
    "Sends the next key event directly to the focused client window, ignoring
any window manager bindings that it may have."
    (require 'sawfish.wm.util.decode-events)
    (let ((override-keymap '(keymap))
	  (unbound-key-hook (list (lambda ()
				    (let ((ev (decode-event (current-event))))
				      (if (eq 'key (car ev))
					  (progn
					    (allow-events 'replay-keyboard)
					    (throw 'quote-event))
					(allow-events 'sync-keyboard)))))))
      ;; grab on the client window, so that the events get replayed
      ;; to that window, not to our frame (thus avoiding any passive
      ;; grabs on the window)
      (when (grab-keyboard (window-id (input-focus)) nil t)
	(unwind-protect
	    (catch 'quote-event
	      (allow-events 'sync-keyboard)
	      (display-message (_ "[Quote]"))
	      (recursive-edit))
	  (display-message nil)
	  (ungrab-keyboard)))))

  ;;###autoload
  (define-command 'quote-event quote-event))

;; wm-spec.jl -- ewmh support

;; Copyright (C) 1999, 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.state.wm-spec

    (export define-wm-spec-window-type
	    define-wm-spec-window-state)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.state.iconify
	  sawfish.wm.util.workarea)

  ;; todo:

  ;; - _NET_WM_ICON

  ;; 1.1 additions:
  ;;  - _NET_WM_ALLOWED_ACTIONS
  ;;  - _STATE_HIDDEN?
  ;;  - _NET_WM_MOVERESIZE changes
  ;;  - _NET_SHOWING_DESKTOP?
  ;;  - _NET_MOVERESIZE_WINDOW

;;; constants

  (defconst _NET_WM_MOVERESIZE_SIZE_TOPLEFT 0)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOP 1)
  (defconst _NET_WM_MOVERESIZE_SIZE_TOPRIGHT 2)
  (defconst _NET_WM_MOVERESIZE_SIZE_RIGHT 3)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT 4)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOM 5)
  (defconst _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT 6)
  (defconst _NET_WM_MOVERESIZE_SIZE_LEFT 7)
  (defconst _NET_WM_MOVERESIZE_MOVE 8)
  (defconst _NET_WM_MOVERESIZE_SIZE_KEYBOARD 9)
  (defconst _NET_WM_MOVERESIZE_MOVE_KEYBOARD 10)
  (defconst _NET_WM_MOVERESIZE_CANCEL 11)

  (defconst _NET_WM_STATE_REMOVE 0)
  (defconst _NET_WM_STATE_ADD 1)
  (defconst _NET_WM_STATE_TOGGLE 2)

  (define wm-spec-window-id nil)

  (define supported-atoms
    [_NET_ACTIVE_WINDOW
     _NET_CLIENT_LIST
     _NET_CLIENT_LIST_STACKING
     _NET_CLOSE_WINDOW
     _NET_CURRENT_DESKTOP
     _NET_DESKTOP_GEOMETRY
     _NET_DESKTOP_NAMES
     _NET_DESKTOP_VIEWPORT
     _NET_FRAME_EXTENTS
     _NET_NUMBER_OF_DESKTOPS
     _NET_PROTOCOLS
     _NET_REQUEST_FRAME_EXTENTS
     _NET_SHOWING_DESKTOP
     _NET_SUPPORTED
     _NET_SUPPORTING_WM_CHECK
     _NET_WORKAREA
     _NET_WM_DESKTOP
     _NET_WM_ICON_GEOMETRY
     _NET_WM_MOVERESIZE
     _NET_WM_MOVERESIZE_MOVE
     _NET_WM_MOVERESIZE_SIZE_BOTTOM
     _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT
     _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT
     _NET_WM_MOVERESIZE_SIZE_LEFT
     _NET_WM_MOVERESIZE_SIZE_RIGHT
     _NET_WM_MOVERESIZE_SIZE_TOP
     _NET_WM_MOVERESIZE_SIZE_TOPLEFT
     _NET_WM_MOVERESIZE_SIZE_TOPRIGHT
     _NET_WM_MOVERESIZE_SIZE_KEYBOARD
     _NET_WM_MOVERESIZE_MOVE_KEYBOARD
     _NET_WM_MOVERESIZE_CANCEL
     _NET_WM_PING
     _NET_WM_STATE
     _NET_WM_STATE_ABOVE
     _NET_WM_STATE_ADD
     _NET_WM_STATE_BELOW
     _NET_WM_STATE_FULLSCREEN
     _NET_WM_STATE_MAXIMIZED
     _NET_WM_STATE_MAXIMIZED_HORZ
     _NET_WM_STATE_MAXIMIZED_VERT
     _NET_WM_STATE_REMOVE
     _NET_WM_STATE_SHADED
     _NET_WM_STATE_SKIP_PAGER
     _NET_WM_STATE_SKIP_TASKBAR
     _NET_WM_STATE_STICKY
     _NET_WM_STATE_TOGGLE
     _NET_WM_STRUT
     _NET_WM_WINDOW_TYPE
     _NET_WM_WINDOW_TYPE_DESKTOP
     _NET_WM_WINDOW_TYPE_DIALOG
     _NET_WM_WINDOW_TYPE_DOCK
     _NET_WM_WINDOW_TYPE_TOOLBAR
     _NET_WM_WINDOW_TYPE_MENU
     _NET_WM_WINDOW_TYPE_UTILITY
     _NET_WM_WINDOW_TYPE_SPLASH
     _NET_WM_USER_TIME])

  (defvar wm-spec-below-depth -2)
  (defvar wm-spec-above-depth +2)

  (define supported-states '())

;;; setting the client list hints

  (define (update-client-list-hints #!key only-stacking-list)
    (define (set-prop lst prop)
      (let loop ((rest lst)
		 (collected '()))
	(cond ((null rest)
	       (set-x-property 'root prop
			       (apply vector (nreverse collected))
			       'WINDOW 32))
	      ((window-mapped-p (car rest))
	       (loop (cdr rest) (cons (window-id (car rest)) collected)))
	      (t (loop (cdr rest) collected)))))
    (unless only-stacking-list
      (set-prop (managed-windows) '_NET_CLIENT_LIST))
    (set-prop (nreverse (stacking-order)) '_NET_CLIENT_LIST_STACKING))

  ;; setting the desktop / viewport hints

  (define last-workspace nil)
  (define last-workspace-count 0)
  (define last-workspace-names nil)
  (define last-area nil)
  (define last-area-count nil)
  (define last-workarea nil)
  (define last-showing-desktop nil)

  (define (update-window-workspace-hints w #!key (limits (workspace-limits)))
    (let ((vec (if (window-sticky-p/workspace w)
		   (vector #xffffffff)
		 (let ((space (or (window-get w 'swapped-in)
				  (car (window-workspaces w)))))
		   (and space (vector (- space (car limits))))))))
      (unless (equal vec (window-get w 'wm-spec/last-workspace))
	(if vec
	    (set-x-property w '_NET_WM_DESKTOP vec 'CARDINAL 32)
	  (delete-x-property w '_NET_WM_DESTOP))
	(window-put w 'wm-spec/last-workspace vec))))

  (define (update-workspace-hints)
    (let* ((limits (workspace-limits))
	   (port (screen-viewport))
           ;; Since vp size can vary from workspace to workspace, use
           ;; the maximum dimensions across all workspaces.
	   (port-size (let ((dims (cons viewport-dimensions
                                        (mapcar (lambda (e)
                                                  (unless (eq (car e)
                                                              current-workspace)
                                                    (nth 3 e)))
                                                workspace-viewport-data))))
                        (cons (apply max (mapcar car dims))
                              (apply max (mapcar cdr dims)))))
	   (total-workspaces (1+ (- (cdr limits) (car limits))))
	   (workarea (make-vector (* 4 total-workspaces)))
	   (showing-desktop (showing-desktop-p)))

      (define (set-ws-hints)
	;; _NET_NUMBER_OF_DESKTOPS
	(unless (equal last-workspace-count total-workspaces)
	  (setq last-workspace-count total-workspaces)
	  (set-x-property 'root '_NET_NUMBER_OF_DESKTOPS
			  (vector total-workspaces) 'CARDINAL 32))

	;; _NET_DESKTOP_NAMES
	(unless (equal last-workspace-names workspace-names)
	  (setq last-workspace-names workspace-names)
	  (set-x-text-property 'root '_NET_DESKTOP_NAMES
			       (apply vector workspace-names)
			       'UTF8_STRING))

	;; _NET_CURRENT_DESKTOP
	(unless (equal last-workspace
		       (- current-workspace (car limits)))
	  (setq last-workspace (- current-workspace (car limits)))
	  (set-x-property 'root '_NET_CURRENT_DESKTOP
			  (vector last-workspace) 'CARDINAL 32))

	;; _NET_DESKTOP_GEOMETRY
	(unless (equal last-area-count port-size)
	  (setq last-area-count port-size)
	  (set-x-property 'root '_NET_DESKTOP_GEOMETRY
			  (vector (* (car port-size) (screen-width))
				  (* (cdr port-size) (screen-height)))
			  'CARDINAL 32))

	;; _NET_DESKTOP_VIEWPORT
	(unless (equal last-area port)
	  (let ((view (make-vector (* total-workspaces 2))))
	    (let loop ((i 0))
	      (if (= i total-workspaces)
		  (set-x-property 'root '_NET_DESKTOP_VIEWPORT
				  view 'CARDINAL 32)
		(if (eq i current-workspace)
		    (progn
		      (aset view (* i 2) (* (car port) (screen-width)))
		      (aset view (1+ (* i 2)) (* (cdr port)
						 (screen-height))))
		  (let ((vp-data (cdr (assoc i workspace-viewport-data))))
		    (aset view (* i 2) (car vp-data))
		    (aset view (1+ (* i 2)) (nth 1 vp-data))))
		(loop (1+ i))))))

	;; _NET_WORKAREA
	(unless (equal last-workarea workarea)
	  (set-x-property 'root '_NET_WORKAREA workarea 'CARDINAL 32)
	  (setq last-workarea workarea))

	;; _NET_SHOWING_DESKTOP
	(unless (equal showing-desktop last-showing-desktop)
	  (set-x-property 'root '_NET_SHOWING_DESKTOP
			  (vector (if showing-desktop 1 0)) 'CARDINAL 32)
	  (setq last-showing-desktop showing-desktop)))

      (define (set-window-hints w)
	(update-window-workspace-hints w #:limits limits))

      ;; calculate workareas
      (do ((i 0 (1+ i)))
	  ((= i total-workspaces))
	(let ((area (calculate-workarea-from-struts
		     #:workspace (+ i (car limits)))))
	  (aset workarea (+ (* i 4) 0) (nth 0 area))
	  (aset workarea (+ (* i 4) 1) (nth 1 area))
	  (aset workarea (+ (* i 4) 2) (- (nth 2 area) (nth 0 area)))
	  (aset workarea (+ (* i 4) 3) (- (nth 3 area) (nth 1 area)))))

      ;; apparently some pagers don't like it if we place windows
      ;; on (temporarily) non-existent workspaces
      (when (< last-workspace-count total-workspaces)
	(set-ws-hints))

      (map-windows set-window-hints)

      (when (>= last-workspace-count total-workspaces)
	(set-ws-hints))))

;;; setting the focus hints

  (define last-focus nil)

  (define (update-focus-state w mode)
    (declare (unused w))
    (let ((focus (input-focus)))
      (unless (or (eq mode 'grab) (eq mode 'ungrab) (eq last-focus focus))
	(setq last-focus focus)
	(set-x-property 'root '_NET_ACTIVE_WINDOW
			(vector (if focus (window-id focus) 0)) 'WINDOW 32))))

;;; setting the window state hints

  (define (update-client-state w)
    (let ((state '()))
      (mapc (lambda (x)
	      (when (and (not (pseudo-state-p x))
			 (call-state-fun w x 'get))
		(setq state (cons x state))))
	    supported-states)
      (set-x-property w '_NET_WM_STATE (apply vector state) 'ATOM 32)))

;;; setting the frame extents (pixels of frame per edge)

  (define (update-frame-extents w)
    (if (window-framed-p w)
        (let* ((left   (- (car (window-frame-offset w))))
               (right  (- (- (car (window-frame-dimensions w))
                             (car (window-dimensions w)))
                          left))
               (top    (- (cdr (window-frame-offset w))))
               (bottom (- (- (cdr (window-frame-dimensions w))
                             (cdr (window-dimensions w)))
                          top)))
          (set-x-property w '_NET_FRAME_EXTENTS
                          (vector (max 0 left) (max 0 right)
                                  (max 0 top) (max 0 bottom))
                          'CARDINAL 32))
      ;; frame none/unframed appears as 0 0 0 0
      ;; this is to stay safe when "->reparented" FALSE/Qnil
      (delete-x-property w '_NET_FRAME_EXTENTS)))

;;; honouring the initially set window state hints

  (define (update-icon-geometry w geom)
    (when (>= (length geom) 2)
      (window-put w 'icon-position (cons (aref geom 0) (aref geom 1)))))

  (define (update-strut w)
    (let ((strut (get-x-property w '_NET_WM_STRUT)))
      (when (and strut (eq (nth 0 strut) 'CARDINAL))
	(let ((data (nth 2 strut)))
	  (define-window-strut w (aref data 0) (aref data 2)
            (aref data 1) (aref data 3))))))

  (define (honour-client-state w)
    (let ((space (get-x-property w '_NET_WM_DESKTOP)))
      (when space
	(setq space (aref (nth 2 space) 0))
	(cond ((equal space #xffffffff)
	       (window-put w 'sticky t))
	      ((and (integerp space) (null (window-workspaces w)))
	       (set-window-workspaces w (list space))))))

    (let ((type (get-x-property w '_NET_WM_WINDOW_TYPE)))
      (when type
	(setq type (nth 2 type))
	;; _NET_WM_WINDOW_TYPE is a vector of atoms, the first atom
	;; about which we know something is the type we'll use
	(let loop ((i 0))
	  (cond ((= i (length type)))
		((get (aref type i) 'wm-spec-type)
		 ((get (aref type i) 'wm-spec-type) w))
		(t (loop (1+ i)))))))

    (let ((state (get-x-property w '_NET_WM_STATE)))
      (when state
	(setq state (nth 2 state))
	(do ((i 0 (1+ i)))
	    ((= i (length state)))
	  (call-state-fun w (aref state i) 'init))))

    (update-strut w)

    (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
      (when geom
	(update-icon-geometry w (nth 2 geom))))
    (when (equal (get-x-property w '_NET_WM_USER_TIME)
                 '(CARDINAL 32 #(0)))
      (window-put w 'inhibit-focus-when-mapped t)))

;;; helper functions

  (define (define-wm-spec-window-type x fun)
    (if (listp x)
	(mapc (lambda (y) (define-wm-spec-window-type y fun)) x)
      (put x 'wm-spec-type fun)))

  (define (define-wm-spec-window-state x fun #!key pseudo)
    (put x 'wm-spec-state fun)
    (unless (memq x supported-states)
      (setq supported-states (cons x supported-states)))
    (when pseudo
      (put x 'wm-spec-pseudo-state t)))

  (define (supported-state-p x) (and (symbolp x) (get x 'wm-spec-state)))
  (define (pseudo-state-p x) (and (symbolp x) (get x 'wm-spec-pseudo-state)))

  (define (call-state-fun w state mode)
    (let ((fun (and (symbolp state) (get state 'wm-spec-state))))
      (when fun
	(fun w mode))))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DESKTOP
    (lambda (w)
      (mark-window-as-desktop w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DOCK
    (lambda (w)
      (mark-window-as-dock w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_DIALOG
    (lambda (w)
      (mark-window-as-transient w)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_UTILITY
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'utility)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_TOOLBAR
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'toolbar)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_MENU
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'menu)))

  (define-wm-spec-window-type '_NET_WM_WINDOW_TYPE_SPLASH
    (lambda (w)
      (require 'sawfish.wm.frames)
      (set-window-type w 'splash)
      (window-put w 'place-mode 'centered)))

  (define-wm-spec-window-state '_NET_WM_STATE_STICKY
    (lambda (w mode)
      (case mode
        ((init)   (window-put w 'sticky-viewport t))
        ((remove) (make-window-unsticky/viewport w))
        ((add)    (make-window-sticky/viewport w))
        ((toggle) (if (window-sticky-p/viewport w)
                      (make-window-unsticky/viewport w)
                    (make-window-sticky/viewport w)))
        ((get)    (window-sticky-p/viewport w)))))

  (define (wm-spec-maximize-handler direction)
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
	((init)
	 (window-put w (if (eq direction 'vertical)
			   'queued-vertical-maximize
			 'queued-horizontal-maximize) t))
	((remove) (unmaximize-window w direction))
	((add)    (maximize-window w direction))
	((toggle) (maximize-window-toggle w direction))
	((get)    (if (window-maximized-fullscreen-p w)
		      nil
		    (case direction
		      ((vertical) (window-maximized-vertically-p w))
		      ((horizontal) (window-maximized-horizontally-p w))
		      (t (window-maximized-p w))))))))

  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_VERT
    (wm-spec-maximize-handler 'vertical))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED_HORZ
    (wm-spec-maximize-handler 'horizontal))
  (define-wm-spec-window-state '_NET_WM_STATE_MAXIMIZED
    (wm-spec-maximize-handler nil)
    #:pseudo t)

  (define-wm-spec-window-state '_NET_WM_STATE_SHADED
    (lambda (w mode)
      (require 'sawfish.wm.state.shading)
      (case mode
        ((init)   (window-put w 'shaded t))
        ((add)    (shade-window w))
        ((remove) (unshade-window w))
        ((toggle) (toggle-window-shaded w))
        ((get)    (window-get w 'shaded)))))

  (define-wm-spec-window-state '_NET_WM_STATE_SKIP_PAGER
    (lambda (w mode)
      (case mode
        ((init add) (window-put w 'window-list-skip t))
        ((remove)   (window-put w 'window-list-skip nil))
        ((toggle)   (window-put w 'window-list-skip
                                (not (window-get w 'window-list-skip))))
        ((get)      (window-get w 'window-list-skip)))))

  (define-wm-spec-window-state '_NET_WM_STATE_SKIP_TASKBAR
    (lambda (w mode)
      (case mode
        ((init add) (window-put w 'task-list-skip t))
        ((remove)   (window-put w 'task-list-skip nil))
        ((toggle)   (window-put w 'task-list-skip
                                (not (window-get w 'task-list-skip))))
        ((get)      (window-get w 'task-list-skip)))))

  (define-wm-spec-window-state '_NET_WM_STATE_FULLSCREEN
    (lambda (w mode)
      (require 'sawfish.wm.state.maximize)
      (case mode
        ((init) (window-put w 'queued-fullscreen-maximize t))
        ((add remove) (maximize-window-fullscreen w (eq mode 'add)))
        ((toggle) (maximize-window-fullscreen-toggle w))
        ((get) (window-maximized-fullscreen-p w)))))

  (define (above-below-handler depth w mode)
    (require 'sawfish.wm.stacking)
    (case mode
      ((init)
       (window-put w 'depth depth))
      ((add remove)
       (set-window-depth w (if (eq mode 'add) depth 0)))
      ((toggle)
       (set-window-depth w (if (= (window-depth w) depth) 0 depth)))
      ((get)
       (= (window-depth w) depth))))

  (define-wm-spec-window-state '_NET_WM_STATE_BELOW
    (lambda (w mode)
      (above-below-handler wm-spec-below-depth w mode)))

  (define-wm-spec-window-state '_NET_WM_STATE_ABOVE
    (lambda (w mode)
      (above-below-handler wm-spec-above-depth w mode)))

;;; client messages

  (define (client-message-handler w type data)
    (let ((handled t))
      (case type
	((_NET_CLOSE_WINDOW)
	 (when (windowp w)
	   (delete-window w)))

        ((_NET_REQUEST_FRAME_EXTENTS)
         (when (windowp w)
           (update-frame-extents w)))

	((_NET_SHOWING_DESKTOP)
	 (if (= (aref data 0) 1)
	     (show-desktop)
	   (hide-desktop)))

	((_NET_WM_MOVERESIZE)
	 (when (and (windowp w) (window-mapped-p w))
	   (require 'sawfish.wm.commands.move-resize)
	   (let ((mode (aref data 2)))
	     ;; don't want grabs failing, sigh
	     (x-server-timestamp t t)
	     (if (or (eq mode _NET_WM_MOVERESIZE_MOVE)
		     (eq mode _NET_WM_MOVERESIZE_MOVE_KEYBOARD))
		 (move-window-interactively w)
	       (let ((move-resize-moving-edges
		      (cond ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPLEFT)
			     '(top left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOP)
			     '(top))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_TOPRIGHT)
			     '(top right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT)
			     '(bottom left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOM)
			     '(bottom))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT)
			     '(bottom right))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_LEFT)
			     '(left))
			    ((eq mode _NET_WM_MOVERESIZE_SIZE_RIGHT)
			     '(right)))))
                 ;; XXX ignore CANCELs for now
                 ;; XXX see reports about GTK3 going into resize randomly
                 ;; XXX probably need to rework all this block
                 (if (not (eq mode _NET_WM_MOVERESIZE_CANCEL))
                     (resize-window-interactively w)))))))

	((_NET_NUMBER_OF_DESKTOPS)
	 (set-number-of-workspaces (aref data 0)))

	((_NET_DESKTOP_GEOMETRY)
	 (set-number-of-viewports (aref data 0) (aref data 1)))

	((_NET_DESKTOP_VIEWPORT)
	 (set-viewport (aref data 0) (aref data 1)))

	((_NET_CURRENT_DESKTOP)
         ;; KDE spews _NET_CURRENT_DESKTOP( -1) messages so often that it
         ;; is best to just ignore out of bounds errors silently.
         (let ((ws (workspace-id-from-logical (aref data 0)))
               (limits (workspace-limits)))
           (if (<= (car limits) ws (cdr limits))
               (select-workspace ws))))

	((_NET_DESKTOP_NAMES)
	 ;; XXX this is kind of broken now we use workspace-names to
	 ;; XXX define the minimum number of workspaces to display?
	 (setq data (aref data 0))
	 (let loop ((i 0)
		    (out '()))
	   (if (= i (length data))
	       (setq workspace-names (nreverse out))
	     (loop (1+ i) (cons (aref data i) out)))))

	((_NET_ACTIVE_WINDOW)
	 (require 'sawfish.wm.util.display-window)
	 (when (and (windowp w) (window-mapped-p w))
	   (display-window w)))

	((_NET_WM_STATE)
	 (when (windowp w)
	   (let ((mode (cond ((eql (aref data 0) _NET_WM_STATE_REMOVE)
                              'remove)
			     ((eql (aref data 0) _NET_WM_STATE_ADD)
                              'add)
			     ((eql (aref data 0) _NET_WM_STATE_TOGGLE)
                              'toggle)))
		 (atom1 (x-atom-name (aref data 1)))
		 (atom2 (x-atom-name (aref data 2))))
	     (when (or (and (eq atom1 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom2 '_NET_WM_STATE_MAXIMIZED_HORZ))
		       (and (eq atom2 '_NET_WM_STATE_MAXIMIZED_VERT)
			    (eq atom1 '_NET_WM_STATE_MAXIMIZED_HORZ)))
	       (setq atom1 '_NET_WM_STATE_MAXIMIZED)
	       (setq atom2 nil))
	     (when atom1
	       (call-state-fun w atom1 mode))
	     (when atom2
	       (call-state-fun w atom2 mode)))))

	((_NET_WM_DESKTOP)
	 (when (windowp w)
	   (let ((desktop (aref data 0)))
	     (if (eql desktop #xffffffff)
		 ;; making window sticky
		 (make-window-sticky/workspace w)
	       ;; changing the desktop
	       (make-window-unsticky/workspace w)
	       (send-window-to-workspace-from-first w desktop nil)))))

	(t (setq handled nil)))
      handled))

;;; property changes

  (define (property-change-handler w prop kind)
    (declare (unused kind))
    (case prop
      ((_NET_WM_ICON_GEOMETRY)
       (let ((geom (get-x-property w '_NET_WM_ICON_GEOMETRY)))
	 (when geom
	   (update-icon-geometry w (nth 2 geom)))))
      ((_NET_WM_STRUT)
       (update-strut w))))

;;; utilities

  (define (vector->list vec)
    (do ((i 0 (1+ i))
	 (out '() (cons (aref vec i) out)))
	((= i (length vec)) (nreverse out))))

  (define (update-on-configure-notify w)
    (when (eq w 'root)
      (update-workspace-hints)))

;;; initialisation

  (define (init)
    (setq wm-spec-window-id (create-window 'root -200 -200 5 5))

    (set-x-property 'root '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_SUPPORTING_WM_CHECK
		    (vector wm-spec-window-id) 'WINDOW 32)
    (set-x-property wm-spec-window-id '_NET_WM_NAME "Sawfish" 'UTF8_STRING 8)

    (set-x-property 'root '_NET_SUPPORTED supported-atoms 'ATOM 32)

    (let ((current-desktop (get-x-property 'root '_NET_CURRENT_DESKTOP)))
      (when (and current-desktop
		 (eq (car current-desktop) 'CARDINAL)
		 (>= (length (caddr current-desktop)) 1))
	(add-hook 'after-initialization-hook
		  ;; Don't do this yet, it can screw things up
		  (lambda ()
		    (select-workspace-from-first
		     (aref (caddr current-desktop) 0))))))

    (update-client-list-hints)
    (update-workspace-hints)

    (add-hook 'workspace-state-change-hook update-workspace-hints)
    (add-hook 'viewport-resized-hook update-workspace-hints)
    (add-hook 'viewport-moved-hook update-workspace-hints)
    (add-hook 'workarea-changed-hook update-workspace-hints)
    (add-hook 'configure-notify-hook update-on-configure-notify)

    ;; Better not expose work in progress.  map-notify-hook gets
    ;; called after this anyway.
    ;;(add-hook 'add-window-hook update-client-list-hints)
    (add-hook 'destroy-notify-hook update-client-list-hints)
    (add-hook 'map-notify-hook update-client-list-hints)
    (add-hook 'unmap-notify-hook update-client-list-hints)
    (add-hook 'after-restacking-hook update-client-list-hints)

    (add-hook 'after-framing-hook update-frame-extents)
    (add-hook 'after-add-window-hook update-frame-extents)
    (add-hook 'reparent-notify-hook update-frame-extents)

    (add-hook 'before-add-window-hook honour-client-state)
    (add-hook 'add-window-hook update-client-state)
    (call-after-state-changed '(sticky shaded maximized stacking
                                       window-list-skip task-list-skip)
			      update-client-state)
    (call-after-state-changed 'sticky update-window-workspace-hints)

    (add-hook 'focus-in-hook update-focus-state)
    (add-hook 'focus-out-hook update-focus-state)

    (add-hook 'client-message-hook client-message-handler)
    (add-hook 'property-notify-hook property-change-handler)

    (add-hook 'before-exit-hook exit)

    (map-windows update-client-state))

  (define (exit)
    (destroy-window wm-spec-window-id)
    (delete-x-property 'root '_NET_SUPPORTING_WM_CHECK)
    (delete-x-property 'root '_NET_PROTOCOLS)
    (delete-x-property 'root '_NET_DESKTOP_GEOMETRY)
    (delete-x-property 'root '_NET_DESKTOP_VIEWPORT))

  (unless (or wm-spec-window-id batch-mode)
    (init)))

;; focus.jl -- implement standard focus behaviour

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.focus

    (export define-focus-mode
	    autoload-focus-mode
	    focus-mode
	    set-focus-mode
	    focus-push-map
	    focus-pop-map
	    warp-pointer-if-necessary
	    focus-revert
	    focus-within-click-event)

    (open rep
	  rep.system
	  rep.util.autoloader
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.util.window-order
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.session.init)

  (defvar focus-modes nil
    "List containing all symbols naming focus modes.")

  (defcustom focus-mode 'click
    "When does the mouse pointer affect the input focus."
    :type symbol
    :group focus
    :before-set (lambda () (focus-mode-changed 'before))
    :after-set (lambda () (focus-mode-changed 'after)))

  (defcustom focus-click-through t
    "Click-to-focus mode passes the click through to the application."
    :type boolean
    :group focus)

  (defcustom focus-dont-push nil
    "Whether focusing a window doesn't change it's position in the stack."
    :type boolean
    :group focus)


  ;; Only used by x-cycle.jl
  (defvar focus-ignore-pointer-events nil
    "When true, pointer in/out events don't cause focus changes.")

  (define focus-within-click-event (make-fluid nil)
          "When true, the current command is being called from within
a click-to-focus button press event.")

;;; general utilities

  (define (define-focus-mode name fun)
    "Define a new focus mode called NAME (a symbol). The function FUN will be
used to implement this focus mode, it will be called with arguments `(WINDOW
EVENT-NAME)', where EVENT-NAME may be one of the following symbols:
`pointer-in', `pointer-out', `focus-in', `focus-out', `add-window'
`before-mode-change', `after-mode-change', `warp-if-necessary' and
`focus-revert'."

    (unless (memq name focus-modes)
      (setq focus-modes (nconc focus-modes (list name))))
    (custom-set-property 'focus-mode ':options focus-modes)
    (put name 'focus-mode fun))

  ;; autoload handling
  (define (getter name) (get name 'focus-mode))
  (define autoload-focus-mode (make-autoloader getter define-focus-mode))
  (define focus-mode-ref (autoloader-ref getter))

  (define (window-focus-mode w)
    (or (and w (windowp w) (window-get w 'focus-mode)) focus-mode))

  (define (focus-invoke-mode w . args)
    (let* ((mode (window-focus-mode w))
	   (fun (focus-mode-ref mode)))
      (when fun
	(apply fun w args))))

  (define (set-focus-mode w mode)
    "Set the focus mode of window W to the mode named by symbol MODE."
    (unless (eq (window-get w 'focus-mode) mode)
      (focus-invoke-mode w 'before-mode-change)
      (window-put w 'focus-mode mode)
      (focus-invoke-mode w 'after-mode-change)))

  (define (focus-mode-changed time)
    (let ((arg (if (eq time 'before)
		   'before-mode-change
		 'after-mode-change)))
      (map-windows
       (lambda (w)
	 (unless (window-get w 'focus-mode)
	   (focus-invoke-mode w arg))))))

  (define (focus-push-map w map)
    (let ((current (window-get w 'keymap))
	  (saved (window-get w 'focus-saved-keymap)))
      (unless (or (eq current map) (null current))
	(unless saved
	  (window-put w 'focus-saved-keymap current))
	(window-put w 'keymap map))))

  (define (focus-pop-map w)
    (let ((saved (window-get w 'focus-saved-keymap)))
      (when saved
	(window-put w 'keymap saved)
	(window-put w 'focus-saved-keymap nil))))

  ;; W is the focused window. Warp to it if it conforms to
  ;; the focus mode.
  (define (warp-pointer-if-necessary #!optional (w (input-focus)))
    (focus-invoke-mode w 'warp-if-necessary))

  ;; Put focus in some window that hopefully feels natural.  This is
  ;; typically used when the window in focus has disappeared.  Thus
  ;; there is no reference window.
  (define (focus-revert)
    (let ((fun (focus-mode-ref focus-mode)))
      (when fun (fun nil 'focus-revert))))

;;; modes

  #|
  From sawfish-1.5.0, enter-notify events invoked by grab are
  ignored in enter-exit and enter-only. This has a down side, too,
  but first let us see what's the intention.

  The problem that this solves is when you press Alt F2 in KDE, the
  Run Command popup appears and gets focused (if focus-when-mapped is
  non-nil), you start typing, the completion list pops up and takes
  focus, then you type a bit further and the completion list
  disappears.  Focus used to revert to the window the pointer was in,
  which usually was not the Run Command popup.  transient-unmap-window
  tries hard to get it right, then the grab-induced enter-notify
  brought focus to the wrong window anyway.

  The problem that this causes is when you open the KDE main menu by
  clicking the K icon in the panel, move the mouse into some
  application window and click to dismiss the open menu, focus reverts
  to the panel. You have to move the pointer out of the application
  window and back in to get it focused.
  |#
  (define-focus-mode 'enter-exit
    (lambda (w action . args)
      (case action
	((pointer-in)
	 (when (and (window-really-wants-input-p w)
		    ;; ignore grab/ungrab enter events
		    ;; See the above long comment
		    (eq (car args) 'normal))
	   (set-input-focus w)))
	((pointer-out)
	 ;; ignore grab/ungrab leave events
	 (when (eq (car args) 'normal)
	   (set-input-focus nil)))
	((enter-root)
	 ;; ensure that any desktop window gets focused
	 (set-input-focus w))
	((warp-if-necessary)
	 (unless (eq (query-pointer-window) w)
	   (warp-cursor-to-window w)))
        ((focus-revert)
         (setq w (query-pointer-window))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define-focus-mode 'enter-only
    (lambda (w action . args)
      (case action
	((pointer-in)
	 (when (and (window-really-wants-input-p w)
		    ;; ignore grab/ungrab enter events
		    ;; See the comment above enter-exit
		    (eq (car args) 'normal))
	   (set-input-focus w)))
	((warp-if-necessary)
	 (let ((current (query-pointer-window)))
	   (unless (or (eq current w) (desktop-window-p current))
	     (warp-cursor-to-window w))))
        ((focus-revert)
         (setq w (query-pointer-window))
         (when (or (null w)
                   (desktop-window-p w))
           (setq w (window-order-most-recent)))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define (focus-click)
    (let ((w (current-event-window))
	  (event (current-event)))
      (when (window-really-wants-input-p w)
	(set-input-focus w))
      (focus-pop-map w)
      ;; do we need to do anything with the event?
      (when event
	;; allow-events called with replay-pointer ignores any passive
	;; grabs on the window, thus if the wm has a binding in the
	;; window's keymap, it would be ignored. So search manually..
	(let ((command (lookup-event-binding event)))
	  (if command
	      (let-fluids ((focus-within-click-event t))
		(call-command command))
	    (require 'sawfish.wm.util.decode-events)
	    (when (and (or focus-click-through
			   (window-get w 'focus-click-through)
			   (not (window-really-wants-input-p w)))
		       (not (should-grab-button-event-p
			     event (window-get w 'keymap))))
	      ;; pass the event through to the client window unless we
	      ;; need to keep the grab for the events that would follow
	      (allow-events 'replay-pointer)
	      (forget-button-press)))))
      (unless (eq (input-focus) w)
        (focus-push-map w click-to-focus-map))))

  (defvar click-to-focus-map
    (bind-keys (make-keymap)
               ;; apparently buttons 4 & 5 are usually bound to the
               ;; wheel on some mice
               "Any-Button1-Click1" focus-click
               "Any-Button2-Click1" focus-click
               "Any-Button3-Click1" focus-click))

  (define-focus-mode 'click
    (lambda (w action)
      (case action
	((focus-in)
	 (focus-pop-map w))
	((focus-out add-window)
	 (unless (or (not (window-really-wants-input-p w))
		     (eq w (input-focus)))
	   (focus-push-map w click-to-focus-map)))
	((before-mode-change)
	 (focus-pop-map w))
	((after-mode-change)
	 (unless (or (not (window-really-wants-input-p w))
		     (eq w (input-focus)))
	   (focus-push-map w click-to-focus-map)))
        ((focus-revert)
         (setq w (window-order-most-recent))
         (when (or (null w)
                   (window-really-wants-input-p w))
           (set-input-focus w))))))

  (define-focus-mode 'enter-click
    (lambda (w action . args)
      (case action
        ((pointer-in warp-if-necessary focus-revert)
         (apply (focus-mode-ref 'enter-only) w action args))
        ((focus-in focus-out add-window before-mode-change after-mode-change)
         (apply (focus-mode-ref 'click) w action args)))))

;;; hooks

  (define (focus-enter-fun w mode)
    (unless focus-ignore-pointer-events
      (cond ((desktop-window-p w)
	     (focus-invoke-mode w 'enter-root mode))
	    ((windowp w)
	     (focus-invoke-mode w 'pointer-in mode)))))

  (define (focus-leave-fun w mode)
    (unless focus-ignore-pointer-events
      (cond ((desktop-window-p w)
	     (focus-invoke-mode w 'leave-root mode))
	    ((windowp w)
	     (focus-invoke-mode w 'pointer-out mode)))))

  (define (focus-in-fun w)
    (focus-invoke-mode w 'focus-in)
    (unless focus-dont-push
      (window-order-push w)))

  (define (focus-out-fun w) (focus-invoke-mode w 'focus-out))
  (define (focus-add-window w) (focus-invoke-mode w 'add-window))

  (add-hook 'enter-notify-hook focus-enter-fun t)
  (add-hook 'leave-notify-hook focus-leave-fun t)
  (add-hook 'focus-in-hook focus-in-fun t)
  (add-hook 'focus-out-hook focus-out-fun t)
  (add-hook 'map-notify-hook focus-add-window)

  (call-after-state-changed
   '(never-focus)
   (lambda (w)
     (if (window-get w 'never-focus)
	 (focus-pop-map w)
       (focus-add-window w))))

  (add-hook 'after-initialization-hook
	    (lambda () (map-windows focus-add-window)))

  (sm-add-saved-properties 'never-focus 'focus-mode)

;;; bug prevention

  ;; XXX Pavel reported this bug (windows becoming unfocusable in
  ;; XXX click-to-focus mode). I can't see why it happens, hence this
  ;; XXX kludge for now..

  (define (scan-windows-for-bugs)
    (map-windows (lambda (w)
		   (when (eq (window-focus-mode w) 'click)
		     ;; check that the correct keymaps are in place
		     (unless (or (eq (input-focus) w)
				 (not (window-mapped-p w))
				 (not (window-really-wants-input-p w))
				 (eq (window-get w 'keymap)
				     click-to-focus-map))
		       ;;(format standard-error
                       ;;        "Window lost focus keymap: %s, %s\n"
                       ;;        (window-name w) (window-get w 'keymap))
                       ;;(beep) (beep)
		       (focus-push-map w click-to-focus-map))))))

  (add-hook 'idle-hook scan-windows-for-bugs))

;; StyleTab

(define theme-name 'StyleTab)

;;need hash tables for icon cache
(require 'rep.data.tables)

;; recolor imanges
(require 'sawfish.wm.util.recolor-image)

;; Defcustom and defgroup
(defgroup StyleTab:group "StyleTab"
  :group appearance)

(defgroup StyleTab:top-buttons-group "Top Titlebar Buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:bottom-buttons-group "Bottom Titlebar Buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:left-buttons-group "Left Titlebar Buttons"
  :group (appearance StyleTab:group))

(defgroup StyleTab:right-buttons-group "Right Titlebar Buttons"
  :group (appearance StyleTab:group))

(defcustom styletab-c:titlebar-place 'top "Titlebar default place."
  :group (appearance StyleTab:group)
  :type symbol
  :options (top bottom left right))

(defcustom styletab-c:title-dimension 24 "Height of title border."
  :group (appearance StyleTab:group)
  :type symbol
  :options (16 18 20 22 24 26 28 30 32))

(defcustom styletab-c:borders-dimension 4 "Width of window border."
  :group (appearance StyleTab:group)
  :type symbol
  :options (0 2 4 6 8))

(defcustom styletab-c:custom-button-width nil "Customize buttons width."
  :group (appearance StyleTab:group)
  :type boolean)

(defcustom styletab-c:button-width 0 "Width of Buttons."
  :group (appearance StyleTab:group)
  :type symbol
  :depends styletab-c:custom-button-width
  :options (1 2 3 4 0 -1 -2 -3 -4))

(defcustom styletab-c:styles 'Default "Frame and button style."
  :group (appearance StyleTab:group)
  :type symbol
  :options (Default Glass Reduce WixDa Smoothly Flat))

(defcustom styletab-c:proposals 'Default "Color proposals."
  :group (appearance StyleTab:group)
  :type symbol
  :options (Default Glass Reduce WixDa Smoothly Flat Brown Darkblue Blue Pink Green)
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:tabbar-marked t "Colorize tab/titelbar if it is to be added as a tab."
  :group (appearance StyleTab:group)
  :type boolean
  :after-set (lambda () (botton-color-changed recolor-tab)))

(defcustom styletab-c:tabbar-marked-color (get-color "#010095")
  "Color of tab/titelbar when it was marked."
  :group (appearance StyleTab:group)
  :type color
  :depends styletab-c:tabbar-marked
  :after-set (lambda () (botton-color-changed recolor-tab)))

(defcustom styletab-c:hightlight-tabbar nil "Also hightlighted tab/titelbar."
  :group (appearance StyleTab:group)
  :type boolean
  :after-set (lambda () (botton-color-changed recolor-tab)))

(defcustom styletab-c:custom-frame-colors nil "Customize frame color/brightness (Don't use color proposals)."
  :group (appearance StyleTab:group)
  :type boolean
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:focus-frame-color (get-color "#780000")
  "Focus frame color."
  :group (appearance StyleTab:group)
  :type color
  :depends styletab-c:custom-frame-colors
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:unfocus-frame-color (get-color "#780000")
  "Inactive frame color"
  :group (appearance StyleTab:group)
  :type color
  :depends styletab-c:custom-frame-colors
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:inactive-dimout 2 "Dimout inactive frame."
  :group (appearance StyleTab:group)
  :depends styletab-c:custom-frame-colors
  :type symbol
  :options (0 1 2 3 4 5)
  :after-set (lambda () (color-changed)))

(defcustom styletab-c:active-hightlight-brighten 2 "Focus window brightness mouse over buttons."
  :group (appearance StyleTab:group)
  :depends styletab-c:custom-frame-colors
  :type symbol
  :options (1 2 3 4 5 0 -1 -2 -3 -4 -5)
  :after-set (lambda () (bright-changed)))

(defcustom styletab-c:inactive-hightlight-brighten 2 "Inactive windows brightness mouse over buttons."
  :group (appearance StyleTab:group)
  :type symbol
  :depends styletab-c:custom-frame-colors
  :options (1 2 3 4 5 0 -1 -2 -3 -4 -5)
  :after-set (lambda () (bright-changed)))

(defcustom styletab-c:hightlight-close nil
  "Colorize the close button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-close-button)))

(defcustom styletab-c:hightlight-close-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-close
  :after-set (lambda () (botton-color-changed recolor-close-button)))

(defcustom styletab-c:hightlight-maximize nil
  "Colorize the maximize button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-maximize-button)))

(defcustom styletab-c:hightlight-maximize-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-maximize
  :after-set (lambda () (botton-color-changed recolor-maximize-button)))

(defcustom styletab-c:hightlight-iconify nil
  "Colorize the minimize button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-iconify-button)))

(defcustom styletab-c:hightlight-iconify-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-iconify
  :after-set (lambda () (botton-color-changed recolor-iconify-button)))

(defcustom styletab-c:hightlight-shade nil
  "Colorize the shade button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-shade-button)))

(defcustom styletab-c:hightlight-shade-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-shade
  :after-set (lambda () (botton-color-changed recolor-shade-button)))

(defcustom styletab-c:hightlight-sticky nil
  "Colorize the sticky button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-sticky-button)))

(defcustom styletab-c:hightlight-sticky-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-sticky
  :after-set (lambda () (botton-color-changed recolor-sticky-button)))

(defcustom styletab-c:hightlight-menu nil
  "Colorize the menu button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-menu-button)))

(defcustom styletab-c:hightlight-menu-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-menu
  :after-set (lambda () (botton-color-changed recolor-menu-button)))

(defcustom styletab-c:hightlight-frame-type nil
  "Colorize the frame type button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-frame-type-button)))

(defcustom styletab-c:hightlight-frame-type-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-frame-type
  :after-set (lambda () (botton-color-changed recolor-frame-type-button)))

(defcustom styletab-c:hightlight-lock nil
  "Colorize the lock button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-lock-button)))

(defcustom styletab-c:hightlight-lock-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-lock
  :after-set (lambda () (botton-color-changed recolor-lock-button)))

(defcustom styletab-c:hightlight-move-resize nil
  "Colorize the move/resize button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-move-resize-button)))

(defcustom styletab-c:hightlight-move-resize-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-move-resize
  :after-set (lambda () (botton-color-changed recolor-move-resize-button)))

(defcustom styletab-c:hightlight-raise-lower nil
  "Colorize the raise/lower button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-raise-lower-button)))

(defcustom styletab-c:hightlight-raise-lower-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-raise-lower
  :after-set (lambda () (botton-color-changed recolor-raise-lower-button)))

(defcustom styletab-c:hightlight-next nil
  "Colorize the next workspace button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-next-button)))

(defcustom styletab-c:hightlight-next-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-next
  :after-set (lambda () (botton-color-changed recolor-next-button)))

(defcustom styletab-c:hightlight-prev nil
  "Colorize the previous workspace button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-prev-button)))

(defcustom styletab-c:hightlight-prev-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-prev
  :after-set (lambda () (botton-color-changed recolor-prev-button)))

(defcustom styletab-c:hightlight-rename nil
  "Colorize the rename button."
  :group (appearance StyleTab:group)
  :type (optional color)
  :after-set (lambda () (botton-color-changed recolor-rename-button)))

(defcustom styletab-c:hightlight-rename-all nil "Always colorize."
  :group (appearance StyleTab:group)
  :type boolean
  :depends styletab-c:hightlight-rename
  :after-set (lambda () (botton-color-changed recolor-rename-button)))

(mapc
 (lambda (arg)
   (let ((type-list ;; ":type" in defcustom
          (append '(v-and)
                  (make-list 10
                             ;; Here, `list' is necessary. If you
                             ;; replace it with a quote, the configurator
                             ;; crashes.
                             (list 'h-and '(choice \(none\) close menu maximize minimize shade sticky space send-to-prev
                                                   send-to-next lock raise-lower move-resize rename frame-type)
                                   '(boolean "Also show in transients."))))))
     (eval
      (macroexpand
       `(defcustom ,(car arg) ;; name
          ,(cadr arg) ;; default value
          ,(caddr arg) ;; doc
          :group
          ,`(appearance StyleTab:group
                        ,(cadddr arg))
          :type ,type-list
          ))))) ;; end of lambda
 '( ;; list to pass to mapc
   (styletab-c:top-left-buttons
    '((menu t) (sticky nil) (shade nil))
    "Top Titlebar Left Buttons (from left to right). \\top"
    StyleTab:top-buttons-group)
   (styletab-c:top-right-buttons
    '((close t) (maximize t) (minimize nil))
    "Top Titlebar Right Buttons (from right to left). \\top"
    StyleTab:top-buttons-group)
   (styletab-c:bottom-left-buttons
    '((menu t) (sticky nil) (shade nil))
    "Bottom Titlebar Left Buttons (from left to right). \\top"
    StyleTab:bottom-buttons-group)
   (styletab-c:bottom-right-buttons
    '((close t) (maximize t) (minimize nil))
    "Bottom Titlebar Right Buttons (from right to left). \\top"
    StyleTab:bottom-buttons-group)
   (styletab-c:left-top-buttons
    '((close t) (maximize t) (minimize nil))
    "Left Titlebar Top Buttons (from top to bottom). \\top"
    StyleTab:left-buttons-group)
   (styletab-c:left-bottom-buttons
    '((menu t) (sticky nil) (shade nil))
    "Left Titlebar Bottom Buttons (from bottom to top). \\top"
    StyleTab:left-buttons-group)
   (styletab-c:right-top-buttons
    '((close t) (maximize t) (minimize nil))
    "Right Titlebar Top Buttons (from top to bottom). \\top"
    StyleTab:right-buttons-group)
   (styletab-c:right-bottom-buttons
    '((menu t) (sticky nil) (shade nil))
    "Right Titlebar Bottom Buttons (from bottom to top). \\top"
    StyleTab:right-buttons-group)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; styles settings

(define proposals-colors
  (lambda ()
    (case styletab-c:proposals
          ;; format "color" "dimout inactive frame" "brighte mouse over button active" "brighte mouse over button inactive"
          ((Default) (list "#000033" '40 '100 '100))
          ((Reduce) (list "#000000" '0 '100 '100))
          ((Glass) (list "#5E5E70" '60 '40 '60))
          ((WixDa) (list "#6E6D8F" '20 '40 '60))
          ((Smoothly) (list "#75759E" '20 '40 '40))
          ((Flat) (list "#6E6D8F" '20 '40 '60))
          ((Darkblue) (list "#00006E" '30 '70 '70))
          ((Brown) (list "#780000" '40 '40 '50))
          ((Blue) (list "#0000B4" '30 '40 '50))
          ((Pink) (list "#7F0081" '50 '50 '50))
          ((Green) (list "#006400" '30 '60 '60)))))

(define title-colors-images
  (lambda ()
    (case styletab-c:styles
          ((Default) (title-colors-default))
          ((Reduce) (title-colors-reduce))
          ((Glass) (title-colors-glass))
          ((WixDa) (title-colors-wixda))
          ((Smoothly) (title-colors-smoothly))
          ((Flat) (title-colors-flat)))))

(define title-colors-default
  (lambda ()
    `((focused . "#F2F2F2") (highlighted . "#FEFEFE") (clicked . "#FEFEFE") (inactive . "#CBCBCB") (inactive-highlighted . "#D8D8D8")
      (inactive-clicked . "#D8D8D8"))))

(define title-colors-reduce
  (lambda ()
    `((focused . "#E5E5E5") (highlighted . "#FDFDFD") (clicked . "#FDFDFD") (inactive . "#B1B1B1") (inactive-highlighted . "#CBCBCB")
      (inactive-clicked . "#CBCBCB"))))

(define title-colors-glass
  (lambda ()
    `((focused . "#F2F2F2") (highlighted . "#FFFFFF") (clicked . "#FFFFFF") (inactive . "#D9D9D9") (inactive-highlighted . "#E6E6E6")
      (inactive-clicked . "#E6E6E6"))))

(define title-colors-wixda
  (lambda ()
    `((focused . "#262626") (highlighted . "#000000") (clicked . "#000000") (inactive . "#404040") (inactive-highlighted . "#333333")
      (inactive-clicked . "#333333"))))

(define title-colors-smoothly
  (lambda ()
    `((focused . "#333333") (highlighted . "#000000") (clicked . "#000000") (inactive . "#666666") (inactive-highlighted . "#444444")
      (inactive-clicked . "#444444"))))

(define title-colors-flat
  (lambda ()
    `((focused . "#F2F2F2") (highlighted . "#FFFFFF") (clicked . "#FFFFFF") (inactive . "#D9D9D9") (inactive-highlighted . "#E6E6E6")
      (inactive-clicked . "#E6E6E6"))))

(define button-width-custom
  (lambda ()
    (if (eq styletab-c:custom-button-width t)
        (button-width-set)
      (case styletab-c:styles
            ((Default) (button-width-default))
            ((Reduce) (button-width-reduce))
            ((Glass) (button-width-glass))
            ((WixDa) (button-width-wixda))
            ((Smoothly) (button-width-smoothly))
            ((Flat) (button-width-flat))))))

(define button-width-add
  (lambda ()
    (if (eq styletab-c:custom-button-width nil)
        (button-width-zero)
      (case styletab-c:styles
            ((Default) (button-width-default))
            ((Reduce) (button-width-reduce))
            ((Glass) (button-width-glass))
            ((WixDa) (button-width-wixda))
            ((Smoothly) (button-width-smoothly))
            ((Flat) (button-width-flat))))))

(define button-width-set (lambda () (+ styletab-c:button-width (button-width-add))))
(define button-width-zero (lambda () 0))
(define button-width-default (lambda () 8))
(define button-width-reduce (lambda () 0))
(define button-width-glass (lambda () 0))
(define button-width-wixda (lambda () -4))
(define button-width-smoothly (lambda () 0))
(define button-width-flat (lambda () 0))

;; end of tabtext
(define tabbar-right-edge-width
  (lambda ()
    (case styletab-c:styles
          ((Default) 3)
          ((Reduce) 6)
          ((Glass) 3)
          ((WixDa) 3)
          ((Smoothly) 3)
          ((Flat) 3))))

;; edge of first buttons left/right
(define button-left-edge
  (lambda ()
    (case styletab-c:styles
          ((Default) 0)
          ((Reduce) 0)
          ((Glass) 0)
          ((WixDa) 0)
          ((Smoothly) 0)
          ((Flat) 0))))

(define button-right-edge
  (lambda ()
    (case styletab-c:styles
          ((Default) 1)
          ((Reduce) 1)
          ((Glass) 0)
          ((WixDa) 0)
          ((Smoothly) 2)
          ((Flat) 0))))

(define icon-edge
  (lambda ()
    (case styletab-c:styles
          ((Default) 2)
          ((Reduce) 2)
          ((Glass) 1)
          ((WixDa) 1)
          ((Smoothly) 2)
          ((Flat) 1))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; frame-class, keys bindings

(define (rotate-tab src dest)
  (let ((w (current-event-window))
        (wins (tab-group-windows (current-event-window)))
        pos-x pos-y fdim framew framehigh dim-x dim-y current-title type)
    (if (not (window-get w 'title-position))
        (case styletab-c:titlebar-place
              ((top) (setq current-title 'top))
              ((bottom) (setq current-title 'bottom))
              ((left) (setq current-title 'left))
              ((right) (setq current-title 'right)))
      (setq current-title (window-get w 'title-position)))
    (setq type (window-get w 'type))
    (setq pos-x (car (window-position w)))
    (setq pos-y (cdr (window-position w)))
    (setq dim-x (car (window-dimensions w)))
    (setq dim-y (cdr (window-dimensions w)))
    (setq fdim (window-frame-dimensions w))
    (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ dim-x dim-y styletab-c:title-dimension)) 3))

    (when (not (eq type 'unframed))
      (if (window-get w 'shaded) (unshade-window w))
      (if (eq src 'horiz)
          (if (eq dest 'opposite)
              (progn
                (if (eq current-title 'top)
                    (setq dest 'bottom)
                  (setq dest 'top))
                (when (>= (+ pos-y dim-y styletab-c:title-dimension framew) (screen-height))
                  (setq pos-y (- (screen-height) dim-y styletab-c:title-dimension framew)))
                (when (<= pos-y 0) (setq pos-y 0)))
            ;; To left or right
            (if (or (eq (window-get w 'type) 'default)
                    (eq (window-get w 'type) 'transient))
                (setq framehigh (+ (- styletab-c:title-dimension (* styletab-c:borders-dimension 2)) framew))
              (setq framehigh (+ styletab-c:title-dimension framew)))
            (setq dim-x (- dim-x framehigh))
            (setq dim-y (+ dim-y framehigh))
            (when (and (eq dest 'left) (<= pos-x 0))
              (setq pos-x 0))
            (when (and (eq dest 'right)
                       (>= (+ pos-x dim-x framehigh framew framew) (screen-width)))
              (setq pos-x (- (screen-width) dim-x styletab-c:title-dimension framew))))
        ;; vert
        (if (eq dest 'opposite)
            (progn
              (if (eq current-title 'left)
                  (progn
                    (setq dest 'right)
                    (when (>= (+ pos-x dim-x) (screen-width))
                      (setq pos-x (- (screen-width) dim-x styletab-c:title-dimension framew))))
                (setq dest 'left)
                (when (<= pos-x 0) (setq pos-x 0))))
          ;; To top or bottom
          (if (or (eq (window-get w 'type) 'default)
                  (eq (window-get w 'type) 'transient))
              (setq framehigh (- styletab-c:title-dimension (* styletab-c:borders-dimension 2)))
            (setq framehigh styletab-c:title-dimension))
          (setq dim-x (+ dim-x framehigh framew))
          (setq dim-y (- dim-y framehigh framew))
          (when (>= (+ pos-y dim-y styletab-c:title-dimension framew) (screen-height))
            (setq pos-y (- (screen-height) dim-y styletab-c:title-dimension framew)))
          (when (<= pos-y 0) (setq pos-y 0))))

      (mapcar (lambda (w)
                (window-put w 'title-position dest)) wins)

      (reframe-window w)
      (move-window-to w pos-x pos-y)
      (resize-window-to w dim-x dim-y)
      (tab-refresh-group w 'move))))

(define (tab/titelbartotop)
  "Move tab/titelbar to top, with resize (StyleTab Option)."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'left)
            (eq (window-get w 'title-position) 'right))
        (rotate-tab 'vert 'top))
    (if (eq (window-get w 'title-position) 'bottom)
        (rotate-tab 'horiz 'opposite))))

(define (tab/titelbartobottom)
  "Move tab/titelbar to bottom, with resize (StyleTab Option)."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'left)
            (eq (window-get w 'title-position) 'right))
        (rotate-tab 'vert 'bottom))
    (if (eq (window-get w 'title-position) 'top)
        (rotate-tab 'horiz 'opposite))))

(define (tab/titelbartoleft)
  "Move tab/titelbar to left, with resize (StyleTab Option)."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'left))
    (if (eq (window-get w 'title-position) 'right)
        (rotate-tab 'vert 'opposite))))

(define (tab/titelbartoright)
  "Move tab/titelbar to right, with resize (StyleTab Option)."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'right))
    (if (eq (window-get w 'title-position) 'left)
        (rotate-tab 'vert 'opposite))))

(define (tab/titelbartoggle)
  "Move tab/titelbar to the opposite side, with resize (StyleTab Option)."
  (let ((w (current-event-window)))
    (if (not (window-get w 'title-position))
        (window-put w 'title-position styletab-c:titlebar-place))
    (if (or (eq (window-get w 'title-position) 'top)
            (eq (window-get w 'title-position) 'bottom))
        (rotate-tab 'horiz 'opposite)
      (rotate-tab 'vert 'opposite))))

(define-command-gaol 'tab/titelbar-toggle tab/titelbartoggle)
(define-command-gaol 'tab/titelbar-to-top tab/titelbartotop)
(define-command-gaol 'tab/titelbar-to-bottom tab/titelbartobottom)
(define-command-gaol 'tab/titelbar-to-left tab/titelbartoleft)
(define-command-gaol 'tab/titelbar-to-right tab/titelbartoright)

(def-frame-class tabbar-horizontal-left-edge ()
  (bind-keys tabbar-horizontal-left-edge-keymap
             "Button1-Off" 'tab/titelbar-to-left
             "Button2-Off" 'tab/titelbar-toggle
             "Button3-Off" 'tab/titelbar-to-right))

(def-frame-class tabbar-vertical-top-edge ()
  (bind-keys tabbar-vertical-top-edge-keymap
             "Button1-Off" 'tab/titelbar-to-top
             "Button2-Off" 'tab/titelbar-toggle
             "Button3-Off" 'tab/titelbar-to-bottom))

(define (f-type dest)
  (let ((w (current-event-window))
        (wins (tab-group-windows (current-event-window)))
        pos-x pos-y dim-x dim-y cur new current-title)
    (if (not (window-get w 'title-position))
        (case styletab-c:titlebar-place
              ((top) (setq current-title 'top))
              ((bottom) (setq current-title 'bottom))
              ((left) (setq current-title 'left))
              ((right) (setq current-title 'right)))
      (setq current-title (window-get w 'title-position)))
    (setq pos-x (car (window-position w)))
    (setq pos-y (cdr (window-position w)))
    (setq dim-x (car (window-dimensions w)))
    (setq dim-y (cdr (window-dimensions w)))
    (setq cur (window-get w 'type))
    (if (window-get w 'shaded) (unshade-window w))

    (when (eq dest 'def-tra)
      (if (eq cur 'default)
          (setq new 'transient)
        (setq new 'default))
      (when (or (eq cur 'shaped)
                (eq cur 'utility))
        (setq new 'default)
        (setq dim-x (- dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (- dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (+ dim-x styletab-c:borders-dimension))
          (setq dim-y (- dim-y styletab-c:borders-dimension))))
      (when (eq cur 'shaped-transient)
        (setq new 'transient)
        (setq dim-x (- dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (- dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (+ dim-x styletab-c:borders-dimension))
          (setq dim-y (- dim-y styletab-c:borders-dimension))))
      (when (eq cur 'unframed)
        (setq new 'default)
        (when (or (eq current-title 'top)
                  (eq current-title 'bottom))
          (setq dim-x (- dim-x (* styletab-c:borders-dimension 2)))
          (setq dim-y (- dim-y styletab-c:borders-dimension styletab-c:title-dimension)))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-y (- dim-y (* styletab-c:borders-dimension 2)))
          (setq dim-x (- dim-x styletab-c:borders-dimension styletab-c:title-dimension)))))

    (when (eq dest 'sha-tra)
      (if (or (eq cur 'shaped)
              (eq cur 'utility))
          (setq new 'shaped-transient)
        (setq new 'shaped))
      (when (eq cur 'default)
        (setq new 'shaped)
        (setq dim-x (+ dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (+ dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (- dim-x styletab-c:borders-dimension))
          (setq dim-y (+ dim-y styletab-c:borders-dimension))))
      (when (eq cur 'transient)
        (setq new 'shaped-transient)
        (setq dim-x (+ dim-x (* styletab-c:borders-dimension 2)))
        (setq dim-y (+ dim-y styletab-c:borders-dimension))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-x (- dim-x styletab-c:borders-dimension))
          (setq dim-y (+ dim-y styletab-c:borders-dimension))))
      (when (eq cur 'unframed)
        (setq new 'shaped)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (- dim-y styletab-c:title-dimension))
          (setq dim-x (- dim-x styletab-c:title-dimension)))))

    (when (eq dest 'unf-def)
      (when (or (eq cur 'default)
                (eq cur 'transient))
        (setq new 'unframed)
        (when (or (eq current-title 'top)
                  (eq current-title 'bottom))
          (setq dim-x (+ dim-x (* styletab-c:borders-dimension 2)))
          (setq dim-y (+ dim-y styletab-c:borders-dimension styletab-c:title-dimension)))
        (when (not (or (eq current-title 'top)
                       (eq current-title 'bottom)))
          (setq dim-y (+ dim-y (* styletab-c:borders-dimension 2)))
          (setq dim-x (+ dim-x styletab-c:borders-dimension styletab-c:title-dimension))))
      (when (or (eq cur 'shaped)
                (eq cur 'shaped-transient)
                (eq cur 'utility))
        (setq new 'unframed)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (+ dim-y styletab-c:title-dimension))
          (setq dim-x (+ dim-x styletab-c:title-dimension))))
      (when (eq cur 'unframed)
        (setq new 'shaped-transient)
        (if (or (eq current-title 'top)
                (eq current-title 'bottom))
            (setq dim-y (- dim-y styletab-c:title-dimension))
          (setq dim-x (- dim-x styletab-c:title-dimension)))))
    (when (not (eq cur new))
      (mapcar (lambda (w)
                (window-put w 'type new)
                (reframe-window w)
                (move-window-to w pos-x pos-y)
                (resize-window-to w dim-x dim-y)) wins)
      (tab-refresh-group w 'move))))

(define (set-frame-default-and-default/transient)
  "Set frametype to `default' and toggle transient-ness, with resize (StyleTab Option)."
  (f-type 'def-tra))

(define (set-frame-unframed-and-unframed/shaped-transient)
  "Set frametype to 'unframed' and toggle transient-ness, with resize (StyleTab Option)."
  (f-type 'unf-def))

(define (set-frame-shaped-and-shaped/shaped-transient)
  "Set frametype to shaped and toggle transient-ness, with resize (StyleTab Option)."
  (f-type 'sha-tra))

(define-command-gaol 'set-frame-default-and-default/transient-toggle set-frame-default-and-default/transient)
(define-command-gaol 'set-frame-unframed-and-unframed/shaped-transient-toggle set-frame-unframed-and-unframed/shaped-transient)
(define-command-gaol 'set-frame-shaped-and-shaped/shaped-transient-toggle set-frame-shaped-and-shaped/shaped-transient)

(def-frame-class frame-type-button ()
  (bind-keys frame-type-button-keymap
             "Button1-Off" 'set-frame-default-and-default/transient-toggle
             "Button2-Off" 'set-frame-unframed-and-unframed/shaped-transient-toggle
             "Button3-Off" 'set-frame-shaped-and-shaped/shaped-transient-toggle))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; make images/recolor

;; button/icon table
(define styletab-c-icon-cache (make-weak-table eq-hash eq))

;; frames/title table
(define styletab-c-frame-cache (make-table equal-hash equal))

(define (window-icon w)
  (or (table-ref styletab-c-icon-cache w)
      (let ((icon (window-icon-image w)))
        (if icon
            (let ((scaled (scale-image icon (- styletab-c:title-dimension 7) (- styletab-c:title-dimension 8))))
              (table-set styletab-c-icon-cache w scaled)
              scaled)
          (scale-image top-frame-icon-title-images (- styletab-c:title-dimension 7) (- styletab-c:title-dimension 8))))))

(defun brighten-color (color percentage)
  (let* ((red (car (color-rgb color)))
         (green (cadr (color-rgb color)))
         (blue (car (cddr (color-rgb color))))
         (red-delta (quotient (* red percentage) 100))
         (green-delta (quotient (* green percentage) 100))
         (blue-delta (quotient (* blue percentage) 100)))
    (get-color-rgb (min (+ red-delta red) 65535)
                   (min (+ green-delta green) 65535)
                   (min (+ blue-delta blue) 65535))))

(defun darken-color (color percentage)
  (let* ((red (car (color-rgb color)))
         (green (cadr (color-rgb color)))
         (blue (car (cddr (color-rgb color))))
         (red-delta (quotient (* red percentage) 100))
         (green-delta (quotient (* green percentage) 100))
         (blue-delta (quotient (* blue percentage) 100)))
    (get-color-rgb (max (- red red-delta) 0)
                   (max (- green green-delta) 0)
                   (max (- blue blue-delta) 0))))

(define (get-recolor-dark dimout color)
  (darken-color color dimout))

(define (get-recolor-bright bright color)
  (brighten-color color bright))

(define start-lock 't)
(define (do-recolor img color)
  (if (and (eq styletab-c:styles 'Flat)
           (not flat-buttons))
      (make-sized-image 1 1 color)
    (if (not (eq styletab-c:styles 'Flat))
        (if start-lock
            img
          (let ((recolorer
                 (make-image-recolorer color
                                       #:zero-channel blue-channel
                                       #:index-channel green-channel)))
            (recolorer img)
            img))
      img)))

(define (do-make-get-image img)
  (if (and (eq styletab-c:styles 'Flat)
           (not flat-buttons))
      nil
    (or
     (table-ref styletab-c-frame-cache img)
     (let ((image
            (make-image (concat (find-frame-style theme-name) "/" img))))
       (table-set styletab-c-frame-cache img image)
       image))))

(define (base-tables-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
    (table-unset styletab-c-frame-cache w)
    (table-set styletab-c-frame-cache w `((focused . ,focus) (inactive . ,inact)))))

(define (build-title-corner-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-frame-top-left-" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-frame-top-left-" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
      (table-unset styletab-c-frame-cache (concat "top-frame-top-left-" w))
      (table-set styletab-c-frame-cache (concat "top-frame-top-left-" w) `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache (concat "top-frame-top-right-" w))
      (table-set styletab-c-frame-cache (concat "top-frame-top-right-" w)
                 `((focused . ,(flip-image-horizontally (copy-image focus))) (inactive . ,(flip-image-horizontally (copy-image inact)))))
      (table-unset styletab-c-frame-cache (concat "left-frame-top-left-" w))
      (table-set styletab-c-frame-cache (concat "left-frame-top-left-" w)
                 `((focused . ,(flip-image-diagonally (copy-image focus))) (inactive . ,(flip-image-diagonally (copy-image inact)))))
      (table-unset styletab-c-frame-cache (concat "left-frame-bottom-left-" w))
      (table-set styletab-c-frame-cache (concat "left-frame-bottom-left-" w)
                 `((focused . ,(flip-image-vertically (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-vertically (flip-image-diagonally (copy-image inact))))))
      (table-unset styletab-c-frame-cache (concat "right-frame-top-right-" w))
      (table-set styletab-c-frame-cache (concat "right-frame-top-right-" w)
                 `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact))))))
      (table-unset styletab-c-frame-cache (concat "right-frame-bottom-right-" w))
      (table-set styletab-c-frame-cache (concat "right-frame-bottom-right-" w)
                 `((focused . ,(flip-image-vertically (flip-image-horizontally (flip-image-diagonally (copy-image focus)))))
                   (inactive . ,(flip-image-vertically (flip-image-horizontally (flip-image-diagonally (copy-image inact)))))))))

(define (build-cursor-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-frame-title-" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-frame-title-" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
      (table-unset styletab-c-frame-cache (concat "top-frame-title-" w))
      (table-set styletab-c-frame-cache (concat "top-frame-title-" w) `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache (concat "left-frame-title-" w))
      (table-set styletab-c-frame-cache (concat "left-frame-title-" w)
                 `((focused . ,(flip-image-diagonally (copy-image focus))) (inactive . ,(flip-image-diagonally (copy-image inact)))))
      (table-unset styletab-c-frame-cache (concat "right-frame-title-" w))
      (table-set styletab-c-frame-cache (concat "right-frame-title-" w)
                 `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact))))))))

(define (build-title-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
      (table-unset styletab-c-frame-cache (concat "top-" w))
      (table-set styletab-c-frame-cache (concat "top-" w) `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache (concat "bottom-" w))
      (table-set styletab-c-frame-cache (concat "bottom-" w) `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache (concat "left-" w))
      (table-set styletab-c-frame-cache (concat "left-" w)
                 `((focused . ,(flip-image-diagonally (copy-image focus))) (inactive . ,(flip-image-diagonally (copy-image inact)))))
      (table-unset styletab-c-frame-cache (concat "right-" w))
      (table-set styletab-c-frame-cache (concat "right-" w)
                 `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact))))))))

(define (build-border-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
      (table-unset styletab-c-frame-cache (concat "top-" w))
      (table-set styletab-c-frame-cache (concat "top-" w) `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache "right-frame-left-border")
      (table-set styletab-c-frame-cache "right-frame-left-border" `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache '"top-frame-right-border")
      (table-set styletab-c-frame-cache '"top-frame-right-border"
                 `((focused . ,(flip-image-horizontally (copy-image focus))) (inactive . ,(flip-image-horizontally (copy-image inact)))))
      (table-unset styletab-c-frame-cache '"left-frame-right-border")
      (table-set styletab-c-frame-cache '"left-frame-right-border"
                 `((focused . ,(flip-image-horizontally (copy-image focus))) (inactive . ,(flip-image-horizontally (copy-image inact)))))
      (table-unset styletab-c-frame-cache '"top-frame-bottom-border")
      (table-set styletab-c-frame-cache '"top-frame-bottom-border"
                 `((focused . ,(flip-image-vertically (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-vertically (flip-image-diagonally (copy-image inact))))))
      (table-unset styletab-c-frame-cache '"right-frame-bottom-border")
      (table-set styletab-c-frame-cache '"right-frame-bottom-border"
                 `((focused . ,(flip-image-vertically (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-vertically (flip-image-diagonally (copy-image inact))))))
      (table-unset styletab-c-frame-cache '"left-frame-bottom-border")
      (table-set styletab-c-frame-cache '"left-frame-bottom-border"
                 `((focused . ,(flip-image-vertically (flip-image-diagonally (copy-image focus))))
                   (inactive . ,(flip-image-vertically (flip-image-diagonally (copy-image inact))))))
      (table-unset styletab-c-frame-cache '"right-frame-top-border")
      (table-set styletab-c-frame-cache '"right-frame-top-border"
                 `((focused . ,(flip-image-diagonally (copy-image focus)))
                   (inactive . ,(flip-image-diagonally (copy-image inact)))))
      (table-unset styletab-c-frame-cache '"left-frame-top-border")
      (table-set styletab-c-frame-cache '"left-frame-top-border"
                 `((focused . ,(flip-image-diagonally (copy-image focus)))
                   (inactive . ,(flip-image-diagonally (copy-image inact)))))))

(define (build-corner-images w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" "top-" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
      (table-unset styletab-c-frame-cache (concat "top-" w))
      (table-set styletab-c-frame-cache (concat "top-" w) `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache "right-frame-bottom-left-corner")
      (table-set styletab-c-frame-cache "right-frame-bottom-left-corner" `((focused . ,focus) (inactive . ,inact)))
      (table-unset styletab-c-frame-cache '"top-frame-bottom-right-corner")
      (table-set styletab-c-frame-cache '"top-frame-bottom-right-corner"
                 `((focused . ,(flip-image-horizontally (copy-image focus))) (inactive . ,(flip-image-horizontally (copy-image inact)))))
      (table-unset styletab-c-frame-cache '"left-frame-bottom-right-corner")
      (table-set styletab-c-frame-cache '"left-frame-bottom-right-corner"
                 `((focused . ,(flip-image-horizontally (copy-image focus))) (inactive . ,(flip-image-horizontally (copy-image inact)))))
      (table-unset styletab-c-frame-cache '"right-frame-top-left-corner")
      (table-set styletab-c-frame-cache '"right-frame-top-left-corner"
                 `((focused . ,(flip-image-vertically (copy-image focus))) (inactive . ,(flip-image-vertically (copy-image inact)))))
      (table-unset styletab-c-frame-cache '"left-frame-top-right-corner")
      (table-set styletab-c-frame-cache '"left-frame-top-right-corner"
                 `((focused . ,(flip-image-diagonally (copy-image focus))) (inactive . ,(flip-image-diagonally (copy-image inact)))))))

(define (tab-tables-images x w)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (focus-m (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-marked-f.png"))
                             (if (eq styletab-c:tabbar-marked t)
                                 styletab-c:tabbar-marked-color
                               (if (eq styletab-c:custom-frame-colors t)
                                   (get-recolor-bright 20 styletab-c:focus-frame-color)
                                 (get-recolor-bright 20 (get-color (nth 0 (proposals-colors))))))))
        (highl (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-h.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-bright
                                (if (eq styletab-c:hightlight-tabbar t)
                                    (/ (* styletab-c:active-hightlight-brighten 20) 2) 0)
                                styletab-c:focus-frame-color) (get-recolor-bright
                                                               (if (eq styletab-c:hightlight-tabbar t)
                                                                   (/ (nth 2 (proposals-colors)) 2) 0)
                                                               (get-color (nth 0 (proposals-colors)))))))
        (highl-m (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-marked-h.png"))
                             (if (eq styletab-c:tabbar-marked t)
                                 (if (eq styletab-c:hightlight-tabbar t)
                                     (get-recolor-bright 20 styletab-c:tabbar-marked-color)
                                   styletab-c:tabbar-marked-color)
                               (if (eq styletab-c:custom-frame-colors t)
                                   (get-recolor-bright
                                    (if (eq styletab-c:hightlight-tabbar t)
                                        (/ (* styletab-c:active-hightlight-brighten 40) 2) 20)
                                    styletab-c:focus-frame-color) (get-recolor-bright
                                                                   (if (eq styletab-c:hightlight-tabbar t)
                                                                       (/ (nth 2 (proposals-colors)) 2) 0)
                                                                   (get-recolor-bright 20 (get-color (nth 0 (proposals-colors)))))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors)))))))
        (inact-m (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-marked-i.png"))
                             (if (eq styletab-c:tabbar-marked t)
                                 styletab-c:tabbar-marked-color
                               (if (eq styletab-c:custom-frame-colors t)
                                   (get-recolor-bright 20 styletab-c:focus-frame-color)
                                 (get-recolor-bright 20 (get-color (nth 0 (proposals-colors))))))))
        (in-hi (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-ih.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-bright
                                (if (eq styletab-c:hightlight-tabbar t)
                                    (- (/ (* styletab-c:inactive-hightlight-brighten 20) 2) (* styletab-c:inactive-dimout 20))
                                  (- (* styletab-c:inactive-dimout 20)))
                                styletab-c:unfocus-frame-color)
                             (get-recolor-bright (if (eq styletab-c:hightlight-tabbar t)
                                                     (- (/ (nth 3 (proposals-colors)) 2) (nth 1 (proposals-colors)))
                                                   (- (nth 1 (proposals-colors))))
                                                 (get-color (nth 0 (proposals-colors)))))))
        (in-hi-m (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" x "-" w "-marked-ih.png"))
                             (if (eq styletab-c:tabbar-marked t)
                                 (if (eq styletab-c:hightlight-tabbar t)
                                     (get-recolor-bright 20 styletab-c:tabbar-marked-color)
                                   styletab-c:tabbar-marked-color)
                               (if (eq styletab-c:custom-frame-colors t)
                                   (get-recolor-bright
                                    (if (eq styletab-c:hightlight-tabbar t)
                                        (/ (* styletab-c:active-hightlight-brighten 40) 2) 20)
                                    styletab-c:focus-frame-color) (get-recolor-bright
                                                                   (if (eq styletab-c:hightlight-tabbar t)
                                                                       (/ (nth 2 (proposals-colors)) 2) 0)
                                                                   (get-recolor-bright 20 (get-color (nth 0 (proposals-colors))))))))))
    (table-unset styletab-c-frame-cache (concat x "-" w))
    (table-set styletab-c-frame-cache (concat x "-" w) `((focused . ,focus) (highlighted . ,highl) (inactive . ,inact)
                                                         (inactive-highlighted . ,in-hi)))
    (table-unset styletab-c-frame-cache (concat "bottom" "-" w))
    (table-set styletab-c-frame-cache (concat "bottom" "-" w) `((focused . ,focus) (highlighted . ,highl) (inactive . ,inact)
                                                                (inactive-highlighted . ,in-hi)))
    (table-unset styletab-c-frame-cache (concat x "-" w "-m"))
    (table-set styletab-c-frame-cache (concat x "-" w "-m") `((focused . ,focus-m) (highlighted . ,highl-m) (inactive . ,inact-m)
                                                              (inactive-highlighted . ,in-hi-m)))
    (table-unset styletab-c-frame-cache (concat "bottom" "-" w "-m"))
    (table-set styletab-c-frame-cache (concat "bottom" "-" w "-m") `((focused . ,focus-m) (highlighted . ,highl-m) (inactive . ,inact-m)
                                                                     (inactive-highlighted . ,in-hi-m)))
    (when (equal w '"frame-tab-left-icon")
      (table-unset styletab-c-frame-cache "left-frame-tab-top")
      (table-set styletab-c-frame-cache "left-frame-tab-top" `((focused . ,(flip-image-diagonally (copy-image focus)))
                                                               (highlighted . ,(flip-image-diagonally (copy-image highl)))
                                                               (inactive . ,(flip-image-diagonally (copy-image inact)))
                                                               (inactive-highlighted . ,(flip-image-diagonally (copy-image in-hi)))))
      (table-unset styletab-c-frame-cache "left-frame-tab-top-m")
      (table-set styletab-c-frame-cache "left-frame-tab-top-m" `((focused . ,(flip-image-diagonally (copy-image focus-m)))
                                                               (highlighted . ,(flip-image-diagonally (copy-image highl-m)))
                                                               (inactive . ,(flip-image-diagonally (copy-image inact-m)))
                                                               (inactive-highlighted . ,(flip-image-diagonally (copy-image in-hi-m)))))
      (table-unset styletab-c-frame-cache "left-frame-tab-bottom-icon")
      (table-set styletab-c-frame-cache
                 "left-frame-tab-bottom-icon" `((focused . ,(flip-image-vertically (flip-image-diagonally (copy-image focus))))
                                                (highlighted . ,(flip-image-vertically (flip-image-diagonally (copy-image highl))))
                                                (inactive . ,(flip-image-vertically (flip-image-diagonally (copy-image inact))))
                                                (inactive-highlighted . ,(flip-image-vertically (flip-image-diagonally (copy-image in-hi))))))
      (table-unset styletab-c-frame-cache "left-frame-tab-bottom-icon-m")
      (table-set styletab-c-frame-cache
                 "left-frame-tab-bottom-icon-m" `((focused . ,(flip-image-vertically (flip-image-diagonally (copy-image focus-m))))
                                                (highlighted . ,(flip-image-vertically (flip-image-diagonally (copy-image highl-m))))
                                                (inactive . ,(flip-image-vertically (flip-image-diagonally (copy-image inact-m))))
                                                (inactive-highlighted . ,(flip-image-vertically (flip-image-diagonally (copy-image in-hi-m))))))
      (table-unset styletab-c-frame-cache "right-frame-tab-top")
      (table-set styletab-c-frame-cache
                 "right-frame-tab-top" `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus))))
                                         (highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image highl))))
                                         (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact))))
                                         (inactive-highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image in-hi))))))
      (table-unset styletab-c-frame-cache "right-frame-tab-top-m")
      (table-set styletab-c-frame-cache
                 "right-frame-tab-top-m" `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus-m))))
                                         (highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image highl-m))))
                                         (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact-m))))
                                         (inactive-highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image in-hi-m))))))
      (table-unset styletab-c-frame-cache "right-frame-tab-bottom-icon")
      (table-set styletab-c-frame-cache
                 "right-frame-tab-bottom-icon" `((focused . ,(flip-image-horizontally (flip-image-vertically
                                                                                       (flip-image-diagonally (copy-image focus)))))
                                                 (highlighted . ,(flip-image-horizontally (flip-image-vertically
                                                                                           (flip-image-diagonally (copy-image highl)))))
                                                 (inactive . ,(flip-image-horizontally (flip-image-vertically
                                                                                        (flip-image-diagonally (copy-image inact)))))
                                                 (inactive-highlighted . ,(flip-image-horizontally (flip-image-vertically
                                                                                                    (flip-image-diagonally (copy-image in-hi)))))))
      (table-unset styletab-c-frame-cache "right-frame-tab-bottom-icon-m")
      (table-set styletab-c-frame-cache
                 "right-frame-tab-bottom-icon-m" `((focused . ,(flip-image-horizontally (flip-image-vertically
                                                                                       (flip-image-diagonally (copy-image focus-m)))))
                                                 (highlighted . ,(flip-image-horizontally (flip-image-vertically
                                                                                           (flip-image-diagonally (copy-image highl-m)))))
                                                 (inactive . ,(flip-image-horizontally (flip-image-vertically
                                                                                        (flip-image-diagonally (copy-image inact-m)))))
                                                 (inactive-highlighted . ,(flip-image-horizontally (flip-image-vertically
                                                                                                    (flip-image-diagonally (copy-image in-hi-m))))))))
    (when (equal w '"frame-tab")
      (table-unset styletab-c-frame-cache "left-frame-tab")
      (table-set styletab-c-frame-cache "left-frame-tab" `((focused . ,(flip-image-diagonally (copy-image focus)))
                                                           (highlighted . ,(flip-image-diagonally (copy-image highl)))
                                                           (inactive . ,(flip-image-diagonally (copy-image inact)))
                                                           (inactive-highlighted . ,(flip-image-diagonally (copy-image in-hi)))))
      (table-unset styletab-c-frame-cache "left-frame-tab-m")
      (table-set styletab-c-frame-cache "left-frame-tab-m" `((focused . ,(flip-image-diagonally (copy-image focus-m)))
                                                             (highlighted . ,(flip-image-diagonally (copy-image highl-m)))
                                                             (inactive . ,(flip-image-diagonally (copy-image inact-m)))
                                                             (inactive-highlighted . ,(flip-image-diagonally (copy-image in-hi-m)))))
      (table-unset styletab-c-frame-cache "right-frame-tab")
      (table-set styletab-c-frame-cache
                 "right-frame-tab" `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus))))
                                     (highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image highl))))
                                     (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact))))
                                     (inactive-highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image in-hi))))))
      (table-unset styletab-c-frame-cache "right-frame-tab-m")
      (table-set styletab-c-frame-cache
                 "right-frame-tab-m" `((focused . ,(flip-image-horizontally (flip-image-diagonally (copy-image focus-m))))
                                       (highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image highl-m))))
                                       (inactive . ,(flip-image-horizontally (flip-image-diagonally (copy-image inact-m))))
                                       (inactive-highlighted . ,(flip-image-horizontally (flip-image-diagonally (copy-image in-hi-m)))))))))

(define (base-button-tables-images w x)
  (let ((focus (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w x "-f.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (in-cl (do-recolor (do-make-get-image  (concat (symbol-name styletab-c:styles) "/" w x "-c.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors)))))))
        (click (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w x"-c.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark 0 styletab-c:focus-frame-color)
                             (get-recolor-dark 0 (get-color (nth 0 (proposals-colors)))))))
        (inact (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w x"-i.png"))
                           (if (eq styletab-c:custom-frame-colors t)
                               (get-recolor-dark (* styletab-c:inactive-dimout 20) styletab-c:unfocus-frame-color)
                             (get-recolor-dark (nth 1 (proposals-colors)) (get-color (nth 0 (proposals-colors))))))))
    (when (equal w '"top")
      (table-unset styletab-c-frame-cache (concat w x))
      (table-set styletab-c-frame-cache (concat w x)  `((focused . ,focus) (clicked . ,click) (inactive . ,inact) (inactive-clicked . ,in-cl)))
      (table-unset styletab-c-frame-cache (concat "bottom" x))
      (table-set styletab-c-frame-cache (concat "bottom" x)  `((focused . ,focus) (clicked . ,click) (inactive . ,inact) (inactive-clicked . ,in-cl))))

    (when (equal w '"left")
      (table-unset styletab-c-frame-cache (concat w x))
      (table-set styletab-c-frame-cache (concat w x)  `((focused . ,focus) (clicked . ,click) (inactive . ,inact) (inactive-clicked . ,in-cl)))
      (table-unset styletab-c-frame-cache (concat "right" x))
      (table-set styletab-c-frame-cache (concat "right" x) `((focused . ,(flip-image-horizontally (copy-image focus)))
                                                             (clicked . ,(flip-image-horizontally (copy-image click)))
                                                             (inactive . ,(flip-image-horizontally (copy-image inact)))
                                                             (inactive-clicked . ,(flip-image-horizontally (copy-image in-cl))))))))
(define flat-buttons nil)
(define scale-w nil)
(define scale-h nil)
(define (button-tables-images w x color always)
  (if (or (equal w '"top")
          (equal w '"bottom"))
      (progn (setq scale-w (+ styletab-c:title-dimension (button-width-custom)))
             (setq scale-h (- styletab-c:title-dimension 4)))
    (progn (setq scale-w (- styletab-c:title-dimension 4))
           (setq scale-h (+ styletab-c:title-dimension (button-width-custom)))))
  (if (eq styletab-c:styles 'Flat)
      (setq flat-buttons t))
  (let ((focus (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-f.png"))
                                        (if (eq styletab-c:custom-frame-colors t)
                                            (get-recolor-dark 0 (if (and always color) color styletab-c:focus-frame-color))
                                          (get-recolor-dark 0 (if (and always color) color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
        highl click inact in-hi in-cl)
    (when (not (eq styletab-c:styles 'Flat))
      (setq highl (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-h.png"))
                                           (if (eq styletab-c:custom-frame-colors t)
                                               (get-recolor-bright (* styletab-c:active-hightlight-brighten 20)
                                                                   (if color color styletab-c:focus-frame-color))
                                             (get-recolor-bright (nth 2 (proposals-colors))
                                                                 (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
      (setq click (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-c.png"))
                                           (if (eq styletab-c:custom-frame-colors t)
                                               (get-recolor-bright (* styletab-c:active-hightlight-brighten 20)
                                                                   (if color color styletab-c:focus-frame-color))
                                             (get-recolor-bright (nth 2 (proposals-colors))
                                                                 (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
      (setq inact (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-i.png"))
                                           (if (eq styletab-c:custom-frame-colors t)
                                               (get-recolor-dark (* styletab-c:inactive-dimout 20)
                                                                 (if (and always color) color styletab-c:unfocus-frame-color))
                                             (get-recolor-dark (nth 1 (proposals-colors))
                                                               (if (and always color) color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
      (setq in-hi (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-ih.png"))
                                           (if (eq styletab-c:custom-frame-colors t)
                                               (get-recolor-bright (- (* styletab-c:inactive-hightlight-brighten 20) (* styletab-c:inactive-dimout 20))
                                                                   (if color color styletab-c:unfocus-frame-color))
                                             (get-recolor-bright (- (nth 3 (proposals-colors)) (nth 1 (proposals-colors)))
                                                                 (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h))
      (setq in-cl (scale-image (do-recolor (do-make-get-image (concat (symbol-name styletab-c:styles) "/" w "-frame-" x "-button-ic.png"))
                                           (if (eq styletab-c:custom-frame-colors t)
                                               (get-recolor-bright (- (* styletab-c:inactive-hightlight-brighten 20) (* styletab-c:inactive-dimout 20))
                                                                   (if color color styletab-c:unfocus-frame-color))
                                             (get-recolor-bright (- (nth 3 (proposals-colors)) (nth 1 (proposals-colors)))
                                                                 (if color color (get-color (nth 0 (proposals-colors))))))) scale-w scale-h)))
    (setq flat-buttons nil)
    (if (eq styletab-c:styles 'Flat)
        (mapcar (lambda (z)
                  (table-unset styletab-c-frame-cache (concat z "-frame-" x "-button"))
                  (table-set styletab-c-frame-cache (concat z "-frame-" x "-button") `(,(copy-image focus))))
                (list "top" "bottom" "left" "right"))

      (when (equal w '"top")
        (table-unset styletab-c-frame-cache (concat "top" "-frame-" x "-button"))
        (table-set styletab-c-frame-cache (concat "top" "-frame-" x "-button") `((focused . ,focus) (highlighted . ,highl) (clicked . ,click)
                                                                                 (inactive . ,inact) (inactive-highlighted . ,in-hi)
                                                                                 (inactive-clicked . ,in-cl))))
      (when (equal w '"top")
        (table-unset styletab-c-frame-cache (concat "bottom" "-frame-" x "-button"))
        (table-set styletab-c-frame-cache (concat "bottom" "-frame-" x "-button") `((focused . ,focus) (highlighted . ,highl) (clicked . ,click)
                                                                                    (inactive . ,inact) (inactive-highlighted . ,in-hi)
                                                                                    (inactive-clicked . ,in-cl))))
      (when (equal w '"left")
        (table-unset styletab-c-frame-cache (concat "left" "-frame-" x "-button"))
        (table-set styletab-c-frame-cache (concat "left" "-frame-" x "-button") `((focused . ,focus) (highlighted . ,highl) (clicked . ,click)
                                                                                  (inactive . ,inact) (inactive-highlighted . ,in-hi)
                                                                                  (inactive-clicked . ,in-cl))))
      (when (equal w '"left")
        (table-unset styletab-c-frame-cache (concat "right" "-frame-" x "-button"))
        (table-set styletab-c-frame-cache (concat "right" "-frame-" x "-button") `((focused . ,(flip-image-horizontally (copy-image focus)))
                                                                                   (highlighted . ,(flip-image-horizontally (copy-image highl)))
                                                                                   (clicked . ,(flip-image-horizontally (copy-image click)))
                                                                                   (inactive . ,(flip-image-horizontally (copy-image inact)))
                                                                                   (inactive-highlighted . ,(flip-image-horizontally (copy-image in-hi)))
                                                                                  (inactive-clicked . ,(flip-image-horizontally (copy-image in-cl)))))))))
;; frames/tabbar
(define top-frame-icon-title-images
  (make-image (concat (symbol-name styletab-c:styles) "/" "top-frame-icon-title-images-f.png")))
(define (bottom-all-images)
  (mapcar (lambda (w) (base-tables-images (concat "bottom" w))) (list "-frame-title-cursor" "-frame-title-nocursor" "-frame-top-border"
                                                                      "-frame-top-left-corner" "-frame-top-right-corner" "-frame-left-border"
                                                                      "-frame-right-border" "-frame-bottom-left-corner-shaped"
                                                                      "-frame-bottom-right-corner-shaped" "-frame-bottom-left-corner"
                                                                      "-frame-bottom-right-corner")))
(define (base-title-corner-images)
  (mapcar (lambda (w) (build-title-corner-images w)) (list "corner" "corner-shaped")))
(define (base-cursor-images)
  (mapcar (lambda (w) (build-cursor-images w)) (list "cursor" "nocursor")))
(define (base-title-images)
  (mapcar (lambda (w) (build-title-images w)) (list "frame-title")))
(define (base-border-images)
  (mapcar (lambda (w) (build-border-images w)) (list "frame-left-border")))
(define (base-corner-images)
  (mapcar (lambda (w) (build-corner-images w)) (list "frame-bottom-left-corner")))

;; buttons
(define (base-button-images)
  (mapcar (lambda (w) (base-button-tables-images  w "-frame-button")) (list "top" "left")))
(define (close-button-images)
  (button-tables-images "top" "close" styletab-c:hightlight-close (if (eq styletab-c:hightlight-close-all t) t))
  (unless (eq styletab-c:styles 'Flat)
       (button-tables-images "left" "close" styletab-c:hightlight-close (if (eq styletab-c:hightlight-close-all t) t))))
(define (menu-button-images)
  (button-tables-images "top" "menu" styletab-c:hightlight-menu (if (eq styletab-c:hightlight-menu-all t) t))
  (unless (eq styletab-c:styles 'Flat)
       (button-tables-images "left" "menu" styletab-c:hightlight-menu (if (eq styletab-c:hightlight-menu-all t) t))))
(define (iconify-button-images)
  (button-tables-images "top" "iconify" styletab-c:hightlight-iconify (if (eq styletab-c:hightlight-iconify-all t) t))
  (unless (eq styletab-c:styles 'Flat)
       (button-tables-images "left" "iconify" styletab-c:hightlight-iconify (if (eq styletab-c:hightlight-iconify-all t) t))))
(define (move-resize-button-images)
  (button-tables-images "top" "move-resize" styletab-c:hightlight-move-resize (if (eq styletab-c:hightlight-move-resize-all t) t))
  (unless (eq styletab-c:styles 'Flat)
       (button-tables-images "left" "move-resize" styletab-c:hightlight-move-resize (if (eq styletab-c:hightlight-move-resize-all t) t))))
(define (rename-button-images)
  (button-tables-images "top" "rename" styletab-c:hightlight-rename (if (eq styletab-c:hightlight-rename-all t) t))
  (unless (eq styletab-c:styles 'Flat)
       (button-tables-images "left" "rename" styletab-c:hightlight-rename (if (eq styletab-c:hightlight-rename-all t) t))))
(define (frame-type-button-images)
  (button-tables-images "top" "frame-type" styletab-c:hightlight-frame-type (if (eq styletab-c:hightlight-frame-type-all t) t))
  (unless (eq styletab-c:styles 'Flat)
       (button-tables-images "left" "frame-type" styletab-c:hightlight-frame-type (if (eq styletab-c:hightlight-frame-type-all t) t))))
(define (maximize-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-maximize
                                            (if (eq styletab-c:hightlight-maximize-all t) t))) (list "maximize" "unmaximize"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-maximize
                                                 (if (eq styletab-c:hightlight-maximize-all t) t))) (list "maximize" "unmaximize"))))
(define (shade-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-shade
                                            (if (eq styletab-c:hightlight-shade-all t) t))) (list "shade" "unshade"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-shade
                                                 (if (eq styletab-c:hightlight-shade-all t) t))) (list "shade" "unshade"))))
(define (sticky-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-sticky
                                            (if (eq styletab-c:hightlight-sticky-all t) t))) (list "sticky" "unsticky"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-sticky
                                                 (if (eq styletab-c:hightlight-sticky-all t) t))) (list "sticky" "unsticky"))))
(define (lock-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-lock
                                            (if (eq styletab-c:hightlight-lock-all t) t))) (list "lock" "unlock"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-lock
                                                 (if (eq styletab-c:hightlight-lock-all t) t))) (list "lock" "unlock"))))
(define (prev-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-prev
                                            (if (eq styletab-c:hightlight-prev-all t) t))) (list "prev" "prev-last"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-prev
                                                 (if (eq styletab-c:hightlight-prev-all t) t))) (list "prev" "prev-last"))))
(define (next-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-next
                                            (if (eq styletab-c:hightlight-next-all t) t))) (list "next" "next-last"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-next
                                                 (if (eq styletab-c:hightlight-next-all t) t))) (list "next" "next-last"))))
(define (raise-lower-button-images)
  (mapcar (lambda (w) (button-tables-images "top" w styletab-c:hightlight-raise-lower
                                            (if (eq styletab-c:hightlight-raise-lower-all t) t))) (list "raise-lower" "ontop" "unontop"))
  (unless (eq styletab-c:styles 'Flat)
       (mapcar (lambda (w) (button-tables-images "left" w styletab-c:hightlight-raise-lower
                                                 (if (eq styletab-c:hightlight-raise-lower-all t) t))) (list "raise-lower" "ontop" "unontop"))))

(define (recolor-base) (base-title-corner-images) (base-cursor-images) (base-title-images) (base-button-images) (base-border-images) (base-corner-images)
        (bottom-all-images))
(define (recolor-tab)
  (mapcar (lambda (w) (mapcar (lambda (x)
                                (tab-tables-images x w)) (list "top"))) (list "frame-tab-left-icon" "frame-tab" "frame-tab-right")))
(define (recolor-close-button)
  (close-button-images))
(define (recolor-menu-button)
  (menu-button-images))
(define (recolor-iconify-button)
  (iconify-button-images))
(define (recolor-move-resize-button)
  (move-resize-button-images))
(define (recolor-rename-button)
  (rename-button-images))
(define (recolor-frame-type-button)
  (frame-type-button-images))
(define (recolor-maximize-button)
  (maximize-button-images))
(define (recolor-shade-button)
  (shade-button-images))
(define (recolor-sticky-button)
  (sticky-button-images))
(define (recolor-lock-button)
  (lock-button-images))
(define (recolor-prev-button)
  (prev-button-images))
(define (recolor-next-button)
  (next-button-images))
(define (recolor-raise-lower-button)
  (raise-lower-button-images))

(define (recolor-all-buttons)
  (recolor-close-button) (recolor-menu-button) (recolor-iconify-button) (recolor-move-resize-button)
  (recolor-rename-button) (recolor-frame-type-button) (recolor-maximize-button) (recolor-shade-button)
  (recolor-sticky-button) (recolor-lock-button) (recolor-prev-button) (recolor-next-button) (recolor-raise-lower-button))

(define (recolor-all)
  (recolor-base) (recolor-tab) (recolor-all-buttons))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; frames classes
(defmacro window-in-workspace-p (w space)
  `(memq ,space (window-get ,w 'workspaces)))

(define (get-first-workspace) 1)

(define (get-last-workspace)
  (aref
   (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS)) 0))

(define frame-width
  (lambda (w)
    (if (or (eq (window-type w) 'default)
			(eq (window-type w) 'transient))
        styletab-c:borders-dimension
      0)))

(define frame-edge
  (lambda (w)
    (if (or (eq (window-type w) 'default)
            (eq (window-type w) 'transient))
        (- styletab-c:borders-dimension)
      0)))

(define sharped-edge
  (lambda (w)
    (if (or (eq (window-get w 'type) 'shaped)
            (eq (window-get w 'type) 'shaped-transient))
        styletab-c:borders-dimension
      0)))

(define title-height (lambda (w) styletab-c:title-dimension))
(define title-height-s (lambda (w) (- styletab-c:title-dimension 4)))
(define title-edge (lambda (w) (- styletab-c:title-dimension)))
(define title-edge-s (lambda (w) (- (- styletab-c:title-dimension 2))))
(define top-frame-button-width (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))
(define bottom-frame-button-width (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))
(define left-frame-button-height (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))
(define right-frame-button-height (lambda (w) (+ styletab-c:title-dimension (button-width-custom))))

(define top-frame-default-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (left-edge . 0)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-top-left-corner")))
     (left-edge . ,frame-edge)
     (top-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-top-right-corner")))
     (top-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (right-edge . 0)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define bottom-frame-default-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (left-edge . 0)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-bottom-left-corner")))
     (left-edge . ,frame-edge)
     (bottom-edge . ,title-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-bottom-right-corner")))
     (bottom-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,frame-width))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (right-edge . 0)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define left-frame-default-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (top-edge . 0)
     (left-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-top-left-corner")))
     (top-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-bottom-left-corner")))
     (bottom-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (bottom-edge . 0)
     (left-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))))

(define right-frame-default-border-corner-group
  `(((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (top-edge . 0)
     (right-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-top-right-corner")))
     (top-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-bottom-right-corner")))
     (bottom-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,frame-width)
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (bottom-edge . 0)
     (right-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))))

(define top-frame-border-group
  `(((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-left-border")))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (top-edge . 0)
     (width . ,frame-width)
     (bottom-edge . 0))
	((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-bottom-left-corner")))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-bottom-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-bottom-right-corner")))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-right-border")))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))))

(define bottom-frame-border-group
  `(((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-left-border")))
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (bottom-edge . 0)
     (width . ,frame-width)
     (top-edge . 0))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-top-left-corner")))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-top-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-top-right-corner")))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (top-edge . ,frame-edge))
    ((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-right-border")))
     (cursor . sb_h_double_arrow)
     (bottom-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (top-edge . 0))))

(define left-frame-border-group
  `(((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-bottom-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-bottom-right-corner")))
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-right-border")))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-top-right-corner")))
     (top-edge . ,frame-edge)
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width))
    ((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-top-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))))

(define right-frame-border-group
  `(((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-bottom-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-bottom-left-corner")))
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
    ((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-left-border")))
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (left-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))
    ((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-top-left-corner")))
     (top-edge . ,frame-edge)
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width))
    ((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-top-border")))
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (top-edge . ,frame-edge))))

(define top-frame-title-group
  `(((class . top-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title-cursor")))
     (cursor . sb_v_double_arrow)
     (left-edge . ,sharped-edge)
     (top-edge . ,title-edge)
     (right-edge . ,sharped-edge)
     (height . 2))
    ((class . tabbar-horizontal)
     (x-justify . ,(lambda (w) (- styletab-c:title-dimension 12)))
     (y-justify . ,(lambda (w) (+ (/ styletab-c:title-dimension 2) -7)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"top-frame-tab-m")
                                  (table-ref styletab-c-frame-cache '"top-frame-tab"))))
     (foreground . ,title-colors-images)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (text . ,window-name))
    ((class . tabbar-horizontal-left-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"top-frame-tab-left-icon-m")
                                  (table-ref styletab-c-frame-cache '"top-frame-tab-left-icon"))))
     (cursor . hand2)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,(lambda (w) (+ 2 (title-height-s w))))
     (y-justify . 2)
     (x-justify . ,(lambda (w) (+ 3 (icon-edge w)))))
    ((class . tabbar-horizontal-right-edge)
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"top-frame-tab-right-m")
                                  (table-ref styletab-c-frame-cache '"top-frame-tab-right"))))
     (width . ,tabbar-right-edge-width)
     (height . ,title-height-s)
     (top-edge . ,title-edge-s))
    ((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title-nocursor")))
     (left-edge . ,sharped-edge)
     (top-edge . -2)
     (right-edge . ,sharped-edge)
     (height . 2))))

(define bottom-frame-title-group
  `(((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title-nocursor")))
     (left-edge . ,sharped-edge)
     (bottom-edge . -2)
     (right-edge . ,sharped-edge)
     (height . 2))
    ((class . tabbar-horizontal)
     (x-justify . ,(lambda (w) (- styletab-c:title-dimension 12)))
     (y-justify . ,(lambda (w) (+ (/ styletab-c:title-dimension 2) -7)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"bottom-frame-tab-m")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-tab"))))
     (foreground . ,title-colors-images)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (text . ,window-name))
    ((class . tabbar-horizontal-left-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"bottom-frame-tab-left-icon-m")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-tab-left-icon"))))
     (cursor . hand2)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,(lambda (w) (+ 2 (title-height-s w))))
     (y-justify . 2)
     (x-justify . ,(lambda (w) (+ 3 (icon-edge w)))))
    ((class . tabbar-horizontal-right-edge)
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"bottom-frame-tab-right-m")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-tab-right"))))
     (width . ,tabbar-right-edge-width)
     (height . ,title-height-s)
     (bottom-edge . ,title-edge-s))
    ((class . bottom-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title-cursor")))
     (cursor . sb_v_double_arrow)
     (left-edge . ,sharped-edge)
     (bottom-edge . ,title-edge)
     (right-edge . ,sharped-edge)
     (height . 2))))

(define left-frame-title-group
  `(((class . left-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title-cursor")))
     (cursor . sb_h_double_arrow)
     (top-edge . ,sharped-edge)
     (left-edge . ,title-edge)
     (bottom-edge . ,sharped-edge)
     (width . 2))
    ((class . tabbar-vertical-top-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"left-frame-tab-top-m")
                                  (table-ref styletab-c-frame-cache '"left-frame-tab-top"))))
     (cursor . hand2)
     (height . ,(lambda (w) (+ 2 (title-height-s w))))
     (width . ,title-height-s)
     (left-edge . ,title-edge-s)
     (y-justify . ,(lambda (w) (+ 2 (icon-edge w))))
     (x-justify . 2))
    ((class . tabbar-vertical)
     (x-justify . 12)
     (y-justify . center)
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"left-frame-tab-m")
                                  (table-ref styletab-c-frame-cache '"left-frame-tab"))))
     (left-edge . ,title-edge-s)
     (width . ,title-height-s))
    ((class . tabbar-vertical-bottom-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"left-frame-tab-bottom-icon-m")
                                  (table-ref styletab-c-frame-cache '"left-frame-tab-bottom-icon"))))
     (left-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . ,(lambda (w) (- (+ 0 (icon-edge w)))))
     (x-justify . 2))
    ((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title-nocursor")))
     (top-edge . ,sharped-edge)
     (left-edge . -2)
     (bottom-edge . ,sharped-edge)
     (width . 2))))

(define right-frame-title-group
  `(((class . right-border)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title-cursor")))
     (cursor . sb_h_double_arrow)
     (top-edge . ,sharped-edge)
     (right-edge . ,title-edge)
     (bottom-edge . ,sharped-edge)
     (width . 2))
    ((class . tabbar-vertical-top-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"right-frame-tab-top-m")
                                  (table-ref styletab-c-frame-cache '"right-frame-tab-top"))))
     (cursor . hand2)
     (height . ,(lambda (w) (+ 2 (title-height-s w))))
     (width . ,title-height-s)
     (right-edge . ,title-edge-s)
     (y-justify . ,(lambda (w) (+ 2 (icon-edge w))))
     (x-justify . 2))
    ((class . tabbar-vertical)
     (x-justify . 12)
     (y-justify . center)
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"right-frame-tab-m")
                                  (table-ref styletab-c-frame-cache '"right-frame-tab"))))
     (right-edge . ,title-edge-s)
     (width . ,title-height-s))
    ((class . tabbar-vertical-bottom-edge)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,(lambda (w) (if (window-get w 'marked)
                                    (table-ref styletab-c-frame-cache '"right-frame-tab-bottom-icon-m")
                                  (table-ref styletab-c-frame-cache '"right-frame-tab-bottom-icon"))))
     (right-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,title-height-s)
     (y-justify . ,(lambda (w) (- (+ 0 (icon-edge w)))))
     (x-justify . 2))
    ((class . title)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title-nocursor")))
     (top-edge . ,sharped-edge)
     (right-edge . -2)
     (bottom-edge . ,sharped-edge)
     (width . 2))))

(define top-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-close-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-close-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-close-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-close-button
  `((class . close-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-close-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-menu-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-menu-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-menu-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-menu-button
  `((class . menu-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-menu-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-iconify-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-iconify-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-iconify-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-iconify-button
  `((class . iconify-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-iconify-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry)
                                   (table-ref styletab-c-frame-cache '"top-frame-unmaximize-button")
                                 (table-ref styletab-c-frame-cache '"top-frame-maximize-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry)
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unmaximize-button")
                                 (table-ref styletab-c-frame-cache '"bottom-frame-maximize-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry)
                                   (table-ref styletab-c-frame-cache '"left-frame-unmaximize-button")
                                 (table-ref styletab-c-frame-cache '"left-frame-maximize-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-maximize-button
  `((class . maximize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'unmaximized-geometry)
                                   (table-ref styletab-c-frame-cache '"right-frame-unmaximize-button")
                                 (table-ref styletab-c-frame-cache '"right-frame-maximize-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded)
                                   (table-ref styletab-c-frame-cache '"top-frame-unshade-button")
                                 (table-ref styletab-c-frame-cache '"top-frame-shade-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded)
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unshade-button")
                                 (table-ref styletab-c-frame-cache '"bottom-frame-shade-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded)
                                   (table-ref styletab-c-frame-cache '"left-frame-unshade-button")
                                 (table-ref styletab-c-frame-cache '"left-frame-shade-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-shade-button
  `((class . shade-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (window-get w 'shaded)
                                   (table-ref styletab-c-frame-cache '"right-frame-unshade-button")
                                 (table-ref styletab-c-frame-cache '"right-frame-shade-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'sticky)
                                       (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"top-frame-unsticky-button")
                                 (table-ref styletab-c-frame-cache '"top-frame-sticky-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'sticky)
                                       (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unsticky-button")
                                 (table-ref styletab-c-frame-cache '"bottom-frame-sticky-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'sticky)
                                       (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"left-frame-unsticky-button")
                                 (table-ref styletab-c-frame-cache '"left-frame-sticky-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-sticky-button
  `((class . sticky-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'sticky)
                                       (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"right-frame-unsticky-button")
                                 (table-ref styletab-c-frame-cache '"right-frame-sticky-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-space-button
  `((class . title)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"top-frame-prev-last-button")
                                 (table-ref styletab-c-frame-cache '"top-frame-prev-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"bottom-frame-prev-last-button")
                                 (table-ref styletab-c-frame-cache '"bottom-frame-prev-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"left-frame-prev-last-button")
                                 (table-ref styletab-c-frame-cache '"left-frame-prev-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-prev-button
  `((class . previous-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-first-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"right-frame-prev-last-button")
                                 (table-ref styletab-c-frame-cache '"right-frame-prev-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"top-frame-next-last-button")
                                 (table-ref styletab-c-frame-cache '"top-frame-next-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"bottom-frame-next-last-button")
                                 (table-ref styletab-c-frame-cache '"bottom-frame-next-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"left-frame-next-last-button")
                                 (table-ref styletab-c-frame-cache '"left-frame-next-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-next-button
  `((class . next-workspace-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-in-workspace-p w (- (get-last-workspace) 1)) (window-get w 'sticky) (window-get w 'sticky-viewport))
                                   (table-ref styletab-c-frame-cache '"right-frame-next-last-button")
                                 (table-ref styletab-c-frame-cache '"right-frame-next-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'fixed-position)
                                       (window-get w 'fixed-size))
                                   (table-ref styletab-c-frame-cache '"top-frame-unlock-button")
                                 (table-ref styletab-c-frame-cache '"top-frame-lock-button"))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'fixed-position)
                                       (window-get w 'fixed-size))
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unlock-button")
                                 (table-ref styletab-c-frame-cache '"bottom-frame-lock-button"))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'fixed-position)
                                       (window-get w 'fixed-size))
                                   (table-ref styletab-c-frame-cache '"left-frame-unlock-button")
                                 (table-ref styletab-c-frame-cache '"left-frame-lock-button"))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-lock-button
  `((class . lock-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (or (window-get w 'fixed-position)
                                       (window-get w 'fixed-size))
                                   (table-ref styletab-c-frame-cache '"right-frame-unlock-button")
                                 (table-ref styletab-c-frame-cache '"right-frame-lock-button"))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"top-frame-raise-lower-button")
                                 (if (> (window-get w 'depth) 0)
                                     (table-ref styletab-c-frame-cache '"top-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"top-frame-unontop-button")))))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"bottom-frame-raise-lower-button")
                                 (if (> (window-get w 'depth) 0)
                                     (table-ref styletab-c-frame-cache '"bottom-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"bottom-frame-unontop-button")))))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"left-frame-raise-lower-button")
                                 (if (> (window-get w 'depth) 0)
                                     (table-ref styletab-c-frame-cache '"left-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"left-frame-unontop-button")))))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-raise-lower-button
  `((class . raise-lower-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (if (= (window-get w 'depth) 0) (table-ref styletab-c-frame-cache '"right-frame-raise-lower-button")
                                 (if (> (window-get w 'depth) 0)
                                     (table-ref styletab-c-frame-cache '"right-frame-ontop-button")
                                   (table-ref styletab-c-frame-cache '"right-frame-unontop-button")))))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define  top-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-move-resize-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define  bottom-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-move-resize-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define  left-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-move-resize-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define  right-frame-move-resize-button
  `((class . move-resize-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-move-resize-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-rename-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-rename-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-rename-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-rename-button
  `((class . rename-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-rename-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-frame-type-button")))
    (cursor . hand2)
    (top-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,top-frame-button-width)))

(define bottom-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-frame-type-button")))
    (cursor . hand2)
    (bottom-edge . ,title-edge-s)
    (height . ,title-height-s)
    (width . ,bottom-frame-button-width)))

(define left-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-frame-type-button")))
    (cursor . hand2)
    (left-edge . ,title-edge-s)
    (height . ,left-frame-button-height)
    (width . ,title-height-s)))

(define right-frame-frame-type-button
  `((class . frame-type-button)
    (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-button")))
    (foreground . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-frame-type-button")))
    (cursor . hand2)
    (right-edge . ,title-edge-s)
    (height . ,right-frame-button-height)
    (width . ,title-height-s)))

(define top-frame-shaped-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (left-edge . ,sharped-edge)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . top-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"top-frame-top-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"top-frame-top-left-corner"))))
     (left-edge . ,frame-edge)
     (top-edge . ,title-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . top-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"top-frame-top-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"top-frame-top-right-corner"))))
     (top-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"top-frame-title")))
     (right-edge . ,sharped-edge)
     (top-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define bottom-frame-shaped-border-corner-group
  `(((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (left-edge . ,sharped-edge)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-left-edge))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"bottom-frame-bottom-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-bottom-left-corner"))))
     (left-edge . ,frame-edge)
     (bottom-edge . ,title-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"bottom-frame-bottom-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"bottom-frame-bottom-right-corner"))))
     (bottom-edge . ,title-edge)
     (right-edge . ,frame-edge)
     (height . ,title-height)
     (width . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                   (eq (window-get w 'type) 'shaped-transient))
                               styletab-c:borders-dimension
                             (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge)))))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"bottom-frame-title")))
     (right-edge . ,sharped-edge)
     (bottom-edge . ,title-edge-s)
     (height . ,title-height-s)
     (width . ,button-right-edge))))

(define left-frame-shaped-border-corner-group
  `(((class . top-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (top-edge . ,sharped-edge)
     (left-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))
    ((class . top-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"left-frame-top-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"left-frame-top-left-corner"))))
     (top-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"left-frame-bottom-left-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"left-frame-bottom-left-corner"))))
     (bottom-edge . ,frame-edge)
     (left-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-left-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"left-frame-title")))
     (bottom-edge . ,sharped-edge)
     (left-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))))

(define right-frame-shaped-border-corner-group
  `(((class . top-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (top-edge . ,sharped-edge)
     (right-edge . ,title-edge-s)
     (height . ,button-left-edge)
     (width . ,title-height-s))
    ((class . top-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"right-frame-top-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"right-frame-top-right-corner"))))
     (top-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (if (window-get w 'shaded)
                                    (table-ref styletab-c-frame-cache '"right-frame-bottom-right-corner-shaped")
                                  (table-ref styletab-c-frame-cache '"right-frame-bottom-right-corner"))))
     (bottom-edge . ,frame-edge)
     (right-edge . ,title-edge)
     (height . ,(lambda (w) (if (or (eq (window-get w 'type) 'shaped)
                                    (eq (window-get w 'type) 'shaped-transient))
                                styletab-c:borders-dimension
                              (if (window-get w 'shaded) styletab-c:borders-dimension sharped-edge))))
     (width . ,title-height))
    ((class . bottom-right-corner)
     (background . ,(lambda (w) (table-ref styletab-c-frame-cache '"right-frame-title")))
     (bottom-edge . ,sharped-edge)
     (right-edge . ,title-edge-s)
     (height . ,button-right-edge)
     (width . ,title-height-s))))

(define top-button-alist
  `((close  . ,top-frame-close-button)
    (menu   . ,top-frame-menu-button)
    (minimize   . ,top-frame-iconify-button)
    (maximize   . ,top-frame-maximize-button)
    (shade  . ,top-frame-shade-button)
    (sticky . ,top-frame-sticky-button)
    (space . ,top-frame-space-button)
    (send-to-prev . ,top-frame-prev-button)
    (send-to-next . ,top-frame-next-button)
    (lock . ,top-frame-lock-button)
    (raise-lower . ,top-frame-raise-lower-button)
    (move-resize . ,top-frame-move-resize-button)
    (rename . ,top-frame-rename-button)
    (frame-type . ,top-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define bottom-button-alist
  `((close  . ,bottom-frame-close-button)
    (menu   . ,bottom-frame-menu-button)
    (minimize   . ,bottom-frame-iconify-button)
    (maximize   . ,bottom-frame-maximize-button)
    (shade  . ,bottom-frame-shade-button)
    (sticky . ,bottom-frame-sticky-button)
    (space . ,bottom-frame-space-button)
    (send-to-prev . ,bottom-frame-prev-button)
    (send-to-next . ,bottom-frame-next-button)
    (lock . ,bottom-frame-lock-button)
    (raise-lower . ,bottom-frame-raise-lower-button)
    (move-resize . ,bottom-frame-move-resize-button)
    (rename . ,bottom-frame-rename-button)
    (frame-type . ,bottom-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define left-button-alist
  `((close  . ,left-frame-close-button)
    (menu   . ,left-frame-menu-button)
    (minimize   . ,left-frame-iconify-button)
    (maximize   . ,left-frame-maximize-button)
    (shade  . ,left-frame-shade-button)
    (sticky . ,left-frame-sticky-button)
    (space . ,left-frame-space-button)
    (send-to-prev . ,left-frame-prev-button)
    (send-to-next . ,left-frame-next-button)
    (lock . ,left-frame-lock-button)
    (raise-lower . ,left-frame-raise-lower-button)
    (move-resize . ,left-frame-move-resize-button)
    (rename . ,left-frame-rename-button)
    (frame-type . ,left-frame-frame-type-button)
    (\(none\)   . ,nil)))

(define right-button-alist
  `((close  . ,right-frame-close-button)
    (menu   . ,right-frame-menu-button)
    (minimize   . ,right-frame-iconify-button)
    (maximize   . ,right-frame-maximize-button)
    (shade  . ,right-frame-shade-button)
    (sticky . ,right-frame-sticky-button)
    (space . ,right-frame-space-button)
    (send-to-prev . ,right-frame-prev-button)
    (send-to-next . ,right-frame-next-button)
    (lock . ,right-frame-lock-button)
    (raise-lower . ,right-frame-raise-lower-button)
    (move-resize . ,right-frame-move-resize-button)
    (rename . ,right-frame-rename-button)
    (frame-type . ,right-frame-frame-type-button)
    (\(none\)   . ,nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; build themes

(define frame nil)
(define button-alist nil)
(define current-title styletab-c:titlebar-place)
(define current-type nil)

;; botton list table
(define styletab-c-botton-cache (make-table equal-hash equal))

(define (make-buttons)
  (setq styletab-c-botton-cache (make-weak-table equal-hash equal))
  ;; ripped from Anonymous
  (let* (;; turns one cons cell (btn-name . show-in-transients) into a button
         ;; definition, adding the button position
         (make-button
          (lambda (is-trans btn edge pos)
            (let ((btn-def  (cdr (assq (car btn) button-alist)))
                  (btn-in-trans (last btn)))
              (if (or (null btn-def) (and is-trans (not btn-in-trans)))
                  nil
                (cons (cons edge pos) btn-def)))))

         ;; turns the list of cons cells (btn-name . show-in-transients) into
         ;; a list of button definitions, adding the button positions
         (make-button-list
          (lambda (is-trans btn-list edge pos-start pos-inc)
            (let loop ((rest btn-list) (pos pos-start) (result ()))
              (if (null rest)
                  result
                (let ((new-btn (make-button is-trans (car rest) edge pos)))
                  (if (null new-btn)
                      (loop (cdr rest) pos result)
                    (loop (cdr rest) (+ pos pos-inc) (append (list new-btn) result))))))))

         (setalist (setq button-alist top-button-alist))
         (top-normal-buttons-left
          (make-button-list nil styletab-c:top-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-normal-buttons-left-s
          (make-button-list nil styletab-c:top-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (top-normal-buttons-right
          (make-button-list nil styletab-c:top-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-normal-buttons-right-s
          (make-button-list nil styletab-c:top-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-left
          (make-button-list t styletab-c:top-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-left-s
          (make-button-list t styletab-c:top-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-right
          (make-button-list t styletab-c:top-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (top-transient-buttons-right-s
          (make-button-list t styletab-c:top-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))

         (setalist (setq button-alist bottom-button-alist))
         (bottom-normal-buttons-left
          (make-button-list nil styletab-c:bottom-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-normal-buttons-left-s
          (make-button-list nil styletab-c:bottom-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-normal-buttons-right
          (make-button-list nil styletab-c:bottom-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-normal-buttons-right-s
          (make-button-list nil styletab-c:bottom-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-left
          (make-button-list t styletab-c:bottom-left-buttons 'left-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-left-s
          (make-button-list t styletab-c:bottom-left-buttons 'left-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-right
          (make-button-list t styletab-c:bottom-right-buttons 'right-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (bottom-transient-buttons-right-s
          (make-button-list t styletab-c:bottom-right-buttons 'right-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))

         (setalist (setq button-alist left-button-alist))
         (left-normal-buttons-top
          (make-button-list nil styletab-c:left-top-buttons 'top-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-normal-buttons-top-s
          (make-button-list nil styletab-c:left-top-buttons 'top-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (left-normal-buttons-bottom
          (make-button-list nil styletab-c:left-bottom-buttons 'bottom-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-normal-buttons-bottom-s
          (make-button-list nil styletab-c:left-bottom-buttons 'bottom-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-top
          (make-button-list t styletab-c:left-top-buttons 'top-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-top-s
          (make-button-list t styletab-c:left-top-buttons 'top-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-bottom
          (make-button-list t styletab-c:left-bottom-buttons 'bottom-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (left-transient-buttons-bottom-s
          (make-button-list t styletab-c:left-bottom-buttons 'bottom-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))

         (setalist (setq button-alist right-button-alist))
         (right-normal-buttons-top
          (make-button-list nil styletab-c:right-top-buttons 'top-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-normal-buttons-top-s
          (make-button-list nil styletab-c:right-top-buttons 'top-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (right-normal-buttons-bottom
          (make-button-list nil styletab-c:right-bottom-buttons 'bottom-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-normal-buttons-bottom-s
          (make-button-list nil styletab-c:right-bottom-buttons 'bottom-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-top
          (make-button-list t styletab-c:right-top-buttons 'top-edge (+ (button-left-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-top-s
          (make-button-list t styletab-c:right-top-buttons 'top-edge (button-left-edge) (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-bottom
          (make-button-list t styletab-c:right-bottom-buttons 'bottom-edge (+ (button-right-edge) styletab-c:borders-dimension)
                            (+ styletab-c:title-dimension (button-width-custom))))
         (right-transient-buttons-bottom-s
          (make-button-list t styletab-c:right-bottom-buttons 'bottom-edge (button-right-edge) (+ styletab-c:title-dimension (button-width-custom)))))

    (table-set styletab-c-botton-cache "top-normal-buttons-left" top-normal-buttons-left)
    (table-set styletab-c-botton-cache "top-normal-buttons-left-s" top-normal-buttons-left-s)
    (table-set styletab-c-botton-cache "top-normal-buttons-right" top-normal-buttons-right)
    (table-set styletab-c-botton-cache "top-normal-buttons-right-s" top-normal-buttons-right-s)
    (table-set styletab-c-botton-cache "top-transient-buttons-left" top-transient-buttons-left)
    (table-set styletab-c-botton-cache "top-transient-buttons-left-s" top-transient-buttons-left-s)
    (table-set styletab-c-botton-cache "top-transient-buttons-right" top-transient-buttons-right)
    (table-set styletab-c-botton-cache "top-transient-buttons-right-s" top-transient-buttons-right-s)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-left" bottom-normal-buttons-left)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-left-s" bottom-normal-buttons-left-s)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-right" bottom-normal-buttons-right)
    (table-set styletab-c-botton-cache "bottom-normal-buttons-right-s" bottom-normal-buttons-right-s)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-left" bottom-transient-buttons-left)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-left-s" bottom-transient-buttons-left-s)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-right" bottom-transient-buttons-right)
    (table-set styletab-c-botton-cache "bottom-transient-buttons-right-s" bottom-transient-buttons-right-s)
    (table-set styletab-c-botton-cache "left-normal-buttons-top" left-normal-buttons-top)
    (table-set styletab-c-botton-cache "left-normal-buttons-top-s" left-normal-buttons-top-s)
    (table-set styletab-c-botton-cache "left-normal-buttons-bottom" left-normal-buttons-bottom)
    (table-set styletab-c-botton-cache "left-normal-buttons-bottom-s" left-normal-buttons-bottom-s)
    (table-set styletab-c-botton-cache "left-transient-buttons-top" left-transient-buttons-top)
    (table-set styletab-c-botton-cache "left-transient-buttons-top-s" left-transient-buttons-top-s)
    (table-set styletab-c-botton-cache "left-transient-buttons-bottom" left-transient-buttons-bottom)
    (table-set styletab-c-botton-cache "left-transient-buttons-bottom-s" left-transient-buttons-bottom-s)
    (table-set styletab-c-botton-cache "right-normal-buttons-top" right-normal-buttons-top)
    (table-set styletab-c-botton-cache "right-normal-buttons-top-s" right-normal-buttons-top-s)
    (table-set styletab-c-botton-cache "right-normal-buttons-bottom" right-normal-buttons-bottom)
    (table-set styletab-c-botton-cache "right-normal-buttons-bottom-s" right-normal-buttons-bottom-s)
    (table-set styletab-c-botton-cache "right-transient-buttons-top" right-transient-buttons-top)
    (table-set styletab-c-botton-cache "right-transient-buttons-top-s" right-transient-buttons-top-s)
    (table-set styletab-c-botton-cache "right-transient-buttons-bottom" right-transient-buttons-bottom)
    (table-set styletab-c-botton-cache "right-transient-buttons-bottom-s" right-transient-buttons-bottom-s)))

(define (adjustments-tabbar w)
  (let ((tab-adjustments (table-ref styletab-c-botton-cache w)))
    (if (numberp (cdr (car (car tab-adjustments))))
        (+ (cdr (car (car tab-adjustments))) (+ styletab-c:title-dimension (button-width-custom))) 0)))

(define (check-sharped w)
  (if (or (eq current-type 'shaped)
          (eq current-type 'shaped-transient))
      w (concat w "-s")))

(define (make-frame w type current-title)
  (setq current-type (window-get w 'type))
  (require 'sawfish.wm.tabs.tab)
  (when (eq current-title 'top)
    (update-title-x-offsets `(,(- styletab-c:title-dimension 12) . 0))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (tabbar-right-edge-width)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"top-normal-buttons-left"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"top-normal-buttons-right"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"top-transient-buttons-left"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"top-transient-buttons-right")))
    (when (eq type 'normal-frame)
      (setq frame (append top-frame-title-group top-frame-default-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-left"))
                          top-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-right")))))
    (when (eq type 'transient-frame)
      (setq frame (append top-frame-title-group top-frame-default-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-left"))
                          top-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-right")))))
    (when (eq type 'shaped-frame)
      (setq frame (append top-frame-title-group top-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"top-normal-buttons-right")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append top-frame-title-group top-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"top-transient-buttons-right"))))))

  (when (eq current-title 'bottom)
    (update-title-x-offsets `(,(- styletab-c:title-dimension 12) . 0))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (tabbar-right-edge-width)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"bottom-normal-buttons-left"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"bottom-normal-buttons-right"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"bottom-transient-buttons-left"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"bottom-transient-buttons-right")))
    (when (eq type 'normal-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-default-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-left"))
                          bottom-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-right")))))
    (when (eq type 'transient-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-default-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-left"))
                          bottom-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-right")))))
    (when (eq type 'shaped-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-normal-buttons-right")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append bottom-frame-title-group bottom-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-left"))
                          (table-ref styletab-c-botton-cache (check-sharped '"bottom-transient-buttons-right"))))))

  (when (eq current-title 'left)
    (update-title-x-offsets '(11 . -11))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (- styletab-c:title-dimension 2)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"left-normal-buttons-bottom"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"left-normal-buttons-top"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"left-transient-buttons-bottom"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"left-transient-buttons-top")))
    (when (eq type 'normal-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-bottom"))
                          left-frame-default-border-corner-group left-frame-border-group
                          (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-top")))))
    (when (eq type 'transient-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-bottom"))
                          left-frame-default-border-corner-group
                          left-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-top")))))
    (when (eq type 'shaped-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-bottom"))
                          left-frame-shaped-border-corner-group (table-ref styletab-c-botton-cache (check-sharped '"left-normal-buttons-top")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append left-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-bottom"))
                          left-frame-shaped-border-corner-group (table-ref styletab-c-botton-cache (check-sharped '"left-transient-buttons-top"))))))

  (when (eq current-title 'right)
    (update-title-x-offsets '(11 . -11))
    (set-tab-adjustments #:theme-left-dec-width 11 #:theme-right-dec-width (- styletab-c:title-dimension 2)
                         #:theme-left-margin (adjustments-tabbar (check-sharped '"right-normal-buttons-bottom"))
                         #:theme-right-margin (adjustments-tabbar (check-sharped '"right-normal-buttons-top"))
                         #:theme-left-margin-transient (adjustments-tabbar (check-sharped '"right-transient-buttons-bottom"))
                         #:theme-right-margin-transient (adjustments-tabbar (check-sharped '"right-transient-buttons-top")))
    (when (eq type 'normal-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-bottom"))
                          right-frame-default-border-corner-group
                          right-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-top")))))
    (when (eq type 'transient-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-bottom"))
                          right-frame-default-border-corner-group
                          right-frame-border-group (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-top")))))
    (when (eq type 'shaped-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-bottom"))
                          right-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"right-normal-buttons-top")))))
    (when (eq type 'shaped-transient-frame)
      (setq frame (append right-frame-title-group (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-bottom"))
                          right-frame-shaped-border-corner-group
                          (table-ref styletab-c-botton-cache (check-sharped '"right-transient-buttons-top"))))))
  frame)

(define (make-buttons-reframe-with-style)
  (make-buttons)
  (reframe-windows-with-style theme-name))

(define (reframe-with-style)
  (reframe-windows-with-style theme-name))

(define (reframe-one w)
  (when (not (window-get w 'tabbed))
    (when (eq (window-get w 'current-frame-style) theme-name)
      (reframe-window w))))

(define (reframe-marked w)
  (when (eq (window-get w 'current-frame-style) theme-name)
    (reframe-window w)))

;; reframe-with-style, resize bottons
;; reset icon cache
(define (clear-icon-cache-reframe)
  (when (not start-lock)
    (recolor-all-buttons)
    (setq styletab-c-icon-cache (make-weak-table eq-hash eq))
    (make-buttons)
    (reframe-with-style)))

(define (color-changed)
  (when (not start-lock)
    (recolor-all)
    (reframe-with-style)))

(define (bright-changed)
  (when (not start-lock)
    (recolor-tab)
    (recolor-all-buttons)
    (reframe-with-style)))

(define (botton-color-changed botton)
  (when (not start-lock)
    (botton)
    (reframe-with-style)))

(define (build-style)
  (when (not start-lock)
    (recolor-all)
    (make-buttons)
    (reframe-with-style)))

(define (frame-style-name w)
  (when (eq (window-get w 'current-frame-style) theme-name)
    (set-tab-theme-name #:frame-style-supported-tabs theme-name)))

(define (frame-style-tabbars w)
  (when (eq (window-get w 'current-frame-style) theme-name)
    (set-tab-theme-tabbars #:frame-style-supported-tabbars (list theme-name styletab-c:titlebar-place))))

(define (get-frame w type)
  (let ((current-title
         (if (not (window-get w 'title-position))
             (case styletab-c:titlebar-place
                   ((top)    'top)
                   ((bottom) 'bottom)
                   ((left)   'left)
                   ((right)  'right))
           (window-get w 'title-position))))
    (case type
          ((default)
           (make-frame w 'normal-frame current-title))
          ((utility)
           (make-frame w 'normal-frame current-title))
          ((shaded-utility)
           (make-frame w 'normal-frame current-title))
          ((transient)
           (make-frame w 'transient-frame current-title))
          ((shaped)
           (make-frame w 'shaped-frame current-title))
          ((shaped-transient)
           (make-frame w 'shaped-transient-frame current-title)))))

(add-frame-style theme-name get-frame)

(call-after-state-changed '(tab-theme-name) frame-style-name)
(call-after-state-changed '(tab-theme-tabbars) frame-style-tabbars)
(call-after-state-changed '(marked) reframe-marked)
(call-after-state-changed '(maximized sticky fixed-position fixed-size stacking) reframe-one)
(add-hook 'remove-from-workspace-hook reframe-one)

(custom-set-property 'styletab-c:styles ':after-set build-style)
(custom-set-property 'styletab-c:title-dimension ':after-set clear-icon-cache-reframe)
(custom-set-property 'styletab-c:custom-button-width ':after-set clear-icon-cache-reframe)
(custom-set-property 'styletab-c:button-width ':after-set clear-icon-cache-reframe)
(custom-set-property 'styletab-c:borders-dimension ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:titlebar-place ':after-set reframe-with-style)
(custom-set-property 'styletab-c:top-left-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:top-right-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:bottom-left-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:bottom-right-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:left-top-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:left-bottom-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:right-top-buttons ':after-set make-buttons-reframe-with-style)
(custom-set-property 'styletab-c:right-bottom-buttons ':after-set make-buttons-reframe-with-style)

(define (timer-theme-load)
  (require 'rep.io.timers)
  (setq start-lock
        (make-timer (lambda ()
                      (setq start-lock nil)
                      (build-style))
                    (quotient 10 1000) (mod 10 1000))))

(timer-theme-load)

;; hqw-util.jl 1.0 -- A bunch of util functions for sawfish

;; Time-stamp: <2011-12-15 10:23:36 hqwrong>
;; Copyright (C) 2011, hqwrong <hq.wrong@gmail.com>

;; Permission is granted to copy, distribute and/or modify this
;; document under the terms of the GNU Free Documentation License,
;; Version 1.3 or any later version published by the Free Software
;; Foundation.

;;
;;; Commentary:
(define-structure sawfish.wm.util.events

      (export event-wait-for
              event-exit-wait)

      (open rep
            rep.data
            rep.system
            rep.regexp
            rep.lang.math
            sawfish.wm.state.shading
            sawfish.wm.state.iconify
            sawfish.wm.stacking
            sawfish.wm.viewport
            sawfish.wm.state.maximize
            sawfish.wm.custom
            sawfish.wm.commands
            sawfish.wm.colors
            sawfish.wm.events
            sawfish.wm.fonts
            sawfish.wm.images
            sawfish.wm.misc
            sawfish.wm.util.x
            sawfish.wm.windows
            sawfish.wm.workspace)

(define (event-wait-for #!key
                      (keymap '(keymap))
                      loop-on-unbound
                      handler
                      exit-hook)
   "wait-for an event.
	`keymap' is used as the override keymap during `recursive-edit'
        
        `handler' is a list of cons cell,as (predict
. procedure), when the key event has no bound in keymap, then the
key name is passed to each predict by order.Once eval to t ,then
the associated procedure is called with key as argument,then
re-enter in `recursive-edit'.Otherwise,if loop-on-unbound is nil,
exit loop.

        `exit-hook' ,if setted,will be called with key's name as argument,
after exit from loop."
   
   (call-with-keyboard-grabbed
    (lambda ()
       (let ((override-keymap keymap)
             (re-exit (lambda ()
                         (throw 're-exit
                                (event-name (current-event)))))
             (key nil))
          (add-hook 'unbound-key-hook re-exit)
          (while (catch 'event-exit
                    (setq key
                          (catch 're-exit
                             (recursive-edit)))
                    (when handler
                       (do ((l handler (cdr handler)))
                             ((null l) t)
                          (let* ((cell (car l))
                                 (pred (car cell))
                                 (proc (cdr cell)))
                             (when (pred key)
                                (proc key)
                                (throw 'event-exit t)))))
                    (when (not loop-on-unbound)
                       (throw 'event-exit nil))
                    t)
             t)
          (when exit-hook
             (exit-hook key))))))

(define (event-exit-wait)
   "You'll find it useful,when you're using `event-wait-for'"
   (throw 'event-exit)))

;; nokogiri-i18n -- support for internationalization
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.cfg.i18n

    (export i18n-lang
	    i18n-filename
	    i18n-init)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.i18n.gettext
	  sawfish.cfg.wm)

  (define i18n-lang (or (getenv "LC_ALL")
			(getenv "LC_MESSAGES")
			(getenv "LANG")))

  (define i18n-lang-base (and i18n-lang
			      (if (string-match "^([^_.]+)_.*" i18n-lang)
				  (expand-last-match "\\1")
				i18n-lang)))

  ;; for a file called FILE, look for one with a .LC extension LC is
  ;; the language code for the current language
  (define (i18n-filename file)
    (cond ((and i18n-lang
		(file-exists-p (concat file #\. i18n-lang)))
	   (concat file #\. i18n-lang))
	  ((and i18n-lang-base
		(file-exists-p (concat file #\. i18n-lang-base)))
	   (concat file #\. i18n-lang-base))
	  (t file)))

  (define (i18n-init)
    (unless (get-command-line-option "--disable-nls")
      (let ((locale-dir (wm-locale-dir)))
	(when locale-dir
	  (bindtextdomain "sawfish" locale-dir)
	  (when (boundp 'bindtextdomaincodeset)
	    (bindtextdomaincodeset "sawfish" "UTF-8"))
	  (textdomain "sawfish"))))))

;; ping.jl -- implement the _NET_WM_PING protocol
;;
;; Author: John Harper <jsh@eazel.com>
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.ping

    (export window-supports-ping-p
	    ping-window)

    (open rep
	  rep.io.timers
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows)

  (define make-ping-record cons)
  (define ping-callback car)
  (define ping-id cdr)

  ;; list of ping records sent but not completed
  (define pings-in-transit '())

  ;; The wm-spec talks about "timestamps", and how they can be used as
  ;; unique ids, but doesn't say whether they're X server timestamps.
  ;; Obviously, X server timestamps can't be used as unique ids, so we
  ;; just use sequence numbers..

  (define unique-id
    (let ((counter 0))
      (lambda ()
	(prog1
	    counter
	  (setq counter (1+ counter))))))

;;; public functions

  (define (window-supports-ping-p w)
    "Returns true if window W supports the _NET_WM_PING protocol."
    (window-supports-wm-protocol-p w '_NET_WM_PING))

  (define (ping-window w callback #!optional (timeout-msecs 1000))
    "Assuming that window W supports the _NET_WM_PING protocol (i.e. the
function `window-supports-ping-p' returns true), initiate a ping sequence.

The function CALLBACK will subsequently be called with a single
argument, true if the window responded to the ping within TIMEOUT-MSECS
milliseconds (defaults to 1 second), false otherwise."

    (let ((ping (make-ping-record callback (unique-id))))
      (send-client-message w 'WM_PROTOCOLS
			   (vector (x-atom '_NET_WM_PING)
				   (ping-id ping)) 32)
      (setq pings-in-transit (cons ping pings-in-transit))
      (make-timer (lambda ()
		    ;; Ensure that this ping hasn't already come back
		    (when (memq ping pings-in-transit)
		      (setq pings-in-transit (delq ping pings-in-transit))
		      (callback nil)))
		  (quotient timeout-msecs 1000) (mod timeout-msecs 1000))))

;;; event handler

  (define (client-message-handler w type data)
    (declare (unused w))
    (when (and (eq type 'WM_PROTOCOLS)
	       (eq (x-atom-name (aref data 0)) '_NET_WM_PING))
      ;; a returning ping (pong?)
      (let ((id (aref data 1)))
	(let loop ((rest pings-in-transit))
	  (cond ((null loop)
		 (format
		  standard-error "Received stray _NET_WM_PING: %s\n" data))

		((eql (ping-id (car rest)) id)
		 ;; found our ping
		 (let ((this (car rest)))
		   (setq pings-in-transit (delq this pings-in-transit))
		   ((ping-callback this) t)))

		(t (loop (cdr rest))))))
      t))

  (add-hook 'client-message-hook client-message-handler))

;; gnome.jl -- GNOME integration

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.gnome

    (export detect-gnome)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias gnome-int sawfish.wm.integration.gnome)

  (define (init)
    (let (menu)
      (setq desktop-environment "gnome")
      (setq want-poweroff-menu nil)

      ;; invoke the GNOME terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "gnome-terminal.wrapper"))

      ;; use the GNOME help browser and url launcher
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "gnome-www-browser"))

      ;; use the GNOME filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "nautilus"))

      ;; add some GNOME menu-entries
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_GNOME Help") (system "yelp &"))
		      (,(_ "GNOME _Website") (browser "http://www.gnome.org"))
		      (,(_ "_About GNOME") (system "gnome-about &")))))

      ;; add gnome-logout and customize menu-entries
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_Customize GNOME") (system "gnome-control-center &"))
		      (,(_ "_Edit GNOME menu") (system "alacarte &"))
		      ()
		      (,(_ "_Logout from GNOME")
		       (system "gnome-session-quit --logout &"))
		      (,(_ "_Shutdown from GNOME")
		       (system "gnome-session-quit --power-off &")))))))

  ;; Returns nil if gnome is not found.
  ;; If detected, returns t, and do also gnome support init.
  (define (detect-gnome)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "GNOME")
	      (equal (getenv "XDG_CURRENT_DESKTOP") "GNOME-Classic:GNOME")
	      (equal (getenv "XDG_SESSION_DESKTOP") "gnome")
	      (equal (getenv "XDG_SESSION_DESKTOP") "gnome-classic"))
      (init)
      t)))

;; customize.jl -- invocation of configurator GUI & customization file IO

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.customize

    (export customize
	    customize-read-user-file
	    customize-write-user-file
	    customize-set)

    (open rep
	  rep.system
	  rep.io.files
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.misc)

  (define-structure-alias customize sawfish.wm.customize)

  (defvar customize-program "sawfish-config"
    "Command name of the configurator GUI.")

  (defvar customize-group-opt "--group")

  (defvar customize-redirect ">/dev/null 2>&1 </dev/null"
    "Redirect the configurator's input & output.")

  ;; Stores the content of ~/.sawfish/custom, both for
  ;; parsing and writing.
  (define customize-user-forms nil)

  (define customize-user-file-read nil)
  (define customize-user-file-dirty nil)

;;; ui

  (define (customize #!optional group)
    "Invoke the configurator GUI."
    (system (format nil "%s %s '%S' %s &"
		    customize-program
		    (if group customize-group-opt "")
		    (or group "")
		    customize-redirect)))

  ;;###autoload
  (define-command 'customize customize)

;;; setting variables

  ;; Currently only called from `customize-set' below.
  (define (customize-read-user-file)
    "Read the file which saves user customization. A configurator
instance can read it only once."
    (unless customize-user-file-read
      (let ((filename
	     (cond ((file-exists-p custom-user-file) custom-user-file)
		   ((file-exists-p custom-default-file) custom-default-file)
		   (t (error "Can't find custom-default-file: %s"
			     custom-default-file)))))
	(setq customize-user-forms nil)
	(when (file-exists-p filename)
	  (let ((file (open-file filename 'read)))
	    (unwind-protect
		(condition-case nil
		    (while t
		      (setq customize-user-forms (cons (read file)
						       customize-user-forms)))
		  (end-of-stream))
	      (close-file file))
	    (setq customize-user-forms
		  ;; remove obsolete variables
		  (delete-if (lambda (form)
			       (get (cadadr form) 'custom-obsolete))
			     (nreverse customize-user-forms)))))
	(setq customize-user-file-read t)
	(setq customize-user-file-dirty nil))))

  (define (customize-write-user-file)
    (when customize-user-file-dirty
      (make-directory-recursively (file-name-directory custom-user-file))
      (let ((file (open-file custom-user-file 'write)))
	(when file
	  (unwind-protect
	      (progn
		(format file "\
;; Sawfish user customization -- do not edit by hand!
;; Use the configurator instead.
;; sawfish version %s, written %s\n\n"
                        sawfish-version (current-time-string))
		(mapc (lambda (f)
			(format file "%S\n" f)) customize-user-forms))
	    (close-file file))
	  (setq customize-user-file-dirty nil)))))

  (define (customize-set symbol value)
    (customize-read-user-file)
    (let ((form (make-custom-form symbol value)))
      (catch 'done
	(mapc (lambda (f)
		(when (eq (nth 1 (nth 1 f)) symbol)
		  (setq customize-user-forms
			(cons form (delq f customize-user-forms)))
		  (throw 'done t)))
	      customize-user-forms)
	(setq customize-user-forms (cons form customize-user-forms)))
      (setq customize-user-file-dirty t)
      (custom-eval form)))

  (unless batch-mode
    (add-hook 'idle-hook customize-write-user-file)
    (add-hook 'before-exit-hook customize-write-user-file)))

;; gtkrc.jl -- code to read current gtkrc settings

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.gtkrc

    (export gtkrc-style
	    gtkrc-background
	    gtkrc-background-pixmaps
	    gtkrc-base
	    gtkrc-light
	    gtkrc-dark
	    gtkrc-mid
	    gtkrc-foreground
	    gtkrc-font
	    gtkrc-load-pixmaps
	    gtkrc-reload-style
	    gtkrc-call-after-changed)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.processes
	  sawfish.wm.colors
	  sawfish.wm.fonts
	  sawfish.wm.images
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.gaol)

  (define-structure-alias gtkrc sawfish.wm.util.gtkrc)

  (defvar gtkrc-style-program
    (expand-file-name "gtk-style" sawfish-exec-directory))

  (define gtkrc-style nil)

  (define gtkrc-background nil)
  (define gtkrc-background-pixmaps nil)
  (define gtkrc-base nil)
  (define gtkrc-light nil)
  (define gtkrc-dark nil)
  (define gtkrc-mid nil)
  (define gtkrc-foreground nil)
  (define gtkrc-font nil)

  (define gtkrc-loaded-pixmaps nil)

  (define gtkrc-dummy-window nil)

  (define gtkrc-changed-hook nil)

  ;; read the current default style
  (define (gtkrc-get-style)
    (let* ((output (make-string-output-stream))
	   (process (make-process output)))
      (set-process-error-stream process nil)
      ;; XXX the gtk-style program can't connect to the X server
      ;; XXX if it's currently grabbed, hence this kludge..
      (call-with-server-ungrabbed
       (lambda ()
	 (unless (zerop (call-process process nil gtkrc-style-program))
	   (error "Can't start gtkrc-style-program: `%s'."
		  gtkrc-style-program))))
      (setq output (make-string-input-stream
		    (get-output-stream-string output)))
      (setq gtkrc-style nil)
      (condition-case nil
	  (while t
	    (setq gtkrc-style (cons (read output) gtkrc-style)))
	(end-of-stream
	 (setq gtkrc-style (nreverse gtkrc-style))))))

  (define (gtkrc-fix-image-name str)
    (while (string-match "//" str)
      (setq str (concat (substring str 0 (match-start))
			?/ (substring str (match-end)))))
    str)

  ;; act on settings in gtkrc-style alist
  (define (gtkrc-apply-style)
    (let (tem)
      (setq gtkrc-background nil)
      (setq gtkrc-background-pixmaps nil)
      (setq gtkrc-base nil)
      (setq gtkrc-light nil)
      (setq gtkrc-dark nil)
      (setq gtkrc-mid nil)
      (setq gtkrc-foreground nil)
      (setq gtkrc-font nil)
      (setq gtkrc-loaded-pixmaps nil)
      (when (setq tem (cdr (assq 'font gtkrc-style)))
	(setq gtkrc-font (condition-case nil
			     (get-font tem)
			   (error
			    default-font))))
      (when (setq tem (cdr (assq 'fg gtkrc-style)))
	(setq gtkrc-foreground (list (cdr (assq 'normal tem))
				     (cdr (assq 'prelight tem))
				     (cdr (assq 'active tem))
				     (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'bg gtkrc-style)))
	(setq gtkrc-background (list (cdr (assq 'normal tem))
				     (cdr (assq 'prelight tem))
				     (cdr (assq 'active tem))
				     (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'base gtkrc-style)))
	(setq gtkrc-base (list (cdr (assq 'normal tem))
			       (cdr (assq 'prelight tem))
			       (cdr (assq 'active tem))
			       (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'light gtkrc-style)))
	(setq gtkrc-light (list (cdr (assq 'normal tem))
				(cdr (assq 'prelight tem))
				(cdr (assq 'active tem))
				(cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'dark gtkrc-style)))
	(setq gtkrc-dark (list (cdr (assq 'normal tem))
			       (cdr (assq 'prelight tem))
			       (cdr (assq 'active tem))
			       (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'mid gtkrc-style)))
	(setq gtkrc-mid (list (cdr (assq 'normal tem))
			      (cdr (assq 'prelight tem))
			      (cdr (assq 'active tem))
			      (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'bg-pixmap gtkrc-style)))
	(setq gtkrc-background-pixmaps (list (cdr (assq 'normal tem))
					     (cdr (assq 'prelight tem))
					     (cdr (assq 'active tem))
					     (cdr (assq 'selected tem)))))
      (mapc (lambda (var)
	      (when (symbol-value var)
		(set var (mapcar (lambda (x)
				   (and x (get-color x)))
				 (symbol-value var)))))
	    '(gtkrc-background gtkrc-base gtkrc-foreground))))

  ;; if a theme want's to use the pixmaps, it must call this function first
  (define (gtkrc-load-pixmaps)
    (when (and gtkrc-background-pixmaps (not gtkrc-loaded-pixmaps))
      (setq gtkrc-background-pixmaps
	    (mapcar (lambda (x)
		      (when x
			(setq x (make-image (gtkrc-fix-image-name x)))
			(image-put x 'tiled t)
			x))
		    gtkrc-background-pixmaps))
      (setq gtkrc-loaded-pixmaps t)))

  (define (gtkrc-reload-style)
    "Reload the gtkrc settings."
    (gtkrc-get-style)
    (gtkrc-apply-style)
    (reload-gaol)
    (call-hook 'gtkrc-changed-hook))

  (define-command 'gtkrc-reload-style gtkrc-reload-style)

  ;; recognize when the GTK theme has been switched
  (define (gtkrc-handle-client-msg w type data)
    (declare (unused data))
    (when (and (eq w gtkrc-dummy-window) (eq type '_GTK_READ_RCFILES))
      (gtkrc-reload-style)
      ;; XXX make conditional
      (require 'sawfish.wm.menus)
      (menu-stop-process t)
      t))

;;; for restricted themes

  (define gtkrc-funs '())

  (define (gtkrc-call-after-changed fun)
    (setq gtkrc-funs (cons fun gtkrc-funs)))

  (add-hook 'gtkrc-changed-hook (lambda () (mapc funcall gtkrc-funs)))

  (define (reload-gaol)
    (gaol-define 'gtkrc-background gtkrc-background)
    (gaol-define 'gtkrc-background-pixmaps gtkrc-background-pixmaps)
    (gaol-define 'gtkrc-base gtkrc-base)
    (gaol-define 'gtkrc-light gtkrc-light)
    (gaol-define 'gtkrc-dark gtkrc-dark)
    (gaol-define 'gtkrc-mid gtkrc-mid)
    (gaol-define 'gtkrc-foreground gtkrc-foreground)
    (gaol-define 'gtkrc-font gtkrc-font))

;;; init

  (define (gtkrc-quit)
    (destroy-window gtkrc-dummy-window))

  (unless batch-mode
    (setq gtkrc-dummy-window (create-window 'root -100 -100 10 10))
    (set-x-property gtkrc-dummy-window 'WM_STATE (vector 0) 'WM_STATE 32)
    (add-hook 'client-message-hook gtkrc-handle-client-msg)
    (add-hook 'before-exit-hook gtkrc-quit)
    (gtkrc-reload-style))

  (gaol-define 'gtkrc-load-pixmaps gtkrc-load-pixmaps)
  (gaol-define 'gtkrc-reload-style gtkrc-reload-style)
  (gaol-define 'gtkrc-call-after-changed gtkrc-call-after-changed)
  (reload-gaol))

;; transient.jl -- support transient windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.state.transient

    (export transient-of-p
	    indirect-transient-of-p
	    transient-parents
	    transient-children
	    transient-group
	    map-transient-group
	    raise-window-and-transients
	    lower-window-and-transients
	    raise-lower-window-and-transients)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands
          sawfish.wm.focus
	  sawfish.wm.windows
	  sawfish.wm.stacking
	  sawfish.wm.viewport
	  sawfish.wm.util.window-order
	  sawfish.wm.util.groups
	  sawfish.wm.frames)

  (defcustom focus-windows-when-mapped t
    "Focus on application windows when they first appear."
    :type boolean
    :group focus)

  (defvar decorate-transients nil
    "Decorate dialog windows similarly to application windows.")

;;; functions

  (define (transient-of-p x y #!key allow-root)
    "Return t if window X is directly a transient for window Y."
    (let ((x-for (window-transient-p x)))
      (and x-for
	   (or (eql x-for (window-id y))
	       ;; windows that set WM_TRANSIENT_FOR to the root window are
	       ;; transients for their entire group (de facto standard).
	       ;; This only makes sense for non-transient windows
	       ;; (disable this code by default, it causes too much weirdness)
	       (and allow-root
		    (eql x-for (root-window-id))
		    (window-group-id x)
		    (not (window-transient-p y))
		    (eql (window-group-id x) (window-group-id y)))))))

  (define (indirect-transient-of-p x y #!key allow-root)
    "Return t if window X is (directly, or indirectly) a transient for
window Y."
    (let loop ((x x))
      (or (transient-of-p x y #:allow-root allow-root)
	  (let ((x-for (window-transient-p x)))
	    (and x-for
		 ;; Some KDE windows set WM_TRANSIENT_FOR to their own id!
		 (not (eql x-for (window-id x)))
		 (let ((x-for-w (get-window-by-id x-for)))
		   (if x-for-w
		       (loop x-for-w)
		     nil)))))))

  (define (transient-parents w #!optional indirectly)
    "Return the list of windows that window W is a transient for."
    (filter-windows (lambda (x)
		      (and (window-mapped-p x)
			   ((if indirectly
				indirect-transient-of-p
			      transient-of-p) w x)))))

  (define (transient-children w #!optional indirectly)
    "Return the list of windows which are transients of window W."
    (filter-windows (lambda (x)
		      (and (window-mapped-p x)
			   ((if indirectly
				indirect-transient-of-p
			      transient-of-p) x w)))))

  (define (transient-group w #!optional by-depth)
    "Return the list of windows which is either a transient window for window
W, or a window which W is a transient for. This always includes W. The
`transient window for' relation holds for windows which are direct or
indirect transients of the parent window in question."
    (delete-if-not (lambda (x)
		     (and (window-mapped-p x)
			  (or (eq x w)
			      (indirect-transient-of-p x w)
			      (indirect-transient-of-p w x))))
		   (if by-depth (stacking-order) (managed-windows))))

  (define (map-transient-group fun w)
    "Map the single argument function FUN over all windows in the same
transient group as window W."
    (mapc fun (transient-group w)))

;;; commands for raising windows with their transients

  (define (raise-window-and-transients w)
    "Raise the current window to its highest allowed position in the stacking
order. Also raise any transient windows that it has."
    (raise-windows w (transient-group w t)))

  (define (lower-window-and-transients w)
    "Lower the current window to its lowest allowed position in the stacking
order. Also lower any transient windows that it has."
    (lower-windows w (transient-group w t)))

  (define (raise-lower-window-and-transients w)
    "If the window is at its highest possible position, then lower it to its
lowest possible position. Otherwise raise it as far as allowed. Also changes
the level of any transient windows it has."
    (raise-lower-windows w (transient-group w t)))

  (define-command 'raise-window-and-transients
    raise-window-and-transients #:spec "%W")
  (define-command 'lower-window-and-transients
    lower-window-and-transients #:spec "%W")
  (define-command 'raise-lower-window-and-transients
    raise-lower-window-and-transients #:spec "%W")

;;; displaying

  (define (transient-frame-type w type)
    (if (and decorate-transients (window-transient-p w))
	(case type
	  ((transient) 'default)
	  ((shaded-transient) 'shaded)
	  (t type))
      type))

  (define-frame-type-mapper transient-frame-type)

;;; hooks

  ;; 1. Transients of the currently focused window get focus.
  ;; 2. Transients of root belonging to the same window group as the
  ;;    currently focused window get focus, unless the currently focused
  ;;    window is also transient (wacky special case code in transient-of-p).
  ;; 3. Other transients for root, transients for a desktop window
  ;;    or non-transients may get focus depending on options (yes, we
  ;;    also handle non-transients).
  (define (transient-map-window w)
    (require 'sawfish.wm.workspace)
    (when (and (window-really-wants-input-p w)
               (or (window-visible-p w)
                   (window-workspaces w))
               (or (let ((focus (input-focus)))
                     (and focus (transient-of-p w focus #:allow-root t)))
                   (let ((x-for-id (window-transient-p w)))
                     (and (or (not x-for-id)
                              (eql x-for-id (root-window-id))
                              (let ((x-for (get-window-by-id x-for-id)))
                                (and x-for (window-get x-for 'desktop))))
                          (or (and
                               focus-windows-when-mapped
                               (not (window-get w 'never-focus))
                               (not (window-get w 'inhibit-focus-when-mapped)))
                              (window-get w 'focus-when-mapped))))))
      (unless (window-get w 'sticky)
        (when (not (eq (car (window-in-workspace-p w current-workspace))
                       (car (window-workspaces w))))
          (select-workspace (car (window-workspaces w)))))
      (set-input-focus w)))

  ;; If a transient window gets unmapped that currently has the input
  ;; focus, pass it (the focus) to its parent. Otherwise, pass the focus
  ;; to the topmost window if click-to-focus, otherwise the window under
  ;; the mouse
  (define (transient-unmap-window w)
    (when (eq (input-focus) w)
      (let ((parent (and (window-transient-p w)
			 ;; for transient windows, look for the most
			 ;; recently focused window in its group, or
			 ;; fall back to its parent window
			 (or (window-order-most-recent
			      #:windows (delq w (windows-in-group w)))
			     (get-window-by-id (window-transient-p w))))))
	(if (and parent
                 (window-mapped-p parent)
                 (window-visible-p parent)
                 (not (window-outside-viewport-p parent))
                 (window-really-wants-input-p parent)
                 (not (window-get parent 'desktop)))
            (set-input-focus parent)
          ;; No parent to give focus back to.
          (focus-revert)))))

  (add-hook 'map-notify-hook transient-map-window)
  (add-hook 'unmap-notify-hook transient-unmap-window)
  (add-hook 'iconify-window-hook transient-unmap-window))

;; mwm.jl -- handle some of the Motif hints

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; There's a conflict between the way that sawfish allows frame-styles
;; to be defined, and the way that the window hints (gnome, mwm, ol,
;; ...) ask for particular decorations.

;; One solution might be to add a `class' attibute to each frame part.
;; These would be things like title, border, close, etc... Then if the
;; window has asked for that decor include it, otherwise don't.

;; But this doesn't work because we may be left with holes in the
;; window frame. For example, leaving the close button out of a
;; brushed-metal frame will just take a chunk out of the window corner.

;; For the moment I'll just have to mash the window hints into the four
;; available window types: default, shaped, transient, shaped-transient

(define-structure sawfish.wm.state.mwm

    (export )

    (open rep
          rep.system
          sawfish.wm.windows
          sawfish.wm.misc
          sawfish.wm.frames)

;;; Hint definitions

  ;; Motif window hints are [FLAGS FUNCTIONS DECORATIONS INPUT-MODE STATUS],
  ;; first three are CARD32, last is INT32, last is CARD32
  (defconst mwm-window-hint-flags 0)
  (defconst mwm-window-hint-functions 1)
  (defconst mwm-window-hint-decorations 2)
  (defconst mwm-window-hint-input-mode 3)
  (defconst mwm-window-hint-status 4)

  ;; Flags define which hints are set
  (defconst mwm-flag-functions 1)
  (defconst mwm-flag-decorations 2)

  ;; Definitions for functions hint
  (defconst mwm-func-all 1)
  (defconst mwm-func-resize 2)
  (defconst mwm-func-move 4)
  (defconst mwm-func-minimize 8)
  (defconst mwm-func-maximize 16)
  (defconst mwm-func-close 32)

  ;; Definitions for decorations hint
  (defconst mwm-decor-all 1)
  (defconst mwm-decor-border 2)
  (defconst mwm-decor-resizeh 4)
  (defconst mwm-decor-title 8)
  (defconst mwm-decor-menu 16)
  (defconst mwm-decor-minimize 32)
  (defconst mwm-decor-maximize 64)

  ;; Definitions for input-mode hint
  (defconst mwm-input-modeless 0)
  (defconst mwm-input-primary-app-modal 1)
  (defconst mwm-input-system-modal 2)
  (defconst mwm-input-full-app-modal 3)

;;; Acting on the hints

  ;; this must be called _before_ the frames.jl add-window function
  (define (mwm-add-window w)
    (let* ((hints (get-x-property w '_MOTIF_WM_HINTS))
	   (type (window-type w))
	   data)
      ;; XXX act on input-mode hints...
      (when hints
	(setq data (nth 2 hints))
	(unless (zerop (logand (aref data mwm-window-hint-flags)
			       mwm-flag-decorations))
	  ;; decor hints supplied
	  (let ((decor (aref data mwm-window-hint-decorations)))
	    (if (zerop (logand decor mwm-decor-all))
		(progn
		  (when (zerop (logand decor mwm-decor-border))
		    (setq type (window-type-remove-border type)))
		  (when (zerop (logand decor mwm-decor-title))
		    (setq type (window-type-remove-title type)))
		  (when (zerop (logand decor mwm-decor-menu))
		    (remove-frame-class w 'menu-button))
		  (when (zerop (logand decor mwm-decor-minimize))
		    (remove-frame-class w 'iconify-button))
		  (when (zerop (logand decor mwm-decor-maximize))
		    (remove-frame-class w 'maximize-button)))
	      (setq type 'default))))
	(unless (zerop (logand (aref data mwm-window-hint-flags)
			       mwm-flag-functions))
	  ;; function hints supplied
	  (let ((func (aref data mwm-window-hint-functions)))
	    (when (zerop (logand func mwm-func-all))
	      (when (zerop (logand func mwm-func-minimize))
		(remove-frame-class w 'iconify-button))
	      (when (zerop (logand func mwm-func-maximize))
		(remove-frame-class w 'maximize-button))
	      (when (zerop (logand func mwm-func-close))
		(remove-frame-class w 'close-button))))))
      (set-window-type w type)))

  (add-hook 'before-add-window-hook mwm-add-window))

;; move-resize.jl -- interactive moving and resizing of windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.move-resize

    (export move-window-interactively
	    resize-window-interactively
	    move-selected-window
	    resize-selected-window
	    resize-window-frame-to
	    resize-window-prompt
	    double-window-size
	    halve-window-size
	    move-window-center)

    (open rep
	  rep.system
	  rep.regexp
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.misc
	  sawfish.wm.state.maximize
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.cursors
	  sawfish.wm.util.stacking
	  sawfish.wm.util.edges)

  (define-structure-alias move-resize sawfish.wm.commands.move-resize)

  ;; we bind to disable-auto-raise
  (eval-when-compile (require 'sawfish.wm.ext.auto-raise))

  ;; todo:
  ;;  * obey the aspect ratio size hints


  (defcustom move-outline-mode 'opaque
    "How windows being moved are animated"
    :type (choice opaque box cross elliptical draft)
    :group (appearance animation))

  (defcustom resize-outline-mode 'opaque
    "How windows being resized are animated"
    :type (choice opaque box cross elliptical draft)
    :group (appearance animation))

  (defcustom move-resize-raise-window nil
    "Raise windows when they are moved or resized."
    :type boolean
    :group move)

  (defcustom move-show-position nil
    "Show current position of windows while moving."
    :group move
    :type boolean)

  (defcustom resize-show-dimensions t
    "Show current dimensions of windows while resizing."
    :group move
    :type boolean)

  (defcustom resize-edge-mode 'border-grab
    "How to choose window edges when resizing."
    :type (choice region border grab border-grab)
    :group move)

  (defcustom move-snap-epsilon 12
    "Distance in pixels before window edges align with each other."
    :group move
    :type (number 0 64)
    :tooltip "When moving a window, this option lets you align one of \
its edges with an edge of another window.")

  (defcustom marked-cursor-shape 'clock
    "Cursor shape if a window is marked to added as tab."
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox clock double_arrow draped_box
                  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
                  pencil pirate plus question_arrow right_ptr sb_left_arrow
                  sb_right_arrow sb_down_arrow sb_up_arrow spider star
                  target tcross watch xterm X_cursor)
    :group move)

  (defvar move-snap-mode 'resistance
    "How to snap together window edges, one of `magnetism', `resistance', or
`attraction'.")

  (defvar move-snap-ignored-windows nil
    "Snap to otherwise-ignored windows.")

  (defvar move-resize-inhibit-configure nil
    "Only update window contents after it has stopped moving.")

  ;; Locally set by place-window-interactively in placement.jl & reset
  ;; in move-switch-to-resize
  (defvar move-from-interactive-placement nil)

  (defvar move-resize-map (bind-keys (make-keymap)
                                     "Any-Off1" (lambda () (finished))
                                     "Any-Off2" (lambda () (finished))
                                     "Any-Off3" (lambda () (finished))
                                     "Button2-Click"
                                     (lambda () (move-switch-to-resize))
                                     "Button3-Click"
                                     (lambda ()
                                       (move-vmaximize-then-finished))
                                     "Any-Move" (lambda () (motion))
                                     "Any-ESC" (lambda () (cancel))
                                     "Any-RET" (lambda () (finished))
                                     "Up" 'move-cursor-up
                                     "Down" 'move-cursor-down
                                     "Left" 'move-cursor-left
                                     "Right" 'move-cursor-right
                                     "S-Up" 'move-cursor-up-fine
                                     "S-Down" 'move-cursor-down-fine
                                     "S-Left" 'move-cursor-left-fine
                                     "S-Right" 'move-cursor-right-fine))

  (define fp-edges-alist '((top-border top)
			   (left-border left)
			   (right-border right)
			   (bottom-border bottom)
			   (top-left-corner top left)
			   (top-right-corner top right)
			   (bottom-left-corner bottom left)
			   (bottom-right-corner bottom right)))

  (defvar move-cursor-shape 'hand2)
  (defvar resize-cursor-shape 'crosshair)

  ;; specials, should make these fluids (external users?)
  (defvar move-resize-window nil)
  (defvar move-resize-function nil)
  (defvar move-resize-x nil)
  (defvar move-resize-y nil)
  (defvar move-resize-width nil)
  (defvar move-resize-height nil)
  (defvar move-resize-old-x nil)
  (defvar move-resize-old-y nil)
  (defvar move-resize-old-width nil)
  (defvar move-resize-old-height nil)
  (defvar move-resize-old-ptr-x nil)
  (defvar move-resize-old-ptr-y nil)
  (defvar move-resize-last-ptr nil)
  (defvar move-resize-snap-state nil)
  (defvar move-resize-mode nil)
  (defvar move-resize-hints nil)
  (defvar move-resize-frame nil)
  (defvar move-resize-edges nil)
  (defvar move-resize-last-outline nil)
  (defvar move-resize-moving-edges nil)
  (defvar move-resize-directions nil)

  (defvar while-moving-hook nil)
  (defvar while-resizing-hook nil)
  (defvar before-move-hook nil)
  (defvar after-move-hook nil)
  (defvar before-resize-hook nil)
  (defvar after-resize-hook nil)

  (define (delete-unmovable-directions directions)
    (when move-lock-when-maximized
      (when (window-maximized-vertically-p move-resize-window)
	(setq directions (delq 'vertical directions)))
      (when (window-maximized-horizontally-p move-resize-window)
	(setq directions (delq 'horizontal directions))))
    directions)

  (define (delete-unresizable-edges edges)
    (when move-lock-when-maximized
      (when (window-maximized-vertically-p move-resize-window)
	(setq edges (delq 'top (delq 'bottom edges))))
      (when (window-maximized-horizontally-p move-resize-window)
	(setq edges (delq 'left (delq 'right edges)))))
    edges)

  ;; called to initiate a move or resize on window W. FUNCTION is either
  ;; `move' or `resize'
  (define (do-move-resize w function)
    (if (eq function 'move)
	(call-window-hook 'before-move-hook w)
      (call-window-hook 'before-resize-hook w))
    (let* ((from-motion-event (and (current-event)
				   (string-match "-Move$" (event-name
							   (current-event)))))
	   (override-keymap move-resize-map)
	   ;; don't want any complications..
	   (unbound-key-hook nil)
	   (disable-auto-raise t)
	   (move-resize-window w)
	   (move-resize-function function)
	   (move-resize-old-x (car (window-position w)))
	   (move-resize-old-y (cdr (window-position w)))
	   (move-resize-old-width (car (window-dimensions w)))
	   (move-resize-old-height (cdr (window-dimensions w)))
	   (move-resize-x move-resize-old-x)
	   (move-resize-y move-resize-old-y)
	   (move-resize-width move-resize-old-width)
	   (move-resize-height move-resize-old-height)
	   (move-resize-last-ptr  (if from-motion-event
				      (query-button-press-pointer)
				    (query-pointer t)))
	   (move-resize-snap-state (cons))
	   (move-resize-old-ptr-x (car move-resize-last-ptr))
	   (move-resize-old-ptr-y (cdr move-resize-last-ptr))
	   (move-resize-hints (window-size-hints w))
	   (move-resize-frame (cons (- (car (window-frame-dimensions w))
				       move-resize-old-width)
				    (- (cdr (window-frame-dimensions w))
				       move-resize-old-height)))
	   (move-resize-mode (if (eq function 'move)
				 move-outline-mode
			       resize-outline-mode))
	   (move-resize-edges nil)
	   (move-resize-last-outline nil)
	   (move-resize-moving-edges move-resize-moving-edges)
	   (move-resize-directions move-resize-directions)
	   (old-frame-draw-mutex
	    (frame-draw-mutex (not (eq move-resize-mode 'opaque))))
	   (old-frame-state-mutex (frame-state-mutex 'clicked))
	   (old-synthetic-configure-mutex
	    (synthetic-configure-mutex move-resize-inhibit-configure))
	   (was-successful nil)
	   server-grabbed)

      (when (and move-resize-raise-window (eq move-resize-mode 'opaque))
	;; only raise window initially if the display will get updated
	(raise-window* w))

      (update-edges)
      (unless (eq move-resize-mode 'opaque)
	(require 'sawfish.wm.animation.modes)
	;; prevent any other programs drawing on the display
	(grab-server)
	(setq server-grabbed t))

      (add-hook 'enter-workspace-hook update-edges)
      (add-hook 'viewport-moved-hook update-edges)
      (unwind-protect
	  (progn
	    (allow-events 'async-pointer)
	    ;; ensure that we catch _all_ mouse events
	    (when (grab-pointer
		   nil (if (eq move-resize-function 'move)
			   move-cursor-shape resize-cursor-shape))
	      (unwind-protect
		  (progn
		    (grab-keyboard w)	;this may fail
		    (unless (eq move-resize-mode 'opaque)
		      (setq move-resize-last-outline
			    (list move-resize-mode
				  move-resize-x move-resize-y
				  (+ move-resize-width
				     (car move-resize-frame))
				  (+ move-resize-height
				     (cdr move-resize-frame)))))
		    (if (eq move-resize-function 'resize)
			(unless (eq resize-edge-mode 'grab)
			  (infer-anchor))
		      (infer-directions))
		    (when (viable-move-resize-p)
		      (unless (eq move-resize-mode 'opaque)
			(apply draw-window-outline move-resize-last-outline))
		      (setq was-successful
			    (catch 'move-resize-done
			      (when from-motion-event
				(motion))
			      (recursive-edit)))))
		(ungrab-keyboard)
		(ungrab-pointer))))

	(when server-grabbed
	  (ungrab-server))
	(display-message nil)
	(frame-draw-mutex old-frame-draw-mutex)
	(frame-state-mutex old-frame-state-mutex)
	(synthetic-configure-mutex old-synthetic-configure-mutex)
	(remove-hook 'enter-workspace-hook update-edges)
	(remove-hook 'viewport-moved-hook update-edges))

      (when (and move-resize-raise-window (not (eq move-resize-mode 'opaque)))
	(raise-window* w))
      (if (eq function 'move)
	  (call-window-hook 'after-move-hook w
			    (list move-resize-directions
				  #:successful was-successful))
	(call-window-hook 'after-resize-hook w
			  (list move-resize-moving-edges
				#:successful was-successful)))))

  (define (update-edges)
    (setq move-resize-edges
	  (and (> move-snap-epsilon 0)
	       (progn
		 (get-visible-window-edges
		  #:with-ignored-windows move-snap-ignored-windows
		  #:windows-to-ignore (list move-resize-window)
		  #:include-heads t)))))

  ;; called each pointer motion event during move/resize
  (define (motion)
    (let* ((this-ptr (query-pointer))
	   (ptr-x (car this-ptr))
	   (ptr-y (cdr this-ptr))
	   logical-width logical-height)
      (unless (eq move-resize-mode 'opaque)
	(apply erase-window-outline move-resize-last-outline))
      (cond ((eq move-resize-function 'move)
	     (when (memq 'horizontal move-resize-directions)
	       (setq move-resize-x (+ move-resize-old-x
				      (- ptr-x move-resize-old-ptr-x))))
	     (when (memq 'vertical move-resize-directions)
	       (setq move-resize-y (+ move-resize-old-y
				      (- ptr-y move-resize-old-ptr-y))))
	     (when (> move-snap-epsilon 0)
	       (let
		   ((coords (snap-window-position-to-edges
			     move-resize-window (cons move-resize-x
						      move-resize-y)
			     (cons (- ptr-x (car move-resize-last-ptr))
				   (- ptr-y (cdr move-resize-last-ptr)))
			     move-resize-snap-state move-snap-epsilon
			     move-resize-edges move-snap-mode)))
		 (setq move-resize-x (car coords))
		 (setq move-resize-y (cdr coords)))))
	    ((eq move-resize-function 'resize)
	     (let
		 ((x-base (or (cdr (assq 'base-width move-resize-hints)) 0))
		  (x-inc (or (cdr (assq 'width-inc move-resize-hints)) 1))
		  (y-base (or (cdr (assq 'base-height move-resize-hints)) 0))
		  (y-inc (or (cdr (assq 'height-inc move-resize-hints)) 1))
		  (min-aspect (assq 'min-aspect move-resize-hints))
		  (max-aspect (assq 'max-aspect move-resize-hints)))

	       (when (memq resize-edge-mode '(grab border-grab))
		 (add-edges ptr-x ptr-y))
	       (cond
		((memq 'right move-resize-moving-edges)
		 (setq move-resize-width
		       (constrain-dimension-to-hints
			(+ move-resize-old-width
			   (- ptr-x move-resize-old-ptr-x))
			'x move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-height
                         (constrain-aspect-to-hints
                          move-resize-width
                          move-resize-old-height 'x min-aspect max-aspect))))

		((memq 'left move-resize-moving-edges)
		 (setq move-resize-width
		       (constrain-dimension-to-hints
			(+ move-resize-old-width
			   (- move-resize-old-ptr-x ptr-x))
                        'x move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-height
                         (constrain-aspect-to-hints
                          move-resize-width
                          move-resize-old-height 'x min-aspect max-aspect)))
		 (setq move-resize-x (- move-resize-old-x
					(- move-resize-width
					   move-resize-old-width)))))
	       (cond
		((memq 'bottom move-resize-moving-edges)
		 (setq move-resize-height
		       (constrain-dimension-to-hints
			(+ move-resize-old-height
			   (- ptr-y move-resize-old-ptr-y))
			'y move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-width
                         (constrain-aspect-to-hints
                          move-resize-height
                          move-resize-old-width 'y min-aspect max-aspect)))
                 )
		((memq 'top move-resize-moving-edges)
		 (setq move-resize-height
		       (constrain-dimension-to-hints
			(+ move-resize-old-height
			   (- move-resize-old-ptr-y ptr-y))
			'y move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-width
                         (constrain-aspect-to-hints
                          move-resize-height
                          move-resize-old-width 'y min-aspect max-aspect)))
		 (setq move-resize-y (- move-resize-old-y
					(- move-resize-height
					   move-resize-old-height)))))
	       (setq logical-width (quotient (- move-resize-width
						x-base) x-inc))
	       (setq logical-height (quotient (- move-resize-height
						 y-base) y-inc)))))
      (call-window-hook (if (eq move-resize-function 'move)
			    'while-moving-hook
			  'while-resizing-hook) move-resize-window)
      (cond ((and (eq move-resize-function 'resize) resize-show-dimensions)
	     (display-message (format nil "%dx%d"
				      ;; XXX broken if while-resizing-hook
				      ;; XXX changes dimensions..
				      logical-width logical-height)))
	    ((and (eq move-resize-function 'move) move-show-position)
	     (display-message (format nil "%+d%+d"
				      move-resize-x move-resize-y))))
      (if (eq move-resize-mode 'opaque)
	  (apply-changes)
	(let ((m-dim-x (+ move-resize-width (car move-resize-frame)))
	      (m-dim-y (+ move-resize-height (cdr move-resize-frame))))
	  (setq move-resize-last-outline (list move-resize-mode
					       move-resize-x move-resize-y
					       m-dim-x m-dim-y))
	  (apply draw-window-outline move-resize-last-outline)))
      (setq move-resize-last-ptr this-ptr)))

  ;; called when the move/resize finished (i.e. button-release event)
  (define (finished)
    (unless (eq move-resize-mode 'opaque)
      (apply erase-window-outline move-resize-last-outline))
    (apply-changes)
    (throw 'move-resize-done t))

  ;; called when B2-Click during interactive placement (see
  ;; place-window-interactively in placement.jl)
  ;; => switch to resizing the window
  (define (move-switch-to-resize)
    (when move-from-interactive-placement
      (grab-pointer nil resize-cursor-shape)
      (warp-cursor (1- (min (+ move-resize-x move-resize-width
			       (car move-resize-frame))
			    (screen-width)))
		   (1- (min (+ move-resize-y move-resize-height
			       (cdr move-resize-frame))
			    (screen-height))))
      (setq move-from-interactive-placement nil
	    move-resize-function 'resize)
      ))

  ;; called when B3-Click during interactive placement (see
  ;; place-window-interactively in placement.jl)
  ;; => vertical maximize the window then map it
  (define (move-vmaximize-then-finished)
    (if move-from-interactive-placement
      (let ((bottom-y (+ move-resize-y
			 move-resize-height
			 (cdr move-resize-frame))))
	(apply erase-window-outline move-resize-last-outline)
	(setq move-resize-height
	      (if (> bottom-y (screen-height))
		  (- move-resize-height
		     (- bottom-y (screen-height)))
		(+ move-resize-height
		   (- (screen-height) bottom-y))))
	(apply-changes)
	(throw 'move-resize-done t))))

  (define (cancel)
    (if (eq move-resize-mode 'opaque)
	(move-resize-window-to move-resize-window
			       move-resize-old-x move-resize-old-y
			       move-resize-old-width move-resize-old-height)
      (apply erase-window-outline move-resize-last-outline))
    (throw 'move-resize-done nil))

  ;; commit the current state of the move or resize
  (define (apply-changes)
    (cond
     ((>= move-resize-x (screen-width))
      (setq move-resize-x (1- (screen-width))))
     ((<= move-resize-x (- (+ move-resize-width (car move-resize-frame))))
      (setq move-resize-x (1+ (- (+ move-resize-width
				    (car move-resize-frame)))))))
    (cond
     ((>= move-resize-y (screen-height))
      (setq move-resize-y (1- (screen-height))))
     ((<= move-resize-y (- (+ move-resize-height (cdr move-resize-frame))))
      (setq move-resize-y (1+ (- (+ move-resize-height
				    (cdr move-resize-frame)))))))
    (move-resize-window-to move-resize-window
			   move-resize-x move-resize-y
			   move-resize-width move-resize-height))

  ;; called when moving, tries to decide which edges to move, which to stick
  (define (infer-anchor)
    (unless move-resize-moving-edges
      (let (tem)
	(if (and (memq resize-edge-mode '(border border-grab))
		 (clicked-frame-part)
		 (setq tem (frame-part-get (clicked-frame-part) 'class))
		 (setq tem (cdr (assq tem fp-edges-alist))))
	    (setq move-resize-moving-edges (copy-sequence tem))
	  (cond ((<= (- move-resize-old-ptr-x move-resize-old-x)
		     (/ move-resize-old-width 3))
		 (setq move-resize-moving-edges
		       (cons 'left move-resize-moving-edges)))
		((>= (- move-resize-old-ptr-x move-resize-old-x)
		     (* (/ move-resize-old-width 3) 2))
		 (setq move-resize-moving-edges
		       (cons 'right move-resize-moving-edges))))
	  (cond ((<= (- move-resize-old-ptr-y move-resize-old-y)
		     (/ move-resize-old-height 3))
		 (setq move-resize-moving-edges
		       (cons 'top move-resize-moving-edges)))
		((>= (- move-resize-old-ptr-y move-resize-old-y)
		     (* (/ move-resize-old-height 3) 2))
		 (setq move-resize-moving-edges
		       (cons 'bottom move-resize-moving-edges)))))))
    (when (null move-resize-moving-edges)
      (setq move-resize-moving-edges '(bottom right)))
    (setq move-resize-moving-edges (delete-unresizable-edges
				    move-resize-moving-edges)))

  (define (add-edges ptr-x ptr-y)
    (unless (or (and move-lock-when-maximized
		     (window-maximized-horizontally-p move-resize-window))
		(memq 'left move-resize-moving-edges)
		(memq 'right move-resize-moving-edges))
      (cond ((< ptr-x move-resize-x)
	     (setq move-resize-moving-edges
		   (cons 'left move-resize-moving-edges))
	     (setq move-resize-old-ptr-x move-resize-x))
	    ((> ptr-x (+ move-resize-x move-resize-width
			 (car move-resize-frame)))
	     (setq move-resize-moving-edges
		   (cons 'right move-resize-moving-edges))
	     (setq move-resize-old-ptr-x (+ move-resize-x move-resize-width
					    (car move-resize-frame))))))
    (unless (or (and move-lock-when-maximized
		     (window-maximized-vertically-p move-resize-window))
		(memq 'top move-resize-moving-edges)
		(memq 'bottom move-resize-moving-edges))
      (cond ((< ptr-y move-resize-y)
	     (setq move-resize-moving-edges
		   (cons 'top move-resize-moving-edges))
	     (setq move-resize-old-ptr-y move-resize-y))
	    ((> ptr-y (+ move-resize-y move-resize-height
			 (cdr move-resize-frame)))
	     (setq move-resize-moving-edges
		   (cons 'bottom move-resize-moving-edges))
	     (setq move-resize-old-ptr-y (+ move-resize-y move-resize-height
					    (cdr move-resize-frame)))))))

  (define (infer-directions)
    (unless move-resize-directions
      (setq move-resize-directions
	    (if (window-get move-resize-window 'fixed-position)
		'()
	      (list 'vertical 'horizontal))))
    (setq move-resize-directions (delete-unmovable-directions
				  move-resize-directions)))

  (define (viable-move-resize-p)
    (if (eq move-resize-function 'move)
	(not (null (delete-unmovable-directions
		    (copy-sequence move-resize-directions))))
      (not (null (delete-unresizable-edges
		  (if (memq resize-edge-mode '(region border))
		      ;; can't grab edges
		      (copy-sequence move-resize-moving-edges)
		    (list 'top 'bottom 'left 'right)))))))

  (define (resize-by-factor win amount)
    "Multiply win's dimensions by amount"
    (let* (
           (orig-wid (car (window-dimensions win)))
           (orig-hgt (cdr (window-dimensions win)))
           (new-wid (inexact->exact (floor (* amount orig-wid))))
           (new-hgt (inexact->exact (floor (* amount orig-hgt)))))
      ;; this expects integers ("800 600") and fails on floats ("800. 600.")
      (resize-window-with-hints* win new-wid new-hgt)))

  (define (double-window-size w)
    "Resize the window to the double size."
    (unless (window-get w 'fixed-size)
      (resize-by-factor w 2)))

  (define (halve-window-size w)
    "Resize the window to the halve size."
    (unless (window-get w 'fixed-size)
      (resize-by-factor w 0.5)))

;;; hook functions

  (define (lost-window w)
    (when (eq move-resize-window w)
      (finished)))

  (add-hook 'unmap-notify-hook lost-window t)
  (add-hook 'destroy-notify-hook lost-window t)

;;; Entry points

  (define (move-window-interactively w)
    "Move the window interactively, with mouse or keyboard."
    (do-move-resize w 'move))

  (define (resize-window-interactively w)
    "Resize the window interactively, with mouse or keyboard."
    (unless (window-get w 'fixed-size)
      (do-move-resize w 'resize)))

  (define (move-selected-window)
    "Wait for the user to select a window, then interactively move
that window."
    (let ((w (select-window)))
      (when w
	(move-window-interactively w))))

  (define (resize-selected-window)
    "Wait for the user to select a window, then interactively resize
that window."
    (let ((w (select-window)))
      (when w
	(resize-window-interactively w))))

  (define (resize-window-frame-to w width height)
    (let ((width-offset (- (car (window-frame-dimensions w))
			  (car (window-dimensions w))))
	  (height-offset (- (cdr (window-frame-dimensions w))
			    (cdr (window-dimensions w)))))
      (resize-window-to w (- width width-offset) (- height height-offset))))

  ;; Move Window To Center
  (define (move-window-center w)
    "Move the window to the center from the current screen."
    (move-window-to w
                    (quotient (- (screen-width)
                                 (car (window-frame-dimensions w))) 2)
                    (quotient (- (screen-height)
                                 (cdr (window-frame-dimensions w))) 2)))

  ;; resize-prompt
  (define (resize-window-prompt)
    "Resize window. Prompted to enter new size."
    (require 'sawfish.wm.util.prompt)
    (let* ((win (current-event-window))
           (w-name (window-name win))
           (old-w (car (window-dimensions win)))
           (old-h (cdr (window-dimensions win)))
	   (new-w (prompt #:title (format nil "Old width of window %s: %s\nEnter new width: " w-name old-w)))
	   (new-h (prompt #:title (format nil "Old height of window %s: %s\nEnter new height: " w-name old-h))))
      (if (and (and new-w (numberp (string->number new-w)))
	       (and new-h (numberp (string->number new-h))))
	  (resize-window-with-hints* win (string->number new-w) (string->number new-h))
	(display-message (format nil "One of the given values is not a number.")))))

  (define-command 'resize-window-prompt resize-window-prompt)

  ;; resize-to-preset-size family
  (define (resize-window-to-preset-size x y)
    ;; The size is set beforehand in the configurator.
    (let ((w (current-event-window)))
      (when (or (null w) (eq w 'root))
	(setq w (input-focus)))
      (resize-window-with-hints* w x y)))

  (define-command 'resize-window-to-preset-size
    resize-window-to-preset-size
    #:doc "Resize a window to the size you specify here."
    #:type '(and (labelled "New width:" (number 10))
		 (labelled "New height:" (number 10)))
    )

  (define (resize-window-to-preset-width x)
    ;; The width is set beforehand in the configurator.
    (let ((w (current-event-window)))
      (when (or (null w) (eq w 'root))
	(setq w (input-focus)))
      (resize-window-with-hints* w x
				 (cdr (window-dimensions w)))))
  (define-command 'resize-window-to-preset-width
    resize-window-to-preset-width
    #:doc "Resize a window to the width you specify here."
    #:type `(and (labelled "New width:" (number 10)))
    )

  (define (resize-window-to-preset-height y)
    ;; The height is set beforehand in the configurator.
    (let ((w (current-event-window)))
      (when (or (null w) (eq w 'root))
	(setq w (input-focus)))
      (resize-window-with-hints* w
				 (car (window-dimensions w)) y)))

  (define-command 'resize-window-to-preset-height
    resize-window-to-preset-height
    #:doc "Resize a window to the height you specify here."
    #:type '(and (labelled "New height:" (number 10)))
    )

  ;;###autoload
  (define-command 'move-window-center
    move-window-center #:spec "%W")
  (define-command 'move-window-interactively
    move-window-interactively #:spec "%W")
  (define-command 'resize-window-interactively
    resize-window-interactively #:spec "%W")
  (define-command 'move-selected-window
    move-selected-window)
  (define-command 'resize-selected-window
    resize-selected-window)
  (define-command 'double-window-size
    double-window-size #:spec "%W")
  (define-command 'halve-window-size
    halve-window-size #:spec "%W"))

;; nokogiri-widget.jl -- high-level widget encapsulation
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widget

    (export add-widget-prefix
	    define-widget-type
	    widget-type-constructor
	    widget-accepts-doc-string
	    widget-accepts-doc-string-p
	    make-widget
	    widget-ref
	    widget-set
	    widget-clear
	    widget-gtk-widget
	    widget-valid-p
	    call-callback
	    make-signal-callback
	    tooltip-split
	    tooltip-set
	    set-widget-enabled
	    enable-widget
	    disable-widget
	    box-spacing
	    box-border
	    button-box-spacing)

    ((open rep
	   gui.gtk-2.gtk
	   rep.system
	   rep.util.utf8
	   rep.util.misc
	   rep.regexp)
     (access rep.structures))

  (defconst box-spacing 4)
  (defconst box-border 5)
  (defconst button-box-spacing 8)

  ;; list of possible module prefixes when auto-loading widgets
  (define widget-prefixes '(sawfish.gtk.widgets))

  ;; predefined widget types are:

  ;;	(choice SYMBOLS)
  ;;	(symbol OPTIONS...)
  ;;	(string)
  ;;	(number [MIN [MAX [INITIAL-VALUE]]]) ;; integer only
  ;;	  The default of minimum is 0, max 65536,
  ;;	  and initial value is the same as the min.
  ;;	(range MIN MAX [INITIAL-VALUE]) ;; integer only
  ;;	  same as number, but using GtkScale rather than GtkSpin
  ;;	  and MIN / MAX need to be passed
  ;;	(boolean [LABEL])
  ;;	(color)
  ;;	(font)
  ;;	(or ITEMS...)
  ;;	(and ITEMS...)
  ;;	(v-and ITEMS...)
  ;;	(h-and ITEMS...)
  ;;	(labelled LABEL ITEM)
  ;;	(optional ITEM)

  ;; items without arguments may be specified by name, i.e. `string'
  ;; instead of `(string)'

  (define (add-widget-prefix arg)
    (setq widget-prefixes (cons arg (delq arg widget-prefixes))))

  (define (define-widget-type name constructor)
    (put name 'nokogiri-widget-constructor constructor))

  (define (widget-type-constructor name)
    (or (get name 'nokogiri-widget-constructor)
	;; try to dynamically load the widget constructor..
	(catch 'out
	  (mapc (lambda (prefix)
		  (let ((module-name (intern (concat (symbol-name prefix)
						     #\. (symbol-name name)))))
		    (condition-case nil
			(progn
			  (rep.structures#intern-structure module-name)
			  (throw 'out (get name 'nokogiri-widget-constructor)))
		      (error nil))))
		widget-prefixes)
	  (widget-type-constructor 'unknown))))

  (define (widget-accepts-doc-string name)
    (put name 'nokogiri-widget-accepts-doc-string t))

  (define (widget-accepts-doc-string-p name)
    (widget-type-constructor name)
    (get name 'nokogiri-widget-accepts-doc-string))

  ;; stack `and' items horizontally by default
  (define and-direction (make-fluid 'horizontal))

  (define callback-enabled (make-fluid t))

;;; High level widget management

  ;; each widget is a function taking a single argument, the operation to
  ;; perform on the item. Operations include:

  ;;	(ref) => VALUE
  ;; 	(set VALUE)
  ;;	(clear)
  ;;	gtk-widget => GTK-WIDGET
  ;;	(validp ARG) => BOOL

  ;; functional operations return the function to perform the operation

  ;; create a new item of type defined by CELL, either a list (TYPE ARGS...)
  ;; or a single symbol TYPE. CALLBACK is a function to be called whenever
  ;; the item's value changes
  (define (make-widget cell #!optional callback doc-string)
    (let*
	((type (or (car cell) cell))
	 (maker (or (widget-type-constructor type)
		    (widget-type-constructor 'unknown))))
      (if maker
	  (if (and doc-string (widget-accepts-doc-string-p type))
	      (let* ((split (tooltip-split doc-string))
		     (widget (apply maker callback (car split) (cdr cell))))
		(when (cdr split)
		  (tooltip-set (widget-gtk-widget widget) (cdr split)))
		widget)
	    (apply maker callback (cdr cell)))
	(error "No widget of type %s" type))))

  (define (widget-ref item) ((item 'ref)))

  (define (widget-set item value)
    (let-fluids ((callback-enabled nil))
      ((item 'set) value)))

  (define (widget-clear item)
    (let-fluids ((callback-enabled nil))
      ((item 'clear))))

  (define (widget-gtk-widget item) (item 'gtk-widget))

  (define (widget-valid-p item value) ((item 'validp) value))

  (define (set-widget-enabled item enabled)
    (gtk-widget-set-sensitive (widget-gtk-widget item) enabled))

  (define (enable-widget item) (set-widget-enabled item t))
  (define (disable-widget item) (set-widget-enabled item nil))

  (define (call-callback fun)
    (when (and fun (fluid callback-enabled))
      (fun)))

  (define (make-signal-callback fun) (lambda () (call-callback fun)))

;;; tooltip support

  (define tooltips)

  ;; returns (LABEL-STRING . TOOLTIP-STRING-OR-NIL)
  (define (tooltip-split doc)
    (setq doc (_ doc))
    (if (string-match "\n\n\\s*" doc)
	(cons (substring doc 0 (match-start))
	      (substring doc (match-end)))
      (cons doc nil)))

  (define (tooltip-set widget tip-string #!optional (key "Foo"))
    (unless tooltips
      (setq tooltips (gtk-tooltips-new)))
    (gtk-tooltips-set-tip tooltips widget tip-string key))

;;; Predefined widget constructors

  (define (make-choice-item changed-callback . options)
    (let ((combo (gtk-combo-box-text-new)))

      (let loop ((rest options))
        (when rest
          (gtk-combo-box-text-append-text combo
            (_ (or (cadar rest) (if (numberp (car rest))
				    (number->string (car rest))
				  (symbol-name (car rest))))))
            (loop (cdr rest))))

      (when changed-callback
	(g-signal-connect combo "changed"
			  (make-signal-callback changed-callback)))

      (gtk-widget-show combo)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-combo-box-set-active combo (or (option-index options x) 0))))
	  ((clear) nop)
	  ((ref) (lambda () (if (numberp (nth (gtk-combo-box-get-active combo) options))
			        (nth (gtk-combo-box-get-active combo) options)
			      (string->symbol (symbol-name (nth (gtk-combo-box-get-active combo) options))))))
	  ((gtk-widget) combo)
	  ((validp) (lambda (x) (option-index options x)))))))

  (define-widget-type 'choice make-choice-item)

  (define (make-symbol-item changed-callback #!rest options)
    (let ((combo (gtk-combo-box-text-new)))

      (let loop ((rest options))
        (when rest
          (gtk-combo-box-text-append-text combo
            (_ (or (cadar rest) (symbol-name (car rest)))))
            (loop (cdr rest))))

      (when changed-callback
	(g-signal-connect combo "changed"
			  (make-signal-callback changed-callback)))

      (gtk-widget-show combo)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-combo-box-set-active combo (or (option-index options x) 0))))
	  ((clear) nop)
	  ((ref) (lambda () (string->symbol (symbol-name (nth (gtk-combo-box-get-active combo) options)))))
	  ((gtk-widget) combo)
	  ((validp) (lambda (x) (symbolp x)))))))

  (define-widget-type 'symbol make-symbol-item)

  (define (make-string-item changed-callback)
    (let ((widget (gtk-entry-new)))
      (when changed-callback
	(g-signal-connect
	 widget "changed" (make-signal-callback changed-callback)))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-entry-set-text widget (or x ""))))
	  ((clear) (lambda ()
		     (gtk-entry-set-text widget "")))
	  ((ref) (lambda () (gtk-entry-get-text widget)))
	  ((gtk-widget) widget)
	  ((validp) stringp)))))

  (define-widget-type 'string make-string-item)

  (define (make-number-item changed-callback
                            #!optional minimum maximum initial-value stepping)
    ;; XXX backwards compat..
    (when (eq minimum 'nil) (setq minimum nil))
    (when (eq maximum 'nil) (setq maximum nil))
    (let ((widget (gtk-spin-button-new-with-range (or minimum 0)
						  (or maximum 65535) 1)))
      (when initial-value
        (gtk-spin-button-set-value widget initial-value))
      (when stepping
	(gtk-spin-button-set-increments widget stepping stepping))
      (when changed-callback
	(g-signal-connect
	 widget "value-changed" (make-signal-callback changed-callback)))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when (numberp x)
		     (gtk-spin-button-set-value widget x))))
	  ((clear) nop)
	  ((ref) (lambda ()
		   (let ((value (gtk-spin-button-get-value widget)))
		     (if (integerp value)
			 (inexact->exact value)
		       value))))
	  ((gtk-widget) widget)
	  ((validp) numberp)))))

  (define-widget-type 'number make-number-item)

  (define (make-range-item changed-callback range #!optional initial-value)
    (let ((widget (gtk-hscale-new-with-range (car range) (cdr range) 1)))
      (when initial-value
        (gtk-range-set-value widget initial-value)
	(gtk-scale-add-mark widget initial-value 'top (number->string initial-value)))

      (when changed-callback
	(g-signal-connect
	 widget "value-changed" (make-signal-callback changed-callback)))

      (gtk-widget-show widget)
      (gtk-scale-set-value-pos widget 'left)
      (gtk-widget-set-size-request widget 100 -1)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when (numberp x)
		     (gtk-range-set-value widget x)
		     (gtk-scale-clear-marks widget)
		     (gtk-scale-add-mark widget x 'top "°"))))
	  ((clear) (lambda () (gtk-scale-clear-marks widget)))
	  ((ref) (lambda ()
		   (let ((value (gtk-range-get-value widget)))
		     (if (integerp value)
			 (inexact->exact value)
		       value))))
	  ((gtk-widget) widget)
	  ((validp) numberp)))))

  (define-widget-type 'range make-range-item)

  (define (make-boolean-item changed-callback #!optional label)
    (let ((widget (if label
		      (gtk-check-button-new-with-label label)
		    (gtk-check-button-new))))
      (when label
	(gtk-label-set-justify (car (gtk-container-get-children widget)) 'left))
      (when changed-callback
	(g-signal-connect
	 widget "toggled" (make-signal-callback changed-callback)))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-toggle-button-set-active widget x)))
	  ((clear) (lambda ()
		     (gtk-toggle-button-set-active widget nil)))
	  ((ref) (lambda ()
		   (gtk-toggle-button-get-active widget)))
	  ((gtk-widget) widget)
	  ((validp) (lambda () t))))))

  (define-widget-type 'boolean make-boolean-item)
  (widget-accepts-doc-string 'boolean)

;;; ``Meta'' widgets

  (define (make-or-item changed-callback #!rest items)
    (setq items (mapcar (lambda (x)
			  (make-widget x changed-callback)) items))
    (let* ((box (gtk-vbox-new nil box-spacing))
	   (hboxes (mapcar (lambda ()
			     (gtk-hbox-new nil box-spacing)) items))
	   (checks (mapcar (lambda ()
			     (gtk-check-button-new)) items))
	   (enabled-item nil)
	   (refresh-item
	    (lambda ()
	      (let ((i 0))
		(mapc (lambda (x)
			(set-widget-enabled x (eq enabled-item x))
			(gtk-toggle-button-set-active
			 (nth i checks) (eq enabled-item x))
			(setq i (1+ i))) items))
	      (call-callback changed-callback)))
	   (toggle-fun
	    (lambda (index)
	      (when (or (eq (nth index items) enabled-item)
			(gtk-toggle-button-get-active (nth index checks)))
		(setq enabled-item (and (gtk-toggle-button-get-active
					 (nth index checks))
					(nth index items))))
	      (refresh-item))))
      (do ((i 0 (1+ i)))
	  ((= i (length items)))
	(g-signal-connect (nth i checks) "toggled" (lambda ()
                                                     (toggle-fun i)))
	(gtk-box-pack-start box (nth i hboxes))
	(gtk-box-pack-start (nth i hboxes) (nth i checks))
	(gtk-box-pack-start (nth i hboxes) (widget-gtk-widget (nth i items))))
      (refresh-item)
      (gtk-widget-show-all box)
      (lambda (op)
	(case op
	  ((set)
	   (lambda (x)
	     (if (null x)
		 (setq enabled-item nil)
	       (if (and enabled-item (widget-valid-p enabled-item x))
		   ;; set the enabled value if possible
		   (widget-set enabled-item x)
		 ;; look for a matching type
		 (catch 'done
		   (do ((i 0 (1+ i)))
		       ((= i (length items)))
		     (when (widget-valid-p (nth i items) x)
		       (setq enabled-item (nth i items))
		       (widget-set enabled-item x)
		       (throw 'done t)))
		   (message (format nil (_ "No matching item for %S") x)))))
	     (refresh-item)))
	  ((clear) (lambda ()
		     (setq enabled-item nil)
		     (mapc (lambda (item)
			     (widget-clear item)) items)
		     (refresh-item)))
	  ((ref) (lambda ()
		   (and enabled-item (widget-ref enabled-item))))
	  ((gtk-widget) box)
	  ((validp) (lambda (x)
		      (catch 'out
			(do ((i 0 (1+ i)))
			    ((= i (length items)))
			  (when (widget-valid-p (nth i items) x)
			    (throw 'out t))))))))))

  (define-widget-type 'or make-or-item)

  (defun make-and-item (changed-callback #!rest items)
    (setq items (mapcar (lambda (x)
			  (make-widget x changed-callback)) items))
    (let
	((box ((if (eq (fluid and-direction) 'horizontal)
		   gtk-hbox-new
		 gtk-vbox-new) nil box-spacing)))
      (do ((i 0 (1+ i)))
	  ((= i (length items)))
	(gtk-box-pack-start box (widget-gtk-widget (nth i items)) t t))
      (gtk-widget-show-all box)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (do ((i 0 (1+ i)))
		       ((= i (length items)))
		     (widget-set (nth i items) (nth i x)))))
	  ((clear) (lambda () (mapc widget-clear items)))
	  ((ref) (lambda () (mapcar widget-ref items)))
	  ((gtk-widget) box)
	  ((validp) (lambda (x)
		      (cond ((null x))
			    ((or (not (listp x))
				 (/= (length x) (length items)))
			     nil)
			    (t
			     (catch 'out
			       (do ((i 0 (1+ i)))
				   ((= i (length items)))
				 (unless (widget-valid-p
					  (nth i items) (nth i x))
				   (throw 'out nil)))
			       t)))))))))

  (define-widget-type 'and make-and-item)

  (define-widget-type 'h-and (lambda (#!rest args)
			       (let-fluids ((and-direction 'horizontal))
				 (apply make-and-item args))))

  (define-widget-type 'v-and (lambda (#!rest args)
			       (let-fluids ((and-direction 'vertical))
				 (apply make-and-item args))))

  (define (make-labelled-item changed-callback label item)
    (let ((box (gtk-hbox-new nil box-spacing)))
      (setq item (make-widget item changed-callback))
      ;; XXX i18n the label string?
      (gtk-box-pack-start box (gtk-label-new (_ label)))
      (gtk-container-add box (widget-gtk-widget item))
      (gtk-widget-show-all box)
      (lambda (op)
	(if (eq op 'gtk-widget)
	    box
	  (item op)))))

  (define-widget-type 'labelled make-labelled-item)

  (define (make-optional-item changed-callback item)
    (let ((box (gtk-hbox-new nil box-spacing))
	  (check (gtk-check-button-new)))
      (setq item (make-widget item changed-callback))
      (gtk-box-pack-start box check)
      (gtk-box-pack-start box (widget-gtk-widget item))
      (g-signal-connect
       check "toggled"
       (lambda ()
	 (set-widget-enabled item (gtk-toggle-button-get-active check))
	 (call-callback changed-callback)))
      (gtk-toggle-button-set-active check nil)
      (disable-widget item)
      (gtk-widget-show-all box)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when x
		     (widget-set item x))
		   (set-widget-enabled item x)
		   (gtk-toggle-button-set-active check x)))
	  ((clear) (lambda ()
		     (widget-clear item)
		     (disable-widget item)
		     (gtk-toggle-button-set-active check nil)))
	  ((ref) (lambda ()
		   (and (gtk-toggle-button-get-active check)
			(widget-ref item))))
	  ((gtk-widget) box)
	  ((validp) (lambda (x)
		      (or (null x) (widget-valid-p item x))))))))

  (define-widget-type 'optional make-optional-item)

  (define (make-quoted-item changed item)
    (let ((widget (make-widget item changed)))
      (lambda (op)
	(case op
	  ((ref) (lambda ()
		   (list 'quote (widget-ref widget))))
	  ((set) (lambda (x)
		   (widget-set widget (cadr x))))
	  ((validp) (lambda (x)
		      (and (eq (car x) 'quote)
			   (widget-valid-p widget (cadr x)))))
	  (t (widget op))))))

  (define-widget-type 'quoted make-quoted-item)

;;; widget used for unknown widget types

  (define (make-unknown-item changed-callback)
    (declare (unused changed-callback))
    (let ((label (gtk-label-new (format nil (_ "** unknown widget **  "))))
	  value)
      (gtk-widget-show label)
      (lambda (op)
	(case op
	  ((set) (lambda (x) (setq value x)))
	  ((clear) (lambda () (setq value nil)))
	  ((ref) (lambda () value))
	  ((gtk-widget) label)
	  ((validp) (lambda (x) (declare (unused x)) t))))))

  (define-widget-type 'unknown make-unknown-item))

;; apps-menu.jl -- generate applications menu from *.desktop files

;; (c) 2009 - 2011 Matthew Love

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Description:
;;
;; Generate applications menu from *.desktop files in the directory
;; /usr/share/applications .

;; "Desktop entry specification", *.desktop files spec, is defined in:
;; http://standards.freedesktop.org/desktop-entry-spec/latest/

;; 'fdo' in some names stands for "freedesktop.org".

;;; Todo:

;;; Notes: we don't handle non-utf8 encoding.

;;; Code:

(define-structure sawfish.wm.ext.apps-menu

    (export generate-apps-menu
	    init-apps-menu
	    update-apps-menu
	    parse-fdo-file
	    fdo-filter-record
	    fdo-toplevel-filter
	    fdo-nodisplay-filter
	    fdo-hidden-filter
	    fdo-onlyshowin-filter
	    fdo-notshowin-filter
	    fdo-default-filter
	    fdo-some-filter)

    (open rep
	  rep.io.files
	  rep.io.streams
	  rep.system
	  rep.regexp
	  sawfish.wm
	  sawfish.wm.menus
	  sawfish.wm.commands
	  sawfish.wm.commands.launcher)

  (define-structure-alias apps-menu sawfish.wm.ext.apps-menu)

  ;; User Options

  (defvar apps-menu-autogen t
    "If non-nil, `apps-menu' is automatically generated from `user-apps-menu'
and *.desktop files. If you set `apps-menu', then it won't happen anyway.")

  (defvar user-apps-menu '()
    "Your own applications menu entries. It is followed by auto generated
applications menu.")

  (defvar apps-menu-filter 'default
    "The filter to use while generating the `apps-menu'. The default filters
include `fdo-toplevel-filter' `fdo-nodisplay-filter' `fdo-hidden-filter'
`fdo-onlyshowin-filter' and `fdo-notshowin-filter'.  Can also be set with
'default or 'some, both of which are combinations of the default filters,
'default uses them all and 'some only uses `fdo-notshowin-filter' and
`fdo-onlyshowin-filter'. This can be set to 'nil or '() to perform no
filtering on the `apps-menu'.")

  (defvar apps-menu-associate-categories t
    "Associate desktop entry categories with the category-master-list")

  (defvar desktop-directory '("/usr/share/applications")
    "List of directories to look for *.desktop files.")

  (defvar apps-menu-alphabetize t
    "Sort the apps menu alphabetically.")

  (defvar apps-menu-lang nil
    "Human language for applications menu, in string. Default is set from locale.")

  ;; The Master Category List

  (defvar desktop-cat-alist
    '(("Top-Level" . ("Application" "Applications" "GNOME" "KDE" "X-Xfce-Toplevel"
		      "GTK" "Qt"))
      ("Desktop" . ("X-Desktop" "X-DesktopApplets" "X-DesktopCountry"))
      ("Office" . ("Office" "WordProcessor" "Presentation" "X-Document"
		   "TextEditor" "SpreadSheet" "Calculator" "X-Calculate"
		   "Chart" "FlowChart" "Finance" "Calendar" "ContactManagement"
		   "X-Personal" "X-PersonalUtility" "Dictionary"))
      ("Internet" . ("Telephony" "Network" "Dialup" "VideoConference"
		     "RemoteAccess" "News" "HamRadio" "FileTransfer"
		     "X-Internet" "P2P" "Email" "WebBrowser" "IRCClient"
		     "Chat" "InstantMessaging" "Chat" "WebDevelopment"))
      ("Games" . ("Game" "ActionGame" "AdventureGame" "ArcadeGame"
		  "BoardGame" "BlocksGame" "CardGame" "KidsGame"
		  "LogicGame" "RolePlaying"))
      ("Graphics" . ("RasterGraphics" "VectorGraphics" "X-GraphicUtility"
		     "2DGraphics" "3dGraphics" "3DGraphics" "Scanning"
		     "OCR" "Photography" "Viewer" "Publishing" "Art"
		     "ImageProcessing"))
      ("Media" . ("AudioVideo" "Audio", "Video" "Midi" "Mixer" "Sequencer"
		  "Tuner" "TV" "AudioVideoEditing" "Player" "Recorder"
		  "DiscBurning" "Music"))
      ("Science" . ("Science" "Astrology" "ArtificialIntelligence"
		    "Astronomy" "Biology" "Chemistry" "ComputerScience"
		    "DataVisualization" "Electricity" "Robotics" "Physics"
		    "Math" "Education" "Geography" "Simulation"))
      ("Development" . ("GUIDesigner" "IDE" "Profiling" "RevisionControl"
			"ProjectManagement" "Translation" "Java"
			"Development" "Documentation" "Editors"))
      ("Utility" . ("X-SystemMemory" "Utility" "X-SetupEntry"
		    "X-SetupUtility" "X-SystemMemory" "TextTools"
		    "TelephonyTools" "Accessibility" "Clock" "ConsoleOnly"))
      ("Filesystem" . ("X-FileSystemFind" "X-FileSystemUtility" "Archiving"
		       "FileManager" "X-FileSystemMount" "Compression"))
      ("System" . ("X-SystemSchedule" "System" "X-SystemMemory" "Emulator"
		   "TerminalEmulator" "Printing" "Monitor" "Security"))
      ("Settings" . ("Settings" "HardwareSettings" "PackageManager"
		     "X-GNOME-PersonalSettings" "DesktopSettings"))
      ("Exiles" . ("Exile"))))

  (define this-line nil)

  (define name-string "Name[")

  ;; fdo-file-parsing

  (define (fdo-skip-line-p instring)
    "Return `t' if `instring' should be skipped."
    (or (eq (aref instring 0) ?#)
	(eq (aref instring 0) ?\n)))

  (define (check-if-desktop-stream instream)
    "Check for the `[Desktop Entry]' line in `instream'"
    (let ((line (read-line instream)))
      (when line
	(if (string= line "[Desktop Entry]\n")
	    't
	  (when (fdo-skip-line-p line)
	    (check-if-desktop-stream instream))))))

  (define (desktop-file-p directory-file)
    "Quickly check if `directory-file' is a `*.desktop' file."
    (condition-case nil
	(let ((this-file (open-file directory-file 'read)))
	  (check-if-desktop-stream this-file))
      ;; unreadable -> return nil
      (file-error)))

  (define (get-key-value-pair instring)
    "Split a `*.desktop' file line into its key-value pair.
Returns (key . value)"
    ;; Sorry, \\s doesn't work. Why??
    (if (string-match "^([^ \t=]+)[ \t]*=[ \t]*([^\n]+)" instring)
	(cons (expand-last-match "\\1") (expand-last-match "\\2"))
      ;; Ususally, it doesn't reach here.
      (cons "" "")))

  (define (fdo-group-p instring)
    (eq (aref instring 0) ?\[))

  (define (get-fdo-group instring)
    (substring instring 1 (- (length instring) 2)))

  (define (parse-fdo-file-line infile)
    "Parse a `*.desktop' file list.
Returns (group1 (key1 . value1) ... group2 (keyA . valueA) ...)"
    (when (setq this-line (read-line infile))
      (if (not (fdo-skip-line-p this-line))
	  (cons
	   (if (fdo-group-p this-line)
	       (get-fdo-group this-line)
	     (get-key-value-pair this-line))
	   (parse-fdo-file-line infile))
	(parse-fdo-file-line infile))))

  (define (parse-fdo-file infile)
    "Parse a `*.desktop' file and return an alist."
    (when (desktop-file-p infile)
      (let ((d-file (open-file infile 'read)))
	(parse-fdo-file-line d-file))))

  ;; desktop-file mapping

  (define (map-desk-files in-desk-files in-directory #!optional (extension "."))
    "Given a list of filenames and a directory, will expand those
filenames to include the full path."
    (when in-desk-files
      (if (string-match extension (car in-desk-files))
	  (cons (expand-file-name (car in-desk-files) in-directory)
		(map-desk-files (cdr in-desk-files) in-directory extension))
	(map-desk-files (cdr in-desk-files) in-directory extension))))

  (define (map-dir-files directories #!optional (extension "."))
    "Given a list of directory paths, will return a list of
files in those direcories with their full pathnames.  Optionally
`extension' may be set to show only files that match the regexp."
    (when directories
      (if (file-directory-p (car directories))
	  (let ((desk0 (directory-files (car directories))))
	    (cons (map-desk-files desk0 (car directories) extension)
		  (map-dir-files (cdr directories) extension)))
	(map-dir-files (cdr directories) extension))))

  (define (flatten input)
    (cond ((null input) nil)
	  ((atom input) (list input))
	  (t (append (flatten (car input))
		     (flatten (cdr input))))))

  ;; language functions

  (defmacro simplify-mlang (mlang mlevel)
    `(and
      ,(cond
	((or (= 0 mlevel) (not mlevel))
	 `(or (string-looking-at "([a-z]*)(_?)([A-Z]*?)(@)([A-Z]*[a-z]*)?" ,mlang)
	      (string-looking-at "([a-z]*)(_..)|([a-z]*)?" ,mlang)
	      (string-looking-at "([a-z]*)?" ,mlang)))
	((= 1 mlevel)
	 `(string-looking-at "([a-z]*)(_?)([A-Z]*?)(@)([A-Z]*[a-z]*)?" ,mlang))
	((= 2 mlevel)
	 `(string-looking-at "([a-z]*)(_..)|([a-z]*)?" ,mlang))
	((= 3 mlevel)
	 `(string-looking-at "([a-z]*)?" ,mlang)))
      (expand-last-match "\&")))

  (define (find-lang-string)
    (let loop ((lang-vars '("LC_ALL" "LC_MESSAGES" "LANG")))
      (and lang-vars
	   (let ((mlang (getenv (car lang-vars))))
	     (if mlang (simplify-mlang mlang 0)
	       (loop (cdr lang-vars)))))))

  ;; Functions for categories

  (define (remove-duplicates input)
    "Remove duplicate entries from `input'"
    (do ((a '() (if (member (car input) a) a (cons (car input) a)))
	 (input input (cdr input)))
	((null input) (reverse a))))

  (define (merge-list input delimiter)
    "Merge a cons list `input' into a string separated by `delimiter'"
    (when input
      (concat (car input) delimiter
	      (merge-list (cdr input) delimiter))))

  (define (associate-categories fdol)
    "Associate the `Categories' value(s) with the category
master list, `desktop-cat-alist'.  Returns a modified desktop-file entry."
    (when fdol
      (let* ((these-categories
	      (delete "" (string-split ";" (cdr (assoc "Categories" fdol)))))
	     (category-list '()))
	(let loop ((this-category these-categories))
	  (if (null this-category)
	      (let ((cat-string (merge-list (remove-duplicates category-list) ";")))
		(rplacd (assoc "Categories" fdol)
			cat-string)
		fdol)
	    (progn (mapc (lambda (ent)
			   (if (member (car this-category) ent)
			       (setq category-list
				     (append category-list (list (car ent))))))
			 desktop-cat-alist)
		   (loop (cdr this-category))))))))

  (define (grab-category input cat)
    "Remove duplicate categories from a generated apps-menu list by
category name."
    (when input
      (let ((cat-list '()))
	(setq cat-list (append cat-list (list cat)))
	(let loop ((this-line input))
	  (if (not this-line) cat-list
	    (progn (if (string= (caar this-line) cat)
		       (setq cat-list (append cat-list (list (cdr (car this-line))))))
		   (loop (cdr this-line))))))))

  (define (make-category-list input)
    "Return a list of the categories to be used in the menu."
    (when input
      (cons (caar input)
	    (make-category-list (cdr input)))))

  (define (consolidate-menu input)
    "Reduce the menu down so that each menu entry is inside a
single category."
    (when input
      (let ((cat-list (remove-duplicates (make-category-list input)))
	    (out-menu nil))
	(mapc (lambda (x)
		(setq out-menu
		      (append out-menu
			      (list (remove-duplicates (grab-category input x))))))
	      cat-list)
	out-menu)))

  ;; In fact, %% means "escaped %". Let's forget :/
  (define (trim-percent string)
    "Cut the string before % sign if present."
    (if (string-match "%" string)
	(substring string 0 (match-start))
      string))

  (define (alphabetize-entries saw-menu)
    "Alphabetize the entries in the category menus."
    (if saw-menu
	(cons (cons (car (car saw-menu))
		    (sort (cdr (car saw-menu))
			  (lambda (a b)
			    (string< (string-downcase (car a)) (string-downcase (car b))))))
	      (alphabetize-entries (cdr saw-menu)))))

  (define (fdo-exile fdo-list)
    "Exile `fdo-list' -- i.e., mark it as an invalid or garbled
desktop file."
    (let ((exile-comment
	   (cons "fdo-Comment" "This .desktop file was exiled, use \
with caution, file may be corrupt.\n"))
	  (exile-cmd
	   (cons "Exec" "sawfish-client -c 'display-errors'\n")))
      ;; Set the fdo-Comment key, mentioning the exile.
      (setq fdo-list (append fdo-list (list exile-comment)))
      ;; Set the NoDisplay key to 'true'
      (if (assoc "NoDisplay" fdo-list)
	  (rplacd (assoc "NoDisplay" fdo-list) "true")
	(setq fdo-list (append fdo-list (cons (cons "NoDisplay" "true")))))
      ;; Set the Categories & Category keys to 'Exile'
      (if (assoc "Categories" fdo-list)
	  (rplacd (assoc "Categories" fdo-list) "Exile")
	(setq fdo-list (append fdo-list (cons (cons "Categories" "Exile")))))
      (if (assoc "Category" fdo-list)
	  (rplacd (assoc "Category" fdo-list) "Exile")
	(setq fdo-list (append fdo-list (cons (cons "Category" "Exile")))))
      ;; Set the Exec key if it does not exist
      (when (not (assoc "Exec" fdo-list))
	(setq fdo-list (append fdo-list (list exile-cmd))))
      ;; Set the Name key if it does not exist
      (when (and (not (assoc "Name" fdo-list))
		 (not (assoc (concat name-string apps-menu-lang "]") fdo-list)))
	(setq fdo-list (append fdo-list (cons (cons "Name" "Unknown")))))
      fdo-list))

  (define (fdo-check-exile fdo-list)
    "If `fdo-list' doesn't have a Categories, Exec, or Name field,
exile it."
    (when fdo-list
      (if (or (and (not (assoc "Categories" fdo-list))
		   (not (stringp (cdr (assoc "Categories" fdo-list)))))
	      (not (assoc "Exec" fdo-list))
	      (and (not (assoc "Name" fdo-list))
		   (not (assoc (concat name-string
				       apps-menu-lang "]")
			       fdo-list))))
	  (fdo-exile fdo-list)
	fdo-list)))

  (define (fdo-double-check-category fdo-list)
    "Make sure the Category key is present and correctly asigned."
    (when fdo-list
      (if (assoc "Category" fdo-list)
	  (if (or (not (stringp (cdr (assoc "Category" fdo-list))))
		  (equal "" (cdr (assoc "Category" fdo-list)))
		  (not (stringp (cdr (assoc "Category" fdo-list)))))
	      (rplacd (assoc "Category" fdo-list) "Exile"))
	(append fdo-list (cons (cons "Category" "Exile")))))
    fdo-list)

  (define (determine-desktop-name fdo-list)
    "Get the correct Name[*] entry based on language settings."
    (or (when apps-menu-lang
	  (let ((mlang-1 (concat name-string (simplify-mlang apps-menu-lang 1) "]"))
		(mlang-2 (concat name-string (simplify-mlang apps-menu-lang 2) "]"))
		(mlang-3 (concat name-string (simplify-mlang apps-menu-lang 3) "]")))
	    (or (cdr (assoc mlang-1 fdo-list))
		(cdr (assoc mlang-2 fdo-list))
		(cdr (assoc mlang-3 fdo-list)))))
	(cdr (assoc "Name" fdo-list))))

  (define (determine-desktop-exec fdo-list)
    "Determine the correct `(system exec)' function from the given fdo alist"
    (if (assoc "Terminal" fdo-list)
	(if (string-match "[Tt]" (cdr (assoc "Terminal" fdo-list)))
	    (list 'system
		  (concat xterm-program " -e "
			  (trim-percent (cdr (assoc "Exec" fdo-list)))
			  " &"))
	  (list 'system
		(concat (trim-percent (cdr (assoc "Exec" fdo-list)))
			" &")))
      (list 'system
	    (concat (trim-percent (cdr (assoc "Exec" fdo-list)))
		    " &"))))

  ;; Apps-Menu Filtering

  (define (fdo-nodisplay-filter fdol)
    "Return the desktop-file-list if NoDisplay is False, or if NoDisplay is
not present in the desktop-file-list"
    (if (assoc "NoDisplay" fdol)
	(if (string-match "[Ff]" (cdr (assoc "NoDisplay" fdol)))
	    fdol)
      fdol))

  (define (fdo-hidden-filter fdol)
    "Return the desktop-file-list if Hidden is False, or if Hidden is
not present in the desktop-file-list"
    (if (assoc "Hidden" fdol)
	(if (string-match "[Ff]" (string-downcase (cdr (assoc "OnlyShowIn" fdol))))
	    fdol)
      fdol))

  (define (fdo-onlyshowin-filter fdol)
    "Return the desktop-file-list if OnlyShowIn matches `desktop-environment',
or if OnlyShowIn is not present in the desktop-file-list"
    (if (assoc "OnlyShowIn" fdol)
	(if (string-match desktop-environment (string-downcase (cdr (assoc "OnlyShowIn" fdol))))
	    fdol)
      fdol))

  (define (fdo-notshowin-filter fdol)
    "Return the desktop-file-list if NotShowIn does not match `desktop-environment',
or if NotShowIn is not present in the desktop-file-list"
    (if (assoc "NotShowIn" fdol)
	(if (not (string-match desktop-environment (string-downcase (cdr (assoc "NotShowIn" fdol)))))
	    fdol)
      fdol))

  (define (fdo-associate-categories-filter fdol)
    "If `apps-menu-associate-categories' is true, filter the
desktop-entry through `fdo-associate-categories'."
    (when fdol
      (if apps-menu-associate-categories
	  (associate-categories fdol)
	fdol)))

  (define (fdo-toplevel-filter fdol)
    "Return the desktop-file-list if the `Category' is of the
Top-Level variety."
    (when fdol
      (if (not (equal "Top-Level" (cdr (assoc "Category" fdol))))
	  fdol)))

  (define (fdo-default-filter fdol)
    "The default fdo-filter, combines the above."
    (fdo-toplevel-filter
     (fdo-hidden-filter
      (fdo-notshowin-filter
       (fdo-onlyshowin-filter
	(fdo-nodisplay-filter fdol))))))

  (define (fdo-some-filter fdol)
    "The 'some fdo-filter, will only respect
the NotShowIn and OnlyShowIn keys."
    (fdo-toplevel-filter
     (fdo-notshowin-filter
      (fdo-onlyshowin-filter fdol))))

  (define (fdo-filter-record fdol filter)
"Let `filter' process `fdol', a desktop file entry, and return the result.
`filter' can be a function, or a symbol 'default or 'some. If it isn't set,
return `fdol' as-is."
    (if (not filter) fdol
      (condition-case nil
	  (let loop ((fdo-entry fdol))
	    (when (consp fdo-entry)
	      (cons
	       ;; Check if entry is valid
	       (fdo-double-check-category
		(fdo-check-exile
		 ((cond
		   ;; default filter is chosen
		   ((equal filter 'default)
		    fdo-default-filter)
		   ;; some flter is chosen
		   ((equal filter 'some)
		    fdo-some-filter)
		   ;; user filter is chosen
		   ((closurep filter)
		    filter))
		  (car fdo-entry))))
	       (loop (cdr fdo-entry)))))
	(error fdol))))

  (define (split-desktop-entry fdol)
    "Split a desktop entry into several entries, each containing one
of the categories of the original."
    (when fdol
      (let ((new-fdol fdol)
	    (category-string (cdr (assoc "Categories" fdol))))
	(when (stringp category-string)
	  (let loop ((categories
		      (delete "" (string-split ";" category-string))))
	    (when categories
	      (append (list
		       (append new-fdol (list (cons "Category" (car categories)))))
		      (loop (cdr categories)))))))))

  ;; Sawfish-menu generation

  (define (fdo-menu-entry fdol)
    "Return menu-entry list from a fdo-list."
    ;; Generate the menu-entry list
    (generate-menu-entry
     ;; Filter entry by pre-made or user function
     (delete nil
	     (fdo-filter-record
	      ;; Split the desktop-entry by category
	      (split-desktop-entry
	       ;; Rename 'Categories' key based on category-list
	       (fdo-associate-categories-filter
		;; Check if entry is valid
		(fdo-check-exile fdol)))
	      apps-menu-filter))))

  (define (generate-menu-entry fdo-list)
    "Generate a menu entry to run the program specified in the the
desktop file `desk-file'."
    (when (car fdo-list)
      (cons (list (cdr (assoc "Category" (car fdo-list)))
		  (determine-desktop-name (car fdo-list))
		  (determine-desktop-exec (car fdo-list)))
	    (generate-menu-entry (cdr fdo-list)))))

  (define (generate-apps-menu)
    "Returns the list of applications menu which can be used for `apps-menu'."
    (unless apps-menu-lang
      (setq apps-menu-lang (find-lang-string)))
    (let ((desk-files (flatten (map-dir-files desktop-directory ".desktop")))
	  (local-menu nil))
      (mapc
       (lambda (x)
	 (setq local-menu
	       (append local-menu
		       (fdo-menu-entry
			(parse-fdo-file x)))))
       desk-files)
      (if apps-menu-alphabetize
	  (alphabetize-entries (consolidate-menu (sort (delete nil local-menu) string<)))
	(consolidate-menu (sort (delete nil local-menu) string<)))))

  (define (init-apps-menu)
    "If `apps-menu' is nil, then call `update-apps-menu'. This function
is intended to be called during Sawfish initialization."
    (unless apps-menu
      (update-apps-menu)))

  (define (update-apps-menu)
    "Set `apps-menu' to `user-apps-menu', and if `apps-menu-autogen' is non-nil,
append the auto generated one."
    (if apps-menu-autogen
	(setq apps-menu
	      (append user-apps-menu (generate-apps-menu)))
      (setq apps-menu user-apps-menu)))

  (define-command 'update-apps-menu update-apps-menu)
  )

;; nokogiri-widgets/match-window.jl -- match-window widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.match-window

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
          rep.util.misc
          sawfish.gtk.widget
          sawfish.gtk.widgets.simple-dialog
          sawfish.cfg.wm)

  (defconst matcher-count 3)

;;; the widget representing the `matchers' frame

  ;; (match-window:matchers x-properties)

  (define (make-match-window:matchers changed-callback x-properties)
    (declare (unused changed-callback))

    (let ((frame (gtk-frame-new (_ "Matchers")))
	  (table (gtk-table-new matcher-count 3 nil))
	  (l10n-x-properties (mapcar (lambda (x)
				       (cons (car x) (_ (cdr x))))
				     x-properties))
	  (widgets '()))

      (do ((i 0 (1+ i)))
	  ((= i matcher-count))
	(let ((combo (gtk-combo-new))
	      (entry (gtk-entry-new))
	      (button (gtk-button-new-with-label (_ "Grab..."))))
	  (gtk-combo-set-popdown-strings
	   combo (cons "" (mapcar cdr l10n-x-properties)))
	  (gtk-table-attach-defaults table button 0 1 i (1+ i))
	  (gtk-table-attach-defaults table combo 1 2 i (1+ i))
	  (gtk-table-attach-defaults table entry 2 3 i (1+ i))
	  (g-signal-connect
           button "clicked"
           (lambda ()
             (let* ((string (gtk-entry-get-text (gtk-combo-entry combo)))
                    (x-prop (and string (car (rassoc string
                                                     l10n-x-properties)))))
               (when string
                 (let ((prop (wm-grab-x-property (or x-prop (intern string)))))
                   (gtk-entry-set-text entry (if (stringp prop)
                                                 prop
                                               "")))))))
	  (setq widgets (nconc widgets (list (cons combo entry))))))
      (gtk-container-add frame table)
      (gtk-container-set-border-width table box-border)
      (gtk-table-set-row-spacings table box-spacing)
      (gtk-table-set-col-spacings table box-spacing)
      (gtk-widget-show-all frame)

      (lambda (op)
	(case op
	  ((gtk-widget) frame)
	  ((clear)
	   (lambda ()
	     (mapc (lambda (cell)
		     (gtk-entry-set-text (gtk-combo-entry (car cell)) "")
		     (gtk-entry-set-text (cdr cell) "")) widgets)))
	  ((set)
	   (lambda (x)
	     (do ((cells widgets (cdr cells))
		  (rest x (cdr rest)))
		 ((or (null cells) (null rest)))
	       (gtk-entry-set-text
		(gtk-combo-entry (caar cells))
		(or (cdr (assq (caar rest) l10n-x-properties)) (caar rest)))
	       (gtk-entry-set-text (cdar cells) (cdar rest)))))
	  ((ref)
	   (lambda ()
	     (let loop ((cells widgets)
			(out '()))
	       (if (null cells)
		   (nreverse out)
		 (let ((name (gtk-entry-get-text
			      (gtk-combo-entry (caar cells))))
		       (value (gtk-entry-get-text (cdar cells))))
		   (if (or (string= name "") (string= value ""))
		       (loop (cdr cells) out)
		     (let ((prop (rassoc name l10n-x-properties)))
		       (if prop
			   (setq name (car prop))
			 (setq name (intern name))))
		     (loop (cdr cells)
			   (cons (cons name value) out))))))))
	  ((validp) listp)))))

  (define-widget-type 'match-window:matchers make-match-window:matchers)

;;; the widget representing the `Actions' frame

  (define (make-match-window:actions changed-callback properties)
    (declare (unused changed-callback))

    (let ((frame (gtk-frame-new (_ "Actions")))
	  (book (gtk-notebook-new))
	  (widgets '()))

      (mapc
       (lambda (sub)
	 (let ((title (car sub))
	       (table (gtk-table-new (length (cdr sub)) 2 nil))
	       (vbox (gtk-vbox-new nil box-spacing)))
	   (do ((i 0 (1+ i))
		(props (cdr sub) (cdr props)))
	       ((null props))
	     (let* ((prop (car props))
		    (widget (make-widget
			     (if (eq (cadr prop) 'boolean)
				 `(scheme-boolean)
			       `(optional ,(cadr prop))))))
	       (gtk-table-attach-defaults
		table (make-left-label (beautify-symbol-name (car prop)))
		0 1 i (1+ i))
	       (gtk-table-attach-defaults
		table (widget-gtk-widget widget) 1 2 i (1+ i))
	       (setq widgets (cons (cons (car prop) widget) widgets))))
	   (gtk-table-set-row-spacings table box-spacing)
	   (gtk-table-set-col-spacings table box-spacing)
	   (gtk-box-pack-start vbox table)
	   (gtk-notebook-append-page book vbox (gtk-label-new title))))
       properties)

      (setq widgets (nreverse widgets))
      (gtk-container-set-border-width book box-border)
      (gtk-container-add frame book)
      (gtk-widget-show-all frame)

      (lambda (op)
	(case op
	  ((gtk-widget) frame)
	  ((clear) (lambda ()
		     (mapc (lambda (x) (widget-clear (cdr x))) widgets)))
	  ((set)
	   (lambda (x)
	     (mapc (lambda (cell)
		     (let ((widget (cdr (assq (car cell) widgets))))
		       (when widget
			 (widget-set widget (cdr cell))))) x)))
	  ((ref)
	   (lambda ()
	     (let loop ((rest widgets)
			(out '()))
	       (if (null rest)
		   (nreverse out)
		 (let ((value (widget-ref (cdar rest))))
		   (if value
		       (loop (cdr rest) (cons (cons (caar rest) value) out))
		     (loop (cdr rest) out)))))))))))

  (define-widget-type 'match-window:actions make-match-window:actions)

  (define (make-left-label string)
    (let ((hbox (gtk-hbox-new nil 0)))
      (gtk-box-pack-start hbox (gtk-label-new string))
      hbox))

;;; the main widget

  ;; (match-window ...)

  (define (make-match-window-item changed-callback properties x-properties)

    (define (print-matcher match)
      (if (stringp (cdr match)) (cdr match) "?"))

    (define (print-action action)
      (cond ((memq (cdr action) '(t #t))
	     (format nil "%s" (car action)))
	    ((eq (cdr action) '#f)
	     (format nil "%s %s" (_ "not") (car action)))
	    (t (format nil "%s=%s" (car action) (cdr action)))))

    (define (print x)
      (list (mapconcat print-matcher (car x) ", ")
	    (mapconcat print-action (cdr x) ", ")))

    (define (dialog title callback #!key for value)
      (declare (unused title))
      (let ((vbox (gtk-vbox-new nil box-spacing))
	    (matcher-widget (make-widget
			     `(match-window:matchers ,x-properties)))
	    (action-widget (make-widget
			    `(match-window:actions ,properties))))
	(gtk-container-add vbox (widget-gtk-widget matcher-widget))
	(gtk-container-add vbox (widget-gtk-widget action-widget))
	(when value
	  (widget-set matcher-widget (car value))
	  (widget-set action-widget (cdr value)))
	(gtk-widget-show vbox)

	(simple-dialog (_ "Match Window Properties") vbox
		       (lambda ()
			 (callback (cons (widget-ref matcher-widget)
					 (widget-ref action-widget))))
		       for)))

    (define (validp x) (and (consp x) (listp (car x)) (listp (cdr x))))

    (define (type op)
      (case op
	((print) print)
	((dialog) dialog)
	((validp) validp)))

    (make-widget `(list ,type (,(_ "Matchers") ,(_ "Actions")))
		 changed-callback))

  (define-widget-type 'match-window make-match-window-item))

;; events.jl

;; Copyright (C) 2011, hqwrong <hq.wrong@gmail.com>

;; This file is part of sawfish.

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.

;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License                                                                                      
;; along with this program.  If not, see `http://www.gnu.org/licenses/'. 


(define-structure sawfish.wm.util.events

    (export event-wait-for
            event-exit-wait)
    
    (open rep
          rep.data
          rep.system
          rep.regexp
          sawfish.wm.misc
          sawfish.wm.events
          sawfish.wm.commands)

  (define (event-wait-for #!key
                          (keymap '(keymap))
                          loop-on-unbound
                          handler
                          exit-hook)
    "wait-for an event.
`keymap' is used as the override keymap during `recursive-edit'
        
`handler' is a list of cons cell,as (predict
. procedure), when the key event has no bound in keymap, then the
key name is passed to each predict by order.Once eval to t ,then
the associated procedure is called with key as argument,then
re-enter in `recursive-edit'.Otherwise,if loop-on-unbound is nil,
exit loop.

`exit-hook' ,if setted,will be called with key's name as argument,
after exit from loop."
   
    (call-with-keyboard-grabbed
     (lambda ()
       (let ((override-keymap keymap)
             (re-exit (lambda ()
                        (throw 're-exit
                               (event-name (current-event)))))
             (key nil))
         (add-hook 'unbound-key-hook re-exit)
         (while (catch 'event-exit
                  (setq key
                        (catch 're-exit
                              (recursive-edit)))
                  (when handler
                     (do ((l handler (cdr handler)))
                        ((null l) t)
                        (let* ((cell (car l))
                               (pred (car cell))
                               (proc (cdr cell)))
                          (when (pred key)
                            (proc key)
                            (throw 'event-exit t)))))
                  (when (not loop-on-unbound)
                    (throw 'event-exit nil))
                  t)
           t)
         (when exit-hook
           (exit-hook key))
         (remove-hook 'unbound-key-hook re-exit)))))

  (define (event-exit-wait)
    "You'll find it useful,when you're using `event-wait-for'"
    (throw 'event-exit)))

;; autoload.jl -- Initialise auto-load functions

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; to rebuild this file, load a tags file containing all lisp files
;; into Jade, then run:

;; (tags-map-buffers
;;  (lambda (buffer)
;;    (add-autoloads "SOURCE-DIR/lisp/sawfish/wm/autoload.jl" buffer)))

;;; ::autoload-start::
(autoload-command 'customize 'sawfish.wm.customize)
(autoload-command 'popup-window-ops-menu 'sawfish.wm.menus)
(autoload-command 'popup-root-menu 'sawfish.wm.menus)
(autoload-command 'popup-apps-menu 'sawfish.wm.menus)
(autoload-command 'popup-window-list-menu 'sawfish.wm.menus)
(autoload-window-animator 'wireframe 'sawfish.wm.animation.main)
(autoload-window-animator 'solid 'sawfish.wm.animation.main)
(autoload-window-animator 'cross 'sawfish.wm.animation.main)
(autoload-window-animator 'elliptical 'sawfish.wm.animation.main)
(autoload-window-animator 'draft 'sawfish.wm.animation.main)
(autoload-command 'next-workspace-window 'sawfish.wm.commands.cycle)
(autoload-command 'previous-workspace-window 'sawfish.wm.commands.cycle)
(autoload-command 'next-window 'sawfish.wm.commands.cycle)
(autoload-command 'previous-window 'sawfish.wm.commands.cycle)
(autoload-command 'describe-symbol 'sawfish.wm.commands.describe)
(autoload-command 'describe-symbol-to-screen 'sawfish.wm.commands.describe)
(autoload-command 'apropos-function 'sawfish.wm.commands.describe)
(autoload-command 'apropos-function-to-screen 'sawfish.wm.commands.describe)
(autoload-command 'apropos-variable 'sawfish.wm.commands.describe)
(autoload-command 'apropos-variable-to-screen 'sawfish.wm.commands.describe)
(autoload-command 'make-group-sticky 'sawfish.wm.commands.groups)
(autoload-command 'make-group-unsticky 'sawfish.wm.commands.groups)
(autoload-command 'toggle-group-sticky 'sawfish.wm.commands.groups)
(autoload-command 'send-group-to-current-workspace 'sawfish.wm.commands.groups)
(autoload-command 'send-group-to-next-workspace 'sawfish.wm.commands.groups)
(autoload-command 'send-group-to-previous-workspace 'sawfish.wm.commands.groups)
(autoload-command 'move-group-to-current-viewport 'sawfish.wm.commands.groups)
(autoload-command 'move-group-left 'sawfish.wm.commands.groups)
(autoload-command 'move-group-right 'sawfish.wm.commands.groups)
(autoload-command 'move-group-up 'sawfish.wm.commands.groups)
(autoload-command 'move-group-down 'sawfish.wm.commands.groups)
(autoload-command 'raise-group 'sawfish.wm.commands.groups)
(autoload-command 'lower-group 'sawfish.wm.commands.groups)
(autoload-command 'raise-lower-group 'sawfish.wm.commands.groups)
(autoload-command 'raise-group-depth 'sawfish.wm.commands.groups)
(autoload-command 'lower-group-depth 'sawfish.wm.commands.groups)
(autoload-command 'delete-group 'sawfish.wm.commands.groups)
(autoload-command 'grow-window-left 'sawfish.wm.commands.grow-pack)
(autoload-command 'grow-window-right 'sawfish.wm.commands.grow-pack)
(autoload-command 'grow-window-up 'sawfish.wm.commands.grow-pack)
(autoload-command 'grow-window-down 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-left 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-right 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-up 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-down 'sawfish.wm.commands.grow-pack)
(autoload-command 'shrink-window-left 'sawfish.wm.commands.shrink-yank)
(autoload-command 'shrink-window-right 'sawfish.wm.commands.shrink-yank)
(autoload-command 'shrink-window-up 'sawfish.wm.commands.shrink-yank)
(autoload-command 'shrink-window-down 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-left 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-right 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-up 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-down 'sawfish.wm.commands.shrink-yank)
(autoload-command 'help:show-faq 'sawfish.wm.commands.help)
(autoload-command 'help:show-news 'sawfish.wm.commands.help)
(autoload-command 'help:show-programmer-manual 'sawfish.wm.commands.help)
(autoload-command 'help:show-homepage 'sawfish.wm.commands.help)
(autoload-command 'help:about 'sawfish.wm.commands.help)
(autoload-command 'move-cursor-right 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-left 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-up 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-down 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-right-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-left-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-up-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-down-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northwest 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northeast 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southwest 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southeast 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northwest-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northeast-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southwest-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southeast-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-center 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-window-center 'sawfish.wm.commands.move-resize)
(autoload-command 'move-window-interactively 'sawfish.wm.commands.move-resize)
(autoload-command 'resize-window-interactively 'sawfish.wm.commands.move-resize)
(autoload-command 'move-selected-window 'sawfish.wm.commands.move-resize)
(autoload-command 'double-window-size 'sawfish.wm.commands.move-resize)
(autoload-command 'halve-window-size 'sawfish.wm.commands.move-resize)
(autoload-command 'resize-selected-window 'sawfish.wm.commands.move-resize)
(autoload-command 'raise-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-and-pass-through-click-if-focused 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-or-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-window-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-group-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-transients-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'size-window-add-row 'sawfish.wm.commands.size-window)
(autoload-command 'size-window-subtract-row 'sawfish.wm.commands.size-window)
(autoload-command 'size-window-add-column 'sawfish.wm.commands.size-window)
(autoload-command 'size-window-subtract-column 'sawfish.wm.commands.size-window)
(autoload-command 'slide-window-left 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-window-right 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-window-up 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-window-down 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-left 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-right 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-up 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-down 'sawfish.wm.commands.slide-window)
(defgroup gpsy "Grow, Pack, Shrink & Yank" :group move :require sawfish.wm.commands.grow-pack)
(defgroup cycle "Window Cycling" :group focus :require sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-windows 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-windows-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-group 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-group-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-among-groups 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-among-groups-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-prefix 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-prefix-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-class 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-class-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-dock 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-dock-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'xterm 'sawfish.wm.commands.launcher)
(autoload-command 'browser 'sawfish.wm.commands.launcher)
(autoload-command 'poweroff 'sawfish.wm.commands.poweroff)
(autoload-command 'rename-window 'sawfish.wm.windows)
(defgroup audio "Sound" :require sawfish.wm.ext.audio-events)
(defgroup match-window "Window Rules" :layout single :require sawfish.wm.ext.match-window)
(defgroup tooltips "Tooltips" :group appearance :require sawfish.wm.ext.tooltips)
(defgroup window-history "History" :group match-window :require sawfish.wm.ext.window-history)
(defgroup messages "Messages" :group misc :require sawfish.wm.util.prompt)
(autoload-placement-mode 'first-fit 'sawfish.wm.placement.smart #:for-normal t)
(autoload-placement-mode 'best-fit 'sawfish.wm.placement.smart #:for-normal t)
(autoload-placement-mode 'best-fit-group 'sawfish.wm.placement.smart #:for-normal t)
(autoload-placement-mode 'first-fit-or-interactive 'sawfish.wm.placement.smart #:for-normal t)
(autoload-command 'maximize-window 'sawfish.wm.state.maximize)
(autoload-command 'unmaximize-window 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-vertically 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-horizontally 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-horizontally-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-vertically-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-vertically 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-horizontally 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-horizontally-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-vertically-toggle 'sawfish.wm.state.maximize)
(autoload-command 'describe-key 'sawfish.wm.util.keymap)
(autoload-command 'describe-key-to-screen 'sawfish.wm.util.keymap)
(autoload-command 'quote-event 'sawfish.wm.util.keymap)
(autoload-placement-mode 'top-left 'sawfish.wm.placement.top-left #:for-normal t)
(autoload-placement-mode 'stagger 'sawfish.wm.placement.stagger #:for-normal t)
(autoload-placement-mode 'off-center 'sawfish.wm.placement.off-center #:for-normal t)
(autoload-command 'move-viewport-right 'sawfish.wm.viewport)
(autoload-command 'move-viewport-up 'sawfish.wm.viewport)
(autoload-command 'move-viewport-down 'sawfish.wm.viewport)
(autoload-command 'move-viewport-left 'sawfish.wm.viewport)
(autoload-command 'move-window-right 'sawfish.wm.viewport)
(autoload-command 'move-window-up 'sawfish.wm.viewport)
(autoload-command 'move-window-down 'sawfish.wm.viewport)
(autoload-command 'move-window-left 'sawfish.wm.viewport)
(autoload-command 'move-viewport-next 'sawfish.wm.commands.viewport-extras)
(autoload-command 'move-viewport-previous 'sawfish.wm.commands.viewport-extras)
(autoload-command 'move-window-previous 'sawfish.wm.commands.viewport-extras)
(autoload-command 'move-window-next 'sawfish.wm.commands.viewport-extras)
(autoload-command 'workspace-down 'sawfish.wm.ext.workspace-grid)
(autoload-command 'workspace-up 'sawfish.wm.ext.workspace-grid)
(autoload-command 'workspace-left 'sawfish.wm.ext.workspace-grid)
(autoload-command 'workspace-right 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-down 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-up 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-left 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-right 'sawfish.wm.ext.workspace-grid)
(autoload-command 'jump-or-exec 'sawfish.wm.commands.jump-or-exec)
(autoload-command 'tile-windows 'sawfish.wm.edge.tile)
;;; ::autoload-end::

;; apps-menu.jl -- generate applications menu from *.desktop files

;; (c) 2009 - 2011 Matthew Love

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;;; Description:
;;
;; Generate applications menu from *.desktop files in the directory
;; /usr/share/applications .

;; "Desktop entry specification", *.desktop files spec, is defined in:
;; http://standards.freedesktop.org/desktop-entry-spec/latest/

;; 'fdo' in some names stands for "freedesktop.org".

;;; Todo:

;;; Notes: we don't handle non-utf8 encoding.

;;; Code:

(define-structure sawfish.wm.ext.apps-menu

    (export generate-apps-menu
	    init-apps-menu
	    update-apps-menu
	    parse-fdo-file
	    fdo-filter-record
	    fdo-toplevel-filter
	    fdo-nodisplay-filter
	    fdo-hidden-filter
	    fdo-onlyshowin-filter
	    fdo-notshowin-filter
	    fdo-default-filter
	    fdo-some-filter)

    (open rep
	  rep.io.files
	  rep.io.streams
	  rep.system
	  rep.regexp
	  sawfish.wm
	  sawfish.wm.menus
	  sawfish.wm.commands
	  sawfish.wm.commands.launcher)

  (define-structure-alias apps-menu sawfish.wm.ext.apps-menu)

  ;; User Options

  (defvar apps-menu-autogen t
    "If non-nil, `apps-menu' is automatically generated from `user-apps-menu'
and *.desktop files. If you set `apps-menu', then it won't happen anyway.")

  (defvar user-apps-menu '()
    "Your own applications menu entries. It is followed by auto generated
applications menu.")

  (defvar apps-menu-filter 'default
    "The filter to use while generating the `apps-menu'. The default filters
include `fdo-toplevel-filter' `fdo-nodisplay-filter' `fdo-hidden-filter'
`fdo-onlyshowin-filter' and `fdo-notshowin-filter'.  Can also be set with
'default or 'some, both of which are combinations of the default filters,
'default uses them all and 'some only uses `fdo-notshowin-filter' and
`fdo-onlyshowin-filter'. This can be set to 'nil or '() to perform no
filtering on the `apps-menu'.")

  (defvar apps-menu-associate-categories t
    "Associate desktop entry categories with the category-master-list")

  (defvar desktop-directory '("/usr/share/applications")
    "List of directories to look for *.desktop files.")

  (defvar apps-menu-alphabetize t
    "Sort the apps menu alphabetically.")

  (defvar apps-menu-lang nil
    "Human language for applications menu, in string. Default is set from locale.")

  ;; The Master Category List

  (defvar desktop-cat-alist
    '(("Top-Level" . ("Application" "Applications" "GNOME" "KDE" "X-Xfce-Toplevel"
		      "GTK" "Qt"))
      ("Desktop" . ("X-Desktop" "X-DesktopApplets" "X-DesktopCountry"))
      ("Office" . ("Office" "WordProcessor" "Presentation" "X-Document"
		   "TextEditor" "SpreadSheet" "Calculator" "X-Calculate"
		   "Chart" "FlowChart" "Finance" "Calendar" "ContactManagement"
		   "X-Personal" "X-PersonalUtility" "Dictionary"))
      ("Internet" . ("Telephony" "Network" "Dialup" "VideoConference"
		     "RemoteAccess" "News" "HamRadio" "FileTransfer"
		     "X-Internet" "P2P" "Email" "WebBrowser" "IRCClient"
		     "Chat" "InstantMessaging" "Chat" "WebDevelopment"))
      ("Games" . ("Game" "ActionGame" "AdventureGame" "ArcadeGame"
		  "BoardGame" "BlocksGame" "CardGame" "KidsGame"
		  "LogicGame" "RolePlaying"))
      ("Graphics" . ("RasterGraphics" "VectorGraphics" "X-GraphicUtility"
		     "2DGraphics" "3dGraphics" "3DGraphics" "Scanning"
		     "OCR" "Photography" "Viewer" "Publishing" "Art"
		     "ImageProcessing"))
      ("Media" . ("AudioVideo" "Audio", "Video" "Midi" "Mixer" "Sequencer"
		  "Tuner" "TV" "AudioVideoEditing" "Player" "Recorder"
		  "DiscBurning" "Music"))
      ("Science" . ("Science" "Astrology" "ArtificialIntelligence"
		    "Astronomy" "Biology" "Chemistry" "ComputerScience"
		    "DataVisualization" "Electricity" "Robotics" "Physics"
		    "Math" "Education" "Geography" "Simulation"))
      ("Development" . ("GUIDesigner" "IDE" "Profiling" "RevisionControl"
			"ProjectManagement" "Translation" "Java"
			"Development" "Documentation" "Editors"))
      ("Utility" . ("X-SystemMemory" "Utility" "X-SetupEntry"
		    "X-SetupUtility" "X-SystemMemory" "TextTools"
		    "TelephonyTools" "Accessibility" "Clock" "ConsoleOnly"))
      ("Filesystem" . ("X-FileSystemFind" "X-FileSystemUtility" "Archiving"
		       "FileManager" "X-FileSystemMount" "Compression"))
      ("System" . ("X-SystemSchedule" "System" "X-SystemMemory" "Emulator"
		   "TerminalEmulator" "Printing" "Monitor" "Security"))
      ("Settings" . ("Settings" "HardwareSettings" "PackageManager"
		     "X-GNOME-PersonalSettings" "DesktopSettings"))
      ("Exiles" . ("Exile"))))

  (define this-line nil)

  (define name-string "Name[")

  ;; fdo-file-parsing

  (define (fdo-skip-line-p instring)
    "Return `t' if `instring' should be skipped."
    (or (eq (aref instring 0) ?#)
	(eq (aref instring 0) ?\n)))

  (define (check-if-desktop-stream instream)
    "Check for the `[Desktop Entry]' line in `instream'"
    (let ((line (read-line instream)))
      (when line
	(if (string= line "[Desktop Entry]\n")
	    't
	  (when (fdo-skip-line-p line)
	    (check-if-desktop-stream instream))))))

  (define (desktop-file-p directory-file)
    "Quickly check if `directory-file' is a `*.desktop' file."
    (condition-case nil
	(let ((this-file (open-file directory-file 'read)))
	  (check-if-desktop-stream this-file))
      ;; unreadable -> return nil
      (file-error)))

  (define (get-key-value-pair instring)
    "Split a `*.desktop' file line into its key-value pair.
Returns (key . value)"
    ;; Sorry, \\s doesn't work. Why??
    (if (string-match "^([^ \t=]+)[ \t]*=[ \t]*([^\n]+)" instring)
	(cons (expand-last-match "\\1") (expand-last-match "\\2"))
      ;; Usually, it doesn't reach here.
      (cons "" "")))

  (define (fdo-group-p instring)
    (eq (aref instring 0) ?\[))

  (define (get-fdo-group instring)
    (substring instring 1 (- (length instring) 2)))

  (define (parse-fdo-file-line infile)
    "Parse a `*.desktop' file list.
Returns (group1 (key1 . value1) ... group2 (keyA . valueA) ...)"
    (when (setq this-line (read-line infile))
      (if (not (fdo-skip-line-p this-line))
	  (cons
	   (if (fdo-group-p this-line)
	       (get-fdo-group this-line)
	     (get-key-value-pair this-line))
	   (parse-fdo-file-line infile))
	(parse-fdo-file-line infile))))

  (define (parse-fdo-file infile)
    "Parse a `*.desktop' file and return an alist."
    (when (desktop-file-p infile)
      (let ((d-file (open-file infile 'read)))
	(parse-fdo-file-line d-file))))

  ;; desktop-file mapping

  (define (map-desk-files in-desk-files in-directory #!optional (extension "."))
    "Given a list of filenames and a directory, will expand those
filenames to include the full path."
    (when in-desk-files
      (if (string-match extension (car in-desk-files))
	  (cons (expand-file-name (car in-desk-files) in-directory)
		(map-desk-files (cdr in-desk-files) in-directory extension))
	(map-desk-files (cdr in-desk-files) in-directory extension))))

  (define (map-dir-files directories #!optional (extension "."))
    "Given a list of directory paths, will return a list of
files in those direcories with their full pathnames.  Optionally
`extension' may be set to show only files that match the regexp."
    (when directories
      (if (file-directory-p (car directories))
	  (let ((desk0 (directory-files (car directories))))
	    (cons (map-desk-files desk0 (car directories) extension)
		  (map-dir-files (cdr directories) extension)))
	(map-dir-files (cdr directories) extension))))

  (define (flatten input)
    (cond ((null input) nil)
	  ((atom input) (list input))
	  (t (append (flatten (car input))
		     (flatten (cdr input))))))

  ;; language functions

  (defmacro simplify-mlang (mlang mlevel)
    `(and
      ,(cond
	((or (= 0 mlevel) (not mlevel))
	 `(or (string-looking-at "([a-z]*)(_?)([A-Z]*?)(@)([A-Z]*[a-z]*)?" ,mlang)
	      (string-looking-at "([a-z]*)(_..)|([a-z]*)?" ,mlang)
	      (string-looking-at "([a-z]*)?" ,mlang)))
	((= 1 mlevel)
	 `(string-looking-at "([a-z]*)(_?)([A-Z]*?)(@)([A-Z]*[a-z]*)?" ,mlang))
	((= 2 mlevel)
	 `(string-looking-at "([a-z]*)(_..)|([a-z]*)?" ,mlang))
	((= 3 mlevel)
	 `(string-looking-at "([a-z]*)?" ,mlang)))
      (expand-last-match "\&")))

  (define (find-lang-string)
    (let loop ((lang-vars '("LC_ALL" "LC_MESSAGES" "LANG")))
      (and lang-vars
	   (let ((mlang (getenv (car lang-vars))))
	     (if mlang (simplify-mlang mlang 0)
	       (loop (cdr lang-vars)))))))

  ;; Functions for categories

  (define (remove-duplicates input)
    "Remove duplicate entries from `input'"
    (do ((a '() (if (member (car input) a) a (cons (car input) a)))
	 (input input (cdr input)))
	((null input) (reverse a))))

  (define (merge-list input delimiter)
    "Merge a cons list `input' into a string separated by `delimiter'"
    (when input
      (concat (car input) delimiter
	      (merge-list (cdr input) delimiter))))

  (define (associate-categories fdol)
    "Associate the `Categories' value(s) with the category
master list, `desktop-cat-alist'.  Returns a modified desktop-file entry."
    (when fdol
      (let* ((these-categories
	      (delete "" (string-split ";" (cdr (assoc "Categories" fdol)))))
	     (category-list '()))
	(let loop ((this-category these-categories))
	  (if (null this-category)
	      (let ((cat-string (merge-list (remove-duplicates category-list) ";")))
		(rplacd (assoc "Categories" fdol)
			cat-string)
		fdol)
	    (progn (mapc (lambda (ent)
			   (if (member (car this-category) ent)
			       (setq category-list
				     (append category-list (list (car ent))))))
			 desktop-cat-alist)
		   (loop (cdr this-category))))))))

  (define (grab-category input cat)
    "Remove duplicate categories from a generated apps-menu list by
category name."
    (when input
      (let ((cat-list '()))
	(setq cat-list (append cat-list (list cat)))
	(let loop ((this-line input))
	  (if (not this-line) cat-list
	    (progn (if (string= (caar this-line) cat)
		       (setq cat-list (append cat-list (list (cdr (car this-line))))))
		   (loop (cdr this-line))))))))

  (define (make-category-list input)
    "Return a list of the categories to be used in the menu."
    (when input
      (cons (caar input)
	    (make-category-list (cdr input)))))

  (define (consolidate-menu input)
    "Reduce the menu down so that each menu entry is inside a
single category."
    (when input
      (let ((cat-list (remove-duplicates (make-category-list input)))
	    (out-menu nil))
	(mapc (lambda (x)
		(setq out-menu
		      (append out-menu
			      (list (remove-duplicates (grab-category input x))))))
	      cat-list)
	out-menu)))

  ;; In fact, %% means "escaped %". Let's forget :/
  (define (trim-percent string)
    "Cut the string before % sign if present."
    (if (string-match "%" string)
	(substring string 0 (match-start))
      string))

  (define (alphabetize-entries saw-menu)
    "Alphabetize the entries in the category menus."
    (if saw-menu
	(cons (cons (car (car saw-menu))
		    (sort (cdr (car saw-menu))
			  (lambda (a b)
			    (string< (string-downcase (car a)) (string-downcase (car b))))))
	      (alphabetize-entries (cdr saw-menu)))))

  (define (fdo-exile fdo-list)
    "Exile `fdo-list' -- i.e., mark it as an invalid or garbled
desktop file."
    (let ((exile-comment
	   (cons "fdo-Comment" "This .desktop file was exiled, use \
with caution, file may be corrupt.\n"))
	  (exile-cmd
	   (cons "Exec" "sawfish-client -c 'display-errors'\n")))
      ;; Set the fdo-Comment key, mentioning the exile.
      (setq fdo-list (append fdo-list (list exile-comment)))
      ;; Set the NoDisplay key to 'true'
      (if (assoc "NoDisplay" fdo-list)
	  (rplacd (assoc "NoDisplay" fdo-list) "true")
	(setq fdo-list (append fdo-list (cons (cons "NoDisplay" "true")))))
      ;; Set the Categories & Category keys to 'Exile'
      (if (assoc "Categories" fdo-list)
	  (rplacd (assoc "Categories" fdo-list) "Exile")
	(setq fdo-list (append fdo-list (cons (cons "Categories" "Exile")))))
      (if (assoc "Category" fdo-list)
	  (rplacd (assoc "Category" fdo-list) "Exile")
	(setq fdo-list (append fdo-list (cons (cons "Category" "Exile")))))
      ;; Set the Exec key if it does not exist
      (when (not (assoc "Exec" fdo-list))
	(setq fdo-list (append fdo-list (list exile-cmd))))
      ;; Set the Name key if it does not exist
      (when (and (not (assoc "Name" fdo-list))
		 (not (assoc (concat name-string apps-menu-lang "]") fdo-list)))
	(setq fdo-list (append fdo-list (cons (cons "Name" "Unknown")))))
      fdo-list))

  (define (fdo-check-exile fdo-list)
    "If `fdo-list' doesn't have a Categories, Exec, or Name field,
exile it."
    (when fdo-list
      (if (or (and (not (assoc "Categories" fdo-list))
		   (not (stringp (cdr (assoc "Categories" fdo-list)))))
	      (not (assoc "Exec" fdo-list))
	      (and (not (assoc "Name" fdo-list))
		   (not (assoc (concat name-string
				       apps-menu-lang "]")
			       fdo-list))))
	  (fdo-exile fdo-list)
	fdo-list)))

  (define (fdo-double-check-category fdo-list)
    "Make sure the Category key is present and correctly assigned."
    (when fdo-list
      (if (assoc "Category" fdo-list)
	  (if (or (not (stringp (cdr (assoc "Category" fdo-list))))
		  (equal "" (cdr (assoc "Category" fdo-list)))
		  (not (stringp (cdr (assoc "Category" fdo-list)))))
	      (rplacd (assoc "Category" fdo-list) "Exile"))
	(append fdo-list (cons (cons "Category" "Exile")))))
    fdo-list)

  (define (determine-desktop-name fdo-list)
    "Get the correct Name[*] entry based on language settings."
    (or (when apps-menu-lang
	  (let ((mlang-1 (concat name-string (simplify-mlang apps-menu-lang 1) "]"))
		(mlang-2 (concat name-string (simplify-mlang apps-menu-lang 2) "]"))
		(mlang-3 (concat name-string (simplify-mlang apps-menu-lang 3) "]")))
	    (or (cdr (assoc mlang-1 fdo-list))
		(cdr (assoc mlang-2 fdo-list))
		(cdr (assoc mlang-3 fdo-list)))))
	(cdr (assoc "Name" fdo-list))))

  (define (determine-desktop-exec fdo-list)
    "Determine the correct `(system exec)' function from the given fdo alist"
    (if (assoc "Terminal" fdo-list)
	(if (string-match "[Tt]" (cdr (assoc "Terminal" fdo-list)))
	    (list 'system
		  (concat xterm-program " -e "
			  (trim-percent (cdr (assoc "Exec" fdo-list)))
			  " &"))
	  (list 'system
		(concat (trim-percent (cdr (assoc "Exec" fdo-list)))
			" &")))
      (list 'system
	    (concat (trim-percent (cdr (assoc "Exec" fdo-list)))
		    " &"))))

  ;; Apps-Menu Filtering

  (define (fdo-nodisplay-filter fdol)
    "Return the desktop-file-list if NoDisplay is False, or if NoDisplay is
not present in the desktop-file-list"
    (if (assoc "NoDisplay" fdol)
	(if (string-match "[Ff]" (cdr (assoc "NoDisplay" fdol)))
	    fdol)
      fdol))

  (define (fdo-hidden-filter fdol)
    "Return the desktop-file-list if Hidden is False, or if Hidden is
not present in the desktop-file-list"
    (if (assoc "Hidden" fdol)
	(if (string-match "[Ff]" (string-downcase (cdr (assoc "OnlyShowIn" fdol))))
	    fdol)
      fdol))

  (define (fdo-onlyshowin-filter fdol)
    "Return the desktop-file-list if OnlyShowIn matches `desktop-environment',
or if OnlyShowIn is not present in the desktop-file-list"
    (if (assoc "OnlyShowIn" fdol)
	(if (string-match desktop-environment (string-downcase (cdr (assoc "OnlyShowIn" fdol))))
	    fdol)
      fdol))

  (define (fdo-notshowin-filter fdol)
    "Return the desktop-file-list if NotShowIn does not match `desktop-environment',
or if NotShowIn is not present in the desktop-file-list"
    (if (assoc "NotShowIn" fdol)
	(if (not (string-match desktop-environment (string-downcase (cdr (assoc "NotShowIn" fdol)))))
	    fdol)
      fdol))

  (define (fdo-associate-categories-filter fdol)
    "If `apps-menu-associate-categories' is true, filter the
desktop-entry through `fdo-associate-categories'."
    (when fdol
      (if apps-menu-associate-categories
	  (associate-categories fdol)
	fdol)))

  (define (fdo-toplevel-filter fdol)
    "Return the desktop-file-list if the `Category' is of the
Top-Level variety."
    (when fdol
      (if (not (equal "Top-Level" (cdr (assoc "Category" fdol))))
	  fdol)))

  (define (fdo-default-filter fdol)
    "The default fdo-filter, combines the above."
    (fdo-toplevel-filter
     (fdo-hidden-filter
      (fdo-notshowin-filter
       (fdo-onlyshowin-filter
	(fdo-nodisplay-filter fdol))))))

  (define (fdo-some-filter fdol)
    "The 'some fdo-filter, will only respect
the NotShowIn and OnlyShowIn keys."
    (fdo-toplevel-filter
     (fdo-notshowin-filter
      (fdo-onlyshowin-filter fdol))))

  (define (fdo-filter-record fdol filter)
"Let `filter' process `fdol', a desktop file entry, and return the result.
`filter' can be a function, or a symbol 'default or 'some. If it isn't set,
return `fdol' as-is."
    (if (not filter) fdol
      (condition-case nil
	  (let loop ((fdo-entry fdol))
	    (when (consp fdo-entry)
	      (cons
	       ;; Check if entry is valid
	       (fdo-double-check-category
		(fdo-check-exile
		 ((cond
		   ;; default filter is chosen
		   ((equal filter 'default)
		    fdo-default-filter)
		   ;; some flter is chosen
		   ((equal filter 'some)
		    fdo-some-filter)
		   ;; user filter is chosen
		   ((closurep filter)
		    filter))
		  (car fdo-entry))))
	       (loop (cdr fdo-entry)))))
	(error fdol))))

  (define (split-desktop-entry fdol)
    "Split a desktop entry into several entries, each containing one
of the categories of the original."
    (when fdol
      (let ((new-fdol fdol)
	    (category-string (cdr (assoc "Categories" fdol))))
	(when (stringp category-string)
	  (let loop ((categories
		      (delete "" (string-split ";" category-string))))
	    (when categories
	      (append (list
		       (append new-fdol (list (cons "Category" (car categories)))))
		      (loop (cdr categories)))))))))

  ;; Sawfish-menu generation

  (define (fdo-menu-entry fdol)
    "Return menu-entry list from a fdo-list."
    ;; Generate the menu-entry list
    (generate-menu-entry
     ;; Filter entry by pre-made or user function
     (delete nil
	     (fdo-filter-record
	      ;; Split the desktop-entry by category
	      (split-desktop-entry
	       ;; Rename 'Categories' key based on category-list
	       (fdo-associate-categories-filter
		;; Check if entry is valid
		(fdo-check-exile fdol)))
	      apps-menu-filter))))

  (define (generate-menu-entry fdo-list)
    "Generate a menu entry to run the program specified in the the
desktop file `desk-file'."
    (when (car fdo-list)
      (cons (list (cdr (assoc "Category" (car fdo-list)))
		  (determine-desktop-name (car fdo-list))
		  (determine-desktop-exec (car fdo-list)))
	    (generate-menu-entry (cdr fdo-list)))))

  (define (generate-apps-menu)
    "Returns the list of applications menu which can be used for `apps-menu'."
    (unless apps-menu-lang
      (setq apps-menu-lang (find-lang-string)))
    (let ((desk-files (flatten (map-dir-files desktop-directory ".desktop")))
	  (local-menu nil))
      (mapc
       (lambda (x)
	 (setq local-menu
	       (append local-menu
		       (fdo-menu-entry
			(parse-fdo-file x)))))
       desk-files)
      (if apps-menu-alphabetize
	  (alphabetize-entries (consolidate-menu (sort (delete nil local-menu) string<)))
	(consolidate-menu (sort (delete nil local-menu) string<)))))

  (define (init-apps-menu)
    "If `apps-menu' is nil, then call `update-apps-menu'. This function
is intended to be called during Sawfish initialization."
    (unless apps-menu
      (update-apps-menu)))

  (define (update-apps-menu)
    "Set `apps-menu' to `user-apps-menu', and if `apps-menu-autogen' is non-nil,
append the auto generated one."
    (if apps-menu-autogen
	(setq apps-menu
	      (append user-apps-menu (generate-apps-menu)))
      (setq apps-menu user-apps-menu)))

  (define-command 'update-apps-menu update-apps-menu)
  )

;; animation/setup.jl -- Set up animation feature.

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.animation.setup

    (export define-window-animator
	    autoload-window-animator
	    run-window-animator
	    record-window-animator)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.custom
	  rep.util.autoloader)
  ;; For backward compatibility.
  (define-structure-alias window-anim sawfish.wm.animation.setup)

  (define window-animators nil
    "List of all possible window animation types.")

  (defgroup animation "Animation" :group appearance)

  (defcustom default-window-animator 'none
    "Animation when an window is iconified."
    :type (choice none solid wireframe cross elliptical draft)
    :tooltip "Can be overriden from \"Window Rules\"."
    :group (appearance animation))

;;; animator registration

  (define (define-window-animator name fun)
    "Define a window animator called NAME (a symbol) that is managed by
function FUN. FUN is called as (FUN WINDOW OP [ACTION]) when it should change
the state of an animation sequence. OP may be one of the symbols `start',
`stop'."
    (put name 'window-animator fun)
    (unless (memq name window-animators)
      (setq window-animators (cons name (delq name window-animators)))
;;      (custom-set-property 'default-window-animator
;;			   ':options window-animators)
      ))

  (define (getter name) (get name 'window-animator))

  (define autoload-window-animator
    (make-autoloader getter define-window-animator))

  (define window-animator (autoloader-ref getter))

;;; running animators

  (define (run-window-animator w action)
    "Invoke an animation for ACTION on window W."
    (let ((running (window-get w 'running-animator)))
      (when running
	(running w 'stop)))
    (let ((animator (or (window-get w 'animator) default-window-animator)))
      (when animator
	((window-animator animator) w 'start action))))

  (define (record-window-animator w animator)
    "Note that window W currently has an animation running; being controlled
by animator function ANIMATOR."
    (window-put w 'running-animator animator))

;;; init

  ;; for the hardcore
  (define-window-animator 'none nop)

  ;; in the window-state-change-hook
  (define (window-anim-initiator w states)
    ;; XXX select a state if >1? (never currently happens?)
    (run-window-animator w (car states)))

  (add-hook 'window-state-change-hook window-anim-initiator))

;; flip.jl -- move viewport / workspace like flipping pages

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;; Copyright (C) 2010 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.edge.flip

    (export edge-flip-invoke)

    (open rep
	  rep.system
	  rep.io.timers
	  sawfish.wm.custom
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.viewport
	  sawfish.wm.workspace
	  sawfish.wm.commands.move-resize
	  sawfish.wm.ext.workspace-grid)

  (define-structure-alias edge-flip sawfish.wm.edge.flip)

  (define edge-flip-timer nil)

  (define (edge-flip-invoke edge type #!key while-moving)
    (unless edge-flip-timer
      (setq edge-flip-timer
            (make-timer (lambda ()
                          (setq edge-flip-timer nil)
                          (flip-core edge type #:while-moving while-moving))
                        (quotient edge-flip-delay 1000)
                        (mod edge-flip-delay 1000)))))

  (define (flip-core edge type)
    (let ((ptr (query-pointer t)))
      (before-flip)
      (if (eq type 'viewport)
	  (progn
	    (cond ((eq edge 'left)
		   (when (move-viewport -1 0)
		     (rplaca ptr (- (screen-width) 2))))
		  ((eq edge 'right)
		   (when (move-viewport 1 0)
		     (rplaca ptr 1)))
		  ((eq edge 'top)
		   (when (move-viewport 0 -1)
		     (rplacd ptr (- (screen-height) 2))))
		  ((eq edge 'bottom)
		   (when (move-viewport 0 1)
		     (rplacd ptr 1))))
	    ;; always warp the pointer to keep it logically static
	    (warp-cursor (car ptr) (cdr ptr)))
	(let ((orig current-workspace))
	  (cond ((eq edge 'left)
		 (workspace-left)
		 (rplaca ptr (- (screen-width) 2)))
		((eq edge 'right)
		 (workspace-right)
		 (rplaca ptr 1))
		((eq edge 'top)
		 (workspace-up)
		 (rplacd ptr (- (screen-height) 2)))
		((eq edge 'bottom)
		 (workspace-down)
		 (rplacd ptr 1)))
	  (unless (= current-workspace orig)
	    (warp-cursor (car ptr) (cdr ptr)))))
      (after-flip type)))

;;; ugly hacks to make flipping work while dragging windows

;;; XXX xrefresh() to fix rubberband-traces? maybe a user-option
;;; XXX whether to do so? We'll see...

  ;; current-workspace before flipping
  (define original-space)

  (define (before-flip)
    (when move-resize-window
      (setq original-space current-workspace)))

  (define (after-flip type)
    (let ((w move-resize-window))
      (when w
	(when (and (eq type 'workspace)
		   (/= original-space current-workspace)
		   (not (window-get w 'sticky)))
	  (move-window-to-workspace w original-space current-workspace t))))))

;; keymaps.jl -- the default keymaps

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.keymaps

    (export custom-set-keymap)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.events
	  sawfish.wm.custom)

  (defgroup bindings "Bindings"
    :layout keymaps)

;;; Customize support

  (define (customizable-command-p x)
    (or (symbolp x)
	(and (symbolp (car x)) (get (car x) 'custom-command-args))))

  (define (custom-get-keymap symbol)
    (cons 'keymap (mapcar (lambda (cell)
			    (cons (car cell) (event-name (cdr cell))))
			  (filter (lambda (cell)
				    (customizable-command-p (car cell)))
				  (cdr (symbol-value symbol))))))

  ;; can't just call out to custom-set-variable since we side-effect VALUE
  (define (custom-set-keymap symbol value)
    (custom-set
     (lambda ()
       (when (eq (car value) 'keymap)
	 (let
	     ((old-value (and (boundp symbol) (symbol-value symbol)))
	      (new-tail (delq nil (mapcar (lambda (cell)
					    (let
						((ev (condition-case nil
							 (lookup-event
							  (cdr cell))
						       (error nil))))
					      (and ev (cons (car cell) ev))))
					  (cdr value)))))

	   (when (eq old-value (variable-default-value symbol))
	     ;; protect the default-value, an ugly hack..
	     (put symbol 'custom-default-value
		  (copy-sequence (variable-default-value symbol))))

	   ;; add in any non-command bindings
	   (setq new-tail (nconc new-tail
				 (filter (lambda (cell)
					   (not (customizable-command-p
						 (car cell))))
					 (cdr old-value))))
	   (if (and old-value (eq (car old-value) 'keymap))
	       ;; hijack the old keymap to preserve eq-ness
	       (rplacd old-value new-tail)
	     (set symbol (cons 'keymap new-tail))))))
     symbol))

  (define-custom-setter 'custom-set-keymap custom-set-keymap)
  (put 'keymap 'custom-set 'custom-set-keymap)
  (put 'keymap 'custom-get custom-get-keymap)

;;; Options

  (defcustom global-keymap (bind-keys (make-keymap)
				      "W-Left" 'previous-workspace
				      "W-Right" 'next-workspace
                      "W-Tab" 'cycle-windows
                      "Super-Tab" 'cabinet-switch
                      "C-Tab" 'cabinet-switch)
    "Keymap active anywhere."
    :group bindings
    :type keymap
    :before-set (lambda () (ungrab-keymap global-keymap))
    :after-set (lambda () (grab-keymap global-keymap)))

  (defcustom window-keymap (bind-keys (make-keymap)
				      "W-Up" 'raise-window
				      "W-Down" 'lower-window
				      "W-Button3-Click1" 'raise-lower-window
				      "W-Button2-Click1" 'popup-window-ops-menu
				      "W-Button1-Move" 'move-window-interactively
				      "Button1-Click1" 'raise-and-pass-through-click
				      "W-ISO_Left_Tab" 'tab-raise-left-window
				      "H-ISO_Left_Tab" 'tab-raise-right-window)
    "Keymap active when a client window is focused."
    :group bindings
    :type keymap
    :before-set (lambda () (ungrab-keymap window-keymap))
    :after-set (lambda () (grab-keymap window-keymap)))

  (defcustom root-window-keymap (bind-keys (make-keymap)
					   "Button2-Click1" 'popup-root-menu)
    "Keymap active when the pointer is in the root window
(or when no window is focused)."
    :group bindings
    :type keymap)

  (defcustom title-keymap (bind-keys (make-keymap)
				     "Button3-Off" 'raise-lower-window
				     "Button3-Move" 'move-window-interactively
				     "Button3-Click" 'tab-release-window
				     "Button2-Move" 'resize-window-interactively
				     "Button2-Off" 'tab-window-add-to-tabgroup
				     "C-Button2-Off" 'tab-tabgroup-add-to-tabgroup
				     "Button1-Off2" 'toggle-window-shaded
				     "Button1-Move" 'move-window-interactively)
    "Keymap of window title bar. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom tabbar-keymap (bind-keys (make-keymap)
				      "Button3-Move" 'move-window-interactively
				      "Button3-Click" 'tab-release-window
				      "Button2-Off" 'tab-window-add-to-tabgroup
				      "C-Button2-Off" 'tab-tabgroup-add-to-tabgroup
				      "Button1-Off2" 'toggle-window-shaded
				      "Button1-Move" 'move-window-interactively
                      "Button1-C-Off" 'tab-move-to-left
                      "Button3-C-Off" 'tab-move-to-right
                      "Button1-Super-Off" 'tab-move-to-beginning
                      "Button3-Super-Off" 'tab-move-to-end)

    "Keymap of window tabbar. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom border-keymap (bind-keys (make-keymap)
				      "Button3-Off" 'raise-lower-window
				      "Button2-Move" 'move-window-interactively
				      "Button1-Move" 'resize-window-interactively)
    "Keymap of window border. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom close-button-keymap (bind-keys (make-keymap)
					    "Button3-Click1" 'popup-window-ops-menu
					    "S-Button1-Off" 'delete-group
					    "Button1-Off" 'delete-window)
    "Keymap of \"close\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom iconify-button-keymap (bind-keys (make-keymap)
					      "Button3-Click1" 'popup-window-ops-menu
					      "Button1-Off" 'iconify-window)
    "Keymap of \"iconify\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom maximize-button-keymap (bind-keys (make-keymap)
					       "Button3-Off" 'maximize-window-horizontally-toggle
					       "Button2-Off" 'maximize-window-vertically-toggle
					       "Button1-Off" 'maximize-window-toggle)
    "Keymap of \"maximize\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom menu-button-keymap (bind-keys (make-keymap)
					   "Button3-Off" 'delete-window
					   "Button1-Click1" 'popup-window-ops-menu)
    "Keymap of \"menu\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom shade-button-keymap (bind-keys (make-keymap)
					    "Button1-Off" 'toggle-window-shaded)
    "Keymap of \"shade\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom sticky-button-keymap (bind-keys (make-keymap)
					     "Button1-Off" 'toggle-window-sticky
					     "Button2-Off" 'toggle-window-sticky-viewport)
    "Keymap of \"sticky\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom lock-button-keymap (bind-keys (make-keymap)
					   "Button1-Off" 'toggle-window-fixed-position
					   "Button3-Off" 'toggle-window-fixed-size)
    "Keymap of \"lock\" button. Mouse-bindings only."
    :group bindings
    :type keymap)


  (defcustom rename-button-keymap (bind-keys (make-keymap)
					     "Button1-Off" 'rename-window)
    "Keymap of \"rename\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom move-resize-button-keymap (bind-keys (make-keymap)
						  "Button1-Off" 'move-window-interactively
						  "Button2-Off" 'resize-window-interactively
						  "Button3-Off" 'move-window-center
						  "Button4-Off" 'double-window-size
						  "Button5-Off" 'halve-window-size)
    "Keymap of \"move/resize\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom raise-lower-button-keymap (bind-keys (make-keymap)
						  "Button1-Off" 'raise-window-depth
						  "Button2-Off" 'raise-window
						  "Button3-Off" 'lower-window-depth
						  "Button4-Off" 'raise-window
						  "Button5-Off" 'lower-window)
    "Keymap of \"raise/lower\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom next-workspace-button-keymap (bind-keys (make-keymap)
					    "Button3-Off" 'send-to-previous-workspace
					    "Button2-Click" 'popup-workspace-list
					    "Button1-Off" 'send-to-next-workspace)
    "Keymap of \"next-workspace\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom previous-workspace-button-keymap (bind-keys (make-keymap)
					    "Button3-Off" 'send-to-next-workspace
					    "Button2-Click" 'popup-workspace-list
					    "Button1-Off" 'send-to-previous-workspace)
    "Keymap of \"previous-workspace\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defvar pointer-motion-threshold 2
    "Distance pointer must move before generating motion events, in pixels.")

  (defcustom wm-modifier-value (wm-modifier)
    "Modifier key(s) used for default shortcuts."
    :group bindings
    :type modifier-list
    :after-set (lambda ()
		 (ungrab-keymap global-keymap)
		 (ungrab-keymap window-keymap)
		 (set-wm-modifier wm-modifier-value)
		 (grab-keymap window-keymap)
		 (grab-keymap global-keymap)))

;;; Arrange for window-keymap to be set in each window

  (define (keymap-add-window w)
    (unless (window-get w 'keymap)
      (window-put w 'keymap window-keymap)))

  (add-hook 'add-window-hook keymap-add-window)

  ;; custom support for modifiers

  (define-custom-serializer 'modifier-list
    (lambda (value)
      (require 'sawfish.wm.util.decode-events)
      (decode-modifier value)))

  (define-custom-deserializer 'modifier-list
    (lambda (value)
      (require 'sawfish.wm.util.decode-events)
      (encode-modifier value))))

;; nokogiri-utils -- utils for SawfishConfig
;;
;; Copyright (C) 2010 Christopher Roy Bratusek <zanghar@freenet.de>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.cfg.utils

  (export beautify-symbol-name
          remove-newlines)

  (open rep
        rep.regexp)

  (define (beautify-symbol-name symbol)
    (cond ((stringp symbol) symbol)
	  ((not (symbolp symbol)) (format "%s" symbol))
	  (t
	   (let ((name (copy-sequence (symbol-name symbol))))
	     (while (string-match "[-:]" name)
	       (setq name (concat (substring name 0 (match-start))
				  ?  (substring name (match-end)))))
	     (aset name 0 (char-upcase (aref name 0)))
	     (_ name)))))

  (define (remove-newlines string)
    (let loop
	((point 0)
	 (out '()))
      (if (string-match "\n" string point)
	  (loop (match-end)
		(list* #\space (substring string point (match-start)) out))
	(apply concat (nreverse (cons (substring string point) out)))))))

;; error-handler.jl -- replace the standard rep error handler

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.ext.error-handler

    (export retrieve-errors
	    display-errors
	    error-handler-function)

    (open rep
	  rep.system
	  rep.data.ring
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands)

  (define-structure-alias error-handler sawfish.wm.ext.error-handler)

  (defcustom error-handler-beep t
    "Beep when errors occur."
    :type boolean
    :group misc)

  ;; By default, an error during ~/.sawfish/rc is printed to both,
  ;; and after that, only to standard-error.
  (defcustom error-destination 'standard-error
    "Display error messages to: \\left"
    :type (choice nowhere screen standard-error both)
    :group misc)

  ;; ring buffer for containing error messages
  (define error-ring (make-ring))

;;; code

  (define (error->string err data)
    (format nil "%s: %s"
	    (or (get err 'error-message) err)
	    (mapconcat (lambda (x)
			 (format nil "%s" x)) data ", ")))

  (define (handler err data)
    (let ((text (error->string err data)))
      (ring-append error-ring
		   (format nil "[%s] %s"
			   (current-time-string nil "%Y-%m-%d %H:%M:%S") text))
      (when error-handler-beep
	(beep))
      (case error-destination
	((screen)
	 (display-message text))
	((standard-error)
	 (write standard-error "Sawfish error:\n")
	 (write standard-error text)
	 (write standard-error #\newline))
	((init)
	 ;; If it's called now, then the message window is covered
	 ;; by client windows.
	 (add-hook 'after-initialization-hook
		   (lambda ()
		     (display-message
		      (concat "Error:\n(Click to dismiss. Also printed to stderr)\n\n" text))))
	 (write standard-error "Sawfish error:\n")
	 (write standard-error text)
	 (write standard-error #\newline))
	((both)
	 (display-message text)
	 (write standard-error "Sawfish error:\n")
	 (write standard-error text)
	 (write standard-error #\newline)))))

  (define (retrieve-errors) (ring->list error-ring))

  (define (display-errors)
    "Display all errors that have occurred to the screen."
    (let ((errors (retrieve-errors)))
      (display-message (if errors
			   (mapconcat identity errors #\newline)
			 (_ "No errors.")))))

  (define-command 'display-errors display-errors)

  ;; install our error handler as the system-wide handler
  (setq error-handler-function handler))

;; trayer.jl -- trayer integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.trayer

  (export start-trayer
          stop-trayer)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
	rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias trayer sawfish.wm.prg.trayer)

  (define %trayer-proc nil)

  (defcustom init-trayer nil
    "Whether to start trayer with Sawfish."
    :type boolean
    :group (misc apps))

  (defcustom trayer-expand 'false
    "Wether to expand trayer."
    :type (choice true false)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-edge 'top
    "What edge to place trayer at."
    :type (choice top right bottom left none)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-align 'left
    "Alignment of trayer."
    :type (choice left center right)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-widthtype 'percent
    "Unit for trayer's width."
    :type (choice request pixel percent)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-width 15
    "Width for trayer."
    :type number
    :depends init-trayer
    :range (0 . 2000)
    :group (misc apps))

  (defcustom trayer-heighttype 'pixel
    "Unit for trayer's height."
    :type (choice request pixel percent)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-height 28
    "Height for trayer."
    :type number
    :range (0 . 1000)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-margin 0
    "Margins for trayer."
    :type number
    :range (0 . 50)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-setdocktype 'false
    "Whether to set trayer's window-type to dock."
    :type (choice true false)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-setpartialstrut 'false
    "Whether to set partial strut."
    :type (choice true false)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-transparent 'false
    "Whether to make trayer transparent."
    :type (choice true false)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-alpha 0
    "Alpha channel value for trayer."
    :type (range (0 . 256))
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-tint 0
    "Tint value for trayer."
    :type (range (0 . 100))
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-distance 0
    "Distance value for trayer."
    :type number
    :range (0 . 200)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-distancefrom 0
    "DistanceFrom value for trayer."
    :type number
    :range (0 . 200)
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-padding 0
    "Padding value for trayer."
    :type (range (0 . 100))
    :depends init-trayer
    :group (misc apps))

  (defcustom trayer-monitor 0
    "Monitor to display trayer on."
    :type number
    :range (0 . 16)
    :depends init-trayer
    :group (misc apps))

  (define (start-trayer #!key
			(expand trayer-expand)
			(edge trayer-edge)
			(align trayer-align)
			(widthtype trayer-widthtype)
			(width trayer-width)
			(heighttype trayer-heighttype)
			(height trayer-height)
			(margin trayer-margin)
			(setdocktype trayer-setdocktype)
			(setpartialstrut trayer-setpartialstrut)
			(transparent trayer-transparent)
			(alpha trayer-alpha)
			(tint trayer-tint)
			(distance trayer-distance)
			(distancefrom trayer-distancefrom)
			(padding trayer-padding)
			(monitor trayer-monitor))
    "Start trayer. If a trayer process already exists, it'll be killed and started again.
All options of trayer are supported."
    (if (program-exists-p "trayer")
        (progn
	  (when %trayer-proc (kill-process %trayer-proc))
	  (setq %trayer-proc (make-process))
	  (start-process %trayer-proc "trayer" "--expand" (format nil "%s" expand) "--edge" (format nil "%s" edge)
            "--align" (format nil "%s" align) "--widthtype" (format nil "%s" widthtype) "--width" (number->string width)
            "--heighttype" (format nil "%s" heighttype) "--height" (number->string height)
            "--SetDockType" (format nil "%s" setdocktype) "--margin" (number->string margin)
            "--SetPartialStrut" (format nil "%s" setpartialstrut) "--monitor" (number->string monitor)
            "--alpha" (number->string alpha) "--tint" (number->string tint)
            "--distance" (number->string distance) "--distancefrom" (number->string distancefrom)
            "--padding" (number->string padding) "--transparent" (format nil "%s" transparent)))
      (display-message (format nil "trayer executable was not found in PATH."))))

  (define (stop-trayer)
    "Stop trayer, if running."
    (when %trayer-proc
      (kill-process %trayer-proc)
      (setq %trayer-proc nil))))

;; window-anim.jl -- visual feedback for window actions
;; $Id: window-anim.jl,v 1.6 2002/04/21 04:52:13 jsh Exp $

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.ext.window-anim

    (export define-window-animator
	    autoload-window-animator
	    run-window-animator
	    record-window-animator)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.custom
	  rep.util.autoloader)

  (define-structure-alias window-anim sawfish.wm.ext.window-anim)

  (define window-animators nil
    "List of all possible window animation types.")

  ;; this used to be a defcustom, and I don't have anything against
  ;; that, except the current animations are so lame it's embarassing

  (defvar default-window-animator 'none
    "The default window animation mode")

;;; animator registration

  (define (define-window-animator name fun)
    "Define a window animator called NAME (a symbol) that is managed by
function FUN. FUN is called as (FUN WINDOW OP [ACTION]) when it should change
the state of an animation sequence. OP may be one of the symbols `start',
`stop'."
    (put name 'window-animator fun)
    (unless (memq name window-animators)
      (setq window-animators (cons name (delq name window-animators)))
;;      (custom-set-property 'default-window-animator
;;			   ':options window-animators)
      ))

  (define (getter name) (get name 'window-animator))
  
  (define autoload-window-animator
    (make-autoloader getter define-window-animator))

  (define window-animator (autoloader-ref getter))

;;; running animators

  (define (run-window-animator w action)
    "Invoke an animation for ACTION on window W."
    (let ((running (window-get w 'running-animator)))
      (when running
	(running w 'stop)))
    (let ((animator (or (window-get w 'animator) default-window-animator)))
      (when animator
	((window-animator animator) w 'start action))))

  (define (record-window-animator w animator)
    "Note that window W currently has an animation running; being controlled
by animator function ANIMATOR."
    (window-put w 'running-animator animator))

;;; init

  ;; for the hardcore
  (define-window-animator 'none nop)

  ;; in the window-state-change-hook
  (define (window-anim-initiator w states)
    ;; XXX select a state if >1? (never currently happens?)
    (run-window-animator w (car states)))

  (add-hook 'window-state-change-hook window-anim-initiator))

;; frames.jl -- handle window framing

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.frames

    (compound-interface
     ;; Subrs are stored in sawfish.wm.frames.subrs, but
     ;; this module re-exports them for convenience.
     (structure-interface sawfish.wm.frames.subrs)
     (export after-setting-frame-option
	     define-frame-type-mapper
	     add-frame-style
	     reload-frame-style
	     reframe-window
	     reframe-all-windows
	     rebuild-frames-with-style
	     reframe-windows-with-style
	     set-frame-style
	     apply-frame-style
	     apply-frame-style-and-save
	     window-type
	     set-window-type
	     push-window-type
	     pop-window-type
	     window-type-remove-title
	     window-type-remove-border
	     window-type-add-title
	     window-type-add-border
	     find-all-frame-styles
	     frame-style-menu
	     frame-type-menu
	     remove-frame-class
	     add-frame-class
	     frame-class-removed-p
	     set-frame-part-value
	     remove-frame-part-value
	     def-frame-class
	     define-frame-class
	     update-frame-font-color
	     update-frame-font
             update-button-cursor-shape
	     update-border-color-width
	     update-title-x-offsets
	     update-title-y-offsets
	     update-text-position))

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.timers
	  sawfish.wm.frames.subrs
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.events
	  sawfish.wm.gaol
	  sawfish.wm.session.init
	  sawfish.wm.workspace)

  ;; Commentary:

  ;; This sets the following window properties:

  ;;	frame-style		If set, the _user-chosen_ frame style
  ;;	current-frame-style	The current frame style
  ;;	type			The notional window type, defining
  ;;				 which parts of the frame are included

  ;; The different window types are:

  ;;	default			title bar and border
  ;;	transient		border only
  ;;	shaped			title-bar only
  ;;	shaped-transient	border-like title-bar only
  ;;	unframed		no frame at all
  ;;	icon
  ;;	dock
  ;;	menu, toolbar
  ;;	utility
  ;;	splash

  ;; There is also a similar concept of frame types. The window type
  ;; never changes (unless the user explicitly does so). But the frame
  ;; type may depend on the current window state. For example, if it's
  ;; shaded, then it may have `shaded' or `shaded-transient' frame type.

  ;; These are the types that the frame styles see. Current types include
  ;; all the above window types plus:

  ;;	shaded			normal title bar only
  ;;	shaded-transient	transient title bar only

  ;; When framing windows the frame-type-fallback-alist variable will be
  ;; used to iterate frame types until a type that the theme implements
  ;; is found.

  ;; However, this separation of frame and window type shouldn't
  ;; discourage themes from detecting other window state. For example,
  ;; themes may want to display maximized windows differently from
  ;; non-maximized. (In fact the frame-type != window-type scheme is
  ;; largely just for compatibility)

;;; custom support

  (define (custom-make-frame-style-widget)
    `(frame-style ,(find-all-frame-styles t) ,theme-load-path))

  (put 'frame-style 'custom-widget custom-make-frame-style-widget)

;;; variables etc

  (defvar frame-part-classes nil
    "Alist of (CLASS . ALIST) associating classes of frame parts with state
they inherit.")

  (defvar override-frame-part-classes nil
    "Alist of (CLASS . ALIST) associating classes of frame parts with state
that overrides settings set elsewhere.")

  (defvar nil-frame nil
    "Frame definition used for unframed windows.")

  (defcustom default-frame-style nil
    "Theme"
    :type frame-style
    :group appearance
    :after-set (lambda () (after-setting-default-frame)))

  (defcustom reload-themes-when-changed t
    "Automatically reload themes when they are updated."
    :type boolean
    :group appearance)

  (defvar frame-type-fallback-alist
    '((transient . default)
      (shaped . default)
      (shaped-transient . shaped)
      (shaded . shaped)
      (shaded-transient . shaped-transient)
      (icon . shaped-transient)
      (dock . unframed)
      (utility . default)
      (shaded-utility . shaded-transient)
      (toolbar . unframed)
      (menu . unframed)
      (splash . unframed)
      ;; (shaded-toolbar . shaded-utility)
      ;; (shaded-menu . shaded-utility)
      )
    "Frame type fallbacks. This is an alist whose elements are
(required-type . fallback-type). When REQUIRED-TYPE is not supported
by the current theme, then FALLBACK-TYPE is used instead.")

  ;; Re-Coloring Options for Themes

  (define (update-frame-font-color)
    (if use-custom-font-color
	(mapc (lambda (fc)
		(set-frame-part-value fc 'foreground
                                      `((inactive . ,frame-font-inactive-color)
                                        (focused . ,frame-font-active-color)
					(highlighted . ,frame-font-highlight-color)
					(clicked . ,frame-font-clicked-color)
					(inactive-highlighted . ,frame-font-inactive-highlight-color)
					(inactive-clicked . ,frame-font-inactive-clicked-color))
                                      t))
              '(title tabbar-horizontal))
      (mapc (lambda (fc) (remove-frame-part-value fc 'foreground t))
            '(title tabbar-horizontal)))
    (mapc rebuild-frame (managed-windows)))

  (define (update-frame-font)
    (if use-custom-font
        (mapc (lambda (fc)
		(set-frame-part-value fc 'font
				      `((inactive . ,frame-font-inactive)
					(focused . ,frame-font-active)
					(highlighted . ,frame-font-highlight)
					(clicked . ,frame-font-clicked)
					(inactive-highlighted . ,frame-font-highlight)
					(inactive-clicked . ,frame-font-clicked)) t))
	      '(title tabbar-horizontal))
      (mapc (lambda (fc) (remove-frame-part-value fc 'font t))
	    '(title tabbar-horizontal)))
    (mapc rebuild-frame (managed-windows)))

  (define (get-cursor-shape-for-button button)
    (case button
      ((menu-button) menu-button-cursor-shape)
      ((close-button) close-button-cursor-shape)
      ((iconify-button) iconify-button-cursor-shape)
      ((maximize-button) maximize-button-cursor-shape)
      ((shade-button) shade-button-cursor-shape)
      ((sticky-button) sticky-button-cursor-shape)
      ((lock-button) lock-button-cursor-shape)
      ((rename-button) rename-button-cursor-shape)
      ((move-resize-button) move-resize-button-cursor-shape)
      ((raise-lower-button) raise-lower-button-cursor-shape)
      ((next-workspace-button) next-workspace-button-cursor-shape)
      ((previous-workspace-button) previous-workspace-button-cursor-shape)))

  (define (update-button-cursor-shape)
    (if use-custom-button-cursor-shape
        (mapc (lambda (btn)
		(set-frame-part-value btn 'cursor (get-cursor-shape-for-button btn) t))
	      '(menu-button close-button iconify-button maximize-button shade-button
		sticky-button lock-button rename-button move-resize-button raise-lower-button
		next-workspace-button previous-workspace-button))
      (mapc (lambda (btn)
	      (remove-frame-part-value btn 'cursor t))
	    '(menu-button close-button iconify-button maximize-button shade-button
	      sticky-button lock-button rename-button move-resize-button raise-lower-button
		next-workspace-button previous-workspace-button)))
    (mapc rebuild-frame (managed-windows)))

  (define (update-border-color-width)
    (if use-custom-border
        (mapc (lambda (border)
		(set-frame-part-value border 'border-width custom-border-width t)
		(set-frame-part-value border 'border-color custom-border-color t))
	      '(title tabbar-horizontal tabbar-vertical))
      (mapc (lambda (border)
	      (remove-frame-part-value border 'border-width t)
	      (remove-frame-part-value border 'border-color t))
	    '(title tabbar-horizontal tabbar-vertical)))
    (mapc rebuild-frame (managed-windows)))

  (define title-x-left-offset)
  (define title-x-right-offset)
  (define title-y-top-offset)
  (define title-y-bottom-offset)

  (define (update-title-x-offsets value)
    (setq title-x-left-offset (car value))
    (setq title-x-right-offset (cdr value)))

  (define (update-title-y-offsets value)
    (setq title-y-top-offset (car value))
    (setq title-y-bottom-offset (cdr value)))

  (define (get-text-position requested-position)
    ;; this function sets the real position. 'left 'center 'right are user-choosen,
    ;; we check here whether applicable. eg. left (= 0) is not appropriate for
    ;; StyleTab, as it shows an icon on the left
    (case requested-position
      ((left) (+ 1 (or title-x-left-offset 0)))
      ((right) (+ -1 (or title-x-right-offset 0)))
      ((top) (+ 1 (or title-y-top-offset 0)))
      ((bottom) (+ -1 (or title-y-bottom-offset 0)))
      ((center) 'center)))

  (define (update-text-position)
    (if use-custom-text-position
      (progn
        (unless (eq custom-text-x-position 'default)
	  (mapc (lambda (pos)
		  (set-frame-part-value pos 'x-justify (get-text-position custom-text-x-position) t))
	        '(title tabbar-horizontal)))
	(unless (eq custom-text-y-position 'default)
	  (mapc (lambda (pos)
		  (set-frame-part-value pos 'y-justify (get-text-position custom-text-y-position) t))
	        '(title tabbar-horizontal))))
      (update-title-x-offsets '(0 . 0))
      (update-title-y-offsets '(0 . 0)))
    (when (or (not use-custom-text-position)
	      (eq custom-text-x-position 'default))
      (mapc (lambda (pos)
	      (remove-frame-part-value pos 'x-justify t))
	    '(title tabbar-horizontal)))
    (when (or (not use-custom-text-position)
	      (eq custom-text-y-position 'default))
      (mapc (lambda (pos)
	      (remove-frame-part-value pos 'y-justify t))
	    '(title tabbar-horizontal)))
    (mapc rebuild-frame (managed-windows)))

  (defvar theme-update-interval 60
    "Number of seconds between checking if theme files have been modified.")

  (defvar user-theme-directory "~/.sawfish/themes"
    "Directory containing user-local themes.")

  (defvar system-theme-directory (expand-file-name
				  "../themes" sawfish-lisp-lib-directory)
    "Directory containing themes from the current sawfish version.")

  (defvar site-theme-directory (expand-file-name
				"../../themes" sawfish-lisp-lib-directory)
    "Directory containing system-wide themes.")

  (defvar theme-load-path (list user-theme-directory
				site-theme-directory
				system-theme-directory)
    "List of directories from which themes may be loaded.")

  (define frame-styles nil
          "List of (NAME . FUNCTION) defining all loaded frame styles.")

  ;; List of (NAME FILENAME MODTIME) mapping loaded frame styles to the
  ;; files they were loaded from; used to check if the theme needs reloading
  (define frame-style-files nil)

  (define frame-type-mappers '()
          "List of functions that map (WINDOW FRAME-TYPE) ->
FRAME-TYPE. Used when deciding which frame type to ask a theme to
generate.")

  ;; list of (REGEXP DIR-EXPAND NAME-EXPAND)
  (defvar theme-suffix-regexps
    '(("^(.*)/(.*)\\.tar(\\.gz|\\.Z|\\.bz2|\\.xz|\\.lzma|)$"
       "\\0#tar/\\2" "\\2")))

  (defvar theme-suffixes '("" ".tar" ".tar.gz" ".tar.Z" ".tar.bz2"
                           ".tar.xz" ".tar.lzma"))

  (defvar themes-are-gaolled t
    "When non-nil themes are assumed to be malicious.")

;;; defcustom's for some built-in variables

  (defcustom default-font nil
    "Default font: \\left"
    :group appearance
    :type font
    :after-set (lambda () (after-setting-frame-option)))

  (defvar default-bevel-percent nil
    "Bevel intensity as a percentage.")

  ;; frame fonts & colors
  (defcustom use-custom-font nil
    "Use custom font for different states"
    :type boolean
    :group appearance
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-inactive default-font
    "Font for inactive titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-active default-font
    "Font for focused titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-highlight default-font
    "Font for highlighted titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-clicked default-font
    "Font for clicked titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom use-custom-font-color '()
    "Use custom font colors for frames"
    :type boolean
    :group appearance
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-active-color "#F2F2F2"
    "Font color for active frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-inactive-color "#CBCBCB"
    "Font color for inactive frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-highlight-color "#FEFEFE"
    "Font color for highlighted frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-inactive-highlight-color "#D8D8D8"
    "Font color for inactive highligted frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-clicked-color "#FFFFFF"
    "Font color for clicked frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-inactive-clicked-color "#EEEEEE"
    "Font color for inactive clicked frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom use-custom-button-cursor-shape nil
    "Whether to change the cursor shape for frame buttons."
    :type boolean
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom menu-button-cursor-shape 'X_cursor
    "Cursor shape for menu button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom close-button-cursor-shape 'pirate
    "Cursor shape for close button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom iconify-button-cursor-shape 'll_angle
    "Cursor shape for iconify button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom maximize-button-cursor-shape 'draped_box
    "Cursor shape for maximize button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom shade-button-cursor-shape 'left_ptr
    "Cursor shape for shade button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom sticky-button-cursor-shape 'plus
    "Cursor shape for sticky button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom lock-button-cursor-shape 'dotbox
    "Cursor shape for lock button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom next-workspace-button-cursor-shape 'sb_right_arrow
    "Cursor shape for next-workspace button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom previous-workspace-button-cursor-shape 'sb_left_arrow
    "Cursor shape for previous-workspace button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom rename-button-cursor-shape 'xterm
    "Cursor shape for rename button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom move-resize-button-cursor-shape 'fleur
    "Cursor shape for move-resize button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom raise-lower-button-cursor-shape 'double_arrow
    "Cursor shape for raise-lower button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_down_arrow sb_up_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom use-custom-text-position nil
    "Whether to change the position of the titlebar text."
    :type boolean
    :group appearance
    :after-set (lambda () (update-text-position)))

  (defcustom custom-text-x-position 'default
    "Horizontal orientation of the text."
    :type (choice default left center right)
    :group appearance
    :depends use-custom-text-position
    :after-set (lambda () (update-text-position)))

  (defcustom custom-text-y-position 'default
    "Vertical orientation of the text."
    :type (choice default top center bottom)
    :group appearance
    :depends use-custom-text-position
    :after-set (lambda () (update-text-position)))

  (defcustom use-custom-border '()
    "Draw an extra window border"
    :type boolean
    :group appearance
    :after-set (lambda () (update-border-color-width)))

  (defcustom custom-border-color "black"
    "Color for the window border"
    :type color
    :group appearance
    :depends use-custom-border
    :after-set (lambda () (update-border-color-width)))

  (defcustom custom-border-width 0
    "Width for the window border"
    :type number
    :range (0 . 10)
    :group appearance
    :depends use-custom-border
    :after-set (lambda () (update-border-color-width)))

;;; managing frame types

  (define (define-frame-type-mapper fun)
    (unless (memq fun frame-type-mappers)
      (setq frame-type-mappers (cons fun frame-type-mappers))))

  (define (find-frame-definition w style)
    ;; 1. map window type to actual frame type
    (let loop-1 ((rest frame-type-mappers)
		 (type (window-type w)))
      (if (null rest)
	  ;; found the final frame type, so,
	  ;; 2. find the closest type that the style implements to this
	  (let loop-2 ((type type)
		       (seen (list type)))
	    (cond ((eq type 'unframed) nil-frame)
		  ((style w type))
		  (t (let ((next (or
				  (cdr (assq type
					     frame-type-fallback-alist))
				  'unframed)))
		       (if (memq next seen)
			   ;; been here before..
			   nil-frame
			 (loop-2 next (cons next seen)))))))
	;; else, apply this transformation and keep looping
	(loop-1 (cdr rest) ((car rest) w type)))))

;;; managing frame styles

  (define (add-frame-style name function)
    (let ((cell (assq name frame-styles)))
      (if cell
	  (rplacd cell function)
	(setq frame-styles (cons (cons name function) frame-styles)))
      (when load-filename
	(let
	    ;; if we're loading from a tar-file, then check the
	    ;; tar file itself, not its contents (for efficiency)
	    ((file (if (string-match "#tar/" load-filename)
		       (substring load-filename 0 (match-start))
		     load-filename)))
	  (setq cell (assq name frame-style-files))
	  (if cell
	      (rplacd cell (list file (file-modtime file)))
	    (setq frame-style-files (cons (list name file (file-modtime file))
					  frame-style-files)))))
      (unless default-frame-style
	(setq default-frame-style name))))

  (define (check-frame-availability name)
    (unless (assq name frame-styles)
      (load-frame-style name)
      (or (assq name frame-styles) (error "No such frame style: %s" name))))

  (define (reload-frame-style name)
    (when (assq name frame-styles)
      (load-frame-style name)
      (reframe-windows-with-style name)))

  ;; called periodically from a timer
  (define (frames-on-idle timer)
    (set-timer timer theme-update-interval)
    (when reload-themes-when-changed
      (mapc (lambda (cell)
	      (let ((style (nth 0 cell))
		    (file (nth 1 cell))
		    (modtime (nth 2 cell)))
		(when (time-later-p (file-modtime file) modtime)
		  (reload-frame-style style))))
	    frame-style-files)))

;;; applying frame styles to windows

  (define (reframe-window w)
    (if (window-get w 'ignored)
	(progn
	  (window-put w 'current-frame-style nil)
	  (set-window-frame w nil-frame))
      (let ((style (or (window-get w 'frame-style)
		       default-frame-style)))
	(check-frame-availability style)
	(let ((style-fun (cdr (assq style frame-styles))))
	  (set-window-frame w (if style-fun
				  (find-frame-definition w style-fun)
				nil-frame))
	  (window-put w 'current-frame-style style)))))

  (define (reframe-all-windows) (map-windows reframe-window))

  (define after-setting-frame-option reframe-all-windows)

  (define (after-setting-default-frame)
    (check-frame-availability default-frame-style)
    (after-setting-frame-option)
    ;; XXX Fucking evil!
    ;; XXX offsets would be wrong else...
    (when use-custom-text-position
      (setq use-custom-text-position nil)
      (update-text-position)
      (reframe-windows-with-style default-frame-style)
      (setq use-custom-text-position t)
      (update-text-position))
    ;; XXX even more Fucking evil!
    ;; XXX tab-adjustments would be wrong else
    ;; XXX even though each theme sets them...
    (if (or (eq default-frame-style (intern "StyleTab"))
	    (eq default-frame-style (intern "Elberg-tabbbed"))
	    (eq default-frame-style (intern "get-S-tabbed"))
	    (eq default-frame-style (intern "gradient-tabbed")))
      (reframe-windows-with-style default-frame-style)))

  (define (rebuild-frames-with-style style)
    (map-windows (lambda (w)
		   (when (eq (window-get w 'current-frame-style) style)
		     (rebuild-frame w)))))

  (define (reframe-windows-with-style style)
    (map-windows (lambda (w)
		   (when (eq (window-get w 'current-frame-style) style)
		     (reframe-window w)))))

  (define (set-frame-style w style)
    (unless (eq (window-get w 'frame-style) style)
      (window-put w 'frame-style style)
      (call-window-hook 'window-state-change-hook w (list '(frame-style)))
      (reframe-window w)))

  ;; return true iff successful
  (define (apply-frame-style style)
    (let ((old-style default-frame-style))
      (condition-case nil
	  (progn
	    (setq default-frame-style style)
	    (after-setting-default-frame)
	    t)
	(error
	 (setq default-frame-style old-style)
	 (after-setting-frame-option)
	 nil))))

  (define (save-current-frame-style)
    (require 'sawfish.wm.customize)
    (customize-set 'default-frame-style default-frame-style))

  (define (apply-frame-style-and-save style)
    (when (apply-frame-style style)
      (save-current-frame-style)))

;;; kludge different window decors by modifying the assumed window type

  (define (window-type w)
    (or (window-get w 'type)
	(if (window-transient-p w)
	    (if (window-shaped-p w)
		'shaped-transient
	      'transient)
	  (if (window-shaped-p w)
	      'shaped
	    'default))))

  (define (set-window-type w type)
    (if (window-get w 'type/saved)
	(window-put w 'type/saved type)
      (unless (eq (window-get w 'type) type)
	(window-put w 'type type)
	(call-window-hook 'window-state-change-hook w (list '(type)))
	(reframe-window w))))

  ;; XXX do something with KEY. (It's a unique symbol used to mark
  ;; XXX the different users of these functions)

  (define (push-window-type w type key)
    (window-put w 'type/key key)
    (unless (eq (window-get w 'type type))
      (unless (window-get w 'type/saved)
	(window-put w 'type/saved (window-get w 'type)))
      (window-put w 'type type)
      (call-window-hook 'window-state-change-hook w (list '(type)))
      (reframe-window w)))

  (define (pop-window-type w key)
    (when (and (window-get w 'type/saved)
	       (eq (window-get w 'type/key) key))
      (window-put w 'type (window-get w 'type/saved))
      (window-put w 'type/saved nil)
      (window-put w 'type/key nil))
    (call-window-hook 'window-state-change-hook w (list '(type)))
    (reframe-window w))

  (define (window-type-remove-title type)
    (case type
      ((default) 'transient)
      ((shaped shaped-transient) 'unframed)
      (t type)))

  (define (window-type-remove-border type)
    (case type
      ((default) 'shaped)
      ((transient shaped-transient) 'unframed)
      (t type)))

  (define (window-type-add-title type)
    (case type
      ((transient) 'default)
      ((unframed) 'shaped)
      (t type)))

  (define (window-type-add-border type)
    (case type
      ((shaped) 'default)
      ((unframed) 'transient)
      (t type)))

  ;; create some commands for setting the window type
  (mapc (lambda (type)
	  (define-command (intern (concat "set-frame:" (symbol-name type)))
	    (lambda (w) (set-window-type w type)) #:spec "%W"))
	'(default transient shaped shaped-transient unframed))

;;; loading ``themes'' (currently just frame styles)

  (define (frame-style-directory dir #!optional get-name)
    (if (and (file-directory-p dir)
	     (or (file-exists-p (expand-file-name "theme.jl" dir))
		 (file-exists-p (expand-file-name "theme.jlc" dir))))
	(if get-name
	    (file-name-nondirectory dir)
	  dir)
      ;; try the list of suffixes
      (catch 'out
	(mapc (lambda (cell)
		(when (string-match (car cell) dir)
		  (let ((full (expand-last-match (nth 1 cell))))
		    (when (file-directory-p full)
		      (throw 'out (if get-name
				      (expand-last-match (nth 2 cell))
				    full))))))
	      theme-suffix-regexps)
	nil)))

  (define (find-frame-style name)
    (catch 'out
      (mapc (lambda (dir)
	      (mapc (lambda (suf)
		      (let* ((t-dir (expand-file-name
				     (concat (symbol-name name) suf) dir))
			     tem)
			(when (file-exists-p t-dir)
			  (setq tem (frame-style-directory t-dir))
			  (when tem
			    (throw 'out tem)))))
		    theme-suffixes))
	    theme-load-path)
      nil))

  (define (load-frame-style name)
    (let ((dir (find-frame-style name)))
      (when dir
	(let ((image-load-path (cons dir image-load-path)))
	  (if themes-are-gaolled
	      (let ((gaol (make-gaol)))
		(gaol-load (expand-file-name "theme.jl" dir) gaol)
		(define-gaol-structure (intern (concat "themes."
						       (symbol-name name)))
                  gaol))
	    (load (expand-file-name "theme" dir) nil t))))))

  (define (find-all-frame-styles #!optional sorted)
    (let (lst tem)
      (mapc (lambda (dir)
	      (when (file-directory-p dir)
		(mapc (lambda (t-dir)
			(when (setq tem (frame-style-directory
					 (expand-file-name t-dir dir) t))
			  (unless (member tem lst)
			    (setq lst (cons tem lst)))))
		      (directory-files dir))))
	    theme-load-path)
      (when sorted
	(setq lst (sort lst string-lessp)))
      (mapcar intern lst)))

  (define (frame-style-menu w)
    (let ((styles (find-all-frame-styles t)))
      (nconc (mapcar (lambda (s)
		       (list (quote-menu-item (symbol-name s))
			     (lambda ()
			       (set-frame-style (current-event-window) s))
			     (cons 'check (eq (window-get w 'frame-style) s))
			     '(group . menu-style)))
		     styles)
	     (list '())
	     (list (list (_ "Default")
			 (lambda ()
			   (set-frame-style (current-event-window) nil))
			 (cons 'check (not (window-get w 'frame-style)))
			 '(group . menu-style))))))

  (define (frame-type-menu w)
    `((,(_ "Normal") set-frame:default
       (check . ,(eq (window-type w) 'default))
       (group . menu-type))
      (,(_ "Title-only") set-frame:shaped
       (check . ,(eq (window-type w) 'shaped))
       (group . menu-type))
      (,(_ "Border-only") set-frame:transient
       (check . ,(eq (window-type w) 'transient))
       (group . menu-type))
      (,(_ "Top-border") set-frame:shaped-transient
       (check . ,(eq (window-type w) 'shaped-transient))
       (group . menu-type))
      (,(_ "None") set-frame:unframed
       (check . ,(eq (window-type w) 'unframed))
       (group . menu-type))))

;;; removing frame parts

  (define (remove-frame-class w class)
    (window-put w 'removed-classes
		(cons class (delq class (window-get w 'removed-classes))))
    (when (window-framed-p w)
      (rebuild-frame w)))

  (define (add-frame-class w class)
    (window-put w 'removed-classes
		(delq class (window-get w 'removed-classes)))
    (when (window-framed-p w)
      (rebuild-frame w)))

  (define (frame-class-removed-p w class)
    (memq class (window-get w 'removed-classes)))

;;; manipulating the frame part classes variables

  (define (set-frame-part-value class key value #!optional override)
    (let* ((var (if override 'override-frame-part-classes 'frame-part-classes))
	   (item (assq class (symbol-value var)))
	   tem)
      (if item
	  (if (setq tem (assq key (cdr item)))
	      (rplacd tem value)
	    (rplacd item (cons (cons key value) (cdr item))))
	(set var (cons (cons class (list (cons key value)))
		       (symbol-value var))))))

  (define (remove-frame-part-value class key #!optional override)
    (let* ((fpcs (if override override-frame-part-classes frame-part-classes))
           (item (assq class fpcs)))
      (when item
        (setcdr item (delete-if (lambda (it) (eq (car it) key))
                                (cdr item))))))

  ;; Example:
  ;; (def-frame-class shade-button '((cursor . foo) ...)
  ;;   (bind-keys shade-button-keymap
  ;;     "Button1-Off" 'toggle-window-shaded))
  ;;
  ;; the idea being that it will only create the frame part if it doesn't
  ;; exist, it will add all properties from the second argument unless
  ;; they're already set, then create and initialise the keymap from the
  ;; third argument (unless a keymap is already defined)

  (defmacro def-frame-class (class alist #!rest keymap-forms)
    (if keymap-forms
	`(when (define-frame-class ',class ,alist t)
	   ,@keymap-forms)
      `(define-frame-class ',class ,alist)))

  (define (define-frame-class class alist #!optional with-keymap)
    (let ((cell (assq class frame-part-classes))
	  (ok-to-bind nil))
      (if (not cell)
	  (progn
	    (setq cell (cons class alist))
	    (setq frame-part-classes (cons cell frame-part-classes)))
	(mapc (lambda (attr)
		(let ((tem (assq (car attr) (cdr cell))))
		  (unless tem
		    (rplacd cell (cons attr (cdr cell))))))
	      alist))
      (when with-keymap
	(let ((map-name (intern (concat (symbol-name class) "-keymap"))))
	  (unless (boundp map-name)
	    (make-variable-special map-name)
	    (set map-name (make-keymap))
	    (setq ok-to-bind t)
	    ;; so the theme can bind to the keymap..
	    (gaol-define-special map-name))
	  (set-frame-part-value class 'keymap map-name)))
      ok-to-bind))

  (define ((cursor-for-frame-part part) w)
    (require 'sawfish.wm.state.maximize)
    (if (frame-part-movable-p w part)
	(case part
	  ((top-border) 'top_side)
	  ((bottom-border) 'bottom_side)
	  ((left-border) 'left_side)
	  ((right-border) 'right_side)
	  ((top-left-corner) 'top_left_corner)
	  ((top-right-corner) 'top_right_corner)
	  ((bottom-left-corner) 'bottom_left_corner)
	  ((bottom-right-corner) 'bottom_right_corner))
      nil))

;;; initialisation

  (define-frame-class 'menu-button '((keymap . menu-button-keymap)))
  (define-frame-class 'close-button '((keymap . close-button-keymap)))
  (define-frame-class 'iconify-button '((keymap . iconify-button-keymap)))
  (define-frame-class 'maximize-button '((keymap . maximize-button-keymap)))
  (define-frame-class 'shade-button '((keymap . shade-button-keymap)))
  (define-frame-class 'sticky-button '((keymap . sticky-button-keymap)))
  (define-frame-class 'lock-button '((keymap . lock-button-keymap)))
  (define-frame-class 'rename-button '((keymap . rename-button-keymap)))
  (define-frame-class 'move-resize-button '((keymap . move-resize-button-keymap)))
  (define-frame-class 'raise-lower-button '((keymap . raise-lower-button-keymap)))
  (define-frame-class 'next-workspace-button '((keymap . next-workspace-button-keymap)))
  (define-frame-class 'previous-workspace-button '((keymap . previous-workspace-button-keymap)))

  (define-frame-class 'title `((keymap . title-keymap)
			       (cursor . ,(cursor-for-frame-part 'title))))

  (define-frame-class 'tabbar-horizontal `((keymap . tabbar-keymap)
					   (cursor . ,(cursor-for-frame-part 'title))))

  (define-frame-class 'tabbar-vertical `((keymap . tabbar-keymap)
					 (cursor . ,(cursor-for-frame-part 'title))))

  (mapc (lambda (x)
	  (define-frame-class x `((cursor . ,(cursor-for-frame-part x))
				  (keymap . border-keymap))))
	'(top-border bottom-border
                     left-border right-border
                     top-left-corner top-right-corner
                     bottom-left-corner bottom-right-corner))

  (gaol-add add-frame-style reframe-window rebuild-frames-with-style
	    reframe-windows-with-style reframe-all-windows window-type
	    def-frame-class define-frame-class after-setting-frame-option
	    frame-part-get frame-part-put frame-part-window frame-part-x-window
	    frame-part-position frame-part-dimensions frame-part-state
	    map-frame-parts refresh-frame-part refresh-window rebuild-frame-part
	    reload-frame-style update-title-x-offsets update-title-y-offsets
        find-frame-style)

  (add-hook 'add-window-hook reframe-window t)
  (add-hook 'shape-notify-hook reframe-window t)

  (make-timer frames-on-idle theme-update-interval)

  (add-hook 'sm-window-save-functions
	    (lambda (w)
	      (cond ((window-get w 'type/saved)
		     (list (cons 'type (window-get w 'type/saved))))
		    ((window-get w 'type)
		     (list (cons 'type (window-get w 'type)))))))

  (sm-add-saved-properties 'ignored 'frame-style)
  (sm-add-restored-properties 'type)
  (add-swapped-properties 'frame-active-color 'frame-inactive-color)
  )

;; frames.jl -- handle window framing

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.frames

    (compound-interface
     ;; Subrs are stored in sawfish.wm.frames.subrs, but
     ;; this module re-exports them for convenience.
     (structure-interface sawfish.wm.frames.subrs)
     (export after-setting-frame-option
	     define-frame-type-mapper
	     add-frame-style
	     reload-frame-style
	     reframe-window
	     reframe-all-windows
	     rebuild-frames-with-style
	     reframe-windows-with-style
	     set-frame-style
	     apply-frame-style
	     apply-frame-style-and-save
	     window-type
	     set-window-type
	     push-window-type
	     pop-window-type
	     window-type-remove-title
	     window-type-remove-border
	     window-type-add-title
	     window-type-add-border
	     find-all-frame-styles
	     frame-style-menu
	     frame-type-menu
	     remove-frame-class
	     add-frame-class
	     frame-class-removed-p
	     set-frame-part-value
	     remove-frame-part-value
	     def-frame-class
	     define-frame-class
	     update-frame-font-color
	     update-frame-font
             update-button-cursor-shape
	     update-border-color-width
	     update-title-x-offsets
	     update-title-y-offsets
	     update-text-position))

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.timers
	  sawfish.wm.frames.subrs
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.events
	  sawfish.wm.gaol
	  sawfish.wm.session.init
	  sawfish.wm.workspace)

  ;; Commentary:

  ;; This sets the following window properties:

  ;;	frame-style		If set, the _user-chosen_ frame style
  ;;	current-frame-style	The current frame style
  ;;	type			The notional window type, defining
  ;;				 which parts of the frame are included

  ;; The different window types are:

  ;;	default			title bar and border
  ;;	transient		border only
  ;;	shaped			title-bar only
  ;;	shaped-transient	border-like title-bar only
  ;;	unframed		no frame at all
  ;;	icon
  ;;	dock
  ;;	menu, toolbar
  ;;	utility
  ;;	splash

  ;; There is also a similar concept of frame types. The window type
  ;; never changes (unless the user explicitly does so). But the frame
  ;; type may depend on the current window state. For example, if it's
  ;; shaded, then it may have `shaded' or `shaded-transient' frame type.

  ;; These are the types that the frame styles see. Current types include
  ;; all the above window types plus:

  ;;	shaded			normal title bar only
  ;;	shaded-transient	transient title bar only

  ;; When framing windows the frame-type-fallback-alist variable will be
  ;; used to iterate frame types until a type that the theme implements
  ;; is found.

  ;; However, this separation of frame and window type shouldn't
  ;; discourage themes from detecting other window state. For example,
  ;; themes may want to display maximized windows differently from
  ;; non-maximized. (In fact the frame-type != window-type scheme is
  ;; largely just for compatibility)

;;; custom support

  (define (custom-make-frame-style-widget)
    `(frame-style ,(find-all-frame-styles t) ,theme-load-path))

  (put 'frame-style 'custom-widget custom-make-frame-style-widget)

;;; variables etc

  (defvar frame-part-classes nil
    "Alist of (CLASS . ALIST) associating classes of frame parts with state
they inherit.")

  (defvar override-frame-part-classes nil
    "Alist of (CLASS . ALIST) associating classes of frame parts with state
that overrides settings set elsewhere.")

  (defvar nil-frame nil
    "Frame definition used for unframed windows.")

  (defcustom default-frame-style nil
    "Theme"
    :type frame-style
    :group appearance
    :after-set (lambda () (after-setting-default-frame)))

  (defcustom reload-themes-when-changed t
    "Automatically reload themes when they are updated."
    :type boolean
    :group appearance)

  (defvar frame-type-fallback-alist
    '((transient . default)
      (shaped . default)
      (shaped-transient . shaped)
      (shaded . shaped)
      (shaded-transient . shaped-transient)
      (icon . shaped-transient)
      (dock . unframed)
      (utility . default)
      (shaded-utility . shaded-transient)
      (toolbar . unframed)
      (menu . unframed)
      (splash . unframed)
      ;; (shaded-toolbar . shaded-utility)
      ;; (shaded-menu . shaded-utility)
      )
    "Frame type fallbacks. This is an alist whose elements are
(required-type . fallback-type). When REQUIRED-TYPE is not supported
by the current theme, then FALLBACK-TYPE is used instead.")

  ;; Re-Coloring Options for Themes

  (define (update-frame-font-color)
    (if use-custom-font-color
	(mapc (lambda (fc)
		(set-frame-part-value fc 'foreground
                                      `((inactive . ,frame-font-inactive-color)
                                        (focused . ,frame-font-active-color)
					(highlighted . ,frame-font-highlight-color)
					(clicked . ,frame-font-clicked-color)
					(inactive-highlighted . ,frame-font-inactive-highlight-color)
					(inactive-clicked . ,frame-font-inactive-clicked-color))
                                      t))
              '(title tabbar-horizontal))
      (mapc (lambda (fc) (remove-frame-part-value fc 'foreground t))
            '(title tabbar-horizontal)))
    (mapc rebuild-frame (managed-windows)))

  (define (update-frame-font)
    (if use-custom-font
        (mapc (lambda (fc)
		(set-frame-part-value fc 'font
				      `((inactive . ,frame-font-inactive)
					(focused . ,frame-font-active)
					(highlighted . ,frame-font-highlight)
					(clicked . ,frame-font-clicked)
					(inactive-highlighted . ,frame-font-highlight)
					(inactive-clicked . ,frame-font-clicked)) t))
	      '(title tabbar-horizontal))
      (mapc (lambda (fc) (remove-frame-part-value fc 'font t))
	    '(title tabbar-horizontal)))
    (mapc rebuild-frame (managed-windows)))

  (define (get-cursor-shape-for-button button)
    (case button
      ((menu-button) menu-button-cursor-shape)
      ((close-button) close-button-cursor-shape)
      ((iconify-button) iconify-button-cursor-shape)
      ((maximize-button) maximize-button-cursor-shape)
      ((shade-button) shade-button-cursor-shape)
      ((sticky-button) sticky-button-cursor-shape)
      ((lock-button) lock-button-cursor-shape)
      ((rename-button) rename-button-cursor-shape)
      ((move-resize-button) move-resize-button-cursor-shape)
      ((raise-lower-button) raise-lower-button-cursor-shape)
      ((next-workspace-button) next-workspace-button-cursor-shape)
      ((previous-workspace-button) previous-workspace-button-cursor-shape)))

  (define (update-button-cursor-shape)
    (if use-custom-button-cursor-shape
        (mapc (lambda (btn)
		(set-frame-part-value btn 'cursor (get-cursor-shape-for-button btn) t))
	      '(menu-button close-button iconify-button maximize-button shade-button
		sticky-button lock-button rename-button move-resize-button raise-lower-button
		next-workspace-button previous-workspace-button))
      (mapc (lambda (btn)
	      (remove-frame-part-value btn 'cursor t))
	    '(menu-button close-button iconify-button maximize-button shade-button
	      sticky-button lock-button rename-button move-resize-button raise-lower-button
		next-workspace-button previous-workspace-button)))
    (mapc rebuild-frame (managed-windows)))

  (define (update-border-color-width)
    (if use-custom-border
        (mapc (lambda (border)
		(set-frame-part-value border 'border-width custom-border-width t)
		(set-frame-part-value border 'border-color custom-border-color t))
	      '(title tabbar-horizontal tabbar-vertical))
      (mapc (lambda (border)
	      (remove-frame-part-value border 'border-width t)
	      (remove-frame-part-value border 'border-color t))
	    '(title tabbar-horizontal tabbar-vertical)))
    (mapc rebuild-frame (managed-windows)))

  (define title-x-left-offset)
  (define title-x-right-offset)
  (define title-y-top-offset)
  (define title-y-bottom-offset)

  (define (update-title-x-offsets value)
    (setq title-x-left-offset (car value))
    (setq title-x-right-offset (cdr value)))

  (define (update-title-y-offsets value)
    (setq title-y-top-offset (car value))
    (setq title-y-bottom-offset (cdr value)))

  (define (get-text-position requested-position)
    ;; this function sets the real position. 'left 'center 'right are user-choosen,
    ;; we check here whether applicable. eg. left (= 0) is not appropriate for
    ;; StyleTab, as it shows an icon on the left
    (case requested-position
      ((left) (+ 1 (or title-x-left-offset 0)))
      ((right) (+ -1 (or title-x-right-offset 0)))
      ((top) (+ 1 (or title-y-top-offset 0)))
      ((bottom) (+ -1 (or title-y-bottom-offset 0)))
      ((center) 'center)))

  (define (update-text-position)
    (if use-custom-text-position
      (progn
        (unless (eq custom-text-x-position 'default)
	  (mapc (lambda (pos)
		  (set-frame-part-value pos 'x-justify (get-text-position custom-text-x-position) t))
	        '(title tabbar-horizontal)))
	(unless (eq custom-text-y-position 'default)
	  (mapc (lambda (pos)
		  (set-frame-part-value pos 'y-justify (get-text-position custom-text-y-position) t))
	        '(title tabbar-horizontal))))
      (update-title-x-offsets '(0 . 0))
      (update-title-y-offsets '(0 . 0)))
    (when (or (not use-custom-text-position)
	      (eq custom-text-x-position 'default))
      (mapc (lambda (pos)
	      (remove-frame-part-value pos 'x-justify t))
	    '(title tabbar-horizontal)))
    (when (or (not use-custom-text-position)
	      (eq custom-text-y-position 'default))
      (mapc (lambda (pos)
	      (remove-frame-part-value pos 'y-justify t))
	    '(title tabbar-horizontal)))
    (mapc rebuild-frame (managed-windows)))

  (defvar theme-update-interval 60
    "Number of seconds between checking if theme files have been modified.")

  (defvar user-theme-directory "~/.sawfish/themes"
    "Directory containing user-local themes.")

  (defvar system-theme-directory (expand-file-name
				  "../themes" sawfish-lisp-lib-directory)
    "Directory containing themes from the current sawfish version.")

  (defvar site-theme-directory (expand-file-name
				"../../themes" sawfish-lisp-lib-directory)
    "Directory containing system-wide themes.")

  (defvar theme-load-path (list user-theme-directory
				site-theme-directory
				system-theme-directory)
    "List of directories from which themes may be loaded.")

  (define frame-styles nil
          "List of (NAME . FUNCTION) defining all loaded frame styles.")

  ;; List of (NAME FILENAME MODTIME) mapping loaded frame styles to the
  ;; files they were loaded from; used to check if the theme needs reloading
  (define frame-style-files nil)

  (define frame-type-mappers '()
          "List of functions that map (WINDOW FRAME-TYPE) ->
FRAME-TYPE. Used when deciding which frame type to ask a theme to
generate.")

  ;; list of (REGEXP DIR-EXPAND NAME-EXPAND)
  (defvar theme-suffix-regexps
    '(("^(.*)/(.*)\\.tar(\\.gz|\\.Z|\\.bz2|\\.xz|\\.lzma|)$"
       "\\0#tar/\\2" "\\2")))

  (defvar theme-suffixes '("" ".tar" ".tar.gz" ".tar.Z" ".tar.bz2"
                           ".tar.xz" ".tar.lzma"))

  (defvar themes-are-gaolled t
    "When non-nil themes are assumed to be malicious.")

;;; defcustom's for some built-in variables

  (defcustom default-font nil
    "Default font: \\left"
    :group appearance
    :type font
    :after-set (lambda () (after-setting-frame-option)))

  (defvar default-bevel-percent nil
    "Bevel intensity as a percentage.")

  ;; frame fonts & colors
  (defcustom use-custom-font nil
    "Use custom font for different states"
    :type boolean
    :group appearance
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-inactive default-font
    "Font for inactive titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-active default-font
    "Font for focused titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-highlight default-font
    "Font for highlighted titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom frame-font-clicked default-font
    "Font for clicked titlebars: \\left"
    :group appearance
    :type font
    :depends use-custom-font
    :after-set (lambda () (update-frame-font)))

  (defcustom use-custom-font-color '()
    "Use custom font colors for frames"
    :type boolean
    :group appearance
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-active-color "#F2F2F2"
    "Font color for active frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-inactive-color "#CBCBCB"
    "Font color for inactive frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-highlight-color "#FEFEFE"
    "Font color for highlighted frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-inactive-highlight-color "#D8D8D8"
    "Font color for inactive highligted frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-clicked-color "#FFFFFF"
    "Font color for clicked frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom frame-font-inactive-clicked-color "#EEEEEE"
    "Font color for inactive clicked frames"
    :type color
    :group appearance
    :depends use-custom-font-color
    :after-set (lambda () (update-frame-font-color)))

  (defcustom use-custom-button-cursor-shape nil
    "Whether to change the cursor shape for frame buttons."
    :type boolean
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom menu-button-cursor-shape 'X_cursor
    "Cursor shape for menu button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom close-button-cursor-shape 'pirate
    "Cursor shape for close button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom iconify-button-cursor-shape 'll_angle
    "Cursor shape for iconify button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom maximize-button-cursor-shape 'draped_box
    "Cursor shape for maximize button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom shade-button-cursor-shape 'left_ptr
    "Cursor shape for shade button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom sticky-button-cursor-shape 'plus
    "Cursor shape for sticky button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom lock-button-cursor-shape 'dotbox
    "Cursor shape for lock button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom next-workspace-button-cursor-shape 'sb_right_arrow
    "Cursor shape for next-workspace button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom previous-workspace-button-cursor-shape 'sb_left_arrow
    "Cursor shape for previous-workspace button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom rename-button-cursor-shape 'xterm
    "Cursor shape for rename button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom move-resize-button-cursor-shape 'fleur
    "Cursor shape for move-resize button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom raise-lower-button-cursor-shape 'double_arrow
    "Cursor shape for raise-lower button: \\left"
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox double_arrow draped_box
		  fleur hand1 hand2 iron_cross left_ptr ll_angel mouse
		  pencil pirate plus question_arrow right_ptr sb_left_arrow
		  sb_right_arrow sb_bottom_arrow sb_top_arrow spider star
		  target tcross xterm X_cursor)
    :depends use-custom-button-cursor-shape
    :group appearance
    :after-set (lambda () (update-button-cursor-shape)))

  (defcustom use-custom-text-position nil
    "Whether to change the position of the titlebar text."
    :type boolean
    :group appearance
    :after-set (lambda () (update-text-position)))

  (defcustom custom-text-x-position 'default
    "Horizontal orientation of the text."
    :type (choice default left center right)
    :group appearance
    :depends use-custom-text-position
    :after-set (lambda () (update-text-position)))

  (defcustom custom-text-y-position 'default
    "Vertical orientation of the text."
    :type (choice default top center bottom)
    :group appearance
    :depends use-custom-text-position
    :after-set (lambda () (update-text-position)))

  (defcustom use-custom-border '()
    "Draw an extra window border"
    :type boolean
    :group appearance
    :after-set (lambda () (update-border-color-width)))

  (defcustom custom-border-color "black"
    "Color for the window border"
    :type color
    :group appearance
    :depends use-custom-border
    :after-set (lambda () (update-border-color-width)))

  (defcustom custom-border-width 0
    "Width for the window border"
    :type number
    :group appearance
    :depends use-custom-border
    :after-set (lambda () (update-border-color-width)))

;;; managing frame types

  (define (define-frame-type-mapper fun)
    (unless (memq fun frame-type-mappers)
      (setq frame-type-mappers (cons fun frame-type-mappers))))

  (define (find-frame-definition w style)
    ;; 1. map window type to actual frame type
    (let loop-1 ((rest frame-type-mappers)
		 (type (window-type w)))
      (if (null rest)
	  ;; found the final frame type, so,
	  ;; 2. find the closest type that the style implements to this
	  (let loop-2 ((type type)
		       (seen (list type)))
	    (cond ((eq type 'unframed) nil-frame)
		  ((style w type))
		  (t (let ((next (or
				  (cdr (assq type
					     frame-type-fallback-alist))
				  'unframed)))
		       (if (memq next seen)
			   ;; been here before..
			   nil-frame
			 (loop-2 next (cons next seen)))))))
	;; else, apply this transformation and keep looping
	(loop-1 (cdr rest) ((car rest) w type)))))

;;; managing frame styles

  (define (add-frame-style name function)
    (let ((cell (assq name frame-styles)))
      (if cell
	  (rplacd cell function)
	(setq frame-styles (cons (cons name function) frame-styles)))
      (when load-filename
	(let
	    ;; if we're loading from a tar-file, then check the
	    ;; tar file itself, not its contents (for efficiency)
	    ((file (if (string-match "#tar/" load-filename)
		       (substring load-filename 0 (match-start))
		     load-filename)))
	  (setq cell (assq name frame-style-files))
	  (if cell
	      (rplacd cell (list file (file-modtime file)))
	    (setq frame-style-files (cons (list name file (file-modtime file))
					  frame-style-files)))))
      (unless default-frame-style
	(setq default-frame-style name))))

  (define (check-frame-availability name)
    (unless (assq name frame-styles)
      (load-frame-style name)
      (or (assq name frame-styles) (error "No such frame style: %s" name))))

  (define (reload-frame-style name)
    (when (assq name frame-styles)
      (load-frame-style name)
      (reframe-windows-with-style name)))

  ;; called periodically from a timer
  (define (frames-on-idle timer)
    (set-timer timer theme-update-interval)
    (when reload-themes-when-changed
      (mapc (lambda (cell)
	      (let ((style (nth 0 cell))
		    (file (nth 1 cell))
		    (modtime (nth 2 cell)))
		(when (time-later-p (file-modtime file) modtime)
		  (reload-frame-style style))))
	    frame-style-files)))

;;; applying frame styles to windows

  (define (reframe-window w)
    (if (window-get w 'ignored)
	(progn
	  (window-put w 'current-frame-style nil)
	  (set-window-frame w nil-frame))
      (let ((style (or (window-get w 'frame-style)
		       default-frame-style)))
	(check-frame-availability style)
	(let ((style-fun (cdr (assq style frame-styles))))
	  (set-window-frame w (if style-fun
				  (find-frame-definition w style-fun)
				nil-frame))
	  (window-put w 'current-frame-style style)))))

  (define (reframe-all-windows) (map-windows reframe-window))

  (define after-setting-frame-option reframe-all-windows)

  (define (after-setting-default-frame)
    (check-frame-availability default-frame-style)
    (after-setting-frame-option)
    ;; XXX Fucking evil!
    ;; XXX offsets would be wrong else...
    (when use-custom-text-position
      (setq use-custom-text-position nil)
      (update-text-position)
      (reframe-windows-with-style default-frame-style)
      (setq use-custom-text-position t)
      (update-text-position))
    ;; XXX even more Fucking evil!
    ;; XXX tab-adjustments would be wrong else
    ;; XXX even though each theme sets them...
    (if (or (eq default-frame-style (intern "StyleTab"))
	    (eq default-frame-style (intern "Elberg-tabbbed"))
	    (eq default-frame-style (intern "get-S-tabbed"))
	    (eq default-frame-style (intern "gradient-tabbed")))
      (reframe-windows-with-style default-frame-style)))

  (define (rebuild-frames-with-style style)
    (map-windows (lambda (w)
		   (when (eq (window-get w 'current-frame-style) style)
		     (rebuild-frame w)))))

  (define (reframe-windows-with-style style)
    (map-windows (lambda (w)
		   (when (eq (window-get w 'current-frame-style) style)
		     (reframe-window w)))))

  (define (set-frame-style w style)
    (unless (eq (window-get w 'frame-style) style)
      (window-put w 'frame-style style)
      (call-window-hook 'window-state-change-hook w (list '(frame-style)))
      (reframe-window w)))

  ;; return true iff successful
  (define (apply-frame-style style)
    (let ((old-style default-frame-style))
      (condition-case nil
	  (progn
	    (setq default-frame-style style)
	    (after-setting-default-frame)
	    t)
	(error
	 (setq default-frame-style old-style)
	 (after-setting-frame-option)
	 nil))))

  (define (save-current-frame-style)
    (require 'sawfish.wm.customize)
    (customize-set 'default-frame-style default-frame-style))

  (define (apply-frame-style-and-save style)
    (when (apply-frame-style style)
      (save-current-frame-style)))

;;; kludge different window decors by modifying the assumed window type

  (define (window-type w)
    (or (window-get w 'type)
	(if (window-transient-p w)
	    (if (window-shaped-p w)
		'shaped-transient
	      'transient)
	  (if (window-shaped-p w)
	      'shaped
	    'default))))

  (define (set-window-type w type)
    (if (window-get w 'type/saved)
	(window-put w 'type/saved type)
      (unless (eq (window-get w 'type) type)
	(window-put w 'type type)
	(call-window-hook 'window-state-change-hook w (list '(type)))
	(reframe-window w))))

  ;; XXX do something with KEY. (It's a unique symbol used to mark
  ;; XXX the different users of these functions)

  (define (push-window-type w type key)
    (window-put w 'type/key key)
    (unless (eq (window-get w 'type type))
      (unless (window-get w 'type/saved)
	(window-put w 'type/saved (window-get w 'type)))
      (window-put w 'type type)
      (call-window-hook 'window-state-change-hook w (list '(type)))
      (reframe-window w)))

  (define (pop-window-type w key)
    (when (and (window-get w 'type/saved)
	       (eq (window-get w 'type/key) key))
      (window-put w 'type (window-get w 'type/saved))
      (window-put w 'type/saved nil)
      (window-put w 'type/key nil))
    (call-window-hook 'window-state-change-hook w (list '(type)))
    (reframe-window w))

  (define (window-type-remove-title type)
    (case type
      ((default) 'transient)
      ((shaped shaped-transient) 'unframed)
      (t type)))

  (define (window-type-remove-border type)
    (case type
      ((default) 'shaped)
      ((transient shaped-transient) 'unframed)
      (t type)))

  (define (window-type-add-title type)
    (case type
      ((transient) 'default)
      ((unframed) 'shaped)
      (t type)))

  (define (window-type-add-border type)
    (case type
      ((shaped) 'default)
      ((unframed) 'transient)
      (t type)))

  ;; create some commands for setting the window type
  (mapc (lambda (type)
	  (define-command (intern (concat "set-frame:" (symbol-name type)))
	    (lambda (w) (set-window-type w type)) #:spec "%W"))
	'(default transient shaped shaped-transient unframed))

;;; loading ``themes'' (currently just frame styles)

  (define (frame-style-directory dir #!optional get-name)
    (if (and (file-directory-p dir)
	     (or (file-exists-p (expand-file-name "theme.jl" dir))
		 (file-exists-p (expand-file-name "theme.jlc" dir))))
	(if get-name
	    (file-name-nondirectory dir)
	  dir)
      ;; try the list of suffixes
      (catch 'out
	(mapc (lambda (cell)
		(when (string-match (car cell) dir)
		  (let ((full (expand-last-match (nth 1 cell))))
		    (when (file-directory-p full)
		      (throw 'out (if get-name
				      (expand-last-match (nth 2 cell))
				    full))))))
	      theme-suffix-regexps)
	nil)))

  (define (find-frame-style name)
    (catch 'out
      (mapc (lambda (dir)
	      (mapc (lambda (suf)
		      (let* ((t-dir (expand-file-name
				     (concat (symbol-name name) suf) dir))
			     tem)
			(when (file-exists-p t-dir)
			  (setq tem (frame-style-directory t-dir))
			  (when tem
			    (throw 'out tem)))))
		    theme-suffixes))
	    theme-load-path)
      nil))

  (define (load-frame-style name)
    (let ((dir (find-frame-style name)))
      (when dir
	(let ((image-load-path (cons dir image-load-path)))
	  (if themes-are-gaolled
	      (let ((gaol (make-gaol)))
		(gaol-load (expand-file-name "theme.jl" dir) gaol)
		(define-gaol-structure (intern (concat "themes."
						       (symbol-name name)))
                  gaol))
	    (load (expand-file-name "theme" dir) nil t))))))

  (define (find-all-frame-styles #!optional sorted)
    (let (lst tem)
      (mapc (lambda (dir)
	      (when (file-directory-p dir)
		(mapc (lambda (t-dir)
			(when (setq tem (frame-style-directory
					 (expand-file-name t-dir dir) t))
			  (unless (member tem lst)
			    (setq lst (cons tem lst)))))
		      (directory-files dir))))
	    theme-load-path)
      (when sorted
	(setq lst (sort lst string-lessp)))
      (mapcar intern lst)))

  (define (frame-style-menu w)
    (let ((styles (find-all-frame-styles t)))
      (nconc (mapcar (lambda (s)
		       (list (quote-menu-item (symbol-name s))
			     (lambda ()
			       (set-frame-style (current-event-window) s))
			     (cons 'check (eq (window-get w 'frame-style) s))
			     '(group . menu-style)))
		     styles)
	     (list '())
	     (list (list (_ "Default")
			 (lambda ()
			   (set-frame-style (current-event-window) nil))
			 (cons 'check (not (window-get w 'frame-style)))
			 '(group . menu-style))))))

  (define (frame-type-menu w)
    `((,(_ "Normal") set-frame:default
       (check . ,(eq (window-type w) 'default))
       (group . menu-type))
      (,(_ "Title-only") set-frame:shaped
       (check . ,(eq (window-type w) 'shaped))
       (group . menu-type))
      (,(_ "Border-only") set-frame:transient
       (check . ,(eq (window-type w) 'transient))
       (group . menu-type))
      (,(_ "Top-border") set-frame:shaped-transient
       (check . ,(eq (window-type w) 'shaped-transient))
       (group . menu-type))
      (,(_ "None") set-frame:unframed
       (check . ,(eq (window-type w) 'unframed))
       (group . menu-type))))

;;; removing frame parts

  (define (remove-frame-class w class)
    (window-put w 'removed-classes
		(cons class (delq class (window-get w 'removed-classes))))
    (when (window-framed-p w)
      (rebuild-frame w)))

  (define (add-frame-class w class)
    (window-put w 'removed-classes
		(delq class (window-get w 'removed-classes)))
    (when (window-framed-p w)
      (rebuild-frame w)))

  (define (frame-class-removed-p w class)
    (memq class (window-get w 'removed-classes)))

;;; manipulating the frame part classes variables

  (define (set-frame-part-value class key value #!optional override)
    (let* ((var (if override 'override-frame-part-classes 'frame-part-classes))
	   (item (assq class (symbol-value var)))
	   tem)
      (if item
	  (if (setq tem (assq key (cdr item)))
	      (rplacd tem value)
	    (rplacd item (cons (cons key value) (cdr item))))
	(set var (cons (cons class (list (cons key value)))
		       (symbol-value var))))))

  (define (remove-frame-part-value class key #!optional override)
    (let* ((fpcs (if override override-frame-part-classes frame-part-classes))
           (item (assq class fpcs)))
      (when item
        (setcdr item (delete-if (lambda (it) (eq (car it) key))
                                (cdr item))))))

  ;; Example:
  ;; (def-frame-class shade-button '((cursor . foo) ...)
  ;;   (bind-keys shade-button-keymap
  ;;     "Button1-Off" 'toggle-window-shaded))
  ;;
  ;; the idea being that it will only create the frame part if it doesn't
  ;; exist, it will add all properties from the second argument unless
  ;; they're already set, then create and initialise the keymap from the
  ;; third argument (unless a keymap is already defined)

  (defmacro def-frame-class (class alist #!rest keymap-forms)
    (if keymap-forms
	`(when (define-frame-class ',class ,alist t)
	   ,@keymap-forms)
      `(define-frame-class ',class ,alist)))

  (define (define-frame-class class alist #!optional with-keymap)
    (let ((cell (assq class frame-part-classes))
	  (ok-to-bind nil))
      (if (not cell)
	  (progn
	    (setq cell (cons class alist))
	    (setq frame-part-classes (cons cell frame-part-classes)))
	(mapc (lambda (attr)
		(let ((tem (assq (car attr) (cdr cell))))
		  (unless tem
		    (rplacd cell (cons attr (cdr cell))))))
	      alist))
      (when with-keymap
	(let ((map-name (intern (concat (symbol-name class) "-keymap"))))
	  (unless (boundp map-name)
	    (make-variable-special map-name)
	    (set map-name (make-keymap))
	    (setq ok-to-bind t)
	    ;; so the theme can bind to the keymap..
	    (gaol-define-special map-name))
	  (set-frame-part-value class 'keymap map-name)))
      ok-to-bind))

  (define ((cursor-for-frame-part part) w)
    (require 'sawfish.wm.state.maximize)
    (if (frame-part-movable-p w part)
	(case part
	  ((top-border) 'top_side)
	  ((bottom-border) 'bottom_side)
	  ((left-border) 'left_side)
	  ((right-border) 'right_side)
	  ((top-left-corner) 'top_left_corner)
	  ((top-right-corner) 'top_right_corner)
	  ((bottom-left-corner) 'bottom_left_corner)
	  ((bottom-right-corner) 'bottom_right_corner))
      nil))

;;; initialisation

  (define-frame-class 'menu-button '((keymap . menu-button-keymap)))
  (define-frame-class 'close-button '((keymap . close-button-keymap)))
  (define-frame-class 'iconify-button '((keymap . iconify-button-keymap)))
  (define-frame-class 'maximize-button '((keymap . maximize-button-keymap)))
  (define-frame-class 'shade-button '((keymap . shade-button-keymap)))
  (define-frame-class 'sticky-button '((keymap . sticky-button-keymap)))
  (define-frame-class 'lock-button '((keymap . lock-button-keymap)))
  (define-frame-class 'rename-button '((keymap . rename-button-keymap)))
  (define-frame-class 'move-resize-button '((keymap . move-resize-button-keymap)))
  (define-frame-class 'raise-lower-button '((keymap . raise-lower-button-keymap)))
  (define-frame-class 'next-workspace-button '((keymap . next-workspace-button-keymap)))
  (define-frame-class 'previous-workspace-button '((keymap . previous-workspace-button-keymap)))

  (define-frame-class 'title `((keymap . title-keymap)
			       (cursor . ,(cursor-for-frame-part 'title))))

  (define-frame-class 'tabbar-horizontal `((keymap . tabbar-keymap)
					   (cursor . ,(cursor-for-frame-part 'title))))

  (define-frame-class 'tabbar-vertical `((keymap . tabbar-keymap)
					 (cursor . ,(cursor-for-frame-part 'title))))

  (mapc (lambda (x)
	  (define-frame-class x `((cursor . ,(cursor-for-frame-part x))
				  (keymap . border-keymap))))
	'(top-border bottom-border
                     left-border right-border
                     top-left-corner top-right-corner
                     bottom-left-corner bottom-right-corner))

  (gaol-add add-frame-style reframe-window rebuild-frames-with-style
	    reframe-windows-with-style reframe-all-windows window-type
	    def-frame-class define-frame-class after-setting-frame-option
	    frame-part-get frame-part-put frame-part-window frame-part-x-window
	    frame-part-position frame-part-dimensions frame-part-state
	    map-frame-parts refresh-frame-part refresh-window rebuild-frame-part
	    reload-frame-style update-title-x-offsets update-title-y-offsets)

  (add-hook 'add-window-hook reframe-window t)
  (add-hook 'shape-notify-hook reframe-window t)

  (make-timer frames-on-idle theme-update-interval)

  (add-hook 'sm-window-save-functions
	    (lambda (w)
	      (cond ((window-get w 'type/saved)
		     (list (cons 'type (window-get w 'type/saved))))
		    ((window-get w 'type)
		     (list (cons 'type (window-get w 'type)))))))

  (sm-add-saved-properties 'ignored 'frame-style)
  (sm-add-restored-properties 'type)
  (add-swapped-properties 'frame-active-color 'frame-inactive-color)
  )

;; sm-init.jl -- session manager code loaded on startup

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.session.init

    (export sm-find-file
	    sm-add-saved-properties
	    sm-add-restored-properties
	    sm-get-window-prop
	    sm-save-yourself
	    sm-init)

    (open rep
	  rep.regexp
	  rep.system
	  rep.io.files
	  rep.io.processes
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.session.util)

  (define sm-client-id nil
          "A string identifying the current session.")

  (define sm-prefix nil
          "A string used to uniquify the session file.")

  ;; this is before both the panel and gmc..?
  (defconst sm-gsm-priority 30)

  (defvar sm-save-directory "~/.sawfish/sessions")

  (defvar sm-saved-window-properties nil
    "List of window properties saved with the session.")

  (defvar sm-restored-window-properties nil
    "Extra window properties restored from the session.")

  (defvar sm-window-save-functions nil
    "List of functions called when the state of each window is saved. Each
function should return a list of alist elements that will be saved in
the state file.")

  (defvar sm-restore-window-hook nil
    "List of functions called when the state of a window is restored. Each is
called with args (WINDOW ALIST), where ALIST defines the state saved for
the window.")

  (defvar sm-after-restore-hook nil
    "Hook called after loading a saved session.")

  (defvar sm-sloppy-id-matching nil
    "When loading sessions, the algorithm that matches saved session data
to running clients requires that if one has a session id, then so must
the other, and they must match. Setting this variable to true turns
that feature off, allowing some broken clients to be session managed.")

;;; utilities

  ;; PREFIX may be null
  (define (sm-find-file id prefix)
    (if prefix
	(expand-file-name (format nil "%s-%s" prefix id) sm-save-directory)
      (expand-file-name id sm-save-directory)))

  (define (sm-add-saved-properties #!rest props)
    (mapc (lambda (p)
	    (or (memq p sm-saved-window-properties)
		(setq sm-saved-window-properties
		      (cons p sm-saved-window-properties))))
	  props))

  (define (sm-add-restored-properties #!rest props)
    (mapc (lambda (p)
	    (or (memq p sm-restored-window-properties)
		(setq sm-restored-window-properties
		      (cons p sm-restored-window-properties))))
	  props))

  ;; find PROP associated with W, or nil
  (define (sm-get-window-prop w prop)
    ;; first look in the window itself,
    (or (nth 2 (get-x-property w prop))
	;; else try the leader
	(let* (tem
	       (leader (cond ((and (setq tem (get-x-property
					      w 'WM_CLIENT_LEADER))
				   (eq (car tem) 'WINDOW)
				   (eq (nth 1 tem) 32)
				   (not (zerop (aref (nth 2 tem) 0))))
			      (aref (nth 2 tem) 0))
			     ((window-group-id w))
			     ((window-transient-p w)))))
	  (and leader (nth 2 (get-x-property leader prop))))))

  (define (make-unique-prefix) (number->string (current-utime) 36))

  ;; callback

  (define (sm-save-yourself)
    (require 'sawfish.wm.session.save)

    ;; We're not allowed to reuse the files used to save sessions.
    ;; So generate a new name each time.
    (setq sm-prefix (make-unique-prefix))

    (save-session (sm-find-file sm-client-id sm-prefix))
    (set-restart-command)
    (set-discard-command))

  ;; But the session manager doesn't delete files that we
  ;; leave around when we exit normally..

  (define (before-exit)
    (unless (or (eq (exit-type) 'session-quit)
		(not sm-client-id))
      (remove-sm-options)
      (let ((file (sm-find-file sm-client-id sm-prefix)))
	(when (file-exists-p file)
	  (delete-file file)))))

  (add-hook 'before-exit-hook before-exit)

;;; initialisation

  (define (remove-sm-options)
    ;; remove any sm options from saved-command-line-args
    (let loop ((args saved-command-line-args))
      (when (cdr args)
	(if (string-match "^(--sm-client-id|-clientId|--sm-prefix)"
			  (cadr args))
	    (progn
	      (if (string-match "=" (cadr args))
		  (rplacd args (cddr args))
		(rplacd args (cdddr args)))
	      (loop args))
	  (loop (cdr args))))))

  (define (set-discard-command)
    (sm-set-property
     "DiscardCommand"
     (list "rm" "-f" (local-file-name (sm-find-file sm-client-id sm-prefix)))))

  (define (set-restart-command)
    (remove-sm-options)
    (if sm-prefix
	(rplacd saved-command-line-args (list* "--sm-client-id" sm-client-id
					       "--sm-prefix" sm-prefix
					       (cdr saved-command-line-args)))
      (rplacd saved-command-line-args (list* "--sm-client-id" sm-client-id
					     (cdr saved-command-line-args))))
    (sm-set-property "RestartCommand" saved-command-line-args))

  (define (sm-init id prefix)
    (when (setq sm-client-id (sm-connect id))

      ;; 1. setup all session manager properties
      (setq sm-prefix prefix)

      ;; XXX should I set this to SmRestartImmediately (2) instead
      ;; XXX of SmRestartIfRunning (0) ?
      (sm-set-property "RestartStyleHint" 2)

      (remove-sm-options)
      (sm-set-property "CloneCommand" saved-command-line-args)

      (set-restart-command)

      (sm-set-property "CurrentDirectory" (local-file-name default-directory))
      (sm-set-property "ProcessId" (format nil "%d" (process-id)))
      (sm-set-property "Program" (car saved-command-line-args))
      (sm-set-property "UserId" (user-login-name))

      ;; we need to start before gmc, otherwise it won't hint its icons
      (sm-set-property "_GSM_Priority" sm-gsm-priority)

      ;; 2. load the session if it exists
      (let ((file (sm-find-file sm-client-id sm-prefix)))
	(when (file-exists-p file)
	  (require 'sawfish.wm.session.load)
	  (load-session file)
	  (set-discard-command))))))

;; recolor-image.jl -- simple code for recolouring images
;;
;; Copyright (C) 2001 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; this module is marked as being fully-safe, so don't add any
;; dangerous functions!

(define-structure sawfish.wm.util.recolor-image

    (export make-image-recolorer*
	    make-image-recolorer
	    red-channel
	    green-channel
	    blue-channel
	    alpha-channel)

    (open rep
	  sawfish.wm.images
	  sawfish.wm.colors)

  (defconst red-channel 0)
  (defconst green-channel 1)
  (defconst blue-channel 2)
  (defconst alpha-channel 3)

  (define original-key (make-symbol "recolor-image/original"))

  (define (make-image-recolorer* colors #!key
				 (zero-channel red-channel)
				 (index-channels (list green-channel))
				 (save-original t))

    ;; XXX add doc string here..

    (let* ((color-rgbs (mapcar color-rgb-8 colors))
	   (red-luts (mapcar (lambda (c)
			       (make-lut (nth red-channel c))) color-rgbs))
	   (green-luts (mapcar (lambda (c)
				 (make-lut (nth green-channel c))) color-rgbs))
	   (blue-luts (mapcar (lambda (c)
				(make-lut (nth blue-channel c))) color-rgbs)))

      (lambda (image)

	;; Get the original state of the image
	(if (image-get image original-key)
	    ;; Hmm.. don't have a blit-image function, this will do
	    (tile-image image (image-get image original-key))

	  (when save-original
	    ;; save a copy for when we recolor in future
	    (image-put image original-key (copy-image image))))

	(image-map (lambda (pixel)
		     (when (zerop (nth zero-channel pixel))
		       (let loop ((rest index-channels)
				  (red-rest red-luts)
				  (green-rest green-luts)
				  (blue-rest blue-luts))
			 (when rest
			   (let ((index (nth (car rest) pixel)))
			     (if (not (zerop index))
				 (list (aref (car red-rest) index)
				       (aref (car green-rest) index)
				       (aref (car blue-rest) index)
				       (nth alpha-channel pixel))
			       (loop (cdr rest)
				     (cdr red-rest)
				     (cdr green-rest)
				     (cdr blue-rest))))))))
		   image))))

  (define (make-image-recolorer color #!key
				(zero-channel red-channel)
				(index-channel green-channel)
				(save-original t))

    "Returns a function of a single argument. Given an image this
function will recolor it based on COLOR. Any pixels in the image whose
ZERO-CHANNEL is zero will be given a new value, computed by indexing
into a 256 element array using the value of the pixel's INDEX-CHANNEL
to choose the element.

The original image is always modified. If SAVE-ORIGINAL is true, the
first time the image is recolored it's original contents will be
stored, and then used as the basis for any future recoloring."

    (make-image-recolorer* (list color)
			   #:zero-channel zero-channel
			   #:index-channels (list index-channel)
			   #:save-original save-original))

  ;; Create a lookup-table, a string containing 256 samples of a gradient
  ;; from 0 -> MID -> 255.
  (define (make-lut mid)
    (let ((lut (make-string 256))
	  (i 0))
      (while (< i 128)
	(aset lut i (inexact->exact (round (* (/ mid 128.) i))))
	(setq i (1+ i)))
      (while (< i 256)
	(aset lut i (inexact->exact
		     (round (+ mid (* (/ (- 255. mid) 128.) (- i 128.))))))
	(setq i (1+ i)))
      lut)))

;; microGUI/theme.jl

;; Copyright (C) 1999 Ryan Lovett <ryan@ocf.berkeley.edu>

;; This theme was based on the QNX Photon microGUI found at www.qnx.com
;; (screenshots at http://www.qnx.com/amiga/delivering.html). Many image
;; components were taken from the minEguE enlightenment theme by Ben
;; FrantzDale (frantzdb@admin.arhs.net). The theme and the rest of the images
;; were put together by Ryan (ryan@ocf.berkeley.edu).

;; hacked for lexical scope by John Harper

(let*
    ;; Update window title pixel length
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))

     ;; 2x6
     (bottom-images (make-image "bottom.png"))

     ;; 6x27
     (top-left-images (list (make-image "top_left_inactive.png")
			    (make-image "top_left.png")))
     (top-left-shaped-images (list (make-image "top_left_inactive_s.png")
				   (make-image "top_left_s.png")))

     ;; 19x19
     (top-blue-images (list (make-image "top_blue_inactive.png")
			    (make-image "top_blue.png")))

     ;; 12x19
     (top-curves-images (list (make-image "top_curves_inactive.png")
			      (make-image "top_curves.png")))

     ;; 19x19
     (top-grey-images (make-image "top_grey.png"))

     ;; 7x19
     (top-right-images (make-image "top_right.png"))
     (top-right-shaped-images (make-image "top_right_s.png"))

     ;; 6x6
     (bottom-left-images (make-image "bl.png"))

     ;; 6x6
     (bottom-right-images (make-image "br.png"))

     ;; 17x16
     (close-images (list (make-image "close_normal.png")
			 (make-image "close_active.png") nil
			 (make-image "close_clicked.png")))

     ;; 17x16
     (maximize-images (list (make-image "maximize_normal.png")
			    (make-image "maximize_active.png") nil
			    (make-image "maximize_clicked.png")))

     ;; 17x16
     (iconify-images (list (make-image "minimize_normal.png")
			   (make-image "minimize_active.png") nil
			   (make-image "minimize_clicked.png")))

     ;; 17x16
     (menu-images (list (make-image "menu_normal.png")
			(make-image "menu_active.png") nil
			(make-image "menu_clicked.png")))

     ;; 6x19
     (left-images (make-image "left.png"))

     ;; 6x19
     (right-images (make-image "right.png"))

     (top-images (flip-image-diagonally (copy-image left-images)))

     ;; 18x17
     (t-close-images (list (make-image "t_close_normal.png")
			   (make-image "t_close_active.png") nil
			   (make-image "t_close_clicked.png")))
     ;; 5x19
     (t-left-images (make-image "t_left.png"))

     ;; 18x10
     (t-right-images (make-image "t_right.png"))

     ;; 19x5
     (t-top-images (make-image "t_top.png"))

     ;; 19x5
     (t-bottom-images (make-image "t_bottom.png"))

     ;; 4x4
     (t-top-left-images (make-image "t_top_left.png"))

     ;; 4x4
     (t-bottom-left-images (make-image "t_bottom_left.png"))

     ;; 17x4
     (t-top-right-images (make-image "t_top_right.png"))

     ;; 17x4
     (t-bottom-right-images (make-image "t_bottom_right.png"))

     (text-colors '("grey85" "white"))

     ;; frame layout

     (frame `(((background . ,top-left-images)
	       (left-edge . -6)
	       (top-edge . -19)
	       (class . top-left-corner))

	      ;; top blue
	      ((background . ,top-blue-images)
	       (foreground . ,text-colors)
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -19)
	       (left-edge . 19)
	       (width . ,(lambda (w) (+ (title-width w) 13)))
	       (class . title))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -19)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; top curves
	      ((background . ,top-curves-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 32)))
	       (top-edge . -19)
	       (class . title))

	      ;; top grey
	      ((background . ,top-grey-images)
	       (top-edge . -19)
	       (left-edge . ,(lambda (w) (+ (title-width w) 44)))
	       (right-edge . 52)
	       (class . title))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -6)
	       (top-edge . 8)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; top-right corner
	      ((background . ,top-right-images)
	       (right-edge . -6)
	       (top-edge . -19)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -6)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 35)
	       (top-edge . -19)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 18)
	       (top-edge . -19)
	       (class . maximize-button))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . 1)
	       (top-edge . -19)
	       (class . close-button))))

     (shaped-frame `(((background . ,top-left-shaped-images)
                      (left-edge . -6)
                      (top-edge . -19)
                      (height . 19)
                      (class . top-left-corner))

                     ;; top blue
                     ((background . ,top-blue-images)
                      (foreground . ,text-colors)
                      (text . ,window-name)
                      (x-justify . 4)
                      (y-justify . center)
                      (top-edge . -19)
                      (left-edge . 19)
                      (width . ,(lambda (w) (+ (title-width w) 13)))
                      (class . title))

                     ;; menu button
                     ((background . ,menu-images)
                      (top-edge . -19)
                      (left-edge . 0)
                      (class . menu-button))

                     ;; top curves
                     ((background . ,top-curves-images)
                      (left-edge . ,(lambda (w) (+ (title-width w) 32)))
                      (top-edge . -19)
                      (class . title))

                     ;; top grey
                     ((background . ,top-grey-images)
                      (top-edge . -19)
                      (left-edge . ,(lambda (w) (+ (title-width w) 44)))
                      (right-edge . 52)
                      (class . title))

                     ;; top-right corner
                     ((background . ,top-right-shaped-images)
                      (right-edge . -6)
                      (top-edge . -19)
                      (height . 19)
                      (class . top-right-corner))

                     ;; iconify button
                     ((background . ,iconify-images)
                      (right-edge . 35)
                      (top-edge . -19)
                      (class . iconify-button))

                     ;; maximize button
                     ((background . ,maximize-images)
                      (right-edge . 18)
                      (top-edge . -19)
                      (class . maximize-button))

                     ;; delete button
                     ((background . ,close-images)
                      (right-edge . 1)
                      (top-edge . -19)
                      (class . close-button))))

     (transient-frame `(((background . ,t-top-left-images)
                         (left-edge . -5)
                         (top-edge . -5)
                         (class . top-left-corner))

                        ;;top-right corner
                        ((background . ,t-top-right-images)
                         (right-edge . -18)
                         (top-edge . -5)
                         (class . top-right-corner))

                        ;;title border
                        ((background . ,t-top-images)
                         (left-edge . -1)
                         (right-edge . -1)
                         (top-edge . -5)
                         (class . top-border))

                        ;; left border
                        ((background . ,t-left-images)
                         (left-edge . -5)
                         (top-edge . -1)
                         (bottom-edge . -1)
                         (class . left-border))

                        ;; right border
                        ((background . ,t-right-images)
                         (right-edge . -18)
                         (top-edge . -1)
                         (bottom-edge . -1)
                         (class . title))

                        ;; bottom border
                        ((background . ,t-bottom-images)
                         (left-edge . -1)
                         (right-edge . -1)
                         (bottom-edge . -5)
                         (class . bottom-border))

                        ;; bottom-left corner
                        ((background . ,t-bottom-left-images)
                         (left-edge . -5)
                         (bottom-edge . -5)
                         (class . bottom-left-corner))

                        ;; bottom-right corner
                        ((background . ,t-bottom-right-images)
                         (right-edge . -18)
                         (bottom-edge . -5)
                         (class . bottom-right-corner))

                        ;; delete button
                        ((background . ,t-close-images)
                         (right-edge . -18)
                         (top-edge . 1)
                         (class . close-button))))

     (shaped-transient-frame `(((background . ,t-top-right-images)
                                (right-edge . -18)
                                (top-edge . -5)
                                (class . top-right-corner))

                               ;; right border
                               ((background . ,t-right-images)
                                (right-edge . -18)
                                (top-edge . -1)
                                (bottom-edge . -1)
                                (class . title))

                               ;; bottom-right corner
                               ((background . ,t-bottom-right-images)
                                (right-edge . -18)
                                (bottom-edge . -5)
                                (class . bottom-right-corner))

                               ;; delete button
                               ((background . ,t-close-images)
                                (right-edge . -18)
                                (top-edge . 1)
                                (class . close-button)))))

  (add-frame-style 'microGUI
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))

  (call-after-property-changed
   '(WM_NAME _NET_WM_NAME) (lambda (w prop state)
                             (reframe-window w))))

;; wallpaper.jl - integrate wallpaper settings into Sawfish

;; (c) 2011 Lucas Pandolfo

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.ext.wallpaper

  (export set-wallpaper
	  set-wallpaper-gnome
	  set-wallpaper-xfce)

  (open rep
	rep.system
	rep.io.files
	sawfish.wm
	sawfish.wm.custom)

  ;; XXX KDE4 doesn't support shell-based changing
  ;; XXX of the wallpaper ... KDE3 did

  ;; XXX Need GNOME3 support

  (define-structure-alias wallpaper sawfish.wm.ext.wallpaper)

  (defgroup wallpaper "Wallpaper" :group appearance)

  (defcustom root-wallpaper nil
    "Wallpaper to use: \\w"
    :type image
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper)))

  (defcustom wallpaper-setter ""
    "Application to set desktop wallpaper."
    :type file-name
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper)))

  (defcustom wallpaper-setter-args ""
    "Additional arguements to pass to the application."
    :type string
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper)))

  (defcustom set-wallpaper-gnome2 nil
    "Whether to apply wallpaper to GNOME2"
    :type boolean
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper-gnome)))

  (defcustom set-wallpaper-xfce4 nil
    "Whether to apply wallpaper to XFCE4"
    :type boolean
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper-xfce)))

  (defcustom wallpaper-display-type 'centered
    "How to display the image (only for GNOME2 and XFCE4)."
    :type (choice auto/none centered tiled scaled streched zoom spanned)
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper)))

  (define (set-wallpaper)
    (when (file-exists-p root-wallpaper)
      (setq wallpaper-filename (concat " \"" root-wallpaper "\""))
      (when wallpaper-setter
	(system (concat wallpaper-setter " " wallpaper-setter-args " " wallpaper-filename " &")))))

  (defvar gnome-type nil)
  (defvar xfce-type nil)
  (defvar wallpaper-filename nil)

  (define (set-wallpaper-gnome)
    (when (and (eq desktop-environment "gnome")
	       set-wallpaper-gnome2
	       (file-exists-p root-wallpaper))
      (setq wallpaper-filename (concat " \"" root-wallpaper "\""))
	(case wallpaper-display-type
	  ((auto/none) (setq gnome-type "none"))
	  ;; unknown value to GNOME2
	  ((tiled) (setq gnome-type "none"))
	  (t (setq gnome-type wallpaper-display-type)))
	(system (concat "gconftool-2 --set --type string
			/desktop/gnome/background/picture_filename " wallpaper-filename " &"))
	(system (concat "gconftool-2 --set --type string
			/desktop/gnome/background/picture_options " gnome-type " &"))))

  (define (set-wallpaper-xfce)
    (when (and (eq desktop-environment "xfce")
	       set-wallpaper-xfce4
	       (file-exists-p root-wallpaper))
      (setq wallpaper-filename (concat " \"" root-wallpaper "\""))
      (case wallpaper-display-type
	((auto/none) (setq xfce-type 0))
	((centered) (setq xfce-type 1))
	((tiled) (setq xfce-type 2))
	((scaled) (setq xfce-type 4))
	((stretched) (setq xfce-type 3))
	((zoom) (setq xfce-type 5))
	;; unknown value to XFCE4
	((spanned) (setq xfce-type 0)))
      (system (concat "xfconf-query -c xfce4-desktop -p /backdrop/screen0/monitor0/image-path
		      -s " wallpaper-filename " &"))
      (system (concat "xfconf-query -c xfce4-desktop -p /backdrop/screen0/monitor0/image-style
		      -s " xfce-type " &")))))

  

#!/bin/sh
exec rep "$0" "$@"
!#

;; sawfish-menu -- subprocess to handle menus

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(require 'gui.gtk-2.gtk)
(require 'rep.data.tables)

;; menus

(define menu-selected nil)

;; map radio-group ids to the last widget
(define group-table (make-fluid))

(define (make-group-table) (make-table symbol-hash eq))
(define (group-id-set id w) (table-set (fluid group-table) id w))
(define (group-id-ref id) (table-ref (fluid group-table) id))

(define (create-menu spec #!optional bar)
  (let* ((menu (if bar (gtk-menu-bar-new) (gtk-menu-new))))

    ;; Set the label of the menu item, handling underlined accelerators
    (define (label-menu-item item label-text #!optional shortcut)
      (let* ((label (gtk-label-new-with-mnemonic label-text))
	     (hbox (gtk-hbox-new nil 16)))
	(gtk-box-pack-start hbox label nil nil t 0)
	(when shortcut
	  (let ((accel (gtk-label-new shortcut)))
	    (gtk-box-pack-end hbox accel nil nil 0)))
	(gtk-widget-show-all hbox)
	(gtk-container-add item hbox)))

    (mapc (lambda (cell)
	    (let (label item)
	      (when (and cell (symbolp (car cell)))
		(setq cell (symbol-value (car cell))))
	      (if (null cell)
		  ;; A separator
		  (setq item (gtk-menu-item-new))

		(setq label (car cell))
		(setq cell (cdr cell))
		(if (and (consp (car cell)) (stringp (car (car cell))))
		    ;; A sub-menu
		    (let ((sub (create-menu cell)))
		      (setq item (gtk-menu-item-new))
		      (label-menu-item item label)
		      (gtk-menu-item-set-submenu item sub))

		  ;; A single menu item
		  (let ((options (cdr cell)))
		    (let* ((check (assq 'check options))
			   (group (cdr (assq 'group options)))
			   (insensitive (cdr (assq 'insensitive options)))
			   (shortcut (cdr (assq 'shortcut options)))
			   (last-widget (and group (group-id-ref group))))
		      (cond (group
			     (setq item (gtk-radio-menu-item-new-from-widget
					 last-widget))
			     (group-id-set group item))
			    (check
			     (setq item (gtk-check-menu-item-new))
			     (gtk-check-menu-item-set-active item t))
			    (t (setq item (gtk-menu-item-new))))
		      (label-menu-item item label shortcut)
		      (when check
			(gtk-check-menu-item-set-active item (cdr check)))
		      (when insensitive
			(gtk-widget-set-sensitive item nil))))

		  (g-signal-connect
		   item "activate" (lambda ()
				     (setq menu-selected (car cell))))))
	      (when item
		;;(gtk-widget-lock-accelerators item)
		(gtk-menu-shell-append menu item)
		(gtk-widget-show item))))
	  spec)
    menu))

(define (popup-menu spec #!optional timestamp position)
  (let ((menu (let-fluids ((group-table (make-group-table)))
                          (create-menu spec))))
    (g-signal-connect menu "deactivate" gtk-main-quit)
    (setq menu-selected nil)
    (gtk-menu-popup-interp menu nil nil 0 (or timestamp 0) position)
    (when (memq 'visible (GTK-WIDGET-FLAGS menu))
      (gtk-main))
    menu-selected))

;; entry point, loop reading command forms, sending back results

(condition-case nil
    (while t
      (let ((input (read standard-input)))
	(format standard-output "%S\n"
		(apply (symbol-value (car input)) (cdr input)))
	(when (filep standard-output)
	  (flush-file standard-output))))
  (end-of-stream))


;; Emacs support
;; Local Variables:
;; mode: sawfish
;; End:

;; lumina.jl -- LUMINA integration

;; Copyright (C) 2014 Christopher Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.lumina

    (export detect-lumina
            lumina-window-matchers)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.windows
	  sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher
	  sawfish.wm.ext.match-window)

  (define-structure-alias lumina-int sawfish.wm.integration.lumina)

  (define (lumina-window-matchers)
    ;; window matchers so we properly interact with lumina-panel
    (add-window-matcher '((WM_CLASS . "^Lumina Desktop Environment/lumina-desktop$"))
     '((opacity . 100)
       (never-tile . t))))

  (define (init)
      (setq desktop-environment "lumina")
      (setq want-poweroff-menu nil)

      ;; invoke the LUMINA terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "xterm"))

      ;; use the LUMINA filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "lumina-fm")))

  ;; Returns nil if lumina is not found.
  ;; If detected, returns t, and do also lumina support init.
  (define (detect-lumina)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "LUMINA")
	      (equal (getenv "XDG_CURRENT_DESKTOP") "Lumina")
	      (equal (getenv "DESKTOP_SESSION") "sawfish-lumina")
	      (get-window-by-class "Lumina" #:regex t)
	      (get-window-by-class "Lumina Desktop Environment" #:regex t))
      (init)
      t)))

(define-structure sawfish.wm.tile
    (export align-workspace-windows
            tile-workspace
            untile-window
            next-tiling
            col-tiling
            tall-tiling
            tall-rotate-left
            tall-rotate-right
            increase-max-windows
            decrease-max-windows
	    increase-max-cols
	    decrease-max-cols
	    window-never-tile-p)
    (open rep
          rep.system
          sawfish.wm.tile.utils
          sawfish.wm.tile.tiler
          sawfish.wm.tile.tall
          sawfish.wm.tile.col))

;; keymaps.jl -- the default keymaps

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.keymaps

    (export custom-set-keymap)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.events
	  sawfish.wm.custom)

  (defgroup bindings "Bindings"
    :layout keymaps)

;;; Customize support

  (define (customizable-command-p x)
    (or (symbolp x)
	(and (symbolp (car x)) (get (car x) 'custom-command-args))))

  (define (custom-get-keymap symbol)
    (cons 'keymap (mapcar (lambda (cell)
			    (cons (car cell) (event-name (cdr cell))))
			  (filter (lambda (cell)
				    (customizable-command-p (car cell)))
				  (cdr (symbol-value symbol))))))

  ;; can't just call out to custom-set-variable since we side-effect VALUE
  (define (custom-set-keymap symbol value)
    (custom-set
     (lambda ()
       (when (eq (car value) 'keymap)
	 (let
	     ((old-value (and (boundp symbol) (symbol-value symbol)))
	      (new-tail (delq nil (mapcar (lambda (cell)
					    (let
						((ev (condition-case nil
							 (lookup-event
							  (cdr cell))
						       (error nil))))
					      (and ev (cons (car cell) ev))))
					  (cdr value)))))

	   (when (eq old-value (variable-default-value symbol))
	     ;; protect the default-value, an ugly hack..
	     (put symbol 'custom-default-value
		  (copy-sequence (variable-default-value symbol))))

	   ;; add in any non-command bindings
	   (setq new-tail (nconc new-tail
				 (filter (lambda (cell)
					   (not (customizable-command-p
						 (car cell))))
					 (cdr old-value))))
	   (if (and old-value (eq (car old-value) 'keymap))
	       ;; hijack the old keymap to preserve eq-ness
	       (rplacd old-value new-tail)
	     (set symbol (cons 'keymap new-tail))))))
     symbol))

  (define-custom-setter 'custom-set-keymap custom-set-keymap)
  (put 'keymap 'custom-set 'custom-set-keymap)
  (put 'keymap 'custom-get custom-get-keymap)

;;; Options

  (defcustom global-keymap (bind-keys (make-keymap)
				      "W-Left" 'previous-workspace
				      "W-Right" 'next-workspace
				      "W-Tab" 'cycle-windows)
    "Keymap active anywhere."
    :group bindings
    :type keymap
    :before-set (lambda () (ungrab-keymap global-keymap))
    :after-set (lambda () (grab-keymap global-keymap)))

  (defcustom window-keymap (bind-keys (make-keymap)
				      "W-Up" 'raise-window
				      "W-Down" 'lower-window
				      "W-Button3-Click1" 'raise-lower-window
				      "W-Button2-Click1" 'popup-window-ops-menu
				      "W-Button1-Move" 'move-window-interactively
				      "Button1-Click1" 'raise-and-pass-through-click
				      "W-ISO_Left_Tab" 'tab-raise-left-window
				      "H-ISO_Left_Tab" 'tab-raise-right-window)
    "Keymap active when a client window is focused."
    :group bindings
    :type keymap
    :before-set (lambda () (ungrab-keymap window-keymap))
    :after-set (lambda () (grab-keymap window-keymap)))

  (defcustom root-window-keymap (bind-keys (make-keymap)
					   "Button2-Click1" 'popup-root-menu)
    "Keymap active when the pointer is in the root window
(or when no window is focused)."
    :group bindings
    :type keymap)

  (defcustom title-keymap (bind-keys (make-keymap)
				     "Button3-Off" 'raise-lower-window
				     "Button2-Move" 'resize-window-interactively
				     "Button1-Off2" 'toggle-window-shaded
				     "Button1-Move" 'move-window-interactively
				     "Button2-Off" 'tab-add-to-group)
    "Keymap of window title bar. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom tabbar-keymap (bind-keys (make-keymap)
				      "Button1-Off2" 'toggle-window-shaded
				      "Button1-Move" 'move-window-interactively
				      "Button2-Off" 'tab-add-to-group
				      "Button3-Click" 'tab-release-window
				      "Button3-Move" 'move-window-interactively)
    "Keymap of window tabbar. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom border-keymap (bind-keys (make-keymap)
				      "Button3-Off" 'raise-lower-window
				      "Button2-Move" 'move-window-interactively
				      "Button1-Move" 'resize-window-interactively)
    "Keymap of window border. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom close-button-keymap (bind-keys (make-keymap)
					    "Button3-Click1" 'popup-window-ops-menu
					    "S-Button1-Off" 'delete-group
					    "Button1-Off" 'delete-window)
    "Keymap of \"close\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom iconify-button-keymap (bind-keys (make-keymap)
					      "Button3-Click1" 'popup-window-ops-menu
					      "Button1-Off" 'iconify-window)
    "Keymap of \"iconify\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom maximize-button-keymap (bind-keys (make-keymap)
					       "Button3-Off" 'maximize-window-horizontally-toggle
					       "Button2-Off" 'maximize-window-vertically-toggle
					       "Button1-Off" 'maximize-window-toggle)
    "Keymap of \"maximize\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom menu-button-keymap (bind-keys (make-keymap)
					   "Button3-Off" 'delete-window
					   "Button1-Click1" 'popup-window-ops-menu)
    "Keymap of \"menu\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom shade-button-keymap (bind-keys (make-keymap)
					    "Button1-Off" 'toggle-window-shaded)
    "Keymap of \"shade\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom sticky-button-keymap (bind-keys (make-keymap)
					     "Button1-Off" 'toggle-window-sticky
					     "Button2-Off" 'toggle-window-sticky-viewport)
    "Keymap of \"sticky\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom lock-button-keymap (bind-keys (make-keymap)
					   "Button1-Off" 'toggle-fixed-postion)
    "Keymap of \"lock\" button. Mouse-bindings only."
    :group bindings
    :type keymap)


  (defcustom rename-button-keymap (bind-keys (make-keymap)
					     "Button1-Off" 'rename-window)
    "Keymap of \"rename\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom move-resize-button-keymap (bind-keys (make-keymap)
						  "Button1-Off" 'move-window-interactively
						  "Button2-Off" 'resize-window-interactively
						  "Button3-Off" 'move-window-center
						  "Button4-Off" 'double-window-size
						  "Button5-Off" 'halve-window-size)
    "Keymap of \"move/resize\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom raise-lower-button-keymap (bind-keys (make-keymap)
						  "Button1-Off" 'raise-window-depth
						  "Button2-Off" 'raise-window
						  "Button3-Off" 'lower-window-depth
						  "Button4-Off" 'raise-window
						  "Button5-Off" 'lower-window)
    "Keymap of \"raise/lower\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom next-workspace-button-keymap (bind-keys (make-keymap)
					    "Button3-Off" 'send-to-previous-workspace
					    "Button2-Click" 'popup-workspace-list
					    "Button1-Off" 'send-to-next-workspace)
    "Keymap of \"next-workspace\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defcustom previous-workspace-button-keymap (bind-keys (make-keymap)
					    "Button3-Off" 'send-to-next-workspace
					    "Button2-Click" 'popup-workspace-list
					    "Button1-Off" 'send-to-previous-workspace)
    "Keymap of \"previous-workspace\" button. Mouse-bindings only."
    :group bindings
    :type keymap)

  (defvar pointer-motion-threshold 2
    "Distance pointer must move before generating motion events, in pixels.")

  (defcustom wm-modifier-value (wm-modifier)
    "Modifier key(s) used for default shortcuts."
    :group bindings
    :type modifier-list
    :after-set (lambda ()
		 (ungrab-keymap global-keymap)
		 (ungrab-keymap window-keymap)
		 (set-wm-modifier wm-modifier-value)
		 (grab-keymap window-keymap)
		 (grab-keymap global-keymap)))

;;; Arrange for window-keymap to be set in each window

  (define (keymap-add-window w)
    (unless (window-get w 'keymap)
      (window-put w 'keymap window-keymap)))

  (add-hook 'add-window-hook keymap-add-window)

  ;; custom support for modifiers

  (define-custom-serializer 'modifier-list
    (lambda (value)
      (require 'sawfish.wm.util.decode-events)
      (decode-modifier value)))

  (define-custom-deserializer 'modifier-list
    (lambda (value)
      (require 'sawfish.wm.util.decode-events)
      (encode-modifier value))))

;; slide-window.jl -- simple code to move a window via the keyboard

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.slide-window

    (export slide-window
	    slide-window-left
	    slide-window-right
	    slide-window-up
	    slide-window-down
	    slide-group-left
	    slide-group-right
	    slide-group-up
	    slide-group-down)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.util.groups)

  (defvar slide-window-increment 16
    "Number of pixels to move window in `slide-' commands.")

  (defvar before-slide-hook '()
    "Window hook called before a window is moved with the keyboard.")

  (define (slide-window w right down)
    (call-window-hook 'before-slide-hook w)
    (unless (window-get w 'fixed-position)
      (let ((coords (window-position w)))
	(move-window-to w (+ (car coords) right) (+ (cdr coords) down)))
      (call-window-hook 'after-move-hook w
			`((,@(if (/= right 0) '(horizontal))
			   ,@(if (/= down 0) '(vertical)))))))

;;; window commands

  (define (slide-window-left w)
    "Move the window `slide-window-increment' pixels to the left."
    (slide-window w (- slide-window-increment) 0))

  (define (slide-window-right w)
    "Move the window `slide-window-increment' pixels to the right."
    (slide-window w slide-window-increment 0))

  (define (slide-window-up w)
    "Move the window `slide-window-increment' pixels upwards."
    (slide-window w 0 (- slide-window-increment)))

  (define (slide-window-down w)
    "Move the window `slide-window-increment' pixels downwards."
    (slide-window w 0 slide-window-increment))

  ;;###autoload
  (define-command 'slide-window-left slide-window-left #:spec "%W")
  (define-command 'slide-window-right slide-window-right #:spec "%W")
  (define-command 'slide-window-up slide-window-up #:spec "%W")
  (define-command 'slide-window-down slide-window-down #:spec "%W")

  ;; group commands

  (define (slide-group-left w)
    "Move the window group `slide-window-increment' pixels to the left."
    (map-window-group slide-window-left w))

  (define (slide-group-right w)
    "Move the window group `slide-window-increment' pixels to the right."
    (map-window-group slide-window-right w))

  (define (slide-group-up w)
    "Move the window group `slide-window-increment' pixels upwards."
    (map-window-group slide-window-up w))

  (define (slide-group-down w)
    "Move the window group `slide-window-increment' pixels downwards."
    (map-window-group slide-window-down w))

  ;;###autoload
  (define-command 'slide-group-left slide-group-left #:spec "%W")
  (define-command 'slide-group-right slide-group-right #:spec "%W")
  (define-command 'slide-group-up slide-group-up #:spec "%W")
  (define-command 'slide-group-down slide-group-down #:spec "%W"))

;; window-order.jl -- keep track of recently accessed windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.window-order

    (export window-order
	    window-order-push
	    window-order-pop
	    window-order-most-recent
	    window-order-focus-most-recent)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.session.init
	  sawfish.wm.workspace
	  sawfish.wm.viewport)

  (define-structure-alias window-order sawfish.wm.util.window-order)

  ;; window order high-water-mark
  (define window-order-highest 1)

  ;; return windows in MRU order
  (define (window-order #!optional workspace allow-iconified all-viewports)
    (let ((windows (managed-windows)))
      (setq windows (delete-if (lambda (w)
				 (or (not (window-mapped-p w))
				     (window-get w 'ignored)
				     (and (not allow-iconified)
					  (window-get w 'iconified))
				     (and workspace
					  (not (window-appears-in-workspace-p
						w workspace)))))
			       windows))
      (unless all-viewports
	(setq windows (delete-if window-outside-viewport-p windows)))
      (sort windows (lambda (x y)
		      (setq x (window-get x 'order))
		      (setq y (window-get y 'order))
		      (cond ((and x y)
			     (> x y))
			    (x t)
			    (t nil))))))

  ;; push window W onto the top of the cycle stack
  (define (window-order-push w)
    (window-put w 'order window-order-highest)
    (setq window-order-highest (1+ window-order-highest))
    (when (> window-order-highest 1000000)		;arbitrary big number
      (window-order-compress)))

  ;; remove window W from the order stack
  (define (window-order-pop w)
    (window-put w 'order nil))

  ;; compress the order stack
  (define (window-order-compress)
    (let ((order (nreverse (window-order nil t t)))	;all windows
	  (i 1))
      (map-windows (lambda (w)
		     (window-put w 'order nil)))
      (mapc (lambda (w)
	      (window-put w 'order i)
	      (setq i (1+ i))) order)
      (setq window-order-highest i)))

  (define (window-order-most-recent #!key (windows 0))
    "Return the most-recently focused window in the current workspace. If the
WINDOWS argument is given it should be a list of windows, in this case the
function will restrict its search to the elements of this list."
    (let loop ((rest (window-order current-workspace nil)))
      (cond ((null rest) nil)
	    ((or (window-get (car rest) 'never-focus)
		 (dock-window-p (car rest));; panel/pager workspace switcher
		 (and (listp windows) (not (memq (car rest) windows))))
	     (loop (cdr rest)))
	    (t (car rest)))))

  (define (window-order-focus-most-recent)
    (set-input-focus (window-order-most-recent)))
  
  ;; The problem is that any sticky windows that have been focused once
  ;; will _always_ rise to the top of the order when switching viewports
  ;; (since the topmost window is _always_ focused when entering a new
  ;; workspace). The hacky solution is to record the "input-focus" window
  ;; if leave a workspace and restore if reenter the workspace. 
  (define focus-most-recent-at-workspace nil)
  (define (record-focus-most-recent-at-workspace)
    (setq focus-most-recent-at-workspace 
          (remove (assoc (car (list current-workspace)) focus-most-recent-at-workspace) 
                  focus-most-recent-at-workspace))
    (setq focus-most-recent-at-workspace 
          (append focus-most-recent-at-workspace 
                  (cons (cons (car (list current-workspace)) (window-order-most-recent))))))
  (define (restore-focus-most-recent-at-workspace)
    (unless (eq focus-mode 'enter-exit)
      (set-input-focus (cdr (assoc (car (list current-workspace)) focus-most-recent-at-workspace)))))

  (sm-add-saved-properties 'order)
  (add-swapped-properties 'order)

  (add-hook 'sm-after-restore-hook window-order-compress)
  (add-hook 'iconify-window-hook window-order-pop)
  (add-hook 'leave-workspace-hook record-focus-most-recent-at-workspace)
  (add-hook 'enter-workspace-hook restore-focus-most-recent-at-workspace))

;; main.jl -- animation definition interface

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.animation.main

    (export make-outline-animator)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.animation.setup
	  sawfish.wm.custom
	  sawfish.wm.animation.modes
	  sawfish.wm.gaol
	  rep.io.timers)

  ;; For backward compatibility.
  (define-structure-alias anim-outline sawfish.wm.animation.main)

  (defcustom anim-outline-icon-coords (cons (screen-width) (screen-height))
    "Animation Outline Coordinates"
    :type (pair (number 1) (number 1))
    :group (appearance animation))

  (defcustom anim-outline-steps 16
    "Animation Steps"
    :type (range (1 . 1000))
    :group (appearance animation))

  (defcustom anim-outline-delay 20
    "Animation Delay"
    :type (range (1 . 1000))
    :group (appearance animation))

  (define (anim-outline-run w mode initial-coords initial-dims
			    final-coords final-dims)
    (let ((step 0)
	  (x-step (quotient (- (car final-coords) (car initial-coords))
			    anim-outline-steps))
	  (y-step (quotient (- (cdr final-coords) (cdr initial-coords))
			    anim-outline-steps))
	  (w-step (quotient (- (car final-dims) (car initial-dims))
			    anim-outline-steps))
	  (h-step (quotient (- (cdr final-dims) (cdr initial-dims))
			    anim-outline-steps))
	  (coords (cons (car initial-coords) (cdr initial-coords)))
	  (dims (cons (car initial-dims) (cdr initial-dims)))
	  timer)

      (define (stop)
	(delete-timer timer)
	(record-window-animator w nil)
	(ungrab-server))

      (define (protect fun)
	(call-with-exception-handler fun (lambda (ex)
					   (stop)
					   (raise-exception ex))))

      (define (clear)
	(unless (zerop step)
	  (protect (lambda ()
		     (erase-window-outline mode (car coords) (cdr coords)
					   (car dims) (cdr dims))))))

      (define (frame)
	(protect (lambda ()
		   (clear)
		   (if (>= step anim-outline-steps)
		       (stop)
		     (rplaca coords (+ (car coords) x-step))
		     (rplacd coords (+ (cdr coords) y-step))
		     (rplaca dims (+ (car dims) w-step))
		     (rplacd dims (+ (cdr dims) h-step))
		     (draw-window-outline mode (car coords) (cdr coords)
					  (car dims) (cdr dims))
		     (setq step (1+ step))
		     (set-timer timer)))))

      (define (animator win op)
	(declare (unused win))
	(when (eq op 'stop)
	  (clear)
	  (stop)))

      ;; kludged.. there may be Expose events waiting
      (accept-x-input)

      (grab-server)
      (record-window-animator w animator)
      (setq timer (make-timer frame nil anim-outline-delay))))

  (define (anim-outline-entry mode w op #!optional action)
    (when (eq op 'start)
      (case action
	((iconified)
	 (if (window-get w 'iconified)
	     (anim-outline-run w mode (window-position w)
			       (window-frame-dimensions w)
			       (or (window-get w 'icon-position)
				   anim-outline-icon-coords)
			       '(1 . 1)))))))

  (define (make-outline-animator mode)
    (lambda (w op #!optional action)
      (anim-outline-entry mode w op action)))

  (define wireframe-animator (make-outline-animator 'box))
  (define solid-animator (make-outline-animator 'solid))
  (define cross-animator (make-outline-animator 'cross))
  (define elliptical-animator (make-outline-animator 'elliptical))
  (define draft-animator (make-outline-animator 'draft))

  ;;###autoload
  (define-window-animator 'wireframe wireframe-animator)
  (define-window-animator 'solid solid-animator)
  (define-window-animator 'cross cross-animator)
  (define-window-animator 'elliptical elliptical-animator)
  (define-window-animator 'draft draft-animator))

;; cabinet.jl

;; Copyright (C) 2011, 2012 hqwrong <hq.wrong@gmail.com>

;; This file is part of sawfish.

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.

;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see `http://www.gnu.org/licenses/'.


;; XXX Without this, this key-commands not run in cabinet, but i have no idea why.
;; XXX
;; XXX maximize-window-toggle maximize-window-fullscreen-toggle
;; XXX maximize-window-horizontally-toggle maximize-window-vertically-toggle
;; XXX maximize-window-fullxinerama-toggle maximize-fill-window
;; XXX maximize-fill-window-horizontally maximize-fill-window-vertically
;; XXX tab-release-window tab-move-to-end tab-move-to-beginning
;; XXX tab-move-to-right tab-move-to-left
;; XXX window-history-save-position window-history-save-dimensions
;; XXX window-history-save-attributes window-history-forget
(require 'sawfish.wm.heads)
(require 'sawfish.wm.state.maximize)
(require 'sawfish.wm.tabs.tabgroup)
(require 'sawfish.wm.ext.window-history)

(define-structure sawfish.wm.ext.cabinet
  
    (export cabinet-switch
            ;; 
            cabinet-keymap-complete
            cabinet-item-text
            ;; you'll need following procedures only when
            ;; you want to extend cabinet-keymap
            with-update-on-workspace
            with-selected
            with-marked-wl
            with-exit-and-clear-mark
            with-update-on-input
            with-new-wlist
            with-draw)
    
    (open rep
          rep.data
          rep.system
          rep.regexp
          rep.lang.math
          rep.io.timers
          sawfish.wm.util.events
          sawfish.wm.prg.compton
          sawfish.wm.tabs.tabgroup
          sawfish.wm.state.shading
          sawfish.wm.state.iconify
          sawfish.wm.stacking
          sawfish.wm.util.workarea
          sawfish.wm.viewport
          sawfish.wm.state.maximize
          sawfish.wm.util.display-window
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.colors
          sawfish.wm.events
          sawfish.wm.fonts
          sawfish.wm.images
          sawfish.wm.misc
          sawfish.wm.util.x
          sawfish.wm.windows
          sawfish.wm.workspace)


  (defgroup cabinet "Cabinet"
    :group focus
    :require sawfish.wm.ext.cabinet)

  (defgroup filter "Filter"
    :group (focus cabinet))
  
  (defgroup bindings "Keybindings"
    :group (focus cabinet))

  (defcustom cabinet:margin (cons 10 10)
    "Margin to the border of cabinet."
    :group (focus cabinet)
    :type (pair (number 1 50 10 1) (number 1 50 10 1)))
  
  (defcustom cabinet:item-margin 6
    "Margin between items."
    :group (focus cabinet)
    :range (1 . 50)
    :type number)
  
  (defcustom cabinet:input-line-margin 25
    "Margin between input line and the first item."
    :group (focus cabinet)
    :range (1 . 100)
    :type number)
  
  (defcustom cabinet:icon-size 24
    "Icon size."
    :group (focus cabinet)
    :range (8 . 128)
    :type number)
  
  (defcustom cabinet:workspace-mode-on-initial nil
    "Display only windows from current workspace."
    :group (focus cabinet)
    :type boolean)
  
  (defcustom cabinet:display-cabinet-on-active nil
    "Display cabinet on active monitor."
    :group (focus cabinet)
    :type boolean)

  (defcustom cabinet:cycle-as-start nil
    "Cycle overhead when start cabinet-switch, like x-cycle."
    :group (focus cabinet)
    :type boolean)
  
  (defcustom cabinet:manipulation-on-selected 'Raise 
    "Action if browse across cabinet."
    :group (focus cabinet)
    :type (choice Raise Focus None))
  
  (defcustom cabinet:raise-window-timeout 200
    "Delay in milliseconds until a window gets raised if browse across cabinet. \\bottom"
    :group (focus cabinet)
    :type (range (1 . 1000)))

  (defcustom cabinet:command-repeat-timeout 100
    "Delay in milliseconds until a window keybinding gets repeats. \\bottom"
    :group (focus cabinet)
    :type (range (100 . 1000)))

  (defcustom cabinet:default-item-forground (get-color "#FFFFFF")
    "Font color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:background (get-color "#000000")
    "Background color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:forground-input (get-color "#FFFF00")
    "Input text color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:split-line-forground (get-color "#B22222")
    "Split line color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:maximized-item-forground (get-color "#FFA500")
    "Maximized windows color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:iconified-item-forground (get-color "#6D6D6D")
    "Iconified windows color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:shaded-item-forground (get-color "#0000FF")
    "Shaded windows color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:filter-out-for-manipulation (list "^Conky$" "^Gkrellm$")
    nil
    :group (focus cabinet filter)
    :widget-flags (expand-horizontally expand-vertically)
    :type* `(list string ,(_ "Windows displayed below the split line.")))
  
  (defcustom cabinet:filter-out-from-display (list "^Gdesklets-daemon$" "^Xfce4-panel$" "^Mate-panel$"
                                                   "^Xfdesktop$" "^x-caja-desktop$" "^plasma-desktop$"
						   "^Pancake$" "^lxpanel" "Sawfishpager" "^conky$"
						   "Lumina Desktop Environment")
    nil
    :group (focus cabinet filter)
    :widget-flags (expand-horizontally expand-vertically)
    :type* `(list string ,(_ "Windows removed from cabinet.")))
  
  (defcustom cabinet:cycle "Super-TAB"
    "Cycle through windows."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:reversely-cycle "C-TAB"
    "Reversely cycle through windows."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:restore-order "ESC"
    "Exit with restore stack order."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:toggle-workspace-mode "Super-a"
    "Toggle windows from current or all workspaces."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:exchange-manipulation "Super-q"
    "Toggle windows for display and for manipulation."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:cycle-workspaces "Super-x"
    "Cycle through workspaces."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:cycle-reversely-workspaces "Super-y"
    "Reversely cycle through workspaces."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:advance-user-keybindings nil
    "Advance user keymap."
    :group (focus cabinet bindings)
    :after-set (lambda () (search-bad-key))
    :type boolean)

  (defcustom cabinet:mark-selected "Super-SPC"
    "Marked window as selected."
    :type event
    :after-set (lambda () (search-bad-key))
    :depends cabinet:advance-user-keybindings
    :group (focus cabinet bindings))

  (defcustom cabinet:advance-keybindings '(("Super-d" delete-window t none)
                                           ("Super-i" toggle-window-iconified t none)
                                           ("Super-m" maximize-window-toggle t none)
                                           ("Super-s" toggle-window-shaded t none)
                                           ("Super-f" maximize-window-fullscreen-toggle t none)
                                           ("Super-t" tab-add-maked-windows t none)
                                           ("C-d" delete-window t close)
                                           ("C-i" toggle-window-iconified t close)
                                           ("C-m" maximize-window-toggle t close)
                                           ("C-s" toggle-window-shaded t close)
                                           ("C-f" maximize-window-fullscreen-toggle t close)
                                           ("C-t" tab-add-maked-windows t close)
                                           ("M-d" delete-window t go-to-next)
                                           ("M-i" toggle-window-iconified t go-to-next)
                                           ("M-m" maximize-window-toggle t go-to-next)
                                           ("M-s" toggle-window-shaded t go-to-next)
                                           ("M-f" maximize-window-fullscreen-toggle t go-to-next)
                                           ("M-t" tab-add-maked-windows t go-to-next))
    nil
    :type* `(alist (event ,(_ "Key:"))
                   ((h-and (symbol 
                            delete-window maximize-window-toggle toggle-window-iconified toggle-window-shaded toggle-window-sticky
                            maximize-window-fullscreen-toggle maximize-window-horizontally-toggle maximize-window-vertically-toggle maximize-window-fullxinerama-toggle
                            tab-add-maked-windows tab-release-window tab-move-to-end tab-move-to-beginning tab-move-to-right tab-move-to-left
                            move-window-to-center move-window-to-top-left move-window-to-next-workspace move-window-to-previous-workspace
                            toggle-window-fixed-position toggle-window-fixed-size  toggle-window-never-focus toggle-window-ignored toggle-task-list-skip toggle-window-cycle-skip
                            toggle-window-list-skip toggle-desktop send-window-to-next-head send-window-to-previous-head
                            raise-window lower-window raise-window-depth lower-window-depth raise-lower-window
                            raise-window-and-transients raise-lower-window-and-transients delete-window-safely destroy-window
                            window-history-save-position window-history-save-dimensions window-history-save-attributes window-history-forget  
                            iconify-window uniconify-window shade-window unshade-window make-window-sticky make-window-unsticky
                            make-window-ignored make-window-not-ignored               
                            maximize-fill-window maximize-fill-window-horizontally maximize-fill-window-vertically 
                            ;; tab/titelbar-toggle tab/titelbar-to-top tab/titelbar-to-bottom tab/titelbar-to-right tab/titelbar-to-left 
                            ;; move-window-center move-window-up move-window-down 
                            ;; move-window-right move-window-left move-window-next move-window-previous 
                            ;; shrink-window-up shrink-window-down shrink-window-left shrink-window-right 
                            ;; yank-window-up yank-window-down yank-window-left yank-window-right
                            ;; size-window-add-column size-window-subtract-column size-window-add-row size-window-subtract-row 
                            ;; grow-window-up grow-window-down grow-window-left grow-window-right
                            ;; pack-window-up pack-window-down pack-window-right pack-window-left 
                            ;; double-window-size halve-window-size
                            ;; send-to-next-workspace send-to-previous-workspace send-to-workspace-left
                            ;; send-to-workspace-right send-to-workspace-up send-to-workspace-down
                            ;; maximize-window-fullscreen maximize-window-fullxinerama  
                            )
                           (label "After executed cabinet:")
                           (choice none close go-to-next)) ,(_ "Event")))
    :widget-flags (expand-vertically)
    :after-set (lambda () (search-bad-key))
    :depends cabinet:advance-user-keybindings
    :group (focus cabinet bindings))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; end defcustom

  (define (do-when-tabbed w do)
    "Action when W is tabbed."
    (when (window-tabbed-p w)
      (tab-refresh-group w do)
      (window-opacity w)))

  (define (window-tabbed-foreground-p w)
    "Returns t if W is a foreground tab"
    (if (window-tabbed-p w)
        (eq w (nth 0 (tab-group-windows-stacking-order w)))))

  (define (tabbgroup-is-shaded-p w)
    "Returns t if tabbgroup from W is shaded"
    (let ((shaded 't))
      (when (window-tabbed-p w)
        (mapcar (lambda (w)
                  (if (not (window-get w 'shaded)) (setq shaded nil))) (tab-group-windows w))
        shaded)))

  (define (cabinet-item-text w)
    "The text part shown on cabinet item"
    ;; if we remove a window we temporary need this if
    (if (not (numberp (window-id w)))
        "Window is gone"
      (concat (when (window-get w 'marked)
                " »»")
              (when (window-tabbed-p w)
                (if (window-tabbed-foreground-p w)
                    (if (eq cabinet:manipulation-on-selected 'None)
                        (format nil " [%s%s]" (tab-window-group-index w) '★)
                      (format nil " [%s]" (tab-window-group-index w)))
                  (format nil " [%s]" (tab-window-group-index w))))
              "  "
              (window-name w)
              "  ["
              (window-class-name w 1)
              "] "
              (when (or (> (car (window-viewport w)) 0)
                        (> (cdr (window-viewport w)) 0))
                (format nil " %s" (window-viewport w)))
              (when (window-get w 'workspaces)
                (format nil " %s" (window-get w 'workspaces)))
              ;;(when (window-sticky-p w)
              ;;  (format nil " ∘"))
              (if (and (window-maximized-vertically-p w)
                       (not (window-maximized-horizontally-p w)))
                  (format nil " ↕"))
              (if (and (window-maximized-horizontally-p w)
                       (not (window-maximized-vertically-p w)))
                  (format nil " ↔"))
              (when (window-maximized-p w)
                (if (or (tabbgroup-is-shaded-p w)
                        (and (not (window-tabbed-p w))
                             (window-shaded-p w)))
                    (format nil " ▾")))
              (when (window-get w 'marked)
                " ««"))))

  (define input-line-height (font-height default-font))
  (define cabinet-font-height input-line-height)
  (define wlist-for-manipulation nil)
  (define wlist-for-display nil)
  (define wlist-for-cabinet nil)
  (define cabinet-window nil)
  (define cabinet-orin-wlist)
  (define cabinet-orin-focus)
  (define cabinet-input "")
  (define cabinet-orin-workspace)
  (define workspace-mode)
  (define cabinet-filter-for-display-func)
  (define cabinet-filter-for-manipulation-func)
  (define cabinet-raise-timer nil)
  (define command-timer nil)
  (define bad-key nil)
  (define focus-by-tab nil)
  (define split-line-length nil)

  ;; item-format package
  (define (cabinet-item-text-format w)
    (let ((split-length (quotient (length (cabinet-item-text w)) 2)))
      (if (> split-length split-line-length)
          (if (> split-length 40)
              (setq split-line-length (- split-length 5))
            (setq split-line-length split-length))))
    (cons (cabinet-item-text w)
          (cond
           ((window-iconified-p w) cabinet:iconified-item-forground)
           ((window-maximized-p w) cabinet:maximized-item-forground)
           ((if (or (tabbgroup-is-shaded-p w)
                    (and (not (window-tabbed-p w))
                         (window-shaded-p w)))
                cabinet:shaded-item-forground))
           (t cabinet:default-item-forground))))

  (define (cabinet-item-format w)
    (let ((item (cons (if (window-icon-image w 32)
                          (window-icon-image w 32)
                        (require 'rep.io.files)
                        (if (file-exists-p (concat (car (cdr image-load-path)) "/" "cabinet-missing.png"))
                            (make-image (concat (cdr image-load-path) "cabinet-missing.png"))))
                      (cabinet-item-text-format w))))
      (lambda (tag)
        (cond
         ((eq tag 'icon) (car item))
         ((eq tag 'text) (cadr item))
         ((eq tag 'forground) (cdr (cdr item)))))))

  (define (make-item icon text forground)
    (lambda (tag)
      (cond
       ((eq tag 'icon) icon)
       ((eq tag 'text) text)
       ((eq tag 'forground) forground))))
  (define (get-item-icon item) (item 'icon))
  (define (get-item-text item) (item 'text))
  (define (get-item-forground item) (item 'forground))
  ;; end @ item format package 

  (define (cabinet-filter filter-list)
    (lambda (window)
      (let loop ((fow-nrl filter-list))
        (cond
         ((null fow-nrl) t)
         ((or (string-match (car fow-nrl) 
                            (window-name window)
                            0 nil)
              (string-match (car fow-nrl) 
                            (window-class-name window 1)
                            0 nil))
          nil)
         (t (loop (cdr fow-nrl)))))))

  (define (cabinet-split-line)
    (let ((lenght '0)
          line enil mode)
      (while (< lenght split-line-length) 
        (setq line (concat line "»")) 
        (setq enil (concat enil "«")) 
        (setq lenght (1+ lenght)))
      (setq mode (if workspace-mode
                     (format nil "%s/%s"
                             current-workspace
                             (cdr (workspace-limits)))
                   "ALL"))
      (make-item nil (format nil (concat line mode enil))
                 cabinet:split-line-forground)))

  (define (draw-items wl input-line)
    (when (x-window-p cabinet-window)
      (x-destroy-window cabinet-window)
      (setq cabinet-window nil))
    (let* ((wl-size (length wl))
           (cabinet-items wl)
           (item-height (max cabinet:icon-size
                             cabinet-font-height))
           (wx (+ (* 2 (car cabinet:margin))
                  cabinet:icon-size
                  (apply max
                         (mapcar text-width
                                 (cons input-line
                                       (mapcar get-item-text
                                               cabinet-items))))))
           (wy (+ (* 2 (cdr cabinet:margin))
                  (* wl-size item-height)
                  (* (- wl-size 1) cabinet:item-margin)
                  cabinet:input-line-margin
                  input-line-height))
           (win-size (cons wx wy)))
      (define (event-handler type xw)
        (define (cabinet-draw-text str pos foreground)
          (let ((gc (x-create-gc xw
                                 `((foreground . ,foreground)))))
            (x-draw-string xw gc pos str)
            ;; (x-destroy-gc gc)
            ))
        (x-clear-window wx type)
        ;; draw input line
        (cabinet-draw-text input-line
                           (cons (car cabinet:margin) (+ (cdr cabinet:margin)
                                                         cabinet-font-height))
                           cabinet:forground-input)
        ;; draw item text
        (let ((item-count 0)
              (item-height-with-margin (+ item-height
                                          cabinet:item-margin))
              (input-height-with-margin (+ input-line-height
                                           cabinet:input-line-margin)))
          (mapc (lambda (item)
                  (let* ((icon (get-item-icon item))
                         (text (get-item-text item))
                         (item-forground (get-item-forground item))
                         (icon-x (+ (car cabinet:margin)))
                         (icon-y (+ (cdr cabinet:margin)
                                    input-height-with-margin
                                    (* item-count
                                       item-height-with-margin)))
                         (text-x (+ icon-x
                                    cabinet:icon-size))
                         (text-y (+ icon-y
                                    (quotient cabinet-font-height 2)
                                    (quotient cabinet:icon-size
                                              3))))
                    (when icon
                      (x-draw-image icon xw
                                    (cons icon-x icon-y)
                                    (cons cabinet:icon-size cabinet:icon-size)))
                    (cabinet-draw-text text
                                       (cons text-x text-y)
                                       item-forground))
                  (setq item-count (+ 1 item-count)))
                cabinet-items))) ;; end of event-handler
      (setq cabinet-window
            (let ((head (if cabinet:display-cabinet-on-active (current-head) '0)))
              (x-create-window `(,(+ (car (head-offset head))
                                     (- (quotient (car (head-dimensions head)) 2)
                                        (quotient wx 2)))
                                 .
                                 ,(if (> (cdr win-size) (cdr (head-dimensions head)))
                                      '0
                                    (+ (cdr (head-offset head))
                                       (- (quotient (cdr (head-dimensions head)) 2)
                                          (quotient wy 2)))))
                               win-size
                               1
                               `((background . ,cabinet:background))
                               event-handler)))
      (x-map-window cabinet-window)
      cabinet-window))

  (define (display-bad-key)
    (display-message (concat "Cabinet:" "\n" "\n" bad-key "\n" "\nIs duplicate." "\nDisable cabinet.")
                     `((background . ,(get-color "Red")))))

  (define (search-bad-key)
    (setq bad-key nil)
    (let ((key-list (list cabinet:cycle cabinet:reversely-cycle cabinet:restore-order cabinet:toggle-workspace-mode
                          cabinet:exchange-manipulation cabinet:cycle-workspaces cabinet:cycle-reversely-workspaces)) key rest-list)
      (when cabinet:advance-user-keybindings
        (setq key-list (append key-list (list cabinet:mark-selected)))
        (setq key-list (append key-list 
                               (mapcar (lambda (w)
                                         (car w))
                                       cabinet:advance-keybindings))))
      (mapcar (lambda ()
                (setq rest-list (cdr key-list))
                (setq key (car key-list))
                (when (not (x-keysym-name (car (lookup-event key))))
                  (setq bad-key key)
                  (display-message (concat "Cabinet:" "\n" "\n" bad-key "\n" "\nIs not a valid x-keysym-name." "\nDisable cabinets.")
                                   `((background . ,(get-color "Red")))))
                (when (member key rest-list)
                  (setq bad-key key)
                  (display-bad-key))
                (setq key-list (cdr key-list)))
              key-list)))
  
  ;; keymap package
  (define (command-delay-timer)
    (setq command-timer
          (make-timer (lambda ()
                        (setq command-timer nil))
                      (quotient cabinet:command-repeat-timeout 1000) (mod cabinet:command-repeat-timeout 1000))))

  (define (update-cabinet-interface-add)
    (when (x-window-p cabinet-window)
      (setq wlist-for-manipulation
            (filter cabinet-filter-for-manipulation-func
                    (filter cabinet-filter-for-display-func
                            (stacking-order))))
      (setq wlist-for-display (filter (lambda (win)
                                        (not (cabinet-filter-for-manipulation-func win)))
                                      (stacking-order)))
      (if workspace-mode
          (update-on-workspace))
      (draw-cabinet)))

  (define (update-cabinet-interface-remove)
    (when (x-window-p cabinet-window)
      (let ((old-manipulation wlist-for-manipulation)
            (old-display wlist-for-display)
            new-manipulation new-display)
        (setq new-manipulation
              (filter cabinet-filter-for-manipulation-func
                      (filter cabinet-filter-for-display-func
                              (stacking-order))))
        (setq new-display (filter (lambda (win)
                                    (not (cabinet-filter-for-manipulation-func win)))
                                  (stacking-order)))
        (mapcar (lambda (w)
                  (if (not (member w new-manipulation))
                      (setq wlist-for-manipulation (remove w old-manipulation))))
                old-manipulation)
        (mapcar (lambda (w)
                  (if (not (member w new-display))
                      (setq wlist-for-manipulation (remove w old-display))))
                old-display)
        (if workspace-mode
            (update-on-workspace))
        (draw-cabinet))))

  (define (update-cabinet-interface #!optional next)
    (when (x-window-p cabinet-window)
      (when (not (null wlist-for-manipulation))
        (if (member next wlist-for-manipulation)
            (cabinet-switch-to-next)))
      (if workspace-mode
          (update-on-workspace))
      (draw-cabinet)))

  (define (cabinet-switch-to-next)
    (when cabinet-raise-timer
      (delete-timer cabinet-raise-timer)
      (setq cabinet-raise-timer nil))
    (when (not (null wlist-for-manipulation))
      (setq wlist-for-manipulation
            (append (cdr wlist-for-manipulation)
                    (list (car wlist-for-manipulation))))))
  
  (define (cabinet-switch-to-previous)
    (when cabinet-raise-timer
      (delete-timer cabinet-raise-timer)
      (setq cabinet-raise-timer nil))
    (when (not (null wlist-for-manipulation))
      (setq wlist-for-manipulation
            (let ((rl (reverse wlist-for-manipulation)))
              (list* (car rl) (reverse (cdr rl)))))))
  
  (define (erase-input)
    (setq cabinet-input ""))
  
  (define (with-draw cmd)  
    "If your cmd will change Cabinet's
apperances,then add it."
    (lambda ()
      (cmd)
      (draw-cabinet)))
  
  (define (with-new-wlist cmd)
    "If your cmd the number of items 
grow, then add it"
    (lambda ()
      (cmd)
      (setq wlist-for-manipulation
            (filter cabinet-filter-for-manipulation-func
                    (filter cabinet-filter-for-display-func
                            (stacking-order))))
      (setq wlist-for-display (filter (lambda (win)
                                  (not (cabinet-filter-for-manipulation-func win)))
                                (stacking-order)))))
  
  (define (with-update-on-input cmd)
    " It will filter items on input after
execution of cmd, add it when you feel proper."
    (lambda ()  
      (cmd)
      (cabinet-update-on-input)))
  
  (define (cabinet-update-on-input)
    "Same with `with-update-on-input',except that it's
a procedure with no argument."
    (setq wlist-for-manipulation
          (if (not (null wlist-for-manipulation))
              (filter (lambda (w)
                        (string-match cabinet-input
                                      (concat
                                       (window-name w)
                                       (window-class-name w))
                                      0 t))
                      wlist-for-manipulation))))
  
  (define (with-exit-and-clear-mark cmd)
    " Use it, when you decide to quit Cabinet after
your cmd's execution."
    (lambda ()
      (cmd)
      (mapc (lambda (w)
              (when (window-get w 'marked)
                (window-remprop w 'marked)
                (call-marked w)))
            cabinet-orin-wlist)
      (event-exit-wait)))

  (define (with-marked-wl cmd)
    "The marked windows will be passed to cmd as a list."
    (lambda ()
      (cmd (filter-windows (lambda (w)
                             (window-get w
                                         'marked))))))
  
  (define (with-selected cmd)
    "The selected window will be passed to cmd as an argument."
    (lambda ()
      (cmd (car wlist-for-manipulation))))
  
  (define (workspace-prev)
    (cycle-workspace -1))
  
  (define (workspace-next)
    (cycle-workspace 1))
  
  (define (cycle-workspace count)
    (with-draw
     (lambda ()
       ((with-update-on-input (with-new-wlist (lambda () t))))
       (if workspace-mode
           (next-workspace count)
         (setq workspace-mode t)
         (next-workspace count))
       (update-on-workspace))))
  
  (define (toggle-workspace-mode)
    (with-draw
     (lambda ()
       ((with-update-on-input (with-new-wlist (lambda () t))))
       (if workspace-mode
           (setq workspace-mode (not workspace-mode))
         (setq workspace-mode t)
         (update-on-workspace)))))

  (define (with-update-on-workspace cmd)
    "It filters items for current workspace windows.
add it, when your command changed workspace"
    (lambda ()
      (cmd)
      (update-on-workspace)))
  
  (define (update-on-workspace)
    " Same with `with-update-on-workspace',except that
this is a procedure with no argument."
    (setq wlist-for-manipulation
          (filter (lambda (w)
                    (let ((ww (window-get w 'workspaces)))
                      (or (memq current-workspace ww)
                          (eq ww nil)))) 
                  wlist-for-manipulation)))

  (define (update-on-bs cmd)
    "Update cabinets interface after backspce"
    (lambda ()
      (cmd)
      (if workspace-mode
          (update-on-workspace)
        (setq wlist-for-manipulation
              (filter cabinet-filter-for-manipulation-func
                      (filter cabinet-filter-for-display-func
                              (stacking-order)))))))

  (define (call-marked cmd)
    "Call marked hook if window marked"
    (call-window-hook 'window-state-change-hook cmd (list '(marked))))

  (define (get-last-workspace)
    (aref (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS)) 0))
  
  (defvar move-window-to-next-workspace
    (lambda (w)
      (unless (window-sticky-p w)
        (let ((nw (+ (car (window-get w 'workspaces)) 1)))
          (if (< nw (get-last-workspace))
              (send-window-to-workspace-from-first w nw))))))
  
  (defvar move-window-to-previous-workspace
    (lambda (w)
      (unless (window-sticky-p w)
        (let ((nw (- (car (window-get w 'workspaces)) 1)))
          (if (> nw '-1)
              (send-window-to-workspace-from-first w nw))))))


  (defvar move-window-to-top-left
    (lambda (w)
    (let ((dims (window-frame-dimensions w))
          (h-off (cons 0 0))
          (screen (calculate-workarea #:window w #:head '0)))
      (move-window-to w
                      (clamp* (car h-off)
                              (car dims) (nth 0 screen) (nth 2 screen))
                      (clamp* (cdr h-off)
                              (cdr dims) (nth 1 screen) (nth 3 screen)))
      (call-window-hook 'after-move-hook w))))

  (defvar move-window-to-center
    (lambda (w)
    (let ((dims (window-frame-dimensions w))
          (h-dims (current-head-dimensions w))
          (h-off (current-head-offset w))
          (screen (calculate-workarea #:window w #:head (current-head w))))
      (move-window-to w
                      (clamp* (+ (car h-off)
                                 (quotient (- (car h-dims) (car dims)) 2))
                              (car dims) (nth 0 screen) (nth 2 screen))
                      (clamp* (+ (cdr h-off)
                                 (quotient (- (cdr h-dims) (cdr dims)) 2))
                              (cdr dims) (nth 1 screen) (nth 3 screen)))
      (call-window-hook 'after-move-hook w))))
  
  (defvar tab-add-maked-windows
    (lambda ()
      (let* ((win (car wlist-for-manipulation))
             (tabs (remove win (filter-windows (lambda (w) (window-get w 'marked))))))
        (when (car tabs)
          (require 'sawfish.wm.tabs.tab)
          (window-remprop win 'marked)
          (mapcar (lambda (w)
                    (window-remprop w 'marked)
                    (tab-window-add-to-tabgroup w)
                    (tab-window-add-to-tabgroup win))
                  tabs)
            (set-input-focus nil)))))

  (define (run-cmd-and-do cmd do)
    (when (not command-timer)
      (command-delay-timer)
      (let ((win (car wlist-for-manipulation))
            (next (car (cdr wlist-for-manipulation))))
        (if (eq cmd 'tab-add-maked-windows)
            (tab-add-maked-windows)
          (if (and (filter-windows (lambda (w) (window-get w 'marked)))
                   cabinet:advance-user-keybindings)
              (mapcar (lambda (x)
                        (cmd x))
                      (filter-windows (lambda (w) (window-get w 'marked))))
            (cmd win)))
        (when (string= do "close")
          (mapc (lambda (w)
                  (when (window-get w 'marked)
                    (window-remprop w 'marked)
                    (call-marked w)))
                cabinet-orin-wlist)
          (event-exit-wait)
          (x-destroy-window cabinet-window)
          (display-window win))
        
        (when (string= do "none")
          (mapc (lambda (w)
                  (when (window-get w 'marked)
                    (window-remprop w 'marked)
                    (call-marked w)))
                cabinet-orin-wlist)
          (update-cabinet-interface))
        
        (when (string= do "go-to-next")
          (mapc (lambda (w)
                  (when (window-get w 'marked)
                    (window-remprop w 'marked)
                    (call-marked w)))
                cabinet-orin-wlist)
          (update-cabinet-interface next)))))

  (define (cabinet-keymap-complete)
    (let ((keymap-complete))
      (if bad-key
          (bind-keys (make-keymap) nil)
        (if (and cabinet:advance-user-keybindings
                 (car cabinet:advance-keybindings))
            (setq keymap-complete (append (cabinet-keymap-base) (cabinet-keymap-advance)))
          (setq keymap-complete (cabinet-keymap-base)))
        keymap-complete)))

  (define (cabinet-keymap-advance)
    (let ((keybind-list cabinet:advance-keybindings)
          keymap-list tmp)
      (mapcar (lambda (w)
                (setq tmp (list (car w) (list run-cmd-and-do (nth 1 w) (prin1-to-string (nth 3 w)))))
                (setq keymap-list (append keymap-list (cdr (bind-keys (make-keymap) (nth 0 tmp) (nth 1 tmp))))))
              keybind-list)
      keymap-list))

  (define (cabinet-keymap-base)
    (bind-keys (make-keymap)
               "RET" (with-exit-and-clear-mark
                      (with-selected
                       (lambda (w)
                         (display-window w))))
               "KP_Enter" (with-exit-and-clear-mark
                           (with-selected
                            (lambda (w)
                              (display-window w))))
               "SPC" (with-draw
                      (with-update-on-input
                       (lambda ()
                         (setq cabinet-input
                               (concat cabinet-input " ")))))
               "BS" (with-draw
                     (with-update-on-input
                      (update-on-bs
                       (with-new-wlist
                        (lambda ()
                          (when (> (length cabinet-input) 0)
                            (setq cabinet-input
                                  (substring cabinet-input
                                             0
                                             (1- (length cabinet-input))))))))))
               cabinet:cycle (with-draw cabinet-switch-to-next)
               cabinet:reversely-cycle (with-draw cabinet-switch-to-previous)
               cabinet:restore-order (with-exit-and-clear-mark 
                                      (lambda ()
                                        (select-workspace cabinet-orin-workspace)
                                        (restack-windows cabinet-orin-wlist)
                                        (set-input-focus cabinet-orin-focus)
                                        (when (and focus-by-tab 
                                                   (numberp (window-id focus-by-tab)))
                                          (do-when-tabbed focus-by-tab 'focus)
                                          (setq focus-by-tab nil))))
               cabinet:exchange-manipulation (with-draw
                                              (with-update-on-input
                                               (lambda ()
                                                 (let ((tmp wlist-for-manipulation))
                                                   (setq wlist-for-manipulation wlist-for-display
                                                         wlist-for-display tmp)))))
               cabinet:toggle-workspace-mode (toggle-workspace-mode)
               cabinet:cycle-workspaces (workspace-next)
               cabinet:cycle-reversely-workspaces (workspace-prev)
               cabinet:mark-selected (when cabinet:advance-user-keybindings
                                       (with-draw
                                        (with-selected
                                         (lambda (w)
                                           (window-put w 'marked
                                                       (not (window-get w 'marked)))
                                           (call-marked w)))))))
  ;; end @ keymap package
  (define (draw-cabinet)
    (let ((w (car wlist-for-manipulation)))
      (when (not (null wlist-for-manipulation))
        (when (eq cabinet:manipulation-on-selected 'Raise)
          (setq cabinet-raise-timer
                (make-timer (lambda ()
                              (raise-window w)
                              (do-when-tabbed w 'raise))
                            (quotient cabinet:raise-window-timeout 1000) (mod cabinet:raise-window-timeout 1000))))
        (when (eq cabinet:manipulation-on-selected 'Focus)
          (setq cabinet-raise-timer
                (make-timer (lambda ()
                              (raise-window w)
                              (set-input-focus w))
                            (quotient cabinet:raise-window-timeout 1000) (mod cabinet:raise-window-timeout 1000))))
        (when (eq cabinet:manipulation-on-selected 'None) 
          (set-input-focus nil)))
      (setq split-line-length nil)
      (draw-items (append (mapcar cabinet-item-format wlist-for-manipulation)
                          (list (cabinet-split-line))
                          (mapcar cabinet-item-format wlist-for-display))
                  (concat cabinet-input "_"))))
  
  (defvar cabinet-handler
    `((,(lambda (key) (= 1 (length key)))
       .
       ,(lambda (key)
          (setq cabinet-input (concat cabinet-input key))
          (cabinet-update-on-input)
          (draw-cabinet)))))

  (define (unbound-check)
    (if bad-key
        (progn (display-bad-key)
               nil)
      (display-message nil)
      't))

  (define (cabinet-switch)
    "Start cabinet switch."
    (if bad-key
        (display-bad-key)
      (when (and (input-focus) 
                 (window-tabbed-p (input-focus))
                 (eq cabinet:manipulation-on-selected 'Raise))
          (set-input-focus nil)
          (setq focus-by-tab (input-focus)))
      (setq cabinet-orin-wlist (stacking-order)
            cabinet-orin-focus (input-focus)
            cabinet-input ""
            cabinet-orin-workspace current-workspace
            workspace-mode cabinet:workspace-mode-on-initial
            cabinet-filter-for-display-func
            (cabinet-filter cabinet:filter-out-from-display)
            cabinet-filter-for-manipulation-func
            (cabinet-filter cabinet:filter-out-for-manipulation)
            wlist-for-cabinet (filter cabinet-filter-for-display-func
                                      (stacking-order))
            wlist-for-manipulation (filter cabinet-filter-for-manipulation-func
                                           wlist-for-cabinet)
            wlist-for-display (filter (lambda (win)
                                        (not (cabinet-filter-for-manipulation-func win)))
                                      wlist-for-cabinet))
      (when workspace-mode
        (update-on-workspace))
      (when cabinet:cycle-as-start
        (cabinet-switch-to-next))
      (draw-cabinet)
      (event-wait-for #:keymap (cabinet-keymap-complete)
                      #:handler cabinet-handler
                      #:loop-on-unbound (unbound-check))
      (x-destroy-window cabinet-window)))

  (search-bad-key)

  (unless batch-mode
    (add-hook 'tab-group-windows-hook update-cabinet-interface)
    (add-hook 'before-add-window-hook update-cabinet-interface-add)
    (add-hook 'destroy-notify-hook update-cabinet-interface-remove))

  (define-command 'cabinet-switch cabinet-switch))

;; run-application.jl -- prompt for an application and run it

;; Copyright (C) 2008 Sergey I. Sharybin <sharybin@nm.ru>
;; Copyright (C) 2007 Sven Schoenung <sven.schoenung@gmail.com>
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; run-application is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 2, or
;; (at your option) any later version.

;; run-application is distributed in the hope that it will be useful, 
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with Sawfish, the program this script is written for; see the
;; file COPYING.  If not, write to  the Free Software Foundation,
;; 675 Mass Ave, Cambridge, MA 02139, USA.

;; Version: 0.1
;;  - Initial release
;;
;; Version: 0.2
;;  - Custom path support
;;  - Application exclusion support
;;
;; Version 0.3
;;  - Added customization of font and colors
;;    NOTE: New version of prompt.jl is required

(declare (in-module sawfish.wm.util.prompt))

(require 'sawfish.wm.util.prompt)
(require 'sawfish.wm.commands)
(require 'sawfish.wm.colors)
(require 'rep.io.files)
(require 'rep.regexp)

;; FIXME: This could probably be better ...
(define (prompt-application-executable file dir)
   (let ((f (expand-file-name file dir)))
    (and (not (file-directory-p f))
	 (string-match "x" (file-modes-as-string f)))))

(define (prompt-application-duplicate file dirs)
  (delete-if-not (lambda (dir)
		   (file-exists-p (expand-file-name file dir)))
		 dirs))

(define (prompt-mismatch-application str dir file dirs)
  (or (not (string-head-eq file str))
      (prompt-application-duplicate file dirs)
      (not (prompt-application-executable file dir))
      (and run-application:use-application-exclude
	   (string-match run-application:application-exclude file))))

(define (prompt-application-path)
  (let ((path (getenv "PATH"))
        (path-list '())
        (dir "")
        (start 0)
        (end 0))
   (while (< start (length path))
     (setq end (if (string-match ":" path start)
		   (match-start) (length path)))
     (setq dir (substring path start end))
     (when (file-exists-p dir)
       (setq path-list (append path-list (list dir))))
     (setq start (1+ end)))
   path-list))

(define (prompt-complete-application str)
  (let ((path (prompt-application-path)))
    (apply #'nconc 
	   (mapcar (lambda (dir)
		     (let ((dirs (cdr (member dir path))))
		       (delete-if 
			 (lambda (file) 
			   (prompt-mismatch-application str dir file dirs))
			 (directory-files dir))))
		   path))))

(define (prompt-for-application #!optional title default)
  "Prompt for an application in $PATH"
  (unless (stringp title)
    (setq title "Enter application:"))
  (let ((str (prompt #:title title
		     #:completion-fun prompt-complete-application)))
    (when (and (string= str "") default)
      (setq str default))
    str))

(define (run-application)
  "Prompt for an application and run it"
  (setq prompt-window-position 
	(cons (case run-application:x-position
		((left) run-application:x-offset)
		((right) (- -1 run-application:x-offset))
		(t nil))
	      (case run-application:y-position
		((top) run-application:y-offset)
		((bottom) (- -1 run-application:y-offset))
		(t nil))))
  (system (format nil "%s &" (prompt-for-application "Run application: "))))

(define-command 'run-application run-application)

;; keymap-diff.jl -- functions for diffing and patching keymaps
;;
;; Copyright (C) 2001 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;; Authors: John Harper <jsh@eazel.com>

(define-structure sawfish.wm.util.keymap-diff

    (export diff-keymaps
	    patch-keymap)

    (open rep)

  ;; sorts non-destructively
  (define (sort-keymap map) (cons 'keymap (sort (copy-sequence (cdr map)))))

  ;; diff script elements are: (+ BINDING) or (- BINDING)

  (define (diff-keymaps from-map to-map)
    "Returns a list describing the changes need to transform the keymap
FROM-MAP to the keymap TO-MAP."

    (let loop ((from-rest (cdr (sort-keymap from-map)))
	       (to-rest (cdr (sort-keymap to-map)))
	       (diff '()))

      (cond ((and (null from-rest) (null to-rest))
	     ;; both lists ended
	     (cons 'keymap-diff (nreverse diff)))

	    ((null from-rest)
	     ;; from ended, so need to add rest of to
	     (loop '() (cdr to-rest) (cons (list '+ (car to-rest)) diff)))

	    ((null to-rest)
	     ;; to ended, so need to subtract rest of from
	     (loop (cdr from-rest)
		   '()
		   (cons (list '- (car from-rest)) diff)))

	    ((equal (car from-rest) (car to-rest))
	     ;; both equal, keep going
	     (loop (cdr from-rest) (cdr to-rest) diff))

	    ((< (car from-rest) (car to-rest))
	     ;; extra item in from list, so subtract it
	     (loop (cdr from-rest) to-rest
		   (cons (list '- (car from-rest)) diff)))

	    ((> (car from-rest) (car to-rest))
	     ;; extra item in to list, so add it
	     (loop from-rest (cdr to-rest)
		   (cons (list '+ (car to-rest)) diff))))))

  (define (patch-keymap map diff)
    "Returns a new copy of the keymap MAP, transformed following by the list
DIFF, which should have been created by the `diff-keymaps' function."

    (or (eq (car diff) 'keymap-diff)
	(error "Malformed keymap diff script"))

    (let loop ((rest (cdr diff))
	       (new-map (copy-sequence (cdr map))))

         (cond ((null rest)
                ;; end of the script, return the new map
                (cons 'keymap new-map))

               ((eq (caar rest) '-)
                ;; something to remove
                (loop (cdr rest) (delete (cadar rest) new-map)))

               ((eq (caar rest) '+)
                ;; something to add
                (loop (cdr rest) (cons (cadar rest) new-map)))

               (t (error "Malformed item in diff script: %s" (car rest)))))))

;; mono/theme.jl
;; $Id: theme.jl,v 1.9 2000/08/14 14:23:08 john Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(defgroup mono "Mono Theme"
  :group appearance)

(defcustom mono:normal-color nil
  "Color of inactive frames (if unset use GTK+ background color)."
  :type (optional color)
  :group (appearance mono)
  :user-level novice
  :after-set after-setting-frame-option)

(defcustom mono:active-color "yellowgreen"
  "Color of active frames."
  :type color
  :group (appearance mono)
  :user-level novice
  :after-set after-setting-frame-option)

(defcustom mono:text-justify 'left
  "Text is \\w justified in window titles."
  :type (choice left right center)
  :group (appearance mono)
  :after-set after-setting-frame-option)

(let*
    ((minimize `((inactive . ,(make-image "min.png"))
		 (clicked . ,(make-image "min-c.png"))))
     ;; 16x16
     (close `((inactive . ,(make-image "close.png"))
	      (clicked . ,(make-image "close-c.png"))))
     (maximize `((inactive . ,(make-image "max.png"))
		 (clicked . ,(make-image "max-c.png"))))
     (restore `((inactive . ,(make-image "restore.png"))
		(clicked . ,(make-image "restore-c.png"))))
     (maximize-restore (lambda (w)
			 (if (window-maximized-p w) restore maximize)))
     (menu `((inactive . ,(make-image "menu.png"))
	     (clicked . ,(make-image "menu-c.png"))))

     (initialised-gtk nil)

     (rebuild (lambda ()
		(when (and (not mono:normal-color)
			   (not initialised-gtk))
		  (setq initialised-gtk t)
		  (require 'gtkrc)
		  (gtkrc-call-after-changed
		   (lambda () (rebuild-frames-with-style 'mono))))
		(rebuild-frames-with-style 'mono)))

     (frame-colors (lambda (w)
		     (list (or (window-get w 'frame-inactive-color)
			       (and (not mono:normal-color)
				    (car gtkrc-background))
			       mono:normal-color)
			   (or (window-get w 'frame-active-color)
			       mono:active-color))))

     (text-justifier (lambda (w)
		       (cond ((eq mono:text-justify 'left) 24)
			     ((eq mono:text-justify 'right) -64)
			     ((eq mono:text-justify 'center) 'center))))

     (frame `(((background . ,frame-colors)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . ,text-justifier)
	       (y-justify . center)
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . -21)
	       (height . 21)
	       (class . title))
	       
	      ((background . "black")
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . -22)
	       (height . 1))
	       
	      ((background . "black")
	       (left-edge . -1)
	       (width . 1)
	       (top-edge . -22)
	       (bottom-edge . -5))
	       
	      ((background . "black")
	       (right-edge . -1)
	       (width . 1)
	       (top-edge . -22)
	       (bottom-edge . -5))
	       
	      ((background . ,frame-colors)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -4)
	       (height . 4)
	       (class . bottom-border))
	       
	      ((background . "black")
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -5)
	       (height . 1))
	       
	      ((background . ,frame-colors)
	       (foreground . ,menu)
	       (left-edge . 4)
	       (top-edge . -18)
	       (width . 16)
	       (height . 16)
	       (class . menu-button)
	       (removable . t))
	       
	      ((background . ,frame-colors)
	       (foreground . ,minimize)
	       (right-edge . 35)
	       (top-edge . -18)
	       (width . 16)
	       (height . 16)
	       (class . iconify-button)
	       (removable . t))
	       
	      ((background . ,frame-colors)
	       (foreground . ,maximize-restore)
	       (right-edge . 19)
	       (top-edge . -18)
	       (width . 16)
	       (height . 16)
	       (class . maximize-button)
	       (removable . t))
	       
	      ((background . ,frame-colors)
	       (foreground . ,close)
	       (right-edge . 0)
	       (top-edge . -18)
	       (width . 19)
	       (height . 16)
	       (class . close-button)
	       (removable . t))))

     (shaped-frame `(((background . ,frame-colors)
		      (foreground . "black")
		      (text . ,window-name)
		      (x-justify . ,text-justifier)
		      (y-justify . center)
		      (left-edge . 0)
		      (right-edge . 0)
		      (top-edge . -21)
		      (height . 21)
		      (class . title))
		      
		     ((background . "black")
		      (left-edge . 0)
		      (right-edge . 0)
		      (top-edge . -22)
		      (height . 1))
		      
		     ((background . "black")
		      (left-edge . -1)
		      (width . 1)
		      (top-edge . -22)
		      (height . 23))
		      
		     ((background . "black")
		      (right-edge . -1)
		      (width . 1)
		      (top-edge . -22)
		      (height . 23))
		      
		     ((background . "black")
		      (left-edge . 0)
		      (right-edge . 0)
		      (top-edge . 0)
		      (height . 1))
	       
		     ((background . ,frame-colors)
		      (foreground . ,menu)
		      (left-edge . 4)
		      (top-edge . -18)
		      (width . 16)
		      (height . 16)
		      (class . menu-button)
		      (removable . t))
		     
		     ((background . ,frame-colors)
		      (foreground . ,minimize)
		      (right-edge . 35)
		      (top-edge . -18)
		      (width . 16)
		      (height . 16)
		      (class . iconify-button)
		      (removable . t))
		     
		     ((background . ,frame-colors)
		      (foreground . ,maximize-restore)
		      (right-edge . 19)
		      (top-edge . -18)
		      (width . 16)
		      (height . 16)
		      (class . maximize-button)
		      (removable . t))
		     
		     ((background . ,frame-colors)
		      (foreground . ,close)
		      (right-edge . 0)
		      (top-edge . -18)
		      (width . 19)
		      (height . 16)
		      (class . close-button)
		      (removable . t))))

     (transient-frame `(((background . ,frame-colors)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -4)
			 (height . 4)
			 (class . title))
			 
			((background . "black")
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -5)
			 (height . 1))
			 
			((background . "black")
			 (left-edge . -1)
			 (width . 1)
			 (top-edge . -5)
			 (bottom-edge . -5))
			 
			((background . "black")
			 (right-edge . -1)
			 (width . 1)
			 (top-edge . -5)
			 (bottom-edge . -5))

			((background . ,frame-colors)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -4)
			 (height . 4)
			 (class . bottom-border))
			 
			((background . "black")
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -5)
			 (height . 1))))

     (shaped-transient-frame `(((background . ,frame-colors)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -5)
				(height . 4)
				(class . title))
				
			       ((background . "black")
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -6)
				(height . 1))
				
			       ((background . "black")
				(left-edge . -1)
				(width . 1)
				(top-edge . -6)
				(height . 6))
				
			       ((background . "black")
				(right-edge . -1)
				(width . 1)
				(top-edge . -6)
				(height . 6))
				
			       ((background . "black")
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -1)
				(height . 1)))))

  (add-frame-style 'mono
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))
  (rebuild)
  (custom-set-property 'mono:normal-color ':after-set rebuild))

;; help.jl -- commands for the help menu

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.help

    (export help-call-info)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  sawfish.wm.commands
	  sawfish.wm.commands.launcher)

  ;; Info

  (define (help-call-info document node)
    (xterm (format nil "info '%s' '%s'"
                   document node)))

  (defvar help-display-info-function help-call-info)

  ;; Commands

  (define (show-faq) 
    "Display the sawfish FAQ."
    (help-display-info-function "sawfish" "FAQ"))

  (define (show-news) 
    "Display sawfish news."
    (help-display-info-function "sawfish" "News"))

  (define (show-programmer-manual)
    "Open the programmer manual."
    (help-display-info-function "sawfish" "Top"))

  (define (show-homepage) 
    "Open the webside http://sawfish.wikia.com."
    (browser "http://sawfish.wikia.com/"))

  (define (show-about)
    "Open about sawfish."
    (system "sawfish-about >/dev/null 2>&1 </dev/null &"))

  ;;###autoload
  (define-command 'help:show-faq show-faq)
  (define-command 'help:show-news show-news)
  (define-command 'help:show-programmer-manual show-programmer-manual)
  (define-command 'help:show-homepage show-homepage)
  (define-command 'help:about show-about))

;; workarea.jl -- calculating the usable region of a head
;;
;; Author: John Harper <jsh@unfactored.org>
;;
;; Copyright (C) 2002 John Harper
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.workarea

    (export define-window-strut
	    largest-rectangle-from-edges
	    calculate-workarea
	    calculate-workarea-from-struts)

    (open rep
	  rep.system
	  sawfish.wm.util.edges
	  sawfish.wm.util.rects
	  sawfish.wm.windows
	  sawfish.wm.workspace
          sawfish.wm.viewport
	  sawfish.wm.misc)

  (defvar workarea-changed-hook nil)
  
  (define (define-window-strut w left top right bottom)
    (let ((new (list left top right bottom))
	  (old (window-get w 'workarea-strut)))
      (unless (equal old new)
	(window-put w 'workarea-strut new)
	(call-hook 'workarea-changed-hook))))

  (define (combined-struts #!key (space current-workspace))
    (let ((struts (mapcar (lambda (x)
			    (window-get x 'workarea-strut))
			  (filter-windows
			   (lambda (x)
			     (window-appears-in-workspace-p x space))))))
      (list (apply max (cons 0 (delq nil (mapcar car struts))))
	    (apply max (cons 0 (delq nil (mapcar cadr struts))))
	    (apply max (cons 0 (delq nil (mapcar caddr struts))))
	    (apply max (cons 0 (delq nil (mapcar cadddr struts)))))))

  (define (apply-struts-to-rect struts head-rect)
    (list (+ (nth 0 head-rect) (nth 0 struts))
	  (+ (nth 1 head-rect) (nth 1 struts))
	  (- (nth 2 head-rect) (nth 2 struts))
	  (- (nth 3 head-rect) (nth 3 struts))))

  (define (largest-rectangle-from-edges edges #!key avoided head)

    (define (pred rect)
      ;; the rectangle mustn't overlap any avoided windows
      ;; or span multiple heads, or be on a different head
      ;; to that requested
      (let* ((viewport (viewport-at (nth 0 rect)
                                    (nth 1 rect)))
             (cur-vp (screen-viewport))
             (x-offset (and viewport (* (screen-width)
                                        (- (car viewport)
                                           (car cur-vp)))))
             (y-offset (and viewport (* (screen-height)
                                        (- (cdr viewport)
                                           (cdr cur-vp))))))
        (let loop ((rest avoided))
	  (cond ((null rest) (rect-within-head-p rect head))
		((> (rect-2d-overlap
		     (window-frame-dimensions (car rest))
		     (let ((pos (window-position (car rest))))
		       (if (window-get (car rest) 'sticky-viewport)
			   (cons (+ (car pos) x-offset)
				 (+ (cdr pos) y-offset))
			 pos))
		     rect)
		    0)
		 nil)
		(t (loop (cdr rest)))))))

    (let* ((grid (grid-from-edges (car edges) (cdr edges)))
	   ;; find all possible rectangles
           (rects (rectangles-from-grid (sort (car grid))
                                        (sort (cdr grid))
                                        pred)))

      ;; return the largest
      (let ((max-area 0)
	    (max-rect nil))
	(mapc (lambda (rect)
		(when (and (rect-within-viewport-p rect)
			   (> (rectangle-area rect) max-area))
		  (setq max-area (rectangle-area rect))
		  (setq max-rect rect)))
              rects)
	max-rect)))

  (define (calculate-workarea #!key window head)
    "Return the rectangle representing the largest rectangle on the
screen that doesn't overlap any avoided windows, or nil.  If HEAD is
true, then an empty workarea will be replaced with the area of HEAD,
not the current head (of WINDOW)."
    (unless head
      (setq head (current-head window)))
    (let* ((avoided (avoided-windows window))
	   ;; Find the edges of all "do not cover" windows
	   (edges (get-visible-window-edges
		   #:with-ignored-windows t
		   #:windows avoided
		   #:include-heads (list head)))
	   ;; Find the rectangle covering the current head
	   (head-rect (rectangle-from-coords (head-offset head)
					     (head-dimensions head)))
	   ;; Find the largest rectangle
	   (rect (or (largest-rectangle-from-edges
		      edges #:avoided avoided #:head head) head-rect)))
      ;; Shrink that to the union of all struts
      (rectangle-intersection
       rect (apply-struts-to-rect (combined-struts) head-rect))))

  (define (calculate-workarea-from-struts #!key (workspace current-workspace))
    (apply-struts-to-rect (combined-struts workspace)
			  (rectangle-from-coords
			   (cons 0 0) (screen-dimensions))))

  (define (on-unmap w)
    (when (window-get w 'workarea-strut)
      (call-hook 'workarea-changed-hook)))

  (add-hook 'unmap-notify-hook on-unmap))

;; ignore-window.jl -- controlling the ignored property

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; originally by Julian Missig <julian@linuxpower.org> (X-ViRGE), with
;; some extra hacking/renaming

(define-structure sawfish.wm.state.ignored

    (export window-ignored-p
	    make-window-ignored
	    make-window-not-ignored
	    toggle-window-ignored
	    toggle-window-never-focus
	    toggle-window-cycle-skip
	    toggle-window-list-skip
	    toggle-task-list-skip)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.util.window-order
	  sawfish.wm.frames
	  sawfish.wm.menus)

  (define (window-ignored-p w) (window-get w 'ignored))

  (define (make-window-ignored w)
    "Ignore the window."
    (unless (window-get w 'ignored)
      (set-window-frame w nil-frame)
      (window-put w 'current-frame-style nil)
      (window-put w 'ignored t)
      (call-window-hook 'window-state-change-hook w (list '(ignored)))
      (call-hook 'workspace-state-change-hook)))

  (define (make-window-not-ignored w)
    "Unignore the window."
    (when (window-get w 'ignored)
      (window-put w 'ignored nil)
      (reframe-window w)
      (call-window-hook 'window-state-change-hook w (list '(ignored)))
      (call-hook 'workspace-state-change-hook)))

  (define (toggle-window-ignored w)
    "Toggle whether a window is ignored or not."
    (if (window-get w 'ignored)
	(make-window-not-ignored w)
      (make-window-ignored w)))

  (define (toggle-window-never-focus w)
    "Toggle whether a window is focusable or not."
    (window-put w 'never-focus (not (window-get w 'never-focus)))
    (when (eq (input-focus) w)
      (window-order-focus-most-recent))
    (call-window-hook 'window-state-change-hook w (list '(never-focus))))

  (define (toggle-window-cycle-skip w)
    "Toggle whether a window is ignored while window cycling."
    (window-put w 'cycle-skip (not (window-get w 'cycle-skip)))
    (call-window-hook 'window-state-change-hook w (list '(cycle-skip))))

  (define (toggle-window-list-skip w)
    "Toggle whether a window will be include in the window list."
    (window-put w 'window-list-skip (not (window-get w 'window-list-skip)))
    (call-window-hook 'window-state-change-hook w (list '(window-list-skip))))

  (define (toggle-task-list-skip w)
    "Toggle whether a window will be included in the task-list."
    (window-put w 'task-list-skip (not (window-get w 'task-list-skip)))
    (call-window-hook 'window-state-change-hook w (list '(task-list-skip))))

  (define-command 'make-window-ignored
    make-window-ignored #:spec "%W")
  (define-command 'make-window-not-ignored
    make-window-not-ignored #:spec "%W")
  (define-command 'toggle-window-ignored
    toggle-window-ignored #:spec "%W")
  (define-command 'toggle-window-never-focus
    toggle-window-never-focus #:spec "%W")
  (define-command 'toggle-window-cycle-skip
    toggle-window-cycle-skip #:spec "%W")
  (define-command 'toggle-window-list-skip
    toggle-window-list-skip #:spec "%W")
  (define-command 'toggle-task-list-skip
    toggle-task-list-skip #:spec "%W")

  (add-window-menu-toggle (_ "_Ignored") 'toggle-window-ignored
			  window-ignored-p)
  (add-window-menu-toggle (_ "_Focusable") 'toggle-window-never-focus
			  (lambda (w) (not (window-get w 'never-focus))))
  (add-window-menu-toggle (_ "_Cyclable") 'toggle-window-cycle-skip
			  (lambda (w) (not (window-get w 'cycle-skip))))
  (add-window-menu-toggle (_ "In _window list") 'toggle-window-list-skip
			  (lambda (w) (not (window-get w 'window-list-skip))))
  (add-window-menu-toggle (_ "In _task list") 'toggle-task-list-skip
                          (lambda (w) (not (window-get w 'task-list-skip)))))

;; rects.jl -- rectangle manipulation

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.rects

    (export rect-left rect-top rect-right rect-bottom
            rect-obscured rect-minus
            rectangles-from-grid
	    rectangles-from-windows
	    grid-from-rectangles
	    rectangle-area
	    rectangle-from-coords
	    rectangle-corners
	    rectangle-center
	    rectangle-center*
	    rectangle-union
	    rectangle-intersection
	    rect-1d-overlap
	    rect-2d-overlap
	    rect-2d-overlap*
	    rect-total-overlap
            rect-wholly-within-rect
	    rect-wholly-visible-p
	    rectangle-heads)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.misc)

  (define-structure-alias rects sawfish.wm.util.rects)

  ;; Commentary:

  ;; A rectangle is (LEFT TOP RIGHT BOTTOM [WEIGHT])
  ;; The left and top edges are considered part of the rectangle,
  ;; the right and bottom edges are not.


;;; rectangles

  (define rect-left car)
  (define rect-top cadr)
  (define rect-right caddr)
  (define rect-bottom cadddr)

  (define (rect-obscured r by)
    "Check whether rectangle R is wholly or partially contained in
rectangle BY.  Return `unobscured', `partially-obscured' or `fully-obscured'."
    (cond ((or (<= (rect-right by) (rect-left r))
               (<= (rect-right r) (rect-left by))
               (<= (rect-bottom by) (rect-top r))
               (<= (rect-bottom r) (rect-top by)))
           'unobscured)
          ((and (<= (rect-left by) (rect-left r))
                (<= (rect-right r) (rect-right by))
                (<= (rect-top by) (rect-top r))
                (<= (rect-bottom r) (rect-bottom by)))
           'fully-obscured)
          (t 'partially-obscured)))

  (define (rect-minus r s #!optional tail)
    "Return a list of disjoint rectangles whose union is the part of
rectangle R not contained in rectangle S.  If TAIL is given, the
result is prepended to it."
    (let rminus ((r r) (result tail))
         (cond
          ;; Check for complete disjointness.
          ((or (<= (rect-right s) (rect-left r))
               (<= (rect-right r) (rect-left s))
               (<= (rect-bottom s) (rect-top r))
               (<= (rect-bottom r) (rect-top s)))
           (cons r result))
          ;; Extract a free slice from the bottom of r.
          ((< (rect-bottom s) (rect-bottom r))
           (rminus (list (rect-left r) (rect-top r)
                         (rect-right r) (rect-bottom s))
                   (cons (list (rect-left r) (rect-bottom s)
                               (rect-right r) (rect-bottom r))
                         result)))
          ;; Extract a free slice from the right side of r.
          ((< (rect-right s) (rect-right r))
           (rminus (list (rect-left r) (rect-top r)
                         (rect-right s) (rect-bottom r))
                   (cons (list (rect-right s) (rect-top r)
                               (rect-right r) (rect-bottom r))
                         result)))
          ;; Extract a free slice from the top of r.
          ((> (rect-top s) (rect-top r))
           (rminus (list (rect-left r) (rect-top s)
                         (rect-right r) (rect-bottom r))
                   (cons (list (rect-left r) (rect-top r)
                               (rect-right r) (rect-top s))
                         result)))
          ;; Extract a free slice from the left side of r.
          ((> (rect-left s) (rect-left r))
           (rminus (list (rect-left s) (rect-top r)
                         (rect-right r) (rect-bottom r))
                   (cons (list (rect-left r) (rect-top r)
                               (rect-left s) (rect-bottom r))
                         result)))
          ;; Completely covered.
          (t result))))

  (define (rectangles-from-grid x-points y-points #!optional pred)
    "The two lists of integers X-POINTS and Y-POINTS define a rectangular
grid. Return the complete list of rectangles formed by the
intersections of the grid.

If PRED is defined, it is called for each rectangle, and only those for
which it returns t are added to the returned list.

Each rectangle is represented by a list `(LEFT TOP RIGHT BOTTOM)'.

Assumes that X-POINTS and Y-POINTS are both sorted smallest->largest."

    (let (rects left-x right-x top-y bottom-y tem-y-points tem-x tem-y rect)
      (while x-points
	(setq left-x (car x-points))
	(setq x-points (cdr x-points))
	(setq tem-y-points y-points)
	(while tem-y-points
	  (setq top-y (car tem-y-points))
	  (setq tem-y-points (cdr tem-y-points))
	  (setq tem-x x-points)
	  (while tem-x
	    (setq right-x (car tem-x))
	    (setq tem-x (cdr tem-x))
	    (setq tem-y tem-y-points)
	    (while tem-y
	      (setq bottom-y (car tem-y))
	      (setq tem-y (cdr tem-y))
	      (setq rect (list left-x top-y right-x bottom-y))
	      (when (or (not pred) (pred rect))
		(setq rects (cons rect rects)))))))
      (nreverse rects)))

  (define (rectangles-from-windows windows #!optional weight-fun)
    "Returns a list of (LEFT TOP RIGHT BOTTOM [OVERLAP-WEIGHT])
representing the rectangles represented by the list of window objects
WINDOWS.

If WEIGHT-FUN is defined, it is a function to call on each window to
return the weight for that window. If not defined, the window's
`weight' property is used instead."

    (mapcar (lambda (w)
	      (let ((dims (window-frame-dimensions w))
		    (pos (window-position w))
		    tem)
		(list* (car pos) (cdr pos)
		       (+ (car pos) (car dims))
		       (+ (cdr pos) (cdr dims))
		       (and (setq tem (if weight-fun
					  (weight-fun w)
					(window-get w 'weight)))
			    (list tem)))))
	    windows))

  (define (grid-from-rectangles rects #!optional with-root)
    "Given a list of rectangles RECTS (each rectangle represented by a
list of at least four elemements, `(LEFT TOP RIGHT BOTTOM)'), return
a cons cell `(X-POINTS . Y-POINTS)' defining the grid they represent.

If WITH-ROOT is non-nil, then add the root window boundaries to the
grid."

    (let ((x-edges (nconc (mapcar car rects)
                          (mapcar (lambda (x) (nth 2 x)) rects)))
          (y-edges (nconc (mapcar (lambda (x) (nth 1 x)) rects)
                          (mapcar (lambda (x) (nth 3 x)) rects))))
      (when with-root
        (setq x-edges (cons 0 (nconc x-edges (list (screen-width)))))
        (setq y-edges (cons 0 (nconc y-edges (list (screen-height))))))
      (cons (uniquify-list x-edges) (uniquify-list y-edges))))

  (define (rectangle-area rect)
    "Given a rectangle RECT, return its area."
    (* (- (nth 2 rect) (nth 0 rect))
       (- (nth 3 rect) (nth 1 rect))))

  (define (rectangle-from-coords point dims)
    "Return a list representing the rectangle with origin POINT and dimensions
DIMS."
    (list (car point) (cdr point)
	  (+ (car point) (car dims)) (+ (cdr point) (cdr dims))))

  (define (rectangle-corners rect)
    "Return a list of four cons cells representing the coordinates of the
corners of the rectangle RECT."
    (list (cons (nth 0 rect) (nth 1 rect))
	  (cons (nth 0 rect) (nth 3 rect))
	  (cons (nth 2 rect) (nth 1 rect))
	  (cons (nth 2 rect) (nth 3 rect))))

  (define (rectangle-center rect)
    (cons (+ (nth 0 rect) (/ (- (nth 2 rect) (nth 0 rect)) 2))
	  (+ (nth 1 rect) (/ (- (nth 3 rect) (nth 1 rect)) 2))))

  (define (rectangle-center* point dims)
    (cons (+ (car point) (/ (car dims) 2))
	  (+ (cdr point) (/ (cdr dims) 2))))

  (define (rectangle-union rect1 rect2)
    (list (min (nth 0 rect1) (nth 0 rect2))
	  (min (nth 1 rect1) (nth 1 rect2))
	  (max (nth 2 rect1) (nth 2 rect2))
	  (max (nth 3 rect1) (nth 3 rect2))
	  (nth 4 rect1)))

  (define (rectangle-intersection rect1 rect2)
    (let ((rect (list (max (nth 0 rect1) (nth 0 rect2))
		      (max (nth 1 rect1) (nth 1 rect2))
		      (min (nth 2 rect1) (nth 2 rect2))
		      (min (nth 3 rect1) (nth 3 rect2))
		      (nth 4 rect1))))
      (if (or (>= (nth 0 rect) (nth 2 rect))
	      (>= (nth 1 rect) (nth 3 rect)))
	  ;; empty
	  nil
	rect)))

;;; overlap

  (define (rect-1d-overlap a-1 a-2 b-1 b-2)
    "Returns the overlap between two 1D line segments, A-1 to A-2, and
B-1 to B-2."
    (max 0 (- (min a-2 b-2) (max a-1 b-1))))

  (define (rect-2d-overlap dims point rect)
    "Returns the overlap between two rectangles, one defined as having
dimensions DIMS and origin POINT, while the other is defined by RECT."

    (* (rect-1d-overlap (car point) (+ (car point) (car dims))
			(car rect) (nth 2 rect))
       (rect-1d-overlap (cdr point) (+ (cdr point) (cdr dims))
			(nth 1 rect) (nth 3 rect))
       ;; include the weight of the rectangle if it has one
       (or (nth 4 rect) 1)))

  (define (rect-2d-overlap* rect1 rect2)
    "Returns the overlap between two rectangles, RECT1 and RECT2."
    (* (rect-1d-overlap (car rect1) (nth 2 rect1)
			(car rect2) (nth 2 rect2))
       (rect-1d-overlap (nth 1 rect1) (nth 3 rect1)
			(nth 1 rect2) (nth 3 rect2))
       ;; include the weight of the rectangle if it has one
       (or (nth 4 rect1) 1)
       (or (nth 4 rect2) 1)))

  (define (rect-total-overlap dims point rects)
    "Returns the total area of the overlap between a rectangle defined by
DIMS and POINT, and the list of rectangles RECTS when placed at POINT."
    (let ((total 0))
      (mapc (lambda (r)
	      (setq total (+ total (rect-2d-overlap dims point r))))
	    rects)
      total))

  (define (rect-wholly-within-rect outer inner)
    "Return t if INNER is completely inside the boundaries of OUTER."
    (eq (rect-obscured inner outer) 'fully-obscured))

  (define (rect-wholly-visible-p rect)
    "Return t if RECT is completely inside the screen boundaries."
    (rect-wholly-within-rect (list 0 0 (screen-width) (screen-height))
                             rect))

  (define (rectangle-heads rect)
    "Return the number of screen heads that rectangle RECT appears on."
    (let loop ((head 0)
	       (count 0))
      (if (= head (head-count))
	  count
	(loop (1+ head)
	      (if (> (rect-2d-overlap (head-dimensions head)
				      (head-offset head) rect) 0)
		  (1+ count)
		count))))))

;; edge/actions.jl -- Sets up central user interface of edge-actions

;; Copyright (C) 2010 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.edge.actions

    (export activate-edges
	    activate-edges-after-set)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.edge.conf
	  sawfish.wm.edge.util
	  sawfish.wm.edge.flip
	  sawfish.wm.edge.hot-spots
	  sawfish.wm.edge.viewport-drag)

  (define-structure-alias edge-actions sawfish.wm.edge.actions)

  (define (edge-action-call func edge)
    (case func
      ((viewport-drag)
       (viewport-drag-invoke edge))
      ((flip-workspace)
       (edge-flip-invoke edge 'workspace))
      ((flip-viewport)
       (edge-flip-invoke edge 'viewport))
      ((none/hot-spot)
       (hot-spot-invoke edge))
      (t nil)))

  ;; Entry point without dragging 
  (define (edge-action-hook-func)
    (let ((corner (get-active-corner))
	  (edge (get-active-edge)))
      (if corner
	  (hot-spot-invoke corner)
	(cond ((or (eq edge 'left)
		   (eq edge 'right))
	       (edge-action-call left-right-edge-action edge))
	      ((or (eq edge 'top)
		   (eq edge 'bottom))
	       (edge-action-call top-bottom-edge-action edge))))))

  ;; Entry point for window dragging
  (define (edge-action-move-hook-func)
    (let ((edge (get-active-edge)))
      (cond ((or (eq edge 'left)
		 (eq edge 'right))
	     (edge-action-call left-right-edge-move-action edge))
	    ((or (eq edge 'top)
		 (eq edge 'bottom))
	     (edge-action-call top-bottom-edge-move-action edge)))))

  (define (activate-edges init)
    (if init
	(progn
	  (activate-flippers t)
	  (unless (in-hook-p 'enter-flipper-hook edge-action-hook-func)
	    (add-hook 'enter-flipper-hook edge-action-hook-func))
	  ;; While the pointer is grabbed, window enter/leave events
	  ;; are not generated.
	  (unless (in-hook-p 'while-moving-hook edge-action-move-hook-func)
	    (add-hook 'while-moving-hook edge-action-move-hook-func)))
      (activate-flippers nil)
      (remove-hook 'enter-flipper-hook edge-action-hook-func)
      (remove-hook 'while-moving-hook edge-action-move-hook-func)))

  (define (activate-edges-after-set)
    (activate-edges edge-actions-enabled)))

;; flip.jl -- move viewport / workspace like flipping pages

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.flip

    (export edge-flip-invoke)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.viewport
	  sawfish.wm.workspace
	  sawfish.wm.commands.move-resize
	  sawfish.wm.ext.workspace-grid)

  (define-structure-alias edge-flip sawfish.wm.edge.flip)

  (define steps nil)

  (define (edge-flip-invoke edge type while-moving)
      (call-hook 'before-edge-action-hook (list type edge while-moving))

      (if (eq type 'flip-viewport)
          (flip-viewport edge while-moving)
        (flip-workspace edge while-moving)))

  (define (flip-viewport edge while-moving)
    (let ((ptr (query-pointer t)))

      (if while-moving
	  (setq steps 1)
	(setq steps scroll-viewport-steps))

      (let ((scroll-viewport-steps steps))
	(cond ((eq edge 'left)
	      (when (move-viewport -1 0)
		(rplaca ptr (- (screen-width) 2))))
	      ((eq edge 'right)
	      (when (move-viewport 1 0)
		(rplaca ptr 1)))
	      ((eq edge 'top)
	      (when (move-viewport 0 -1)
		(rplacd ptr (- (screen-height) 2))))
	      ((eq edge 'bottom)
	      (when (move-viewport 0 1)
		(rplacd ptr 1))))

	(warp-cursor (car ptr) (cdr ptr))

        (call-hook 'after-edge-action-hook (list 'flip-viewport edge while-moving)))))

  (define (flip-workspace edge while-moving)
    (let ((ptr (query-pointer t))
          (original-workspace current-workspace)
          (mr-win))

      (call-hook 'before-edge-action-hook (list 'flip-workspace edge while-moving))

      (when while-moving
        (setq mr-win move-resize-window))

      (cond ((eq edge 'left)
	      (workspace-left)
	      (rplaca ptr (- (screen-width) 2)))
	    ((eq edge 'right)
	      (workspace-right)
	      (rplaca ptr 1))
	    ((eq edge 'top)
	      (workspace-up)
	      (rplacd ptr (- (screen-height) 2)))
	    ((eq edge 'bottom)
	      (workspace-down)
	      (rplacd ptr 1)))

      (unless (= current-workspace original-workspace)
	(warp-cursor (car ptr) (cdr ptr))
        (when (and mr-win
	      (not (window-get mr-win 'sticky)))
	  (move-window-to-workspace mr-win original-workspace current-workspace t)))

      (call-hook 'after-edge-action-hook (list 'flip-workspace edge while-moving)))))

#!/bin/sh
exec rep "$0" "$@"
!#

;; sawfish-client.jl -- window manager remote client
;;
;; $Id$
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(require 'sawfish.client)

(define current-repl (make-fluid))

(define (usage)
  (write standard-output "\
usage: sawfish-client OPTIONS...

where OPTIONS are any of:

        --display X     Connect to the window manager on display X
        -q              Be quiet (perform commands asynchronously)
        -f FUNCTION     Call Lisp function FUNCTION on the server
        -c COMMAND      Call the interactive Lisp function COMMAND
        -r FEATURE      Require the module called FEATURE
        -e FORM         Evaluate Lisp form FORM on the server
        -               Read lines of input until EOF, evaluating each
                         one as it is read
        --              Read forms from standard input until EOF, evaluating
                         the whole lot in one go (inside a progn)\n"))

(define (exit n) (throw 'quit n))

(define (main)
  (let ((dpy (or (get-command-line-option "-display" t)
                 (get-command-line-option "--display" t))))
    (when dpy
      (sawfish-client-display dpy)))

  (when (get-command-line-option "--help")
    (usage)
    (exit 0))

  (let ((quiet nil))

    (define (do-eval form)
      (if quiet
          (sawfish-client-eval-async form)
        (write standard-output (sawfish-client-eval form t))
        (write standard-output #\newline)))

    (let loop ((args (or command-line-args '("-"))))
      (cond ((null args))

            ((string= (car args) "-q")
             (setq quiet t)
             (loop (cdr args)))

            ((string= (car args) "-d") (loop (cdr args)))

            ((and (string= (car args) "-f") (cdr args))
             (do-eval `(,(read-from-string (cadr args))))
             (loop (cddr args)))

	    ((and (string= (car args) "-c") (cdr args))
	     (do-eval `(call-command ',(read-from-string (cadr args))))
	     (loop (cddr args)))

            ((and (string= (car args) "-r") (cdr args))
	     (do-eval `(require ',(read-from-string (cadr args))))
	     (loop (cddr args)))

	    ((and (string= (car args) "-e") (cdr args))
	     (do-eval (read-from-string (cadr args)))
	     (loop (cddr args)))

	    ((string= (car args) "-")
	     (require 'rep.io.readline)
	     (require 'rep.util.repl)
	     (format standard-output "\
sawfish-client %s.\n"
		     (sawfish-client-eval 'sawfish-version))
	     (let ((r (sawfish-client-eval
		       `(progn
			  (require 'rep.util.repl)
                          (define-repl-command 'quit
                            (lambda () (throw 'sawfish-client-exit)))
			  (make-repl 'user)))))
	       (let-fluids ((current-repl r))
		 (write standard-output "\nEnter `,help' to list commands.\n")
		 (let loop ()
		   (let ((input (readline
				 (format nil (if (repl-pending r) "" "client > ")
					 (repl-struct r)))))
		     (when input
		       (let ((out (sawfish-client-eval
				   `(progn
				      (require 'rep.util.repl)
				      (let* ((standard-output
					      (make-string-output-stream))
					     (standard-error standard-output)
					     (r ',r))
					(cons (catch 'sawfish-client-exit
                                                (and (repl-iterate r ',input)
                                                     r))
					      (get-output-stream-string
					       standard-output)))))))
			 (setq r (car out))
			 (fluid-set current-repl r)
			 (write standard-output (cdr out))
			 (when r (loop))))))))
	     (loop (cdr args)))

	    ((string= (car args) "--")
	     (let ((text (make-string-output-stream)))
	       (copy-stream standard-input text)
	       (do-eval (read-from-string
			 (concat "\(progn"
				 (get-output-stream-string text)
				 "\)")))
	       (loop (cdr args))))

	    (t (format standard-error
		       "sawfish-client: unknown option `%s'\n" (car args))
	       (format standard-error
		       "Try `sawfish-client --help' for more information.\n")
	       (exit 1))))
    (exit 0)))

(define (rl-completion-generator w)
  (sawfish-client-eval
   `(repl-completions ',(fluid current-repl) ',w)))

(main)

;; Emacs support
;; Local variables:
;; mode: sawfish
;; End:

;; stacking.jl -- window stacking

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.stacking

    (export save-stacking-order
	    mapped-stacking-order
            window-obscured
            stacking-visibility
	    raise-window
	    lower-window
	    stack-window-above
	    stack-window-below
	    restack-window
	    stacking-order-by-depth
	    window-depth
	    set-window-depth
	    window-on-top-p
	    raise-lower-window
	    lower-window-depth
	    raise-window-depth
	    raise-windows
	    lower-windows
	    raise-lower-windows)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.session.init
	  sawfish.wm.workspace
          sawfish.wm.state.transient
          sawfish.wm.util.rects)

  ;; Each window will have a `depth' property--an integer, zero
  ;; represents the level of normal windows, negative for windows below
  ;; this level, and positive for windows above the normal level

  (defcustom transients-above 'parents
    "Keep transient windows stacked above: \\left"
    :group (misc stacking)
    :type (choice all parents none))

  (defmacro save-stacking-order (#!rest forms)
    "Execute FORMS, then reinstall the original stacking order."
    (let ((tem (gensym)))
      `(let ((,tem (stacking-order)))
	 (unwind-protect
	     (progn ,@forms)
	   (restack-windows ,tem)))))

  ;; this will always return an integer
  (define (window-depth w) (window-get w 'depth))

;;; constraint mechanics (predicates actually..)

  (define (stacking-constraint:layer w)
    (let ((depth (window-depth w)))
      (lambda (above below)
	;; constraints are met locally in ABOVE and BELOW, so just
	;; test against windows adjacent to W
	(and (or (null above)
		 (<= depth (window-depth (car above))))
	     (or (null below)
		 (>= depth (window-depth (car below))))))))

  (define (stacking-constraint:transients-above-parent w)
    (let ((parents (transient-parents w))
	  (children (transient-children w)))

      ;; ignore parents with depth > W, ignore children with depth < W
      (let ((w-depth (window-depth w)))
	(setq parents (delete-if (lambda (x)
				   (> (window-depth x) w-depth)) parents))
	  (setq children (delete-if (lambda (x)
				      (< (window-depth x) w-depth)) children)))

	(lambda (above below)
	  (and (or (null parents)
		   ;; All parents must be below W
		   (let loop ((rest parents))
		     (cond ((null rest) t)
			   ((memq (car rest) above) nil)
			   (t (loop (cdr rest))))))
	       (or (null children)
		   ;; All children must be above W
		   (let loop ((rest children))
		     (cond ((null rest) t)
			   ((memq (car rest) below) nil)
			   (t (loop (cdr rest))))))))))

  (define (stacking-constraint:transients-above-all w)
    (let ((w-depth (window-depth w)))
      (if (window-transient-p w)
	  ;; ensure there are no normal windows above W, unless they
	  ;; have depth > W
	  (lambda (above below)
	    (declare (unused below))
	    (let loop ((rest above))
	      (cond ((null rest) t)
		    ((and (not (window-transient-p (car rest)))
			  (<= (window-depth (car rest)) w-depth)) nil)
		    (t (loop (cdr rest))))))
	;; ensure no transients below W, unless they're depth < W
	(lambda (above below)
	  (declare (unused above))
	  (let loop ((rest below))
	    (cond ((null rest) t)
		  ((and (window-transient-p (car rest))
			(>= (window-depth (car rest)) w-depth)) nil)
		  (t (loop (cdr rest)))))))))

  (define (combine-constraints constraints)
    "Combine the list of secondary constraint functions into a single
function (using logical `and' combinator)."
    (lambda (above below)
      (let loop ((rest constraints))
	(cond ((null rest) t)
	      ((not ((car rest) above below)) nil)
	      (t (loop (cdr rest)))))))

  (defvar basic-stacking-constraints (list stacking-constraint:layer)
    "List of stacking constraint functions to adhere to (excluding transient
stacking modes controlled by `transients-above' option).")

  (define (make-constraint w)
    "Return the constraint function to use when stacking window W, a function
of two arguments, the list of windows above W (from bottom to top) and the
list of windows below W (from top to bottom). If the constraint holds
for a particular stacking configuration, it will return non-`nil'."
    (combine-constraints
     (mapcar (lambda (c) (c w))
	     (case (or (window-get w 'transients-above) transients-above)
	       ((parents)
		(cons stacking-constraint:transients-above-parent
		      basic-stacking-constraints))
	       ((all)
		(cons stacking-constraint:transients-above-all
		      basic-stacking-constraints))
	       (t basic-stacking-constraints)))))

;;; utilities

  ;; returns (BEFORE . AFTER), modifies LST
  (define (break-window-list lst pivot)
    "Given a list of windows LST and a window PIVOT, return a cons cell
containing two lists, the windows that occur in LST before PIVOT does (in
reverse order), and the list of windows occurring in LST after PIVOT.

LST is destructively modified by this procedure."
    (let loop ((rest lst)
	       (before '()))
      (cond ((null rest)
	     (cons before rest))
	    ((eq (car rest) pivot)
	     (cons before (cdr rest)))
	    (t
	     (let ((next (cdr rest)))
	       (rplacd rest before)
		 (loop next rest))))))

  (define (stack-rotate-upwards cell)
    "Given a cons cell containing two lists of windows `(ABOVE . BELOW)',
rotate the lists so that the first element of BELOW becomes the first
element of ABOVE. The lists are modified. Returns `nil' if BELOW is
the empty list."
    (if (null (car cell))
	nil
      (let ((next (car cell)))
	(rplaca cell (cdar cell))
	  (rplacd next (cdr cell))
	  (rplacd cell next)
	  cell)))

  (define (stack-rotate-downwards cell)
    "Given a cons cell containing two lists of windows `(ABOVE . BELOW)',
rotate the lists so that the first element of ABOVE becomes the first
element of BELOW. The lists are modified. Returns `nil' if ABOVE is
the empty list."
    (if (null (cdr cell))
	nil
      (let ((next (cdr cell)))
	(rplacd cell (cddr cell))
	  (rplacd next (car cell))
	  (rplaca cell next)
	  cell)))

  (define (mapped-stacking-order)
    (delete-if-not window-mapped-p (stacking-order)))

  (define (window-obscured window)
    "Check whether WINDOW is obscured.  Return `t' if WINDOW is fully obscured
by some other window, otherwise a list of windows partially obscuring WINDOW.
In particular return `nil' if WINDOW is unobscured.  Note that if a list of
partially obscuring windows is returned, taken together they may or may not
fully obscure WINDOW."
    (define w window)
    (define ws (nearest-workspace-with-window w current-workspace))
    (let loop ((stack (stacking-order))
               (obs nil))
      (if (null stack)               ; Should not happen
	  obs
	(let ((w2 (car stack)))
	  (cond ((eq w2 w) obs)
		((and (window-visible-p w2)
		      (window-appears-in-workspace-p w2 ws))
		 (case (apply rect-obscured
			      (rectangles-from-windows (list w w2)))
		   ((unobscured) (loop (cdr stack) obs))
		   ((fully-obscured) t)
		   (t (loop (cdr stack) (cons w2 obs))))) ; Partially
		(t (loop (cdr stack) obs)))))))

  (define (stacking-visibility window)
    "Compute the visibility of WINDOW from the stacking order.  This should
work even with the Composite extension, which appears to disable
VisibilityNotify events.  Note that deciding between fully and partially
obscured may require quite a bit of computation.  If you do not need that
distinction, window-obscured should be faster."
    (define (rect-list-minus rs s tail)
      (if (null rs)
          tail
        (rect-list-minus (cdr rs) s
                         (rect-minus (car rs) s tail))))
    (let ((obs (window-obscured window)))
      (case obs
        ((t) 'fully-obscured)
        ((()) 'unobscured)
        (t
         (do ((unobs (rectangles-from-windows (list window))
                     (rect-list-minus unobs (car robs) nil))
              (robs (rectangles-from-windows obs) (cdr robs)))
             ((or (null unobs) (null robs))
              (if (null unobs)
                  'fully-obscured
                'partially-obscured)))))))


;;; stacking functions

  (define (raise-window w)
    "Raise the window to its highest allowed position in the stacking order."
    ;; work downwards from top
    (let ((constraint (make-constraint w))
	  (stack (cons '() (delq w (stacking-order)))))
      (let loop ()
	(cond ((constraint (car stack) (cdr stack))
	       (if (car stack)
		   (x-lower-window w (car (car stack)))
		 (x-raise-window w (car (cdr stack)))))
	      ((null (cdr stack))
	       ;; no position
	       nil)
	      (t
	       (stack-rotate-downwards stack)
	       (loop))))))

  (define (lower-window w)
    "Lower the window to its lowest allowed position in the stacking order."
    (let ((constraint (make-constraint w))
	  (stack (cons (nreverse (delq w (stacking-order))) '())))
      ;; work upwards from bottom
      (let loop ()
	(cond ((constraint (car stack) (cdr stack))
	       ;; found the lowest position
	       (if (cdr stack)
		   (x-raise-window w (car (cdr stack)))
		 (x-lower-window w (car (car stack)))))
	      ((null (car stack))
	       ;; no possible position..
	       nil)
	      (t
	       (stack-rotate-upwards stack)
	       (loop))))))

  (define (stack-window-above above below)
    "Change the stacking of window ABOVE so that it is as closely above window
BELOW as possible."
    (let ((constraint (make-constraint above))
	  (stack (break-window-list
		  (delq above (stacking-order)) below)))
      (rplacd stack (cons below (cdr stack)))
	(let loop ()
	  (cond ((constraint (car stack) (cdr stack))
		 ;; found a suitable position
		 (if (car stack)
		     (x-lower-window above (car (car stack)))
		   (x-raise-window above (car (cdr stack)))))
		((null (car stack))
		 ;; reached the top
		 nil)
		(t
		 (stack-rotate-upwards stack)
		 (loop))))))

  (define (stack-window-below below above)
    "Change the stacking of window BELOW so that it is as closely below window
ABOVE as possible."
    (let ((constraint (make-constraint below))
	  (stack (break-window-list
		  (delq below (stacking-order)) above)))
      (rplaca stack (cons above (car stack)))
	(let loop ()
	  (cond ((constraint (car stack) (cdr stack))
		 (if (cdr stack)
		     (x-raise-window below (car (cdr stack)))
		   (x-lower-window below (car (car stack)))))
		((null (cdr stack))
		 ;; reached the bottom
		 nil)
		(t
		 (stack-rotate-downwards stack)
		 (loop))))))

  (define (restack-window w)
    "Assuming that the current stacking order is in a consistent state
except, possibly, for the position of window W, restore the consistent
state including window W. This is achieved by raising or lowering
window W as appropriate."
    (let ((constraint (make-constraint w))
	  (stack (break-window-list (stacking-order) w)))
      (unless (constraint (car stack) (cdr stack))
	(if (< (length (car stack)) (length (cdr stack)))
	    (raise-window w)
	  (lower-window w)))))

  (define (stacking-order-by-depth depth)
    "Return a list of windows containing only those in depth DEPTH, in the
order they are stacked within the layer (top to bottom)."
    (let ((order (stacking-order)))
      (delete-if (lambda (x)
		   (/= (window-depth x) depth)) order)))

  (define (set-window-depth w depth)
    "Set the stacking depth of window W to DEPTH."
    (let ((old (window-depth w)))
      (window-put w 'depth depth)
	(cond ((> old depth)
	       ;; window's going downwards
	       (raise-window w))
	      ((< old depth)
	       ;; window's going upwards
	       (lower-window w)))
	(call-window-hook 'window-depth-change-hook w (list depth))
	(call-window-hook 'window-state-change-hook w (list '(stacking)))))

  (define (window-on-top-p w)
    "Return t if window W is as high as it can legally go in the
stacking order."
    (let* ((constraint (make-constraint w))
	   (order (delete-if-not
		   ;; XXX doesn't handle viewports..
		   (let ((space (nearest-workspace-with-window
				 w current-workspace)))
		     (lambda (x)
		       (window-appears-in-workspace-p x space)))
		   (stacking-order)))
	   (old-posn (- (length order) (length (memq w order))))
	   (stack (cons '() (delq w order))))
      (let loop ()
	(if (or (constraint (car stack) (cdr stack))
		(null (cdr stack)))
	    ;; found highest position
	    (= (length (car stack)) old-posn)
	  (stack-rotate-downwards stack)
	  (loop)))))

  (define (raise-lower-window w)
    "If the window is at its highest possible position, then lower it to its
lowest possible position. Otherwise raise it as far as allowed."
    (if (or (not (window-obscured w))
	    (window-on-top-p w))
	(lower-window w)
      (raise-window w)))

  (define (lower-window-depth w)
    "Put the window in the stacking level beneath its current level."
    (set-window-depth w (1- (window-depth w))))

  (define (raise-window-depth w)
    "Put the window in the stacking level above its current level."
    (set-window-depth w (1+ (window-depth w))))

  (define-command 'raise-single-window raise-window
    #:spec "%W")
  (define-command 'lower-single-window lower-window
    #:spec "%W")
  (define-command 'raise-lower-single-window raise-lower-window
    #:spec "%W")
  (define-command 'raise-window-depth raise-window-depth #:spec "%W")
  (define-command 'lower-window-depth lower-window-depth #:spec "%W")

;;; stacking groups of windows

  ;; Helper function for raise-windows and lower-windows. Calls (FIRST
  ;; X) on the first element X of ORDER, then (SUCCESSOR Y X) on each
  ;; pair of adjacent elements X and Y

  (define (apply-group-order order first successor)
    (when order
      (first (car order))
      (do ((rest order (cdr rest)))
	  ((null (cdr rest)))
	(successor (cadr rest) (car rest)))))

  (define (raise-windows w order)
    ;; STRATEGY: take every window in ORDER to its highest possible
    ;; position, giving W priority but otherwise obeying ORDER, which
    ;; must be a valid stacking configuration (highest-to-lowest).  Do
    ;; the restacking in such a way that no part of any window in
    ;; ORDER is exposed during the restacking that is not exposed
    ;; afterwards.

    (define (highest-window order)
      ;; find the first window in ORDER that is allowed
      ;; to be above all other windows in ORDER...
      (let loop ((rest order))
	(cond ((null rest) nil)
	      (((make-constraint (car rest)) '() (remq (car rest) order))
	       (car rest))
	      (t (loop (cdr rest))))))

    ;; Cons up the new order (in reverse), by picking the most-raisable
    ;; each time until no windows are left, then commit that ordering
    (let loop ((rest (cons w (remq w order)))
	       (out '()))
      (if (null rest)
	  (apply-group-order (nreverse out) raise-window stack-window-below)
	(let ((highest (or (highest-window rest)
			   (error "Stacking constraint failed"))))
	  (loop (delq highest rest) (cons highest out))))))

  (define (lower-windows w order)

    (define (lowest-window order)
      ;; find the last window in ORDER that may be below all other
      ;; windows in ORDER
      (let ((reversed (reverse order)))
	(let loop ((rest reversed))
	  (cond ((null rest) nil)
		(((make-constraint (car rest))
		  (remq (car rest) reversed) '()) (car rest))
		(t (loop (cdr rest)))))))

    (let loop ((rest (nconc (remq w order) (list w)))
	       (out '()))
      (if (null rest)
	  (apply-group-order (nreverse out) lower-window stack-window-above)
	(let ((lowest (or (lowest-window rest)
			  (error "Stacking constraint failed"))))
	  (loop (delq lowest rest) (cons lowest out))))))

  (define (raise-lower-windows w order)
    (if (or (not (window-obscured w))
	    (and (window-on-top-p (car order))
		 ;; look for the group as a block.. this is a heuristic
		 (let loop ((rest (memq (car order) (stacking-order))))
		   (cond ((null rest) nil)
			 ((eq (car rest) w) t)
			 ((memq (car rest) order) (loop (cdr rest)))
			 (t nil)))))
	(lower-windows w order)
      (raise-windows w order)))

;;; hooks

  ;; Called from the add-window-hook
  (define (stacking-add-window w)
    (unless (window-get w 'depth)
      (let ((parents (transient-parents w)))
	(if parents
	    ;; put dialogs in at least as high a layer as their
	    ;; highest parent, but never below the default depth
	    (window-put w 'depth (apply max 0 (mapcar window-depth parents)))
	  ;; default depth
	  (window-put w 'depth 0)))))

  (add-hook 'add-window-hook stacking-add-window t)
  (add-hook 'after-add-window-hook restack-window t)
  (add-hook 'map-notify-hook restack-window t)

  (sm-add-saved-properties 'depth)
  (add-swapped-properties 'depth))

;; nokogiri-widgets/list.jl -- list widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.list

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget
          sawfish.gtk.widgets.simple-dialog)

  ;; (list SPEC-OR-FUNCTION [TITLE])

  ;; if a functional spec is passed, these operations will be used:

  ;; - ((SPEC 'print) VALUE) => LIST-OF-STRINGS
  ;; - ((SPEC 'dialog) TITLE CALLBACK [#:for WIDGET] [#:value VALUE])
  ;; - ((SPEC 'validp) ARG) => BOOL

  ;; CALLBACK is a function that will be called with the new value
  ;; if it's accepted

  (defconst list-width 200)
  (defconst list-height -2)

  (define (make-list-item changed-callback spec #!optional title)

    (let ((clist (if title
		     (gtk-clist-new-with-titles (if (stringp title)
						    (vector title)
						  title))
		   (gtk-clist-new 1)))
	  (scroller (gtk-scrolled-window-new))
	  (add (gtk-button-new-from-stock "gtk-add"))
	  (delete (gtk-button-new-from-stock "gtk-delete"))
	  (edit (gtk-button-new-from-stock "gtk-edit"))
	  (outer-box (gtk-hbox-new nil box-spacing))
	  (button-box (gtk-vbox-new nil box-spacing))
	  (other-box (gtk-vbox-new nil box-spacing))
	  (value '())
	  (selection nil))

      (define (top-level) (gtk-widget-get-toplevel outer-box))

      (define (set-selection row)
	(setq selection row)
	(gtk-widget-set-sensitive delete selection)
	(gtk-widget-set-sensitive edit selection))

      (define (print-value x)
	(if (functionp spec)
	    ((spec 'print) x)
	  (list (format nil "%s" x))))

      (define (add-item)
	(let ((callback
               (lambda (new)
                 (with-clist-frozen clist
                                    (if (not selection)
                                        (progn
                                          (setq value (append value (list new)))
                                          (gtk-clist-append clist
                                                            (print-value new)))
                                      (setq value (copy-sequence value))
                                      (setq value (insert-after new value
                                                                selection))
                                      (gtk-clist-insert
                                       clist (1+ selection) (print-value new))
                                      (gtk-clist-select-row clist
                                                            (1+ selection) 0)))
                 (call-callback changed-callback))))
	  (if (functionp spec)
	      ((spec 'dialog) (_ "Add:") callback #:for (top-level))
	    (widget-dialog (_ "Add:") spec callback nil (top-level)))))

      (define (delete-item)
	(when selection
	  (let ((orig-sel selection))
	    (if (zerop selection)
		(setq value (cdr value))
	      (setq value (copy-sequence value))
	      (rplacd (nthcdr (1- selection) value)
		      (nthcdr (1+ selection) value)))
	    (with-clist-frozen clist
                               (gtk-clist-remove clist selection)
                               (if (> (gtk-clist-rows clist) orig-sel)
                                   (gtk-clist-select-row clist orig-sel 0)
                                 (set-selection nil)))
	    (call-callback changed-callback))))

      (define (edit-item)
	(when selection
	  (setq value (copy-sequence value))
	  (let* ((orig-sel selection)
		 (cell (nthcdr orig-sel value))
		 (callback
                  (lambda (new)
                    (rplaca cell new)
                    (with-clist-frozen clist
                                       (gtk-clist-remove clist orig-sel)
                                       (gtk-clist-insert
                                        clist orig-sel (print-value new))
                                       (gtk-clist-select-row clist orig-sel 0))
                    (call-callback changed-callback))))
	    (if (functionp spec)
		((spec 'dialog) (_ "Edit:") callback
		 #:value (car cell) #:for (top-level))
	      (widget-dialog (_ "Edit:") spec callback
			     (car cell) (top-level))))))

      (define (clear)
	(gtk-clist-clear clist)
	(setq value '()))

      (g-signal-connect add "clicked" add-item)
      (g-signal-connect delete "clicked" delete-item)
      (g-signal-connect edit "clicked" edit-item)
      (g-signal-connect clist "select_row"
                        (lambda (w row col)
                          (declare (unused w col))
                          (set-selection row)))
      (g-signal-connect clist "unselect_row"
                        (lambda (w row col)
                          (declare (unused w col))
                          (when (= row selection)
                            (set-selection nil))))
      (g-signal-connect clist "button_press_event"
                        (lambda (w ev)
                          (declare (unused w))
                          (when (eq (gdk-event-type ev) '2button-press)
                            (edit-item))
                          nil))
      (g-signal-connect clist "key_press_event"
                        (lambda (w ev)
                          (declare (unused w))
                          (when (string= (gdk-event-string ev) "\r")
                            (edit-item))
                          nil))

      (gtk-clist-set-shadow-type clist 'none)
      (gtk-clist-set-column-width clist 0 100)
      (gtk-clist-set-selection-mode clist 'browse)
      (gtk-scrolled-window-set-policy scroller 'automatic 'automatic)
      (gtk-scrolled-window-add-with-viewport scroller clist)
      ;; XXX fixme
      ;;(gtk-widget-set-usize scroller list-width list-height)
      (gtk-container-add outer-box scroller)
      (gtk-box-pack-end outer-box other-box)
      (gtk-box-pack-start other-box button-box)
      (gtk-box-pack-start button-box add)
      (gtk-box-pack-start button-box edit)
      (gtk-box-pack-start button-box delete)
      (gtk-widget-show-all outer-box)
      (set-selection nil)

      (lambda (op)
	(case op
	  ((gtk-widget) outer-box)
	  ((clear) (lambda ()
		     (clear)
		     (call-callback changed-callback)))
	  ((set) (lambda (x)
		   (clear)
		   (setq value x)
		   (mapc (lambda (cell)
			   (gtk-clist-append clist (print-value cell)))
			 value)
		   (call-callback changed-callback)))
	  ((ref) (lambda () value))
	  ((validp) (lambda (x)
		      (let ((validp (if (functionp spec)
					(spec 'validp)
				      ((make-widget spec) 'validp))))
			(catch 'out
			  (mapc (lambda (y)
				  (unless (validp y)
				    (throw 'out nil))) x))
			t)))))))

  (define-widget-type 'list make-list-item)

;;; utilities

  (define (insert-after x lst idx)
    (let ((cell (nthcdr idx lst)))
      (if cell
	  (rplacd cell (cons x (cdr cell)))
	(setq lst (nconc lst (list x))))
      lst))

  (defmacro with-clist-frozen (clist . body)
    `(progn
       (gtk-clist-freeze ,clist)
       (unwind-protect
	   (progn ,@body)
	 (gtk-clist-thaw ,clist)))))

;; window-history.jl -- store state across window instances

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This provides a much-asked-for feature -- being able to remember
;; window attributes without using the match-windows feature. It works
;; a bit like session management, but across window instances, not
;; session instances.

;; I'm still not convinced that this is a stunningly great idea, hence
;; it's not enabled by default, do (require 'window-history) to load it.

;; It matches against WM_CLASS, and remembers window properties after
;; they're manually altered. E.g. move a window, then other windows of
;; that class/instance pair will subsequently appear at that position.
;; Similarly for window sizes and attributes (e.g. frame style/type)

(define-structure sawfish.wm.ext.window-history

    (export window-history-save-position
	    window-history-save-dimensions
	    window-history-save-attributes
	    window-history-forget
	    window-history-load
	    window-history-save
	    window-history-clear)

    (open rep
	  rep.system
	  rep.io.files
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.windows
	  sawfish.wm.viewport
	  sawfish.wm.workspace
	  rep.data.tables
	  sawfish.wm.menus
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify
	  sawfish.wm.ext.match-window)

  (define-structure-alias window-history sawfish.wm.ext.window-history)

;;; Configuration / variables

  (defvar window-history-file "~/.sawfish/window-history"
    "Name of the file used to store persistent window state.")

  ;; a hash table mapping encoded WM_CLASS text property to state alist
  (define window-history-state nil)

  ;; non-nil when window-history-state contains unsaved changes
  (define window-history-dirty nil)

  ;; list of states in window-state-change-hook that should be tracked
  (defvar window-history-states '(sticky ignored never-focus type maximized
                                         frame-style cycle-skip tab-group
                                         window-list-skip title-position))

  ;; property matched on
  (defvar window-history-key-property '(WM_CLASS WM_WINDOW_ROLE))

  (defvar window-history-menu
    `((,(_ "Remember _position") window-history-save-position)
      (,(_ "Remember _dimensions") window-history-save-dimensions)
      (,(_ "Remember _attributes") window-history-save-attributes)
      (,(_ "_Forget saved state") window-history-forget)
      ()
      (,(_ "_Clear window-history") window-history-clear)
      (,(_ "_Save window-history") window-history-save)
      (,(_ "_Reload window-history") window-history-load)))

;;; customizations

  (defgroup window-history "History" :group match-window)

  (defcustom window-history-auto-save-position t
    "Automatically remember window positions."
    :group (match-window window-history)
    :type boolean
    :require sawfish.wm.ext.window-history)

  (defcustom window-history-auto-save-dimensions nil
    "Automatically remember window sizes."
    :group (match-window window-history)
    :type boolean
    :require sawfish.wm.ext.window-history)

  (defcustom window-history-auto-save-state nil
    "Automatically remember other window attributes."
    :group (match-window window-history)
    :type boolean
    :require sawfish.wm.ext.window-history)

  (defcustom window-history-ignore-transients t
    "Don't automatically remember details of transient windows."
    :group (match-window window-history)
    :type boolean)

;;; matching windows

  (define (window-history-key w)

    ;; This function returns the key used to match windows, it can be any
    ;; lisp object with a read syntax (preferably one that hashes well),
    ;; if `(equal (window-history-key X) (window-history-key Y))' then
    ;; the two windows are assumed to be the `same' (whatever that means)

    ;; It has been suggested that WM_NAME should be factored in to this
    ;; somehow, but I want to avoid that, since windows I consider the
    ;; same often have different names (e.g. `Netscape: FOO' vs
    ;; `Netscape: BAR')

    ;; Instead I'm going to try just using this method for transient
    ;; windows, this should avoid the annoying cases where you save the
    ;; state of the app window, then a transient with the same class gets
    ;; given the same state..

    (define (get-prop p) (nth 2 (get-x-property w p)))

    (let ((props (append (if (listp window-history-key-property)
			     window-history-key-property
			   (list window-history-key-property))
			 (and (window-transient-p w)
			      (list 'WM_NAME)))))
      ;; This isn't the best method of creating keys, but it
      ;; preserves some backwards compatibility with old versions
      (mapconcat identity (delq nil (mapcar get-prop props)) "/")))

  (define (window-history-ref w)
    (let ((class (window-history-key w)))
      (when class
	(window-history-load)
	(table-ref window-history-state class))))

  (define (window-history-set w alist)
    (let ((class (window-history-key w)))
      (when class
	(window-history-load)
	(if alist
	    (table-set window-history-state class alist)
	  (table-unset window-history-state class))
	(setq window-history-dirty t))))

  (define (window-history-match w)
    (let ((alist (window-history-ref w)))
      (when alist
	(window-history-apply w alist))))

;;; recording attributes

  (define (window-history-snapshotter w state)
    (unless (or (window-get w 'no-history)
		(and window-history-ignore-transients (window-transient-p w)))
      (let* ((alist (window-history-ref w))
	     (value (if (get state 'window-history-snapshotter)
			((get state 'window-history-snapshotter) w)
		      (window-get w state)))
	     (cell (assq state alist)))
	(cond ((and value cell)
	       (rplacd cell value))
	      (value
	       (setq alist (cons (cons state value) alist)))
	      (cell
	       (setq alist (delq cell alist))))
	(window-history-set w alist))))

  (put 'position 'window-history-snapshotter window-absolute-position)
  (put 'dimensions 'window-history-snapshotter window-dimensions)

  (put 'maximized 'window-history-snapshotter
       (lambda (w)
	 (if (window-maximized-horizontally-p w)
	     (if (window-maximized-vertically-p w)
		 'both
	       'horizontal)
	   (if (window-maximized-vertically-p w)
	       'vertical
	     nil))))

  (put 'sticky 'window-history-snapshotter
       (lambda (w)
	 (if (window-sticky-p/viewport w)
	     (if (window-sticky-p/workspace w)
		 t
	       'viewport)
	   (if (window-sticky-p/workspace w)
	       'workspace
	     nil))))

  (define (window-history-position-snapshotter w)
    (when (and window-history-auto-save-position
	       (not (window-get w 'client-set-position)))
      (window-history-snapshotter w 'position)))

  (define (window-history-dimensions-snapshotter w)
    (when (and window-history-auto-save-dimensions
	       (not (window-get w 'client-set-position)))
      (window-history-snapshotter w 'dimensions)))

  (define (window-history-state-snapshotter w states)
    (when (and window-history-auto-save-state states)
      (when (memq (car states) window-history-states)
	(window-history-snapshotter w (car states)))
      (window-history-state-snapshotter w (cdr states))))

;;; manual state recording

  (defun window-history-save-position (w)
    "Remember the current position of the focused window."
    (window-history-snapshotter w 'position))

  (defun window-history-save-dimensions (w)
    "Remember the current dimensions of the focused window."
    (window-history-snapshotter w 'dimensions))

  (defun window-history-save-attributes (w)
    "Remember the current attributes of the focused window."
    (mapc (lambda (state)
	    (window-history-snapshotter w state))
	  window-history-states))

  (defun window-history-forget (w)
    "Forget any persistent state associated with the current window."
    (window-history-set w nil))

  (define-command 'window-history-save-position
    window-history-save-position #:spec "%W")
  (define-command 'window-history-save-dimensions
    window-history-save-dimensions #:spec "%W")
  (define-command 'window-history-save-attributes
    window-history-save-attributes #:spec "%W")
  (define-command 'window-history-forget
    window-history-forget #:spec "%W")

;;; restoring attributes

  (define (window-history-apply w alist)
    ;; handle the `position' attribute specially
    (let ((position (cdr (assq 'position alist))))
      (when position
	;; we don't want to place two windows of the same class
	;; at the same position, that's just pointless
	(when (or (window-get w 'placed)
		  (catch 'out
		    (let ((key (window-history-key w))
			  (space (or (cdr (assq 'workspace alist))
				     current-workspace)))
		      (when key
			(map-windows
			 (lambda (x)
			   (when (and (equal (window-history-key x) key)
				      (window-appears-in-workspace-p x space)
				      (equal position
					     (window-absolute-position x)))
			     ;; here's our match..
			     (throw 'out t))))))))
	  (setq alist (filter (lambda (cell)
				(not (eq (car cell) 'position)))
			      alist)))))

    ;; also do `dimensions'
    (let ((dims (cdr (assq 'dimensions alist))))
      (when (and dims (not (cdr (assq 'user-size (window-size-hints w)))))
	(resize-window-with-hints* w (car dims) (cdr dims))))

    ;; then the rest (borrowed from sm-load.jl)
    (mapc (lambda (sym)
	    (let ((tem (cdr (assq sym alist))))
	      (when tem
		(let ((setter (get sym 'window-history-setter)))
		  (if setter
		      (setter w tem)
		    (window-put w sym tem))))))
	  window-history-states)
    (call-window-hook 'sm-restore-window-hook w (list alist)))

  (put 'maximized 'window-history-setter
       (lambda (w value)
	 (when (memq value '(both vertical))
	   (window-put w 'queued-vertical-maximize t))
	 (when (memq value '(both horizontal))
	   (window-put w 'queued-horizontal-maximize t))))

  (put 'sticky 'window-history-setter
       (lambda (w value)
	 (when (memq value '(t both vertical))
	   (window-put w 'sticky-viewport t))
	 (when (memq value '(t both workspace))
	   (window-put w 'sticky t))))

;;; saving and loading state

  (define (window-history-load)
    (unless window-history-state
      (setq window-history-state (make-table equal-hash equal))
      (setq window-history-dirty nil)
      (when (file-exists-p window-history-file)
	(let
	    ((file (open-file window-history-file 'read)))
	  (when file
	    (unwind-protect
		(condition-case nil
		    (while t
		      (let ((cell (read file)))
			(table-set window-history-state
				   (car cell) (cdr cell))))
		  (end-of-stream))
	      (close-file file)))))))

  (define (window-history-save)
    (when window-history-dirty
      (unless (file-exists-p (file-name-directory window-history-file))
	(make-directory-recursively (file-name-directory window-history-file)))
      (let
	  ((file (open-file window-history-file 'write)))
	(when file
	  (unwind-protect
	      (progn
		(format file (concat ";; history saved for %s@%s\n"
				     ";; sawfish version %s; %s\n\n")
			(user-login-name) (system-name)
			sawfish-version (current-time-string))
		(table-walk (lambda (key value)
			      (print-alist file (cons key value)))
			    window-history-state)
		(setq window-history-dirty nil))
	    (close-file file))))))

  (define (window-history-clear)
    "Forget all saved window history."
    (setq window-history-state (make-table equal-hash equal))
    (setq window-history-dirty t))

  (define-command 'window-history-clear window-history-clear)

  (define (print-alist stream alist)
    (if (null alist)
	(write stream "()\n")
      (let (not-first)
	(mapc (lambda (x)
		(format stream "%s%S" (if not-first "\n " "\(") x)
		(setq not-first t))
	      alist)
	(write stream "\)\n\n"))))

;;; init

  (let ((tem (get-command-line-option "--window-history-file" t)))
    (when tem
      (setq window-history-file tem)))

  (add-hook 'before-add-window-hook window-history-match t)
  (add-hook 'after-move-hook window-history-position-snapshotter)
  (add-hook 'after-resize-hook window-history-dimensions-snapshotter)
  (add-hook 'window-state-change-hook window-history-state-snapshotter)
  (add-hook 'before-exit-hook window-history-save)

  (setq window-ops-menu
	(nconc window-ops-menu
	       (list `(,(_ "_History") . window-history-menu))))

  (define-match-window-property 'no-history 'other 'boolean))

;; custom.jl -- Emacs-like ``customizing'' (but more simple)

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.custom

    (export custom-groups
	    custom-option-alist
	    custom-group-option-alist
	    defcustom
	    defgroup
	    custom-declare-variable
	    custom-declare-group
	    custom-quote-keys
	    define-custom-setter
	    custom-set-property
	    custom-get-property
	    custom-set-group-property
	    custom-get-group-property
	    custom-add-option
	    custom-get-options
	    custom-find-group
	    custom-set
	    custom-set-variable
	    custom-set-typed-variable
	    variable-customized-p
	    variable-type
	    variable-default-value
	    variable-declared-p
	    make-custom-form
	    custom-eval
	    custom-serialize
	    custom-deserialize
	    define-custom-serializer
	    define-custom-deserializer
	    custom-load-user-file)

    (open rep
	  rep.io.files
	  rep.data.tables
	  rep.structures
	  rep.system
	  #|
	     Don't add more sawfish.wm.* here unless you know what
	     you're doing. Instead, embed 'require' in
	     definition. It's because this file is read from
	     windows.jl. See windows.jl for more.
	  |#
	  sawfish.wm.commands
	  sawfish.wm.gaol
	  sawfish.wm.colors
	  sawfish.wm.fonts
	  sawfish.wm.misc)

  (define-structure-alias custom sawfish.wm.custom)

  ;; list associating groups with the list of variables in that group
  (define custom-groups (list 'root "Sawfish"))

  (defvar custom-user-file "~/.sawfish/custom"
    "File used to store user's configuration settings.")

  (defvar custom-default-file (expand-file-name "sawfish/wm/custom-defaults.jl"
						sawfish-lisp-lib-directory)
    "Lisp library storing default customization settings.")

  (define custom-quoted-keys
    '(:group :require :type :options :range :depends
             :layout :widget-flags)
    "defcustom keys whose values are quoted by the macro expansion.")

  (define custom-option-alist '((:group . custom-group)
				(:require . custom-require)
				(:type . custom-type)
				(:type* . custom-type)
				(:options . custom-options)
				(:depends . custom-depends)
				(:set . custom-set)
				(:get . custom-get)
				(:widget . custom-widget)
				(:after-set . custom-after-set)
				(:before-set . custom-before-set)
				(:range . custom-range)
				(:widget-flags . custom-widget-flags)))

  (define custom-group-option-alist '((:layout . custom-group-layout)
				      (:require . custom-group-require)))

  ;; hash group names (lists of symbols) to alist of options
  (define custom-group-table (make-table equal-hash equal))

;;; defining custom variables and groups

  (defmacro defcustom (symbol value doc #!rest keys)
    "Define a new customization variable SYMBOL which initially has value
VALUE (unless SYMBOL is already bound, in which case its value is not
altered), and documentations string DOC.

KEYS is a property-list containing any of the following:

	:group GROUP
	:require FEATURE
	:type TYPE
	:options OPTIONS
	:depends SYMBOL
	:range (MIN . MAX)		for `number' type
	:set FUNCTION
	:get FUNCTION
	:before-set FUNCTION
	:after-set FUNCTION
	:widget FUNCTION

TYPE may be `boolean', `number', `string', `symbol', `file-name',
`program-name', `font', `color'.

Note that the values of the `:group', `:require', `:type', `:options',
`:depends' and `:range' keys are not evaluated. All other key values are
evaluated.

Each defcustom'd symbol may have several special properties

	custom-set (FUNCTION SYMBOL VALUE)
	custom-get (FUNCTION SYMBOL)
	custom-widget (FUNCTION SYMBOL)

These functions are used while constructing and responding to the
customisation dialog. If not set in the symbol itself they may be
inherited from the plist of the type of the variable.

custom-set and custom-get may be used to translate data types to the
string representation required by some widget types. custom-widget may
construct the widget definition passed to the ui backend."

    (let* ((cell (memq ':tooltip keys))
	   (tooltip (cadr cell))
	   (tem (gensym)))
      (when cell
	(setq keys (delq (car cell) (delq (cadr cell) keys))))
      `(let ((,tem ,value))
	 (defvar ,symbol ,tem ,(if tooltip (concat doc "\n\n" tooltip) doc))
	 (custom-declare-variable ',symbol ,(custom-quote-keys keys) ,tem))))

  (defmacro defgroup (symbol doc #!rest keys)
    "Declare a new custom group called SYMBOL, with English name DOC. The
property list KEYS may contain the following key-value items:

	:group PARENT-GROUP
	:layout LAYOUT-TYPE

Note that the value of the `:group' key is not evaluated."

    `(custom-declare-group ',symbol ,doc ,(custom-quote-keys keys)))

  (define (custom-declare-variable symbol keys #!optional default-value)
    (let (type prop)
      (while keys
	(setq prop (cdr (assq (car keys) custom-option-alist)))
	(setq keys (cdr keys))
	(when prop
	  (put symbol prop (car keys)))
	(setq keys (cdr keys)))
      (custom-add-to-group symbol (get symbol 'custom-group))
      (setq type (get symbol 'custom-type))
      (when (eq (car type) 'set)
	;; backwards compatibility
	(put symbol 'custom-options (cdr type))
	(setq type 'symbol)
	(put symbol 'custom-type type))
      (when (and type (symbolp type))
	(when (and (not (get symbol 'custom-get)) (get type 'custom-get))
	  (put symbol 'custom-get (get type 'custom-get)))
	(when (and (not (get symbol 'custom-set)) (get type 'custom-set))
	  (put symbol 'custom-set (get type 'custom-set)))
	(when (and (not (get symbol 'custom-widget)) (get type 'custom-widget))
	  (put symbol 'custom-widget (get type 'custom-widget))))
      (put symbol 'custom-default-value default-value)
      symbol))

  (define (custom-declare-group group #!optional doc keys)
    (let (container)
      (while keys
	(case (car keys)
	  ((:group)
	   (setq container (nth 1 keys))
	   (unless (listp container)
	     (setq container (list container))))
	  ((:require)
	   (custom-group-requires (append container (list group)) (cadr keys)))
	  (t
	   (custom-set-group-property (append container (list group))
				      (car keys) (cadr keys))))
	(setq keys (cddr keys)))
      (custom-add-to-group (list group doc) container)
      (unless container
	;; declare a command to customize this group
	(define-command (intern (concat "customize:" (symbol-name group)))
          (lambda ()
            (require 'sawfish.wm.customize)
            (customize group))
	  #:doc (format nil
			"Invoke configurator to customize group %s."
			group
			)))))

  (define (custom-quote-keys keys)
    (let ((out '()))
      (while (and keys (cdr keys))
	(if (memq (car keys) custom-quoted-keys)
	    (setq out (cons (list 'quote (nth 1 keys))
			    (cons (list 'quote (car keys)) out)))
	  (setq out (cons (nth 1 keys) (cons (list 'quote (car keys)) out))))
	(setq keys (nthcdr 2 keys)))
      (cons 'list (nreverse out))))

;;; general management

  (define custom-setter-table (make-table symbol-hash eq))

  (define (define-custom-setter name def)
    (table-set custom-setter-table name def))

  (define (custom-setter name)
    (or (table-ref custom-setter-table name)
	(error "No such custom setter: %s" name)))

  (define (custom-set-property sym prop value)
    "Set the custom key PROP for defcustom'd symbol SYM to value."
    (let ((key (cdr (assq prop custom-option-alist))))
      (when key
	(put sym key value))))

  (define (custom-get-property sym prop)
    (let ((key (cdr (assq prop custom-option-alist))))
      (and key (get sym key))))

  (define (custom-set-group-property group prop value)
    "Set the custom key PROP for defgroup'd symbol SYM to value."
    (unless (listp group)
      (setq group (list group)))
    (let* ((alist (table-ref custom-group-table group))
	   (cell (and alist (assq prop alist))))
      (if cell
	  (rplacd cell value)
	(setq alist (cons (cons prop value) alist))
	(table-set custom-group-table group alist))))

  (define (custom-get-group-property group prop)
    (unless (listp group)
      (setq group (list group)))
    (let ((alist (table-ref custom-group-table group)))
      (cdr (assq prop alist))))

  (define (custom-group-requires group feature)
    (unless (listp group)
      (setq group (list group)))
    (custom-set-group-property
     group ':require
     (cons feature (delq feature
			 (custom-get-group-property ':require group)))))

  (defmacro custom-add-option (sym option)
    "Assuming that defcustom'd symbol SYM is of type `symbol', add the
symbol OPTION to the list of choices."
    `(put ,sym 'custom-options
	  (nconc (get ,sym 'custom-options) (list ,option))))

  (defmacro custom-get-options (sym)
    "Assuming that defcustom'd symbol SYM is of type `symbol', return the
of choices."
    `(get ,sym 'custom-options))

  (define (custom-find-group full-group)
    (when (and (symbolp full-group) (not (null full-group)))
      (setq full-group (list full-group)))
    (let loop ((group full-group)
	       (parent custom-groups))
      (if (null group)
	  parent
	(loop (cdr group)
	      (or (assq (car group) (cddr parent))
		  (error "No such group: %S" full-group))))))

  (define (custom-add-to-group cell full-group)
    (when (and (symbolp full-group) (not (null full-group)))
      (setq full-group (list full-group)))
    (let loop ((group full-group)
	       (parent custom-groups))
      (if (null group)
	  (unless (or (memq cell (cddr parent))
		      (assq (car cell) (cddr parent)))
	    ;; reached the bottom most group
	    (rplacd (cdr parent) (nconc (cddr parent) (list cell))))
	;; keep on recursing
	(loop (cdr group)
	      (or (assq (car group) (cddr parent))
		  (error
		   "Unknown customization group: %s.\nIf not typo, its defgroup is not called yet." full-group)))
	(unless (cdr group)
	  (rplacd (cdr custom-groups)
		  (nconc (sort (filter consp (cddr custom-groups))
			       (lambda (x y)
				 (string-lessp (cadr x) (cadr y))))
			 (filter atom (cddr custom-groups))))))))

;;; setting values

  (define (custom-set setter symbol)
    (when (get symbol 'custom-before-set)
      ((get symbol 'custom-before-set) symbol))
    (make-variable-special symbol)
    (setter)
    (put symbol 'custom-user-value t)
    (when (get symbol 'custom-after-set)
      ((get symbol 'custom-after-set) symbol)))

  (define (custom-set-symbol setter symbol)
    (unless (get symbol 'custom-obsolete)
      (let* ((was-bound (boundp symbol))
	     (old-value (and was-bound (symbol-value symbol))))
	(call-with-exception-handler
	 (lambda ()
	   (custom-set setter symbol))
	 (lambda (ex)
	   ;; error while setting SYMBOL; revert to its old state
	   (if was-bound
	       (set symbol old-value)
	     (makunbound symbol))
	   (raise-exception ex))))))

  (define (custom-set-variable symbol value #!optional req)
    ;; XXX kludge for old custom files..
    (when (eq value 'nil) (setq value nil))
    (when (and req value)
      ;; load in the user module in case it's a file of bare code
      (user-require req))
    (custom-set-symbol (lambda ()
			 (make-variable-special symbol)
			 (set symbol value)) symbol))

  (define (custom-set-typed-variable symbol value type #!optional req)
    ;; XXX kludge for old custom files..
    (when (eq value 'nil) (setq value nil))
    (when (and req value)
      (user-require req))
    (custom-set-symbol (lambda ()
			 (make-variable-special symbol)
			 (set symbol (custom-deserialize value type)))
		       symbol))

  (define (variable-customized-p symbol)
    "Returns `t' if the variable named SYMBOL has been customized by
the user."
    (get symbol 'custom-user-value))

  (define (variable-type symbol)
    "Returns the customizable type of the variable named SYMBOL."
    (get symbol 'custom-type))

  (define (variable-default-value symbol)
    "Returns the default value of SYMBOL."
    (get symbol 'custom-default-value))

  ;; if the custom variable has been declared, then it will always
  ;; have a default-value property
  (define (variable-declared-p symbol)
    (memq 'custom-default-value (symbol-plist symbol)))

  (define (make-custom-form symbol value)
    (let ((fun (or (get symbol 'custom-set) 'custom-set-typed-variable))
	  (custom-value (custom-serialize value (variable-type symbol))))
      `(,fun ',symbol ',custom-value
             ,@(and (eq fun 'custom-set-typed-variable)
                    (list (list 'quote (variable-type symbol))))
             ,@(and (get symbol 'custom-require)
                    (list (list 'quote (get symbol 'custom-require)))))))

  (define (custom-eval form)
    (apply (custom-setter (car form))
	   (mapcar (lambda (x)
		     (if (eq (car x) 'quote)
			 (cadr x)
		       ;; XXX alternatives to user-eval
		       (user-eval x))) (cdr form))))

;;; serializing unreadable types

  ;; property name (symbol) to find type converters on during
  ;; custom-convert
  (define custom-converter-property (make-fluid))

  ;; convert VALUE of TYPE to or from a printable object
  (define (custom-convert value type)
    (case (or (car type) type)
      ((optional)
       (custom-convert value (cadr type)))

      ((labelled)
       (custom-convert value (caddr type)))

      ((quoted)
       `(quote ,(custom-convert (cadr value) (cadr type))))

      ((pair)
       (cons (custom-convert (car value) (cadr type))
	     (custom-convert (cdr value) (caddr type))))

      ((list)
       (mapcar (lambda (x) (custom-convert x (cadr type))) value))

      ((alist)
       (let ((k-type (or (car (cadr type)) (cadr type)))
	     (v-type (or (car (caddr type)) (caddr type))))
	 (mapcar (lambda (x)
		   (cons (custom-convert (car x) k-type)
			 (custom-convert (cdr x) v-type))) value)))

      ((and v-and h-and)
       (do ((values value (cdr values))
	    (types (cdr type) (cdr types))
	    (out '() (cons (custom-convert (car values) (car types)) out)))
	   ((or (null types) (null values))
	    (nreverse out))))

      ;; XXX handle `or' (needs type predicates)

      (t (let ((converter (get (or (car type) type)
			       (fluid custom-converter-property))))
	   (if converter
	       (converter value type)
	     value)))))

  (define (custom-serialize value type)
    "Convert VALUE of TYPE to a printable value."
    (let-fluids ((custom-converter-property 'custom-serializer))
      (custom-convert value type)))

  (define (custom-deserialize value type)
    "Convert VALUE of TYPE back from a printable value."
    (let-fluids ((custom-converter-property 'custom-deserializer))
      (custom-convert value type)))

  (define (define-custom-serializer type fun)
    (put type 'custom-serializer fun))

  (define (define-custom-deserializer type fun)
    (put type 'custom-deserializer fun))

;;; support for font and color primitive types

  (define-custom-serializer 'font (lambda (value)
				    (if (fontp value)
					(cons (font-type value)
					      (font-name value))
				      value)))

  (define-custom-deserializer 'font (lambda (value)
				      (cond ((stringp value)
					     (get-font value))
					    ((consp value)
					     (get-font-typed
					      (car value) (cdr value)))
					    (t value))))

  (define-custom-serializer 'color (lambda (value)
				     (if (colorp value)
					 (color-name value)
				       value)))

  (define-custom-deserializer 'color (lambda (value)
				       (if (stringp value)
					   (get-color value)
					 value)))

;;; default groups

  ;; If you suffer from Sawfish init failure in defcustom / defgroup
  ;; which is the result of additional "open", then push the defcustom
  ;; of the parent group here.
  (defgroup appearance "Appearance")
  (defgroup bindings "Bindings")
  (defgroup focus "Focus")
  (defgroup min-max "Mini/Maximizing")
  (defgroup misc "Miscellaneous")
  (defgroup move "Move/Resize" :require sawfish.wm.commands.move-resize)
  (defgroup placement "Placement" :group misc)
  (defgroup stacking "Stacking" :group misc)
  (defgroup workspace "Workspaces")
  (defgroup edge-actions "Edge Actions")

;;; loading user's customisations

  (define (custom-load filename)
    (let ((file (open-file filename 'read)))
      (unwind-protect
	  (condition-case nil
	      (while t
		(let ((form (read file)))
		  (call-with-error-handler
		   (lambda () (custom-eval form)))))
	    (end-of-stream))
	(close-file file))))

  (define (custom-load-user-file)
    "Load the user's customization file, or the custom-default-file."
    (cond ((file-exists-p custom-user-file)
	   (custom-load custom-user-file))
	  (custom-default-file
	   (custom-load custom-default-file))))

  (defcustom introduction nil
    " "
    :type (label "\tSawfish Configuration utility.\n
\nSawfishConfig allows you to adjust vartious aspects of sawfish easily. \
Choose a group from the tree on the left and adjust Sawfish to your liking.
\nSometimes loading additional scripts will enable new options \(check for \
defcustoms in the script\). Additional information about Sawfish can be found at:")
    :group ())

  (defcustom introduction-link nil
    " "
    :type (link "http://sawfish.wikia.com" "http://sawfish.wikia.com" nil)
    :group ())

  (defcustom introduction-edit nil
    " "
    :type (v-and (label "\nSawfish additionally supports a user resource file \
in which you can add custom function, load additional scripts on startup \
and much more.") (xdg "~/.sawfishrc" "=> open (or create) resource file"))
    :group ())

  (defcustom introduction-info nil
    " "
    :type (v-and (label "\nSawfish features an info file, containing lots of \
useful information about Sawfish itself and how to use it.")
(shell "info sawfish Top" "=> view info file"))
    :group ())

;;; init

  (let ((tem (get-command-line-option "--custom-file" t)))
    (when tem
      (setq custom-user-file tem)))

  (define-custom-setter 'custom-set-variable custom-set-variable)
  (define-custom-setter 'custom-set-typed-variable custom-set-typed-variable)

  (gaol-add defcustom defgroup custom-declare-variable custom-declare-group
	    custom-quote-keys custom-set-property custom-set-group-property
	    custom-option-alist custom-group-option-alist))

#| nokogiri-widgets/event.jl

   $Id: event.jl,v 1.3 2000/09/25 19:15:35 john Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure sawfish.ui.widgets.event ()

    (open rep
	  gui.gtk
	  sawfish.gtk.widget
	  sawfish.ui.wm)

  (define (make-event-item changed)

    (let ((entry (gtk-entry-new))
	  (grab (gtk-button-new-with-label (_ "Grab...")))
	  (hbox (gtk-hbox-new nil box-spacing)))

      (gtk-container-add hbox entry)
      (gtk-box-pack-end hbox grab)
      (gtk-widget-show-all hbox)

      (gtk-signal-connect entry "changed" (make-signal-callback changed))
      (gtk-signal-connect grab "clicked"
			  (lambda ()
			    (gtk-entry-set-text entry (wm-grab-key))))

      (lambda (op)
	(case op
	  ((gtk-widget) hbox)
	  ((clear) (lambda ()
		     (gtk-entry-set-text entry "")))
	  ((set) (lambda (x)
		   (gtk-entry-set-text entry x)))
	  ((ref) (lambda ()
		   (gtk-entry-get-text entry)))
	  ((validp) stringp)))))

  (define-widget-type 'event make-event-item))

;; rects.jl -- rectangle manipulation

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.rects

    (export rect-left rect-top rect-right rect-bottom
            rect-obscured rect-minus
            rectangles-from-grid
	    rectangles-from-windows
	    grid-from-rectangles
	    rectangle-area
	    rectangle-from-coords
	    rectangle-corners
	    rectangle-center
	    rectangle-center*
	    rectangle-union
	    rectangle-intersection
	    rect-1d-overlap
	    rect-2d-overlap
	    rect-2d-overlap*
	    rect-total-overlap
            rect-wholly-within-rect
	    rect-wholly-visible-p
	    rectangle-heads)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.misc)

  (define-structure-alias rects sawfish.wm.util.rects)

  ;; Commentary:

  ;; A rectangle is (LEFT TOP RIGHT BOTTOM [WEIGHT])
  ;; The left and top edges are considered part of the rectangle,
  ;; the right and bottom edges are not.


;;; rectangles

  (define rect-left car)
  (define rect-top cadr)
  (define rect-right caddr)
  (define rect-bottom cadddr)

  (define (rect-obscured r by)
    "Check whether rectangle R is wholly or partially contained in
rectangle BY.  Return `unobscured', `partially-obscured' or `fully-obscured'."
    (cond ((or (<= (rect-right by) (rect-left r))
               (<= (rect-right r) (rect-left by))
               (<= (rect-bottom by) (rect-top r))
               (<= (rect-bottom r) (rect-top by)))
           'unobscured)
          ((and (<= (rect-left by) (rect-left r))
                (<= (rect-right r) (rect-right by))
                (<= (rect-top by) (rect-top r))
                (<= (rect-bottom r) (rect-bottom by)))
           'fully-obscured)
          (t 'partially-obscured)))

  (define (rect-minus r s #!optional tail)
    "Return a list of disjoint rectangles whose union is the part of
rectangle R not contained in rectangle S.  If TAIL is given, the
result is prepended to it."
    (let rminus ((r r) (result tail))
         (cond
          ;; Check for complete disjointness.
          ((or (<= (rect-right s) (rect-left r))
               (<= (rect-right r) (rect-left s))
               (<= (rect-bottom s) (rect-top r))
               (<= (rect-bottom r) (rect-top s)))
           (cons r result))
          ;; Extract a free slice from the bottom of r.
          ((< (rect-bottom s) (rect-bottom r))
           (rminus (list (rect-left r) (rect-top r)
                         (rect-right r) (rect-bottom s))
                   (cons (list (rect-left r) (rect-bottom s)
                               (rect-right r) (rect-bottom r))
                         result)))
          ;; Extract a free slice from the right side of r.
          ((< (rect-right s) (rect-right r))
           (rminus (list (rect-left r) (rect-top r)
                         (rect-right s) (rect-bottom r))
                   (cons (list (rect-right s) (rect-top r)
                               (rect-right r) (rect-bottom r))
                         result)))
          ;; Extract a free slice from the top of r.
          ((> (rect-top s) (rect-top r))
           (rminus (list (rect-left r) (rect-top s)
                         (rect-right r) (rect-bottom r))
                   (cons (list (rect-left r) (rect-top r)
                               (rect-right r) (rect-top s))
                         result)))
          ;; Extract a free slice from the left side of r.
          ((> (rect-left s) (rect-left r))
           (rminus (list (rect-left s) (rect-top r)
                         (rect-right r) (rect-bottom r))
                   (cons (list (rect-left r) (rect-top r)
                               (rect-left s) (rect-bottom r))
                         result)))
          ;; Completely covered.
          (t result))))

  (define (rectangles-from-grid x-points y-points #!optional pred)
    "The two lists of integers X-POINTS and Y-POINTS define a rectangular
grid. Return the complete list of rectangles formed by the
intersections of the grid.

If PRED is defined, it is called for each rectangle, and only those for
which it returns t are added to the returned list.

Each rectangle is represented by a list `(LEFT TOP RIGHT BOTTOM)'.

Assumes that X-POINTS and Y-POINTS are both sorted smallest->largest."

    (let (rects left-x right-x top-y bottom-y tem-y-points tem-x tem-y rect)
      (while x-points
	(setq left-x (car x-points))
	(setq x-points (cdr x-points))
	(setq tem-y-points y-points)
	(while tem-y-points
	  (setq top-y (car tem-y-points))
	  (setq tem-y-points (cdr tem-y-points))
	  (setq tem-x x-points)
	  (while tem-x
	    (setq right-x (car tem-x))
	    (setq tem-x (cdr tem-x))
	    (setq tem-y tem-y-points)
	    (while tem-y
	      (setq bottom-y (car tem-y))
	      (setq tem-y (cdr tem-y))
	      (setq rect (list left-x top-y right-x bottom-y))
	      (when (or (not pred) (pred rect))
		(setq rects (cons rect rects)))))))
      (nreverse rects)))

  (define (rectangles-from-windows windows #!optional weight-fun)
    "Returns a list of (LEFT TOP RIGHT BOTTOM [OVERLAP-WEIGHT])
representing the rectangles represented by the list of window objects
WINDOWS.

If WEIGHT-FUN is defined, it is a function to call on each window to
return the weight for that window. If not defined, the window's
`weight' property is used instead."

    (mapcar (lambda (w)
	      (let ((dims (window-frame-dimensions w))
		    (pos (window-position w))
		    tem)
		(list* (car pos) (cdr pos)
		       (+ (car pos) (car dims))
		       (+ (cdr pos) (cdr dims))
		       (and (setq tem (if weight-fun
					  (weight-fun w)
					(window-get w 'weight)))
			    (list tem)))))
	    windows))

  (define (grid-from-rectangles rects #!optional with-root)
    "Given a list of rectangles RECTS (each rectangle represented by a
list of at least four elemements, `(LEFT TOP RIGHT BOTTOM)'), return
a cons cell `(X-POINTS . Y-POINTS)' defining the grid they represent.

If WITH-ROOT is non-nil, then add the root window boundaries to the
grid."

    (let ((x-edges (nconc (mapcar car rects)
                          (mapcar (lambda (x) (nth 2 x)) rects)))
          (y-edges (nconc (mapcar (lambda (x) (nth 1 x)) rects)
                          (mapcar (lambda (x) (nth 3 x)) rects))))
      (when with-root
        (setq x-edges (cons 0 (nconc x-edges (list (screen-width)))))
        (setq y-edges (cons 0 (nconc y-edges (list (screen-height))))))
      (cons (uniquify-list x-edges) (uniquify-list y-edges))))

  (define (rectangle-area rect)
    "Given a rectangle RECT, return its area."
    (* (- (nth 2 rect) (nth 0 rect))
       (- (nth 3 rect) (nth 1 rect))))

  (define (rectangle-from-coords point dims)
    "Return a list representing the rectangle with origin POINT and dimensions
DIMS."
    (list (car point) (cdr point)
	  (+ (car point) (car dims)) (+ (cdr point) (cdr dims))))

  (define (rectangle-corners rect)
    "Return a list of four cons cells representing the coordinates of the
corners of the rectangle RECT."
    (list (cons (nth 0 rect) (nth 1 rect))
	  (cons (nth 0 rect) (nth 3 rect))
	  (cons (nth 2 rect) (nth 1 rect))
	  (cons (nth 2 rect) (nth 3 rect))))

  (define (rectangle-center rect)
    (cons (+ (nth 0 rect) (/ (- (nth 2 rect) (nth 0 rect)) 2))
	  (+ (nth 1 rect) (/ (- (nth 3 rect) (nth 1 rect)) 2))))

  (define (rectangle-center* point dims)
    (cons (+ (car point) (/ (car dims) 2))
	  (+ (cdr point) (/ (cdr dims) 2))))

  (define (rectangle-union rect1 rect2)
    (list (min (nth 0 rect1) (nth 0 rect2))
	  (min (nth 1 rect1) (nth 1 rect2))
	  (max (nth 2 rect1) (nth 2 rect2))
	  (max (nth 3 rect1) (nth 3 rect2))
	  (nth 4 rect1)))

  (define (rectangle-intersection rect1 rect2)
    (let ((rect (list (max (nth 0 rect1) (nth 0 rect2))
		      (max (nth 1 rect1) (nth 1 rect2))
		      (min (nth 2 rect1) (nth 2 rect2))
		      (min (nth 3 rect1) (nth 3 rect2))
		      (nth 4 rect1))))
      (if (or (>= (nth 0 rect) (nth 2 rect))
	      (>= (nth 1 rect) (nth 3 rect)))
	  ;; empty
	  nil
	rect)))

;;; overlap

  (define (rect-1d-overlap a-1 a-2 b-1 b-2)
    "Returns the overlap between two 1D line segments, A-1 to A-2, and
B-1 to B-2."
    (max 0 (- (min a-2 b-2) (max a-1 b-1))))

  (define (rect-2d-overlap dims point rect)
    "Returns the overlap between two rectangles, one defined as having
dimensions DIMS and origin POINT, while the other is defined by RECT."

    (* (rect-1d-overlap (car point) (+ (car point) (car dims))
			(car rect) (nth 2 rect))
       (rect-1d-overlap (cdr point) (+ (cdr point) (cdr dims))
			(nth 1 rect) (nth 3 rect))
       ;; include the weight of the rectangle if it has one
       (or (nth 4 rect) 1)))

  (define (rect-2d-overlap* rect1 rect2)
    "Returns the overlap between two rectangles, RECT1 and RECT2."
    (* (rect-1d-overlap (car rect1) (nth 2 rect1)
			(car rect2) (nth 2 rect2))
       (rect-1d-overlap (nth 1 rect1) (nth 3 rect1)
			(nth 1 rect2) (nth 3 rect2))
       ;; include the weight of the rectangle if it has one
       (or (nth 4 rect1) 1)
       (or (nth 4 rect2) 1)))

  (define (rect-total-overlap dims point rects)
    "Returns the total area of the overlap between a rectangle defined by
DIMS and POINT, and the list of rectangles RECTS when placed at POINT."
    (let ((total 0))
      (mapc (lambda (r)
	      (setq total (+ total (rect-2d-overlap dims point r))))
	    rects)
      total))

  (define (rect-wholly-within-rect outer inner)
    "Return t if INNER is completely inside the boundaries of OUTER."
    (eq (rect-obscured inner outer) 'fully-obscured))

  (define (rect-wholly-visible-p rect)
    "Return t if RECT is completely inside the screen boundaries."
    (rect-wholly-within-rect (list 0 0 (screen-width) (screen-height))
                             rect))

  (define (rectangle-heads rect)
    "Return the number of screen heads that rectangle RECT appears on."
    (let loop ((head 0)
	       (count 0))
      (if (= head (head-count))
	  count
	(loop (1+ head)
	      (if (> (rect-2d-overlap (head-dimensions head)
				      (head-offset head) rect) 0)
		  (1+ count)
		count))))))

;; sawfish.wm.cursors bootstrap
;;
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(declare (in-module sawfish.wm.cursors))

(open-structures '(rep))

(put 'X_cursor 'cursor-shape 0)
(put 'arrow 'cursor-shape 2)
(put 'based_arrow_down 'cursor-shape 4)
(put 'based_arrow_up 'cursor-shape 6)
(put 'boat 'cursor-shape 8)
(put 'bogosity 'cursor-shape 10)
(put 'bottom_left_corner 'cursor-shape 12)
(put 'bottom_right_corner 'cursor-shape 14)
(put 'bottom_side 'cursor-shape 16)
(put 'bottom_tee 'cursor-shape 18)
(put 'box_spiral 'cursor-shape 20)
(put 'center_ptr 'cursor-shape 22)
(put 'circle 'cursor-shape 24)
(put 'clock 'cursor-shape 26)
(put 'coffee_mug 'cursor-shape 28)
(put 'cross 'cursor-shape 30)
(put 'cross_reverse 'cursor-shape 32)
(put 'crosshair 'cursor-shape 34)
(put 'diamond_cross 'cursor-shape 36)
(put 'dot 'cursor-shape 38)
(put 'dotbox 'cursor-shape 40)
(put 'double_arrow 'cursor-shape 42)
(put 'draft_large 'cursor-shape 44)
(put 'draft_small 'cursor-shape 46)
(put 'draped_box 'cursor-shape 48)
(put 'exchange 'cursor-shape 50)
(put 'fleur 'cursor-shape 52)
(put 'gobbler 'cursor-shape 54)
(put 'gumby 'cursor-shape 56)
(put 'hand1 'cursor-shape 58)
(put 'hand2 'cursor-shape 60)
(put 'heart 'cursor-shape 62)
(put 'icon 'cursor-shape 64)
(put 'iron_cross 'cursor-shape 66)
(put 'left_ptr 'cursor-shape 68)
(put 'left_side 'cursor-shape 70)
(put 'left_tee 'cursor-shape 72)
(put 'leftbutton 'cursor-shape 74)
(put 'll_angle 'cursor-shape 76)
(put 'lr_angle 'cursor-shape 78)
(put 'man 'cursor-shape 80)
(put 'middlebutton 'cursor-shape 82)
(put 'mouse 'cursor-shape 84)
(put 'pencil 'cursor-shape 86)
(put 'pirate 'cursor-shape 88)
(put 'plus 'cursor-shape 90)
(put 'question_arrow 'cursor-shape 92)
(put 'right_ptr 'cursor-shape 94)
(put 'right_side 'cursor-shape 96)
(put 'right_tee 'cursor-shape 98)
(put 'rightbutton 'cursor-shape 100)
(put 'rtl_logo 'cursor-shape 102)
(put 'sailboat 'cursor-shape 104)
(put 'sb_down_arrow 'cursor-shape 106)
(put 'sb_h_double_arrow 'cursor-shape 108)
(put 'sb_left_arrow 'cursor-shape 110)
(put 'sb_right_arrow 'cursor-shape 112)
(put 'sb_up_arrow 'cursor-shape 114)
(put 'sb_v_double_arrow 'cursor-shape 116)
(put 'shuttle 'cursor-shape 118)
(put 'sizing 'cursor-shape 120)
(put 'spider 'cursor-shape 122)
(put 'spraycan 'cursor-shape 124)
(put 'star 'cursor-shape 126)
(put 'target 'cursor-shape 128)
(put 'tcross 'cursor-shape 130)
(put 'top_left_arrow 'cursor-shape 132)
(put 'top_left_corner 'cursor-shape 134)
(put 'top_right_corner 'cursor-shape 136)
(put 'top_side 'cursor-shape 138)
(put 'top_tee 'cursor-shape 140)
(put 'trek 'cursor-shape 142)
(put 'ul_angle 'cursor-shape 144)
(put 'umbrella 'cursor-shape 146)
(put 'ur_angle 'cursor-shape 148)
(put 'watch 'cursor-shape 150)
(put 'xterm 'cursor-shape 152)

;; nokogiri-widgets/alist.jl -- alist widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widgets.alist

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget
          sawfish.gtk.widgets.simple-dialog)

  ;; (alist (KEY-SPEC "KEY-TITLE") (VALUE-SPEC "VALUE-TITLE"))

  (define (make-alist-item changed-callback key value)

    (let* ((spec `(pair ,(or (car key) key)
			,(or (car value) value)))
	   (title `(,(or (cadr key) (_ "Key"))
		    ,(or (cadr value) (_ "Value")))))

      (define (type op)
	(case op
	  ((print) (lambda (x) (list (format nil "%s" (car x))
				     (format nil "%s" (cdr x)))))
	  ((dialog) (lambda (title callback #!key value for)
		      (widget-dialog title spec callback value for)))
	  ((validp) ((make-widget spec) 'validp))))

      (make-widget `(list ,type ,title) changed-callback)))

  (define-widget-type 'alist make-alist-item))

;; edge/expand.jl -- window-expansion for EdgeActions

;; Copyright (C) 2011 Christopher Roy Bratusek <zanghar@freenet.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.edge.expand

    (export expand-window-half-screen-horizontal
            expand-window-half-screen-vertical
            expand-action)

    (open rep
	  rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.commands.move-resize
	  sawfish.wm.state.maximize
	  sawfish.wm.edge.util)

  (define-structure-alias edge-expand sawfish.wm.edge.expand)

  (define (expand-window-half-screen-vertical side #!optional w)
    (unless w
      (setq w (input-focus)))
    (if (eq side 'left)
        (move-window-to-corner w 'top-left)
      (move-window-to-corner w 'top-right))
    (resize-window-frame-to w (/ (screen-width) 2) (window-height w))
    (maximize-fill-window-vertically w))

  (define (expand-window-half-screen-horizontal side #!optional w)
    (unless w
      (setq w (input-focus)))
    (if (eq side 'top)
        (move-window-to-corner w 'top-left)
      (move-window-to-corner w 'bottom-left))
    (resize-window-frame-to w (window-width w) (/ (screen-height) 2))
    (maximize-fill-window-horizontally w))

  (define (expand-action edge)
    (let ((w (input-focus))
          (func (case edge
                   ((left) expand-window-half-screen-vertical)
                   ((right) expand-window-half-screen-vertical)
                   ((top) expand-window-half-screen-horizontal)
                   ((bottom) expand-window-half-screen-horizontal))))
      (allow-events 'async-both)
      (fake-release-window)
      (funcall func edge w))))

#!/bin/sh

# I tried: `REP_LOAD_PATH=... exec ...' but solaris /bin/sh won't play along

REP_LOAD_PATH="/usr/local/share/sawfish/0.36/lisp"
export REP_LOAD_PATH

exec rep "$0" "$@"

!#

#| nokogiri-main.jl -- entry point

   $Id: main.jl.in,v 1.10 2000/11/18 00:32:43 jsh Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(structure ()

    (open rep
	  rep.system
	  rep.io.streams
	  sawfish.gtk.widget
	  sawfish.ui.i18n
	  sawfish.ui.shell
	  sawfish.ui.group
	  sawfish.ui.user-level)

  (define socket-id nil)

  (when (get-command-line-option "--help")
    (write standard-output "\
usage: sawfish-ui [OPTIONS...]\n
where OPTIONS are any of:\n
  --group=GROUP-NAME
  --flatten
  --single-level
  --socket-id=WINDOW-ID\n")
    (throw 'quit 0))

  (let ((group (get-command-line-option "--group" t)))
    (when group
      (setq group (read-from-string group))
      (set-top-group (if (listp group) group `(root ,group)))))

  (let ((level (get-command-line-option "--user-level" t)))
    (when level
      (setq *nokogiri-user-level* (read-from-string level))))

  (when (get-command-line-option "--flatten")
    (setq *nokogiri-flatten-groups* t))

  (when (get-command-line-option "--single-level")
    (setq *nokogiri-single-level* t))

  (let ((id (get-command-line-option "--socket-id" t)))
    (when id
      (setq socket-id (string->number id))))

  (setq interrupt-mode 'exit)
  (i18n-init)
  (add-widget-prefix 'sawfish.ui.widgets)
  (run-shell socket-id))


;; Local variables:
;; major-mode: lisp-mode
;; End:

;; windows.jl -- miscellaneous window mgmt functions
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.windows

    (compound-interface
     ;; Subrs are stored in sawfish.wm.windows.subrs, but
     ;; this module re-exports them for convenience.
     (structure-interface sawfish.wm.windows.subrs)
     (export get-window-by-name
	     get-window-by-class
	     window-class-name
	     get-window-by-role
	     window-really-wants-input-p
	     window-transient-p
	     mark-window-as-transient
	     desktop-window-p
	     mark-window-as-desktop
	     dock-window-p
	     mark-window-as-dock
	     window-in-cycle-p
	     window-class
	     window-pid
	     window-role
	     warp-cursor-to-window
	     activate-window
	     constrain-dimension-to-hints
	     constrain-aspect-to-hints
	     resize-window-with-hints
	     resize-window-with-hints*
	     window-gravity
	     adjust-position-for-gravity/x
	     adjust-position-for-gravity/y
	     adjust-position-for-gravity
	     get-window-wm-protocols
	     window-supports-wm-protocol-p
	     delete-window
	     delete-window-safely
	     uniquify-name
	     uniquify-window-name
	     select-window
	     window-avoided-p
	     avoided-windows
	     call-after-property-changed
	     call-after-state-changed
	     rename-window
	     window-touching-p
	     window-x
	     window-y
	     window-width
	     window-height
	     toggle-fixed-postion))

    (open rep
	  rep.system
	  rep.regexp
	  #|
	    Don't add more sawfish.wm.* here unless you know what
	    you're doing. Instead, embed 'require' in definition.
	    It's because this file is read in early stage of Sawfish
	    init.
	  |#
	  sawfish.wm.windows.subrs
	  sawfish.wm.gaol
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.commands)


  (defgroup warp "Warping" :group misc)

  (defcustom warp-to-window-offset (cons -1 -1)
    "Offset (percent) from window edges when warping pointer."
    :type (pair (number 1) (number 1))
    :group (misc warp))

  (defcustom warp-to-window-enabled nil
    "Whether to enable warping the cursor to windows."
    :type boolean
    :group (misc warp))

  (defcustom dont-avoid-ignored t
    "Whether to not avoid ignored windows by default."
    :type boolean
    :group misc)

  (defcustom avoid-by-default nil
    "Whether to avoid any unspecified window by default."
    :type boolean
    :group misc)

  (defcustom uniquify-name-format "%s [%d]"
    "Format to create unique window names."
    :type string
    :group misc)

  (defvar dock-window-properties
    '(window-list-skip cycle-skip fixed-position focus-click-through
		       avoid no-history never-iconify never-maximize sticky
		       sticky-viewport placed)
    "List of properties set (to true) on windows when they are marked as docks.")

  (defvar desktop-window-properties
    '(fixed-position sticky sticky-viewport)
    "List of properties set (to true) on windows when they are marked as desktops.")

  (defvar desktop-window-depth -4
    "The stacking depth of desktop windows.")

  (defvar dock-window-depth 0
    "The stacking depth of dock windows.")

  (defvar activate-window-hook nil)

;;; finding windows, reading properties

  (define (get-window-by-name name #!key regex icon)
    "Find a window object whose window-name is NAME. If REGEX is
non-nil, then find a window object whose name matches NAME. If
ICON is non-nil, then window-icon-name (NET_WM_ICON_NAME, _not_ EWMH
_NET_WM_ICON_NAME) is checked instead. Returns nil if no such window is found."
    (if icon 
        (if regex
	    (car (filter-windows (lambda (w)
				   (when (window-icon-name w)
				     (string-match name (window-icon-name w))))))
	  (car (filter-windows (lambda (w)
				 (when (window-icon-name w)
				   (string= (window-icon-name w) name))))))
      (if regex
          (car (filter-windows (lambda (w)
				 (when (window-name w)
			           (string-match name (window-name w))))))
        (car (filter-windows (lambda (w)
			       (when (window-name w)
  			         (string= (window-name w) name))))))))

  (define (get-window-by-class class #!key regex)
    "Find a window object whose window-class is CLASS. If REGEX is
non-nil then find a window object whose class matches
CLASS. Returns nil if no such window is found."
    (if regex
        (car (filter-windows (lambda (w)
			       (when (window-class w)
			         (string-match class (window-class w))))))
      (car (filter-windows (lambda (w)
			     (when (window-class w)
  			       (string= (window-class w) class)))))))

  (define (window-class-name w #!optional (ref 1))
    "Quick way to get window class name."
    (aref (get-x-text-property w 'WM_CLASS) ref))

  (define (get-window-by-role role #!key regex)
    "Find a window object whose window-role is ROLE. If REGEX is non-nil then
find a window object whose role matches ROLE. Returns nil if no such
window is found."
    (if regex
        (car (filter-windows (lambda (w)
			       (when (window-role w)
				 (string-match role (window-role w))))))
      (car (filter-windows (lambda (w)
			     (when (window-role w)
			       (string= (window-role w) role)))))))

  (define (window-really-wants-input-p w)
    "Return nil if window W should never be focused."
    (and (not (window-get w 'never-focus))
	 (window-wants-input-p w)))

  (define (window-transient-p w)
    "Return non-nil if WINDOW is a transient window. The returned value will
then be the numeric id of its parent window."
    (or (window-get w 'transient-for)
	(let ((prop (get-x-property w 'WM_TRANSIENT_FOR)))
	  (when (and prop (eq (car prop) 'WINDOW)
		     (eql (cadr prop) 32) (>= (length (caddr prop)) 1))
	    (aref (caddr prop) 0)))))

  (define (mark-window-as-transient w)
    "Mark that window W is a dialog window of some sort."
    (require 'sawfish.wm.frames)
    (unless (window-transient-p w)
      (window-put w 'transient-for (root-window-id)))
    (set-window-type w 'transient))

  (define (desktop-window-p arg)
    "Return true if ARG represents a desktop window."
    (or (eq arg 'root) (and (windowp arg) (window-get arg 'desktop))))

  (define (mark-window-as-desktop w)
    "Mark that the window associated with object W is a desktop window."
    (require 'sawfish.wm.stacking)
    (require 'sawfish.wm.frames)
    (window-put w 'desktop t)
    (window-put w 'keymap root-window-keymap)
    (mapc (lambda (p)
	    (window-put w p t)) desktop-window-properties)
    (set-window-type w 'unframed)
    (set-window-depth w desktop-window-depth))

  (define (focus-desktop)
    "Transfer input focus to the desktop window (if one exists)."
    (let ((desktop-window (car (filter-windows desktop-window-p))))
      (when desktop-window
	(set-input-focus desktop-window))))

  (define-command 'focus-desktop focus-desktop)

  (define (dock-window-p arg)
    "Return true if ARG represents a dock window."
    (and (windowp arg) (window-get arg 'dock-type)))

  (define (mark-window-as-dock w)
    "Mark that the window associated with object W is a dock window."
    (require 'sawfish.wm.stacking)
    (require 'sawfish.wm.frames)
    (window-put w 'dock-type t)
    (mapc (lambda (p)
	    (window-put w p t)) dock-window-properties)
    (set-window-type w 'dock)
    (set-window-depth w dock-window-depth))

  (define (window-in-cycle-p w #!key ignore-cycle-skip)
    "Returns true if the window W should be included when cycling between
windows."
    (and (window-really-wants-input-p w)
	 (not (or (and (not ignore-cycle-skip) (window-get w 'cycle-skip))
		  (desktop-window-p w)))))

  (define (window-class w #!optional spec)
    "If SPEC is nil, return the class that window W belongs to,
as a string. Returns `nil' if W has no associated class.

If SPEC is 'cons, then cons (Instance . Class) is returned.
If SPEC is 'configurator, then the string of the form \"Instance/Class\"
is returned."
    (let ((prop (get-x-text-property w 'WM_CLASS)))
      (when (and prop (> (length prop) 1))
	(case spec
	  ((cons)
	   (cons (aref prop 0) (aref prop 1)))
	  ((configurator)
	   (concat (aref prop 1) "/" (aref prop 0)))
	  (t
	   (and prop (> (length prop) 1) (aref prop 1)))))))

  (define (window-pid win)
    "Returns the window pid, or nil if not available."
    (when (caddr (get-x-property win '_NET_WM_PID))
      (aref (caddr (get-x-property win '_NET_WM_PID)) 0)))

  (define (window-role win)
    "Returns the window role, or nil if not available."
    (when (get-x-text-property win 'WM_WINDOW_ROLE)
      (aref (get-x-text-property win 'WM_WINDOW_ROLE) 0)))

  (define (get-window-wm-protocols w)
    "Return a list of symbols defining the X11 window manager protocols
supported by client window W."
    (let* ((prop (get-x-property w 'WM_PROTOCOLS))
	   (data (and prop (eq (car prop) 'ATOM) (nth 2 prop))))
      (when data
	(do ((i 0 (1+ i))
	     (out '() (cons (aref data i) out)))
	    ((= i (length data))
	     (nreverse out))))))

  (define (window-supports-wm-protocol-p w atom)
    "Return true if window W includes ATOM in its `WM_PROTOCOLS' property."
    (let* ((prop (get-x-property w 'WM_PROTOCOLS))
	   (data (and prop (eq (car prop) 'ATOM) (nth 2 prop))))
      (when data
	(let loop ((i 0))
	  (cond ((= i (length data)) nil)
		((eq (aref data i) atom) t)
		(t (loop (1+ i))))))))

;;; warping

  (define (warp-cursor-to-window w #!optional x y)
    "Move the mouse pointer to position (X, Y) relative to the client window
associated with object WINDOW.

If X and Y are nil, then the pointer is moved to a default position, as
specified by the user."
    (when warp-to-window-enabled
      (let ((coords (window-position w))
	    (foff (window-frame-offset w))
	    (dims (window-dimensions w)))
	(require 'sawfish.wm.state.shading)
	(when (window-shaded-p w)
	  (setq foff (cons 0 0))
	  (setq dims (window-frame-dimensions w)))
	(unless x
	  (setq x
		(if (< (car warp-to-window-offset) 0)
		    (car warp-to-window-offset)
		  (quotient (* (car dims)
                               (car warp-to-window-offset)) 100))))
	(unless y
	  (setq y (if (< (cdr warp-to-window-offset) 0)
		      (cdr warp-to-window-offset)
		    (quotient (* (cdr dims)
                                 (cdr warp-to-window-offset)) 100))))
	(warp-cursor
	 (max 0 (min (1- (screen-width))
                     (+ x (car coords) (- (car foff)))))
	 (max 0 (min (1- (screen-height))
                     (+ y (cdr coords) (- (cdr foff)))))))))

  (define (activate-window w)
    (require 'sawfish.wm.focus)
    (require 'sawfish.wm.util.stacking)
    (require 'sawfish.wm.util.window-order)
    (raise-window* w)
    (when (window-really-wants-input-p w)
      (set-input-focus w))
    (warp-pointer-if-necessary w)
    (window-order-push w)
    (call-window-hook 'activate-window-hook w))

;;; resizing windows in accordance with their size hints

  (define (constrain-dimension-to-hints x dimension hints)
    ;; User asks the value DIMENSION as a window dimension.
    ;; X is either 'x or 'y.
    ;; Return value is the DIMENSION constrained by HINTS.
    (let ((base (cdr (assq (if (eq dimension 'x)
			       'base-width 'base-height) hints)))
	  (minimum (cdr (assq (if (eq dimension 'x)
				  'min-width 'min-height) hints)))
	  (maximum (or (cdr (assq (if (eq dimension 'x)
				      'max-width 'max-height) hints)) 65535))
	  (inc (or (cdr (assq (if (eq dimension 'x)
				  'width-inc 'height-inc) hints)) 1)))
      (let ((bottom (or base minimum 1)))
	(unless (= (mod (- x bottom) inc) 0)
	  (setq x (inexact->exact
		   (+ (* (ceiling (/ (- x bottom) inc)) inc) bottom)))))
      (clamp x (or minimum base 1) maximum)))

  (define (constrain-aspect-to-hints a old-b dimension min-aspect max-aspect)
    (let ((min-ratio (/ (cadr min-aspect) (cddr min-aspect)))
          (max-ratio (/ (cadr max-aspect) (cddr min-aspect))))
      (if (eq dimension 'y)
          (clamp old-b (floor (* a min-ratio)) (floor (* a max-ratio)))
        (clamp old-b (floor (/ a max-ratio)) (floor (/ a min-ratio))))))

  (define (resize-window-with-hints w cols rows #!optional hints)
    "Resize window W to COLS x ROWS, using the window's size hints to
define the row and column size, and the minimum possible size.

If HINTS is non-nil, then it is the size hints structure to
use. Otherwise (window-size-hints W) is used."
    (unless hints
      (setq hints (window-size-hints w)))
    (let ((x-base (or (cdr (or (assq 'base-width hints)
			       (assq 'min-width hints))) 1))
	  (x-inc (or (cdr (assq 'width-inc hints)) 1))
	  (y-base (or (cdr (or (assq 'base-height hints)
			       (assq 'min-height hints))) 1))
	  (y-inc (or (cdr (assq 'height-inc hints)) 1)))
      (resize-window-to
       w (constrain-dimension-to-hints (+ x-base (* x-inc cols)) 'x hints)
       (constrain-dimension-to-hints (+ y-base (* y-inc rows)) 'y hints))))

  (define (resize-window-with-hints* w width height #!optional hints)
    "Resize window W to WIDTH x HEIGHT, with WIDTH and HEIGHT defined
in terms of pixels. The window's size hints structure defines the
minimum and maximum dimensions of the window, within which WIDTH and
HEIGHT are constrained.

If HINTS is non-nil, then it is the size hints structure to
use. Otherwise (window-size-hints W) is used."
    (unless hints
      (setq hints (window-size-hints w)))
    (resize-window-to w (constrain-dimension-to-hints width 'x hints)
		      (constrain-dimension-to-hints height 'y hints)))

  (define (window-gravity w #!optional hints)
    (or (window-get w 'gravity)
	(cdr (assq 'window-gravity (or hints (window-size-hints w))))
	;; default gravity is NorthWest (from ICCCM)
	'north-west))

  (define (adjust-position-for-gravity/x w grav x #!key inverse)
    (let* ((tl-off (car (window-frame-offset w)))
	   (br-off (- (car (window-frame-dimensions w))
		      (car (window-dimensions w))))
	   (sign (if inverse -1 +1)))
      (cond ((eq grav 'static)
	     ;; static gravity is relative to the original
	     ;; client window position
	     (+ x (* sign tl-off)))
	    ((memq grav '(east south-east north-east))
	     ;; relative to the right of the frame
	     (- x (* sign (+ br-off (* -2 (window-border-width w))))))
	    ((memq grav '(north center south))
	     ;; relative to the horizontal center of the frame
	     (- x (* sign (quotient
			   (+ br-off (* -2 (window-border-width w))) 2))))
	    (t x))))

  (define (adjust-position-for-gravity/y w grav y #!key inverse)
    (let* ((tl-off (cdr (window-frame-offset w)))
	   (br-off (- (cdr (window-frame-dimensions w))
		      (cdr (window-dimensions w))))
	   (sign (if inverse -1 +1)))
      (cond ((eq grav 'static)
	     ;; static gravity is relative to the original
	     ;; client window position
	     (+ y (* sign tl-off)))
	    ((memq grav '(south south-east south-west))
	     ;; relative to the bottom of the frame
	     (- y (* sign (+ br-off (* -2 (window-border-width w))))))
	    ((memq grav '(east center west))
	     ;; relative to the vertical center of the frame
	     (- y (* sign (quotient
			   (+ br-off (* -2 (window-border-width w))) 2))))
	    (t y))))

  ;; UNADJUST means to reverse the gravity compensation, suitable for
  ;; when unmanaging windows at shutdown
  (define (adjust-position-for-gravity w grav coords #!optional unadjust)
    (cons (adjust-position-for-gravity/x
	   w grav (car coords) #:inverse unadjust)
	  (adjust-position-for-gravity/y
	   w grav (cdr coords) #:inverse unadjust)))

;;; deleting windows

  (define (delete-window w #!optional safely)
    "Delete a window. If the window does not support that protocol,
kill the client."
    (unless (and (memq this-command
		       '(delete-window delete-window-safely
			 delete-group delete-window-instance))
		 (window-get w 'never-delete))
      (cond
       ((window-supports-wm-protocol-p w 'WM_DELETE_WINDOW)
	(send-client-message w 'WM_PROTOCOLS (vector (x-atom 'WM_DELETE_WINDOW)
						     (x-server-timestamp)) 32))
       (safely (beep))
       (t (x-kill-client w)))))

  (define-command 'delete-window delete-window #:spec "%W")

  (define (delete-window-safely w)
    "Delete a window, or beep if the window can't be closed safely."
    (delete-window w t))

  (define-command 'delete-window-safely delete-window-safely #:spec "%W")

;;; making window names unique

  (define (uniquify-name in existing)
    "Uniquify the string IN from the list of strings EXISTING. Uses the format
string `uniquify-name-format' to generate unique names."
    (letrec
	((again (lambda (i)
		  (if (member (format nil uniquify-name-format in i) existing)
		      (again (1+ i))
		    (format nil uniquify-name-format in i)))))
      (if (member in existing)
	  (again 2)
	in)))

  (define (uniquify-window-name w)
    "Force the current window to have a unique title."
    (set-x-text-property
     w 'WM_NAME
     (vector (uniquify-name (window-name w)
			    (mapcar window-name (delq w (managed-windows)))))))

  (define-command 'uniquify-window-name uniquify-window-name #:spec "%W")

;;; selecting a single window

  (define select-window-map
    (bind-keys (make-keymap)
               "Any-Click1" (lambda ()
                              (throw 'select-window
                                     (query-pointer-window)))))

  (defvar select-window-cursor-shape 'crosshair)

  (define (select-window)
    "Wait for a click, and returns the clicked window. Nil for the root
window."
    (allow-events 'async-pointer)
    (when (grab-pointer nil select-window-cursor-shape)
      (unwind-protect
	  (let ((override-keymap select-window-map))
	    (catch 'select-window
	      (recursive-edit)))
	(ungrab-pointer))))

;;; avoided (i.e. non-overlapped) windows

  (define (window-avoided-p w)
    "Return t if window W should be kept unobscured by other windows wherever
possible."
    (cond ((or (not (window-mapped-p w))
	       (not (window-visible-p w))) nil)
	  ((window-get w 'avoid) t)
	  ((and dont-avoid-ignored (window-get w 'ignored)) nil)
	  (t avoid-by-default)))

  (define (avoided-windows #!optional window)
    "Returns a list of all windows that should be left unobscured where
possible. If WINDOW is defined, then it defines a window that will be never
returned in the list."
    (filter-windows (lambda (w)
		      (and (not (eq w window))
			   (window-avoided-p w)))))

;;; property and window-state changed interface

  (define prop-changes '())

  (define (call-after-property-changed prop fun)
    "Arrange for function FUN to be called with arguments (WINDOW PROPERTY
STATE) when the X11 property named PROP (a symbol) changes. PROP may also
be a list of property names to monitor.

Kluge: if PROP is `WM_NAME', it is replaced with `(WM_NAME _NET_WM_NAME)'.
This is done to cope with themes that want to update title bars on name
changes but only watch `WM_NAME'.  A warning is printed on stderr when
this substitution occurs.  Those themes should really be fixed."
    (setq prop-changes
          (cons
           (cons (cond ((listp prop) prop)
                       ((eq prop 'WM_NAME)
                        (format standard-error
" (call-after-property-changed 'WM_NAME ...) should probably be
 (call-after-property-changed '(WM_NAME _NET_WM_NAME) ...);
Use '(WM_NAME) if you really want only WM_NAME\n")
                        '(WM_NAME _NET_WM_NAME))
                       (t (list prop)))
                 fun)
           prop-changes)))

  (add-hook 'property-notify-hook
	    (lambda (w prop state)
	      (mapc (lambda (cell)
                      (when (memq prop (car cell))
			((cdr cell) w prop state)))
		    prop-changes)))

  (define state-changes '())

  (define (call-after-state-changed states fun)
    "Arrange for function FUN to be called with arguments (WINDOW
CHANGED-STATES) when one of the states defined by the list of symbols
STATES has been changed. STATES may also be a single symbol."
    (setq state-changes (cons (cons (if (listp states)
					states
				      (list states)) fun) state-changes)))

  (add-hook
   'window-state-change-hook
   (lambda (w states)
     (mapc (lambda (cell)
	     (let ((relevant (filter (lambda (state)
                                       (memq state (car cell))) states)))
	       (when relevant
		 ((cdr cell) w relevant))))
           state-changes)))

  (define (rename-window window new-name)
    "Renames WINDOW to NEW-NAME."
    (set-x-text-property window 'WM_NAME (vector new-name))
    (set-x-text-property window '_NET_WM_NAME (vector new-name))
    (set-x-text-property window 'WM_ICON_NAME (vector new-name))
    (set-x-text-property window '_NET_WM_ICON_NAME (vector new-name)))

  (define-command 'rename-window rename-window
    #:spec "%W\nsEnter new window name:")

    ;; helpers for window-touching-p
  (define (find-if fn l)
    (cond ((null l) nil)
	  ((fn (car l)) (car l))
	  (t (find-if fn (cdr l)))))

  (define (overlapping w1 w2)
    "Do window W1 and window W2 overlap?"
    (and (< (abs (- (window-x w1) (window-x w2)))
	    (window-width (if (< (window-x w1) (window-x w2))
			      w1 w2)))
	(< (abs (- (window-y w1) (window-y w2)))
	    (window-height (if (< (window-y w1) (window-y w2))
			      w1 w2)))))

  (define (window-touching-p w)
    "Is window W touching another window?"
    (require 'sawfish.wm.state.ignored)
    (require 'sawfish.wm.workspace)
    (find-if (lambda (other) (overlapping w other))
	    (remove w (remove-if window-ignored-p
				  (filter-windows
				  window-on-current-workspace-p)))))

  (define (window-x w)
    (car (window-position w)))

  (define (window-y w)
    (cdr (window-position w)))

  (define (window-width w)
    (car (window-frame-dimensions w)))

  (define (window-height w)
    (cdr (window-frame-dimensions w)))

  (define (toggle-fixed-postion w)
    "Toggle the window property `fixed-position'."
     (if (window-get w 'fixed-position)
	 (window-put w 'fixed-position nil)
       (window-put w 'fixed-position t))
     (call-window-hook 'window-state-change-hook w (list '(fixed-position))))
  (define-command 'toggle-fixed-postion toggle-fixed-postion #:spec "%W")
;;; gaollable functions

  (gaol-add window-really-wants-input-p window-class window-avoided-p
	    call-after-property-changed call-after-state-changed
	    window-get window-name window-full-name window-icon-name
	    window-mapped-p window-frame set-window-frame rebuild-frame
	    window-position window-dimensions window-frame-dimensions windowp
	    managed-windows stacking-order window-visibility
	    window-transient-p window-urgent-p window-shaped-p window-visible-p
	    window-framed-p window-id window-group-id window-size-hints
	    call-window-hook input-focus window-icon-image map-windows
	    filter-windows current-event-window window-put
	    move-window-to resize-window-to))

(define-structure sawfish.wm.tile.tiler
    (export tile-workspace
            untile-window
            register-workspace-tiler
            current-tiler-name
            tileable-windows
            next-tiling
            setting
            set-setting)

    (open rep
          rep.system
          rep.data.tables
          sawfish.wm.windows
          sawfish.wm.tile.utils
          sawfish.wm.state.ignored)

  (define %tilers '())
  (define %sizes (make-table eq-hash eq))

  (define (save-size w)
    (table-set %sizes w
               (list (window-x w) (window-y w)
                     (window-width w) (window-height w))))

  (define (forget w) (table-unset %sizes w))

  (define (restore-window w)
    (let ((s (table-ref %sizes w)))
      (when s
        (apply push-window (cons w s))
        t)))

  (define (restore-windows ws)
    (mapc restore-window (tileable-workspace-windows ws)))

  (define (restore-sizes ws)
    (mapc (lambda (w)
            (let ((s (table-ref %sizes w)))
              (when s
                (resize-frame-to w (nth 2 s) (nth 3 s)))))
          (tileable-workspace-windows ws)))

  (define null-tiler
    (list (lambda ()
            (restore-windows current-workspace))))

  (define (register-workspace-tiler ws tiler args auto #!optional name picker)
    (let ((curr (assoc ws %tilers))
          (new (list tiler args auto name picker)))
      (if (null curr)
          (setq %tilers (cons (list ws new null-tiler) %tilers))
        (setcdr curr (cons new (cdr curr))))))

    (define (rotate-tiling #!optional ws)
    (let ((ts (assoc (or ws current-workspace) %tilers)))
      (when (> (length ts) 2)
        (setcdr ts `(,@(cddr ts) ,(cadr ts))))))

  (define (tilings #!optional ws)
    (cdr (assoc (or ws current-workspace) %tilers)))

  (define (tiling #!optional ws)
    (car (tilings ws)))

  (define (tiling-tiler ti) (nth 0 ti))
  (define (tiling-settings ti) (nth 1 ti))

  (define (tiling-auto-p ti w)
    (let ((p (nth 2 ti)))
      (if (functionp p) (p w) p)))

  (define (tiling-name ti) (nth 3 ti))

  (define (tiling-master-picker ti)
    (or (nth 4 ti) (lambda (w) #t)))

  (define (tileable-window-p w)
    (and w
         (tiling-auto-p (tiling (window-workspace w)) w)
         (not (window-never-tile-p w))
         (not (window-ignored-p w))
         (not (dock-window-p w))
         (not (tab-background-p w))
         (not (eq (window-type w) 'transient))))

  (define (tileable-windows #!optional ignore)
    (filter tileable-window-p (tileable-workspace-windows ignore)))

  (define (current-tiler-name) (tiling-name (tiling)))

  (define (pick ti master ignore)
    (let ((test (tiling-master-picker ti)))
      (or (and master (not (eq master ignore)) (test master) master)
          (let ((wl (tileable-workspace-windows ignore)))
            (or (car (filter test wl))
                (and (tileable-window-p master) master)
                (car wl))))))

  (define (tile-workspace #!optional new-window destroyed-window)
    (interactive)
    (let ((ti (tiling)))
      (when ti
	((tiling-tiler ti) (pick ti new-window destroyed-window)
                           destroyed-window))))

  (define (next-tiling)
    (interactive)
    (when (rotate-tiling)
      (restore-sizes current-workspace)
      (tile-workspace))
    (let ((cn (current-tiler-name)))
      (if cn (notify "Current tiler: %s" cn) (notify "No active tiler"))))

  (define (untile-window w)
    (interactive "%f")
    (when (restore-window w) (tile-workspace nil w)))

  (define (add-autotile w)
    (save-size w)
    (when (tileable-window-p w)
      (tile-workspace w)))

  (define (destroy-autotile w)
    (forget w)
    (when (tileable-window-p w)
      (tile-workspace nil w)))

  (define (maybe-save w)
    (let ((ct (tiling)))
      (when (or (not ct) (eq ct null-tiler))
        (save-size w))))

  (define (setting n #!optional def ws)
    (or (nth n (tiling-settings (tiling ws))) def))

  (define (set-setting n v #!optional ws)
    (let ((s (tiling-settings (tiling ws))))
      (when s (rplaca (nthcdr n s) v))))

  (add-hook 'shape-notify-hook maybe-save t)
  (add-hook 'after-move-hook maybe-save t)
  (add-hook 'after-resize-hook maybe-save t)
  (add-hook 'after-add-window-hook add-autotile t)
  (add-hook 'uniconify-window-hook add-autotile t)
  (add-hook 'iconify-window-hook destroy-autotile t)
  (add-hook 'destroy-notify-hook destroy-autotile t)
  (add-hook 'unmap-notify-hook destroy-autotile t))

;; nokogiri-widgets/frame-style.jl -- theme chooser widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.frame-style

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
          rep.io.files
          rep.util.misc
          sawfish.gtk.widget
          sawfish.cfg.i18n)

  (eval-when-compile
    (defvar fallback-frame-style nil))

  (define (make-frame-style-item changed-callback doc options path)

    (let ((vbox (gtk-vbox-new nil 0))
	  (hbox (gtk-hbox-new nil 0))
	  (combo (gtk-combo-box-text-new))
	  (doc-label (gtk-label-new (_ doc)))
	  (readme-text-view (gtk-text-view-new))
	  (readme-scroller (gtk-scrolled-window-new)))

      (let loop ((rest options))
        (when rest
           (gtk-combo-box-text-append-text combo
             (_ (or (cadar rest) (symbol-name (car rest)))))
            (loop (cdr rest))))

      (gtk-box-set-spacing hbox box-spacing)
      (gtk-box-set-spacing vbox box-spacing)
      (gtk-container-add readme-scroller readme-text-view)
      (gtk-box-pack-start hbox doc-label)
      (gtk-box-pack-start hbox combo nil nil)
      (gtk-box-pack-start vbox readme-scroller t t)
      (gtk-box-pack-start vbox hbox nil nil)
      (gtk-label-set-justify doc-label 'left)
      (gtk-text-view-set-cursor-visible readme-text-view nil)
      (gtk-text-view-set-wrap-mode readme-text-view 'word-char)
      (gtk-text-view-set-editable readme-text-view nil)
      (gtk-scrolled-window-set-policy readme-scroller 'automatic 'automatic)
      (gtk-widget-set-size-request readme-text-view -1 250)

      (g-signal-connect combo "changed" changed-callback)

      (gtk-widget-show-all vbox)

      (lambda (op)
	(case op
	  ((gtk-widget) vbox)
	  ((clear) nop)
	  ((set) (lambda (x)
		   (gtk-combo-box-set-active combo (or (option-index options x) (option-index options fallback-frame-style)))
		   (update-readme (string->symbol (symbol-name (nth (gtk-combo-box-get-active combo) options))) readme-text-view path)))
	  ((ref) (lambda () (string->symbol (symbol-name (nth (gtk-combo-box-get-active combo) options)))))
	  ((validp) (lambda (x) (memq x options)))))))

  (define-widget-type 'frame-style make-frame-style-item)
  (widget-accepts-doc-string 'frame-style)

  (define (text-view-set view string)
    (let ((buffer (gtk-text-view-get-buffer view))
	  (iter (gtk-text-iter-new)))
      (gtk-text-buffer-set-text buffer string (length string))
      (gtk-text-buffer-get-start-iter buffer iter)
      (gtk-text-buffer-place-cursor buffer iter)))

  (define (update-readme value text-view theme-path)
    (catch 'out
      (let ((theme (symbol-name value)))
	(mapc (lambda (dir)
		(let ((full (expand-file-name theme dir)))
		  (when (catch 'out
			  (mapc (lambda (suf)
				  (let ((dir (format nil suf full theme)))
				    (condition-case nil
					(when (file-directory-p dir)
					  (setq full dir)
					  (throw 'out t))
				      (error))))
				'("%s"))
			  nil)
		    (setq full (i18n-filename
				(expand-file-name "README" full)))
		    (if (file-exists-p full)
			(let ((text (make-string-output-stream))
			      (file (open-file full 'read)))
			  (unwind-protect
			      (progn
				(copy-stream file text)
				(setq text (get-output-stream-string text))
				(when (string-match "\\s+$" text)
				  (setq text (substring text 0 (match-start))))
				(text-view-set text-view text))
			    (close-file file)))
		      (text-view-set text-view ""))
		    (throw 'out t))))
	      theme-path)
	(text-view-set text-view "")))))

;; nokogiri-widgets/color.jl -- color selector widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.color

    (export )

    (open rep
          gui.gtk-2.gtk
          rep.regexp
          sawfish.gtk.widget)

  (defconst default-color "#000000")

  (define (make-color-item changed-callback)
    (let* ((value default-color)
	   (button (gtk-color-button-new-with-color
                    (gdk-color-parse-interp value))))
      (g-signal-connect button "color-set"
                        (lambda ()
                          (let ((color (gtk-color-button-get-color-interp
                                        button)))
                            (setq value color)
                            (call-callback changed-callback))))
      (gtk-widget-show button)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (setq value x)
		   (gtk-color-button-set-color button (gdk-color-parse-interp
                                                       value))))
	  ((clear) (lambda ()
		     (setq value default-color)
		     (gtk-color-button-set-color button (gdk-color-parse-interp
                                                         value))))
	  ((ref) (lambda () value))
	  ((gtk-widget) button)
	  ((validp) (lambda (x)
		      (and (stringp x) (string-match "^#" x))))))))

  (define-widget-type 'color make-color-item))

;; nokogiri-shell.jl -- shell displaying custom groups
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.cfg.shell

    (export run-shell)

    (open rep
	  gui.gtk-2.gtk
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.streams
	  rep.io.timers
	  sawfish.gtk.widget
	  sawfish.cfg.i18n
	  sawfish.cfg.group
	  sawfish.cfg.slot
	  sawfish.cfg.apply
	  sawfish.cfg.layout
	  sawfish.cfg.config
	  sawfish.cfg.wm)

  (defvar *nokogiri-flatten-groups* nil)

  (define main-window)
  (define group-tree-widget)
  (define slot-box-widget)

  (define active-slots '())

  (define ok-widget)
  (define revert-widget)
  (define about-button)

  (define (initialize-shell)
    (let ((vbox (gtk-vbox-new nil box-spacing))
	  (hbox (gtk-hbutton-box-new))
	  (s-scroller (gtk-scrolled-window-new))
	  root-container)

      (setq main-window (gtk-window-new 'toplevel))

      (gtk-box-set-homogeneous hbox t)
      (gtk-window-set-resizable main-window t)
      (gtk-window-set-icon-name main-window "sawfish-config")
      (gtk-window-set-default-size main-window 550 400)
      (setq root-container (gtk-frame-new))
      (gtk-frame-set-shadow-type root-container 'etched-in)
      (gtk-container-add main-window root-container)

      (setq slot-box-widget (gtk-vbox-new nil box-spacing))

      (gtk-container-set-border-width vbox box-border)
      (gtk-container-set-border-width slot-box-widget box-border)
      (when s-scroller
	(gtk-scrolled-window-set-policy s-scroller 'automatic 'automatic)
	(gtk-scrolled-window-add-with-viewport s-scroller slot-box-widget))

      (let ((group (get-group top-group)))
	(fetch-group group)
	(if (and (not *nokogiri-flatten-groups*)
		 (group-sub-groups group))
	    (let ((paned (gtk-hpaned-new))
		  (g-scroller (gtk-scrolled-window-new)))
	      (setq group-tree-widget (make-group-tree (get-group top-group)))
	      (gtk-container-set-border-width group-tree-widget box-border)
	      (gtk-scrolled-window-set-policy g-scroller 'automatic 'automatic)
	      (gtk-container-add vbox paned)
	      (gtk-paned-add1 paned g-scroller)
	      (gtk-paned-add2 paned (or s-scroller slot-box-widget))
	      (gtk-paned-set-position paned 250)
	      (gtk-scrolled-window-add-with-viewport g-scroller
						     group-tree-widget))
	  (gtk-container-add vbox (or s-scroller slot-box-widget))))


	(setq ok-widget (gtk-button-new-from-stock "gtk-close"))
	(gtk-button-set-relief ok-widget 'none)

	(setq revert-widget (gtk-button-new-from-stock "gtk-undo"))
	(gtk-button-set-relief revert-widget 'none)

	(setq about-button (gtk-button-new-from-stock "gtk-about"))
	(gtk-button-set-relief about-button 'none)

	(gtk-window-set-title main-window (_ "Sawfish Configurator"))
	(gtk-widget-set-name main-window (_ "Sawfish Configurator"))
	(gtk-window-set-wmclass main-window "sawfish-configurator"
                                "Sawfish-Configurator")

      (g-signal-connect main-window "delete_event" on-quit)

	(gtk-box-set-spacing hbox button-box-spacing)
	(gtk-button-box-set-layout hbox 'spread)

	(gtk-box-pack-end vbox hbox)

	(g-signal-connect ok-widget "clicked" on-ok)
	(g-signal-connect revert-widget "clicked" on-revert)

	(g-signal-connect about-button "clicked"
	  (lambda () (system "sawfish-about >/dev/null 2>&1 </dev/null &")))

	(gtk-container-add hbox about-button)
	(gtk-container-add hbox revert-widget)
	(gtk-container-add hbox ok-widget)

      (gtk-container-add root-container vbox)
      (gtk-widget-show-all main-window)
      (set-button-states)

      (if group-tree-widget
	  (progn
	    (gtk-tree-select-item group-tree-widget 0)
	    (mapc gtk-tree-item-expand
		  (gtk-container-get-children group-tree-widget)))
	(select-group (get-group top-group)))))

  (define (destroy-shell)
    (when main-window
      (gtk-widget-destroy main-window)
      (setq main-window nil)
      (setq group-tree-widget nil)
      (setq slot-box-widget nil)
      (setq ok-widget nil)
      (setq revert-widget nil)))

  (define (on-quit)
    (destroy-shell)
    (throw 'nokogiri-exit t))

  (define (on-ok)
    (apply-slot-changes)
    (on-quit))

  (define (on-apply)
    (apply-slot-changes)
    (set-button-states))

  (define (on-cancel)
    (revert-slot-changes)
    (on-quit))

  (define (on-revert)
    (revert-slot-changes)
    (set-button-states))

  (define (set-button-states)
    (when revert-widget
      (gtk-widget-set-sensitive revert-widget (changes-to-revert-p)))
    (when ok-widget
      (gtk-widget-set-sensitive ok-widget t)))

;;; displaying custom groups

  (define (get-slots group)
    (fetch-group group)
    (group-slots group))

  (define (add-active-slots slots)
    (setq active-slots (nconc active-slots
			      (filter (lambda (x)
					(not (memq x active-slots))) slots))))

  (define (display-book-tree group)

    (define (iter group slots)
      (let ((group-page (and slots (layout-slots (group-layout group) slots))))
	(add-active-slots slots)
	(when (and group-page (gtk-container-p group-page))
	  (gtk-container-set-border-width group-page box-border))
	(if (group-sub-groups group)
	    (let ((book (gtk-notebook-new)))
	      (gtk-notebook-set-scrollable book t)
	      (gtk-notebook-popup-enable book t)
	      (when group-page
		(gtk-notebook-append-page
		 book group-page (gtk-label-new (_ (group-real-name group)))))
	      (mapc (lambda (sub)
		      (fetch-group sub)
		      (let ((slots (get-slots sub)))
			(when (or slots (group-sub-groups sub))
			  (let ((page (iter sub slots)))
			    (when page
			      (gtk-notebook-append-page
			       book page (gtk-label-new
					  (_ (group-real-name sub)))))))))
		    (get-sub-groups group))
	      (gtk-widget-show book)
	      book)
	  group-page)))

    (let ((page (iter group (get-slots group))))
      (when page
	(gtk-container-add slot-box-widget page))))

  (define (display-flattened group)

    (define (iter book group slots)
      (when slots
	(let ((layout (layout-slots (group-layout group) slots)))
	  (add-active-slots slots)
          (gtk-box-pack-start book layout)
	  (when (gtk-container-p layout)
	    (gtk-container-set-border-width layout box-border))))
      (mapc (lambda (sub)
	      (fetch-group sub)
	      (let ((slots (get-slots sub)))
		(when (or slots (group-sub-groups group))
		  (iter book sub slots))))
	    (get-sub-groups group)))

    (let ((notebook (gtk-vbox-new nil 0)))
      (iter notebook group (get-slots group))
      (gtk-widget-show notebook)
      (gtk-container-add slot-box-widget notebook)))

  (define (display-unflattened group)
    (let* ((slots (get-slots group)))
      (gtk-container-add
       slot-box-widget (layout-slots (group-layout group) slots))
      (add-active-slots slots)))

  (define (add-group-widgets group)
    (if (and *nokogiri-flatten-groups* (group-sub-groups group))
	(display-book-tree group)
      (display-unflattened group))
    (update-all-dependences))

  (define (remove-group-widgets group)
    (declare (unused group))
    (mapc (lambda (s)
	    (let ((w (slot-gtk-widget s)))
	      (when (gtk-widget-parent w)
		(gtk-container-remove (gtk-widget-parent w) w))
	      (set-slot-layout s nil))) active-slots)
    (setq active-slots '())
    (mapc (lambda (w)
	    (gtk-container-remove slot-box-widget w))
	  (gtk-container-get-children slot-box-widget)))

  (define (sawfish-config-display-info text kill)
    (let ((window (gtk-window-new 'toplevel))
	  (vbox (gtk-vbox-new nil box-spacing))
	  (label (gtk-label-new text))
	  (button (gtk-button-new-from-stock "gtk-ok")))

      (gtk-window-set-title window "SawfishConfig Info")
      (gtk-window-set-icon-name window "gtk-info")

      (gtk-container-set-border-width window 10)

      (gtk-label-set-line-wrap label t)

      (gtk-widget-set-size-request label 225 45)

      (if kill
	  (progn
	    (g-signal-connect window "delete_event" (lambda () throw 'quit 1))
	    (g-signal-connect button "clicked" (lambda () (throw 'quit 1))))
	(g-signal-connect window "delete_event"
			  (lambda () (gtk-widget-destroy window)))
	(g-signal-connect button "clicked"
			  (lambda () (gtk-widget-destroy window))))

      (gtk-container-add window vbox)
      (gtk-container-add vbox label)
      (gtk-container-add vbox button)

      (gtk-widget-show-all window)

      (setq interrupt-mode 'exit)
      (recursive-edit)
      (throw 'quit 1)))

  (define (run-shell)
    (condition-case nil
	(wm-locale-dir)
      (error (sawfish-config-display-info "Sawfish's configurator needs a running Sawfish. Aborting." t)))
    (when (get-command-line-option "--help")
      (write standard-output "\
usage: sawfish-config [OPTIONS...]\n
where OPTIONS are any of:\n
  --group=GROUP-NAME
  --flatten\n")
      (throw 'quit 0))

    (let ((group (get-command-line-option "--group" t)))
      (when group
	(setq group (read-from-string group))
	(set-top-group (if (listp group) group `(root ,group)))))

    (when (get-command-line-option "--flatten")
      (setq *nokogiri-flatten-groups* t))

    (setq interrupt-mode 'exit)
    (i18n-init)

    (initialize-configs)
    (initialize-shell)

    (catch 'nokogiri-exit
      (recursive-edit))
    (throw 'quit 0))

  (add-hook '*nokogiri-slot-changed-hook* set-button-states t)
  (add-hook '*nokogiri-group-selected-hook* add-group-widgets)
  (add-hook '*nokogiri-group-deselected-hook* remove-group-widgets))

;; single-window-mode.jl - pedantic implementation of single-window-mode

;; (c) 2011 Christopher Roy Bratusek <nano@tuxfamily.org>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.ext.single-window-mode

  (export toggle-single-window-mode
	  single-window-on-workspace-p
	  window-in-single-window-mode-list-p
	  workspace-in-single-window-mode-list-p
	  single-window-mode-get-window-for-workspace
	  single-window-mode-get-window-for-workspace
	  single-window-mode-get-workspace-for-window)

  (open rep
	rep.system
	rep.regexp
	sawfish.wm
	sawfish.wm.misc
        sawfish.wm.commands
        sawfish.wm.commands.move-resize
        sawfish.wm.state.iconify
	sawfish.wm.state.maximize
        sawfish.wm.windows
	sawfish.wm.events
        sawfish.wm.workspace
	sawfish.wm.util.groups)

  (define-structure-alias single-window-mode sawfish.wm.ext.single-window-mode)

  ;; from edge-actions-1.9 branch (will be removed once EA is merged into head.

  (define (window-on-current-workspace-p w)                                                                                                                                                                                  
    (= (car (window-get w 'workspaces)) current-workspace))

  (defvar single-window-mode-window-fullscreen nil)
  (defvar single-window-mode-list ())

  (define (single-window-mode-list-append ws class)
    "Add a single-window to the list."
    (setq single-window-mode-list
      (append single-window-mode-list `((,ws . ,class)))))

  (define (single-window-mode-list-remove ws class)
    "Remove a single-window from the list."
    (setq single-window-mode-list
      (remove `(,ws . ,class) single-window-mode-list)))

  (define (single-window-on-workspace-p ws)
    "Whether there's a single-window on workspace `ws'."
    (if (assoc ws single-window-mode-list) t nil))

  (define (window-in-single-window-mode-list-p class)
    "Whether window `class' is in single-window-mode-list."
    (if (single-window-mode-get-workspace-for-window class) t nil))

  (define (workspace-in-single-window-mode-list-p ws)
    "Whether workspace `ws' is in single-window-mode-list."
    (if (single-window-mode-get-window-class-for-workspace ws) t nil))

  (define (single-window-mode-get-window-for-workspace ws)
    "Return single-window for workspace `ws' or nil, if none."
    (let ((class (cdr (assoc ws single-window-mode-list))))
      (if class (get-window-by-class class) nil)))

  (define (single-window-mode-get-window-class-for-workspace ws)
    "Return single-window's class for workspace `ws' or nil, if none."
    (cdr (assoc ws single-window-mode-list)))

  (define (single-window-mode-get-workspace-for-window class)
    "Return workspace for single-window `win' or nil, if none."
    (car (rassoc class single-window-mode-list)))

  (define (toggle-single-window-mode #!optional w)
    "Toggle single-window-mode for window `w'."
    (let ((win (if w w (input-focus)))
	  (window-ws))
      (setq window-ws (if (window-on-current-workspace-p win)
			  current-workspace
			;; XXX 'sticky winodws?
			(car (window-workspaces win))))
      (message (format nil "win: %s > ws: %s\n class: %s > win-class-ws: %s" win window-ws (window-class win)
			   (single-window-mode-get-window-class-for-workspace window-ws)))
	(if (equal (window-class win)
		   (single-window-mode-get-window-class-for-workspace window-ws))
	    (single-window-mode-stop win)
	  (if (single-window-on-workspace-p window-ws)
	      (progn
		(single-window-mode-stop (single-window-mode-get-window-for-workspace window-ws))
		(single-window-mode-start win))
	  (single-window-mode-start win))))
    (message (format nil "%s" single-window-mode-list)))

  (define-command 'toggle-single-window-mode toggle-single-window-mode)

  (define (single-window-mode-core start w)
    (let ((iconify-group-mode 'none)
	  (raise-windows-on-uniconify nil)
	  (default-window-animator 'none))
      (if start
          (progn (message (format nil "starting"))
	  (map-other-window-groups
	    (lambda (x)
	      (when (windows-share-workspace-p w x)
		(if (or (window-get x 'ignore)
			(window-get x 'avoid))
		    (lower-window x)
		  (iconify-window x)))) w))
        (message (format nil "stopping"))
	(map-other-window-groups
	    (lambda (x)
	      (when (windows-share-workspace-p w x)
		(if (or (window-get x 'ignore)
			(window-get x 'avoid))
		    (raise-window x)
		  (uniconify-window x)))) w))))

  (define (single-window-mode-start w)
    "Start single-window-mode for window `w'."
    
    (when single-window-mode-window-fullscreen
      (maximize-window-fullscreen w t))

    (single-window-mode-list-append (if (window-on-current-workspace-p w)
					current-workspace
				      (car (window-workspaces w)))
				    (window-class w))

    (single-window-mode-core t w))

  (define (single-window-mode-stop w)
    "Stop single-window-mode for window `w'."
    
    (when single-window-mode-window-fullscreen
      (unmaximize-window w))

    (single-window-mode-list-remove (if (window-on-current-workspace-p w)
					current-workspace
				      (car (window-workspaces w)))
				    (window-class w))

    (single-window-mode-core nil w))

  (define (single-window-mode-after-add-window w)
    (when (window-get w 'single-window)
      (toggle-single-window-mode w)))

  (define (single-window-mode-unmap-notify w)
    (let ((class (window-class w))
	  (ws (single-window-mode-get-workspace-for-window (window-class w)))
	  (in-list (window-in-single-window-mode-list-p (window-class w))))
      (message (format nil "unmap notify: ws: %s > class: %s > in-list: %s" ws class in-list))
      (when in-list
	(single-window-mode-list-remove ws class)
	(map-windows (lambda (x)
	  (if (or (window-get x 'ignored)
		  (window-get x 'avoid))
	      (raise-window x)
	    (uniconify-window x)))
	  (workspace-windows ws)))
      (message (format nil "unmap notify: %s" single-window-mode-list))))

  (unless batch-mode
    (add-hook 'after-add-window-hook single-window-mode-after-add-window t)
    (add-hook 'unmap-notify-hook single-window-mode-unmap-notify t)))

;; modifier-list.jl -- widget for a list of modifier keys
;;
;; Author: John Harper <john@dcs.warwick.ac.uk>
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.modifier-list

    (export )

    (open rep
          rep.regexp
          sawfish.gtk.widget)

  ;; XXX should read the non-null modifiers from the wm?

  (define modifiers '(shift control meta alt hyper super))

  (define (list->symbol x)
    (if (null x)
	nil
      (intern (mapconcat symbol-name x #\space))))

  (define (symbol->list x)
    (if (not x)
	'()
      (mapcar (lambda (x)
		(intern (string-downcase x)))
	      (string-split "[-,; \t]" (symbol-name x)))))

  (define (validp x)
    (and (listp x)
	 (not (null x))
	 (let loop ((rest x))
	   (cond ((null rest) t)
		 ((not (memq (car rest) modifiers)) nil)
		 (t (loop (cdr rest)))))))

  (define (make-item changed-callback)
    (let (base)

      (define (real-changed)
	(let ((value (widget-ref base)))
	  (when (validp (symbol->list value))
	    (changed-callback))))

      (setq base (make-widget `(symbol ,@modifiers) real-changed))

      (lambda (op)
	(case op
	  ((set) (lambda (x) (widget-set base (list->symbol x))))
	  ((ref) (lambda () (symbol->list (widget-ref base))))
	  ((validp) validp)
	  (t (base op))))))

  (define-widget-type 'modifier-list make-item))

;; workspace-grid.jl -- Workspace Grid
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.
;;
;; Author: Michael Toomim <toomim@cs.berkeley.edu>

;; Commentary:

;; Provides a virtual desktop "grid" abstraction, using workspaces. In
;; effect, this emulates viewports with workspaces

;; Gets desktop layout information from the _NET_DESKTOP_LAYOUT root
;; property according to a proposed ICWWM EWMH spec.  Accounts for bugs
;; in gnome2's implementation.

(define-structure sawfish.wm.ext.workspace-grid

    (export workspace-up
	    workspace-down
	    workspace-right
	    workspace-left

	    send-to-workspace-up
	    send-to-workspace-down
	    send-to-workspace-left
	    send-to-workspace-right

	    ;; Useful for edge-flip functions, etc.
	    get-workspace-up
	    get-workspace-down
	    get-workspace-left
	    get-workspace-right)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.workspace
	  sawfish.wm.commands)

;;; Public Variables

  (defvar overriden-pager-vertical-p nil
    "Set this to t if you have no _NET_DESKTOP_LAYOUT root property and
want your workspaces to behave as if they were on a vertical pager.")

  (defvar overriden-num-workspace-rows nil
    "If you have no _NET_DESKTOP_LAYOUT root property, set this to the
number of rows your workspaces are arranged in")

;;; Public Commands

  ;; Move current workspace commands
  (define (workspace-down)
    "View the workspace below the current workspace"
    (safe-select-workspace
     (get-workspace-down current-workspace 1)))

  (define (workspace-up)
    "View the workspace above the current workspace"
    (safe-select-workspace
     (get-workspace-up current-workspace 1)))

  (define (workspace-left)
    "View the workspace to the left of the current workspace"
    (safe-select-workspace
     (get-workspace-left current-workspace 1)))

  (define (workspace-right)
    "View the workspace to the right of the current workspace"
    (safe-select-workspace
     (get-workspace-right current-workspace 1)))

  ;;###autoload
  (define-command 'workspace-down workspace-down)
  (define-command 'workspace-up workspace-up)
  (define-command 'workspace-left workspace-left)
  (define-command 'workspace-right workspace-right)

  ;; "Send-window" commands
  (define (send-to-workspace-down window)
    "Send window to the workspace below the current workspace"
    (safe-send-to-workspace
     window
     (get-workspace-down current-workspace 1)))

  (define (send-to-workspace-up window)
    "Send window to the workspace above the current workspace"
    (safe-send-to-workspace
     window
     (get-workspace-up current-workspace 1)))

  (define (send-to-workspace-left window)
    "Send window to the workspace left of the current workspace"
    (safe-send-to-workspace
     window
     (get-workspace-left current-workspace 1)))

  (define (send-to-workspace-right window)
    "Send window to the workspace right of the current workspace"
    (safe-send-to-workspace
     window
     (get-workspace-right current-workspace 1)))

  ;;###autoload
  (define-command 'send-to-workspace-down send-to-workspace-down #:spec "%W")
  (define-command 'send-to-workspace-up send-to-workspace-up #:spec "%W")
  (define-command 'send-to-workspace-left send-to-workspace-left #:spec "%W")
  (define-command 'send-to-workspace-right send-to-workspace-right #:spec "%W")

;;; Public Procedures

  ;; The workspace-switcher makes a desktop grid by splitting a sequence of
  ;; workspaces into rows and columns.
  ;;
  ;; With a horizontal panel, workspaces line up as
  ;;    1 2 3
  ;;    4 5 6
  ;; but with a vertical panel, they line up as
  ;;    1 4
  ;;    2 5
  ;;    3 6
  ;;
  ;; I take the convention that a "row" is a sequence of consecutive
  ;; workspaces (horizontal for a horizontal panel, vertical for a vertical
  ;; panel), and a "column" is the opposite (vertical on a horizontal panel,
  ;; horizontal on a vertical panel).  This way, I can just think about what
  ;; the coordinate code is supposed to do on horizontal panels, and then
  ;; translate it to "up", "down", "left", "right", etc. later.
  ;;
  ;; A `coordinates' object consists of the pair (column . row).

  ;; Get workspace in user-coordinate directions
  (define (get-workspace-down workspace distance)
    "Returns the workspace `distance' squares below `workspace' in the
pager, or nil of none exists."
    (let ((coords (workspace->coordinates workspace)))
      (coordinates->workspace
       (if (pager-vertical-p)
	   (cons (+ distance (car coords))
		 (cdr coords))
	 (cons (car coords)
	       (+ distance (cdr coords)))))))

  (define (get-workspace-right workspace distance)
    "Returns the workspace `distance' squares right of `workspace' in
the pager, or nil of none exists."
    (let ((coords (workspace->coordinates workspace)))
      (coordinates->workspace
       (if (pager-vertical-p)
	   (cons (car coords)
		 (+ distance (cdr coords)))
	 (cons (+ distance (car coords))
	       (cdr coords))))))

  (define (get-workspace-up workspace distance)
    "Returns the workspace `distance' squares above `workspace' in the
pager, or nil of none exists."
    (get-workspace-down workspace (- distance)))

  (define (get-workspace-left workspace distance)
    "Returns the workspace `distance' squares left of `workspace' in
the pager, or nil of none exists."
    (get-workspace-right workspace (- distance)))

;;; Private Procedures

  (define (num-workspaces)
    (let ((limits (workspace-limits)))
      (- (cdr limits) (car limits) -1)))

  ;; Defaults to horizontal, in case there is no _NET_DESKTOP_LAYOUT property
  (define (pager-vertical-p #!optional property)
    (or overriden-pager-vertical-p
	(let ((prop (or property
			(get-x-property 'root '_NET_DESKTOP_LAYOUT))))
	  (and prop
	       (= (aref (caddr prop) 0)
		  1)))))

  (define-macro (swap x y)
    `(setq ,x (prog1 ,y (setq ,y ,x))))

  (define (num-workspace-rows)
    (or overriden-num-workspace-rows

	(let ((layout-property (get-x-property 'root '_NET_DESKTOP_LAYOUT)))

	  ;; Property is of the form (CARDINAL 32 [orientation x y])
	  ;; Orientation horizontal=0, vert=1
	  ;; x is always sideways
	  ;; y is always vertical
	  ;; x or y are optional (can be zero)

	  ;; Bugs in gnome2: x and y are switched, orientation is always
	  ;; horizontal
	  (if (not layout-property)
	      1				;Default to 1 row

	    (let ((cols (aref (caddr layout-property) 1))
		  (rows (aref (caddr layout-property) 2)))

	      ;; Since we're translating (x,y) to (cols,rows), swap if values
	      ;; are for a vertical pager,
  	      (when (= (aref (caddr layout-property) 0) 1)
  		(swap cols rows))

	      (if (= rows 0)
		  ;; Compute rows from colums and num-workspaces
		  (let ((total (num-workspaces)))
		    (+ (quotient total cols)
		       (if (= (remainder total cols) 0)
			   0
			 1)))
		rows))))))

  (define (num-workspaces-per-row)
    (quotient (num-workspaces) (num-workspace-rows)))

  ;; Existence
  (define (coordinates-exist-p coords)
    (and (>= (car coords) 0)
	 (< (car coords) (num-workspaces-per-row))
	 (>= (cdr coords) 0)
	 (< (cdr coords) (num-workspace-rows))))

  ;; Coordinate Mapping
  (define (workspace->coordinates workspace)
    "Returns zero-based (column . row) coordinates of `workspace' in pager."
    (let ((normalized-workspace-index (- workspace (car (workspace-limits))))
	  (row-size (num-workspaces-per-row)))
      (cons (modulo normalized-workspace-index row-size)
	    (quotient normalized-workspace-index row-size))))

  (define (coordinates->workspace coordinates)
    "Returns the workspace at `coordinates', or nil if coordinates are invalid"
    (when (coordinates-exist-p coordinates)
      (+ (car (workspace-limits))	;min real workspace
	 (car coordinates)		;column
	 (* (cdr coordinates)		;row
	    (num-workspaces-per-row)))))

  ;; Misc
  (define (safe-select-workspace workspace)
    "Selects `workspace' iff non-nil"
    (when workspace
      (select-workspace workspace)))

  (define (safe-send-to-workspace window workspace)
    "Sends `window' to `workspace' and selects `workspace' iff
workspace is non-nil."
    (when workspace
      (send-to-next-workspace window
			      (- workspace current-workspace) nil t))))

;; smart-placement.jl -- ``intelligent'' window placement

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Commentary:

;; This implements two different algorithms: first-fit and best-fit.

;; Both use the same inner core -- they scan for the position to place
;; the window where it overlaps the smallest area with other windows

;; The two algorithms differ where more than one position has this
;; smallest overlap area. The first-fit algorithm takes the first such
;; position found, while the best-fit algorithm tries to choose the
;; best such position.

;; The cost function used for the best-fit currently tries to combine
;; two factors: the future ``usefulness'' of the chosen space, and the
;; number (and size) of the window edges the window will abut when
;; placed in the position

(define-structure sawfish.wm.placement.smart

    (export sp-do-placement
	    sp-first-fit
	    sp-best-fit
	    sp-fit-or-nil
	    sp-cost:grid-lines
	    sp-cost:aligned-edges
	    sp-cost:pointer-locality
	    sp-cost:focus-locality
	    sp-cost:center-locality
	    sp-cost:overlap)

    (open rep
	  sawfish.wm.util.rects
	  sawfish.wm.util.groups
	  sawfish.wm.util.workarea
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.placement
	  sawfish.wm.custom
	  sawfish.wm.workspace)

;;; options/variables

  (defvar sp-avoided-windows-weight 100)
  (defvar sp-normal-windows-weight 1)

  (defvar sp-padding 0
    "Try to leave at least this many pixels between window edges in
first/best-fit.")

  ;; the maximum number of points to keep in each grid dimension
  (defvar sp-max-points 10)

  ;; only when there's fewer X events than this pending do we try
  ;; to do smart placement
  (defvar sp-max-queued-events 256)

;;; utility functions

  ;; RECTS is a list of (LEFT TOP RIGHT BOTTOM); returns sorted, uniquified
  ;; (X-EDGES . Y-EDGES)
  (define (sp-make-grid rects #!optional with-root)
    (let ((grid (grid-from-rectangles rects)))
      ;; XXX fix for multiple heads
      (when with-root
	(unless (memql 0 (car grid))
	  (rplaca grid (cons 0 (car grid))))
	(unless (memql (screen-width) (car grid))
	  (rplaca grid (cons (screen-width) (car grid))))
	(unless (memql 0 (cdr grid))
	  (rplacd grid (cons 0 (cdr grid))))
	(unless (memql (screen-height) (cdr grid))
	  (rplacd grid (cons (screen-height) (cdr grid)))))
      (rplaca grid (sort (sp-prune-points (car grid) sp-max-points
					  (cons 0 (screen-width)))))
      (rplacd grid (sort (sp-prune-points (cdr grid) sp-max-points
					  (cons 0 (screen-height)))))
      grid))

  (define (sp-prune-points points maximum range)
    (setq points (delete-if-not (lambda (p)
				  (and (>= p (car range)) (<= p (cdr range))))
				points))
    (let ((total (length points)))
      (cond ((> total maximum)
	     ;; remove points
	     (let ((cutoff (* (max 0 (- total maximum)) 100)))
	       (setq total (* total 100))
	       (delete-if (lambda (unused)
			    (declare (unused unused))
			    (< (random total) cutoff)) points)))
	    ((< total maximum)
	     ;; add points
	     (while (< total maximum)
	       (setq points (cons (+ (car range)
				     (random (- (cdr range) (car range))))
				  points))
	       (setq total (1+ total)))))
      points))

  ;; returns the list of windows to compare with when overlapping, by
  ;; default windows with their `ignored' property set are dropped
  (define (sp-get-windows w #!optional pred)
    (filter-windows
     (lambda (x)
       (not (or (eq x w)
		(not (window-mapped-p x))
		(and (or (and pred (not (pred x))) (window-get x 'ignored))
		     (not (window-avoided-p x)))
		(window-get x 'iconified)
		(not (windows-share-workspace-p x w)))))))

;;; calculating overlaps

  ;; returns (POINT . OVERLAP), find the alignment of the rectangle
  ;; of dimensions DIMS at POINT with the least overlap compared to
  ;; RECTS
  (define (sp-least-overlap dims point rects)
    (let (min-overlap min-point)
      (mapc (lambda (delta)
	      (let ((point-foo (cons (+ (car point)
					(* (car delta) (car dims)))
				     (+ (cdr point)
					(* (cdr delta) (cdr dims)))))
		    tem)
		(when (and (>= (car point-foo) 0)
			   (>= (cdr point-foo) 0)
			   (<= (+ (car point-foo) (car dims)) (screen-width))
			   (<= (+ (cdr point-foo) (cdr dims)) (screen-height))
			   (= (rectangle-heads
			       (rectangle-from-coords point-foo dims)) 1))
		  (setq tem (rect-total-overlap dims point-foo rects))
		  (when (or (not min-point) (< tem min-overlap))
		    (setq min-overlap tem)
		    (setq min-point point-foo)))))
	    ;; try aligning all four corners to this point
	    '((0 . 0) (0 . -1) (-1 . 0) (-1 . -1)))
      (and min-point (cons min-point min-overlap))))

;;; first-fit search

  (define (sp-first-fit dims grid rects)
    (let ((point (cons 0 0))
	  min-point min-overlap tem)
      (catch 'done
	(mapc (lambda (y)
		(rplacd point y)
		(mapc (lambda (x)
			(rplaca point x)
			(setq tem (sp-least-overlap dims point rects))
			(when tem
			  (when (zerop (cdr tem))
			    (throw 'done (car tem)))
			  (when (or (not min-overlap)
				    (< (cdr tem) min-overlap))
			    (setq min-overlap (cdr tem))
			    (setq min-point (car tem)))))
		      (car grid)))
	      (cdr grid))
	;; no zero overlap point, use the point with least overlap
	min-point)))

  (define (sp-fit-or-nil dims grid rects)
    (let ((point (cons 0 0))
	  tem)
      (catch 'done
	(mapc (lambda (y)
		(rplacd point y)
		(mapc (lambda (x)
			(rplaca point x)
			(setq tem (sp-least-overlap dims point rects))
			(when (and tem (zerop (cdr tem)))
			  (throw 'done (car tem))))
		      (car grid)))
	      (cdr grid))
	nil)))

;;; best-fit search

  (defmacro sp-edges-adjacent (align-1 start-1 end-1 align-2 start-2 end-2)
    `(if (= ,align-1 ,align-2)
	 (rect-1d-overlap ,start-1 ,end-1 ,start-2 ,end-2)
       0))

  (define (sp-cost:grid-lines point dims grid rects)
    "Smart placement cost function. Cost is proportional to the number of grid
lines that the proposed placement crosses."
    (declare (unused rects))
    (let ((win-left (car point))
	  (win-top (cdr point))
	  (win-right (+ (car point) (car dims)))
	  (win-bottom (+ (cdr point) (cdr dims)))
	  (x-cross 0)
	  (y-cross 0)
	  (x-total 0)
	  (y-total 0))
      ;; count the number of grid lines this position crosses
      ;; the idea is to maximize this, since it's likely that it
      ;; will use up the annoying small parts of the screen
      (mapc (lambda (x)
	      (when (and (>= x win-left) (<= x win-right))
		(setq x-cross (1+ x-cross)))
	      (setq x-total (1+ x-total)))
	    (car grid))
      (mapc (lambda (y)
	      (when (and (>= y win-top) (<= y win-bottom))
		(setq y-cross (1+ y-cross)))
	      (setq y-total (1+ y-total)))
	    (cdr grid))
      (/ (* x-cross y-cross) (* x-total y-total))))

  (define (sp-cost:aligned-edges point dims grid rects)
    "Smart placement cost function. Cost is proportional to the length of the
edges that the proposed placement abuts."
    (declare (unused grid))
    (let ((win-left (car point))
	  (win-top (cdr point))
	  (win-right (+ (car point) (car dims)))
	  (win-bottom (+ (cdr point) (cdr dims)))
	  (edges (make-vector 4 0)))
      ;; how many window edges does this position abut?
      ;; it can save space to cluster windows as much as possible
      (mapc (lambda (r)
	      (aset edges 0 (max (sp-edges-adjacent
				  win-right win-top win-bottom
				  (car r) (nth 1 r) (nth 3 r))
				 (aref edges 0)))
	      (aset edges 1 (max (sp-edges-adjacent
				  win-left win-top win-bottom
				  (nth 2 r) (nth 1 r) (nth 3 r))
				 (aref edges 1)))
	      (aset edges 2 (max (sp-edges-adjacent
				  win-bottom win-left win-right
				  (nth 1 r) (car r) (nth 2 r))
				 (aref edges 2)))
	      (aset edges 3 (max (sp-edges-adjacent
				  win-top win-left win-right
				  (nth 3 r) (car r) (nth 2 r))
				 (aref edges 3))))
	    rects)
      (/ (+ (aref edges 0) (aref edges 1)
	    (aref edges 2) (aref edges 3))
	 (+ (* 2 (car dims)) (* 2 (cdr dims))))))

  ;; calculate the cost associated with the distance between POINT-1 and
  ;; POINT-2. As they get nearer the cost tends to zero, as they get
  ;; further apart the cost tends to one (hopefully)
  (define (sp-cost-from-distance point-1 point-2)
    (/ (sqrt (+ (expt (- (screen-width)
			 (abs (- (car point-2) (car point-1)))) 2)
		(expt (- (screen-height)
			 (abs (- (cdr point-2) (cdr point-1)))) 2)))
       (sqrt (+ (expt (screen-width) 2) (expt (screen-height) 2)))))

  (define (sp-cost:pointer-locality point dims grid rects)
    "Smart placement cost function. Cost is proportional to the distance
from the proposed placement to the current pointer position."
    (declare (unused grid rects))
    (sp-cost-from-distance (rectangle-center* point dims) (query-pointer)))

  (define (sp-cost:focus-locality point dims grid rects)
    "Smart placement cost function. Cost is proportional to the distance from
the proposed placement to the position of the currently focused window."
    (declare (unused grid rects))
    (let ((focus (input-focus)))
      (if focus
	  (sp-cost-from-distance (rectangle-center* point dims)
				 (rectangle-center* (window-position focus)
						    (window-dimensions focus)))
	1)))

  (define (sp-cost:center-locality point dims grid rects)
    "Smart placement cost function. Cost is proportional to the distance from
the proposed placement to the center of the screen."
    (declare (unused grid rects))
    (sp-cost-from-distance (rectangle-center* point dims)
			   (cons (/ (screen-width) 2) (/ (screen-height) 2))))

  (define (sp-cost:overlap point dims grid rects overlap)
    (declare (unused point dims grid rects))
    (exp (- (/ overlap (* (screen-width) (screen-height))))))

  (defvar sp-cost-components (list (cons sp-cost:overlap 7/8)
				   (cons sp-cost:center-locality 1/8))
    "Alist defining smart placement cost functions and their
associated weights (multipliers).")

  ;; This is the crux of the problem -- this function must assign a value
  ;; to placing a window of DIMS at POINT. GRID defines the grid from which
  ;; POINT was chosen, RECTS defines all other windows on the screen.
  ;; The returned value must be non-negative, with higher values reflecting
  ;; better placements
  (define (sp-cost point dims grid rects overlap)
    (let ((total 0))
      (mapc (lambda (cell)
	      (setq total
		    (+ total (* ((car cell) point dims grid rects overlap)
				(cdr cell)))))
	    sp-cost-components)
      total))

  (define (sp-best-fit dims grid rects)
    (let ((point (cons 0 0))
	  points tem)

      ;; 1. find the list of possible placements (POINT . OVERLAP)
      (mapc (lambda (y)
	      (rplacd point y)
	      (mapc (lambda (x)
		      (rplaca point x)
		      (setq tem (sp-least-overlap dims point rects))
		      (when tem
			(setq points (cons tem points))))
		    (car grid)))
	    (cdr grid))

      ;; 2. choose the best of these points
      (cond ((null points)
	     ;; no choice
	     nil)
	    ((null (cdr points))
	     ;; one choice
	     (caar points))
	    (t
	     ;; n choices
	     (let ((max-cost 0)
		   (max-point nil))
	       (mapc (lambda (p)
		       (let ((cost (sp-cost (car p) dims grid rects (cdr p))))
			 (when (> cost max-cost)
			   (setq max-cost cost)
			   (setq max-point (car p)))))
		     points)
	       max-point)))))

;;; entry-points

  (define (sp-do-placement w fit-fun #!optional fall-back-fun
                           #!key window-filter)
    (if (and sp-max-queued-events (> (x-events-queued) sp-max-queued-events))
	;; fitted placement can cause event tailbacks when there's
	;; lots of windows being opened with lots of windows already
	;; open
	((placement-mode 'randomly) w)
      (let* ((windows (sp-get-windows w window-filter))
	     (rects (rectangles-from-windows
		     windows
		     (lambda (x)
		       (cond ((window-avoided-p x)
			      sp-avoided-windows-weight)
			     ((window-get x 'placement-weight))
			     (t sp-normal-windows-weight)))))
	     (grid (sp-make-grid rects t))
	     (dims (window-frame-dimensions w))
	     (workarea (calculate-workarea #:window w))
	     (workarea-width (- (nth 2 workarea) (nth 0 workarea)))
	     (workarea-height (- (nth 3 workarea) (nth 1 workarea)))
	     point)

	;; first try with padding
	(when (and (> sp-padding 0)
		   (<= (+ (car dims) (* sp-padding 2)) workarea-width)
		   (<= (+ (cdr dims) (* sp-padding 2)) workarea-height))
	  (let ((padded-dims (cons (+ (car dims) (* sp-padding 2))
				   (+ (cdr dims) (* sp-padding 2)))))
	    (setq point (fit-fun padded-dims grid rects)))
	  (when point
	    (rplaca point (+ (car point) sp-padding))
	    (rplacd point (+ (cdr point) sp-padding))))

	;; then try without padding
	(when (null point)
	  (let ((smallest-dims (cons (min (car dims) workarea-width)
				     (min (cdr dims) workarea-height))))
	    (setq point (fit-fun smallest-dims grid rects))))

	(if point
	    (move-window-to w (car point) (cdr point))
	  ((or fall-back-fun (placement-mode 'randomly)) w)))))

  (define (place-window-first-fit w)
    (sp-do-placement w sp-first-fit))

  (define (place-window-best-fit w)
    (sp-do-placement w sp-best-fit))

  (define (place-window-best-fit-group w)
    (let ((group (windows-in-group w)))
      (sp-do-placement w sp-best-fit nil
		       #:window-filter (lambda (x) (memq x group)))))

  (define (place-window-first-fit-or-interactive w)
    (sp-do-placement w sp-fit-or-nil (placement-mode 'interactively)))


;;; init

  ;;###autoload
  (define-placement-mode 'first-fit place-window-first-fit #:for-normal t)
  (define-placement-mode 'best-fit place-window-best-fit #:for-normal t)
  (define-placement-mode 'best-fit-group
    place-window-best-fit-group #:for-normal t)
  (define-placement-mode 'first-fit-or-interactive
    place-window-first-fit-or-interactive #:for-normal t))

;; edge/actions.jl -- Sets up central user interface of edge-actions

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.actions

    (export activate-edges
	    activate-edges-after-set)

    (open rep
	  rep.system
	  rep.io.timers
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.edge.conf
	  sawfish.wm.edge.util
	  sawfish.wm.edge.expand
	  sawfish.wm.edge.flip
	  sawfish.wm.edge.hot-spots
	  sawfish.wm.edge.misc
	  sawfish.wm.edge.viewport-drag
	  sawfish.wm.workspace)

  (define-structure-alias edge-actions sawfish.wm.edge.actions)

  (defvar while-hot-move nil)
  (defvar while-mousetrap nil)
  (define edge-action-timer nil)

  (define (edge-action-call func edge while-moving)
    (case func
      ((viewport-drag)
       (viewport-drag-invoke edge while-moving))
      ((flip-workspace)
       (edge-flip-invoke edge func while-moving))
      ((flip-viewport)
       (edge-flip-invoke edge func while-moving))
      ((expand-window)
       (expand-action edge))
      ((maximize-window)
       (maximize-action))
      ((kill-window)
       (kill-action))
      ((iconify-window)
       (iconify-action))
      ((move-window-viewport)
       (move-window-viewport-action edge))
      ((move-window-workspace)
       (move-window-workspace-action edge))
      ((show-desktop)
       (toggle-desktop))
      ((none/hot-spot)
       (hot-spot-invoke edge))
      ((none/hot-move)
       (hot-move-invoke edge))
      (t nil)))

  ;; Entry point without dragging a window
  (define (edge-action-hook-func)
    (unless (or while-hot-move
	        while-mousetrap)
      (let ((corner (get-active-corner))
   	    (edge (get-active-edge)))
        (if corner
	    (hot-spot-invoke corner)
	  (let ((func (case edge
	              ((left) left-edge-action)
	              ((right) right-edge-action)
	              ((top) top-edge-action)
	              ((bottom) bottom-edge-action))))
	    (setq edge-action-timer
              (make-timer (lambda ()
                            (setq edge-action-timer nil)
	                    (funcall edge-action-call func edge nil))
	                  (quotient edge-flip-delay 1000)
                          (mod edge-flip-delay 1000))))))))

  ;; Entry point while dragging a window
  (define (edge-action-move-hook-func)
    (unless while-mousetrap
      (setq while-hot-move t)
      (let ((edge (get-active-edge)))
	 (let ((func (case edge
	             ((left) left-edge-move-action)
	             ((right) right-edge-move-action)
	             ((top) top-edge-move-action)
	             ((bottom) bottom-edge-move-action))))
	   (setq edge-action-timer
            (make-timer (lambda ()
                          (setq edge-action-timer nil)
	                  (funcall edge-action-call func edge t))
	                (quotient edge-flip-delay 1000)
                        (mod edge-flip-delay 1000))))
      ;; for one second after HotMove prevent HotSpot
      (make-timer (lambda () (setq while-hot-move nil)) 1))))

  (define (edge-action-unhook-func)
    (when edge-action-timer
      (delete-timer edge-action-timer)
      (setq edge-action-timer nil)))

  (define (activate-edges init)
    (if init
	(progn
	  (activate-flippers t)
	  (unless (in-hook-p 'enter-flipper-hook edge-action-hook-func)
	    (add-hook 'enter-flipper-hook edge-action-hook-func))
	  (unless (in-hook-p 'leave-flipper-hook edge-action-unhook-func)
	    (add-hook 'leave-flipper-hook edge-action-unhook-func))
	  ;; While the pointer is grabbed, window enter/leave events
	  ;; are not generated.
	  (unless (in-hook-p 'while-moving-hook edge-action-move-hook-func)
	    (add-hook 'while-moving-hook edge-action-move-hook-func)))
      (activate-flippers nil)
      (remove-hook 'enter-flipper-hook edge-action-hook-func)
      (remove-hook 'while-moving-hook edge-action-move-hook-func)))

  (define (activate-edges-after-set)
    (activate-edges edge-actions-enabled)))

;; help.jl -- commands for the help menu

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.help

    (export help-call-info)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  sawfish.wm.commands
	  sawfish.wm.commands.launcher)

  ;; Info

  (define (help-call-info document node)
    (xterm (format nil "info '%s' '%s'"
                   document node)))

  (defvar help-display-info-function help-call-info)

  ;; Commands

  (define (show-faq) (help-display-info-function "sawfish" "FAQ"))

  (define (show-news) (help-display-info-function "sawfish" "News"))

  (define (show-programmer-manual)
    (help-display-info-function "sawfish" "Top"))

  (define (show-homepage) (browser "http://sawfish.wikia.com/"))

  (define (show-about)
    (system "sawfish-about >/dev/null 2>&1 </dev/null &"))

  ;;###autoload
  (define-command 'help:show-faq show-faq)
  (define-command 'help:show-news show-news)
  (define-command 'help:show-programmer-manual show-programmer-manual)
  (define-command 'help:show-homepage show-homepage)
  (define-command 'help:about show-about))

;; size-window -- resizing window iteratively (like `C-x ^' in emacs)

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.size-window

    (export size-window
	    size-window-add-row
	    size-window-subtract-row
	    size-window-add-column
	    size-window-subtract-column)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.custom)

  (defvar size-window-def-increment 16
    "Default increment for size-window commands (when the window doesn't
specify it's own increments).")

  (define (size-window w cols rows)
    "Increase the size of window W by COLS columns and ROWS rows (each of which
may be negative). If the window doesn't define it's increment size, then the
size of each row or column is taken from `size-window-def-increment.'"
    (let* ((hints (window-size-hints w))
	   (dims (window-dimensions w))
	   (x-base (or (cdr (or (assq 'base-width hints)
				(assq 'min-width hints))) 1))
	   (x-inc (or (cdr (assq 'width-inc hints))
		      size-window-def-increment))
	   (y-base (or (cdr (or (assq 'base-height hints)
				(assq 'min-height hints))) 1))
	   (y-inc (or (cdr (assq 'height-inc hints))
		      size-window-def-increment))
	   (x-max (cdr (assq 'max-width hints)))
	   (y-max (cdr (assq 'max-height hints)))
	   (scale (lambda (x base inc maximum)
		    (min (+ base (* inc (max 0 x))) (or maximum 65535))))
	   (descale (lambda (x base inc)
		      (quotient (- x base) inc))))

      ;; use the configure-request handler (to handle gravity)
      (call-window-hook
       'configure-request-hook w
       (list (list (cons 'dimensions
			 (cons (scale (+ (descale (car dims) x-base x-inc)
					 cols) x-base x-inc x-max)
			       (scale (+ (descale (cdr dims) y-base y-inc)
					 rows) y-base y-inc y-max))))))))

  (define (size-window-add-row w)
    "Increase the size of the current window by one row."
    (size-window w 0 +1))

  (define (size-window-subtract-row w)
    "Decrease the size of the current window by one row."
    (size-window w 0 -1))

  (define (size-window-add-column w)
    "Increase the size of the current window by one column."
    (size-window w +1 0))

  (define (size-window-subtract-column w)
    "Decrease the size of the current window by one column."
    (size-window w -1 0))

  ;;###autoload
  (define-command 'size-window-add-row size-window-add-row
    #:spec "%W")
  (define-command 'size-window-subtract-row size-window-subtract-row
    #:spec "%W")
  (define-command 'size-window-add-column size-window-add-column
    #:spec "%W")
  (define-command 'size-window-subtract-column size-window-subtract-column
    #:spec "%W"))

#| nokogiri-widgets/frame-style.jl -- theme chooser widget

   $Id: frame-style.jl,v 1.7 2000/11/27 18:13:51 jsh Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure sawfish.ui.widgets.frame-style ()

    (open rep
	  gui.gtk
	  rep.regexp
	  rep.io.files
	  sawfish.gtk.widget
	  sawfish.ui.i18n)

  (define (make-frame-style-item changed-callback doc options path)

    (let ((vbox (gtk-vbox-new nil 0))
	  (hbox (gtk-hbox-new nil 0))
	  (combo (gtk-combo-new))
	  (doc-label (gtk-label-new doc))
	  (readme-text (gtk-text-new))
	  (readme-scroller (gtk-scrolled-window-new))
	  (value (car options)))

      (gtk-box-set-spacing hbox box-spacing)
      (gtk-box-set-spacing vbox box-spacing)
      (gtk-container-add readme-scroller readme-text)
      (gtk-box-pack-start hbox doc-label)
      (gtk-box-pack-start hbox combo t t)
      (gtk-box-pack-start vbox readme-scroller t t)
      (gtk-box-pack-start vbox hbox nil nil)
      (gtk-label-set-justify doc-label 'left)
      ;;(gtk-text-set-word-wrap readme-text 1)
      (gtk-editable-set-editable readme-text nil)
      (gtk-entry-set-editable (gtk-combo-entry combo) nil)
      (gtk-scrolled-window-set-policy readme-scroller 'automatic 'automatic)

      (gtk-combo-set-popdown-strings combo (mapcar symbol-name options))
      (when value
	(gtk-entry-set-text (gtk-combo-entry combo) (symbol-name value)))

      (gtk-signal-connect (gtk-combo-entry combo) "changed"
			  (lambda ()
			    (setq value (intern (gtk-entry-get-text
						 (gtk-combo-entry combo))))
			    (update-readme value readme-text path)
			    (call-callback changed-callback)))

      (update-readme value readme-text path)
      (gtk-widget-show-all vbox)

      (lambda (op)
	(case op
	  ((gtk-widget) vbox)
	  ((clear) (lambda ()))
	  ((set) (lambda (x)
		   (gtk-entry-set-text
		    (gtk-combo-entry combo) (symbol-name x))))
	  ((ref) (lambda () value))
	  ((validp) (lambda (x) (memq x options)))))))

  (define-widget-type 'frame-style make-frame-style-item)
  (widget-accepts-doc-string 'frame-style)

  (define (gtk-text-set widget string)
    (gtk-text-set-point widget 0)
    (gtk-text-forward-delete widget (gtk-text-get-length widget))
    (gtk-text-insert widget nil nil nil string (length string))
    (gtk-text-set-point widget 0))

  (define (update-readme value text-widget theme-path)
    (catch 'out
      (let ((theme (symbol-name value)))
	(mapc (lambda (dir)
		(let ((full (expand-file-name theme dir)))
		  (when (catch 'out
			  (mapc (lambda (suf)
				  (let ((dir (format nil suf full theme)))
				    (condition-case nil
					(when (file-directory-p dir)
					  (setq full dir)
					  (throw 'out t))
				      (error))))
				'("%s"))
			  nil)
		    (setq full (i18n-filename
				(expand-file-name "README" full)))
		    (if (file-exists-p full)
			(let ((text (make-string-output-stream))
			      (file (open-file full 'read)))
			  (unwind-protect
			      (progn
				(copy-stream file text)
				(setq text (get-output-stream-string text))
				(when (string-match "\\s+$" text)
				  (setq text (substring text 0 (match-start))))
				(gtk-text-set text-widget text))
			    (close-file file)))
		      (gtk-text-set text-widget ""))
		    (throw 'out t))))
	      theme-path)
	(gtk-text-set text-widget "")))))

;; wallpaper.jl - integrate wallpaper settings into Sawfish

;; (c) 2011 Lucas Pandolfo

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.wallpaper

  (export set-wallpaper
	  set-wallpaper-gnome
	  set-wallpaper-xfce)

  (open rep
	rep.system
	rep.io.files
	rep.util.misc
	sawfish.wm
	sawfish.wm.custom)

  ;; XXX KDE4 doesn't support shell-based changing
  ;; XXX of the wallpaper ... KDE3 did

  ;; XXX Need GNOME3 support

  (define-structure-alias wallpaper sawfish.wm.ext.wallpaper)

  (defgroup wallpaper "Wallpaper" :group appearance)

  (defcustom init-wallpaper nil
    "Whether to change wallpaper on startup."
    :type boolean
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper)))

  (defcustom root-wallpaper nil
    "Wallpaper to use: \\w"
    :type image
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper))
    :depends init-wallpaper)

  (defcustom wallpaper-setter ""
    "Application to set desktop wallpaper."
    :type file-name
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper))
    :depends init-wallpaper)

  (defcustom wallpaper-setter-args ""
    "Additional arguments to pass to the application."
    :type string
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper))
    :depends init-wallpaper)

  (defcustom set-wallpaper-gnome2 nil
    "Whether to apply wallpaper to GNOME2"
    :type boolean
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper))
    :depends init-wallpaper)

  (defcustom set-wallpaper-xfce4 nil
    "Whether to apply wallpaper to XFCE4"
    :type boolean
    :group (appearance wallpaper)
    :after-set (lambda () (set-wallpaper))
    :depends init-wallpaper)

  (defcustom wallpaper-display-type 'centered
    "How to display the image (only for GNOME2 and XFCE4)."
    :type (choice auto/none centered tiled scaled streched zoom spanned)
    :group (appearance wallpaper)
    :depends init-wallpaper
    :after-set (lambda () (set-wallpaper)))

  (define (set-wallpaper)
    (when (and init-wallpaper
	       (not (equal root-wallpaper ())))
    (if (file-exists-p root-wallpaper)
        (progn
	  (when set-wallpaper-xfce4
            (set-wallpaper-xfce))
	  (when set-wallpaper-gnome2
            (set-wallpaper-gnome))
          (when (and wallpaper-setter
	        (not (eq desktop-environment "gnome"))
		(not (eq desktop-environment "xfce")))
            (setq wallpaper-filename (concat " \"" root-wallpaper "\""))
	    (when (or (program-exists-p wallpaper-setter)
	              (file-exists-p wallpaper-setter))
	      (system (concat wallpaper-setter " " wallpaper-setter-args " " wallpaper-filename " &")))))
      (display-message (format nil "Wallpaper %s not found." root-wallpaper)))))

  (defvar gnome-type nil)
  (defvar xfce-type nil)
  (defvar wallpaper-filename nil)

  (define (set-wallpaper-gnome)
    (when (eq desktop-environment "gnome")
      (setq wallpaper-filename (concat " \"" root-wallpaper "\""))
	(case wallpaper-display-type
	  ((auto/none) (setq gnome-type "none"))
	  ;; unknown value to GNOME2
	  ((tiled) (setq gnome-type "none"))
	  (t (setq gnome-type wallpaper-display-type)))
	(system (concat "gconftool-2 --set --type string
			/desktop/gnome/background/picture_filename " wallpaper-filename " &"))
	(system (concat "gconftool-2 --set --type string
			/desktop/gnome/background/picture_options " gnome-type " &"))))

  (define (set-wallpaper-xfce)
    (when (eq desktop-environment "xfce")
      (setq wallpaper-filename (concat " \"" root-wallpaper "\""))
      (case wallpaper-display-type
	((auto/none) (setq xfce-type 0))
	((centered) (setq xfce-type 1))
	((tiled) (setq xfce-type 2))
	((scaled) (setq xfce-type 4))
	((stretched) (setq xfce-type 3))
	((zoom) (setq xfce-type 5))
	;; unknown value to XFCE4
	((spanned) (setq xfce-type 0)))
      (system (concat "xfconf-query -c xfce4-desktop -p /backdrop/screen0/monitor0/image-path
		      -s " wallpaper-filename " &"))
      (system (concat "xfconf-query -c xfce4-desktop -p /backdrop/screen0/monitor0/image-style
		      -s " xfce-type " &")))))

;; marks.jl -- provide a way to operate on multiple windows
;;
;; Copyright (C) Yann Hodique <Yann.Hodique@lifl.fr>
;;
;; This file is an official accepted contribution into sawfish.
;;
;; This script is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.marks

    (export mark-window
            unmark-window
            unmark-all-windows
            apply-on-marked-windows
            marked-windows)

    (open rep
          rep.system
          sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands)

  (define-structure-alias marks sawfish.wm.util.marks)

  (defvar marked-windows-list nil)

  (define (mark-window win)
    (setq marked-windows-list (append marked-windows-list (list win))))

  (define-command 'mark-window mark-window #:spec "%W")

  (define (unmark-window win)
    (setq marked-windows-list (remove win marked-windows-list)))

  (define-command 'unmark-window unmark-window #:spec "%W")

  (define (unmark-all-windows)
    (setq marked-windows-list nil))

  (define-command 'unmark-all-windows unmark-all-windows)

  (define (apply-on-marked-windows func)
    (mapcar func marked-windows-list))

  (define (marked-windows)
    (not (eq marked-windows-list nil))))

;; This USED to be the theme.jl from the microGUI theme by
;; Ryan Lovett, Ben FrantzDale, and John Harper.  Big props to them, and
;; here's to hoping someone will write a decent HOWTO for sawfish-themer
;; because I really, _really_ suck at scheme coding.

;; This theme is GPL, unless Ryan, Ben, or John have a problem with that.
;; I just got tired of there not being many non-hideous themes for Sawfish.

;; Modified to add tabbed windowing support by Scott Scriven.


;;(define title-width
;;  (lambda (w)
;;    (let
;;        ((w-width (car (window-dimensions w))))
;;      (max 0 (min (- w-width 100) (text-width (window-name w)))))))

(define theme-name 'Elberg-tabbed)

;; 6x19 - upper left corner
(define upper-left-images (list (make-image "i-ul.png")
                                (make-image "a-ul.png")))
(define upper-left-shaped-images (list (make-image "i-uls.png")
                                (make-image "a-uls.png")))

;; 16x19 - upper left menu button
(define menu-images 
  (list (make-image "i-th.png")
        (make-image "a-th.png")
        (make-image "p-th.png")
        (make-image "c-th.png")))

;; 11x19 - upper left grey to green border
(define top-lefthollow-images 
  (list (make-image "i-t1.png")
        (make-image "a-t1.png")))

;; 3x19 - upper green background
(define top-hollow-images 
  (list (make-image "i-t2.png")
        (make-image "a-t2.png")))

;; 11x19 - upper right green to grey border
(define top-righthollow-images 
  (list (make-image "i-t3.png")
        (make-image "a-t3.png")))

;; 3x19 - upper grey background
(define top-grey-images 
  (list (make-image "i-t0.png")
        (make-image "a-t0.png")))

;; 17x16 - iconify icon
(define iconify-images 
  (list (make-image "i-ti.png")
        (make-image "a-ti.png")
        (make-image "p-ti.png")
        (make-image "c-ti.png")))

;; 17x16 - maximize icon
(define maximize-images 
  (list (make-image "i-tm.png")
        (make-image "a-tm.png")
        (make-image "p-tm.png")
        (make-image "c-tm.png")))

;; 17x16 - close icon
(define close-images 
  (list (make-image "i-tx.png")
        (make-image "a-tx.png")
        (make-image "p-tx.png")
        (make-image "c-tx.png")))

;; 18x6 - upper right corner
(define upper-right-images 
  (list (make-image "i-ur.png")
        (make-image "a-ur.png")))

(define upper-right-shaped-images 
  (list (make-image "i-urs.png")
        (make-image "a-urs.png")))

;; 6x18 - left side
(define left-side-images 
  (list (make-image "i-ls.png")
        (make-image "a-ls.png")))

;; 6x18 - right side
(define right-side-images 
  (list (make-image "i-rs.png")
        (make-image "a-rs.png")))

;; 6x6 - lower left corner
(define bottom-left-images 
  (list (make-image "i-ll.png")
        (make-image "a-ll.png")))

;; 18x6 - lower ledge
(define bottom-images 
  (list (make-image "i-bot.png")
        (make-image "a-bot.png")))

;; 6x6 - lower right corner
(define bottom-right-images 
  (list (make-image "i-lr.png")
        (make-image "a-lr.png")))

;; 4x4
(define t-upper-left-images 
  (list (make-image "i-tul.png")
        (make-image "a-tul.png")))

;; 11x4
(define t-upper-side-images 
  (list (make-image "i-ttop.png")
        (make-image "a-ttop.png")))

;; 17x4
(define t-upper-right-images 
  (list (make-image "i-tur.png")
        (make-image "a-tur.png")))

(define t-upper-right-shaped-images 
  (list (make-image "i-turs.png")
        (make-image "a-turs.png")))

;; 4x17
(define t-left-images 
  (list (make-image "i-tls.png")
        (make-image "a-tls.png")))

;; 17x16
(define t-close-images 
  (list (make-image "i-ttx.png")
        (make-image "a-ttx.png")
        (make-image "p-ttx.png")
        (make-image "c-ttx.png")))

;; 17x3
(define t-right-images 
  (list (make-image "i-tt0.png")
        (make-image "a-tt0.png")))

;; 4x4
(define t-bottom-left-images 
  (list (make-image "i-tll.png")
        (make-image "a-tll.png")))

;; 11x4
(define t-bottom-side-images 
  (list (make-image "i-tbot.png")
        (make-image "a-tbot.png")))

;; 17x4
(define t-bottom-right-images 
  (list (make-image "i-tlr.png")
        (make-image "a-tlr.png")))

(define t-bottom-right-shaped-images 
  (list (make-image "i-tlrs.png")
        (make-image "a-tlrs.png")))

(define text-colors (list "grey50" "white"))

;; frame layout
(define frame
  `(((background . ,upper-left-images)
     (left-edge . -6)
     (top-edge . -19)
     (class . top-left-corner))
    
    ;; menu button
    ((background . ,menu-images)
     (top-edge . -19)
     (left-edge . 0)
     (class . menu-button))
    
    ;; top curves
    ;;((background . ,top-lefthollow-images)
    ;; (top-edge . -19)
    ;; ;(left-edge . 16)
    ;; (left-edge . 0)
    ;; (class . title))
    
    ;; top green
    ;;((background . ,top-hollow-images)
    ;; (foreground . ,text-colors)
    ;; (text . ,window-name)
    ;; (x-justify . 4)
    ;; (y-justify . center)
    ;; (top-edge . -19)
    ;; ;(left-edge . 27)
    ;; (left-edge . 11)
    ;; (width . ,(lambda (w) (+ (title-width w) 13)))
    ;; ;(right-edge . 27)
    ;; (class . title))
    
    ;; top curves
    ;;((background . ,top-righthollow-images)
    ;; ;(left-edge . ,(lambda (w) (+ (title-width w) 37)))
    ;; (left-edge . ,(lambda (w) (+ (title-width w) 21)))
    ;; ;(right-edge . 16)
    ;; (top-edge . -19)
    ;; (class . title))
    
    ;; top grey
    ;;((background . ,top-grey-images)
    ;; ;(left-edge . ,(lambda (w) (+ (title-width w) 48)))
    ;; (left-edge . ,(lambda (w) (+ (title-width w) 32)))
    ;; (top-edge . -19)
    ;; ;(right-edge . 48)
    ;; (right-edge . 16)
    ;; (class . title))
    
    ;; left border
    ((background . ,left-side-images)
     (left-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . left-border))
    
    ;; top-right corner
    ((background . ,upper-right-images)
     (right-edge . -6)
     (top-edge . -19)
     (class . top-right-corner))
    
    ;; right border
    ((background . ,right-side-images)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))
    
    ;; bottom border
    ((background . ,bottom-images)
     (left-edge . 0)
     (right-edge . 0)
     (bottom-edge . -6)
     (class . bottom-border))
    
    ;; bottom-left corner
    ((background . ,bottom-left-images)
     (left-edge . -6)
     (bottom-edge . -6)
     (class . bottom-left-corner))
    
    ;; bottom-right corner
    ((background . ,bottom-right-images)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))
    
    ;; iconify button
    ;;((background . ,iconify-images)
    ;; (right-edge . 32)
    ;; (top-edge . -19)
    ;; (class . iconify-button))
    
    ;; maximize button
    ;;((background . ,maximize-images)
    ;; (right-edge . 16)
    ;; (top-edge . -19)
    ;; (class . maximize-button))
    
    ;; delete button
    ((background . ,close-images)
     (right-edge . 0)
     (top-edge . -19)
     (class . close-button))
    
    ;; tab left curve
    ((background . ,top-lefthollow-images)
     (top-edge . -19)
     (class . tabbar-horizontal-left-edge))
    
    ;; tab
    ((background . ,top-hollow-images)
     (foreground . ,text-colors)
     (top-edge . -19)
     ;;(left-edge . 0)
     (height . 19)
     (text . ,window-name)
     ;;(x-justify . 4)
     ;;(y-justify . center)
     (class . tabbar-horizontal))
    
    ;; tab right curve
    ((background . ,top-righthollow-images)
     (top-edge . -19)
     (class . tabbar-horizontal-right-edge))))

(define shaped-frame 
  `(((background . ,upper-left-shaped-images)
     (left-edge . 6)
     (top-edge . -19)
     (height . 19)
     (class . top-left-corner))
    
    ;; menu button
    ((background . ,menu-images)
     (top-edge . -19)
     (left-edge . 0)
     (class . menu-button))
    
    ;; top curves
    ;;((background . ,top-lefthollow-images)
    ;;(top-edge . -19)
    ;;(left-edge . 16)
    ;;(class . title))
    
    ;; Title text area
    ;;((background . ,top-hollow-images)
    ;;(foreground . ,text-colors)
    ;;(text . ,window-name)
    ;;(x-justify . 4)
    ;;(y-justify . center)
    ;;(top-edge . -19)
    ;;(left-edge . 27)
    ;;(width . ,(lambda (w) (+ (title-width w) 13)))
    ;;(class . title))
    
    ;; top curves
    ;;((background . ,top-righthollow-images)
    ;;(left-edge . ,(lambda (w) (+ (title-width w) 37)))
    ;;(top-edge . -19)
    ;;(class . title))
    
    ;; top grey
    ;;((background . ,top-grey-images)
    ;;(left-edge . ,(lambda (w) (+ (title-width w) 48)))
    ;;(top-edge . -19)
    ;;(right-edge . 48)
    ;;(class . title))
    
    ;; top-right corner
    ((background . ,upper-right-shaped-images)
     (right-edge . 6)
     (top-edge . -19)
     (height . 19)
     (class . top-right-corner))
    
    ;; iconify button
    ;;((background . ,iconify-images)
    ;;(right-edge . 32)
    ;;(top-edge . -19)
    ;;(class . iconify-button))
    
    ;; maximize button
    ;;((background . ,maximize-images)
    ;;(right-edge . 16)
    ;;(top-edge . -19)
    ;;(class . maximize-button))
    
    ;; delete button
    ((background . ,close-images)
     (right-edge . 0)
     (top-edge . -19)
     (class . close-button))
    
    ;; tab left curve
    ((background . ,top-lefthollow-images)
     (top-edge . -19)
     (class . tabbar-horizontal-left-edge))
    
    ;; tab
    ((background . ,top-hollow-images)
     (foreground . ,text-colors)
     (top-edge . -19)
     ;;(left-edge . 0)
     (height . 19)
     (text . ,window-name)
     ;;(x-justify . 4)
     ;;(y-justify . center)
     (class . tabbar-horizontal))
    
    ;; tab right curve
    ((background . ,top-righthollow-images)
     (top-edge . -19)
     (class . tabbar-horizontal-right-edge))))

(define transient-frame 
  `(((background . ,t-upper-left-images)
     (left-edge . -4)
     (top-edge . -4)
     (class . top-left-corner))

    ;;top-right corner
    ((background . ,t-upper-right-images)
     (right-edge . -17)
     (top-edge . -4)
     (class . top-right-corner))
    
    ;;title border
    ((background . ,t-upper-side-images)
     (left-edge . -1)
     (right-edge . -1)
     (top-edge . -4)
     (class . top-border))
    
    ;; left border
    ((background . ,t-left-images)
     (left-edge . -4)
     (top-edge . -1)
     (bottom-edge . -1)
     (class . left-border))
    
    ;; right border
    ((background . ,t-right-images)
     (right-edge . -17)
     (top-edge . -1)
     (bottom-edge . -1)
     (class . title))
    
    ;; bottom border
    ((background . ,t-bottom-side-images)
     (left-edge . -1)
     (right-edge . -1)
     (bottom-edge . -4)
     (class . bottom-border))
    
    ;; bottom-left corner
    ((background . ,t-bottom-left-images)
     (left-edge . -4)
     (bottom-edge . -4)
     (class . bottom-left-corner))
    
    ;; bottom-right corner
    ((background . ,t-bottom-right-images)
     (right-edge . -17)
     (bottom-edge . -4)
     (class . bottom-right-corner))
    
    ;; delete button
    ((background . ,t-close-images)
     (right-edge . -17)
     (top-edge . 1)
     (class . close-button))))


(define shaped-transient-frame 
  `(((background . ,t-upper-right-shaped-images)
     (right-edge . -17)
     (top-edge . -4)
     (class . top-right-corner))
    
    ;; right border
    ((background . ,t-right-images)
     (right-edge . -17)
     (top-edge . -1)
     (bottom-edge . -1)
     (class . title))
    
    ;; bottom-right corner
    ((background . ,t-bottom-right-shaped-images)
     (right-edge . -17)
     (bottom-edge . -4)
     (class . bottom-right-corner))
    
    ;; delete button
    ((background . ,t-close-images)
     (right-edge . -17)
     (top-edge . 1)
     (class . close-button))))

(define create-frames
  (lambda ()
    (let ((Elberg-left-d-w 11)
          (Elberg-right-d-w 11)
          (Elberg-left-m 16)
          (Elberg-rigth-m 16)
          (Elberg-left-m-t 0)
          (Elberg-right-m-t 0))
      (require 'sawfish.wm.tabs.tab)
      (set-tab-adjustments #:theme-left-dec-width Elberg-left-d-w #:theme-right-dec-width Elberg-right-d-w #:theme-left-margin 
                           Elberg-left-m #:theme-right-margin Elberg-rigth-m #:theme-left-margin-transient Elberg-left-m-t 
                           #:theme-right-margin-transient Elberg-right-m-t))))

(define (frame-style-name w)
  (when (eq (window-get w 'current-frame-style) theme-name)
    (set-tab-theme-name #:frame-style-supported-tabs theme-name)))

(define (get-frame w type)
  (create-frames)
  (case type
        ((default) frame)
        ((transient) transient-frame)
        ((shaped) shaped-frame)
        ((shaped-transient) shaped-transient-frame)))

(create-frames)

(add-frame-style theme-name get-frame)
(call-after-state-changed '(tab-theme-name) frame-style-name)

;; display-window.jl -- activating windows
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.display-window

    (export display-window-without-focusing
	    display-window)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.focus
	  sawfish.wm.workspace
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.viewport
	  sawfish.wm.util.stacking
	  sawfish.wm.state.shading
	  sawfish.wm.state.iconify
	  sawfish.wm.windows
	  sawfish.wm.util.window-order)

  (defcustom unshade-selected-windows nil
    "Unshade window when selected."
    :type boolean
    :group min-max)

;;; Activating windows

  ;; No Sawfish code except display-window calls this function.
  ;; But this is a command, too, so don't delete it.
  (define (display-window-without-focusing
	   w #!optional preferred-space #!key will-refocus)
    "Display the window, by choosing the workspace/viewport containing
the window W, and by showing it, i.e. the window is uniconified, or
unshaded if necessary."
    (when w
      (when (window-iconified-p w)
	(uniconify-window w))
      (when (or (not preferred-space)
		(not (window-in-workspace-p w preferred-space)))
	(setq preferred-space
	      (nearest-workspace-with-window w current-workspace)))
      (when preferred-space
	(select-workspace preferred-space will-refocus))
      (move-viewport-to-window w)
      (move-window-to-current-viewport w)
      (when (and unshade-selected-windows (window-get w 'shaded))
	(unshade-window w))))

  (define-command 'display-window-without-focusing
    display-window-without-focusing
    #:spec (lambda ()
	     (require 'sawfish.wm.util.prompt)
	     (list (prompt-for-window)))
    #:doc "Display the window, but don't focus. You're prompted to type in the name."
    )

  #|
    Currently, the optional argument `preferred-space' is not used
    anywhere in the Sawfish code, so I didn't describe it in the texi.
    Consider removing it, and instead implementing many other options
    with #!key.
  |#
  (define (display-window w #!optional preferred-space)
    "Do everything necessary to make window W ready for user,
i.e. display, focus, etc."
    (when w
      (display-window-without-focusing
       w preferred-space
       #:will-refocus (window-really-wants-input-p w))
      (activate-window w)))

  (define-command 'display-window display-window
    #:spec (lambda ()
	     (require 'sawfish.wm.util.prompt)
	     (list (prompt-for-window)))
    #:doc "Display the window. You're prompted to type in the name."))

;;; mousetrap.jl -- Zoom the mouse to any place with few keystrokes.

;; Author: Fernando Carmona Varo  <ferkiwi@gmail.com>
;; Maintainer: Christopher Roy Bratusek <nano@tuxfamily.org>
;; Version: 0.7

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 3, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with Sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; This script provides a method for moving the mouse to any place of
;; the screen by zooming with just a few keystrokes (and as much
;; precision as you want).

;; When the command is invoked the mouse is warped to the center of
;; the screen and a outline is drawn dividing the screen in 4
;; squares (like trapping the mouse on it).

;; You can then press an arrow key (or H J K or L key) and the mouse will
;; move to a new position inside the outline, moving half the distance
;; between it's current position and the edge of the "cage".
;; Each new keystroke will half the area of the cage, increasing 
;; precision exponentially.
;; When you press the spacebar or enter a mouse click is performed. If
;; you press ESC no click will be made, but the mouse will be moved to
;; that position.

;; The idea was inspired by a similar proyect shown in the Yahoo
;; Hack Day '06: http://www.semicomplete.com/presentations/hackday06/

;; The keys Q W A and S can also be used for warping the mouse to one of the
;; four quarters of the square, which would result in even less 
;; keystrokes.

(define-structure sawfish.wm.ext.mousetrap

    (export mousetrap-action
            synthetic-click)

    (open rep
	  rep.system
	  rep.io.timers
          sawfish.wm
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.animation.modes
          sawfish.wm.util.x)

  (define-structure-alias mousetrap sawfish.wm.ext.mousetrap)
  
  (defcustom mousetrap-outline 'crosshair
    "Outline drawing to use for mousetrap area."
    :type (choice crosshair none)
    :group misc)

  (defcustom mousetrap-cursor-shape 'fleur
    "Mouse cursor shape to use for mousetrap."
    :type (choice fleur cross crosshair iron_cross target)
    :group misc)

  (defvar mousetrap-escape-key nil)

  (defvar mousetrap-move-right-key nil)
  (defvar mousetrap-move-left-key nil)
  (defvar mousetrap-move-up-key nil)
  (defvar mousetrap-move-down-key nil)

  (defvar mousetrap-move-quarter-top-right-key nil)
  (defvar mousetrap-move-quarter-top-left-key nil)
  (defvar mousetrap-move-quarter-bottom-right-key nil)
  (defvar mousetrap-move-quarter-bottom-left-key nil)

  (define (draw-crosshair-outline x y width height)
    "Crosshair outline drawing."
    (let ((gc (x-create-root-xor-gc))
	  (x-step (/ width 2))
	  (y-step (/ height 2)))
      (do ((i 0 (1+ i)))
	  ((= i 3))
	;; Horizontal line
	(x-draw-line 'root gc
		      (cons x 
			    (inexact->exact (round (+ y (* y-step i)))))
		      (cons (+ x width) 
			    (inexact->exact (round (+ y (* y-step i))))))
	;; Vertical line
	(x-draw-line 'root gc
		      (cons (inexact->exact (round (+ x (* x-step i)))) 
			    y)
		      (cons (inexact->exact (round (+ x (* x-step i)))) 
			    (+ y height))))
      ;; Crosshair ruler
      (do ((x (+ x (/ x-step 2)))
	    (y (+ y (/ y-step 2)))
	    (i 0 (1+ i)))
	  ((= i 2))
	(x-draw-line 'root gc
		      (cons (inexact->exact (round (+ x (* x-step 0.47))))
			    (inexact->exact (round (+ y (* y-step i)))))
		      (cons (inexact->exact (round (+ x (* x-step 0.53))))
			    (inexact->exact (round (+ y (* y-step i))))))
	(x-draw-line 'root gc
		      (cons (inexact->exact (round (+ x (* x-step i))))
			    (inexact->exact (round (+ y (* y-step 0.47)))))
		      (cons (inexact->exact (round (+ x (* x-step i))))
			  (inexact->exact (round (+ y (* y-step 0.53)))))))
      (x-destroy-gc gc)))

  (define-window-outliner 'crosshair draw-crosshair-outline)

  ;; prevent edge actions from beeing invoked while mousetrapping
  (defvar while-mousetrap nil)
  (defvar server-grabbed nil)

  (eval-when-compile
    (defvar mousetrap-read-event nil))

  (define (mousetrap-action)
    "Let the user move the mouse by 'trapping' it to a position.
Returns the event-name of the key pressed to finish, nil if cancelled."
    (when (grab-keyboard)
      (unwind-protect
        (setq while-mousetrap t)

	  (define (mousetrap-read-event)
	    "Keyboard events callback for `mousetrap-action'."
	    (throw 'mousetrap-read (event-name (current-event))))
	(add-hook 'unbound-key-hook mousetrap-read-event)

	    (grab-server) ; don't draw anything else
	    (grab-pointer nil mousetrap-cursor-shape)
	    (setq server-grabbed t)
	    
	      (catch 'exit-mousetrap
		(let* (
		      (override-keymap '(keymap))
		      (pos-x 0)
		      (pos-y 0)
		      (dim-x (screen-width))
		      (dim-y (screen-height))
		      (key ""))
		  
		  (while t
		    ;; Update cursor
		    (warp-cursor (floor (+ pos-x (/ dim-x 2)))
				(floor (+ pos-y (/ dim-y 2))))
		      
		    ;; Draw outline
		    (unless (eq mousetrap-outline 'none)
		      (draw-window-outline mousetrap-outline pos-x pos-y dim-x dim-y))
		    ;; Read a key
		      (setq key
			    (catch 'mousetrap-read
			      (recursive-edit)))
		      ;; Erase outline
		      (unless (eq mousetrap-outline 'none)
			(erase-window-outline mousetrap-outline pos-x pos-y dim-x dim-y))
		      ;; Act according to the key read
		      (cond ((or (equal key mousetrap-escape-key)
				 (equal key "ESC"))
			    (throw 'exit-mousetrap nil))
			    ((or (equal key "RET")
				 (equal key "SPC"))
			    (throw 'exit-mousetrap key))
			    ((or (equal key mousetrap-move-left-key); Left half
			         (equal key "Left")
			         (equal key "h"))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-up-key); Upper half
			         (equal key "Up")
			         (equal key "u"))
			    (setq dim-y (floor (/ dim-y 2))))
			    ((or (equal key mousetrap-move-down-key); Lower half
			         (equal key "Down")
			         (equal key "n"))
			    (setq pos-y (floor (+ pos-y (/ dim-y 2))))
			    (setq dim-y (floor (/ dim-y 2))))
			    ((or (equal key mousetrap-move-right-key); Right half
			         (equal key "Right")
			         (equal key "j"))
			    (setq pos-x (floor (+ pos-x (/ dim-x 2))))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-top-left-key) ; top-left quarter
			         (equal key "M-Left")
			         (equal key "r"))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-top-right-key) ; top-right quarter
			         (equal key "M-Right")
			         (equal key "t"))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq pos-x (floor (+ pos-x (/ dim-x 2))))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-bottom-left-key) ; bottom-left quarter
			         (equal key "C-Left")
			         (equal key "v"))
			    (setq pos-y (floor (+ pos-y (/ dim-y 2))))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-bottom-right-key) ; bottom-right quarter
			         (equal key "C-Right")
			         (equal key "b"))
			    (setq pos-y (floor (+ pos-y (/ dim-y 2))))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq pos-x (floor (+ pos-x (/ dim-x 2))))
			    (setq dim-x (floor (/ dim-x 2))))
			    ))))
	    (ungrab-server)
	    (ungrab-pointer)
	    (remove-hook 'unbound-key-hook mousetrap-read-event)
	    (ungrab-keyboard)))
            (make-timer (lambda () (setq while-mousetrap nil)) 1))

  (define (synthetic-click event-name)
    (let* ((w (query-pointer-window))
	  (event (lookup-event event-name)))
      ;; focus, if allowed
      (when (window-really-wants-input-p w)
	(set-input-focus w))
      ;; send click to window
      (when (or focus-click-through 
		(not (window-really-wants-input-p w)))
	(synthesize-event event w))
      ;; raise
      (raise-window w)))

  (define (mousetrap-invoke)
    "Move mouse by mousetrapping."
    (interactive)
    (mousetrap-action))

  (define (mousetrap-invoke-and-left-click)
    "Move mouse by mousetrapping and make a left click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button1-Click1")))

  (define (mousetrap-invoke-and-left-double-click )
    "Move mouse by mousetrapping and make a left double click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button1-Click2")))

  (define (mousetrap-invoke-and-middle-click)
    "Move mouse by mousetrapping and make a middle click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button2-Click1")))

  (define (mousetrap-invoke-and-right-click)
    "Move mouse by mousetrapping and make a right click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button3-Click1")))

  (define-command 'mousetrap-invoke mousetrap-invoke)
  (define-command 'mousetrap-invoke-and-left-click mousetrap-invoke-and-left-click)
  (define-command 'mousetrap-invoke-and-left-double-click mousetrap-invoke-and-left-double-click)
  (define-command 'mousetrap-invoke-and-middle-click mousetrap-invoke-and-middle-click)
  (define-command 'mousetrap-invoke-and-right-click mousetrap-invoke-and-right-click))

;; group-funs.jl -- ever-present window-group support

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; Each window may only be a member of a single group, each group is
;; defined by its group id, either an integer or a symbol. Positive
;; integers are used for application-defined groups (window ids, as
;; returned by window-group-id), negative integers are used for
;; user-defined anonymous groups, symbols are used for user-defined
;; named groups.

;; To put a window in a different group to which its application
;; originally put it, set its `group' property (preferably by calling
;; the add-window-to-group function)

;; Only named groups are saved when saving sessions (anything else may
;; not work properly when the windows are reopened, and therefore their
;; ids change)

;; See groups.jl for the commands that manipulate groups of windows

(define-structure sawfish.wm.util.groups

    (export window-actual-group-id
	    windows-by-group
	    windows-in-group
	    map-window-group
	    map-other-window-groups
	    window-group-ids
	    add-window-to-group
	    add-window-to-new-group
	    window-group-menu)

    (open rep
	  rep.util.utf8
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.custom
	  sawfish.wm.gaol)

  (define-structure-alias group-funs sawfish.wm.util.groups)

  (defvar transients-are-group-members t
    "Group transient windows with their parents.")

  (defvar persistent-group-ids '()
    "List of symbols naming groups that always exist.")

  (define (window-actual-group-id w)
    "Return the id of the group that window W is a member of."
    (let (tem)
      (or (window-get w 'group)
	  (window-group-id w)
	  (and transients-are-group-members
	       (window-transient-p w)
	       (setq tem (get-window-by-id (window-transient-p w)))
	       (or (window-get tem 'group) (window-group-id tem)))
	  (window-id w))))

  (define (windows-by-group group-id #!optional by-depth)
    "Return the list of windows in the group with id GROUP-ID. If
BY-DEPTH is non-nil, then return the windows in order of stacking,
from topmost to bottommost."
    (delete-if-not (lambda (x)
		     (eq (window-actual-group-id x) group-id))
		   (if by-depth (stacking-order) (managed-windows))))

  (define (windows-in-group w #!optional by-depth)
    "Return the list of windows in the same group as window W."
    (windows-by-group (window-actual-group-id w) by-depth))

  (define (map-window-group fun w)
    "Map the single argument function FUN over all windows in the same
group as window W."
    (mapc fun (windows-in-group w)))

  (define (map-other-window-groups fun w)
    "Map the single argument function FUN over all windows not in the same
group as window W."
    (let ((group (windows-in-group w)))
      (map-windows (lambda (x)
		     (unless (memq x group)
		       (fun x))))))

  (define (window-group-ids)
    "Return the list of all group ids."
    (let ((ids (copy-sequence persistent-group-ids))
	  id)
      (map-windows (lambda (w)
		     (setq id (window-actual-group-id w))
		     (unless (memq id ids)
		       (setq ids (cons id ids)))))
      ids))

  (define (add-window-to-group w group-id)
    "Put window W in group with id GROUP-ID; returns GROUP-ID."
    (window-put w 'group group-id))

  (define (add-window-to-new-group w)
    "Add window W to a new group (i.e. has W as its sole member); returns
the id of the new group."
    (let ((ids (window-group-ids))
	  (i -1))
      (while (memq i ids)
	(setq i (1- i)))
      (add-window-to-group w i)))

;;; menu constructor

  (define (window-group-menu #!optional w)
    (unless w
      (setq w (or (current-event-window) (input-focus))))
    (let ((group-names (mapcar (lambda (x)
				 (cons (window-actual-group-id x)
				       (window-name x)))
			       (managed-windows)))
	  (group-ids (window-group-ids)))
      (nconc (mapcar
	      (lambda (id)
		(let ((name (if (symbolp id)
				(symbol-name id)
			      (cdr (assq id group-names)))))
		  (when (> (utf8-string-length name) 20)
		    (setq name (concat
				(utf8-substring name 0 20) "...")))
		  (list (quote-menu-item name)
			(lambda ()
			  (add-window-to-group w id))
			(cons 'check (eql (window-actual-group-id w) id))
			'(group . window-group))))
	      group-ids)
	     (list '())
	     (list (list (_ "New group")
			 (lambda ()
			   (add-window-to-new-group w)))))))

;;; session management -- only save group-ids that are _symbols_

  (define (group-saved-state w)
    (let ((group-id (window-get w 'group)))
      (when (and group-id (symbolp group-id))
	`((group . ,group-id)))))

  (define (group-load-state w alist)
    (let ((group-id (cdr (assq 'group alist))))
      (when group-id
	(add-window-to-group w group-id))))

  (add-hook 'sm-window-save-functions group-saved-state)
  (add-hook 'sm-restore-window-hook group-load-state)

;;; gaol init

  (gaol-add window-actual-group-id windows-by-group windows-in-group
	    map-window-group window-group-ids))

#| nokogiri-shell.jl -- shell displaying custom groups

   $Id: shell.jl,v 1.19 2000/11/28 19:00:53 jsh Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure sawfish.ui.shell

    (export initialize-shell
	    destroy-shell
	    run-shell)

    (open rep
	  gui.gtk
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.timers
	  sawfish.gtk.stock
	  sawfish.gtk.widget
	  sawfish.ui.group
	  sawfish.ui.slot
	  sawfish.ui.apply
	  sawfish.ui.layout
	  sawfish.ui.user-level
	  sawfish.ui.config)

  (defvar *nokogiri-buttons* nil)

  (defvar *nokogiri-flatten-groups* nil)
  (defvar *nokogiri-single-level* nil)

  (define main-window)
  (define group-tree-widget)
  (define slot-box-widget)

  (define active-slots '())

  (define ok-widget)
  (define apply-widget)
  (define revert-widget)
  (define cancel-widget)

  (define (initialize-shell #!optional socket-id)
    (let ((vbox (gtk-vbox-new nil box-spacing))
	  (hbox (gtk-hbutton-box-new))
	  (s-scroller (and (not socket-id) (gtk-scrolled-window-new)))
	  root-container)

      (setq main-window (if socket-id
			    (gtk-plug-new socket-id)
			  (gtk-window-new 'toplevel)))
      (if socket-id
	  (progn
	    (gtk-window-set-default-size main-window 400 300)
	    (setq root-container main-window))
	(gtk-window-set-policy main-window nil t nil)
	(gtk-window-set-default-size main-window 550 400)
	(setq root-container (gtk-frame-new))
	(gtk-frame-set-shadow-type root-container 'out)
	(gtk-container-add main-window root-container))

      (setq slot-box-widget (gtk-vbox-new nil box-spacing))

      (gtk-container-border-width vbox box-border)
      (gtk-container-border-width slot-box-widget box-border)
      (when s-scroller
	(gtk-scrolled-window-set-policy s-scroller 'automatic 'automatic)
	(gtk-scrolled-window-add-with-viewport s-scroller slot-box-widget))

      (let ((group (get-group top-group)))
	(fetch-group group)
	(if (and (not *nokogiri-flatten-groups*)
		 (not *nokogiri-single-level*)
		 (group-sub-groups group))
	    (let ((paned (gtk-hpaned-new))
		  (g-scroller (gtk-scrolled-window-new)))
	      (setq group-tree-widget (make-group-tree (get-group top-group)))
	      (gtk-container-border-width group-tree-widget box-border)
	      (gtk-scrolled-window-set-policy g-scroller 'automatic 'automatic)
	      (gtk-container-add vbox paned)
	      (gtk-paned-add1 paned g-scroller)
	      (gtk-paned-add2 paned (or s-scroller slot-box-widget))
	      (gtk-paned-set-position paned 150)
	      (gtk-scrolled-window-add-with-viewport g-scroller
						     group-tree-widget))
	  (gtk-container-add vbox (or s-scroller slot-box-widget))))

      (unless socket-id
	(setq ok-widget (stock-button 'ok))
	(setq apply-widget (stock-button 'apply))
	(setq revert-widget (stock-button 'revert))
	(setq cancel-widget (stock-button 'cancel))
	(gtk-window-set-title main-window (_ "Sawfish configurator"))
	(gtk-widget-set-name main-window (_ "Sawfish configurator"))
	(gtk-window-set-wmclass main-window "main" "Nokogiri"))

      (gtk-signal-connect main-window "delete_event"
			  (if (not socket-id) on-quit capplet-delete-event))

      (unless socket-id
	(gtk-button-box-set-layout hbox 'end)
	(gtk-box-pack-end vbox hbox)
	(gtk-signal-connect ok-widget "clicked" on-ok)
	(gtk-signal-connect apply-widget "clicked" on-apply)
	(gtk-signal-connect cancel-widget "clicked" on-cancel)
	(gtk-signal-connect revert-widget "clicked" on-revert)
	(gtk-container-add hbox apply-widget)
	(gtk-container-add hbox revert-widget)
	(gtk-container-add hbox ok-widget)
	(gtk-container-add hbox cancel-widget))

      (gtk-container-add root-container vbox)
      (gtk-widget-show-all main-window)
      (set-button-states)

      (when socket-id
	(setq *nokogiri-apply-immediately* nil)
	(set-input-handler standard-input capplet-input)
	(add-hook '*nokogiri-slot-changed-hook* capplet-state-changed))

      (if group-tree-widget
	  (progn
	    (gtk-tree-select-item group-tree-widget 0)
	    (mapc gtk-tree-item-expand
		  (gtk-container-children group-tree-widget)))
	(select-group (get-group top-group)))))

  (define (destroy-shell)
    (when main-window
      (gtk-widget-destroy main-window)
      (setq main-window nil)
      (setq group-tree-widget nil)
      (setq slot-box-widget nil)
      (setq ok-widget nil)
      (setq apply-widget nil)
      (setq revert-widget nil)
      (setq cancel-widget nil)))

  (define (on-quit)
    (destroy-shell)
    (throw 'nokogiri-exit t))

  (define (on-ok)
    (apply-slot-changes)
    (on-quit))

  (define (on-apply)
    (apply-slot-changes)
    (set-button-states))

  (define (on-cancel)
    (revert-slot-changes)
    (on-quit))

  (define (on-revert)
    (revert-slot-changes)
    (set-button-states))

  (define (set-button-states)
    (define (show-hide w state)
      ((if state gtk-widget-show gtk-widget-hide) w))
    (when apply-widget
      (show-hide apply-widget (eq *nokogiri-buttons* 'apply/revert/cancel/ok))
      (gtk-widget-set-sensitive apply-widget (changes-to-apply-p)))
    (when revert-widget
      (show-hide revert-widget (memq *nokogiri-buttons*
				     '(revert/cancel/ok
				       apply/revert/cancel/ok)))
      (gtk-widget-set-sensitive revert-widget (changes-to-revert-p)))
    (when ok-widget
      (gtk-widget-set-sensitive ok-widget (or (eq *nokogiri-buttons* 'ok)
					      (changes-to-apply-p)
					      (changes-to-revert-p))))
    (when cancel-widget
      (show-hide cancel-widget (memq *nokogiri-buttons*
				     '(revert/cancel/ok
				       apply/revert/cancel/ok)))))

;;; displaying custom groups

  (define (get-slots group)
    (fetch-group group)
    (filter slot-is-appropriate-p (group-slots group)))

  (define (display-flattened group)

    (define (iter book group slots)
      (when slots
	(let ((layout (layout-slots (group-layout group) slots)))
	  (setq active-slots (nconc active-slots slots))
	  (gtk-notebook-append-page
	   book layout (gtk-label-new (group-real-name group)))
	  (when (gtk-container-p layout)
	    (gtk-container-border-width layout box-border))))
      (mapc (lambda (sub)
	      (fetch-group sub)
	      (let ((slots (get-slots sub)))
		(when (or slots (group-sub-groups group))
		  (iter book sub slots))))
	    (get-sub-groups group)))

    (let ((notebook (gtk-notebook-new)))
      (gtk-notebook-set-scrollable notebook 1)
      (gtk-notebook-popup-enable notebook)
      (iter notebook group (get-slots group))
      (gtk-widget-show notebook)
      (gtk-container-add slot-box-widget notebook)))

  (define (display-unflattened group)
    (let* ((slots (get-slots group)))
      (gtk-container-add
       slot-box-widget (layout-slots (group-layout group) slots))
      (setq active-slots (nconc active-slots slots))))

  (define (add-group-widgets group)
    (if (and *nokogiri-flatten-groups* (group-sub-groups group))
	(display-flattened group)
      (display-unflattened group))
    (update-all-dependences))

  (define (remove-group-widgets group)
    (mapc (lambda (s)
	    (let ((w (slot-gtk-widget s)))
	      (when (gtk-widget-parent w)
		(gtk-container-remove (gtk-widget-parent w) w))
	      (set-slot-layout s nil))) active-slots)
    (setq active-slots '())
    (mapc (lambda (w)
	    (gtk-container-remove slot-box-widget w))
	  (gtk-container-children slot-box-widget)))

  (define (run-shell #!optional socket-id)
    (initialize-configs)
    (initialize-shell socket-id)
    (catch 'nokogiri-exit
      (recursive-edit)))

  (add-hook '*nokogiri-slot-changed-hook* set-button-states t)
  (add-hook '*nokogiri-group-selected-hook* add-group-widgets)
  (add-hook '*nokogiri-group-deselected-hook* remove-group-widgets)

  (define-config-item 'nokogiri-buttons
		      '*nokogiri-buttons*
		      (lambda ()
			(set-button-states)
			(setq *nokogiri-apply-immediately*
			      (memq *nokogiri-buttons*
				    '(ok revert/cancel/ok)))))

;;; capplet interfacing

  ;; called when there's input available on stdin
  (define (capplet-input)
    (let ((tem (read-line standard-input)))
      (condition-case nil
	  (progn
	    (cond ((string-match "apply" tem) (on-apply))
		  ((string-match "revert" tem) (on-revert))
		  ((string-match "ok" tem) (on-ok))
		  ((string-match "cancel" tem) (on-cancel)))
	    (write standard-output ?\001)
	    (flush-file standard-output))
	(end-of-stream))))

  (define (capplet-delete-event)
    (gtk-widget-hide main-window)
    (make-timer on-quit 10)
    ;; return t so no destroy - if the timer fires we'll destroy then
    t)

  (define (capplet-state-changed)
    (write standard-output ?c)
    (flush-file standard-output))

  (define (capplet-no-group)
    (write standard-output ?g)
    (flush-file standard-output)))

#| user.jl -- do user-local initialization

   $Id: user.jl,v 1.15 2001/01/20 02:40:28 jsh Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of sawfish.

   sawfish is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sawfish is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sawfish; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

;; Commentary:

;; The idea is that the `user' module is where all user code gets to
;; play. By default it has a set of modules opened so that it looks
;; pretty much how the old non-modular wm looked.

;; This means that the `sawfish.wm' structures aren't modified by user
;; code, this is a good thing, since it means that modules importing
;; `sawfish.wm.foo' know what they are getting (no random user
;; bindings)

;; The downside is that it's harder for user extensions to redefine
;; existing code, IMHO this may also be a good thing..

(define-structure user ()

    ((open rep
	   rep.regexp
	   rep.system
	   rep.io.files
	   rep.io.processes
	   sawfish.wm
	   sawfish.wm.util.groups
	   sawfish.wm.util.display-window
	   sawfish.wm.util.compat)
     (set-binds))

  (setq *user-structure* 'user)

  ;; frame-style loaded if user hasn't set their own
  (define fallback-frame-style 'Crux)

  ;; initialize the special variable pointing at this structure
  (structure () (open rep rep.structures)
    (setq *user-module* (get-structure 'user)))

  (define (safe-load . args)
    (condition-case data
	(apply load args)
      (error
       (error-handler-function (car data) (cdr data)))))

  ;; they're probably not going to leave us in an unusable state
  (unless (get-command-line-option "--no-rc")
    (condition-case error-data
	(progn
	  ;; try to rename ~/.sawmill to ~/.sawfish
	  (when (and (file-directory-p "~/.sawmill")
		     (not (file-exists-p "~/.sawfish")))
	    (rename-file "~/.sawmill" "~/.sawfish")
	    (message "Renamed directory ~/.sawmill -> ~/.sawfish")
	    (make-symlink "~/.sawmill" ".sawfish")
	    (message "Created .sawmill symlink (delete if unwanted)"))

	  ;; First the site-wide stuff
	  (load-all "site-init" (lambda (f) (safe-load f nil t)))

	  ;; then the users rep configuration, or site-wide defaults
	  (or (safe-load (concat (user-home-directory) ".reprc") t t t)
	      (safe-load "rep-defaults" t))

	  (unless batch-mode
	    (let ((rc-file-exists-p (lambda (f)
				      (or (file-exists-p f)
					  (file-exists-p (concat f ".jl"))
					  (file-exists-p (concat f ".jlc"))))))
	      ;; load these before customized settings (but only if there's
	      ;; no .sawmillrc file)
	      (unless (or (rc-file-exists-p "~/.sawfishrc")
			  (rc-file-exists-p "~/.sawmillrc"))
		(load "sawfish/wm/defaults" t))

	      ;; then the customized options
	      (condition-case data
		  (custom-load-user-file)
		(error
		 (format (stderr-file) "error in custom file--> %S\n" data)))

	      ;; then the sawmill specific user configuration
	      (cond ((rc-file-exists-p "~/.sawfishrc")
		     (safe-load "~/.sawfishrc" t t t))
		    ((rc-file-exists-p "~/.sawmillrc")
		     (safe-load "~/.sawmillrc" t t t))))))
      (error
       (format (stderr-file) "error in local config--> %S\n" error-data))))

  ;; use a default theme if none given
  (unless (or batch-mode default-frame-style)
    (setq default-frame-style fallback-frame-style))

  (unless (and (boundp 'window-menu) window-menu)
    (require 'sawfish.wm.ext.beos-window-menu))

  ;; load the new WM-spec code by default now
  (load-module 'sawfish.wm.state.wm-spec)

  ;; might it be useful to load the old GNOME support?
  (unless batch-mode
    (catch 'out
      (mapc (lambda (prop)
	      (when (string-match "^GNOME_" (symbol-name prop))
		(load-module 'sawfish.wm.state.gnome)
		(throw 'out t)))
	    (list-x-properties 'root))))

  ;; Use all arguments which are left.
  (let ((do-load (lambda (name)
		   (cond ((file-exists-p name)
			  (load name nil t t))
			 ((string-match "\\.jlc?$" name)
			  (load name))
			 (t (require (intern name))))))
	arg)
    (while (setq arg (car command-line-args))
      (setq command-line-args (cdr command-line-args))
      (cond
       ((member arg '("-f" "--call"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	((symbol-value (read-from-string arg))))
       ((member arg '("-l" "--load"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	(do-load arg))
       ((member arg '("-q" "--quit"))
	(throw 'quit 0))
       (t (do-load arg))))))

;; prevent this file being loaded as a module
nil

;; group-funs.jl -- ever-present window-group support

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Commentary:

;; Each window may only be a member of a single group, each group is
;; defined by its group id, either an integer or a symbol. Positive
;; integers are used for application-defined groups (window ids, as
;; returned by window-group-id), negative integers are used for
;; user-defined anonymous groups, symbols are used for user-defined
;; named groups.

;; To put a window in a different group to which its application
;; originally put it, set its `group' property (preferably by calling
;; the add-window-to-group function)

;; Only named groups are saved when saving sessions (anything else may
;; not work properly when the windows are reopened, and therefore their
;; ids change)

;; See groups.jl for the commands that manipulate groups of windows

(define-structure sawfish.wm.util.groups

    (export window-actual-group-id
	    windows-by-group
	    windows-in-group
	    map-window-group
	    map-other-window-groups
	    window-group-ids
	    add-window-to-group
	    add-window-to-new-group
	    window-group-menu)

    (open rep
	  rep.util.utf8
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.windows
	  sawfish.wm.custom
	  sawfish.wm.gaol)

  (define-structure-alias group-funs sawfish.wm.util.groups)

  (defvar transients-are-group-members t
    "Group transient windows with their parents.")

  (defvar persistent-group-ids '()
    "List of symbols naming groups that always exist.")

  (define (window-actual-group-id w)
    "Return the id of the group that window W is a member of."
    (let (tem)
      (or (window-get w 'group)
	  (window-group-id w)
	  (and transients-are-group-members
	       (window-transient-p w)
	       (setq tem (get-window-by-id (window-transient-p w)))
	       (or (window-get tem 'group) (window-group-id tem)))
	  (window-id w))))

  (define (windows-by-group group-id #!optional by-depth)
    "Return the list of windows in the group with id GROUP-ID. If
BY-DEPTH is non-nil, then return the windows in order of stacking,
from topmost to bottommost."
    (delete-if-not (lambda (x)
		     (eq (window-actual-group-id x) group-id))
		   (if by-depth (stacking-order) (managed-windows))))

  (define (windows-in-group w #!optional by-depth)
    "Return the list of windows in the same group as window W."
    (windows-by-group (window-actual-group-id w) by-depth))

  (define (map-window-group fun w)
    "Map the single argument function FUN over all windows in the same
group as window W."
    (mapc fun (windows-in-group w)))

  (define (map-other-window-groups fun w)
    "Map the single argument function FUN over all windows not in the same
group as window W."
    (let ((group (windows-in-group w)))
      (map-windows (lambda (x)
		     (unless (memq x group)
		       (fun x))))))

  (define (window-group-ids)
    "Return the list of all group ids."
    (let ((ids (copy-sequence persistent-group-ids))
	  id)
      (map-windows (lambda (w)
		     (setq id (window-actual-group-id w))
		     (unless (memq id ids)
		       (setq ids (cons id ids)))))
      ids))

  (define (add-window-to-group w group-id)
    "Put window W in group with id GROUP-ID; returns GROUP-ID."
    (window-put w 'group group-id))

  (define (add-window-to-new-group w)
    "Add window W to a new group (i.e. has W as its sole member); returns
the id of the new group."
    (let ((ids (window-group-ids))
	  (i -1))
      (while (memq i ids)
	(setq i (1- i)))
      (add-window-to-group w i)))

;;; menu constructor

  (define (window-group-menu #!optional w)
    (unless w
      (setq w (or (current-event-window) (input-focus))))
    (let ((group-names (mapcar (lambda (x)
				 (cons (window-actual-group-id x)
				       (window-name x)))
			       (managed-windows)))
	  (group-ids (window-group-ids)))
      (nconc (mapcar
	      (lambda (id)
		(let ((name (if (symbolp id)
				(symbol-name id)
			      (cdr (assq id group-names)))))
		  (when (> (utf8-string-length name) 20)
		    (setq name (concat
				(utf8-substring name 0 20) "...")))
		  (list (quote-menu-item name)
			(lambda ()
			  (add-window-to-group w id))
			(cons 'check (eql (window-actual-group-id w) id))
			'(group . window-group))))
	      group-ids)
	     (list '())
	     (list (list (_ "New group")
			 (lambda ()
			   (add-window-to-new-group w)))))))

;;; session management -- only save group-ids that are _symbols_

  (define (group-saved-state w)
    (let ((group-id (window-get w 'group)))
      (when (and group-id (symbolp group-id))
	`((group . ,group-id)))))

  (define (group-load-state w alist)
    (let ((group-id (cdr (assq 'group alist))))
      (when group-id
	(add-window-to-group w group-id))))

  (add-hook 'sm-window-save-functions group-saved-state)
  (add-hook 'sm-restore-window-hook group-load-state)

;;; gaol init

  (gaol-add window-actual-group-id windows-by-group windows-in-group
	    map-window-group window-group-ids))

;; windows.jl -- miscellaneous window mgmt functions
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.windows

    (compound-interface
     ;; Subrs are stored in sawfish.wm.windows.subrs, but
     ;; this module re-exports them for convenience.
     (structure-interface sawfish.wm.windows.subrs)
     (export get-window-by-name
	     get-window-by-class
	     window-class-name
	     get-window-by-role
	     window-really-wants-input-p
	     window-transient-p
	     mark-window-as-transient
	     desktop-window-p
	     mark-window-as-desktop
	     dock-window-p
	     mark-window-as-dock
	     window-in-cycle-p
	     window-class
	     window-pid
	     window-role
	     warp-cursor-to-window
	     activate-window
	     constrain-dimension-to-hints
	     constrain-aspect-to-hints
	     resize-window-with-hints
	     resize-window-with-hints*
	     window-gravity
	     adjust-position-for-gravity/x
	     adjust-position-for-gravity/y
	     adjust-position-for-gravity
	     get-window-wm-protocols
	     window-supports-wm-protocol-p
	     delete-window
	     delete-window-safely
	     uniquify-name
	     uniquify-window-name
	     select-window
	     window-avoided-p
	     avoided-windows
	     call-after-property-changed
	     call-after-state-changed
	     rename-window
	     window-touching-p
	     window-x
	     window-y
	     window-width
	     window-height
	     toggle-window-fixed-position
	     toggle-window-fixed-size))

    (open rep
	  rep.system
	  rep.regexp
	  #|
	    Don't add more sawfish.wm.* here unless you know what
	    you're doing. Instead, embed 'require' in definition.
	    It's because this file is read in early stage of Sawfish
	    init.
	  |#
	  sawfish.wm.windows.subrs
	  sawfish.wm.gaol
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.commands)


  (defgroup warp "Warping" :group misc)

  (defcustom warp-to-window-offset (cons -1 -1)
    "Offset (percent) from window edges when warping pointer."
    :type (pair (number 1) (number 1))
    :group (misc warp))

  (defcustom warp-to-window-enabled nil
    "Whether to enable warping the cursor to windows."
    :type boolean
    :group (misc warp))

  (defcustom dont-avoid-ignored t
    "Whether to not avoid ignored windows by default."
    :type boolean
    :group misc)

  (defcustom avoid-by-default nil
    "Whether to avoid any unspecified window by default."
    :type boolean
    :group misc)

  (defcustom uniquify-name-format "%s [%d]"
    "Format to create unique window names."
    :type string
    :group misc)

  (defvar dock-window-properties
    '(window-list-skip cycle-skip fixed-position focus-click-through
		       avoid no-history never-iconify never-maximize sticky
		       sticky-viewport placed)
    "List of properties set (to true) on windows when they are marked as docks.")

  (defvar desktop-window-properties
    '(fixed-position sticky sticky-viewport)
    "List of properties set (to true) on windows when they are marked as desktops.")

  (defvar desktop-window-depth -4
    "The stacking depth of desktop windows.")

  (defvar dock-window-depth 0
    "The stacking depth of dock windows.")

  (defvar activate-window-hook nil)

;;; finding windows, reading properties

  (define (get-window-by-name name #!key regex icon)
    "Find a window object whose window-name is NAME. If REGEX is
non-nil, then find a window object whose name matches NAME. If
ICON is non-nil, then window-icon-name (NET_WM_ICON_NAME, _not_ EWMH
_NET_WM_ICON_NAME) is checked instead. Returns nil if no such window is found."
    (if icon 
        (if regex
	    (car (filter-windows (lambda (w)
				   (when (window-icon-name w)
				     (string-match name (window-icon-name w))))))
	  (car (filter-windows (lambda (w)
				 (when (window-icon-name w)
				   (string= (window-icon-name w) name))))))
      (if regex
          (car (filter-windows (lambda (w)
				 (when (window-name w)
			           (string-match name (window-name w))))))
        (car (filter-windows (lambda (w)
			       (when (window-name w)
  			         (string= (window-name w) name))))))))

  (define (get-window-by-class class #!key regex)
    "Find a window object whose window-class is CLASS. If REGEX is
non-nil then find a window object whose class matches
CLASS. Returns nil if no such window is found."
    (if regex
        (car (filter-windows (lambda (w)
			       (when (window-class w)
			         (string-match class (window-class w))))))
      (car (filter-windows (lambda (w)
			     (when (window-class w)
  			       (string= (window-class w) class)))))))

  (define (window-class-name w #!optional (ref 1))
    "Quick way to get window class name."
    (aref (get-x-text-property w 'WM_CLASS) ref))

  (define (get-window-by-role role #!key regex)
    "Find a window object whose window-role is ROLE. If REGEX is non-nil then
find a window object whose role matches ROLE. Returns nil if no such
window is found."
    (if regex
        (car (filter-windows (lambda (w)
			       (when (window-role w)
				 (string-match role (window-role w))))))
      (car (filter-windows (lambda (w)
			     (when (window-role w)
			       (string= (window-role w) role)))))))

  (define (window-really-wants-input-p w)
    "Return nil if window W should never be focused."
    (and (not (window-get w 'never-focus))
	 (window-wants-input-p w)))

  (define (window-transient-p w)
    "Return non-nil if WINDOW is a transient window. The returned value will
then be the numeric id of its parent window."
    (or (window-get w 'transient-for)
	(let ((prop (get-x-property w 'WM_TRANSIENT_FOR)))
	  (when (and prop (eq (car prop) 'WINDOW)
		     (eql (cadr prop) 32) (>= (length (caddr prop)) 1))
	    (aref (caddr prop) 0)))))

  (define (mark-window-as-transient w)
    "Mark that window W is a dialog window of some sort."
    (require 'sawfish.wm.frames)
    (unless (window-transient-p w)
      (window-put w 'transient-for (root-window-id)))
    (set-window-type w 'transient))

  (define (desktop-window-p arg)
    "Return true if ARG represents a desktop window."
    (or (eq arg 'root) (and (windowp arg) (window-get arg 'desktop))))

  (define (mark-window-as-desktop w)
    "Mark that the window associated with object W is a desktop window."
    (require 'sawfish.wm.stacking)
    (require 'sawfish.wm.frames)
    (window-put w 'desktop t)
    (window-put w 'keymap root-window-keymap)
    (mapc (lambda (p)
	    (window-put w p t)) desktop-window-properties)
    (set-window-type w 'unframed)
    (set-window-depth w desktop-window-depth))

  (define (focus-desktop)
    "Transfer input focus to the desktop window (if one exists)."
    (let ((desktop-window (car (filter-windows desktop-window-p))))
      (when desktop-window
	(set-input-focus desktop-window))))

  (define-command 'focus-desktop focus-desktop)

  (define (dock-window-p arg)
    "Return true if ARG represents a dock window."
    (and (windowp arg) (window-get arg 'dock-type)))

  (define (mark-window-as-dock w)
    "Mark that the window associated with object W is a dock window."
    (require 'sawfish.wm.stacking)
    (require 'sawfish.wm.frames)
    (window-put w 'dock-type t)
    (mapc (lambda (p)
	    (window-put w p t)) dock-window-properties)
    (set-window-type w 'dock)
    (set-window-depth w dock-window-depth))

  (define (window-in-cycle-p w #!key ignore-cycle-skip)
    "Returns true if the window W should be included when cycling between
windows."
    (and (window-really-wants-input-p w)
	 (not (or (and (not ignore-cycle-skip) (window-get w 'cycle-skip))
		  (desktop-window-p w)))))

  (define (window-class w #!optional spec)
    "If SPEC is nil, return the class that window W belongs to,
as a string. Returns `nil' if W has no associated class.

If SPEC is 'cons, then cons (Instance . Class) is returned.
If SPEC is 'configurator, then the string of the form \"Instance/Class\"
is returned."
    (let ((prop (get-x-text-property w 'WM_CLASS)))
      (when (and prop (> (length prop) 1))
	(case spec
	  ((cons)
	   (cons (aref prop 0) (aref prop 1)))
	  ((configurator)
	   (concat (aref prop 1) "/" (aref prop 0)))
	  (t
	   (and prop (> (length prop) 1) (aref prop 1)))))))

  (define (window-pid win)
    "Returns the window pid, or nil if not available."
    (when (caddr (get-x-property win '_NET_WM_PID))
      (aref (caddr (get-x-property win '_NET_WM_PID)) 0)))

  (define (window-role win)
    "Returns the window role, or nil if not available."
    (when (get-x-text-property win 'WM_WINDOW_ROLE)
      (aref (get-x-text-property win 'WM_WINDOW_ROLE) 0)))

  (define (get-window-wm-protocols w)
    "Return a list of symbols defining the X11 window manager protocols
supported by client window W."
    (let* ((prop (get-x-property w 'WM_PROTOCOLS))
	   (data (and prop (eq (car prop) 'ATOM) (nth 2 prop))))
      (when data
	(do ((i 0 (1+ i))
	     (out '() (cons (aref data i) out)))
	    ((= i (length data))
	     (nreverse out))))))

  (define (window-supports-wm-protocol-p w atom)
    "Return true if window W includes ATOM in its `WM_PROTOCOLS' property."
    (let* ((prop (get-x-property w 'WM_PROTOCOLS))
	   (data (and prop (eq (car prop) 'ATOM) (nth 2 prop))))
      (when data
	(let loop ((i 0))
	  (cond ((= i (length data)) nil)
		((eq (aref data i) atom) t)
		(t (loop (1+ i))))))))

;;; warping

  (define (warp-cursor-to-window w #!optional x y)
    "Move the mouse pointer to position (X, Y) relative to the client window
associated with object WINDOW.

If X and Y are nil, then the pointer is moved to a default position, as
specified by the user."
    (when warp-to-window-enabled
      (let ((coords (window-position w))
	    (foff (window-frame-offset w))
	    (dims (window-dimensions w)))
	(require 'sawfish.wm.state.shading)
	(when (window-shaded-p w)
	  (setq foff (cons 0 0))
	  (setq dims (window-frame-dimensions w)))
	(unless x
	  (setq x
		(if (< (car warp-to-window-offset) 0)
		    (car warp-to-window-offset)
		  (quotient (* (car dims)
                               (car warp-to-window-offset)) 100))))
	(unless y
	  (setq y (if (< (cdr warp-to-window-offset) 0)
		      (cdr warp-to-window-offset)
		    (quotient (* (cdr dims)
                                 (cdr warp-to-window-offset)) 100))))
	(warp-cursor
	 (max 0 (min (1- (screen-width))
                     (+ x (car coords) (- (car foff)))))
	 (max 0 (min (1- (screen-height))
                     (+ y (cdr coords) (- (cdr foff)))))))))

  (define (activate-window w)
    (require 'sawfish.wm.focus)
    (require 'sawfish.wm.util.stacking)
    (require 'sawfish.wm.util.window-order)
    (raise-window* w)
    (when (window-really-wants-input-p w)
      (set-input-focus w))
    (warp-pointer-if-necessary w)
    (window-order-push w)
    (call-window-hook 'activate-window-hook w))

;;; resizing windows in accordance with their size hints

  (define (constrain-dimension-to-hints x dimension hints)
    ;; User asks the value DIMENSION as a window dimension.
    ;; X is either 'x or 'y.
    ;; Return value is the DIMENSION constrained by HINTS.
    (let ((base (cdr (assq (if (eq dimension 'x)
			       'base-width 'base-height) hints)))
	  (minimum (cdr (assq (if (eq dimension 'x)
				  'min-width 'min-height) hints)))
	  (maximum (or (cdr (assq (if (eq dimension 'x)
				      'max-width 'max-height) hints)) 65535))
	  (inc (or (cdr (assq (if (eq dimension 'x)
				  'width-inc 'height-inc) hints)) 1)))
      (let ((bottom (or base minimum 1)))
	(unless (= (mod (- x bottom) inc) 0)
	  (setq x (inexact->exact
		   (+ (* (ceiling (/ (- x bottom) inc)) inc) bottom)))))
      (clamp x (or minimum base 1) maximum)))

  (define (constrain-aspect-to-hints a old-b dimension min-aspect max-aspect)
    (let ((min-ratio (/ (cadr min-aspect) (cddr min-aspect)))
          (max-ratio (/ (cadr max-aspect) (cddr min-aspect))))
      (if (eq dimension 'y)
          (clamp old-b (floor (* a min-ratio)) (floor (* a max-ratio)))
        (clamp old-b (floor (/ a max-ratio)) (floor (/ a min-ratio))))))

  (define (resize-window-with-hints w cols rows #!optional hints)
    "Resize window W to COLS x ROWS, using the window's size hints to
define the row and column size, and the minimum possible size.

If HINTS is non-nil, then it is the size hints structure to
use. Otherwise (window-size-hints W) is used."
    (unless hints
      (setq hints (window-size-hints w)))
    (let ((x-base (or (cdr (or (assq 'base-width hints)
			       (assq 'min-width hints))) 1))
	  (x-inc (or (cdr (assq 'width-inc hints)) 1))
	  (y-base (or (cdr (or (assq 'base-height hints)
			       (assq 'min-height hints))) 1))
	  (y-inc (or (cdr (assq 'height-inc hints)) 1)))
      (resize-window-to
       w (constrain-dimension-to-hints (+ x-base (* x-inc cols)) 'x hints)
       (constrain-dimension-to-hints (+ y-base (* y-inc rows)) 'y hints))))

  (define (resize-window-with-hints* w width height #!optional hints)
    "Resize window W to WIDTH x HEIGHT, with WIDTH and HEIGHT defined
in terms of pixels. The window's size hints structure defines the
minimum and maximum dimensions of the window, within which WIDTH and
HEIGHT are constrained.

If HINTS is non-nil, then it is the size hints structure to
use. Otherwise (window-size-hints W) is used."
    (unless hints
      (setq hints (window-size-hints w)))
    (resize-window-to w (constrain-dimension-to-hints width 'x hints)
		      (constrain-dimension-to-hints height 'y hints)))

  (define (window-gravity w #!optional hints)
    (or (window-get w 'gravity)
	(cdr (assq 'window-gravity (or hints (window-size-hints w))))
	;; default gravity is NorthWest (from ICCCM)
	'north-west))

  (define (adjust-position-for-gravity/x w grav x #!key inverse)
    (let* ((tl-off (car (window-frame-offset w)))
	   (br-off (- (car (window-frame-dimensions w))
		      (car (window-dimensions w))))
	   (sign (if inverse -1 +1)))
      (cond ((eq grav 'static)
	     ;; static gravity is relative to the original
	     ;; client window position
	     (+ x (* sign tl-off)))
	    ((memq grav '(east south-east north-east))
	     ;; relative to the right of the frame
	     (- x (* sign (+ br-off (* -2 (window-border-width w))))))
	    ((memq grav '(north center south))
	     ;; relative to the horizontal center of the frame
	     (- x (* sign (quotient
			   (+ br-off (* -2 (window-border-width w))) 2))))
	    (t x))))

  (define (adjust-position-for-gravity/y w grav y #!key inverse)
    (let* ((tl-off (cdr (window-frame-offset w)))
	   (br-off (- (cdr (window-frame-dimensions w))
		      (cdr (window-dimensions w))))
	   (sign (if inverse -1 +1)))
      (cond ((eq grav 'static)
	     ;; static gravity is relative to the original
	     ;; client window position
	     (+ y (* sign tl-off)))
	    ((memq grav '(south south-east south-west))
	     ;; relative to the bottom of the frame
	     (- y (* sign (+ br-off (* -2 (window-border-width w))))))
	    ((memq grav '(east center west))
	     ;; relative to the vertical center of the frame
	     (- y (* sign (quotient
			   (+ br-off (* -2 (window-border-width w))) 2))))
	    (t y))))

  ;; UNADJUST means to reverse the gravity compensation, suitable for
  ;; when unmanaging windows at shutdown
  (define (adjust-position-for-gravity w grav coords #!optional unadjust)
    (cons (adjust-position-for-gravity/x
	   w grav (car coords) #:inverse unadjust)
	  (adjust-position-for-gravity/y
	   w grav (cdr coords) #:inverse unadjust)))

;;; deleting windows

  (define (delete-window w #!optional safely)
    "Delete a window. If the window does not support that protocol,
kill the client."
    (unless (and (memq this-command
		       '(delete-window delete-window-safely
			 delete-group delete-window-instance))
		 (window-get w 'never-delete))
      (cond
       ((window-supports-wm-protocol-p w 'WM_DELETE_WINDOW)
	(send-client-message w 'WM_PROTOCOLS (vector (x-atom 'WM_DELETE_WINDOW)
						     (x-server-timestamp)) 32))
       (safely (beep))
       (t (x-kill-client w)))))

  (define-command 'delete-window delete-window #:spec "%W")

  (define (delete-window-safely w)
    "Delete a window, or beep if the window can't be closed safely."
    (delete-window w t))

  (define-command 'delete-window-safely delete-window-safely #:spec "%W")

;;; making window names unique

  (define (uniquify-name in existing)
    "Uniquify the string IN from the list of strings EXISTING. Uses the format
string `uniquify-name-format' to generate unique names."
    (letrec
	((again (lambda (i)
		  (if (member (format nil uniquify-name-format in i) existing)
		      (again (1+ i))
		    (format nil uniquify-name-format in i)))))
      (if (member in existing)
	  (again 2)
	in)))

  (define (uniquify-window-name w)
    "Force the current window to have a unique title."
    (set-x-text-property
     w 'WM_NAME
     (vector (uniquify-name (window-name w)
			    (mapcar window-name (delq w (managed-windows)))))))

  (define-command 'uniquify-window-name uniquify-window-name #:spec "%W")

;;; selecting a single window

  (define select-window-map
    (bind-keys (make-keymap)
               "Any-Click1" (lambda ()
                              (throw 'select-window
                                     (query-pointer-window)))))

  (defvar select-window-cursor-shape 'crosshair)

  (define (select-window)
    "Wait for a click, and returns the clicked window. Nil for the root
window."
    (allow-events 'async-pointer)
    (when (grab-pointer nil select-window-cursor-shape)
      (unwind-protect
	  (let ((override-keymap select-window-map))
	    (catch 'select-window
	      (recursive-edit)))
	(ungrab-pointer))))

;;; avoided (i.e. non-overlapped) windows

  (define (window-avoided-p w)
    "Return t if window W should be kept unobscured by other windows wherever
possible."
    (cond ((or (not (window-mapped-p w))
	       (not (window-visible-p w))) nil)
	  ((window-get w 'avoid) t)
	  ((and dont-avoid-ignored (window-get w 'ignored)) nil)
	  (t avoid-by-default)))

  (define (avoided-windows #!optional window)
    "Returns a list of all windows that should be left unobscured where
possible. If WINDOW is defined, then it defines a window that will be never
returned in the list."
    (filter-windows (lambda (w)
		      (and (not (eq w window))
			   (window-avoided-p w)))))

;;; property and window-state changed interface

  (define prop-changes '())

  (define (call-after-property-changed prop fun)
    "Arrange for function FUN to be called with arguments (WINDOW PROPERTY
STATE) when the X11 property named PROP (a symbol) changes. PROP may also
be a list of property names to monitor.

Kluge: if PROP is `WM_NAME', it is replaced with `(WM_NAME _NET_WM_NAME)'.
This is done to cope with themes that want to update title bars on name
changes but only watch `WM_NAME'.  A warning is printed on stderr when
this substitution occurs.  Those themes should really be fixed."
    (setq prop-changes
          (cons
           (cons (cond ((listp prop) prop)
                       ((eq prop 'WM_NAME)
                        (format standard-error
" (call-after-property-changed 'WM_NAME ...) should probably be
 (call-after-property-changed '(WM_NAME _NET_WM_NAME) ...);
Use '(WM_NAME) if you really want only WM_NAME\n")
                        '(WM_NAME _NET_WM_NAME))
                       (t (list prop)))
                 fun)
           prop-changes)))

  (add-hook 'property-notify-hook
	    (lambda (w prop state)
	      (mapc (lambda (cell)
                      (when (memq prop (car cell))
			((cdr cell) w prop state)))
		    prop-changes)))

  (define state-changes '())

  (define (call-after-state-changed states fun)
    "Arrange for function FUN to be called with arguments (WINDOW
CHANGED-STATES) when one of the states defined by the list of symbols
STATES has been changed. STATES may also be a single symbol."
    (setq state-changes (cons (cons (if (listp states)
					states
				      (list states)) fun) state-changes)))

  (add-hook
   'window-state-change-hook
   (lambda (w states)
     (mapc (lambda (cell)
	     (let ((relevant (filter (lambda (state)
                                       (memq state (car cell))) states)))
	       (when relevant
		 ((cdr cell) w relevant))))
           state-changes)))

  (define (rename-window window new-name)
    "Renames WINDOW to NEW-NAME."
    (when (stringp new-name)
      (set-x-text-property window 'WM_NAME (vector new-name))
      (set-x-text-property window '_NET_WM_NAME (vector new-name))
      (set-x-text-property window 'WM_ICON_NAME (vector new-name))
      (set-x-text-property window '_NET_WM_ICON_NAME (vector new-name))))

  (define-command 'rename-window rename-window
    #:spec "%W\nsEnter new window name:")

    ;; helpers for window-touching-p
  (define (find-if fn l)
    (cond ((null l) nil)
	  ((fn (car l)) (car l))
	  (t (find-if fn (cdr l)))))

  (define (overlapping w1 w2)
    "Do window W1 and window W2 overlap?"
    (and (< (abs (- (window-x w1) (window-x w2)))
	    (window-width (if (< (window-x w1) (window-x w2))
			      w1 w2)))
	(< (abs (- (window-y w1) (window-y w2)))
	    (window-height (if (< (window-y w1) (window-y w2))
			      w1 w2)))))

  (define (window-touching-p w)
    "Is window W touching another window?"
    (require 'sawfish.wm.state.ignored)
    (require 'sawfish.wm.workspace)
    (find-if (lambda (other) (overlapping w other))
	    (remove w (remove-if window-ignored-p
				  (filter-windows
				  window-on-current-workspace-p)))))

  (define (window-x w)
    (car (window-position w)))

  (define (window-y w)
    (cdr (window-position w)))

  (define (window-width w)
    (car (window-frame-dimensions w)))

  (define (window-height w)
    (cdr (window-frame-dimensions w)))

  (define (toggle-window-fixed-position w)
    "Toggle the window property `fixed-position'."
     (if (window-get w 'fixed-position)
	 (window-put w 'fixed-position nil)
       (window-put w 'fixed-position t))
     (call-window-hook 'window-state-change-hook w (list '(fixed-position))))
  (define-command 'toggle-window-fixed-position toggle-window-fixed-position #:spec "%W")

  (define (toggle-window-fixed-size w)
    "Toggle the window property `fixed-size'."
     (if (window-get w 'fixed-size)
	 (window-put w 'fixed-size nil)
       (window-put w 'fixed-size t))
     (call-window-hook 'window-state-change-hook w (list '(fixed-size))))
  (define-command 'toggle-window-fixed-size toggle-window-fixed-size #:spec "%W")

;;; gaollable functions

  (gaol-add window-really-wants-input-p window-class window-avoided-p
	    call-after-property-changed call-after-state-changed
	    window-get window-name window-full-name window-icon-name
	    window-mapped-p window-frame set-window-frame rebuild-frame
	    window-position window-dimensions window-frame-dimensions windowp
	    managed-windows stacking-order window-visibility
	    window-transient-p window-urgent-p window-shaped-p window-visible-p
	    window-framed-p window-id window-group-id window-size-hints
	    call-window-hook input-focus window-icon-image map-windows
	    filter-windows current-event-window window-put
	    move-window-to resize-window-to))

;; sm-init.jl -- session manager code loaded on startup
;; $Id: init.jl,v 1.16 2000/09/11 07:44:42 john Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.session.init

    (export sm-find-file
	    delete-session
	    sm-add-saved-properties
	    sm-get-window-prop
	    sm-save-yourself
	    sm-init)

    (open rep
	  rep.regexp
	  rep.system
	  rep.io.files
	  rep.io.processes
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.session.util)

  (defvar sm-client-id nil
    "A string identifying the current session.")

  ;; this is before both the panel and gmc..?
  (defconst sm-gsm-priority 30)

  (defvar sm-save-directory "~/.sawfish/sessions")

  (defvar sm-saved-window-properties nil
    "List of window properties saved with the session.")

  (defvar sm-window-save-functions nil
    "List of functions called when the state of each window is saved. Each
function should return a list of alist elements that will be saved in
the state file.")

  (defvar sm-restore-window-hook nil
    "List of functions called when the state of a window is restored. Each is
called with args (WINDOW ALIST), where ALIST defines the state saved for
the window.")

  (defvar sm-after-restore-hook nil
    "Hook called after loading a saved session.")

;;; utilities

  (define (sm-find-file id)
    (expand-file-name id sm-save-directory))

  (define (delete-session id)
    (let ((file (sm-find-file id)))
      (when (file-exists-p file)
	(delete-file file))))

  (define (sm-add-saved-properties #!rest props)
    (mapc (lambda (p)
	    (or (memq p sm-saved-window-properties)
		(setq sm-saved-window-properties
		      (cons p sm-saved-window-properties))))
	  props))

  ;; find PROP associated with W, or nil
  (define (sm-get-window-prop w prop)
    ;; first look in the window itself,
    (or (nth 2 (get-x-property w prop))
	;; else try the leader
	(let* (tem
	       (leader (cond ((and (setq tem (get-x-property
					      w 'WM_CLIENT_LEADER))
				   (eq (car tem) 'WINDOW)
				   (eq (nth 1 tem) 32))
			      (aref (nth 2 tem) 0))
			     ((window-group-id w))
			     ((window-transient-p w)))))
	  (and leader (nth 2 (get-x-property leader prop))))))

;; callback

  (define (sm-save-yourself)
    (require 'sawfish.wm.session.save)
    (save-session sm-client-id))

;;; initialisation

  (define (sm-init id)
    (when (setq sm-client-id (sm-connect id))
      ;; 1. setup all session manager properties

      ;; remove any --sm-client-id option from saved-command-line-args
      (let ((args saved-command-line-args)
	    tem)
	(while (cdr args)
	  (when (string-match "^(--sm-client-id|-clientId)" (car (cdr args)))
	    (setq tem (car (cdr args)))
	    (rplacd args (cdr (cdr args)))
	    (unless (string-match "^(--sm-client-id|-clientId)=" tem)
	      (rplacd args (cdr (cdr args)))))
	  (setq args (cdr args))))

      ;; XXX should I set this to SmRestartImmediately (2) instead
      ;; XXX of SmRestartIfRunning (0) ?
      (sm-set-property "RestartStyleHint" 0)

      (sm-set-property "CloneCommand" saved-command-line-args)

      ;; fix saved-command-line-args to include the client-id
      (rplacd saved-command-line-args (list* "--sm-client-id" sm-client-id
					     (cdr saved-command-line-args)))

      (sm-set-property "RestartCommand" saved-command-line-args)

      (sm-set-property "CurrentDirectory" default-directory)
      (sm-set-property
       "DiscardCommand" (list "rm" "-f" (local-file-name
					 (sm-find-file sm-client-id))))
      (sm-set-property "ProcessId" (format nil "%d" (process-id)))
      (sm-set-property "Program" (car saved-command-line-args))
      (sm-set-property "UserId" (user-login-name))

      ;; we need to start before gmc, otherwise it won't hint its icons
      (sm-set-property "_GSM_Priority" sm-gsm-priority)

      ;; 2. load the session if it exists
      (when (file-exists-p (sm-find-file sm-client-id))
	(require 'sawfish.wm.session.load)
	(load-session sm-client-id)))))

;; poweroff.jl -- reboot, halt, suspend or hibernate your machine
;;
;; Copyright (C) 2009 Christopher Roy Bratusek <zanghar@freenet.de>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.poweroff

    (export poweroff)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  rep.io.files
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.commands.launcher
	  sawfish.wm.windows)

  (define-structure-alias poweroff sawfish.wm.commands.poweroff)

  (defcustom reboot-command "sudo shutdown -r now"
    "The command used to reboot the computer."
    :type string
    :group (misc apps))

  (defcustom halt-command "sudo shutdown -h now"
    "The command used to halt the computer."
    :type string
    :group (misc apps))

  (defcustom suspend-command "sudo suspend"
    "The command used to suspend the computer."
    :type string
    :group (misc apps))

  (defcustom hibernate-command "sudo hibernate"
    "The command used to hibernate the computer."
    :type string
    :group (misc apps))

  (define (poweroff action)
    (case action
      ((reboot)
       (call-hook 'before-exit-hook)
       (map-windows delete-window)
       (system (format nil "%s &" reboot-command)))
      ((halt)
       (call-hook 'before-exit-hook)
       (map-windows delete-window)
       (system (format nil "%s &" halt-command)))
      ((suspend)   (system (format nil "%s &" suspend-command)))
      ((hibernate) (system (format nil "%s &" hibernate-command)))))

  ;;###autoload
  (define-command 'poweroff poweroff))

;; match-window.jl -- match windows to properties
;; $Id: match-window.jl,v 1.44 2000/11/29 00:54:47 jsh Exp $

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawmill.

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Commentary:

;; This module provides a general mechanism for setting properties on
;; matched windows as they're created. It removes much of the need for
;; manually creating functions to put in before-add-window-hook.

;; For example, doing:

;;	(add-window-matcher 'WM_CLASS "Term" '(place-mode . interactive))

;; makes all terminal windows be placed interactively. Or even better:

;;	(add-window-matcher 'WM_CLASS "Netscape/Navigator"
;;			    '(ignore-program-position . t))

;; makes netscape windows a lot easier to live with.

(define-structure sawfish.wm.ext.match-window

    (export match-window-grab-x-property
	    define-match-window-group
	    define-match-window-property
	    define-match-window-setter
	    define-match-window-formatter
	    add-window-matcher
	    remove-window-matcher
	    match-window)

    (open rep
	  rep.system
	  rep.regexp
	  sawfish.wm.custom
	  sawfish.wm.frames
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.focus
	  sawfish.wm.misc
	  sawfish.wm.util.groups)

  (define-structure-alias match-window sawfish.wm.ext.match-window)


;;; configuration and customize stuff

  (defvar match-window-x-properties
    '((WM_NAME . "Name")
      (WM_CLASS . "Class")
      (WM_ICON_NAME . "Icon Name")
      (WM_CLIENT_MACHINE . "Host")
      (WM_COMMAND . "Command")
      (WM_LOCALE_NAME . "Locale")))

  (defvar match-window-properties
    `((placement ,(_ "Placement")
       (avoid boolean)
       (ignore-program-position boolean)
       (place-mode ,(lambda () `(choice ,@placement-modes)))
       (position (pair number number))
       (dimensions (pair (number 1) (number 1)))
       (workspace (number 1))
       (viewport (pair (number 1) (number 1)))
       (depth (number -16 16))
       (placement-weight number)
       (maximized (choice all vertical horizontal)))
      (focus ,(_ "Focus")
       (raise-on-focus boolean)
       (focus-when-mapped boolean)
       (never-focus boolean)
       (focus-click-through boolean)
       (focus-mode ,(lambda () `(choice ,@focus-modes))))
      (appearance ,(_ "Appearance")
       (frame-type ,(lambda () `(choice ,@(mapcar car match-window-types))))
       (frame-style ,(lambda () `(symbol ,@(find-all-frame-styles t)))))
      (state ,(_ "State")
       (ignored boolean)
       (iconified boolean)
       (shaded boolean)
       (sticky boolean)
       (sticky-viewport boolean)
       (group ,(lambda ()
		 `(symbol ,@(delete-if-not symbolp (window-group-ids)))))
       (ungrouped boolean)
       (cycle-skip boolean)
       (window-list-skip boolean))
      (other ,(_ "Other")
       (unique-name boolean)
       (auto-gravity boolean)
       (shade-hover boolean)
       (transients-above (choice all parents none)))))

  ;; alist of (PROPERTY . FEATURE) mapping properties to the lisp
  ;; libraries implementing them
  (defvar match-window-features
    '((raise-on-focus . auto-raise)
      (shade-hover . shade-hover)))

  (defvar match-window-types
    '((normal . default)
      (title-only . shaped)
      (border-only . transient)
      (top-border . shaped-transient)
      (none . unframed)))

  (define (match-window-widget)
    (let ((props (mapcar
		  (lambda (sub)
		    (cons (cadr sub)
			  (mapcar (lambda (prop)
				    (if (functionp (cadr prop))
					(list* (car prop)
					       ((cadr prop))
					       (cddr prop))
				      prop))
				  (cddr sub)))) match-window-properties)))
      `(match-window ,props ,match-window-x-properties)))

  (put 'match-window 'custom-widget match-window-widget)

  ;;###autoload (defgroup match-window "Matched Windows" :layout single :require sawfish.wm.ext.match-window)
  (defgroup match-window "Matched Windows"
    :layout single
    :require sawfish.wm.ext.match-window)

  ;; List of (MATCH-ELTS . ACTION-ELTS)
  ;; Each MATCH-ELT is (PROP . REGEXP or NUMBER or SYMBOL)
  ;; Each ACTION-ELT is (PROP . VALUE)
  (defcustom match-window-profile nil
    nil
    :type match-window
    :group match-window
    :require sawfish.wm.ext.match-window)

  ;; used by sawmill-ui when grabbing property values
  (define (match-window-grab-x-property prop-name)
    (let ((real-prop (or (car (rassoc prop-name match-window-x-properties))
			 (intern prop-name)))
	  (window (select-window))
	  prop)
      (when window
	(setq prop (get-x-property window real-prop))
	(if (and prop (eq (car prop) 'STRING))
	    (setq prop (get-x-text-property window real-prop))
	  (setq prop (nth 2 prop)))
	(when prop
	  (cond ((get real-prop 'match-window-formatter)
		 (setq prop ((get real-prop 'match-window-formatter) prop)))
		((vectorp prop)
		 (setq prop (aref prop 0))))))
      (when (stringp prop)
	(setq prop (quote-regexp prop)))
      prop))

  (define (define-match-window-group group name)
    (unless (assq group match-window-properties)
      (setq match-window-properties (nconc match-window-properties
					   (list (list group name))))))

  (define (define-match-window-property name group . def)
    (let* ((group-cell (or (assq group match-window-properties)
			   (error "Unknown match-window group: %s" group)))
	   (item-cell (assq name (cddr group-cell))))
      (if item-cell
	  (rplacd item-cell def)
	(rplacd (cdr group-cell) (nconc (cddr group-cell)
					(list (cons name def)))))))

  (define (define-match-window-setter name setter)
    (put name 'match-window-setter setter))

  (define (define-match-window-formatter name formatter)
    (put name 'match-window-formatter formatter))


;;; main entry point

  (define (add-window-matcher prop value #!rest actions)
    (catch 'out
      (let
	  ((pair (cons prop value))
	   (add-to (lambda (slot)
		     (mapc (lambda (action)
			     (let
				 ((tem (assq (car action) (cdr slot))))
			       (if tem
				   (rplacd tem (cdr action))
				 (rplacd slot (cons action (cdr slot))))))
			   actions))))
	;; does the list already contain a (PROP . VALUE) pair?
	(mapc (lambda (cell)
		(when (member pair (car cell))
		  (add-to cell)
		  (throw 'out t)))
	      match-window-profile)
	;; no
	(setq match-window-profile (cons (list (cons pair nil))
					 match-window-profile))
	(add-to (car match-window-profile)))))

  (define (remove-window-matcher prop value #!rest props)
    (let
	((pair (cons prop value))
	 (remove-from (lambda (slot)
			(mapc (lambda (p)
				(let
				    ((tem (assq p (cdr slot))))
				  (when tem
				    (rplacd slot (delq tem (cdr slot))))))
			      props))))
      (mapc (lambda (cell)
	      (when (member pair (car cell))
		(remove-from cell)))
	    match-window-profile)
      ;; remove any empty matchers
      (setq match-window-profile
	    (delete-if (lambda (cell)
			 (null (cdr cell))) match-window-profile))))


;;; matcher code

  (define (safe-string-match re . args)
    (condition-case data
	(apply string-match re args)
      (regexp-error
       (format standard-error
	       "regexp error in match-window: %s, %s" re (car data)))))

  (define (match-window w)
    (let ((prop-cache '()))

      ;; Get the X property P of window W, uses a cache, will
      ;; reformat properties with a match-window-formatter property 
      (define (get-prop p)
	(let
	    ((tem (assq p prop-cache)))
	  (if tem
	      (cdr tem)
	    (setq tem (get-x-property w p))
	    (when (and tem (eq (car tem) 'STRING))
	      (rplaca (cddr tem) (get-x-text-property w p)))
	    (when (and tem (get p 'match-window-formatter))
	      (rplaca (cddr tem) ((get p 'match-window-formatter)
				  (nth 2 tem))))
	    (setq prop-cache (cons (cons p tem) prop-cache))
	    tem)))

      ;; Return t if X property PROP of window W matches INPUT (a
      ;; regexp, number, or symbol)
      (define (match-prop prop input)
	(catch 'out
	  (cond ((and (stringp input)
		      (or (stringp prop)
			  (and (vectorp prop)
			       (> (length prop) 0)
			       (stringp (aref prop 0)))))
		 ;; regexp match
		 (if (vectorp prop)
		     (do ((i 0 (1+ i)))
			 ((= i (length prop)) nil)
		       (when (safe-string-match input (aref prop i))
			 (throw 'out t)))
		   (safe-string-match input prop)))
		((and (numberp input) (numberp prop))
		 (= input prop))
		(t (equal input prop)))))

      ;; Execute the list of actions for window W
      (define (run-actions actions)
	(mapc (lambda (cell)
		(let ((feature (cdr (assq (car cell) match-window-features))))
		  (when feature
		    (require feature)))
		((or (get (car cell) 'match-window-setter) window-put)
		 w (car cell) (cdr cell)))
	      actions)
	;; hack alert!
	(when (assq 'position actions)
	  (window-put w 'placed t)))

      (mapc (lambda (cell)
	      (when (catch 'out
		      (mapc (lambda (match)
			      (let ((prop (and (symbolp (car match))
					       (get-prop (car match)))))
				(when (or (not prop)
					  (not (match-prop (nth 2 prop)
							   (cdr match))))
				  (throw 'out nil))))
			    (car cell))
		      t)
		(run-actions (cdr cell))))
	    match-window-profile)))

  (add-hook 'before-add-window-hook match-window t)


;;; custom property formatters and setters

  (define-match-window-formatter 'WM_CLASS
   (lambda (vec)
     (format nil "%s/%s" (aref vec 1) (aref vec 0))))

  (define-match-window-formatter 'WM_COMMAND
   (lambda (vec)
     (let ((i 0)
	   parts)
       (while (< i (length vec))
	 (when parts
	   (setq parts (cons ?  parts)))
	 (setq parts (cons (aref vec i) parts))
	 (setq i (1+ i)))
       (apply concat (nreverse parts)))))

  (define-match-window-setter 'workspace
   (lambda (w prop value)
     (declare (unused prop))
     (unless (or (window-get w 'placed) (window-workspaces w))
       ;; translate from 1.. to 0..
       (set-window-workspaces w (list (1- value))))))

  (define-match-window-setter 'position
   (lambda (w prop value)
     (declare (unused prop))
     (let ((x (car value))
	   (y (cdr value)))
       (when (< x 0)
	 ;; XXX should change placement gravity
	 (setq x (+ (screen-width) x)))
       (when (< y 0)
	 ;; XXX should change placement gravity
	 (setq y (+ (screen-height) y)))
       (move-window-to w x y))))

  (define-match-window-setter 'dimensions
   (lambda (w prop value)
     (declare (unused prop))
     (resize-window-with-hints w (car value) (cdr value))))

  (define-match-window-setter 'viewport
   (lambda (w prop value)
     (declare (unused prop))
     (unless (window-get w 'placed)
       (set-screen-viewport (1- (car value)) (1- (cdr value)))
       (set-window-viewport w (1- (car value)) (1- (cdr value))))))

  (define-match-window-setter 'frame-type
   (lambda (w prop value)
     (declare (unused prop))
     (set-window-type w (or (cdr (assq value match-window-types)) value))))

  (define-match-window-setter 'ungrouped
   (lambda (w prop value)
     (declare (unused prop))
     (when value
       (add-window-to-new-group w))))

  (define-match-window-setter 'unique-name
    (lambda (w prop value)
     (declare (unused prop))
      (when value
	(uniquify-window-name w))))

  (define-match-window-setter 'focus-mode
   (lambda (w prop value)
     (declare (unused prop))
     (set-focus-mode w value)))

  (define-match-window-setter 'maximized
   (lambda (w prop value)
     (declare (unused prop))
     (when (memq value '(all vertical))
       (window-put w 'queued-vertical-maximize t))
     (when (memq value '(all horizontal))
       (window-put w 'queued-horizontal-maximize t)))))

;; error-handler.jl -- replace the standard rep error handler

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.error-handler

    (export retrieve-errors
	    display-errors
	    error-handler-function)

    (open rep
	  rep.system
	  rep.data.ring
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands)

  (define-structure-alias error-handler sawfish.wm.ext.error-handler)

  (defcustom error-handler-beep t
    "Beep when errors occur."
    :type boolean
    :group misc)

  ;; By default, an error during ~/.sawfish/rc is printed to both,
  ;; and after that, only to standard-error.
  (defcustom error-destination 'standard-error
    "Display error messages to: \\left"
    :type (choice nowhere screen standard-error both)
    :group misc)

  ;; ring buffer for containing error messages
  (define error-ring (make-ring))

;;; code

  (define (error->string err data)
    (format nil "%s: %s"
	    (or (get err 'error-message) err)
	    (mapconcat (lambda (x)
			 (format nil "%s" x)) data ", ")))

  (define (handler err data)
    (let ((text (error->string err data)))
      (ring-append error-ring
		   (format nil "[%s] %s"
			   (current-time-string nil "%Y-%m-%d %H:%M:%S") text))
      (when error-handler-beep
	(beep))
      (case error-destination
	((screen)
	 (display-message text))
	((standard-error)
	 (write standard-error "Sawfish error:\n")
	 (write standard-error text)
	 (write standard-error #\newline))
	((init)
	 ;; If it's called now, then the message window is covered
	 ;; by client windows.
	 (add-hook 'after-initialization-hook
		   (lambda ()
		     (display-message
		      (concat "Error:\n(Click to dismiss. Also printed to stderr)\n\n" text))))
	 (write standard-error "Sawfish error:\n")
	 (write standard-error text)
	 (write standard-error #\newline))
	((both)
	 (display-message text)
	 (write standard-error "Sawfish error:\n")
	 (write standard-error text)
	 (write standard-error #\newline)))))

  (define (retrieve-errors) (ring->list error-ring))

  (define (display-errors)
    "Display all errors that have occurred to the screen."
    (let ((errors (retrieve-errors)))
      (display-message (if errors
			   (mapconcat identity errors #\newline)
			 (_ "No errors.")))))

  (define-command 'display-errors display-errors)

  ;; install our error handler as the system-wide handler
  (setq error-handler-function handler))

;;; jump-or-exec.jl -- flexible application shortcut keys

;; Copyright (C) 2002 Damien Elmes <resolve@repose.cx>
;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>
;; Copyright (C) 2010 Teika Kazura <teika@lavabit.com>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;;; Description

;; Provides key bindings to focus a given window, or starts the
;; application if absent.
;;

(define-structure sawfish.wm.commands.jump-or-exec

    (export jump-or-exec
	    toggle-or-exec)

    (open rep
          rep.system
	  rep.regexp
          sawfish.wm.misc
          sawfish.wm.windows
	  sawfish.wm.state.iconify
	  sawfish.wm.util.display-window
	  sawfish.wm.commands)

  (define (jump-or-exec regex prog #!key match-class onfocused)
    "Jump to a window, or when absent, start program."
    (let ((wind (if match-class
		    (get-window-by-class regex #:regex t)
		  (get-window-by-name regex #:regex t)))
	  (curwin (input-focus)))
      (cond ((and onfocused
		  curwin
		  (if match-class
		      (string-match regex (window-class curwin))
		    (string-match regex (window-name curwin))))
	     ;; Exec "onfocused"
	     (cond ((commandp onfocused)
		    (call-command onfocused))
		   ((functionp onfocused)
		    (funcall onfocused wind))
		   (t (user-eval onfocused ))))
	    ;; Jump to the window.
	    ((windowp wind) (display-window wind))
	    ;; Exec "prog"
	    ((stringp prog) (system (concat prog "&")))
	    ((functionp prog) (funcall prog))
	    ((commandp prog) (call-command prog))
	    (t (user-eval prog)))))

  (define-command 'jump-or-exec jump-or-exec)

  (define (toggle-or-exec regex prog #!key match-class)
    (jump-or-exec regex prog
		  #:match-class match-class
		  #:onfocused iconify-window))
  
  (define-command 'toggle-or-exec toggle-or-exec))

;; wm.jl -- interface to WM as a server
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.cfg.wm

    (export wm-load-slots
	    wm-load-group
	    wm-apply-changes
	    wm-locale-dir
	    wm-grab-x-property
	    wm-grab-key
	    wm-command-list
	    wm-documentation)

    (open rep
	  sawfish.client)

;;; wm communication (possibly replace by CORBA..?)

  (define (wm-eval form #!optional read-back)
    (sawfish-client-eval form (not read-back)))

  (define (wm-eval-async form)
    (sawfish-client-eval-async form))

  (define done-init nil)
  (define (init-server)
    (unless done-init
      (wm-eval '(require 'sawfish.wm.util.nokogiri))
      (setq done-init t)))

;;; stub functions

  ;; returns a list of keyworded items. Keywords include:
  ;; #:name, #:depends, #:value, #:type, #:doc
  (define (wm-load-slots names)
    (init-server)
    (wm-eval `(nokogiri-report-slots ',names) t))

  ;; return the data in GROUP
  (define (wm-load-group group)
    (init-server)
    (wm-eval `(nokogiri-report-group ',group) t))

  ;; CHANGES is list of (SLOT-NAME . NEW-VALUE)
  (define (wm-apply-changes changes)
    (init-server)
    (wm-eval `(nokogiri-apply-changes ',changes)))

  (define (wm-locale-dir)
    (wm-eval 'sawfish-locale-directory t))

  (define (wm-grab-x-property prop-name)
    (wm-eval `(nokogiri-grab-match-window-property ',prop-name) t))

  (define (wm-grab-key)
    (wm-eval '(nokogiri-grab-key) t))

  (define wm-command-list
    (let ((commands '*undefined*))
      (lambda ()
	(unless (listp commands)
	  (init-server)
	  (setq commands (wm-eval '(nokogiri-report-commands) t)))
	commands)))

  (define (wm-documentation symbol)
    (wm-eval
     `(let ((doc (command-documentation ',symbol)))
	(and doc (_ doc))) t)))

;; single-window-mode.jl - pedantic implementation of single-window-mode

;; (c) 2011 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.single-window-mode

  (export toggle-single-window-mode
	  single-window-on-workspace-p
	  window-in-single-window-mode-list-p
	  workspace-in-single-window-mode-list-p
	  single-window-mode-get-window-for-workspace
	  single-window-mode-get-window-for-workspace
	  single-window-mode-get-workspace-for-window)

  (open rep
	rep.system
	rep.regexp
	sawfish.wm
	sawfish.wm.misc
        sawfish.wm.commands
        sawfish.wm.commands.move-resize
        sawfish.wm.state.iconify
	sawfish.wm.state.maximize
        sawfish.wm.windows
	sawfish.wm.events
        sawfish.wm.workspace
	sawfish.wm.util.groups)

  (define-structure-alias single-window-mode sawfish.wm.ext.single-window-mode)

  ;; from edge-actions-1.9 branch (will be removed once EA is merged into head.

  (define (window-on-current-workspace-p w)                                                                                                                                                                                  
    (= (car (window-get w 'workspaces)) current-workspace))

  (defvar single-window-mode-window-fullscreen nil)
  (defvar single-window-mode-list ())

  (define (single-window-mode-list-append ws class)
    "Add a single-window to the list."
    (setq single-window-mode-list
      (append single-window-mode-list `((,ws . ,class)))))

  (define (single-window-mode-list-remove ws class)
    "Remove a single-window from the list."
    (setq single-window-mode-list
      (remove `(,ws . ,class) single-window-mode-list)))

  (define (single-window-on-workspace-p ws)
    "Whether there's a single-window on workspace `ws'."
    (if (assoc ws single-window-mode-list) t nil))

  (define (window-in-single-window-mode-list-p class)
    "Whether window `class' is in single-window-mode-list."
    (if (single-window-mode-get-workspace-for-window class) t nil))

  (define (workspace-in-single-window-mode-list-p ws)
    "Whether workspace `ws' is in single-window-mode-list."
    (if (single-window-mode-get-window-class-for-workspace ws) t nil))

  (define (single-window-mode-get-window-for-workspace ws)
    "Return single-window for workspace `ws' or nil, if none."
    (let ((class (cdr (assoc ws single-window-mode-list))))
      (if class (get-window-by-class class) nil)))

  (define (single-window-mode-get-window-class-for-workspace ws)
    "Return single-window's class for workspace `ws' or nil, if none."
    (cdr (assoc ws single-window-mode-list)))

  (define (single-window-mode-get-workspace-for-window class)
    "Return workspace for single-window `win' or nil, if none."
    (car (rassoc class single-window-mode-list)))

  (define (toggle-single-window-mode #!optional w)
    "Toggle single-window-mode for window `w'."
    (let ((win (if w w (input-focus)))
	  (window-ws))
      (setq window-ws (if (window-on-current-workspace-p win)
			  current-workspace
			;; XXX 'sticky winodws?
			(car (window-workspaces win))))
      (message (format nil "win: %s > ws: %s\n class: %s > win-class-ws: %s" win window-ws (window-class win)
			   (single-window-mode-get-window-class-for-workspace window-ws)))
	(if (equal (window-class win)
		   (single-window-mode-get-window-class-for-workspace window-ws))
	    (single-window-mode-stop win)
	  (if (single-window-on-workspace-p window-ws)
	      (progn
		(single-window-mode-stop (single-window-mode-get-window-for-workspace window-ws))
		(single-window-mode-start win))
	  (single-window-mode-start win))))
    (message (format nil "%s" single-window-mode-list)))

  (define-command 'toggle-single-window-mode toggle-single-window-mode)

  (define (single-window-mode-core start w)
    (let ((iconify-group-mode 'none)
	  (raise-windows-on-uniconify nil)
	  (default-window-animator 'none))
      (if start
          (progn (message (format nil "starting"))
	  (map-other-window-groups
	    (lambda (x)
	      (when (windows-share-workspace-p w x)
		(if (or (window-get x 'ignore)
			(window-get x 'avoid))
		    (lower-window x)
		  (iconify-window x)))) w))
        (message (format nil "stopping"))
	(map-other-window-groups
	    (lambda (x)
	      (when (windows-share-workspace-p w x)
		(if (or (window-get x 'ignore)
			(window-get x 'avoid))
		    (raise-window x)
		  (uniconify-window x)))) w))))

  (define (single-window-mode-start w)
    "Start single-window-mode for window `w'."
    
    (when single-window-mode-window-fullscreen
      (maximize-window-fullscreen w t))

    (single-window-mode-list-append (if (window-on-current-workspace-p w)
					current-workspace
				      (car (window-workspaces w)))
				    (window-class w))

    (single-window-mode-core t w))

  (define (single-window-mode-stop w)
    "Stop single-window-mode for window `w'."
    
    (when single-window-mode-window-fullscreen
      (unmaximize-window w))

    (single-window-mode-list-remove (if (window-on-current-workspace-p w)
					current-workspace
				      (car (window-workspaces w)))
				    (window-class w))

    (single-window-mode-core nil w))

  (define (single-window-mode-after-add-window w)
    (when (window-get w 'single-window)
      (toggle-single-window-mode w)))

  (define (single-window-mode-unmap-notify w)
    (let ((class (window-class w))
	  (ws (single-window-mode-get-workspace-for-window (window-class w)))
	  (in-list (window-in-single-window-mode-list-p (window-class w))))
      (message (format nil "unmap notify: ws: %s > class: %s > in-list: %s" ws class in-list))
      (when in-list
	(single-window-mode-list-remove ws class)
	(map-windows (lambda (x)
	  (if (or (window-get x 'ignored)
		  (window-get x 'avoid))
	      (raise-window x)
	    (uniconify-window x)))
	  (workspace-windows ws)))
      (message (format nil "unmap notify: %s" single-window-mode-list))))

  (unless batch-mode
    (add-hook 'after-add-window-hook single-window-mode-after-add-window t)
    (add-hook 'unmap-notify-hook single-window-mode-unmap-notify t)))

;; prompt-extras.jl -- more esoteric prompt variants

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Most of this is originally from Jade

(declare (in-module sawfish.wm.util.prompt))

(require 'rep.io.files)

(defvar prompt-list-fold-case nil
  "Whether prompt-from-list should ignore case.")

(defvar prompt-file-exclude '"\\.(o|jlc|x)$|~$|^#.*#$|^\\.\\.?$"
  "A regexp, if it matches the file being considered for completion, the file
is rejected.")

;;; completion/validation functions

(define (prompt-complete-filename word)
  (let* ((path (file-name-directory word))
	 (file (file-name-nondirectory word))
	 (files (directory-files path)))
    (mapcar (lambda (x)
	      (when (file-directory-p (setq x (concat path x)))
		(setq x (concat x ?/)))
	      x)
	    (delete-if (lambda (f)
			 (or (not (string-head-eq f file))
			     (string-match prompt-file-exclude f)))
		       files))))

(define (prompt-validate-filename name)
  (and (file-exists-p name) name))

(define (prompt-complete-directory word)
  (setq word (expand-file-name word))
  (let ((path (file-name-directory word))
	(file (file-name-nondirectory word)))
    (delq nil
	  (mapcar (lambda (x)
		    (when (file-directory-p (concat path x))
		      (concat path x ?/)))
		  (delete-if (lambda (f)
			       (not (string-head-eq f file)))
			     (directory-files path))))))

(define (prompt-validate-directory name)
  (and (file-directory-p name) name))

(define (prompt-abbreviate-filename name)
  (let ((abbrev (file-name-nondirectory name)))
    (if (string= abbrev "")
	(file-name-as-directory
	 (file-name-nondirectory (directory-file-name name)))
      abbrev)))

(define (prompt-list-completor prompt-list)
  (lambda (word)
    (let (out)
      (mapc (lambda (x)
              (when (string-match (concat ?^ (quote-regexp word))
                                  x nil prompt-list-fold-case)
                (setq out (cons x out)))) prompt-list)
      out)))

(define (prompt-list-validator prompt-list)
  (lambda (name)
    (if (null prompt-list-fold-case)
        (and (member name prompt-list) name)
      (catch 'exit
        (mapc (lambda (x)
                (when (string-match (concat ?^ (quote-regexp name) ?$) x nil t)
                  (throw 'exit name))) prompt-list)))))

;;; entry points

(define filename-history (prompt-make-history))
(define (prompt-for-file #!optional title existing start default)
  "Prompt for a file, if EXISTING is t only files which exist are
allowed to be entered."
  (unless (stringp title)
    (setq title "Enter filename:"))
  (setq start (if (stringp start)
		  (expand-file-name start)
		(file-name-as-directory default-directory)))
  (let ((str (prompt #:title title
                     #:start start
                     #:completion-fun prompt-complete-filename
                     #:validation-fun (and existing prompt-validate-filename)
                     #:abbrev-fun prompt-abbreviate-filename
                     #:history filename-history)))
    (when (and (string= str "") default)
      (setq str default))
    str))

(define directory-name-history (prompt-make-history))
(define (prompt-for-directory #!optional title existing start default)
  "Prompt for a directory, if EXISTING is t only files which exist are
allowed to be entered."
  (unless (stringp title)
    (setq title "Enter filename:"))
  (unless (stringp start)
    (setq start (file-name-as-directory default-directory)))
  (let ((str (prompt #:title title
                     #:start start
                     #:completion-fun prompt-complete-directory
                     #:validation-fun (and existing prompt-validate-directory)
                     #:abbrev-fun prompt-abbreviate-filename
                     #:history directory-name-history)))
    (when (and (string= str "") default)
      (setq str default))
    str))

(define (prompt-from-list options title #!optional start dont-validate)
  "Return a selected choice from the list of options (strings) OPTIONS.
PROMPT is the title displayed, START the starting choice.
Unless DONT-VALIDATE is t, only a member of PROMPT-LIST will be returned."
  (prompt #:title title
          #:start start
          #:completion-fun (prompt-list-completor options)
          #:validation-fun (if dont-validate
                               nil
                             (prompt-list-validator options))))

(define (prompt-for-string #!optional title start)
  (prompt #:title (or title "Enter string: ")
          #:start start
          ;; XXX: Why is this completing on files???
          #:completion-fun prompt-complete-filename))

(define (prompt-for-number #!optional title)
  (let (num)
    (while (not (numberp num))
      (setq num (read-from-string (prompt
                                   #:title (or title "Enter number: ")))))
    num))

(define (pwd-prompt title)
  "Prompt for a string, hiding the string behind asterisks (e.g., for
a password)."
  (prompt #:title title
          #:history (make-fluid) ; Disable history
          #:display-fun (lambda (string)
                          (make-string (length string) ?*))))

;; window-order.jl -- keep track of recently accessed windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.util.window-order

    (export window-order
	    window-order-push
	    window-order-pop
	    window-order-most-recent
	    window-order-focus-most-recent)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.session.init
	  sawfish.wm.workspace
	  sawfish.wm.viewport)

  (define-structure-alias window-order sawfish.wm.util.window-order)

  ;; window order high-water-mark
  (define window-order-highest 1)

  ;; return windows in MRU order
  (define (window-order #!optional workspace allow-iconified all-viewports)
    (let ((windows (managed-windows)))
      (setq windows (delete-if (lambda (w)
				 (or (not (window-mapped-p w))
				     (window-get w 'ignored)
				     (and (not allow-iconified)
					  (window-get w 'iconified))
				     (and workspace
					  (not (window-appears-in-workspace-p
						w workspace)))))
			       windows))
      (unless all-viewports
	(setq windows (delete-if window-outside-viewport-p windows)))
      (sort windows (lambda (x y)
		      (setq x (window-get x 'order))
		      (setq y (window-get y 'order))
		      (cond ((and x y)
			     (> x y))
			    (x t)
			    (t nil))))))

  ;; push window W onto the top of the cycle stack
  (define (window-order-push w)
    (window-put w 'order window-order-highest)
    (setq window-order-highest (1+ window-order-highest))
    (when (> window-order-highest 1000000)		;arbitrary big number
      (window-order-compress)))

  ;; remove window W from the order stack
  (define (window-order-pop w)
    (window-put w 'order nil))

  ;; compress the order stack
  (define (window-order-compress)
    (let ((order (nreverse (window-order nil t t)))	;all windows
	  (i 1))
      (map-windows (lambda (w)
		     (window-put w 'order nil)))
      (mapc (lambda (w)
	      (window-put w 'order i)
	      (setq i (1+ i))) order)
      (setq window-order-highest i)))

  (define (window-order-most-recent #!key (windows 0))
    "Return the most-recently focused window in the current workspace. If the
WINDOWS argument is given it should be a list of windows, in this case the
function will restrict its search to the elements of this list."
    (let loop ((rest (window-order current-workspace nil)))
      (cond ((null rest) nil)
	    ((or (window-get (car rest) 'never-focus)
		 (and (listp windows) (not (memq (car rest) windows))))
	     (loop (cdr rest)))
	    (t (car rest)))))

  (define (window-order-focus-most-recent)
    (set-input-focus (window-order-most-recent)))

  (define (on-viewport-change)
    ;; The problem is that any sticky windows that have been focused once
    ;; will _always_ rise to the top of the order when switching viewports
    ;; (since the topmost window is _always_ focused when entering a new
    ;; workspace). The hacky solution is to remove the order of any sticky
    ;; windows
    (let ((order (window-order current-workspace)))
      (mapc (lambda (w)
	      (when (window-get w 'sticky-viewport)
		(window-put w 'order nil))) order))
    (unless (eq focus-mode 'enter-exit)
      (window-order-focus-most-recent)))

  (sm-add-saved-properties 'order)
  (add-swapped-properties 'order)

  (add-hook 'sm-after-restore-hook window-order-compress)
  (add-hook 'iconify-window-hook window-order-pop)
  (add-hook 'viewport-moved-hook on-viewport-change))

;;; shrink windows to fit or yank them free.
;; Copyright 2000, 2001, 2003, 2005 by Timo Korvola <tkorvola@iki.fi>

;;; Commentary:
;; This package provides functions to shrink or yank a window in the
;; four cardinal directions.  Shrinking resizes the window by moving one
;; of its edges and yanking moves the window to meet the following condition:
;; - if the window was partially (or in case of yanking even entirely) outside
;;   the screen it will be entirely on the screen,
;; - otherwise, if the window intersected with other windows it will intersect
;;   with one less window,
;; - otherwise the window will not be moved or resized.
;;
;; If the window reaches its minimum size before this condition can be
;; satisfied the window is resized to the minimum size instead.  There
;; is also a minimum size constraint `shrink-window-minimum', which
;; applies to all windows.  However, it is measured in pixels and
;; windows may actually become smaller than the specified value due to
;; size truncation.
;;
;; If the window would have to be yanked off the screen to satisfy the
;; condition `yank-window-minimum-visible' pixels will be left visible instead.

(define-structure sawfish.wm.commands.shrink-yank

    (export shrink-window-left
            shrink-window-right
            shrink-window-up
            shrink-window-down
            yank-window-left
            yank-window-right
            yank-window-up
            yank-window-down)

    (open   rep
            sawfish.wm.commands
            sawfish.wm.commands.grow-pack
            sawfish.wm.events
            sawfish.wm.misc
            sawfish.wm.state.maximize
            sawfish.wm.state.iconify
            sawfish.wm.util.rects
            sawfish.wm.windows
            sawfish.wm.workspace
            sawfish.wm.custom)

  (define-structure-alias shrink-yank sawfish.wm.commands.shrink-yank)

;;; Customization options are defined in grow-pack.jl

;;; Commands:

  (define (shrink-window-left window)
    "Shrinks WINDOW by moving the right edge to the left until it
overlaps with one less window than before."
    (shrink-window window 'left))

  (define (shrink-window-right window)
    "Shrinks WINDOW by moving the left edge to the right until it
overlaps with one less window than before."
    (shrink-window window 'right))

  (define (shrink-window-up window)
    "Shrinks WINDOW by moving the lower edge upwards until it
overlaps with one less window than before."
    (shrink-window window 'up))

  (define (shrink-window-down window)
    "Shrinks WINDOW by moving the upper edge downwards until it
overlaps with one less window than before."
    (shrink-window window 'down))

  (define (yank-window-left window)
    "Moves WINDOW to the left until it overlaps with one less window
than before."
    (yank-window window 'left))

  (define (yank-window-right window)
    "Moves WINDOW to the right until it overlaps with one less window
than before."
    (yank-window window 'right))

  (define (yank-window-up window)
    "Moves WINDOW upwards until it overlaps with one less window than
before."
    (yank-window window 'up))

  (define (yank-window-down window)
    "Moves WINDOW downwards until it overlaps with one less window than
before."
    (yank-window window 'down))

  ;;###autoload
  (define-command 'shrink-window-left shrink-window-left #:spec "%W")
  (define-command 'shrink-window-right shrink-window-right #:spec "%W")
  (define-command 'shrink-window-up shrink-window-up #:spec "%W")
  (define-command 'shrink-window-down shrink-window-down #:spec "%W")
  (define-command 'yank-window-left yank-window-left #:spec "%W")
  (define-command 'yank-window-right yank-window-right #:spec "%W")
  (define-command 'yank-window-up yank-window-up #:spec "%W")
  (define-command 'yank-window-down yank-window-down #:spec "%W")

;;; Implementation:

  (define (window-frame-rect window)
    "Returns the rectangle (left top right bottom) describing the frame
dimensions of WINDOW."
    (let* ((wpos (window-position window))
	   (wdim (window-frame-dimensions window))
	   (wleft (car wpos))
	   (wtop (cdr wpos)))
      (list wleft wtop (+ wleft (car wdim)) (+ wtop (cdr wdim)))))

  ;; I can never remember these!
  (define left car)
  (define top cadr)
  (define right caddr)
  (define bottom cadddr)

  (define (maybe-warp-pointer window old-rect direction maybe)
    (define (scale x x0 x1 x0new x1new)
      (round (/ (+ (* (- x x0) x1new)
		   (* (- x1 x) x0new))
		(- x1 x0))))
    (define (truncate-rect r)
      (list (max (left r) 0)
	    (max (top r) 0)
	    (min (right r) (screen-width))
	    (min (bottom r) (screen-height))))
    (case pack-warp-pointer
      ((always) (warp-cursor-to-window window))
      ((maybe)
       (when maybe
	 (let* ((owr (truncate-rect old-rect))
                (nwr (truncate-rect (window-frame-rect window)))
                (ppos (query-pointer))
                (xpos (car ppos))
                (ypos (cdr ppos)))
	   (case direction
	     ((left right)
	      (setq xpos (scale xpos (left owr) (right owr)
                                (left nwr) (right nwr))))
	     ((up down)
	      (setq ypos (scale ypos (top owr) (bottom owr)
                                (top nwr) (bottom nwr)))))
	   (warp-cursor xpos ypos))))))

  ;; Return the coordinate of the window intersection to shink or yank
  ;; to.  This will do for both shrinking and yanking although the
  ;; requirements are slightly different: e.g., a window that
  ;; completely surrounds the active window is irrelevant for
  ;; shrinking.
  (define (find-least-intersection window wr direction yank)
    (let* ((isect-coord (if yank
			    (case direction
			      ((left up) 0)
			      ((right) (screen-width))
			      ((down) (screen-height)))
			  (case direction
			    ((left) (left wr))
			    ((up) (top wr))
			    ((right) (right wr))
			    ((down) (bottom wr)))))
	   (isect-check (case direction
			  ((left)
			   (lambda (xr)
			     (and (< isect-coord (left xr) (right wr))
				  (setq isect-coord (left xr)))))
			  ((up)
			   (lambda (xr)
			     (and (< isect-coord (top xr) (bottom wr))
				  (setq isect-coord (top xr)))))
			  ((right)
			   (lambda (xr)
			     (and (< (left wr) (right xr) isect-coord)
				  (setq isect-coord (right xr)))))
			  ((down)
			   (lambda (xr)
			     (and (< (top wr) (bottom xr) isect-coord)
				  (setq isect-coord (bottom xr))))))))
      ;; If the window is partially (shrink or yank) or entirely (yank
      ;; only) outside the screen return the screen edge.
      (cond ((and (eq direction 'left)
		  (< isect-coord (screen-width) (right wr)))
	     (screen-width))
	    ((and (eq direction 'right) (< (left wr) 0 isect-coord))
	     0)
	    ((and (eq direction 'up)
		  (< isect-coord (screen-height) (bottom wr)))
	     (screen-height))
	    ((and (eq direction 'down) (< (top wr) 0 isect-coord))
	     0)
	    (t
	     (let ((win nil))
	       (mapc (lambda (x)
		       (and (not (eql x window))
			    (not (window-iconified-p x))
			    (window-appears-in-workspace-p x current-workspace)
			    (let ((xr (window-frame-rect x)))
			      (and (positivep (rect-2d-overlap* wr xr))
				   (isect-check xr)
				   (setq win x)))))
		     (managed-windows))
	       (and win isect-coord))))))

  (define (shrink-window window direction)
    "Shrinks WINDOW by moving the edge opposite to DIRECTION (left, right,
up or down) towards DIRECTION until it overlaps with one less window than
before."
    (let* ((wr (window-frame-rect window))
	   (isect-coord (find-least-intersection window wr direction nil))
	   (nleft (left wr))
	   (ntop (top wr))
	   (wdim (window-dimensions window))
	   (nwidth (car wdim))
	   (nheight (cdr wdim)))
      (when (and isect-coord
		 (let ((max-shrinkage (- (case direction
					   ((left right) nwidth)
					   ((up down) nheight))
					 shrink-window-minimum-size)))
		   (when (positivep max-shrinkage)
		     (case direction
		       ((left) (setq nwidth (- nwidth
					       (min max-shrinkage
						    (- (right wr)
						       isect-coord)))))
		       ((up) (setq nheight (- nheight
					      (min max-shrinkage
						   (- (bottom wr)
						      isect-coord)))))
		       ((right) (setq nwidth (- nwidth
						(min max-shrinkage
						     (- isect-coord
							(left wr))))))
		       ((down) (setq nheight (- nheight
						(min max-shrinkage
						     (- isect-coord
							(top wr))))))))))
	(let ((tem (cons nwidth nheight)))
	  (maximize-truncate-dims window tem)
	  (setq nwidth (car tem)
		nheight (cdr tem)))
	(case direction
	  ((right) (setq nleft (+ nleft (- (car wdim) nwidth))))
	  ((down) (setq ntop (+ ntop (- (cdr wdim) nheight)))))
	(let ((pointerw (query-pointer-window)))
	  (move-resize-window-to window nleft ntop nwidth nheight)
	  (maybe-warp-pointer window wr direction (eql window pointerw))))))

  (define (yank-window window direction)
    "Moves WINDOW towards DIRECTION (left, right, up or down) until
WINDOW overlaps with one less window than before."
    (let* ((wr (window-frame-rect window))
	   (isect-coord (find-least-intersection window wr direction t))
	   (nleft (left wr))
	   (ntop (top wr)))
      (and isect-coord
	   (case direction
	     ((left) (let ((max-move (- (right wr)
					yank-window-minimum-visible)))
		       (when (positivep max-move)
			 (setq nleft (- nleft
					(min max-move
					     (- (right wr) isect-coord)))))))
	     ((up) (let ((max-move (- (bottom wr)
				      yank-window-minimum-visible)))
		     (when (positivep max-move)
		       (setq ntop (- ntop
				     (min max-move
					  (- (bottom wr) isect-coord)))))))
	     ((right) (let ((max-pos (- (screen-width)
					yank-window-minimum-visible)))
			(when (< (left wr) max-pos)
			  (setq nleft (min max-pos isect-coord)))))
	     ((down) (let ((max-pos (- (screen-height)
				       yank-window-minimum-visible)))
		       (when (< (top wr) max-pos)
			 (setq ntop (min max-pos isect-coord))))))
	   (let ((pointerw (query-pointer-window)))
	     (move-window-to window nleft ntop)
	     (maybe-warp-pointer window wr
				 direction (eql window pointerw)))))))

;; expose.jl --- Tile Sawfish windows in an intelligent (hah!) fashion
;;
;; Description: Handles tiling of all windows on the current workspace.
;; Windows are automatically sized and arranged to make best use of the
;; workspace without overlapping.
;;
;; Author: Mark Triggs <mst@dishevelled.net>
;; Maintainer: Christopher Roy Bratusek <nano@tuxfamily.org>

(define-structure sawfish.wm.ext.expose

    (export expose-windows
            expose-windows-vertically
            expose-windows-horizontally
  	    window-never-expose-p)

    (open rep
	  rep.data
	  rep.system
	  sawfish.wm.commands
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.state.iconify
	  sawfish.wm.state.maximize
	  sawfish.wm.state.ignored
	  sawfish.wm.commands.move-resize)

  (define-structure-alias expose sawfish.wm.ext.expose)

  (defvar min-height (/ (screen-height) 4)
    "For windows at least, wideness is preferable to tallness. So, the minimum
height specifies how short you are willing to tolerate your windows before
an extra column should be used.")

  (define (window-never-expose-p w) (window-get w 'never-expose))

  (defvar top-panel-height 0
   "This var will be considered when using tile commands offered by hqw-util")

  (defvar bottom-panel-height 0
    "This var will be considered when using tile commands offered by hqw-util")

  (define (expose-windows-vertically)
    (lambda ()
      (let (
            (wins (workspace-windows current-workspace)))
         (expose-windows wins t
                    #:top-left-corner `(0 . ,top-panel-height)
                    #:height-for-tile (- (screen-height) (+ top-panel-height bottom-panel-height))))))

  (define (expose-windows-horizontally)
    (lambda ()
      (let (
            (wins (workspace-windows current-workspace)))
         (expose-windows wins nil
                    #:top-left-corner `(0 . ,top-panel-height)
                    #:height-for-tile (- (screen-height)
                                         (+ top-panel-height bottom-panel-height))))))

  (define (expose-windows wins #!optional
                      vertically
                      #!key
                      (width-for-tile (screen-width))
                      (height-for-tile (screen-height))
                      (top-left-corner '(0 . 0)))
   "To tile windows."
   (let* (
         (windows (remove-if (or window-iconified-p
                                 window-never-expose-p
                                 window-ignored-p)
                               (or (filter-windows window-on-current-workspace-viewport-p)
                                   (filter-windows window-on-current-head-viewport-p))))
         (len (length windows))
         (border-width (- (car (window-frame-dimensions (car windows)))
                          (car (window-dimensions (car windows)))))
         (border-height (- (cdr (window-frame-dimensions (car windows)))
                           (cdr (window-dimensions (car windows)))))
         (width-step (ceiling (/  width-for-tile
                                  len)))
         (height-step (ceiling (/ height-for-tile
                                  len))))
      (do (
           (w (car windows) (progn (setq windows (cdr windows)) (car windows)))
           (x (car top-left-corner) (if vertically
                                          x
                                       (setq x (+ x width-step))))
           (y (cdr top-left-corner) (if vertically
                                          (setq y (+ y height-step))
                                       y))
           (win-width (if vertically
                            (- width-for-tile border-width)
                         (- width-step border-width)))
           (win-height (if vertically
                             (- height-step border-height)
                           (- height-for-tile border-height)))
           )
            ((null wins) )
         (move-resize-window-to w x y win-width win-height))))

  (define-command 'expose-windows expose-windows))

;; shading.jl -- window ``shading''

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.state.shading

    (export window-shaded-p
	    shade-window
	    unshade-window
	    toggle-window-shaded)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.frames
	  sawfish.wm.gaol
	  sawfish.wm.session.init
	  sawfish.wm.workspace
	  sawfish.wm.util.stacking
	  sawfish.wm.menus)

  (define-structure-alias shading sawfish.wm.state.shading)

  (defvar raise-windows-when-unshaded nil
    "Raise windows when they are unshaded.")

  (defvar shade-window-hook nil)
  (defvar unshade-window-hook nil)

  (define (window-shaded-p w) (window-get w 'shaded))

  (define (shade-window w)
    "Display only the title bar of the window."
    (unless (window-get w 'shaded)
      (window-put w 'shaded t)
      (window-put w 'hide-client t)
      (reframe-window w)
      (call-window-hook 'shade-window-hook w)
      (call-window-hook 'window-state-change-hook w (list '(shaded)))))

  (define (unshade-window w)
    "If the window is shaded (see `shade-window'), restore it to it's usual
state."
    (when (window-get w 'shaded)
      (window-put w 'shaded nil)
      (window-put w 'hide-client nil)
      (reframe-window w)
      (call-window-hook 'unshade-window-hook w)
      (call-window-hook 'window-state-change-hook w (list '(shaded)))
      (when raise-windows-when-unshaded
	(raise-window* w))))

  (define (toggle-window-shaded w)
    "Toggle the shaded (only the title bar is displayed) state of the window."
    (if (window-get w 'shaded)
	(unshade-window w)
      (shade-window w)))

  (define-command 'shade-window shade-window #:spec "%W")
  (define-command 'unshade-window unshade-window #:spec "%W")
  (define-command 'toggle-window-shaded toggle-window-shaded #:spec "%W")

;;; displaying

  (define (shaded-frame-type-mapper w type)
    (if (window-get w 'shaded)
	(case type
	  ((default shaped) 'shaded)
	  ((transient shaped-transient) 'shaded-transient)
	  ((utility shaped-utility) 'shaded-utility)
	  ((menu shaped-menu) 'shaded-menu)
	  ((toolbar shaped-toolbar) 'shaded-toolbar)
	  (t type))
      type))

  (define-frame-type-mapper shaded-frame-type-mapper)

;;; hooks

  (define (shading-add-window w)
    (when (window-get w 'shaded)
      (window-put w 'hide-client t)))

  (add-hook 'add-window-hook shading-add-window t)

  (define (shading-after-swap-in w space)
    (declare (unused space))
    (unless (eq (window-get w 'shaded)
		(window-get w 'hide-client))
      (window-put w 'hide-client (window-get w 'shaded))
      (reframe-window w)))

  (add-hook 'after-workspace-swap-in-hook shading-after-swap-in)

  (sm-add-saved-properties 'shaded)
  (add-swapped-properties 'shaded)

  (add-window-menu-toggle (_ "S_haded") 'toggle-window-shaded window-shaded-p)

  (gaol-add unshade-window)
  )

;; custom-defaults.jl -- loaded if there's no user customization

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; This file is read if there's no ~/.sawfish/custom.

;; The following can be taken as an example.
;; (But it is a deprecated variable, so meaningless per se.)

;;(custom-set-typed-variable (quote workspace-geometry)
;;			     (quote (4 1 . 1))
;;                           (quote workspace-geometry))

;; viewport-linear.jl -- linear address of viewports

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This was originally written by Eric Kidd <eric.kidd@pobox.com>

;; I've rewritten it to take advantage of lexical scope, and changed
;; some names

(define-structure sawfish.wm.commands.viewport-linear

    (export set-viewport-linear
	    define-linear-viewport-commands)

    (open rep
	  sawfish.wm.events
	  sawfish.wm.commands
	  sawfish.wm.viewport)

  (define-structure-alias viewport-linear sawfish.wm.commands.viewport-linear)

  (defvar viewport-linear-last 9)

  ;; Set the viewport using linear addressing
  (define (set-viewport-linear index)
    (set-screen-viewport (mod index (car viewport-dimensions))
			 (quotient index (car viewport-dimensions))))

  ;;###autoload
  (define-command 'set-viewport-linear set-viewport-linear
    #:spec "NIndex:"
    #:type `(and (labelled ,(_ "Index:") (number 0)))
    #:class 'viewport)

  ;; Move window to viewport INDEX using linear addressing
  (define (set-window-viewport-linear index)
    (set-window-viewport (current-event-window)
			 (mod index (car viewport-dimensions))
			 (quotient index (car viewport-dimensions))))

  ;;###autoload
  (define-command 'set-window-viewport-linear set-window-viewport-linear
    #:spec "NIndex:"
    #:type `(and (labelled ,(_ "Index:") (number 0)))
    #:class 'viewport)

  (define (define-linear-viewport-commands index)
    (let ((fn (lambda (base)
		(intern (format nil "%s:%d" base (1+ index))))))
      (define-command (fn "set-viewport-linear")
	(lambda ()
	  "Move to the specified linear viewport."
	  (set-viewport-linear index)))
      (define-command (fn "set-window-viewport-linear")
	(lambda ()
	  "Move the current window to the specified linear viewport."
	  (set-window-viewport-linear index)))
      (put (fn "set-viewport-linear") 'deprecated-command t)
      (put (fn "set-window-viewport-linear") 'deprecated-command t)))

  (do ((i 0 (1+ i)))
      ((= i viewport-linear-last))
    (define-linear-viewport-commands i)))

;;###autoload (autoload-command 'set-viewport-linear:1 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:1 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:2 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:2 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:3 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:3 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:4 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:4 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:5 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:5 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:6 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:6 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:7 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:7 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:8 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:8 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-viewport-linear:9 'sawfish.wm.commands.viewport-linear #:class 'deprecated)
;;###autoload (autoload-command 'set-window-viewport-linear:9 'sawfish.wm.commands.viewport-linear #:class 'deprecated)

;; nokogiri-widgets/pair.jl -- cons-cell widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.gtk.widgets.pair

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  ;; (pair CAR-SPEC CDR-SPEC)

  (define (box-packer arg)
    (case arg
      ((start) gtk-box-pack-start)
      ((end) gtk-box-pack-end)
      (t gtk-container-add)))

  (define (make-pair-item changed-callback left right
			  #!optional use-vbox reversed packing)
    (let ((hbox ((if use-vbox gtk-vbox-new gtk-hbox-new) nil box-spacing))
	  (left-widget (make-widget left changed-callback))
	  (right-widget (make-widget right changed-callback)))

      (let ((w1 (if (not reversed) left-widget right-widget))
	    (w2 (if (not reversed) right-widget left-widget)))

	((box-packer (car packing)) hbox (widget-gtk-widget w1))
	((box-packer (cdr packing)) hbox (widget-gtk-widget w2)))

      (gtk-widget-show hbox)

      (lambda (op)
	(case op
	  ((gtk-widget) hbox)
	  ((set) (lambda (x)
		   (widget-set left-widget (car x))
		   (widget-set right-widget (cdr x))))
	  ((clear) (lambda ()
		     (widget-clear left-widget)
		     (widget-clear right-widget)))
	  ((ref) (lambda ()
		   (cons (widget-ref left-widget)
			 (widget-ref right-widget))))
	  ((validp) (lambda (x)
		      (and (widget-valid-p left-widget (car x))
			   (widget-valid-p right-widget (cdr x)))))))))

  (define-widget-type 'pair make-pair-item))

;; poweroff.jl -- reboot, halt, suspend or hibernate your machine
;;
;; Copyright (C) 2009 Christopher Roy Bratusek <nano@jpberlin.de>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.poweroff

    (export poweroff)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  rep.io.files
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.commands.launcher
	  sawfish.wm.windows)

  (define-structure-alias poweroff sawfish.wm.commands.poweroff)

  (defcustom reboot-command "ssd --reboot"
    "The command used to reboot the computer."
    :type string
    :group (misc apps))

  (defcustom halt-command "ssd --shutdown"
    "The command used to halt the computer."
    :type string
    :group (misc apps))

  (defcustom suspend-command "ssd --suspend"
    "The command used to suspend the computer."
    :type string
    :group (misc apps))

  (defcustom hibernate-command "ssd --hibernate"
    "The command used to hibernate the computer."
    :type string
    :group (misc apps))

  (defcustom logout-command "ssd --logout"
    "The command used to logout the user."
    :type string
    :group (misc apps))

  (defcustom lockdown-command "ssd --lockdown"
    "The command used to lockdown the display."
    :type string
    :group (misc apps))

  (define (poweroff action)
    "Run one of the following system programs: 
halt, reboot, suspend, hibernate, logout or lockdown."
    (case action
      ((reboot)
       (call-hook 'before-exit-hook)
       (map-windows delete-window)
       (system (format nil "%s &" reboot-command)))
      ((halt)
       (call-hook 'before-exit-hook)
       (map-windows delete-window)
       (system (format nil "%s &" halt-command)))
      ((suspend)   (system (format nil "%s &" suspend-command)))
      ((hibernate) (system (format nil "%s &" hibernate-command)))
      ((logout) (system (format nil "%s &" logout-command)))
      ((lockdown) (system (format nil "%s &" lockdown-command)))))

  ;;###autoload
  (define-command 'poweroff poweroff))

;; modes.jl -- Define animators.

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.animation.modes

    (export draw-window-outline
	    erase-window-outline
	    define-window-outliner
	    autoload-window-outliner)

    (open rep
	  rep.util.autoloader
	  sawfish.wm.misc)

  ;; For backward compatibility.
  (define-structure-alias window-outline sawfish.wm.animation.modes)

;;; mechanics

  (define (getter symbol) (get symbol 'window-outline))
  (define (setter symbol value) (put symbol 'window-outline value))

  (define define-window-outliner setter)
  (define autoload-window-outliner (make-autoloader getter setter))
  (define window-outliner (autoloader-ref getter))

;;; entry points

  (define (draw-window-outline mode x y width height)
    "Draw an outline of a window of dimensions (WIDTH, HEIGHT) at
position (X, Y) relative to the root window.

MODE is a symbol defining the type of outline drawn, currently it may
only be `box' for a 3x3 grid.

Use the `erase-window-outline' to erase the grid. Also note that since
these functions draw directly on the root window the server should be
grabbed until the outline is erased."

    (let ((fun (window-outliner mode)))
      (when fun
	(fun x y width height))))

  (defun erase-window-outline (mode x y width height)
    "Erase a previously drawn outline of a window of dimensions (WIDTH,
HEIGHT) at position (X, Y) relative to the root window. See
`draw-window-outline'. MODE is a symbol defining the type of outline
drawn, currently it may only be `box' for a 3x3 grid."

    (draw-window-outline mode x y width height))

;;; default outline types

  (define (draw-box-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let ((gc (x-create-root-xor-gc))
	  (x-step (/ width 3))
	  (y-step (/ height 3)))
      (do ((i 0 (1+ i)))
	  ((= i 4))
	(x-draw-line 'root gc
		     (cons x (inexact->exact (round (+ y (* y-step i)))))
		     (cons (+ x width) (inexact->exact
					(round (+ y (* y-step i))))))
	(x-draw-line 'root gc
		     (cons (inexact->exact (round (+ x (* x-step i)))) y)
		     (cons (inexact->exact
			    (round (+ x (* x-step i)))) (+ y height))))
      (x-destroy-gc gc)))

  (define-window-outliner 'box draw-box-outline)

  ;; this is quite flickery.. double buffering doesn't work either..
  (define (draw-solid-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let ((gc (x-create-root-xor-gc)))
      (x-fill-rectangle 'root gc (cons x y) (cons width height))
      (x-destroy-gc gc)))

  (define-window-outliner 'solid draw-solid-outline)

  (define (draw-cross-outline x y width height)
    (require 'sawfish.wm.util.x)
      (let
        ((gc (x-create-root-xor-gc))
         (ul (cons x y))                      ; upper left
         (ur (cons (+ x width) y))            ; upper right
         (ll (cons x (+ y height)))           ; lower left
         (lr (cons (+ x width) (+ y height))) ; lower right
        )
      ; perimeter outline
      (x-draw-line 'root gc ul ur)
      (x-draw-line 'root gc ll lr)
      (x-draw-line 'root gc ul ll)
      (x-draw-line 'root gc ur lr)
      ; cross
      (x-draw-line 'root gc ul lr)
      (x-draw-line 'root gc ur ll)
      (x-destroy-gc gc)))

  (define-window-outliner 'cross draw-cross-outline)

  (define (draw-elliptical-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let
      ((gc (x-create-root-xor-gc))
       (height-prime (inexact->exact (floor (* height 1.4142))))
       (width-prime  (inexact->exact (floor (* width 1.4142))))
      )
    ; draw the circumscribed ellipse (the outside one)
    (x-draw-arc 'root gc (cons (inexact->exact (- x (floor (/ width 4.8))))
			       (inexact->exact (- y (floor (/ height 4.8)))))
		(cons width-prime height-prime)
		(cons 0 (* 360 64)))
    ; draw the inscribed ellipse (the inside one)
    (x-draw-arc 'root gc (cons x y)
		(cons width height)
		(cons 0 (* 360 64)))
    (x-destroy-gc gc)))

  (define-window-outliner 'elliptical draw-elliptical-outline)

  (define (draw-draft-line rw gc pta ptb dim-p arrow-p)
    (require 'sawfish.wm.util.x)
    (let ((pta-x (car pta)) ; recover the components
	(pta-y (cdr pta))
	(ptb-x (car ptb))
	(ptb-y (cdr ptb))
	(delta-x (- (car ptb) (car pta))) ; figure out the difference
	(delta-y (- (cdr ptb) (cdr pta)))
	(xah 4)  ; cope with different window scales
	(yah 3)  ; to ensure arrow heads look the same
	(x-dim-offset 5) ; how far to offset the dimension from the
	(y-dim-offset 5) ; draft line
	)
    ; first off, we know we are going to draw the line, always
    (x-draw-line rw gc pta ptb)
    ; now figure out if we drawing vertically or horizontally
    (if (= pta-x ptb-x)
	(progn ; vertical
	 (if dim-p
	     (x-draw-text rw gc (cons (+ pta-x x-dim-offset)
					(+ pta-y (quotient delta-y 2))
					)
			    (format nil "%d" delta-y)))
	 (if arrow-p
	     (progn
	       (x-draw-line rw gc pta (cons (+ pta-x xah) (+ pta-y yah)))
	       (x-draw-line rw gc pta (cons (- pta-x xah) (+ pta-y yah)))
	       (x-draw-line rw gc ptb (cons (+ ptb-x xah) (- ptb-y yah)))
	       (x-draw-line rw gc ptb (cons (- ptb-x xah) (- ptb-y yah)))
	      ))
	 )
	(progn ; horizontal
         (if dim-p
	   (x-draw-text rw gc (cons (+ pta-x (quotient delta-x 2))
				      (- pta-y y-dim-offset)
				      )
			    (format nil "%d" delta-x)))
         (if arrow-p
	     (progn
	       (x-draw-line rw gc pta (cons (+ pta-x xah) (+ pta-y yah)))
	       (x-draw-line rw gc pta (cons (+ pta-x xah) (- pta-y yah)))
	       (x-draw-line rw gc ptb (cons (- ptb-x xah) (+ ptb-y yah)))
	       (x-draw-line rw gc ptb (cons (- ptb-x xah) (- ptb-y yah)))
	       ))
        ))))

  (define (draw-draft-outline x y width height)
    (require 'sawfish.wm.util.x)
    (let
      ((gc (x-create-root-xor-gc))
       ; window Upper (Left Middle Right)
       (ul (cons x y))
       (um (cons (+ x (quotient width 2)) y))
       (ur (cons (+ x width) y))

       ; window Middle (Left Right)
       (ml (cons x           (+ y (quotient height 2))))
       (mr (cons (+ x width) (+ y (quotient height 2))))

       ; window Lower (Left Middle Right)
       (ll (cons x (+ y height)))
       (lm (cons (+ x (quotient width 2)) (+ y height)))
       (lr (cons (+ x width) (+ y height)))

       ; window Screen (Left Right Top Bottom)
       (sl (cons 0              (+ y (quotient height 2))))
       (sr (cons (screen-width) (+ y (quotient height 2))))
       (st (cons (+ x (quotient width 2)) 0))
       (sb (cons (+ x (quotient width 2)) (screen-height)))

       (offset 3) ; how much to offset the guidelines from the window
       )
    ; perimeter outline of window + frame
    ; is there an x-draw-retangle ?
    (x-draw-line 'root gc ul ur)
    (x-draw-line 'root gc ll lr)
    (x-draw-line 'root gc ul ll)
    (x-draw-line 'root gc ur lr)
    ; from screen left to left border
    (x-draw-line 'root gc (cons 0 y)            (cons (- x offset) y))
    (x-draw-line 'root gc (cons 0 (+ y height))
		 (cons (- x offset) (+ y height)))
    (draw-draft-line 'root gc sl ml t t)
    ; from screen top to top border
    (x-draw-line 'root gc (cons x 0) (cons x (- y offset)))
    (x-draw-line 'root gc (cons (+ x width) 0) (cons (+ x width) (- y offset)))
    (draw-draft-line 'root gc st um t t)
    ; from screen right to right border
    (x-draw-line 'root gc (cons (screen-width) y)
		 (cons (+ x width offset) y))
    (x-draw-line 'root gc (cons (screen-width) (+ y height))
		 (cons (+ x width offset) (+ y height)))
    (draw-draft-line 'root gc mr sr t t)
    ; from screen bottom to bottom border
    (x-draw-line 'root gc (cons x (screen-height))
		 (cons x (+ y height offset)))
    (x-draw-line 'root gc (cons (+ x width) (screen-height))
		 (cons (+ x width) (+ y height offset)))
    (draw-draft-line 'root gc lm sb 't 't)
    (x-destroy-gc gc)))

  (define-window-outliner 'draft draw-draft-outline))

;; transient.jl -- support transient windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.state.transient

    (export transient-of-p
	    indirect-transient-of-p
	    transient-parents
	    transient-children
	    transient-group
	    map-transient-group
	    raise-window-and-transients
	    lower-window-and-transients
	    raise-lower-window-and-transients)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands
          sawfish.wm.focus
	  sawfish.wm.windows
	  sawfish.wm.stacking
	  sawfish.wm.viewport
	  sawfish.wm.util.window-order
	  sawfish.wm.util.groups
	  sawfish.wm.frames)

  (defcustom focus-windows-when-mapped t
    "Focus on application windows when they first appear."
    :type boolean
    :group focus)

  (defcustom decorate-transients nil
    "Decorate dialog windows similarly to application windows."
    :type boolean
    :group appearance
    :after-set after-setting-frame-option)

;;; functions

  (define (transient-of-p x y #!key allow-root)
    "Return t if window X is directly a transient for window Y."
    (let ((x-for (window-transient-p x)))
      (and x-for
	   (or (eql x-for (window-id y))
	       ;; windows that set WM_TRANSIENT_FOR to the root window are
	       ;; transients for their entire group (de facto standard).
	       ;; This only makes sense for non-transient windows
	       ;; (disable this code by default, it causes too much weirdness)
	       (and allow-root
		    (eql x-for (root-window-id))
		    (window-group-id x)
		    (not (window-transient-p y))
		    (eql (window-group-id x) (window-group-id y)))))))

  (define (indirect-transient-of-p x y #!key allow-root)
    "Return t if window X is (directly, or indirectly) a transient for
window Y."
    (let loop ((x x))
      (or (transient-of-p x y #:allow-root allow-root)
	  (let ((x-for (window-transient-p x)))
	    (and x-for
		 ;; Some KDE windows set WM_TRANSIENT_FOR to their own id!
		 (not (eql x-for (window-id x)))
		 (let ((x-for-w (get-window-by-id x-for)))
		   (if x-for-w
		       (loop x-for-w)
		     nil)))))))

  (define (transient-parents w #!optional indirectly)
    "Return the list of windows that window W is a transient for."
    (filter-windows (lambda (x)
		      (and (window-mapped-p x)
			   ((if indirectly
				indirect-transient-of-p
			      transient-of-p) w x)))))

  (define (transient-children w #!optional indirectly)
    "Return the list of windows which are transients of window W."
    (filter-windows (lambda (x)
		      (and (window-mapped-p x)
			   ((if indirectly
				indirect-transient-of-p
			      transient-of-p) x w)))))

  (define (transient-group w #!optional by-depth)
    "Return the list of windows which is either a transient window for window
W, or a window which W is a transient for. This always includes W. The
`transient window for' relation holds for windows which are direct or
indirect transients of the parent window in question."
    (delete-if-not (lambda (x)
		     (and (window-mapped-p x)
			  (or (eq x w)
			      (indirect-transient-of-p x w)
			      (indirect-transient-of-p w x))))
		   (if by-depth (stacking-order) (managed-windows))))

  (define (map-transient-group fun w)
    "Map the single argument function FUN over all windows in the same
transient group as window W."
    (mapc fun (transient-group w)))

;;; commands for raising windows with their transients

  (define (raise-window-and-transients w)
    "Raise the current window to its highest allowed position in the stacking
order. Also raise any transient windows that it has."
    (raise-windows w (transient-group w t)))

  (define (lower-window-and-transients w)
    "Lower the current window to its lowest allowed position in the stacking
order. Also lower any transient windows that it has."
    (lower-windows w (transient-group w t)))

  (define (raise-lower-window-and-transients w)
    "If the window is at its highest possible position, then lower it to its
lowest possible position. Otherwise raise it as far as allowed. Also changes
the level of any transient windows it has."
    (raise-lower-windows w (transient-group w t)))

  (define-command 'raise-window-and-transients
    raise-window-and-transients #:spec "%W")
  (define-command 'lower-window-and-transients
    lower-window-and-transients #:spec "%W")
  (define-command 'raise-lower-window-and-transients
    raise-lower-window-and-transients #:spec "%W")

;;; displaying

  (define (transient-frame-type w type)
    (if (and decorate-transients (window-transient-p w))
	(case type
	  ((transient) 'default)
	  ((shaded-transient) 'shaded)
	  (t type))
      type))

  (define-frame-type-mapper transient-frame-type)

;;; hooks

  ;; 1. Transients of the currently focused window get focus.
  ;; 2. Transients of root belonging to the same window group as the
  ;;    currently focused window get focus, unless the currently focused
  ;;    window is also transient (wacky special case code in transient-of-p).
  ;; 3. Other transients for root, transients for a desktop window
  ;;    or non-transients may get focus depending on options (yes, we
  ;;    also handle non-transients).
  (define (transient-map-window w)
    (require 'sawfish.wm.workspace)
    (when (and (window-really-wants-input-p w)
               (or (window-visible-p w)
                   (window-workspaces w))
               (or (let ((focus (input-focus)))
                     (and focus (transient-of-p w focus #:allow-root t)))
                   (let ((x-for-id (window-transient-p w)))
                     (and (or (not x-for-id)
                              (eql x-for-id (root-window-id))
                              (let ((x-for (get-window-by-id x-for-id)))
                                (and x-for (window-get x-for 'desktop))))
                          (or (and
                               focus-windows-when-mapped
                               (not (eq (window-get w 'focus-when-mapped) 'never))
                               (not (window-get w 'never-focus))
                               (not (window-get w 'inhibit-focus-when-mapped)))
                              (eq (window-get w 'focus-when-mapped) 'always))))))
      (unless (window-get w 'sticky)
        (when (not (eq (car (window-in-workspace-p w current-workspace))
                       (car (window-workspaces w))))
          (select-workspace (car (window-workspaces w)))))
      (set-input-focus w)))

  ;; If a transient window gets unmapped that currently has the input
  ;; focus, pass it (the focus) to its parent. Otherwise, pass the focus
  ;; to the topmost window if click-to-focus, otherwise the window under
  ;; the mouse
  (define (transient-unmap-window w)
    (when (eq (input-focus) w)
      (let ((parent (and (window-transient-p w)
			 ;; for transient windows, look for the most
			 ;; recently focused window in its group, or
			 ;; fall back to its parent window
			 (or (window-order-most-recent
			      #:windows (delq w (windows-in-group w)))
			     (get-window-by-id (window-transient-p w))))))
	(if (and parent
                 (window-mapped-p parent)
                 (window-visible-p parent)
                 (not (window-outside-viewport-p parent))
                 (window-really-wants-input-p parent)
                 (not (window-get parent 'desktop)))
            (set-input-focus parent)
          ;; No parent to give focus back to.
          (focus-revert)))))

  (add-hook 'map-notify-hook transient-map-window)
  (add-hook 'unmap-notify-hook transient-unmap-window)
  (add-hook 'iconify-window-hook transient-unmap-window))

;; gaol.jl -- protected environment for themes
;;
;; Copyright (C) 1999, 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.gaol

    (export make-gaol
	    gaol-load
	    gaol-eval
	    gaol-add
	    gaol-define
	    gaol-define-special
	    define-gaol-structure)

    (open rep
	  rep.io.files
	  sawfish.wm.colors
	  sawfish.wm.cursors
	  sawfish.wm.events
	  sawfish.wm.fonts
	  sawfish.wm.images
	  sawfish.wm.misc
	  rep.util.gaol)

  ;; safe functions in the core module
  (define safe-functions
    '(get-color-rgb get-color color-name color-rgb colorp
      get-cursor cursorp get-font get-font-typed
      font-type-exists-p font-name fontp font-type text-width
      font-height font-ascent font-descent screen-width
      screen-height get-x-property get-x-text-property
      list-x-properties x-atom x-atom-name make-image
      make-image-from-x-drawable copy-image
      flip-image-horizontally flip-image-vertically
      flip-image-diagonally image-get image-put imagep
      image-dimensions image-border set-image-border
      image-shape-color set-image-shape-color image-modifier
      set-image-modifier make-sized-image bevel-image clear-image
      tile-image scale-image composite-images crop-image
      make-keymap bind-keys unbind-keys keymapp eventp image-ref
      image-set image-map image-fill color-rgb-8 uniquify-list))

  (define safe-specials
    '(default-foreground display-name canonical-display-name
      default-font default-frame nil-frame frame-part-classes
      decorate-transients batch-mode default-directory frame-font
      ;; This should be in librep, but I added it here, too.
      ;; Without this, wrong theme codes make Sawfish crash.
      ;; It's ok for librep to fix it, too.
      %in-condition-case))

  (define safe-features '(sawfish.wm.util.gtkrc
			  sawfish.wm.util.x
			  ;; compatibility
			  gtkrc x))
  (define fully-safe-features '(rep.io.timers rep.data.tables
				rep.data.records rep.data.ring
				rep.data.queues rep.data.symbol-table
				sawfish.wm.util.gradient
				sawfish.wm.util.recolor-image
				sawfish.wm.theming.make-theme
				sawfish.wm.tabs.tab
				;; compatibility
				timers gradient make-theme))

;;; functions

  (defmacro gaol-add vars
    `(mapc (lambda (x) (gaol-define x (symbol-value x))) ',vars))

  (defun gaol:require (feature)
    (cond ((memq feature fully-safe-features) (gaol-open feature))
	  ((memq feature safe-features) (load-module feature))
	  (t (error "Gaolled code trying to require %s" feature))))

;;; initialize the gaol envrironment

  ;; for backwards compatibility, / is integer division in themes, use
  ;; `divide' for real division
  (gaol-define 'divide /)
  (gaol-define '/ quotient)

  ;; use safe version of require
  (gaol-define 'require gaol:require)

  ;; add standard bindings
  (mapc (lambda (x)
	  (if (boundp x)
	      (gaol-define x (symbol-value x))
	    (format standard-error "warning: %s unbound\n" x))) safe-functions)
  (mapc gaol-define-special safe-specials)

  ;; a plugin, so easier to do this here..
  (call-after-load "sawfish.wm.util.x"
                   (lambda ()
                     (require 'sawfish.wm.util.x)
                     (mapc (lambda (x) (gaol-define x (symbol-value x)))
                           '(x-create-gc x-change-gc x-destroy-gc x-gc-p
                             x-create-pixmap x-create-bitmap
                             x-change-window-attributes x-window-p
                             x-destroy-drawable x-drawable-p
                             x-pixmap-p x-bitmap-p x-drawable-id
                             x-drawable-width x-drawable-height
                             x-window-id x-window-back-buffer
                             x-window-swap-buffers x-clear-window
                             x-draw-string x-draw-line
                             x-draw-rectangle x-fill-rectangle
                             x-draw-arc x-fill-arc x-fill-polygon
                             x-copy-area x-draw-image
                             x-grab-image-from-drawable
                             x-gc-set-dashes)))))

;; open-look.jl -- handle some ol hints

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; This suffers from the same limitations as the Motif hints. See
;; mwm.jl for more details

(define-structure sawfish.wm.state.open-look

    (export )

    (open rep
          rep.system
          sawfish.wm.windows
          sawfish.wm.misc
          sawfish.wm.frames)

  (define (ol-add-window w)
    (let* ((type (window-type w))
	   prop data)
      (when (setq prop (get-x-property w '_OL_WIN_ATTR))
	(setq data (nth 2 prop))
	(let ((ol-type (cond ((= (length data) 3)
			      (aref data 0))
			     ((= (length data) 5)
			      (aref data 1))
			     ((> (length data) 0)
			      ;; wordperfect gives us [_OL_WT_OTHER]
			      ;; i.e. a _single_ atom
			      (aref data 0)))))
	  (when (memq ol-type '(_OL_WT_NOTICE _OL_WT_OTHER))
	    (setq type (window-type-remove-title type)))))
      (when (setq prop (get-x-property w '_OL_DECOR_ADD))
	(setq data (nth 2 prop))
	(do ((i 0 (1+ i)))
	    ((= i (length data)))
	  (when (eq (aref data i) '_OL_DECOR_HEADER)
	    (setq type (window-type-add-title type)))))
      (when (setq prop (get-x-property w '_OL_DECOR_DEL))
	(setq data (nth 2 prop))
	(do ((i 0 (1+ i)))
	    ((= i (length data)))
	  (when (eq (aref data i) '_OL_DECOR_HEADER)
	    (setq type (window-type-remove-title type)))))
      (set-window-type w type)))

  (add-hook 'before-add-window-hook ol-add-window))

;; tab.jl - frame handling of tab
;;
;; Copyright (C) Yann Hodique <Yann.Hodique@lifl.fr>
;;
;; This file is an official accepted contribution into sawfish.
;;
;; This script is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.tabs.tab

    (export tab-pos 
            tabbar-left-margin
            tabbar-left-margin-transient
            tabbar-right-margin
            tabbar-right-margin-transient
            tab-window-add-to-tabgroup
            set-tab-adjustments)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.frames
	  sawfish.wm.tabs.tabgroup
      sawfish.wm.cursors
	  sawfish.wm.windows
      sawfish.wm.gaol)

  (define-structure-alias tab sawfish.wm.tabs.tab)

  ;; TODO:
  ;; - make calculations work with tiny windows, should fixed
  ;; - hide some frame parts on leftmost and rightmost tabs, should fixed
  ;; - add a drag-n-drop way to group windows by tabs

  (define select-cursor (default-cursor))
  (define marked-window nil)

  (define tabbar-left-dec-width)
  (define tabbar-right-dec-width)
  (define tabbar-left-margin)
  (define tabbar-right-margin)
  (define tabbar-left-margin-transient)
  (define tabbar-right-margin-transient)

  (define (set-tab-adjustments #!key theme-left-dec-width theme-right-dec-width theme-left-margin
                               theme-right-margin theme-left-margin-transient theme-right-margin-transient)
    (setq tabbar-left-dec-width theme-left-dec-width)
    (setq tabbar-right-dec-width theme-right-dec-width)
    (setq tabbar-left-margin theme-left-margin)
    (setq tabbar-right-margin theme-right-margin)
    (setq tabbar-left-margin-transient theme-left-margin-transient)
    (setq tabbar-right-margin-transient theme-right-margin-transient))

  (gaol-add set-tab-adjustments)

  (define (get-tab-pos win)
    (let* ((group (tab-find-window win))
       	   (tabnum (tab-rank win (tab-group-window-list group))))
      (tab-pos group tabnum win)))

  (define (tab-pos group tabnum win)
    "Find the left and right pixel offsets of a tab"
    (let* ((dim-x (car (window-dimensions win)))
           (dim-y (cdr (window-dimensions win)))
           (margin-l
            (if (or (eq (window-get win 'type) 'transient)
                    (eq (window-get win 'type) 'shaped-transient))
                tabbar-left-margin-transient
              tabbar-left-margin))
           (margin-r
            (if (or (eq (window-get win 'type) 'transient)
                    (eq (window-get win 'type) 'shaped-transient))
                tabbar-right-margin-transient
              tabbar-right-margin))
           (tabarea-width (- dim-x margin-l margin-r))
           (tabarea-height (- dim-y margin-l margin-r))
           (numtabs (length (tab-group-window-list group)))
           (left (quotient (* tabnum tabarea-width) numtabs))
           (bottom (quotient (* tabnum tabarea-height) numtabs))
           ;; the right edge is not always "left + (window-width / numtabs)"
           ;; that would be inaccurate due to rounding errors
           ;;
           (right (quotient (* (+ tabnum 1) tabarea-width) numtabs))
           (top (quotient (* (+ tabnum 1) tabarea-height) numtabs))
           (width (- right left))
           (height (- top bottom)))
      (list dim-x dim-y margin-l margin-r left right width bottom top height)))

  (define (tab-title-text-width win)
    "Width of the title text area is the tabwidth minus decorations by horizontal titlebar themes"
    (let* ((tabwidth (nth 6 (get-tab-pos win))))
      (+ tabwidth
         (- tabbar-left-dec-width)
         (- tabbar-right-dec-width))))

  (define (tab-title-text-height win)
    "Height of the title text area is the tabheight minus decorations by vertical titlebar themes"
    (let* ((tabheight (nth 9 (get-tab-pos win))))
      (when (> tabheight 0)
        (+ tabheight
           (- tabbar-left-dec-width)
           (- tabbar-right-dec-width)))))

  (define (tab-left-edge win)
    "Compute left edge of tab by horizontal titlebar themes"
    (let* ((left (nth 4 (get-tab-pos win)))
           (margin-l (nth 2 (get-tab-pos win))))
      (+ left margin-l)))

  (define (tab-bottom-edge win)
    "Compute bottom edge of tab by vertical titlebar themes"
    (let* ((bottom (nth 7 (get-tab-pos win)))
           (margin-l (nth 2 (get-tab-pos win))))
      (+ bottom margin-l)))

  (define (tab-right-dec-pos win)
    "Compute position of tab's right-edge decoration by horizontal titlebar themes"
    (let* ((right (nth 5 (get-tab-pos win)))
           (margin-l (nth 2 (get-tab-pos win)))
           (dim-x (nth 0 (get-tab-pos win))))
      (when (> dim-x margin-l) ;; don't display outside from frame
        (+ right margin-l (- tabbar-right-dec-width)))))

  (define (tab-top-dec-pos win)
    "Compute position of tab's top-edge decoration by vertical titlebar themes"
    (let* ((top (nth 8 (get-tab-pos win)))
           (margin-l (nth 2 (get-tab-pos win)))
           (dim-y (nth 1 (get-tab-pos win))))
      (when (> dim-y margin-l) ;; don't display outside from frame
        (+ top margin-l (- tabbar-right-dec-width)))))

  (define (tab-title-left-edge win)
    "Compute left edge of tab by horizontal titlebar themes"
    (+ (tab-left-edge win) tabbar-left-dec-width))

  (define (tab-title-bottom-edge win)
    "Compute bottom edge of tab by vertical titlebar themes"
    (+ (tab-bottom-edge win) tabbar-left-dec-width))

  ;; new classes tabs : tabbar-horizontal-left-edge tabbar-horizontal tabbar-horizontal-right-edge
  ;;
  (define-frame-class 'tabbar-horizontal-left-edge
    `((left-edge . ,tab-left-edge)) t)

  (define-frame-class 'tabbar-horizontal
    `((left-edge . ,tab-title-left-edge)
      (width . ,tab-title-text-width)))

  (define-frame-class 'tabbar-horizontal-right-edge
    `((left-edge . ,tab-right-dec-pos)) t)

  ;; new classes tabs on side : tabbar-vertical-top-edge tabbar-vertical tabbar-vertical-bottom-edge
  ;;
  (define-frame-class 'tabbar-vertical-top-edge
    `((bottom-edge . ,tab-top-dec-pos)) t)

  (define-frame-class 'tabbar-vertical
    `((bottom-edge . ,tab-title-bottom-edge)
      (height . ,tab-title-text-height)))

  (define-frame-class 'tabbar-vertical-bottom-edge
    `((bottom-edge . ,tab-bottom-edge)) t)

  (define (emit-marked-hook w)
    (call-window-hook 'window-state-change-hook w (list '(marked))))

  ;; This function is for interactive use. Use tab-group-window for lisp.
  (define (tab-window-add-to-tabgroup win)
    "Add a window to a tabgroup. Apply this command on a window, then
on another. The first window will be added to the tabgroup containig
the second."
    (when (net-wm-window-type-normal-p win)
      (if marked-window
          (progn
            (mapcar (lambda (w) 
                      (window-put w 'marked nil)
                      (emit-marked-hook w)
                      (tab-group-window w win)) marked-window)
            (default-cursor select-cursor)
            (window-put win 'marked nil)
            (setq marked-window nil))
        (window-put win 'marked t)
        (default-cursor (get-cursor marked-cursor-shape))
        (setq marked-window (cons win)))
      (emit-marked-hook win)))

  (define-command 'tab-window-add-to-tabgroup tab-window-add-to-tabgroup #:spec "%W")

  (define (tab-tabgroup-add-to-tabgroup win)
    "Add a tabgroup to a tabgroup. Apply this command on a window
from the tabgroup, then on another. The tabgroup will be added to
the tabgroup containig the second."
    (when (net-wm-window-type-normal-p win)
      (if marked-window
          (progn
            (setq marked-window (tab-group-windows (car marked-window)))
            (tab-window-add-to-tabgroup win))
        (default-cursor (get-cursor marked-cursor-shape))
        (setq marked-window (tab-group-windows win))
        (mapcar (lambda (w) 
                  (window-put w 'marked t)
                  (emit-marked-hook w)) marked-window))))

  (define-command 'tab-tabgroup-add-to-tabgroup tab-tabgroup-add-to-tabgroup #:spec "%W")

  (define (check-win)
    "Check if a window that was marked as tab is destroy"
    (if (car marked-window)
        (let ((m-list marked-window))
          (setq marked-window nil)
          (mapcar (lambda (w)
                    (if (window-id w)
                        (setq marked-window (append marked-window (cons w nil))))) m-list)
          (when (not (car marked-window))
            (default-cursor select-cursor)
            (setq marked-window nil)))))

  (add-hook 'destroy-notify-hook check-win))

;;(require 'x-cycle)
;;(define-cycle-command-pair
;;  'cycle-tabgroup 'cycle-tabgroup-backwards
;;  (lambda (w)
;;    (delete-if-not window-in-cycle-p
;;                   (delete-if (lambda (win)
;;                                (and (not (eq win w))
;;                                     (tab-same-group-p win w)))
;;                              (workspace-windows current-workspace))
;;                   )
;;    )
;;  #:spec "%W")

;; server.jl -- execute forms on demand

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; The protocol is something like:

;;	1. Send a ClientMessage event to the window identified by the
;;	property _SAWFISH_REQUEST_WIN on the root window, event mask 0,
;;	with the event's window field set to the root window, type
;;	_SAWFISH_REQUEST, format 32. data.l[0] = protocol version (1),
;;	data.l[1] = window to use for properties, data.l[2] = property
;;	containing form to evaluate, data.l[3] is non-zero if a result
;;	it required.

;;	2. The wm reads and evaluates the form from the specified
;;	property on the specified window.

;;	3. If a result is required it overwrites the form with its
;;	value, and assumes that the client will delete the property
;;	after it has read it. If no result is required, it will delete
;;	the property after having read it.

;; The result is a string, it's first byte defines whether an error
;; occurred or not, \001 if okay, \002 if an error
(define-structure sawfish.wm.server

    (export server-eval
	    server-net-init
	    server-net-exit)

    (open rep
	  rep.system
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.ext.error-handler)

  (defconst protocol-version 1)

  (define server-window nil)

  ;; Set `print-error' to non-nil for example for an async call.
  ;; Then the error is printed here.
  (define (server-eval form #!optional print-error)
    (let ((print-escape t))
      (condition-case error-data
	  ;; This enables backtrace printing inside of sawfish-client
	  (let ((%in-condition-case nil))
	    (setq form (read-from-string form))
	    (format nil "\001%S" (user-eval form)))
	(error
	 (when print-error
	   (let ((error-handler-beep nil)
		 (error-destination 'standard-error))
	     (error-handler-function 'error error-data)))
	 (format nil "\002%S" error-data)))))

  (define (server-client-message-handler w type data)
    (when (and server-window (eq w 'root)
	       (eq type '_SAWFISH_REQUEST)
	       (= (aref data 0) protocol-version))
      (let* ((window (aref data 1))
	     (prop (x-atom-name (aref data 2)))
	     (needs-result (/= (aref data 3) 0))
	     (form-data (get-x-property window prop)))
	(if needs-result
	    (set-x-property
	     window prop (server-eval (nth 2 form-data)) 'STRING 8)
	  (delete-x-property window prop)
	  (server-eval (nth 2 form-data)))
	t)))

  (define (server-net-init)
    (unless server-window
      (setq server-window (create-window 'root -100 -100 10 10))
      (set-x-property 'root '_SAWFISH_REQUEST_WIN
		      (vector server-window) 'CARDINAL 32)
      (set-x-property server-window '_SAWFISH_REQUEST_WIN
		      (vector server-window) 'CARDINAL 32)))

  (define (server-net-exit)
    (when server-window
      (delete-x-property 'root '_SAWFISH_REQUEST_WIN)
      (destroy-window server-window)
      (setq server-window nil)))

  (add-hook 'client-message-hook server-client-message-handler)
  (add-hook 'before-exit-hook server-net-exit))

;; keymap-diff.jl -- functions for diffing and patching keymaps
;;
;; Copyright (C) 2001 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.
;;
;; Authors: John Harper <jsh@eazel.com>

(define-structure sawfish.wm.util.keymap-diff

    (export diff-keymaps
	    patch-keymap)

    (open rep)

  ;; sorts non-destructively
  (define (sort-keymap map) (cons 'keymap (sort (copy-sequence (cdr map)))))

  ;; diff script elements are: (+ BINDING) or (- BINDING)

  (define (diff-keymaps from-map to-map)
    "Returns a list describing the changes need to transform the keymap
FROM-MAP to the keymap TO-MAP."

    (let loop ((from-rest (cdr (sort-keymap from-map)))
	       (to-rest (cdr (sort-keymap to-map)))
	       (diff '()))

      (cond ((and (null from-rest) (null to-rest))
	     ;; both lists ended
	     (cons 'keymap-diff (nreverse diff)))

	    ((null from-rest)
	     ;; from ended, so need to add rest of to
	     (loop '() (cdr to-rest) (cons (list '+ (car to-rest)) diff)))

	    ((null to-rest)
	     ;; to ended, so need to subtract rest of from
	     (loop (cdr from-rest)
		   '()
		   (cons (list '- (car from-rest)) diff)))

	    ((equal (car from-rest) (car to-rest))
	     ;; both equal, keep going
	     (loop (cdr from-rest) (cdr to-rest) diff))

	    ((< (car from-rest) (car to-rest))
	     ;; extra item in from list, so subtract it
	     (loop (cdr from-rest) to-rest
		   (cons (list '- (car from-rest)) diff)))

	    ((> (car from-rest) (car to-rest))
	     ;; extra item in to list, so add it
	     (loop from-rest (cdr to-rest)
		   (cons (list '+ (car to-rest)) diff))))))

  (define (patch-keymap map diff)
    "Returns a new copy of the keymap MAP, transformed following by the list
DIFF, which should have been created by the `diff-keymaps' function."

    (or (eq (car diff) 'keymap-diff)
	(error "Malformed keymap diff script"))

    (let loop ((rest (cdr diff))
	       (new-map (copy-sequence (cdr map))))

         (cond ((null rest)
                ;; end of the script, return the new map
                (cons 'keymap new-map))

               ((eq (caar rest) '-)
                ;; something to remove
                (loop (cdr rest) (delete (cadar rest) new-map)))

               ((eq (caar rest) '+)
                ;; something to add
                (loop (cdr rest) (cons (cadar rest) new-map)))

               (t (error "Malformed item in diff script: %s" (car rest)))))))

;; move-cursor.jl -- commands to move the mouse pointer

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-structure sawfish.wm.commands.move-cursor

    (export move-cursor
            move-cursor-left-fine
            move-cursor-right-fine
            move-cursor-up-fine
            move-cursor-down-fine
            move-cursor-left
            move-cursor-right
            move-cursor-up
            move-cursor-down
	    move-cursor-northwest
	    move-cursor-northeast
	    move-cursor-southwest
	    move-cursor-southeast
            move-cursor-northwest-fine
	    move-cursor-northeast-fine
	    move-cursor-southwest-fine
	    move-cursor-southeast-fine
            move-cursor-center)

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.custom
	  sawfish.wm.commands
          sawfish.wm.gaol)

  (defcustom move-cursor-increment 16
    "Number of pixels to move pointer in."
    :group misc
    :type (number 1))

  (define (move-cursor right down)
    (let ((coords (query-pointer)))
      (warp-cursor (+ (car coords) right) (+ (cdr coords) down))))

  (define (move-cursor-left)
    "Move the cursor `move-cursor-increment' pixels to the left."
    (move-cursor (- move-cursor-increment) 0))

  (define (move-cursor-right)
    "Move the cursor `move-cursor-increment' pixels to the right."
    (move-cursor move-cursor-increment 0))

  (define (move-cursor-up)
    "Move the cursor `move-cursor-increment' pixels upwards."
    (move-cursor 0 (- move-cursor-increment)))

  (define (move-cursor-down)
    "Move the cursor `move-cursor-increment' pixels downwards."
    (move-cursor 0 move-cursor-increment))

  (define (move-cursor-northwest)
    "Move the cursor `move-cursor-increment' pixels northwest"
    (move-cursor (- move-cursor-increment) (- move-cursor-increment)))

  (define (move-cursor-northeast)
    "Move the cursor `move-cursor-increment' pixels northeast"
    (move-cursor move-cursor-increment (- move-cursor-increment)))

  (define (move-cursor-southwest)
    "Move the cursor `move-cursor-increment' pixels southwest"
    (move-cursor (- move-cursor-increment) move-cursor-increment))

  (define (move-cursor-southeast)
    "Move the cursor `move-cursor-increment' pixels southeast"
    (move-cursor move-cursor-increment move-cursor-increment))

  (define (move-cursor-left-fine)
    "Move the cursor 1 pixel to the left."
    (move-cursor -1 0))

  (define (move-cursor-right-fine)
    "Move the cursor 1 pixel to the right."
    (move-cursor 1 0))

  (define (move-cursor-up-fine)
    "Move the cursor 1 pixel upwards."
    (move-cursor 0 -1))

  (define (move-cursor-down-fine)
    "Move the cursor 1 pixel downwards."
    (move-cursor 0 1))

  (define (move-cursor-northwest-fine)
    "Move the cursor `move-cursor-increment' pixels northwest"
    (move-cursor -1 -1))

  (define (move-cursor-northeast-fine)
    "Move the cursor `move-cursor-increment' pixels northeast"
    (move-cursor 1 -1))

  (define (move-cursor-southwest-fine)
    "Move the cursor `move-cursor-increment' pixels southwest"
    (move-cursor -1 1))

  (define (move-cursor-southeast-fine)
    "Move the cursor `move-cursor-increment' pixels southeast"
    (move-cursor 1 1))

  (define (move-cursor-center)
    "Move the cursor to the center of the screen"
    (warp-cursor (/ (screen-width) 2) (/ (screen-height) 2)))

  ;;###autoload
  (define-command 'move-cursor-right move-cursor-right)
  (define-command 'move-cursor-left move-cursor-left)
  (define-command 'move-cursor-up move-cursor-up)
  (define-command 'move-cursor-down move-cursor-down)
  (define-command 'move-cursor-right-fine move-cursor-right-fine)
  (define-command 'move-cursor-left-fine move-cursor-left-fine)
  (define-command 'move-cursor-up-fine move-cursor-up-fine)
  (define-command 'move-cursor-down-fine move-cursor-down-fine)
  (define-command 'move-cursor-northwest move-cursor-northwest)
  (define-command 'move-cursor-northeast move-cursor-northeast)
  (define-command 'move-cursor-southwest move-cursor-southwest)
  (define-command 'move-cursor-southeast move-cursor-southeast)
  (define-command 'move-cursor-down-fine move-cursor-down-fine)
  (define-command 'move-cursor-northwest-fine move-cursor-northwest-fine)
  (define-command 'move-cursor-northeast-fine move-cursor-northeast-fine)
  (define-command 'move-cursor-southwest-fine move-cursor-southwest-fine)
  (define-command 'move-cursor-southeast-fine move-cursor-southeast-fine)
  (define-command 'move-cursor-center move-cursor-center))

;; workspace.jl -- similar to virtual desktops

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; Sawfish's workspace are organised as a 1-dimensional continuum, from
;; -infinity to +infinity. Normally the user only sees a small part of
;; this continuum, from the first non-empty workspace to the last
;; non-empty workspace

;; So that we never run out of workspace ids the non-empty portion is
;; intermittently normalised to start with index zero

;; Inserting and deleting workspaces just involves shuffling the
;; workspace index of each window

;; The intention is that whatever structure the user wants to see (e.g.
;; grid, cube, ...) is built on top of the underlying 1d structure

;; Each window can be a member of any (positive) number of workspaces;
;; the `workspaces' property contains a list of workspace ids. Sticky
;; windows appear on all workspaces, and have their `sticky' property
;; set (with a null `workspaces' property)

;; When a window appears on more than one workspaces most of it's
;; properties are swapped in and out on demand when the current
;; workspace is changed. Use the `workspace-local-properties' and the
;; `workspace-swap-{in,out}-hook' variables (see workspace-swapper module)

;; If a window is added with its `workspaces' property set, then it's
;; added to those (logical) spaces

;; Private functions are prefixed by ws-

(eval-when-compile (require 'sawfish.wm.menus))

(define-structure sawfish.wm.workspace

    (export current-workspace
	    NormalState IconicState
	    window-workspaces
	    set-window-workspaces
	    window-in-workspace-p
	    map-window-workspaces
	    window-appears-in-workspace-p
	    transform-window-workspaces
	    workspace-empty-p
	    windows-share-workspace-p
	    all-workspaces
	    nearest-workspace-with-window
	    workspace-limits
	    workspace-id-to-logical
	    workspace-id-from-logical
	    move-window-to-workspace
	    copy-window-to-workspace
	    insert-workspace
	    remove-workspace
	    move-workspace
	    select-workspace
	    workspace-windows
	    workspace-menu
	    popup-workspace-list
	    popup-window-list
	    next-workspace
	    previous-workspace
	    send-to-workspace
	    send-to-next-workspace
	    send-to-previous-workspace
	    copy-to-next-workspace
	    copy-to-previous-workspace
	    merge-next-workspace
	    merge-previous-workspace
	    insert-workspace-before
	    insert-workspace-after
	    move-workspace-forwards
	    move-workspace-backwards
	    select-workspace-from-first
	    send-window-to-workspace-from-first
	    delete-empty-workspaces
	    delete-window-instance
	    add-swapped-properties
	    workspace-local-properties
	    set-number-of-workspaces
	    show-desktop
	    hide-desktop
	    showing-desktop-p
	    toggle-desktop
	    window-on-current-workspace-p
	    window-on-current-workspace-viewport-p

	    ;; XXX rename these..?
	    ws-remove-window
	    ws-add-window-to-space
	    ws-call-with-workspace)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.events
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.session.init
	  sawfish.wm.commands.launcher)

;;; Options and variables

  (defcustom workspace-boundary-mode 'stop
    "How to act when passing the first or last workspace."
    :type (choice stop wrap-around keep-going)
    :group workspace)

  (defcustom workspace-send-boundary-mode 'stop
    "How to act when passing the first or last workspace, while moving
a window"
    :type (choice stop wrap-around keep-going)
    :group workspace)

  (defcustom workspace-names nil
    nil
    :type* `(list string ,(_ "Workspace names"))
    :group workspace
    :widget-flags (expand-vertically)
    :after-set (lambda () (workspace-names-changed)))

  (defcustom lock-first-workspace t
    "Preserve outermost empty workspaces in the pager."
    :type boolean
    :group workspace)

  ;; Currently active workspace, an integer
  (define current-workspace 0)

  (define first-interesting-workspace nil)
  (define last-interesting-workspace nil)

  (defvar static-workspace-menus
    `((,(_ "_Insert workspace (before current)") insert-workspace-before)
      (,(_ "_Insert workspace (after current)") insert-workspace-after)
      ()
      (,(_ "Select _next workspace") next-workspace)
      (,(_ "Select _previous workspace") previous-workspace)
      ()
      (,(_ "Merge with next") merge-next-workspace)
      (,(_ "Merge with previous") merge-previous-workspace)
      ()
      (,(_ "Move workspace _right") move-workspace-forwards)
      (,(_ "Move workspace _left") move-workspace-backwards)))

  ;; X constants
  (defconst NormalState 1)
  (defconst IconicState 3)

  (defvar workspace-swap-in-hook '())
  (defvar workspace-swap-out-hook '())

  (defvar enter-workspace-hook '())
  (defvar leave-workspace-hook '())
  (defvar workspace-state-change-hook '())
  (defvar add-to-workspace-hook '())
  (defvar remove-from-workspace-hook '())

  ;; window properties whose values may differ on different workspaces
  (define workspace-local-properties '())

  ;; true when in "show desktop" mode
  (define showing-desktop nil)

;;; Workspace ``swapping''

  ;; Property swapping is done on demand, and for each window
  ;; individually. This ensures that only the minimum required data is
  ;; ever swapped

  ;; Each window has a `swapped-in' property and may have a `swapped'
  ;; property. `swapped-in' is a workspace id defining which of the
  ;; window's configurations is stored in the window itself (as if there
  ;; was no swapping). The `swapped' property is an alist associating
  ;; workspace ids with an alist of swapped attributes

  ;; this doesn't need to be called explicitly for every switch, just to
  ;; fork the data
  (define (swap-out w space)
    (let ((alist (apply nconc (mapcar (lambda (fun)
					(fun w space))
				      workspace-swap-out-hook)))
	  (swapped (assq space (window-get w 'swapped))))
      (if swapped
	  (rplacd swapped alist)
	(window-put w 'swapped (cons (cons space alist)
				     (window-get w 'swapped))))))

  ;; swap in data for workspace id SPACE to window W
  (define (swap-in w space)
    (let ((current (window-get w 'swapped-in)))
      (unless (eq current space)
	(when current
	  ;; swap out the current data
	  (swap-out w current))
	(let ((alist (assq space (window-get w 'swapped))))
	  (when alist
	    (call-hook 'workspace-swap-in-hook (list w space (cdr alist)))
	    (window-put w 'swapped (delq alist (window-get w 'swapped))))
	  (window-put w 'swapped-in space)))))

;;; Low level functions

  ;; return list of all workspaces containing window W
  (define (window-workspaces w)
    (window-get w 'workspaces))

  ;; set list of all workspaces containing window W to LST
  (define (set-window-workspaces w lst)
    (window-put w 'workspaces lst))

  ;; return t if window W is a member of workspace SPACE
  (define (window-in-workspace-p w space)
    (memq space (window-get w 'workspaces)))

  ;; map FUN over all workspace ids containing window W
  (define (map-window-workspaces fun w)
    (mapc fun (window-workspaces w)))

  (define (window-viewable-p w)
    (if showing-desktop
	(or (desktop-window-p w) (dock-window-p w))
      (not (window-get w 'iconified))))

  (define (window-appears-in-workspace-p w space)
    (or (window-get w 'sticky) (window-in-workspace-p w space)))

  ;; add window W to those in workspace SPACE
  (define (window-add-to-workspace w space)
    (set-window-workspaces
     w (cons space (delq space (window-workspaces w))))
    (cond ((= space current-workspace)
	   (swap-in w space))
	  ((and (window-get w 'swapped-in)
		(/= (window-get w 'swapped-in) space))
	   ;; write out the current state for when we switch
	   (swap-out w space))
	  (t
	   (window-put w 'swapped-in space))))

  ;; remove window W from those in workspace SPACE
  (define (window-remove-from-workspace w space)
    (set-window-workspaces w (delq space (window-workspaces w)))
    (window-put w 'swapped (delete-if (lambda (cell)
					(= (car cell) space))
				      (window-get w 'swapped)))
    (when (eq (window-get w 'swapped-in) space)
      (window-put w 'swapped-in nil)))

  ;; FUN is a function transforming an old workspace id to a new id.
  ;; Run this function over all workspaces that window W is a member of.
  (define (transform-window-workspaces fun w)
    (let ((workspaces (window-get w 'workspaces))
	  (swapped (window-get w 'swapped))
	  (swapped-in (window-get w 'swapped-in))
	  (new-workspaces '())
	  (new-swapped '()))
      (while workspaces
	(let* ((space (car workspaces))
	       (swap (assq space swapped))
	       (new (fun space)))
	  (unless (memq new new-workspaces)
	    (setq new-workspaces (cons new new-workspaces))
	    (when swap
	      (setq new-swapped (cons (cons new (cdr swap)) new-swapped))))
	  (when (eq swapped-in space)
	    (window-put w 'swapped-in new))
	  (setq workspaces (cdr workspaces))))
      (set-window-workspaces w (nreverse new-workspaces))
      (window-put w 'swapped (nreverse new-swapped))))

  ;; return t if workspace SPACE contains zero (non-sticky) windows
  (define (workspace-empty-p space)
    (catch 'out
      (map-windows (lambda (w)
		     (when (window-in-workspace-p w space)
		       (throw 'out nil))))
      t))

  ;; return t if windows W-1 and W-2 both appear on the same workspace
  (define (windows-share-workspace-p w-1 w-2)
    (if (or (window-get w-1 'sticky) (window-get w-2 'sticky))
	t
      (let ((spaces-1 (window-workspaces w-1))
	    (spaces-2 (window-workspaces w-2)))
	(catch 'out
	  (mapc (lambda (space)
		  (when (memq space spaces-2)
		    (throw 'out t))) spaces-1)
	  nil))))

  ;; return a list of all workspace indices that contain windows
  (define (all-workspaces)
    (let (spaces)
      (map-windows
       (lambda (w)
	 (map-window-workspaces (lambda (space)
				  (unless (memq space spaces)
				    (setq spaces (cons space spaces)))) w)))
      spaces))

  ;; return the nearest workspace to SPACE that contains window W
  (define (nearest-workspace-with-window w space)
    (if (window-get w 'sticky)
	space
      (let ((all (window-workspaces w))
	    (min-diff 10000)
	    (min-space nil)
	    tem)
	(while all
	  (setq tem (max (- space (car all)) (- (car all) space)))
	  (when (< tem min-diff)
	    (setq min-diff tem)
	    (setq min-space (car all)))
	  (setq all (cdr all)))
	min-space)))

  ;; returns (FIRST-INDEX . LAST-INDEX) defining the subset of the
  ;; continuum that is `interesting' to the user
  (define (workspace-limits)
    (let* ((all-spaces (all-workspaces))
	   (max-w (if last-interesting-workspace
		      (max last-interesting-workspace current-workspace)
		    current-workspace))
	   (min-w (if first-interesting-workspace
		      (min first-interesting-workspace current-workspace)
		    current-workspace)))
      (cond ((cdr all-spaces)
	     (setq max-w (max max-w (apply max all-spaces)))
	     (setq min-w (min min-w (apply min all-spaces))))
	    (all-spaces
	     (setq max-w (max max-w (car all-spaces)))
	     (setq min-w (min min-w (car all-spaces)))))
      (setq max-w (max max-w (1- (+ (length workspace-names) min-w))))
      (when lock-first-workspace
	(setq first-interesting-workspace min-w)
	(setq last-interesting-workspace max-w))
      (cons min-w max-w)))

  (define (set-number-of-workspaces wanted)
    (or (> wanted 0) (error "Too few workspaces: %s" wanted))
    (let* ((limits (workspace-limits))
	   (total (1+ (- (cdr limits) (car limits)))))
      (cond ((> total wanted)
	     ;; too many workspaces
	     (do ((i wanted (1+ i)))
		 ((>= i total))
	       (remove-workspace (car limits))))
	    ((< total wanted)
	     (setq first-interesting-workspace (car limits))
	     (setq last-interesting-workspace (1- (+ (car limits) wanted)))
	     (call-hook 'workspace-state-change-hook)))))

  (define (workspace-id-to-logical space #!optional limits)
    (unless limits
      (setq limits (workspace-limits)))
    (- space (car limits)))

  (define (workspace-id-from-logical offset #!optional limits)
    (unless limits
      (setq limits (workspace-limits)))
    (+ offset (car limits)))

  ;; renormalize the interesting workspaces so they begin at index zero
  (define (normalize-indices)
    (let* ((first-space (car (workspace-limits))))
      (map-windows (lambda (w)
		     (transform-window-workspaces (lambda (space)
						    (- space first-space)) w)))
      (setq current-workspace (- current-workspace first-space))
      (when first-interesting-workspace
	(setq first-interesting-workspace
	      (- first-interesting-workspace first-space)))
      (when last-interesting-workspace
	(setq last-interesting-workspace
	      (- last-interesting-workspace first-space)))))

  ;; insert a new workspace (returning its index) so that the workspace
  ;; before it has index AFTER
  (define (insert-workspace #!optional after)
    (unless after
      (setq after current-workspace))
    (map-windows
     (lambda (w)
       (transform-window-workspaces (lambda (space)
				      (if (> space after)
					  (1+ space)
					space)) w)))
    (when (> current-workspace after)
      (setq current-workspace (1+ current-workspace)))
    (call-hook 'workspace-state-change-hook)
    (1+ after))

  ;; merge workspace INDEX with workspace INDEX+1
  (define (remove-workspace #!optional index)
    (unless index
      (setq index current-workspace))
    (when (> current-workspace index)
      (setq current-workspace (1- current-workspace)))
    (when (and first-interesting-workspace
               (> first-interesting-workspace index))
      (setq first-interesting-workspace (1- first-interesting-workspace)))
    (when (and last-interesting-workspace
               (> last-interesting-workspace index))
      (setq last-interesting-workspace (1- last-interesting-workspace)))
    (map-windows
     (lambda (w)
       (transform-window-workspaces (lambda (space)
				      (if (> space index)
					  (1- space)
					space)) w)
       (when (and (window-in-workspace-p w current-workspace)
		  (window-viewable-p w))
	 (show-window w))))
    (call-hook 'workspace-state-change-hook))

  ;; move workspace INDEX COUNT positions forwards (+ve or -ve)
  (define (move-workspace index count)
    (cond ((> count 0)
	   (map-windows
	    (lambda (w)
	      (transform-window-workspaces (lambda (space)
					     (cond ((< space index)
						    space)
						   ((= space index)
						    (+ space count))
						   ((<= space (+ index count))
						    (1- space))
						   (t space))) w)))
	   (cond ((= current-workspace index)
		  (setq current-workspace (+ current-workspace count)))
		 ((> current-workspace index)
		  (setq current-workspace (1- current-workspace)))))
	  ((< count 0)
	   (map-windows
	    (lambda (w)
	      (transform-window-workspaces (lambda (space)
					     (cond ((> space index)
						    space)
						   ((= space index)
						    (+ space count))
						   ((>= space (+ index count))
                                                    (1+ space))
						   (t space))) w)))
	   (cond ((= current-workspace index)
		  (setq current-workspace (+ current-workspace count)))
		 ((< current-workspace index)
		  (setq current-workspace (1+ current-workspace))))))
    (call-hook 'workspace-state-change-hook))

  ;; called when window W is destroyed
  (define (ws-remove-window w #!optional dont-hide)
    (let ((spaces (window-workspaces w)))
      (mapc (lambda (space)
	      (window-remove-from-workspace w space)) spaces)
      (when (and (not dont-hide) (windowp w))
	(hide-window w))
      (mapc (lambda (space)
	      (call-window-hook
	       'remove-from-workspace-hook w (list space))) spaces)
      (call-hook 'workspace-state-change-hook)))

  ;; move window W from workspace id OLD to workspace NEW
  (define (move-window-to-workspace w old new #!optional was-focused)
    (or (window-in-workspace-p w old)
	(error
	 "move-window-to-workspace--window isn't in original workspace: %s, %s"
         w old))
    (unless (= old new)
      (cond ((window-in-workspace-p w new)
	     ;; just remove from the source workspace
	     (window-remove-from-workspace w old)
	     (call-window-hook 'remove-from-workspace-hook w (list old)))
	    (t
	     ;; need to move it..
	     (transform-window-workspaces (lambda (space)
					    (if (= space old)
						new
					      space)) w)))
      (cond ((= old current-workspace)
	     (hide-window w))
	    ((and (= new current-workspace) (window-viewable-p w))
	     (show-window w)))
      ;; the window may lose the focus when switching spaces
      (when (and was-focused (window-visible-p w))
	(set-input-focus w))
      (call-window-hook 'add-to-workspace-hook w (list new))
      (call-hook 'workspace-state-change-hook)))

  ;; arrange it so that window W appears on both OLD and NEW workspaces
  (define (copy-window-to-workspace w old new #!optional was-focused)
    (or (window-in-workspace-p w old)
	(error
	 "copy-window-to-workspace--window isn't in original workspace: %s, %s"
         w old))
    (unless (= old new)
      (unless (window-in-workspace-p w new)
	(window-add-to-workspace w new))
      (when (and (= new current-workspace) (window-viewable-p w))
	(show-window w))
      ;; the window may lose the focus when switching spaces
      (when (and was-focused (window-visible-p w))
	(set-input-focus w))
      (call-window-hook 'add-to-workspace-hook w (list new))
      (call-hook 'workspace-state-change-hook)))

  ;; switch to workspace with id SPACE
  (define (select-workspace* space #!key dont-focus inner-thunk force)
    "Activate workspace number SPACE (from zero)."
    (when (or force (/= current-workspace space))
      (when current-workspace
	(call-hook 'leave-workspace-hook (list current-workspace)))
      (let ((order (stacking-order)))

	;; install the new workspace id
	(setq current-workspace space)

	;; this used to be called between unmapping old windows and
	;; mapping new windows, but we don't do that anymore. This
	;; should be ok though..
	(when inner-thunk
	  (inner-thunk))

	;; the server grabs are just for optimisation (each call to
	;; show-window or hide-window may also grab the server semaphore)
	(with-server-grabbed

	 ;; first map new windows top-to-bottom
	 (mapc (lambda (w)
             (when (and (window-appears-in-workspace-p w current-workspace)
                        (cdr (window-get w 'workspaces)))
               (swap-in w current-workspace))
             (when (and (window-appears-in-workspace-p w current-workspace)
                        (window-get w 'placed))
               (if (window-viewable-p w)
                   (show-window w)
                 (hide-window w))))
	       order)

	 ;; then unmap old-windows bottom-to-top
	 (mapc (lambda (w)
		 (when (and (not (window-appears-in-workspace-p
				  w current-workspace))
			    (window-get w 'placed))
		   (hide-window w)))
	       (nreverse order)))

	;; focus the correct window in the new workspace
	(unless (or dont-focus (eq focus-mode 'enter-exit))
	  (require 'sawfish.wm.util.window-order)
	  (window-order-focus-most-recent))

	;; and call some hooks
	(when current-workspace
	  (call-hook 'enter-workspace-hook (list current-workspace)))
	(call-hook 'workspace-state-change-hook))))

  (define (select-workspace space #!optional dont-focus inner-thunk)
    (select-workspace* space #:dont-focus dont-focus
                       #:inner-thunk inner-thunk))

  ;; return a list of all windows on workspace index SPACE
  (define (workspace-windows
	   #!optional (space current-workspace) include-iconified)
    (filter-windows
     (lambda (w)
       (and (window-in-workspace-p w space)
	    (or include-iconified (not (window-get w 'iconified)))))))

  ;; add window W to workspace index SPACE; window shouldn't be in any
  ;; workspace
  (define (ws-add-window-to-space w space)
    (unless (window-get w 'sticky)
      (window-add-to-workspace w space)
      (cond ((not (window-viewable-p w))
	     (hide-window w))
	    ((= space current-workspace)
	     (show-window w))
	    ((not (window-in-workspace-p w current-workspace))
	     (hide-window w)))
      (call-window-hook 'add-to-workspace-hook w (list space))
      (call-hook 'workspace-state-change-hook)))

  ;; usually called from the add-window-hook; adds window W to the
  ;; current workspace (or wherever else it should go)
  (define (ws-add-window w)
    (ws-window-activated w)
    (if (window-get w 'sticky)
	(progn
	  (set-window-workspaces w nil)
	  (window-put w 'swapped-in current-workspace)
	  (if (window-viewable-p w)
	      (show-window w)
	    (hide-window w)))
      (if (window-workspaces w)
	  (let ((spaces (window-workspaces w))
		(limits (workspace-limits)))
	    (set-window-workspaces w '())
	    (mapc (lambda (space)
		    (ws-add-window-to-space
		     w (workspace-id-from-logical space limits))) spaces))
	;; add it to the current workspace
	(ws-add-window-to-space w current-workspace))))

  ;; called from the unmap-notify hook
  (define (ws-window-unmapped w)
    (unless (window-get w 'sticky)
      (ws-remove-window w t)))

  ;; called from the map-notify-hook
  (define (ws-window-mapped w)
    (unless (or (window-get w 'sticky) (window-workspaces w))
      (ws-add-window w)))

  (define (ws-window-activated w)
    (when (and showing-desktop
	       (not (or (desktop-window-p w) (dock-window-p w))))
      (hide-desktop)))

;;; Menu constructors

  (define (workspace-menu)
    (let ((limits (workspace-limits))
	  menu)
      (do ((i (car limits) (1+ i)))
	  ((> i (cdr limits)))
	(let ((ws-name (or (nth (- i (car limits)) workspace-names)
			   (format nil (_ "space %d")
				   (1+ (- i (car limits)))))))
	  (setq menu (cons (list (quote-menu-item ws-name)
				 (lambda () (select-workspace i))
				 (cons 'check (= i current-workspace))
				 '(group . current-workspace))
			   menu))))
      (nconc (nreverse menu) (list nil) static-workspace-menus)))

  (define (popup-workspace-list)
    "Display the menu containing the list of all workspaces."
    (require 'sawfish.wm.menus)
    (popup-menu (workspace-menu)))

  (define (popup-window-list)
    "Display the menu of all managed windows."
    (require 'sawfish.wm.menus)
    (declare (special window-menu))
    (popup-menu (window-menu)))

  (define-command 'popup-workspace-list popup-workspace-list)
  (define-command 'popup-window-list popup-window-list)

;;; Commands

  (define (ws-call-with-workspace fun count mode)
    (let ((limits (workspace-limits))
	  (target (+ current-workspace count)))
      (if (and (>= target (car limits)) (<= target (cdr limits)))
	  (fun target)
	(cond ((eq mode 'stop))
	      ((eq mode 'wrap-around)
	       (fun (+ (car limits)
		       (mod (- target (car limits))
			    (1+ (- (cdr limits) (car limits)))))))
	      ((eq mode 'keep-going)
	       (fun target))))))

  (define (next-workspace count)
    "Display the next workspace."
    (ws-call-with-workspace select-workspace count workspace-boundary-mode))

  (define (previous-workspace count)
    "Display the previous workspace."
    (next-workspace (- count)))

  (define-command 'next-workspace next-workspace #:spec "p")
  (define-command 'previous-workspace previous-workspace #:spec "p")

  (define (send-to-next-workspace w count #!optional copy select)
    "Move the window to the next workspace."
    (require 'sawfish.wm.tabs.tabgroup)
    (ws-call-with-workspace
     (lambda (space)
       (let ((was-focused (eq w (input-focus)))
             (orig-space (if (window-in-workspace-p
                              w current-workspace)
                             current-workspace
                           (car (window-workspaces w))))
             (wins (tab-group-windows w)))
         (when orig-space
           (mapcar (lambda (w)
                     (copy-window-to-workspace w orig-space space)) wins)
           (when select
             (select-workspace space was-focused))
           (unless copy
             (mapcar (lambda (w)  
                       (move-window-to-workspace w orig-space space)) wins))
           (when (and was-focused (window-visible-p w))
             (set-input-focus w)))))
     count workspace-send-boundary-mode))

  (define (send-to-previous-workspace w count #!optional copy select)
    "Move the window to the previous workspace."
    (send-to-next-workspace w (- count) copy select))

  (define-command 'send-to-next-workspace send-to-next-workspace
    #:spec "%W\np\n\nt")
  (define-command 'send-to-previous-workspace send-to-previous-workspace
    #:spec "%W\np\n\nt")

  (define (copy-to-next-workspace w count select)
    "Copy the window to the next workspace."
    (send-to-next-workspace w count t select))

  (define (copy-to-previous-workspace w count #!optional select)
    "Copy the window to the previous workspace."
    (send-to-previous-workspace w count t select))

  (define-command 'copy-to-next-workspace copy-to-next-workspace
    #:spec "%W\np\nt")
  (define-command 'copy-to-previous-workspace copy-to-previous-workspace
    #:spec "%W\np\nt")

  (define (append-workspace-and-send w #!optional select)
    "Create a new workspace at the end of the list, and move the window to it."
    (let ((limits (workspace-limits))
	  (was-focused (eq (input-focus) w))
	  (orig-space (if (window-in-workspace-p w current-workspace)
			  current-workspace
			(car (window-workspaces w)))))
      (when orig-space
	(if select
	    (progn
	      (select-workspace (1+ (cdr limits)) was-focused)
	      (move-window-to-workspace
	       w orig-space current-workspace was-focused))
	  (move-window-to-workspace
	   w orig-space (1+ (cdr limits)) was-focused)))))

  (define (prepend-workspace-and-send w #!optional select)
    "Create a new workspace at the start of the list, and move the
window to it."
    (let ((limits (workspace-limits))
	  (was-focused (eq (input-focus) w))
	  (orig-space (if (window-in-workspace-p w current-workspace)
			  current-workspace
			(car (window-workspaces w)))))
      (when orig-space
	(if select
	    (progn
	      (select-workspace (1- (car limits)) was-focused)
	      (move-window-to-workspace
	       w orig-space current-workspace was-focused))
	  (move-window-to-workspace
	   w orig-space (1- (car limits)) was-focused)))))

  (define-command 'append-workspace-and-send append-workspace-and-send
    #:spec "%W\nt")
  (define-command 'prepend-workspace-and-send prepend-workspace-and-send
    #:spec "%W\nt")

  (define (merge-next-workspace)
    "Delete the current workspace. Its member windows are relocated to the next
workspace."
    (remove-workspace current-workspace))

  (define (merge-previous-workspace)
    "Delete the current workspace. Its member windows are relocated to the
previous workspace."
    (remove-workspace (1- current-workspace)))

  (define-command 'merge-next-workspace merge-next-workspace
   )
  (define-command 'merge-previous-workspace merge-previous-workspace
   )

  (define (insert-workspace-after)
    "Create a new workspace following the current workspace."
    (insert-workspace current-workspace)
    (select-workspace (1+ current-workspace)))

  (define (insert-workspace-before)
    "Create a new workspace before the current workspace."
    (insert-workspace (1- current-workspace))
    (select-workspace (- current-workspace 2)))

  (define-command 'insert-workspace-after insert-workspace-after
   )
  (define-command 'insert-workspace-before insert-workspace-before
   )

  (define (move-workspace-forwards #!optional count)
    "Move the current workspace one place to the right."
    (move-workspace current-workspace (or count 1)))

  (define (move-workspace-backwards #!optional count)
    "Move the current workspace one place to the left."
    (move-workspace current-workspace (- (or count 1))))

  (define-command 'move-workspace-forwards move-workspace-forwards
   )
  (define-command 'move-workspace-backwards move-workspace-backwards
   )

  (define (select-workspace-from-first count)
    (select-workspace (workspace-id-from-logical count)))

  (define (send-window-to-workspace-from-first w count #!optional copy select)
    (let* ((was-focused (eq (input-focus) w))
	   (orig-space (if (window-in-workspace-p w current-workspace)
			   current-workspace
			 (car (window-workspaces w))))
	   (new-space (workspace-id-from-logical count)))
      (when (and orig-space (/= orig-space new-space))
	(copy-window-to-workspace w orig-space new-space was-focused)
	(when select
	  (select-workspace new-space was-focused))
	(unless copy
	  (move-window-to-workspace w orig-space new-space was-focused)))))

  (define (delete-empty-workspaces)
    "Delete any workspaces that don't contain any windows."
    (let* ((limits (workspace-limits))
	   (space (car limits)))
      (while (<= space (cdr limits))
	(if (workspace-empty-p space)
	    (cond ((= space (car limits))
		   (when (= first-interesting-workspace space)
		     (setq first-interesting-workspace (1+ space)))
		   (setq space (1+ space)))
		  ((= space (cdr limits))
		   (when (= last-interesting-workspace space)
		     (setq last-interesting-workspace (1- space)))
		   (setq space (1+ space)))
		  (t
		   (remove-workspace space)
		   (setq limits (workspace-limits))))
	  (setq space (1+ space))))
      (when (and first-interesting-workspace
		 (> first-interesting-workspace last-interesting-workspace))
	(setq first-interesting-workspace last-interesting-workspace))))

  (define-command 'delete-empty-workspaces delete-empty-workspaces
   )

  (define (delete-window-instance w)
    "Remove the copy of the window on the current workspace. If this is the
last instance remaining, then delete the actual window."
    (let ((spaces (window-workspaces w)))
      (if (cdr spaces)
	  ;; not the last instance
	  (let ((space (if (memq current-workspace spaces)
			   current-workspace
			 (car spaces))))
	    (window-remove-from-workspace w space)
	    (when (= space current-workspace)
	      (hide-window w))
	    (call-window-hook 'remove-from-workspace-hook w (list space))
	    (call-hook 'workspace-state-change-hook))
	(delete-window w))))

  (define-command 'delete-window-instance delete-window-instance #:spec "%W")

  (define (show-desktop)
    "Hide all windows except the desktop window."
    (unless showing-desktop
      (setq showing-desktop t)
      (select-workspace* current-workspace #:force t)))

  (define (hide-desktop)
    "Undoes the effect of the `show-desktop' command."
    (when showing-desktop
      (setq showing-desktop nil)
      (select-workspace* current-workspace #:force t)))

  (define (showing-desktop-p)
    "Returns true when in `showing desktop' mode."
    showing-desktop)

  (define (toggle-desktop)
    "Hide or unhide all windows except the desktop window."
    (if showing-desktop
        (hide-desktop)
      (show-desktop)))

  (define-command 'show-desktop show-desktop)
  (define-command 'hide-desktop hide-desktop)
  (define-command 'toggle-desktop toggle-desktop)

  (define (window-on-current-workspace-p w)
    (= (car (window-get w 'workspaces)) current-workspace))

  (define (window-on-current-workspace-viewport-p w)
    (require 'sawfish.wm.viewport)
    (and (= (car (window-get w 'workspaces)) current-workspace)
	 (not (window-outside-viewport-p w))))

;;; some commands for moving directly to a workspace

  (define (activate-workspace n)
    "Select the N'th workspace."
    (select-workspace-from-first (1- n)))

  (define-command 'activate-workspace activate-workspace
    #:spec "NWorkspace:"
    #:type `(and (labelled ,(_ "Workspace:") (number 1))))

  (define (send-to-workspace n)
    "Move the current window to the N'th workspace."
    (send-window-to-workspace-from-first (current-event-window) (1- n)))

  (define-command 'send-to-workspace send-to-workspace
    #:spec "NWorkspace:"
    #:type `(and (labelled ,(_ "Workspace:") (number 1))))

  (define (copy-to-workspace n)
    "Copy the current window to the N'th workspace."
    (send-window-to-workspace-from-first (current-event-window) (1- n) t))

  (define-command 'copy-to-workspace copy-to-workspace
    #:spec "NWorkspace:"
    #:type `(and (labelled ,(_ "Workspace:") (number 1))))

  (define (select-workspace-interactively)
    "Prompt for a workspace and switch to it."
    (require 'sawfish.wm.util.prompt)
    (let ((ws (prompt-for-workspace)))
      (when ws
	(select-workspace-from-first (1- ws)))))

  (define-command 'select-workspace-interactively
    select-workspace-interactively)

;;; session management

  (define (ws-saved-state w)
    (unless (window-get w 'sticky)
      (let ((limits (workspace-limits))
	    (spaces (window-workspaces w)))
	(when spaces
	  `((workspaces . ,(mapcar (lambda (space)
				     (workspace-id-to-logical space limits))
				   spaces)))))))

  (define (ws-load-state w alist)
    (cond ((cdr (assq 'workspaces alist))
	   (set-window-workspaces w (cdr (assq 'workspaces alist))))
	  ((cdr (assq 'workspace alist))
	   ;; backwards compatibility..
	   (set-window-workspaces w (list (cdr (assq 'workspace alist)))))))

  ;; Note that all of PROPS (symbols) should be saved and restored
  ;; automatically when swapping window states
  (define (add-swapped-properties #!rest props)
    (mapc (lambda (p)
	    (or (memq p workspace-local-properties)
		(setq workspace-local-properties
		      (cons p workspace-local-properties))))
	  props))

;;; configuration

  (define (workspace-names-changed)
    ;; XXX this isn't ideal, but it's better than getting
    ;; XXX workspaces that aren't deleted as the total
    ;; XXX number of workspaces is decreased...
    (setq first-interesting-workspace nil)
    (setq last-interesting-workspace nil)
    (call-hook 'workspace-state-change-hook))

;;; Initialisation

  (sm-add-saved-properties 'sticky 'iconified 'fixed-position)

  ;; some of these should really be added by other files
  (add-swapped-properties 'frame-style 'type)

  (add-hook 'add-window-hook ws-add-window)
  (add-hook 'map-notify-hook ws-window-mapped)
  (add-hook 'activate-window-hook ws-window-activated)
  (add-hook 'unmap-notify-hook ws-window-unmapped)
  (add-hook 'destroy-notify-hook ws-remove-window)
  (add-hook 'sm-window-save-functions ws-saved-state)
  (add-hook 'sm-restore-window-hook ws-load-state))

;; display-wininfo.jl -- shows info about focused window
;;
;; Copyright (C) 2000 Unai Uribarri <unaiur@telecable.es>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.display-wininfo

    (export display-wininfo)

    (open rep
	  rep.system
	  rep.data.records
	  sawfish.wm.commands
	  sawfish.wm.colors
	  sawfish.wm.events
	  sawfish.wm.fonts
	  sawfish.wm.images
	  sawfish.wm.misc
	  sawfish.wm.util.x
	  sawfish.wm.windows
	  sawfish.wm.workspace)

;;; variables

  ;; margins
  (defconst x-margin 10)
  (defconst y-margin 10)

  (defconst icon-size (32 . 32))

  ;; Move this to x-cycle.jl, and add viewport. Leave this undocumented
  ;; until that.
  (defvar display-wininfo-show-workspace nil)

  ;; the popup window which currently shows wininfo, or nil
  (define info-window nil)

;;; utilities

  ;; type used to encapsulate a vertically stacked set of strings, the
  ;; font used to draw them, and the screen space they would take when
  ;; drawn
  (define-record-type :text-item
    (make-text-item-1 strings font width height)
    ;; [no predicate]
    (strings ti-strings)
    (font ti-font)
    (width ti-width)
    (height ti-height))

  (define (make-text-item strings font)
    (make-text-item-1 strings font
		      (apply max (mapcar (lambda (s)
					   (text-width s font)) strings))
		      (* (length strings) (font-height font))))

  ;; Calculates where to put an info window associated with W with size
  ;; DIMS
  (define (get-window-pos w dims)
    (let ((head (current-head w)))
      (if head
	  (cons (+ (quotient (- (car (head-dimensions head)) (car dims)) 2)
		   (car (head-offset head)))
		(+ (quotient (- (cdr (head-dimensions head)) (cdr dims)) 2)
		   (cdr (head-offset head))))
	(cons (quotient (- (screen-width) (car dims)) 2)
	      (quotient (- (screen-height) (cdr dims)) 2)))))

  ;; Returns the list of *one* string which is made of
  ;; * name, in brackets when iconified
  ;; * workspace num like <2>, when display-wininfo-show-workspace in non-nil
  (define (window-info w)
    (list (concat (and (window-get w 'iconified) ?[)
                       (window-name w)
                       (and (window-get w 'iconified) ?])
                  ;; potentially include the workspace where the window is
		  (if (and
		       display-wininfo-show-workspace
		       (not (window-in-workspace-p w current-workspace)))
		      (concat " <" (number->string
                                    (car (window-workspaces w))) ">")
                    ""))))

;;; entry point

  (define (display-wininfo w)
    "Popups a small window with window's informations. It includes
icon, name, and workspace if `display-wininfo-show-workspace' is non-nil.
If W is nil previous window is removed."
    ;; if there's an old window, destroy it
    (when info-window
      (x-destroy-window info-window)
      (setq info-window nil))

    (when w
      (let* ((text (make-text-item (window-info w) default-font))
	     (icon (let ((i (window-icon-image w 32)))
		     (and i (scale-image i (car icon-size) (cdr icon-size)))))
	     (icon-dims (if icon icon-size '(0 . 0)))
	     (win-size (cons (+ (car icon-dims)
				(ti-width text)
				(* x-margin (if icon 3 2)))
			     (+ (* 2 y-margin)
				(max (cdr icon-dims) (ti-height text))))))

	(define (event-handler type xw)
	  ;; XW is the handle of the X drawable to draw in
	  (case type
	    ((expose)
	     (x-clear-window xw)

	     ;; draw the icon
	     (when icon
	       (x-draw-image icon xw
			     (cons x-margin
				   (quotient (- (x-drawable-height xw)
						(cdr icon-dims)) 2))))

	     ;; draw lines of text one at a time
	     (let ((gc (x-create-gc xw
				    `((foreground . ,(get-color "black"))
				      (background . ,(get-color "white")))))
		   (x (+ (if icon (* 2 x-margin) x-margin) (car icon-dims))))

	       (do ((rest (ti-strings text) (cdr rest))
		    (y (+ (font-ascent (ti-font text))
			  (quotient (- (x-drawable-height xw)
				       (ti-height text)) 2))
		       (+ y (font-height (ti-font text)))))
		   ((null rest))
		 (x-draw-string xw gc (cons x y) (car rest) (ti-font text)))

	       (x-destroy-gc gc)))))

	;; create new window
	(setq info-window (x-create-window
			   (get-window-pos w win-size) win-size 1
			   `((background . ,(get-color "white"))
			     (border-color . ,(get-color "black")))
			   event-handler))
	(x-map-window info-window))))

  (define (display-window-position #!optional w)
    "Display window position and size in a popup."
    (unless (windowp w)
      (setq w (select-window)))
    (let (
	  (coord (window-position w))
	  (size (window-dimensions w))
	  str)
      (setq str (concat "Name: " (window-name w) "\n\n"))
      (setq str (format nil "%sTop left:     (%s, %s)\n" str
			(car coord) (cdr coord)))
      (setq str (format nil "%sRight bottom: (%s, %s)\n" str
			(+ (car coord) (car size))
			(+ (cdr coord) (cdr size))))
      (setq str (format nil "%sSize: %s x %s\n" str
			(car size) (cdr size)))
      (display-message (concat str "\nClick to dismiss."))))
  
  (define-command 'display-window-position display-window-position
    #:doc "Choose a window, and prints its position and size in a popup.")
  )

;; window-order.jl -- keep track of recently accessed windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.window-order

    (export window-order
	    window-order-push
	    window-order-pop
	    window-order-most-recent
	    window-order-focus-most-recent)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.session.init
	  sawfish.wm.workspace
	  sawfish.wm.viewport)

  (define-structure-alias window-order sawfish.wm.util.window-order)

  ;; window order high-water-mark
  (define window-order-highest 1)

  ;; return windows in MRU order
  (define (window-order #!optional workspace allow-iconified all-viewports)
    (let ((windows (managed-windows)))
      (setq windows (delete-if (lambda (w)
				 (or (not (window-mapped-p w))
				     (window-get w 'ignored)
				     (and (not allow-iconified)
					  (window-get w 'iconified))
				     (and workspace
					  (not (window-appears-in-workspace-p
						w workspace)))))
			       windows))
      (unless all-viewports
	(setq windows (delete-if window-outside-viewport-p windows)))
      (sort windows (lambda (x y)
		      (setq x (window-get x 'order))
		      (setq y (window-get y 'order))
		      (cond ((and x y)
			     (> x y))
			    (x t)
			    (t nil))))))

  ;; push window W onto the top of the cycle stack
  (define (window-order-push w)
    (window-put w 'order window-order-highest)
    (setq window-order-highest (1+ window-order-highest))
    (when (> window-order-highest 1000000)		;arbitrary big number
      (window-order-compress)))

  ;; remove window W from the order stack
  (define (window-order-pop w)
    (window-put w 'order nil))

  ;; compress the order stack
  (define (window-order-compress)
    (let ((order (nreverse (window-order nil t t)))	;all windows
	  (i 1))
      (map-windows (lambda (w)
		     (window-put w 'order nil)))
      (mapc (lambda (w)
	      (window-put w 'order i)
	      (setq i (1+ i))) order)
      (setq window-order-highest i)))

  (define (window-order-most-recent #!key (windows 0))
    "Return the most-recently focused window in the current workspace. If the
WINDOWS argument is given it should be a list of windows, in this case the
function will restrict its search to the elements of this list."
    (let loop ((rest (window-order current-workspace nil)))
      (cond ((null rest) nil)
	    ((or (window-get (car rest) 'never-focus)
		 (dock-window-p (car rest));; panel/pager workspace switcher
		 (and (listp windows) (not (memq (car rest) windows))))
	     (loop (cdr rest)))
	    (t (car rest)))))

  (define (window-order-focus-most-recent)
    (set-input-focus (window-order-most-recent)))

  (define (on-viewport-change)
    ;; The problem is that any sticky windows that have been focused once
    ;; will _always_ rise to the top of the order when switching viewports
    ;; (since the topmost window is _always_ focused when entering a new
    ;; workspace). The hacky solution is to remove the order of any sticky
    ;; windows
    (let ((order (window-order current-workspace)))
      (mapc (lambda (w)
	      (when (window-get w 'sticky-viewport)
		(window-put w 'order nil))) order))
    (unless (eq focus-mode 'enter-exit)
      (window-order-focus-most-recent)))

  (sm-add-saved-properties 'order)
  (add-swapped-properties 'order)

  (add-hook 'sm-after-restore-hook window-order-compress)
  (add-hook 'iconify-window-hook window-order-pop)
  (add-hook 'viewport-moved-hook on-viewport-change))

;; simple-dialog.jl
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
;; for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; History
;; This file was delete once by mistake, in the commit dbe8c2235, and
;; it had been called "lisp/sawfish/gtk/stock.jl.gtk".
;; Re-added in the commit ce7e6c, as "lisp/sawfish/gtk/stock.jl".
;; Then renamed again in commit a22557030.

(define-structure sawfish.gtk.widgets.simple-dialog

    (export simple-dialog
            widget-dialog)

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (simple-dialog title widget #!optional ok-callback main-window)

    (let ((window (gtk-window-new 'toplevel))
	  (vbox (gtk-vbox-new nil box-spacing))
	  (hbbox (gtk-hbutton-box-new))
	  (ok (gtk-button-new-from-stock "gtk-ok"))
	  (cancel (and ok-callback (gtk-button-new-from-stock "gtk-cancel"))))

      (define (on-cancel)
	(gtk-widget-destroy window))

      (define (on-ok)
	(ok-callback)
	(gtk-widget-destroy window))

      (gtk-window-set-title window title)
      (gtk-window-set-wmclass window "SimpleDialog" "SawfishConfig")
      (gtk-container-set-border-width window box-border)
      (when main-window
	(gtk-window-set-transient-for window main-window))

      (gtk-box-set-spacing hbbox button-box-spacing)
      (gtk-button-box-set-layout hbbox 'end)
      (when cancel
	(gtk-box-pack-end hbbox cancel))
      (gtk-box-pack-end hbbox ok)
      (gtk-box-pack-end vbox hbbox)
      (gtk-container-add window vbox)
      (gtk-widget-show-all vbox)

      (gtk-container-add vbox widget)

      (when cancel
	(g-signal-connect cancel "clicked" on-cancel))
      (g-signal-connect ok "clicked" (if ok-callback on-ok on-cancel))
      (g-signal-connect window "delete_event" on-cancel)

      (gtk-widget-show window)
      (gtk-window-set-modal window t)
      (gtk-widget-grab-focus widget)

      window))

  (define (widget-dialog title spec callback
			 #!optional initial-value main-window)

    (let* ((widget (make-widget spec))
	   (vbox (gtk-vbox-new nil box-spacing))
	   (hbox (gtk-hbox-new nil 0)))

      (when initial-value
	(widget-set widget initial-value))

      (gtk-box-pack-start hbox (gtk-label-new title))
      (gtk-container-add vbox hbox)
      (gtk-container-add vbox (widget-gtk-widget widget))
      (gtk-widget-show-all vbox)
      (simple-dialog title vbox
		     (lambda () (callback (widget-ref widget)))
		     main-window))))

;; Initiates lisp part of Sawfish.
;;
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA

(declare (in-module sawfish.wm))

(open-structures '(rep rep.system rep.io.files))

;;(setq debug-on-error '(bad-arg missing-arg void-value invalid-function))

;; so modularised rep knows where to inherit specials and load from
;; this will be changed to 'user later
(setq *user-structure* 'sawfish.wm)

;; Expand tilde for efficiency. Otherwise, tilde file-handler is called
;; every time in path search.
(setq load-path (mapcar canonical-file-name load-path))

;; load always-present session-manager stuff
(require 'sawfish.wm.session.init)

;; set $DISPLAY so that any subprocesses inherit it
(setenv "DISPLAY" display-name)

;; load i18n support when necessary

(unless batch-mode
  (let ((lang (or (getenv "LANGUAGE") (getenv "LC_ALL")
		  (getenv "LC_MESSAGES") (getenv "LANG")))
	(disable-nls (get-command-line-option "--disable-nls")))

    (when (and lang (not disable-nls) (not (string= lang "C")))
      (require 'rep.i18n.gettext)
      (bindtextdomain "sawfish" sawfish-locale-directory)
      (when (boundp 'bindtextdomaincodeset)
	(bindtextdomaincodeset "sawfish" "UTF-8"))
      (textdomain "sawfish"))))

;; ignore file errors on stdio streams
(when (boundp 'set-file-ignore-errors)
  (set-file-ignore-errors (stdin-file) t)
  (set-file-ignore-errors (stdout-file) t)
  (set-file-ignore-errors (stderr-file) t))

;; used to mark variable declarations that need special attention
;; from the sawfish-xgettext script
(defmacro i18n-defvar args (cons 'defvar args))
(defmacro i18n-define args (cons 'define args))
(export-bindings '(i18n-defvar i18n-define))

;; import libraries needed by autoload
(require 'sawfish.wm.commands)
(require 'sawfish.wm.custom)
(require 'sawfish.wm.focus)
(require 'sawfish.wm.placement)
(require 'sawfish.wm.animation.setup)

;; load standard libraries (but don't import them)
(mapc intern-structure '(sawfish.wm.keymaps
			 sawfish.wm.workspace
			 sawfish.wm.viewport
			 sawfish.wm.stacking
			 sawfish.wm.frames
			 sawfish.wm.swapper
			 sawfish.wm.state.configure
			 sawfish.wm.state.maximize
			 sawfish.wm.state.mwm
			 sawfish.wm.state.open-look
			 sawfish.wm.state.transient
			 sawfish.wm.state.shading
			 sawfish.wm.state.iconify
			 sawfish.wm.state.ignored
			 sawfish.wm.server
			 sawfish.wm.state.wm-spec))

;; Create the exports from sawfish.wm; Bindings in these modules are
;; exported by sawfish.wm on behalf of them. User scripts have to
;; import only sawfish.wm for core functions.
(let ((mods '(sawfish.wm.colors
	      sawfish.wm.commands
	      sawfish.wm.cursors
	      sawfish.wm.custom
	      sawfish.wm.events
	      sawfish.wm.focus
	      sawfish.wm.fonts
	      sawfish.wm.frames
	      sawfish.wm.gaol
	      sawfish.wm.images
	      sawfish.wm.misc
	      sawfish.wm.placement
	      sawfish.wm.session.init
	      sawfish.wm.server
	      sawfish.wm.stacking
	      sawfish.wm.viewport
	      sawfish.wm.animation.setup
	      sawfish.wm.windows
	      sawfish.wm.workspace
	      sawfish.wm.state.iconify
	      sawfish.wm.state.shading
	      sawfish.wm.state.transient
	      sawfish.wm.state.ignored)))
  (open-structures mods)
  #| I.e.
  (export-bindings (parse-interface
		    '(compound-interface
		      (structure-interface sawfish.wm.colors)
		      (structure-interface sawfish.wm.commands)
		      ...)))
  |#
  (export-bindings (parse-interface
		    (cons 'compound-interface
			  (mapcar (lambda (i)
				    (list 'structure-interface i))
				  mods)))))

(let ((sawfish-load-all (lambda (s)
			  ;; ensure files are loaded in the correct structure
			  (load-all s (lambda (f) (load f nil t))))))

  ;; all rep-based programs should do this
  (sawfish-load-all "sawfish/wm/autoload")
  (sawfish-load-all (concat "os-" (symbol-name operating-system))))

(let ((session-id     (get-command-line-option "--sm-client-id" t))
      (session-prefix (get-command-line-option "--sm-prefix" t)))

  ;; Now connect with the session manager; gsm requires that apps don't
  ;; connect until they're ready to handle the later priority levels

  ;; NB: Even if you want to defer sm-init after sawfish.wm.user,
  ;; initialization of related command line arguments has to be done
  ;; here. Read also the comment below.
  (when (and (not batch-mode) (getenv "SESSION_MANAGER"))
    (sm-init session-id session-prefix)))

;; do user-level initialization
;; This swallows all command line arguments, including those starting
;; with "--".
(load "sawfish/wm/user")

;; commands.jl -- manages commands
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation,  51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands

    (export define-command
	    autoload-command
	    command-ref
	    command-type
	    command-class
	    apply-command
	    call-command
	    prefix-numeric-argument
	    commandp
	    command-documentation
	    report-commands

	    ;; autoloaded from with-output.jl
	    call-command-with-output-to-screen
	    define-command-to-screen)

    (open rep
	  rep.system
	  rep.regexp
	  rep.util.autoloader
	  rep.lang.doc
	  #|
	    Don't add more sawfish.wm.* here unless you know what
	    you're doing. Instead, embed 'require' in definition. It's
	    because this file is read from windows.jl. See windows.jl
	    for more.
	  |#
	  sawfish.wm.misc
	  sawfish.wm.gaol
	  sawfish.wm.events
	  sawfish.wm.windows.subrs
	  sawfish.wm.util.with-output)

  (defvar customize-command-classes '(default)
    "In configurator \"binding\" section, show commands of
these classes. For possible keys, see `command-classes-all'".)

  (defvar command-classes-all '(default advanced viewport deprecated)
    "List of all command classes.")

  (defvar pre-command-hook '()
    "Hook called before calling each command.")

  (defvar post-command-hook '()
    "Hook called after calling each command.")

  (defvar this-command nil
    "The command currently being called, or `nil' if no command is being
evaluated.")

  (defvar last-command nil
    "The command previously called.")

;;; defining commands

  ;; spec is cadr of old (interactive ...) style thing

  (define (getter name) (get name 'command-fun))
  (define (setter name fun) (put name 'command-fun fun))
  (define autoloader (make-autoloader getter setter))
  (define real-getter (autoloader-ref getter))

  (define (apply-command-keys name #!key spec type doc class)
    (when spec
      (put name 'command-spec spec))
    (when type
      (put name 'custom-command-args type))
    (when doc
      (put name 'command-doc doc))
    (when class
      (put name 'command-class class)))

  (define (define-command name fun . keys)
    "Define a window managed command called NAME (a symbol). The
function FUN will be called to execute the command. SPEC and TYPE may
be used to define the arguments expected by the command. (an
interactive specification and a custom-type specification respectively)."
    (setter name fun)
    (apply apply-command-keys name keys))

  (define (define-command-gaol name fun . keys)
    "Version of `define-commnad' which can be used in gaol.
You can't override an existing command."
    (when (and (not (boundp name))
	       (functionp fun))
      (make-variable-special name)
      (apply define-command name fun keys)))
  (gaol-add define-command-gaol)
  
  (define (autoload-command name module . keys)
    "Record that loading the module called MODULE (a symbol) will provde a
command called NAME (optionally whose arguments have custom-type TYPE)."
    (autoloader name module)
    (apply apply-command-keys name keys))

  ;; return the function associated with command NAME, or nil
  (define (command-ref name)
    (or (real-getter name)
	(condition-case nil
	    (user-eval name)
	  (error nil))))

  ;; return the spec associated with command NAME, or nil
  (define (command-spec name)
    (or (get name 'command-spec)
	(cadr (function-spec (command-ref name)))))

  (define (command-type name) (get name 'custom-command-args))
  (define (command-class name) (or (get name 'command-class) 'default))

  (define (commandp arg)
    "Return t if ARG names a command."
    (and (symbolp arg)
	 ;; check this first to avoid loading autoloads
	 (or (get arg 'command-fun)
	     (let ((fun (command-ref arg)))
	       (and fun (function-spec fun))))))

;;; calling commands

  (define (apply-command name args)
    "Apply the list of values ARGS to the command NAME."
    (let ((fun (command-ref name)))
      (or (functionp fun)
	  (error "Command has no function: %s" name))
      (apply fun args)))

  (define (call-command name #!optional pfx-arg)
    "Call the command NAME; optionally with the prefix argument PFX-ARG."

    ;; `name' is a lisp expression for commands with `type',
    ;; among others.
    
    ;; prefix
    (let ((this-command name))
      (unless pfx-arg (setq pfx-arg prefix-arg))
      (setq prefix-arg nil)
      (setq current-prefix-arg pfx-arg)

      ;; pre-command-hook is allowed to modifiy this-command
      ;; and current-prefix-arg. If this-command is set to nil the
      ;; command won't be called
      (call-hook 'pre-command-hook (list name))

      (setq name this-command)
      (setq pfx-arg current-prefix-arg)

      ;; call
      (cond ((null name))

	    ((commandp name)
	     ;; a named command
	     (command-ref name) ;so spec is loaded
	     (let ((spec (command-spec name))
		   args)
	       (when spec
		 (setq args (build-arg-list spec name)))
	       ;; reinitialize current-prefix-arg in case it got overwritten
	       (setq current-prefix-arg pfx-arg)
	       (apply-command name args)))

	    ((commandp (car name))
	     (apply-command (car name) (mapcar user-eval (cdr name))))

	    ((functionp name)
	     (let ((spec (function-spec name)))
	       (if spec
		   ;; function has an embedded spec, so use it
		   (let ((args (build-arg-list (cadr spec) name)))
		     (setq current-prefix-arg pfx-arg)
		     (apply name args))
		 ;; no spec, just call it
		 (name))))

	    (t (user-eval name)))		;just eval it

      ;; postfix
      (call-hook 'post-command-hook (list name))
      (setq last-command this-command)
      (setq current-prefix-arg nil)))

  (define-command 'call-command call-command
    #:spec "CEnter command:\nP")

;;; building command arg-list from spec strings

  (define arg-can-be-nil (make-fluid))

  (define (build-arg-list spec name)
    (cond ((stringp spec)
	   (let loop ((args '())
		      (point 0))
	     (cond ((>= point (length spec)) (nreverse args))
		   ((eql (aref spec point) #\newline)
		    (loop (cons nil args) (1+ point)))
		   (t
		    (let ((local nil)
			  (code nil)
			  (prompt nil))
		      (if (eql (aref spec point) #\%)
			  (progn
			    (setq local t)
			    (setq code (aref spec (1+ point)))
			    (setq point (+ point 2)))
			(setq code (aref spec point))
			(setq point (1+ point)))
		      (let ((end (if (string-match "(\n|$)" spec point)
				     (match-start)
				   (length spec))))
			(unless (= point end)
			  (setq prompt (substring spec point end)))
			(setq point (1+ end)))
		      (let (arg)
			(let-fluids ((arg-can-be-nil nil))
			  (setq arg (if local
					(local-codes code prompt)
				      (global-codes code prompt)))
			  (when (and (not (fluid arg-can-be-nil))
				     (null arg))
			    (error "Null argument to command: %s"
				   name)))
			(loop (cons arg args) point)))))))
	  ((functionp spec) (spec))
	  ((consp spec) (user-eval spec))))

;;; switching on spec codes

  ;; codes local to sawfish, i.e. "%X" case, where X is one of:
  (define (local-codes code prompt)
    (case code
      ((#\f)
       (input-focus))

      ((#\w)
       (current-event-window))

      ((#\W)
       (let ((w (current-event-window)))
	 (if (or (null w) (eq w 'root))
	     (input-focus)
	   w)))

      ((#\s)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-workspace prompt))

      (t (error "Unknown spec: %%%c" code))))

  ;; general rep codes
  (define (global-codes code prompt)
    (case code
      ((#\a)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-function prompt))

      ((#\C)
       (fluid-set arg-can-be-nil t)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-command prompt))

      ((#\D)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-directory prompt))

      ((#\e) (current-event))

      ((#\E) (current-event-string))

      ((#\f)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-file prompt t))

      ((#\F)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-file prompt))

      ((#\k)
       (require 'sawfish.wm.util.keymap)
       (read-event))

      ((#\n)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-number prompt))

      ((#\N)
       (if current-prefix-arg
	   (prefix-numeric-argument current-prefix-arg)
	 (require 'sawfish.wm.util.prompt)
	 (prompt-for-number prompt)))

      ((#\p) (prefix-numeric-argument current-prefix-arg))

      ((#\P) (fluid-set arg-can-be-nil t) current-prefix-arg)

      ((#\s)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-string prompt))

      ((#\S)
       (fluid-set arg-can-be-nil t)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-symbol prompt))

      ((#\t) t)

      ((#\v)
       (require 'sawfish.wm.util.prompt)
       (prompt-for-variable prompt))

      (t (error "Unknown spec: %c" code))))

  (define (prefix-numeric-argument arg)
    (cond ((symbolp arg) (if (null arg) 1 -1))
	  ((numberp arg) arg)
	  ((consp arg) (car arg))
	  (t 1)))

;;; utilities

  ;; dig out the interactive spec from a function
  (define (function-spec fun)
    (and (closurep fun)
	 (let ((body (closure-function fun)))
	   (cond ((bytecodep body)
		  ;; interactive spec is 5th element of the vector
		  (and (>= (length body) 5) (list 'interactive (aref body 4))))
		 ((eq (car body) 'lambda)
		  ;; search for interactive decl at head of body
		  (let loop ((rest (cddr body)))
		    (cond ((stringp (car rest)) (loop (cdr rest)))
			  ((eq (caar rest) 'interactive) (car rest))
			  (t nil))))))))

  (define (command-documentation name)
    "Return the documentation associated with the command called NAME."
    (cond ((get name 'command-doc))
	  (t
	   (let ((value (command-ref name)))
	     ;; assume that the command has the same name as
	     ;; the underlying function
	     (or (documentation name nil value)
		 ;; XXX last chance, kludge by looking for the
		 ;; XXX name of the closure...
		 (and (closurep value) (closure-name value)
		      (documentation (intern (closure-name value))
				     nil value)))))))

  (define (report-commands #!optional type all)
    "Returns the list of commands. Each element is the symbol of
a command name, and they're sorted alphabetically.

The optional argument TYPE is for internal use. When it's non-nil,
(command-name #:type type-param) is returned for commands with
\"type\", instead of a symbol.

If the optional argument ALL is nil, returns commands only user wants,
i.e. those specified by `customize-command-class' are included. Else,
all commands are returned."
    (let ((classes (if all
		       command-classes-all
		     customize-command-classes)))
      (mapcar (lambda (sym)
		(let ((params (command-type sym)))
		  (if (and type params)
		      (list sym #:type params)
		    sym)))
	      (sort (apropos "" (lambda (x)
				  (and (commandp x)
				       (memq (command-class x) classes))))))))

;;; some default commands

  (define (run-shell-command command)
    "Execute a shell command in the background. This is a wrapper
command for the `system' function."
    (system (format nil "%s &" command)))

  (define-command 'run-shell-command run-shell-command
    #:spec "sCommand:"
    #:type `(and (labelled ,(_ "Command:") string))
    #:doc "Execute the given shell command in the background.")

  (define (command-sequence commands)
    "Invoke the list of commands, one by one."
    (mapc call-command commands))

  (define-command 'command-sequence command-sequence
    #:type `(and (quoted (list command ,(_ "Command")))))

  (define-command 'quit quit
    #:doc "Quit sawfish.")
  (define-command 'restart restart
    #:doc "Restart sawfish.")
  (define-command 'destroy-window destroy-window #:spec "%W"
    #:doc "Destroy a window.")
  (define-command 'kill-client x-kill-client #:spec "%W"
    #:doc "Kill the client that created the specified window.")
  (define-command 'no-operation nop)

  (define (call-command-with-output-to-screen command)
    "Prompt for a command, execute it, and print any output to the screen."
    (call-with-output-to-screen (lambda () (call-command command))))

  (define-command 'call-command-with-output-to-screen
    call-command-with-output-to-screen #:spec "CCommand:")

  (define (define-command-to-screen name fun #!rest keys)
    (apply define-command name (lambda args (with-output-to-screen
                                              (apply fun args))) keys))

  )

;; xsettingsd.jl -- xsettingsd integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.xsettingsd

  (export start-xsettingsd
          stop-xsettingsd
          dump-xsettings)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
	rep.io.files
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias xsettingsd sawfish.wm.prg.xsettingsd)

  (define %xsettingsd-proc nil)

  (defcustom init-xsettingsd nil
    "Whether to start xsettingsd with Sawfish."
    :type boolean
    :group (misc apps))

  (defcustom xsettingsd-config (concat (getenv "HOME") "/.xsettingsd")
    "xsettingsd configuration file to use."
    :type file
    :depends init-xsettingsd
    :group (misc apps))

  (define (dump-xsettings #!key (config xsettingsd-config))
    (if (program-exists-p "dump_xsettings")
	(system (format nil "dump_xsettings > %s &" config))
      (message (format nil "dump_xsettings executable not found in PATH."))))

  (define (start-xsettingsd #!key (config xsettingsd-config))
    "Start xsettingsd. If a xsettingsd process already exists, it's being killed.
     Configuration-file may be passed, if not, $HOME/.xsettingsd is used."
    (if (program-exists-p "xsettingsd")
        (progn
	  (when %xsettingsd-proc (kill-process %xsettingsd-proc))
          (setq %xsettingsd-proc (make-process))
          (if (file-exists-p config)
	      (start-process %xsettingsd-proc "xsettingsd" config)
	    (display-message (format nil "given configuration filie does not exist.
\n use (dump-xsettings) while gnome-settings-daemon is running  to generate default configuration."))))
      (display-message (format nil "xsettingsd executable not found in PATH."))))

  (define (stop-xsettingsd)
    "Stop xsettingsd, if running."
    (when %xsettingsd-proc
      (kill-process %xsettingsd-proc)
      (setq %xsettingsd-proc nil))))

;; Name    : candido. Based on metacity candido theme.
;; Author  : Sergey Sharybin <sharybin@nm.ru>
;; License : GPL-2

(let*
  (
    (iclose  (list (make-image "close.png")       nil (make-image "close_active.png") nil))
    (imax    (list (make-image "max.png")         nil (make-image "max_active.png")   nil))
    (imin    (list (make-image "min.png")         nil (make-image "min_active.png")   nil))
    (ititle  (list (make-image "title.png")       nil nil nil))
    (imenu   (list (make-image "menu.png")        nil (make-image "menu_active.png")  nil))
    (ibl     (list (make-image "bl.png")          nil nil nil))
    (ibr     (list (make-image "br.png")          nil nil nil))
    (iright  (list (make-image "right.png")       nil nil nil))
    (ileft   (list (make-image "left.png")        nil nil nil))
    (ibottom (list (make-image "bottom.png")      nil nil nil))
    (ibtbg   (list (make-image "btbg.png")        nil nil nil))
    (imenubg (list (make-image "menubg.png")      nil nil nil))

    (default-frame
     `(
        ((background . ,ibtbg)  (right-edge . -4) (width . 81)        (height . 19) (top-edge . -19) (class . title))
        ((background . ,imenubg)(left-edge . -4)  (width . 21)        (height . 19) (top-edge . -19) (class . title))

        ((background . ,iclose)  (right-edge . 1)                   (width . 26)               (top-edge . -19)                    (class . close-button))
        ((background . ,imax)    (right-edge . 26)                  (width . 26)               (top-edge . -19)                    (class . maximize-button))
        ((background . ,imin)    (right-edge . 51)                  (width . 26)               (top-edge . -19)                    (class . iconify-button))
        ((background . ,imenu)                     (left-edge . 0)  (width . 13)               (top-edge . -15)                    (class . menu-button))
        ((background . ,iright)  (right-edge . -4)                  (width . 4)                (top-edge . 0)   (bottom-edge . 0)  (class . right-border))
        ((background . ,ileft)                     (left-edge . -4) (width . 4)                (top-edge . 0)   (bottom-edge . 0)  (class . left-border))
        ((background . ,ibottom) (right-edge . 0)  (left-edge . 0)  (height . 4)               (bottom-edge . -4) (class . bottom-border))
        ((background . ,ibl)                       (left-edge . -4) (width . 4)  (height . 4)                   (bottom-edge . -4) (class . bottom-left-corner))
        ((background . ,ibr)     (right-edge . -4)                  (width . 4)  (height . 4)                   (bottom-edge . -4) (class . bottom-right-corner))

        ((background . ,ititle)  (right-edge . 77) (left-edge . 17)              (height . 19) (top-edge . -19) 
         (foreground . ("grey" "black"))  (text . ,window-name) (x-justify . center) (y-justify . center) (class . title))
      )
    )

    (shaded-frame
     `(
        ((background . ,ibtbg)  (right-edge . -4) (width . 81)        (height . 19) (top-edge . -19) (class . title))
        ((background . ,imenubg)(left-edge . -4)  (width . 21)        (height . 19) (top-edge . -19) (class . title))

        ((background . ,iclose)  (right-edge . 1)                   (width . 26)               (top-edge . -19)                    (class . close-button))
        ((background . ,imax)    (right-edge . 26)                  (width . 26)               (top-edge . -19)                    (class . maximize-button))
        ((background . ,imin)    (right-edge . 51)                  (width . 26)               (top-edge . -19)                    (class . iconify-button))
        ((background . ,imenu)                     (left-edge . 0)  (width . 13)               (top-edge . -15)                    (class . menu-button))
        ((background . ,ibottom) (right-edge . 0)  (left-edge . 0)  (height . 4)               (top-edge . 0) (class . bottom-border))
        ((background . ,ibl)                       (left-edge . -4) (width . 4)  (height . 4)  (top-edge . 0) (class . bottom-left-corner))
        ((background . ,ibr)     (right-edge . -4)                  (width . 4)  (height . 4)  (top-edge . 0) (class . bottom-right-corner))

        ((background . ,ititle)  (right-edge . 77) (left-edge . 17)              (height . 19) (top-edge . -19) 
         (foreground . ("grey" "black"))  (text . ,window-name) (x-justify . center) (y-justify . center) (class . title))

      )
    )

    (transident-frame
     `(
        ((background . ,ibtbg)  (right-edge . -4) (width . 81)        (height . 19) (top-edge . -19) (class . title))
        ((background . ,imenubg)(left-edge . -4)  (width . 21)        (height . 19) (top-edge . -19) (class . title))

        ((background . ,iclose)  (right-edge . 1)                   (width . 26)               (top-edge . -19)                    (class . close-button))
        ((background . ,imin)    (right-edge . 26)                  (width . 26)               (top-edge . -19)                    (class . iconify-button))
        ((background . ,imenu)                     (left-edge . 0)  (width . 13)               (top-edge . -15)                    (class . menu-button))
        ((background . ,iright)  (right-edge . -4)                  (width . 4)                (top-edge . 0)   (bottom-edge . 0)  (class . right-border))
        ((background . ,ileft)                     (left-edge . -4) (width . 4)                (top-edge . 0)   (bottom-edge . 0)  (class . left-border))
        ((background . ,ibottom) (right-edge . 0)  (left-edge . 0)  (height . 4)               (bottom-edge . -4) (class . bottom-border))
        ((background . ,ibl)                       (left-edge . -4) (width . 4)  (height . 4)                   (bottom-edge . -4) (class . bottom-left-corner))
        ((background . ,ibr)     (right-edge . -4)                  (width . 4)  (height . 4)                   (bottom-edge . -4) (class . bottom-right-corner))

        ((background . ,ititle)  (right-edge . 77) (left-edge . 17)              (height . 19) (top-edge . -19) 
         (foreground . ("grey" "black"))  (text . ,window-name) (x-justify . center) (y-justify . center) (class . title))

      )
    )

    (shaded-transident-frame
     `(
        ((background . ,ibtbg)  (right-edge . -4) (width . 81)        (height . 19) (top-edge . -19) (class . title))
        ((background . ,imenubg)(left-edge . -4)  (width . 21)        (height . 19) (top-edge . -19) (class . title))

        ((background . ,iclose)  (right-edge . 1)                   (width . 26)               (top-edge . -19)                    (class . close-button))
        ((background . ,imin)    (right-edge . 26)                  (width . 26)               (top-edge . -19)                    (class . iconify-button))
        ((background . ,imenu)                     (left-edge . 0)  (width . 13)               (top-edge . -15)                    (class . menu-button))
        ((background . ,ibottom) (right-edge . 0)  (left-edge . 0)  (height . 4)               (top-edge . 0) (class . bottom-border))
        ((background . ,ibl)                       (left-edge . -4) (width . 4)  (height . 4)  (top-edge . 0) (class . bottom-left-corner))
        ((background . ,ibr)     (right-edge . -4)                  (width . 4)  (height . 4)  (top-edge . 0) (class . bottom-right-corner))

        ((background . ,ititle)  (right-edge . 77) (left-edge . 17)              (height . 19) (top-edge . -19) 
         (foreground . ("grey" "black"))  (text . ,window-name) (x-justify . center) (y-justify . center) (class . title))

      )
    )
  )

  (add-frame-style 'candido 
    (lambda (w type) 
      (case type 
        ((default) default-frame)
        ((transient) transident-frame)
        ((shaped) shaded-frame)
        ((shaped-transient) shaded-transident-frame)
      )
    )
  )
)

;; decode-events.jl -- symbolic event manipulation

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.decode-events

    (export decode-modifier
	    encode-modifier
	    substitute-wm-modifier
	    decode-event
	    encode-event
	    string->keysym
	    modifier->keysyms
	    modifier-keysym-p
	    should-grab-button-event-p)

    (open rep
	  sawfish.wm.events)

  (define-structure-alias decode-events sawfish.wm.util.decode-events)

  (define (decode-modifier mods)
    (let ((out '()))
      (do ((i 0 (1+ i)))
	  ((= i 13))
	(when (not (zerop (logand mods (lsh 1 i))))
	  (setq out (cons (aref [shift lock control mod-1 mod-2
				       mod-3 mod-4 mod-5 button-1
				       button-2 button-3 button-4
				       button-5] i) out))))
      (when (not (zerop (logand mods (lsh 1 20))))
	(setq out (cons 'meta out)))
      (when (not (zerop (logand mods (lsh 1 21))))
	(setq out (cons 'alt out)))
      (when (not (zerop (logand mods (lsh 1 24))))
	(setq out (cons 'hyper out)))
      (when (not (zerop (logand mods (lsh 1 25))))
	(setq out (cons 'super out)))
      (when (not (zerop (logand mods (lsh 1 26))))
	(setq out (cons 'wm out)))
      (when (not (zerop (logand mods (lsh 1 22))))
	(setq out (cons 'any out)))
      (when (not (zerop (logand mods (lsh 1 23))))
	(setq out (cons 'release out)))
      out))

  (define (encode-modifier in)
    (let ((encode-mod-map '((shift . 1) (lock . 2)
			    (control . 4) (mod-1 . 8)
			    (mod-2 . 16) (mod-3 . 32) (mod-4 . 64)
			    (mod-5 . 128) (button-1 . 256)
			    (button-2 . 512) (button-3 . 1024)
			    (button-4 . 2048) (button-5 . 4096)
			    (meta . #x100000) (alt . #x200000)
			    (hyper . #x1000000) (super . #x2000000)
			    (wm . #x4000000) (any . #x400000)
			    (release . #x800000))))

      (apply + (mapcar (lambda (m)
			 (cdr (assq m encode-mod-map))) in))))

  (define (substitute-wm-modifier event)
    (if (/= (logand (cdr event) #x04000000) 0)
	(cons (car event) (logior (wm-modifier) (logand (cdr event)
							(lognot #x04000000))))
      event))

  (define (decode-event event)
    "Return a symbol description of the low-level event structure
EVENT (a cons cell). The symbolic description has the form `(TYPE
MODIFIER-LIST ACTION)'."
    (let* ((code (car event))
	   (mods (cdr event)))

      (cond ((not (zerop (logand mods (lsh 1 16))))
	     ;; keyboard event
	     (list 'key (decode-modifier mods) (x-keysym-name code)))
	    ((not (zerop (logand mods (lsh 1 17))))
	     ;; mouse event
	     (list 'mouse (decode-modifier mods)
		   (aref [click-1 click-2 move off-1 click-3 off-2 off-3]
			 (1- code))))
	    (t (error "Unknown event type")))))

  (define (encode-event event)
    "Return the low-level event structure (cons cell) representing the
symbolic event description EVENT, a list `(TYPE MODIFIER-LIST
ACTION)'."
    (let* ((code 0)
	   (mods (encode-modifier (cadr event))))

      (cond ((eq (car event) 'key)
	     (setq mods (logior mods (lsh 1 16)))
	     (setq code (x-lookup-keysym (caddr event))))
	    ((eq (car event) 'mouse)
	     (setq mods (logior mods (lsh 1 17)))
	     (setq code (cdr (assq (caddr event) '((click . 1)
						   (click-1 . 1)
						   (click-2 . 2)
						   (move . 3)
						   (off . 4)
						   (off-1 . 4)
						   (click-3 . 5)
						   (off-2 . 6)
						   (off-3 . 7))))))
	    (t (error "Unknown event type: %s" (car event))))
      (cons code mods)))

  (define (string->keysym string)
    "Convert a string naming a key into a symbol naming an X11 keysym."
    (x-keysym-name (car (lookup-event string))))

  (define (modifier->keysyms modifier)
    "Convert a symbol naming an event modifier into a list of symbols
representing the X11 keysyms that may generate the modifier."
    (cond ((eq modifier 'alt)
	   (mapcar string->keysym alt-keysyms))
	  ((eq modifier 'meta)
	   (mapcar string->keysym meta-keysyms))
	  ((eq modifier 'hyper)
	   (mapcar string->keysym hyper-keysyms))
	  ((eq modifier 'super)
	   (mapcar string->keysym super-keysyms))
	  ((eq modifier 'shift)
	   '(Shift_L Shift_R))
	  ((eq modifier 'control)
	   '(Control_L Control_R))
	  (t (error "Unknown modifier: %s" modifier))))

  (define (modifier-keysym-p keysym)
    "Returns true if KEYSYM is a modifier keysym."
    (or (memq keysym '(Shift_L Shift_R Control_L Control_R))
	(member (symbol-name keysym) alt-keysyms)
	(member (symbol-name keysym) meta-keysyms)
	(member (symbol-name keysym) hyper-keysyms)
	(member (symbol-name keysym) super-keysyms)))

  (define (member-event ev lst)
    (let loop ((rest lst))
         (cond ((null rest) nil)
               ((event-match ev (car rest)) rest)
               (t (loop (cdr rest))))))

  (define (should-grab-button-event-p event keymap)
    (let* ((decoded (decode-event event))
	   (variants (mapcar (lambda (action)
			       (encode-event
				(list (car decoded) (cadr decoded) action)))
			     '(click-2 click-3 move off-1 off-2 off-3))))
      (let loop ((rest (cdr keymap)))
           (cond ((null rest) nil)
                 ((member-event (cdar rest) variants) t)
                 (t (loop (cdr rest))))))))

;; xfce.jl -- XFCE integration

;; Copyright (C) 2010 Christopher Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.xfce

    (export detect-xfce)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias xfce-int sawfish.wm.integration.xfce)

  (define (init)
    (let (menu)
      (setq desktop-environment "xfce")
      (setq want-poweroff-menu nil)

      ;; invoke the XFCE terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "xfce4-terminal"))

      ;; use the XFCE help browser and url launcher
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "midori"))

      ;; use the XFCE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "thunar"))

      ;; add some XFCE help menus
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_XFCE Help") (system "xfhelp4 &"))
		      (,(_ "XFCE _Website") (browser "http://www.xfce.org"))
		      (,(_ "_About XFCE") (system "xfce4-about &")))))

      ;; add xfce-logout menu item
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_Customize XFCE") (system "xfce4-settings-manager &"))
		      (,(_ "_Edit XFCE Menu") (system "menulibre &"))
		      ()
		      (,(_ "L_ock from XFCE")
			(system "xflock4 &"))
		      (,(_ "_Logout from XFCE")
		       (system "xfce4-session-logout --logout -f &"))
		      (,(_ "_Reboot from XFCE")
		       (system "xfce4-session-logout --reboot -f &"))
		      (,(_ "_Shutdown from XFCE")
		       (system "xfce4-session-logout --halt -f &"))
		      (,(_ "_Hibernate from XFCE")
			(system "xfce4-session-logout --hibernate -f &"))
		      (,(_ "S_uspend from XFCE")
			(system "xfce4-session-logout --suspend -f &")))))))

  ;; Returns nil if xfce is not found.
  ;; If detected, returns t, and do also xfce support init.
  (define (detect-xfce)
    (when (or (get-x-property 'root '_DT_SAVE_MODE)
              (equal (getenv "DESKTOP_SESSION") "sawfish-xfce")
              (equal (getenv "XDG_CURRENT_DESKTOP") "XFCE"))
      (init)
      t)))

;; stacking.jl -- customizable stacking functions
;;
;; Copyright (C) 2000 Eazel, Inc
;;
;; Author: John Harper <jsh@eazel.com>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.stacking

    (export raise-window*
	    lower-window*
	    raise-lower-window*)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.stacking
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.state.transient
	  sawfish.wm.commands.groups)

  (defcustom user-raise-type 'transients
    "When raising a window, also raise its: \\left"
    :type (choice none transients group)
    :group (misc stacking))

  (define (raise-window* w)
    "Raise the window to its highest allowed position in the stacking
order."
    (case user-raise-type
      ((transients) (raise-window-and-transients w))
      ((group) (raise-group w))
      (t (raise-window w))))

  (define (lower-window* w)
    "Lower the window to its lowest allowed position in the stacking
order."
    (case user-raise-type
      ((transients) (lower-window-and-transients w))
      ((group) (lower-group w))
      (t (lower-window w))))

  (define (raise-lower-window* w)
    "If the window is at its highest possible position, then lower it
to its lowest possible position. Otherwise raise it as far as
allowed."
    (case user-raise-type
      ((transients) (raise-lower-window-and-transients w))
      ((group) (raise-lower-group w))
      (t (raise-lower-window w))))

  (define-command 'raise-window raise-window* #:spec "%W")
  (define-command 'lower-window lower-window* #:spec "%W")
  (define-command 'raise-lower-window raise-lower-window* #:spec "%W")

  )

;; gnome.jl -- GNOME integration

;; Copyright (C) 2010 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.gnome

    (export detect-gnome)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias gnome-int sawfish.wm.integration.gnome)

  (define (init)
    (let (menu)
      (setq desktop-environment "gnome")
      (setq want-poweroff-menu nil)

      ;; invoke the GNOME terminal instead of xterm
      (unless (variable-customized-p 'xterm-program)
	(setq xterm-program "gnome-terminal.wrapper"))

      ;; use the GNOME help browser and url launcher
      (unless (variable-customized-p 'browser-program)
	(setq browser-program "gnome-www-browser"))

      ;; use the GNOME filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "nautilus"))

      ;; add some GNOME menu-entries
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "_GNOME Help") (system "yelp &"))
		      (,(_ "GNOME _Website") (browser "http://www.gnome.org"))
		      (,(_ "_About GNOME") (system "gnome-about &")))))

      ;; add gnome-logout and customize menu-entries
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_Customize GNOME") (system "gnome-control-center &"))
		      (,(_ "_Edit GNOME menu") (system "alacarte &"))
		      ()
		      (,(_ "L_ock screen from GNOME")
			(system "gnome-screensaver-command -l &"))
		      (,(_ "_Logout from GNOME")
		       (system "gnome-session-save --logout-dialog &"))
		      (,(_ "_Shutdown from GNOME")
		       (system "gnome-session-save --shutdown-dialog &")))))))

  ;; Returns nil if gnome is not found.
  ;; If detected, returns t, and do also gnome support init.
  (define (detect-gnome)
    (when (or (equal (getenv "XDG_CURRENT_DESKTOP") "GNOME")
              (getenv "GNOME_DESKTOP_SESSION_ID"))
      (init)
      t)))

;; xmobar.jl -- xmobar integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.xmobar

  (export start-xmobar
          stop-xmobar)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
	rep.io.files
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias xmobar sawfish.wm.prg.xmobar)

  (define %xmobar-proc nil)

  (defcustom init-xmobar nil
    "Whether to start xmobar with Sawfish."
    :type boolean
    :group (misc apps))

  (defcustom xmobar-config (concat (getenv "HOME") "/.xmobarrc")
    "xmobar configuration file to use."
    :type file
    :depends init-xmobar
    :group (misc apps))

  (define (start-xmobar #!key (config xmobar-config))
    "Start xmobar. If a xmobar process already exists, it's being killed.
     Configuration-file may be passed, if not, $HOME/.xmobarrc is used."
    (if (program-exists-p "xmobar")
        (progn
	  (when %xmobar-proc (kill-process %xmobar-proc))
          (setq %xmobar-proc (make-process))
          (if (file-exists-p config)
	      (start-process %xmobar-proc "xmobar" config)
	    (display-message (format nil "given configuration filie does not exist."))))
      (display-message (format nil "xmobar executable not found in PATH."))))

  (define (stop-xmobar)
    "Stop xmobar, if running."
    (when %xmobar-proc
      (kill-process %xmobar-proc)
      (setq %xmobar-proc nil))))

;; conky.jl -- conky clipboard manager integration

;; Copyright (C) 2014 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.conky

  (export start-conky
          stop-conky)

  (open rep
        rep.system
        rep.io.processes
	rep.io.files
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom
	sawfish.wm.ext.match-window)

  (define-structure-alias conky sawfish.wm.prg.conky)

  (defcustom init-conky nil
    "Whether to start conky with Sawfish."
    :type boolean
    :group (misc apps))

  (defcustom conky-args ""
    "Extra arguments for launching conky"
    :type string
    :group (misc apps)
    :depends init-conky)

  (define (start-conky)
    "Start conky. If a conky process already exists, it's being killed."
    (if (program-exists-p "conky")
        (progn
          (add-window-matcher '((WM_CLASS . "^conky/conky$"))
            '((never-tile . t)))
          (system "conky %s &" conky-args))
      (display-message (format nil "conky executable not found in PATH."))))

  (define (stop-conky)
    "Stop conky, if running."
    (system "killall -qw conky &"))

  (unless batch-mode
    (add-hook 'before-exit-hook stop-conky)))

;; move-resize.jl -- interactive moving and resizing of windows

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.move-resize

    (export move-window-interactively
	    resize-window-interactively
	    move-selected-window
	    resize-selected-window
	    resize-window-frame-to
	    resize-window-prompt
	    double-window-size
	    halve-window-size
	    move-window-center)

    (open rep
	  rep.system
	  rep.regexp
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.misc
	  sawfish.wm.state.maximize
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.cursors
	  sawfish.wm.util.stacking
	  sawfish.wm.util.edges)

  (define-structure-alias move-resize sawfish.wm.commands.move-resize)

  ;; we bind to disable-auto-raise
  (eval-when-compile (require 'sawfish.wm.ext.auto-raise))

  ;; todo:
  ;;  * obey the aspect ratio size hints


  (defcustom move-outline-mode 'opaque
    "How windows being moved are animated"
    :type (choice opaque box cross elliptical draft)
    :group (appearance animation))

  (defcustom resize-outline-mode 'opaque
    "How windows being resized are animated"
    :type (choice opaque box cross elliptical draft)
    :group (appearance animation))

  (defcustom move-resize-raise-window nil
    "Raise windows when they are moved or resized."
    :type boolean
    :group move)

  (defcustom move-show-position nil
    "Show current position of windows while moving."
    :group move
    :type boolean)

  (defcustom resize-show-dimensions t
    "Show current dimensions of windows while resizing."
    :group move
    :type boolean)

  (defcustom resize-edge-mode 'border-grab
    "How to choose window edges when resizing."
    :type (choice region border grab border-grab)
    :group move)

  (defcustom move-snap-epsilon 12
    "Distance in pixels before window edges align with each other."
    :group move
    :type (number 0 64)
    :tooltip "When moving a window, this option lets you align one of \
its edges with an edge of another window.")

  (defcustom marked-cursor-shape 'clock
    "Cursor shape if a window is marked to added as tab."
    :type (choice arrow box_spiral center_ptr circle cross cross_reverse
                  crosshair diamond_cross dotbox clock double_arrow draped_box
                  fleur hand1 hand2 iron_cross left_ptr ll_angle mouse
                  pencil pirate plus question_arrow right_ptr sb_left_arrow
                  sb_right_arrow sb_down_arrow sb_up_arrow spider star
                  target tcross watch xterm X_cursor)
    :group move)

  (defvar move-snap-mode 'resistance
    "How to snap together window edges, one of `magnetism', `resistance', or
`attraction'.")

  (defvar move-snap-ignored-windows nil
    "Snap to otherwise-ignored windows.")

  (defvar move-resize-inhibit-configure nil
    "Only update window contents after it has stopped moving.")

  ;; Locally set by place-window-interactively in placement.jl & reset
  ;; in move-switch-to-resize
  (defvar move-from-interactive-placement nil)

  (defvar move-resize-map (bind-keys (make-keymap)
                                     "Any-Off1" (lambda () (finished))
                                     "Any-Off2" (lambda () (finished))
                                     "Any-Off3" (lambda () (finished))
                                     "Button2-Click"
                                     (lambda () (move-switch-to-resize))
                                     "Button3-Click"
                                     (lambda ()
                                       (move-vmaximize-then-finished))
                                     "Any-Move" (lambda () (motion))
                                     "Any-ESC" (lambda () (cancel))
                                     "Any-RET" (lambda () (finished))
                                     "Up" 'move-cursor-up
                                     "Down" 'move-cursor-down
                                     "Left" 'move-cursor-left
                                     "Right" 'move-cursor-right
                                     "S-Up" 'move-cursor-up-fine
                                     "S-Down" 'move-cursor-down-fine
                                     "S-Left" 'move-cursor-left-fine
                                     "S-Right" 'move-cursor-right-fine))

  (define fp-edges-alist '((top-border top)
			   (left-border left)
			   (right-border right)
			   (bottom-border bottom)
			   (top-left-corner top left)
			   (top-right-corner top right)
			   (bottom-left-corner bottom left)
			   (bottom-right-corner bottom right)))

  (defvar move-cursor-shape 'hand2)
  (defvar resize-cursor-shape 'crosshair)

  ;; specials, should make these fluids (external users?)
  (defvar move-resize-window nil)
  (defvar move-resize-function nil)
  (defvar move-resize-x nil)
  (defvar move-resize-y nil)
  (defvar move-resize-width nil)
  (defvar move-resize-height nil)
  (defvar move-resize-old-x nil)
  (defvar move-resize-old-y nil)
  (defvar move-resize-old-width nil)
  (defvar move-resize-old-height nil)
  (defvar move-resize-old-ptr-x nil)
  (defvar move-resize-old-ptr-y nil)
  (defvar move-resize-last-ptr nil)
  (defvar move-resize-snap-state nil)
  (defvar move-resize-mode nil)
  (defvar move-resize-hints nil)
  (defvar move-resize-frame nil)
  (defvar move-resize-edges nil)
  (defvar move-resize-last-outline nil)
  (defvar move-resize-moving-edges nil)
  (defvar move-resize-directions nil)

  (defvar while-moving-hook nil)
  (defvar while-resizing-hook nil)
  (defvar before-move-hook nil)
  (defvar after-move-hook nil)
  (defvar before-resize-hook nil)
  (defvar after-resize-hook nil)

  (define (delete-unmovable-directions directions)
    (when move-lock-when-maximized
      (when (window-maximized-vertically-p move-resize-window)
	(setq directions (delq 'vertical directions)))
      (when (window-maximized-horizontally-p move-resize-window)
	(setq directions (delq 'horizontal directions))))
    directions)

  (define (delete-unresizable-edges edges)
    (when move-lock-when-maximized
      (when (window-maximized-vertically-p move-resize-window)
	(setq edges (delq 'top (delq 'bottom edges))))
      (when (window-maximized-horizontally-p move-resize-window)
	(setq edges (delq 'left (delq 'right edges)))))
    edges)

  ;; called to initiate a move or resize on window W. FUNCTION is either
  ;; `move' or `resize'
  (define (do-move-resize w function)
    (if (eq function 'move)
	(call-window-hook 'before-move-hook w)
      (call-window-hook 'before-resize-hook w))
    (let* ((from-motion-event (and (current-event)
				   (string-match "-Move$" (event-name
							   (current-event)))))
	   (override-keymap move-resize-map)
	   ;; don't want any complications..
	   (unbound-key-hook nil)
	   (disable-auto-raise t)
	   (move-resize-window w)
	   (move-resize-function function)
	   (move-resize-old-x (car (window-position w)))
	   (move-resize-old-y (cdr (window-position w)))
	   (move-resize-old-width (car (window-dimensions w)))
	   (move-resize-old-height (cdr (window-dimensions w)))
	   (move-resize-x move-resize-old-x)
	   (move-resize-y move-resize-old-y)
	   (move-resize-width move-resize-old-width)
	   (move-resize-height move-resize-old-height)
	   (move-resize-last-ptr  (if from-motion-event
				      (query-button-press-pointer)
				    (query-pointer t)))
	   (move-resize-snap-state (cons))
	   (move-resize-old-ptr-x (car move-resize-last-ptr))
	   (move-resize-old-ptr-y (cdr move-resize-last-ptr))
	   (move-resize-hints (window-size-hints w))
	   (move-resize-frame (cons (- (car (window-frame-dimensions w))
				       move-resize-old-width)
				    (- (cdr (window-frame-dimensions w))
				       move-resize-old-height)))
	   (move-resize-mode (if (eq function 'move)
				 move-outline-mode
			       resize-outline-mode))
	   (move-resize-edges nil)
	   (move-resize-last-outline nil)
	   (move-resize-moving-edges move-resize-moving-edges)
	   (move-resize-directions move-resize-directions)
	   (old-frame-draw-mutex
	    (frame-draw-mutex (not (eq move-resize-mode 'opaque))))
	   (old-frame-state-mutex (frame-state-mutex 'clicked))
	   (old-synthetic-configure-mutex
	    (synthetic-configure-mutex move-resize-inhibit-configure))
	   (was-successful nil)
	   server-grabbed)

      (when (and move-resize-raise-window (eq move-resize-mode 'opaque))
	;; only raise window initially if the display will get updated
	(raise-window* w))

      (update-edges)
      (unless (eq move-resize-mode 'opaque)
	(require 'sawfish.wm.animation.modes)
	;; prevent any other programs drawing on the display
	(grab-server)
	(setq server-grabbed t))

      (add-hook 'enter-workspace-hook update-edges)
      (add-hook 'viewport-moved-hook update-edges)
      (unwind-protect
	  (progn
	    (allow-events 'async-pointer)
	    ;; ensure that we catch _all_ mouse events
	    (when (grab-pointer
		   nil (if (eq move-resize-function 'move)
			   move-cursor-shape resize-cursor-shape))
	      (unwind-protect
		  (progn
		    (grab-keyboard w)	;this may fail
		    (unless (eq move-resize-mode 'opaque)
		      (setq move-resize-last-outline
			    (list move-resize-mode
				  move-resize-x move-resize-y
				  (+ move-resize-width
				     (car move-resize-frame))
				  (+ move-resize-height
				     (cdr move-resize-frame)))))
		    (if (eq move-resize-function 'resize)
			(unless (eq resize-edge-mode 'grab)
			  (infer-anchor))
		      (infer-directions))
		    (when (viable-move-resize-p)
		      (unless (eq move-resize-mode 'opaque)
			(apply draw-window-outline move-resize-last-outline))
		      (setq was-successful
			    (catch 'move-resize-done
			      (when from-motion-event
				(motion))
			      (recursive-edit)))))
		(ungrab-keyboard)
		(ungrab-pointer))))

	(when server-grabbed
	  (ungrab-server))
	(display-message nil)
	(frame-draw-mutex old-frame-draw-mutex)
	(frame-state-mutex old-frame-state-mutex)
	(synthetic-configure-mutex old-synthetic-configure-mutex)
	(remove-hook 'enter-workspace-hook update-edges)
	(remove-hook 'viewport-moved-hook update-edges))

      (when (and move-resize-raise-window (not (eq move-resize-mode 'opaque)))
	(raise-window* w))
      (if (eq function 'move)
	  (call-window-hook 'after-move-hook w
			    (list move-resize-directions
				  #:successful was-successful))
	(call-window-hook 'after-resize-hook w
			  (list move-resize-moving-edges
				#:successful was-successful)))))

  (define (update-edges)
    (setq move-resize-edges
	  (and (> move-snap-epsilon 0)
	       (progn
		 (get-visible-window-edges
		  #:with-ignored-windows move-snap-ignored-windows
		  #:windows-to-ignore (list move-resize-window)
		  #:include-heads t)))))

  ;; called each pointer motion event during move/resize
  (define (motion)
    (let* ((this-ptr (query-pointer))
	   (ptr-x (car this-ptr))
	   (ptr-y (cdr this-ptr))
	   logical-width logical-height)
      (unless (eq move-resize-mode 'opaque)
	(apply erase-window-outline move-resize-last-outline))
      (cond ((eq move-resize-function 'move)
	     (when (memq 'horizontal move-resize-directions)
	       (setq move-resize-x (+ move-resize-old-x
				      (- ptr-x move-resize-old-ptr-x))))
	     (when (memq 'vertical move-resize-directions)
	       (setq move-resize-y (+ move-resize-old-y
				      (- ptr-y move-resize-old-ptr-y))))
	     (when (> move-snap-epsilon 0)
	       (let
		   ((coords (snap-window-position-to-edges
			     move-resize-window (cons move-resize-x
						      move-resize-y)
			     (cons (- ptr-x (car move-resize-last-ptr))
				   (- ptr-y (cdr move-resize-last-ptr)))
			     move-resize-snap-state move-snap-epsilon
			     move-resize-edges move-snap-mode)))
		 (setq move-resize-x (car coords))
		 (setq move-resize-y (cdr coords)))))
	    ((eq move-resize-function 'resize)
	     (let
		 ((x-base (or (cdr (assq 'base-width move-resize-hints)) 0))
		  (x-inc (or (cdr (assq 'width-inc move-resize-hints)) 1))
		  (y-base (or (cdr (assq 'base-height move-resize-hints)) 0))
		  (y-inc (or (cdr (assq 'height-inc move-resize-hints)) 1))
		  (min-aspect (assq 'min-aspect move-resize-hints))
		  (max-aspect (assq 'max-aspect move-resize-hints)))

	       (when (memq resize-edge-mode '(grab border-grab))
		 (add-edges ptr-x ptr-y))
	       (cond
		((memq 'right move-resize-moving-edges)
		 (setq move-resize-width
		       (constrain-dimension-to-hints
			(+ move-resize-old-width
			   (- ptr-x move-resize-old-ptr-x))
			'x move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-height
                         (constrain-aspect-to-hints
                          move-resize-width
                          move-resize-old-height 'x min-aspect max-aspect))))

		((memq 'left move-resize-moving-edges)
		 (setq move-resize-width
		       (constrain-dimension-to-hints
			(+ move-resize-old-width
			   (- move-resize-old-ptr-x ptr-x))
                        'x move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-height
                         (constrain-aspect-to-hints
                          move-resize-width
                          move-resize-old-height 'x min-aspect max-aspect)))
		 (setq move-resize-x (- move-resize-old-x
					(- move-resize-width
					   move-resize-old-width)))))
	       (cond
		((memq 'bottom move-resize-moving-edges)
		 (setq move-resize-height
		       (constrain-dimension-to-hints
			(+ move-resize-old-height
			   (- ptr-y move-resize-old-ptr-y))
			'y move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-width
                         (constrain-aspect-to-hints
                          move-resize-height
                          move-resize-old-width 'y min-aspect max-aspect)))
                 )
		((memq 'top move-resize-moving-edges)
		 (setq move-resize-height
		       (constrain-dimension-to-hints
			(+ move-resize-old-height
			   (- move-resize-old-ptr-y ptr-y))
			'y move-resize-hints))
                 (when (or min-aspect max-aspect)
                   (setq move-resize-width
                         (constrain-aspect-to-hints
                          move-resize-height
                          move-resize-old-width 'y min-aspect max-aspect)))
		 (setq move-resize-y (- move-resize-old-y
					(- move-resize-height
					   move-resize-old-height)))))
	       (setq logical-width (quotient (- move-resize-width
						x-base) x-inc))
	       (setq logical-height (quotient (- move-resize-height
						 y-base) y-inc)))))
      (call-window-hook (if (eq move-resize-function 'move)
			    'while-moving-hook
			  'while-resizing-hook) move-resize-window)
      (cond ((and (eq move-resize-function 'resize) resize-show-dimensions)
	     (display-message (format nil "%dx%d"
				      ;; XXX broken if while-resizing-hook
				      ;; XXX changes dimensions..
				      logical-width logical-height)))
	    ((and (eq move-resize-function 'move) move-show-position)
	     (display-message (format nil "%+d%+d"
				      move-resize-x move-resize-y))))
      (if (eq move-resize-mode 'opaque)
	  (apply-changes)
	(let ((m-dim-x (+ move-resize-width (car move-resize-frame)))
	      (m-dim-y (+ move-resize-height (cdr move-resize-frame))))
	  (setq move-resize-last-outline (list move-resize-mode
					       move-resize-x move-resize-y
					       m-dim-x m-dim-y))
	  (apply draw-window-outline move-resize-last-outline)))
      (setq move-resize-last-ptr this-ptr)))

  ;; called when the move/resize finished (i.e. button-release event)
  (define (finished)
    (unless (eq move-resize-mode 'opaque)
      (apply erase-window-outline move-resize-last-outline))
    (apply-changes)
    (throw 'move-resize-done t))

  ;; called when B2-Click during interactive placement (see
  ;; place-window-interactively in placement.jl)
  ;; => switch to resizing the window
  (define (move-switch-to-resize)
    (when move-from-interactive-placement
      (grab-pointer nil resize-cursor-shape)
      (warp-cursor (1- (min (+ move-resize-x move-resize-width
			       (car move-resize-frame))
			    (screen-width)))
		   (1- (min (+ move-resize-y move-resize-height
			       (cdr move-resize-frame))
			    (screen-height))))
      (setq move-from-interactive-placement nil
	    move-resize-function 'resize)
      ))

  ;; called when B3-Click during interactive placement (see
  ;; place-window-interactively in placement.jl)
  ;; => vertical maximize the window then map it
  (define (move-vmaximize-then-finished)
    (if move-from-interactive-placement
      (let ((bottom-y (+ move-resize-y
			 move-resize-height
			 (cdr move-resize-frame))))
	(apply erase-window-outline move-resize-last-outline)
	(setq move-resize-height
	      (if (> bottom-y (screen-height))
		  (- move-resize-height
		     (- bottom-y (screen-height)))
		(+ move-resize-height
		   (- (screen-height) bottom-y))))
	(apply-changes)
	(throw 'move-resize-done t))))

  (define (cancel)
    (if (eq move-resize-mode 'opaque)
	(move-resize-window-to move-resize-window
			       move-resize-old-x move-resize-old-y
			       move-resize-old-width move-resize-old-height)
      (apply erase-window-outline move-resize-last-outline))
    (throw 'move-resize-done nil))

  ;; commit the current state of the move or resize
  (define (apply-changes)
    (cond
     ((>= move-resize-x (screen-width))
      (setq move-resize-x (1- (screen-width))))
     ((<= move-resize-x (- (+ move-resize-width (car move-resize-frame))))
      (setq move-resize-x (1+ (- (+ move-resize-width
				    (car move-resize-frame)))))))
    (cond
     ((>= move-resize-y (screen-height))
      (setq move-resize-y (1- (screen-height))))
     ((<= move-resize-y (- (+ move-resize-height (cdr move-resize-frame))))
      (setq move-resize-y (1+ (- (+ move-resize-height
				    (cdr move-resize-frame)))))))
    (move-resize-window-to move-resize-window
			   move-resize-x move-resize-y
			   move-resize-width move-resize-height))

  ;; called when moving, tries to decide which edges to move, which to stick
  (define (infer-anchor)
    (unless move-resize-moving-edges
      (let (tem)
	(if (and (memq resize-edge-mode '(border border-grab))
		 (clicked-frame-part)
		 (setq tem (frame-part-get (clicked-frame-part) 'class))
		 (setq tem (cdr (assq tem fp-edges-alist))))
	    (setq move-resize-moving-edges (copy-sequence tem))
	  (cond ((<= (- move-resize-old-ptr-x move-resize-old-x)
		     (/ move-resize-old-width 3))
		 (setq move-resize-moving-edges
		       (cons 'left move-resize-moving-edges)))
		((>= (- move-resize-old-ptr-x move-resize-old-x)
		     (* (/ move-resize-old-width 3) 2))
		 (setq move-resize-moving-edges
		       (cons 'right move-resize-moving-edges))))
	  (cond ((<= (- move-resize-old-ptr-y move-resize-old-y)
		     (/ move-resize-old-height 3))
		 (setq move-resize-moving-edges
		       (cons 'top move-resize-moving-edges)))
		((>= (- move-resize-old-ptr-y move-resize-old-y)
		     (* (/ move-resize-old-height 3) 2))
		 (setq move-resize-moving-edges
		       (cons 'bottom move-resize-moving-edges)))))))
    (when (null move-resize-moving-edges)
      (setq move-resize-moving-edges '(bottom right)))
    (setq move-resize-moving-edges (delete-unresizable-edges
				    move-resize-moving-edges)))

  (define (add-edges ptr-x ptr-y)
    (unless (or (and move-lock-when-maximized
		     (window-maximized-horizontally-p move-resize-window))
		(memq 'left move-resize-moving-edges)
		(memq 'right move-resize-moving-edges))
      (cond ((< ptr-x move-resize-x)
	     (setq move-resize-moving-edges
		   (cons 'left move-resize-moving-edges))
	     (setq move-resize-old-ptr-x move-resize-x))
	    ((> ptr-x (+ move-resize-x move-resize-width
			 (car move-resize-frame)))
	     (setq move-resize-moving-edges
		   (cons 'right move-resize-moving-edges))
	     (setq move-resize-old-ptr-x (+ move-resize-x move-resize-width
					    (car move-resize-frame))))))
    (unless (or (and move-lock-when-maximized
		     (window-maximized-vertically-p move-resize-window))
		(memq 'top move-resize-moving-edges)
		(memq 'bottom move-resize-moving-edges))
      (cond ((< ptr-y move-resize-y)
	     (setq move-resize-moving-edges
		   (cons 'top move-resize-moving-edges))
	     (setq move-resize-old-ptr-y move-resize-y))
	    ((> ptr-y (+ move-resize-y move-resize-height
			 (cdr move-resize-frame)))
	     (setq move-resize-moving-edges
		   (cons 'bottom move-resize-moving-edges))
	     (setq move-resize-old-ptr-y (+ move-resize-y move-resize-height
					    (cdr move-resize-frame)))))))

  (define (infer-directions)
    (unless move-resize-directions
      (setq move-resize-directions
	    (if (window-get move-resize-window 'fixed-position)
		'()
	      (list 'vertical 'horizontal))))
    (setq move-resize-directions (delete-unmovable-directions
				  move-resize-directions)))

  (define (viable-move-resize-p)
    (if (eq move-resize-function 'move)
	(not (null (delete-unmovable-directions
		    (copy-sequence move-resize-directions))))
      (not (null (delete-unresizable-edges
		  (if (memq resize-edge-mode '(region border))
		      ;; can't grab edges
		      (copy-sequence move-resize-moving-edges)
		    (list 'top 'bottom 'left 'right)))))))

  (define (resize-by-factor win amount)
    "Multiply win's dimensions by amount"
    (let* (
           (orig-wid (car (window-dimensions win)))
           (orig-hgt (cdr (window-dimensions win)))
           (new-wid (inexact->exact (floor (* amount orig-wid))))
           (new-hgt (inexact->exact (floor (* amount orig-hgt)))))
      ;; this expects integers ("800 600") and fails on floats ("800. 600.")
      (resize-window-with-hints* win new-wid new-hgt)))

  (define (double-window-size w)
    "Resize the window to the double size."
    (unless (window-get w 'fixed-size)
      (resize-by-factor w 2)))

  (define (halve-window-size w)
    "Resize the window to the halve size."
    (unless (window-get w 'fixed-size)
      (resize-by-factor w 0.5)))

;;; hook functions

  (define (lost-window w)
    (when (eq move-resize-window w)
      (finished)))

  (add-hook 'unmap-notify-hook lost-window t)
  (add-hook 'destroy-notify-hook lost-window t)

;;; Entry points

  (define (move-window-interactively w)
    "Move the window interactively, with mouse or keyboard."
    (do-move-resize w 'move))

  (define (resize-window-interactively w)
    "Resize the window interactively, with mouse or keyboard."
    (unless (window-get w 'fixed-size)
      (do-move-resize w 'resize)))

  (define (move-selected-window)
    "Wait for the user to select a window, then interactively move
that window."
    (let ((w (select-window)))
      (when w
	(move-window-interactively w))))

  (define (resize-selected-window)
    "Wait for the user to select a window, then interactively resize
that window."
    (let ((w (select-window)))
      (when w
	(resize-window-interactively w))))

  (define (resize-window-frame-to w width height)
    (let ((width-offset (- (car (window-frame-dimensions w))
			  (car (window-dimensions w))))
	  (height-offset (- (cdr (window-frame-dimensions w))
			    (cdr (window-dimensions w)))))
      (resize-window-to w (- width width-offset) (- height height-offset))))

  ;; Move Window To Center
  (define (move-window-center w)
    "Move the window to the center from the current screen."
    (move-window-to w
                    (quotient (- (screen-width)
                                 (car (window-frame-dimensions w))) 2)
                    (quotient (- (screen-height)
                                 (cdr (window-frame-dimensions w))) 2)))

  ;; resize-prompt
  (define (resize-window-prompt)
    "Resize window. Prompted to enter new size."
    (require 'sawfish.wm.util.prompt)
    (let* ((win (current-event-window))
           (w-name (window-name win))
           (old-w (car (window-dimensions win)))
           (old-h (cdr (window-dimensions win)))
	   (new-w (prompt #:title (format nil "Old width of window %s: %s\nEnter new width: " w-name old-w)))
	   (new-h (prompt #:title (format nil "Old height of window %s: %s\nEnter new height: " w-name old-h))))
      (if (and (numberp (string->number new-w))
	       (numberp (string->number new-h)))
	  (resize-window-with-hints* win (string->number new-w) (string->number new-h))
	(display-message (format nil "One of the given values is not a number.")))))

  (define-command 'resize-window-prompt resize-window-prompt)

  ;; resize-to-preset-size family
  (define (resize-window-to-preset-size x y)
    ;; The size is set beforehand in the configurator.
    (let ((w (current-event-window)))
      (when (or (null w) (eq w 'root))
	(setq w (input-focus)))
      (resize-window-with-hints* w x y)))

  (define-command 'resize-window-to-preset-size
    resize-window-to-preset-size
    #:doc "Resize a window to the size you specify here."
    #:type '(and (labelled "New width:" (number 10))
		 (labelled "New height:" (number 10)))
    )

  (define (resize-window-to-preset-width x)
    ;; The width is set beforehand in the configurator.
    (let ((w (current-event-window)))
      (when (or (null w) (eq w 'root))
	(setq w (input-focus)))
      (resize-window-with-hints* w x
				 (cdr (window-dimensions w)))))
  (define-command 'resize-window-to-preset-width
    resize-window-to-preset-width
    #:doc "Resize a window to the width you specify here."
    #:type `(and (labelled "New width:" (number 10)))
    )

  (define (resize-window-to-preset-height y)
    ;; The height is set beforehand in the configurator.
    (let ((w (current-event-window)))
      (when (or (null w) (eq w 'root))
	(setq w (input-focus)))
      (resize-window-with-hints* w
				 (car (window-dimensions w)) y)))

  (define-command 'resize-window-to-preset-height
    resize-window-to-preset-height
    #:doc "Resize a window to the height you specify here."
    #:type '(and (labelled "New height:" (number 10)))
    )

  ;;###autoload
  (define-command 'move-window-center
    move-window-center #:spec "%W")
  (define-command 'move-window-interactively
    move-window-interactively #:spec "%W")
  (define-command 'resize-window-interactively
    resize-window-interactively #:spec "%W")
  (define-command 'move-selected-window
    move-selected-window)
  (define-command 'resize-selected-window
    resize-selected-window)
  (define-command 'double-window-size
    double-window-size #:spec "%W")
  (define-command 'halve-window-size
    halve-window-size #:spec "%W"))

;; sm-save.jl -- session manager code to save the current session

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.session.save

    (export save-session)

    (open rep
	  rep.system
	  rep.io.files
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.session.init
	  sawfish.wm.session.util)

  ;; create an alist defining the current state of window W
  (define (sm-get-window-state w)
    (let ((alist (apply nconc (mapcar (lambda (fun)
					(fun w)) sm-window-save-functions))))
      (mapc (lambda (sym)
	      (when (window-get w sym)
		(setq alist (cons (cons sym (window-get w sym)) alist))))
	    sm-saved-window-properties)

      ;; some standard items
      (setq alist `((name . ,(window-name w))
		    (dimensions . ,(window-dimensions w))
		    (client-id . ,(sm-get-window-prop w 'SM_CLIENT_ID))
		    (role . ,(nth 2 (get-x-property w 'WM_WINDOW_ROLE)))
		    (class . ,(sm-get-window-prop w 'WM_CLASS))
		    (command . ,(sm-get-window-prop w 'WM_COMMAND))
		    (machine . ,(sm-get-window-prop w 'WM_CLIENT_MACHINE))
		    ,@alist))
      alist))

  (define (sm-print-alist stream alist)
    (if (null alist)
	(write stream "()\n")
      (let (not-first)
	(mapc (lambda (x)
		(format stream "%s%S" (if not-first "\n " "\(") x)
		(setq not-first t))
	      alist)
	(write stream "\)\n\n"))))

  (define (save-session filename)
    (unless (file-exists-p (file-name-directory filename))
      (make-directory-recursively (file-name-directory filename)))
    (let ((file (open-file filename 'write)))
      (when file
	(unwind-protect
	    (progn
	      (format file (concat ";; session saved for %s@%s\n"
				   ";; sawfish version %s; %s\n\n")
		      (user-login-name) (system-name)
		      sawfish-version (current-time-string))
	      (map-windows (lambda (w)
                             (and (not (desktop-window-p w))
                                  (sm-print-alist file
                                                  (sm-get-window-state w)))))
	      t)
	  (close-file file))))))

;; compat.jl -- support for obsolete functions and variables

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.compat

    (export custom-set-color
	    custom-set-font
	    custom-set-frame-style
	    get-window-by-class-re
	    get-window-by-name-re
	    maybe-raise-window
	    maybe-lower-window
	    popup-window-menu
	    rename-window-func
	    show-message
	    ws-copy-window
	    ws-insert-workspace
	    ws-move-window
	    ws-remove-workspace)

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.menus
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands
	  sawfish.wm.workspace
	  sawfish.wm.util.stacking)

;;; obsolete functions are collected here

  (define (show-message #!optional text font fg bg position)
    (let ((attrs nil))
      (when font
	(setq attrs (cons (cons 'font font) attrs)))
      (when fg
	(setq attrs (cons (cons 'fg fg) attrs)))
      (when bg
	(setq attrs (cons (cons 'bg bg) attrs)))
      (when position
	(setq attrs (cons (cons 'position position) attrs)))
      (display-message text attrs)))

  ;; Define alias for renamed functions.
  (define ws-copy-window copy-window-to-workspace)
  (define ws-move-window move-window-to-workspace)
  (define ws-insert-workspace insert-workspace)
  (define ws-remove-workspace remove-workspace)

  (define maybe-raise-window raise-window*)
  (define maybe-lower-window lower-window*)

  (define popup-window-menu popup-window-ops-menu)
  (define rename-window-func rename-window)

  (define (get-window-by-class-re class)
    (get-window-by-class class #:regex t))

  (define (get-window-by-name-re name)
    (get-window-by-name name #:regex t))

;;; obsolete commands

  (define (define-commands index)
    (let ((fn (lambda (base)
		(intern (format nil "%s:%d" base (1+ index))))))
      (define-command (fn "select-workspace")
	(lambda () (select-workspace-from-first index))
	#:class 'deprecated)
      (define-command (fn "send-to-workspace")
	(lambda (w) (send-window-to-workspace-from-first w index))
	#:spec "%W"
	#:class 'deprecated)
      (define-command (fn "copy-to-workspace")
	(lambda (w) (send-window-to-workspace-from-first w index t))
	#:spec "%W"
	#:class 'deprecated)))

  (do ((i 0 (1+ i)))
      ((= i 9))
    (define-commands i))

  (define-command 'insert-workspace (command-ref 'insert-workspace-after)
    #:doc "Obsolete. Renamed to insert-workspace-after."
    #:class 'deprecated)

  (define-command 'popup-window-menu (command-ref 'popup-window-ops-menu)
    #:doc "Obsolete. Renamed to popup-window-ops-menu."
    #:class 'deprecated
    #:spec "%W")

;;; obsolete options

  ;; 1. If these options are set in ~/.sawfish/custom, then they are
  ;;    ignored. This means the next time you save the file `custom',
  ;;    they are removed.
  ;; 2. You can't set value to them via custom related methods.
  (mapc (lambda (x)
	  (put x 'custom-obsolete t))
	'(viewport-columns viewport-rows preallocated-workspaces
          iconify-whole-group uniconify-whole-group
          always-update-frames edge-flip-warp-pointer
          frame-type-fallbacks warp-to-window-x-offset
          warp-to-window-y-offset uniquify-name-format transients-get-focus 
          raise-windows-on-uniconify uniconify-to-current-workspace
          iconify-ignored focus-ignore-pointer-events
          focus-windows-on-uniconify transients-are-group-members
          raise-selected-windows warp-to-selected-windows configure-auto-gravity
          configure-ignore-stacking-requests beos-window-menu-simplifies
          move-snap-mode move-snap-ignored-windows
          move-resize-inhibit-configure move-snap-edges
          raise-windows-when-unshaded persistent-group-ids
          delete-workspaces-when-empty transients-on-parents-workspace
          audio-for-ignored-windows size-window-def-increment
          slide-window-increment default-bevel-percent sp-padding
          nokogiri-user-level nokogiri-buttons lock-first-workspace
          ignore-window-input-hint workspace-geometry
          pointer-motion-threshold ignore-program-positions
          infinite-desktop.stop-at-workspace-borders
	  edge-flip-enabled edge-flip-type edge-flip-only-when-moving
	  infinite-desktop-p infinite-desktop.move-distance
	  infinite-desktop.move-cursor-distance
	  tab-left-dec-width tab-right-dec-width
	  tab-left-margin tab-right-margin
	  tab-left-margin-transient tab-right-margin-transient
	  ))

;;; obsolete custom setters

  (define (custom-set-color var value #!optional req)
    (custom-set-typed-variable var value 'color req))
  (define (custom-set-font var value #!optional req)
    (custom-set-typed-variable var value 'font req))
  (define (custom-set-frame-style var value #!optional req)
    (custom-set-typed-variable var value 'frame-style req))

  (define-custom-setter 'custom-set-color custom-set-color)
  (define-custom-setter 'custom-set-font custom-set-font)
  (define-custom-setter 'custom-set-frame-style custom-set-frame-style))

;; off-center.jl -- place windows around the centre of the screen
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; Commentary:

;; This placement mode tries to put windows in the center of the
;; screen, but in such a way that the newly placed window doesn't fully
;; obscure an existing window.

;; This is to handle the case where two windows of the same size are
;; created one after the other, so that the user is sure to see (at
;; least part of) both windows

(define-structure sawfish.wm.placement.off-center

    (export )

    (open rep
	  sawfish.wm.misc
	  sawfish.wm.placement
	  sawfish.wm.windows
	  sawfish.wm.viewport
	  sawfish.wm.workspace
	  sawfish.wm.util.rects
	  sawfish.wm.util.workarea
	  sawfish.wm.state.iconify)

  (define multipliers '[(0 . 0)		;centered

			(-1/8 . -1/8)	;diagonals
			(-1/8 . -1/8)
			(1/8 . -1/8)
			(1/8 . 1/8)
			(-1/8 . 1/8)
			(0 . -1/6)	;perpendicular
			(1/6 . 0)
			(0 . 1/6)
			(-1/6 . 0)

			(-1/4 . -1/4)	;diagonals
			(-1/4 . -1/4)
			(1/4 . -1/4)
			(1/4 . 1/4)
			(-1/4 . 1/4)
			(0 . -1/3)	;perpendicular
			(1/3 . 0)
			(0 . 1/3)
			(-1/3 . 0)

			(-1/2 . -1/2)	;diagonals
			(-1/2 . -1/2)
			(1/2 . -1/2)
			(1/2 . 1/2)
			(-1/2 . 1/2)
			(0 . -1/2)	;perpendicular
			(1/2 . 0)
			(0 . 1/2)
			(-1/2 . 0)])

  (define (make-point center dims index)
    (if (>= index (length multipliers))
	nil
      (let ((mult (aref multipliers index)))
	;; need to coerce to exact representation in case rep
	;; was compiled --without-gmp (and thus division may lose
	;; exactness)
	(cons (inexact->exact (round (- (+ (car center)
					   (* (car dims) (car mult)))
					(/ (car dims) 2))))
	      (inexact->exact (round (- (+ (cdr center)
					   (* (cdr dims) (cdr mult)))
					(/ (cdr dims) 2))))))))

  (define (obscured-windows w point dims)
    (filter-windows
     (lambda (x)
       (and (not (eq x w))
	    (window-mapped-p x)
	    (not (window-iconified-p x))
	    (window-in-workspace-p x current-workspace)
	    (let ((x-rect (car (rectangles-from-windows (list x)))))
	      (>= (rect-2d-overlap dims point x-rect)
		  (rectangle-area x-rect)))))))

  (define (within-rectangle point dims rect)
    (= (rect-2d-overlap dims point rect) (* (car dims) (cdr dims))))

  (define (place-window-off-center w)
    (let* ((workarea (calculate-workarea #:window w))
	   (fdims (window-frame-dimensions w))
	   (center (rectangle-center workarea)))

      (let loop ((index 0))
	(let ((point (make-point center fdims index)))
	  (if (null point)
	      ;; fall back to random placement
	      ((placement-mode 'randomly) w)

	    (if (and (within-rectangle point fdims workarea)
		     (null (obscured-windows w point fdims)))
		(move-window-to w (car point) (cdr point))

	      (loop (1+ index))))))))

  ;;###autoload
  (define-placement-mode 'off-center place-window-off-center #:for-normal t))

;; heads.jl -- Multihead support

;; Copyright (C) 2014 fuchur <flohtransporter@gmail.com>

;; This file is part of sawfish.

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.

;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see `http://www.gnu.org/licenses/'.


(define-structure sawfish.wm.heads

    (export send-window-to-next-head
            send-window-to-previous-head)
    
    (open rep
          rep.data
          rep.system
          sawfish.wm.misc
          sawfish.wm.windows
          sawfish.wm.commands
          sawfish.wm.state.maximize
          sawfish.wm.tabs.tabgroup)


  (define (move-win-to-head w head)
    "Move window to head"
    (let ((maximized-fullscreen (window-get w 'maximized-fullscreen))
          (maximized-vertically (window-get w 'maximized-vertically))
          (maximized-horizontally (window-get w 'maximized-horizontally))
          is-maximized)
      
      (when (window-maximized-p w)
        (unmaximize-window w)
        (setq is-maximized t))
      
      (let ((dim-x (car (window-position w)))
            (dim-y (cdr (window-position w)))
            (head-dim-x (car (current-head-dimensions w)))
            (head-dim-y (cdr (current-head-dimensions w)))
            (head-offset-x (car (current-head-offset w)))
            (head-offset-y (cdr (current-head-offset w)))
            (wins (tab-group-windows w))
            (new-head head)
            new-dim-x new-dim-y new-head-dim-x new-head-dim-y)
        
        (setq new-head-dim-x (car (head-dimensions new-head)))
        (setq new-head-dim-y (cdr (head-dimensions new-head)))
        (setq new-dim-x (+ (* (/ new-head-dim-x head-dim-x) (- dim-x head-offset-x)) (car (head-offset new-head))))
        (setq new-dim-y (+ (* (/ new-head-dim-y head-dim-y) (- dim-y head-offset-y)) (cdr (head-offset new-head))))
        
        (if (eq is-maximized t)
            (progn
              (move-window-to w new-dim-x new-dim-y)
              (if maximized-fullscreen
                  (maximize-window-fullscreen w 't)
                (if maximized-horizontally
                    (maximize-window-horizontally w))
                (if maximized-vertically
                    (maximize-window-vertically w)))
              (setq is-maximized nil))
          (mapcar (lambda (w) (move-window-to w new-dim-x new-dim-y)) wins)))))
  
  (define (send-window-to-next-head w)
    "Send window to the next head."
    (interactive "%W")
    (when (> (head-count) 1)
      (if (< (current-head w) (- (head-count) 1))
          (move-win-to-head w (+ (current-head w) 1))
        (move-win-to-head w 0))))
  
  (define (send-window-to-previous-head w)
    "Send window to the previous head."
    (interactive "%W")
    (when (> (head-count) 1)
      (if (> (current-head w) 0)
          (move-win-to-head w (- (current-head w) 1))
        (move-win-to-head w (- (head-count) 1)))))
  
  (define-command 'send-window-to-next-head send-window-to-next-head #:spec "%W")
  (define-command 'send-window-to-previous-head send-window-to-previous-head #:spec "%W")
  )

;; windows.jl -- miscellaneous window mgmt functions
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.windows

    (compound-interface
     ;; Subrs are stored in sawfish.wm.windows.subrs, but
     ;; this module re-exports them for convenience.
     (structure-interface sawfish.wm.windows.subrs)
     (export get-window-by-name
	     get-window-by-class
	     window-class-name
	     get-window-by-role
	     window-really-wants-input-p
	     window-transient-p
	     mark-window-as-transient
	     desktop-window-p
	     mark-window-as-desktop
	     dock-window-p
	     mark-window-as-dock
	     window-in-cycle-p
	     window-class
	     window-pid
	     window-role
	     warp-cursor-to-window
	     activate-window
	     constrain-dimension-to-hints
	     constrain-aspect-to-hints
	     resize-window-with-hints
	     resize-window-with-hints*
	     window-gravity
	     adjust-position-for-gravity/x
	     adjust-position-for-gravity/y
	     adjust-position-for-gravity
	     get-window-wm-protocols
	     window-supports-wm-protocol-p
	     delete-window
	     delete-window-safely
	     uniquify-name
	     uniquify-window-name
	     select-window
	     window-avoided-p
	     avoided-windows
	     call-after-property-changed
	     call-after-state-changed
	     rename-window
	     window-touching-p
	     window-x
	     window-y
	     window-width
	     window-height
	     toggle-window-fixed-position
	     toggle-window-fixed-size))

    (open rep
	  rep.system
	  rep.regexp
	  #|
	    Don't add more sawfish.wm.* here unless you know what
	    you're doing. Instead, embed 'require' in definition.
	    It's because this file is read in early stage of Sawfish
	    init.
	  |#
	  sawfish.wm.windows.subrs
	  sawfish.wm.gaol
	  sawfish.wm.custom
	  sawfish.wm.events
	  sawfish.wm.misc
	  sawfish.wm.commands)


  (defgroup warp "Warping" :group misc)

  (defcustom warp-to-window-offset (cons -1 -1)
    "Offset (percent) from window edges when warping pointer."
    :type (pair (number 1) (number 1))
    :group (misc warp))

  (defcustom warp-to-window-enabled nil
    "Whether to enable warping the cursor to windows."
    :type boolean
    :group (misc warp))

  (defcustom dont-avoid-ignored t
    "Whether to not avoid ignored windows by default."
    :type boolean
    :group misc)

  (defcustom avoid-by-default nil
    "Whether to avoid any unspecified window by default."
    :type boolean
    :group misc)

  (defcustom uniquify-name-format "%s [%d]"
    "Format to create unique window names."
    :type string
    :group misc)

  (defvar dock-window-properties
    '(window-list-skip cycle-skip fixed-position focus-click-through
		       avoid no-history never-iconify never-maximize sticky
		       sticky-viewport placed)
    "List of properties set (to true) on windows when they are marked as docks.")

  (defvar desktop-window-properties
    '(fixed-position sticky sticky-viewport)
    "List of properties set (to true) on windows when they are marked as desktops.")

  (defvar desktop-window-depth -4
    "The stacking depth of desktop windows.")

  (defvar dock-window-depth 0
    "The stacking depth of dock windows.")

  (defvar activate-window-hook nil)

;;; finding windows, reading properties

  (define (get-window-by-name name #!key regex icon)
    "Find a window object whose window-name is NAME. If REGEX is
non-nil, then find a window object whose name matches NAME. If
ICON is non-nil, then window-icon-name (NET_WM_ICON_NAME, _not_ EWMH
_NET_WM_ICON_NAME) is checked instead. Returns nil if no such window is found."
    (if icon 
        (if regex
	    (car (filter-windows (lambda (w)
				   (when (window-icon-name w)
				     (string-match name (window-icon-name w))))))
	  (car (filter-windows (lambda (w)
				 (when (window-icon-name w)
				   (string= (window-icon-name w) name))))))
      (if regex
          (car (filter-windows (lambda (w)
				 (when (window-name w)
			           (string-match name (window-name w))))))
        (car (filter-windows (lambda (w)
			       (when (window-name w)
  			         (string= (window-name w) name))))))))

  (define (get-window-by-class class #!key regex)
    "Find a window object whose window-class is CLASS. If REGEX is
non-nil then find a window object whose class matches
CLASS. Returns nil if no such window is found."
    (if regex
        (car (filter-windows (lambda (w)
			       (when (window-class w)
			         (string-match class (window-class w))))))
      (car (filter-windows (lambda (w)
			     (when (window-class w)
  			       (string= (window-class w) class)))))))

  (define (window-class-name w #!optional (ref 1))
    "Quick way to get window class name."
    (aref (get-x-text-property w 'WM_CLASS) ref))

  (define (get-window-by-role role #!key regex)
    "Find a window object whose window-role is ROLE. If REGEX is non-nil then
find a window object whose role matches ROLE. Returns nil if no such
window is found."
    (if regex
        (car (filter-windows (lambda (w)
			       (when (window-role w)
				 (string-match role (window-role w))))))
      (car (filter-windows (lambda (w)
			     (when (window-role w)
			       (string= (window-role w) role)))))))

  (define (window-really-wants-input-p w)
    "Return nil if window W should never be focused."
    (and (not (window-get w 'never-focus))
	 (window-wants-input-p w)))

  (define (window-transient-p w)
    "Return non-nil if WINDOW is a transient window. The returned value will
then be the numeric id of its parent window."
    (or (window-get w 'transient-for)
	(let ((prop (get-x-property w 'WM_TRANSIENT_FOR)))
	  (when (and prop (eq (car prop) 'WINDOW)
		     (eql (cadr prop) 32) (>= (length (caddr prop)) 1))
	    (aref (caddr prop) 0)))))

  (define (mark-window-as-transient w)
    "Mark that window W is a dialog window of some sort."
    (require 'sawfish.wm.frames)
    (unless (window-transient-p w)
      (window-put w 'transient-for (root-window-id)))
    (set-window-type w 'transient))

  (define (desktop-window-p arg)
    "Return true if ARG represents a desktop window."
    (or (eq arg 'root) (and (windowp arg) (window-get arg 'desktop))))

  (define (mark-window-as-desktop w)
    "Mark that the window associated with object W is a desktop window."
    (require 'sawfish.wm.stacking)
    (require 'sawfish.wm.frames)
    (window-put w 'desktop t)
    (window-put w 'keymap root-window-keymap)
    (mapc (lambda (p)
	    (window-put w p t)) desktop-window-properties)
    (set-window-type w 'unframed)
    (set-window-depth w desktop-window-depth))

  (define (focus-desktop)
    "Transfer input focus to the desktop window (if one exists)."
    (let ((desktop-window (car (filter-windows desktop-window-p))))
      (when desktop-window
	(set-input-focus desktop-window))))

  (define-command 'focus-desktop focus-desktop)

  (define (dock-window-p arg)
    "Return true if ARG represents a dock window."
    (and (windowp arg) (window-get arg 'dock-type)))

  (define (mark-window-as-dock w)
    "Mark that the window associated with object W is a dock window."
    (require 'sawfish.wm.stacking)
    (require 'sawfish.wm.frames)
    (window-put w 'dock-type t)
    (mapc (lambda (p)
	    (window-put w p t)) dock-window-properties)
    (set-window-type w 'dock)
    (set-window-depth w dock-window-depth))

  (define (window-in-cycle-p w #!key ignore-cycle-skip)
    "Returns true if the window W should be included when cycling between
windows."
    (and (window-really-wants-input-p w)
	 (not (or (and (not ignore-cycle-skip) (window-get w 'cycle-skip))
		  (desktop-window-p w)))))

  (define (window-class w #!optional spec)
    "If SPEC is nil, return the class that window W belongs to,
as a string. Returns `nil' if W has no associated class.

If SPEC is 'cons, then cons (Instance . Class) is returned.
If SPEC is 'configurator, then the string of the form \"Instance/Class\"
is returned."
    (let ((prop (get-x-text-property w 'WM_CLASS)))
      (when (and prop (> (length prop) 1))
	(case spec
	  ((cons)
	   (cons (aref prop 0) (aref prop 1)))
	  ((configurator)
	   (concat (aref prop 1) "/" (aref prop 0)))
	  (t
	   (and prop (> (length prop) 1) (aref prop 1)))))))

  (define (window-pid win)
    "Returns the window pid, or nil if not available."
    (when (caddr (get-x-property win '_NET_WM_PID))
      (aref (caddr (get-x-property win '_NET_WM_PID)) 0)))

  (define (window-role win)
    "Returns the window role, or nil if not available."
    (when (get-x-text-property win 'WM_WINDOW_ROLE)
      (aref (get-x-text-property win 'WM_WINDOW_ROLE) 0)))

  (define (get-window-wm-protocols w)
    "Return a list of symbols defining the X11 window manager protocols
supported by client window W."
    (let* ((prop (get-x-property w 'WM_PROTOCOLS))
	   (data (and prop (eq (car prop) 'ATOM) (nth 2 prop))))
      (when data
	(do ((i 0 (1+ i))
	     (out '() (cons (aref data i) out)))
	    ((= i (length data))
	     (nreverse out))))))

  (define (window-supports-wm-protocol-p w atom)
    "Return true if window W includes ATOM in its `WM_PROTOCOLS' property."
    (let* ((prop (get-x-property w 'WM_PROTOCOLS))
	   (data (and prop (eq (car prop) 'ATOM) (nth 2 prop))))
      (when data
	(let loop ((i 0))
	  (cond ((= i (length data)) nil)
		((eq (aref data i) atom) t)
		(t (loop (1+ i))))))))

;;; warping

  (define (warp-cursor-to-window w #!optional x y)
    "Move the mouse pointer to position (X, Y) relative to the client window
associated with object WINDOW.

If X and Y are nil, then the pointer is moved to a default position, as
specified by the user."
    (when warp-to-window-enabled
      (let ((coords (window-position w))
	    (foff (window-frame-offset w))
	    (dims (window-dimensions w)))
	(require 'sawfish.wm.state.shading)
	(when (window-shaded-p w)
	  (setq foff (cons 0 0))
	  (setq dims (window-frame-dimensions w)))
	(unless x
	  (setq x
		(if (< (car warp-to-window-offset) 0)
		    (car warp-to-window-offset)
		  (quotient (* (car dims)
                               (car warp-to-window-offset)) 100))))
	(unless y
	  (setq y (if (< (cdr warp-to-window-offset) 0)
		      (cdr warp-to-window-offset)
		    (quotient (* (cdr dims)
                                 (cdr warp-to-window-offset)) 100))))
	(warp-cursor
	 (max 0 (min (1- (screen-width))
                     (+ x (car coords) (- (car foff)))))
	 (max 0 (min (1- (screen-height))
                     (+ y (cdr coords) (- (cdr foff)))))))))

  (define (activate-window w)
    (require 'sawfish.wm.focus)
    (require 'sawfish.wm.util.stacking)
    (require 'sawfish.wm.util.window-order)
    (raise-window* w)
    (when (window-really-wants-input-p w)
      (set-input-focus w))
    (warp-pointer-if-necessary w)
    (window-order-push w)
    (call-window-hook 'activate-window-hook w))

;;; resizing windows in accordance with their size hints

  (define (constrain-dimension-to-hints x dimension hints)
    ;; User asks the value DIMENSION as a window dimension.
    ;; X is either 'x or 'y.
    ;; Return value is the DIMENSION constrained by HINTS.
    (let ((base (cdr (assq (if (eq dimension 'x)
			       'base-width 'base-height) hints)))
	  (minimum (cdr (assq (if (eq dimension 'x)
				  'min-width 'min-height) hints)))
	  (maximum (or (cdr (assq (if (eq dimension 'x)
				      'max-width 'max-height) hints)) 65535))
	  (inc (or (cdr (assq (if (eq dimension 'x)
				  'width-inc 'height-inc) hints)) 1)))
      (let ((bottom (or base minimum 1)))
	(unless (= (mod (- x bottom) inc) 0)
	  (setq x (inexact->exact
		   (+ (* (ceiling (/ (- x bottom) inc)) inc) bottom)))))
      (clamp x (or minimum base 1) maximum)))

  (define (constrain-aspect-to-hints a old-b dimension min-aspect max-aspect)
    (let ((min-ratio (/ (cadr min-aspect) (cddr min-aspect)))
          (max-ratio (/ (cadr max-aspect) (cddr min-aspect))))
      (if (eq dimension 'y)
          (clamp old-b (floor (* a min-ratio)) (floor (* a max-ratio)))
        (clamp old-b (floor (/ a max-ratio)) (floor (/ a min-ratio))))))

  (define (resize-window-with-hints w cols rows #!optional hints)
    "Resize window W to COLS x ROWS, using the window's size hints to
define the row and column size, and the minimum possible size.

If HINTS is non-nil, then it is the size hints structure to
use. Otherwise (window-size-hints W) is used."
    (unless hints
      (setq hints (window-size-hints w)))
    (let ((x-base (or (cdr (or (assq 'base-width hints)
			       (assq 'min-width hints))) 1))
	  (x-inc (or (cdr (assq 'width-inc hints)) 1))
	  (y-base (or (cdr (or (assq 'base-height hints)
			       (assq 'min-height hints))) 1))
	  (y-inc (or (cdr (assq 'height-inc hints)) 1)))
      (resize-window-to
       w (constrain-dimension-to-hints (+ x-base (* x-inc cols)) 'x hints)
       (constrain-dimension-to-hints (+ y-base (* y-inc rows)) 'y hints))))

  (define (resize-window-with-hints* w width height #!optional hints)
    "Resize window W to WIDTH x HEIGHT, with WIDTH and HEIGHT defined
in terms of pixels. The window's size hints structure defines the
minimum and maximum dimensions of the window, within which WIDTH and
HEIGHT are constrained.

If HINTS is non-nil, then it is the size hints structure to
use. Otherwise (window-size-hints W) is used."
    (unless hints
      (setq hints (window-size-hints w)))
    (resize-window-to w (constrain-dimension-to-hints width 'x hints)
		      (constrain-dimension-to-hints height 'y hints)))

  (define (window-gravity w #!optional hints)
    (or (window-get w 'gravity)
	(cdr (assq 'window-gravity (or hints (window-size-hints w))))
	;; default gravity is NorthWest (from ICCCM)
	'north-west))

  (define (adjust-position-for-gravity/x w grav x #!key inverse)
    (let* ((tl-off (car (window-frame-offset w)))
	   (br-off (- (car (window-frame-dimensions w))
		      (car (window-dimensions w))))
	   (sign (if inverse -1 +1)))
      (cond ((eq grav 'static)
	     ;; static gravity is relative to the original
	     ;; client window position
	     (+ x (* sign tl-off)))
	    ((memq grav '(east south-east north-east))
	     ;; relative to the right of the frame
	     (- x (* sign (+ br-off (* -2 (window-border-width w))))))
	    ((memq grav '(north center south))
	     ;; relative to the horizontal center of the frame
	     (- x (* sign (quotient
			   (+ br-off (* -2 (window-border-width w))) 2))))
	    (t x))))

  (define (adjust-position-for-gravity/y w grav y #!key inverse)
    (let* ((tl-off (cdr (window-frame-offset w)))
	   (br-off (- (cdr (window-frame-dimensions w))
		      (cdr (window-dimensions w))))
	   (sign (if inverse -1 +1)))
      (cond ((eq grav 'static)
	     ;; static gravity is relative to the original
	     ;; client window position
	     (+ y (* sign tl-off)))
	    ((memq grav '(south south-east south-west))
	     ;; relative to the bottom of the frame
	     (- y (* sign (+ br-off (* -2 (window-border-width w))))))
	    ((memq grav '(east center west))
	     ;; relative to the vertical center of the frame
	     (- y (* sign (quotient
			   (+ br-off (* -2 (window-border-width w))) 2))))
	    (t y))))

  ;; UNADJUST means to reverse the gravity compensation, suitable for
  ;; when unmanaging windows at shutdown
  (define (adjust-position-for-gravity w grav coords #!optional unadjust)
    (cons (adjust-position-for-gravity/x
	   w grav (car coords) #:inverse unadjust)
	  (adjust-position-for-gravity/y
	   w grav (cdr coords) #:inverse unadjust)))

;;; deleting windows

  (define (delete-window w #!optional safely)
    "Delete a window. If the window does not support that protocol,
kill the client."
    (unless (and (memq this-command
		       '(delete-window delete-window-safely
			 delete-group delete-window-instance))
		 (window-get w 'never-delete))
      (cond
       ((window-supports-wm-protocol-p w 'WM_DELETE_WINDOW)
	(send-client-message w 'WM_PROTOCOLS (vector (x-atom 'WM_DELETE_WINDOW)
						     (x-server-timestamp)) 32))
       (safely (beep))
       (t (x-kill-client w)))))

  (define-command 'delete-window delete-window #:spec "%W")

  (define (delete-window-safely w)
    "Delete a window, or beep if the window can't be closed safely."
    (delete-window w t))

  (define-command 'delete-window-safely delete-window-safely #:spec "%W")

;;; making window names unique

  (define (uniquify-name in existing)
    "Uniquify the string IN from the list of strings EXISTING. Uses the format
string `uniquify-name-format' to generate unique names."
    (letrec
	((again (lambda (i)
		  (if (member (format nil uniquify-name-format in i) existing)
		      (again (1+ i))
		    (format nil uniquify-name-format in i)))))
      (if (member in existing)
	  (again 2)
	in)))

  (define (uniquify-window-name w)
    "Force the current window to have a unique title."
    (set-x-text-property
     w 'WM_NAME
     (vector (uniquify-name (window-name w)
			    (mapcar window-name (delq w (managed-windows)))))))

  (define-command 'uniquify-window-name uniquify-window-name #:spec "%W")

;;; selecting a single window

  (define select-window-map
    (bind-keys (make-keymap)
               "Any-Click1" (lambda ()
                              (throw 'select-window
                                     (query-pointer-window)))))

  (defvar select-window-cursor-shape 'crosshair)

  (define (select-window)
    "Wait for a click, and returns the clicked window. Nil for the root
window."
    (allow-events 'async-pointer)
    (when (grab-pointer nil select-window-cursor-shape)
      (unwind-protect
	  (let ((override-keymap select-window-map))
	    (catch 'select-window
	      (recursive-edit)))
	(ungrab-pointer))))

;;; avoided (i.e. non-overlapped) windows

  (define (window-avoided-p w)
    "Return t if window W should be kept unobscured by other windows wherever
possible."
    (cond ((or (not (window-mapped-p w))
	       (not (window-visible-p w))) nil)
	  ((window-get w 'avoid) t)
	  ((and dont-avoid-ignored (window-get w 'ignored)) nil)
	  (t avoid-by-default)))

  (define (avoided-windows #!optional window)
    "Returns a list of all windows that should be left unobscured where
possible. If WINDOW is defined, then it defines a window that will be never
returned in the list."
    (filter-windows (lambda (w)
		      (and (not (eq w window))
			   (window-avoided-p w)))))

;;; property and window-state changed interface

  (define prop-changes '())

  (define (call-after-property-changed prop fun)
    "Arrange for function FUN to be called with arguments (WINDOW PROPERTY
STATE) when the X11 property named PROP (a symbol) changes. PROP may also
be a list of property names to monitor.

Kluge: if PROP is `WM_NAME', it is replaced with `(WM_NAME _NET_WM_NAME)'.
This is done to cope with themes that want to update title bars on name
changes but only watch `WM_NAME'.  A warning is printed on stderr when
this substitution occurs.  Those themes should really be fixed."
    (setq prop-changes
          (cons
           (cons (cond ((listp prop) prop)
                       ((eq prop 'WM_NAME)
                        (format standard-error
" (call-after-property-changed 'WM_NAME ...) should probably be
 (call-after-property-changed '(WM_NAME _NET_WM_NAME) ...);
Use '(WM_NAME) if you really want only WM_NAME\n")
                        '(WM_NAME _NET_WM_NAME))
                       (t (list prop)))
                 fun)
           prop-changes)))

  (add-hook 'property-notify-hook
	    (lambda (w prop state)
	      (mapc (lambda (cell)
                      (when (memq prop (car cell))
			((cdr cell) w prop state)))
		    prop-changes)))

  (define state-changes '())

  (define (call-after-state-changed states fun)
    "Arrange for function FUN to be called with arguments (WINDOW
CHANGED-STATES) when one of the states defined by the list of symbols
STATES has been changed. STATES may also be a single symbol."
    (setq state-changes (cons (cons (if (listp states)
					states
				      (list states)) fun) state-changes)))

  (add-hook
   'window-state-change-hook
   (lambda (w states)
     (mapc (lambda (cell)
	     (let ((relevant (filter (lambda (state)
                                       (memq state (car cell))) states)))
	       (when relevant
		 ((cdr cell) w relevant))))
           state-changes)))

  (define (rename-window window new-name)
    "Renames WINDOW to NEW-NAME."
    (set-x-text-property window 'WM_NAME (vector new-name))
    (set-x-text-property window '_NET_WM_NAME (vector new-name))
    (set-x-text-property window 'WM_ICON_NAME (vector new-name))
    (set-x-text-property window '_NET_WM_ICON_NAME (vector new-name)))

  (define-command 'rename-window rename-window
    #:spec "%W\nsEnter new window name:")

    ;; helpers for window-touching-p
  (define (find-if fn l)
    (cond ((null l) nil)
	  ((fn (car l)) (car l))
	  (t (find-if fn (cdr l)))))

  (define (overlapping w1 w2)
    "Do window W1 and window W2 overlap?"
    (and (< (abs (- (window-x w1) (window-x w2)))
	    (window-width (if (< (window-x w1) (window-x w2))
			      w1 w2)))
	(< (abs (- (window-y w1) (window-y w2)))
	    (window-height (if (< (window-y w1) (window-y w2))
			      w1 w2)))))

  (define (window-touching-p w)
    "Is window W touching another window?"
    (require 'sawfish.wm.state.ignored)
    (require 'sawfish.wm.workspace)
    (find-if (lambda (other) (overlapping w other))
	    (remove w (remove-if window-ignored-p
				  (filter-windows
				  window-on-current-workspace-p)))))

  (define (window-x w)
    (car (window-position w)))

  (define (window-y w)
    (cdr (window-position w)))

  (define (window-width w)
    (car (window-frame-dimensions w)))

  (define (window-height w)
    (cdr (window-frame-dimensions w)))

  (define (toggle-window-fixed-position w)
    "Toggle the window property `fixed-position'."
     (if (window-get w 'fixed-position)
	 (window-put w 'fixed-position nil)
       (window-put w 'fixed-position t))
     (call-window-hook 'window-state-change-hook w (list '(fixed-position))))
  (define-command 'toggle-window-fixed-position toggle-window-fixed-position #:spec "%W")

  (define (toggle-window-fixed-size w)
    "Toggle the window property `fixed-size'."
     (if (window-get w 'fixed-size)
	 (window-put w 'fixed-size nil)
       (window-put w 'fixed-size t))
     (call-window-hook 'window-state-change-hook w (list '(fixed-size))))
  (define-command 'toggle-window-fixed-size toggle-window-fixed-size #:spec "%W")

;;; gaollable functions

  (gaol-add window-really-wants-input-p window-class window-avoided-p
	    call-after-property-changed call-after-state-changed
	    window-get window-name window-full-name window-icon-name
	    window-mapped-p window-frame set-window-frame rebuild-frame
	    window-position window-dimensions window-frame-dimensions windowp
	    managed-windows stacking-order window-visibility
	    window-transient-p window-urgent-p window-shaped-p window-visible-p
	    window-framed-p window-id window-group-id window-size-hints
	    call-window-hook input-focus window-icon-image map-windows
	    filter-windows current-event-window window-put
	    move-window-to resize-window-to))

;;; mousetrap.jl -- Zoom the mouse to any place with few keystrokes.

;; Author: Fernando Carmona Varo  <ferkiwi@gmail.com>
;; Maintainer: Christopher Roy Bratusek <nano@jpberlin.de>
;; Version: 0.7

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 3, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with Sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;;; Commentary:

;; This script provides a method for moving the mouse to any place of
;; the screen by zooming with just a few keystrokes (and as much
;; precision as you want).

;; When the command is invoked the mouse is warped to the center of
;; the screen and a outline is drawn dividing the screen in 4
;; squares (like trapping the mouse on it).

;; You can then press an arrow key (or H J K or L key) and the mouse will
;; move to a new position inside the outline, moving half the distance
;; between it's current position and the edge of the "cage".
;; Each new keystroke will half the area of the cage, increasing 
;; precision exponentially.
;; When you press the spacebar or enter a mouse click is performed. If
;; you press ESC no click will be made, but the mouse will be moved to
;; that position.

;; The idea was inspired by a similar proyect shown in the Yahoo
;; Hack Day '06: http://www.semicomplete.com/presentations/hackday06/

;; The keys Q W A and S can also be used for warping the mouse to one of the
;; four quarters of the square, which would result in even less 
;; keystrokes.

(define-structure sawfish.wm.ext.mousetrap

    (export mousetrap-action
            synthetic-click)

    (open rep
	  rep.system
	  rep.io.timers
          sawfish.wm
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.animation.modes
          sawfish.wm.util.x)

  (define-structure-alias mousetrap sawfish.wm.ext.mousetrap)
  
  (defcustom mousetrap-outline 'crosshair
    "Outline drawing to use for mousetrap area."
    :type (choice crosshair none)
    :group misc)

  (defcustom mousetrap-cursor-shape 'fleur
    "Mouse cursor shape to use for mousetrap."
    :type (choice fleur cross crosshair iron_cross target)
    :group misc)

  (defvar mousetrap-escape-key nil)

  (defvar mousetrap-move-right-key nil)
  (defvar mousetrap-move-left-key nil)
  (defvar mousetrap-move-up-key nil)
  (defvar mousetrap-move-down-key nil)

  (defvar mousetrap-move-quarter-top-right-key nil)
  (defvar mousetrap-move-quarter-top-left-key nil)
  (defvar mousetrap-move-quarter-bottom-right-key nil)
  (defvar mousetrap-move-quarter-bottom-left-key nil)

  (define (draw-crosshair-outline x y width height)
    "Crosshair outline drawing."
    (let ((gc (x-create-root-xor-gc))
	  (x-step (/ width 2))
	  (y-step (/ height 2)))
      (do ((i 0 (1+ i)))
	  ((= i 3))
	;; Horizontal line
	(x-draw-line 'root gc
		      (cons x 
			    (inexact->exact (round (+ y (* y-step i)))))
		      (cons (+ x width) 
			    (inexact->exact (round (+ y (* y-step i))))))
	;; Vertical line
	(x-draw-line 'root gc
		      (cons (inexact->exact (round (+ x (* x-step i)))) 
			    y)
		      (cons (inexact->exact (round (+ x (* x-step i)))) 
			    (+ y height))))
      ;; Crosshair ruler
      (do ((x (+ x (/ x-step 2)))
	    (y (+ y (/ y-step 2)))
	    (i 0 (1+ i)))
	  ((= i 2))
	(x-draw-line 'root gc
		      (cons (inexact->exact (round (+ x (* x-step 0.47))))
			    (inexact->exact (round (+ y (* y-step i)))))
		      (cons (inexact->exact (round (+ x (* x-step 0.53))))
			    (inexact->exact (round (+ y (* y-step i))))))
	(x-draw-line 'root gc
		      (cons (inexact->exact (round (+ x (* x-step i))))
			    (inexact->exact (round (+ y (* y-step 0.47)))))
		      (cons (inexact->exact (round (+ x (* x-step i))))
			  (inexact->exact (round (+ y (* y-step 0.53)))))))
      (x-destroy-gc gc)))

  (define-window-outliner 'crosshair draw-crosshair-outline)

  ;; prevent edge actions from being invoked while mousetrapping
  (defvar while-mousetrap nil)
  (defvar server-grabbed nil)

  (eval-when-compile
    (defvar mousetrap-read-event nil))

  (define (mousetrap-action)
    "Let the user move the mouse by 'trapping' it to a position.
Returns the event-name of the key pressed to finish, nil if cancelled."
    (when (grab-keyboard)
      (unwind-protect
        (setq while-mousetrap t)

	  (define (mousetrap-read-event)
	    "Keyboard events callback for `mousetrap-action'."
	    (throw 'mousetrap-read (event-name (current-event))))
	(add-hook 'unbound-key-hook mousetrap-read-event)

	    (grab-server) ; don't draw anything else
	    (grab-pointer nil mousetrap-cursor-shape)
	    (setq server-grabbed t)
	    
	      (catch 'exit-mousetrap
		(let* (
		      (override-keymap '(keymap))
		      (pos-x 0)
		      (pos-y 0)
		      (dim-x (screen-width))
		      (dim-y (screen-height))
		      (key ""))
		  
		  (while t
		    ;; Update cursor
		    (warp-cursor (floor (+ pos-x (/ dim-x 2)))
				(floor (+ pos-y (/ dim-y 2))))
		      
		    ;; Draw outline
		    (unless (eq mousetrap-outline 'none)
		      (draw-window-outline mousetrap-outline pos-x pos-y dim-x dim-y))
		    ;; Read a key
		      (setq key
			    (catch 'mousetrap-read
			      (recursive-edit)))
		      ;; Erase outline
		      (unless (eq mousetrap-outline 'none)
			(erase-window-outline mousetrap-outline pos-x pos-y dim-x dim-y))
		      ;; Act according to the key read
		      (cond ((or (equal key mousetrap-escape-key)
				 (equal key "ESC"))
			    (throw 'exit-mousetrap nil))
			    ((or (equal key "RET")
				 (equal key "SPC"))
			    (throw 'exit-mousetrap key))
			    ((or (equal key mousetrap-move-left-key); Left half
			         (equal key "Left")
			         (equal key "h"))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-up-key); Upper half
			         (equal key "Up")
			         (equal key "u"))
			    (setq dim-y (floor (/ dim-y 2))))
			    ((or (equal key mousetrap-move-down-key); Lower half
			         (equal key "Down")
			         (equal key "n"))
			    (setq pos-y (floor (+ pos-y (/ dim-y 2))))
			    (setq dim-y (floor (/ dim-y 2))))
			    ((or (equal key mousetrap-move-right-key); Right half
			         (equal key "Right")
			         (equal key "j"))
			    (setq pos-x (floor (+ pos-x (/ dim-x 2))))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-top-left-key) ; top-left quarter
			         (equal key "M-Left")
			         (equal key "r"))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-top-right-key) ; top-right quarter
			         (equal key "M-Right")
			         (equal key "t"))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq pos-x (floor (+ pos-x (/ dim-x 2))))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-bottom-left-key) ; bottom-left quarter
			         (equal key "C-Left")
			         (equal key "v"))
			    (setq pos-y (floor (+ pos-y (/ dim-y 2))))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq dim-x (floor (/ dim-x 2))))
			    ((or (equal key mousetrap-move-quarter-bottom-right-key) ; bottom-right quarter
			         (equal key "C-Right")
			         (equal key "b"))
			    (setq pos-y (floor (+ pos-y (/ dim-y 2))))
			    (setq dim-y (floor (/ dim-y 2)))
			    (setq pos-x (floor (+ pos-x (/ dim-x 2))))
			    (setq dim-x (floor (/ dim-x 2))))
			    ))))
	    (ungrab-server)
	    (ungrab-pointer)
	    (remove-hook 'unbound-key-hook mousetrap-read-event)
	    (ungrab-keyboard)))
            (make-timer (lambda () (setq while-mousetrap nil)) 1))

  (define (synthetic-click event-name)
    (let* ((w (query-pointer-window))
	  (event (lookup-event event-name)))
      ;; focus, if allowed
      (when (window-really-wants-input-p w)
	(set-input-focus w))
      ;; send click to window
      (when (or focus-click-through 
		(not (window-really-wants-input-p w)))
	(synthesize-event event w))
      ;; raise
      (raise-window w)))

  (define (mousetrap-invoke)
    "Move mouse by mousetrapping."
    (interactive)
    (mousetrap-action))

  (define (mousetrap-invoke-and-left-click)
    "Move mouse by mousetrapping and make a left click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button1-Click1")))

  (define (mousetrap-invoke-and-left-double-click )
    "Move mouse by mousetrapping and make a left double click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button1-Click2")))

  (define (mousetrap-invoke-and-middle-click)
    "Move mouse by mousetrapping and make a middle click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button2-Click1")))

  (define (mousetrap-invoke-and-right-click)
    "Move mouse by mousetrapping and make a right click."
    (interactive)
    (and (mousetrap-action)
	(synthetic-click "Any-Button3-Click1")))

  (define-command 'mousetrap-invoke mousetrap-invoke)
  (define-command 'mousetrap-invoke-and-left-click mousetrap-invoke-and-left-click)
  (define-command 'mousetrap-invoke-and-left-double-click mousetrap-invoke-and-left-double-click)
  (define-command 'mousetrap-invoke-and-middle-click mousetrap-invoke-and-middle-click)
  (define-command 'mousetrap-invoke-and-right-click mousetrap-invoke-and-right-click))

;; ignore-window.jl -- controlling the ignored property

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

;; originally by Julian Missig <julian@linuxpower.org> (X-ViRGE), with
;; some extra hacking/renaming

(define-structure sawfish.wm.state.ignored

    (export window-ignored-p
	    make-window-ignored
	    make-window-not-ignored
	    toggle-window-ignored
	    toggle-window-never-focus
	    toggle-window-cycle-skip
	    toggle-window-list-skip
	    toggle-task-list-skip)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.util.window-order
	  sawfish.wm.frames
	  sawfish.wm.menus)

  (define (window-ignored-p w) (window-get w 'ignored))

  (define (make-window-ignored w)
    "Ignore the window."
    (unless (window-get w 'ignored)
      (set-window-frame w nil-frame)
      (window-put w 'current-frame-style nil)
      (window-put w 'ignored t)
      (call-window-hook 'window-state-change-hook w (list '(ignored)))
      (call-hook 'workspace-state-change-hook)))

  (define (make-window-not-ignored w)
    "Unignore the window."
    (when (window-get w 'ignored)
      (window-put w 'ignored nil)
      (reframe-window w)
      (call-window-hook 'window-state-change-hook w (list '(ignored)))
      (call-hook 'workspace-state-change-hook)))

  (define (toggle-window-ignored w)
    "Toggle whether a window is ignored or not."
    (if (window-get w 'ignored)
	(make-window-not-ignored w)
      (make-window-ignored w)))

  (define (toggle-window-never-focus w)
    "Toggle whether a window is focusable or not."
    (window-put w 'never-focus (not (window-get w 'never-focus)))
    (when (eq (input-focus) w)
      (window-order-focus-most-recent))
    (call-window-hook 'window-state-change-hook w (list '(never-focus))))

  (define (toggle-window-cycle-skip w)
    "Toggle whether a window is ignored while window cycling."
    (window-put w 'cycle-skip (not (window-get w 'cycle-skip)))
    (call-window-hook 'window-state-change-hook w (list '(cycle-skip))))

  (define (toggle-window-list-skip w)
    "Toggle whether a window will be include in the window list."
    (window-put w 'window-list-skip (not (window-get w 'window-list-skip)))
    (call-window-hook 'window-state-change-hook w (list '(window-list-skip))))

  (define (toggle-task-list-skip w)
    "Toggle whether a window will be included in the task-list."
    (window-put w 'task-list-skip (not (window-get w 'task-list-skip)))
    (call-window-hook 'window-state-change-hook w (list '(task-list-skip))))

  (define-command 'make-window-ignored
    make-window-ignored #:spec "%W")
  (define-command 'make-window-not-ignored
    make-window-not-ignored #:spec "%W")
  (define-command 'toggle-window-ignored
    toggle-window-ignored #:spec "%W")
  (define-command 'toggle-window-never-focus
    toggle-window-never-focus #:spec "%W")
  (define-command 'toggle-window-cycle-skip
    toggle-window-cycle-skip #:spec "%W")
  (define-command 'toggle-window-list-skip
    toggle-window-list-skip #:spec "%W")
  (define-command 'toggle-task-list-skip
    toggle-task-list-skip #:spec "%W")

  (add-window-menu-toggle (_ "_Ignored") 'toggle-window-ignored
			  window-ignored-p)
  (add-window-menu-toggle (_ "_Focusable") 'toggle-window-never-focus
			  (lambda (w) (not (window-get w 'never-focus))))
  (add-window-menu-toggle (_ "_Cyclable") 'toggle-window-cycle-skip
			  (lambda (w) (not (window-get w 'cycle-skip))))
  (add-window-menu-toggle (_ "In _window list") 'toggle-window-list-skip
			  (lambda (w) (not (window-get w 'window-list-skip))))
  (add-window-menu-toggle (_ "In _task list") 'toggle-task-list-skip
                          (lambda (w) (not (window-get w 'task-list-skip)))))

;; -*- indent-tabs-mode: nil -*-
;;
;; File: undo-viewport.jl
;; Version: $Revision: 0.1 $
;; Description: 
;;     Remembers changing viewports, allows to switch back and forth.
;;
;; Installation:
;;     Install this file, and add the following lines to your .sawmillrc:
;;
;; (setq load-path (cons "/directory/containing/this/file/" load-path))
;; (require 'undo-viewport)
;;
;;     And then bind the "viewport-switch-undo" and "viewport-switch-redo" commands to two handy keys.
;;
;; Author:
;;     Janek Kozicki <cosurgi@gmail.com>
;;     Terry Weissman <terry@weissman.org> - original author of undo.jl which
;;     was shamelessly modified here
;;


(require 'timers)

(defvar l "")

(defun undo-viewport-eval (cmd)
  (eval cmd)
)

(defun undo-viewport-record (l)
  (setq viewport-undo-cmd-list (cons l viewport-undo-cmd-list)))

(defun viewport-switch-undo ()
  "Undo last viewport switch"
  (interactive)
  (let ((cmd (car viewport-undo-list))
        (x (cdr viewport-undo-list))
        (r viewport-undo-redo-list))
    (setq viewport-undo-list ())
    (setq viewport-undo-cmd-list ())
    (undo-viewport-eval cmd)
    (viewport-undo-transfer-to-viewport-undo-list)
    (if viewport-undo-list
        (setq r (cons (car viewport-undo-list) r)))
    (setq viewport-undo-redo-list r)
    (setq viewport-undo-list x)
    (setq viewport-undo-cmd-list ())))


(defun viewport-switch-redo ()
  "Redo last viewport switch"
  (interactive)
  (let ((cmd (car viewport-undo-redo-list))
        (r (cdr viewport-undo-redo-list)))
    (undo-viewport-eval cmd)
    (make-timer (lambda () (setq viewport-undo-redo-list r)) 0 1)))
 

(defun undo-viewport-record-workspace ()
  (undo-viewport-record (list 'set-screen-viewport viewport-last-coords-x viewport-last-coords-y ))
  (setq viewport-last-coords-x (car (screen-viewport)))
  (setq viewport-last-coords-y (cdr (screen-viewport)))
  (viewport-undo-transfer-to-viewport-undo-list)
  )

(defun viewport-undo-transfer-to-viewport-undo-list ()
  (if viewport-undo-check-stacking
      (progn
	(setq viewport-undo-check-stacking nil)))
  (if viewport-undo-cmd-list
      (progn
        (setq viewport-undo-list (cons (cons 'progn viewport-undo-cmd-list) viewport-undo-list))
        (setq viewport-undo-cmd-list nil)
        (setq viewport-undo-redo-list nil)
        (while (> (length viewport-undo-list) 50)
          (setq viewport-undo-list (nreverse (cdr (nreverse viewport-undo-list))))))))

;;;;; Initialize global variables.

(defvar viewport-undo-list ())

(defvar viewport-undo-redo-list ())

(defvar viewport-undo-cmd-list ())

(defvar viewport-last-coords-x 0)
(defvar viewport-last-coords-y 0)

(defvar viewport-undo-cur-stack nil)

(defvar viewport-undo-check-stacking nil)

;;;;; Set hooks for operations that we want to be able to undo.

(unless (in-hook-p 'viewport-moved-hook undo-viewport-record-workspace)
  (add-hook 'viewport-moved-hook undo-viewport-record-workspace))

;; launcher.jl -- command to launch external apps, xterm & browser
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; This module was renamed from xterm in Sawfish-1.6.
(define-structure sawfish.wm.commands.launcher

    (export xterm
	    browser
	    filemanager)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  rep.io.files
	  sawfish.wm.misc
	  sawfish.wm.custom
	  sawfish.wm.commands)

  (define-structure-alias launcher sawfish.wm.commands.launcher)

  (defgroup apps "External Applications" :group misc)

  (defcustom xterm-program "xterm"
    "The program launched by the `xterm' function. Interpreted by shell."
    :type string
    :group (misc apps))

  (defcustom browser-program "www-browser"
    "The program launched by the `browser' function. Interpreted by shell."
    :type string
    :group (misc apps))


  (defcustom filemanager-program ""
    "The program launched by the 'filemanager' function. Interpreted by shell."
    :type string
    :group (misc apps))

  (define (xterm #!optional command)
    "Start a new terminal specified by the option `xterm-program'.

Optional argument `COMMAND' is passed to the terminal with -e option,
so for most terminals, including xterm, it can contain arguments to be
passed."
    (if (or (not command)
	    (equal "" command))
	(system (format nil "%s >/dev/null 2>&1 </dev/null &"
			xterm-program))
      ;; Note that -e has to be the last argument. See man xterm.
      (system (format nil "%s -e %s >/dev/null 2>&1 </dev/null &"
		      xterm-program command))))

  (define (browser #!optional url)
    "Start a new browser instance."
    (if (not url)
        (system (format nil "%s >/dev/null 2>&1 </dev/null &"
			browser-program))
      (system (format nil "%s %s >/dev/null 2>&1 </dev/null &"
                      browser-program url))))

  (define (filemanager #!optional url)
    "Start a new filemanager instance."
    (if (not url)
        (system (format nil "%s >/dev/null 2>&1 </dev/null &"
			filemanager-program))
      (system (format nil "%s %s >/dev/null 2>&1 </dev/null &"
                      filemanager-program url))))

  ;;###autoload
  (define-command 'xterm xterm
    #:spec "sCommand:"
    #:type `(and (labelled ,(_ "Command:") string))
    #:doc "Start a terminal. Optional command is passed with -e. The terminal is specified by variable `xterm-program' in Config -> Misc -> External Applications.")
  (define-command 'browser browser
    #:spec "sUrl:"
    #:type `(and (labelled ,(_ "url:") string))
    #:doc "Start browser. Url is optional. Browser program is specified by variable `browser-program' in Config -> Misc -> External Applications.")
  (define-command 'filemanager filemanager
    #:spec "sUrl:"
    #:type `(and (labelled ,(_ "url:") string))
    #:doc "Start filemanager. Url is optional. filemanager program is specified by variable `filemanager-program' in Config -> Misc -> External Applications."))

;; cabinet.jl

;; Copyright (C) 2011, 2012 hqwrong <hq.wrong@gmail.com>

;; This file is part of sawfish.

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.

;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see `http://www.gnu.org/licenses/'.


;; XXX Without this, this key-commands not run in cabinet, but i have no idea why.
;; XXX
;; XXX maximize-window-toggle maximize-window-fullscreen-toggle
;; XXX maximize-window-horizontally-toggle maximize-window-vertically-toggle
;; XXX maximize-window-fullxinerama-toggle maximize-fill-window
;; XXX maximize-fill-window-horizontally maximize-fill-window-vertically
;; XXX tab-release-window tab-move-to-end tab-move-to-beginning
;; XXX tab-move-to-right tab-move-to-left
;; XXX window-history-save-position window-history-save-dimensions
;; XXX window-history-save-attributes window-history-forget
(require 'sawfish.wm.heads)
(require 'sawfish.wm.state.maximize)
(require 'sawfish.wm.tabs.tabgroup)
(require 'sawfish.wm.ext.window-history)

(define-structure sawfish.wm.ext.cabinet
  
    (export cabinet-switch
            ;; 
            cabinet-keymap-complete
            cabinet-item-text
            ;; you'll need following procedures only when
            ;; you want to extend cabinet-keymap
            with-update-on-workspace
            with-selected
            with-marked-wl
            with-exit-and-clear-mark
            with-update-on-input
            with-new-wlist
            with-draw)
    
    (open rep
          rep.data
          rep.system
          rep.regexp
          rep.lang.math
          rep.io.timers
          sawfish.wm.util.events
          sawfish.wm.prg.compton
          sawfish.wm.tabs.tabgroup
          sawfish.wm.state.shading
          sawfish.wm.state.iconify
          sawfish.wm.stacking
          sawfish.wm.util.workarea
          sawfish.wm.viewport
          sawfish.wm.state.maximize
          sawfish.wm.util.display-window
          sawfish.wm.custom
          sawfish.wm.commands
          sawfish.wm.colors
          sawfish.wm.events
          sawfish.wm.fonts
          sawfish.wm.images
          sawfish.wm.misc
          sawfish.wm.util.x
          sawfish.wm.windows
          sawfish.wm.workspace)


  (defgroup cabinet "Cabinet"
    :group focus
    :require sawfish.wm.ext.cabinet)

  (defgroup filter "Filter"
    :group (focus cabinet))
  
  (defgroup bindings "Keybindings"
    :group (focus cabinet))

  (defcustom cabinet:margin (cons 10 10)
    "Margin to the border of cabinet."
    :group (focus cabinet)
    :type (pair (number 1 50 10 1) (number 1 50 10 1)))
  
  (defcustom cabinet:item-margin 6
    "Margin between items."
    :group (focus cabinet)
    :range (1 . 50)
    :type number)
  
  (defcustom cabinet:input-line-margin 25
    "Margin between input line and the first item."
    :group (focus cabinet)
    :range (1 . 100)
    :type number)
  
  (defcustom cabinet:icon-size 24
    "Icon size."
    :group (focus cabinet)
    :range (8 . 128)
    :type number)
  
  (defcustom cabinet:workspace-mode-on-initial nil
    "Display only windows from current workspace."
    :group (focus cabinet)
    :type boolean)
  
  (defcustom cabinet:display-cabinet-on-active nil
    "Display cabinet on active monitor."
    :group (focus cabinet)
    :type boolean)

  (defcustom cabinet:cycle-as-start nil
    "Cycle overhead when start cabinet-switch, like x-cycle."
    :group (focus cabinet)
    :type boolean)
  
  (defcustom cabinet:manipulation-on-selected 'Raise 
    "Action if browse across cabinet."
    :group (focus cabinet)
    :type (choice Raise Focus None))
  
  (defcustom cabinet:raise-window-timeout 200
    "Delay in milliseconds until a window gets raised if browse across cabinet. \\bottom"
    :group (focus cabinet)
    :type (range (1 . 1000)))

  (defcustom cabinet:command-repeat-timeout 100
    "Delay in milliseconds until a window keybinding gets repeats. \\bottom"
    :group (focus cabinet)
    :type (range (100 . 1000)))

  (defcustom cabinet:default-item-forground (get-color "#FFFFFF")
    "Font color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:background (get-color "#000000")
    "Background color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:forground-input (get-color "#FFFF00")
    "Input text color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:split-line-forground (get-color "#B22222")
    "Split line color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:maximized-item-forground (get-color "#FFA500")
    "Maximized windows color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:iconified-item-forground (get-color "#6D6D6D")
    "Iconified windows color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:shaded-item-forground (get-color "#0000FF")
    "Shaded windows color."
    :group (focus cabinet)
    :type color)
  
  (defcustom cabinet:filter-out-for-manipulation (list "^Conky$" "^Gkrellm$")
    nil
    :group (focus cabinet filter)
    :widget-flags (expand-horizontally expand-vertically)
    :type* `(list string ,(_ "Windows displayed below the split line.")))
  
  (defcustom cabinet:filter-out-from-display (list "^Gdesklets-daemon$" "^Xfce4-panel$" "^Mate-panel$"
                                                   "^Xfdesktop$" "^x-caja-desktop$" "^plasma-desktop$"
						   "^Pancake$" "^lxpanel" "Sawfishpager" "^conky$"
						   "Lumina Desktop Environment" "^trayer$")
    nil
    :group (focus cabinet filter)
    :widget-flags (expand-horizontally expand-vertically)
    :type* `(list string ,(_ "Windows removed from cabinet.")))
  
  (defcustom cabinet:cycle "Super-TAB"
    "Cycle through windows."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:reversely-cycle "C-TAB"
    "Reversely cycle through windows."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:restore-order "ESC"
    "Exit with restore stack order."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:toggle-workspace-mode "Super-a"
    "Toggle windows from current or all workspaces."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:exchange-manipulation "Super-q"
    "Toggle windows for display and for manipulation."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:cycle-workspaces "Super-x"
    "Cycle through workspaces."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:cycle-reversely-workspaces "Super-y"
    "Reversely cycle through workspaces."
    :type event
    :after-set (lambda () (search-bad-key))
    :group (focus cabinet bindings))

  (defcustom cabinet:advance-user-keybindings nil
    "Advance user keymap."
    :group (focus cabinet bindings)
    :after-set (lambda () (search-bad-key))
    :type boolean)

  (defcustom cabinet:mark-selected "Super-SPC"
    "Marked window as selected."
    :type event
    :after-set (lambda () (search-bad-key))
    :depends cabinet:advance-user-keybindings
    :group (focus cabinet bindings))

  (defcustom cabinet:advance-keybindings '(("Super-d" delete-window t none)
                                           ("Super-i" toggle-window-iconified t none)
                                           ("Super-m" maximize-window-toggle t none)
                                           ("Super-s" toggle-window-shaded t none)
                                           ("Super-f" maximize-window-fullscreen-toggle t none)
                                           ("Super-t" tab-add-maked-windows t none)
                                           ("C-d" delete-window t close)
                                           ("C-i" toggle-window-iconified t close)
                                           ("C-m" maximize-window-toggle t close)
                                           ("C-s" toggle-window-shaded t close)
                                           ("C-f" maximize-window-fullscreen-toggle t close)
                                           ("C-t" tab-add-maked-windows t close)
                                           ("M-d" delete-window t go-to-next)
                                           ("M-i" toggle-window-iconified t go-to-next)
                                           ("M-m" maximize-window-toggle t go-to-next)
                                           ("M-s" toggle-window-shaded t go-to-next)
                                           ("M-f" maximize-window-fullscreen-toggle t go-to-next)
                                           ("M-t" tab-add-maked-windows t go-to-next))
    nil
    :type* `(alist (event ,(_ "Key:"))
                   ((h-and (symbol 
                            delete-window maximize-window-toggle toggle-window-iconified toggle-window-shaded toggle-window-sticky
                            maximize-window-fullscreen-toggle maximize-window-horizontally-toggle maximize-window-vertically-toggle maximize-window-fullxinerama-toggle
                            tab-add-maked-windows tab-release-window tab-move-to-end tab-move-to-beginning tab-move-to-right tab-move-to-left
                            move-window-to-center move-window-to-top-left move-window-to-next-workspace move-window-to-previous-workspace
                            toggle-window-fixed-position toggle-window-fixed-size  toggle-window-never-focus toggle-window-ignored toggle-task-list-skip toggle-window-cycle-skip
                            toggle-window-list-skip toggle-desktop send-window-to-next-head send-window-to-previous-head
                            raise-window lower-window raise-window-depth lower-window-depth raise-lower-window
                            raise-window-and-transients raise-lower-window-and-transients delete-window-safely destroy-window
                            window-history-save-position window-history-save-dimensions window-history-save-attributes window-history-forget  
                            iconify-window uniconify-window shade-window unshade-window make-window-sticky make-window-unsticky
                            make-window-ignored make-window-not-ignored               
                            maximize-fill-window maximize-fill-window-horizontally maximize-fill-window-vertically 
                            ;; tab/titelbar-toggle tab/titelbar-to-top tab/titelbar-to-bottom tab/titelbar-to-right tab/titelbar-to-left 
                            ;; move-window-center move-window-up move-window-down 
                            ;; move-window-right move-window-left move-window-next move-window-previous 
                            ;; shrink-window-up shrink-window-down shrink-window-left shrink-window-right 
                            ;; yank-window-up yank-window-down yank-window-left yank-window-right
                            ;; size-window-add-column size-window-subtract-column size-window-add-row size-window-subtract-row 
                            ;; grow-window-up grow-window-down grow-window-left grow-window-right
                            ;; pack-window-up pack-window-down pack-window-right pack-window-left 
                            ;; double-window-size halve-window-size
                            ;; send-to-next-workspace send-to-previous-workspace send-to-workspace-left
                            ;; send-to-workspace-right send-to-workspace-up send-to-workspace-down
                            ;; maximize-window-fullscreen maximize-window-fullxinerama  
                            )
                           (label "After executed cabinet:")
                           (choice none close go-to-next)) ,(_ "Event")))
    :widget-flags (expand-vertically)
    :after-set (lambda () (search-bad-key))
    :depends cabinet:advance-user-keybindings
    :group (focus cabinet bindings))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; end defcustom

  (define (do-when-tabbed w do)
    "Action when W is tabbed."
    (when (window-tabbed-p w)
      (tab-refresh-group w do)
      (window-opacity w)))

  (define (window-tabbed-foreground-p w)
    "Returns t if W is a foreground tab"
    (if (window-tabbed-p w)
        (eq w (nth 0 (tab-group-windows-stacking-order w)))))

  (define (tabbgroup-is-shaded-p w)
    "Returns t if tabbgroup from W is shaded"
    (let ((shaded 't))
      (when (window-tabbed-p w)
        (mapcar (lambda (w)
                  (if (not (window-get w 'shaded)) (setq shaded nil))) (tab-group-windows w))
        shaded)))

  (define (cabinet-item-text w)
    "The text part shown on cabinet item"
    ;; if we remove a window we temporary need this if
    (if (not (numberp (window-id w)))
        "Window is gone"
      (concat (when (window-get w 'marked)
                " »»")
              (when (window-tabbed-p w)
                (if (window-tabbed-foreground-p w)
                    (if (eq cabinet:manipulation-on-selected 'None)
                        (format nil " [%s%s]" (tab-window-group-index w) '★)
                      (format nil " [%s]" (tab-window-group-index w)))
                  (format nil " [%s]" (tab-window-group-index w))))
              "  "
              (window-name w)
              "  ["
              (window-class-name w 1)
              "] "
              (when (or (> (car (window-viewport w)) 0)
                        (> (cdr (window-viewport w)) 0))
                (format nil " %s" (window-viewport w)))
              (when (window-get w 'workspaces)
                (format nil " %s" (window-get w 'workspaces)))
              ;;(when (window-sticky-p w)
              ;;  (format nil " ∘"))
              (if (and (window-maximized-vertically-p w)
                       (not (window-maximized-horizontally-p w)))
                  (format nil " ↕"))
              (if (and (window-maximized-horizontally-p w)
                       (not (window-maximized-vertically-p w)))
                  (format nil " ↔"))
              (when (window-maximized-p w)
                (if (or (tabbgroup-is-shaded-p w)
                        (and (not (window-tabbed-p w))
                             (window-shaded-p w)))
                    (format nil " ▾")))
              (when (window-get w 'marked)
                " ««"))))

  (define input-line-height (font-height default-font))
  (define cabinet-font-height input-line-height)
  (define wlist-for-manipulation nil)
  (define wlist-for-display nil)
  (define wlist-for-cabinet nil)
  (define cabinet-window nil)
  (define cabinet-orin-wlist)
  (define cabinet-orin-focus)
  (define cabinet-input "")
  (define cabinet-orin-workspace)
  (define workspace-mode)
  (define cabinet-filter-for-display-func)
  (define cabinet-filter-for-manipulation-func)
  (define cabinet-raise-timer nil)
  (define command-timer nil)
  (define bad-key nil)
  (define focus-by-tab nil)
  (define split-line-length nil)

  ;; item-format package
  (define (cabinet-item-text-format w)
    (let ((split-length (quotient (length (cabinet-item-text w)) 2)))
      (if (> split-length split-line-length)
          (if (> split-length 40)
              (setq split-line-length (- split-length 5))
            (setq split-line-length split-length))))
    (cons (cabinet-item-text w)
          (cond
           ((window-iconified-p w) cabinet:iconified-item-forground)
           ((window-maximized-p w) cabinet:maximized-item-forground)
           ((if (or (tabbgroup-is-shaded-p w)
                    (and (not (window-tabbed-p w))
                         (window-shaded-p w)))
                cabinet:shaded-item-forground))
           (t cabinet:default-item-forground))))

  (define (cabinet-item-format w)
    (let ((item (cons (if (window-icon-image w 32)
                          (window-icon-image w 32)
                        (require 'rep.io.files)
                        (if (file-exists-p (concat (car (cdr image-load-path)) "/" "cabinet-missing.png"))
                            (make-image (concat (cdr image-load-path) "cabinet-missing.png"))))
                      (cabinet-item-text-format w))))
      (lambda (tag)
        (cond
         ((eq tag 'icon) (car item))
         ((eq tag 'text) (cadr item))
         ((eq tag 'forground) (cdr (cdr item)))))))

  (define (make-item icon text forground)
    (lambda (tag)
      (cond
       ((eq tag 'icon) icon)
       ((eq tag 'text) text)
       ((eq tag 'forground) forground))))
  (define (get-item-icon item) (item 'icon))
  (define (get-item-text item) (item 'text))
  (define (get-item-forground item) (item 'forground))
  ;; end @ item format package 

  (define (cabinet-filter filter-list)
    (lambda (window)
      (let loop ((fow-nrl filter-list))
        (cond
         ((null fow-nrl) t)
         ((or (string-match (car fow-nrl) 
                            (window-name window)
                            0 nil)
              (string-match (car fow-nrl) 
                            (window-class-name window 1)
                            0 nil))
          nil)
         (t (loop (cdr fow-nrl)))))))

  (define (cabinet-split-line)
    (let ((length '0)
          line enil mode)
      (while (< length split-line-length) 
        (setq line (concat line "»")) 
        (setq enil (concat enil "«")) 
        (setq length (1+ length)))
      (setq mode (if workspace-mode
                     (format nil "%s/%s"
                             current-workspace
                             (cdr (workspace-limits)))
                   "ALL"))
      (make-item nil (format nil (concat line mode enil))
                 cabinet:split-line-forground)))

  (define (draw-items wl input-line)
    (when (x-window-p cabinet-window)
      (x-destroy-window cabinet-window)
      (setq cabinet-window nil))
    (let* ((wl-size (length wl))
           (cabinet-items wl)
           (item-height (max cabinet:icon-size
                             cabinet-font-height))
           (wx (+ (* 2 (car cabinet:margin))
                  cabinet:icon-size
                  (apply max
                         (mapcar text-width
                                 (cons input-line
                                       (mapcar get-item-text
                                               cabinet-items))))))
           (wy (+ (* 2 (cdr cabinet:margin))
                  (* wl-size item-height)
                  (* (- wl-size 1) cabinet:item-margin)
                  cabinet:input-line-margin
                  input-line-height))
           (win-size (cons wx wy)))
      (define (event-handler type xw)
        (define (cabinet-draw-text str pos foreground)
          (let ((gc (x-create-gc xw
                                 `((foreground . ,foreground)))))
            (x-draw-string xw gc pos str)
            ;; (x-destroy-gc gc)
            ))
        (x-clear-window wx type)
        ;; draw input line
        (cabinet-draw-text input-line
                           (cons (car cabinet:margin) (+ (cdr cabinet:margin)
                                                         cabinet-font-height))
                           cabinet:forground-input)
        ;; draw item text
        (let ((item-count 0)
              (item-height-with-margin (+ item-height
                                          cabinet:item-margin))
              (input-height-with-margin (+ input-line-height
                                           cabinet:input-line-margin)))
          (mapc (lambda (item)
                  (let* ((icon (get-item-icon item))
                         (text (get-item-text item))
                         (item-forground (get-item-forground item))
                         (icon-x (+ (car cabinet:margin)))
                         (icon-y (+ (cdr cabinet:margin)
                                    input-height-with-margin
                                    (* item-count
                                       item-height-with-margin)))
                         (text-x (+ icon-x
                                    cabinet:icon-size))
                         (text-y (+ icon-y
                                    (quotient cabinet-font-height 2)
                                    (quotient cabinet:icon-size
                                              3))))
                    (when icon
                      (x-draw-image icon xw
                                    (cons icon-x icon-y)
                                    (cons cabinet:icon-size cabinet:icon-size)))
                    (cabinet-draw-text text
                                       (cons text-x text-y)
                                       item-forground))
                  (setq item-count (+ 1 item-count)))
                cabinet-items))) ;; end of event-handler
      (setq cabinet-window
            (let ((head (if cabinet:display-cabinet-on-active (current-head) '0)))
              (x-create-window `(,(+ (car (head-offset head))
                                     (- (quotient (car (head-dimensions head)) 2)
                                        (quotient wx 2)))
                                 .
                                 ,(if (> (cdr win-size) (cdr (head-dimensions head)))
                                      '0
                                    (+ (cdr (head-offset head))
                                       (- (quotient (cdr (head-dimensions head)) 2)
                                          (quotient wy 2)))))
                               win-size
                               1
                               `((background . ,cabinet:background))
                               event-handler)))
      (x-map-window cabinet-window)
      cabinet-window))

  (define (display-bad-key)
    (display-message (concat "Cabinet:" "\n" "\n" bad-key "\n" "\nIs duplicate." "\nDisable cabinet.")
                     `((background . ,(get-color "Red")))))

  (define (search-bad-key)
    (setq bad-key nil)
    (let ((key-list (list cabinet:cycle cabinet:reversely-cycle cabinet:restore-order cabinet:toggle-workspace-mode
                          cabinet:exchange-manipulation cabinet:cycle-workspaces cabinet:cycle-reversely-workspaces)) key rest-list)
      (when cabinet:advance-user-keybindings
        (setq key-list (append key-list (list cabinet:mark-selected)))
        (setq key-list (append key-list 
                               (mapcar (lambda (w)
                                         (car w))
                                       cabinet:advance-keybindings))))
      (mapcar (lambda ()
                (setq rest-list (cdr key-list))
                (setq key (car key-list))
                (when (not (x-keysym-name (car (lookup-event key))))
                  (setq bad-key key)
                  (display-message (concat "Cabinet:" "\n" "\n" bad-key "\n" "\nIs not a valid x-keysym-name." "\nDisable cabinets.")
                                   `((background . ,(get-color "Red")))))
                (when (member key rest-list)
                  (setq bad-key key)
                  (display-bad-key))
                (setq key-list (cdr key-list)))
              key-list)))
  
  ;; keymap package
  (define (command-delay-timer)
    (setq command-timer
          (make-timer (lambda ()
                        (setq command-timer nil))
                      (quotient cabinet:command-repeat-timeout 1000) (mod cabinet:command-repeat-timeout 1000))))

  (define (update-cabinet-interface-add)
    (when (x-window-p cabinet-window)
      (setq wlist-for-manipulation
            (filter cabinet-filter-for-manipulation-func
                    (filter cabinet-filter-for-display-func
                            (stacking-order))))
      (setq wlist-for-display (filter (lambda (win)
                                        (not (cabinet-filter-for-manipulation-func win)))
                                      (stacking-order)))
      (if workspace-mode
          (update-on-workspace))
      (draw-cabinet)))

  (define (update-cabinet-interface-remove)
    (when (x-window-p cabinet-window)
      (let ((old-manipulation wlist-for-manipulation)
            (old-display wlist-for-display)
            new-manipulation new-display)
        (setq new-manipulation
              (filter cabinet-filter-for-manipulation-func
                      (filter cabinet-filter-for-display-func
                              (stacking-order))))
        (setq new-display (filter (lambda (win)
                                    (not (cabinet-filter-for-manipulation-func win)))
                                  (stacking-order)))
        (mapcar (lambda (w)
                  (if (not (member w new-manipulation))
                      (setq wlist-for-manipulation (remove w old-manipulation))))
                old-manipulation)
        (mapcar (lambda (w)
                  (if (not (member w new-display))
                      (setq wlist-for-manipulation (remove w old-display))))
                old-display)
        (if workspace-mode
            (update-on-workspace))
        (draw-cabinet))))

  (define (update-cabinet-interface #!optional next)
    (when (x-window-p cabinet-window)
      (when (not (null wlist-for-manipulation))
        (if (member next wlist-for-manipulation)
            (cabinet-switch-to-next)))
      (if workspace-mode
          (update-on-workspace))
      (draw-cabinet)))

  (define (cabinet-switch-to-next)
    (when cabinet-raise-timer
      (delete-timer cabinet-raise-timer)
      (setq cabinet-raise-timer nil))
    (when (not (null wlist-for-manipulation))
      (setq wlist-for-manipulation
            (append (cdr wlist-for-manipulation)
                    (list (car wlist-for-manipulation))))))
  
  (define (cabinet-switch-to-previous)
    (when cabinet-raise-timer
      (delete-timer cabinet-raise-timer)
      (setq cabinet-raise-timer nil))
    (when (not (null wlist-for-manipulation))
      (setq wlist-for-manipulation
            (let ((rl (reverse wlist-for-manipulation)))
              (list* (car rl) (reverse (cdr rl)))))))
  
  (define (erase-input)
    (setq cabinet-input ""))
  
  (define (with-draw cmd)  
    "If your cmd will change Cabinet's
appearances,then add it."
    (lambda ()
      (cmd)
      (draw-cabinet)))
  
  (define (with-new-wlist cmd)
    "If your cmd the number of items 
grow, then add it"
    (lambda ()
      (cmd)
      (setq wlist-for-manipulation
            (filter cabinet-filter-for-manipulation-func
                    (filter cabinet-filter-for-display-func
                            (stacking-order))))
      (setq wlist-for-display (filter (lambda (win)
                                  (not (cabinet-filter-for-manipulation-func win)))
                                (stacking-order)))))
  
  (define (with-update-on-input cmd)
    " It will filter items on input after
execution of cmd, add it when you feel proper."
    (lambda ()  
      (cmd)
      (cabinet-update-on-input)))
  
  (define (cabinet-update-on-input)
    "Same with `with-update-on-input',except that it's
a procedure with no argument."
    (setq wlist-for-manipulation
          (if (not (null wlist-for-manipulation))
              (filter (lambda (w)
                        (string-match cabinet-input
                                      (concat
                                       (window-name w)
                                       (window-class-name w))
                                      0 t))
                      wlist-for-manipulation))))
  
  (define (with-exit-and-clear-mark cmd)
    " Use it, when you decide to quit Cabinet after
your cmd's execution."
    (lambda ()
      (cmd)
      (mapc (lambda (w)
              (when (window-get w 'marked)
                (window-remprop w 'marked)
                (call-marked w)))
            cabinet-orin-wlist)
      (event-exit-wait)))

  (define (with-marked-wl cmd)
    "The marked windows will be passed to cmd as a list."
    (lambda ()
      (cmd (filter-windows (lambda (w)
                             (window-get w
                                         'marked))))))
  
  (define (with-selected cmd)
    "The selected window will be passed to cmd as an argument."
    (lambda ()
      (cmd (car wlist-for-manipulation))))
  
  (define (workspace-prev)
    (cycle-workspace -1))
  
  (define (workspace-next)
    (cycle-workspace 1))
  
  (define (cycle-workspace count)
    (with-draw
     (lambda ()
       ((with-update-on-input (with-new-wlist (lambda () t))))
       (if workspace-mode
           (next-workspace count)
         (setq workspace-mode t)
         (next-workspace count))
       (update-on-workspace))))
  
  (define (toggle-workspace-mode)
    (with-draw
     (lambda ()
       ((with-update-on-input (with-new-wlist (lambda () t))))
       (if workspace-mode
           (setq workspace-mode (not workspace-mode))
         (setq workspace-mode t)
         (update-on-workspace)))))

  (define (with-update-on-workspace cmd)
    "It filters items for current workspace windows.
add it, when your command changed workspace"
    (lambda ()
      (cmd)
      (update-on-workspace)))
  
  (define (update-on-workspace)
    " Same with `with-update-on-workspace',except that
this is a procedure with no argument."
    (setq wlist-for-manipulation
          (filter (lambda (w)
                    (let ((ww (window-get w 'workspaces)))
                      (or (memq current-workspace ww)
                          (eq ww nil)))) 
                  wlist-for-manipulation)))

  (define (update-on-bs cmd)
    "Update cabinets interface after backspce"
    (lambda ()
      (cmd)
      (if workspace-mode
          (update-on-workspace)
        (setq wlist-for-manipulation
              (filter cabinet-filter-for-manipulation-func
                      (filter cabinet-filter-for-display-func
                              (stacking-order)))))))

  (define (call-marked cmd)
    "Call marked hook if window marked"
    (call-window-hook 'window-state-change-hook cmd (list '(marked))))

  (define (get-last-workspace)
    (aref (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS)) 0))
  
  (defvar move-window-to-next-workspace
    (lambda (w)
      (unless (window-sticky-p w)
        (let ((nw (+ (car (window-get w 'workspaces)) 1)))
          (if (< nw (get-last-workspace))
              (send-window-to-workspace-from-first w nw))))))
  
  (defvar move-window-to-previous-workspace
    (lambda (w)
      (unless (window-sticky-p w)
        (let ((nw (- (car (window-get w 'workspaces)) 1)))
          (if (> nw '-1)
              (send-window-to-workspace-from-first w nw))))))


  (defvar move-window-to-top-left
    (lambda (w)
    (let ((dims (window-frame-dimensions w))
          (h-off (cons 0 0))
          (screen (calculate-workarea #:window w #:head '0)))
      (move-window-to w
                      (clamp* (car h-off)
                              (car dims) (nth 0 screen) (nth 2 screen))
                      (clamp* (cdr h-off)
                              (cdr dims) (nth 1 screen) (nth 3 screen)))
      (call-window-hook 'after-move-hook w))))

  (defvar move-window-to-center
    (lambda (w)
    (let ((dims (window-frame-dimensions w))
          (h-dims (current-head-dimensions w))
          (h-off (current-head-offset w))
          (screen (calculate-workarea #:window w #:head (current-head w))))
      (move-window-to w
                      (clamp* (+ (car h-off)
                                 (quotient (- (car h-dims) (car dims)) 2))
                              (car dims) (nth 0 screen) (nth 2 screen))
                      (clamp* (+ (cdr h-off)
                                 (quotient (- (cdr h-dims) (cdr dims)) 2))
                              (cdr dims) (nth 1 screen) (nth 3 screen)))
      (call-window-hook 'after-move-hook w))))
  
  (defvar tab-add-maked-windows
    (lambda ()
      (let* ((win (car wlist-for-manipulation))
             (tabs (remove win (filter-windows (lambda (w) (window-get w 'marked))))))
        (when (car tabs)
          (require 'sawfish.wm.tabs.tab)
          (window-remprop win 'marked)
          (mapcar (lambda (w)
                    (window-remprop w 'marked)
                    (tab-window-add-to-tabgroup w)
                    (tab-window-add-to-tabgroup win))
                  tabs)
            (set-input-focus nil)))))

  (define (run-cmd-and-do cmd do)
    (when (not command-timer)
      (command-delay-timer)
      (let ((win (car wlist-for-manipulation))
            (next (car (cdr wlist-for-manipulation))))
        (if (eq cmd 'tab-add-maked-windows)
            (tab-add-maked-windows)
          (if (and (filter-windows (lambda (w) (window-get w 'marked)))
                   cabinet:advance-user-keybindings)
              (mapcar (lambda (x)
                        (cmd x))
                      (filter-windows (lambda (w) (window-get w 'marked))))
            (cmd win)))
        (when (string= do "close")
          (mapc (lambda (w)
                  (when (window-get w 'marked)
                    (window-remprop w 'marked)
                    (call-marked w)))
                cabinet-orin-wlist)
          (event-exit-wait)
          (x-destroy-window cabinet-window)
          (display-window win))
        
        (when (string= do "none")
          (mapc (lambda (w)
                  (when (window-get w 'marked)
                    (window-remprop w 'marked)
                    (call-marked w)))
                cabinet-orin-wlist)
          (update-cabinet-interface))
        
        (when (string= do "go-to-next")
          (mapc (lambda (w)
                  (when (window-get w 'marked)
                    (window-remprop w 'marked)
                    (call-marked w)))
                cabinet-orin-wlist)
          (update-cabinet-interface next)))))

  (define (cabinet-keymap-complete)
    (let ((keymap-complete))
      (if bad-key
          (bind-keys (make-keymap) nil)
        (if (and cabinet:advance-user-keybindings
                 (car cabinet:advance-keybindings))
            (setq keymap-complete (append (cabinet-keymap-base) (cabinet-keymap-advance)))
          (setq keymap-complete (cabinet-keymap-base)))
        keymap-complete)))

  (define (cabinet-keymap-advance)
    (let ((keybind-list cabinet:advance-keybindings)
          keymap-list tmp)
      (mapcar (lambda (w)
                (setq tmp (list (car w) (list run-cmd-and-do (nth 1 w) (prin1-to-string (nth 3 w)))))
                (setq keymap-list (append keymap-list (cdr (bind-keys (make-keymap) (nth 0 tmp) (nth 1 tmp))))))
              keybind-list)
      keymap-list))

  (define (cabinet-keymap-base)
    (bind-keys (make-keymap)
               "RET" (with-exit-and-clear-mark
                      (with-selected
                       (lambda (w)
                         (display-window w))))
               "KP_Enter" (with-exit-and-clear-mark
                           (with-selected
                            (lambda (w)
                              (display-window w))))
               "SPC" (with-draw
                      (with-update-on-input
                       (lambda ()
                         (setq cabinet-input
                               (concat cabinet-input " ")))))
               "BS" (with-draw
                     (with-update-on-input
                      (update-on-bs
                       (with-new-wlist
                        (lambda ()
                          (when (> (length cabinet-input) 0)
                            (setq cabinet-input
                                  (substring cabinet-input
                                             0
                                             (1- (length cabinet-input))))))))))
               cabinet:cycle (with-draw cabinet-switch-to-next)
               cabinet:reversely-cycle (with-draw cabinet-switch-to-previous)
               cabinet:restore-order (with-exit-and-clear-mark 
                                      (lambda ()
                                        (select-workspace cabinet-orin-workspace)
                                        (restack-windows cabinet-orin-wlist)
                                        (set-input-focus cabinet-orin-focus)
                                        (when (and focus-by-tab 
                                                   (numberp (window-id focus-by-tab)))
                                          (do-when-tabbed focus-by-tab 'focus)
                                          (setq focus-by-tab nil))))
               cabinet:exchange-manipulation (with-draw
                                              (with-update-on-input
                                               (lambda ()
                                                 (let ((tmp wlist-for-manipulation))
                                                   (setq wlist-for-manipulation wlist-for-display
                                                         wlist-for-display tmp)))))
               cabinet:toggle-workspace-mode (toggle-workspace-mode)
               cabinet:cycle-workspaces (workspace-next)
               cabinet:cycle-reversely-workspaces (workspace-prev)
               cabinet:mark-selected (when cabinet:advance-user-keybindings
                                       (with-draw
                                        (with-selected
                                         (lambda (w)
                                           (window-put w 'marked
                                                       (not (window-get w 'marked)))
                                           (call-marked w)))))))
  ;; end @ keymap package
  (define (draw-cabinet)
    (let ((w (car wlist-for-manipulation)))
      (when (not (null wlist-for-manipulation))
        (when (eq cabinet:manipulation-on-selected 'Raise)
          (setq cabinet-raise-timer
                (make-timer (lambda ()
                              (raise-window w)
                              (do-when-tabbed w 'raise))
                            (quotient cabinet:raise-window-timeout 1000) (mod cabinet:raise-window-timeout 1000))))
        (when (eq cabinet:manipulation-on-selected 'Focus)
          (setq cabinet-raise-timer
                (make-timer (lambda ()
                              (raise-window w)
                              (set-input-focus w))
                            (quotient cabinet:raise-window-timeout 1000) (mod cabinet:raise-window-timeout 1000))))
        (when (eq cabinet:manipulation-on-selected 'None) 
          (set-input-focus nil)))
      (setq split-line-length nil)
      (draw-items (append (mapcar cabinet-item-format wlist-for-manipulation)
                          (list (cabinet-split-line))
                          (mapcar cabinet-item-format wlist-for-display))
                  (concat cabinet-input "_"))))
  
  (defvar cabinet-handler
    `((,(lambda (key) (= 1 (length key)))
       .
       ,(lambda (key)
          (setq cabinet-input (concat cabinet-input key))
          (cabinet-update-on-input)
          (draw-cabinet)))))

  (define (unbound-check)
    (if bad-key
        (progn (display-bad-key)
               nil)
      (display-message nil)
      't))

  (define (cabinet-switch)
    "Start cabinet switch."
    (if bad-key
        (display-bad-key)
      (when (and (input-focus) 
                 (window-tabbed-p (input-focus))
                 (eq cabinet:manipulation-on-selected 'Raise))
          (set-input-focus nil)
          (setq focus-by-tab (input-focus)))
      (setq cabinet-orin-wlist (stacking-order)
            cabinet-orin-focus (input-focus)
            cabinet-input ""
            cabinet-orin-workspace current-workspace
            workspace-mode cabinet:workspace-mode-on-initial
            cabinet-filter-for-display-func
            (cabinet-filter cabinet:filter-out-from-display)
            cabinet-filter-for-manipulation-func
            (cabinet-filter cabinet:filter-out-for-manipulation)
            wlist-for-cabinet (filter cabinet-filter-for-display-func
                                      (stacking-order))
            wlist-for-manipulation (filter cabinet-filter-for-manipulation-func
                                           wlist-for-cabinet)
            wlist-for-display (filter (lambda (win)
                                        (not (cabinet-filter-for-manipulation-func win)))
                                      wlist-for-cabinet))
      (when workspace-mode
        (update-on-workspace))
      (when cabinet:cycle-as-start
        (cabinet-switch-to-next))
      (draw-cabinet)
      (event-wait-for #:keymap (cabinet-keymap-complete)
                      #:handler cabinet-handler
                      #:loop-on-unbound (unbound-check))
      (x-destroy-window cabinet-window)))

  (search-bad-key)

  (unless batch-mode
    (add-hook 'tab-group-windows-hook update-cabinet-interface)
    (add-hook 'before-add-window-hook update-cabinet-interface-add)
    (add-hook 'destroy-notify-hook update-cabinet-interface-remove))

  (define-command 'cabinet-switch cabinet-switch))

;; nokogiri-widgets/file.jl -- file name widget
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.file

    (export )

    (open rep
	  rep.io.files
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (make-file-item changed-callback)
    (let* ((button (gtk-file-chooser-button-new '() 'open)))

      (when changed-callback
	(g-signal-connect
	 button "file-set" (make-signal-callback changed-callback)))

      (gtk-widget-show button)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-file-chooser-select-filename button (or (and (file-exists-p x) x) ""))))
	  ((clear) (lambda ()
		     (gtk-file-chooser-select-filename button "")))
	  ((ref) (lambda () (gtk-file-chooser-get-filename button)))
	  ((gtk-widget) button)
	  ((validp) (lambda (x) (stringp x)))))))

  (define-widget-type 'file make-file-item))

;; x-cycle.jl -- stack-based window cycling

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;; Commentary:

;; Cycles through windows in MRU order. Whichever key is used to invoke
;; `cycle-windows' will continue to the next window on the stack when
;; pressed again. Releasing the initial modifier ends the cycling and
;; selects the current window

;; Thanks to Kuba Winnicki <blackwine@optimus.wroc.pl> for the idea:

;; [ assumes command invoked by MOD-KEY, i.e. M-TAB by default ]

;; MOD held;

;; * window 1            window 1            window 1          * window 3
;;   window 2    ==>   * window 2    ==>     window 2    ==>     window 1
;;   window 3    KEY     window 3    KEY   * window 3  release   window 2
;;   window 4            window 4            window 4    MOD     window 4

;; If cycle-raise-windows is enabled, focused window is brought to
;; front, but gets back to original placement in order when it's
;; defocused.

;; Also it'd be nice to be able to cycle through hidden windows as
;; well, like here:

;; MOD held;

;; * window 1            window 1            window 1          * window 3
;;  [window 2]   ==>   * window 2    ==>    [window 2]   ==>     window 1
;;  [window 3]   KEY    [window 3]   KEY   * window 3  release  [window 2]
;;   window 4            window 4            window 4    MOD     window 4

;; Each window may have an x-cycle-order property, an integer id
;; defining its position in the window stack, higher numbers equal
;; more recently selected. The ids may not be contiguous

;; Obviously there would be a problem when we overflow rep's integers, but
;; every now and then we compress the stack to make the ids contiguous

;; It might seem as though it should be possible to use the actual
;; window stacking to define MRU order. But since there are multiple
;; layers of windows this wouldn't work (selected windows may not reach
;; the top of the stack)

(define-structure sawfish.wm.commands.x-cycle

    (export define-cycle-command
	    define-cycle-command-pair)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.util.window-order
	  sawfish.wm.util.keymap
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.focus
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.util.stacking
	  sawfish.wm.events
	  sawfish.wm.util.decode-events
	  sawfish.wm.util.groups
	  sawfish.wm.util.rects
	  sawfish.wm.util.display-window)

  (define-structure-alias x-cycle sawfish.wm.commands.x-cycle)

  ;; we bind to disable-auto-raise and tooltips-enabled
  (eval-when-compile (require 'sawfish.wm.ext.auto-raise))
  (eval-when-compile (require 'sawfish.wm.ext.tooltips))

;;; customization options

  ;;###autoload (defgroup cycle "Window Cycling" :group focus :require sawfish.wm.commands.x-cycle)
  (defgroup cycle "Window Cycling"
    :group focus
    :require sawfish.wm.commands.x-cycle)

  (defcustom cycle-show-window-names t
    "Display window names and icons while cycling through windows."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-include-iconified t
    "Include iconified windows when cycling."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-all-workspaces nil
    "Include windows on all workspaces when cycling."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-all-viewports nil
    "Include windows on all viewports when cycling."
    :group (focus cycle)
    :type boolean)

  (defcustom cycle-raise-windows t
    "Raise windows while they're temporarily selected during cycling."
    :type boolean
    :group (focus cycle))

  (defcustom cycle-keymap (make-keymap)
    "Keymap containing bindings active only during window cycling operations."
    :group bindings
    :type keymap)

  (defvar after-cycle-step-hook '()
    "Window hook called after each step of window cycling.")

  ;; variables

  ;; the current window
  (define x-cycle-current (make-fluid))

  ;; the original stacking order
  (define x-cycle-stacking (make-fluid))

  ;; the list of windows being cycled through
  (define x-cycle-windows (make-fluid))

  ;; is this call during a cycle operation
  (define x-cycle-active (make-fluid))

  ;; list of all cycle command names
  (define cycle-commands '())

;;; code

  (define (forwards lst elt count)
    (let ((total (length lst))
	  (current (let loop ((rest lst) (i 0))
                        (cond ((null rest) 0)
                              ((eq (car rest) elt) i)
                              (t (loop (cdr rest) (1+ i)))))))
      (nth (mod (+ current count) total) lst)))

  (define (cycle-display-message)
    (require 'sawfish.wm.util.display-wininfo)
    (display-wininfo (fluid x-cycle-current)))

  (define (remove-message)
    (require 'sawfish.wm.util.display-wininfo)
    (display-wininfo nil))

  (define (cycle-next windows count)
    (fluid-set x-cycle-windows windows)
    (let ((win (window-order (if cycle-all-workspaces
                                 nil
                               current-workspace)
                             cycle-include-iconified cycle-all-viewports)))
      (setq win (delete-if (lambda (w)
                             (not (memq w windows))) win))
      (unless win
        (throw 'x-cycle-exit t))
      (if (fluid x-cycle-current)
          (when (or (window-get (fluid x-cycle-current) 'iconified)
                    (not (window-appears-in-workspace-p
                          (fluid x-cycle-current) current-workspace)))
            (hide-window (fluid x-cycle-current)))
        ;; first call, push the currently focused window onto
        ;; the top of the stack
        (when (input-focus)
          (fluid-set x-cycle-current (input-focus))
          (window-order-push (fluid x-cycle-current))
          (setq win (cons (fluid x-cycle-current)
                          (delq (fluid x-cycle-current) win)))))
      (when (fluid x-cycle-stacking)
        (restack-windows (fluid x-cycle-stacking))
        (fluid-set x-cycle-stacking nil))
      (if (fluid x-cycle-current)
          (setq win (forwards win (fluid x-cycle-current) count))
        (setq win (car win)))
      (fluid-set x-cycle-current win)
      (when (not (window-get win 'sticky))
        (select-workspace (nearest-workspace-with-window
                           win current-workspace)))
      (move-viewport-to-window win)
      (when (window-get win 'iconified)
        (show-window win))
      (when cycle-raise-windows
        (fluid-set x-cycle-stacking (stacking-order))
        (raise-window* win)
	(warp-pointer-if-necessary win))
      (when cycle-show-window-names
        (cycle-display-message))
      (when (window-really-wants-input-p win)
        (set-input-focus win))
      (allow-events 'sync-keyboard)
      (call-window-hook 'after-cycle-step-hook win)))

  (define (cycle-begin windows step)
    "Cycle through all windows in order of recent selections."
    (let ((tail-command nil)
	  (grab-win (input-focus)))
      (let-fluids ((x-cycle-current nil)
		   (x-cycle-stacking nil)
		   (x-cycle-windows windows)
		   (x-cycle-active t))

        (define (unmap-fun w)
          (when (eq w grab-win)
            (setq grab-win nil)
            (or (grab-keyboard nil nil t)
                (throw 'x-cycle-exit nil))
            (allow-events 'sync-keyboard)))

        (define (enter-fun space)
          (declare (unused space))
          (when grab-win
            (setq grab-win nil)
            (or (grab-keyboard nil nil t)
                (throw 'x-cycle-exit nil))
            (allow-events 'sync-keyboard)))

        (define (unbound-fun)
          (let* ((event (current-event))
                 (ev (decode-event event)))
            (cond
             ((memq 'release (nth 1 ev)) ; key released
              (when (and (modifier-keysym-p (nth 2 ev)) ; modifier released
                         (eq 2 (length (nth 1 ev))))    ; 'release + 1 modifier
                (throw 'x-cycle-exit t)))
             ((not (modifier-keysym-p (nth 2 ev)))
              ;; real key pressed
              (let* ((override-keymap cycle-keymap)
                     (command (lookup-event-binding event)))
                (unless command
                  ;; search cycle-keymap then the usual ones
                  (setq override-keymap nil)
                  (setq command (lookup-event-binding event)))
                (if (memq command cycle-commands)
                    ;; call without aborting cycle operation
                    (progn
                      (current-event-window (fluid x-cycle-current))
                      (call-command command))
                  (unless (setq tail-command command)
                    ;; no wm binding, so forward the event to
                    ;; the focused window (this is why we have
                    ;; to grab the keyboard synchronously)
                    (allow-events 'replay-keyboard))
                  (throw 'x-cycle-exit nil)))))))

        (let* ((decoded (decode-event (current-event)))
               (eval-modifier-events t)
               (eval-key-release-events t)
               (override-keymap (make-keymap))
               (focus-dont-push t)
               (disable-auto-raise t)
               (tooltips-enabled nil)
               (unmap-notify-hook (cons unmap-fun unmap-notify-hook))
               (enter-workspace-hook (cons enter-fun enter-workspace-hook))
               (unbound-key-hook (list unbound-fun)))

          (unless (and (eq 'key (car decoded)) (nth 1 decoded))
            (error "%s must be bound to a key event with modifiers."
                   this-command))

          ;; grab synchronously, so that event replaying works
          (when (grab-keyboard grab-win nil t)
            (unwind-protect
                (progn
                  (catch 'x-cycle-exit
                    ;; do the first step
                    (cycle-next windows step)
		    ;; Record current time + 0.1 sec.
                    (setq focus-xcycle-timestamp
			  (cons (current-time)
				(+ 100000 (current-utime))))

                    (recursive-edit))
                  (when (fluid x-cycle-current)
                    (display-window (fluid x-cycle-current))))
              (remove-message)
              (ungrab-keyboard)))))

      (when tail-command
	;; make sure that the command operates on the newly-focused
	;; window, not the window that was focused when the original
	;; event was received
	(current-event-window (input-focus))
	(call-command tail-command))))

  (define (define-cycle-command name body . rest)
    "Create a command that will not cause the current cycle operation
to abort before execution.

All arguments are passed to define-command."
    (unless (memq name cycle-commands)
      (setq cycle-commands (cons name cycle-commands)))
    (apply define-command name body rest))

  (define (define-cycle-command-pair forward-name reverse-name selector . rest)
    "Create a pair of commands for cycling through windows. The command named
FORWARD-NAME cycles forwards, while the command named REVERSE-NAME cycles
backwards.

SELECTOR is called when initializing the cycle environment, it should
return the list of windows to cycle through, or the symbol `t' to
denote all cyclable windows.

Any extra arguments are passed to each call to define-command."
    (define (command-body step)
      (lambda args
	(let ((windows (apply selector args)))
	  (when windows
	    (if (fluid x-cycle-active)
		(cycle-next windows step)
	      (cycle-begin windows step))))))
    (when forward-name
      (apply define-cycle-command forward-name (command-body +1) rest))
    (when reverse-name
      (apply define-cycle-command reverse-name (command-body -1) rest)))

;;; commands

  (define-cycle-command-pair
    'cycle-windows 'cycle-windows-backwards
    (lambda () (filter-windows window-in-cycle-p)))

  (define-cycle-command-pair
    'cycle-group 'cycle-group-backwards
    (lambda (w)
      (delete-if-not window-in-cycle-p (windows-in-group w)))
    #:spec "%W")

  (define-cycle-command-pair
    'cycle-among-groups 'cycle-among-groups-backwards
    (lambda ()
      "Only cycle the top members of each group."
      (let loop
	  ((wl (window-order
		(if cycle-all-workspaces
		    nil
		  current-workspace)
		cycle-include-iconified cycle-all-viewports))
	   grps
	   retval)
	(when (and (window-in-cycle-p (car wl))
		   (not (memq (window-group-id (car wl)) grps)))
	  (when (window-group-id (car wl))
	    ;; Some windows don't have group.
	    (setq grps (cons (window-group-id (car wl)) grps)))
	  (setq retval (cons (car wl) retval)))
	(if (cdr wl)
	    (loop (cdr wl) grps retval)
	  (nreverse retval)
	  ))))

  (define-cycle-command-pair
    'cycle-prefix 'cycle-prefix-backwards
    (lambda (w)
      (when (string-match "^([^:]+)\\s*:" (window-name w))
        (let* ((prefix (expand-last-match "\\1"))
               (re (concat ?^ (quote-regexp prefix) "\\s*:")))
          (delete-if-not window-in-cycle-p
                         (filter-windows
                          (lambda (x)
                            (string-match re (window-name x))))))))
    #:spec "%W")

  (define-cycle-command-pair
    'cycle-class 'cycle-class-backwards
    (lambda (w)
      (let ((class (window-class w)))
        (delete-if-not window-in-cycle-p
                       (filter-windows
                        (lambda (x) (equal (window-class x) class))
                        (window-order)))))
    #:spec "%W")

  (define-cycle-command-pair
    'cycle-step 'cycle-step-backwards
    (lambda ()
      (if (fluid x-cycle-active)
          (fluid x-cycle-windows)
        (error "%s must be bound to a key event in the cycle keymap."
               this-command))))

  (define-cycle-command-pair
    'cycle-dock 'cycle-dock-backwards
    (lambda ()
      (delete-if-not (lambda (x) (window-in-cycle-p x #:ignore-cycle-skip t))
                     (filter-windows dock-window-p)))))

#| autoload cookies:

###autoload (autoload-command 'cycle-windows 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-windows-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-group 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-group-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-among-groups 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-among-groups-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-prefix 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-prefix-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-class 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-class-backwards 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-dock 'sawfish.wm.commands.x-cycle)
###autoload (autoload-command 'cycle-dock-backwards 'sawfish.wm.commands.x-cycle)

|#

#| doc strings for the cycle commands:

::doc:sawfish.wm.commands.x-cycle#cycle-windows::
Cycle through all windows in order of recent selections.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-windows-backwards::
Cycle through all windows in reverse order of recent selections.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-group::
Cycle through all windows in the same group as the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-group-backwards::
Reverse cycle through all windows in the same group as the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-among-groups::
Cycle through different groups (only the top window of each group).
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-among-groups-backwards::
Reverse cycle through different groups (only the top window of each group).
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-prefix::
Cycle through all windows whose names match the leading colon-delimited
prefix of the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-prefix-backwards::
Reverse cycle through all windows whose names match the leading
colon-delimited prefix of the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-class::
Cycle through all windows with the same class as the current window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-class-backwards::
Reverse cycle through all windows with the same class as the current
window.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-step::
Step one window forwards through the current window cycle list.
This command should only be used in the cycle keymap.
::end::

::doc:sawfish.wm.commands.x-cycle#cycle-step-backwards::
Step one window backwards through the current window cycle list.
This command should only be used in the cycle keymap.
::end::

|#

;; pancake.jl -- pancake integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.pancake

  (export start-pancake
          stop-pancake)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
	rep.io.files
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias pancake sawfish.wm.prg.pancake)

  (define %pancake-proc nil)

  (defcustom init-pancake nil
    "Whether to start pancake with Sawfish."
    :type boolean
    :group (misc apps))

  (defcustom pancake-config (concat (getenv "HOME") "/.pancakerc")
    "pancake configuration file to use."
    :type file
    :depends init-pancake
    :group (misc apps))

  (define (start-pancake #!key (config pancake-config))
    "Start pancake. If a pancake process already exists, it's beeing killed.
     Configuration-file may be passed, if not, $HOME/.pancakerc is used."
    (if (program-exists-p "pancake")
        (progn
	  (when %pancake-proc (kill-process %pancake-proc))
          (setq %pancake-proc (make-process))
          (if (file-exists-p config)
	      (start-process %pancake-proc "pancake" "-c" config)
	    (display-message (format nil "given configuration filie does not exist."))))
      (display-message (format nil "pancake executable not found in PATH."))))

  (define (stop-pancake)
    "Stop pancake, if running."
    (when %pancake-proc
      (kill-process %pancake-proc)
      (setq %pancake-proc nil))))

;; stagger-placement.jl -- for jwz

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.placement.stagger

    (export )

    (open rep
          sawfish.wm.windows
          sawfish.wm.misc
          sawfish.wm.events
          sawfish.wm.placement
          sawfish.wm.custom
          sawfish.wm.util.workarea)

  (defcustom stagger-placement-step 32
    "Distance between successive placements in `stagger' placement mode."
    :type number
    :range (1)
    :group (misc placement))

  (define place-window-stagger
    (let ((last-x 0)
	  (last-y 0))
      (lambda (w)
	(let ((dims (window-frame-dimensions w))
	      (workarea (calculate-workarea #:window w)))
	  (setq last-x (+ last-x stagger-placement-step))
	  (setq last-y (+ last-y stagger-placement-step))
	  (when (>= (+ last-x (car dims)) (nth 2 workarea))
	    (setq last-x (nth 0 workarea)))
	  (when (>= (+ last-y (cdr dims)) (nth 3 workarea))
	    (setq last-y (nth 1 workarea)))
	  (move-window-to w last-x last-y)))))

  ;;###autoload
  (define-placement-mode 'stagger place-window-stagger #:for-normal t))

;; mxflat/mxflat.jl
;;
;; theme.jl for mxflat (v0.7.3) sawfish theme
;;
;; Copyright (C) 2002 mx & ta
;;
;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 2 of the
;; License, or (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;; authors: mx (email) & ta (dev.null@gmx.net)

(require 'gradient)
;; need hash tables for icon cache
(require 'rep.data.tables)
(require 'rep.io.timers)
(require 'sawfish.wm.util.recolor-image)

;; required when gaoling is turned off (for debugging)
;;(require 'rep.mmsystem)
;;(require 'sawfish.wm.custom)
;;(require 'sawfish.wm.colors)
;;(require 'sawfish.wm.images)
;;(require 'sawfish.wm.fonts)

;;  ---------
;;; REDRAWING
;;  ---------

;;
;; redrawing:internal vars
;;

;; we need to define theme here
;; so we can reach them from our defcustom clauses

;; cache for window icons
(defvar icon-cache (make-weak-table eq-hash eq))

;; holds the shadow side for the current selected option
(defvar shadow-side nil)

;; for now empty, see below
(define (recolor-all))

;;
;; redrawing:functions
;;

(define (get-symbol #!rest strings)
  (intern (mapconcat identity strings "")))

(define (check-symbol #!rest strings)
  (let ((name (intern (mapconcat identity strings ""))))
    (if (boundp name)
        (symbol-value name)
      nil)))

(define (refresh-one-frame w)
  (if (eq (window-get w 'current-frame-style) 'mxflat)
      (refresh-window w)))

(define (refresh-all-frames)
  (map-windows refresh-window))

(define (rebuild-all-frames)
  (rebuild-frames-with-style 'mxflat))

;; same as rebuild but this also deletes the icon cache
(define (recreate-all-frames)
  (reframe-windows-with-style 'mxflat))

;; after the light source direction is updated we have to destroy the cache
;; with the correct shadow sides, it will be recreated on next access
(define (after-set-shadow-light-source)
  (setq shadow-side nil)
  (recreate-all-frames))

(define update-interval nil)
(define update-timer
  (make-timer (lambda ()
                (refresh-all-frames)
                (if update-interval
                    (set-timer update-timer update-interval)))))

(define (after-set-title-periodic-update)
  (if (check-symbol "mxflat:title-periodic-update")
      (set-timer update-timer update-interval)
    (delete-timer update-timer)))

(define (after-set-title-update-interval)
  (setq update-interval (check-symbol "mxflat:title-update-interval"))
  (after-set-title-periodic-update))

(define (recreate-all-frames-clear-cache)
  ;; reset icon cache
  (setq icon-cache (make-weak-table eq-hash eq))
  (recreate-all-frames))

(define (recreate-all-frames-recolor-all)
  (recolor-all)
  (recreate-all-frames))

;;  -------------
;;; CONFIGURATION
;;  -------------

;;
;; configuration:keymaps
;;

;; we need to define our default keymaps here,
;; so we can reach them from our defcustom clauses

(defvar sticky-button-keymap
  (bind-keys (make-keymap)
             "Button1-Off" 'toggle-window-sticky))

(defvar previous-button-keymap
  (bind-keys (make-keymap)
             "Button3-Off" '(command-sequence
                             `((send-to-workspace
                                ,(1+ (car (workspace-limits))))
                               (activate-workspace
                                ,(1+ (car (workspace-limits))))))
             "Button2-Click" 'popup-workspace-list
             "Button1-Off" 'send-to-previous-workspace))

(defvar next-button-keymap
  (bind-keys (make-keymap)
             "Button3-Off" '(command-sequence
                             `((send-to-workspace
                                ,(1+ (cdr (workspace-limits))))
                               (activate-workspace
                                ,(1+ (cdr (workspace-limits))))))
             "Button2-Click" 'popup-workspace-list
             "Button1-Off" 'send-to-next-workspace))

(defvar configure-button-keymap
  (bind-keys (make-keymap)
             "Button1-Off" 'customize
             "Button3-Off" '(call-command
                             (lambda ()
                               (if mxflat:custom-title
                                   (setq mxflat:custom-title nil)
                                 (setq mxflat:custom-title t))
                               ;;(reframe-windows-with-style 'mxflat)
                               (map-windows refresh-window)))))

(defvar always-on-top-button-keymap
  (bind-keys (make-keymap)
             "Button1-Off" '(call-command
                             (lambda ()
                               (if (> (window-get (current-event-window)
                                                  'depth)
                                      0)
                                   (window-put (current-event-window)
                                               'depth 0)
                                 (window-put (current-event-window)
                                             'depth
                                             mxflat:always-on-top-depth))
                               (reframe-window (current-event-window))))))

(defvar lock-button-keymap
  (bind-keys (make-keymap)
             "Button1-Off" '(call-command
                             (lambda ()
                               (if (window-get (current-event-window)
                                               'fixed-position)
                                   (window-put (current-event-window)
                                               'fixed-position nil)
                                 (window-put (current-event-window)
                                             'fixed-position t))
                               (reframe-window (current-event-window))))))


;;
;; configuration:groups
;;

;; there are just too many options
;; so we put them into several groups/tabs
(defgroup mxflat:group
  "mxflat"
  :group appearance)

(defgroup mxflat:title-group
  "title"
  :group (appearance mxflat:group))

(defgroup mxflat:title-basic-group
  "basic"
  :group (appearance mxflat:group mxflat:title-group))

(defgroup mxflat:title-gradient-group
  "gradient"
  :group (appearance mxflat:group mxflat:title-group))

(defgroup mxflat:title-colors-group
  "colors"
  :group (appearance mxflat:group mxflat:title-group))

(defgroup mxflat:buttons-group
  "buttons"
  :group (appearance mxflat:group))

(defgroup mxflat:buttons-basic-group
  "basic"
  :group (appearance mxflat:group mxflat:buttons-group))

(defgroup mxflat:buttons-positions1-group
  "positions 1"
  :group (appearance mxflat:group mxflat:buttons-group))

(defgroup mxflat:buttons-positions2-group
  "positions 2"
  :group (appearance mxflat:group mxflat:buttons-group))

(defgroup mxflat:buttons-keymaps1-group
  "keymaps 1"
  :group (appearance mxflat:group mxflat:buttons-group))

(defgroup mxflat:buttons-keymaps2-group
  "keymaps 2"
  :group (appearance mxflat:group mxflat:buttons-group))

(defgroup mxflat:button-colors-group
  "colors"
  :group (appearance mxflat:group mxflat:buttons-group))

(defgroup mxflat:border-group
  "borders"
  :group (appearance mxflat:group))

(defgroup mxflat:border1-group
  "basic"
  :group (appearance mxflat:group mxflat:border-group))

(defgroup mxflat:border-extended-group
  "extended"
  :group (appearance mxflat:group mxflat:border-group))

(defgroup mxflat:border-colors-group
  "colors"
  :group (appearance mxflat:group mxflat:border-group))


;;
;; configuration:title-basic
;;

(defcustom mxflat:decoration-mode
  'normal
  "decoration mode"
  :tooltip "Set the mode 'when to draw a titlebar and window \
buttons'.  The decoration mode 'all' means that all windows, even \
transients/dialogs, will get a titlebar and buttons.  None means no \
window will get any :-).  Usually transients only have a \
contents-border.  This option is for reimplementing a sawfish feature \
that is gone in the latest version."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type symbol
  :options (normal all none)
  :after-set recreate-all-frames)

(defcustom mxflat:title-height
  16
  "titlebar height (9 - 1000 pixel)"
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type (number 9 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:custom-title
  nil
  "customize title string"
  :tooltip "See the tooltip for the 'title string' option below for \
more information.  (NOTE: I hope the redrawing problems with this \
option are solved.  If not, write an email please!)"
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type boolean
  :after-set refresh-all-frames)

(defcustom mxflat:title-string
  "$fullname |$widthx$height-($x-pos,$y-pos)@$current-ws/$last-ws-$(DISPLAY)"
  "title string"
  :tooltip "The string you insert here will be your new title \
string.  Variables always start with a dollar-sign ($) and are \
replaced with their actual values.  To get the value of an environment \
variable use $(variable), eg $(DISPLAY).  To get the value of an \
rep/sawfish function use $[fuction], eg $[current-time-string].  The \
following vars are built-in: $name, $fullname, $width, $width-content, \
$height, $height-content, $depth, $x-pos, $y-pos, $current-ws and \
$last-ws. (NOTE: I hope the redrawing problems with this option are \
solved.  If not, write an email please!"
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type string
  :depends mxflat:custom-title
  :after-set refresh-all-frames)

(defcustom mxflat:title-periodic-update
  nil
  "update title string periodically"
  :tooltip "This is useful if your title string changes without user \
interaction (eg because it displays the current time or something like \
that)."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type boolean
  :depends mxflat:custom-title
  :after-set after-set-title-periodic-update)

(defcustom mxflat:title-update-interval
  1000
  "title string update interval (1 - 1000000 s)"
  :tooltip "This is useful if your title string changes without user \
interaction (e.g., because it displays the current time or something \
like that)."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type (number 1 1000000)
  :depends mxflat:custom-title
  :after-set after-set-title-update-interval)

(defcustom mxflat:title-font default-font
  "title string font"
  :tooltip "You should really choose a better font.  Verdana bold 8 \
pt looks nice."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type font
  :after-set rebuild-all-frames)

(defcustom mxflat:customize-title-position
  nil
  "customize title position"
  :tooltip "By default the title string is centered horizontally and \
vertically."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type boolean
  :after-set rebuild-all-frames)

(defcustom mxflat:title-x-justify
  'center
  "title string horizontal alignment"
  :tooltip "'real-center' means to take the whole titlebar into \
account while centering the string. When selecting 'center' only the \
distance between the buttons is taken into account."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type symbol
  :depends mxflat:customize-title-position
  :options (left center real-center right)
  :after-set rebuild-all-frames)

(defcustom mxflat:title-x-adjustment
  0
  "title string horizontal align adjustment (-10000 - 10000 pixel)"
  :tooltip "The horizontal position of the title string can only be \
adjusted if the horizontal alignment is not 'center'.  The range also \
depends on the setting of the option above.  It the title string is \
already aligned left, you cannot adjust it to be even further left \
because there are button in the way."
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type (number -10000 10000)
  :depends mxflat:customize-title-position
  :after-set rebuild-all-frames)

(defcustom mxflat:title-y-justify
  'center
  "title string vertical alignment"
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type symbol
  :depends mxflat:customize-title-position
  :options (top center bottom)
  :after-set rebuild-all-frames)

(defcustom mxflat:title-y-adjustment
  0
  "title string vertical align adjustment (-10000 - 10000 pixel)"
  :group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
  :type (number -10000 10000)
  :depends mxflat:customize-title-position
  :after-set rebuild-all-frames)

;;
;; configuration:title-gradient
;;

(defcustom mxflat:title-gradient
  nil
  "gradient titlebar background (experimental)"
  :tooltip "When activating the gradient background the normal \
titlebar background colors will be ignored.  Besides the button \
background colors will be ignored.  (NOTE: This can be very cpu \
intensive if you set the quality to a low value, i.e., high quality.)"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:gradient-direction
  'horizontal
  "gradient mode"
  :tooltip "With gradient mode vertical or diagonal only the first \
or last (reversed) 2 colors in the list are used."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :options (none horizontal vertical diagonal)
  :depends mxflat:title-gradient
  :type symbol
  :after-set recreate-all-frames
  )

(defcustom mxflat:gradient-scale
  3
  "gradient quality (1 best - 20 worst)"
  :tooltip "The value here is the factor the calculated gradient image \
will be scaled down.  This increases speed but decreases quality."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :depends mxflat:title-gradient
  :type (number 1 20)
  :after-set recreate-all-frames)

(defcustom mxflat:titlebar-gradient-color-mode
  'rainbow
  "gradient color mode"
  :tooltip "the custom mode will respect the colors set in the list below."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :options (rainbow jamaica rgb custom)
  :depends mxflat:title-gradient
  :type symbol
  :after-set recreate-all-frames)

(defcustom mxflat:titlebar-gradient-bgcolors
  nil
  nil
  :tooltip "With gradient mode vertical or diagonal only the first or \
last (reversed) 2 colors in the list are used.  Besides the gradient \
color mode must be set to custom to activate this list."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :widget-flags (expand-horizontally)
  :depends mxflat:title-gradient
  :type* `(list color "titlebar background colors")
  :after-set recreate-all-frames)

(defcustom mxflat:titlebar-gradient-bgcolors-reverse
  nil
  "reverse colors"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :depends mxflat:title-gradient
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:color-hue
  0
  "unfocused/highlighted titlebar colors hue (0 - 360)"
  :tooltip "This value changes the hue of a color, by moving (0 - 360) \
degress around the color cycle...180 for example inverts the color"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :depends mxflat:title-gradient
  :type (number 0 360)
  :after-set recreate-all-frames)

(defcustom mxflat:color-saturation
  50
  "unfocused/highlighted titlebar colors saturation (0 - 100 percent of the \
focused color)"
  :tooltip "The saturation of a color is a measurement of the color \
intensity"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :depends mxflat:title-gradient
  :type (number 0 100)
  :after-set recreate-all-frames)

(defcustom mxflat:color-brightness
  90
  "unfocused/highlighted titlebar colors brightness (0 - 100 percent of the \
focused color)"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-gradient-group)
  :depends mxflat:title-gradient
  :type (number 0 100)
  :after-set recreate-all-frames)

;;
;; configuration:title-colors
;;

(defcustom mxflat:titlebar-bgcolor-focused
  (get-color "#fffbde")
  "  focused titlebar color"
  :tooltip "This is one of the 4 base colors.  You can set these 4 \
colors and keep the extended colors deactivated.  All other color \
options of the theme will then depend on these 4 colors."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:titlebar-bgcolor-unfocused
  (get-color "#cedfef")
  "unfocused titlebar color"
  :tooltip "This is one of the 4 base colors.  You can set these 4 \
colors and keep the extended colors deactivated.  All other color \
options of the theme will then depend on these 4 colors."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:text-color-focused
  (get-color "#000000")
  "  focused title string color"
  :tooltip "This is one of the 4 base colors.  You can set these 4 \
colors and keep the extended colors deactivated.  All other color \
options of the theme will then depend on these 4 colors."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :after-set recreate-all-frames-recolor-all)

(defcustom mxflat:text-color-unfocused
  (get-color "#838383")
  "unfocused title string color"
  :tooltip "This is one of the 4 base colors.  You can set these 4 \
colors and keep the extended colors deactivated.  All other color \
options of the theme will then depend on these 4 colors."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :after-set recreate-all-frames-recolor-all)

(defcustom mxflat:customize-extended-text-colors
  nil
  "customize extended title string colors"
  :tooltip "You can customize additional colors of the title string.  \
If you deactivate this, these colors will be set to the focused title \
string color."
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:text-color-highlighted
  (get-color "#000000")
  "  focused highlighted title string color"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :depends mxflat:customize-extended-text-colors
  :after-set recreate-all-frames)

(defcustom mxflat:text-color-inactive-highlighted
  (get-color "#000000")
  "unfocused highlighted title string color"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :depends mxflat:customize-extended-text-colors
  :after-set recreate-all-frames)

(defcustom mxflat:text-color-clicked
  (get-color "#000000")
  "  focused clicked title string color"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :depends mxflat:customize-extended-text-colors
  :after-set recreate-all-frames)

(defcustom mxflat:text-color-inactive-clicked
  (get-color "#000000")
  "unfocused clicked title string color"
  :group (appearance mxflat:group mxflat:title-group
                     mxflat:title-colors-group)
  :type color
  :depends mxflat:customize-extended-text-colors
  :after-set recreate-all-frames)


;; configuration:buttons-basic
;;

(defcustom mxflat:button-icon-set
  'default-9
  "button icon set (experimental)"
  :tooltip "The number at the end is the width/height of the button \
icons in the icon set.  (NOTE: YOU NEED TO RESTART SAWFISH AFTER \
CHANGING THE BUTTON ICON SET!)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :options (default-9 default-12 square-6 square-9 square-12
             square-15 square-18 ball-9 ball-12)
  :type symbol
  :after-set recreate-all-frames-clear-cache)

(defcustom mxflat:customize-button-size
  nil
  "customize button size"
  :tooltip "By default the button size follows the size of the \
titlebar, but by activating this you can set it to something \
different."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :type boolean
  :after-set rebuild-all-frames)

(defcustom mxflat:button-size
  14
  "buttons size (1 - 1000 pixel)"
  :tooltip "A buttons size that is bigger than your current titlebar \
height is ignored."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :depends mxflat:customize-button-size
  :type (number 1 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:button-y-alignment
  'center
  "button vertical alignment"
  :tooltip "If a button is smaller than the titlebar you might want to \
set its vertical alignment."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :depends mxflat:customize-button-size
  :options (top center bottom)
  :type symbol
  :after-set rebuild-all-frames)

(defcustom mxflat:scale-buttons
  nil
  "scale button icons (experimental)"
  :tooltip "In case you don't like the default size of 9 pixel you \
might activate button-scaling.  YOU NEED TO RESTART SAWFISH AFTER \
CHANGING THE BUTTON SCALE!"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :type boolean
  :after-set recreate-all-frames-clear-cache)

(defcustom mxflat:button-scale
  9
  "button icon scale; changes here need a restart of sawfish (0 - 1000 \
pixel)"
  :tooltip "in case you don't like the default size of 9 pixel you \
might activate button-scaling. (NOTE: YOU NEED TO RESTART SAWFISH \
AFTER CHANGING THE BUTTON SCALE!)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :depends mxflat:scale-buttons
  :type (number 0 1000)
  :after-set recreate-all-frames-clear-cache)

(defcustom mxflat:menu-button-icon
  nil
  "display window icon on menu button"
  :tooltip "Many people like having the window-icon displayed on the \
menu-button.  This icon is defined by the application itself and is \
also shown in your pager and task-list."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:menu-button-scale
  12
  "menu icon scale (0 - 1000 pixel)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-basic-group)
  :depends mxflat:menu-button-icon
  :type (number 0 1000)
  :after-set recreate-all-frames-clear-cache)

;;
;; configuration:buttons-position1
;;

(defcustom mxflat:button-distance
  3
  "button distance (0 - 1000 pixel)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions1-group)
  :type (number 0  1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:button-left-offset
  1
  "buttons left offset (0 - 1000 pixel)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions1-group)
  :type (number 0  1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:button-right-offset
  1
  "buttons right offset (0 - 1000 pixel)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions1-group)
  :type (number 0  1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:customize-buttons
  nil
  "customize button position (-1 -2 -3 .. title string .. +3 +2 +1)"
  :tooltip "Enabling this will allow you to set the position of each \
button in the titlebar manually.  A negative/positiv value means the \
button will be drawn on left/right side of the titlebar."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions1-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:button-position-model
  'title-height
  "button position model"
  :tooltip "'title-height' means calculate position as multiple of \
title height. When selecting 'pixel' you can adjust the button \
position pixelwise, but keep in mind that several buttons might \
slide on top of each other. 'none' means no buttons at all."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions1-group)
  :options (title-height pixel none)
  :depends mxflat:customize-buttons
  :type symbol
  :after-set rebuild-all-frames)

;;
;; configuration:buttons-position2
;;

(defcustom mxflat:menu-button-position
  -1
  "menu button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:shade-button-position
  -2
  "shade button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:iconify-button-position
  +3
  "iconify button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:maximize-button-position
  +2
  "maximize button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:close-button-position
  +1
  "close button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:sticky-button-position
  -3
  "sticky button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:previous-button-position
  -5
  "previous workspace button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:next-button-position
  -6
  "next workspace button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:configure-button-position
  0
  "configure button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:info-button-position
  0
  "info button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:always-on-top-button-position
  0
  "always-on-top button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

(defcustom mxflat:lock-button-position
  0
  "lock button position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-positions2-group)
  :depends mxflat:customize-buttons
  :type (number -10000 10000)
  :after-set rebuild-all-frames)

;;
;; configuration:buttons-keymaps1
;;

(defcustom mxflat:customize-sticky-keymap
  nil
  "customize sticky button keymap"
  :tooltip "By default a button will work as it's name suggests.
Button1: toggle sticky state of window"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps1-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:sticky-button-keymap
  nil
  nil
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps1-group)
  :widget-flags (expand-horizontally)
  :depends mxflat:customize-sticky-keymap
  :type keymap)

(defcustom mxflat:customize-previous-keymap
  nil
  "customize previous button keymap"
  :tooltip "By default a button will work as it's name suggests. \
Button1: send window to previous workspace - button2 workspace-list \
- button3 send window to first workspace - button6 pack window left"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps1-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:previous-button-keymap
  nil
  nil
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps1-group)
  :widget-flags (expand-horizontally)
  :depends mxflat:customize-previous-keymap
  :type keymap)

(defcustom mxflat:customize-next-keymap
  nil
  "customize next button keymap"
  :tooltip "By default a button will work as it's name suggests. \
Button1: send window to next workspace - button2 workspace-list - \
button3 send window to last workspace - button6 pack window right"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps1-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:next-button-keymap
  nil
  nil
  :tooltip "button1: send window to next workspace - button2 \
workspace-list - button3 send window to last workspace - button6 \
pack window right"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps1-group)
  :widget-flags (expand-horizontally)
  :depends mxflat:customize-next-keymap
  :type keymap)

;;
;; configuration:buttons-keymaps2
;;

(defcustom mxflat:customize-configure-keymap
  nil
  "customize configure button keymap"
  :tooltip "By default a button will work as it's name suggests. \
Button1: start sawfish-config - button3: toggle custom title string"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:configure-button-keymap
  nil
  nil
  :tooltip "Button1: start sawfish-config - button3: toggle custom \
title string"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :widget-flags (expand-horizontally)
  :depends mxflat:customize-configure-keymap
  :type keymap)

(defcustom mxflat:customize-info-keymap
  nil
  "customize info button keymap"
  :tooltip "By default a button will work as it's name suggests. \
Button1: window list - button3 window snooper (not included by \
default)"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:info-button-keymap
  nil
  nil
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :widget-flags (expand-horizontally)
  :depends mxflat:customize-info-keymap
  :type keymap)

(defcustom mxflat:always-on-top-depth
  1
  "always on top depth (-1000 - 1000)"
  :tooltip "A window will have this depth after you have pressed the \
always-on-top button.  0 is the normal window level.  Every positive \
value means above other windows, a negative value means below.  Keep \
it at a positive value in order to have the always-on-top button do \
it's job."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :type (number -1000 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:customize-always-on-top-keymap
  nil
  "customize always-on-top button keymap"
  :tooltip "By default a button will work as it's name suggests. \
Button1: sets window depth to the adjusted value."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:always-on-top-button-keymap
  nil
  nil
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :depends mxflat:customize-always-on-top-keymap
  :widget-flags (expand-horizontally)
  :type keymap)

(defcustom mxflat:customize-lock-keymap
  nil
  "customize lock button keymap"
  :tooltip "By default a button will work as it's name suggests. \
Button1: lock window position"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:lock-button-keymap
  nil
  nil
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:buttons-keymaps2-group)
  :depends mxflat:customize-lock-keymap
  :widget-flags (expand-horizontally)
  :type keymap)

;;
;; configuration:button-colors
;;

(defcustom mxflat:custom-button-colors
  nil
  "customize button-colors"
  :tooltip "When you active this you will be able to set custom \
button colors.  By default the button colors depend on the titlebar \
colors."
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :type boolean
  :after-set recreate-all-frames-recolor-all)

(defcustom mxflat:button-bgcolor-focused
  (get-color "#fffbde")
  "  focused button background color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:button-bgcolor-unfocused
  (get-color "#cedfef")
  "unfocused button background color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:button-bgcolor-highlighted
  (get-color "#def3ff")
  "  focused highlighted button background color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:button-bgcolor-inactive-highlighted
  (get-color "#fffbde")
  "unfocused highlighted button background color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:button-bgcolor-clicked
  (get-color "#cecece")
  "  focused clicked button background color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:button-bgcolor-inactive-clicked
  (get-color "#cecece")
  "unfocused clicked button background color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames)

(defcustom mxflat:button-fgcolor-focused
  (get-color "#000000")
  "  focused button foreground color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames-recolor-all)

(defcustom mxflat:button-fgcolor-inactive
  (get-color "#838383")
  "unfocused button foreground color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames-recolor-all)

(defcustom mxflat:button-fgcolor-highlighted
  (get-color "#000000")
  "  focused highlighted button foreground color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames-recolor-all)

(defcustom mxflat:button-fgcolor-clicked
  (get-color "#000000")
  "  focused clicked button foreground color"
  :group (appearance mxflat:group mxflat:buttons-group
                     mxflat:button-colors-group)
  :depends mxflat:custom-button-colors
  :type color
  :after-set recreate-all-frames-recolor-all)

;;
;; configuration:border-basic
;;

(defcustom mxflat:border-width-unmaximized
  1
  "border width (0 - 1000 pixel)"
  :tooltip "set the width border around the window."
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type (number 0 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:border-width-maximized
  1
  "border width for maximized windows (0 - 1000 pixel)"
  :tooltip "When you like having a big border around your windows you \
might have noticed that sawfish still draws that big border when the \
window is maximized.  If you don't want that, set the border width for \
maximized windows smaller than the border width for unmaximized \
windows.  (NOTE: this feature is still buggy as sawfish does not \
resize the windows correctly yet, so the best might be to set it to \
the normal border width.)"
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type (number 0 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:custom-border-focused
  nil
  "customize border for focused windows (experimental)"
  :tooltip "(NOTE: this works but it is VERY cpu intensive and might \
slow down your computer noticeably.  So turn it on at your own risk.)"
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type boolean
  :after-set rebuild-all-frames)

(defcustom mxflat:border-width-focused
  1
  "border width for focused windows (0 - 1000 pixel)"
  :tooltip "(NOTE: this works but it is VERY cpu intensive and might \
slow down your computer noticeably.  So turn it on at your own risk.)"
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type (number 0 1000)
  :depends mxflat:custom-border-focused
  :after-set rebuild-all-frames)

(defcustom mxflat:border-width-titlebar-contents
  1
  "title-contents border width (0 - 1000 pixel)"
  :tooltip "Sets the widths of the line between titlebar and contents \
window"
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type (number 0 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:border-offset
  -1
  "border offset (-1000 - 1000 pixel)"
  :tooltip "Adjust the point where the border actually starts.  Many \
gtk2 apps draw a small black border around their contents window and \
this is just ugly when sawfish draws another border around the window. \
With a border offset of -1 the sawfish window border will overlay the \
gtk2 border exactly."
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type (number -1000 1000)
  :after-set rebuild-all-frames)

(defcustom mxflat:keep-borders-when-shaded
  nil
  "keep window borders and corners at their place when shading a window"
  :tooltip "When shading a window borders and corners will stay where \
they were and not merge with the titlebar."
  :group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
  :type boolean
  :after-set recreate-all-frames)

;;
;; configuration:border-extended
;;

(defcustom mxflat:show-corners
  t
  "show window corners"
  :tooltip "The corners are used to resize a window in two directions \
at the same time.  Usually the width and length of window corners are \
determined by the border width but you can adjust them below."
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:corner-length-adjustment
  20
  "corners length adjustement (-1 - 100 pixel)"
  :tooltip "Increasing the corner length will grow the window corners \
along the window border (i.e. make them longer).  With a border width \
of 1 pixel it is hard to grab the 1 pixel corner to be able to resize \
the window in two directions; thus, make it bigger."
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type (number -1 100)
  :depends mxflat:show-corners
  :after-set rebuild-all-frames)

(defcustom mxflat:corner-direction
  'outside
  "corner direction"
  :"inside or outside the window border"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type symbol
  :options (outside inside)
  :depends mxflat:show-corners
  :after-set recreate-all-frames)

(defcustom mxflat:corner-width-adjustment
  1
  "corners width adjustement (0 - 100 pixel)"
  :tooltip "This option makes the window corners broader. with a \
border width of 1 pixel it is hard to grab this 1 pixel corner to be \
able to resize the window in two directions; thus, make it bigger."
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type (number 0 100)
  :depends mxflat:show-corners
  :after-set rebuild-all-frames)

(defcustom mxflat:corner-width-adjustment-maximized
  0
  "corners width adjustement for maximized windows (0 - 100 pixel)"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type (number 0 100)
  :depends mxflat:show-corners
  :after-set rebuild-all-frames)

(defcustom mxflat:fake-shadow
  nil
  "fake shadow (experimental)"
  :tooltip "Draw a small additional border around your windows \
emulating a solid shadow effect.  Use the options below to adjust its \
width and direction.  (NOTE: this is VERY cpu intensive and might slow \
down your computer noticeably.  So turn it on at your own risk.)"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type boolean
  :after-set recreate-all-frames)

(defcustom mxflat:fake-shadow-focused-only
  nil
  "fake shadow only on focused windows"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type boolean
  :depends mxflat:fake-shadow
  :after-set recreate-all-frames)

(defcustom mxflat:shadow-light-source
  'north-west
  "fake shadow light source"
  :tooltip "Set the direction of the fake shadow.  Usually only 2 or 3 \
borders of your window have a fake shadow.  This depends on where the \
light comes from."
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type symbol
  :options (north east south west north-east north-west
                  south-east south-west)
  :depends mxflat:fake-shadow
  :after-set after-set-shadow-light-source)

(defcustom mxflat:shadow-light-distance
  3
  "fake shadow light distance (0 - 100)"
  :tooltip "This option has only an effect on the north, east, south \
and west light sources.  The further away the light source is, the \
smaller will the two 'side' shadows be."
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type (number 1 100)
  :depends mxflat:fake-shadow
  :after-set rebuild-all-frames)

(defcustom mxflat:shadow-width
  4
  "fake shadow width (0 - 100 pixel)"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type (number 0 100)
  :depends mxflat:fake-shadow
  :after-set rebuild-all-frames)

(defcustom mxflat:shadow-color
  (get-color "#838383")
  "shadow color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-extended-group)
  :type color
  :depends mxflat:fake-shadow
  :after-set rebuild-all-frames)

;;
;; configuration:border-colors
;;

(defcustom mxflat:customize-border-colors
  nil
  "customize border colors"
  :tooltip "You can customize your border colors here. If you \
deactivate this, these colors will be set to the focused title \
string color."
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type boolean
  :after-set rebuild-all-frames)

(defcustom mxflat:border-color-focused
  (get-color "#000000")
  "  focused border color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type color
  :depends mxflat:customize-border-colors
  :after-set rebuild-all-frames)

(defcustom mxflat:border-color-unfocused
  (get-color "#000000")
  "unfocused border color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type color
  :depends mxflat:customize-border-colors
  :after-set rebuild-all-frames)

(defcustom mxflat:border-color-highlighted
  (get-color "#000000")
  "  focused highlighted border color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type color
  :depends mxflat:customize-border-colors
  :after-set rebuild-all-frames)

(defcustom mxflat:border-color-inactive-highlighted
  (get-color "#000000")
  "unfocused highlighted border color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type color
  :depends mxflat:customize-border-colors
  :after-set rebuild-all-frames)

(defcustom mxflat:border-color-clicked
  (get-color "#000000")
  "  focused clicked border color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type color
  :depends mxflat:customize-border-colors
  :after-set rebuild-all-frames)

(defcustom mxflat:border-color-inactive-clicked
  (get-color "#000000")
  "unfocused clicked border color"
  :group (appearance mxflat:group mxflat:border-group
                     mxflat:border-colors-group)
  :type color
  :depends mxflat:customize-border-colors
  :after-set rebuild-all-frames)

;;  ----
;;; MISC
;;  ----

(define (get-last-workspace)
  (aref (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS))
        0))

(define (get-first-workspace) 1)

(defmacro window-in-workspace-p (w space)
  `(memq ,space (window-get ,w 'workspaces)))

(define (window-maximized-p w)
  (window-get w 'unmaximized-geometry))

(define (window-maximized-horizontally-p w)
  (window-get w 'maximized-horizontally))

(define (window-maximized-vertically-p w)
  (window-get w 'maximized-vertically))

;; constant accuracy factor since we ???are not allowed to  use floats
;; in themes???
;; / seems to be gaoled
(defvar afactor 10000000000000)
(defvar afactor360 (* 360 afactor))

;;
;; misc:color manipulation
;;

;; returns a list containing hue saturation and value of color
(define (rgb2hsv color)
  (let* (
         ;; get rgb ints for the color
         (rgbchannels (color-rgb color))

         ;; get red, green and blue ints from rgbchannels
         (red   (nth 0 rgbchannels))
         (green (nth 1 rgbchannels))
         (blue  (nth 2 rgbchannels))

         ;; channnel with the biggest int value
         (value (apply max (list red green blue)))
         ;; delta
         (max-min (- value (apply min (list red green blue))))

         ;; saturation: 1 - min / max  =  (max - min) / max  =  delta / max
         ;; saturation * afactor - acutally the saturation
         ;; is a float between 0 and 1 but as it seems
         ;; we cannot use them in themes
         (saturation
          (if (= max-min 0)
              0
            (/ (* max-min afactor) value)))
         ;; value between 0 and 360 degree * afactor
         ;; 0 = red, 120 = green, 240 = blue
         (hue (if (= max-min 0)
                  0
                (/ (* 60 afactor (cond ((= value red)
                                        (- green blue))
                                       ((= value green)
                                        (+ (* 2 max-min) (- blue red)))
                                       (t ; (= value blue)
                                        (+ (* 4 max-min) (- red green)))))
                   max-min))))
    (list (if (< hue 0) (+ hue afactor360) hue) saturation value)))

;; translates a rgb-color from the ints of the list, which contains
;; hue, saturation and value
(define (hsv2rgb hsv)
  (let* ((hue (nth 0 hsv))
         (saturation (nth 1 hsv))
         (value (nth 2 hsv)))

    ;; value zero -> color black
    (cond ((= value 0)
           (get-color-rgb 0 0 0))
          ((= saturation 0)

           ;; in this case the color is grey and
           ;; thus its rgb value is:
           (get-color-rgb value value value))
          (t
           ;; else we need to do some calculations -
           ;; the hue and saturation are aleady
           ;; multiplied with afactor
           (let* (;; we need it often, so we define
                  ;; it once here
                  (afactor2 (* afactor afactor))

                  ;; kind of an 'compensation delta'
                  (f (if (or (= hue 0)
                             (= hue afactor360))
                         0
                       (/ (mod hue (* 60 afactor)) 60)))

                  ;; p is the lowest color int
                  (p (/ (*  value
                            (- afactor saturation))
                        afactor))

                  ;; tt is a medium color int
                  (q (/ (* value
                           (- afactor2 (* saturation f)))
                        afactor2))

                  ;; tt is a medium color int
                  (tt (/ (* value
                            (- afactor2
                               (* saturation (- afactor f))))
                         afactor2))

                  ;; area on the color circle (0 .. 5)
                  (circle-part
                   (if (>= hue afactor360)
                       0
                     (/ (/ hue afactor)
                        60))))
             ;; arrange the right vars for the current
             ;; color circle part
             (case circle-part
               ((0) (get-color-rgb value tt    p))
               ((1) (get-color-rgb q     value p))
               ((2) (get-color-rgb p     value tt))
               ((3) (get-color-rgb p     q     value))
               ((4) (get-color-rgb tt    p     value))
               ((5) (get-color-rgb value p     p))))))))

;; adjusts the hue, brightness and saturation of color
(define (adjust-color color)
  (let* (;; hue saturation value list
         (hsv (rgb2hsv color))
         ;; add used configured adjustment to
         ;; the hue of the color
         (a-hue (+ (nth 0 hsv)
                   (* mxflat:color-hue afactor)))
         ;; adjust saturation with
         ;; user configured factor
         (a-saturation (/ (* (nth 1 hsv)
                             mxflat:color-saturation)
                          100))
         ;; adjust value/brightness with
         ;; user configured factor
         (a-value (/ (* (nth 2 hsv)
                        mxflat:color-brightness)
                     100)))
    (hsv2rgb (list
              ;; adjust the hue if necessary
              ;; (ie it is >360 degree)
              (if (> a-hue afactor360)
                  (- a-hue afactor360)
                a-hue)
              a-saturation
              a-value))))

;;
;; misc:hook-ins
;;

;; when the window title or some other wm_hints attribute changes,
;; redraw the window
(call-after-property-changed (list 'WM_NAME)
                             (lambda (w)
                               (if (eq mxflat:title-x-justify 'real-center)
                                   (rebuild-frame w)
                                 (refresh-one-frame w))))

;; when we set a window sticky we have to redraw it, the sticky button
;; has changed
(call-after-state-changed '(sticky) reframe-window)

;; when the window is sent to another workspace redraw it to update
;; the buttons and titlebar if necessary
(add-hook 'remove-from-workspace-hook
          (lambda (w)
            (reframe-window w)))

;; not necessary anymore?
;;(add-hook 'after-resize-hook refresh-one-frame)

(add-hook 'focus-in-hook
          (lambda (w)
            ;; if 'custom borders for focused windows' -> redraw
            (if (or mxflat:custom-border-focused
                    (and mxflat:fake-shadow
                         mxflat:fake-shadow-focused-only))
                (reframe-window w))))

(add-hook 'focus-out-hook
          (lambda (w)
            ;; if 'custom borders for focused windows' -> redraw
            (if (or mxflat:custom-border-focused
                    (and mxflat:fake-shadow
                         mxflat:fake-shadow-focused-only))
                (reframe-window w))))

;;
;; misc:functions
;;

(define (get-border-offset)
  ;; we use the negative value to make the defcustom option work more
  ;; like one would expect, ie a positive value means the border will
  ;; have a bigger distance to the contents window
  (- mxflat:border-offset))

(define (get-button-size)
  (if (and mxflat:customize-button-size
           (< mxflat:button-size mxflat:title-height))
      mxflat:button-size
    mxflat:title-height))

;;  -----------
;;; FAKE SHADOW
;;  -----------

;; this list defines which window sides have shadows for which
;; direction
(defvar shadow-sides
  `((north . (bottom left right))
    (east . (top bottom left))
    (west . (top bottom right))
    (south . (top left right))
    (north-east . (bottom left))
    (north-west . (bottom right))
    (south-west . (top right))
    (south-east . (top left))))

;; selects the right shadow-side from the shadow-sides list
(define (get-shadow-side)
  (mapc (lambda (ss)
          (if (eq (car ss) mxflat:shadow-light-source)
              (setq shadow-side (cdr ss))))
        shadow-sides))

(define (get-shadow-color) mxflat:shadow-color)

(define (get-shadow-width w side)
  (if (member side shadow-side)
      (get-neg-border-width w side)
    mxflat:shadow-width))

(define (get-shadow-offset w side)
  ;; the shadow is only not visible on all window edges
  (if (not (window-maximized-p w))
      (if (or (and (eq mxflat:shadow-light-source 'north)
                   (not (eq side 'bottom)))
              (and (eq mxflat:shadow-light-source 'south)
                   (not (eq side 'top)))
              (and (eq mxflat:shadow-light-source 'east)
                   (not (eq side 'left)))
              (and (eq mxflat:shadow-light-source 'west)
                   (not (eq side 'right))))
          (/ mxflat:shadow-width mxflat:shadow-light-distance)
        (if (member side shadow-side)
            mxflat:shadow-width
          0))
    0))

;;  --------
;;; TITLEBAR
;;  --------

;;
;; titlebar:colors
;;

(define (get-text-colors)
  (if mxflat:customize-extended-text-colors
      `((inactive             . ,mxflat:text-color-unfocused)
        (focused              . ,mxflat:text-color-focused)
        (highlighted          . ,mxflat:text-color-highlighted)
        (inactive-highlighted . ,mxflat:text-color-inactive-highlighted)
        (clicked              . ,mxflat:text-color-clicked)
        (inactive-clicked     . ,mxflat:text-color-inactive-clicked))

    `((inactive             . ,mxflat:text-color-unfocused)
      (focused              . ,mxflat:text-color-focused)
      (highlighted          . ,mxflat:text-color-focused)
      (inactive-highlighted . ,mxflat:text-color-focused)
      (clicked              . ,mxflat:text-color-focused)
      (inactive-clicked     . ,mxflat:text-color-focused))))

(define (titlebar-gradient-colors-helper)
  (case mxflat:titlebar-gradient-color-mode
    ((custom)
     (if (> (length mxflat:titlebar-gradient-bgcolors) 0)
         mxflat:titlebar-gradient-bgcolors
       (list (get-color "#ffffffffffff"))))
    ((rainbow)
     (list (get-color "#ffff0000153b")
           (get-color "#ffff9b700000")
           (get-color "#fffff92d0000")
           (get-color "#3661ffff0000")
           (get-color "#00004c0dffff")
           (get-color "#b7ad0000ffff")))
    ((jamaica)
     (list (get-color "#7899f1340000")
           (get-color "#ffffffff0000")
           (get-color "#ffff37030000")))
    ((rgb)
     (list (get-color "#ffff00000000")
           (get-color "#0000ffff0000")
           (get-color "#00000000ffff")))))

(define (titlebar-gradient-colors)
  (if mxflat:titlebar-gradient-bgcolors-reverse
      (reverse (titlebar-gradient-colors-helper))
    (titlebar-gradient-colors-helper)))

;; changes the brightness and saturation for the titlebar gradient
;; color with index i
(define (adjust-titlebar-bgcolor i)
  ;; get rgb ints for the color with index i
  (adjust-color (nth i (titlebar-gradient-colors))))

(define (get-titlebar-bgcolors #!optional side)
  (cond ((and mxflat:title-gradient side)
         (let* ((index
                 (if (eq side 'right)
                     (1- (length (titlebar-gradient-colors)))
                   0)))
           `((inactive . ,(adjust-titlebar-bgcolor index))
             (focused  . ,(nth index (titlebar-gradient-colors))))))
        (t
         `((inactive    . ,mxflat:titlebar-bgcolor-unfocused)
           (focused     . ,mxflat:titlebar-bgcolor-focused)))))

;;
;; titlebar:bg rendering
;;

(define (num-titlebar-parts)
  (if (or (= (length (titlebar-gradient-colors)) 1)
          (eq mxflat:gradient-direction 'none))
      (length (titlebar-gradient-colors))
    (1- (length (titlebar-gradient-colors)))))

;; render frame-part background
;; this function takes the background img and uses many single 2-color
;; gradients to fill it
(define (render-bg img state)
  (let* (;; width and height of the titlebar part we have to fill
         (width (car (image-dimensions img)))
         (height (cdr (image-dimensions img)))

         ;; 2-color gradient width
         (part-width (/ width (num-titlebar-parts)))
         (rest-width (modulo width (num-titlebar-parts)))

         ;; the offset in the img that we've already reached
         ;; with our 2-color gradients
         (offset 0)

         ;; get the width of the 2-color gradient with index i
         (titlebar-parts-width-helper (lambda (i)
                                        (if (= i (1- (num-titlebar-parts)))
                                            (+ part-width rest-width)
                                          part-width)))

         ;; check the 2-color gradient width if it is > 0
         (titlebar-parts-width (lambda (i)
                                 (let ((val (titlebar-parts-width-helper i)))
                                   (if (< val 1)
                                       1
                                     val))))

         ;; 2-color gradient image
         (img2 nil))

    (case mxflat:gradient-direction
      ((horizontal none)
       (do ((i 0 (1+ i)))
           ((= i (num-titlebar-parts)))

         ;; create the 2-color gradient image and fill it with a
         ;; background color
         (setq img2 (make-sized-image (titlebar-parts-width i)
                                      height
                                      (if state
                                          (nth i (titlebar-gradient-colors))
                                        (adjust-titlebar-bgcolor i))))

         ;; fill the img2 with the 2-color gradient if necessary
         (if (not (eq mxflat:gradient-direction 'none))
             (apply draw-horizontal-gradient
                    img2
                    (if state
                        (list (nth i (titlebar-gradient-colors))
                              (if (or
                                   (= (length  (titlebar-gradient-colors)) 1)
                                   (eq mxflat:gradient-direction 'none))
                                  (nth i (titlebar-gradient-colors))
                                (nth (1+ i) (titlebar-gradient-colors))))
                      (list (adjust-titlebar-bgcolor i)
                            (if (or
                                 (= (length (titlebar-gradient-colors)) 1)
                                 (eq mxflat:gradient-direction 'none))
                                (adjust-titlebar-bgcolor i)
                              (adjust-titlebar-bgcolor (1+ i)))))))

         ;; paste the current 2-color gradient into the titlebar
         ;; background image
         (composite-images img img2 offset 0)
         (setq offset (+ offset (titlebar-parts-width i)))))

      ((vertical diagonal)
       (apply
        (if (eq mxflat:gradient-direction 'vertical)
            draw-vertical-gradient
          draw-diagonal-gradient)
        img
        (if state
            (list (nth 0 (titlebar-gradient-colors))
                  (if (= (length  (titlebar-gradient-colors)) 1)
                      (nth 0 (titlebar-gradient-colors))
                    (nth 1 (titlebar-gradient-colors))))
          (list (adjust-titlebar-bgcolor 0)
                (if (= (length (titlebar-gradient-colors)) 1)
                    (adjust-titlebar-bgcolor 0)
                  (adjust-titlebar-bgcolor 1)))))))
    img))

;;
;; titlebar:string
;;

(define (get-title-font) mxflat:title-font)

;; replace vars in the title string with their actual values and
;; return the  new title string
(define (get-title-string w)
  (if mxflat:custom-title
      (let* ((title mxflat:title-string)
             (update-title (lambda (match-str replace-str)
                             (while (string-match match-str title)
                               (setq title
                                     (concat
                                      (expand-last-match "\\1")
                                      (if (numberp replace-str)
                                          (number->string replace-str)
                                        replace-str)
                                      (expand-last-match "\\3")))))))
        ;; some built-in vars
        (update-title "(.*)(\\$name)(.*)"
                      (window-name w))
        (update-title "(.*)(\\$fullname)(.*)"
                      (window-full-name w))
        (update-title "(.*)(\\$width-content)(.*)"
                      (car (window-dimensions w)))
        (update-title "(.*)(\\$height-content)(.*)"
                      (cdr (window-dimensions w)))
        (update-title "(.*)(\\$width)(.*)"
                      (car (window-frame-dimensions w)))
        (update-title "(.*)(\\$height)(.*)"
                      (cdr (window-frame-dimensions w)))
        (update-title "(.*)(\\$x-pos)(.*)"
                      (car (window-position w)))
        (update-title "(.*)(\\$y-pos)(.*)"
                      (cdr (window-position w)))
        (update-title "(.*)(\\$id)(.*)"
                      (window-id w))
        (update-title "(.*)(\\$depth)(.*)"
                      (window-get w 'depth))
        (update-title "(.*)(\\$gid)(.*)"
                      (window-group-id w))
        (update-title "(.*)(\\$last-ws)(.*)"
                      (get-last-workspace))
        (update-title "(.*)(\\$current-ws)(.*)"
                      (let ((workspaces (window-get w 'workspaces)))
                        (if workspaces
                            (1+ (nth 0 workspaces))
                          "*")))
        ;; replace environment vars
        (while (string-match "(.*)\\$\\((.+?)\\)(.*)" title)
          (let ((part1 (expand-last-match "\\1"))
                (part2 (expand-last-match "\\3"))
                (envvar (getenv (expand-last-match "\\2"))))
            (if (not envvar)
                (setq envvar (concat "$?(" (expand-last-match "\\2") ")")))
            (setq title (concat part1 envvar part2))))
        ;; replace rep functions
        ;; XXX: no arguments to the functions possible yet, does
        ;; someone need this?
        (while (string-match "(.*)\\$\\[(.+?)\\](.*)" title)
          (let ((part1 (expand-last-match "\\1"))
                (part2 (expand-last-match "\\3"))
                (symb (intern (expand-last-match "\\2")))
                (func nil)
                (value (concat "$?[" (expand-last-match "\\2") "]")))
            (if (boundp symb)
                (setq func (symbol-value symb)))
            (if (functionp func)
                (setq value (funcall func)))
            (setq title (concat part1 value part2))))
        title)
    (window-name w)))

;;
;; titlebar:position
;;

;; calculate the leftmost x position of an object on the titlebar
;; this function is also used for button positions on the titlebar
(define (calculate-position pos)
  (if (and mxflat:customize-buttons
           (eq mxflat:button-position-model 'pixel))
      ;; if the button-position-model is pixel we don't
      ;; need to calculate anything but just return the
      ;; argument value
      pos
    ;; actually calculate the position
    (* (1- pos)
       (+ (get-button-size)
          mxflat:button-distance))))

(define (get-title-height)
  (+ mxflat:title-height
     mxflat:border-width-titlebar-contents))

;; not really the neg value since we add the border offset
;; but thats the easiest place for doing so
(define (get-neg-title-height)
  (- (get-border-offset)
     (get-title-height)))

(define (get-titlebar-height w)
  (+ (get-title-height)
     (get-border-width w 'top)))

;; not really the neg value since we add the border offset
;; but thats the easiest place for doing so
(define (get-neg-titlebar-height w)
  (- (get-border-offset)
     (get-titlebar-height w)))

;; get the 1+ position of the leftmost or rightmost button
(define (get-last-button-position left-right)
  (let ((pos
         (if mxflat:customize-buttons
             (abs (apply
                   (if (eq left-right 'left)
                       min
                     max)
                   (list mxflat:menu-button-position
                         mxflat:shade-button-position
                         mxflat:sticky-button-position
                         mxflat:previous-button-position
                         mxflat:next-button-position
                         mxflat:configure-button-position
                         mxflat:info-button-position
                         mxflat:iconify-button-position
                         mxflat:maximize-button-position
                         mxflat:close-button-position
                         mxflat:always-on-top-button-position
                         mxflat:lock-button-position)))
           (if (eq left-right 'left)
               3
             2))))
    (if (or (eq mxflat:button-position-model 'title-height)
            (not mxflat:customize-buttons))
        (calculate-position (1+ pos))
      (if (eq mxflat:button-position-model 'pixel)
          (+ pos
             mxflat:title-height)1))))

;; by default the title is vertically centered and pixelwise
;; adjusted through mxflat:title-y-adjustment
(define (get-title-y-alignment)
  (if mxflat:customize-title-position
      (case mxflat:title-y-justify
        ((top)
         ;; sanity check on the value
         ;; else the title string would not be visible
         (if (> mxflat:title-y-adjustment 0)
             mxflat:title-y-adjustment
           0))

        ;; we have to calculate it manually to be able to take
        ;; the y align adjustment into account
        ((center)
         (+ mxflat:title-y-adjustment
            (/ (- mxflat:title-height
                  (font-height mxflat:title-font))
               2)))

        ;; bottom
        (t
         ;; sanity check on the value
         ;; else the title string would not be visible
         (if (< mxflat:title-y-adjustment 0)
             mxflat:title-y-adjustment
           -1)))
    'center))

(define (get-title-x-alignment w)
  (if mxflat:customize-title-position
      (case mxflat:title-x-justify
        ((left)
         ;; sanity check on the value
         ;; else the title string would not be visible
         (if (< mxflat:title-x-adjustment 0)
             0
           mxflat:title-x-adjustment))
        ((center)
         'center)
        ((right)
         ;; sanity check on the value
         ;; else the title string would not be visible
         (if (> mxflat:title-x-adjustment -1)
             -1
           mxflat:title-x-adjustment))
        ;; 'real-center' means to take the whole titlebar into account
        ;; while centering the title string
        ((real-center)
         (let ((real-title-offset
                (/ (- (car (window-dimensions w))
                      (text-width (get-title-string w) (get-title-font)))
                   2))
               (title-offset
                (- (get-last-button-position 'left)
                   mxflat:title-x-adjustment)))
           (if (> title-offset real-title-offset)
               0
             (- real-title-offset title-offset)))))
    'center))

(define (left-buttons-end-offset)
  (get-last-button-position 'left))

(define (right-buttons-end-offset)
  (get-last-button-position 'right))

;;
;; titlebar:creation
;;

(define (titlebar-center backgroun backgroundd)
  `(((class        . title)
     (,backgroun   . ,backgroundd)
     (render-scale . ,mxflat:gradient-scale)
     (foreground   . ,get-text-colors)
     (font         . ,get-title-font)
     (text         . ,get-title-string)
     (x-justify    . ,get-title-x-alignment)
     (y-justify    . ,get-title-y-alignment)
     (left-edge    . ,(lambda ()
                        (+ (left-buttons-end-offset)
                           (get-border-offset))))
     (right-edge   . ,(lambda ()
                        (+ (right-buttons-end-offset)
                           (get-border-offset))))
     (top-edge     . ,get-neg-title-height)
     (height       . ,(lambda () mxflat:title-height)))))

(define (titlebar-left-right backgroun backgroundd edg1 edgee1 edg2 edgee2)
  ;; left part of the titlebar
  `(((class        . title)
     (,backgroun   . ,backgroundd)
     (render-scale . ,mxflat:gradient-scale)
     (,edg1        . ,edgee1)
     (,edg2        . ,edgee2)
     (top-edge     . ,get-neg-title-height)
     (height       . ,(lambda () mxflat:title-height)))))

(define (titlebar)
  (append
   (if (and (or (eq mxflat:gradient-direction 'vertical)
                (eq mxflat:gradient-direction 'diagonal))
            mxflat:title-gradient)
       (append
        (titlebar-left-right
         'renderer render-bg
         'left-edge get-border-offset
         'width left-buttons-end-offset)
        (titlebar-left-right
         'renderer render-bg
         'width right-buttons-end-offset
         'right-edge get-border-offset))
     (append
      (titlebar-left-right
       'background (lambda () (get-titlebar-bgcolors 'left))
       'left-edge get-border-offset
       'width left-buttons-end-offset)
      (titlebar-left-right
       'background (lambda () (get-titlebar-bgcolors 'right))
       'width right-buttons-end-offset
       'right-edge get-border-offset)))
   (if mxflat:title-gradient
       (titlebar-center 'renderer render-bg)
     (titlebar-center 'background get-titlebar-bgcolors))))

;;  -------
;;; BORDERS
;;  -------

;;
;; borders:colors
;;

(define (get-border-color)
  (if mxflat:customize-border-colors
      `((inactive             . ,mxflat:border-color-unfocused)
        (focused              . ,mxflat:border-color-focused)
        (highlighted          . ,mxflat:border-color-highlighted)
        (inactive-highlighted . ,mxflat:border-color-inactive-highlighted)
        (clicked              . ,mxflat:border-color-clicked)
        (inactive-clicked     . ,mxflat:border-color-inactive-clicked))
    `((inactive . ,mxflat:text-color-unfocused)
      (focused  . ,mxflat:text-color-focused))))

(define (get-border-color-titlebar-contents)
  (if mxflat:customize-border-colors
      `((inactive . ,mxflat:border-color-unfocused)
        (focused  . ,mxflat:border-color-focused))
    `((inactive . ,mxflat:text-color-unfocused)
      (focused  . ,mxflat:text-color-focused))))

;;
;; borders:width
;;

(define (get-border-width w #!optional side)
  (cond ((or (and (window-maximized-vertically-p w)
                  (or (eq side 'top)
                      (eq side 'bottom)))
             (and (window-maximized-horizontally-p w)
                  (or (eq side 'left)
                      (eq side 'right))))
         mxflat:border-width-maximized)
        ((and mxflat:custom-border-focused
              (eq w (input-focus)))
         mxflat:border-width-focused)
        (t
         mxflat:border-width-unmaximized)))

(define (get-neg-border-width w #!optional side)
  (- (get-border-offset)
     (get-border-width w side)))

;;
;; borders:creation
;;

(define (create-border-frame-parts color offset widthh
                                   #!optional mode border-list)
  (let* ((get-pos (lambda (w side)
                    (- (offset w side)
                       (widthh w side))))
         ;; bottom edge of the frame
         (bottom-edgee1 'bottom-edge)
         (bottom-edgee2 'bottom-edge)
         (bottom-edg1 (lambda (w)
                        (offset w 'bottom)))
         (bottom-edg2 (lambda (w)
                        (get-pos w 'bottom)))
         (top-edg1 (lambda (w)
                     (- (offset w 'top)
                        (get-title-height))))
         (top-edg2 (lambda (w)
                     (- (offset w 'top)
                        (+ (get-title-height)
                           (widthh w 'top)))))
         (left-edg (lambda (w)
                     (get-pos w 'left)))
         (right-edg (lambda (w)
                      (get-pos w 'right)))
         (right-borderr (if border-list
                            'shadow
                          'right-border))
         (left-borderr (if border-list
                           'shadow
                         'left-border))
         (top-borderr (if border-list
                          'shadow
                        'top-border))
         (bottom-borderr (if border-list
                             'shadow
                           'bottom-border)))
    (case mode
      ('transient
       (setq top-edg1 (lambda (w) (offset w 'top)))
       (setq top-edg2 (lambda (w) (get-pos w 'top))))
      ('shaded
       (setq bottom-edgee2 'top-edge)
       (setq bottom-edg2 (lambda (w)
                           (- (offset w 'bottom)
                              mxflat:border-width-titlebar-contents)))
       ;; when the window is shaded we rather define the borders by
       ;; top-edge and height nstead of using top- and bottom-edge
       (setq bottom-edgee1 'height)
       (setq bottom-edg1 (lambda (w)
                           (get-titlebar-height w)))))
    (append
     ;; draw the right border
     (if (or (not border-list)
             (member 'right border-list))
         `(((class          . ,right-borderr)
            (background     . ,color)
            (width          . ,(lambda (w) (widthh w 'right)))
            (right-edge     . ,right-edg)
            (top-edge       . ,top-edg1)
            (,bottom-edgee1 . ,bottom-edg1))))

     ;; draw the left border
     (if (or (not border-list)
             (member 'left border-list))
         `(((class          . ,left-borderr)
            (background     . ,color)
            (width          . ,(lambda (w) (widthh w 'left)))
            (left-edge      . ,left-edg)
            (top-edge       . ,top-edg1)
            (,bottom-edgee1 . ,bottom-edg1))))

     ;; draw the top border of the title frame
     (if (or (not border-list)
             (member 'top border-list))
         `(((class      . ,top-borderr)
            (background . ,color)
            (height     . ,(lambda (w) (widthh w 'top)))
            (left-edge  . ,left-edg)
            (right-edge . ,right-edg)
            (top-edge   . ,top-edg2))))

     ;; draw the bottom border
     (if (or (not border-list)
             (member 'bottom border-list))
         `(((class          . ,bottom-borderr)
            (background     . ,color)
            (height         . ,(lambda (w) (widthh w 'bottom)))
            (left-edge      . ,left-edg)
            (right-edge     . ,right-edg)
            (,bottom-edgee2 . ,bottom-edg2)))))))

;; this function appends the window border (frame) and its shadow
(define (create-borders w #!optional mode)
  (when (= (length shadow-side) 0)
    (get-shadow-side))
  (append
   ;; create normal window border
   (create-border-frame-parts get-border-color
                              get-border-offset
                              get-border-width
                              mode)
   ;; create fake shadow if necessary
   (when (and mxflat:fake-shadow
              (or (not mxflat:fake-shadow-focused-only)
                  (eq w (input-focus))))
     (create-border-frame-parts get-shadow-color
                                get-shadow-width
                                get-shadow-offset
                                mode
                                shadow-side))))

;; create the (small) line between titlebar and contents window
(define (create-titlebar-contents-border)
  `(((class      . middle-border)
     (background . ,get-border-color-titlebar-contents)
     (height     . ,(lambda ()
                      mxflat:border-width-titlebar-contents))
     (top-edge   . ,(lambda ()
                      (- (get-border-offset)
                         mxflat:border-width-titlebar-contents)))
     (left-edge  . ,get-border-offset)
     (right-edge . ,get-border-offset))))

;; return a top border (for shaded-transient)
(define (create-top-border)
  `(((class      . top-border)
     (background . ,get-border-color)
     (height     . ,(lambda (w) (get-border-width w 'top)))
     (top-edge   . ,(lambda (w) (get-neg-border-width w 'top)))
     (left-edge  . 0)
     (right-edge . 0))))

;;  -------
;;; BUTTONS
;;  -------


;; create, scale and cache an image
(define (get-image img)
  (or (table-ref icon-cache img)
      (let ((image
             (if mxflat:scale-buttons
                 (scale-image (make-image img) mxflat:button-scale
                              mxflat:button-scale)
               (make-image img))))
        (table-set icon-cache img image)
        image)))

;;
;; buttons:colors
;;

(define (get-button-bgcolor #!optional edge)
  (cond (mxflat:title-gradient
         (let* ((index
                 (if (eq edge 'right-edge)
                     (1- (length (titlebar-gradient-colors)))
                   0)))
           `((inactive             . ,(adjust-titlebar-bgcolor index))
             (focused              . ,(nth index (titlebar-gradient-colors)))
             (highlighted          . ,(adjust-titlebar-bgcolor index))
             (inactive-highlighted . ,(nth index (titlebar-gradient-colors)))
             (clicked              . ,(adjust-titlebar-bgcolor index))
             (inactive-clicked     . ,(nth index
                                           (titlebar-gradient-colors))))))
        (mxflat:custom-button-colors
         `((inactive             . ,mxflat:button-bgcolor-unfocused)
           (focused              . ,mxflat:button-bgcolor-focused)
           (highlighted          . ,mxflat:button-bgcolor-highlighted)
           (inactive-highlighted . ,mxflat:button-bgcolor-inactive-highlighted)
           (clicked              . ,mxflat:button-bgcolor-clicked)
           (inactive-clicked     . ,mxflat:button-bgcolor-inactive-clicked)))
        (t
         `((inactive             . ,mxflat:titlebar-bgcolor-unfocused)
           (focused              . ,mxflat:titlebar-bgcolor-focused)
           (highlighted          . ,mxflat:titlebar-bgcolor-unfocused)
           (inactive-highlighted . ,mxflat:titlebar-bgcolor-focused)
           (clicked              . ,mxflat:text-color-unfocused)
           (inactive-clicked     . ,mxflat:text-color-unfocused)))))


;;
;; buttons:icons
;;

;; return a list of 4 different image objects as needed for the button
;; fg images/icons
(define (get-images img)
  (let ((image (get-image (concat "button-icons/"
                                  (symbol-name mxflat:button-icon-set)
                                  "/"
                                  img))))
    (list image
          (copy-image image)
          (copy-image image)
          (copy-image image))))

(defvar get-menu-button1 (get-images "button-menu.png"))
(define (get-menu-button w)
  (if mxflat:menu-button-icon
      (or (table-ref icon-cache w)
          (or (let ((icon (window-icon-image w)))
                (when icon
                  (let ((scaled
                         (scale-image icon mxflat:menu-button-scale
                                      mxflat:menu-button-scale)))
                    (table-set icon-cache w scaled)
                    scaled)))
              get-menu-button1))
    get-menu-button1))

(defvar get-shade-button1 (get-images "button-shade1.png"))
(defvar get-shade-button2 (get-images "button-shade2.png"))
(define (get-shade-button w)
  (if (window-get w 'shaded)
      get-shade-button2
    get-shade-button1))

(defvar get-sticky-button1 (get-images "button-sticky1.png"))
(defvar get-sticky-button2 (get-images "button-sticky2.png"))
(define (get-sticky-button w)
  (if (window-get w 'sticky)
      get-sticky-button2
    get-sticky-button1))

(defvar get-iconify-button (get-images "button-minimize.png"))

(defvar get-maximize-button1 (get-images "button-maximize1.png"))
(defvar get-maximize-button2 (get-images "button-maximize2.png"))
(define (get-maximize-button w)
  (if (window-maximized-p w)
      get-maximize-button2
    get-maximize-button1))

(defvar get-close-button (get-images "button-close.png"))

(defvar get-previous-button1 (get-images "button-previous1.png"))
(defvar get-previous-button2 (get-images "button-previous2.png"))
(define (get-previous-button w)
  (if (or (window-in-workspace-p w (- (get-first-workspace) 1))
          (window-get w 'sticky))
      get-previous-button2
    get-previous-button1))

(defvar get-next-button1 (get-images "button-next1.png"))
(defvar get-next-button2 (get-images "button-next2.png"))
(define (get-next-button w)
  (if (or (window-in-workspace-p w (- (get-last-workspace) 1))
          (window-get w 'sticky))
      get-next-button2
    get-next-button1))

(defvar get-configure-button (get-images "button-configure.png"))

(defvar get-info-button (get-images "button-info.png"))

(defvar get-always-on-top-button1 (get-images "button-a1.png"))
(defvar get-always-on-top-button2 (get-images "button-a2.png"))
(define (get-always-on-top-button w)
  (if (> (window-get w 'depth) 0)
      get-always-on-top-button2
    get-always-on-top-button1))

(defvar get-lock-button1 (get-images "button-lock1.png"))
(defvar get-lock-button2 (get-images "button-lock2.png"))
(define (get-lock-button w)
  (if (window-get w 'fixed-position)
      get-lock-button2
    get-lock-button1))

;;
;; buttons:fg recolor
;;

;; this function is stolen from the crux sawfish theme (the theme is
;; included in the original sawfish package)
(setq recolor-all
      (lambda ()
        (let* ((recolorer (lambda (color1 color2)
                            (make-image-recolorer
                             (if mxflat:custom-button-colors
                                 color1
                               color2)
                             #:zero-channel blue-channel
                             #:index-channel red-channel)))

               ;; unfocused
               (recolorer1 (recolorer
                            mxflat:button-fgcolor-inactive
                            mxflat:text-color-unfocused))
               ;; focused
               (recolorer2 (recolorer
                            mxflat:button-fgcolor-focused
                            mxflat:text-color-focused))
               ;; highlighted
               (recolorer3 (recolorer
                            mxflat:button-fgcolor-highlighted
                            mxflat:text-color-unfocused))
               ;; clicked
               (recolorer4 (recolorer
                            mxflat:button-fgcolor-clicked
                            mxflat:text-color-focused)))
          (mapc (lambda (x)
                  (apply recolorer1 x)
                  (apply recolorer2 (cdr x))
                  (if (> (length x) 2)
                      (apply recolorer3 (nthcdr 2 x)))
                  (if (> (length x) 3)
                      (apply recolorer4 (nthcdr 3 x))))

                ;; list of all button fg icon lists that we have to recolor
                (list get-menu-button1 get-shade-button1
                      get-shade-button2 get-sticky-button1
                      get-sticky-button2 get-iconify-button
                      get-maximize-button1 get-maximize-button2
                      get-close-button get-previous-button1
                      get-previous-button2 get-next-button1
                      get-next-button2 get-configure-button
                      get-info-button get-always-on-top-button1
                      get-always-on-top-button2 get-lock-button1
                      get-lock-button2)))))

;;
;; buttons:define classes
;;

;; missing button frame part classes
;; all other classes are defined by sawfish by default - it are always
;; 2 classes, one with the default key binding and one with the custom
;; (user defined) one

(define-frame-class 'configure-button-custom
  '((keymap . mxflat:configure-button-keymap)))

(define-frame-class 'configure-button
  '((keymap . configure-button-keymap)))

(define-frame-class 'info-button-custom
  '((keymap . mxflat:info-button-keymap)))

(define-frame-class 'info-button
  '((keymap . info-button-keymap)))

(define-frame-class 'next-button-custom
  '((keymap . mxflat:next-button-keymap)))

(define-frame-class 'next-button
  '((keymap . next-button-keymap)))

(define-frame-class 'previous-button-custom
  '((keymap . mxflat:previous-button-keymap)))

(define-frame-class 'previous-button
  '((keymap . previous-button-keymap)))

(define-frame-class 'sticky-button-custom
  '((keymap . mxflat:sticky-button-keymap)))

(define-frame-class 'sticky-button
  '((keymap . sticky-button-keymap)))

(define-frame-class 'always-on-top-button-custom
  '((keymap . mxflat:always-on-top-button-keymap)))

(define-frame-class 'always-on-top-button
  '((keymap . always-on-top-button-keymap)))

(define-frame-class 'lock-button-custom
  '((keymap . mxflat:lock-button-keymap)))

(define-frame-class 'lock-button
  '((keymap . lock-button-keymap)))

;;
;; buttons:creation
;;

;; this function actually creates a button frame part and returns it
(define (create-button-frame-part classs fg edge x-pos y-pos backgroun
                                  backgroundd)
  ;; button frame part definition
  `((class        . ,classs)
    (,backgroun   . ,backgroundd)
    (render-scale . ,mxflat:gradient-scale)
    (foreground   . ,fg)
    (x-justify    . center)
    (y-justify    . center)
    (,edge        . ,x-pos)
    (top-edge     . ,y-pos)
    (height       . ,get-button-size)
    (width        . ,get-button-size)))

;; gather all necessary arguments and then call create-button-frame-part
;; to actually create the button
(define (create-button button-type #!optional x-pos-default)
  (let ((x-pos-raw
         ;; raw position, creatue-button-frame-part does some more
         ;; calculations on it
         (if mxflat:customize-buttons
             (check-symbol "mxflat:" button-type "-button-position")
           (if x-pos-default x-pos-default 0))))

    ;; position = 0 means the button is not displayed so we can save
    ;; some time be not doing all these evaluations
    (if (not (= x-pos-raw 0))
        (let* (;; if the position parameter (x-pos-raw) for the
               ;; current button is positive it starts on the right
               ;; side
               (edge (if (> x-pos-raw 0) 'right-edge 'left-edge))

               ;; default button background mode (ie static color)
               (backgroun 'background)
               (backgroundd (get-button-bgcolor edge))

               ;; button x offset from the left/right titlebar edge
               (x-pos (lambda ()
                        (+ (- (calculate-position (abs x-pos-raw))
                              mxflat:border-offset)
                           (if (> x-pos-raw 0)
                               mxflat:button-right-offset
                             mxflat:button-left-offset))))

               ;; different top positions for different
               ;; mxflat:button-y-alignment but only in case
               ;; mxflat:customize-button-size is true because in the
               ;; other case the buttons height and width is equal to
               ;; the titlebar height
               (y-pos (lambda ()
                        (if mxflat:customize-button-size
                            (case mxflat:button-y-alignment
                              ((top)
                               (get-neg-title-height))
                              ((bottom)
                               (+ (get-neg-title-height)
                                  (- mxflat:title-height
                                     (get-button-size))))
                              (t  ; this is the center case
                               (+ (get-neg-title-height)
                                  (/ (- mxflat:title-height
                                        (get-button-size))
                                     2))))
                          ;; in case the size is the default we start
                          ;; on top of the titlebar
                          (get-neg-title-height)))))

          ;; in case of a gradient titlebar bg change the button bg to
          ;; rendering
          (cond ((and mxflat:title-gradient
                      (or (eq mxflat:gradient-direction 'vertical)
                          (eq mxflat:gradient-direction 'diagonal)))
                 (setq backgroun 'renderer)
                 (setq backgroundd render-bg)))

          (create-button-frame-part
           ;; decide which frame part (and indirectly which keymap) to
           ;; use
           (if (check-symbol "mxflat:customize-" button-type "-keymap")
               (get-symbol button-type "-button-custom")
             (get-symbol button-type "-button"))
           ;; button fg images/icons
           (check-symbol "get-" button-type "-button")
           edge
           x-pos
           y-pos
           backgroun
           backgroundd)))))

;; create a list of button frame parts and return it
(define (create-buttons)
  ;; create a list of all custom buttons if the button
  ;; position model is not none (none means no buttons)
  (if (not (eq mxflat:button-position-model 'none))
      (list
       (create-button "menu" -1)
       (create-button "shade" -2)
       (create-button "iconify" +3)
       (create-button "maximize" +2)
       (create-button "close" +1)
       (create-button "sticky")
       (create-button "next")
       (create-button "previous")
       (create-button "configure")
       (create-button "info")
       (create-button "always-on-top")
       (create-button "lock"))))

;;  -------
;;; CORNERS
;;  -------

;;
;; corners:size
;;

(define (get-corner-width-adjustment w #!optional side)
  (if (or (and (window-maximized-vertically-p w)
               (or (eq side 'top)
                   (eq side 'bottom)))
          (and (window-maximized-horizontally-p w)
               (or (eq side 'left)
                   (eq side 'right))))
      mxflat:corner-width-adjustment-maximized
    mxflat:corner-width-adjustment))

(define (get-corner-width w #!optional frame-type side)
  (if (and (eq frame-type 'shaded)
           (> (get-corner-width-adjustment w side)
              (/ (get-title-height) 2))
           (eq mxflat:corner-direction 'inside))
      (/ (1+ (get-title-height)) 2)
    (+ (get-corner-width-adjustment w side)
       (get-border-width w side))))

(define (get-corner-length w #!optional frame-type)
  (if (= mxflat:corner-length-adjustment -1)
      0
    (+ (+ (if (and (eq frame-type 'shaded)
                   (> mxflat:corner-length-adjustment
                      (/ (get-title-height) 2)))
              (/ (1+ (get-title-height)) 2)
            mxflat:corner-length-adjustment)
          (get-border-width w 'top))
       (if (eq mxflat:corner-direction 'inside)
           0
         (get-corner-width-adjustment w)))))

;;
;; corners:position
;;

;; get top or bottom position
(define (get-corner-1-pos w side part #!optional frame-type)
  (- (if (eq side 'bottom)
         (if (eq frame-type 'shaded)
             (+ (if (eq part 'b)
                    (+ (- (get-corner-length w frame-type))
                       (get-corner-width w frame-type side))
                  0)
                (- (get-border-offset)
                   mxflat:border-width-titlebar-contents))
           (get-neg-border-width w side))
       (if (eq frame-type 'transient)
           (get-neg-border-width w 'top)
         (get-neg-titlebar-height w)))
     (if (and (eq frame-type 'shaded)
              (eq side 'bottom))
         (if (eq mxflat:corner-direction 'inside)
             (get-corner-width-adjustment w side)
           0)
       (if (eq mxflat:corner-direction 'inside)
           0
         (get-corner-width-adjustment w side)))))

;; get left or right position
(define (get-corner-2-pos w side)
  (- (get-neg-border-width w side)
     (if (eq mxflat:corner-direction 'inside)
         0
       (get-corner-width-adjustment w side))))

;;
;; corners:creation
;;

;; create the two corner lists a real corner consists of
(define (create-corner classs edgee1 side1 edgee2 side2 frame-type)
  `(((class      . ,classs)
     (background . ,get-border-color)
     (width      . ,get-corner-length)
     (height     . ,(lambda (w) (get-corner-width w frame-type side1)))
     (,edgee1    . ,(lambda (w) (get-corner-1-pos w side1 'a frame-type)))
     (,edgee2    . ,(lambda (w) (get-corner-2-pos w side2))))
    ((class      . ,classs)
     (background . ,get-border-color)
     (width      . ,(lambda (w) (get-corner-width w frame-type side2)))
     (height     . ,(lambda (w) (get-corner-length w frame-type)))
     (,edgee1    . ,(lambda (w) (get-corner-1-pos w side1 'b frame-type)))
     (,edgee2    . ,(lambda (w) (get-corner-2-pos w side2))))))

;; this function actually creates the 4 window corners and returns
;; them
(define (create-corners #!optional frame-type)
  (if mxflat:show-corners
      (let ((edgee1 'top-edge)
            (edgee2 'bottom-edge))
        (if (eq frame-type 'shaded)
            (setq edgee2 'top-edge))
        (append
         (create-corner 'top-left-corner edgee1 'top 'left-edge
                        'left frame-type)
         (create-corner 'top-right-corner edgee1 'top 'right-edge
                        'right frame-type)
         (create-corner 'bottom-left-corner edgee2 'bottom 'left-edge
                        'left frame-type)
         (create-corner 'bottom-right-corner edgee2 'bottom 'right-edge
                        'right frame-type)))))

;;  --------------
;;; REGISTER THEME
;;  --------------
;;
;; "Normal" 'default
;; "Title-only" 'shaped
;; "Border-only" 'transient
;; "Top-border" 'shaped-transient
;; "None" 'unframed

;; return the window frame and decorations
(define (get-frame w frame-type)
  (let* (;; window with all decorations
         (defaul (lambda ()
                   (append (titlebar)
                           (create-titlebar-contents-border)
                           (create-borders w)
                           (create-buttons)
                           (create-corners))))

         ;; window with contents frame only
         (transien (lambda ()
                     (append (create-borders w 'transient)
                             (create-corners 'transient))))

         (titleba (lambda (#!optional mode)
                    (if mode
                        (titlebar)
                      (append (titlebar) (create-buttons)))))

         ;; window that is shaded
         (shade (lambda (#!optional titlebar-mode)
                  (if mxflat:keep-borders-when-shaded
                      (append (titleba titlebar-mode)
                              (create-titlebar-contents-border)
                              (create-borders w)
                              (create-corners))
                    (append (titleba titlebar-mode)
                            (create-borders w 'shaded)
                            (create-corners 'shaded)))))

         (check (lambda (mode)
                  (cond
                   ((eq mxflat:decoration-mode 'none)
                    (transien))
                   ((eq mxflat:decoration-mode 'all)
                    (defaul))
                   (t
                    (mode))))))

    (case frame-type
      ((default)
       (check defaul))
      ((transient)
       (check transien))
      ((shaped shaded)
       (if (eq mxflat:decoration-mode 'none)
           (shade 'no-buttons)
         (shade)))
      ((shaded-transient)
       (if (eq mxflat:decoration-mode 'all)
           (shade)
         (shade 'no-buttons)))
      ((shaped-transient)
       (create-top-border)))))

;; setup initial colors
(recolor-all)
(after-set-title-update-interval)
;; register theme with sawfish
(add-frame-style 'mxflat get-frame)

;;; END

;; -*- indent-tabs-mode: nil -*-
;;
;; File: undo.jl
;; Version: $Revision: 1.4 $
;; Description: 
;;     Remembers window activity (moving, resizing, iconifying, shading,
;;     workspace switching) and lets you undo it.
;;
;;     Do you ever accidentally move a window, and then have to tediously
;;     replace it where it used to be?  Ever hit a "clean up this cluttered
;;     desktop" command, and decide that the results are worse than what you
;;     started with?
;;
;; Installation:
;;     Install this file, and add the following lines to your .sawmillrc:
;;
;; (setq load-path (cons "/directory/containing/this/file/" load-path))
;; (require 'undo)
;;
;;     And then bind the "undo" and "undo-redo" commands to two handy keys.
;;
;; Author:
;;     Terry Weissman <terry@weissman.org>
;;     Latest version can be found at http://www.weissman.org/sawfish
;;
;; Changelog:
;;    $Log: undo.jl,v $
;;    Revision 1.4  2000/09/11 15:34:50  weissman
;;    Added missing 'require' line.
;;
;;    Revision 1.3  2000/05/31 21:29:05  terry
;;    Added support for the repel package.  Also, put in some not-yet-working
;;    stuff for undoing stacking order changes.
;;
;;    Revision 1.2  2000/05/23 16:47:24  terry
;;    "redo" should be a no-op if the last relevant operation was not an "undo".
;;    Also, fixed compiler warnings.
;;


(require 'timers)

(defvar l "")

(defun undo-eval (cmd)
;  (grab-server)
  (eval cmd)
;  (ungrab-server)
;  (display-message (format nil "%S" cmd))
)

(defun undo-record (l)
  (setq undo-curcmd-list (cons l undo-curcmd-list)))

(defun undo ()
  "Undo last window move or resize"
  (interactive)
  (let ((cmd (car undo-list))
        (x (cdr undo-list))
        (r undo-redo-list))
    (setq undo-list ())
    (setq undo-curcmd-list ())
    (undo-eval cmd)
    (undo-transfer-to-undo-list)
    (if undo-list
        (setq r (cons (car undo-list) r)))
    (setq undo-redo-list r)
    (setq undo-list x)
    (setq undo-curcmd-list ())))


(defun undo-redo ()
  "Redo last window move or resize"
  (interactive)
  (let ((cmd (car undo-redo-list))
        (r (cdr undo-redo-list)))
    (undo-eval cmd)
    (make-timer (lambda () (setq undo-redo-list r)) 0 1)))


(defun undo-record-move (w)
  (let ((oldloc (window-get w 'undo-loc))
        (newloc (window-position w)))
    (if oldloc
        (unless (equal oldloc newloc)
          (undo-record (list 'move-window-to w (car oldloc) (cdr oldloc)))))
    (window-put w 'undo-loc newloc)))
  
    
(defun undo-record-resize (w)
  (let ((oldsize (window-get w 'undo-size))
        (newsize (window-dimensions w)))
    (if oldsize
        (unless (equal oldsize newsize)
          (undo-record (list 'resize-window-to w (car oldsize) (cdr oldsize)))))
    (window-put w 'undo-size newsize)))
  
    
(defun undo-record-stacking-for-real ()
;  (undo-pre-command)
  (setq l (concat l "s"))
  (let ((newstack (stacking-order)))
    (unless (equal undo-cur-stack newstack)
      (undo-record `(restack-windows (quote ,undo-cur-stack)))
      (setq undo-cur-stack newstack)))
;  (undo-post-command)
)

(defun undo-record-stacking ()
  ; Doing the real stuff now seems to cause weird event-droppings or something.
  ; So, we will just do it soon.
 ; (setq undo-check-stacking t)
  (undo-record-stacking-for-real))

        
       

(defun undo-record-workspace (w)
  (undo-record (list 'select-workspace w)))


(defun undo-record-iconify (w)
  (undo-record (list 'uniconify-window w)))

(defun undo-record-uniconify (w)
  (undo-record (list 'iconify-window w)))

(defun undo-record-shade (w)
  (undo-record (list 'unshade-window w)))

(defun undo-record-unshade (w)
  (undo-record (list 'shade-window w)))


(defun undo-transfer-to-undo-list ()
  (if undo-check-stacking
      (progn
	(undo-record-stacking-for-real)
	(setq undo-check-stacking nil)))
  (if undo-curcmd-list
      (progn
        (setq undo-list (cons (cons 'progn undo-curcmd-list) undo-list))
        (setq undo-curcmd-list nil)
        (setq undo-redo-list nil)
        (while (> (length undo-list) 50)
          (setq undo-list (nreverse (cdr (nreverse undo-list))))))))

  
(defun undo-transfer-if-done ()
  (unless (or undo-in-command undo-in-interactive (< 0 undo-group-depth))
    (undo-transfer-to-undo-list)))


(defun undo-pre-command ()
  (setq undo-in-command t))

(defun undo-post-command ()
  (setq undo-in-command nil)
 ( undo-transfer-if-done))

(defun undo-pre-interactive ()
  (setq undo-in-interactive t))

(defun undo-post-interactive (w)
  (setq undo-in-interactive nil)
  (undo-record-resize w)                ;These two lines shouldn't be
  (undo-record-move w)                  ;necessary, but they don't hurt...
  (undo-transfer-if-done))

(defun undo-start-group ()
  (setq undo-group-depth (+ undo-group-depth 1)))

(defun undo-end-group ()
  (setq undo-group-depth (- undo-group-depth 1))
  (undo-transfer-if-done))


(defun undo-record-all-locs ()
  (setq undo-cur-stack (stacking-order))
  (map-windows (lambda (w)
                 (window-put w 'undo-loc (window-position w))
                 (window-put w 'undo-size (window-dimensions w)))))



;;;;; Initialize global variables.

(defvar undo-list ())

(defvar undo-redo-list ())

(defvar undo-curcmd-list ())

(defvar undo-in-command nil)

(defvar undo-in-interactive nil)

(defvar undo-cur-stack nil)

(defvar undo-check-stacking nil)

(defvar undo-group-depth 0)



;;;;; Set hooks for operations that we want to be able to undo.


(unless (in-hook-p 'window-moved-hook undo-record-move)
  (add-hook 'window-moved-hook undo-record-move))

(unless (in-hook-p 'window-resized-hook undo-record-resize)
  (add-hook 'window-resized-hook undo-record-resize))

(unless (in-hook-p 'leave-workspace-hook undo-record-workspace)
  (add-hook 'leave-workspace-hook undo-record-workspace))

(unless (in-hook-p 'iconify-window-hook undo-record-iconify)
  (add-hook 'iconify-window-hook undo-record-iconify))

(unless (in-hook-p 'uniconify-window-hook undo-record-uniconify)
  (add-hook 'uniconify-window-hook undo-record-uniconify))

(unless (in-hook-p 'shade-window-hook undo-record-shade)
  (add-hook 'shade-window-hook undo-record-shade))

(unless (in-hook-p 'unshade-window-hook undo-record-unshade)
  (add-hook 'unshade-window-hook undo-record-unshade))

; (unless (in-hook-p 'after-restacking-hook undo-record-stacking)
;   (add-hook 'after-restacking-hook undo-record-stacking))

; (unless (in-hook-p 'window-depth-changed-hook undo-record-stacking)
;   (add-hook 'window-depth-changed-hook undo-record-stacking))

; (unless (in-hook-p 'visibilty-notify-hook undo-record-stacking)
;   (add-hook 'visibilty-notify-hook undo-record-stacking))



;;;;; Set hooks for operations that tend to group un-do-able operations.

(unless (in-hook-p 'pre-command-hook undo-pre-command)
  (add-hook 'pre-command-hook undo-pre-command))

(unless (in-hook-p 'post-command-hook undo-post-command)
  (add-hook 'post-command-hook undo-post-command))

(unless (in-hook-p 'before-move-hook undo-pre-interactive)
  (add-hook 'before-move-hook undo-pre-interactive))

(unless (in-hook-p 'after-move-hook undo-post-interactive)
  (add-hook 'after-move-hook undo-post-interactive))

(unless (in-hook-p 'before-resize-hook undo-pre-interactive)
  (add-hook 'before-resize-hook undo-pre-interactive))

(unless (in-hook-p 'after-resize-hook undo-post-interactive)
  (add-hook 'after-resize-hook undo-post-interactive))



;;; Remember the initial size and locations of all windows, so that if they
;;; change we will know what their old values were.

(make-timer undo-record-all-locs 1 0)


; (setq log "")
; (add-hook 'window-moved-hook (lambda () (setq log (concat log "*"))))
; (add-hook 'before-move-hook (lambda () (setq log (concat log "m"))))
; (add-hook 'after-move-hook (lambda () (setq log (concat log "M"))))
; (add-hook 'pre-command-hook (lambda () (setq log (concat log "c"))))
; (add-hook 'post-command-hook (lambda () (setq log (concat log "C"))))

;; edge/misc.jl -- misc actions for EdgeActions

;; Copyright (C) 2011 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.edge.misc

    (export maximize-action
            kill-action
	    iconify-action
	    move-window-viewport-action
	    move-window-workspace-action)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.events
	  sawfish.wm.state.maximize
	  sawfish.wm.state.iconify
	  sawfish.wm.viewport
	  sawfish.wm.workspace
	  sawfish.wm.ext.workspace-grid)

  (define-structure-alias edge-misc sawfish.wm.edge.misc)

  (define (maximize-action)
    (let ((w (input-focus)))
      (allow-events 'async-both)
      (fake-release-window)
      (maximize-window w)))

  (define (kill-action)
    (let ((w (input-focus)))
      (allow-events 'async-both)
      (fake-release-window)
      (delete-window-safely w)))

  (define (iconify-action)
    (let ((w (input-focus)))
      (allow-events 'async-both)
      (fake-release-window)
      (iconify-window w)))

  (define (move-window-viewport-action edge)
    (let ((w (input-focus))
          (func (case edge
                   ((left) move-window-left)
                   ((right) move-window-right)
                   ((top) move-window-up)
                   ((bottom) move-window-down))))
      (allow-events 'async-both)
      (fake-release-window)
      (funcall func w)))

  (define (move-window-workspace-action edge)
    (let ((w (input-focus))
          (func (case edge
                   ((left) send-to-workspace-left)
                   ((right) send-to-workspace-right)
                   ((top) send-to-workspace-up)
                   ((bottom) send-to-workspace-down))))
      (allow-events 'async-both)
      (fake-release-window)
      (funcall func w 1))))

;; tooltips.jl -- display frame-part keymap descriptions

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.tooltips

    (export display-tooltip
	    display-tooltip-after-delay
	    remove-tooltip)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.timers
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.colors
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.frames
	  sawfish.wm.events
	  sawfish.wm.util.keymap)

  (define-structure-alias tooltips sawfish.wm.ext.tooltips)

  (define tooltips-timer nil)

  ;;###autoload (defgroup tooltips "Tooltips" :group appearance :require sawfish.wm.ext.tooltips)

  (defgroup tooltips "Tooltips"
    :group appearance
    :require sawfish.wm.ext.tooltips)

  (defcustom tooltips-enabled nil
    "Display tooltips for window frames."
    :type boolean
    :group (appearance tooltips)
    :require sawfish.wm.ext.tooltips)

  (defcustom tooltips-show-doc-strings nil
    "Show full documentation in tooltips."
    :type boolean
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-delay 500
    "Number of milliseconds before displaying tooltips."
    :type number
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-timeout-delay 5000
    "Number of milliseconds before removing tooltips."
    :type number
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-font default-font
    "Font used to display tooltips, or nil for default."
    :type font
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-background-color "grey85"
    "Color used for the tooltips background"
    :type color
    :depends tooltips-enabled
    :group (appearance tooltips))

  (defcustom tooltips-foreground-color "black"
    "Color used for the tooltips foreground"
    :type color
    :depends tooltips-enabled
    :group (appearance tooltips))

;;; displaying tooltips

  ;; the window it's displayed for (or t)
  (define tooltips-displayed nil)

  (define (display-tooltip text #!optional win)
    (let ((pos (query-pointer))
	  (pos-fn (lambda (in size inc)
		    (if (< in (/ size 2))
			(+ in inc)
		      (- (+ (- size in) inc))))))
      (rplaca pos (pos-fn (car pos) (screen-width) 0))
      (rplacd pos (pos-fn (cdr pos) (screen-height) 16))
      (display-message (if (functionp text) (text) text)
		       `((position . ,pos)
			 (background . ,tooltips-background-color)
			 (foreground . ,tooltips-foreground-color)
			 (x-justify . left)
			 (spacing . 2)
			 ,@(and tooltips-font
				(list (cons 'font tooltips-font)))))
      (setq tooltips-displayed (or win t))
      (setq tooltips-timer
	    (make-timer remove-tooltip
			(quotient tooltips-timeout-delay 1000)
			(mod tooltips-timeout-delay 1000)))
      (unless (in-hook-p 'pre-command-hook remove-tooltip)
	(add-hook 'pre-command-hook remove-tooltip))))

  (define (remove-tooltip)
    (remove-hook 'pre-command-hook remove-tooltip)
    (when tooltips-displayed
      (display-message nil)
      (setq tooltips-displayed nil))
    (when tooltips-timer
      (delete-timer tooltips-timer)
      (setq tooltips-timer nil)))

  (define (tooltips-unmapped win)
    (when (eq win tooltips-displayed)
      (remove-tooltip)))

  (add-hook 'unmap-notify-hook tooltips-unmapped)

  (define (call-after-delay thunk)
    (remove-tooltip)
    (when tooltips-enabled
      (setq tooltips-timer (make-timer (lambda ()
					 (setq tooltips-timer nil)
					 (thunk))
				       (quotient tooltips-delay 1000)
				       (mod tooltips-delay 1000)))
      (unless (in-hook-p 'pre-command-hook remove-tooltip)
	(add-hook 'pre-command-hook remove-tooltip))))

  (define (display-tooltip-after-delay . args)
    (call-after-delay (lambda ()
			(apply display-tooltip args))))

;;; frame-part tooltips

  ;; each item is (EVENT-DESC . DOC)
  (define (tooltips-format items)
    (let ((max-event-width 0)
	  (split (lambda (s)
		   (let (point parts)
		     (while (string-match "\n" s point)
		       (setq parts (cons (substring
					  s (or point 0) (match-start)) parts))
		       (setq point (match-end)))
		     (setq parts (cons (substring s (or point 0)) parts))
		     (nreverse parts))))
	  out)
      (mapc (lambda (cell)
	      (setq max-event-width (max max-event-width (length (car cell)))))
	    items)
      (setq max-event-width (1+ max-event-width))
      (mapc (lambda (cell)
	      (setq out (cons (car cell) out))
	      (setq out (cons (make-string (- max-event-width
					      (length (car cell))) ? ) out))
	      (let ((parts (split (cdr cell))))
		(when parts
		  (setq out (cons (car parts) out))
		  (setq out (cons ?\n out)))
		(mapc (lambda (string)
			(setq out (cons (make-string max-event-width ? ) out))
			(setq out (cons string out))
			(setq out (cons ?\n out))) (cdr parts)))) items)
      (apply concat (nreverse out))))

  (define (command-info command)
    (let (doc)
      (if (and tooltips-show-doc-strings command
	       (symbolp command)
	       (setq doc (command-documentation command)))
	  (_ doc)
	(format nil "%S" command))))

  (define (display-fp-tooltip fp)
    (let ((keymap (frame-part-get fp 'keymap))
	  items)
      (when (symbolp keymap)
	(setq keymap (symbol-value keymap)))
      (when (cdr keymap)
	(map-keymap (lambda (cell)
		      (setq items (cons (cons (event-name (cdr cell))
					      (command-info (car cell))) items)))
		    keymap)
	(display-tooltip (tooltips-format (nreverse items))))))

  (define (tooltips-fp-enter win fp)
    (declare (unused win))
    (when tooltips-enabled
      (call-after-delay (lambda ()
			  (unless (clicked-frame-part)
			    (display-fp-tooltip fp))))))

  (add-hook 'enter-frame-part-hook tooltips-fp-enter)
  (add-hook 'leave-frame-part-hook remove-tooltip))

;; autoload.jl -- Initialise auto-load functions

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

;; to rebuild this file, load a tags file containing all lisp files
;; into Jade, then run:

;; (tags-map-buffers
;;  (lambda (buffer)
;;    (add-autoloads "SOURCE-DIR/lisp/sawfish/wm/autoload.jl" buffer)))

;;; ::autoload-start::
(autoload-command 'customize 'sawfish.wm.customize)
(autoload-command 'popup-window-ops-menu 'sawfish.wm.menus)
(autoload-command 'popup-root-menu 'sawfish.wm.menus)
(autoload-command 'popup-apps-menu 'sawfish.wm.menus)
(autoload-command 'popup-window-list-menu 'sawfish.wm.menus)
(autoload-window-animator 'wireframe 'sawfish.wm.animation.main)
(autoload-window-animator 'solid 'sawfish.wm.animation.main)
(autoload-window-animator 'cross 'sawfish.wm.animation.main)
(autoload-window-animator 'elliptical 'sawfish.wm.animation.main)
(autoload-window-animator 'draft 'sawfish.wm.animation.main)
(autoload-command 'next-workspace-window 'sawfish.wm.commands.cycle)
(autoload-command 'previous-workspace-window 'sawfish.wm.commands.cycle)
(autoload-command 'next-window 'sawfish.wm.commands.cycle)
(autoload-command 'previous-window 'sawfish.wm.commands.cycle)
(autoload-command 'describe-symbol 'sawfish.wm.commands.describe)
(autoload-command 'describe-symbol-to-screen 'sawfish.wm.commands.describe)
(autoload-command 'apropos-function 'sawfish.wm.commands.describe)
(autoload-command 'apropos-function-to-screen 'sawfish.wm.commands.describe)
(autoload-command 'apropos-variable 'sawfish.wm.commands.describe)
(autoload-command 'apropos-variable-to-screen 'sawfish.wm.commands.describe)
(autoload-command 'make-group-sticky 'sawfish.wm.commands.groups)
(autoload-command 'make-group-unsticky 'sawfish.wm.commands.groups)
(autoload-command 'toggle-group-sticky 'sawfish.wm.commands.groups)
(autoload-command 'send-group-to-current-workspace 'sawfish.wm.commands.groups)
(autoload-command 'send-group-to-next-workspace 'sawfish.wm.commands.groups)
(autoload-command 'send-group-to-previous-workspace 'sawfish.wm.commands.groups)
(autoload-command 'move-group-to-current-viewport 'sawfish.wm.commands.groups)
(autoload-command 'move-group-left 'sawfish.wm.commands.groups)
(autoload-command 'move-group-right 'sawfish.wm.commands.groups)
(autoload-command 'move-group-up 'sawfish.wm.commands.groups)
(autoload-command 'move-group-down 'sawfish.wm.commands.groups)
(autoload-command 'raise-group 'sawfish.wm.commands.groups)
(autoload-command 'lower-group 'sawfish.wm.commands.groups)
(autoload-command 'raise-lower-group 'sawfish.wm.commands.groups)
(autoload-command 'raise-group-depth 'sawfish.wm.commands.groups)
(autoload-command 'lower-group-depth 'sawfish.wm.commands.groups)
(autoload-command 'delete-group 'sawfish.wm.commands.groups)
(autoload-command 'grow-window-left 'sawfish.wm.commands.grow-pack)
(autoload-command 'grow-window-right 'sawfish.wm.commands.grow-pack)
(autoload-command 'grow-window-up 'sawfish.wm.commands.grow-pack)
(autoload-command 'grow-window-down 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-left 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-right 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-up 'sawfish.wm.commands.grow-pack)
(autoload-command 'pack-window-down 'sawfish.wm.commands.grow-pack)
(autoload-command 'shrink-window-left 'sawfish.wm.commands.shrink-yank)
(autoload-command 'shrink-window-right 'sawfish.wm.commands.shrink-yank)
(autoload-command 'shrink-window-up 'sawfish.wm.commands.shrink-yank)
(autoload-command 'shrink-window-down 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-left 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-right 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-up 'sawfish.wm.commands.shrink-yank)
(autoload-command 'yank-window-down 'sawfish.wm.commands.shrink-yank)
(autoload-command 'help:show-faq 'sawfish.wm.commands.help)
(autoload-command 'help:show-news 'sawfish.wm.commands.help)
(autoload-command 'help:show-programmer-manual 'sawfish.wm.commands.help)
(autoload-command 'help:show-homepage 'sawfish.wm.commands.help)
(autoload-command 'help:about 'sawfish.wm.commands.help)
(autoload-command 'move-cursor-right 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-left 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-up 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-down 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-right-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-left-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-up-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-down-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northwest 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northeast 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southwest 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southeast 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northwest-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-northeast-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southwest-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-southeast-fine 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-cursor-center 'sawfish.wm.commands.move-cursor)
(autoload-command 'move-window-center 'sawfish.wm.commands.move-resize)
(autoload-command 'move-window-interactively 'sawfish.wm.commands.move-resize)
(autoload-command 'resize-window-interactively 'sawfish.wm.commands.move-resize)
(autoload-command 'move-selected-window 'sawfish.wm.commands.move-resize)
(autoload-command 'double-window-size 'sawfish.wm.commands.move-resize)
(autoload-command 'halve-window-size 'sawfish.wm.commands.move-resize)
(autoload-command 'resize-selected-window 'sawfish.wm.commands.move-resize)
(autoload-command 'raise-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-and-pass-through-click-if-focused 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-or-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-window-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-group-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'raise-transients-and-pass-through-click 'sawfish.wm.commands.raise-commands)
(autoload-command 'size-window-add-row 'sawfish.wm.commands.size-window)
(autoload-command 'size-window-subtract-row 'sawfish.wm.commands.size-window)
(autoload-command 'size-window-add-column 'sawfish.wm.commands.size-window)
(autoload-command 'size-window-subtract-column 'sawfish.wm.commands.size-window)
(autoload-command 'slide-window-left 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-window-right 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-window-up 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-window-down 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-left 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-right 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-up 'sawfish.wm.commands.slide-window)
(autoload-command 'slide-group-down 'sawfish.wm.commands.slide-window)
(defgroup cabinet "Cabinet" :group focus :require sawfish.wm.ext.cabinet)
(autoload-command 'cabinet-switch 'sawfish.wm.ext.cabinet)
(defgroup gpsy "Grow, Pack, Shrink & Yank" :group move :require sawfish.wm.commands.grow-pack)
(defgroup cycle "Window Cycling" :group focus :require sawfish.wm.commands.x-cycle)
(defgroup shade-hover "Shade Hover" :group focus :require sawfish.wm.ext.shade-hover)
(defgroup auto-raise "Auto-Raise" :group focus :require sawfish.wm.ext.auto-raise)
(autoload-command 'cycle-windows 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-windows-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-group 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-group-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-among-groups 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-among-groups-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-prefix 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-prefix-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-class 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-class-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-dock 'sawfish.wm.commands.x-cycle)
(autoload-command 'cycle-dock-backwards 'sawfish.wm.commands.x-cycle)
(autoload-command 'xterm 'sawfish.wm.commands.launcher)
(autoload-command 'browser 'sawfish.wm.commands.launcher)
(autoload-command 'poweroff 'sawfish.wm.commands.poweroff)
(autoload-command 'rename-window 'sawfish.wm.windows)
(defgroup audio "Sound" :require sawfish.wm.ext.audio-events)
(defgroup match-window "Window Rules" :layout single :require sawfish.wm.ext.match-window)
(defgroup tooltips "Tooltips" :group appearance :require sawfish.wm.ext.tooltips)
(defgroup window-history "History" :group match-window :require sawfish.wm.ext.window-history)
(defgroup messages "Messages" :group misc :require sawfish.wm.util.prompt)
(autoload-placement-mode 'first-fit 'sawfish.wm.placement.smart #:for-normal t)
(autoload-placement-mode 'best-fit 'sawfish.wm.placement.smart #:for-normal t)
(autoload-placement-mode 'best-fit-group 'sawfish.wm.placement.smart #:for-normal t)
(autoload-placement-mode 'first-fit-or-interactive 'sawfish.wm.placement.smart #:for-normal t)
(autoload-command 'maximize-window 'sawfish.wm.state.maximize)
(autoload-command 'unmaximize-window 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-vertically 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-horizontally 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-horizontally-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-window-vertically-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-vertically 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-horizontally 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-horizontally-toggle 'sawfish.wm.state.maximize)
(autoload-command 'maximize-fill-window-vertically-toggle 'sawfish.wm.state.maximize)
(autoload-command 'describe-key 'sawfish.wm.util.keymap)
(autoload-command 'describe-key-to-screen 'sawfish.wm.util.keymap)
(autoload-command 'quote-event 'sawfish.wm.util.keymap)
(autoload-placement-mode 'top-left 'sawfish.wm.placement.top-left #:for-normal t)
(autoload-placement-mode 'stagger 'sawfish.wm.placement.stagger #:for-normal t)
(autoload-placement-mode 'off-center 'sawfish.wm.placement.off-center #:for-normal t)
(autoload-command 'send-window-to-next-head 'sawfish.wm.heads)
(autoload-command 'send-window-to-previous-head 'sawfish.wm.heads)
(autoload-command 'move-viewport-right 'sawfish.wm.viewport)
(autoload-command 'move-viewport-up 'sawfish.wm.viewport)
(autoload-command 'move-viewport-down 'sawfish.wm.viewport)
(autoload-command 'move-viewport-left 'sawfish.wm.viewport)
(autoload-command 'move-window-right 'sawfish.wm.viewport)
(autoload-command 'move-window-up 'sawfish.wm.viewport)
(autoload-command 'move-window-down 'sawfish.wm.viewport)
(autoload-command 'move-window-left 'sawfish.wm.viewport)
(autoload-command 'move-viewport-next 'sawfish.wm.commands.viewport-extras)
(autoload-command 'move-viewport-previous 'sawfish.wm.commands.viewport-extras)
(autoload-command 'move-window-previous 'sawfish.wm.commands.viewport-extras)
(autoload-command 'move-window-next 'sawfish.wm.commands.viewport-extras)
(autoload-command 'workspace-down 'sawfish.wm.ext.workspace-grid)
(autoload-command 'workspace-up 'sawfish.wm.ext.workspace-grid)
(autoload-command 'workspace-left 'sawfish.wm.ext.workspace-grid)
(autoload-command 'workspace-right 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-down 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-up 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-left 'sawfish.wm.ext.workspace-grid)
(autoload-command 'send-to-workspace-right 'sawfish.wm.ext.workspace-grid)
(autoload-command 'jump-or-exec 'sawfish.wm.commands.jump-or-exec)
(autoload-command 'toggle-or-exec 'sawfish.wm.commands.jump-or-exec)
(autoload-command 'run-application 'sawfish.wm.ext.run-application)
;;; ::autoload-end::

;; workarea.jl -- calculating the usable region of a head
;;
;; Author: John Harper <jsh@unfactored.org>
;;
;; Copyright (C) 2002 John Harper
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.workarea

    (export define-window-strut
	    largest-rectangle-from-edges
	    calculate-workarea
	    calculate-workarea-from-struts)

    (open rep
	  rep.system
	  sawfish.wm.util.edges
	  sawfish.wm.util.rects
	  sawfish.wm.windows
	  sawfish.wm.workspace
          sawfish.wm.viewport
	  sawfish.wm.misc)

  (defvar workarea-changed-hook nil)
  
  (define (define-window-strut w left top right bottom)
    (let ((new (list left top right bottom))
	  (old (window-get w 'workarea-strut)))
      (unless (equal old new)
	(window-put w 'workarea-strut new)
	(call-hook 'workarea-changed-hook))))

  (define (combined-struts #!key (space current-workspace))
    (let ((struts (mapcar (lambda (x)
			    (window-get x 'workarea-strut))
			  (filter-windows
			   (lambda (x)
			     (window-appears-in-workspace-p x space))))))
      (list (apply max (cons 0 (delq nil (mapcar car struts))))
	    (apply max (cons 0 (delq nil (mapcar cadr struts))))
	    (apply max (cons 0 (delq nil (mapcar caddr struts))))
	    (apply max (cons 0 (delq nil (mapcar cadddr struts)))))))

  (define (apply-struts-to-rect struts head-rect)
    (list (+ (nth 0 head-rect) (nth 0 struts))
	  (+ (nth 1 head-rect) (nth 1 struts))
	  (- (nth 2 head-rect) (nth 2 struts))
	  (- (nth 3 head-rect) (nth 3 struts))))

  (define (largest-rectangle-from-edges edges #!key avoided head)

    (define (pred rect)
      ;; the rectangle mustn't overlap any avoided windows
      ;; or span multiple heads, or be on a different head
      ;; to that requested
      (let* ((viewport (viewport-at (nth 0 rect)
                                    (nth 1 rect)))
             (cur-vp (screen-viewport))
             (x-offset (and viewport (* (screen-width)
                                        (- (car viewport)
                                           (car cur-vp)))))
             (y-offset (and viewport (* (screen-height)
                                        (- (cdr viewport)
                                           (cdr cur-vp))))))
        (let loop ((rest avoided))
	  (cond ((null rest) (rect-within-head-p rect head))
		((> (rect-2d-overlap
		     (window-frame-dimensions (car rest))
		     (let ((pos (window-position (car rest))))
		       (if (window-get (car rest) 'sticky-viewport)
			   (cons (+ (car pos) x-offset)
				 (+ (cdr pos) y-offset))
			 pos))
		     rect)
		    0)
		 nil)
		(t (loop (cdr rest)))))))

    (let* ((grid (grid-from-edges (car edges) (cdr edges)))
	   ;; find all possible rectangles
           (rects (rectangles-from-grid (sort (car grid))
                                        (sort (cdr grid))
                                        pred)))

      ;; return the largest
      (let ((max-area 0)
	    (max-rect nil))
	(mapc (lambda (rect)
		(when (and (rect-within-viewport-p rect)
			   (> (rectangle-area rect) max-area))
		  (setq max-area (rectangle-area rect))
		  (setq max-rect rect)))
              rects)
	max-rect)))

  (define (calculate-workarea #!key window head)
    "Return the rectangle representing the largest rectangle on the
screen that doesn't overlap any avoided windows, or nil.  If HEAD is
true, then an empty workarea will be replaced with the area of HEAD,
not the current head (of WINDOW)."
    (unless head
      (setq head (current-head window)))
    (let* ((avoided (avoided-windows window))
	   ;; Find the edges of all "do not cover" windows
	   (edges (get-visible-window-edges
		   #:with-ignored-windows t
		   #:windows avoided
		   #:include-heads (list head)))
	   ;; Find the rectangle covering the current head
	   (head-rect (rectangle-from-coords (head-offset head)
					     (head-dimensions head)))
	   ;; Find the largest rectangle
	   (rect (or (largest-rectangle-from-edges
		      edges #:avoided avoided #:head head) head-rect)))
      ;; Shrink that to the union of all struts
      (rectangle-intersection
       rect (apply-struts-to-rect (combined-struts) head-rect))))

  (define (calculate-workarea-from-struts #!key (workspace current-workspace))
    (apply-struts-to-rect (combined-struts workspace)
			  (rectangle-from-coords
			   (cons 0 0) (screen-dimensions))))

  (define (on-unmap w)
    (when (window-get w 'workarea-strut)
      (call-hook 'workarea-changed-hook)))

  (add-hook 'unmap-notify-hook on-unmap))

;; recolor-image.jl -- simple code for recolouring images
;;
;; Copyright (C) 2001 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; this module is marked as being fully-safe, so don't add any
;; dangerous functions!

(define-structure sawfish.wm.util.recolor-image

    (export make-image-recolorer*
	    make-image-recolorer
	    red-channel
	    green-channel
	    blue-channel
	    alpha-channel)

    (open rep
	  sawfish.wm.images
	  sawfish.wm.colors)

  (defconst red-channel 0)
  (defconst green-channel 1)
  (defconst blue-channel 2)
  (defconst alpha-channel 3)

  (define original-key (make-symbol "recolor-image/original"))

  (define (make-image-recolorer* colors #!key
				 (zero-channel red-channel)
				 (index-channels (list green-channel))
				 (save-original t))

    ;; XXX add doc string here..

    (let* ((color-rgbs (mapcar color-rgb-8 colors))
	   (red-luts (mapcar (lambda (c)
			       (make-lut (nth red-channel c))) color-rgbs))
	   (green-luts (mapcar (lambda (c)
				 (make-lut (nth green-channel c))) color-rgbs))
	   (blue-luts (mapcar (lambda (c)
				(make-lut (nth blue-channel c))) color-rgbs)))

      (lambda (image)

	;; Get the original state of the image
	(if (image-get image original-key)
	    ;; Hmm.. don't have a blit-image function, this will do
	    (tile-image image (image-get image original-key))

	  (when save-original
	    ;; save a copy for when we recolor in future
	    (image-put image original-key (copy-image image))))

	(image-map (lambda (pixel)
		     (when (zerop (nth zero-channel pixel))
		       (let loop ((rest index-channels)
				  (red-rest red-luts)
				  (green-rest green-luts)
				  (blue-rest blue-luts))
			 (when rest
			   (let ((index (nth (car rest) pixel)))
			     (if (not (zerop index))
				 (list (aref (car red-rest) index)
				       (aref (car green-rest) index)
				       (aref (car blue-rest) index)
				       (nth alpha-channel pixel))
			       (loop (cdr rest)
				     (cdr red-rest)
				     (cdr green-rest)
				     (cdr blue-rest))))))))
		   image))))

  (define (make-image-recolorer color #!key
				(zero-channel red-channel)
				(index-channel green-channel)
				(save-original t))

    "Returns a function of a single argument. Given an image this
function will recolor it based on COLOR. Any pixels in the image whose
ZERO-CHANNEL is zero will be given a new value, computed by indexing
into a 256 element array using the value of the pixel's INDEX-CHANNEL
to choose the element.

The original image is always modified. If SAVE-ORIGINAL is true, the
first time the image is recolored it's original contents will be
stored, and then used as the basis for any future recoloring."

    (make-image-recolorer* (list color)
			   #:zero-channel zero-channel
			   #:index-channels (list index-channel)
			   #:save-original save-original))

  ;; Create a lookup-table, a string containing 256 samples of a gradient
  ;; from 0 -> MID -> 255.
  (define (make-lut mid)
    (let ((lut (make-string 256))
	  (i 0))
      (while (< i 128)
	(aset lut i (inexact->exact (round (* (/ mid 128.) i))))
	(setq i (1+ i)))
      (while (< i 256)
	(aset lut i (inexact->exact
		     (round (+ mid (* (/ (- 255. mid) 128.) (- i 128.))))))
	(setq i (1+ i)))
      lut)))

;; simple-dialog.jl
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
;; for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;;; History
;; This file was delete once by mistake, in the commit dbe8c2235, and
;; it had been called "lisp/sawfish/gtk/stock.jl.gtk".
;; Re-added in the commit ce7e6c, as "lisp/sawfish/gtk/stock.jl".
;; Then renamed again in commit a22557030.

(define-structure sawfish.gtk.widgets.simple-dialog

    (export simple-dialog
            widget-dialog)

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (simple-dialog title widget #!optional ok-callback main-window)

    (let ((window (gtk-window-new 'toplevel))
	  (vbox (gtk-vbox-new nil box-spacing))
	  (hbbox (gtk-hbutton-box-new))
	  (ok (gtk-button-new-from-stock "gtk-ok"))
	  (cancel (and ok-callback (gtk-button-new-from-stock "gtk-cancel"))))

      (define (on-cancel)
	(gtk-widget-destroy window))

      (define (on-ok)
	(ok-callback)
	(gtk-widget-destroy window))

      (gtk-window-set-title window title)
      (gtk-window-set-wmclass window "SimpleDialog" "SawfishConfig")
      (gtk-container-set-border-width window box-border)
      (when main-window
	(gtk-window-set-transient-for window main-window))

      (gtk-box-set-spacing hbbox button-box-spacing)
      (gtk-button-box-set-layout hbbox 'end)
      (when cancel
	(gtk-box-pack-end hbbox cancel))
      (gtk-box-pack-end hbbox ok)
      (gtk-box-pack-end vbox hbbox)
      (gtk-container-add window vbox)
      (gtk-widget-show-all vbox)

      (gtk-container-add vbox widget)

      (when cancel
	(g-signal-connect cancel "clicked" on-cancel))
      (g-signal-connect ok "clicked" (if ok-callback on-ok on-cancel))
      (g-signal-connect window "delete_event" on-cancel)

      (gtk-widget-show window)
      (gtk-window-set-modal window t)
      (gtk-widget-grab-focus widget)

      window))

  (define (widget-dialog title spec callback
			 #!optional initial-value main-window)

    (let* ((widget (make-widget spec))
	   (vbox (gtk-vbox-new nil box-spacing))
	   (hbox (gtk-hbox-new nil 0)))

      (when initial-value
	(widget-set widget initial-value))

      (gtk-box-pack-start hbox (gtk-label-new title))
      (gtk-container-add vbox hbox)
      (gtk-container-add vbox (widget-gtk-widget widget))
      (gtk-widget-show-all vbox)
      (simple-dialog title vbox
		     (lambda () (callback (widget-ref widget)))
		     main-window))))

;; theme.jl for Arlo's new theme design
;;
;; Copyright (C) 2001 Eazel, Inc.
;;
;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 2 of the
;; License, or (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;;
;; Authors: John Harper <jsh@eazel.com>

(require 'rep.data.tables)		;need hash tables for icon cache
(require 'sawfish.wm.util.recolor-image)

(defgroup Crux "Crux Theme"
  :group appearance)

(defcustom Crux:normal-color nil
  "Accent color for focused windows (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Crux)
  :after-set (lambda () (color-changed)))

(defcustom Crux:show-window-icons nil
  "Display the window's icon in its menu button."
  :type boolean
  :group (appearance Crux)
  :after-set (lambda () (rebuild-all)))

(defvar Crux:button-themes
  '((default
      ((close-button) . (iconify-button maximize-button shade-button)))
    (platinum
     ((close-button) . (maximize-button shade-button)))
    (macos-x
     ((close-button maximize-button iconify-button)))
    (windows
     ((menu-button) . (iconify-button maximize-button close-button))
     ((menu-button)))
    (next
     ((iconify-button) . (close-button))
     ((iconify-button) . (close-button)))
    (complete
     ((close-button) . (shade-button iconify-button maximize-button
                                     menu-button)))
    (complete-inverse
     ((menu-button maximize-button iconify-button shade-button) .
      (close-button)))))

(defcustom Crux:button-theme 'default
  "Display title buttons to mimic: \\left"
  ;; XXX it would be better if the choices were extracted from
  ;; XXX the above alist somehow
  :type (choice (default "Default")
		(platinum "Mac OS Platinum")
		(macos-x "Mac OS X")
		(windows "MS Windows")
		(next "NeXTSTEP")
		(complete "Complete")
		(complete-inverse "Complete (Inverse)"))
  :group (appearance Crux)
  :after-set (lambda () (reframe-all)))

;; maps WINDOW -> BUTTON-LIST
(define button-table (make-weak-table eq-hash eq))

;; images

;; 16x3
(define top-left-border
  (list (make-image "inactive:top-left-border.png")
	(make-image "active:top-left-border.png")))

;; 18x3
(define top-right-border
  (list (make-image "inactive:top-right-border.png")
	(make-image "active:top-right-border.png")))

;; 16*x3
(define top-center-left-border
  (list (set-image-border
	 (make-image "inactive:top-center-left-border.png") 0 13 0 0)
	(set-image-border
	 (make-image "active:top-center-left-border.png") 0 13 0 0)))

;; 16*x3
(define top-center-right-border
  (list (make-image "inactive:top-center-right-border.png")
	(make-image "active:top-center-right-border.png")))

;; 48*x19
(define top-center-left
  (list (make-image "inactive:top-center-left.png")
	(make-image "active:top-center-left.png")))

;; 48*x19
(define top-center-mid
  (list (make-image "inactive:top-center-mid.png")
	(make-image "active:top-center-mid.png")))

;; 48*x19
(define top-center-right
  (list (make-image "inactive:top-center-right.png")
	(make-image "active:top-center-right.png")))

;; 4x18
(define left-top-border
  (list (make-image "inactive:left-top-border.png")
	(make-image "active:left-top-border.png")))
(define left-top-border-shaped
  (list (make-image "inactive:left-top-border-shaped.png")
	(make-image "active:left-top-border-shaped.png")))

;; 5x16*
(define left-border
  (list (make-image "inactive:left-border.png")
	(make-image "active:left-border.png")))

;; 5x18
(define right-top-border
  (list (make-image "inactive:right-top-border.png")
	(make-image "active:right-top-border.png")))
(define right-top-border-shaped
  (list (make-image "inactive:right-top-border-shaped.png")
	(make-image "active:right-top-border-shaped.png")))

;; 6x16*
(define right-border
  (list (make-image "inactive:right-border.png")
	(make-image "active:right-border.png")))

;; 5x6
(define bottom-left-corner
  (list (make-image "inactive:bottom-left-corner.png")
	(make-image "active:bottom-left-corner.png")))

;; 32*x6
(define bottom-left-border
  (list (set-image-border
         (make-image "inactive:bottom-left-border.png") 0 30 0 0)
	(set-image-border
         (make-image "active:bottom-left-border.png") 0 30 0 0)))

;; 16*x6
(define bottom-right-border
  (list (make-image "inactive:bottom-right-border.png")
	(make-image "active:bottom-right-border.png")))

;; 6x6
(define bottom-right-corner
  (list (make-image "inactive:bottom-right-corner.png")
	(make-image "active:bottom-right-corner.png")))

;; 16x16
(define button-background
  `((inactive . ,(make-image "inactive:button.png"))
    (focused . ,(make-image "active:button.png"))
    (inactive-highlighted . ,(make-image "inactive:button-hilight.png"))
    (highlighted . ,(make-image "active:button-hilight.png"))
    (inactive-clicked . ,(make-image "inactive:button-pressed.png"))
    (clicked . ,(make-image "active:button-pressed.png"))))
(define menu-button
  `((inactive . ,(make-image "inactive:menu-button.png"))
    (focused . ,(make-image "active:menu-button.png"))
    (inactive-highlighted . ,(make-image "inactive:menu-button-hilight.png"))
    (highlighted . ,(make-image "active:menu-button-hilight.png"))
    (inactive-clicked . ,(make-image "inactive:menu-button-pressed.png"))
    (clicked . ,(make-image "active:menu-button-pressed.png"))))

(let ((make-button-fg
       (lambda (inactive active)
	 `((inactive . ,inactive)
	   (focused . ,active)
	   (inactive-highlighted . ,active)
	   (highlighted . ,active)
	   (inactive-clicked . ,active)
	   (clicked . ,active)))))

  (define minimize-fg
    (make-button-fg (make-image "inactive:minimize-button.png")
		    (make-image "active:minimize-button.png")))
  (define maximize-fg
    (make-button-fg (make-image "inactive:maximize-button.png")
		    (make-image "active:maximize-button.png")))
  (define close-fg
    (make-button-fg (make-image "inactive:close-button.png")
		    (make-image "active:close-button.png")))
  (define shade-fg
    (make-button-fg (make-image "inactive:shade-button.png")
		    (make-image "active:shade-button.png"))))

;; geometry computations

(define (title-left-width w)
  (let ((buttons (table-ref button-table w)))
    (max 0 (min (- (car (window-dimensions w))
		   (* (length (cdr buttons)) 18))
		(+ (text-width (window-name w)) 52
		   (* (length (car buttons)) 18))))))

(define (top-border-left-width w)
  (let ((buttons (table-ref button-table w)))
    (max 0 (min (- (car (window-dimensions w)) (* (length (cdr buttons)) 18))
		(+ (title-left-width w) -43)))))

(define (bottom-border-left-width w)
  (max 0 (min (car (window-dimensions w))
	      (+ (title-left-width w)
		 (quotient (cdr (window-dimensions w)) 2)))))

(define (vertical-justification)
  ;; `center' justification adjusted for the 3-pixel top-border
  (max 0 (- (/ (- 22 (font-height default-font)) 2) 3)))

(define (horizontal-justification w)
  (+ (* (length (car (table-ref button-table w))) 18) 2))

;; recolouring images

(define (foreground-color)
  (if (colorp Crux:normal-color)
      Crux:normal-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
	(nth 3 gtkrc-background)
      (get-color "steelblue"))))

;; Recolor all images that need recolouring. Precalculates the lookup
;; tables first.
(define (recolor-all)
  ;; Use the SELECTED state of the background colors as the
  ;; midpoint of the gradient for recolouring images. (This is
  ;; usually a bright, contrasting colour, and thus is the
  ;; best choice. It works particularly well with the Eazel-Foo
  ;; themes)
  (let ((recolorer (make-image-recolorer (foreground-color)
					 #:zero-channel blue-channel
					 #:index-channel green-channel)))
    (mapc (lambda (x) (mapc recolorer (cdr x)))
	  (list top-left-border
		top-center-left-border
		top-center-left
		top-center-mid
		left-top-border
		left-top-border-shaped
		left-border
		bottom-left-corner
		bottom-left-border))
    (mapc (lambda (x)
	    (recolorer (cdr x))) menu-button)))

;; window icons

(define icon-table (make-weak-table eq-hash eq))

(define (window-icon w)
  (when Crux:show-window-icons
    (or (table-ref icon-table w)
	(let ((icon (window-icon-image w)))
	  (when icon
	    (let ((scaled (scale-image icon 12 12)))
	      (table-set icon-table w scaled)
	      scaled))))))

;; frames

(define common-frame-parts
  `(((background . ,top-left-border)
     (left-edge . -5)
     (top-edge . -22)
     (class . top-left-corner))

    ((background . ,top-center-left-border)
     (left-edge . 11)
     (top-edge . -22)
     (width . ,top-border-left-width)
     (class . top-border))
    ((background . ,top-center-right-border)
     (left-edge . ,(lambda (w) (+ (top-border-left-width w) 11)))
     (right-edge . 10)
     (top-edge . -22)
     (class . top-border))

    ((background . ,top-center-left)
     (left-edge . -2)
     (width . ,(lambda (w) (+ (title-left-width w) 2 -48)))
     (top-edge . -19)
     (text . ,window-name)
     (foreground . ("black" "white"))
     (x-justify . ,horizontal-justification)
     (y-justify . ,vertical-justification)
     (class . title))
    ((background . ,top-center-mid)
     (left-edge . ,(lambda (w) (max 0 (- (title-left-width w) 48))))
     (top-edge . -19)
     (class . title))
    ((background . ,top-center-right)
     (left-edge . ,title-left-width)
     (right-edge . -1)
     (top-edge . -19)
     (class . title))

    ((background . ,top-right-border)
     (right-edge . -6)
     (top-edge . -22)
     (class . top-right-corner))))

(define normal-frame
  `(,@common-frame-parts

    ((background . ,left-top-border)
     (left-edge . -5)
     (top-edge . -19)
     (class . top-left-corner))
    ((background . ,right-top-border)
     (right-edge . -6)
     (top-edge . -19)
     (class . top-right-corner))

    ((background . ,left-border)
     (left-edge . -5)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . left-border))

    ((background . ,bottom-left-corner)
     (left-edge . -5)
     (bottom-edge . -6)
     (class . bottom-left-corner))

    ((background . ,right-border)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))

    ((background . ,bottom-right-corner)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))

    ((background . ,bottom-left-border)
     (left-edge . 0)
     (width . ,bottom-border-left-width)
     (bottom-edge . -6)
     (class . bottom-border))
    ((background . ,bottom-right-border)
     (left-edge . ,bottom-border-left-width)
     (right-edge . 0)
     (bottom-edge . -6)
     (class . bottom-border))))

(define shaped-frame
  `(,@common-frame-parts

    ((background . ,left-top-border-shaped)
     (left-edge . -5)
     (top-edge . -19)
     (class . top-left-corner))
    ((background . ,right-top-border-shaped)
     (right-edge . -6)
     (top-edge . -19)
     (class . top-right-corner))))

;; packing buttons

(define button-map
  `((iconify-button . ,minimize-fg)
    (maximize-button . ,maximize-fg)
    (close-button . ,close-fg)
    (menu-button . ,window-icon)
    (shade-button . ,shade-fg)))

(define (button-theme type)
  (let ((style (cdr (or (assq Crux:button-theme Crux:button-themes)
			(assq 'default Crux:button-themes)))))
    (if (eq type 'transient)
	(cadr style)
      (car style))))

(define (make-buttons spec background edge)

  (define (make-button class fg point)
    `((background . ,background)
      (foreground . ,fg)
      (x-justify . 2)
      (y-justify . 2)
      (,edge . ,point)
      (top-edge . -19)
      (class . ,class)
      (removable . t)))

  (do ((rest spec (cdr rest))
       (point -1 (+ point 18))
       (out '() (cons (make-button (car rest)
				   (cdr (assq (car rest) button-map))
				   point) out)))
      ((null rest) out)))

;; misc stuff

(define (rebuild-all)
  (rebuild-frames-with-style 'Crux))

(define (reframe-all)
  (reframe-windows-with-style 'Crux))

(define (reset-icon w)
  (table-unset icon-table w)
  (rebuild-frame w))

(define (color-changed)
  (recolor-all)
  (reframe-all))

(define (make-frame w frame buttons)
  (table-set button-table w buttons)
  (append frame
	  (make-buttons (car buttons) menu-button 'left-edge)
	  (make-buttons (reverse (cdr buttons)) button-background 'right-edge)))

(define (get-frame w type)
  (case type
    ((default)
     (make-frame w normal-frame (button-theme 'normal)))
    ((transient)
     (make-frame w normal-frame (button-theme 'transient)))
    ((shaped)
     (make-frame w shaped-frame (button-theme 'normal)))
    ((shaped-transient)
     (make-frame w shaped-frame (button-theme 'transient)))))

;; initialization

(define initialize-gtkrc
  (let ((done nil))
    (lambda ()
      (unless done
	(require 'gtkrc)
	;; recolour everything when the GTK theme changes
	(gtkrc-call-after-changed color-changed)
	(setq done t)))))

;; setup the initial colours
(recolor-all)

;; register the theme
(add-frame-style 'Crux get-frame)

;; recalibrate frames when the window-name changes
(call-after-property-changed '(WM_NAME _NET_WM_NAME) rebuild-frame)

;; Konqueror changes the icon by page.
(call-after-property-changed 'WM_HINTS reset-icon)

;; audio-events.jl -- map wm actions to audio samples

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

;;;###autoload (defgroup audio "Sound" :require sawfish.wm.ext.audio-events)

(define-structure sawfish.wm.ext.audio-events

    (export audio-event-handler)

    (open rep
	  rep.system
	  sawfish.wm.custom
	  sawfish.wm.windows
	  sawfish.wm.state.maximize
	  sawfish.wm.util.play-audio)

  (define-structure-alias audio-events sawfish.wm.ext.audio-events)

  (defgroup audio "Sound" :require sawfish.wm.ext.audio-events)

  ;; XXX it would be cool to merge the customization with the GNOME sound prefs

  (defcustom audio-events-enabled nil
    "Play sound effects for window events."
    :type boolean
    :require sawfish.wm.ext.audio-events
    :group audio)

  (defvar audio-for-ignored-windows nil
    "Play sound effects for unmanaged windows.")

  ;; standard events are: iconified, uniconified, shaded, unshaded,
  ;; maximized, unmaximized, mapped, unmapped, mapped-transient,
  ;; unmapped-transient, switch-workspace, move-viewport, focused,
  ;; unfocused

  (defcustom audio-events-alist '((iconified . "iconify.wav")
				  (uniconified . "uniconify.wav")
				  (shaded . "shade.wav")
				  (unshaded . "unshade.wav")
				  (maximized . "maximize.wav")
				  (unmaximized . "unmaximize.wav")
				  (mapped . "map.wav")
				  (unmapped . "unmap.wav")
				  (mapped-transient . "map-transient.wav")
				  (unmapped-transient . "unmap-transient.wav")
                                  ;;(focused . "focused.wav")
                                  ;;(unfocused . "unfocused.wav")
				  (switch-workspace . "switch-workspace.wav")
				  (move-viewport . "move-viewport.wav"))
    nil
    :type* `(alist ((symbol iconified uniconified
			    shaded unshaded
			    maximized unmaximized
			    mapped unmapped
			    mapped-transient unmapped-transient
			    switch-workspace move-viewport
			    focused unfocused) ,(_ "Event"))
		   (file ,(_ "Audio file")))
    :widget-flags (expand-vertically)
    :depends audio-events-enabled
    :group audio)

  (defun audio-event-handler (event #!optional w)
    "Possibly play a sound sample for EVENT (a symbol) occurring on window W."
    (when (and audio-events-enabled
	       (or (null w)
		   (not (window-get w 'ignored))
		   audio-for-ignored-windows))
      (let
	  ((sample (cdr (assq event audio-events-alist))))
	(when sample
	  (require 'sawfish.wm.util.play-audio)
	  (play-sample sample)))))

;;; hooks

  (defun audio-state-change-fun (w states)
    (mapc (lambda (state)
	    (case state
	      ((iconified)
	       (audio-event-handler (if (window-get w 'iconified)
					'iconified 'uniconified) w))
	      ((shaded)
	       (audio-event-handler (if (window-get w 'shaded)
					'shaded 'unshaded) w))
	      ((maximized)
	       (audio-event-handler (if (window-maximized-p w)
					'maximized 'unmaximized) w)))) states))

  (call-after-state-changed '(iconified shaded maximized)
			    audio-state-change-fun)

  (defun audio-focus-in-fun (w)
    (audio-event-handler 'focused w))

  (add-hook 'focus-in-hook audio-focus-in-fun)

  (defun audio-focus-out-fun (w)
    (audio-event-handler 'unfocused w))

  (add-hook 'focus-out-hook audio-focus-out-fun)

  (defun audio-mapped-fun (w)
    (audio-event-handler (if (window-transient-p w)
			     'mapped-transient 'mapped) w))

  (add-hook 'map-notify-hook audio-mapped-fun)

  (defun audio-unmapped-fun (w)
    (audio-event-handler (if (window-transient-p w)
			     'unmapped-transient 'unmapped) w))

  (add-hook 'unmap-notify-hook audio-unmapped-fun)

  (defun audio-enter-ws-fun ()
    (audio-event-handler 'switch-workspace))

  (add-hook 'enter-workspace-hook audio-enter-ws-fun)

  (defun audio-move-vp-fun ()
    (audio-event-handler 'move-viewport))

  (add-hook 'viewport-moved-hook audio-move-vp-fun))

;; nokogiri-widget.jl -- high-level widget encapsulation
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widget

    (export add-widget-prefix
	    define-widget-type
	    widget-type-constructor
	    widget-accepts-doc-string
	    widget-accepts-doc-string-p
	    make-widget
	    widget-ref
	    widget-set
	    widget-clear
	    widget-gtk-widget
	    widget-valid-p
	    call-callback
	    make-signal-callback
	    tooltip-split
	    tooltip-set
	    set-widget-enabled
	    enable-widget
	    disable-widget
	    box-spacing
	    box-border
	    button-box-spacing)

    ((open rep
	   gui.gtk-2.gtk
	   rep.system
	   rep.util.utf8
	   rep.util.misc
	   rep.regexp
	   rep.io.files)
     (access rep.structures))

  (defconst box-spacing 4)
  (defconst box-border 5)
  (defconst button-box-spacing 8)

  ;; list of possible module prefixes when auto-loading widgets
  (define widget-prefixes '(sawfish.gtk.widgets))

  ;; predefined widget types are:

  ;;	(choice SYMBOLS)
  ;;	(symbol OPTIONS...)
  ;;	(string)
  ;;	(number [MIN [MAX [INITIAL-VALUE]]]) ;; integer only
  ;;	  The default of minimum is 0, max 65536,
  ;;	  and initial value is the same as the min.
  ;;	(range MIN MAX [INITIAL-VALUE]) ;; integer only
  ;;	  same as number, but using GtkScale rather than GtkSpin
  ;;	  and MIN / MAX need to be passed
  ;;	(boolean [LABEL])
  ;;	(color)
  ;;	(font)
  ;;	(or ITEMS...)
  ;;	(and ITEMS...)
  ;;	(v-and ITEMS...)
  ;;	(h-and ITEMS...)
  ;;	(labelled LABEL ITEM)
  ;;	(optional ITEM)

  ;; items without arguments may be specified by name, i.e. `string'
  ;; instead of `(string)'

  (define (add-widget-prefix arg)
    (setq widget-prefixes (cons arg (delq arg widget-prefixes))))

  (define (define-widget-type name constructor)
    (put name 'nokogiri-widget-constructor constructor))

  (define (widget-type-constructor name)
    (or (get name 'nokogiri-widget-constructor)
	;; try to dynamically load the widget constructor..
	(catch 'out
	  (mapc (lambda (prefix)
		  (let ((module-name (intern (concat (symbol-name prefix)
						     #\. (symbol-name name)))))
		    (condition-case nil
			(progn
			  (rep.structures#intern-structure module-name)
			  (throw 'out (get name 'nokogiri-widget-constructor)))
		      (error nil))))
		widget-prefixes)
	  (widget-type-constructor 'unknown))))

  (define (widget-accepts-doc-string name)
    (put name 'nokogiri-widget-accepts-doc-string t))

  (define (widget-accepts-doc-string-p name)
    (widget-type-constructor name)
    (get name 'nokogiri-widget-accepts-doc-string))

  ;; stack `and' items horizontally by default
  (define and-direction (make-fluid 'horizontal))

  (define callback-enabled (make-fluid t))

;;; High level widget management

  ;; each widget is a function taking a single argument, the operation to
  ;; perform on the item. Operations include:

  ;;	(ref) => VALUE
  ;; 	(set VALUE)
  ;;	(clear)
  ;;	gtk-widget => GTK-WIDGET
  ;;	(validp ARG) => BOOL

  ;; functional operations return the function to perform the operation

  ;; create a new item of type defined by CELL, either a list (TYPE ARGS...)
  ;; or a single symbol TYPE. CALLBACK is a function to be called whenever
  ;; the item's value changes
  (define (make-widget cell #!optional callback doc-string)
    (let*
	((type (or (car cell) cell))
	 (maker (or (widget-type-constructor type)
		    (widget-type-constructor 'unknown))))
      (if maker
	  (if (and doc-string (widget-accepts-doc-string-p type))
	      (let* ((split (tooltip-split doc-string))
		     (widget (apply maker callback (car split) (cdr cell))))
		(when (cdr split)
		  (tooltip-set (widget-gtk-widget widget) (cdr split)))
		widget)
	    (apply maker callback (cdr cell)))
	(error "No widget of type %s" type))))

  (define (widget-ref item) ((item 'ref)))

  (define (widget-set item value)
    (let-fluids ((callback-enabled nil))
      ((item 'set) value)))

  (define (widget-clear item)
    (let-fluids ((callback-enabled nil))
      ((item 'clear))))

  (define (widget-gtk-widget item) (item 'gtk-widget))

  (define (widget-valid-p item value) ((item 'validp) value))

  (define (set-widget-enabled item enabled)
    (gtk-widget-set-sensitive (widget-gtk-widget item) enabled))

  (define (enable-widget item) (set-widget-enabled item t))
  (define (disable-widget item) (set-widget-enabled item nil))

  (define (call-callback fun)
    (when (and fun (fluid callback-enabled))
      (fun)))

  (define (make-signal-callback fun) (lambda () (call-callback fun)))

;;; tooltip support

  (define tooltips)

  ;; returns (LABEL-STRING . TOOLTIP-STRING-OR-NIL)
  (define (tooltip-split doc)
    (setq doc (_ doc))
    (if (string-match "\n\n\\s*" doc)
	(cons (substring doc 0 (match-start))
	      (substring doc (match-end)))
      (cons doc nil)))

  (define (tooltip-set widget tip-string #!optional (key "Foo"))
    (unless tooltips
      (setq tooltips (gtk-tooltips-new)))
    (gtk-tooltips-set-tip tooltips widget tip-string key))

;;; Predefined widget constructors

  (define (make-choice-item changed-callback . options)
    (let ((combo (gtk-combo-box-text-new)))

      (let loop ((rest options))
        (when rest
          (gtk-combo-box-text-append-text combo
            (_ (or (cadar rest) (if (numberp (car rest))
				    (number->string (car rest))
				  (symbol-name (car rest))))))
            (loop (cdr rest))))

      (when changed-callback
	(g-signal-connect combo "changed"
			  (make-signal-callback changed-callback)))

      (gtk-widget-show combo)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-combo-box-set-active combo (or (option-index options x) 0))))
	  ((clear) nop)
	  ((ref) (lambda ()
		   (let* ((option-idx (gtk-combo-box-get-active combo))
			  (option (nth option-idx options))
			  (selected (or (car option) option)))
		     (if (numberp selected)
			 selected
		       (string->symbol (symbol-name selected))))))
	  ((gtk-widget) combo)
	  ((validp) (lambda (x) (option-index options x)))))))

  (define-widget-type 'choice make-choice-item)

  (define (make-symbol-item changed-callback #!rest options)
    (let ((combo (gtk-combo-box-text-new)))

      (let loop ((rest options))
        (when rest
          (gtk-combo-box-text-append-text combo
            (_ (or (cadar rest) (symbol-name (car rest)))))
            (loop (cdr rest))))

      (when changed-callback
	(g-signal-connect combo "changed"
			  (make-signal-callback changed-callback)))

      (gtk-widget-show combo)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-combo-box-set-active combo (or (option-index options x) 0))))
	  ((clear) nop)
	  ((ref) (lambda () (string->symbol (symbol-name (nth (gtk-combo-box-get-active combo) options)))))
	  ((gtk-widget) combo)
	  ((validp) (lambda (x) (symbolp x)))))))

  (define-widget-type 'symbol make-symbol-item)

  (define (make-string-item changed-callback)
    (let ((widget (gtk-entry-new)))
      (when changed-callback
	(g-signal-connect
	 widget "changed" (make-signal-callback changed-callback)))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-entry-set-text widget (or x ""))))
	  ((clear) (lambda ()
		     (gtk-entry-set-text widget "")))
	  ((ref) (lambda () (gtk-entry-get-text widget)))
	  ((gtk-widget) widget)
	  ((validp) stringp)))))

  (define-widget-type 'string make-string-item)

  (define (make-number-item changed-callback
                            #!optional minimum maximum initial-value stepping)
    ;; XXX backwards compat..
    (when (eq minimum 'nil) (setq minimum nil))
    (when (eq maximum 'nil) (setq maximum nil))
    (let ((widget (gtk-spin-button-new-with-range (or minimum 0)
						  (or maximum 65535) 1)))
      (when initial-value
        (gtk-spin-button-set-value widget initial-value))
      (when stepping
	(gtk-spin-button-set-increments widget stepping stepping))
      (when changed-callback
	(g-signal-connect
	 widget "value-changed" (make-signal-callback changed-callback)))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when (numberp x)
		     (gtk-spin-button-set-value widget x))))
	  ((clear) nop)
	  ((ref) (lambda ()
		   (let ((value (gtk-spin-button-get-value widget)))
		     (if (integerp value)
			 (inexact->exact value)
		       value))))
	  ((gtk-widget) widget)
	  ((validp) numberp)))))

  (define-widget-type 'number make-number-item)

  (define (make-range-item changed-callback range #!optional initial-value)
    (let ((widget (gtk-hscale-new-with-range (car range) (cdr range) 1)))
      (when initial-value
        (gtk-range-set-value widget initial-value)
	(gtk-scale-add-mark widget initial-value 'top (number->string initial-value)))

      (when changed-callback
	(g-signal-connect
	 widget "value-changed" (make-signal-callback changed-callback)))

      (gtk-widget-show widget)
      (gtk-scale-set-value-pos widget 'left)
      (gtk-widget-set-size-request widget 100 -1)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when (numberp x)
		     (gtk-range-set-value widget x)
		     (gtk-scale-clear-marks widget)
		     (gtk-scale-add-mark widget x 'top "°"))))
	  ((clear) (lambda () (gtk-scale-clear-marks widget)))
	  ((ref) (lambda ()
		   (let ((value (gtk-range-get-value widget)))
		     (if (integerp value)
			 (inexact->exact value)
		       value))))
	  ((gtk-widget) widget)
	  ((validp) numberp)))))

  (define-widget-type 'range make-range-item)

  (define (make-boolean-item changed-callback #!optional label)
    (let ((widget (if label
		      (gtk-check-button-new-with-label label)
		    (gtk-check-button-new))))
      (when label
	(gtk-label-set-justify (car (gtk-container-get-children widget)) 'left))
      (when changed-callback
	(g-signal-connect
	 widget "toggled" (make-signal-callback changed-callback)))
      (gtk-widget-show widget)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (gtk-toggle-button-set-active widget x)))
	  ((clear) (lambda ()
		     (gtk-toggle-button-set-active widget nil)))
	  ((ref) (lambda ()
		   (gtk-toggle-button-get-active widget)))
	  ((gtk-widget) widget)
	  ((validp) (lambda () t))))))

  (define-widget-type 'boolean make-boolean-item)
  (widget-accepts-doc-string 'boolean)

;;; ``Meta'' widgets

  (define (make-or-item changed-callback #!rest items)
    (setq items (mapcar (lambda (x)
			  (make-widget x changed-callback)) items))
    (let* ((box (gtk-vbox-new nil box-spacing))
	   (hboxes (mapcar (lambda ()
			     (gtk-hbox-new nil box-spacing)) items))
	   (checks (mapcar (lambda ()
			     (gtk-check-button-new)) items))
	   (enabled-item nil)
	   (refresh-item
	    (lambda ()
	      (let ((i 0))
		(mapc (lambda (x)
			(set-widget-enabled x (eq enabled-item x))
			(gtk-toggle-button-set-active
			 (nth i checks) (eq enabled-item x))
			(setq i (1+ i))) items))
	      (call-callback changed-callback)))
	   (toggle-fun
	    (lambda (index)
	      (when (or (eq (nth index items) enabled-item)
			(gtk-toggle-button-get-active (nth index checks)))
		(setq enabled-item (and (gtk-toggle-button-get-active
					 (nth index checks))
					(nth index items))))
	      (refresh-item))))
      (do ((i 0 (1+ i)))
	  ((= i (length items)))
	(g-signal-connect (nth i checks) "toggled" (lambda ()
                                                     (toggle-fun i)))
	(gtk-box-pack-start box (nth i hboxes))
	(gtk-box-pack-start (nth i hboxes) (nth i checks))
	(gtk-box-pack-start (nth i hboxes) (widget-gtk-widget (nth i items))))
      (refresh-item)
      (gtk-widget-show-all box)
      (lambda (op)
	(case op
	  ((set)
	   (lambda (x)
	     (if (null x)
		 (setq enabled-item nil)
	       (if (and enabled-item (widget-valid-p enabled-item x))
		   ;; set the enabled value if possible
		   (widget-set enabled-item x)
		 ;; look for a matching type
		 (catch 'done
		   (do ((i 0 (1+ i)))
		       ((= i (length items)))
		     (when (widget-valid-p (nth i items) x)
		       (setq enabled-item (nth i items))
		       (widget-set enabled-item x)
		       (throw 'done t)))
		   (message (format nil (_ "No matching item for %S") x)))))
	     (refresh-item)))
	  ((clear) (lambda ()
		     (setq enabled-item nil)
		     (mapc (lambda (item)
			     (widget-clear item)) items)
		     (refresh-item)))
	  ((ref) (lambda ()
		   (and enabled-item (widget-ref enabled-item))))
	  ((gtk-widget) box)
	  ((validp) (lambda (x)
		      (catch 'out
			(do ((i 0 (1+ i)))
			    ((= i (length items)))
			  (when (widget-valid-p (nth i items) x)
			    (throw 'out t))))))))))

  (define-widget-type 'or make-or-item)

  (defun make-and-item (changed-callback #!rest items)
    (setq items (mapcar (lambda (x)
			  (make-widget x changed-callback)) items))
    (let
	((box ((if (eq (fluid and-direction) 'horizontal)
		   gtk-hbox-new
		 gtk-vbox-new) nil box-spacing)))
      (do ((i 0 (1+ i)))
	  ((= i (length items)))
	(gtk-box-pack-start box (widget-gtk-widget (nth i items)) t t))
      (gtk-widget-show-all box)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (do ((i 0 (1+ i)))
		       ((= i (length items)))
		     (widget-set (nth i items) (nth i x)))))
	  ((clear) (lambda () (mapc widget-clear items)))
	  ((ref) (lambda () (mapcar widget-ref items)))
	  ((gtk-widget) box)
	  ((validp) (lambda (x)
		      (cond ((null x))
			    ((or (not (listp x))
				 (/= (length x) (length items)))
			     nil)
			    (t
			     (catch 'out
			       (do ((i 0 (1+ i)))
				   ((= i (length items)))
				 (unless (widget-valid-p
					  (nth i items) (nth i x))
				   (throw 'out nil)))
			       t)))))))))

  (define-widget-type 'and make-and-item)

  (define-widget-type 'h-and (lambda (#!rest args)
			       (let-fluids ((and-direction 'horizontal))
				 (apply make-and-item args))))

  (define-widget-type 'v-and (lambda (#!rest args)
			       (let-fluids ((and-direction 'vertical))
				 (apply make-and-item args))))

  (define (make-labelled-item changed-callback label item)
    (let ((box (gtk-hbox-new nil box-spacing)))
      (setq item (make-widget item changed-callback))
      ;; XXX i18n the label string?
      (gtk-box-pack-start box (gtk-label-new (_ label)))
      (gtk-container-add box (widget-gtk-widget item))
      (gtk-widget-show-all box)
      (lambda (op)
	(if (eq op 'gtk-widget)
	    box
	  (item op)))))

  (define-widget-type 'labelled make-labelled-item)

  (define (make-label-item changed-callback label)
    (declare (unused changed-callback))
    (let ((box (gtk-hbox-new nil box-spacing))
	  (label (gtk-label-new (_ label))))
      (gtk-label-set-line-wrap label t)
      (gtk-box-pack-start box label)
      (gtk-widget-show-all box)
      (lambda (op)
	(if (eq op 'gtk-widget)
	    box
	  (lambda () t)))))

  (define-widget-type 'label make-label-item)

  (define (make-link-item changed-callback link label)
    (declare (unused changed-callback))
    (let ((box (gtk-hbox-new nil box-spacing))
	  (link (gtk-link-button-new-with-label link (_ label))))
      (gtk-button-set-relief link 'none)
      (gtk-box-pack-start box link)
      (gtk-widget-show-all box)
      (lambda (op)
	(if (eq op 'gtk-widget)
	    box
	  (lambda () t)))))

  (define-widget-type 'link make-link-item)

  (define (make-xdg-item changed-callback file label)
    (declare (unused changed-callback))
    (let ((box (gtk-hbox-new nil box-spacing))
	  (button (gtk-button-new-with-label (_ label))))
      (gtk-box-pack-start box button)
      (gtk-button-set-relief button 'none)
      (g-signal-connect button "clicked"
	(lambda ()
	  (if (or (equal file "~/.sawfishrc")
		  (equal file "~/.sawfish/rc"))
	      (if (file-exists-p "~/.sawfish/rc")
		  (system (format nil "xdg-open ~/.sawfish/rc &"))
		(if (file-exists-p "~/.sawfishrc")
		    (system (format nil "xdg-open ~/.sawfishrc &"))
		  (system (format nil "touch ~/.sawfishrc && xdg-open ~/.sawfishrc &"))))
	    (if (not (file-exists-p file))
	        (system (format nil "touch %s && xdg-open %s &" file file))
	      (when (file-exists-p file)
	        (system (format nil "xdg-open %s &" file)))))))
      (gtk-widget-show-all box)
      (lambda (op)
	(if (eq op 'gtk-widget)
	    box
	  (lambda () t)))))

  (define-widget-type 'xdg make-xdg-item)

  (define (make-shell-item changed-callback command label)
    (declare (unused changed-callback))
    (let ((box (gtk-hbox-new nil box-spacing))
	  (button (gtk-button-new-with-label (_ label))))
      (gtk-box-pack-start box button)
      (gtk-button-set-relief button 'none)
      (g-signal-connect button "clicked"
	(lambda ()
	      (system (format nil "xterm -e %s &" command))))
      (gtk-widget-show-all box)
      (lambda (op)
	(if (eq op 'gtk-widget)
	    box
	  (lambda () t)))))

  (define-widget-type 'shell make-shell-item)

  (define (make-optional-item changed-callback item)
    (let ((box (gtk-hbox-new nil box-spacing))
	  (check (gtk-check-button-new)))
      (setq item (make-widget item changed-callback))
      (gtk-box-pack-start box check)
      (gtk-box-pack-start box (widget-gtk-widget item))
      (g-signal-connect
       check "toggled"
       (lambda ()
	 (set-widget-enabled item (gtk-toggle-button-get-active check))
	 (call-callback changed-callback)))
      (gtk-toggle-button-set-active check nil)
      (disable-widget item)
      (gtk-widget-show-all box)
      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (when x
		     (widget-set item x))
		   (set-widget-enabled item x)
		   (gtk-toggle-button-set-active check x)))
	  ((clear) (lambda ()
		     (widget-clear item)
		     (disable-widget item)
		     (gtk-toggle-button-set-active check nil)))
	  ((ref) (lambda ()
		   (and (gtk-toggle-button-get-active check)
			(widget-ref item))))
	  ((gtk-widget) box)
	  ((validp) (lambda (x)
		      (or (null x) (widget-valid-p item x))))))))

  (define-widget-type 'optional make-optional-item)

  (define (make-quoted-item changed item)
    (let ((widget (make-widget item changed)))
      (lambda (op)
	(case op
	  ((ref) (lambda ()
		   (list 'quote (widget-ref widget))))
	  ((set) (lambda (x)
		   (widget-set widget (cadr x))))
	  ((validp) (lambda (x)
		      (and (eq (car x) 'quote)
			   (widget-valid-p widget (cadr x)))))
	  (t (widget op))))))

  (define-widget-type 'quoted make-quoted-item)

;;; widget used for unknown widget types

  (define (make-unknown-item changed-callback)
    (declare (unused changed-callback))
    (let ((label (gtk-label-new (format nil (_ "** unknown widget **  "))))
	  value)
      (gtk-widget-show label)
      (lambda (op)
	(case op
	  ((set) (lambda (x) (setq value x)))
	  ((clear) (lambda () (setq value nil)))
	  ((ref) (lambda () value))
	  ((gtk-widget) label)
	  ((validp) (lambda (x) (declare (unused x)) t))))))

  (define-widget-type 'unknown make-unknown-item))

;; nokogiri-widgets/scheme-boolean.jl --
;;
;; Copyright (C) 2002 John Harper <jsh@unfactored.org>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.gtk.widgets.scheme-boolean

    (export )

    (open rep
          gui.gtk-2.gtk
          sawfish.gtk.widget)

  (define (make-item changed-callback)
    (let ((widget (gtk-check-button-new-with-label (_ "Enable"))))

      (gtk-label-set-justify (car (gtk-container-get-children widget)) 'left)
      (gtk-toggle-button-set-inconsistent widget t)

      (g-signal-connect widget "toggled" (lambda (widget)
					   (gtk-toggle-button-set-inconsistent widget nil)))

      (when changed-callback
	(g-signal-connect widget "toggled" (make-signal-callback changed-callback)))

      (gtk-widget-show widget)

      (lambda (op)
	(case op
	  ((set) (lambda (x)
		   (if (not (memq x '(() #f)))
		       (gtk-toggle-button-set-active widget t)
		     (gtk-toggle-button-set-inconsistent widget nil)
		     (gtk-toggle-button-set-active widget nil))))
	  ((clear) (lambda ()
		     (gtk-toggle-button-set-inconsistent widget t)))
	  ((ref) (lambda ()
		   (unless (gtk-toggle-button-get-inconsistent widget)
		     (if (gtk-toggle-button-get-active widget) '#t '#f))))
	  ((gtk-widget) widget)
	  ((validp) (lambda () t))))))

  (define-widget-type 'scheme-boolean make-item)
  (widget-accepts-doc-string 'scheme-boolean))

;; lxde.jl -- LXDE integration

;; Copyright (C) 2012 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.integration.lxde

    (export detect-lxde)

    (open rep
	  rep.system
          sawfish.wm.menus
	  sawfish.wm.misc
          sawfish.wm.custom
	  sawfish.wm.windows
          sawfish.wm.commands
          sawfish.wm.commands.launcher)

  (define-structure-alias lxde-int sawfish.wm.integration.lxde)

  (define (init)
    (let (menu)
      (setq desktop-environment "lxde")
      (setq want-poweroff-menu nil)

      ;; invoke the LXDE terminal instead of xterm
        (unless (variable-customized-p 'xterm-program)
		(setq xterm-program "lxterm"))

      ;; use the LXDE help browser and url launcher
      ;;
      ;; XXX LXDE does not come with a default browser
      ;; XXX candidate for int: ??
      ;;
      ;; (unless (variable-customized-p 'browser-program)
      ;; 	(setq browser-program "lxde-www-browser"))

      ;; use the LXDE filemanager
      (unless (variable-customized-p 'filemanager-program)
	(setq filemanager-program "pcmanfm"))

      ;; add some LXDE menu-entries
      (when (setq menu (assoc (_ "_Help") root-menu))
	(nconc menu `(()
		      (,(_ "LXDE _Website") (browser "http://www.lxde.org")))))

      ;; add lxde-logout and customize menu-entries
      (when (setq menu (assoc (_ "Sessi_on") root-menu))
	(nconc menu `(()
		      (,(_ "_LXSession Logout") (system "lxsession-logout &")))))))

  ;; Returns nil if lxde is not found.
  ;; If detected, returns t, and do also lxde support init.
  (define (detect-lxde)
    (when (or (equal (getenv "XDG_CURRENT_DESKTKOP") "LXDE")
	      (equal (getenv "DESKTOP_SESSION") "LXDE"))
      (init)
      t)))

;; gtkrc.jl -- code to read current gtkrc settings

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.util.gtkrc

    (export gtkrc-style
	    gtkrc-background
	    gtkrc-background-pixmaps
	    gtkrc-base
	    gtkrc-light
	    gtkrc-dark
	    gtkrc-mid
	    gtkrc-foreground
	    gtkrc-font
	    gtkrc-load-pixmaps
	    gtkrc-reload-style
	    gtkrc-call-after-changed)

    (open rep
	  rep.system
	  rep.regexp
	  rep.io.files
	  rep.io.processes
	  sawfish.wm.colors
	  sawfish.wm.fonts
	  sawfish.wm.images
	  sawfish.wm.misc
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.gaol)

  (define-structure-alias gtkrc sawfish.wm.util.gtkrc)

  (defvar gtkrc-style-program
    (expand-file-name "gtk-style" sawfish-exec-directory))

  (define gtkrc-style nil)

  (define gtkrc-background nil)
  (define gtkrc-background-pixmaps nil)
  (define gtkrc-base nil)
  (define gtkrc-light nil)
  (define gtkrc-dark nil)
  (define gtkrc-mid nil)
  (define gtkrc-foreground nil)
  (define gtkrc-font nil)

  (define gtkrc-loaded-pixmaps nil)

  (define gtkrc-dummy-window nil)

  (define gtkrc-changed-hook nil)

  ;; read the current default style
  (define (gtkrc-get-style)
    (let* ((output (make-string-output-stream))
	   (process (make-process output)))
      (set-process-error-stream process nil)
      ;; XXX the gtk-style program can't connect to the X server
      ;; XXX if it's currently grabbed, hence this kludge..
      (call-with-server-ungrabbed
       (lambda ()
	 (unless (zerop (call-process process nil gtkrc-style-program))
	   (error "Can't start gtkrc-style-program: `%s'."
		  gtkrc-style-program))))
      (setq output (make-string-input-stream
		    (get-output-stream-string output)))
      (setq gtkrc-style nil)
      (condition-case nil
	  (while t
	    (setq gtkrc-style (cons (read output) gtkrc-style)))
	(end-of-stream
	 (setq gtkrc-style (nreverse gtkrc-style))))))

  (define (gtkrc-fix-image-name str)
    (while (string-match "//" str)
      (setq str (concat (substring str 0 (match-start))
			?/ (substring str (match-end)))))
    str)

  ;; act on settings in gtkrc-style alist
  (define (gtkrc-apply-style)
    (let (tem)
      (setq gtkrc-background nil)
      (setq gtkrc-background-pixmaps nil)
      (setq gtkrc-base nil)
      (setq gtkrc-light nil)
      (setq gtkrc-dark nil)
      (setq gtkrc-mid nil)
      (setq gtkrc-foreground nil)
      (setq gtkrc-font nil)
      (setq gtkrc-loaded-pixmaps nil)
      (when (setq tem (cdr (assq 'font gtkrc-style)))
	(setq gtkrc-font (condition-case nil
			     (get-font tem)
			   (error
			    default-font))))
      (when (setq tem (cdr (assq 'fg gtkrc-style)))
	(setq gtkrc-foreground (list (cdr (assq 'normal tem))
				     (cdr (assq 'prelight tem))
				     (cdr (assq 'active tem))
				     (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'bg gtkrc-style)))
	(setq gtkrc-background (list (cdr (assq 'normal tem))
				     (cdr (assq 'prelight tem))
				     (cdr (assq 'active tem))
				     (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'base gtkrc-style)))
	(setq gtkrc-base (list (cdr (assq 'normal tem))
			       (cdr (assq 'prelight tem))
			       (cdr (assq 'active tem))
			       (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'light gtkrc-style)))
	(setq gtkrc-light (list (cdr (assq 'normal tem))
				(cdr (assq 'prelight tem))
				(cdr (assq 'active tem))
				(cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'dark gtkrc-style)))
	(setq gtkrc-dark (list (cdr (assq 'normal tem))
			       (cdr (assq 'prelight tem))
			       (cdr (assq 'active tem))
			       (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'mid gtkrc-style)))
	(setq gtkrc-mid (list (cdr (assq 'normal tem))
			      (cdr (assq 'prelight tem))
			      (cdr (assq 'active tem))
			      (cdr (assq 'selected tem)))))
      (when (setq tem (cdr (assq 'bg-pixmap gtkrc-style)))
	(setq gtkrc-background-pixmaps (list (cdr (assq 'normal tem))
					     (cdr (assq 'prelight tem))
					     (cdr (assq 'active tem))
					     (cdr (assq 'selected tem)))))
      (mapc (lambda (var)
	      (when (symbol-value var)
		(set var (mapcar (lambda (x)
				   (and x (get-color x)))
				 (symbol-value var)))))
	    '(gtkrc-background gtkrc-base gtkrc-foreground))))

  ;; if a theme want's to use the pixmaps, it must call this function first
  (define (gtkrc-load-pixmaps)
    (when (and gtkrc-background-pixmaps (not gtkrc-loaded-pixmaps))
      (setq gtkrc-background-pixmaps
	    (mapcar (lambda (x)
		      (when x
			(setq x (make-image (gtkrc-fix-image-name x)))
			(image-put x 'tiled t)
			x))
		    gtkrc-background-pixmaps))
      (setq gtkrc-loaded-pixmaps t)))

  (define (gtkrc-reload-style)
    "Reload the gtkrc settings."
    (gtkrc-get-style)
    (gtkrc-apply-style)
    (reload-gaol)
    (call-hook 'gtkrc-changed-hook))

  (define-command 'gtkrc-reload-style gtkrc-reload-style)

  ;; recognize when the GTK theme has been switched
  (define (gtkrc-handle-client-msg w type data)
    (declare (unused data))
    (when (and (eq w gtkrc-dummy-window) (eq type '_GTK_READ_RCFILES))
      (gtkrc-reload-style)
      ;; XXX make conditional
      (require 'sawfish.wm.menus)
      (menu-stop-process t)
      t))

;;; for restricted themes

  (define gtkrc-funs '())

  (define (gtkrc-call-after-changed fun)
    (setq gtkrc-funs (cons fun gtkrc-funs)))

  (add-hook 'gtkrc-changed-hook (lambda () (mapc funcall gtkrc-funs)))

  (define (reload-gaol)
    (gaol-define 'gtkrc-background gtkrc-background)
    (gaol-define 'gtkrc-background-pixmaps gtkrc-background-pixmaps)
    (gaol-define 'gtkrc-base gtkrc-base)
    (gaol-define 'gtkrc-light gtkrc-light)
    (gaol-define 'gtkrc-dark gtkrc-dark)
    (gaol-define 'gtkrc-mid gtkrc-mid)
    (gaol-define 'gtkrc-foreground gtkrc-foreground)
    (gaol-define 'gtkrc-font gtkrc-font))

;;; init

  (define (gtkrc-quit)
    (destroy-window gtkrc-dummy-window))

  (unless batch-mode
    (setq gtkrc-dummy-window (create-window 'root -100 -100 10 10))
    (set-x-property gtkrc-dummy-window 'WM_STATE (vector 0) 'WM_STATE 32)
    (add-hook 'client-message-hook gtkrc-handle-client-msg)
    (add-hook 'before-exit-hook gtkrc-quit)
    (gtkrc-reload-style))

  (gaol-define 'gtkrc-load-pixmaps gtkrc-load-pixmaps)
  (gaol-define 'gtkrc-reload-style gtkrc-reload-style)
  (gaol-define 'gtkrc-call-after-changed gtkrc-call-after-changed)
  (reload-gaol))

;; idesk.jl -- idesk (desktop icon manager) integration

;; Copyright (C) 2014 Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.prg.idesk

  (export start-idesk
          stop-idesk)

  (open rep
        rep.system
        rep.io.processes
        rep.io.timers
	rep.io.files
        rep.util.misc
        sawfish.wm.misc
	sawfish.wm.custom)

  (define-structure-alias idesk sawfish.wm.prg.idesk)

  (define %idesk-proc nil)

  (defcustom init-idesk nil
    "Whether to start idesk with Sawfish."
    :type boolean
    :group (misc apps))

  (define (start-idesk)
    "Start idesk. If a idesk process already exists, it's beeing killed."
    (if (program-exists-p "idesk")
        (progn
	  (when %idesk-proc (kill-process %idesk-proc))
          (setq %idesk-proc (make-process))
          (start-process %idesk-proc "idesk"))
      (display-message (format nil "idesk executable not found in PATH."))))

  (define (stop-idesk)
    "Stop idesk, if running."
    (when %idesk-proc
      (kill-process %idesk-proc)
      (setq %idesk-proc nil))))

;; describe.jl --

;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.commands.describe

    (export describe-symbol
	    apropos-function
	    apropos-variable)

    (open rep
	  rep.lang.doc
	  sawfish.wm.commands)

  (define-structure-alias describe sawfish.wm.commands.describe)

  (define (describe-symbol fun)
    "Print the documentation of a specified symbol to the standard output ."
    (describe-value (symbol-value fun t) fun)
    (format standard-output "\n%s\n"
	    (or (documentation fun nil (symbol-value fun t)) "Undocumented.")))

  ;;###autoload
  (define-command 'describe-symbol describe-symbol
    #:spec "SSymbol:")
  (define-command-to-screen 'describe-symbol-to-screen describe-symbol
    #:spec "SSymbol:"
    #:doc "Enter a name of var/func, and prints its doc.")

  (define (apropos-output symbols)
    (let ((separator (make-string 72 ?-)))
      (mapc (lambda (sym)
	      (write standard-output separator)
	      (write standard-output #\newline)
	      (describe-symbol sym)) symbols)))

  (define (apropos-function regexp #!optional all-functions)
    (format standard-output "Apropos %s `%s':\n\n"
	    (if all-functions "function" "command") regexp)
    (apropos-output (apropos regexp (if all-functions
					(lambda (s)
					  (and (boundp s)
					       (functionp (symbol-value s))))
				      commandp))))

  ;;###autoload
  (define-command 'apropos-function apropos-function
    #:spec "sApropos functions:\nP")
  (define-command-to-screen 'apropos-function-to-screen apropos-function
    #:spec "sApropos functions:\nP")

  (define (apropos-variable regexp)
    (format standard-output "Apropos variable `%s':\n" regexp)
    (apropos-output (apropos regexp boundp)))

  ;;###autoload
  (define-command 'apropos-variable apropos-variable
    #:spec "sApropos variables:")
  (define-command-to-screen 'apropos-variable-to-screen apropos-variable
    #:spec "sApropos variables:"))

;; stacking.jl -- window stacking

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.stacking

    (export save-stacking-order
	    mapped-stacking-order
            window-obscured
            stacking-visibility
	    raise-window
	    lower-window
	    stack-window-above
	    stack-window-below
	    restack-window
	    stacking-order-by-depth
	    window-depth
	    set-window-depth
	    window-on-top-p
	    raise-lower-window
	    lower-window-depth
	    raise-window-depth
	    raise-windows
	    lower-windows
	    raise-lower-windows)

    (open rep
	  rep.system
	  sawfish.wm.windows
	  sawfish.wm.commands
	  sawfish.wm.custom
	  sawfish.wm.session.init
	  sawfish.wm.workspace
          sawfish.wm.state.transient
          sawfish.wm.util.rects)

  ;; Each window will have a `depth' property--an integer, zero
  ;; represents the level of normal windows, negative for windows below
  ;; this level, and positive for windows above the normal level

  (defcustom transients-above 'parents
    "Keep transient windows stacked above: \\left"
    :group (misc stacking)
    :type (choice all parents none))

  (defmacro save-stacking-order (#!rest forms)
    "Execute FORMS, then reinstall the original stacking order."
    (let ((tem (gensym)))
      `(let ((,tem (stacking-order)))
	 (unwind-protect
	     (progn ,@forms)
	   (restack-windows ,tem)))))

  ;; this will always return an integer
  (define (window-depth w) (window-get w 'depth))

;;; constraint mechanics (predicates actually..)

  (define (stacking-constraint:layer w)
    (let ((depth (window-depth w)))
      (lambda (above below)
	;; constraints are met locally in ABOVE and BELOW, so just
	;; test against windows adjacent to W
	(and (or (null above)
		 (<= depth (window-depth (car above))))
	     (or (null below)
		 (>= depth (window-depth (car below))))))))

  (define (stacking-constraint:transients-above-parent w)
    (let ((parents (transient-parents w))
	  (children (transient-children w)))

      ;; ignore parents with depth > W, ignore children with depth < W
      (let ((w-depth (window-depth w)))
	(setq parents (delete-if (lambda (x)
				   (> (window-depth x) w-depth)) parents))
	  (setq children (delete-if (lambda (x)
				      (< (window-depth x) w-depth)) children)))

	(lambda (above below)
	  (and (or (null parents)
		   ;; All parents must be below W
		   (let loop ((rest parents))
		     (cond ((null rest) t)
			   ((memq (car rest) above) nil)
			   (t (loop (cdr rest))))))
	       (or (null children)
		   ;; All children must be above W
		   (let loop ((rest children))
		     (cond ((null rest) t)
			   ((memq (car rest) below) nil)
			   (t (loop (cdr rest))))))))))

  (define (stacking-constraint:transients-above-all w)
    (let ((w-depth (window-depth w)))
      (if (window-transient-p w)
	  ;; ensure there are no normal windows above W, unless they
	  ;; have depth > W
	  (lambda (above below)
	    (declare (unused below))
	    (let loop ((rest above))
	      (cond ((null rest) t)
		    ((and (not (window-transient-p (car rest)))
			  (<= (window-depth (car rest)) w-depth)) nil)
		    (t (loop (cdr rest))))))
	;; ensure no transients below W, unless they're depth < W
	(lambda (above below)
	  (declare (unused above))
	  (let loop ((rest below))
	    (cond ((null rest) t)
		  ((and (window-transient-p (car rest))
			(>= (window-depth (car rest)) w-depth)) nil)
		  (t (loop (cdr rest)))))))))

  (define (combine-constraints constraints)
    "Combine the list of secondary constraint functions into a single
function (using logical `and' combinator)."
    (lambda (above below)
      (let loop ((rest constraints))
	(cond ((null rest) t)
	      ((not ((car rest) above below)) nil)
	      (t (loop (cdr rest)))))))

  (defvar basic-stacking-constraints (list stacking-constraint:layer)
    "List of stacking constraint functions to adhere to (excluding transient
stacking modes controlled by `transients-above' option).")

  (define (make-constraint w)
    "Return the constraint function to use when stacking window W, a function
of two arguments, the list of windows above W (from bottom to top) and the
list of windows below W (from top to bottom). If the constraint holds
for a particular stacking configuration, it will return non-`nil'."
    (combine-constraints
     (mapcar (lambda (c) (c w))
	     (case (or (window-get w 'transients-above) transients-above)
	       ((parents)
		(cons stacking-constraint:transients-above-parent
		      basic-stacking-constraints))
	       ((all)
		(cons stacking-constraint:transients-above-all
		      basic-stacking-constraints))
	       (t basic-stacking-constraints)))))

;;; utilities

  ;; returns (BEFORE . AFTER), modifies LST
  (define (break-window-list lst pivot)
    "Given a list of windows LST and a window PIVOT, return a cons cell
containing two lists, the windows that occur in LST before PIVOT does (in
reverse order), and the list of windows occurring in LST after PIVOT.

LST is destructively modified by this procedure."
    (let loop ((rest lst)
	       (before '()))
      (cond ((null rest)
	     (cons before rest))
	    ((eq (car rest) pivot)
	     (cons before (cdr rest)))
	    (t
	     (let ((next (cdr rest)))
	       (rplacd rest before)
		 (loop next rest))))))

  (define (stack-rotate-upwards cell)
    "Given a cons cell containing two lists of windows `(ABOVE . BELOW)',
rotate the lists so that the first element of BELOW becomes the first
element of ABOVE. The lists are modified. Returns `nil' if BELOW is
the empty list."
    (if (null (car cell))
	nil
      (let ((next (car cell)))
	(rplaca cell (cdar cell))
	  (rplacd next (cdr cell))
	  (rplacd cell next)
	  cell)))

  (define (stack-rotate-downwards cell)
    "Given a cons cell containing two lists of windows `(ABOVE . BELOW)',
rotate the lists so that the first element of ABOVE becomes the first
element of BELOW. The lists are modified. Returns `nil' if ABOVE is
the empty list."
    (if (null (cdr cell))
	nil
      (let ((next (cdr cell)))
	(rplacd cell (cddr cell))
	  (rplacd next (car cell))
	  (rplaca cell next)
	  cell)))

  (define (mapped-stacking-order)
    (delete-if-not window-mapped-p (stacking-order)))

  (define (window-obscured window)
    "Check whether WINDOW is obscured.  Return `t' if WINDOW is fully obscured
by some other window, otherwise a list of windows partially obscuring WINDOW.
In particular return `nil' if WINDOW is unobscured.  Note that if a list of
partially obscuring windows is returned, taken together they may or may not
fully obscure WINDOW."
    (define w window)
    (define ws (nearest-workspace-with-window w current-workspace))
    (let loop ((stack (stacking-order))
               (obs nil))
      (if (null stack)               ; Should not happen
	  obs
	(let ((w2 (car stack)))
	  (cond ((eq w2 w) obs)
		((and (window-visible-p w2)
		      (window-appears-in-workspace-p w2 ws))
		 (case (apply rect-obscured
			      (rectangles-from-windows (list w w2)))
		   ((unobscured) (loop (cdr stack) obs))
		   ((fully-obscured) t)
		   (t (loop (cdr stack) (cons w2 obs))))) ; Partially
		(t (loop (cdr stack) obs)))))))

  (define (stacking-visibility window)
    "Compute the visibility of WINDOW from the stacking order.  This should
work even with the Composite extension, which appears to disable
VisibilityNotify events.  Note that deciding between fully and partially
obscured may require quite a bit of computation.  If you do not need that
distinction, window-obscured should be faster."
    (define (rect-list-minus rs s tail)
      (if (null rs)
          tail
        (rect-list-minus (cdr rs) s
                         (rect-minus (car rs) s tail))))
    (let ((obs (window-obscured window)))
      (case obs
        ((t) 'fully-obscured)
        ((()) 'unobscured)
        (t
         (do ((unobs (rectangles-from-windows (list window))
                     (rect-list-minus unobs (car robs) nil))
              (robs (rectangles-from-windows obs) (cdr robs)))
             ((or (null unobs) (null robs))
              (if (null unobs)
                  'fully-obscured
                'partially-obscured)))))))


;;; stacking functions

  (define (raise-window w)
    "Raise the window to its highest allowed position in the stacking order."
    ;; work downwards from top
    (let ((constraint (make-constraint w))
	  (stack (cons '() (delq w (stacking-order)))))
      (let loop ()
	(cond ((constraint (car stack) (cdr stack))
	       (if (car stack)
		   (x-lower-window w (car (car stack)))
		 (x-raise-window w (car (cdr stack)))))
	      ((null (cdr stack))
	       ;; no position
	       nil)
	      (t
	       (stack-rotate-downwards stack)
	       (loop))))))

  (define (lower-window w)
    "Lower the window to its lowest allowed position in the stacking order."
    (let ((constraint (make-constraint w))
	  (stack (cons (nreverse (delq w (stacking-order))) '())))
      ;; work upwards from bottom
      (let loop ()
	(cond ((constraint (car stack) (cdr stack))
	       ;; found the lowest position
	       (if (cdr stack)
		   (x-raise-window w (car (cdr stack)))
		 (x-lower-window w (car (car stack)))))
	      ((null (car stack))
	       ;; no possible position..
	       nil)
	      (t
	       (stack-rotate-upwards stack)
	       (loop))))))

  (define (stack-window-above above below)
    "Change the stacking of window ABOVE so that it is as closely above window
BELOW as possible."
    (let ((constraint (make-constraint above))
	  (stack (break-window-list
		  (delq above (stacking-order)) below)))
      (rplacd stack (cons below (cdr stack)))
	(let loop ()
	  (cond ((constraint (car stack) (cdr stack))
		 ;; found a suitable position
		 (if (car stack)
		     (x-lower-window above (car (car stack)))
		   (x-raise-window above (car (cdr stack)))))
		((null (car stack))
		 ;; reached the top
		 nil)
		(t
		 (stack-rotate-upwards stack)
		 (loop))))))

  (define (stack-window-below below above)
    "Change the stacking of window BELOW so that it is as closely below window
ABOVE as possible."
    (let ((constraint (make-constraint below))
	  (stack (break-window-list
		  (delq below (stacking-order)) above)))
      (rplaca stack (cons above (car stack)))
	(let loop ()
	  (cond ((constraint (car stack) (cdr stack))
		 (if (cdr stack)
		     (x-raise-window below (car (cdr stack)))
		   (x-lower-window below (car (car stack)))))
		((null (cdr stack))
		 ;; reached the bottom
		 nil)
		(t
		 (stack-rotate-downwards stack)
		 (loop))))))

  (define (restack-window w)
    "Assuming that the current stacking order is in a consistent state
except, possibly, for the position of window W, restore the consistent
state including window W. This is achieved by raising or lowering
window W as appropriate."
    (let ((constraint (make-constraint w))
	  (stack (break-window-list (stacking-order) w)))
      (unless (constraint (car stack) (cdr stack))
	(if (< (length (car stack)) (length (cdr stack)))
	    (raise-window w)
	  (lower-window w)))))

  (define (stacking-order-by-depth depth)
    "Return a list of windows containing only those in depth DEPTH, in the
order they are stacked within the layer (top to bottom)."
    (let ((order (stacking-order)))
      (delete-if (lambda (x)
		   (/= (window-depth x) depth)) order)))

  (define (set-window-depth w depth)
    "Set the stacking depth of window W to DEPTH."
    (let ((old (window-depth w)))
      (window-put w 'depth depth)
	(cond ((> old depth)
	       ;; window's going downwards
	       (raise-window w))
	      ((< old depth)
	       ;; window's going upwards
	       (lower-window w)))
	(call-window-hook 'window-depth-change-hook w (list depth))
	(call-window-hook 'window-state-change-hook w (list '(stacking)))))

  (define (window-on-top-p w)
    "Return t if window W is as high as it can legally go in the
stacking order."
    (let* ((constraint (make-constraint w))
	   (order (delete-if-not
		   ;; XXX doesn't handle viewports..
		   (let ((space (nearest-workspace-with-window
				 w current-workspace)))
		     (lambda (x)
		       (window-appears-in-workspace-p x space)))
		   (stacking-order)))
	   (old-posn (- (length order) (length (memq w order))))
	   (stack (cons '() (delq w order))))
      (let loop ()
	(if (or (constraint (car stack) (cdr stack))
		(null (cdr stack)))
	    ;; found highest position
	    (= (length (car stack)) old-posn)
	  (stack-rotate-downwards stack)
	  (loop)))))

  (define (raise-lower-window w)
    "If the window is at its highest possible position, then lower it to its
lowest possible position. Otherwise raise it as far as allowed."
    (if (or (not (window-obscured w))
	    (window-on-top-p w))
	(lower-window w)
      (raise-window w)))

  (define (lower-window-depth w)
    "Put the window in the stacking level beneath its current level."
    (set-window-depth w (1- (window-depth w))))

  (define (raise-window-depth w)
    "Put the window in the stacking level above its current level."
    (set-window-depth w (1+ (window-depth w))))

  (define-command 'raise-single-window raise-window
    #:spec "%W")
  (define-command 'lower-single-window lower-window
    #:spec "%W")
  (define-command 'raise-lower-single-window raise-lower-window
    #:spec "%W")
  (define-command 'raise-window-depth raise-window-depth #:spec "%W")
  (define-command 'lower-window-depth lower-window-depth #:spec "%W")

;;; stacking groups of windows

  ;; Helper function for raise-windows and lower-windows. Calls (FIRST
  ;; X) on the first element X of ORDER, then (SUCCESSOR Y X) on each
  ;; pair of adjacent elements X and Y

  (define (apply-group-order order first successor)
    (when order
      (first (car order))
      (do ((rest order (cdr rest)))
	  ((null (cdr rest)))
	(successor (cadr rest) (car rest)))))

  (define (raise-windows w order)
    ;; STRATEGY: take every window in ORDER to its highest possible
    ;; position, giving W priority but otherwise obeying ORDER, which
    ;; must be a valid stacking configuration (highest-to-lowest).  Do
    ;; the restacking in such a way that no part of any window in
    ;; ORDER is exposed during the restacking that is not exposed
    ;; afterwards.

    (define (highest-window order)
      ;; find the first window in ORDER that is allowed
      ;; to be above all other windows in ORDER...
      (let loop ((rest order))
	(cond ((null rest) nil)
	      (((make-constraint (car rest)) '() (remq (car rest) order))
	       (car rest))
	      (t (loop (cdr rest))))))

    ;; Cons up the new order (in reverse), by picking the most-raisable
    ;; each time until no windows are left, then commit that ordering
    (let loop ((rest (cons w (remq w order)))
	       (out '()))
      (if (null rest)
	  (apply-group-order (nreverse out) raise-window stack-window-below)
	(let ((highest (or (highest-window rest)
			   (error "Stacking constraint failed"))))
	  (loop (delq highest rest) (cons highest out))))))

  (define (lower-windows w order)

    (define (lowest-window order)
      ;; find the last window in ORDER that may be below all other
      ;; windows in ORDER
      (let ((reversed (reverse order)))
	(let loop ((rest reversed))
	  (cond ((null rest) nil)
		(((make-constraint (car rest))
		  (remq (car rest) reversed) '()) (car rest))
		(t (loop (cdr rest)))))))

    (let loop ((rest (nconc (remq w order) (list w)))
	       (out '()))
      (if (null rest)
	  (apply-group-order (nreverse out) lower-window stack-window-above)
	(let ((lowest (or (lowest-window rest)
			  (error "Stacking constraint failed"))))
	  (loop (delq lowest rest) (cons lowest out))))))

  (define (raise-lower-windows w order)
    (if (or (not (window-obscured w))
	    (and (window-on-top-p (car order))
		 ;; look for the group as a block.. this is a heuristic
		 (let loop ((rest (memq (car order) (stacking-order))))
		   (cond ((null rest) nil)
			 ((eq (car rest) w) t)
			 ((memq (car rest) order) (loop (cdr rest)))
			 (t nil)))))
	(lower-windows w order)
      (raise-windows w order)))

;;; hooks

  ;; Called from the add-window-hook
  (define (stacking-add-window w)
    (unless (window-get w 'depth)
      (let ((parents (transient-parents w)))
	(if parents
	    ;; put dialogs in at least as high a layer as their
	    ;; highest parent, but never below the default depth
	    (window-put w 'depth (apply max 0 (mapcar window-depth parents)))
	  ;; default depth
	  (window-put w 'depth 0)))))

  (add-hook 'add-window-hook stacking-add-window t)
  (add-hook 'after-add-window-hook restack-window t)
  (add-hook 'map-notify-hook restack-window t)

  (sm-add-saved-properties 'depth)
  (add-swapped-properties 'depth))

;; top-left.jl -- place windows on the diagonal from the top-left corner
;;
;; Copyright (C) 2000 Eazel, Inc.
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.
;;
;; Authors: John Harper <jsh@eazel.com>

;; Commentary:

;; The idea here is that there's a fixed number of possible placement
;; positions on a diagonal from the top-left corner, each successive
;; spot is slightly below and to the right of the previous spot.

;; The placement algorithm searches these spots for the first one that
;; doesn't have the top-left corner of a window in its immediate
;; vicinity. If placing the window on the first found spot would push
;; the window off the right or bottom of the screen, then resize the
;; window to avoid this happening.

;; If no spot can be found to accommodate the window's minimum allowed
;; size, then fallback to placing the window randomly.

;; (note, for `screen' above, I actually mean the work-area, i.e. the
;; area not reserved for special windows, e.g. the panel)

(define-structure sawfish.wm.placement.top-left

    (export )

    (open rep
	  sawfish.wm.windows
	  sawfish.wm.misc
	  sawfish.wm.placement
	  sawfish.wm.workspace
	  sawfish.wm.viewport
	  sawfish.wm.util.workarea
	  sawfish.wm.state.iconify)

  (define top-left '(8 . 8))
  (define fuzz '(8 . 16))
  (define step '(16 . 32))

  (define resize-windows nil)

  (define (round-up x mult) (* (quotient (+ x (1- mult)) mult) mult))

  (define (next-position point)
    (cons (+ (car point) (car step))
	  (+ (cdr point) (cdr step))))

  (define (windows-around point)
    (filter-windows
     (lambda (w)
       (and (window-get w 'placed)
	    (window-in-workspace-p w current-workspace)
	    (not (window-outside-viewport-p w))
	    (window-mapped-p w)
	    (not (window-iconified-p w))
	    (let ((w-point (window-position w)))
	      (and (< (abs (- (car w-point) (car point))) (car fuzz))
		   (< (abs (- (cdr w-point) (cdr point))) (cdr fuzz))))))))

  (define (next-free-position point boundary)
    (let loop ((point point))
      (cond ((or (>= (car point) (car boundary))
		 (>= (cdr point) (cdr boundary)))
	     nil)
	    ((null (windows-around point))
	     point)
	    (t (loop (next-position point))))))

  (define (place-window-top-left w)
    (let* ((workarea (calculate-workarea #:window w #:head (current-head)))
	   (dims (window-dimensions w))
	   (f-dims (window-frame-dimensions w))
	   (hints (window-size-hints w))

	   (min-dims (if resize-windows
			 (cons (or (cdr (or (assq 'min-width hints)
					    (assq 'base-width hints))) 1)
			       (or (cdr (or (assq 'min-height hints)
					    (assq 'base-height hints))) 1))
		       dims))

	   (first (cons (max (round-up (nth 0 workarea) (car step))
			     (car top-left))
			(max (round-up (nth 1 workarea) (cdr step))
			     (cdr top-left))))

	   (boundary (cons (- (nth 2 workarea) (car min-dims)
			      (- (car f-dims) (car dims)))
			   (- (nth 3 workarea) (cdr min-dims)
			      (- (cdr f-dims) (cdr dims))))))

      (let ((point (next-free-position first boundary)))
	(if point
	    (progn
	      (move-window-to w (car point) (cdr point))
	      (let ((changed nil))
		(when (>= (+ (car point) (car f-dims)) (nth 2 workarea))
		  (rplaca dims (- (nth 2 workarea) (car point)
				  (- (car f-dims) (car dims))))
		  (setq changed t))
		(when (>= (+ (cdr point) (cdr f-dims)) (nth 3 workarea))
		  (rplacd dims (- (nth 3 workarea) (cdr point)
				  (- (cdr f-dims) (cdr dims))))
		  (setq changed t))
		(when changed
		  (resize-window-with-hints* w (car dims) (cdr dims)))))
	  ;; fall back to random placement
	  ((placement-mode 'randomly) w)))))

  ;;###autoload
  (define-placement-mode 'top-left place-window-top-left #:for-normal t))

;; shade-stack.jl -- maintain a stack of shaded windows as iconify substitute

;; Copyright (C) 1999 Luke Gorrie <luke@vegetable.org>
;; Modifications by: 	The Glyph <glyph@twistedmatrix.com>
;;			Christopher Roy Bratusek <nano@jpberlin.de>

;; This file is part of sawfish.

;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.ext.shade-stack

  (export toggle-window-shade-stacked
	  shade-stack-window
	  shade-unstack-window
	  window-shade-stacked-p)

  (open rep
	rep.system
	sawfish.wm.misc
	sawfish.wm.custom
	sawfish.wm.windows
	sawfish.wm.commands.move-resize
	sawfish.wm.state.shading
	sawfish.wm.stacking
	sawfish.wm.workspace
	sawfish.wm.frames)

  (define-structure-alias shade-stack sawfish.wm.ext.shade-stack)

  (defvar shade-stacks '())
  (defcustom shade-stack-columns 3
    "Number of columns for the shade stack."
    :group misc
    :type (range 1 4))
  ;; TODO: automatically calculate
  (defvar shade-stack-item-height 22)

  ;;; API commands

  (define (toggle-window-shade-stacked window)
    "Toggle shade-stacking of a window"
    (if (window-shade-stacked-p window (get-shade-stack))
	(shade-unstack-window window)
      (shade-stack-window window)))

  (define (shade-stack-window window)
    "Shade a window and stack it at the top of the screen"
    (if (window-shade-stacked-p window (get-shade-stack))
	t
      (let ((shaded-position (shade-stack-insert window)))
	(lower-window window)
	(shade-window window)
	(move-window-to window (car shaded-position) (cdr shaded-position))
	(resize-window-to window (- (quotient (screen-width) shade-stack-columns) 10)
			  (cdr (window-dimensions window))))))

  (define (shade-unstack-window window)
    "Unshade a window from the stack"
    (let* ((original-configuration (shade-stack-extract window))
	  (original-position (car original-configuration))
	  (original-dimensions (car (cdr original-configuration))))
      (if (window-get window 'shade-hover-unshaded)
	  (progn
	    (window-put window 'shaded nil)
	    (window-put window 'hide-client nil)
	    (window-put window 'shade-hover-unshaded nil)
	    (reframe-window window)
	    (call-window-hook 'unshade-window-hook window)
	    (call-window-hook 'window-state-change-hook
			      window (list '(shaded))))
	(unshade-window window))
      (raise-window window)
      (move-window-to window (car original-position) (cdr original-position))
      (resize-window-to window
			(car original-dimensions)
			(cdr original-dimensions))))

  ;;; Main stacking code

  (define (shade-stack-insert window)
    "Put a window into the shaded stack registry. Return its slot number."
      (let ((insert-result
	    (do-shade-stack-insert window
				    (remove-leading-empty (get-shade-stack)))))
	(set-shade-stack (cdr insert-result))
	(let ((idx (car insert-result)))
	  (cons (* (quotient (screen-width) shade-stack-columns)
		  (mod idx shade-stack-columns))
		(* shade-stack-item-height (quotient idx shade-stack-columns))))))

  (define (do-shade-stack-insert window stack)
    (let ((empty-slot (last-empty-slot-idx stack 0 nil)))
      (if (null empty-slot)
	  (cons (length stack)
		(cons (win-info window) stack))
	(cons (- (length stack) 1 empty-slot)
	      (set-elem stack empty-slot (win-info window))))))

  (define (shade-stack-extract window)
    "Take a window off the shaded stack registry. Return its original properties"
    (let ((extract-result (do-shade-stack-extract window (get-shade-stack) '())))
      (set-shade-stack (cdr extract-result))
      (car extract-result)))

  (define (do-shade-stack-extract window stack accu)
    (if (null stack)
	(error "window not on shade stack")
      (let ((elem (car stack)))
	(if (eq (car elem) window)
	    (cons (cdr elem)
		  (append (reverse (cons 'empty accu)) (cdr stack)))
	  (do-shade-stack-extract window
				  (cdr stack)
				  (cons (car stack) accu))))))

  (define (window-shade-stacked-p window stack)
    "Is window already on stack?"
    (if (null stack)
	nil
      (if (and (consp (car stack))
	      (eq (car (car stack)) window))
	  t
	(window-shade-stacked-p window (cdr stack)))))

  (define (get-shade-stack)
    "Get the shade stack for the current viewport / workspace"
    (let ((stack (assoc (make-key) shade-stacks)))
      (if stack
	  (cdr stack)
	nil)))

  (define (set-shade-stack stack)
    "Set the shade stack for the current viewport / workspace"
    (let ((key (make-key)))
      (setq shade-stacks (cons (cons key stack)
			      (filter (lambda (x) (not (equal (car x) key)))
				      shade-stacks)))))

  ;;; Utility functions

  (define (make-key)
    "Make a key to uniquely identify this viewport / workspace"
    (list current-workspace viewport-x-offset viewport-y-offset))

  (define (win-info window)
    "Capture pre-stacking window properties"
    (cons window (list (window-position window) (window-dimensions window))))

  (define (last-empty-slot-idx stack idx prev-idx)
    "Return the index of an empty slot, or nil if none exists"
    (if (null stack)
	prev-idx
      (let ((curr-idx (if (eq (car stack) 'empty)
			  idx
			prev-idx)))
	(last-empty-slot-idx (cdr stack) (+ idx 1) curr-idx))))

  (define (set-elem lst idx val)
    "Set element idx of lst to val"
    (if (= idx 0)
	(cons val (cdr lst))
      (cons (car lst) (set-elem (cdr lst) (- idx 1) val))))

  (define (remove-leading-empty lst)
    "Strip leading empty slots"
    (if (eq (car lst) 'empty)
	(remove-leading-empty (cdr lst))
      lst))

  (define (cleanup-after-window w)
    "If a shade-stacked window is destroyed, free up its slot"
    (setq shade-stacks
	  (mapcar (lambda (x) (cleanup-environment w x)) shade-stacks)))

  (define (cleanup-environment w stack-alist)
    (let ((key (car stack-alist))
	  (stack (cdr stack-alist)))
      (cons key
	    (mapcar (lambda (x)
		      (if (equal (car x) w)
			  'empty
			x))
		    stack))))

  (add-hook 'destroy-notify-hook cleanup-after-window))

;; workspace-swapper.jl -- swapping window attributes per-workspace
;;
;; Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>
;;
;; This file is part of sawfish.
;;
;; sawfish is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; sawfish is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 51 Franklin Street, Fifth Floor, 
;; Boston, MA 02110-1301 USA.

(define-structure sawfish.wm.swapper

    (export )

    (open rep
          rep.system
          sawfish.wm.windows
          sawfish.wm.misc
          sawfish.wm.workspace
          sawfish.wm.viewport
          sawfish.wm.frames)

  (defvar after-workspace-swap-in-hook nil)
  
;;; default swappers

  (define (workspace-swap-out w space)
    (declare (unused space))
    (let ((props (mapcar (lambda (prop)
			   (cons prop (window-get w prop)))
			 workspace-local-properties)))
      ;; meta properties
      (if (not (window-get w 'sticky))
	  (list (cons 'position (window-absolute-position w))
		(cons 'viewport (window-viewport w))
		(cons 'dimensions (window-dimensions w))
		(cons 'properties props))
	(list (cons 'properties props)))))

  (define (workspace-swap-in w space alist)
    (declare (unused space))
    (let ((position (cdr (assq 'position alist)))
	  (viewport (cdr (assq 'viewport alist)))
	  (dimensions (cdr (assq 'dimensions alist)))
	  (properties (cdr (assq 'properties alist)))
	  (old-frame-style (window-get w 'current-frame-style)))
      (mapc (lambda (cell)
	      (window-put w (car cell) (cdr cell))) properties)
      (when (and position dimensions viewport)
	(move-resize-window-to w (+ (car position)
				    (* (car viewport) (screen-width))
				    (- viewport-x-offset))
			       (+ (cdr position)
				  (* (cdr viewport) (screen-height))
				  (- viewport-y-offset))
			       (car dimensions) (cdr dimensions)))
      (when old-frame-style
	;; special case this to help switching the default theme
	(window-put w 'current-frame-style (or (window-get w 'frame-style)
					       default-frame-style))
	(unless (eq (window-get w 'current-frame-style) old-frame-style)
	  (reframe-window w))))
    (call-hook 'after-workspace-swap-in-hook (list w space)))

  (add-hook 'workspace-swap-in-hook workspace-swap-in)
  (add-hook 'workspace-swap-out-hook workspace-swap-out))

#!/bin/sh

if [ -f Makefile ]; then
	make gitclean
fi

if [ -f aclocal.m4 ]; then
	rm -fv aclocal.m4
fi

if [ -d m4 ]; then
	rm -fv m4/*
fi

if [ -f configure.in ]; then
  if grep "AC_CONFIG_HEADER" configure.in >/dev/null; then
      echo "Running autoheader"
      autoheader || exit 1
  fi
  if grep "AM_PROG_LIBTOOL" configure.in >/dev/null; then
    echo "Running libtoolize"
    lver=$(libtool --version | grep 1.5)
    if [ "x${lver}" != "x" ]; then
	    libtoolize --force --copy || exit 1
    else    libtoolize --force --copy --install || exit 1
    fi
  fi
#  echo "Running intltoolize"
#  intltoolize --copy --force
  echo "Running aclocal $ACLOCAL_FLAGS"
  aclocal -I m4 $ACLOCAL_FLAGS || exit 1

  echo "Running autoconf $AUTOCONF_FLAGS"
  autoconf $AUTOCONF_FLAGS || exit 1
fi

if [ "${1}" != "--nocfg" ]; then
	./configure "$@"
fi

#!/bin/sh

THEME=$1
BKGD=$2

XSERV=Xnest
DISP=:4

#export DISPLAY=:0
$XSERV -ac $DISP -geometry 600x450+5+5 &
export DISPLAY=$DISP

display -window root -size 256x256 xc:grey50
#xsetroot -solid grey

prep_config.sh $THEME
sawfish &
sleep 1
bgimg=`ls $HOME/.sawfish/themes/$THEME/*.jpg | head -1`
if [ x"$bgimg" = "x" ]; then
  feh --bg-scale $BKGD
else
  feh --bg-scale "$bgimg"
fi
killall pager
apps.sh $THEME
import -window root -quality 85 $THEME.jpg
sleep 1
killall $XSERV

#!/bin/bash
THEME=$1
echo
echo Theme to test: "$THEME"
echo
# Edit this script to remove that stupid confirmation.
#echo Really delete ~/.sawfish/custom and ~/.sawfishrc for theme testing?
#echo -n "Make sure you don't delete something important! (enter 'n' to abort) : ";
#read x; if [ "$x" = "n" ]; then exit; fi

rm -f ~/.sawfish/rc
rm -rf ~/.sawfish/custom

# TODO: create a sawfish rc

#echo "(custom-set-typed-variable (quote default-frame-style) (quote $1) \
#(quote frame-style))" > ~/.sawfish/custom
echo "(defvar-setq default-frame-style '$THEME \"Default frame style\")" > ~/.sawfish/rc
cat >> ~/.sawfish/rc << EOF
(custom-set-typed-variable
  (quote match-window-profile)
  (quote ((((WM_NAME . "^Normal$")) (frame-type . normal))
          (((WM_NAME . "^Shaded$")) (shaded . #t))
          (((WM_NAME . "^Title-only$")) (frame-type . title-only))
          (((WM_NAME . "^Border-only$")) (frame-type . border-only))
          (((WM_NAME . "^Top-border$")) (frame-type . top-border))
          (((WM_NAME . "^None$")) (frame-type . none))
          ))
  (quote match-window)
  (quote sawfish.wm.ext.match-window))
  )

EOF

#!/bin/sh

PACKAGE="sawfish"

if [ "x$1" = "x--help" ]; then
    echo Usage: ./update.sh langcode[.po]
    echo --help                  display this help and exit
    echo
    echo Examples of use:
    echo ./update.sh da[.po] -- updates the da.po file
    exit 0
elif [ "x$1" = "x" ]; then 
    echo "Type language code, e.g. da / da.po for Danish, etc."
    exit 0
fi

PO="${1}"

if [ -e "${PO}.po" ]; then
    PO="${PO}.po"
fi

echo "Now merging $PO with $PACKAGE.pot, and creating an updated $PO ..."

mv ${PO} ${PO}.old && msgmerge ${PO}.old ${PACKAGE}.pot -o ${PO} \
    && rm ${PO}.old;

msgfmt $PO --statistics -o /dev/null

#!/bin/sh

if [ -f Makefile ]; then
	make distclean
fi

if [ -f aclocal.m4 ]; then
	rm -fv aclocal.m4
fi

if [ -d m4 ]; then
	rm -fv m4/*
fi

if [ -f configure.ac ]; then
  if grep "AC_CONFIG_HEADER" configure.ac >/dev/null; then
      echo "Running autoheader"
      autoheader || exit 1
  fi
  if grep "AM_PROG_LIBTOOL" configure.ac >/dev/null; then
    echo "Running libtoolize"
    lver=$(libtoolize --version | grep 1.5)
    if [ "x${lver}" != "x" ]; then
	    libtoolize --force --copy || exit 1
    else    libtoolize --force --copy --install || exit 1
    fi
  fi
#  echo "Running intltoolize"
#  intltoolize --copy --force
  echo "Running aclocal $ACLOCAL_FLAGS"
  aclocal -I m4 $ACLOCAL_FLAGS || exit 1

  echo "Running autoconf $AUTOCONF_FLAGS"
  autoconf $AUTOCONF_FLAGS || exit 1
fi

if [ "${1}" != "--nocfg" ]; then
	./configure "$@"
fi

#!/bin/bash

XTERM="xterm -fg white -bg black"
#XTERM="rxvt -fg white -bg black"

$XTERM -geom 34x10-10-10 -T Top-border \
   -e /bin/bash -c "cowsay \"A top border window\" ; sleep 200" &

#$XTERM -geom 28x9-10+150 -T Title-only \
#   -e /bin/bash -c "cowsay \"A title only window\" ; sleep 200" &

xeyes -geom 180x90-10+10 &

xclock -render -geom 130x100-10+130 &
#sleep 0.1

$XTERM -geom 47x6+10-10 -T Border-only \
   -e /bin/bash -c "echo \"A border only window\" ; sleep 200" &
sleep 0.4

$XTERM -geom 44x7+75+295 -T Shaded \
   -e /bin/bash -c "echo \"Eeeek! A Shaded window!\" ; sleep 200" &
sleep 0.6

$XTERM -geom 52x18+10+10 -T "Normal Window with Really Really Really Long Title" \
   -e /bin/bash -c "normal-window.sh "$1" ; sleep 200" &
   #"cowsay Theme \'$1\' README is below. \
   #This window has focus. ; sleep 200" &

sleep 1

#!/bin/sh

BKGD=`dirname $0`/bkgd.jpg

ERR=/tmp/screenshot.errors
rm -f $ERR

for tarball in $HOME/.sawfish/tarballs/*.tar.gz ; do
  echo "===================="
  echo "Tarball: $tarball"
  pushd $HOME/.sawfish/tarballs > /dev/null
  theme=`echo $tarball | perl -ne '/\/([^\/]*)(-[0-9\.]+)(-\d{8,14}).tar.gz/ && print "$1\n";'`
  echo "Theme: $theme"
  cd $HOME/.sawfish/themes
  rm -rf $HOME/.sawfish/themes/*
  tar xfz $tarball
  tardir=`ls`
  popd > /dev/null
  if [ x"$tardir" != x"$theme" ]; then
    echo "WARN: $theme != $tardir/" | tee -a $ERR
    if [ x"$tardir" != x ]; then
      theme=$tardir
      #make_screenshot.sh $theme $BKGD
      ## allow Xnest to really die
      #sleep 1
    else
      echo "ERROR: $tarball contains nothing?" | tee -a $ERR
      continue
    fi
  fi
  make_screenshot.sh $theme $BKGD
  # allow Xnest to really die
  sleep 1
done
